import*as Platform from"../platform/platform.js";import{ColorConverter}from"./ColorConverter.js";import{blendColors,contrastRatioAPCA,desiredLuminanceAPCA,luminance,luminanceAPCA,rgbToHsl,rgbToHwb}from"./ColorUtils.js";function normalizeHue(r){return(r%360+360)%360}function parseAngle(r){const e=r.replace(/(deg|g?rad|turn)$/,"");if(isNaN(e)||r.match(/\s+(deg|g?rad|turn)/))return null;const t=parseFloat(e);return r.includes("turn")?360*t:r.includes("grad")?9*t/10:r.includes("rad")?180*t/Math.PI:t}export function getFormat(r){switch(r){case"nickname":return"nickname";case"hex":return"hex";case"shorthex":return"shorthex";case"hexa":return"hexa";case"shorthexa":return"shorthexa";case"rgb":return"rgb";case"rgba":return"rgba";case"hsl":return"hsl";case"hsla":return"hsla";case"hwb":return"hwb";case"hwba":return"hwba";case"lch":return"lch";case"oklch":return"oklch";case"lab":return"lab";case"oklab":return"oklab"}return getColorSpace(r)}function getColorSpace(r){switch(r){case"srgb":return"srgb";case"srgb-linear":return"srgb-linear";case"display-p3":return"display-p3";case"a98-rgb":return"a98-rgb";case"prophoto-rgb":return"prophoto-rgb";case"rec2020":return"rec2020";case"xyz":return"xyz";case"xyz-d50":return"xyz-d50";case"xyz-d65":return"xyz-d65"}return null}function mapPercentToRange(r,e){const t=Math.sign(r),a=Math.abs(r),[o,n]=e;return t*(a*(n-o)/100+o)}export function parse(r){let e=r.toLowerCase().replace(/\s+/g,"").match(/^(?:#([0-9a-f]{3,4}|[0-9a-f]{6}|[0-9a-f]{8})|(\w+))$/i);if(e)return e[1]?Legacy.fromHex(e[1],r):e[2]?Legacy.fromName(e[2],r):null;if(e=r.toLowerCase().match(/^\s*(?:(rgba?)|(hsla?)|(hwba?)|(lch)|(oklch)|(lab)|(oklab)|(color))\((.*)\)\s*$/),e){const t=Boolean(e[1]),a=Boolean(e[2]),o=Boolean(e[3]),n=Boolean(e[4]),l=Boolean(e[5]),s=Boolean(e[6]),i=Boolean(e[7]),h=Boolean(e[8]),c=e[9];if(h)return ColorFunction.fromSpec(r,c);const g=splitColorFunctionParameters(c,{allowCommas:t||a,convertNoneToZero:!(t||a||o)});if(!g)return null;const u=[g[0],g[1],g[2],g[3]];if(t)return Legacy.fromRGBAFunction(g[0],g[1],g[2],g[3],r);if(a)return HSL.fromSpec(u,r);if(o)return HWB.fromSpec(u,r);if(n)return LCH.fromSpec(u,r);if(l)return Oklch.fromSpec(u,r);if(s)return Lab.fromSpec(u,r);if(i)return Oklab.fromSpec(u,r)}return null}function splitColorFunctionParameters(r,{allowCommas:e,convertNoneToZero:t}){const a=r.trim();let o=[];if(e&&(o=a.split(/\s*,\s*/)),!e||1===o.length)if(o=a.split(/\s+/),"/"===o[3]){if(o.splice(3,1),4!==o.length)return null}else if(o.length>2&&-1!==o[2].indexOf("/")||o.length>3&&-1!==o[3].indexOf("/")){const r=o.slice(2,4).join("");o=o.slice(0,2).concat(r.split(/\//)).concat(o.slice(4))}else if(o.length>=4)return null;return 3!==o.length&&4!==o.length||o.indexOf("")>-1?null:t?o.map((r=>"none"===r?"0":r)):o}function clamp(r,{min:e,max:t}){return null===r||(void 0!==e&&(r=Math.max(r,e)),void 0!==t&&(r=Math.min(r,t))),r}function parsePercentage(r,e){if(!r.endsWith("%"))return null;const t=parseFloat(r.substr(0,r.length-1));return isNaN(t)?null:mapPercentToRange(t,e)}function parseNumber(r){const e=parseFloat(r);return isNaN(e)?null:e}function parseAlpha(r){return void 0===r?null:clamp(parsePercentage(r,[0,1])??parseNumber(r),{min:0,max:1})}function parsePercentOrNumber(r,e=[0,1]){if(isNaN(r.replace("%","")))return null;const t=parseFloat(r);return-1!==r.indexOf("%")?r.indexOf("%")!==r.length-1?null:mapPercentToRange(t,e):t}function parseRgbNumeric(r){const e=parsePercentOrNumber(r);return null===e?null:-1!==r.indexOf("%")?e:e/255}function parseHueNumeric(r){const e=r.replace(/(deg|g?rad|turn)$/,"");if(isNaN(e)||r.match(/\s+(deg|g?rad|turn)/))return null;const t=parseFloat(e);return-1!==r.indexOf("turn")?t%1:-1!==r.indexOf("grad")?t/400%1:-1!==r.indexOf("rad")?t/(2*Math.PI)%1:t/360%1}function parseSatLightNumeric(r){if(r.indexOf("%")!==r.length-1||isNaN(r.replace("%","")))return null;return parseFloat(r)/100}function parseAlphaNumeric(r){return parsePercentOrNumber(r)}function hsva2hsla(r,e){const t=r[0];let a=r[1];const o=r[2],n=(2-a)*o;0===o||0===a?a=0:a*=o/(n<1?n:2-n),e[0]=t,e[1]=a,e[2]=n/2,e[3]=r[3]}export function hsl2rgb(r,e){const t=r[0];let a=r[1];const o=r[2];function n(r,e,t){return t<0?t+=1:t>1&&(t-=1),6*t<1?r+(e-r)*t*6:2*t<1?e:3*t<2?r+(e-r)*(2/3-t)*6:r}let l;a<0&&(a=0),l=o<=.5?o*(1+a):o+a-o*a;const s=2*o-l,i=t+1/3,h=t,c=t-1/3;e[0]=n(s,l,i),e[1]=n(s,l,h),e[2]=n(s,l,c),e[3]=r[3]}function hwb2rgb(r,e){const t=r[0],a=r[1],o=r[2];if(a+o>=1)e[0]=e[1]=e[2]=a/(a+o),e[3]=r[3];else{hsl2rgb([t,1,.5,r[3]],e);for(let r=0;r<3;++r)e[r]+=a-(a+o)*e[r]}}export function hsva2rgba(r,e){const t=[0,0,0,0];hsva2hsla(r,t),hsl2rgb(t,e)}export function rgb2hsv(r){const e=rgbToHsl(r),t=e[0];let a=e[1];const o=e[2];return a*=o<.5?o:1-o,[t,0!==a?2*a/(o+a):0,o+a]}export function desiredLuminance(r,e,t){function a(){return t?(r+.05)*e-.05:(r+.05)/e-.05}let o=a();return(o<0||o>1)&&(t=!t,o=a()),o}export function approachColorValue(r,e,t,a,o){let n=r[t],l=1,s=o(r)-a,i=Math.sign(s);for(let e=100;e;e--){if(Math.abs(s)<2e-4)return r[t]=n,n;const e=Math.sign(s);if(e!==i)l/=2,i=e;else if(n<0||n>1)return null;n+=l*(2===t?-s:s),r[t]=n,s=o(r)-a}return null}export function findFgColorForContrast(r,e,t){const a=r.as("hsl").hsva(),o=e.rgba(),n=r=>luminance(blendColors(Legacy.fromHSVA(r).rgba(),o)),l=luminance(e.rgba()),s=desiredLuminance(l,t,n(a)>l);return approachColorValue(a,o,2,s,n)?Legacy.fromHSVA(a):(a[2]=1,approachColorValue(a,o,1,s,n)?Legacy.fromHSVA(a):null)}export function findFgColorForContrastAPCA(r,e,t){const a=r.as("hsl").hsva(),o=e.rgba(),n=r=>luminanceAPCA(Legacy.fromHSVA(r).rgba()),l=luminanceAPCA(e.rgba()),s=n(a),i=desiredLuminanceAPCA(l,t,s>=l);if(approachColorValue(a,o,2,i,n)){const r=Legacy.fromHSVA(a);if(Math.abs(contrastRatioAPCA(e.rgba(),r.rgba()))>=t)return r}if(a[2]=1,approachColorValue(a,o,1,i,n)){const r=Legacy.fromHSVA(a);if(Math.abs(contrastRatioAPCA(e.rgba(),r.rgba()))>=t)return r}return null}const EPSILON=.01,WIDE_RANGE_EPSILON=1;function equals(r,e,t=.01){if(Array.isArray(r)&&Array.isArray(e)){if(r.length!==e.length)return!1;for(const t in r)if(!equals(r[t],e[t]))return!1;return!0}return!Array.isArray(r)&&!Array.isArray(e)&&(null===r||null===e?r===e:Math.abs(r-e)<t)}function lessOrEquals(r,e,t=.01){return r-e<=t}export class Lab{l;a;b;alpha;#r;#e;static#t={nickname:r=>new Legacy(r.#a(!1),"nickname"),hex:r=>new Legacy(r.#a(!1),"hex"),shorthex:r=>new Legacy(r.#a(!1),"shorthex"),hexa:r=>new Legacy(r.#a(!0),"hexa"),shorthexa:r=>new Legacy(r.#a(!0),"shorthexa"),rgb:r=>new Legacy(r.#a(!1),"rgb"),rgba:r=>new Legacy(r.#a(!0),"rgba"),hsl:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hsla:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hwb:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),hwba:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),lch:r=>new LCH(...ColorConverter.labToLch(r.l,r.a,r.b),r.alpha),oklch:r=>new Oklch(...ColorConverter.xyzd50ToOklch(...r.#o()),r.alpha),lab:r=>r,oklab:r=>new Oklab(...ColorConverter.xyzd65ToOklab(...ColorConverter.xyzd50ToD65(...r.#o())),r.alpha),srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#o(){return ColorConverter.labToXyzd50(this.l,this.a,this.b)}#a(r=!0){const e=ColorConverter.xyzd50ToSrgb(...this.#o());return r?[...e,this.alpha??void 0]:e}constructor(r,e,t,a,o){this.#e=[r,e,t],this.l=clamp(r,{min:0,max:100}),(equals(this.l,0,1)||equals(this.l,100,1))&&(e=t=0),this.a=e,this.b=t,this.alpha=clamp(a,{min:0,max:1}),this.#r=o}as(r){return Lab.#t[r](this)}asLegacyColor(){return this.as("rgba")}equal(r){const e=r.as("lab");return equals(e.l,this.l,1)&&equals(e.a,this.a)&&equals(e.b,this.b)&&equals(e.alpha,this.alpha)}format(){return"lab"}setAlpha(r){return new Lab(this.l,this.a,this.b,r,void 0)}asString(r){return r?this.as(r).asString():this.#n(this.l,this.a,this.b)}#n(r,e,t){const a=null===this.alpha||equals(this.alpha,1)?"":` / ${Platform.StringUtilities.stringifyWithPrecision(this.alpha)}`;return`lab(${Platform.StringUtilities.stringifyWithPrecision(r,0)} ${Platform.StringUtilities.stringifyWithPrecision(e)} ${Platform.StringUtilities.stringifyWithPrecision(t)}${a})`}getAuthoredText(){return this.#r??null}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(...this.#e)}isGamutClipped(){return!1}static fromSpec(r,e){const t=parsePercentage(r[0],[0,100])??parseNumber(r[0]);if(null===t)return null;const a=parsePercentage(r[1],[0,125])??parseNumber(r[1]);if(null===a)return null;const o=parsePercentage(r[2],[0,125])??parseNumber(r[2]);if(null===o)return null;const n=parseAlpha(r[3]);return new Lab(t,a,o,n,e)}}export class LCH{#e;l;c;h;alpha;#r;static#t={nickname:r=>new Legacy(r.#a(!1),"nickname"),hex:r=>new Legacy(r.#a(!1),"hex"),shorthex:r=>new Legacy(r.#a(!1),"shorthex"),hexa:r=>new Legacy(r.#a(!0),"hexa"),shorthexa:r=>new Legacy(r.#a(!0),"shorthexa"),rgb:r=>new Legacy(r.#a(!1),"rgb"),rgba:r=>new Legacy(r.#a(!0),"rgba"),hsl:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hsla:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hwb:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),hwba:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),lch:r=>r,oklch:r=>new Oklch(...ColorConverter.xyzd50ToOklch(...r.#o()),r.alpha),lab:r=>new Lab(...ColorConverter.lchToLab(r.l,r.c,r.h),r.alpha),oklab:r=>new Oklab(...ColorConverter.xyzd65ToOklab(...ColorConverter.xyzd50ToD65(...r.#o())),r.alpha),srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#o(){return ColorConverter.labToXyzd50(...ColorConverter.lchToLab(this.l,this.c,this.h))}#a(r=!0){const e=ColorConverter.xyzd50ToSrgb(...this.#o());return r?[...e,this.alpha??void 0]:e}constructor(r,e,t,a,o){this.#e=[r,e,t],this.l=clamp(r,{min:0,max:100}),e=equals(this.l,0,1)||equals(this.l,100,1)?0:e,this.c=clamp(e,{min:0}),t=equals(e,0)?0:t,this.h=normalizeHue(t),this.alpha=clamp(a,{min:0,max:1}),this.#r=o}asLegacyColor(){return this.as("rgba")}as(r){return LCH.#t[r](this)}equal(r){const e=r.as("lch");return equals(e.l,this.l,1)&&equals(e.c,this.c)&&equals(e.h,this.h)&&equals(e.alpha,this.alpha)}format(){return"lch"}setAlpha(r){return new LCH(this.l,this.c,this.h,r)}asString(r){return r?this.as(r).asString():this.#n(this.l,this.c,this.h)}#n(r,e,t){const a=null===this.alpha||equals(this.alpha,1)?"":` / ${Platform.StringUtilities.stringifyWithPrecision(this.alpha)}`;return`lch(${Platform.StringUtilities.stringifyWithPrecision(r,0)} ${Platform.StringUtilities.stringifyWithPrecision(e)} ${Platform.StringUtilities.stringifyWithPrecision(t)}${a})`}getAuthoredText(){return this.#r??null}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(...this.#e)}isGamutClipped(){return!1}isHuePowerless(){return equals(this.c,0)}static fromSpec(r,e){const t=parsePercentage(r[0],[0,100])??parseNumber(r[0]);if(null===t)return null;const a=parsePercentage(r[1],[0,150])??parseNumber(r[1]);if(null===a)return null;const o=parseAngle(r[2]);if(null===o)return null;const n=parseAlpha(r[3]);return new LCH(t,a,o,n,e)}}export class Oklab{#e;l;a;b;alpha;#r;static#t={nickname:r=>new Legacy(r.#a(!1),"nickname"),hex:r=>new Legacy(r.#a(!1),"hex"),shorthex:r=>new Legacy(r.#a(!1),"shorthex"),hexa:r=>new Legacy(r.#a(!0),"hexa"),shorthexa:r=>new Legacy(r.#a(!0),"shorthexa"),rgb:r=>new Legacy(r.#a(!1),"rgb"),rgba:r=>new Legacy(r.#a(!0),"rgba"),hsl:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hsla:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hwb:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),hwba:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),lch:r=>new LCH(...ColorConverter.labToLch(...ColorConverter.xyzd50ToLab(...r.#o())),r.alpha),oklch:r=>new Oklch(...ColorConverter.xyzd50ToOklch(...r.#o()),r.alpha),lab:r=>new Lab(...ColorConverter.xyzd50ToLab(...r.#o()),r.alpha),oklab:r=>r,srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#o(){return ColorConverter.xyzd65ToD50(...ColorConverter.oklabToXyzd65(this.l,this.a,this.b))}#a(r=!0){const e=ColorConverter.xyzd50ToSrgb(...this.#o());return r?[...e,this.alpha??void 0]:e}constructor(r,e,t,a,o){this.#e=[r,e,t],this.l=clamp(r,{min:0,max:1}),(equals(this.l,0)||equals(this.l,1))&&(e=t=0),this.a=e,this.b=t,this.alpha=clamp(a,{min:0,max:1}),this.#r=o}asLegacyColor(){return this.as("rgba")}as(r){return Oklab.#t[r](this)}equal(r){const e=r.as("oklab");return equals(e.l,this.l)&&equals(e.a,this.a)&&equals(e.b,this.b)&&equals(e.alpha,this.alpha)}format(){return"oklab"}setAlpha(r){return new Oklab(this.l,this.a,this.b,r)}asString(r){return r?this.as(r).asString():this.#n(this.l,this.a,this.b)}#n(r,e,t){const a=null===this.alpha||equals(this.alpha,1)?"":` / ${Platform.StringUtilities.stringifyWithPrecision(this.alpha)}`;return`oklab(${Platform.StringUtilities.stringifyWithPrecision(r)} ${Platform.StringUtilities.stringifyWithPrecision(e)} ${Platform.StringUtilities.stringifyWithPrecision(t)}${a})`}getAuthoredText(){return this.#r??null}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(...this.#e)}isGamutClipped(){return!1}static fromSpec(r,e){const t=parsePercentage(r[0],[0,1])??parseNumber(r[0]);if(null===t)return null;const a=parsePercentage(r[1],[0,.4])??parseNumber(r[1]);if(null===a)return null;const o=parsePercentage(r[2],[0,.4])??parseNumber(r[2]);if(null===o)return null;const n=parseAlpha(r[3]);return new Oklab(t,a,o,n,e)}}export class Oklch{#e;l;c;h;alpha;#r;static#t={nickname:r=>new Legacy(r.#a(!1),"nickname"),hex:r=>new Legacy(r.#a(!1),"hex"),shorthex:r=>new Legacy(r.#a(!1),"shorthex"),hexa:r=>new Legacy(r.#a(!0),"hexa"),shorthexa:r=>new Legacy(r.#a(!0),"shorthexa"),rgb:r=>new Legacy(r.#a(!1),"rgb"),rgba:r=>new Legacy(r.#a(!0),"rgba"),hsl:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hsla:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hwb:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),hwba:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),lch:r=>new LCH(...ColorConverter.labToLch(...ColorConverter.xyzd50ToLab(...r.#o())),r.alpha),oklch:r=>r,lab:r=>new Lab(...ColorConverter.xyzd50ToLab(...r.#o()),r.alpha),oklab:r=>new Oklab(...ColorConverter.xyzd65ToOklab(...ColorConverter.xyzd50ToD65(...r.#o())),r.alpha),srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#o(){return ColorConverter.oklchToXyzd50(this.l,this.c,this.h)}#a(r=!0){const e=ColorConverter.xyzd50ToSrgb(...this.#o());return r?[...e,this.alpha??void 0]:e}constructor(r,e,t,a,o){this.#e=[r,e,t],this.l=clamp(r,{min:0,max:1}),e=equals(this.l,0)||equals(this.l,1)?0:e,this.c=clamp(e,{min:0}),t=equals(e,0)?0:t,this.h=normalizeHue(t),this.alpha=clamp(a,{min:0,max:1}),this.#r=o}asLegacyColor(){return this.as("rgba")}as(r){return Oklch.#t[r](this)}equal(r){const e=r.as("oklch");return equals(e.l,this.l)&&equals(e.c,this.c)&&equals(e.h,this.h)&&equals(e.alpha,this.alpha)}format(){return"oklch"}setAlpha(r){return new Oklch(this.l,this.c,this.h,r)}asString(r){return r?this.as(r).asString():this.#n(this.l,this.c,this.h)}#n(r,e,t){const a=null===this.alpha||equals(this.alpha,1)?"":` / ${Platform.StringUtilities.stringifyWithPrecision(this.alpha)}`;return`oklch(${Platform.StringUtilities.stringifyWithPrecision(r)} ${Platform.StringUtilities.stringifyWithPrecision(e)} ${Platform.StringUtilities.stringifyWithPrecision(t)}${a})`}getAuthoredText(){return this.#r??null}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(...this.#e)}isGamutClipped(){return!1}static fromSpec(r,e){const t=parsePercentage(r[0],[0,1])??parseNumber(r[0]);if(null===t)return null;const a=parsePercentage(r[1],[0,.4])??parseNumber(r[1]);if(null===a)return null;const o=parseAngle(r[2]);if(null===o)return null;const n=parseAlpha(r[3]);return new Oklch(t,a,o,n,e)}}export class ColorFunction{#e;p0;p1;p2;alpha;colorSpace;#r;static#t={nickname:r=>new Legacy(r.#a(!1),"nickname"),hex:r=>new Legacy(r.#a(!1),"hex"),shorthex:r=>new Legacy(r.#a(!1),"shorthex"),hexa:r=>new Legacy(r.#a(!0),"hexa"),shorthexa:r=>new Legacy(r.#a(!0),"shorthexa"),rgb:r=>new Legacy(r.#a(!1),"rgb"),rgba:r=>new Legacy(r.#a(!0),"rgba"),hsl:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hsla:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hwb:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),hwba:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),lch:r=>new LCH(...ColorConverter.labToLch(...ColorConverter.xyzd50ToLab(...r.#o())),r.alpha),oklch:r=>new Oklch(...ColorConverter.xyzd50ToOklch(...r.#o()),r.alpha),lab:r=>new Lab(...ColorConverter.xyzd50ToLab(...r.#o()),r.alpha),oklab:r=>new Oklab(...ColorConverter.xyzd65ToOklab(...ColorConverter.xyzd50ToD65(...r.#o())),r.alpha),srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#o(){const[r,e,t]=this.#e;switch(this.colorSpace){case"srgb":return ColorConverter.srgbToXyzd50(r,e,t);case"srgb-linear":return ColorConverter.srgbLinearToXyzd50(r,e,t);case"display-p3":return ColorConverter.displayP3ToXyzd50(r,e,t);case"a98-rgb":return ColorConverter.adobeRGBToXyzd50(r,e,t);case"prophoto-rgb":return ColorConverter.proPhotoToXyzd50(r,e,t);case"rec2020":return ColorConverter.rec2020ToXyzd50(r,e,t);case"xyz-d50":return[r,e,t];case"xyz":case"xyz-d65":return ColorConverter.xyzd65ToD50(r,e,t)}throw new Error("Invalid color space")}#a(r=!0){const[e,t,a]=this.#e,o="srgb"===this.colorSpace?[e,t,a]:[...ColorConverter.xyzd50ToSrgb(...this.#o())];return r?[...o,this.alpha??void 0]:o}constructor(r,e,t,a,o,n){this.#e=[e,t,a],this.colorSpace=r,this.#r=n,"xyz-d50"!==this.colorSpace&&"xyz-d65"!==this.colorSpace&&"xyz"!==this.colorSpace&&(e=clamp(e,{min:0,max:1}),t=clamp(t,{min:0,max:1}),a=clamp(a,{min:0,max:1})),this.p0=e,this.p1=t,this.p2=a,this.alpha=clamp(o,{min:0,max:1})}asLegacyColor(){return this.as("rgba")}as(r){return this.colorSpace===r?this:ColorFunction.#t[r](this)}equal(r){const e=r.as(this.colorSpace);return equals(this.p0,e.p0)&&equals(this.p1,e.p1)&&equals(this.p2,e.p2)&&equals(this.alpha,e.alpha)}format(){return this.colorSpace}setAlpha(r){return new ColorFunction(this.colorSpace,this.p0,this.p1,this.p2,r)}asString(r){return r?this.as(r).asString():this.#n(this.p0,this.p1,this.p2)}#n(r,e,t){const a=null===this.alpha||equals(this.alpha,1)?"":` / ${Platform.StringUtilities.stringifyWithPrecision(this.alpha)}`;return`color(${this.colorSpace} ${Platform.StringUtilities.stringifyWithPrecision(r)} ${Platform.StringUtilities.stringifyWithPrecision(e)} ${Platform.StringUtilities.stringifyWithPrecision(t)}${a})`}getAuthoredText(){return this.#r??null}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(...this.#e)}isGamutClipped(){return"xyz-d50"!==this.colorSpace&&"xyz-d65"!==this.colorSpace&&"xyz"!==this.colorSpace&&!equals(this.#e,[this.p0,this.p1,this.p2])}static fromSpec(r,e){const[t,a]=e.split("/",2),o=t.trim().split(/\s+/),[n,...l]=o,s=getColorSpace(n);if(!s)return null;if(0===l.length&&void 0===a)return new ColorFunction(s,0,0,0,null,r);if(0===l.length&&void 0!==a&&a.trim().split(/\s+/).length>1)return null;if(l.length>3)return null;const i=l.map((r=>"none"===r?"0":r)).map((r=>parsePercentOrNumber(r,[0,1])));if(i.includes(null))return null;const h=a?parsePercentOrNumber(a,[0,1])??1:1,c=[i[0]??0,i[1]??0,i[2]??0,h];return new ColorFunction(s,...c,r)}}export class HSL{h;s;l;alpha;#e;#r;static#t={nickname:r=>new Legacy(r.#a(!1),"nickname"),hex:r=>new Legacy(r.#a(!1),"hex"),shorthex:r=>new Legacy(r.#a(!1),"shorthex"),hexa:r=>new Legacy(r.#a(!0),"hexa"),shorthexa:r=>new Legacy(r.#a(!0),"shorthexa"),rgb:r=>new Legacy(r.#a(!1),"rgb"),rgba:r=>new Legacy(r.#a(!0),"rgba"),hsl:r=>r,hsla:r=>r,hwb:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),hwba:r=>new HWB(...rgbToHwb(r.#a(!1)),r.alpha),lch:r=>new LCH(...ColorConverter.labToLch(...ColorConverter.xyzd50ToLab(...r.#o())),r.alpha),oklch:r=>new Oklch(...ColorConverter.xyzd50ToOklch(...r.#o()),r.alpha),lab:r=>new Lab(...ColorConverter.xyzd50ToLab(...r.#o()),r.alpha),oklab:r=>new Oklab(...ColorConverter.xyzd65ToOklab(...ColorConverter.xyzd50ToD65(...r.#o())),r.alpha),srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#a(r=!0){const e=[0,0,0,0];return hsl2rgb([this.h,this.s,this.l,0],e),r?[e[0],e[1],e[2],this.alpha??void 0]:[e[0],e[1],e[2]]}#o(){const r=this.#a(!1);return ColorConverter.srgbToXyzd50(r[0],r[1],r[2])}constructor(r,e,t,a,o){this.#e=[r,e,t],this.l=clamp(t,{min:0,max:1}),e=equals(this.l,0)||equals(this.l,1)?0:e,this.s=clamp(e,{min:0,max:1}),r=equals(this.s,0)?0:r,this.h=normalizeHue(360*r)/360,this.alpha=clamp(a??null,{min:0,max:1}),this.#r=o}equal(r){const e=r.as("hsl");return equals(this.h,e.h)&&equals(this.s,e.s)&&equals(this.l,e.l)&&equals(this.alpha,e.alpha)}asString(r){return r?this.as(r).asString():this.#n(this.h,this.s,this.l)}#n(r,e,t){const a=Platform.StringUtilities.sprintf("hsl(%sdeg %s% %s%",Platform.StringUtilities.stringifyWithPrecision(360*r),Platform.StringUtilities.stringifyWithPrecision(100*e),Platform.StringUtilities.stringifyWithPrecision(100*t));return null!==this.alpha&&1!==this.alpha?a+Platform.StringUtilities.sprintf(" / %s%)",Platform.StringUtilities.stringifyWithPrecision(100*this.alpha)):a+")"}setAlpha(r){return new HSL(this.h,this.s,this.l,r)}format(){return null===this.alpha||1===this.alpha?"hsl":"hsla"}as(r){return r===this.format()?this:HSL.#t[r](this)}asLegacyColor(){return this.as("rgba")}getAuthoredText(){return this.#r??null}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(...this.#e)}isGamutClipped(){return!lessOrEquals(this.#e[1],1)||!lessOrEquals(0,this.#e[1])}static fromSpec(r,e){const t=parseHueNumeric(r[0]);if(null===t)return null;const a=parseSatLightNumeric(r[1]);if(null===a)return null;const o=parseSatLightNumeric(r[2]);if(null===o)return null;const n=parseAlpha(r[3]);return new HSL(t,a,o,n,e)}hsva(){const r=this.s*(this.l<.5?this.l:1-this.l);return[this.h,0!==r?2*r/(this.l+r):0,this.l+r,this.alpha??1]}canonicalHSLA(){return[Math.round(360*this.h),Math.round(100*this.s),Math.round(100*this.l),this.alpha??1]}}export class HWB{h;w;b;alpha;#e;#r;static#t={nickname:r=>new Legacy(r.#a(!1),"nickname"),hex:r=>new Legacy(r.#a(!1),"hex"),shorthex:r=>new Legacy(r.#a(!1),"shorthex"),hexa:r=>new Legacy(r.#a(!0),"hexa"),shorthexa:r=>new Legacy(r.#a(!0),"shorthexa"),rgb:r=>new Legacy(r.#a(!1),"rgb"),rgba:r=>new Legacy(r.#a(!0),"rgba"),hsl:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hsla:r=>new HSL(...rgbToHsl(r.#a(!1)),r.alpha),hwb:r=>r,hwba:r=>r,lch:r=>new LCH(...ColorConverter.labToLch(...ColorConverter.xyzd50ToLab(...r.#o())),r.alpha),oklch:r=>new Oklch(...ColorConverter.xyzd50ToOklch(...r.#o()),r.alpha),lab:r=>new Lab(...ColorConverter.xyzd50ToLab(...r.#o()),r.alpha),oklab:r=>new Oklab(...ColorConverter.xyzd65ToOklab(...ColorConverter.xyzd50ToD65(...r.#o())),r.alpha),srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#a(r=!0){const e=[0,0,0,0];return hwb2rgb([this.h,this.w,this.b,0],e),r?[e[0],e[1],e[2],this.alpha??void 0]:[e[0],e[1],e[2]]}#o(){const r=this.#a(!1);return ColorConverter.srgbToXyzd50(r[0],r[1],r[2])}constructor(r,e,t,a,o){if(this.#e=[r,e,t],this.w=clamp(e,{min:0,max:1}),this.b=clamp(t,{min:0,max:1}),r=lessOrEquals(1,this.w+this.b)?0:r,this.h=normalizeHue(360*r)/360,this.alpha=clamp(a,{min:0,max:1}),lessOrEquals(1,this.w+this.b)){const r=this.w/this.b;this.b=1/(1+r),this.w=1-this.b}this.#r=o}equal(r){const e=r.as("hwb");return equals(this.h,e.h)&&equals(this.w,e.w)&&equals(this.b,e.b)&&equals(this.alpha,e.alpha)}asString(r){return r?this.as(r).asString():this.#n(this.h,this.w,this.b)}#n(r,e,t){const a=Platform.StringUtilities.sprintf("hwb(%sdeg %s% %s%",Platform.StringUtilities.stringifyWithPrecision(360*r),Platform.StringUtilities.stringifyWithPrecision(100*e),Platform.StringUtilities.stringifyWithPrecision(100*t));return null!==this.alpha&&1!==this.alpha?a+Platform.StringUtilities.sprintf(" / %s%)",Platform.StringUtilities.stringifyWithPrecision(100*this.alpha)):a+")"}setAlpha(r){return new HWB(this.h,this.w,this.b,r,this.#r)}format(){return null===this.alpha||equals(this.alpha,1)?"hwb":"hwba"}as(r){return r===this.format()?this:HWB.#t[r](this)}asLegacyColor(){return this.as("rgba")}getAuthoredText(){return this.#r??null}canonicalHWBA(){return[Math.round(360*this.h),Math.round(100*this.w),Math.round(100*this.b),this.alpha??1]}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(...this.#e)}isGamutClipped(){return!(lessOrEquals(this.#e[1],1)&&lessOrEquals(0,this.#e[1])&&lessOrEquals(this.#e[2],1)&&lessOrEquals(0,this.#e[2]))}static fromSpec(r,e){const t=parseHueNumeric(r[0]);if(null===t)return null;const a=parseSatLightNumeric(r[1]);if(null===a)return null;const o=parseSatLightNumeric(r[2]);if(null===o)return null;const n=parseAlpha(r[3]);return new HWB(t,a,o,n,e)}}function toRgbValue(r){return Math.round(255*r)}export class Legacy{#e;#l;#r;#s;static#t={nickname:r=>new Legacy(r.#l,"nickname"),hex:r=>new Legacy(r.#l,"hex"),shorthex:r=>new Legacy(r.#l,"shorthex"),hexa:r=>new Legacy(r.#l,"hexa"),shorthexa:r=>new Legacy(r.#l,"shorthexa"),rgb:r=>new Legacy(r.#l,"rgb"),rgba:r=>new Legacy(r.#l,"rgba"),hsl:r=>new HSL(...rgbToHsl([r.#l[0],r.#l[1],r.#l[2]]),r.alpha),hsla:r=>new HSL(...rgbToHsl([r.#l[0],r.#l[1],r.#l[2]]),r.alpha),hwb:r=>new HWB(...rgbToHwb([r.#l[0],r.#l[1],r.#l[2]]),r.alpha),hwba:r=>new HWB(...rgbToHwb([r.#l[0],r.#l[1],r.#l[2]]),r.alpha),lch:r=>new LCH(...ColorConverter.labToLch(...ColorConverter.xyzd50ToLab(...r.#o())),r.alpha),oklch:r=>new Oklch(...ColorConverter.xyzd50ToOklch(...r.#o()),r.alpha),lab:r=>new Lab(...ColorConverter.xyzd50ToLab(...r.#o()),r.alpha),oklab:r=>new Oklab(...ColorConverter.xyzd65ToOklab(...ColorConverter.xyzd50ToD65(...r.#o())),r.alpha),srgb:r=>new ColorFunction("srgb",...ColorConverter.xyzd50ToSrgb(...r.#o()),r.alpha),"srgb-linear":r=>new ColorFunction("srgb-linear",...ColorConverter.xyzd50TosRGBLinear(...r.#o()),r.alpha),"display-p3":r=>new ColorFunction("display-p3",...ColorConverter.xyzd50ToDisplayP3(...r.#o()),r.alpha),"a98-rgb":r=>new ColorFunction("a98-rgb",...ColorConverter.xyzd50ToAdobeRGB(...r.#o()),r.alpha),"prophoto-rgb":r=>new ColorFunction("prophoto-rgb",...ColorConverter.xyzd50ToProPhoto(...r.#o()),r.alpha),rec2020:r=>new ColorFunction("rec2020",...ColorConverter.xyzd50ToRec2020(...r.#o()),r.alpha),xyz:r=>new ColorFunction("xyz",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha),"xyz-d50":r=>new ColorFunction("xyz-d50",...r.#o(),r.alpha),"xyz-d65":r=>new ColorFunction("xyz-d65",...ColorConverter.xyzd50ToD65(...r.#o()),r.alpha)};#o(){const[r,e,t]=this.#l;return ColorConverter.srgbToXyzd50(r,e,t)}get alpha(){switch(this.format()){case"hexa":case"shorthexa":case"rgba":return this.#l[3];default:return null}}asLegacyColor(){return this}constructor(r,e,t){this.#r=t||null,this.#s=e,this.#e=[r[0],r[1],r[2]],this.#l=[clamp(r[0],{min:0,max:1}),clamp(r[1],{min:0,max:1}),clamp(r[2],{min:0,max:1}),clamp(r[3]??1,{min:0,max:1})]}static fromHex(r,e){let t;3===(r=r.toLowerCase()).length?(t="shorthex",r=r.charAt(0)+r.charAt(0)+r.charAt(1)+r.charAt(1)+r.charAt(2)+r.charAt(2)):4===r.length?(t="shorthexa",r=r.charAt(0)+r.charAt(0)+r.charAt(1)+r.charAt(1)+r.charAt(2)+r.charAt(2)+r.charAt(3)+r.charAt(3)):t=6===r.length?"hex":"hexa";const a=parseInt(r.substring(0,2),16),o=parseInt(r.substring(2,4),16),n=parseInt(r.substring(4,6),16);let l=1;return 8===r.length&&(l=parseInt(r.substring(6,8),16)/255),new Legacy([a/255,o/255,n/255,l],t,e)}static fromName(r,e){const t=r.toLowerCase(),a=Nicknames.get(t);if(void 0!==a){const r=Legacy.fromRGBA(a,e);return r.#s="nickname",r}return null}static fromRGBAFunction(r,e,t,a,o){const n=[parseRgbNumeric(r),parseRgbNumeric(e),parseRgbNumeric(t),a?parseAlphaNumeric(a):1];return Platform.ArrayUtilities.arrayDoesNotContainNullOrUndefined(n)?new Legacy(n,a?"rgba":"rgb",o):null}static fromRGBA(r,e){return new Legacy([r[0]/255,r[1]/255,r[2]/255,r[3]],"rgba",e)}static fromHSVA(r){const e=[0,0,0,0];return hsva2rgba(r,e),new Legacy(e,"rgba")}as(r){return r===this.format()?this:Legacy.#t[r](this)}format(){return this.#s}hasAlpha(){return 1!==this.#l[3]}detectHEXFormat(){let r=!0;for(let e=0;e<4;++e){if(Math.round(255*this.#l[e])%17){r=!1;break}}const e=this.hasAlpha();return r?e?"shorthexa":"shorthex":e?"hexa":"hex"}asString(r){return r?this.as(r).asString():this.#n(r,this.#l[0],this.#l[1],this.#l[2])}#n(r,e,t,a){function o(r){const e=Math.round(255*r).toString(16);return 1===e.length?"0"+e:e}function n(r){return(Math.round(255*r)/17).toString(16)}switch(r||(r=this.#s),r){case"rgb":case"rgba":{const r=Platform.StringUtilities.sprintf("rgb(%d %d %d",toRgbValue(e),toRgbValue(t),toRgbValue(a));return this.hasAlpha()?r+Platform.StringUtilities.sprintf(" / %d%)",Math.round(100*this.#l[3])):r+")"}case"hexa":return Platform.StringUtilities.sprintf("#%s%s%s%s",o(e),o(t),o(a),o(this.#l[3])).toLowerCase();case"hex":return this.hasAlpha()?null:Platform.StringUtilities.sprintf("#%s%s%s",o(e),o(t),o(a)).toLowerCase();case"shorthexa":{const r=this.detectHEXFormat();return"shorthexa"!==r&&"shorthex"!==r?null:Platform.StringUtilities.sprintf("#%s%s%s%s",n(e),n(t),n(a),n(this.#l[3])).toLowerCase()}case"shorthex":return this.hasAlpha()||"shorthex"!==this.detectHEXFormat()?null:Platform.StringUtilities.sprintf("#%s%s%s",n(e),n(t),n(a)).toLowerCase();case"nickname":return this.nickname()}return null}getAuthoredText(){return this.#r??null}getRawParameters(){return[...this.#e]}getAsRawString(r){return r?this.as(r).getAsRawString():this.#n(r,...this.#e)}isGamutClipped(){return!equals(this.#e.map(toRgbValue),[this.#l[0],this.#l[1],this.#l[2]].map(toRgbValue),1)}rgba(){return[...this.#l]}canonicalRGBA(){const r=new Array(4);for(let e=0;e<3;++e)r[e]=Math.round(255*this.#l[e]);return r[3]=this.#l[3],r}nickname(){return RGBAToNickname.get(String(this.canonicalRGBA()))||null}toProtocolRGBA(){const r=this.canonicalRGBA(),e={r:r[0],g:r[1],b:r[2],a:void 0};return 1!==r[3]&&(e.a=r[3]),e}invert(){const r=[0,0,0,0];return r[0]=1-this.#l[0],r[1]=1-this.#l[1],r[2]=1-this.#l[2],r[3]=this.#l[3],new Legacy(r,"rgba")}setAlpha(r){const e=[...this.#l];return e[3]=r,new Legacy(e,"rgba")}blendWith(r){const e=blendColors(r.#l,this.#l);return new Legacy(e,"rgba")}blendWithAlpha(r){const e=[...this.#l];return e[3]*=r,new Legacy(e,"rgba")}setFormat(r){this.#s=r}equal(r){const e=r.as(this.#s);return equals(toRgbValue(this.#l[0]),toRgbValue(e.#l[0]),1)&&equals(toRgbValue(this.#l[1]),toRgbValue(e.#l[1]),1)&&equals(toRgbValue(this.#l[2]),toRgbValue(e.#l[2]),1)&&equals(this.#l[3],e.#l[3])}}export const Regex=/((?:rgba?|hsla?|hwba?|lab|lch|oklab|oklch|color)\([^)]+\)|#[0-9a-fA-F]{8}|#[0-9a-fA-F]{6}|#[0-9a-fA-F]{3,4}|\b[a-zA-Z]+\b(?!-))/g;export const ColorMixRegex=/color-mix\(.*,\s*(?<firstColor>.+)\s*,\s*(?<secondColor>.+)\s*\)/g;const COLOR_TO_RGBA_ENTRIES=[["aliceblue",[240,248,255]],["antiquewhite",[250,235,215]],["aqua",[0,255,255]],["aquamarine",[127,255,212]],["azure",[240,255,255]],["beige",[245,245,220]],["bisque",[255,228,196]],["black",[0,0,0]],["blanchedalmond",[255,235,205]],["blue",[0,0,255]],["blueviolet",[138,43,226]],["brown",[165,42,42]],["burlywood",[222,184,135]],["cadetblue",[95,158,160]],["chartreuse",[127,255,0]],["chocolate",[210,105,30]],["coral",[255,127,80]],["cornflowerblue",[100,149,237]],["cornsilk",[255,248,220]],["crimson",[237,20,61]],["cyan",[0,255,255]],["darkblue",[0,0,139]],["darkcyan",[0,139,139]],["darkgoldenrod",[184,134,11]],["darkgray",[169,169,169]],["darkgrey",[169,169,169]],["darkgreen",[0,100,0]],["darkkhaki",[189,183,107]],["darkmagenta",[139,0,139]],["darkolivegreen",[85,107,47]],["darkorange",[255,140,0]],["darkorchid",[153,50,204]],["darkred",[139,0,0]],["darksalmon",[233,150,122]],["darkseagreen",[143,188,143]],["darkslateblue",[72,61,139]],["darkslategray",[47,79,79]],["darkslategrey",[47,79,79]],["darkturquoise",[0,206,209]],["darkviolet",[148,0,211]],["deeppink",[255,20,147]],["deepskyblue",[0,191,255]],["dimgray",[105,105,105]],["dimgrey",[105,105,105]],["dodgerblue",[30,144,255]],["firebrick",[178,34,34]],["floralwhite",[255,250,240]],["forestgreen",[34,139,34]],["fuchsia",[255,0,255]],["gainsboro",[220,220,220]],["ghostwhite",[248,248,255]],["gold",[255,215,0]],["goldenrod",[218,165,32]],["gray",[128,128,128]],["grey",[128,128,128]],["green",[0,128,0]],["greenyellow",[173,255,47]],["honeydew",[240,255,240]],["hotpink",[255,105,180]],["indianred",[205,92,92]],["indigo",[75,0,130]],["ivory",[255,255,240]],["khaki",[240,230,140]],["lavender",[230,230,250]],["lavenderblush",[255,240,245]],["lawngreen",[124,252,0]],["lemonchiffon",[255,250,205]],["lightblue",[173,216,230]],["lightcoral",[240,128,128]],["lightcyan",[224,255,255]],["lightgoldenrodyellow",[250,250,210]],["lightgreen",[144,238,144]],["lightgray",[211,211,211]],["lightgrey",[211,211,211]],["lightpink",[255,182,193]],["lightsalmon",[255,160,122]],["lightseagreen",[32,178,170]],["lightskyblue",[135,206,250]],["lightslategray",[119,136,153]],["lightslategrey",[119,136,153]],["lightsteelblue",[176,196,222]],["lightyellow",[255,255,224]],["lime",[0,255,0]],["limegreen",[50,205,50]],["linen",[250,240,230]],["magenta",[255,0,255]],["maroon",[128,0,0]],["mediumaquamarine",[102,205,170]],["mediumblue",[0,0,205]],["mediumorchid",[186,85,211]],["mediumpurple",[147,112,219]],["mediumseagreen",[60,179,113]],["mediumslateblue",[123,104,238]],["mediumspringgreen",[0,250,154]],["mediumturquoise",[72,209,204]],["mediumvioletred",[199,21,133]],["midnightblue",[25,25,112]],["mintcream",[245,255,250]],["mistyrose",[255,228,225]],["moccasin",[255,228,181]],["navajowhite",[255,222,173]],["navy",[0,0,128]],["oldlace",[253,245,230]],["olive",[128,128,0]],["olivedrab",[107,142,35]],["orange",[255,165,0]],["orangered",[255,69,0]],["orchid",[218,112,214]],["palegoldenrod",[238,232,170]],["palegreen",[152,251,152]],["paleturquoise",[175,238,238]],["palevioletred",[219,112,147]],["papayawhip",[255,239,213]],["peachpuff",[255,218,185]],["peru",[205,133,63]],["pink",[255,192,203]],["plum",[221,160,221]],["powderblue",[176,224,230]],["purple",[128,0,128]],["rebeccapurple",[102,51,153]],["red",[255,0,0]],["rosybrown",[188,143,143]],["royalblue",[65,105,225]],["saddlebrown",[139,69,19]],["salmon",[250,128,114]],["sandybrown",[244,164,96]],["seagreen",[46,139,87]],["seashell",[255,245,238]],["sienna",[160,82,45]],["silver",[192,192,192]],["skyblue",[135,206,235]],["slateblue",[106,90,205]],["slategray",[112,128,144]],["slategrey",[112,128,144]],["snow",[255,250,250]],["springgreen",[0,255,127]],["steelblue",[70,130,180]],["tan",[210,180,140]],["teal",[0,128,128]],["thistle",[216,191,216]],["tomato",[255,99,71]],["turquoise",[64,224,208]],["violet",[238,130,238]],["wheat",[245,222,179]],["white",[255,255,255]],["whitesmoke",[245,245,245]],["yellow",[255,255,0]],["yellowgreen",[154,205,50]],["transparent",[0,0,0,0]]];Platform.DCHECK((()=>COLOR_TO_RGBA_ENTRIES.every((([r])=>r.toLowerCase()===r))),"All color nicknames must be lowercase.");export const Nicknames=new Map(COLOR_TO_RGBA_ENTRIES);const RGBAToNickname=new Map(COLOR_TO_RGBA_ENTRIES.map((([r,[e,t,a,o=1]])=>[String([e,t,a,o]),r]))),LAYOUT_LINES_HIGHLIGHT_COLOR=[127,32,210];export const PageHighlight={Content:Legacy.fromRGBA([111,168,220,.66]),ContentLight:Legacy.fromRGBA([111,168,220,.5]),ContentOutline:Legacy.fromRGBA([9,83,148]),Padding:Legacy.fromRGBA([147,196,125,.55]),PaddingLight:Legacy.fromRGBA([147,196,125,.4]),Border:Legacy.fromRGBA([255,229,153,.66]),BorderLight:Legacy.fromRGBA([255,229,153,.5]),Margin:Legacy.fromRGBA([246,178,107,.66]),MarginLight:Legacy.fromRGBA([246,178,107,.5]),EventTarget:Legacy.fromRGBA([255,196,196,.66]),Shape:Legacy.fromRGBA([96,82,177,.8]),ShapeMargin:Legacy.fromRGBA([96,82,127,.6]),CssGrid:Legacy.fromRGBA([75,0,130,1]),LayoutLine:Legacy.fromRGBA([...LAYOUT_LINES_HIGHLIGHT_COLOR,1]),GridBorder:Legacy.fromRGBA([...LAYOUT_LINES_HIGHLIGHT_COLOR,1]),GapBackground:Legacy.fromRGBA([...LAYOUT_LINES_HIGHLIGHT_COLOR,.3]),GapHatch:Legacy.fromRGBA([...LAYOUT_LINES_HIGHLIGHT_COLOR,.8]),GridAreaBorder:Legacy.fromRGBA([26,115,232,1])};export const SourceOrderHighlight={ParentOutline:Legacy.fromRGBA([224,90,183,1]),ChildOutline:Legacy.fromRGBA([0,120,212,1])};export const IsolationModeHighlight={Resizer:Legacy.fromRGBA([222,225,230,1]),ResizerHandle:Legacy.fromRGBA([166,166,166,1]),Mask:Legacy.fromRGBA([248,249,249,1])};export class Generator{#i;#h;#c;#g;#u;constructor(r,e,t,a){this.#i=r||{min:0,max:360,count:void 0},this.#h=e||67,this.#c=t||80,this.#g=a||1,this.#u=new Map}setColorForID(r,e){this.#u.set(r,e)}colorForID(r){let e=this.#u.get(r);return e||(e=this.generateColorForID(r),this.#u.set(r,e)),e}generateColorForID(r){const e=Platform.StringUtilities.hashCode(r),t=this.indexToValueInSpace(e,this.#i),a=this.indexToValueInSpace(e>>8,this.#h),o=this.indexToValueInSpace(e>>16,this.#c),n=this.indexToValueInSpace(e>>24,this.#g),l=`hsl(${t}deg ${a}% ${o}%`;return 1!==n?`${l} / ${Math.floor(100*n)}%)`:`${l})`}indexToValueInSpace(r,e){if("number"==typeof e)return e;const t=e.count||e.max-e.min;return r%=t,e.min+Math.floor(r/(t-1)*(e.max-e.min))}}