import*as i18n from"../../core/i18n/i18n.js";import{Issue,IssueCategory,IssueKind}from"./Issue.js";import{resolveLazyDescription}from"./MarkdownIssueDescription.js";const UIStrings={crossOriginPortalPostMessage:"Portals - Same-origin communication channels",howDoesAutofillWorkPageTitle:"How does autofill work?",labelFormlementsPageTitle:"The label elements",inputFormElementPageTitle:"The form input element",autocompleteAttributePageTitle:"HTML attribute: autocomplete",corbExplainerPageTitle:"CORB explainer"},str_=i18n.i18n.registerUIStrings("models/issues_manager/GenericIssue.ts",UIStrings),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class GenericIssue extends Issue{#e;constructor(e,r,t){super(["GenericIssue",e.errorType].join("::"),r,t),this.#e=e}requests(){return this.#e.request?[this.#e.request]:[]}getCategory(){return IssueCategory.Generic}primaryKey(){const e=this.#e.request?this.#e.request.requestId:"no-request";return`${this.code()}-(${this.#e.frameId})-(${this.#e.violatingNodeId})-(${this.#e.violatingNodeAttribute})-(${e})`}getDescription(){const e=issueDescriptions.get(this.#e.errorType);return e?resolveLazyDescription(e):null}details(){return this.#e}getKind(){return issueTypes.get(this.#e.errorType)||IssueKind.Improvement}static fromInspectorIssue(e,r){const t=r.details.genericIssueDetails;return t?[new GenericIssue(t,e,r.issueId)]:(console.warn("Generic issue without details received."),[])}}export const genericCrossOriginPortalPostMessageError={file:"genericCrossOriginPortalPostMessageError.md",links:[{link:"https://github.com/WICG/portals#same-origin-communication-channels",linkTitle:i18nLazyString(UIStrings.crossOriginPortalPostMessage)}]};export const genericFormLabelForNameError={file:"genericFormLabelForNameError.md",links:[{link:"https://html.spec.whatwg.org/multipage/forms.html#attr-label-for",linkTitle:i18n.i18n.lockedLazyString("HTML Standard")}]};export const genericFormInputWithNoLabelError={file:"genericFormInputWithNoLabelError.md",links:[]};export const genericFormAutocompleteAttributeEmptyError={file:"genericFormAutocompleteAttributeEmptyError.md",links:[]};export const genericFormDuplicateIdForInputError={file:"genericFormDuplicateIdForInputError.md",links:[{link:"https://web.dev/learn/forms/autofill/#how-does-autofill-work",linkTitle:i18nLazyString(UIStrings.howDoesAutofillWorkPageTitle)}]};export const genericFormAriaLabelledByToNonExistingId={file:"genericFormAriaLabelledByToNonExistingId.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label",linkTitle:i18nLazyString(UIStrings.labelFormlementsPageTitle)}]};export const genericFormEmptyIdAndNameAttributesForInputError={file:"genericFormEmptyIdAndNameAttributesForInputError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input",linkTitle:i18nLazyString(UIStrings.inputFormElementPageTitle)}]};export const genericFormInputAssignedAutocompleteValueToIdOrNameAttributeError={file:"genericFormInputAssignedAutocompleteValueToIdOrNameAttributeError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete#values",linkTitle:i18nLazyString(UIStrings.autocompleteAttributePageTitle)}]};export const genericFormInputHasWrongButWellIntendedAutocompleteValue={file:"genericFormInputHasWrongButWellIntendedAutocompleteValueError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete#values",linkTitle:i18nLazyString(UIStrings.autocompleteAttributePageTitle)}]};export const genericFormLabelForMatchesNonExistingIdError={file:"genericFormLabelForMatchesNonExistingIdError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label",linkTitle:i18nLazyString(UIStrings.labelFormlementsPageTitle)}]};export const genericFormLabelHasNeitherForNorNestedInput={file:"genericFormLabelHasNeitherForNorNestedInput.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label",linkTitle:i18nLazyString(UIStrings.labelFormlementsPageTitle)}]};export const genericResponseWasBlockedbyORB={file:"genericResponseWasBlockedByORB.md",links:[{link:"https://www.chromium.org/Home/chromium-security/corb-for-developers/",linkTitle:i18nLazyString(UIStrings.corbExplainerPageTitle)}]};const issueDescriptions=new Map([["CrossOriginPortalPostMessageError",genericCrossOriginPortalPostMessageError],["FormLabelForNameError",genericFormLabelForNameError],["FormInputWithNoLabelError",genericFormInputWithNoLabelError],["FormAutocompleteAttributeEmptyError",genericFormAutocompleteAttributeEmptyError],["FormDuplicateIdForInputError",genericFormDuplicateIdForInputError],["FormAriaLabelledByToNonExistingId",genericFormAriaLabelledByToNonExistingId],["FormEmptyIdAndNameAttributesForInputError",genericFormEmptyIdAndNameAttributesForInputError],["FormInputAssignedAutocompleteValueToIdOrNameAttributeError",genericFormInputAssignedAutocompleteValueToIdOrNameAttributeError],["FormLabelForMatchesNonExistingIdError",genericFormLabelForMatchesNonExistingIdError],["FormLabelHasNeitherForNorNestedInput",genericFormLabelHasNeitherForNorNestedInput],["FormInputHasWrongButWellIntendedAutocompleteValueError",genericFormInputHasWrongButWellIntendedAutocompleteValue],["ResponseWasBlockedByORB",genericResponseWasBlockedbyORB]]),issueTypes=new Map([["CrossOriginPortalPostMessageError",IssueKind.Improvement],["FormLabelForNameError",IssueKind.PageError],["FormInputWithNoLabelError",IssueKind.Improvement],["FormAutocompleteAttributeEmptyError",IssueKind.PageError],["FormDuplicateIdForInputError",IssueKind.PageError],["FormAriaLabelledByToNonExistingId",IssueKind.Improvement],["FormEmptyIdAndNameAttributesForInputError",IssueKind.Improvement],["FormInputAssignedAutocompleteValueToIdOrNameAttributeError",IssueKind.Improvement],["FormLabelForMatchesNonExistingIdError",IssueKind.PageError],["FormLabelHasNeitherForNorNestedInput",IssueKind.Improvement],["FormInputHasWrongButWellIntendedAutocompleteValueError",IssueKind.Improvement]]);