export default{cssContent:"/*\n * Copyright 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n/* Media query bars */\n\n.media-inspector-view {\n  height: 50px;\n  /* (min-width: 50px) */\n  --override-min-width-media-query-selector-background-color: rgb(255 204 128);\n  --override-min-width-media-query-selector-background-color-inactive: rgb(255 243 224);\n  --override-min-width-media-query-selector-marker-color: rgb(245 122 0);\n  /* (min-width: 50px) and (max-width: 50px) */\n  --override-min-and-max-width-media-query-selector-background-color: rgb(196 224 163);\n  --override-min-and-max-width-media-query-selector-background-color-inactive: rgb(234 246 235);\n  --override-min-and-max-width-media-query-selector-marker-color: rgb(104 159 56);\n  /* (max-width: 50px) */\n  --override-max-width-media-query-selector-background-color: rgb(144 202 249);\n  --override-max-width-media-query-selector-background-color-inactive: rgb(225 245 254);\n  --override-max-width-media-query-selector-marker-color: rgb(66 165 245);\n}\n\n.-theme-with-dark-background .media-inspector-view,\n:host-context(.-theme-with-dark-background) .media-inspector-view {\n  /* (min-width: 50px) */\n  --override-min-width-media-query-selector-background-color: rgb(127 76 0);\n  --override-min-width-media-query-selector-background-color-inactive: rgb(31 19 0);\n  --override-min-width-media-query-selector-marker-color: rgb(255 132 10);\n  /* (min-width: 50px) and (max-width: 50px) */\n  --override-min-and-max-width-media-query-selector-background-color: rgb(64 92 31);\n  --override-min-and-max-width-media-query-selector-background-color-inactive: rgb(9 21 10);\n  --override-min-and-max-width-media-query-selector-marker-color: rgb(144 199 96);\n  /* (max-width: 50px) */\n  --override-max-width-media-query-selector-background-color: rgb(6 64 111);\n  --override-max-width-media-query-selector-background-color-inactive: rgb(1 21 30);\n  --override-max-width-media-query-selector-marker-color: rgb(10 109 189);\n}\n\n.media-inspector-marker-container {\n  height: 14px;\n  margin: 2px 0;\n  position: relative;\n}\n\n.media-inspector-bar {\n  display: flex;\n  flex-direction: row;\n  align-items: stretch;\n  pointer-events: none;\n  position: absolute;\n  left: 0;\n  right: 0;\n  top: 0;\n  bottom: 0;\n}\n\n.media-inspector-marker {\n  flex: none;\n  pointer-events: auto;\n  margin: 1px 0;\n  white-space: nowrap;\n  z-index: auto;\n  position: relative;\n}\n\n.media-inspector-marker-spacer {\n  flex: auto;\n}\n\n.media-inspector-marker:hover {\n  margin: -1px 0;\n  opacity: 100%;\n}\n\n.media-inspector-marker-min-width {\n  flex: auto;\n  background-color: var(--override-min-width-media-query-selector-background-color);\n  border-right: 2px solid var(--override-min-width-media-query-selector-marker-color);\n  border-left: 2px solid var(--override-min-width-media-query-selector-marker-color);\n}\n\n.media-inspector-marker-min-width-right {\n  border-left: 2px solid var(--override-min-width-media-query-selector-marker-color);\n}\n\n.media-inspector-marker-min-width-left {\n  border-right: 2px solid var(--override-min-width-media-query-selector-marker-color);\n}\n\n.media-inspector-marker-min-max-width {\n  background-color: var(--override-min-and-max-width-media-query-selector-background-color);\n  border-left: 2px solid var(--override-min-and-max-width-media-query-selector-marker-color);\n  border-right: 2px solid var(--override-min-and-max-width-media-query-selector-marker-color);\n}\n\n.media-inspector-marker-min-max-width:hover {\n  z-index: 1;\n}\n\n.media-inspector-marker-max-width {\n  background-color: var(--override-max-width-media-query-selector-background-color);\n  border-right: 2px solid var(--override-max-width-media-query-selector-marker-color);\n  border-left: 2px solid var(--override-max-width-media-query-selector-marker-color);\n}\n\n/* Clear background colors when query is not active and not hovering */\n\n.media-inspector-marker-inactive .media-inspector-marker-min-width:not(:hover) {\n  background-color: var(--override-min-width-media-query-selector-background-color-inactive);\n}\n\n.media-inspector-marker-inactive .media-inspector-marker-min-max-width:not(:hover) {\n  background-color: var(--override-min-and-max-width-media-query-selector-background-color-inactive);\n}\n\n.media-inspector-marker-inactive .media-inspector-marker-max-width:not(:hover) {\n  background-color: var(--override-max-width-media-query-selector-background-color-inactive);\n}\n\n/* Media query labels */\n\n.media-inspector-marker-label-container {\n  position: absolute;\n  z-index: 1;\n}\n\n.media-inspector-marker:not(:hover) .media-inspector-marker-label-container {\n  display: none;\n}\n\n.media-inspector-marker-label-container-left {\n  left: -2px;\n}\n\n.media-inspector-marker-label-container-right {\n  right: -2px;\n}\n\n.media-inspector-marker-label {\n  color: var(--color-text-primary);\n  position: absolute;\n  top: 1px;\n  bottom: 0;\n  font-size: 12px;\n  pointer-events: none;\n}\n\n.media-inspector-label-right {\n  right: 4px;\n}\n\n.media-inspector-label-left {\n  left: 4px;\n}\n"};