const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (c) 2020 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n/* Remove container padding from TreeOutline.\n * Allows issues to touch the edges of the container. */\n:host,\n.issues {\n  padding: 0;\n  overflow: auto;\n}\n\n.issues {\n  --issue-indent: 8px;\n}\n\n/* Override whitespace behavior for tree items to allow wrapping */\n.issues li {\n  white-space: normal;\n  align-items: flex-start;\n}\n\n/* Hide toggle for tree items which cannot be collapsed */\n.issues .always-parent::before {\n  display: none;\n}\n\n.issues li.parent::before {\n  margin-top: 8px;\n}\n\n.issues .affected-resources li.parent::before {\n  margin-top: 3px;\n  margin-right: 0;\n}\n\n.issue-category,\n.issue-kind,\n.issue {\n  padding: 0 8px;\n  padding-left: var(--issue-indent);\n  overflow: hidden;\n  flex: none;\n  transition: background-color 200ms;\n  border: 1px solid var(--color-details-hairline-light);\n  border-width: 0 0 1px;\n}\n\n.issue-category.hidden-issues.parent.expanded,\n.issue-kind.parent.expanded {\n  border-width: 0 0 1px;\n  background-color: var(--color-background-elevation-1);\n}\n\n.issue-category + .children .issue,\n.issue.expanded {\n  background: var(--sys-color-cdt-base-container);\n}\n\n.issue.expanded {\n  border-width: 0;\n}\n\n.issue.selected,\n.issue.expanded.selected {\n  background-color: var(--legacy-focus-bg-color);\n}\n\n.unhide-all-issues-button {\n  margin: 0;\n  height: 20px;\n}\n\np {\n  margin-block-start: 2px;\n  margin-block-end: 2px;\n}\n\n/* Override selected tree item styles for issues to avoid changing width. */\n.tree-outline-disclosure:not(.tree-outline-disclosure-hide-overflow) .tree-outline.hide-selection-when-blurred .issue-category.selected:focus-visible,\n.tree-outline-disclosure:not(.tree-outline-disclosure-hide-overflow) .tree-outline.hide-selection-when-blurred .issue-kind.selected:focus-visible,\n.tree-outline-disclosure:not(.tree-outline-disclosure-hide-overflow) .tree-outline.hide-selection-when-blurred .issue.selected:focus-visible {\n  width: auto;\n  padding-right: 8px;\n}\n\n.header {\n  display: flex;\n  flex-direction: row;\n  align-items: flex-start;\n  padding: 4px 0;\n  cursor: pointer;\n  width: 100%;\n}\n\n.header devtools-hide-issues-menu {\n  visibility: hidden;\n}\n\n.header:hover devtools-hide-issues-menu {\n  visibility: visible;\n}\n\n.header devtools-hide-issues-menu.has-context-menu-opened {\n  visibility: visible;\n}\n\n.title {\n  flex: 1;\n  font-size: 14px;\n  color: var(--color-text-primary);\n  font-weight: normal;\n  user-select: text;\n  padding-top: 2px;\n}\n\n.issue.expanded .title {\n  font-weight: 450;\n}\n\n.body.children {\n  border-bottom: 1px solid var(--color-details-hairline-light);\n  padding: 6px 0;\n  position: relative;\n  padding-left: calc(var(--issue-indent) + 43px);\n  padding-bottom: 26px;\n  padding-right: 8px;\n}\n\n.issue-category + .children,\n.issue-kind + .children {\n  --issue-indent: 24px;\n\n  padding-left: 0;\n}\n\n/* Show a colored border on the left side of opened issues. */\n.body::before {\n  content: "";\n  display: block;\n  position: absolute;\n  left: calc(var(--issue-indent) + 23px);\n  top: 0;\n  bottom: 20px;\n  width: 2px;\n}\n\n.issue-kind-breaking-change.body::before {\n  border-left: 2px solid var(--issue-color-yellow);\n}\n\n.issue-kind-page-error.body::before {\n  border-left: 2px solid var(--issue-color-red);\n}\n\n.issue-kind-improvement.body::before {\n  border-left: 2px solid var(--issue-color-blue);\n}\n\ndevtools-icon.leading-issue-icon {\n  margin: 1px 0 -1px 7px;\n}\n\n.message {\n  line-height: 20px;\n  font-size: 14px;\n  color: var(--color-text-secondary);\n  margin-bottom: 4px;\n  user-select: text;\n}\n\n.message p {\n  margin-bottom: 16px;\n}\n\n.message li {\n  margin-top: 8px;\n}\n\n.message code {\n  color: var(--color-text-primary);\n  font-size: 12px;\n  user-select: text;\n  cursor: text;\n  background: var(--color-background-elevation-1);\n}\n\n.separator::before {\n  content: "·";\n  padding-left: 1ex;\n  padding-right: 1ex;\n}\n\n.link {\n  font-size: 14px;\n  color: var(--color-link);\n}\n\n.link-wrapper {\n  margin-top: 15px;\n  user-select: text;\n}\n\n.affected-resources-label,\n.resolutions-label {\n  margin-top: 5px;\n  font-size: 10px;\n  font-weight: 500;\n  letter-spacing: 0.06em;\n  text-transform: uppercase;\n  color: var(--color-text-primary);\n  display: inline-block;\n}\n\n.link-list {\n  list-style-type: none;\n  list-style-position: inside;\n  padding-inline-start: 0;\n}\n\n.resolutions-list {\n  list-style-type: none;\n  list-style-position: inside;\n  padding-inline-start: 0;\n}\n\n/* We inherit all the styles from treeoutline, but these are simple text <li>, so we override some styles */\n.link-list li::before {\n  content: none;\n  -webkit-mask-image: none;\n}\n\n.resolutions-list li::before {\n  content: "→";\n  -webkit-mask-image: none;\n  padding-right: 5px;\n  position: relative;\n  top: -1px;\n}\n\n.resolutions-list li {\n  display: list-item;\n}\n\nul > li.plain-enum {\n  display: list-item;\n}\n\n/* This is a hack because the tree view\'s CSS overrides list styling in a non-compositional way. This\n   can be removed once we\'ve moved to proper components. */\nul > li.plain-enum::before {\n  content: "";\n  padding: 0;\n  margin: 0;\n  max-width: 0;\n}\n\n.affected-resources-label + .affected-resources {\n  padding: 3px 0 0;\n  position: relative;\n  user-select: text;\n}\n\n.affected-resource-label {\n  font-size: 14px;\n  line-height: 20px;\n  color: var(--color-text-primary);\n  position: relative;\n  cursor: pointer;\n}\n\n.affected-resource-cookie {\n  font-size: 14px;\n  line-height: 20px;\n  border: 0;\n  border-collapse: collapse;\n}\n\n.affected-resource-element {\n  font-size: 14px;\n  line-height: 20px;\n  color: var(--color-link);\n  border: 0;\n  border-collapse: collapse;\n}\n\n.affected-resource-row {\n  font-size: 14px;\n  line-height: 20px;\n  border: 0;\n  border-collapse: collapse;\n  vertical-align: top;\n}\n\n.affected-resource-mixed-content {\n  font-size: 14px;\n  line-height: 20px;\n  border: 0;\n  border-collapse: collapse;\n}\n\n.affected-resource-heavy-ad {\n  font-size: 14px;\n  line-height: 20px;\n  border: 0;\n  border-collapse: collapse;\n}\n\n.affected-resource-request {\n  font-size: 14px;\n  line-height: 20px;\n  border: 0;\n  border-collapse: collapse;\n}\n\n.affected-resource-source {\n  font-size: 14px;\n  line-height: 20px;\n  color: var(--color-link);\n  border: 0;\n  border-collapse: collapse;\n}\n\n.affected-resource-list {\n  border-spacing: 10px 0;\n  margin-left: -12px;\n}\n\n.affected-resource-header {\n  font-size: 12px;\n  color: var(--color-text-primary);\n  padding-left: 2px;\n}\n\n.code-example {\n  font-family: var(--monospace-font-family);\n  font-size: var(--monospace-font-size);\n}\n\n.affected-resource-blocked-status {\n  color: var(--issue-color-red);\n}\n\n.affected-resource-report-only-status {\n  color: var(--issue-color-yellow);\n}\n\n.affected-resource-cookie-info {\n  color: var(--color-text-secondary);\n  padding: 2px;\n  text-align: right;\n}\n\n.affected-resource-cookie-info-header {\n  text-align: right;\n}\n\n.affected-resource-mixed-content-info {\n  color: var(--color-text-secondary);\n  padding: 2px;\n}\n\n.affected-resource-heavy-ad-info {\n  color: var(--color-text-secondary);\n  padding: 2px;\n}\n\n.affected-resource-heavy-ad-info-frame {\n  display: flex;\n  align-items: center;\n  color: var(--color-text-secondary);\n  padding: 2px;\n}\n\n.affected-resource-cell {\n  color: var(--color-text-secondary);\n  padding: 2px;\n}\n\n.affected-resource-cell.link {\n  color: var(--color-link);\n}\n\n.affected-resource-cell span.icon {\n  margin-right: 0.5ex;\n  vertical-align: sub;\n}\n\n.affected-resources > .parent {\n  margin-top: 0;\n  padding: 2px 5px 0;\n}\n\n.affected-resources > .parent.expanded {\n  background: var(--color-background-elevation-0);\n}\n\n.affected-resources > .children.expanded {\n  background: var(--color-background-elevation-0);\n  padding: 6px 0 9px 5px;\n  margin-bottom: 10px;\n}\n\n.aggregated-issues-count {\n  padding: 3px 7px 0;\n}\n\n.affected-resource-directive-info-header {\n  text-align: left;\n}\n\n.affected-resource-directive {\n  font-size: 14px;\n  line-height: 20px;\n  border: 0;\n  border-collapse: collapse;\n}\n\n.affected-resource-directive-info {\n  color: var(--color-text-secondary);\n  padding: 2px;\n  text-align: left;\n}\n\n.devtools-link {\n  padding-top: 4px;\n}\n\ndevtools-icon.link-icon {\n  vertical-align: sub;\n  margin-right: 0.5ch;\n}\n\ndevtools-icon.elements-panel,\ndevtools-icon.network-panel {\n  margin-right: 0.5ex;\n  vertical-align: baseline;\n  height: 14px;\n}\n\n@media (forced-colors: active) {\n  .title {\n    color: ButtonText;\n  }\n\n  .tree-outline:not(.hide-selection-when-blurred) .selected .header .title,\n  .tree-outline.hide-selection-when-blurred .selected:focus-visible .header .title {\n    color: HighlightText;\n  }\n}\n\n/*# sourceURL=issuesTree.css */\n');export default styles;