const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (C) 2013 Google Inc. All rights reserved.\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions are\n * met:\n *\n *     * Redistributions of source code must retain the above copyright\n * notice, this list of conditions and the following disclaimer.\n *     * Redistributions in binary form must reproduce the above\n * copyright notice, this list of conditions and the following disclaimer\n * in the documentation and/or other materials provided with the\n * distribution.\n *     * Neither the name of Google Inc. nor the names of its\n * contributors may be used to endorse or promote products derived from\n * this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\n * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\n * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\n * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n\n.screencast {\n  overflow: hidden;\n}\n\n.screencast-navigation {\n  flex-direction: row;\n  display: flex;\n  flex: 24px 0 0;\n  position: relative;\n  padding-left: 1px;\n  border-bottom: 1px solid var(--color-details-hairline);\n  background-origin: padding-box;\n  background-clip: padding-box;\n}\n\n.screencast-navigation button {\n  border-radius: 2px;\n  background-color: transparent;\n  background-image:\n    image-set(\n      var(--image-file-navigationControls) 1x,\n      var(--image-file-navigationControls_2x) 2x\n    );\n  background-clip: content-box;\n  background-origin: content-box;\n  background-repeat: no-repeat;\n  border: 1px solid transparent;\n  height: 23px;\n  padding: 2px;\n  width: 23px;\n}\n\n.screencast-navigation button:hover,\n.screencast-navigation button:focus {\n  border-color: var(--legacy-accent-color-hover);\n}\n\n.screencast-navigation button:active {\n  border-color: var(--color-background-elevation-2);\n}\n\n.screencast-navigation button[disabled] {\n  opacity: 50%;\n}\n\n.screencast-navigation button.back {\n  background-position-x: -1px;\n}\n\n.screencast-navigation button.forward {\n  background-position-x: -18px;\n}\n\n.screencast-navigation button.reload {\n  background-position-x: -37px;\n}\n\n.screencast-navigation input {\n  flex: 1;\n  margin: 2px;\n  max-height: 19px;\n}\n\n.screencast-navigation .progress {\n  --override-progress-background-color: rgb(66 129 235);\n\n  background-color: var(--override-progress-background-color);\n  height: 3px;\n  left: 0;\n  position: absolute;\n  top: 100%;  /* Align with the bottom edge of the parent. */\n  width: 0;\n  z-index: 2;  /* Above .screencast-glasspane. */\n}\n\n.-theme-with-dark-background .screencast-navigation .progress,\n:host-context(.-theme-with-dark-background) .screencast-navigation .progress {\n  --override-progress-background-color: rgb(20 83 189);\n}\n\n.screencast-viewport {\n  display: flex;\n  border: 1px solid var(--color-details-hairline);\n  border-radius: 20px;\n  flex: none;\n  padding: 20px;\n  margin: 10px;\n  background-color: var(--color-background-elevation-2);\n}\n\n.screencast-canvas-container {\n  flex: auto;\n  display: flex;\n  border: 1px solid var(--color-details-hairline);\n  position: relative;\n  cursor: image-set(var(--image-file-touchCursor) 1x, var(--image-file-touchCursor_2x) 2x), default;\n}\n\n.screencast canvas {\n  flex: auto;\n  position: relative;\n}\n\n.screencast-element-title {\n  position: absolute;\n  z-index: 10;\n}\n\n.screencast-tag-name {\n  color: var(--color-token-tag);\n}\n\n.screencast-attribute {\n  color: var(--color-token-attribute);\n}\n\n.screencast-dimension {\n  --override-dimension-color: hsl(0deg 0% 45%);\n  /* Keep this in sync with tool_highlight.css (.dimensions) */\n  color: var(--override-dimension-color);\n}\n\n.screencast-glasspane {\n  background-color: var(--color-background-opacity-80);\n  font-size: 30px;\n  z-index: 100;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n}\n\n/*# sourceURL=screencastView.css */\n');export default styles;