import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Breakpoints from"../../models/breakpoints/breakpoints.js";import*as Workspace from"../../models/workspace/workspace.js";import*as ObjectUI from"../../ui/legacy/components/object_ui/object_ui.js";import*as QuickOpen from"../../ui/legacy/components/quick_open/quick_open.js";import*as UI from"../../ui/legacy/legacy.js";const UIStrings={showSources:"Show Sources",sources:"Sources",showWorkspace:"Show Workspace",workspace:"Workspace",showSnippets:"Show Snippets",snippets:"Snippets",showSearch:"Show Search",search:"Search",showQuickSource:"Show Quick source",quickSource:"Quick source",showThreads:"Show Threads",threads:"Threads",showScope:"Show Scope",scope:"Scope",showWatch:"Show Watch",watch:"Watch",showBreakpoints:"Show Breakpoints",breakpoints:"Breakpoints",pauseScriptExecution:"Pause script execution",resumeScriptExecution:"Resume script execution",stepOverNextFunctionCall:"Step over next function call",stepIntoNextFunctionCall:"Step into next function call",step:"Step",stepOutOfCurrentFunction:"Step out of current function",runSnippet:"Run snippet",deactivateBreakpoints:"Deactivate breakpoints",activateBreakpoints:"Activate breakpoints",addSelectedTextToWatches:"Add selected text to watches",evaluateSelectedTextInConsole:"Evaluate selected text in console",switchFile:"Switch file",rename:"Rename",closeAll:"Close All",jumpToPreviousEditingLocation:"Jump to previous editing location",jumpToNextEditingLocation:"Jump to next editing location",closeTheActiveTab:"Close the active tab",goToLine:"Go to line",goToAFunctionDeclarationruleSet:"Go to a function declaration/rule set",toggleBreakpoint:"Toggle breakpoint",toggleBreakpointEnabled:"Toggle breakpoint enabled",toggleBreakpointInputWindow:"Toggle breakpoint input window",save:"Save",saveAll:"Save all",createNewSnippet:"Create new snippet",addFolderToWorkspace:"Add folder to workspace",addFolder:"Add folder",previousCallFrame:"Previous call frame",nextCallFrame:"Next call frame",incrementCssUnitBy:"Increment CSS unit by {PH1}",decrementCssUnitBy:"Decrement CSS unit by {PH1}",searchInAnonymousAndContent:"Search in anonymous and content scripts",doNotSearchInAnonymousAndContent:"Do not search in anonymous and content scripts",automaticallyRevealFilesIn:"Automatically reveal files in sidebar",doNotAutomaticallyRevealFilesIn:"Do not automatically reveal files in sidebar",enableJavascriptSourceMaps:"Enable JavaScript source maps",disableJavascriptSourceMaps:"Disable JavaScript source maps",enableTabMovesFocus:"Enable tab moves focus",disableTabMovesFocus:"Disable tab moves focus",detectIndentation:"Detect indentation",doNotDetectIndentation:"Do not detect indentation",autocompletion:"Autocompletion",enableAutocompletion:"Enable autocompletion",disableAutocompletion:"Disable autocompletion",bracketMatching:"Bracket matching",enableBracketMatching:"Enable bracket matching",disableBracketMatching:"Disable bracket matching",codeFolding:"Code folding",enableCodeFolding:"Enable code folding",disableCodeFolding:"Disable code folding",showWhitespaceCharacters:"Show whitespace characters:",doNotShowWhitespaceCharacters:"Do not show whitespace characters",none:"None",showAllWhitespaceCharacters:"Show all whitespace characters",all:"All",showTrailingWhitespaceCharacters:"Show trailing whitespace characters",trailing:"Trailing",displayVariableValuesInlineWhile:"Display variable values inline while debugging",doNotDisplayVariableValuesInline:"Do not display variable values inline while debugging",enableCssSourceMaps:"Enable CSS source maps",disableCssSourceMaps:"Disable CSS source maps",allowScrollingPastEndOfFile:"Allow scrolling past end of file",disallowScrollingPastEndOfFile:"Disallow scrolling past end of file",wasmAutoStepping:"When debugging wasm with debug information, do not pause on wasm bytecode if possible",enableWasmAutoStepping:"Enable wasm auto-stepping",disableWasmAutoStepping:"Disable wasm auto-stepping",goTo:"Go to",line:"Line",symbol:"Symbol",open:"Open",file:"File",disableAutoFocusOnDebuggerPaused:"Do not focus Sources panel when triggering a breakpoint",enableAutoFocusOnDebuggerPaused:"Focus Sources panel when triggering a breakpoint",toggleNavigatorSidebar:"Toggle navigator sidebar",toggleDebuggerSidebar:"Toggle debugger sidebar",nextEditorTab:"Next editor",previousEditorTab:"Previous editor"},str_=i18n.i18n.registerUIStrings("panels/sources/sources-meta.ts",UIStrings),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);let loadedSourcesModule,loadedSourcesComponentsModule;async function loadSourcesModule(){return loadedSourcesModule||(loadedSourcesModule=await import("./sources.js")),loadedSourcesModule}async function loadSourcesComponentsModule(){return loadedSourcesComponentsModule||(loadedSourcesComponentsModule=await import("./components/components.js")),loadedSourcesComponentsModule}function maybeRetrieveContextTypes(e){return void 0===loadedSourcesModule?[]:e(loadedSourcesModule)}UI.ViewManager.registerViewExtension({location:"panel",id:"sources",commandPrompt:i18nLazyString(UIStrings.showSources),title:i18nLazyString(UIStrings.sources),order:30,loadView:async()=>(await loadSourcesModule()).SourcesPanel.SourcesPanel.instance()}),UI.ViewManager.registerViewExtension({location:"navigator-view",id:"navigator-files",commandPrompt:i18nLazyString(UIStrings.showWorkspace),title:i18nLazyString(UIStrings.workspace),order:3,persistence:"permanent",loadView:async()=>(await loadSourcesModule()).SourcesNavigator.FilesNavigatorView.instance()}),UI.ViewManager.registerViewExtension({location:"navigator-view",id:"navigator-snippets",commandPrompt:i18nLazyString(UIStrings.showSnippets),title:i18nLazyString(UIStrings.snippets),order:6,persistence:"permanent",loadView:async()=>(await loadSourcesModule()).SourcesNavigator.SnippetsNavigatorView.instance()}),UI.ViewManager.registerViewExtension({location:"drawer-view",id:"sources.search-sources-tab",commandPrompt:i18nLazyString(UIStrings.showSearch),title:i18nLazyString(UIStrings.search),order:7,persistence:"closeable",loadView:async()=>(await loadSourcesModule()).SearchSourcesView.SearchSourcesView.instance()}),UI.ViewManager.registerViewExtension({location:"drawer-view",id:"sources.quick",commandPrompt:i18nLazyString(UIStrings.showQuickSource),title:i18nLazyString(UIStrings.quickSource),persistence:"closeable",order:1e3,loadView:async()=>(await loadSourcesModule()).SourcesPanel.WrapperView.instance()}),UI.ViewManager.registerViewExtension({id:"sources.threads",commandPrompt:i18nLazyString(UIStrings.showThreads),title:i18nLazyString(UIStrings.threads),persistence:"permanent",condition:Root.Runtime.ConditionName.NOT_SOURCES_HIDE_ADD_FOLDER,loadView:async()=>(await loadSourcesModule()).ThreadsSidebarPane.ThreadsSidebarPane.instance()}),UI.ViewManager.registerViewExtension({id:"sources.scopeChain",commandPrompt:i18nLazyString(UIStrings.showScope),title:i18nLazyString(UIStrings.scope),persistence:"permanent",loadView:async()=>(await loadSourcesModule()).ScopeChainSidebarPane.ScopeChainSidebarPane.instance()}),UI.ViewManager.registerViewExtension({id:"sources.watch",commandPrompt:i18nLazyString(UIStrings.showWatch),title:i18nLazyString(UIStrings.watch),persistence:"permanent",loadView:async()=>(await loadSourcesModule()).WatchExpressionsSidebarPane.WatchExpressionsSidebarPane.instance(),hasToolbar:!0}),UI.ViewManager.registerViewExtension({id:"sources.jsBreakpoints",commandPrompt:i18nLazyString(UIStrings.showBreakpoints),title:i18nLazyString(UIStrings.breakpoints),persistence:"permanent",loadView:async()=>(await loadSourcesComponentsModule()).BreakpointsView.BreakpointsView.instance().wrapper}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.toggle-pause",iconClass:"pause",toggleable:!0,toggledIconClass:"resume",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.RevealingActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView,UI.ShortcutRegistry.ForwardedShortcut])),options:[{value:!0,title:i18nLazyString(UIStrings.pauseScriptExecution)},{value:!1,title:i18nLazyString(UIStrings.resumeScriptExecution)}],bindings:[{shortcut:"F8",keybindSets:["devToolsDefault"]},{platform:"windows,linux",shortcut:"Ctrl+\\"},{shortcut:"F5",keybindSets:["vsCode"]},{shortcut:"Shift+F5",keybindSets:["vsCode"]},{platform:"mac",shortcut:"Meta+\\"}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.step-over",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),title:i18nLazyString(UIStrings.stepOverNextFunctionCall),iconClass:"step-over",contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],bindings:[{shortcut:"F10",keybindSets:["devToolsDefault","vsCode"]},{platform:"windows,linux",shortcut:"Ctrl+'"},{platform:"mac",shortcut:"Meta+'"}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.step-into",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),title:i18nLazyString(UIStrings.stepIntoNextFunctionCall),iconClass:"step-into",contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],bindings:[{shortcut:"F11",keybindSets:["devToolsDefault","vsCode"]},{platform:"windows,linux",shortcut:"Ctrl+;"},{platform:"mac",shortcut:"Meta+;"}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.step",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),title:i18nLazyString(UIStrings.step),iconClass:"step",contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],bindings:[{shortcut:"F9",keybindSets:["devToolsDefault"]}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.step-out",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),title:i18nLazyString(UIStrings.stepOutOfCurrentFunction),iconClass:"step-out",contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],bindings:[{shortcut:"Shift+F11",keybindSets:["devToolsDefault","vsCode"]},{platform:"windows,linux",shortcut:"Shift+Ctrl+;"},{platform:"mac",shortcut:"Shift+Meta+;"}]}),UI.ActionRegistration.registerActionExtension({actionId:"debugger.run-snippet",category:UI.ActionRegistration.ActionCategory.DEBUGGER,loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),title:i18nLazyString(UIStrings.runSnippet),iconClass:"play",contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Enter"},{platform:"mac",shortcut:"Meta+Enter"}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.toggle-breakpoints-active",iconClass:"breakpoint-crossed",toggledIconClass:"breakpoint-crossed-filled",toggleable:!0,loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),options:[{value:!0,title:i18nLazyString(UIStrings.deactivateBreakpoints)},{value:!1,title:i18nLazyString(UIStrings.activateBreakpoints)}],bindings:[{platform:"windows,linux",shortcut:"Ctrl+F8"},{platform:"mac",shortcut:"Meta+F8"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.add-to-watch",loadActionDelegate:async()=>(await loadSourcesModule()).WatchExpressionsSidebarPane.WatchExpressionsSidebarPane.instance(),category:UI.ActionRegistration.ActionCategory.DEBUGGER,title:i18nLazyString(UIStrings.addSelectedTextToWatches),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.UISourceCodeFrame.UISourceCodeFrame])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Shift+A"},{platform:"mac",shortcut:"Meta+Shift+A"}]}),UI.ActionRegistration.registerActionExtension({actionId:"debugger.evaluate-selection",category:UI.ActionRegistration.ActionCategory.DEBUGGER,loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),title:i18nLazyString(UIStrings.evaluateSelectedTextInConsole),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.UISourceCodeFrame.UISourceCodeFrame])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Shift+E"},{platform:"mac",shortcut:"Meta+Shift+E"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.switch-file",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.switchFile),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.SwitchFileActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{shortcut:"Alt+O"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.rename",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.rename),bindings:[{platform:"windows,linux",shortcut:"F2"},{platform:"mac",shortcut:"Enter"}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.SOURCES,actionId:"sources.close-all",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),title:i18nLazyString(UIStrings.closeAll)}),UI.ActionRegistration.registerActionExtension({actionId:"sources.jump-to-previous-location",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.jumpToPreviousEditingLocation),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{shortcut:"Alt+Minus"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.jump-to-next-location",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.jumpToNextEditingLocation),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{shortcut:"Alt+Plus"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.close-editor-tab",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.closeTheActiveTab),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{shortcut:"Alt+w"},{shortcut:"Ctrl+W",keybindSets:["vsCode"]},{platform:"windows",shortcut:"Ctrl+F4",keybindSets:["vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.next-editor-tab",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.nextEditorTab),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+PageDown",keybindSets:["devToolsDefault","vsCode"]},{platform:"mac",shortcut:"Meta+PageDown",keybindSets:["devToolsDefault","vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.previous-editor-tab",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.previousEditorTab),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+PageUp",keybindSets:["devToolsDefault","vsCode"]},{platform:"mac",shortcut:"Meta+PageUp",keybindSets:["devToolsDefault","vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.go-to-line",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.goToLine),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{shortcut:"Ctrl+g",keybindSets:["devToolsDefault","vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.go-to-member",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.goToAFunctionDeclarationruleSet),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Shift+o",keybindSets:["devToolsDefault","vsCode"]},{platform:"mac",shortcut:"Meta+Shift+o",keybindSets:["devToolsDefault","vsCode"]},{platform:"mac",shortcut:"Meta+T",keybindSets:["vsCode"]},{platform:"windows,linux",shortcut:"Ctrl+T",keybindSets:["vsCode"]},{shortcut:"F12",keybindSets:["vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"debugger.toggle-breakpoint",category:UI.ActionRegistration.ActionCategory.DEBUGGER,title:i18nLazyString(UIStrings.toggleBreakpoint),bindings:[{platform:"windows,linux",shortcut:"Ctrl+b",keybindSets:["devToolsDefault"]},{platform:"mac",shortcut:"Meta+b",keybindSets:["devToolsDefault"]},{shortcut:"F9",keybindSets:["vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"debugger.toggle-breakpoint-enabled",category:UI.ActionRegistration.ActionCategory.DEBUGGER,title:i18nLazyString(UIStrings.toggleBreakpointEnabled),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Shift+b"},{platform:"mac",shortcut:"Meta+Shift+b"}]}),UI.ActionRegistration.registerActionExtension({actionId:"debugger.breakpoint-input-window",category:UI.ActionRegistration.ActionCategory.DEBUGGER,title:i18nLazyString(UIStrings.toggleBreakpointInputWindow),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Alt+b"},{platform:"mac",shortcut:"Meta+Alt+b"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.save",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.save),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+s",keybindSets:["devToolsDefault","vsCode"]},{platform:"mac",shortcut:"Meta+s",keybindSets:["devToolsDefault","vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.save-all",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.saveAll),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesView.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Shift+s"},{platform:"mac",shortcut:"Meta+Alt+s"},{platform:"windows,linux",shortcut:"Ctrl+K S",keybindSets:["vsCode"]},{platform:"mac",shortcut:"Meta+Alt+S",keybindSets:["vsCode"]}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.SOURCES,actionId:"sources.create-snippet",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesNavigator.ActionDelegate.instance(),title:i18nLazyString(UIStrings.createNewSnippet)}),Host.InspectorFrontendHost.InspectorFrontendHostInstance.isHostedMode()||UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.SOURCES,actionId:"sources.add-folder-to-workspace",loadActionDelegate:async()=>(await loadSourcesModule()).SourcesNavigator.ActionDelegate.instance(),iconClass:"plus",title:i18nLazyString(UIStrings.addFolderToWorkspace),condition:Root.Runtime.ConditionName.NOT_SOURCES_HIDE_ADD_FOLDER}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.previous-call-frame",loadActionDelegate:async()=>(await loadSourcesModule()).CallStackSidebarPane.ActionDelegate.instance(),title:i18nLazyString(UIStrings.previousCallFrame),contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],bindings:[{shortcut:"Ctrl+,"}]}),UI.ActionRegistration.registerActionExtension({category:UI.ActionRegistration.ActionCategory.DEBUGGER,actionId:"debugger.next-call-frame",loadActionDelegate:async()=>(await loadSourcesModule()).CallStackSidebarPane.ActionDelegate.instance(),title:i18nLazyString(UIStrings.nextCallFrame),contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],bindings:[{shortcut:"Ctrl+."}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.search",title:i18nLazyString(UIStrings.search),loadActionDelegate:async()=>(await loadSourcesModule()).SearchSourcesView.ActionDelegate.instance(),category:UI.ActionRegistration.ActionCategory.SOURCES,bindings:[{platform:"mac",shortcut:"Meta+Alt+F",keybindSets:["devToolsDefault"]},{platform:"windows,linux",shortcut:"Ctrl+Shift+F",keybindSets:["devToolsDefault","vsCode"]},{platform:"windows,linux",shortcut:"Ctrl+Shift+J",keybindSets:["vsCode"]},{platform:"mac",shortcut:"Meta+Shift+F",keybindSets:["vsCode"]},{platform:"mac",shortcut:"Meta+Shift+J",keybindSets:["vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.increment-css",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.incrementCssUnitBy,{PH1:1}),bindings:[{shortcut:"Alt+Up"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.increment-css-by-ten",title:i18nLazyString(UIStrings.incrementCssUnitBy,{PH1:10}),category:UI.ActionRegistration.ActionCategory.SOURCES,bindings:[{shortcut:"Alt+PageUp"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.decrement-css",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.decrementCssUnitBy,{PH1:1}),bindings:[{shortcut:"Alt+Down"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.decrement-css-by-ten",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.decrementCssUnitBy,{PH1:10}),bindings:[{shortcut:"Alt+PageDown"}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.toggle-navigator-sidebar",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.toggleNavigatorSidebar),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Shift+y",keybindSets:["devToolsDefault"]},{platform:"mac",shortcut:"Meta+Shift+y",keybindSets:["devToolsDefault"]},{platform:"windows,linux",shortcut:"Ctrl+b",keybindSets:["vsCode"]},{platform:"windows,linux",shortcut:"Meta+b",keybindSets:["vsCode"]}]}),UI.ActionRegistration.registerActionExtension({actionId:"sources.toggle-debugger-sidebar",category:UI.ActionRegistration.ActionCategory.SOURCES,title:i18nLazyString(UIStrings.toggleDebuggerSidebar),loadActionDelegate:async()=>(await loadSourcesModule()).SourcesPanel.ActionDelegate.instance(),contextTypes:()=>maybeRetrieveContextTypes((e=>[e.SourcesView.SourcesView])),bindings:[{platform:"windows,linux",shortcut:"Ctrl+Shift+h"},{platform:"mac",shortcut:"Meta+Shift+h"}]}),Common.Settings.registerSettingExtension({settingName:"navigatorGroupByFolder",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0}),Common.Settings.registerSettingExtension({settingName:"navigatorGroupByAuthored",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!1}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.searchInAnonymousAndContent),settingName:"searchInAnonymousAndContentScripts",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!1,options:[{value:!0,title:i18nLazyString(UIStrings.searchInAnonymousAndContent)},{value:!1,title:i18nLazyString(UIStrings.doNotSearchInAnonymousAndContent)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.automaticallyRevealFilesIn),settingName:"autoRevealInNavigator",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.automaticallyRevealFilesIn)},{value:!1,title:i18nLazyString(UIStrings.doNotAutomaticallyRevealFilesIn)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.enableJavascriptSourceMaps),settingName:"jsSourceMapsEnabled",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.enableJavascriptSourceMaps)},{value:!1,title:i18nLazyString(UIStrings.disableJavascriptSourceMaps)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.enableTabMovesFocus),settingName:"textEditorTabMovesFocus",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!1,options:[{value:!0,title:i18nLazyString(UIStrings.enableTabMovesFocus)},{value:!1,title:i18nLazyString(UIStrings.disableTabMovesFocus)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.detectIndentation),settingName:"textEditorAutoDetectIndent",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.detectIndentation)},{value:!1,title:i18nLazyString(UIStrings.doNotDetectIndentation)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.autocompletion),settingName:"textEditorAutocompletion",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.enableAutocompletion)},{value:!1,title:i18nLazyString(UIStrings.disableAutocompletion)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,title:i18nLazyString(UIStrings.bracketMatching),settingName:"textEditorBracketMatching",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.enableBracketMatching)},{value:!1,title:i18nLazyString(UIStrings.disableBracketMatching)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.codeFolding),settingName:"textEditorCodeFolding",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.enableCodeFolding)},{value:!1,title:i18nLazyString(UIStrings.disableCodeFolding)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.showWhitespaceCharacters),settingName:"showWhitespacesInEditor",settingType:Common.Settings.SettingType.ENUM,defaultValue:"original",options:[{title:i18nLazyString(UIStrings.doNotShowWhitespaceCharacters),text:i18nLazyString(UIStrings.none),value:"none"},{title:i18nLazyString(UIStrings.showAllWhitespaceCharacters),text:i18nLazyString(UIStrings.all),value:"all"},{title:i18nLazyString(UIStrings.showTrailingWhitespaceCharacters),text:i18nLazyString(UIStrings.trailing),value:"trailing"}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.displayVariableValuesInlineWhile),settingName:"inlineVariableValues",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.displayVariableValuesInlineWhile)},{value:!1,title:i18nLazyString(UIStrings.doNotDisplayVariableValuesInline)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.enableAutoFocusOnDebuggerPaused),settingName:"autoFocusOnDebuggerPausedEnabled",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.enableAutoFocusOnDebuggerPaused)},{value:!1,title:i18nLazyString(UIStrings.disableAutoFocusOnDebuggerPaused)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.enableCssSourceMaps),settingName:"cssSourceMapsEnabled",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.enableCssSourceMaps)},{value:!1,title:i18nLazyString(UIStrings.disableCssSourceMaps)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Synced,title:i18nLazyString(UIStrings.allowScrollingPastEndOfFile),settingName:"allowScrollPastEof",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.allowScrollingPastEndOfFile)},{value:!1,title:i18nLazyString(UIStrings.disallowScrollingPastEndOfFile)}]}),Common.Settings.registerSettingExtension({category:Common.Settings.SettingCategory.SOURCES,storageType:Common.Settings.SettingStorageType.Local,title:i18nLazyString(UIStrings.wasmAutoStepping),settingName:"wasmAutoStepping",settingType:Common.Settings.SettingType.BOOLEAN,defaultValue:!0,options:[{value:!0,title:i18nLazyString(UIStrings.enableWasmAutoStepping)},{value:!1,title:i18nLazyString(UIStrings.disableWasmAutoStepping)}]}),UI.ViewManager.registerLocationResolver({name:"navigator-view",category:UI.ViewManager.ViewLocationCategory.SOURCES,loadResolver:async()=>(await loadSourcesModule()).SourcesPanel.SourcesPanel.instance()}),UI.ViewManager.registerLocationResolver({name:"sources.sidebar-top",category:UI.ViewManager.ViewLocationCategory.SOURCES,loadResolver:async()=>(await loadSourcesModule()).SourcesPanel.SourcesPanel.instance()}),UI.ViewManager.registerLocationResolver({name:"sources.sidebar-bottom",category:UI.ViewManager.ViewLocationCategory.SOURCES,loadResolver:async()=>(await loadSourcesModule()).SourcesPanel.SourcesPanel.instance()}),UI.ViewManager.registerLocationResolver({name:"sources.sidebar-tabs",category:UI.ViewManager.ViewLocationCategory.SOURCES,loadResolver:async()=>(await loadSourcesModule()).SourcesPanel.SourcesPanel.instance()}),UI.ContextMenu.registerProvider({contextTypes:()=>[Workspace.UISourceCode.UISourceCode,Workspace.UISourceCode.UILocation,SDK.RemoteObject.RemoteObject,SDK.NetworkRequest.NetworkRequest,...maybeRetrieveContextTypes((e=>[e.UISourceCodeFrame.UISourceCodeFrame]))],loadProvider:async()=>(await loadSourcesModule()).SourcesPanel.SourcesPanel.instance(),experiment:void 0}),UI.ContextMenu.registerProvider({loadProvider:async()=>(await loadSourcesModule()).WatchExpressionsSidebarPane.WatchExpressionsSidebarPane.instance(),contextTypes:()=>[ObjectUI.ObjectPropertiesSection.ObjectPropertyTreeElement],experiment:void 0}),UI.ContextMenu.registerProvider({contextTypes:()=>maybeRetrieveContextTypes((e=>[e.UISourceCodeFrame.UISourceCodeFrame])),loadProvider:async()=>(await loadSourcesModule()).WatchExpressionsSidebarPane.WatchExpressionsSidebarPane.instance(),experiment:void 0}),UI.ContextMenu.registerProvider({loadProvider:async()=>(await loadSourcesModule()).ScopeChainSidebarPane.OpenLinearMemoryInspector.instance(),experiment:void 0,contextTypes:()=>[ObjectUI.ObjectPropertiesSection.ObjectPropertyTreeElement]}),Common.Revealer.registerRevealer({contextTypes:()=>[Workspace.UISourceCode.UILocation],destination:Common.Revealer.RevealerDestination.SOURCES_PANEL,loadRevealer:async()=>(await loadSourcesModule()).SourcesPanel.UILocationRevealer.instance()}),Common.Revealer.registerRevealer({contextTypes:()=>[SDK.DebuggerModel.Location],destination:Common.Revealer.RevealerDestination.SOURCES_PANEL,loadRevealer:async()=>(await loadSourcesModule()).SourcesPanel.DebuggerLocationRevealer.instance()}),Common.Revealer.registerRevealer({contextTypes:()=>[Workspace.UISourceCode.UISourceCode],destination:Common.Revealer.RevealerDestination.SOURCES_PANEL,loadRevealer:async()=>(await loadSourcesModule()).SourcesPanel.UISourceCodeRevealer.instance()}),Common.Revealer.registerRevealer({contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],destination:Common.Revealer.RevealerDestination.SOURCES_PANEL,loadRevealer:async()=>(await loadSourcesModule()).SourcesPanel.DebuggerPausedDetailsRevealer.instance()}),Common.Revealer.registerRevealer({contextTypes:()=>[Breakpoints.BreakpointManager.BreakpointLocation],destination:Common.Revealer.RevealerDestination.SOURCES_PANEL,loadRevealer:async()=>(await loadSourcesModule()).DebuggerPlugin.BreakpointLocationRevealer.instance()}),UI.Toolbar.registerToolbarItem({actionId:"sources.add-folder-to-workspace",location:UI.Toolbar.ToolbarItemLocation.FILES_NAVIGATION_TOOLBAR,label:i18nLazyString(UIStrings.addFolder),showLabel:!0,condition:Root.Runtime.ConditionName.NOT_SOURCES_HIDE_ADD_FOLDER,loadItem:void 0,order:void 0,separator:void 0}),UI.Context.registerListener({contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],loadListener:async()=>(await loadSourcesComponentsModule()).BreakpointsView.BreakpointsSidebarController.instance()}),UI.Context.registerListener({contextTypes:()=>[SDK.DebuggerModel.DebuggerPausedDetails],loadListener:async()=>(await loadSourcesModule()).CallStackSidebarPane.CallStackSidebarPane.instance()}),UI.Context.registerListener({contextTypes:()=>[SDK.DebuggerModel.CallFrame],loadListener:async()=>(await loadSourcesModule()).ScopeChainSidebarPane.ScopeChainSidebarPane.instance()}),UI.ContextMenu.registerItem({location:UI.ContextMenu.ItemLocation.NAVIGATOR_MENU_DEFAULT,actionId:"quickOpen.show",order:void 0}),UI.ContextMenu.registerItem({location:UI.ContextMenu.ItemLocation.MAIN_MENU_DEFAULT,actionId:"sources.search",order:void 0}),QuickOpen.FilteredListWidget.registerProvider({prefix:"@",iconName:"symbol",iconWidth:"16px",provider:async()=>new((await loadSourcesModule()).OutlineQuickOpen.OutlineQuickOpen),titlePrefix:i18nLazyString(UIStrings.goTo),titleSuggestion:i18nLazyString(UIStrings.symbol)}),QuickOpen.FilteredListWidget.registerProvider({prefix:":",iconName:"colon",iconWidth:"20px",provider:async()=>new((await loadSourcesModule()).GoToLineQuickOpen.GoToLineQuickOpen),titlePrefix:i18nLazyString(UIStrings.goTo),titleSuggestion:i18nLazyString(UIStrings.line)}),QuickOpen.FilteredListWidget.registerProvider({prefix:"",iconName:"document",iconWidth:"16px",provider:async()=>new((await loadSourcesModule()).OpenFileQuickOpen.OpenFileQuickOpen),titlePrefix:i18nLazyString(UIStrings.open),titleSuggestion:i18nLazyString(UIStrings.file)});