/**
 * Lighthouse v10.4.0-55-gcd3d3a4c7 (Aug 03 2023)
 *
 * Automated auditing, performance metrics, and best practices for the web.
 *
 * @homepage https://github.com/GoogleChrome/lighthouse#readme
 * @author   The Lighthouse Authors
 * @license  Apache-2.0
 */
"use strict";(()=>{var e=Object.create,t=Object.defineProperty,a=Object.getOwnPropertyDescriptor,n=Object.getOwnPropertyNames,r=Object.getPrototypeOf,i=Object.prototype.hasOwnProperty,o=(e,a)=>t(e,"name",{value:a,configurable:!0}),s=(e,t)=>()=>(e&&(t=e(e=0)),t),l=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),c=(e,a)=>{for(var n in a)t(e,n,{get:a[n],enumerable:!0})},u=(e,r,o,s)=>{if(r&&"object"==typeof r||"function"==typeof r)for(let l of n(r))!i.call(e,l)&&l!==o&&t(e,l,{get:()=>r[l],enumerable:!(s=a(r,l))||s.enumerable});return e},d=(a,n,i)=>(i=null!=a?e(r(a)):{},u(!n&&a&&a.__esModule?i:t(i,"default",{value:a,enumerable:!0}),a));function m(){throw new Error("setTimeout has not been defined")}function p(){throw new Error("clearTimeout has not been defined")}function h(e){if(x===setTimeout)return setTimeout(e,0);if((x===m||!x)&&setTimeout)return x=setTimeout,setTimeout(e,0);try{return x(e,0)}catch{try{return x.call(null,e,0)}catch{return x.call(this,e,0)}}}function g(e){if(A===clearTimeout)return clearTimeout(e);if((A===p||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(e);try{return A(e)}catch{try{return A.call(null,e)}catch{return A.call(this,e)}}}function f(){!R||!F||(R=!1,F.length?_=F.concat(_):N=-1,_.length&&y())}function y(){if(!R){var e=h(f);R=!0;for(var t=_.length;t;){for(F=_,_=[];++N<t;)F&&F[N].run();N=-1,t=_.length}F=null,R=!1,g(e)}}function v(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)t[a-1]=arguments[a];_.push(new b(e,t)),1===_.length&&!R&&h(y)}function b(e,t){this.fun=e,this.array=t}function w(){}function D(e){throw new Error("process.binding is not supported")}function E(){return"/"}function T(e){throw new Error("process.chdir is not supported")}function S(){return 0}function C(e){var t=.001*G.call(H),a=Math.floor(t),n=Math.floor(t%1*1e9);return e&&(a-=e[0],(n-=e[1])<0&&(a--,n+=1e9)),[a,n]}function k(){return(new Date-$)/1e3}var x,A,_,R,F,N,I,M,P,L,O,j,U,B,q,z,V,W,H,G,$,K,Y=s((()=>{J(),o(m,"defaultSetTimout"),o(p,"defaultClearTimeout"),x=m,A=p,"function"==typeof globalThis.setTimeout&&(x=setTimeout),"function"==typeof globalThis.clearTimeout&&(A=clearTimeout),o(h,"runTimeout"),o(g,"runClearTimeout"),_=[],R=!1,N=-1,o(f,"cleanUpNextTick"),o(y,"drainQueue"),o(v,"nextTick"),o(b,"Item"),b.prototype.run=function(){this.fun.apply(null,this.array)},"browser","browser",!0,I={},M=[],"",P={},L={},O={},o(w,"noop"),j=w,U=w,B=w,q=w,z=w,V=w,W=w,o(D,"binding"),o(E,"cwd"),o(T,"chdir"),o(S,"umask"),H=globalThis.performance||{},G=H.now||H.mozNow||H.msNow||H.oNow||H.webkitNow||function(){return(new Date).getTime()},o(C,"hrtime"),$=new Date,o(k,"uptime"),K={nextTick:v,title:"browser",browser:true,env:I,argv:M,version:"",versions:P,on:j,addListener:U,once:B,off:q,removeListener:z,removeAllListeners:V,emit:W,binding:D,cwd:E,chdir:T,umask:S,hrtime:C,platform:"browser",release:L,config:O,uptime:k}})),J=s((()=>{Y(),globalThis.process=K}));function Z(){nt=!0;for(var e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t=0;t<64;++t)et[t]=e[t],tt[e.charCodeAt(t)]=t;tt["-".charCodeAt(0)]=62,tt["_".charCodeAt(0)]=63}function X(e){nt||Z();var t,a,n,r,i,o,s=e.length;if(s%4>0)throw new Error("Invalid string. Length must be a multiple of 4");i="="===e[s-2]?2:"="===e[s-1]?1:0,o=new at(3*s/4-i),n=i>0?s-4:s;var l=0;for(t=0,a=0;t<n;t+=4,a+=3)r=tt[e.charCodeAt(t)]<<18|tt[e.charCodeAt(t+1)]<<12|tt[e.charCodeAt(t+2)]<<6|tt[e.charCodeAt(t+3)],o[l++]=r>>16&255,o[l++]=r>>8&255,o[l++]=255&r;return 2===i?(r=tt[e.charCodeAt(t)]<<2|tt[e.charCodeAt(t+1)]>>4,o[l++]=255&r):1===i&&(r=tt[e.charCodeAt(t)]<<10|tt[e.charCodeAt(t+1)]<<4|tt[e.charCodeAt(t+2)]>>2,o[l++]=r>>8&255,o[l++]=255&r),o}function Q(e){return et[e>>18&63]+et[e>>12&63]+et[e>>6&63]+et[63&e]}function ee(e,t,a){for(var n,r=[],i=t;i<a;i+=3)n=(e[i]<<16)+(e[i+1]<<8)+e[i+2],r.push(Q(n));return r.join("")}function te(e){nt||Z();for(var t,a=e.length,n=a%3,r="",i=[],o=16383,s=0,l=a-n;s<l;s+=o)i.push(ee(e,s,s+o>l?l:s+o));return 1===n?(t=e[a-1],r+=et[t>>2],r+=et[t<<4&63],r+="=="):2===n&&(t=(e[a-2]<<8)+e[a-1],r+=et[t>>10],r+=et[t>>4&63],r+=et[t<<2&63],r+="="),i.push(r),i.join("")}function ae(e,t,a,n,r){var i,o,s=8*r-n-1,l=(1<<s)-1,c=l>>1,u=-7,d=a?r-1:0,m=a?-1:1,p=e[t+d];for(d+=m,i=p&(1<<-u)-1,p>>=-u,u+=s;u>0;i=256*i+e[t+d],d+=m,u-=8);for(o=i&(1<<-u)-1,i>>=-u,u+=n;u>0;o=256*o+e[t+d],d+=m,u-=8);if(0===i)i=1-c;else{if(i===l)return o?NaN:1/0*(p?-1:1);o+=Math.pow(2,n),i-=c}return(p?-1:1)*o*Math.pow(2,i-n)}function ne(e,t,a,n,r,i){var o,s,l,c=8*i-r-1,u=(1<<c)-1,d=u>>1,m=23===r?Math.pow(2,-24)-Math.pow(2,-77):0,p=n?0:i-1,h=n?1:-1,g=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(s=isNaN(t)?1:0,o=u):(o=Math.floor(Math.log(t)/Math.LN2),t*(l=Math.pow(2,-o))<1&&(o--,l*=2),(t+=o+d>=1?m/l:m*Math.pow(2,1-d))*l>=2&&(o++,l/=2),o+d>=u?(s=0,o=u):o+d>=1?(s=(t*l-1)*Math.pow(2,r),o+=d):(s=t*Math.pow(2,d-1)*Math.pow(2,r),o=0));r>=8;e[a+p]=255&s,p+=h,s/=256,r-=8);for(o=o<<r|s,c+=r;c>0;e[a+p]=255&o,p+=h,o/=256,c-=8);e[a+p-h]|=128*g}function re(){return oe.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function ie(e,t){if(re()<t)throw new RangeError("Invalid typed array length");return oe.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(t)).__proto__=oe.prototype:(null===e&&(e=new oe(t)),e.length=t),e}function oe(e,t,a){if(!(oe.TYPED_ARRAY_SUPPORT||this instanceof oe))return new oe(e,t,a);if("number"==typeof e){if("string"==typeof t)throw new Error("If encoding is specified then the first argument must be a string");return ue(this,e)}return se(this,e,t,a)}function se(e,t,a,n){if("number"==typeof t)throw new TypeError('"value" argument must not be a number');return typeof ArrayBuffer<"u"&&t instanceof ArrayBuffer?pe(e,t,a,n):"string"==typeof t?de(e,t,a):he(e,t)}function le(e){if("number"!=typeof e)throw new TypeError('"size" argument must be a number');if(e<0)throw new RangeError('"size" argument must not be negative')}function ce(e,t,a,n){return le(t),t<=0?ie(e,t):void 0!==a?"string"==typeof n?ie(e,t).fill(a,n):ie(e,t).fill(a):ie(e,t)}function ue(e,t){if(le(t),e=ie(e,t<0?0:0|ge(t)),!oe.TYPED_ARRAY_SUPPORT)for(var a=0;a<t;++a)e[a]=0;return e}function de(e,t,a){if(("string"!=typeof a||""===a)&&(a="utf8"),!oe.isEncoding(a))throw new TypeError('"encoding" must be a valid string encoding');var n=0|ye(t,a),r=(e=ie(e,n)).write(t,a);return r!==n&&(e=e.slice(0,r)),e}function me(e,t){var a=t.length<0?0:0|ge(t.length);e=ie(e,a);for(var n=0;n<a;n+=1)e[n]=255&t[n];return e}function pe(e,t,a,n){if(t.byteLength,a<0||t.byteLength<a)throw new RangeError("'offset' is out of bounds");if(t.byteLength<a+(n||0))throw new RangeError("'length' is out of bounds");return t=void 0===a&&void 0===n?new Uint8Array(t):void 0===n?new Uint8Array(t,a):new Uint8Array(t,a,n),oe.TYPED_ARRAY_SUPPORT?(e=t).__proto__=oe.prototype:e=me(e,t),e}function he(e,t){if(fe(t)){var a=0|ge(t.length);return 0===(e=ie(e,a)).length||t.copy(e,0,0,a),e}if(t){if(typeof ArrayBuffer<"u"&&t.buffer instanceof ArrayBuffer||"length"in t)return"number"!=typeof t.length||Je(t.length)?ie(e,0):me(e,t);if("Buffer"===t.type&&it(t.data))return me(e,t.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}function ge(e){if(e>=re())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+re().toString(16)+" bytes");return 0|e}function fe(e){return!(null==e||!e._isBuffer)}function ye(e,t){if(fe(e))return e.length;if(typeof ArrayBuffer<"u"&&"function"==typeof ArrayBuffer.isView&&(ArrayBuffer.isView(e)||e instanceof ArrayBuffer))return e.byteLength;"string"!=typeof e&&(e=""+e);var a=e.length;if(0===a)return 0;for(var n=!1;;)switch(t){case"ascii":case"latin1":case"binary":return a;case"utf8":case"utf-8":case void 0:return He(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*a;case"hex":return a>>>1;case"base64":return Ke(e).length;default:if(n)return He(e).length;t=(""+t).toLowerCase(),n=!0}}function ve(e,t,a){var n=!1;if((void 0===t||t<0)&&(t=0),t>this.length||((void 0===a||a>this.length)&&(a=this.length),a<=0)||(a>>>=0)<=(t>>>=0))return"";for(e||(e="utf8");;)switch(e){case"hex":return Ie(this,t,a);case"utf8":case"utf-8":return _e(this,t,a);case"ascii":return Fe(this,t,a);case"latin1":case"binary":return Ne(this,t,a);case"base64":return Ae(this,t,a);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return Me(this,t,a);default:if(n)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),n=!0}}function be(e,t,a){var n=e[t];e[t]=e[a],e[a]=n}function we(e,t,a,n,r){if(0===e.length)return-1;if("string"==typeof a?(n=a,a=0):a>2147483647?a=2147483647:a<-2147483648&&(a=-2147483648),a=+a,isNaN(a)&&(a=r?0:e.length-1),a<0&&(a=e.length+a),a>=e.length){if(r)return-1;a=e.length-1}else if(a<0){if(!r)return-1;a=0}if("string"==typeof t&&(t=oe.from(t,n)),fe(t))return 0===t.length?-1:De(e,t,a,n,r);if("number"==typeof t)return t&=255,oe.TYPED_ARRAY_SUPPORT&&"function"==typeof Uint8Array.prototype.indexOf?r?Uint8Array.prototype.indexOf.call(e,t,a):Uint8Array.prototype.lastIndexOf.call(e,t,a):De(e,[t],a,n,r);throw new TypeError("val must be string, number or Buffer")}function De(e,t,a,n,r){var i,s=1,l=e.length,c=t.length;if(void 0!==n&&("ucs2"===(n=String(n).toLowerCase())||"ucs-2"===n||"utf16le"===n||"utf-16le"===n)){if(e.length<2||t.length<2)return-1;s=2,l/=2,c/=2,a/=2}function u(e,t){return 1===s?e[t]:e.readUInt16BE(t*s)}if(o(u,"read"),r){var d=-1;for(i=a;i<l;i++)if(u(e,i)===u(t,-1===d?0:i-d)){if(-1===d&&(d=i),i-d+1===c)return d*s}else-1!==d&&(i-=i-d),d=-1}else for(a+c>l&&(a=l-c),i=a;i>=0;i--){for(var m=!0,p=0;p<c;p++)if(u(e,i+p)!==u(t,p)){m=!1;break}if(m)return i}return-1}function Ee(e,t,a,n){a=Number(a)||0;var r=e.length-a;n?(n=Number(n))>r&&(n=r):n=r;var i=t.length;if(i%2!=0)throw new TypeError("Invalid hex string");n>i/2&&(n=i/2);for(var o=0;o<n;++o){var s=parseInt(t.substr(2*o,2),16);if(isNaN(s))return o;e[a+o]=s}return o}function Te(e,t,a,n){return Ye(He(t,e.length-a),e,a,n)}function Se(e,t,a,n){return Ye(Ge(t),e,a,n)}function Ce(e,t,a,n){return Se(e,t,a,n)}function ke(e,t,a,n){return Ye(Ke(t),e,a,n)}function xe(e,t,a,n){return Ye($e(t,e.length-a),e,a,n)}function Ae(e,t,a){return 0===t&&a===e.length?te(e):te(e.slice(t,a))}function _e(e,t,a){a=Math.min(e.length,a);for(var n=[],r=t;r<a;){var i,o,s,l,c=e[r],u=null,d=c>239?4:c>223?3:c>191?2:1;if(r+d<=a)switch(d){case 1:c<128&&(u=c);break;case 2:128==(192&(i=e[r+1]))&&((l=(31&c)<<6|63&i)>127&&(u=l));break;case 3:i=e[r+1],o=e[r+2],128==(192&i)&&128==(192&o)&&((l=(15&c)<<12|(63&i)<<6|63&o)>2047&&(l<55296||l>57343)&&(u=l));break;case 4:i=e[r+1],o=e[r+2],s=e[r+3],128==(192&i)&&128==(192&o)&&128==(192&s)&&((l=(15&c)<<18|(63&i)<<12|(63&o)<<6|63&s)>65535&&l<1114112&&(u=l))}null===u?(u=65533,d=1):u>65535&&(u-=65536,n.push(u>>>10&1023|55296),u=56320|1023&u),n.push(u),r+=d}return Re(n)}function Re(e){var t=e.length;if(t<=ot)return String.fromCharCode.apply(String,e);for(var a="",n=0;n<t;)a+=String.fromCharCode.apply(String,e.slice(n,n+=ot));return a}function Fe(e,t,a){var n="";a=Math.min(e.length,a);for(var r=t;r<a;++r)n+=String.fromCharCode(127&e[r]);return n}function Ne(e,t,a){var n="";a=Math.min(e.length,a);for(var r=t;r<a;++r)n+=String.fromCharCode(e[r]);return n}function Ie(e,t,a){var n=e.length;(!t||t<0)&&(t=0),(!a||a<0||a>n)&&(a=n);for(var r="",i=t;i<a;++i)r+=We(e[i]);return r}function Me(e,t,a){for(var n=e.slice(t,a),r="",i=0;i<n.length;i+=2)r+=String.fromCharCode(n[i]+256*n[i+1]);return r}function Pe(e,t,a){if(e%1!=0||e<0)throw new RangeError("offset is not uint");if(e+t>a)throw new RangeError("Trying to access beyond buffer length")}function Le(e,t,a,n,r,i){if(!fe(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>r||t<i)throw new RangeError('"value" argument is out of bounds');if(a+n>e.length)throw new RangeError("Index out of range")}function Oe(e,t,a,n){t<0&&(t=65535+t+1);for(var r=0,i=Math.min(e.length-a,2);r<i;++r)e[a+r]=(t&255<<8*(n?r:1-r))>>>8*(n?r:1-r)}function je(e,t,a,n){t<0&&(t=4294967295+t+1);for(var r=0,i=Math.min(e.length-a,4);r<i;++r)e[a+r]=t>>>8*(n?r:3-r)&255}function Ue(e,t,a,n,r,i){if(a+n>e.length)throw new RangeError("Index out of range");if(a<0)throw new RangeError("Index out of range")}function Be(e,t,a,n,r){return r||Ue(e,0,a,4),ne(e,t,a,n,23,4),a+4}function qe(e,t,a,n,r){return r||Ue(e,0,a,8),ne(e,t,a,n,52,8),a+8}function ze(e){if((e=Ve(e).replace(st,"")).length<2)return"";for(;e.length%4!=0;)e+="=";return e}function Ve(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function We(e){return e<16?"0"+e.toString(16):e.toString(16)}function He(e,t){t=t||1/0;for(var a,n=e.length,r=null,i=[],o=0;o<n;++o){if((a=e.charCodeAt(o))>55295&&a<57344){if(!r){if(a>56319){(t-=3)>-1&&i.push(239,191,189);continue}if(o+1===n){(t-=3)>-1&&i.push(239,191,189);continue}r=a;continue}if(a<56320){(t-=3)>-1&&i.push(239,191,189),r=a;continue}a=65536+(r-55296<<10|a-56320)}else r&&(t-=3)>-1&&i.push(239,191,189);if(r=null,a<128){if((t-=1)<0)break;i.push(a)}else if(a<2048){if((t-=2)<0)break;i.push(a>>6|192,63&a|128)}else if(a<65536){if((t-=3)<0)break;i.push(a>>12|224,a>>6&63|128,63&a|128)}else{if(!(a<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;i.push(a>>18|240,a>>12&63|128,a>>6&63|128,63&a|128)}}return i}function Ge(e){for(var t=[],a=0;a<e.length;++a)t.push(255&e.charCodeAt(a));return t}function $e(e,t){for(var a,n,r,i=[],o=0;o<e.length&&!((t-=2)<0);++o)n=(a=e.charCodeAt(o))>>8,r=a%256,i.push(r),i.push(n);return i}function Ke(e){return X(ze(e))}function Ye(e,t,a,n){for(var r=0;r<n&&!(r+a>=t.length||r>=e.length);++r)t[r+a]=e[r];return r}function Je(e){return e!=e}function Ze(e){return null!=e&&(!!e._isBuffer||Xe(e)||Qe(e))}function Xe(e){return!!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function Qe(e){return"function"==typeof e.readFloatLE&&"function"==typeof e.slice&&Xe(e.slice(0,0))}var et,tt,at,nt,rt,it,ot,st,lt=s((()=>{J(),et=[],tt=[],at=typeof Uint8Array<"u"?Uint8Array:Array,nt=!1,o(Z,"init"),o(X,"toByteArray"),o(Q,"tripletToBase64"),o(ee,"encodeChunk"),o(te,"fromByteArray"),o(ae,"read"),o(ne,"write"),rt={}.toString,it=Array.isArray||function(e){return"[object Array]"==rt.call(e)},50,oe.TYPED_ARRAY_SUPPORT=void 0===globalThis.TYPED_ARRAY_SUPPORT||globalThis.TYPED_ARRAY_SUPPORT,re(),o(re,"kMaxLength"),o(ie,"createBuffer"),o(oe,"Buffer"),oe.poolSize=8192,oe._augment=function(e){return e.__proto__=oe.prototype,e},o(se,"from"),oe.from=function(e,t,a){return se(null,e,t,a)},oe.TYPED_ARRAY_SUPPORT&&(oe.prototype.__proto__=Uint8Array.prototype,oe.__proto__=Uint8Array,typeof Symbol<"u"&&Symbol.species&&oe[Symbol.species]),o(le,"assertSize"),o(ce,"alloc"),oe.alloc=function(e,t,a){return ce(null,e,t,a)},o(ue,"allocUnsafe"),oe.allocUnsafe=function(e){return ue(null,e)},oe.allocUnsafeSlow=function(e){return ue(null,e)},o(de,"fromString"),o(me,"fromArrayLike"),o(pe,"fromArrayBuffer"),o(he,"fromObject"),o(ge,"checked"),oe.isBuffer=Ze,o(fe,"internalIsBuffer"),oe.compare=o((function(e,t){if(!fe(e)||!fe(t))throw new TypeError("Arguments must be Buffers");if(e===t)return 0;for(var a=e.length,n=t.length,r=0,i=Math.min(a,n);r<i;++r)if(e[r]!==t[r]){a=e[r],n=t[r];break}return a<n?-1:n<a?1:0}),"compare"),oe.isEncoding=o((function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}}),"isEncoding"),oe.concat=o((function(e,t){if(!it(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return oe.alloc(0);var a;if(void 0===t)for(t=0,a=0;a<e.length;++a)t+=e[a].length;var n=oe.allocUnsafe(t),r=0;for(a=0;a<e.length;++a){var i=e[a];if(!fe(i))throw new TypeError('"list" argument must be an Array of Buffers');i.copy(n,r),r+=i.length}return n}),"concat"),o(ye,"byteLength"),oe.byteLength=ye,o(ve,"slowToString"),oe.prototype._isBuffer=!0,o(be,"swap"),oe.prototype.swap16=o((function(){var e=this.length;if(e%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var t=0;t<e;t+=2)be(this,t,t+1);return this}),"swap16"),oe.prototype.swap32=o((function(){var e=this.length;if(e%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var t=0;t<e;t+=4)be(this,t,t+3),be(this,t+1,t+2);return this}),"swap32"),oe.prototype.swap64=o((function(){var e=this.length;if(e%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var t=0;t<e;t+=8)be(this,t,t+7),be(this,t+1,t+6),be(this,t+2,t+5),be(this,t+3,t+4);return this}),"swap64"),oe.prototype.toString=o((function(){var e=0|this.length;return 0===e?"":0===arguments.length?_e(this,0,e):ve.apply(this,arguments)}),"toString"),oe.prototype.equals=o((function(e){if(!fe(e))throw new TypeError("Argument must be a Buffer");return this===e||0===oe.compare(this,e)}),"equals"),oe.prototype.inspect=o((function(){var e="";return this.length>0&&(e=this.toString("hex",0,50).match(/.{2}/g).join(" "),this.length>50&&(e+=" ... ")),"<Buffer "+e+">"}),"inspect"),oe.prototype.compare=o((function(e,t,a,n,r){if(!fe(e))throw new TypeError("Argument must be a Buffer");if(void 0===t&&(t=0),void 0===a&&(a=e?e.length:0),void 0===n&&(n=0),void 0===r&&(r=this.length),t<0||a>e.length||n<0||r>this.length)throw new RangeError("out of range index");if(n>=r&&t>=a)return 0;if(n>=r)return-1;if(t>=a)return 1;if(this===e)return 0;for(var i=(r>>>=0)-(n>>>=0),o=(a>>>=0)-(t>>>=0),s=Math.min(i,o),l=this.slice(n,r),c=e.slice(t,a),u=0;u<s;++u)if(l[u]!==c[u]){i=l[u],o=c[u];break}return i<o?-1:o<i?1:0}),"compare"),o(we,"bidirectionalIndexOf"),o(De,"arrayIndexOf"),oe.prototype.includes=o((function(e,t,a){return-1!==this.indexOf(e,t,a)}),"includes"),oe.prototype.indexOf=o((function(e,t,a){return we(this,e,t,a,!0)}),"indexOf"),oe.prototype.lastIndexOf=o((function(e,t,a){return we(this,e,t,a,!1)}),"lastIndexOf"),o(Ee,"hexWrite"),o(Te,"utf8Write"),o(Se,"asciiWrite"),o(Ce,"latin1Write"),o(ke,"base64Write"),o(xe,"ucs2Write"),oe.prototype.write=o((function(e,t,a,n){if(void 0===t)n="utf8",a=this.length,t=0;else if(void 0===a&&"string"==typeof t)n=t,a=this.length,t=0;else{if(!isFinite(t))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");t|=0,isFinite(a)?(a|=0,void 0===n&&(n="utf8")):(n=a,a=void 0)}var r=this.length-t;if((void 0===a||a>r)&&(a=r),e.length>0&&(a<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");n||(n="utf8");for(var i=!1;;)switch(n){case"hex":return Ee(this,e,t,a);case"utf8":case"utf-8":return Te(this,e,t,a);case"ascii":return Se(this,e,t,a);case"latin1":case"binary":return Ce(this,e,t,a);case"base64":return ke(this,e,t,a);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return xe(this,e,t,a);default:if(i)throw new TypeError("Unknown encoding: "+n);n=(""+n).toLowerCase(),i=!0}}),"write"),oe.prototype.toJSON=o((function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}}),"toJSON"),o(Ae,"base64Slice"),o(_e,"utf8Slice"),ot=4096,o(Re,"decodeCodePointsArray"),o(Fe,"asciiSlice"),o(Ne,"latin1Slice"),o(Ie,"hexSlice"),o(Me,"utf16leSlice"),oe.prototype.slice=o((function(e,t){var a,n=this.length;if((e=~~e)<0?(e+=n)<0&&(e=0):e>n&&(e=n),(t=void 0===t?n:~~t)<0?(t+=n)<0&&(t=0):t>n&&(t=n),t<e&&(t=e),oe.TYPED_ARRAY_SUPPORT)(a=this.subarray(e,t)).__proto__=oe.prototype;else{var r=t-e;a=new oe(r,void 0);for(var i=0;i<r;++i)a[i]=this[i+e]}return a}),"slice"),o(Pe,"checkOffset"),oe.prototype.readUIntLE=o((function(e,t,a){e|=0,t|=0,a||Pe(e,t,this.length);for(var n=this[e],r=1,i=0;++i<t&&(r*=256);)n+=this[e+i]*r;return n}),"readUIntLE"),oe.prototype.readUIntBE=o((function(e,t,a){e|=0,t|=0,a||Pe(e,t,this.length);for(var n=this[e+--t],r=1;t>0&&(r*=256);)n+=this[e+--t]*r;return n}),"readUIntBE"),oe.prototype.readUInt8=o((function(e,t){return t||Pe(e,1,this.length),this[e]}),"readUInt8"),oe.prototype.readUInt16LE=o((function(e,t){return t||Pe(e,2,this.length),this[e]|this[e+1]<<8}),"readUInt16LE"),oe.prototype.readUInt16BE=o((function(e,t){return t||Pe(e,2,this.length),this[e]<<8|this[e+1]}),"readUInt16BE"),oe.prototype.readUInt32LE=o((function(e,t){return t||Pe(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]}),"readUInt32LE"),oe.prototype.readUInt32BE=o((function(e,t){return t||Pe(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])}),"readUInt32BE"),oe.prototype.readIntLE=o((function(e,t,a){e|=0,t|=0,a||Pe(e,t,this.length);for(var n=this[e],r=1,i=0;++i<t&&(r*=256);)n+=this[e+i]*r;return n>=(r*=128)&&(n-=Math.pow(2,8*t)),n}),"readIntLE"),oe.prototype.readIntBE=o((function(e,t,a){e|=0,t|=0,a||Pe(e,t,this.length);for(var n=t,r=1,i=this[e+--n];n>0&&(r*=256);)i+=this[e+--n]*r;return i>=(r*=128)&&(i-=Math.pow(2,8*t)),i}),"readIntBE"),oe.prototype.readInt8=o((function(e,t){return t||Pe(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]}),"readInt8"),oe.prototype.readInt16LE=o((function(e,t){t||Pe(e,2,this.length);var a=this[e]|this[e+1]<<8;return 32768&a?4294901760|a:a}),"readInt16LE"),oe.prototype.readInt16BE=o((function(e,t){t||Pe(e,2,this.length);var a=this[e+1]|this[e]<<8;return 32768&a?4294901760|a:a}),"readInt16BE"),oe.prototype.readInt32LE=o((function(e,t){return t||Pe(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24}),"readInt32LE"),oe.prototype.readInt32BE=o((function(e,t){return t||Pe(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]}),"readInt32BE"),oe.prototype.readFloatLE=o((function(e,t){return t||Pe(e,4,this.length),ae(this,e,!0,23,4)}),"readFloatLE"),oe.prototype.readFloatBE=o((function(e,t){return t||Pe(e,4,this.length),ae(this,e,!1,23,4)}),"readFloatBE"),oe.prototype.readDoubleLE=o((function(e,t){return t||Pe(e,8,this.length),ae(this,e,!0,52,8)}),"readDoubleLE"),oe.prototype.readDoubleBE=o((function(e,t){return t||Pe(e,8,this.length),ae(this,e,!1,52,8)}),"readDoubleBE"),o(Le,"checkInt"),oe.prototype.writeUIntLE=o((function(e,t,a,n){(e=+e,t|=0,a|=0,n)||Le(this,e,t,a,Math.pow(2,8*a)-1,0);var r=1,i=0;for(this[t]=255&e;++i<a&&(r*=256);)this[t+i]=e/r&255;return t+a}),"writeUIntLE"),oe.prototype.writeUIntBE=o((function(e,t,a,n){(e=+e,t|=0,a|=0,n)||Le(this,e,t,a,Math.pow(2,8*a)-1,0);var r=a-1,i=1;for(this[t+r]=255&e;--r>=0&&(i*=256);)this[t+r]=e/i&255;return t+a}),"writeUIntBE"),oe.prototype.writeUInt8=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,1,255,0),oe.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),this[t]=255&e,t+1}),"writeUInt8"),o(Oe,"objectWriteUInt16"),oe.prototype.writeUInt16LE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,2,65535,0),oe.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):Oe(this,e,t,!0),t+2}),"writeUInt16LE"),oe.prototype.writeUInt16BE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,2,65535,0),oe.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):Oe(this,e,t,!1),t+2}),"writeUInt16BE"),o(je,"objectWriteUInt32"),oe.prototype.writeUInt32LE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,4,4294967295,0),oe.TYPED_ARRAY_SUPPORT?(this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e):je(this,e,t,!0),t+4}),"writeUInt32LE"),oe.prototype.writeUInt32BE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,4,4294967295,0),oe.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):je(this,e,t,!1),t+4}),"writeUInt32BE"),oe.prototype.writeIntLE=o((function(e,t,a,n){if(e=+e,t|=0,!n){var r=Math.pow(2,8*a-1);Le(this,e,t,a,r-1,-r)}var i=0,o=1,s=0;for(this[t]=255&e;++i<a&&(o*=256);)e<0&&0===s&&0!==this[t+i-1]&&(s=1),this[t+i]=(e/o>>0)-s&255;return t+a}),"writeIntLE"),oe.prototype.writeIntBE=o((function(e,t,a,n){if(e=+e,t|=0,!n){var r=Math.pow(2,8*a-1);Le(this,e,t,a,r-1,-r)}var i=a-1,o=1,s=0;for(this[t+i]=255&e;--i>=0&&(o*=256);)e<0&&0===s&&0!==this[t+i+1]&&(s=1),this[t+i]=(e/o>>0)-s&255;return t+a}),"writeIntBE"),oe.prototype.writeInt8=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,1,127,-128),oe.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),e<0&&(e=255+e+1),this[t]=255&e,t+1}),"writeInt8"),oe.prototype.writeInt16LE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,2,32767,-32768),oe.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):Oe(this,e,t,!0),t+2}),"writeInt16LE"),oe.prototype.writeInt16BE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,2,32767,-32768),oe.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):Oe(this,e,t,!1),t+2}),"writeInt16BE"),oe.prototype.writeInt32LE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,4,2147483647,-2147483648),oe.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24):je(this,e,t,!0),t+4}),"writeInt32LE"),oe.prototype.writeInt32BE=o((function(e,t,a){return e=+e,t|=0,a||Le(this,e,t,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),oe.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):je(this,e,t,!1),t+4}),"writeInt32BE"),o(Ue,"checkIEEE754"),o(Be,"writeFloat"),oe.prototype.writeFloatLE=o((function(e,t,a){return Be(this,e,t,!0,a)}),"writeFloatLE"),oe.prototype.writeFloatBE=o((function(e,t,a){return Be(this,e,t,!1,a)}),"writeFloatBE"),o(qe,"writeDouble"),oe.prototype.writeDoubleLE=o((function(e,t,a){return qe(this,e,t,!0,a)}),"writeDoubleLE"),oe.prototype.writeDoubleBE=o((function(e,t,a){return qe(this,e,t,!1,a)}),"writeDoubleBE"),oe.prototype.copy=o((function(e,t,a,n){if(a||(a=0),!n&&0!==n&&(n=this.length),t>=e.length&&(t=e.length),t||(t=0),n>0&&n<a&&(n=a),n===a||0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(a<0||a>=this.length)throw new RangeError("sourceStart out of bounds");if(n<0)throw new RangeError("sourceEnd out of bounds");n>this.length&&(n=this.length),e.length-t<n-a&&(n=e.length-t+a);var r,i=n-a;if(this===e&&a<t&&t<n)for(r=i-1;r>=0;--r)e[r+t]=this[r+a];else if(i<1e3||!oe.TYPED_ARRAY_SUPPORT)for(r=0;r<i;++r)e[r+t]=this[r+a];else Uint8Array.prototype.set.call(e,this.subarray(a,a+i),t);return i}),"copy"),oe.prototype.fill=o((function(e,t,a,n){if("string"==typeof e){if("string"==typeof t?(n=t,t=0,a=this.length):"string"==typeof a&&(n=a,a=this.length),1===e.length){var r=e.charCodeAt(0);r<256&&(e=r)}if(void 0!==n&&"string"!=typeof n)throw new TypeError("encoding must be a string");if("string"==typeof n&&!oe.isEncoding(n))throw new TypeError("Unknown encoding: "+n)}else"number"==typeof e&&(e&=255);if(t<0||this.length<t||this.length<a)throw new RangeError("Out of range index");if(a<=t)return this;var i;if(t>>>=0,a=void 0===a?this.length:a>>>0,e||(e=0),"number"==typeof e)for(i=t;i<a;++i)this[i]=e;else{var o=fe(e)?e:He(new oe(e,n).toString()),s=o.length;for(i=0;i<a-t;++i)this[i+t]=o[i%s]}return this}),"fill"),st=/[^+\/0-9A-Za-z-_]/g,o(ze,"base64clean"),o(Ve,"stringtrim"),o(We,"toHex"),o(He,"utf8ToBytes"),o(Ge,"asciiToBytes"),o($e,"utf16leToBytes"),o(Ke,"base64ToBytes"),o(Ye,"blitBuffer"),o(Je,"isnan"),o(Ze,"isBuffer"),o(Xe,"isFastBuffer"),o(Qe,"isSlowBuffer")}));function ct(){}function ut(){ut.init.call(this)}function dt(e){return void 0===e._maxListeners?ut.defaultMaxListeners:e._maxListeners}function mt(e,t,a){if(t)e.call(a);else for(var n=e.length,r=Et(e,n),i=0;i<n;++i)r[i].call(a)}function pt(e,t,a,n){if(t)e.call(a,n);else for(var r=e.length,i=Et(e,r),o=0;o<r;++o)i[o].call(a,n)}function ht(e,t,a,n,r){if(t)e.call(a,n,r);else for(var i=e.length,o=Et(e,i),s=0;s<i;++s)o[s].call(a,n,r)}function gt(e,t,a,n,r,i){if(t)e.call(a,n,r,i);else for(var o=e.length,s=Et(e,o),l=0;l<o;++l)s[l].call(a,n,r,i)}function ft(e,t,a,n){if(t)e.apply(a,n);else for(var r=e.length,i=Et(e,r),o=0;o<r;++o)i[o].apply(a,n)}function yt(e,t,a,n){var r,i,o;if("function"!=typeof a)throw new TypeError('"listener" argument must be a function');if((i=e._events)?(i.newListener&&(e.emit("newListener",t,a.listener?a.listener:a),i=e._events),o=i[t]):(i=e._events=new ct,e._eventsCount=0),o){if("function"==typeof o?o=i[t]=n?[a,o]:[o,a]:n?o.unshift(a):o.push(a),!o.warned&&((r=dt(e))&&r>0&&o.length>r)){o.warned=!0;var s=new Error("Possible EventEmitter memory leak detected. "+o.length+" "+t+" listeners added. Use emitter.setMaxListeners() to increase limit");s.name="MaxListenersExceededWarning",s.emitter=e,s.type=t,s.count=o.length,vt(s)}}else o=i[t]=a,++e._eventsCount;return e}function vt(e){"function"==typeof console.warn?console.warn(e):console.log(e)}function bt(e,t,a){var n=!1;function r(){e.removeListener(t,r),n||(n=!0,a.apply(e,arguments))}return o(r,"g"),r.listener=a,r}function wt(e){var t=this._events;if(t){var a=t[e];if("function"==typeof a)return 1;if(a)return a.length}return 0}function Dt(e,t){for(var a=t,n=a+1,r=e.length;n<r;a+=1,n+=1)e[a]=e[n];e.pop()}function Et(e,t){for(var a=new Array(t);t--;)a[t]=e[t];return a}function Tt(e){for(var t=new Array(e.length),a=0;a<t.length;++a)t[a]=e[a].listener||e[a];return t}var St,Ct,kt=s((()=>{J(),o(ct,"EventHandlers"),ct.prototype=Object.create(null),o(ut,"EventEmitter"),Ct=ut,ut.EventEmitter=ut,ut.usingDomains=!1,ut.prototype.domain=void 0,ut.prototype._events=void 0,ut.prototype._maxListeners=void 0,ut.defaultMaxListeners=10,ut.init=function(){this.domain=null,ut.usingDomains&&St.active&&!(this instanceof St.Domain)&&(this.domain=St.active),(!this._events||this._events===Object.getPrototypeOf(this)._events)&&(this._events=new ct,this._eventsCount=0),this._maxListeners=this._maxListeners||void 0},ut.prototype.setMaxListeners=o((function(e){if("number"!=typeof e||e<0||isNaN(e))throw new TypeError('"n" argument must be a positive number');return this._maxListeners=e,this}),"setMaxListeners"),o(dt,"$getMaxListeners"),ut.prototype.getMaxListeners=o((function(){return dt(this)}),"getMaxListeners"),o(mt,"emitNone"),o(pt,"emitOne"),o(ht,"emitTwo"),o(gt,"emitThree"),o(ft,"emitMany"),ut.prototype.emit=o((function(e){var t,a,n,r,i,o,s,l="error"===e;if(o=this._events)l=l&&null==o.error;else if(!l)return!1;if(s=this.domain,l){if(t=arguments[1],!s){if(t instanceof Error)throw t;var c=new Error('Uncaught, unspecified "error" event. ('+t+")");throw c.context=t,c}return t||(t=new Error('Uncaught, unspecified "error" event')),t.domainEmitter=this,t.domain=s,t.domainThrown=!1,s.emit("error",t),!1}if(!(a=o[e]))return!1;var u="function"==typeof a;switch(n=arguments.length){case 1:mt(a,u,this);break;case 2:pt(a,u,this,arguments[1]);break;case 3:ht(a,u,this,arguments[1],arguments[2]);break;case 4:gt(a,u,this,arguments[1],arguments[2],arguments[3]);break;default:for(r=new Array(n-1),i=1;i<n;i++)r[i-1]=arguments[i];ft(a,u,this,r)}return!0}),"emit"),o(yt,"_addListener"),o(vt,"emitWarning"),ut.prototype.addListener=o((function(e,t){return yt(this,e,t,!1)}),"addListener"),ut.prototype.on=ut.prototype.addListener,ut.prototype.prependListener=o((function(e,t){return yt(this,e,t,!0)}),"prependListener"),o(bt,"_onceWrap"),ut.prototype.once=o((function(e,t){if("function"!=typeof t)throw new TypeError('"listener" argument must be a function');return this.on(e,bt(this,e,t)),this}),"once"),ut.prototype.prependOnceListener=o((function(e,t){if("function"!=typeof t)throw new TypeError('"listener" argument must be a function');return this.prependListener(e,bt(this,e,t)),this}),"prependOnceListener"),ut.prototype.removeListener=o((function(e,t){var a,n,r,i,o;if("function"!=typeof t)throw new TypeError('"listener" argument must be a function');if(!(n=this._events))return this;if(!(a=n[e]))return this;if(a===t||a.listener&&a.listener===t)0==--this._eventsCount?this._events=new ct:(delete n[e],n.removeListener&&this.emit("removeListener",e,a.listener||t));else if("function"!=typeof a){for(r=-1,i=a.length;i-- >0;)if(a[i]===t||a[i].listener&&a[i].listener===t){o=a[i].listener,r=i;break}if(r<0)return this;if(1===a.length){if(a[0]=void 0,0==--this._eventsCount)return this._events=new ct,this;delete n[e]}else Dt(a,r);n.removeListener&&this.emit("removeListener",e,o||t)}return this}),"removeListener"),ut.prototype.off=function(e,t){return this.removeListener(e,t)},ut.prototype.removeAllListeners=o((function(e){var t,a;if(!(a=this._events))return this;if(!a.removeListener)return 0===arguments.length?(this._events=new ct,this._eventsCount=0):a[e]&&(0==--this._eventsCount?this._events=new ct:delete a[e]),this;if(0===arguments.length){for(var n,r=Object.keys(a),i=0;i<r.length;++i)"removeListener"!==(n=r[i])&&this.removeAllListeners(n);return this.removeAllListeners("removeListener"),this._events=new ct,this._eventsCount=0,this}if("function"==typeof(t=a[e]))this.removeListener(e,t);else if(t)do{this.removeListener(e,t[t.length-1])}while(t[0]);return this}),"removeAllListeners"),ut.prototype.listeners=o((function(e){var t,a,n=this._events;return n?a=(t=n[e])?"function"==typeof t?[t.listener||t]:Tt(t):[]:a=[],a}),"listeners"),ut.listenerCount=function(e,t){return"function"==typeof e.listenerCount?e.listenerCount(t):wt.call(e,t)},ut.prototype.listenerCount=wt,o(wt,"listenerCount"),ut.prototype.eventNames=o((function(){return this._eventsCount>0?Reflect.ownKeys(this._events):[]}),"eventNames"),o(Dt,"spliceOne"),o(Et,"arrayClone"),o(Tt,"unwrapListeners")})),xt=l(((e,t)=>{J();var a=1e3,n=6e4,r=60*n,i=24*r;function s(e){if(!((e=String(e)).length>100)){var t=/^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(e);if(t){var o=parseFloat(t[1]);switch((t[2]||"ms").toLowerCase()){case"years":case"year":case"yrs":case"yr":case"y":return 315576e5*o;case"weeks":case"week":case"w":return 6048e5*o;case"days":case"day":case"d":return o*i;case"hours":case"hour":case"hrs":case"hr":case"h":return o*r;case"minutes":case"minute":case"mins":case"min":case"m":return o*n;case"seconds":case"second":case"secs":case"sec":case"s":return o*a;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return o;default:return}}}}function l(e){var t=Math.abs(e);return t>=i?Math.round(e/i)+"d":t>=r?Math.round(e/r)+"h":t>=n?Math.round(e/n)+"m":t>=a?Math.round(e/a)+"s":e+"ms"}function c(e){var t=Math.abs(e);return t>=i?u(e,t,i,"day"):t>=r?u(e,t,r,"hour"):t>=n?u(e,t,n,"minute"):t>=a?u(e,t,a,"second"):e+" ms"}function u(e,t,a,n){var r=t>=1.5*a;return Math.round(e/a)+" "+n+(r?"s":"")}t.exports=function(e,t){t=t||{};var a=typeof e;if("string"===a&&e.length>0)return s(e);if("number"===a&&isFinite(e))return t.long?c(e):l(e);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))},o(s,"parse"),o(l,"fmtShort"),o(c,"fmtLong"),o(u,"plural")})),At=l(((e,t)=>{function a(e){function t(e){let t=0;for(let a=0;a<e.length;a++)t=(t<<5)-t+e.charCodeAt(a),t|=0;return a.colors[Math.abs(t)%a.colors.length]}function a(e){let t,r,i,s=null;function l(...e){if(!l.enabled)return;let n=l,r=Number(new Date),i=r-(t||r);n.diff=i,n.prev=t,n.curr=r,t=r,e[0]=a.coerce(e[0]),"string"!=typeof e[0]&&e.unshift("%O");let o=0;e[0]=e[0].replace(/%([a-zA-Z%])/g,((t,r)=>{if("%%"===t)return"%";o++;let i=a.formatters[r];if("function"==typeof i){let a=e[o];t=i.call(n,a),e.splice(o,1),o--}return t})),a.formatArgs.call(n,e),(n.log||a.log).apply(n,e)}return o(l,"debug"),l.namespace=e,l.useColors=a.useColors(),l.color=a.selectColor(e),l.extend=n,l.destroy=a.destroy,Object.defineProperty(l,"enabled",{enumerable:!0,configurable:!1,get:()=>null!==s?s:(r!==a.namespaces&&(r=a.namespaces,i=a.enabled(e)),i),set:e=>{s=e}}),"function"==typeof a.init&&a.init(l),l}function n(e,t){let n=a(this.namespace+(typeof t>"u"?":":t)+e);return n.log=this.log,n}function r(e){a.save(e),a.namespaces=e,a.names=[],a.skips=[];let t,n=("string"==typeof e?e:"").split(/[\s,]+/),r=n.length;for(t=0;t<r;t++)n[t]&&("-"===(e=n[t].replace(/\*/g,".*?"))[0]?a.skips.push(new RegExp("^"+e.slice(1)+"$")):a.names.push(new RegExp("^"+e+"$")))}function i(){let e=[...a.names.map(l),...a.skips.map(l).map((e=>"-"+e))].join(",");return a.enable(""),e}function s(e){if("*"===e[e.length-1])return!0;let t,n;for(t=0,n=a.skips.length;t<n;t++)if(a.skips[t].test(e))return!1;for(t=0,n=a.names.length;t<n;t++)if(a.names[t].test(e))return!0;return!1}function l(e){return e.toString().substring(2,e.toString().length-2).replace(/\.\*\?$/,"*")}function c(e){return e instanceof Error?e.stack||e.message:e}function u(){console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.")}return a.debug=a,a.default=a,a.coerce=c,a.disable=i,a.enable=r,a.enabled=s,a.humanize=xt(),a.destroy=u,Object.keys(e).forEach((t=>{a[t]=e[t]})),a.names=[],a.skips=[],a.formatters={},o(t,"selectColor"),a.selectColor=t,o(a,"createDebug"),o(n,"extend"),o(r,"enable"),o(i,"disable"),o(s,"enabled"),o(l,"toNamespace"),o(c,"coerce"),o(u,"destroy"),a.enable(a.load()),a}J(),o(a,"setup"),t.exports=a})),_t=l(((e,t)=>{function a(){return!(!(typeof window<"u"&&window.process)||"renderer"!==window.process.type&&!window.process.__nwjs)||!(typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/))&&(typeof document<"u"&&document.documentElement&&document.documentElement.style&&document.documentElement.style.WebkitAppearance||typeof window<"u"&&window.console&&(window.console.firebug||window.console.exception&&window.console.table)||typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/))}function n(e){if(e[0]=(this.useColors?"%c":"")+this.namespace+(this.useColors?" %c":" ")+e[0]+(this.useColors?"%c ":" ")+"+"+t.exports.humanize(this.diff),!this.useColors)return;let a="color: "+this.color;e.splice(1,0,a,"color: inherit");let n=0,r=0;e[0].replace(/%[a-zA-Z%]/g,(e=>{"%%"!==e&&(n++,"%c"===e&&(r=n))})),e.splice(r,0,a)}function r(t){try{t?e.storage.setItem("debug",t):e.storage.removeItem("debug")}catch{}}function i(){let t;try{t=e.storage.getItem("debug")}catch{}return!t&&typeof process<"u"&&"env"in process&&(t=process.env.DEBUG),t}function s(){try{return localStorage}catch{}}J(),e.formatArgs=n,e.save=r,e.load=i,e.useColors=a,e.storage=s(),e.destroy=(()=>{let e=!1;return()=>{e||(e=!0,console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."))}})(),e.colors=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"],o(a,"useColors"),o(n,"formatArgs"),e.log=console.debug||console.log||(()=>{}),o(r,"save"),o(i,"load"),o(s,"localstorage"),t.exports=At()(e);var{formatters:l}=t.exports;l.j=function(e){try{return JSON.stringify(e)}catch(e){return"[UnexpectedJSONParseError]: "+e.message}}}));function Rt(e){if(!e)throw new Error("name must be non-empty")}function Ft(e,t){for(var a,n=0,r=e.length;n<r;)e[a=n+r>>>1].startTime<t.startTime?n=a+1:r=a;e.splice(n,0,t)}var Nt,It,Mt,Pt,Lt,Ot,jt,Ut,Bt,qt,zt,Vt,Wt,Ht,Gt,$t,Kt,Yt,Jt,Zt,Xt,Qt=s((()=>{J(),Nt=typeof performance<"u"&&performance,It=Nt&&Nt.now?function(){return Nt.now()}:function(){return Date.now()},o(Rt,"throwIfEmpty"),o(Ft,"insertSorted"),Nt&&Nt.mark&&Nt.getEntriesByName&&Nt.getEntriesByType&&Nt.clearMeasures?(Mt=o((function(e){Rt(e),Nt.mark("start "+e)}),"mark"),Pt=o((function(e){Rt(e),Nt.mark("end "+e),Nt.measure(e,"start "+e,"end "+e);var t=Nt.getEntriesByName(e);return t[t.length-1]}),"stop"),Lt=o((function(){return Nt.getEntriesByType("measure")}),"getEntries"),Ot=o((function(){Nt.clearMarks(),Nt.clearMeasures()}),"clear")):(jt={},Ut=[],Mt=o((function(e){Rt(e);var t=It();jt["$"+e]=t}),"mark"),Pt=o((function(e){Rt(e);var t=It(),a=jt["$"+e];if(!a)throw new Error("no known mark: "+e);var n={startTime:a,name:e,duration:t-a,entryType:"measure"};return Ft(Ut,n),n}),"stop"),Lt=o((function(){return Ut}),"getEntries"),Ot=o((function(){jt={},Ut=[]}),"clear"))})),ea=s((()=>{J(),Y(),kt(),Bt=d(_t()),Qt(),qt="win32"===K.platform,zt=K.browser,Vt={red:zt?"crimson":1,yellow:zt?"gold":3,cyan:zt?"darkturquoise":6,green:zt?"forestgreen":2,blue:zt?"steelblue":4,magenta:zt?"palevioletred":5},Bt.default.colors=[Vt.cyan,Vt.green,Vt.blue,Vt.magenta],Wt=class extends ut{static{o(this,"Emitter")}issueStatus(e,t){("status"===e||"statusEnd"===e)&&this.emit(e,[e,...t])}issueWarning(e,t){this.emit("warning",[e,...t])}},Ht={},25,($t=class e{static{o(this,"Log")}static _logToStdErr(t,a){e.loggerfn(t)(...a)}static loggerfn(e){let t=Ht[e=`LH:${e}`];return t||(t=(0,Bt.default)(e),Ht[e]=t,e.endsWith("error")?t.color=Vt.red:e.endsWith("warn")&&(t.color=Vt.yellow)),t}static setLevel(e){switch(Gt=e,e){case"silent":Bt.default.enable("-LH:*");break;case"verbose":Bt.default.enable("LH:*");break;case"warn":Bt.default.enable("-LH:*, LH:*:warn, LH:*:error");break;case"error":Bt.default.enable("-LH:*, LH:*:error");break;default:Bt.default.enable("LH:*, -LH:*:verbose")}}static formatProtocol(t,a,n){let r=!K||K.browser?1/0:K.stdout.columns,i=a.method||"?????",o=r-i.length-t.length-25,s=a.params&&"IO.read"!==i?JSON.stringify(a.params).substr(0,o):"";e._logToStdErr(`${t}:${n||""}`,[i,s])}static isVerbose(){return"verbose"===Gt}static time({msg:t,id:a,args:n=[]},r="log"){Mt(a),e[r]("status",t,...n)}static timeEnd({msg:t,id:a,args:n=[]},r="verbose"){e[r]("statusEnd",t,...n),Pt(a)}static log(t,...a){return e.events.issueStatus(t,a),e._logToStdErr(t,a)}static warn(t,...a){return e.events.issueWarning(t,a),e._logToStdErr(`${t}:warn`,a)}static error(t,...a){return e._logToStdErr(`${t}:error`,a)}static verbose(t,...a){return e.events.issueStatus(t,a),e._logToStdErr(`${t}:verbose`,a)}static greenify(t){return`${e.green}${t}${e.reset}`}static redify(t){return`${e.red}${t}${e.reset}`}static get green(){return"[32m"}static get red(){return"[31m"}static get yellow(){return"[33m"}static get purple(){return"[95m"}static get reset(){return"[0m"}static get bold(){return"[1m"}static get dim(){return"[2m"}static get tick(){return qt?"√":"✓"}static get cross(){return qt?"×":"✘"}static get whiteSmallSquare(){return qt?"·":"▫"}static get heavyHorizontal(){return qt?"─":"━"}static get heavyVertical(){return qt?"│ ":"┃ "}static get heavyUpAndRight(){return qt?"└":"┗"}static get heavyVerticalAndRight(){return qt?"├":"┣"}static get heavyDownAndHorizontal(){return qt?"┬":"┳"}static get doubleLightHorizontal(){return"──"}}).events=new Wt,$t.takeTimeEntries=()=>{let e=Lt();return Ot(),e},$t.getTimeEntries=()=>Lt(),Kt=$t})),ta=s((()=>{J()})),aa=s((()=>{J(),ta(),Yt=class{static{o(this,"BaseGatherer")}meta={supportedModes:[]};startInstrumentation(e){}startSensitiveInstrumentation(e){}stopSensitiveInstrumentation(e){}stopInstrumentation(e){}getArtifact(e){}},Jt=Yt})),na=s((()=>{J(),ea(),Zt=/^(chrome|https?):/,16,"RunTask","ThreadControllerImpl::RunTask","ThreadControllerImpl::DoWork","TaskQueueManager::ProcessTaskFromWorkQueue",Xt=class e{static{o(this,"TraceProcessor")}static get TIMESPAN_MARKER_ID(){return"__lighthouseTimespanStart__"}static createNoNavstartError(){return new Error("No navigationStart event found")}static createNoResourceSendRequestError(){return new Error("No ResourceSendRequest event found")}static createNoTracingStartedError(){return new Error("No tracingStartedInBrowser event found")}static createNoFirstContentfulPaintError(){return new Error("No FirstContentfulPaint event found")}static createNoLighthouseMarkerError(){return new Error("No Lighthouse timespan marker event found")}static _isNavigationStartOfInterest(e){return"navigationStart"===e.name&&(void 0===e.args.data?.documentLoaderURL||!!e.args.data?.documentLoaderURL&&Zt.test(e.args.data.documentLoaderURL))}static _sortTimestampEventGroup(e,t,a,n){let r=o((e=>t[e]),"lookupArrayIndexByTsIndex"),i=o((e=>n[r(e)]),"lookupEventByTsIndex"),s=[],l=[],c=[];for(let t of e){let e=r(t),a=i(t);"E"===a.ph?s.push(e):"X"===a.ph||"B"===a.ph?l.push(e):c.push(e)}let u=new Map;for(let r of l){let o=n[r];if("X"===o.ph)u.set(r,o.dur);else{let n=Number.MAX_SAFE_INTEGER,s=0;for(let r=a+e.length;r<t.length;r++){let e=i(r);if(e.name===o.name&&e.pid===o.pid&&e.tid===o.tid){if("E"===e.ph&&0===s){n=e.ts-o.ts;break}"E"===e.ph?s--:"B"===e.ph&&s++}}u.set(r,n)}}return l.sort(((e,t)=>(u.get(t)||0)-(u.get(e)||0)||e-t)),c.sort(((e,t)=>e-t)),[...s,...l,...c]}static filteredTraceSort(t,a){let n=[];for(let e=0;e<t.length;e++)a(t[e])&&n.push(e);n.sort(((e,a)=>t[e].ts-t[a].ts));for(let a=0;a<n.length-1;a++){let r=t[n[a]].ts,i=[a];for(let e=a+1;e<n.length&&t[n[e]].ts===r;e++)i.push(e);if(1===i.length)continue;let o=e._sortTimestampEventGroup(i,n,a,t);n.splice(a,o.length,...o),a+=i.length-1}let r=[];for(let e=0;e<n.length;e++)r.push(t[n[e]]);return r}static assertHasToplevelEvents(e){if(!e.some(this.isScheduleableTask))throw new Error("Could not find any top level events")}static _riskPercentiles(e,t,a,n=0){let r=0;for(let t=0;t<e.length;t++)r+=e[t];r-=n;let i=t-r,o=0,s=i,l=[],c=-1,u=e.length+1;n>0&&u--;for(let r of a){let a=r*t;for(;s<a&&c<e.length-1;)i+=o,u-=o<0?-1:1,n>0&&n<e[c+1]?(o=-n,n=0):(c++,o=e[c]),s=i+Math.abs(o)*u;l.push({percentile:r,time:Math.max(0,(a-i)/u)+16})}return l}static getRiskToResponsiveness(e,t,a,n=[.5,.75,.9,.99,1]){let r=a-t;n.sort(((e,t)=>e-t));let i=this.getMainThreadTopLevelEventDurations(e,t,a);return this._riskPercentiles(i.durations,r,n,i.clippedLength)}static getMainThreadTopLevelEventDurations(e,t=0,a=1/0){let n=[],r=0;for(let i of e){if(i.end<t||i.start>a)continue;let e=i.duration,o=i.start;o<t&&(o=t,e=i.end-t),i.end>a&&(r=e-(a-o)),n.push(e)}return n.sort(((e,t)=>e-t)),{durations:n,clippedLength:r}}static getMainThreadTopLevelEvents(e,t=0,a=1/0){let n=[];for(let r of e.mainThreadEvents){if(!this.isScheduleableTask(r)||!r.dur)continue;let i=(r.ts-e.timeOriginEvt.ts)/1e3,o=(r.ts+r.dur-e.timeOriginEvt.ts)/1e3;i>a||o<t||n.push({start:i,end:o,duration:r.dur/1e3})}return n}static findMainFrameIds(e){let t=e.find((e=>"TracingStartedInBrowser"===e.name));if(t?.args.data?.frames){let e=t.args.data.frames.find((e=>!e.parent)),a=e?.frame,n=e?.processId;if(n&&a)return{startingPid:n,frameId:a}}let a=e.find((e=>"TracingStartedInPage"===e.name));if(a?.args?.data){let e=a.args.data.page;if(e)return{startingPid:a.pid,frameId:e}}let n=e.find((e=>this._isNavigationStartOfInterest(e)&&e.args.data?.isLoadingMainFrame)),r=e.find((e=>"ResourceSendRequest"===e.name));if(n?.args?.data&&r&&r.pid===n.pid&&r.tid===n.tid){let e=n.args.frame;if(e)return{startingPid:n.pid,frameId:e}}throw this.createNoTracingStartedError()}static findMainFramePidTids(e,t){let a=t.filter((t=>("FrameCommittedInBrowser"===t.name||"ProcessReadyInBrowser"===t.name)&&t.args?.data?.frame===e.frameId&&t?.args?.data?.processId)),n=a.length?a.map((e=>e?.args?.data?.processId)):[e.startingPid],r=new Map;for(let e of new Set(n)){let a=t.filter((t=>"__metadata"===t.cat&&t.pid===e&&"M"===t.ph&&"thread_name"===t.name)),n=a.find((e=>"CrRendererMain"===e.args.name));n||(n=a.find((e=>"CrBrowserMain"===e.args.name)));let i=n?.tid;if(!i)throw new Error("Unable to determine tid for renderer process");r.set(e,i)}return r}static isScheduleableTask(e){return"RunTask"===e.name||"ThreadControllerImpl::RunTask"===e.name||"ThreadControllerImpl::DoWork"===e.name||"TaskQueueManager::ProcessTaskFromWorkQueue"===e.name}static isLCPEvent(e){return("largestContentfulPaint::Invalidate"===e.name||"largestContentfulPaint::Candidate"===e.name)&&!!e.args?.frame}static isLCPCandidateEvent(e){return!("largestContentfulPaint::Candidate"!==e.name||!e.args?.frame||!e.args.data||void 0===e.args.data.size)}static getFrameId(e){return e.args?.data?.frame||e.args.data?.frameID||e.args.frame}static computeValidLCPAllFrames(e,t){let a,n=e.filter(this.isLCPEvent).reverse(),r=new Map;for(let e of n){if(e.ts<=t.ts)break;let a=e.args.frame;r.has(a)||r.set(a,e)}for(let e of r.values())this.isLCPCandidateEvent(e)&&(!a||e.args.data.size>a.args.data.size)&&(a=e);return{lcp:a,invalidated:!(a||!r.size)}}static resolveRootFrames(e){let t=new Map;for(let a of e)a.parent&&t.set(a.id,a.parent);let a=new Map;for(let n of e){let e=n.id;for(;t.has(e);)e=t.get(e);if(void 0===e)throw new Error("Unexpected undefined frameId");a.set(n.id,e)}return a}static processTrace(t,a){let{timeOriginDeterminationMethod:n="auto"}=a||{},r=this.filteredTraceSort(t.traceEvents,(e=>e.cat.includes("blink.user_timing")||e.cat.includes("loading")||e.cat.includes("devtools.timeline")||"__metadata"===e.cat)),i=this.findMainFrameIds(r),s=this.findMainFramePidTids(i,r),l=e.filteredTraceSort(t.traceEvents,(e=>s.has(e.pid))),c=new Map,u=r.find((e=>"TracingStartedInBrowser"===e.name))?.args?.data?.frames;if(u)for(let e of u)c.set(e.frame,{id:e.frame,url:e.url,parent:e.parent});r.filter((e=>!("FrameCommittedInBrowser"!==e.name||!e.args.data?.frame||void 0===e.args.data.url))).forEach((e=>{c.set(e.args.data.frame,{id:e.args.data.frame,url:e.args.data.url,parent:e.args.data.parent})}));let d=[...c.values()],m=this.resolveRootFrames(d),p=[...m.entries()].filter((([,e])=>e===i.frameId)).map((([e])=>e));function h(t){return e.getFrameId(t)===i.frameId}function g(t){let a=e.getFrameId(t);return!!a&&p.includes(a)}o(h,"associatedToMainFrame"),o(g,"associatedToAllFrames");let f=r.filter((e=>h(e))),y=[];m.has(i.frameId)?y=r.filter((e=>g(e))):(Kt.warn("TraceProcessor","frameTreeEvents may be incomplete, make sure the trace has frame events"),m.set(i.frameId,i.frameId),y=f);let v=this.computeTimeOrigin({keyEvents:r,frameEvents:f,mainFrameInfo:i},n),b=l.filter((e=>e.tid===s.get(e.pid))),w=this.computeTraceEnd(t.traceEvents,v);return{frames:d,mainThreadEvents:b,frameEvents:f,frameTreeEvents:y,processEvents:l,mainFrameInfo:i,timeOriginEvt:v,timings:{timeOrigin:0,traceEnd:w.timing},timestamps:{timeOrigin:v.ts,traceEnd:w.timestamp},_keyEvents:r,_rendererPidToTid:s}}static processNavigation(e){let{frameEvents:t,frameTreeEvents:a,timeOriginEvt:n,timings:r,timestamps:i}=e,s=this.computeNavigationTimingsForFrame(t,{timeOriginEvt:n}),l=a.find((e=>"firstContentfulPaint"===e.name&&e.ts>n.ts));if(!l)throw this.createNoFirstContentfulPaintError();let c=this.computeValidLCPAllFrames(a,n).lcp,u=o((e=>(e-n.ts)/1e3),"getTiming"),d=o((e=>void 0===e?void 0:u(e)),"maybeGetTiming");return{timings:{timeOrigin:r.timeOrigin,firstPaint:s.timings.firstPaint,firstContentfulPaint:s.timings.firstContentfulPaint,firstContentfulPaintAllFrames:u(l.ts),firstMeaningfulPaint:s.timings.firstMeaningfulPaint,largestContentfulPaint:s.timings.largestContentfulPaint,largestContentfulPaintAllFrames:d(c?.ts),load:s.timings.load,domContentLoaded:s.timings.domContentLoaded,traceEnd:r.traceEnd},timestamps:{timeOrigin:i.timeOrigin,firstPaint:s.timestamps.firstPaint,firstContentfulPaint:s.timestamps.firstContentfulPaint,firstContentfulPaintAllFrames:l.ts,firstMeaningfulPaint:s.timestamps.firstMeaningfulPaint,largestContentfulPaint:s.timestamps.largestContentfulPaint,largestContentfulPaintAllFrames:c?.ts,load:s.timestamps.load,domContentLoaded:s.timestamps.domContentLoaded,traceEnd:i.traceEnd},firstPaintEvt:s.firstPaintEvt,firstContentfulPaintEvt:s.firstContentfulPaintEvt,firstContentfulPaintAllFramesEvt:l,firstMeaningfulPaintEvt:s.firstMeaningfulPaintEvt,largestContentfulPaintEvt:s.largestContentfulPaintEvt,largestContentfulPaintAllFramesEvt:c,loadEvt:s.loadEvt,domContentLoadedEvt:s.domContentLoadedEvt,fmpFellBack:s.fmpFellBack,lcpInvalidated:s.lcpInvalidated}}static computeTraceEnd(e,t){let a=-1/0;for(let t of e)a=Math.max(t.ts+(t.dur||0),a);return{timestamp:a,timing:(a-t.ts)/1e3}}static computeTimeOrigin(t,a){let n=o((()=>t.frameEvents.filter(this._isNavigationStartOfInterest).pop()),"lastNavigationStart"),r=o((()=>t.keyEvents.find((t=>"clock_sync"===t.name&&t.args.sync_id===e.TIMESPAN_MARKER_ID))),"lighthouseMarker");switch(a){case"firstResourceSendRequest":{let e=t.keyEvents.find((e=>"ResourceSendRequest"===e.name&&(e.args.data||{}).frame===t.mainFrameInfo.frameId));if(!e)throw this.createNoResourceSendRequestError();return e}case"lastNavigationStart":{let e=n();if(!e)throw this.createNoNavstartError();return e}case"lighthouseMarker":{let e=r();if(!e)throw this.createNoLighthouseMarkerError();return e}case"auto":{let e=r()||n();if(!e)throw this.createNoNavstartError();return e}}}static computeNavigationTimingsForFrame(e,t){let{timeOriginEvt:a}=t,n=e.find((e=>"firstPaint"===e.name&&e.ts>a.ts)),r=e.find((e=>"firstContentfulPaint"===e.name&&e.ts>a.ts));if(!r)throw this.createNoFirstContentfulPaintError();let i=e.find((e=>"firstMeaningfulPaint"===e.name&&e.ts>a.ts)),s=!1;if(!i){let t="firstMeaningfulPaintCandidate";s=!0,Kt.verbose("TraceProcessor",`No firstMeaningfulPaint found, falling back to last ${t}`);let a=e.filter((e=>e.name===t)).pop();a||Kt.verbose("TraceProcessor","No `firstMeaningfulPaintCandidate` events found in trace"),i=a}let l=this.computeValidLCPAllFrames(e,a),c=e.find((e=>"loadEventEnd"===e.name&&e.ts>a.ts)),u=e.find((e=>"domContentLoadedEventEnd"===e.name&&e.ts>a.ts)),d=o((e=>e?.ts),"getTimestamp"),m={timeOrigin:a.ts,firstPaint:d(n),firstContentfulPaint:r.ts,firstMeaningfulPaint:d(i),largestContentfulPaint:d(l.lcp),load:d(c),domContentLoaded:d(u)},p=o((e=>(e-a.ts)/1e3),"getTiming"),h=o((e=>void 0===e?void 0:p(e)),"maybeGetTiming");return{timings:{timeOrigin:0,firstPaint:h(m.firstPaint),firstContentfulPaint:p(m.firstContentfulPaint),firstMeaningfulPaint:h(m.firstMeaningfulPaint),largestContentfulPaint:h(m.largestContentfulPaint),load:h(m.load),domContentLoaded:h(m.domContentLoaded)},timestamps:m,timeOriginEvt:a,firstPaintEvt:n,firstContentfulPaintEvt:r,firstMeaningfulPaintEvt:i,largestContentfulPaintEvt:l.lcp,loadEvt:c,domContentLoadedEvt:u,fmpFellBack:s,lcpInvalidated:l.invalidated}}}})),ra={};c(ra,{default:()=>oa});var ia,oa,sa=s((()=>{J(),aa(),na(),ia=class e extends Jt{static{o(this,"Trace")}_trace={traceEvents:[]};static getDefaultTraceCategories(){return["-*","disabled-by-default-lighthouse","loading","v8","v8.execute","blink.user_timing","blink.console","devtools.timeline","disabled-by-default-devtools.timeline","disabled-by-default-devtools.screenshot","disabled-by-default-devtools.timeline.stack","disabled-by-default-devtools.timeline.frame","latencyInfo"]}static async endTraceAndCollectEvents(e){let t=[],a=o((function(e){t.push(...e.value)}),"dataListener");return e.on("Tracing.dataCollected",a),new Promise(((n,r)=>{e.once("Tracing.tracingComplete",(r=>{e.off("Tracing.dataCollected",a),n({traceEvents:t})})),e.sendCommand("Tracing.end").catch(r)}))}static symbol=Symbol("Trace");meta={symbol:e.symbol,supportedModes:["timespan","navigation"]};async startSensitiveInstrumentation({driver:t,gatherMode:a,settings:n}){let r=e.getDefaultTraceCategories().concat(n.additionalTraceCategories||[]);await t.defaultSession.sendCommand("Page.enable"),await t.defaultSession.sendCommand("Tracing.start",{categories:r.join(","),options:"sampling-frequency=10000"}),"timespan"===a&&await t.defaultSession.sendCommand("Tracing.recordClockSyncMarker",{syncId:Xt.TIMESPAN_MARKER_ID})}async stopSensitiveInstrumentation({driver:t}){this._trace=await e.endTraceAndCollectEvents(t.defaultSession)}getArtifact(){return this._trace}},oa=ia})),la={};c(la,{default:()=>ca});var ca,ua=s((()=>{J(),ca={}}));function da(e,t){for(var a=0,n=e.length-1;n>=0;n--){var r=e[n];"."===r?e.splice(n,1):".."===r?(e.splice(n,1),a++):a&&(e.splice(n,1),a--)}if(t)for(;a--;a)e.unshift("..");return e}function ma(){for(var e="",t=!1,a=arguments.length-1;a>=-1&&!t;a--){var n=a>=0?arguments[a]:"/";if("string"!=typeof n)throw new TypeError("Arguments to path.resolve must be strings");n&&(e=n+"/"+e,t="/"===n.charAt(0))}return(t?"/":"")+(e=da(wa(e.split("/"),(function(e){return!!e})),!t).join("/"))||"."}function pa(e){var t=ha(e),a="/"===Sa(e,-1);return!(e=da(wa(e.split("/"),(function(e){return!!e})),!t).join("/"))&&!t&&(e="."),e&&a&&(e+="/"),(t?"/":"")+e}function ha(e){return"/"===e.charAt(0)}function ga(){return pa(wa(Array.prototype.slice.call(arguments,0),(function(e,t){if("string"!=typeof e)throw new TypeError("Arguments to path.join must be strings");return e})).join("/"))}function fa(e,t){function a(e){for(var t=0;t<e.length&&""===e[t];t++);for(var a=e.length-1;a>=0&&""===e[a];a--);return t>a?[]:e.slice(t,a-t+1)}e=ma(e).substr(1),t=ma(t).substr(1),o(a,"trim");for(var n=a(e.split("/")),r=a(t.split("/")),i=Math.min(n.length,r.length),s=i,l=0;l<i;l++)if(n[l]!==r[l]){s=l;break}var c=[];for(l=s;l<n.length;l++)c.push("..");return(c=c.concat(r.slice(s))).join("/")}function ya(e){var t=Ea(e),a=t[0],n=t[1];return a||n?(n&&(n=n.substr(0,n.length-1)),a+n):"."}function va(e,t){var a=Ea(e)[2];return t&&a.substr(-1*t.length)===t&&(a=a.substr(0,a.length-t.length)),a}function ba(e){return Ea(e)[3]}function wa(e,t){if(e.filter)return e.filter(t);for(var a=[],n=0;n<e.length;n++)t(e[n],n,e)&&a.push(e[n]);return a}var Da,Ea,Ta,Sa,Ca,ka=s((()=>{J(),o(da,"normalizeArray"),Da=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,Ea=o((function(e){return Da.exec(e).slice(1)}),"splitPath"),o(ma,"resolve"),o(pa,"normalize"),o(ha,"isAbsolute"),o(ga,"join"),o(fa,"relative"),"/",":",o(ya,"dirname"),o(va,"basename"),o(ba,"extname"),Ta={extname:ba,basename:va,dirname:ya,sep:"/",delimiter:":",relative:fa,join:ga,isAbsolute:ha,normalize:pa,resolve:ma},o(wa,"filter"),Sa="b"==="ab".substr(-1)?function(e,t,a){return e.substr(t,a)}:function(e,t,a){return t<0&&(t=e.length+t),e.substr(t,a)}})),xa=l(((e,t)=>{function a(){this.__data__=[],this.size=0}J(),o(a,"listCacheClear"),t.exports=a})),Aa=l(((e,t)=>{function a(e,t){return e===t||e!=e&&t!=t}J(),o(a,"eq"),t.exports=a})),_a=l(((e,t)=>{J();var a=Aa();function n(e,t){for(var n=e.length;n--;)if(a(e[n][0],t))return n;return-1}o(n,"assocIndexOf"),t.exports=n})),Ra=l(((e,t)=>{J();var a=_a(),n=Array.prototype.splice;function r(e){var t=this.__data__,r=a(t,e);return!(r<0)&&(r==t.length-1?t.pop():n.call(t,r,1),--this.size,!0)}o(r,"listCacheDelete"),t.exports=r})),Fa=l(((e,t)=>{J();var a=_a();function n(e){var t=this.__data__,n=a(t,e);return n<0?void 0:t[n][1]}o(n,"listCacheGet"),t.exports=n})),Na=l(((e,t)=>{J();var a=_a();function n(e){return a(this.__data__,e)>-1}o(n,"listCacheHas"),t.exports=n})),Ia=l(((e,t)=>{J();var a=_a();function n(e,t){var n=this.__data__,r=a(n,e);return r<0?(++this.size,n.push([e,t])):n[r][1]=t,this}o(n,"listCacheSet"),t.exports=n})),Ma=l(((e,t)=>{J();var a=xa(),n=Ra(),r=Fa(),i=Na(),s=Ia();function l(e){var t=-1,a=null==e?0:e.length;for(this.clear();++t<a;){var n=e[t];this.set(n[0],n[1])}}o(l,"ListCache"),l.prototype.clear=a,l.prototype.delete=n,l.prototype.get=r,l.prototype.has=i,l.prototype.set=s,t.exports=l})),Pa=l(((e,t)=>{J();var a=Ma();function n(){this.__data__=new a,this.size=0}o(n,"stackClear"),t.exports=n})),La=l(((e,t)=>{function a(e){var t=this.__data__,a=t.delete(e);return this.size=t.size,a}J(),o(a,"stackDelete"),t.exports=a})),Oa=l(((e,t)=>{function a(e){return this.__data__.get(e)}J(),o(a,"stackGet"),t.exports=a})),ja=l(((e,t)=>{function a(e){return this.__data__.has(e)}J(),o(a,"stackHas"),t.exports=a})),Ua=l(((e,t)=>{J();var a="object"==typeof globalThis&&globalThis&&globalThis.Object===Object&&globalThis;t.exports=a})),Ba=l(((e,t)=>{J();var a=Ua(),n="object"==typeof self&&self&&self.Object===Object&&self,r=a||n||Function("return this")();t.exports=r})),qa=l(((e,t)=>{J();var a=Ba().Symbol;t.exports=a})),za=l(((e,t)=>{J();var a=qa(),n=Object.prototype,r=n.hasOwnProperty,i=n.toString,s=a?a.toStringTag:void 0;function l(e){var t=r.call(e,s),a=e[s];try{e[s]=void 0;var n=!0}catch{}var o=i.call(e);return n&&(t?e[s]=a:delete e[s]),o}o(l,"getRawTag"),t.exports=l})),Va=l(((e,t)=>{J();var a=Object.prototype.toString;function n(e){return a.call(e)}o(n,"objectToString"),t.exports=n})),Wa=l(((e,t)=>{J();var a=qa(),n=za(),r=Va(),i=a?a.toStringTag:void 0;function s(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":i&&i in Object(e)?n(e):r(e)}o(s,"baseGetTag"),t.exports=s})),Ha=l(((e,t)=>{function a(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}J(),o(a,"isObject"),t.exports=a})),Ga=l(((e,t)=>{J();var a=Wa(),n=Ha();function r(e){if(!n(e))return!1;var t=a(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}o(r,"isFunction"),t.exports=r})),$a=l(((e,t)=>{J();var a=Ba()["__core-js_shared__"];t.exports=a})),Ka=l(((e,t)=>{J();var a,n=$a(),r=(a=/[^.]+$/.exec(n&&n.keys&&n.keys.IE_PROTO||""))?"Symbol(src)_1."+a:"";function i(e){return!!r&&r in e}o(i,"isMasked"),t.exports=i})),Ya=l(((e,t)=>{J();var a=Function.prototype.toString;function n(e){if(null!=e){try{return a.call(e)}catch{}try{return e+""}catch{}}return""}o(n,"toSource"),t.exports=n})),Ja=l(((e,t)=>{J();var a=Ga(),n=Ka(),r=Ha(),i=Ya(),s=/^\[object .+?Constructor\]$/,l=Function.prototype,c=Object.prototype,u=l.toString,d=c.hasOwnProperty,m=RegExp("^"+u.call(d).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");function p(e){return!(!r(e)||n(e))&&(a(e)?m:s).test(i(e))}o(p,"baseIsNative"),t.exports=p})),Za=l(((e,t)=>{function a(e,t){return e?.[t]}J(),o(a,"getValue"),t.exports=a})),Xa=l(((e,t)=>{J();var a=Ja(),n=Za();function r(e,t){var r=n(e,t);return a(r)?r:void 0}o(r,"getNative"),t.exports=r})),Qa=l(((e,t)=>{J();var a=Xa()(Ba(),"Map");t.exports=a})),en=l(((e,t)=>{J();var a=Xa()(Object,"create");t.exports=a})),tn=l(((e,t)=>{J();var a=en();function n(){this.__data__=a?a(null):{},this.size=0}o(n,"hashClear"),t.exports=n})),an=l(((e,t)=>{function a(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}J(),o(a,"hashDelete"),t.exports=a})),nn=l(((e,t)=>{J();var a=en(),n=Object.prototype.hasOwnProperty;function r(e){var t=this.__data__;if(a){var r=t[e];return"__lodash_hash_undefined__"===r?void 0:r}return n.call(t,e)?t[e]:void 0}o(r,"hashGet"),t.exports=r})),rn=l(((e,t)=>{J();var a=en(),n=Object.prototype.hasOwnProperty;function r(e){var t=this.__data__;return a?void 0!==t[e]:n.call(t,e)}o(r,"hashHas"),t.exports=r})),on=l(((e,t)=>{J();var a=en();function n(e,t){var n=this.__data__;return this.size+=this.has(e)?0:1,n[e]=a&&void 0===t?"__lodash_hash_undefined__":t,this}o(n,"hashSet"),t.exports=n})),sn=l(((e,t)=>{J();var a=tn(),n=an(),r=nn(),i=rn(),s=on();function l(e){var t=-1,a=null==e?0:e.length;for(this.clear();++t<a;){var n=e[t];this.set(n[0],n[1])}}o(l,"Hash"),l.prototype.clear=a,l.prototype.delete=n,l.prototype.get=r,l.prototype.has=i,l.prototype.set=s,t.exports=l})),ln=l(((e,t)=>{J();var a=sn(),n=Ma(),r=Qa();function i(){this.size=0,this.__data__={hash:new a,map:new(r||n),string:new a}}o(i,"mapCacheClear"),t.exports=i})),cn=l(((e,t)=>{function a(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}J(),o(a,"isKeyable"),t.exports=a})),un=l(((e,t)=>{J();var a=cn();function n(e,t){var n=e.__data__;return a(t)?n["string"==typeof t?"string":"hash"]:n.map}o(n,"getMapData"),t.exports=n})),dn=l(((e,t)=>{J();var a=un();function n(e){var t=a(this,e).delete(e);return this.size-=t?1:0,t}o(n,"mapCacheDelete"),t.exports=n})),mn=l(((e,t)=>{J();var a=un();function n(e){return a(this,e).get(e)}o(n,"mapCacheGet"),t.exports=n})),pn=l(((e,t)=>{J();var a=un();function n(e){return a(this,e).has(e)}o(n,"mapCacheHas"),t.exports=n})),hn=l(((e,t)=>{J();var a=un();function n(e,t){var n=a(this,e),r=n.size;return n.set(e,t),this.size+=n.size==r?0:1,this}o(n,"mapCacheSet"),t.exports=n})),gn=l(((e,t)=>{J();var a=ln(),n=dn(),r=mn(),i=pn(),s=hn();function l(e){var t=-1,a=null==e?0:e.length;for(this.clear();++t<a;){var n=e[t];this.set(n[0],n[1])}}o(l,"MapCache"),l.prototype.clear=a,l.prototype.delete=n,l.prototype.get=r,l.prototype.has=i,l.prototype.set=s,t.exports=l})),fn=l(((e,t)=>{J();var a=Ma(),n=Qa(),r=gn();function i(e,t){var i=this.__data__;if(i instanceof a){var o=i.__data__;if(!n||o.length<199)return o.push([e,t]),this.size=++i.size,this;i=this.__data__=new r(o)}return i.set(e,t),this.size=i.size,this}o(i,"stackSet"),t.exports=i})),yn=l(((e,t)=>{J();var a=Ma(),n=Pa(),r=La(),i=Oa(),s=ja(),l=fn();function c(e){var t=this.__data__=new a(e);this.size=t.size}o(c,"Stack"),c.prototype.clear=n,c.prototype.delete=r,c.prototype.get=i,c.prototype.has=s,c.prototype.set=l,t.exports=c})),vn=l(((e,t)=>{J();function a(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this}o(a,"setCacheAdd"),t.exports=a})),bn=l(((e,t)=>{function a(e){return this.__data__.has(e)}J(),o(a,"setCacheHas"),t.exports=a})),wn=l(((e,t)=>{J();var a=gn(),n=vn(),r=bn();function i(e){var t=-1,n=null==e?0:e.length;for(this.__data__=new a;++t<n;)this.add(e[t])}o(i,"SetCache"),i.prototype.add=i.prototype.push=n,i.prototype.has=r,t.exports=i})),Dn=l(((e,t)=>{function a(e,t){for(var a=-1,n=null==e?0:e.length;++a<n;)if(t(e[a],a,e))return!0;return!1}J(),o(a,"arraySome"),t.exports=a})),En=l(((e,t)=>{function a(e,t){return e.has(t)}J(),o(a,"cacheHas"),t.exports=a})),Tn=l(((e,t)=>{J();var a=wn(),n=Dn(),r=En();function i(e,t,i,o,s,l){var c=1&i,u=e.length,d=t.length;if(u!=d&&!(c&&d>u))return!1;var m=l.get(e),p=l.get(t);if(m&&p)return m==t&&p==e;var h=-1,g=!0,f=2&i?new a:void 0;for(l.set(e,t),l.set(t,e);++h<u;){var y=e[h],v=t[h];if(o)var b=c?o(v,y,h,t,e,l):o(y,v,h,e,t,l);if(void 0!==b){if(b)continue;g=!1;break}if(f){if(!n(t,(function(e,t){if(!r(f,t)&&(y===e||s(y,e,i,o,l)))return f.push(t)}))){g=!1;break}}else if(y!==v&&!s(y,v,i,o,l)){g=!1;break}}return l.delete(e),l.delete(t),g}o(i,"equalArrays"),t.exports=i})),Sn=l(((e,t)=>{J();var a=Ba().Uint8Array;t.exports=a})),Cn=l(((e,t)=>{function a(e){var t=-1,a=Array(e.size);return e.forEach((function(e,n){a[++t]=[n,e]})),a}J(),o(a,"mapToArray"),t.exports=a})),kn=l(((e,t)=>{function a(e){var t=-1,a=Array(e.size);return e.forEach((function(e){a[++t]=e})),a}J(),o(a,"setToArray"),t.exports=a})),xn=l(((e,t)=>{J();var a=qa(),n=Sn(),r=Aa(),i=Tn(),s=Cn(),l=kn(),c=a?a.prototype:void 0,u=c?c.valueOf:void 0;function d(e,t,a,o,c,d,m){switch(a){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return!(e.byteLength!=t.byteLength||!d(new n(e),new n(t)));case"[object Boolean]":case"[object Date]":case"[object Number]":return r(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var p=s;case"[object Set]":var h=1&o;if(p||(p=l),e.size!=t.size&&!h)return!1;var g=m.get(e);if(g)return g==t;o|=2,m.set(e,t);var f=i(p(e),p(t),o,c,d,m);return m.delete(e),f;case"[object Symbol]":if(u)return u.call(e)==u.call(t)}return!1}o(d,"equalByTag"),t.exports=d})),An=l(((e,t)=>{function a(e,t){for(var a=-1,n=t.length,r=e.length;++a<n;)e[r+a]=t[a];return e}J(),o(a,"arrayPush"),t.exports=a})),_n=l(((e,t)=>{J();var a=Array.isArray;t.exports=a})),Rn=l(((e,t)=>{J();var a=An(),n=_n();function r(e,t,r){var i=t(e);return n(e)?i:a(i,r(e))}o(r,"baseGetAllKeys"),t.exports=r})),Fn=l(((e,t)=>{function a(e,t){for(var a=-1,n=null==e?0:e.length,r=0,i=[];++a<n;){var o=e[a];t(o,a,e)&&(i[r++]=o)}return i}J(),o(a,"arrayFilter"),t.exports=a})),Nn=l(((e,t)=>{function a(){return[]}J(),o(a,"stubArray"),t.exports=a})),In=l(((e,t)=>{J();var a=Fn(),n=Nn(),r=Object.prototype.propertyIsEnumerable,i=Object.getOwnPropertySymbols,o=i?function(e){return null==e?[]:(e=Object(e),a(i(e),(function(t){return r.call(e,t)})))}:n;t.exports=o})),Mn=l(((e,t)=>{function a(e,t){for(var a=-1,n=Array(e);++a<e;)n[a]=t(a);return n}J(),o(a,"baseTimes"),t.exports=a})),Pn=l(((e,t)=>{function a(e){return null!=e&&"object"==typeof e}J(),o(a,"isObjectLike"),t.exports=a})),Ln=l(((e,t)=>{J();var a=Wa(),n=Pn();function r(e){return n(e)&&"[object Arguments]"==a(e)}o(r,"baseIsArguments"),t.exports=r})),On=l(((e,t)=>{J();var a=Ln(),n=Pn(),r=Object.prototype,i=r.hasOwnProperty,o=r.propertyIsEnumerable,s=a(function(){return arguments}())?a:function(e){return n(e)&&i.call(e,"callee")&&!o.call(e,"callee")};t.exports=s})),jn=l(((e,t)=>{function a(){return!1}J(),o(a,"stubFalse"),t.exports=a})),Un=l(((e,t)=>{J();var a=Ba(),n=jn(),r="object"==typeof e&&e&&!e.nodeType&&e,i=r&&"object"==typeof t&&t&&!t.nodeType&&t,o=i&&i.exports===r?a.Buffer:void 0,s=(o?o.isBuffer:void 0)||n;t.exports=s})),Bn=l(((e,t)=>{J();var a=/^(?:0|[1-9]\d*)$/;function n(e,t){var n=typeof e;return!!(t=t??9007199254740991)&&("number"==n||"symbol"!=n&&a.test(e))&&e>-1&&e%1==0&&e<t}o(n,"isIndex"),t.exports=n})),qn=l(((e,t)=>{J();function a(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=9007199254740991}o(a,"isLength"),t.exports=a})),zn=l(((e,t)=>{J();var a=Wa(),n=qn(),r=Pn(),i={};function s(e){return r(e)&&n(e.length)&&!!i[a(e)]}i["[object Float32Array]"]=i["[object Float64Array]"]=i["[object Int8Array]"]=i["[object Int16Array]"]=i["[object Int32Array]"]=i["[object Uint8Array]"]=i["[object Uint8ClampedArray]"]=i["[object Uint16Array]"]=i["[object Uint32Array]"]=!0,i["[object Arguments]"]=i["[object Array]"]=i["[object ArrayBuffer]"]=i["[object Boolean]"]=i["[object DataView]"]=i["[object Date]"]=i["[object Error]"]=i["[object Function]"]=i["[object Map]"]=i["[object Number]"]=i["[object Object]"]=i["[object RegExp]"]=i["[object Set]"]=i["[object String]"]=i["[object WeakMap]"]=!1,o(s,"baseIsTypedArray"),t.exports=s})),Vn=l(((e,t)=>{function a(e){return function(t){return e(t)}}J(),o(a,"baseUnary"),t.exports=a})),Wn=l(((e,t)=>{J();var a=Ua(),n="object"==typeof e&&e&&!e.nodeType&&e,r=n&&"object"==typeof t&&t&&!t.nodeType&&t,i=r&&r.exports===n&&a.process,o=function(){try{return r&&r.require&&r.require("util").types||i&&i.binding&&i.binding("util")}catch{}}();t.exports=o})),Hn=l(((e,t)=>{J();var a=zn(),n=Vn(),r=Wn(),i=r&&r.isTypedArray,o=i?n(i):a;t.exports=o})),Gn=l(((e,t)=>{J();var a=Mn(),n=On(),r=_n(),i=Un(),s=Bn(),l=Hn(),c=Object.prototype.hasOwnProperty;function u(e,t){var o=r(e),u=!o&&n(e),d=!o&&!u&&i(e),m=!o&&!u&&!d&&l(e),p=o||u||d||m,h=p?a(e.length,String):[],g=h.length;for(var f in e)(t||c.call(e,f))&&(!p||!("length"==f||d&&("offset"==f||"parent"==f)||m&&("buffer"==f||"byteLength"==f||"byteOffset"==f)||s(f,g)))&&h.push(f);return h}o(u,"arrayLikeKeys"),t.exports=u})),$n=l(((e,t)=>{J();var a=Object.prototype;function n(e){var t=e&&e.constructor;return e===("function"==typeof t&&t.prototype||a)}o(n,"isPrototype"),t.exports=n})),Kn=l(((e,t)=>{function a(e,t){return function(a){return e(t(a))}}J(),o(a,"overArg"),t.exports=a})),Yn=l(((e,t)=>{J();var a=Kn()(Object.keys,Object);t.exports=a})),Jn=l(((e,t)=>{J();var a=$n(),n=Yn(),r=Object.prototype.hasOwnProperty;function i(e){if(!a(e))return n(e);var t=[];for(var i in Object(e))r.call(e,i)&&"constructor"!=i&&t.push(i);return t}o(i,"baseKeys"),t.exports=i})),Zn=l(((e,t)=>{J();var a=Ga(),n=qn();function r(e){return null!=e&&n(e.length)&&!a(e)}o(r,"isArrayLike"),t.exports=r})),Xn=l(((e,t)=>{J();var a=Gn(),n=Jn(),r=Zn();function i(e){return r(e)?a(e):n(e)}o(i,"keys"),t.exports=i})),Qn=l(((e,t)=>{J();var a=Rn(),n=In(),r=Xn();function i(e){return a(e,r,n)}o(i,"getAllKeys"),t.exports=i})),er=l(((e,t)=>{J();var a=Qn(),n=Object.prototype.hasOwnProperty;function r(e,t,r,i,o,s){var l=1&r,c=a(e),u=c.length;if(u!=a(t).length&&!l)return!1;for(var d=u;d--;){var m=c[d];if(!(l?m in t:n.call(t,m)))return!1}var p=s.get(e),h=s.get(t);if(p&&h)return p==t&&h==e;var g=!0;s.set(e,t),s.set(t,e);for(var f=l;++d<u;){var y=e[m=c[d]],v=t[m];if(i)var b=l?i(v,y,m,t,e,s):i(y,v,m,e,t,s);if(!(void 0===b?y===v||o(y,v,r,i,s):b)){g=!1;break}f||(f="constructor"==m)}if(g&&!f){var w=e.constructor,D=t.constructor;w!=D&&"constructor"in e&&"constructor"in t&&!("function"==typeof w&&w instanceof w&&"function"==typeof D&&D instanceof D)&&(g=!1)}return s.delete(e),s.delete(t),g}o(r,"equalObjects"),t.exports=r})),tr=l(((e,t)=>{J();var a=Xa()(Ba(),"DataView");t.exports=a})),ar=l(((e,t)=>{J();var a=Xa()(Ba(),"Promise");t.exports=a})),nr=l(((e,t)=>{J();var a=Xa()(Ba(),"Set");t.exports=a})),rr=l(((e,t)=>{J();var a=Xa()(Ba(),"WeakMap");t.exports=a})),ir=l(((e,t)=>{J();var a=tr(),n=Qa(),r=ar(),i=nr(),s=rr(),l=Wa(),c=Ya(),u="[object Map]",d="[object Promise]",m="[object Set]",p="[object WeakMap]",h="[object DataView]",g=c(a),f=c(n),y=c(r),v=c(i),b=c(s),w=l;(a&&w(new a(new ArrayBuffer(1)))!=h||n&&w(new n)!=u||r&&w(r.resolve())!=d||i&&w(new i)!=m||s&&w(new s)!=p)&&(w=o((function(e){var t=l(e),a="[object Object]"==t?e.constructor:void 0,n=a?c(a):"";if(n)switch(n){case g:return h;case f:return u;case y:return d;case v:return m;case b:return p}return t}),"getTag")),t.exports=w})),or=l(((e,t)=>{J();var a=yn(),n=Tn(),r=xn(),i=er(),s=ir(),l=_n(),c=Un(),u=Hn(),d="[object Arguments]",m="[object Array]",p="[object Object]",h=Object.prototype.hasOwnProperty;function g(e,t,o,g,f,y){var v=l(e),b=l(t),w=v?m:s(e),D=b?m:s(t),E=(w=w==d?p:w)==p,T=(D=D==d?p:D)==p,S=w==D;if(S&&c(e)){if(!c(t))return!1;v=!0,E=!1}if(S&&!E)return y||(y=new a),v||u(e)?n(e,t,o,g,f,y):r(e,t,w,o,g,f,y);if(!(1&o)){var C=E&&h.call(e,"__wrapped__"),k=T&&h.call(t,"__wrapped__");if(C||k){var x=C?e.value():e,A=k?t.value():t;return y||(y=new a),f(x,A,o,g,y)}}return!!S&&(y||(y=new a),i(e,t,o,g,f,y))}o(g,"baseIsEqualDeep"),t.exports=g})),sr=l(((e,t)=>{J();var a=or(),n=Pn();function r(e,t,i,o,s){return e===t||(null==e||null==t||!n(e)&&!n(t)?e!=e&&t!=t:a(e,t,i,o,r,s))}o(r,"baseIsEqual"),t.exports=r})),lr=l(((e,t)=>{J();var a=sr();function n(e,t){return a(e,t)}o(n,"isEqual"),t.exports=n})),cr=s((()=>{J(),Y(),Ca=!!K.env.CI||"test"===K.env.NODE_ENV}));function ur(e){let t=Math.sign(e),a=1/(1+.3275911*(e=Math.abs(e)));return t*(1-a*(.254829592+a*(a*(1.421413741+a*(1.061405429*a-1.453152027))-.284496736))*Math.exp(-e*e))}function dr({median:e,p10:t},a){if(e<=0)throw new Error("median must be greater than zero");if(t<=0)throw new Error("p10 must be greater than zero");if(t>=e)throw new Error("p10 must be less than the median");if(a<=0)return 1;let n,r=Math.max(Number.MIN_VALUE,a/e),i=Math.log(r),o=Math.max(Number.MIN_VALUE,t/e),s=(1-ur(.9061938024368232*i/-Math.log(o)))/2;return n=a<=t?Math.max(.9,Math.min(1,s)):a<=e?Math.max(hr,Math.min(pr,s)):Math.max(0,Math.min(gr,s)),n}function mr(e,t,a,n,r){return t+(r-e)*((n-t)/(a-e))}var pr,hr,gr,fr,yr,vr,br,wr,Dr,Er,Tr,Sr,Cr=s((()=>{J(),pr=.8999999999999999,hr=.5,gr=.49999999999999994,o(ur,"erf"),o(dr,"getLogNormalScore"),o(mr,"linearInterpolation")})),kr=s((()=>{J(),fr="…"," ",yr={PASS:{label:"pass",minScore:.9},AVERAGE:{label:"average",minScore:.5},FAIL:{label:"fail"},ERROR:{label:"error"}},vr=["com","co","gov","edu","ac","org","go","gob","or","net","in","ne","nic","gouv","web","spb","blog","jus","kiev","mil","wi","qc","ca","bel","on"],br=class e{static{o(this,"Util")}static get RATINGS(){return yr}static get PASS_THRESHOLD(){return.9}static get MS_DISPLAY_VALUE(){return"%10d ms"}static getFinalDisplayedUrl(e){if(e.finalDisplayedUrl)return e.finalDisplayedUrl;if(e.finalUrl)return e.finalUrl;throw new Error("Could not determine final displayed URL")}static getMainDocumentUrl(e){return e.mainDocumentUrl||e.finalUrl}static getFullPageScreenshot(e){return e.fullPageScreenshot?e.fullPageScreenshot:e.audits["full-page-screenshot"]?.details}static splitMarkdownCodeSpans(e){let t=[],a=e.split(/`(.*?)`/g);for(let e=0;e<a.length;e++){let n=a[e];if(!n)continue;let r=e%2!=0;t.push({isCode:r,text:n})}return t}static splitMarkdownLink(e){let t=[],a=e.split(/\[([^\]]+?)\]\((https?:\/\/.*?)\)/g);for(;a.length;){let[e,n,r]=a.splice(0,3);e&&t.push({isLink:!1,text:e}),n&&r&&t.push({isLink:!0,text:n,linkHref:r})}return t}static truncate(e,t,a="…"){if(e.length<=t)return e;let n=new Intl.Segmenter(void 0,{granularity:"grapheme"}).segment(e)[Symbol.iterator](),r=0;for(let i=0;i<=t-a.length;i++){let t=n.next();if(t.done)return e;r=t.value.index}for(let t=0;t<a.length;t++)if(n.next().done)return e;return e.slice(0,r)+a}static getURLDisplayName(e,t){let a,n=void 0!==(t=t||{numPathParts:void 0,preserveQuery:void 0,preserveHost:void 0}).numPathParts?t.numPathParts:2,r=void 0===t.preserveQuery||t.preserveQuery,i=t.preserveHost||!1;if("about:"===e.protocol||"data:"===e.protocol)a=e.href;else{a=e.pathname;let t=a.split("/").filter((e=>e.length));n&&t.length>n&&(a=fr+t.slice(-1*n).join("/")),i&&(a=`${e.host}/${a.replace(/^\//,"")}`),r&&(a=`${a}${e.search}`)}if("data:"!==e.protocol&&(a=a.slice(0,200),a=a.replace(/([a-f0-9]{7})[a-f0-9]{13}[a-f0-9]*/g,`$1${fr}`),a=a.replace(/([a-zA-Z0-9-_]{9})(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])[a-zA-Z0-9-_]{10,}/g,`$1${fr}`),a=a.replace(/(\d{3})\d{6,}/g,`$1${fr}`),a=a.replace(/\u2026+/g,fr),a.length>64&&a.includes("?")&&(a=a.replace(/\?([^=]*)(=)?.*/,`?$1$2${fr}`),a.length>64&&(a=a.replace(/\?.*/,`?${fr}`)))),a.length>64){let e=a.lastIndexOf(".");a=e>=0?a.slice(0,63-(a.length-e))+`${fr}${a.slice(e)}`:a.slice(0,63)+fr}return a}static getChromeExtensionOrigin(e){let t=new URL(e);return t.protocol+"//"+t.host}static parseURL(t){let a=new URL(t);return{file:e.getURLDisplayName(a),hostname:a.hostname,origin:"chrome-extension:"===a.protocol?e.getChromeExtensionOrigin(t):a.origin}}static createOrReturnURL(e){return e instanceof URL?e:new URL(e)}static getTld(e){let t=e.split(".").slice(-2);return vr.includes(t[0])?`.${t.join(".")}`:`.${t[t.length-1]}`}static getRootDomain(t){let a=e.createOrReturnURL(t).hostname,n=e.getTld(a).split(".");return a.split(".").slice(-n.length).join(".")}static filterRelevantLines(e,t,a){if(0===t.length)return e.slice(0,2*a+1);let n=new Set;return(t=t.sort(((e,t)=>(e.lineNumber||0)-(t.lineNumber||0)))).forEach((({lineNumber:e})=>{let t=e-a,r=e+a;for(;t<1;)t++,r++;n.has(t-3-1)&&(t-=3);for(let e=t;e<=r;e++){let t=e;n.add(t)}})),e.filter((e=>n.has(e.lineNumber)))}}})),xr=s((()=>{J(),ta(),cr(),Cr(),kr(),"defaultPass",wr=o((e=>Math.round(100*e)/100),"clampTo2Decimals"),Dr=class e{static{o(this,"Audit")}static get DEFAULT_PASS(){return"defaultPass"}static get SCORING_MODES(){return{NUMERIC:"numeric",BINARY:"binary",MANUAL:"manual",INFORMATIVE:"informative",NOT_APPLICABLE:"notApplicable",ERROR:"error"}}static get meta(){throw new Error("Audit meta information must be overridden.")}static get defaultOptions(){return{}}static audit(e,t){throw new Error("audit() method must be overridden")}static computeLogNormalScore(e,t){let a=dr(e,t);return a>.9&&(a+=.05*(a-.9)),Math.floor(100*a)/100}static assertHeadingKeysExist(e,t){if(t.length&&Ca)for(let a of e){if(null===a.key)continue;let e=a.key;if(!t.some((t=>e in t)))throw new Error(`"${a.key}" is missing from items`)}}static makeTableDetails(t,a,n={}){let{wastedBytes:r,wastedMs:i,sortedBy:o,skipSumming:s,isEntityGrouped:l}=n,c=r||i?{wastedBytes:r,wastedMs:i}:void 0;return 0===a.length?{type:"table",headings:[],items:[],summary:c}:(e.assertHeadingKeysExist(t,a),{type:"table",headings:t,items:a,summary:c,sortedBy:o,skipSumming:s,isEntityGrouped:l})}static makeListDetails(e){return{type:"list",items:e}}static makeSnippetDetails({content:t,title:a,lineMessages:n,generalMessages:r,node:i,maxLineLength:o=200,maxLinesAroundMessage:s=20}){let l=e._makeSnippetLinesArray(t,o);return{type:"snippet",lines:br.filterRelevantLines(l,n,s),title:a,lineMessages:n,generalMessages:r,lineCount:l.length,node:i}}static _makeSnippetLinesArray(e,t){return e.split("\n").map(((e,a)=>{let n=a+1,r={content:br.truncate(e,t),lineNumber:n};return e.length>t&&(r.truncated=!0),r}))}static makeOpportunityDetails(t,a,n){e.assertHeadingKeysExist(t,a);let{overallSavingsMs:r,overallSavingsBytes:i,sortedBy:o,skipSumming:s,isEntityGrouped:l}=n;return{type:"opportunity",headings:0===a.length?[]:t,items:a,overallSavingsMs:r,overallSavingsBytes:i,sortedBy:o,skipSumming:s,isEntityGrouped:l}}static makeNodeItem(e){return{type:"node",lhId:e.lhId,path:e.devtoolsNodePath,selector:e.selector,boundingRect:e.boundingRect,snippet:e.snippet,nodeLabel:e.nodeLabel}}static _findOriginalLocation(e,t,a){let n=e?.map.findEntry(t,a);if(n)return{file:n.sourceURL||"",line:n.sourceLineNumber||0,column:n.sourceColumnNumber||0}}static makeSourceLocation(e,t,a,n){return{type:"source-location",url:e,urlProvider:"network",line:t,column:a,original:n&&this._findOriginalLocation(n,t,a)}}static makeSourceLocationFromConsoleMessage(e,t){if(!e.url)return;let a=e.lineNumber||0,n=e.columnNumber||0;return this.makeSourceLocation(e.url,a,n,t)}static _normalizeAuditScore(t,a,n){if(a!==e.SCORING_MODES.BINARY&&a!==e.SCORING_MODES.NUMERIC)return null;if(null===t||!Number.isFinite(t))throw new Error(`Invalid score for ${n}: ${t}`);if(t>1)throw new Error(`Audit score for ${n} is > 1`);if(t<0)throw new Error(`Audit score for ${n} is < 0`);return t=wr(t)}static generateErrorAuditResult(t,a,n){return e.generateAuditResult(t,{score:null,errorMessage:a,errorStack:n})}static generateAuditResult(t,a){if(void 0===a.score)throw new Error("generateAuditResult requires a score");let n=t.meta.scoreDisplayMode||e.SCORING_MODES.BINARY;void 0!==a.errorMessage?n=e.SCORING_MODES.ERROR:a.notApplicable&&(n=e.SCORING_MODES.NOT_APPLICABLE);let r=e._normalizeAuditScore(a.score,n,t.meta.id),i=t.meta.title;t.meta.failureTitle&&null!==r&&r<br.PASS_THRESHOLD&&(i=t.meta.failureTitle);let o="numericUnit"in a?a:void 0;return{id:t.meta.id,title:i,description:t.meta.description,score:r,scoreDisplayMode:n,numericValue:o?.numericValue,numericUnit:o?.numericUnit,displayValue:a.displayValue,explanation:a.explanation,errorMessage:a.errorMessage,errorStack:a.errorStack,warnings:a.warnings,details:a.details}}static makeMetricComputationDataInput(t,a){return{trace:t.traces[e.DEFAULT_PASS],devtoolsLog:t.devtoolsLogs[e.DEFAULT_PASS],gatherContext:t.GatherContext,settings:a.settings,URL:t.URL}}}})),Ar=s((()=>{J(),xr(),Er=o((e=>Math.round(100*e)/100),"clampTo2Decimals"),Tr=class e{static{o(this,"ReportScoring")}static arithmeticMean(e){if((e=e.filter((e=>e.weight>0))).some((e=>null===e.score)))return null;let t=e.reduce(((e,t)=>{let a=t.score,n=t.weight;return{weight:e.weight+n,sum:e.sum+a*n}}),{weight:0,sum:0});return Er(t.sum/t.weight||0)}static scoreAllCategories(t,a){let n={};for(let[r,i]of Object.entries(t)){let t=i.auditRefs.map((e=>{let t={...e},n=a[t.id];return(n.scoreDisplayMode===Dr.SCORING_MODES.NOT_APPLICABLE||n.scoreDisplayMode===Dr.SCORING_MODES.INFORMATIVE||n.scoreDisplayMode===Dr.SCORING_MODES.MANUAL)&&(t.weight=0),t})),o=t.map((e=>({score:a[e.id].score,weight:e.weight}))),s=e.arithmeticMean(o);n[r]={...i,auditRefs:t,id:r,score:s}}return n}}})),_r=s((()=>{J(),Sr=function(){function e(e,t){function a(){this.constructor=e}o(a,"ctor"),a.prototype=t.prototype,e.prototype=new a}function t(e,a,n,r){this.message=e,this.expected=a,this.found=n,this.location=r,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,t)}function a(e,a){a=void 0!==a?a:{};var n,r={},i={start:ze},s=ze,l=o((function(e){return{type:"messageFormatPattern",elements:e,location:Fe()}}),"peg$c0"),c=o((function(e){return e.reduce((function(e,t){return e.concat(t)}),[]).join("")}),"peg$c1"),u=o((function(e){return{type:"messageTextElement",value:e,location:Fe()}}),"peg$c2"),d=o((function(e){return e.join("")}),"peg$c3"),m="{",p=Ne("{",!1),h=",",g=Ne(",",!1),f="}",y=Ne("}",!1),v=o((function(e,t){return{type:"argumentElement",id:e,format:t&&t[2],location:Fe()}}),"peg$c10"),b="number",w=Ne("number",!1),D="date",E=Ne("date",!1),T="time",S=Ne("time",!1),C=o((function(e,t){return{type:e+"Format",style:t&&t[2],location:Fe()}}),"peg$c17"),k="plural",x=Ne("plural",!1),A=o((function(e){return{type:e.type,ordinal:!1,offset:e.offset||0,options:e.options,location:Fe()}}),"peg$c20"),_="selectordinal",R=Ne("selectordinal",!1),F=o((function(e){return{type:e.type,ordinal:!0,offset:e.offset||0,options:e.options,location:Fe()}}),"peg$c23"),N="select",I=Ne("select",!1),M=o((function(e){return{type:"selectFormat",options:e,location:Fe()}}),"peg$c26"),P="=",L=Ne("=",!1),O=o((function(e,t){return{type:"optionalFormatPattern",selector:e,value:t,location:Fe()}}),"peg$c29"),j="offset:",U=Ne("offset:",!1),B=o((function(e){return e}),"peg$c32"),q=o((function(e,t){return{type:"pluralFormat",offset:e,options:t,location:Fe()}}),"peg$c33"),z=Le("whitespace"),V=/^[ \t\n\r]/,W=Ie([" ","\t","\n","\r"],!1,!1),H=Le("optionalWhitespace"),G=/^[0-9]/,$=Ie([["0","9"]],!1,!1),K=/^[0-9a-f]/i,Y=Ie([["0","9"],["a","f"]],!1,!0),J="0",Z=Ne("0",!1),X=/^[1-9]/,Q=Ie([["1","9"]],!1,!1),ee=o((function(e){return parseInt(e,10)}),"peg$c46"),te="'",ae=Ne("'",!1),ne=/^[ \t\n\r,.+={}#]/,re=Ie([" ","\t","\n","\r",",",".","+","=","{","}","#"],!1,!1),ie={type:"any"},oe=o((function(e){return e}),"peg$c52"),se=o((function(e){return e}),"peg$c53"),le=/^[^{}\\\0-\x1F\x7F \t\n\r]/,ce=Ie(["{","}","\\",["\0",""],""," ","\t","\n","\r"],!0,!1),ue="\\\\",de=Ne("\\\\",!1),me=o((function(){return"\\"}),"peg$c58"),pe="\\#",he=Ne("\\#",!1),ge=o((function(){return"\\#"}),"peg$c61"),fe="\\{",ye=Ne("\\{",!1),ve=o((function(){return"{"}),"peg$c64"),be="\\}",we=Ne("\\}",!1),De=o((function(){return"}"}),"peg$c67"),Ee="\\u",Te=Ne("\\u",!1),Se=o((function(e){return String.fromCharCode(parseInt(e,16))}),"peg$c70"),Ce=0,ke=0,xe=[{line:1,column:1}],Ae=0,_e=[],Re=0;if("startRule"in a){if(!(a.startRule in i))throw new Error("Can't start parsing from rule \""+a.startRule+'".');s=i[a.startRule]}function Fe(){return je(ke,Ce)}function Ne(e,t){return{type:"literal",text:e,ignoreCase:t}}function Ie(e,t,a){return{type:"class",parts:e,inverted:t,ignoreCase:a}}function Me(){return{type:"any"}}function Pe(){return{type:"end"}}function Le(e){return{type:"other",description:e}}function Oe(t){var a,n=xe[t];if(n)return n;for(a=t-1;!xe[a];)a--;for(n={line:(n=xe[a]).line,column:n.column};a<t;)10===e.charCodeAt(a)?(n.line++,n.column=1):n.column++,a++;return xe[t]=n,n}function je(e,t){var a=Oe(e),n=Oe(t);return{start:{offset:e,line:a.line,column:a.column},end:{offset:t,line:n.line,column:n.column}}}function Ue(e){Ce<Ae||(Ce>Ae&&(Ae=Ce,_e=[]),_e.push(e))}function Be(e,a){return new t(e,null,null,a)}function qe(e,a,n){return new t(t.buildMessage(e,a),e,a,n)}function ze(){return Ve()}function Ve(){var e,t,a;for(e=Ce,t=[],a=We();a!==r;)t.push(a),a=We();return t!==r&&(ke=e,t=l(t)),e=t}function We(){var e;return(e=Ge())===r&&(e=Ke()),e}function He(){var t,a,n,i,o,s;if(t=Ce,a=[],n=Ce,(i=it())!==r?(o=pt())!==r?(s=it())!==r?n=i=[i,o,s]:(Ce=n,n=r):(Ce=n,n=r):(Ce=n,n=r),n!==r)for(;n!==r;)a.push(n),n=Ce,(i=it())!==r?(o=pt())!==r?(s=it())!==r?n=i=[i,o,s]:(Ce=n,n=r):(Ce=n,n=r):(Ce=n,n=r);else a=r;return a!==r&&(ke=t,a=c(a)),(t=a)===r&&(t=Ce,t=(a=rt())!==r?e.substring(t,Ce):a),t}function Ge(){var e,t;return e=Ce,(t=He())!==r&&(ke=e,t=u(t)),e=t}function $e(){var e,t,a;if((e=lt())===r){for(e=Ce,t=[],a=ct();a!==r;)t.push(a),a=ct();t!==r&&(ke=e,t=d(t)),e=t}return e}function Ke(){var t,a,n,i,o,s,l;return t=Ce,123===e.charCodeAt(Ce)?(a=m,Ce++):(a=r,0===Re&&Ue(p)),a!==r?it()!==r?(n=$e())!==r?it()!==r?(i=Ce,44===e.charCodeAt(Ce)?(o=h,Ce++):(o=r,0===Re&&Ue(g)),o!==r?(s=it())!==r?(l=Ye())!==r?i=o=[o,s,l]:(Ce=i,i=r):(Ce=i,i=r):(Ce=i,i=r),i===r&&(i=null),i!==r?(o=it())!==r?(125===e.charCodeAt(Ce)?(s=f,Ce++):(s=r,0===Re&&Ue(y)),s!==r?(ke=t,t=a=v(n,i)):(Ce=t,t=r)):(Ce=t,t=r):(Ce=t,t=r)):(Ce=t,t=r):(Ce=t,t=r):(Ce=t,t=r):(Ce=t,t=r),t}function Ye(){var e;return(e=Je())===r&&((e=Ze())===r&&((e=Xe())===r&&(e=Qe()))),e}function Je(){var t,a,n,i,o,s;return t=Ce,e.substr(Ce,6)===b?(a=b,Ce+=6):(a=r,0===Re&&Ue(w)),a===r&&(e.substr(Ce,4)===D?(a=D,Ce+=4):(a=r,0===Re&&Ue(E)),a===r&&(e.substr(Ce,4)===T?(a=T,Ce+=4):(a=r,0===Re&&Ue(S)))),a!==r?it()!==r?(n=Ce,44===e.charCodeAt(Ce)?(i=h,Ce++):(i=r,0===Re&&Ue(g)),i!==r?(o=it())!==r?(s=pt())!==r?n=i=[i,o,s]:(Ce=n,n=r):(Ce=n,n=r):(Ce=n,n=r),n===r&&(n=null),n!==r?(ke=t,t=a=C(a,n)):(Ce=t,t=r)):(Ce=t,t=r):(Ce=t,t=r),t}function Ze(){var t,a,n,i;return t=Ce,e.substr(Ce,6)===k?(a=k,Ce+=6):(a=r,0===Re&&Ue(x)),a!==r?it()!==r?(44===e.charCodeAt(Ce)?(n=h,Ce++):(n=r,0===Re&&Ue(g)),n!==r?it()!==r?(i=nt())!==r?(ke=t,t=a=A(i)):(Ce=t,t=r):(Ce=t,t=r):(Ce=t,t=r)):(Ce=t,t=r):(Ce=t,t=r),t}function Xe(){var t,a,n,i;return t=Ce,e.substr(Ce,13)===_?(a=_,Ce+=13):(a=r,0===Re&&Ue(R)),a!==r?it()!==r?(44===e.charCodeAt(Ce)?(n=h,Ce++):(n=r,0===Re&&Ue(g)),n!==r?it()!==r?(i=nt())!==r?(ke=t,t=a=F(i)):(Ce=t,t=r):(Ce=t,t=r):(Ce=t,t=r)):(Ce=t,t=r):(Ce=t,t=r),t}function Qe(){var t,a,n,i,o;if(t=Ce,e.substr(Ce,6)===N?(a=N,Ce+=6):(a=r,0===Re&&Ue(I)),a!==r)if(it()!==r)if(44===e.charCodeAt(Ce)?(n=h,Ce++):(n=r,0===Re&&Ue(g)),n!==r)if(it()!==r){if(i=[],(o=tt())!==r)for(;o!==r;)i.push(o),o=tt();else i=r;i!==r?(ke=t,t=a=M(i)):(Ce=t,t=r)}else Ce=t,t=r;else Ce=t,t=r;else Ce=t,t=r;else Ce=t,t=r;return t}function et(){var t,a,n,i;return t=Ce,a=Ce,61===e.charCodeAt(Ce)?(n=P,Ce++):(n=r,0===Re&&Ue(L)),n!==r?(i=lt())!==r?a=n=[n,i]:(Ce=a,a=r):(Ce=a,a=r),(t=a!==r?e.substring(t,Ce):a)===r&&(t=pt()),t}function tt(){var t,a,n,i,o;return t=Ce,it()!==r?(a=et())!==r?it()!==r?(123===e.charCodeAt(Ce)?(n=m,Ce++):(n=r,0===Re&&Ue(p)),n!==r?(i=Ve())!==r?(125===e.charCodeAt(Ce)?(o=f,Ce++):(o=r,0===Re&&Ue(y)),o!==r?(ke=t,t=O(a,i)):(Ce=t,t=r)):(Ce=t,t=r):(Ce=t,t=r)):(Ce=t,t=r):(Ce=t,t=r):(Ce=t,t=r),t}function at(){var t,a,n;return t=Ce,e.substr(Ce,7)===j?(a=j,Ce+=7):(a=r,0===Re&&Ue(U)),a!==r?it()!==r?(n=lt())!==r?(ke=t,t=a=B(n)):(Ce=t,t=r):(Ce=t,t=r):(Ce=t,t=r),t}function nt(){var e,t,a,n;if(e=Ce,(t=at())===r&&(t=null),t!==r)if(it()!==r){if(a=[],(n=tt())!==r)for(;n!==r;)a.push(n),n=tt();else a=r;a!==r?(ke=e,e=t=q(t,a)):(Ce=e,e=r)}else Ce=e,e=r;else Ce=e,e=r;return e}function rt(){var t,a;if(Re++,t=[],V.test(e.charAt(Ce))?(a=e.charAt(Ce),Ce++):(a=r,0===Re&&Ue(W)),a!==r)for(;a!==r;)t.push(a),V.test(e.charAt(Ce))?(a=e.charAt(Ce),Ce++):(a=r,0===Re&&Ue(W));else t=r;return Re--,t===r&&(a=r,0===Re&&Ue(z)),t}function it(){var t,a,n;for(Re++,t=Ce,a=[],n=rt();n!==r;)a.push(n),n=rt();return t=a!==r?e.substring(t,Ce):a,Re--,t===r&&(a=r,0===Re&&Ue(H)),t}function ot(){var t;return G.test(e.charAt(Ce))?(t=e.charAt(Ce),Ce++):(t=r,0===Re&&Ue($)),t}function st(){var t;return K.test(e.charAt(Ce))?(t=e.charAt(Ce),Ce++):(t=r,0===Re&&Ue(Y)),t}function lt(){var t,a,n,i,o,s;if(t=Ce,48===e.charCodeAt(Ce)?(a=J,Ce++):(a=r,0===Re&&Ue(Z)),a===r){if(a=Ce,n=Ce,X.test(e.charAt(Ce))?(i=e.charAt(Ce),Ce++):(i=r,0===Re&&Ue(Q)),i!==r){for(o=[],s=ot();s!==r;)o.push(s),s=ot();o!==r?n=i=[i,o]:(Ce=n,n=r)}else Ce=n,n=r;a=n!==r?e.substring(a,Ce):n}return a!==r&&(ke=t,a=ee(a)),t=a}function ct(){var t,a,n;return t=Ce,a=Ce,Re++,39===e.charCodeAt(Ce)?(n=te,Ce++):(n=r,0===Re&&Ue(ae)),n===r&&(ne.test(e.charAt(Ce))?(n=e.charAt(Ce),Ce++):(n=r,0===Re&&Ue(re))),Re--,n===r?a=void 0:(Ce=a,a=r),a!==r?(e.length>Ce?(n=e.charAt(Ce),Ce++):(n=r,0===Re&&Ue(ie)),n!==r?(ke=t,t=a=oe(n)):(Ce=t,t=r)):(Ce=t,t=r),t===r&&(t=Ce,39===e.charCodeAt(Ce)?(a=te,Ce++):(a=r,0===Re&&Ue(ae)),a!==r?(n=dt())!==r?(ke=t,t=a=se(n)):(Ce=t,t=r):(Ce=t,t=r)),t}function ut(){var t;return 39===e.charCodeAt(Ce)?(t=te,Ce++):(t=r,0===Re&&Ue(ae)),t}function dt(){var t;return ne.test(e.charAt(Ce))?(t=e.charAt(Ce),Ce++):(t=r,0===Re&&Ue(re)),t===r&&(t=ut()),t}function mt(){var t,a,n,i,o,s,l,c;return t=Ce,39===e.charCodeAt(Ce)?(a=te,Ce++):(a=r,0===Re&&Ue(ae)),a!==r?(n=ut())!==r?(ke=t,t=a=se(n)):(Ce=t,t=r):(Ce=t,t=r),t===r&&(le.test(e.charAt(Ce))?(t=e.charAt(Ce),Ce++):(t=r,0===Re&&Ue(ce)),t===r&&(t=Ce,e.substr(Ce,2)===ue?(a=ue,Ce+=2):(a=r,0===Re&&Ue(de)),a!==r&&(ke=t,a=me()),(t=a)===r&&(t=Ce,e.substr(Ce,2)===pe?(a=pe,Ce+=2):(a=r,0===Re&&Ue(he)),a!==r&&(ke=t,a=ge()),(t=a)===r&&(t=Ce,e.substr(Ce,2)===fe?(a=fe,Ce+=2):(a=r,0===Re&&Ue(ye)),a!==r&&(ke=t,a=ve()),(t=a)===r&&(t=Ce,e.substr(Ce,2)===be?(a=be,Ce+=2):(a=r,0===Re&&Ue(we)),a!==r&&(ke=t,a=De()),(t=a)===r&&(t=Ce,e.substr(Ce,2)===Ee?(a=Ee,Ce+=2):(a=r,0===Re&&Ue(Te)),a!==r?(n=Ce,i=Ce,(o=st())!==r?(s=st())!==r?(l=st())!==r?(c=st())!==r?i=o=[o,s,l,c]:(Ce=i,i=r):(Ce=i,i=r):(Ce=i,i=r):(Ce=i,i=r),(n=i!==r?e.substring(n,Ce):i)!==r?(ke=t,t=a=Se(n)):(Ce=t,t=r)):(Ce=t,t=r))))))),t}function pt(){var e,t,a;if(e=Ce,t=[],(a=mt())!==r)for(;a!==r;)t.push(a),a=mt();else t=r;return t!==r&&(ke=e,t=d(t)),e=t}if(o((function(){return e.substring(ke,Ce)}),"text"),o(Fe,"location"),o((function(t,a){throw a=void 0!==a?a:je(ke,Ce),qe([Le(t)],e.substring(ke,Ce),a)}),"expected"),o((function(e,t){throw Be(e,t=void 0!==t?t:je(ke,Ce))}),"error"),o(Ne,"peg$literalExpectation"),o(Ie,"peg$classExpectation"),o(Me,"peg$anyExpectation"),o(Pe,"peg$endExpectation"),o(Le,"peg$otherExpectation"),o(Oe,"peg$computePosDetails"),o(je,"peg$computeLocation"),o(Ue,"peg$fail"),o(Be,"peg$buildSimpleError"),o(qe,"peg$buildStructuredError"),o(ze,"peg$parsestart"),o(Ve,"peg$parsemessageFormatPattern"),o(We,"peg$parsemessageFormatElement"),o(He,"peg$parsemessageText"),o(Ge,"peg$parsemessageTextElement"),o($e,"peg$parseargument"),o(Ke,"peg$parseargumentElement"),o(Ye,"peg$parseelementFormat"),o(Je,"peg$parsesimpleFormat"),o(Ze,"peg$parsepluralFormat"),o(Xe,"peg$parseselectOrdinalFormat"),o(Qe,"peg$parseselectFormat"),o(et,"peg$parseselector"),o(tt,"peg$parseoptionalFormatPattern"),o(at,"peg$parseoffset"),o(nt,"peg$parsepluralStyle"),o(rt,"peg$parsews"),o(it,"peg$parse_"),o(ot,"peg$parsedigit"),o(st,"peg$parsehexDigit"),o(lt,"peg$parsenumber"),o(ct,"peg$parsequoteEscapedChar"),o(ut,"peg$parseapostrophe"),o(dt,"peg$parseescape"),o(mt,"peg$parsechar"),o(pt,"peg$parsechars"),(n=s())!==r&&Ce===e.length)return n;throw n!==r&&Ce<e.length&&Ue({type:"end"}),qe(_e,Ae<e.length?e.charAt(Ae):null,Ae<e.length?je(Ae,Ae+1):je(Ae,Ae))}return o(e,"peg$subclass"),o(t,"peg$SyntaxError"),e(t,Error),t.buildMessage=function(e,t){var a={literal:function(e){return'"'+r(e.text)+'"'},class:function(e){var t,a="";for(t=0;t<e.parts.length;t++)a+=e.parts[t]instanceof Array?i(e.parts[t][0])+"-"+i(e.parts[t][1]):i(e.parts[t]);return"["+(e.inverted?"^":"")+a+"]"},any:function(e){return"any character"},end:function(e){return"end of input"},other:function(e){return e.description}};function n(e){return e.charCodeAt(0).toString(16).toUpperCase()}function r(e){return e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,(function(e){return"\\x0"+n(e)})).replace(/[\x10-\x1F\x7F-\x9F]/g,(function(e){return"\\x"+n(e)}))}function i(e){return e.replace(/\\/g,"\\\\").replace(/\]/g,"\\]").replace(/\^/g,"\\^").replace(/-/g,"\\-").replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,(function(e){return"\\x0"+n(e)})).replace(/[\x10-\x1F\x7F-\x9F]/g,(function(e){return"\\x"+n(e)}))}function s(e){return a[e.type](e)}function l(e){var t,a,n=new Array(e.length);for(t=0;t<e.length;t++)n[t]=s(e[t]);if(n.sort(),n.length>0){for(t=1,a=1;t<n.length;t++)n[t-1]!==n[t]&&(n[a]=n[t],a++);n.length=a}switch(n.length){case 1:return n[0];case 2:return n[0]+" or "+n[1];default:return n.slice(0,-1).join(", ")+", or "+n[n.length-1]}}function c(e){return e?'"'+r(e)+'"':"end of input"}return o(n,"hex"),o(r,"literalEscape"),o(i,"classEscape"),o(s,"describeExpectation"),o(l,"describeExpected"),o(c,"describeFound"),"Expected "+l(e)+" but "+c(t)+" found."},o(a,"peg$parse"),{SyntaxError:t,parse:a}}()}));function Rr(e){return!!e.options}var Fr,Nr,Ir,Mr,Pr,Lr,Or,jr,Ur=s((()=>{var e;J(),e=o((function(t,a){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var a in t)t.hasOwnProperty(a)&&(e[a]=t[a])})(t,a)}),"extendStatics"),Fr=function(t,a){function n(){this.constructor=t}e(t,a),o(n,"__"),t.prototype=null===a?Object.create(a):(n.prototype=a.prototype,new n)},Nr=function(){function e(e,t,a){this.locales=[],this.formats={number:{},date:{},time:{}},this.pluralNumberFormat=null,this.currentPlural=null,this.pluralStack=[],this.locales=e,this.formats=t,this.formatters=a}return o(e,"Compiler"),e.prototype.compile=function(e){return this.pluralStack=[],this.currentPlural=null,this.pluralNumberFormat=null,this.compileMessage(e)},e.prototype.compileMessage=function(e){var t=this;if(!e||"messageFormatPattern"!==e.type)throw new Error('Message AST is not of type: "messageFormatPattern"');var a=e.elements,n=a.filter((function(e){return"messageTextElement"===e.type||"argumentElement"===e.type})).map((function(e){return"messageTextElement"===e.type?t.compileMessageText(e):t.compileArgument(e)}));if(n.length!==a.length)throw new Error("Message element does not have a valid type");return n},e.prototype.compileMessageText=function(e){return this.currentPlural&&/(^|[^\\])#/g.test(e.value)?(this.pluralNumberFormat||(this.pluralNumberFormat=new Intl.NumberFormat(this.locales)),new Or(this.currentPlural.id,this.currentPlural.format.offset,this.pluralNumberFormat,e.value)):e.value.replace(/\\#/g,"#")},e.prototype.compileArgument=function(e){var t=e.format,a=e.id,n=this.formatters;if(!t)return new Pr(a);var r=this.formats,i=this.locales;switch(t.type){case"numberFormat":return{id:a,format:n.getNumberFormat(i,r.number[t.style]).format};case"dateFormat":return{id:a,format:n.getDateTimeFormat(i,r.date[t.style]).format};case"timeFormat":return{id:a,format:n.getDateTimeFormat(i,r.time[t.style]).format};case"pluralFormat":return new Lr(a,t.offset,this.compileOptions(e),n.getPluralRules(i,{type:t.ordinal?"ordinal":"cardinal"}));case"selectFormat":return new jr(a,this.compileOptions(e));default:throw new Error("Message element does not have a valid format type")}},e.prototype.compileOptions=function(e){var t=this,a=e.format,n=a.options;this.pluralStack.push(this.currentPlural),this.currentPlural="pluralFormat"===a.type?e:null;var r=n.reduce((function(e,a){return e[a.selector]=t.compileMessage(a.value),e}),{});return this.currentPlural=this.pluralStack.pop(),r},e}(),Ir=Nr,Mr=function(){function e(e){this.id=e}return o(e,"Formatter"),e}(),Pr=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return Fr(t,e),o(t,"StringFormat"),t.prototype.format=function(e){return e||"number"==typeof e?"string"==typeof e?e:String(e):""},t}(Mr),Lr=function(){function e(e,t,a,n){this.id=e,this.offset=t,this.options=a,this.pluralRules=n}return o(e,"PluralFormat"),e.prototype.getOption=function(e){var t=this.options;return t["="+e]||t[this.pluralRules.select(e-this.offset)]||t.other},e}(),Or=function(e){function t(t,a,n,r){var i=e.call(this,t)||this;return i.offset=a,i.numberFormat=n,i.string=r,i}return Fr(t,e),o(t,"PluralOffsetString"),t.prototype.format=function(e){var t=this.numberFormat.format(e-this.offset);return this.string.replace(/(^|[^\\])#/g,"$1"+t).replace(/\\#/g,"#")},t}(Mr),jr=function(){function e(e,t){this.id=e,this.options=t}return o(e,"SelectFormat"),e.prototype.getOption=function(e){var t=this.options;return t[e]||t.other},e}(),o(Rr,"isSelectOrPluralFormat")}));function Br(e){"string"==typeof e&&(e=[e]);try{return Intl.NumberFormat.supportedLocalesOf(e,{localeMatcher:"best fit"})[0]}catch{return Kr.defaultLocale}}function qr(e,t){for(var a="",n=0,r=e;n<r.length;n++){var i=r[n];if("string"!=typeof i){var o=i.id;if(!t||!(o in t))throw new $r("A value must be provided for: "+o,o);var s=t[o];Rr(i)?a+=qr(i.getOption(s),t):a+=i.format(s)}else a+=i}return a}function zr(e,t){return t?Gr({},e||{},t||{},Object.keys(e).reduce((function(a,n){return a[n]=Gr({},e[n],t[n]||{}),a}),{})):e}function Vr(e,t){return t?Object.keys(e).reduce((function(a,n){return a[n]=zr(e[n],t[n]),a}),Gr({},e)):e}function Wr(){return{getNumberFormat:function(){for(var e,t=[],a=0;a<arguments.length;a++)t[a]=arguments[a];return new((e=Intl.NumberFormat).bind.apply(e,[void 0].concat(t)))},getDateTimeFormat:function(){for(var e,t=[],a=0;a<arguments.length;a++)t[a]=arguments[a];return new((e=Intl.DateTimeFormat).bind.apply(e,[void 0].concat(t)))},getPluralRules:function(){for(var e,t=[],a=0;a<arguments.length;a++)t[a]=arguments[a];return new((e=Intl.PluralRules).bind.apply(e,[void 0].concat(t)))}}}var Hr,Gr,$r,Kr,Yr,Jr,Zr,Xr,Qr,ei,ti=s((()=>{var e;J(),Ur(),e=o((function(t,a){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var a in t)t.hasOwnProperty(a)&&(e[a]=t[a])})(t,a)}),"extendStatics"),Hr=function(t,a){function n(){this.constructor=t}e(t,a),o(n,"__"),t.prototype=null===a?Object.create(a):(n.prototype=a.prototype,new n)},Gr=function(){return Gr=Object.assign||function(e){for(var t,a=1,n=arguments.length;a<n;a++)for(var r in t=arguments[a])Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r]);return e},Gr.apply(this,arguments)},o(Br,"resolveLocale"),o(qr,"formatPatterns"),o(zr,"mergeConfig"),o(Vr,"mergeConfigs"),$r=function(e){function t(t,a){var n=e.call(this,t)||this;return n.variableId=a,n}return Hr(t,e),o(t,"FormatError"),t}(Error),o(Wr,"createDefaultFormatters"),Kr=function(){function e(t,a,n,r){var i=this;if(void 0===a&&(a=e.defaultLocale),this.format=function(e){try{return qr(i.pattern,e)}catch(e){throw e.variableId?new Error("The intl string context variable '"+e.variableId+"' was not provided to the string '"+i.message+"'"):e}},"string"==typeof t){if(!e.__parse)throw new TypeError("IntlMessageFormat.__parse must be set to process `message` of type `string`");this.ast=e.__parse(t)}else this.ast=t;if(this.message=t,!this.ast||"messageFormatPattern"!==this.ast.type)throw new TypeError("A message must be provided as a String or AST.");var o=Vr(e.formats,n);this.locale=Br(a||[]);var s=r&&r.formatters||Wr();this.pattern=new Ir(a,o,s).compile(this.ast)}return o(e,"IntlMessageFormat"),e.prototype.resolvedOptions=function(){return{locale:this.locale}},e.prototype.getAst=function(){return this.ast},e.defaultLocale="en",e.__parse=void 0,e.formats={number:{currency:{style:"currency"},percent:{style:"percent"}},date:{short:{month:"numeric",day:"numeric",year:"2-digit"},medium:{month:"short",day:"numeric",year:"numeric"},long:{month:"long",day:"numeric",year:"numeric"},full:{weekday:"long",month:"long",day:"numeric",year:"numeric"}},time:{short:{hour:"numeric",minute:"numeric"},medium:{hour:"numeric",minute:"numeric",second:"numeric"},long:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"},full:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"}}},e}(),Yr=Kr})),ai=s((()=>{J(),_r(),ti(),ti(),Yr.__parse=Sr.parse,Jr=Yr})),ni=s((()=>{J(),Zr=o((()=>({resolve(){throw new Error("createRequire.resolve is not supported in bundled Lighthouse")}})),"createRequire")})),ri=s((()=>{J(),Xr=globalThis.URL,Qr=o((e=>e),"fileURLToPath"),ei={URL:Xr,fileURLToPath:Qr}}));function ii(e){return ei.fileURLToPath(e.url)}var oi=s((()=>{J(),ni(),ri(),ka(),o(ii,"getModulePath")}));function si(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)}function li(e){return"object"==typeof e&&null!==e}var ci,ui=s((()=>{J(),o(si,"isObjectOfUnknownValues"),o(li,"isObjectOrArrayOfUnknownValues")})),di=s((()=>{J(),ci={}}));function mi(e,t=new Map){for(let a of e)if("argumentElement"===a.type&&(t.set(a.id,a),a.format&&"pluralFormat"===a.format.type))for(let e of a.format.options)mi(e.value.elements,t);return t}function pi(e,t={},a){let n=[...mi(e.getAst().elements).values()],r={};for(let{id:e,format:i}of n){if(e&&!(e in t))throw new Error(`ICU Message "${a}" contains a value reference ("${e}") that wasn't provided`);let n=t[e];if(i&&"numberFormat"===i.type){if("number"!=typeof n)throw new Error(`ICU Message "${a}" contains a numeric reference ("${e}") but provided value was not a number`);"milliseconds"===i.style?r[e]=10*Math.round(n/10):"seconds"===i.style&&"timeInMs"===e?r[e]=Math.round(n/100)/10:"bytes"===i.style?r[e]=n/1024:r[e]=n}else r[e]=n}for(let e of Object.keys(t))if(!(e in r)){if("errorCode"===e){r.errorCode=t.errorCode;continue}throw new Error(`Provided value "${e}" does not match any placeholder in ICU message "${a}"`)}return r}function hi(e,t,a){if(!e.includes("{")&&void 0===t)return e;let n=new Jr(e,"en-XA"===a||"en-XL"===a?"de-DE":a,Ri),r=pi(n,t,e);return n.format(r)}function gi(e,t){let a=Di(t)[e.i18nId];return a?hi(a.message,e.values,t):e.formattedDefault}function fi(e){let t=Di(e),a=Object.keys(t).filter((e=>e.startsWith("report/renderer/report-utils.js"))),n={};for(let e of a){let{filename:a,key:r}=Ci(e);if(!a.endsWith("report-utils.js"))throw new Error(`Unexpected message: ${e}`);n[r]=t[e].message}return n}function yi(e){if(!si(e))return!1;let{i18nId:t,values:a,formattedDefault:n}=e;if("string"!=typeof t||"string"!=typeof n)return!1;if(void 0!==a){if(!si(a))return!1;for(let e of Object.values(a))if("string"!=typeof e&&"number"!=typeof e)return!1}return _i.test(t)}function vi(e,t){if(yi(e))return gi(e,t);if("string"==typeof e)return e;throw new Error("Attempted to format invalid icuMessage type")}function bi(e){let t="";for(let a of e)if(/^[a-z]+$/i.test(a))t.length&&(t+="."),t+=a;else{if(/]|"|'|\s/.test(a))throw new Error(`Cannot handle "${a}" in i18n`);t+=`[${a}]`}return t}function wi(e,t){function a(e,n,r=[]){if(li(e))for(let[i,o]of Object.entries(e)){let s=r.concat([i]);if(yi(o)){let a=vi(o,t),r=n[o.i18nId]||[],l=bi(s);r.push(o.values?{values:o.values,path:l}:l),e[i]=a,n[o.i18nId]=r}else a(o,n,s)}}o(a,"replaceInObject");let n={};return a(e,n),n}function Di(e){let t=ki[e];if(!t){if(e===xi)return{};throw new Error(`Unsupported locale '${e}'`)}return t}function Ei(){return Ai}function Ti(){return[...new Set([...Object.keys(ki),xi])].sort()}function Si(e,t){ki[e]=t}function Ci(e){if(!_i.test(e))throw Error(`"${e}" does not appear to be a valid ICU message id`);let[t,a]=e.split(" | ");return{filename:t,key:a}}var ki,xi,Ai,_i,Ri,Fi,Ni,Ii,Mi=s((()=>{J(),ua(),ai(),oi(),ui(),di(),ki=ci,xi="en-US",Ai=["ar-XB.json","ar.json","bg.json","ca.json","cs.json","da.json","de.json","el.json","en-GB.json","en-US.ctc.json","en-US.json","en-XA.json","en-XL.ctc.json","en-XL.json","es-419.json","es.json","fi.json","fil.json","fr.json","he.json","hi.json","hr.json","hu.json","id.json","it.json","ja.json","ko.json","lt.json","lv.json","nl.json","no.json","pl.json","pt-PT.json","pt.json","ro.json","ru.json","sk.json","sl.json","sr-Latn.json","sr.json","sv.json","ta.json","te.json","th.json","tr.json","uk.json","vi.json","zh-HK.json","zh-TW.json","zh.json"].filter((e=>e.endsWith(".json")&&!e.endsWith(".ctc.json"))).map((e=>e.replace(".json",""))).sort(),_i=/ | [^\s]+$/,Ri={number:{bytes:{maximumFractionDigits:0},milliseconds:{maximumFractionDigits:0},seconds:{minimumFractionDigits:1,maximumFractionDigits:1},extendedPercent:{maximumFractionDigits:2,style:"percent"}}},o(mi,"collectAllCustomElementsFromICU"),o(pi,"_preformatValues"),o(hi,"formatMessage"),o(gi,"_localizeIcuMessage"),o(fi,"getRendererFormattedStrings"),o(yi,"isIcuMessage"),o(vi,"getFormatted"),o(bi,"_formatPathAsString"),o(wi,"replaceIcuMessages"),o(Di,"_getLocaleMessages"),o(Ei,"getCanonicalLocales"),o(Ti,"getAvailableLocales"),o(Si,"registerLocaleData"),o(Ci,"getIcuMessageIdParts")})),Pi=l(((e,t)=>{J();t.exports={id:"amp",title:"AMP",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 256"><path fill="%230379c4" fill-rule="evenodd" d="m171.887 116.28-53.696 89.36h-9.728l9.617-58.227-30.2.047a4.852 4.852 0 0 1-4.855-4.855c0-1.152 1.07-3.102 1.07-3.102l53.52-89.254 9.9.043-9.86 58.317 30.413-.043a4.852 4.852 0 0 1 4.855 4.855c0 1.088-.427 2.044-1.033 2.854l.004.004zM128 0C57.306 0 0 57.3 0 128s57.306 128 128 128 128-57.306 128-128S198.7 0 128 0z"/></svg>',UIStrings:{"modern-image-formats":"Consider displaying all [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) components in WebP formats while specifying an appropriate fallback for other browsers. [Learn more](https://amp.dev/documentation/components/amp-img/#example:-specifying-a-fallback-image).","offscreen-images":"Ensure that you are using [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) for images to automatically lazy-load. [Learn more](https://amp.dev/documentation/guides-and-tutorials/develop/media_iframes_3p/?format=websites#images).","render-blocking-resources":"Use tools such as [AMP Optimizer](https://github.com/ampproject/amp-toolbox/tree/master/packages/optimizer) to [server-side render AMP layouts](https://amp.dev/documentation/guides-and-tutorials/optimize-and-measure/server-side-rendering/).","unminified-css":"Refer to the [AMP documentation](https://amp.dev/documentation/guides-and-tutorials/develop/style_and_layout/style_pages/) to ensure all styles are supported.","efficient-animated-content":"For animated content, use [`amp-anim`](https://amp.dev/documentation/components/amp-anim/) to minimize CPU usage when the content is offscreen.","uses-responsive-images":"The [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) component supports the [`srcset`](https://web.dev/use-srcset-to-automatically-choose-the-right-image/) attribute to specify which image assets to use based on the screen size. [Learn more](https://amp.dev/documentation/guides-and-tutorials/develop/style_and_layout/art_direction/)."}}})),Li=l(((e,t)=>{J();t.exports={id:"angular",title:"Angular",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 250 250"><path fill="%23dd0031" d="M125 30 31.9 63.2l14.2 123.1L125 230l78.9-43.7 14.2-123.1z"/><path fill="%23c3002f" d="M125 30v22.2-.1V230l78.9-43.7 14.2-123.1L125 30z"/><path fill="%23fff" d="M125 52.1 66.8 182.6h21.7l11.7-29.2h49.4l11.7 29.2H183L125 52.1zm17 83.3h-34l17-40.9 17 40.9z"/></svg>',UIStrings:{"total-byte-weight":"Apply [route-level code splitting](https://web.dev/route-level-code-splitting-in-angular/) to minimize the size of your JavaScript bundles. Also, consider precaching assets with the [Angular service worker](https://web.dev/precaching-with-the-angular-service-worker/).","unminified-warning":"If you are using Angular CLI, ensure that builds are generated in production mode. [Learn more](https://angular.io/guide/deployment#enable-runtime-production-mode).","unused-javascript":"If you are using Angular CLI, include source maps in your production build to inspect your bundles. [Learn more](https://angular.io/guide/deployment#inspect-the-bundles).","uses-responsive-images":"Consider using the `BreakpointObserver` utility in the Component Dev Kit (CDK) to manage image breakpoints. [Learn more](https://material.angular.io/cdk/layout/overview).","uses-rel-preload":"Preload routes ahead of time to speed up navigation. [Learn more](https://web.dev/route-preloading-in-angular/).","dom-size":"Consider virtual scrolling with the Component Dev Kit (CDK) if very large lists are being rendered. [Learn more](https://web.dev/virtualize-lists-with-angular-cdk/)."}}})),Oi=l(((e,t)=>{J();t.exports={id:"drupal",title:"Drupal",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 186.525 243.713"><path fill="%23009cde" d="M131.64 51.91C114.491 34.769 98.13 18.429 93.26 0c-4.87 18.429-21.234 34.769-38.38 51.91C29.16 77.613 0 106.743 0 150.434a93.263 93.263 0 1 0 186.525 0c0-43.688-29.158-72.821-54.885-98.524m-92 120.256c-5.719-.194-26.824-36.571 12.329-75.303l25.909 28.3a2.215 2.215 0 0 1-.173 3.306c-6.183 6.34-32.534 32.765-35.81 41.902-.675 1.886-1.663 1.815-2.256 1.795m53.624 47.943a32.075 32.075 0 0 1-32.076-32.075 33.423 33.423 0 0 1 7.995-21.187c5.784-7.072 24.077-26.963 24.077-26.963s18.012 20.183 24.033 26.896a31.368 31.368 0 0 1 8.046 21.254 32.076 32.076 0 0 1-32.075 32.075m61.392-52.015c-.691 1.512-2.26 4.036-4.376 4.113-3.773.138-4.176-1.796-6.965-5.923-6.122-9.06-59.551-64.9-69.545-75.699-8.79-9.498-1.238-16.195 2.266-19.704 4.395-4.403 17.224-17.225 17.224-17.225s38.255 36.296 54.19 61.096 10.444 46.26 7.206 53.342"/></svg>',UIStrings:{"unused-css-rules":"Consider removing unused CSS rules and only attach the needed Drupal libraries to the relevant page or component in a page. See the [Drupal documentation link](https://www.drupal.org/docs/8/creating-custom-modules/adding-stylesheets-css-and-javascript-js-to-a-drupal-8-module#library) for details. To identify attached libraries that are adding extraneous CSS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/module responsible from the URL of the stylesheet when CSS aggregation is disabled in your Drupal site. Look out for themes/modules that have many stylesheets in the list which have a lot of red in code coverage. A theme/module should only enqueue a stylesheet if it is actually used on the page.","unused-javascript":"Consider removing unused JavaScript assets and only attach the needed Drupal libraries to the relevant page or component in a page. See the [Drupal documentation link](https://www.drupal.org/docs/8/creating-custom-modules/adding-stylesheets-css-and-javascript-js-to-a-drupal-8-module#library) for details. To identify attached libraries that are adding extraneous JavaScript, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/module responsible from the URL of the script when JavaScript aggregation is disabled in your Drupal site. Look out for themes/modules that have many scripts in the list which have a lot of red in code coverage. A theme/module should only enqueue a script if it is actually used on the page.","modern-image-formats":"Consider configuring [WebP image formats with a Convert image style](https://www.drupal.org/docs/core-modules-and-themes/core-modules/image-module/working-with-images#styles) on your site.","offscreen-images":"Install [a Drupal module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A67&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=%22lazy+load%22&solrsort=iss_project_release_usage+desc&op=Search) that can lazy load images. Such modules provide the ability to defer any offscreen images to improve performance.","total-byte-weight":"Consider using [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) to reduce the size of images loaded on your page. If you are using Views to show multiple content items on a page, consider implementing pagination to limit the number of content items shown on a given page.","render-blocking-resources":"Consider using a module to inline critical CSS and JavaScript, and use the defer attribute for non-critical CSS or JavaScript.","unminified-css":'Ensure you have enabled "Aggregate CSS files" in the "Administration » Configuration » Development" page.  Ensure your Drupal site is running at least Drupal 10.1 for improved asset aggregation support.',"unminified-javascript":'Ensure you have enabled "Aggregate JavaScript files" in the "Administration » Configuration » Development" page.  Ensure your Drupal site is running at least Drupal 10.1 for improved asset aggregation support.',"efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.","uses-long-cache-ttl":'Set the "Browser and proxy cache maximum age" in the "Administration » Configuration » Development" page. Read about [Drupal cache and optimizing for performance](https://www.drupal.org/docs/7/managing-site-performance-and-scalability/caching-to-improve-performance/caching-overview#s-drupal-performance-resources).',"uses-optimized-images":"Consider using [a module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A123&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=optimize+images&solrsort=iss_project_release_usage+desc&op=Search) that automatically optimizes and reduces the size of images uploaded through the site while retaining quality. Also, ensure you are using the native [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) provided from Drupal (available in Drupal 8 and above) for all images rendered on the site.","uses-responsive-images":"Ensure that you are using the native [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) provided from Drupal (available in Drupal 8 and above). Use the Responsive Image Styles when rendering image fields through view modes, views, or images uploaded through the WYSIWYG editor.","server-response-time":"Themes, modules, and server specifications all contribute to server response time. Consider finding a more optimized theme, carefully selecting an optimization module, and/or upgrading your server. Your hosting servers should make use of PHP opcode caching, memory-caching to reduce database query times such as Redis or Memcached, as well as optimized application logic to prepare pages faster.","uses-rel-preconnect":"Preconnect or dns-prefetch resource hints can be added by installing and configuring [a module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=dns-prefetch&solrsort=iss_project_release_usage+desc&op=Search) that provides facilities for user agent resource hints.","font-display":"Specify `@font-display` when defining custom fonts in your theme."}}})),ji=l(((e,t)=>{J();t.exports={id:"ezoic",title:"Ezoic",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 82 82"><path fill="%235FA624" fill-rule="evenodd" d="M81.37 48.117C85.301 25.821 70.413 4.56 48.117.63 25.821-3.3 4.56 11.586.63 33.883-3.3 56.178 11.586 77.44 33.883 81.37 56.18 85.301 77.44 70.412 81.37 48.117Zm-8.935-14.17c2.77 12.357-1.942 25.721-12.96 33.436-14.57 10.203-34.656 6.662-44.859-7.909a32.434 32.434 0 0 1-2.869-4.98l28.7-20.097a6.53 6.53 0 1 0-3.744-5.347L9.564 48.054c-2.768-12.359 1.943-25.724 12.96-33.439 14.572-10.203 34.656-6.662 44.86 7.91a32.349 32.349 0 0 1 2.868 4.98L41.554 47.6a6.53 6.53 0 1 0 3.746 5.35l27.136-19.003Z"/></svg>',UIStrings:{"unused-css-rules":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Remove Unused CSS` to help with this issue. It will identify the CSS classes that are actually used on each page of your site, and remove any others to keep the file size small.","modern-image-formats":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Next-Gen Formats` to convert images to WebP.","offscreen-images":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Lazy Load Images` to defer loading off-screen images until they are needed.","render-blocking-resources":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Critical CSS` and `Script Delay` to defer non-critical JS/CSS.","unminified-css":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Minify CSS` to automatically minify your CSS to reduce network payload sizes.","unminified-javascript":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Minify Javascript` to automatically minify your JS to reduce network payload sizes.","uses-long-cache-ttl":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Efficient Static Cache Policy` to set recommended values in the caching header for static assests.","uses-optimized-images":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Next-Gen Formats` to convert images to WebP.","uses-responsive-images":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Resize Images` to resize images to a device appropriate size, reducing network payload sizes.","server-response-time":"Use [Ezoic Cloud Caching](https://pubdash.ezoic.com/speed/caching) to cache your content across our world wide network, improving time to first byte.","uses-rel-preconnect":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Pre-Connect Origins` to automatically add `preconnect` resource hints to establish early connections to important third-party origins.","uses-rel-preload":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Preload Fonts` and `Preload Background Images` to add `preload` links to prioritize fetching resources that are currently requested later in page load.","font-display":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Optimize Fonts` to automatically leverage the `font-display` CSS feature to ensure text is user-visible while webfonts are loading."}}})),Ui=l(((e,t)=>{J();t.exports={id:"gatsby",title:"Gatsby",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 28 28"><circle cx="14" cy="14" r="14" fill="%23639"/><path fill="%23fff" d="M6.2 21.8C4.1 19.7 3 16.9 3 14.2L13.9 25c-2.8-.1-5.6-1.1-7.7-3.2zm10.2 2.9L3.3 11.6C4.4 6.7 8.8 3 14 3c3.7 0 6.9 1.8 8.9 4.5l-1.5 1.3C19.7 6.5 17 5 14 5c-3.9 0-7.2 2.5-8.5 6L17 22.5c2.9-1 5.1-3.5 5.8-6.5H18v-2h7c0 5.2-3.7 9.6-8.6 10.7z"/></svg>',UIStrings:{"unused-css-rules":"Use the `PurgeCSS` `Gatsby` plugin to remove unused rules from stylesheets. [Learn more](https://purgecss.com/plugins/gatsby.html).","modern-image-formats":"Use the `gatsby-plugin-image` component instead of `<img>` to automatically optimize image format. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","offscreen-images":"Use the `gatsby-plugin-image` component instead of `<img>` to automatically lazy-load images. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","render-blocking-resources":"Use the `Gatsby Script API` to defer loading of non-critical third-party scripts. [Learn more](https://www.gatsbyjs.com/docs/reference/built-in-components/gatsby-script/).","unused-javascript":"Use `Webpack Bundle Analyzer` to detect unused JavaScript code. [Learn more](https://www.gatsbyjs.com/plugins/gatsby-plugin-webpack-bundle-analyser-v2/)","uses-long-cache-ttl":"Configure caching for immutable assets. [Learn more](https://www.gatsbyjs.com/docs/how-to/previews-deploys-hosting/caching/).","uses-optimized-images":"Use the `gatsby-plugin-image` component instead of `<img>` to adjust image quality. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","uses-responsive-images":"Use the `gatsby-plugin-image` component to set appropriate `sizes`. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","prioritize-lcp-image":"Use the `gatsby-plugin-image` component and set the `loading` prop to `eager`. [Learn more](https://www.gatsbyjs.com/docs/reference/built-in-components/gatsby-plugin-image#shared-props)."}}})),Bi=l(((e,t)=>{J();t.exports={id:"joomla",title:"Joomla",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMidYMid" viewBox="0 0 256 258"><path fill="%23F9AE41" d="M255.7 35.6a33.7 33.7 0 0 0-67-4.8l-.4-.2c-27.6-12.4-50.8 9.6-50.8 9.6l-61.4 61.7 24.3 23.4 49.4-48.6c23-23 35.6-7.4 35.6-7.4 17.4 14.6.6 32 .6 32l24.9 24c20.3-22 21.5-41.1 15.3-56.3a33.7 33.7 0 0 0 29.5-33.4"/><path fill="%23EE4035" d="m226.5 190.5.2-.3c12.4-27.6-9.6-50.8-9.6-50.8L155.4 78l-23.3 24.3 48.5 49.4c23 23 7.5 35.6 7.5 35.6-14.7 17.4-32 .6-32 .6l-24 24.9c21.9 20.3 41 21.5 56.2 15.3a33.7 33.7 0 1 0 38.2-37.6"/><path fill="%234F91CD" d="m156 133-49.5 48.6c-23 23-35.6 7.4-35.6 7.4-17.4-14.6-.6-32-.6-32l-24.9-24c-20.3 22-21.4 41.1-15.3 56.3a33.7 33.7 0 1 0 37.6 38.2l.3.2c27.6 12.4 50.8-9.6 50.8-9.6l61.4-61.7-24.3-23.4"/><path fill="%237AC043" d="M75.7 106.6c-23-23-7.4-35.6-7.4-35.6 14.6-17.4 32-.6 32-.6l24-24.9c-22-20.3-41-21.5-56.3-15.3a33.7 33.7 0 1 0-38.2 37.6l-.2.3C17.2 95.7 39.2 119 39.2 119l61.7 61.4 23.4-24.3-48.6-49.4"/></svg>',UIStrings:{"unused-css-rules":"Consider reducing, or switching, the number of [Joomla extensions](https://extensions.joomla.org/) loading unused CSS in your page. To identify extensions that are adding extraneous CSS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the stylesheet. Look out for plugins that have many stylesheets in the list which have a lot of red in code coverage. A plugin should only enqueue a stylesheet if it is actually used on the page.","modern-image-formats":"Consider using a [plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=webp) or service that will automatically convert your uploaded images to the optimal formats.","offscreen-images":"Install a [lazy-load Joomla plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=lazy%20loading) that provides the ability to defer any offscreen images, or switch to a template that provides that functionality. Starting with Joomla 4.0, all new images will [automatically](https://github.com/joomla/joomla-cms/pull/30748) get the `loading` attribute from the core.","total-byte-weight":"Consider showing excerpts in your article categories (e.g. via the read more link), reducing the number of articles shown on a given page, breaking your long posts into multiple pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are a number of Joomla plugins that can help you [inline critical assets](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) or [defer less important resources](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance). Beware that optimizations provided by these plugins may break features of your templates or plugins, so you will need to test these thoroughly.","unminified-css":"A number of [Joomla extensions](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) can speed up your site by concatenating, minifying, and compressing your css styles. There are also templates that provide this functionality.","unminified-javascript":"A number of [Joomla extensions](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) can speed up your site by concatenating, minifying, and compressing your scripts. There are also templates that provide this functionality.","efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.","unused-javascript":"Consider reducing, or switching, the number of [Joomla extensions](https://extensions.joomla.org/) loading unused JavaScript in your page. To identify plugins that are adding extraneous JS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the extension responsible from the URL of the script. Look out for extensions that have many scripts in the list which have a lot of red in code coverage. An extension should only enqueue a script if it is actually used on the page.","uses-long-cache-ttl":"Read about [Browser Caching in Joomla](https://docs.joomla.org/Cache).","uses-optimized-images":"Consider using an [image optimization plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) that compresses your images while retaining quality.","uses-text-compression":"You can enable text compression by enabling Gzip Page Compression in Joomla (System > Global configuration > Server).","uses-responsive-images":"Consider using a [responsive images plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=responsive%20images) to use responsive images in your content.","server-response-time":"Templates, extensions, and server specifications all contribute to server response time. Consider finding a more optimized template, carefully selecting an optimization extension, and/or upgrading your server."}}})),qi=l(((e,t)=>{J();var a={"modern-image-formats":"Consider searching the [Magento Marketplace](https://marketplace.magento.com/catalogsearch/result/?q=webp) for a variety of third-party extensions to leverage newer image formats.","offscreen-images":"Consider modifying your product and catalog templates to make use of the web platform's [lazy loading](https://web.dev/native-lazy-loading) feature.","disable-bundling":"Disable Magento's built-in [JavaScript bundling and minification](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/themes/js-bundling.html), and consider using [baler](https://github.com/magento/baler/) instead.","unminified-css":'Enable the "Minify CSS Files" option in your store\'s Developer settings. [Learn more](https://devdocs.magento.com/guides/v2.3/performance-best-practices/configuration.html?itm_source=devdocs&itm_medium=search_page&itm_campaign=federated_search&itm_term=minify%20css%20files).',"unminified-javascript":"Use [Terser](https://www.npmjs.com/package/terser) to minify all JavaScript assets from static content deployment, and disable the built-in minification feature.","unused-javascript":"Disable Magento's built-in [JavaScript bundling](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/themes/js-bundling.html).","uses-optimized-images":"Consider searching the [Magento Marketplace](https://marketplace.magento.com/catalogsearch/result/?q=optimize%20image) for a variety of third party extensions to optimize images.","server-response-time":"Use Magento's [Varnish integration](https://devdocs.magento.com/guides/v2.3/config-guide/varnish/config-varnish.html).","uses-rel-preconnect":"Preconnect or dns-prefetch resource hints can be added by [modifying a themes's layout](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/layouts/xml-manage.html).","uses-rel-preload":"`<link rel=preload>` tags can be added by [modifying a themes's layout](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/layouts/xml-manage.html).","critical-request-chains":"If you are not bundling your JavaScript assets, consider using [baler](https://github.com/magento/baler).","font-display":"Specify `@font-display` when [defining custom fonts](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/css-topics/using-fonts.html)."};t.exports={id:"magento",title:"Magento",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" fill="%23f26322" viewBox="0 0 1000 1000"><path d="M916.9 267.4v465.3l-111.3 67.4V331.4l-1.5-.9-303.9-189-304.6 189.2-1.2.8V799L83.1 732.6V267.4l.7-.4L500.3 10l416 257 .6.4zM560.7 468.5v383.3L500.3 890l-61-38.2V306.7l-136 84.3v476.6l197 122.5 196.4-122.5V391l-136-84.3v161.8z"/></svg>',UIStrings:a}})),zi=l(((e,t)=>{J();t.exports={id:"next.js",title:"Next.js",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 207 124"><path fill="%23000" d="M48.942 32.632h38.96v3.082h-35.39v23.193H85.79v3.082H52.513v25.464h35.794v3.081H48.942V32.632Zm42.45 0h4.139l18.343 25.464 18.749-25.464L158.124.287l-41.896 60.485 21.59 29.762h-4.302l-19.642-27.086L94.15 90.534h-4.22l21.751-29.762-20.29-28.14Zm47.967 3.082v-3.082h44.397v3.082h-20.453v54.82h-3.571v-54.82h-20.373ZM.203 32.632h4.464l61.557 91.671-25.439-33.769L3.936 37.011l-.162 53.523H.203zm183.194 53.891c.738 0 1.276-.563 1.276-1.29 0-.727-.538-1.29-1.276-1.29-.73 0-1.277.563-1.277 1.29 0 .727.547 1.29 1.277 1.29Zm3.509-3.393c0 2.146 1.555 3.549 3.822 3.549 2.414 0 3.874-1.446 3.874-3.956v-8.837h-1.946v8.828c0 1.394-.704 2.138-1.946 2.138-1.112 0-1.867-.692-1.893-1.722h-1.911Zm10.24-.113c.14 2.233 2.007 3.662 4.787 3.662 2.97 0 4.83-1.498 4.83-3.887 0-1.878-1.06-2.917-3.632-3.514l-1.38-.338c-1.634-.38-2.294-.891-2.294-1.783 0-1.125 1.025-1.86 2.563-1.86 1.459 0 2.466.718 2.649 1.869h1.893c-.113-2.103-1.971-3.583-4.516-3.583-2.737 0-4.56 1.48-4.56 3.704 0 1.835 1.033 2.926 3.3 3.454l1.616.39c1.659.389 2.388.96 2.388 1.912 0 1.108-1.146 1.913-2.71 1.913-1.676 0-2.84-.753-3.005-1.939h-1.928Z"/></svg>',UIStrings:{"unused-css-rules":"Consider setting up `PurgeCSS` in `Next.js` configuration to remove unused rules from stylesheets. [Learn more](https://purgecss.com/guides/next.html).","modern-image-formats":"Use the `next/image` component instead of `<img>` to automatically optimize image format. [Learn more](https://nextjs.org/docs/basic-features/image-optimization).","offscreen-images":"Use the `next/image` component instead of `<img>` to automatically lazy-load images. [Learn more](https://nextjs.org/docs/basic-features/image-optimization).","render-blocking-resources":"Use the `next/script` component to defer loading of non-critical third-party scripts. [Learn more](https://nextjs.org/docs/basic-features/script).","unused-javascript":"Use `Webpack Bundle Analyzer` to detect unused JavaScript code. [Learn more](https://github.com/vercel/next.js/tree/canary/packages/next-bundle-analyzer)","uses-long-cache-ttl":"Configure caching for immutable assets and `Server-side Rendered` (SSR) pages. [Learn more](https://nextjs.org/docs/going-to-production#caching).","uses-optimized-images":"Use the `next/image` component instead of `<img>` to adjust image quality. [Learn more](https://nextjs.org/docs/basic-features/image-optimization).","uses-text-compression":"Enable compression on your Next.js server. [Learn more](https://nextjs.org/docs/api-reference/next.config.js/compression).","uses-responsive-images":"Use the `next/image` component to set the appropriate `sizes`. [Learn more](https://nextjs.org/docs/api-reference/next/image#sizes).","user-timings":"Consider using `Next.js Analytics` to measure your app's real-world performance. [Learn more](https://nextjs.org/docs/advanced-features/measuring-performance).","prioritize-lcp-image":'Use the `next/image` component and set "priority" to true to preload LCP image. [Learn more](https://nextjs.org/docs/api-reference/next/image#priority).',"unsized-images":"Use the `next/image` component to make sure images are always sized appropriately. [Learn more](https://nextjs.org/docs/api-reference/next/image#width)."}}})),Vi=l(((e,t)=>{J();t.exports={id:"nitropack",title:"NitroPack",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="142" height="54"><g fill="none" fill-rule="evenodd"><g fill="%231B004E"><path d="M19.486 53.24h-3.891L4.682 39.247v13.936H0V32.946h5.444l9.475 12.398V32.946h4.567zM21.346 32.94h4.647v3.57h-4.647v-3.57Zm0 5.477h4.647V53.18h-4.647V38.417ZM40.569 53.183H36c-3.408 0-4.991-1.625-4.991-4.697v-6.22h-3.777V38.42h3.777v-5.474h4.598v5.474h4.958v3.846h-4.958v4.588c0 1.597.477 2.252 2.197 2.252h2.764v4.077ZM46.688 53.183h-4.57V38.42h4.57v2.308c.31-.686 1.351-2.336 4.425-2.336h3.13v4.56h-4.004c-2.593 0-3.55.967-3.55 3.019v7.212ZM70.612 45.802c0 4.56-3.409 7.75-8.01 7.75s-8.006-3.19-8.006-7.75c0-4.56 3.408-7.755 8.006-7.755 4.598 0 8.01 3.195 8.01 7.755Zm-4.599 0c0-2.14-1.35-3.733-3.408-3.733-2.057 0-3.44 1.594-3.44 3.733 0 2.139 1.41 3.733 3.44 3.733 2.03 0 3.408-1.598 3.408-3.733ZM72.47 32.946h11.7c4.543 0 7.192 2.28 7.192 6.526 0 4.247-2.649 6.577-7.191 6.577h-6.935v7.125h-4.765V32.946Zm4.766 4.218v4.676h6.485c1.832 0 2.736-.883 2.736-2.34 0-1.565-.904-2.336-2.736-2.336h-6.485ZM102.662 51.016c-.254.485-1.636 2.48-4.71 2.48-3.665 0-6.627-2.906-6.627-7.694 0-4.789 2.962-7.667 6.656-7.667 2.962 0 4.372 1.851 4.626 2.336v-2.05h4.567v14.762h-4.512v-2.167Zm-3.327-8.932c-2.03 0-3.384 1.594-3.384 3.733 0 2.14 1.354 3.733 3.384 3.733s3.327-1.597 3.327-3.733-1.298-3.733-3.327-3.733ZM119.184 43.578a2.98 2.98 0 0 0-2.749-1.494c-1.918 0-3.13 1.594-3.13 3.733 0 2.14 1.24 3.758 3.158 3.758 1.807 0 2.625-1.168 2.764-1.51h4.4c-.143 2.052-2.116 5.5-7.275 5.5-4.286 0-7.641-3.078-7.641-7.75 0-4.673 3.328-7.755 7.585-7.755 5.159 0 7.105 3.392 7.33 5.53l-4.442-.012ZM129.712 46.6v6.577h-4.567V32.194h4.567v11.998l5.838-5.784h5.751l-6.994 6.811 7.362 7.952h-5.921z"/></g><g fill="%2325F5CE"><path d="M49.159 4.65c12.832 0 23.235 10.41 23.235 23.251h4.648C77.042 12.491 64.558 0 49.159 0c-15.4 0-27.883 12.492-27.883 27.901h4.647c0-12.841 10.403-23.25 23.236-23.25Z"/><path d="M44.852 25.793a3.632 3.632 0 0 1 2.6-5.097L63.8 16.951 50.426 27.09a3.626 3.626 0 0 1-5.574-1.296Z"/></g></g></svg>',UIStrings:{"unused-css-rules":"Enable [`Reduce Unused CSS`](https://support.nitropack.io/hc/en-us/articles/360020418457-Reduce-Unused-CSS) to remove CSS rules that are not applicable to this page.","modern-image-formats":"Use [`Image Optimization`](https://support.nitropack.io/hc/en-us/articles/16547237162513) to automatically convert your images to WebP.","offscreen-images":"Defer offscreen images by enabling [`Automatic Image Lazy Loading`](https://support.nitropack.io/hc/en-us/articles/12457493524369-NitroPack-Lazy-Loading-Feature-for-Images).","render-blocking-resources":"Enable [`Remove render-blocking resources`](https://support.nitropack.io/hc/en-us/articles/13820893500049-How-to-Deal-with-Render-Blocking-Resources-in-NitroPack) in NitroPack for faster initial load times.","unminified-css":"Enable [`Minify resources`](https://support.nitropack.io/hc/en-us/articles/360061059394-Minify-Resources) in your Caching settings to reduce the size of your CSS, HTML, and JavaScript files for faster load times.","unminified-javascript":"Enable [`Minify resources`](https://support.nitropack.io/hc/en-us/articles/360061059394-Minify-Resources) in your Caching settings to reduce the size of your JS, HTML, and CSS files for faster load times.","unused-javascript":"Configure [`Delayed Scripts`](https://support.nitropack.io/hc/en-us/articles/1500002600942-Delayed-Scripts) in NitroPack to delay loading of scripts until they are needed.","uses-long-cache-ttl":"Go to the [`Improve Server Response Time`](https://support.nitropack.io/hc/en-us/articles/1500002321821-Improve-Server-Response-Time) feature in the `Caching` menu and adjust your page cache expiration time to improve loading times and user experience.","uses-optimized-images":"Automatically compress, optimize, and convert your images into WebP by enabling the [`Image Optimization`](https://support.nitropack.io/hc/en-us/articles/14177271695121-How-to-serve-images-in-next-gen-formats-using-NitroPack) setting.","uses-text-compression":"Use [`Gzip compression`](https://support.nitropack.io/hc/en-us/articles/13229297479313-Enabling-GZIP-compression) in NitroPack to reduce the size of the files that are sent to the browser.","uses-responsive-images":"Enable [`Adaptive Image Sizing`](https://support.nitropack.io/hc/en-us/articles/10123833029905-How-to-Enable-Adaptive-Image-Sizing-For-Your-Site) to preemptively optimize your images and make them match the dimensions of the containers they’re displayed in across all devices.","server-response-time":"Improve server response time and optimize perceived performance by activating [`Instant Load`](https://support.nitropack.io/hc/en-us/articles/16547340617361).","dom-size":"Contact your account manager to enable [`HTML Lazy Load`](https://support.nitropack.io/hc/en-us/articles/17144942904337). Configuring it will prioritize and optimize your page rendering performance.","font-display":"Use the [`Override Font Rendering Behavior`](https://support.nitropack.io/hc/en-us/articles/16547358865041) option in NitroPack to set a desired value for the CSS font-display rule."}}})),Wi=l(((e,t)=>{J();t.exports={id:"nuxt",title:"Nuxt",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 124 124"><path fill="%2380EEC0" fill-rule="evenodd" d="M55.75 27.155c-3.222-5.54-11.278-5.54-14.5 0L6.134 87.535C2.912 93.075 6.94 100 13.384 100h27.413c-2.753-2.407-3.773-6.57-1.69-10.142L65.704 44.27 55.75 27.155Z" clip-rule="evenodd"/><path fill="%2300DC82" d="M78 40.4c2.667-4.533 9.333-4.533 12 0l29.06 49.4c2.667 4.533-.666 10.199-5.999 10.199H54.938c-5.333 0-8.666-5.666-6-10.199L78 40.4Z"/></svg>',UIStrings:{"modern-image-formats":'Use the `nuxt/image` component and set `format="webp"`. [Learn more](https://image.nuxtjs.org/components/nuxt-img#format).',"offscreen-images":'Use the `nuxt/image` component and set `loading="lazy"` for offscreen images. [Learn more](https://image.nuxtjs.org/components/nuxt-img#loading).',"uses-optimized-images":"Use the `nuxt/image` component and set the appropriate `quality`. [Learn more](https://image.nuxtjs.org/components/nuxt-img#quality).","uses-responsive-images":"Use the `nuxt/image` component and set the appropriate `sizes`. [Learn more](https://image.nuxtjs.org/components/nuxt-img#sizes).","prioritize-lcp-image":"Use the `nuxt/image` component and specify `preload` for LCP image. [Learn more](https://image.nuxtjs.org/components/nuxt-img#preload).","unsized-images":"Use the `nuxt/image` component and specify explicit `width` and `height`. [Learn more](https://image.nuxtjs.org/components/nuxt-img#width--height)."}}})),Hi=l(((e,t)=>{J();t.exports={id:"octobercms",title:"October CMS",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 310 310"><path fill="none" d="M-1-1h802v602H-1z"/><path fill="%23de6c26" d="M135 6.9c-14.2 4.4-34.9 21.8-49.9 42C55.8 88.5 39.6 135.8 41.4 177c.8 20.2 4.9 35.5 14.4 54.5 13.6 27.4 40.8 55.1 65.5 66.9 14.1 6.7 13.4 6.9 14.1-2.8.3-4.4 1-32.4 1.6-62.1 2.7-137.3 4.4-176 8.2-191.3.6-2.3 1.4-4.2 1.9-4.2 1.2 0 3.6 9.1 4.9 18.3.5 4.3 1 17.7 1 29.8 0 12 .3 21.9.7 21.9.3 0 5.7-5 11.9-11 6.9-6.8 12-11 13.3-11 1.8 0 1.9.3 1 2.7-1.2 3.1-7.9 13.2-19.1 28.5L153 128l.1 31.2c.1 17.2.4 37.4.8 44.9l.6 13.7 11-12.6c14-16 35.1-37.1 39.5-39.6l3.3-1.9-.6 3.2c-2 9.8-9.5 20.7-37.4 54.3L154 240.8v31.1c0 18.3.4 31.1.9 31.1 2.8 0 19.3-6.4 26.8-10.5 13.8-7.3 23.8-15 38.3-29.5 15.7-15.7 24.4-27.4 33.4-45.2 20.5-40 21-80.3 1.6-119-17.8-35.6-54.6-72.1-87.8-86.9-11.7-5.3-24.6-7.3-32.2-5z"/></svg>',UIStrings:{"unused-css-rules":"Consider reviewing the [plugins](https://octobercms.com/plugins) loading unused CSS on the website. To identify plugins that add unnecessary CSS, run [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. Identify the theme/plugin responsible from the stylesheet URL. Look for plugins with many stylesheets with lots of red in code coverage. A plugin should only add a stylesheet if it is actually used on the web page.","modern-image-formats":"Consider using a [plugin](https://octobercms.com/plugins?search=image) or service that will automatically convert the uploaded images to the optimal formats. [WebP lossless images](https://developers.google.com/speed/webp) are 26% smaller in size compared to PNGs and 25-34% smaller than comparable JPEG images at the equivalent SSIM quality index. Another next-gen image format to consider is [AVIF](https://jakearchibald.com/2020/avif-has-landed/).","offscreen-images":"Consider installing an [image lazy loading plugin](https://octobercms.com/plugins?search=lazy) that provides the ability to defer any offscreen images, or switch to a theme that provides that functionality. Also consider using [the AMP plugin](https://octobercms.com/plugins?search=Accelerated+Mobile+Pages).","total-byte-weight":"Consider showing excerpts in the post lists (e.g. using a `show more` button), reducing the number of posts shown on a given web page, breaking long posts into multiple web pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are many plugins that help [inline critical assets](https://octobercms.com/plugins?search=css). These plugins may break other plugins, so you should test thoroughly.","unminified-css":"There are many [plugins](https://octobercms.com/plugins?search=css) that can speed up a website by concatenating, minifying and compressing the styles. Using a build process to do this minification up-front can speed up development.","unminified-javascript":"There are many [plugins](https://octobercms.com/plugins?search=javascript) that can speed up a website by concatenating, minifying and compressing the scripts. Using a build process to do this minification up-front can speed up development.","efficient-animated-content":"[Replace animated GIFs with video](https://web.dev/replace-gifs-with-videos/) for faster web page loads and consider using modern file formats such as [WebM](https://web.dev/replace-gifs-with-videos/#create-webm-videos) or [AV1](https://developers.google.com/web/updates/2018/09/chrome-70-media-updates#av1-decoder) to improve compression efficiency by greater than 30% over the current state-of-the-art video codec, VP9.","unused-javascript":"Consider reviewing the [plugins](https://octobercms.com/plugins?search=javascript) that load unused JavaScript in the web page. To identify plugins that add unnecessary JavaScript, run [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. Identify the theme/plugin responsible from the URL of the script. Look for plugins with many scripts with lots of red in code coverage. A plugin should only add a script if it is actually used on the web page.","uses-long-cache-ttl":"Read about [preventing unnecessary network requests with the HTTP Cache](https://web.dev/http-cache/#caching-checklist). There are many [plugins](https://octobercms.com/plugins?search=Caching) that can be used to speed up caching.","uses-optimized-images":"Consider using an [image optimization plugin](https://octobercms.com/plugins?search=image) to compresses images while retaining the quality.","uses-text-compression":"Enable text compression in the web server configuration.","uses-responsive-images":"Upload images directly in the media manager to ensure the required image sizes are available. Consider using the [resize filter](https://octobercms.com/docs/markup/filter-resize) or an [image resizing plugin](https://octobercms.com/plugins?search=image) to ensure the optimal image sizes are used.","server-response-time":"Themes, plugins and server specifications all contribute to the server response time. Consider finding a more optimized theme, carefully selecting an optimization plugin and/or upgrade the server. October CMS also allows developers to use [`Queues`](https://octobercms.com/docs/services/queues) to defer the processing of a time consuming task, such as sending an e-mail. This drastically speeds up web requests."}}})),Gi=l(((e,t)=>{J();t.exports={id:"react",title:"React",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 841.9 595.3"><g fill="%2361DAFB"><path d="M666.3 296.5c0-32.5-40.7-63.3-103.1-82.4 14.4-63.6 8-114.2-20.2-130.4-6.5-3.8-14.1-5.6-22.4-5.6v22.3c4.6 0 8.3.9 11.4 2.6 13.6 7.8 19.5 37.5 14.9 75.7-1.1 9.4-2.9 19.3-5.1 29.4-19.6-4.8-41-8.5-63.5-10.9-13.5-18.5-27.5-35.3-41.6-50 32.6-30.3 63.2-46.9 84-46.9V78c-27.5 0-63.5 19.6-99.9 53.6-36.4-33.8-72.4-53.2-99.9-53.2v22.3c20.7 0 51.4 16.5 84 46.6-14 14.7-28 31.4-41.3 49.9-22.6 2.4-44 6.1-63.6 11-2.3-10-4-19.7-5.2-29-4.7-38.2 1.1-67.9 14.6-75.8 3-1.8 6.9-2.6 11.5-2.6V78.5c-8.4 0-16 1.8-22.6 5.6-28.1 16.2-34.4 66.7-19.9 130.1-62.2 19.2-102.7 49.9-102.7 82.3 0 32.5 40.7 63.3 103.1 82.4-14.4 63.6-8 114.2 20.2 130.4 6.5 3.8 14.1 5.6 22.5 5.6 27.5 0 63.5-19.6 99.9-53.6 36.4 33.8 72.4 53.2 99.9 53.2 8.4 0 16-1.8 22.6-5.6 28.1-16.2 34.4-66.7 19.9-130.1 62-19.1 102.5-49.9 102.5-82.3zm-130.2-66.7c-3.7 12.9-8.3 26.2-13.5 39.5-4.1-8-8.4-16-13.1-24-4.6-8-9.5-15.8-14.4-23.4 14.2 2.1 27.9 4.7 41 7.9zm-45.8 106.5c-7.8 13.5-15.8 26.3-24.1 38.2-14.9 1.3-30 2-45.2 2-15.1 0-30.2-.7-45-1.9-8.3-11.9-16.4-24.6-24.2-38-7.6-13.1-14.5-26.4-20.8-39.8 6.2-13.4 13.2-26.8 20.7-39.9 7.8-13.5 15.8-26.3 24.1-38.2 14.9-1.3 30-2 45.2-2 15.1 0 30.2.7 45 1.9 8.3 11.9 16.4 24.6 24.2 38 7.6 13.1 14.5 26.4 20.8 39.8-6.3 13.4-13.2 26.8-20.7 39.9zm32.3-13c5.4 13.4 10 26.8 13.8 39.8-13.1 3.2-26.9 5.9-41.2 8 4.9-7.7 9.8-15.6 14.4-23.7 4.6-8 8.9-16.1 13-24.1zM421.2 430c-9.3-9.6-18.6-20.3-27.8-32 9 .4 18.2.7 27.5.7 9.4 0 18.7-.2 27.8-.7-9 11.7-18.3 22.4-27.5 32zm-74.4-58.9c-14.2-2.1-27.9-4.7-41-7.9 3.7-12.9 8.3-26.2 13.5-39.5 4.1 8 8.4 16 13.1 24 4.7 8 9.5 15.8 14.4 23.4zM420.7 163c9.3 9.6 18.6 20.3 27.8 32-9-.4-18.2-.7-27.5-.7-9.4 0-18.7.2-27.8.7 9-11.7 18.3-22.4 27.5-32zm-74 58.9c-4.9 7.7-9.8 15.6-14.4 23.7-4.6 8-8.9 16-13 24-5.4-13.4-10-26.8-13.8-39.8 13.1-3.1 26.9-5.8 41.2-7.9zm-90.5 125.2c-35.4-15.1-58.3-34.9-58.3-50.6 0-15.7 22.9-35.6 58.3-50.6 8.6-3.7 18-7 27.7-10.1 5.7 19.6 13.2 40 22.5 60.9-9.2 20.8-16.6 41.1-22.2 60.6-9.9-3.1-19.3-6.5-28-10.2zM310 490c-13.6-7.8-19.5-37.5-14.9-75.7 1.1-9.4 2.9-19.3 5.1-29.4 19.6 4.8 41 8.5 63.5 10.9 13.5 18.5 27.5 35.3 41.6 50-32.6 30.3-63.2 46.9-84 46.9-4.5-.1-8.3-1-11.3-2.7zm237.2-76.2c4.7 38.2-1.1 67.9-14.6 75.8-3 1.8-6.9 2.6-11.5 2.6-20.7 0-51.4-16.5-84-46.6 14-14.7 28-31.4 41.3-49.9 22.6-2.4 44-6.1 63.6-11 2.3 10.1 4.1 19.8 5.2 29.1zm38.5-66.7c-8.6 3.7-18 7-27.7 10.1-5.7-19.6-13.2-40-22.5-60.9 9.2-20.8 16.6-41.1 22.2-60.6 9.9 3.1 19.3 6.5 28.1 10.2 35.4 15.1 58.3 34.9 58.3 50.6-.1 15.7-23 35.6-58.4 50.6zM320.8 78.4z"/><circle cx="420.9" cy="296.5" r="45.7"/><path d="M520.5 78.1z"/></g></svg>',UIStrings:{"unminified-css":"If your build system minifies CSS files automatically, ensure that you are deploying the production build of your application. You can check this with the React Developer Tools extension. [Learn more](https://reactjs.org/docs/optimizing-performance.html#use-the-production-build).","unminified-javascript":"If your build system minifies JS files automatically, ensure that you are deploying the production build of your application. You can check this with the React Developer Tools extension. [Learn more](https://reactjs.org/docs/optimizing-performance.html#use-the-production-build).","unused-javascript":"If you are not server-side rendering, [split your JavaScript bundles](https://web.dev/code-splitting-suspense/) with `React.lazy()`. Otherwise, code-split using a third-party library such as [loadable-components](https://www.smooth-code.com/open-source/loadable-components/docs/getting-started/).","server-response-time":"If you are server-side rendering any React components, consider using `renderToPipeableStream()` or `renderToStaticNodeStream()` to allow the client to receive and hydrate different parts of the markup instead of all at once. [Learn more](https://reactjs.org/docs/react-dom-server.html#renderToPipeableStream).",redirects:"If you are using React Router, minimize usage of the `<Redirect>` component for [route navigations](https://reacttraining.com/react-router/web/api/Redirect).","user-timings":"Use the React DevTools Profiler, which makes use of the Profiler API, to measure the rendering performance of your components. [Learn more.](https://reactjs.org/blog/2018/09/10/introducing-the-react-profiler.html)","dom-size":'Consider using a "windowing" library like `react-window` to minimize the number of DOM nodes created if you are rendering many repeated elements on the page. [Learn more](https://web.dev/virtualize-long-lists-react-window/). Also, minimize unnecessary re-renders using [`shouldComponentUpdate`](https://reactjs.org/docs/optimizing-performance.html#shouldcomponentupdate-in-action), [`PureComponent`](https://reactjs.org/docs/react-api.html#reactpurecomponent), or [`React.memo`](https://reactjs.org/docs/react-api.html#reactmemo) and [skip effects](https://reactjs.org/docs/hooks-effect.html#tip-optimizing-performance-by-skipping-effects) only until certain dependencies have changed if you are using the `Effect` hook to improve runtime performance.'}}})),$i=l(((e,t)=>{J();t.exports={id:"wix",title:"Wix",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 71 28"><path fill-rule="evenodd" d="M0 .032s2.796-.356 4.66 1.31C5.81 2.37 6.145 4.008 6.145 4.008L9.952 18.96l3.165-12.239c.309-1.301.864-2.909 1.743-3.997 1.121-1.385 3.398-1.472 3.641-1.472.242 0 2.519.087 3.639 1.472.88 1.088 1.435 2.696 1.744 3.997l3.165 12.239 3.806-14.953s.336-1.638 1.486-2.666C34.205-.324 37 .032 37 .032l-7.289 27.945s-2.404.176-3.607-.446c-1.58-.816-2.332-1.447-3.289-5.249l-.099-.395c-.349-1.399-.883-3.59-1.424-5.813l-.162-.667-.162-.664c-.779-3.198-1.497-6.143-1.612-6.517-.108-.351-.236-1.187-.855-1.187-.607 0-.746.837-.857 1.187-.13.412-.99 3.955-1.856 7.514l-.162.667c-.512 2.107-1.01 4.151-1.341 5.48l-.1.395c-.956 3.802-1.708 4.433-3.288 5.249-1.204.622-3.608.446-3.608.446zM43.998 5v.995L44 5.994v16.628c-.014 3.413-.373 4.17-1.933 4.956-1.213.61-3.067.379-3.067.379V9.332c0-.935.315-1.548 1.477-2.098.693-.329 1.34-.58 2.012-.953C43.54 5.703 43.998 5 43.998 5zM46 .125s3.877-.673 5.797 1.107c1.228 1.14 2.602 3.19 2.602 3.19l3.38 4.965c.164.258.378.54.72.54.343 0 .558-.282.722-.54l3.38-4.965s1.374-2.05 2.602-3.19C67.123-.548 71 .125 71 .125l-9.186 13.923 9.161 13.881-.032.004c-.38.045-4.036.423-5.855-1.266-1.229-1.138-2.487-2.992-2.487-2.992l-3.38-4.964c-.164-.26-.379-.54-.721-.54-.343 0-.557.28-.721.54l-3.38 4.964s-1.19 1.854-2.418 2.992c-1.92 1.783-5.957 1.262-5.957 1.262l9.161-13.88zM43.96 0H44c0 1.91-.186 3.042-1.387 3.923-.384.28-1.048.71-1.826.992C39.719 5.304 39 6 39 6c0-3.476.53-4.734 1.95-5.48.865-.452 2.272-.514 2.82-.52z"></path></svg>',UIStrings:{"modern-image-formats":"Upload images using `Wix Media Manager` to ensure they are automatically served as WebP. Find [more ways to optimize](https://support.wix.com/en/article/site-performance-optimizing-your-media) your site's media.","render-blocking-resources":"When [adding third-party code](https://support.wix.com/en/article/site-performance-using-third-party-code-on-your-site) in the `Custom Code` tab of your site's dashboard, make sure it's deferred or loaded at the end of the code body. Where possible, use Wix’s [integrations](https://support.wix.com/en/article/about-marketing-integrations) to embed marketing tools on your site. ","efficient-animated-content":"Place videos inside `VideoBoxes`, customize them using `Video Masks` or add `Transparent Videos`. [Learn more](https://support.wix.com/en/article/wix-video-about-wix-video).","unused-javascript":"Review any third-party code you've added to your site in the `Custom Code` tab of your site's dashboard and only keep the services that are necessary to your site. [Find out more](https://support.wix.com/en/article/site-performance-removing-unused-javascript).","server-response-time":"Wix utilizes CDNs and caching to serve responses as fast as possible for most visitors. Consider [manually enabling caching](https://support.wix.com/en/article/site-performance-caching-pages-to-optimize-loading-speed) for your site, especially if using `Velo`."}}})),Ki=l(((e,t)=>{J();t.exports={id:"wordpress",title:"WordPress",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 122.5 122.5"><g fill="%232f3439"><path d="M8.7 61.3c0 20.8 12.1 38.7 29.6 47.3l-25-68.7c-3 6.5-4.6 13.7-4.6 21.4zm88-2.7c0-6.5-2.3-11-4.3-14.5-2.7-4.3-5.2-8-5.2-12.3 0-4.8 3.7-9.3 8.9-9.3h.7a52.4 52.4 0 0 0-79.4 9.9h3.3c5.5 0 14-.6 14-.6 2.9-.2 3.2 4 .4 4.3 0 0-2.9.4-6 .5l19.1 57L59.7 59l-8.2-22.5c-2.8-.1-5.5-.5-5.5-.5-2.8-.1-2.5-4.5.3-4.3 0 0 8.7.7 13.9.7 5.5 0 14-.7 14-.7 2.8-.2 3.2 4 .3 4.3 0 0-2.8.4-6 .5l19 56.5 5.2-17.5c2.3-7.3 4-12.5 4-17z"/><path d="m62.2 65.9-15.8 45.8a52.6 52.6 0 0 0 32.3-.9l-.4-.7zM107.4 36a49.6 49.6 0 0 1-3.6 24.2l-16.1 46.5A52.5 52.5 0 0 0 107.4 36z"/><path d="M61.3 0a61.3 61.3 0 1 0 .1 122.7A61.3 61.3 0 0 0 61.3 0zm0 119.7a58.5 58.5 0 1 1 .1-117 58.5 58.5 0 0 1-.1 117z"/></g></svg>',UIStrings:{"unused-css-rules":"Consider reducing, or switching, the number of [WordPress plugins](https://wordpress.org/plugins/) loading unused CSS in your page. To identify plugins that are adding extraneous CSS, try running [code coverage](https://developer.chrome.com/docs/devtools/coverage/) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the stylesheet. Look out for plugins that have many stylesheets in the list which have a lot of red in code coverage. A plugin should only enqueue a stylesheet if it is actually used on the page.","modern-image-formats":"Consider using the [Performance Lab](https://wordpress.org/plugins/performance-lab/) plugin to automatically convert your uploaded JPEG images into WebP, wherever supported.","offscreen-images":"Install a [lazy-load WordPress plugin](https://wordpress.org/plugins/search/lazy+load/) that provides the ability to defer any offscreen images, or switch to a theme that provides that functionality. Also consider using [the AMP plugin](https://wordpress.org/plugins/amp/).","total-byte-weight":"Consider showing excerpts in your post lists (e.g. via the more tag), reducing the number of posts shown on a given page, breaking your long posts into multiple pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are a number of WordPress plugins that can help you [inline critical assets](https://wordpress.org/plugins/search/critical+css/) or [defer less important resources](https://wordpress.org/plugins/search/defer+css+javascript/). Beware that optimizations provided by these plugins may break features of your theme or plugins, so you will likely need to make code changes.","unminified-css":"A number of [WordPress plugins](https://wordpress.org/plugins/search/minify+css/) can speed up your site by concatenating, minifying, and compressing your styles. You may also want to use a build process to do this minification up-front if possible.","unminified-javascript":"A number of [WordPress plugins](https://wordpress.org/plugins/search/minify+javascript/) can speed up your site by concatenating, minifying, and compressing your scripts. You may also want to use a build process to do this minification up front if possible.","efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.","unused-javascript":"Consider reducing, or switching, the number of [WordPress plugins](https://wordpress.org/plugins/) loading unused JavaScript in your page. To identify plugins that are adding extraneous JS, try running [code coverage](https://developer.chrome.com/docs/devtools/coverage/) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the script. Look out for plugins that have many scripts in the list which have a lot of red in code coverage. A plugin should only enqueue a script if it is actually used on the page.","uses-long-cache-ttl":"Read about [Browser Caching in WordPress](https://wordpress.org/support/article/optimization/#browser-caching).","uses-optimized-images":"Consider using an [image optimization WordPress plugin](https://wordpress.org/plugins/search/optimize+images/) that compresses your images while retaining quality.","uses-text-compression":"You can enable text compression in your web server configuration.","uses-responsive-images":"Upload images directly through the [media library](https://wordpress.org/support/article/media-library-screen/) to ensure that the required image sizes are available, and then insert them from the media library or use the image widget to ensure the optimal image sizes are used (including those for the responsive breakpoints). Avoid using `Full Size` images unless the dimensions are adequate for their usage. [Learn More](https://wordpress.org/support/article/inserting-images-into-posts-and-pages/).","server-response-time":"Themes, plugins, and server specifications all contribute to server response time. Consider finding a more optimized theme, carefully selecting an optimization plugin, and/or upgrading your server."}}})),Yi=l(((e,t)=>{J();var a={"unused-css-rules":"Enable [Remove Unused CSS](https://docs.wp-rocket.me/article/1529-remove-unused-css) in 'WP Rocket' to fix this issue. It reduces page size by removing all CSS and stylesheets that are not used while keeping only the used CSS for each page.","modern-image-formats":"Enable 'Imagify' from the Image Optimization tab in 'WP Rocket' to convert your images to WebP.","unused-javascript":"Enable [Delay JavaScript execution](https://docs.wp-rocket.me/article/1349-delay-javascript-execution) in 'WP Rocket' to fix this problem. It will improve the loading of your page by delaying the execution of scripts until user interaction. If your site has iframes, you can use WP Rocket's [LazyLoad for iframes and videos](https://docs.wp-rocket.me/article/1674-lazyload-for-iframes-and-videos) and [Replace YouTube iframe with preview image](https://docs.wp-rocket.me/article/1488-replace-youtube-iframe-with-preview-image) as well.","render-blocking-resources":"Enable [Remove Unused CSS](https://docs.wp-rocket.me/article/1529-remove-unused-css) and [Load JavaScript deferred](https://docs.wp-rocket.me/article/1265-load-javascript-deferred) in 'WP Rocket' to address this recommendation. These features will respectively optimize the CSS and JavaScript files so that they don't block the rendering of your page.","unminified-css":"Enable [Minify CSS files](https://docs.wp-rocket.me/article/1350-css-minify-combine) in 'WP Rocket' to fix this issue. Any spaces and comments in your site's CSS files will be removed to make the file size smaller and faster to download.","unminified-javascript":"Enable [Minify JavaScript files](https://docs.wp-rocket.me/article/1351-javascript-minify-combine) in 'WP Rocket' to fix this issue. Empty spaces and comments will be removed from JavaScript files to make their size smaller and faster to download.","uses-optimized-images":"Enable 'Imagify' from the Image Optimization tab in 'WP Rocket' and run Bulk Optimization to compress your images.","uses-rel-preconnect":"Use [Prefetch DNS Requests](https://docs.wp-rocket.me/article/1302-prefetch-dns-requests) in 'WP Rocket' to add \"dns-prefetch\" and speed up the connection with external domains. Also, 'WP Rocket' automatically adds \"preconnect\" to [Google Fonts domain](https://docs.wp-rocket.me/article/1312-optimize-google-fonts) and any CNAME(S) added via the [Enable CDN](https://docs.wp-rocket.me/article/42-using-wp-rocket-with-a-cdn) feature.","uses-rel-preload":"To fix this issue for fonts, enable [Remove Unused CSS](https://docs.wp-rocket.me/article/1529-remove-unused-css) in 'WP Rocket'. Your site's critical fonts will be preloaded with priority.","offscreen-images":"Enable [LazyLoad](https://docs.wp-rocket.me/article/1141-lazyload-for-images) in WP Rocket to fix this recommendation. This feature delays the loading of the images until the visitor scrolls down the page and actually needs to see them."};t.exports={id:"wp-rocket",title:"WP Rocket",icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 294 524"><defs><linearGradient id="a" x1="36.742%" x2="37.116%" y1="100.518%" y2="-.001%"><stop offset="0%" stop-color="%23DD5F29"/><stop offset="26.042%" stop-color="%23F26B32"/><stop offset="100%" stop-color="%23FAC932"/></linearGradient><linearGradient id="b" x1="28.046%" x2="28.421%" y1="100.518%" y2="-.003%"><stop offset="0%" stop-color="%23DD5F29"/><stop offset="26.042%" stop-color="%23F26B32"/><stop offset="100%" stop-color="%23FAC932"/></linearGradient><linearGradient id="c" x1="38.215%" x2="38.589%" y1="100.518%" y2="0%"><stop offset="0%" stop-color="%23DD5F29"/><stop offset="26.042%" stop-color="%23F26B32"/><stop offset="100%" stop-color="%23FAC932"/></linearGradient></defs><g fill="none" fill-rule="evenodd"><path fill="url(%23a)" d="M218.617 270.615c-9.752 0-18.896-5.689-23.366-14.63l-7.72-17.27h-76.6l-7.722 17.27c-4.47 8.941-13.613 14.63-23.366 14.63H75.78l32.712 249.306c1.625 4.671 4.673 4.671 6.502 0l32.51-79.648 28.242 79.442c1.625 4.676 4.673 4.676 6.501 0L220.04 270.82l-1.423-.204Z" transform="translate(-1.58 -.2)"/><path fill="url(%23b)" d="M184.47 231.784h-70.3l-10.77 24.179c-3.657 7.314-10.768 12.597-18.489 14.02L109.7 423.791c1.625 2.844 4.673 2.844 6.501 0l31.697-48.155 29.055 47.951c1.829 2.845 4.673 2.845 6.502 0l28.039-154.012c-6.908-2.032-13.004-6.908-16.255-13.613l-10.768-24.18Z" transform="translate(-1.58 -.2)"/><path fill="url(%23c)" d="m195.259 255.988-46.123-103.014-45.92 103.014c-1.625 3.048-3.656 5.69-6.095 7.925l19.1 102.2c1.015 1.423 3.657 1.83 5.485 0l25.601-33.931 25.602 33.728c1.625 2.032 4.47 1.626 5.485 0l21.131-103.42c-1.625-2.032-3.047-4.064-4.266-6.502Z" transform="translate(-1.58 -.2)"/><path fill="%23F56F46" d="M.439 12.559c-1.422-4.877 1.422-8.33 6.299-8.33H47.17c2.845 0 5.486 2.437 6.299 4.876l29.665 116.83h1.422l53.437-121.3c1.016-2.032 3.048-3.86 5.892-3.86h6.299c3.047 0 5.08 1.625 5.892 3.86l53.437 121.3h1.423L240.6 9.105c.61-2.439 3.454-4.877 6.299-4.877h40.433c4.877 0 7.518 3.454 6.299 8.33l-65.221 231.63c-.61 2.845-3.454 4.876-6.298 4.876h-5.487c-2.438 0-4.876-1.625-5.892-3.86l-63.19-141.009h-1.015L83.744 245.203c-1.016 2.032-3.454 3.86-5.892 3.86h-5.486c-2.845 0-5.486-2.031-6.299-4.876L.44 12.559Z"/></g></svg>',UIStrings:a}})),Ji=l(((e,t)=>{J();var a=[Pi(),Li(),Oi(),ji(),Ui(),Bi(),qi(),zi(),Vi(),Wi(),Hi(),Gi(),$i(),Ki(),Yi()];t.exports=a})),Zi=l(((e,t)=>{J(),t.exports=o((function(e,t){if("string"==typeof e&&t[e])return e;for(var a=[].concat(e||[]),n=0,r=a.length;n<r;++n)for(var i=a[n].split("-");i.length;){var o=i.join("-");if(t[o])return o;i.pop()}}),"lookupClosestLocale")})),Xi=s((()=>{J(),ua(),oi(),Fi="",Ni=JSON.parse('{\n  "name": "lighthouse",\n  "type": "module",\n  "version": "11.0.0",\n  "description": "Automated auditing, performance metrics, and best practices for the web.",\n  "main": "./core/index.js",\n  "bin": {\n    "lighthouse": "./cli/index.js",\n    "chrome-debug": "./core/scripts/manual-chrome-launcher.js",\n    "smokehouse": "./cli/test/smokehouse/frontends/smokehouse-bin.js"\n  },\n  "engines": {\n    "node": ">=18.16"\n  },\n  "scripts": {\n    "prepack": "yarn build-report --standalone --flow --esm && yarn build-types",\n    "postpack": "yarn clean-types",\n    "build-all": "npm-run-posix-or-windows build-all:task",\n    "build-all:task": "yarn build-report && yarn build-cdt-lib && yarn build-devtools && concurrently \'yarn build-extension\' \'yarn build-lr\' \'yarn build-viewer\' \'yarn build-treemap\' \'yarn build-smokehouse-bundle\' && yarn build-pack",\n    "build-all:task:windows": "yarn build-report && yarn build-cdt-lib && yarn build-extension && yarn build-devtools && yarn build-lr && yarn build-viewer && yarn build-treemap && yarn build-smokehouse-bundle",\n    "build-cdt-lib": "node ./build/build-cdt-lib.js",\n    "build-extension": "yarn build-extension-chrome && yarn build-extension-firefox",\n    "build-extension-chrome": "node ./build/build-extension.js chrome",\n    "build-extension-firefox": "node ./build/build-extension.js firefox",\n    "build-devtools": "yarn reset-link && node ./build/build-bundle.js clients/devtools/devtools-entry.js dist/lighthouse-dt-bundle.js && node ./build/build-dt-report-resources.js",\n    "build-smokehouse-bundle": "node ./build/build-smokehouse-bundle.js",\n    "build-lr": "yarn reset-link && node --max-old-space-size=4096 ./build/build-lightrider-bundles.js",\n    "build-pack": "bash build/build-pack.sh",\n    "build-report": "node build/build-report-components.js && node build/build-report.js",\n    "build-sample-reports": "yarn build-report && node build/build-sample-reports.js",\n    "build-treemap": "node ./build/build-treemap.js",\n    "build-viewer": "node ./build/build-viewer.js",\n    "build-types": "yarn type-check && rsync -a .tmp/tsbuildinfo/ ./ --include=\'*.d.ts\' --include=\'*.d.cts\' --exclude=\'*.map\' --exclude=\'*.tsbuildinfo\'",\n    "reset-link": "(yarn unlink || true) && yarn link && yarn link lighthouse",\n    "c8": "bash core/scripts/c8.sh",\n    "clean": "rm -r dist proto/scripts/*.json proto/scripts/*_pb2.* proto/scripts/*_pb.* proto/scripts/__pycache__ proto/scripts/*.pyc *.report.html *.report.dom.html *.report.json *.devtoolslog.json *.trace.json shared/localization/locales/*.ctc.json || true",\n    "clean-types": "git clean -xfq \'*.d.ts\' \'*.d.cts\' -e \'node_modules/\' -e \'dist/\' -e \'.tmp/\' -e \'**/types/\'",\n    "lint": "[ \\"$CI\\" = true ] && eslint --quiet -f codeframe . || eslint .",\n    "smoke": "node cli/test/smokehouse/frontends/smokehouse-bin.js",\n    "debug": "node --inspect-brk ./cli/index.js",\n    "start": "yarn build-report --standalone && node ./cli/index.js",\n    "mocha": "node --loader=testdouble core/test/scripts/run-mocha-tests.js",\n    "test": "yarn diff:sample-json && yarn lint --quiet && yarn unit && yarn type-check",\n    "test-bundle": "yarn smoke --runner bundle",\n    "test-clients": "yarn mocha --testMatch clients/**/*-test.js && yarn mocha --testMatch clients/**/*-test-pptr.js",\n    "test-viewer": "yarn unit-viewer && yarn mocha --testMatch viewer/**/*-test-pptr.js --timeout 35000",\n    "test-treemap": "yarn unit-treemap && yarn mocha --testMatch treemap/**/*-test-pptr.js --timeout 35000",\n    "test-lantern": "bash core/scripts/test-lantern.sh",\n    "test-legacy-javascript": "bash core/scripts/test-legacy-javascript.sh",\n    "test-docs": "yarn --cwd docs/recipes/ test",\n    "test-proto": "yarn compile-proto && yarn build-proto-roundtrip",\n    "unit-core": "yarn mocha core",\n    "unit-cli": "yarn mocha --testMatch cli/**/*-test.js",\n    "unit-report": "yarn mocha --testMatch report/**/*-test.js",\n    "unit-treemap": "yarn mocha --testMatch treemap/**/*-test.js",\n    "unit-viewer": "yarn mocha --testMatch viewer/**/*-test.js",\n    "unit-flow": "bash flow-report/test/run-flow-report-tests.sh",\n    "unit": "yarn unit-flow && yarn mocha",\n    "unit:ci": "NODE_OPTIONS=--max-old-space-size=8192 npm run unit --forbid-only",\n    "core-unit": "yarn unit-core",\n    "cli-unit": "yarn unit-cli",\n    "viewer-unit": "yarn unit-viewer",\n    "watch": "yarn unit-core --watch",\n    "unit:cicoverage": "yarn c8 --all yarn unit:ci",\n    "coverage": "yarn unit:cicoverage && c8 report --reporter html",\n    "coverage:smoke": "yarn c8 yarn smoke -j=1 && c8 report --reporter html",\n    "devtools": "bash core/scripts/roll-to-devtools.sh",\n    "chrome": "node core/scripts/manual-chrome-launcher.js",\n    "fast": "node ./cli/index.js --preset=desktop --throttlingMethod=provided",\n    "deploy-treemap": "yarn build-treemap --deploy",\n    "deploy-viewer": "yarn build-viewer --deploy",\n    "vercel-build": "yarn build-sample-reports && yarn build-viewer && yarn build-treemap",\n    "dogfood-lhci": "./core/scripts/dogfood-lhci.sh",\n    "timing-trace": "node core/scripts/generate-timing-trace.js",\n    "changelog": "conventional-changelog --config ./build/changelog-generator/index.cjs --infile changelog.md --same-file",\n    "type-check": "tsc --build ./tsconfig-all.json",\n    "i18n:checks": "./core/scripts/i18n/assert-strings-collected.sh",\n    "i18n:collect-strings": "node core/scripts/i18n/collect-strings.js",\n    "update:lantern-baseline": "node core/scripts/lantern/update-baseline-lantern-values.js",\n    "update:sample-artifacts": "node core/scripts/update-report-fixtures.js",\n    "update:sample-json": "yarn i18n:collect-strings && node ./cli -A=./core/test/results/artifacts --config-path=./core/test/results/sample-config.js --output=json --output-path=./core/test/results/sample_v2.json && node core/scripts/cleanup-LHR-for-diff.js ./core/test/results/sample_v2.json --only-remove-timing && node ./core/scripts/update-flow-fixtures.js",\n    "update:flow-sample-json": "yarn i18n:collect-strings && node ./core/scripts/update-flow-fixtures.js",\n    "test-devtools": "bash core/test/devtools-tests/test-locally.sh",\n    "open-devtools": "bash core/scripts/open-devtools.sh",\n    "run-devtools": "node core/scripts/pptr-run-devtools.js",\n    "diff:sample-json": "yarn i18n:checks && bash core/scripts/assert-golden-lhr-unchanged.sh",\n    "diff:flow-sample-json": "yarn i18n:collect-strings && bash core/scripts/assert-baseline-flow-result-unchanged.sh",\n    "computeBenchmarkIndex": "./core/scripts/benchmark.js",\n    "save-latest-run": "./core/scripts/save-latest-run.sh",\n    "compile-proto": "protoc --python_out=./ ./proto/lighthouse-result.proto && mv ./proto/*_pb2.py ./proto/scripts || (echo \\"❌ Install protobuf = 3.20.x to compile the proto file.\\" && false)",\n    "build-proto-roundtrip": "mkdir -p .tmp && python3 proto/scripts/json_roundtrip_via_proto.py",\n    "static-server": "node cli/test/fixtures/static-server.js",\n    "serve-dist": "cd dist && python3 -m http.server 7878",\n    "serve-gh-pages": "cd dist/gh-pages && python3 -m http.server 7333",\n    "serve-treemap": "yarn serve-gh-pages",\n    "serve-viewer": "yarn serve-gh-pages",\n    "flow-report": "yarn build-report --flow && node ./core/scripts/build-test-flow-report.js"\n  },\n  "devDependencies": {\n    "@build-tracker/cli": "^1.0.0-beta.15",\n    "@esbuild-kit/esm-loader": "^2.1.1",\n    "@esbuild-plugins/node-modules-polyfill": "^0.1.4",\n    "@jest/fake-timers": "^28.1.0",\n    "@testing-library/preact": "^3.1.1",\n    "@testing-library/preact-hooks": "^1.1.0",\n    "@types/archiver": "^2.1.2",\n    "@types/chrome": "^0.0.154",\n    "@types/configstore": "^4.0.0",\n    "@types/cpy": "^5.1.0",\n    "@types/debug": "^4.1.7",\n    "@types/eslint": "^8.2.1",\n    "@types/estree": "^0.0.50",\n    "@types/gh-pages": "^2.0.0",\n    "@types/google.analytics": "0.0.39",\n    "@types/jpeg-js": "^0.3.7",\n    "@types/jsdom": "^16.2.13",\n    "@types/lodash": "^4.14.178",\n    "@types/mocha": "^9.0.0",\n    "@types/node": "*",\n    "@types/pako": "^1.0.1",\n    "@types/resize-observer-browser": "^0.1.1",\n    "@types/resolve": "^1.20.2",\n    "@types/semver": "^5.5.0",\n    "@types/tabulator-tables": "^4.9.1",\n    "@types/ws": "^7.0.0",\n    "@types/yargs": "^17.0.8",\n    "@types/yargs-parser": "^20.2.1",\n    "@typescript-eslint/eslint-plugin": "^5.48.0",\n    "@typescript-eslint/parser": "^5.48.0",\n    "acorn": "^8.5.0",\n    "angular": "^1.7.4",\n    "archiver": "^3.0.0",\n    "builtin-modules": "^3.3.0",\n    "c8": "^7.11.3",\n    "chalk": "^2.4.1",\n    "chrome-devtools-frontend": "1.0.1153166",\n    "concurrently": "^6.4.0",\n    "conventional-changelog-cli": "^2.1.1",\n    "cpy": "^8.1.2",\n    "cross-env": "^7.0.2",\n    "csv-validator": "^0.0.3",\n    "es-main": "^1.2.0",\n    "esbuild": "^0.18.11",\n    "eslint": "^8.4.1",\n    "eslint-config-google": "^0.14.0",\n    "eslint-formatter-codeframe": "^7.32.1",\n    "eslint-plugin-import": "^2.25.3",\n    "eslint-plugin-local-rules": "1.1.0",\n    "event-target-shim": "^6.0.2",\n    "expect": "^28.1.0",\n    "firebase": "^9.0.2",\n    "gh-pages": "^2.0.1",\n    "glob": "^7.1.3",\n    "idb-keyval": "2.2.0",\n    "intl-messageformat-parser": "^1.8.1",\n    "jest-mock": "^27.3.0",\n    "jest-snapshot": "^28.1.0",\n    "jsdom": "^12.2.0",\n    "lighthouse-plugin-publisher-ads": "1.5.7-beta",\n    "lighthouse-plugin-soft-navigation": "^1.0.1",\n    "magic-string": "^0.25.7",\n    "mime-types": "^2.1.30",\n    "mocha": "^10.0.0",\n    "node-fetch": "^2.6.1",\n    "npm-run-posix-or-windows": "^2.0.2",\n    "pako": "^2.0.3",\n    "preact": "^10.7.2",\n    "pretty-json-stringify": "^0.0.2",\n    "puppeteer": "^21.0.1",\n    "resolve": "^1.22.1",\n    "rollup": "^2.52.7",\n    "rollup-plugin-polyfill-node": "^0.12.0",\n    "tabulator-tables": "^4.9.3",\n    "terser": "^5.18.2",\n    "testdouble": "^3.18.0",\n    "typed-query-selector": "^2.6.1",\n    "typescript": "^5.0.4",\n    "wait-for-expect": "^3.0.2",\n    "webtreemap-cdt": "^3.2.1"\n  },\n  "dependencies": {\n    "@sentry/node": "^6.17.4",\n    "axe-core": "4.7.2",\n    "chrome-launcher": "^1.0.0",\n    "configstore": "^5.0.1",\n    "csp_evaluator": "1.1.1",\n    "devtools-protocol": "0.0.1155343",\n    "enquirer": "^2.3.6",\n    "http-link-header": "^1.1.1",\n    "intl-messageformat": "^4.4.0",\n    "jpeg-js": "^0.4.4",\n    "js-library-detector": "^6.7.0",\n    "lighthouse-logger": "^2.0.1",\n    "lighthouse-stack-packs": "1.12.0",\n    "lodash": "^4.17.21",\n    "lookup-closest-locale": "6.2.0",\n    "metaviewport-parser": "0.3.0",\n    "open": "^8.4.0",\n    "parse-cache-control": "1.0.1",\n    "ps-list": "^8.0.0",\n    "puppeteer-core": "^21.0.1",\n    "robots-parser": "^3.0.1",\n    "semver": "^5.3.0",\n    "speedline-core": "^1.4.3",\n    "third-party-web": "^0.23.3",\n    "ws": "^7.0.0",\n    "yargs": "^17.3.1",\n    "yargs-parser": "^21.0.0"\n  },\n  "resolutions": {\n    "puppeteer/**/devtools-protocol": "0.0.1155343",\n    "puppeteer-core/**/devtools-protocol": "0.0.1155343"\n  },\n  "repository": "GoogleChrome/lighthouse",\n  "keywords": [\n    "google",\n    "chrome",\n    "devtools"\n  ],\n  "author": "The Lighthouse Authors",\n  "license": "Apache-2.0",\n  "bugs": {\n    "url": "https://github.com/GoogleChrome/lighthouse/issues"\n  },\n  "homepage": "https://github.com/GoogleChrome/lighthouse#readme"\n}\n'),Ii=Ni.version}));function Qi(e,t){if("object"!=typeof Intl)throw new Error("Lighthouse must be run in Node with `Intl` support. See https://nodejs.org/api/intl.html for help");let a=Intl.getCanonicalLocales(e),n=Intl.NumberFormat.supportedLocalesOf(a),r=t||Ti(),i=Object.fromEntries(r.map((e=>[e,{}]))),o=(0,ao.default)(n,i);return o||(0===Intl.NumberFormat.supportedLocalesOf("es").length&&Kt.warn("i18n","Requested locale not available in this version of node. The `full-icu` npm module can provide additional locales. For help, see https://github.com/GoogleChrome/lighthouse/blob/main/readme.md#how-do-i-get-localized-lighthouse-results-via-the-cli"),Kt.warn("i18n",`locale(s) '${e}' not available. Falling back to default '${xi}'`)),o||xi}function eo(e,t){e.startsWith("file://")&&(e=ei.fileURLToPath(e)),Ta.isAbsolute(e)&&(e=Ta.relative(Fi,e));let a={...no,...t};return o(((n,r)=>{let i=Object.keys(a).find((e=>a[e]===n));if(!i)throw new Error(`Could not locate: ${n}`);return{i18nId:`${(i in t?e:Ta.relative(Fi,ii({url:"core/lib/i18n/i18n.js"}))).replace(/\\/g,"/")} | ${i}`,values:r,formattedDefault:hi(n,r,xi)}}),"getIcuMessageFn")}function to(e){return"string"==typeof e||yi(e)}var ao,no,ro=s((()=>{J(),ka(),ri(),ao=d(Zi(),1),ea(),Mi(),Xi(),Mi(),oi(),no={ms:"{timeInMs, number, milliseconds} ms",seconds:"{timeInMs, number, seconds} s",displayValueByteSavings:"Potential savings of {wastedBytes, number, bytes} KiB",displayValueMsSavings:"Potential savings of {wastedMs, number, milliseconds} ms",displayValueElementsFound:"{nodeCount, plural, =1 {1 element found} other {# elements found}}",columnURL:"URL",columnSize:"Size",columnResourceSize:"Resource Size",columnTransferSize:"Transfer Size",columnCacheTTL:"Cache TTL",columnWastedBytes:"Potential Savings",columnWastedMs:"Potential Savings",columnBlockingTime:"Main-Thread Blocking Time",columnTimeSpent:"Time Spent",columnLocation:"Location",columnResourceType:"Resource Type",columnRequests:"Requests",columnName:"Name",columnSource:"Source",columnOverBudget:"Over Budget",columnElement:"Element",columnStartTime:"Start Time",columnDuration:"Duration",columnFailingElem:"Failing Elements",columnDescription:"Description",totalResourceType:"Total",documentResourceType:"Document",scriptResourceType:"Script",stylesheetResourceType:"Stylesheet",imageResourceType:"Image",mediaResourceType:"Media",fontResourceType:"Font",otherResourceType:"Other",thirdPartyResourceType:"Third-party",otherResourcesLabel:"Other resources",firstContentfulPaintMetric:"First Contentful Paint",interactiveMetric:"Time to Interactive",firstMeaningfulPaintMetric:"First Meaningful Paint",totalBlockingTimeMetric:"Total Blocking Time",maxPotentialFIDMetric:"Max Potential First Input Delay",speedIndexMetric:"Speed Index",largestContentfulPaintMetric:"Largest Contentful Paint",cumulativeLayoutShiftMetric:"Cumulative Layout Shift",interactionToNextPaint:"Interaction to Next Paint",itemSeverityLow:"Low",itemSeverityMedium:"Medium",itemSeverityHigh:"High"},o(Qi,"lookupLocale"),o(eo,"createIcuMessageFn"),o(to,"isStringOrIcuMessage")}));function io(e){if(!e)return[];let t=[];for(let a of e){let e=so.find((e=>e.requiredStacks.includes(`${a.detector}:${a.id}`)));if(!e)continue;let n=oo.default.find((t=>t.id===e.packId));if(!n){Kt.warn("StackPacks",`'${e.packId}' stack pack was matched but is not found in stack-packs lib`);continue}let r=eo(`node_modules/lighthouse-stack-packs/packs/${n.id}.js`,n.UIStrings),i={},o=n.UIStrings;for(let e in o)o[e]&&(i[e]=r(o[e]));t.push({id:n.id,title:n.title,iconDataURL:n.icon,descriptions:i})}return t.sort(((e,t)=>so.findIndex((t=>t.packId===e.id))-so.findIndex((e=>e.packId===t.id))))}var oo,so,lo,co,uo=s((()=>{J(),ea(),oo=d(Ji(),1),ro(),so=[{packId:"gatsby",requiredStacks:["js:gatsby"]},{packId:"wordpress",requiredStacks:["js:wordpress"]},{packId:"wix",requiredStacks:["js:wix"]},{packId:"wp-rocket",requiredStacks:["js:wp-rocket"]},{packId:"ezoic",requiredStacks:["js:ezoic"]},{packId:"drupal",requiredStacks:["js:drupal"]},{packId:"nitropack",requiredStacks:["js:nitropack"]},{packId:"amp",requiredStacks:["js:amp"]},{packId:"magento",requiredStacks:["js:magento"]},{packId:"octobercms",requiredStacks:["js:octobercms"]},{packId:"joomla",requiredStacks:["js:joomla"]},{packId:"next.js",requiredStacks:["js:next"]},{packId:"nuxt",requiredStacks:["js:nuxt"]},{packId:"angular",requiredStacks:["js:@angular/core"]},{packId:"react",requiredStacks:["js:react"]}],o(io,"getStackPacks")})),mo=s((()=>{J(),lo="function"==typeof Object.create?o((function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}),"inherits"):o((function(e,t){e.super_=t;var a=o((function(){}),"TempCtor");a.prototype=t.prototype,e.prototype=new a,e.prototype.constructor=e}),"inherits"),co=lo}));function po(e){if(!Ro(e)){for(var t=[],a=0;a<arguments.length;a++)t.push(fo(arguments[a]));return t.join(" ")}a=1;for(var n=arguments,r=n.length,i=String(e).replace(zo,(function(e){if("%%"===e)return"%";if(a>=r)return e;switch(e){case"%s":return String(n[a++]);case"%d":return Number(n[a++]);case"%j":try{return JSON.stringify(n[a++])}catch{return"[Circular]"}default:return e}})),o=n[a];a<r;o=n[++a])Ao(o)||!Io(o)?i+=" "+o:i+=" "+fo(o);return i}function ho(e,t){if(Fo(globalThis.process))return function(){return ho(e,t).apply(this,arguments)};if(!0===K.noDeprecation)return e;var a=!1;function n(){if(!a){if(K.throwDeprecation)throw new Error(t);K.traceDeprecation?console.trace(t):console.error(t),a=!0}return e.apply(this,arguments)}return o(n,"deprecated"),n}function go(e){if(Fo(Wo)&&(Wo=K.env.NODE_DEBUG||""),e=e.toUpperCase(),!Vo[e])if(new RegExp("\\b"+e+"\\b","i").test(Wo)){Vo[e]=function(){var t=po.apply(null,arguments);console.error("%s %d: %s",e,0,t)}}else Vo[e]=function(){};return Vo[e]}function fo(e,t){var a={seen:[],stylize:vo};return arguments.length>=3&&(a.depth=arguments[2]),arguments.length>=4&&(a.colors=arguments[3]),xo(t)?a.showHidden=t:t&&jo(a,t),Fo(a.showHidden)&&(a.showHidden=!1),Fo(a.depth)&&(a.depth=2),Fo(a.colors)&&(a.colors=!1),Fo(a.customInspect)&&(a.customInspect=!0),a.colors&&(a.stylize=yo),wo(a,e,a.depth)}function yo(e,t){var a=fo.styles[t];return a?"["+fo.colors[a][0]+"m"+e+"["+fo.colors[a][1]+"m":e}function vo(e,t){return e}function bo(e){var t={};return e.forEach((function(e,a){t[e]=!0})),t}function wo(e,t,a){if(e.customInspect&&t&&Lo(t.inspect)&&t.inspect!==fo&&(!t.constructor||t.constructor.prototype!==t)){var n=t.inspect(a,e);return Ro(n)||(n=wo(e,n,a)),n}var r=Do(e,t);if(r)return r;var i=Object.keys(t),o=bo(i);if(e.showHidden&&(i=Object.getOwnPropertyNames(t)),Po(t)&&(i.indexOf("message")>=0||i.indexOf("description")>=0))return Eo(t);if(0===i.length){if(Lo(t)){var s=t.name?": "+t.name:"";return e.stylize("[Function"+s+"]","special")}if(No(t))return e.stylize(RegExp.prototype.toString.call(t),"regexp");if(Mo(t))return e.stylize(Date.prototype.toString.call(t),"date");if(Po(t))return Eo(t)}var l,c="",u=!1,d=["{","}"];(ko(t)&&(u=!0,d=["[","]"]),Lo(t))&&(c=" [Function"+(t.name?": "+t.name:"")+"]");return No(t)&&(c=" "+RegExp.prototype.toString.call(t)),Mo(t)&&(c=" "+Date.prototype.toUTCString.call(t)),Po(t)&&(c=" "+Eo(t)),0!==i.length||u&&0!=t.length?a<0?No(t)?e.stylize(RegExp.prototype.toString.call(t),"regexp"):e.stylize("[Object]","special"):(e.seen.push(t),l=u?To(e,t,a,o,i):i.map((function(n){return So(e,t,a,o,n,u)})),e.seen.pop(),Co(l,c,d)):d[0]+c+d[1]}function Do(e,t){if(Fo(t))return e.stylize("undefined","undefined");if(Ro(t)){var a="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(a,"string")}return _o(t)?e.stylize(""+t,"number"):xo(t)?e.stylize(""+t,"boolean"):Ao(t)?e.stylize("null","null"):void 0}function Eo(e){return"["+Error.prototype.toString.call(e)+"]"}function To(e,t,a,n,r){for(var i=[],o=0,s=t.length;o<s;++o)Uo(t,String(o))?i.push(So(e,t,a,n,String(o),!0)):i.push("");return r.forEach((function(r){r.match(/^\d+$/)||i.push(So(e,t,a,n,r,!0))})),i}function So(e,t,a,n,r,i){var o,s,l;if((l=Object.getOwnPropertyDescriptor(t,r)||{value:t[r]}).get?s=l.set?e.stylize("[Getter/Setter]","special"):e.stylize("[Getter]","special"):l.set&&(s=e.stylize("[Setter]","special")),Uo(n,r)||(o="["+r+"]"),s||(e.seen.indexOf(l.value)<0?(s=Ao(a)?wo(e,l.value,null):wo(e,l.value,a-1)).indexOf("\n")>-1&&(s=i?s.split("\n").map((function(e){return"  "+e})).join("\n").substr(2):"\n"+s.split("\n").map((function(e){return"   "+e})).join("\n")):s=e.stylize("[Circular]","special")),Fo(o)){if(i&&r.match(/^\d+$/))return s;(o=JSON.stringify(""+r)).match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(o=o.substr(1,o.length-2),o=e.stylize(o,"name")):(o=o.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),o=e.stylize(o,"string"))}return o+": "+s}function Co(e,t,a){return e.reduce((function(e,t){return t.indexOf("\n")>=0&&0,e+t.replace(/\u001b\[\d\d?m/g,"").length+1}),0)>60?a[0]+(""===t?"":t+"\n ")+" "+e.join(",\n  ")+" "+a[1]:a[0]+t+" "+e.join(", ")+" "+a[1]}function ko(e){return Array.isArray(e)}function xo(e){return"boolean"==typeof e}function Ao(e){return null===e}function _o(e){return"number"==typeof e}function Ro(e){return"string"==typeof e}function Fo(e){return void 0===e}function No(e){return Io(e)&&"[object RegExp]"===Oo(e)}function Io(e){return"object"==typeof e&&null!==e}function Mo(e){return Io(e)&&"[object Date]"===Oo(e)}function Po(e){return Io(e)&&("[object Error]"===Oo(e)||e instanceof Error)}function Lo(e){return"function"==typeof e}function Oo(e){return Object.prototype.toString.call(e)}function jo(e,t){if(!t||!Io(t))return e;for(var a=Object.keys(t),n=a.length;n--;)e[a[n]]=t[a[n]];return e}function Uo(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function Bo(e){if("function"!=typeof e)throw new TypeError('The "original" argument must be of type Function');if(Ho&&e[Ho]){var t;if("function"!=typeof(t=e[Ho]))throw new TypeError('The "util.promisify.custom" argument must be of type Function');return Object.defineProperty(t,Ho,{value:t,enumerable:!1,writable:!1,configurable:!0}),t}function t(){for(var t,a,n=new Promise((function(e,n){t=e,a=n})),r=[],i=0;i<arguments.length;i++)r.push(arguments[i]);r.push((function(e,n){e?a(e):t(n)}));try{e.apply(this,r)}catch(e){a(e)}return n}return o(t,"fn"),Object.setPrototypeOf(t,Object.getPrototypeOf(e)),Ho&&Object.defineProperty(t,Ho,{value:t,enumerable:!1,writable:!1,configurable:!0}),Object.defineProperties(t,qo(e))}var qo,zo,Vo,Wo,Ho,Go=s((()=>{J(),Y(),mo(),qo=Object.getOwnPropertyDescriptors||o((function(e){for(var t=Object.keys(e),a={},n=0;n<t.length;n++)a[t[n]]=Object.getOwnPropertyDescriptor(e,t[n]);return a}),"getOwnPropertyDescriptors"),zo=/%[sdj%]/g,o(po,"format"),o(ho,"deprecate"),Vo={},o(go,"debuglog"),o(fo,"inspect"),fo.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},fo.styles={special:"cyan",number:"yellow",boolean:"yellow",undefined:"grey",null:"bold",string:"green",date:"magenta",regexp:"red"},o(yo,"stylizeWithColor"),o(vo,"stylizeNoColor"),o(bo,"arrayToHash"),o(wo,"formatValue"),o(Do,"formatPrimitive"),o(Eo,"formatError"),o(To,"formatArray"),o(So,"formatProperty"),o(Co,"reduceToSingleString"),o(ko,"isArray"),o(xo,"isBoolean"),o(Ao,"isNull"),o(_o,"isNumber"),o(Ro,"isString"),o(Fo,"isUndefined"),o(No,"isRegExp"),o(Io,"isObject"),o(Mo,"isDate"),o(Po,"isError"),o(Lo,"isFunction"),o(Oo,"objectToString"),o(jo,"_extend"),o(Uo,"hasOwnProperty"),Ho=typeof Symbol<"u"?Symbol("util.promisify.custom"):void 0,o(Bo,"promisify"),Bo.custom=Ho}));function $o(){this.head=null,this.tail=null,this.length=0}var Ko,Yo=s((()=>{J(),lt(),Ko=$o,o($o,"BufferList"),$o.prototype.push=function(e){var t={data:e,next:null};this.length>0?this.tail.next=t:this.head=t,this.tail=t,++this.length},$o.prototype.unshift=function(e){var t={data:e,next:this.head};0===this.length&&(this.tail=t),this.head=t,++this.length},$o.prototype.shift=function(){if(0!==this.length){var e=this.head.data;return 1===this.length?this.head=this.tail=null:this.head=this.head.next,--this.length,e}},$o.prototype.clear=function(){this.head=this.tail=null,this.length=0},$o.prototype.join=function(e){if(0===this.length)return"";for(var t=this.head,a=""+t.data;t=t.next;)a+=e+t.data;return a},$o.prototype.concat=function(e){if(0===this.length)return oe.alloc(0);if(1===this.length)return this.head.data;for(var t=oe.allocUnsafe(e>>>0),a=this.head,n=0;a;)a.data.copy(t,n),n+=a.data.length,a=a.next;return t}}));function Jo(e){if(e&&!ts(e))throw new Error("Unknown encoding: "+e)}function Zo(e){switch(this.encoding=(e||"utf8").toLowerCase().replace(/[-_]/,""),Jo(e),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=Qo;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=es;break;default:return void(this.write=Xo)}this.charBuffer=new oe(6),this.charReceived=0,this.charLength=0}function Xo(e){return e.toString(this.encoding)}function Qo(e){this.charReceived=e.length%2,this.charLength=this.charReceived?2:0}function es(e){this.charReceived=e.length%3,this.charLength=this.charReceived?3:0}var ts,as=s((()=>{J(),lt(),ts=oe.isEncoding||function(e){switch(e&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},o(Jo,"assertEncoding"),o(Zo,"StringDecoder"),Zo.prototype.write=function(e){for(var t="";this.charLength;){var a=e.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:e.length;if(e.copy(this.charBuffer,this.charReceived,0,a),this.charReceived+=a,this.charReceived<this.charLength)return"";if(e=e.slice(a,e.length),!((r=(t=this.charBuffer.slice(0,this.charLength).toString(this.encoding)).charCodeAt(t.length-1))>=55296&&r<=56319)){if(this.charReceived=this.charLength=0,0===e.length)return t;break}this.charLength+=this.surrogateSize,t=""}this.detectIncompleteChar(e);var n=e.length;this.charLength&&(e.copy(this.charBuffer,0,e.length-this.charReceived,n),n-=this.charReceived);var r;n=(t+=e.toString(this.encoding,0,n)).length-1;if((r=t.charCodeAt(n))>=55296&&r<=56319){var i=this.surrogateSize;return this.charLength+=i,this.charReceived+=i,this.charBuffer.copy(this.charBuffer,i,0,i),e.copy(this.charBuffer,0,0,i),t.substring(0,n)}return t},Zo.prototype.detectIncompleteChar=function(e){for(var t=e.length>=3?3:e.length;t>0;t--){var a=e[e.length-t];if(1==t&&a>>5==6){this.charLength=2;break}if(t<=2&&a>>4==14){this.charLength=3;break}if(t<=3&&a>>3==30){this.charLength=4;break}}this.charReceived=t},Zo.prototype.end=function(e){var t="";if(e&&e.length&&(t=this.write(e)),this.charReceived){var a=this.charReceived,n=this.charBuffer,r=this.encoding;t+=n.slice(0,a).toString(r)}return t},o(Xo,"passThroughWrite"),o(Qo,"utf16DetectIncompleteChar"),o(es,"base64DetectIncompleteChar")}));function ns(e,t,a){if("function"==typeof e.prependListener)return e.prependListener(t,a);e._events&&e._events[t]?Array.isArray(e._events[t])?e._events[t].unshift(a):e._events[t]=[a,e._events[t]]:e.on(t,a)}function rs(e,t){return e.listeners(t).length}function is(e,t){e=e||{},this.objectMode=!!e.objectMode,t instanceof el&&(this.objectMode=this.objectMode||!!e.readableObjectMode);var a=e.highWaterMark,n=this.objectMode?16:16384;this.highWaterMark=a||0===a?a:n,this.highWaterMark=~~this.highWaterMark,this.buffer=new Ko,this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.defaultEncoding=e.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,e.encoding&&(this.decoder=new Zo(e.encoding),this.encoding=e.encoding)}function os(e){if(!(this instanceof os))return new os(e);this._readableState=new is(e,this),this.readable=!0,e&&"function"==typeof e.read&&(this._read=e.read),Ct.call(this)}function ss(e,t,a,n,r){var i=ds(t,a);if(i)e.emit("error",i);else if(null===a)t.reading=!1,ms(e,t);else if(t.objectMode||a&&a.length>0)if(t.ended&&!r){var o=new Error("stream.push() after EOF");e.emit("error",o)}else if(t.endEmitted&&r){var s=new Error("stream.unshift() after end event");e.emit("error",s)}else{var l;t.decoder&&!r&&!n&&(a=t.decoder.write(a),l=!t.objectMode&&0===a.length),r||(t.reading=!1),l||(t.flowing&&0===t.length&&!t.sync?(e.emit("data",a),e.read(0)):(t.length+=t.objectMode?1:a.length,r?t.buffer.unshift(a):t.buffer.push(a),t.needReadable&&ps(e))),gs(e,t)}else r||(t.reading=!1);return ls(t)}function ls(e){return!e.ended&&(e.needReadable||e.length<e.highWaterMark||0===e.length)}function cs(e){return e>=Fs?e=Fs:(e--,e|=e>>>1,e|=e>>>2,e|=e>>>4,e|=e>>>8,e|=e>>>16,e++),e}function us(e,t){return e<=0||0===t.length&&t.ended?0:t.objectMode?1:e!=e?t.flowing&&t.length?t.buffer.head.data.length:t.length:(e>t.highWaterMark&&(t.highWaterMark=cs(e)),e<=t.length?e:t.ended?t.length:(t.needReadable=!0,0))}function ds(e,t){var a=null;return!Buffer.isBuffer(t)&&"string"!=typeof t&&null!=t&&!e.objectMode&&(a=new TypeError("Invalid non-string/buffer chunk")),a}function ms(e,t){if(!t.ended){if(t.decoder){var a=t.decoder.end();a&&a.length&&(t.buffer.push(a),t.length+=t.objectMode?1:a.length)}t.ended=!0,ps(e)}}function ps(e){var t=e._readableState;t.needReadable=!1,t.emittedReadable||(Rs("emitReadable",t.flowing),t.emittedReadable=!0,t.sync?v(hs,e):hs(e))}function hs(e){Rs("emit readable"),e.emit("readable"),Ds(e)}function gs(e,t){t.readingMore||(t.readingMore=!0,v(fs,e,t))}function fs(e,t){for(var a=t.length;!t.reading&&!t.flowing&&!t.ended&&t.length<t.highWaterMark&&(Rs("maybeReadMore read 0"),e.read(0),a!==t.length);)a=t.length;t.readingMore=!1}function ys(e){return function(){var t=e._readableState;Rs("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,0===t.awaitDrain&&e.listeners("data").length&&(t.flowing=!0,Ds(e))}}function vs(e){Rs("readable nexttick read 0"),e.read(0)}function bs(e,t){t.resumeScheduled||(t.resumeScheduled=!0,v(ws,e,t))}function ws(e,t){t.reading||(Rs("resume read 0"),e.read(0)),t.resumeScheduled=!1,t.awaitDrain=0,e.emit("resume"),Ds(e),t.flowing&&!t.reading&&e.read(0)}function Ds(e){var t=e._readableState;for(Rs("flow",t.flowing);t.flowing&&null!==e.read(););}function Es(e,t){return 0===t.length?null:(t.objectMode?a=t.buffer.shift():!e||e>=t.length?(a=t.decoder?t.buffer.join(""):1===t.buffer.length?t.buffer.head.data:t.buffer.concat(t.length),t.buffer.clear()):a=Ts(e,t.buffer,t.decoder),a);var a}function Ts(e,t,a){var n;return e<t.head.data.length?(n=t.head.data.slice(0,e),t.head.data=t.head.data.slice(e)):n=e===t.head.data.length?t.shift():a?Ss(e,t):Cs(e,t),n}function Ss(e,t){var a=t.head,n=1,r=a.data;for(e-=r.length;a=a.next;){var i=a.data,o=e>i.length?i.length:e;if(o===i.length?r+=i:r+=i.slice(0,e),0===(e-=o)){o===i.length?(++n,a.next?t.head=a.next:t.head=t.tail=null):(t.head=a,a.data=i.slice(o));break}++n}return t.length-=n,r}function Cs(e,t){var a=Buffer.allocUnsafe(e),n=t.head,r=1;for(n.data.copy(a),e-=n.data.length;n=n.next;){var i=n.data,o=e>i.length?i.length:e;if(i.copy(a,a.length-e,0,o),0===(e-=o)){o===i.length?(++r,n.next?t.head=n.next:t.head=t.tail=null):(t.head=n,n.data=i.slice(o));break}++r}return t.length-=r,a}function ks(e){var t=e._readableState;if(t.length>0)throw new Error('"endReadable()" called on non-empty stream');t.endEmitted||(t.ended=!0,v(xs,t,e))}function xs(e,t){!e.endEmitted&&0===e.length&&(e.endEmitted=!0,t.readable=!1,t.emit("end"))}function As(e,t){for(var a=0,n=e.length;a<n;a++)t(e[a],a)}function _s(e,t){for(var a=0,n=e.length;a<n;a++)if(e[a]===t)return a;return-1}var Rs,Fs,Ns=s((()=>{J(),kt(),Go(),Yo(),as(),ol(),Y(),os.ReadableState=is,Rs=go("stream"),co(os,Ct),o(ns,"prependListener"),o(rs,"listenerCount"),o(is,"ReadableState"),o(os,"Readable"),os.prototype.push=function(e,t){var a=this._readableState;return!a.objectMode&&"string"==typeof e&&((t=t||a.defaultEncoding)!==a.encoding&&(e=Buffer.from(e,t),t="")),ss(this,a,e,t,!1)},os.prototype.unshift=function(e){return ss(this,this._readableState,e,"",!0)},os.prototype.isPaused=function(){return!1===this._readableState.flowing},o(ss,"readableAddChunk"),o(ls,"needMoreData"),os.prototype.setEncoding=function(e){return this._readableState.decoder=new Zo(e),this._readableState.encoding=e,this},Fs=8388608,o(cs,"computeNewHighWaterMark"),o(us,"howMuchToRead"),os.prototype.read=function(e){Rs("read",e),e=parseInt(e,10);var t=this._readableState,a=e;if(0!==e&&(t.emittedReadable=!1),0===e&&t.needReadable&&(t.length>=t.highWaterMark||t.ended))return Rs("read: emitReadable",t.length,t.ended),0===t.length&&t.ended?ks(this):ps(this),null;if(0===(e=us(e,t))&&t.ended)return 0===t.length&&ks(this),null;var n,r=t.needReadable;return Rs("need readable",r),(0===t.length||t.length-e<t.highWaterMark)&&Rs("length less than watermark",r=!0),t.ended||t.reading?Rs("reading or ended",r=!1):r&&(Rs("do read"),t.reading=!0,t.sync=!0,0===t.length&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1,t.reading||(e=us(a,t))),null===(n=e>0?Es(e,t):null)?(t.needReadable=!0,e=0):t.length-=e,0===t.length&&(t.ended||(t.needReadable=!0),a!==e&&t.ended&&ks(this)),null!==n&&this.emit("data",n),n},o(ds,"chunkInvalid"),o(ms,"onEofChunk"),o(ps,"emitReadable"),o(hs,"emitReadable_"),o(gs,"maybeReadMore"),o(fs,"maybeReadMore_"),os.prototype._read=function(e){this.emit("error",new Error("not implemented"))},os.prototype.pipe=function(e,t){var a=this,n=this._readableState;switch(n.pipesCount){case 0:n.pipes=e;break;case 1:n.pipes=[n.pipes,e];break;default:n.pipes.push(e)}n.pipesCount+=1,Rs("pipe count=%d opts=%j",n.pipesCount,t);var r=!t||!1!==t.end?s:u;function i(e){Rs("onunpipe"),e===a&&u()}function s(){Rs("onend"),e.end()}n.endEmitted?v(r):a.once("end",r),e.on("unpipe",i),o(i,"onunpipe"),o(s,"onend");var l=ys(a);e.on("drain",l);var c=!1;function u(){Rs("cleanup"),e.removeListener("close",h),e.removeListener("finish",g),e.removeListener("drain",l),e.removeListener("error",p),e.removeListener("unpipe",i),a.removeListener("end",s),a.removeListener("end",u),a.removeListener("data",m),c=!0,n.awaitDrain&&(!e._writableState||e._writableState.needDrain)&&l()}o(u,"cleanup");var d=!1;function m(t){Rs("ondata"),d=!1,!1===e.write(t)&&!d&&((1===n.pipesCount&&n.pipes===e||n.pipesCount>1&&-1!==_s(n.pipes,e))&&!c&&(Rs("false write response, pause",a._readableState.awaitDrain),a._readableState.awaitDrain++,d=!0),a.pause())}function p(t){Rs("onerror",t),f(),e.removeListener("error",p),0===rs(e,"error")&&e.emit("error",t)}function h(){e.removeListener("finish",g),f()}function g(){Rs("onfinish"),e.removeListener("close",h),f()}function f(){Rs("unpipe"),a.unpipe(e)}return a.on("data",m),o(m,"ondata"),o(p,"onerror"),ns(e,"error",p),o(h,"onclose"),e.once("close",h),o(g,"onfinish"),e.once("finish",g),o(f,"unpipe"),e.emit("pipe",a),n.flowing||(Rs("pipe resume"),a.resume()),e},o(ys,"pipeOnDrain"),os.prototype.unpipe=function(e){var t=this._readableState;if(0===t.pipesCount)return this;if(1===t.pipesCount)return e&&e!==t.pipes||(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this)),this;if(!e){var a=t.pipes,n=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var r=0;r<n;r++)a[r].emit("unpipe",this);return this}var i=_s(t.pipes,e);return-1===i||(t.pipes.splice(i,1),t.pipesCount-=1,1===t.pipesCount&&(t.pipes=t.pipes[0]),e.emit("unpipe",this)),this},os.prototype.on=function(e,t){var a=Ct.prototype.on.call(this,e,t);if("data"===e)!1!==this._readableState.flowing&&this.resume();else if("readable"===e){var n=this._readableState;!n.endEmitted&&!n.readableListening&&(n.readableListening=n.needReadable=!0,n.emittedReadable=!1,n.reading?n.length&&ps(this):v(vs,this))}return a},os.prototype.addListener=os.prototype.on,o(vs,"nReadingNextTick"),os.prototype.resume=function(){var e=this._readableState;return e.flowing||(Rs("resume"),e.flowing=!0,bs(this,e)),this},o(bs,"resume"),o(ws,"resume_"),os.prototype.pause=function(){return Rs("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(Rs("pause"),this._readableState.flowing=!1,this.emit("pause")),this},o(Ds,"flow"),os.prototype.wrap=function(e){var t=this._readableState,a=!1,n=this;for(var r in e.on("end",(function(){if(Rs("wrapped end"),t.decoder&&!t.ended){var e=t.decoder.end();e&&e.length&&n.push(e)}n.push(null)})),e.on("data",(function(r){(Rs("wrapped data"),t.decoder&&(r=t.decoder.write(r)),t.objectMode&&null==r||!(t.objectMode||r&&r.length))||(n.push(r)||(a=!0,e.pause()))})),e)void 0===this[r]&&"function"==typeof e[r]&&(this[r]=function(t){return function(){return e[t].apply(e,arguments)}}(r));return As(["error","close","destroy","pause","resume"],(function(t){e.on(t,n.emit.bind(n,t))})),n._read=function(t){Rs("wrapped _read",t),a&&(a=!1,e.resume())},n},os._fromList=Es,o(Es,"fromList"),o(Ts,"fromListPartial"),o(Ss,"copyFromBufferString"),o(Cs,"copyFromBuffer"),o(ks,"endReadable"),o(xs,"endReadableNT"),o(As,"forEach"),o(_s,"indexOf")}));function Is(){}function Ms(e,t,a){this.chunk=e,this.encoding=t,this.callback=a,this.next=null}function Ps(e,t){Object.defineProperty(this,"buffer",{get:ho((function(){return this.getBuffer()}),"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")}),e=e||{},this.objectMode=!!e.objectMode,t instanceof el&&(this.objectMode=this.objectMode||!!e.writableObjectMode);var a=e.highWaterMark,n=this.objectMode?16:16384;this.highWaterMark=a||0===a?a:n,this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var r=!1===e.decodeStrings;this.decodeStrings=!r,this.defaultEncoding=e.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(e){Ws(t,e)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new Xs(this)}function Ls(e){if(!(this instanceof Ls||this instanceof el))return new Ls(e);this._writableState=new Ps(e,this),this.writable=!0,e&&("function"==typeof e.write&&(this._write=e.write),"function"==typeof e.writev&&(this._writev=e.writev)),ut.call(this)}function Os(e,t){var a=new Error("write after end");e.emit("error",a),v(t,a)}function js(e,t,a,n){var r=!0,i=!1;return null===a?i=new TypeError("May not write null values to stream"):!oe.isBuffer(a)&&"string"!=typeof a&&void 0!==a&&!t.objectMode&&(i=new TypeError("Invalid non-string/buffer chunk")),i&&(e.emit("error",i),v(n,i),r=!1),r}function Us(e,t,a){return!e.objectMode&&!1!==e.decodeStrings&&"string"==typeof t&&(t=oe.from(t,a)),t}function Bs(e,t,a,n,r){a=Us(t,a,n),oe.isBuffer(a)&&(n="buffer");var i=t.objectMode?1:a.length;t.length+=i;var o=t.length<t.highWaterMark;if(o||(t.needDrain=!0),t.writing||t.corked){var s=t.lastBufferedRequest;t.lastBufferedRequest=new Ms(a,n,r),s?s.next=t.lastBufferedRequest:t.bufferedRequest=t.lastBufferedRequest,t.bufferedRequestCount+=1}else qs(e,t,!1,i,a,n,r);return o}function qs(e,t,a,n,r,i,o){t.writelen=n,t.writecb=o,t.writing=!0,t.sync=!0,a?e._writev(r,t.onwrite):e._write(r,i,t.onwrite),t.sync=!1}function zs(e,t,a,n,r){--t.pendingcb,a?v(r,n):r(n),e._writableState.errorEmitted=!0,e.emit("error",n)}function Vs(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0}function Ws(e,t){var a=e._writableState,n=a.sync,r=a.writecb;if(Vs(a),t)zs(e,a,n,t,r);else{var i=Ks(a);!i&&!a.corked&&!a.bufferProcessing&&a.bufferedRequest&&$s(e,a),n?v(Hs,e,a,i,r):Hs(e,a,i,r)}}function Hs(e,t,a,n){a||Gs(e,t),t.pendingcb--,n(),Js(e,t)}function Gs(e,t){0===t.length&&t.needDrain&&(t.needDrain=!1,e.emit("drain"))}function $s(e,t){t.bufferProcessing=!0;var a=t.bufferedRequest;if(e._writev&&a&&a.next){var n=t.bufferedRequestCount,r=new Array(n),i=t.corkedRequestsFree;i.entry=a;for(var o=0;a;)r[o]=a,a=a.next,o+=1;qs(e,t,!0,t.length,r,"",i.finish),t.pendingcb++,t.lastBufferedRequest=null,i.next?(t.corkedRequestsFree=i.next,i.next=null):t.corkedRequestsFree=new Xs(t)}else{for(;a;){var s=a.chunk,l=a.encoding,c=a.callback;if(qs(e,t,!1,t.objectMode?1:s.length,s,l,c),a=a.next,t.writing)break}null===a&&(t.lastBufferedRequest=null)}t.bufferedRequestCount=0,t.bufferedRequest=a,t.bufferProcessing=!1}function Ks(e){return e.ending&&0===e.length&&null===e.bufferedRequest&&!e.finished&&!e.writing}function Ys(e,t){t.prefinished||(t.prefinished=!0,e.emit("prefinish"))}function Js(e,t){var a=Ks(t);return a&&(0===t.pendingcb?(Ys(e,t),t.finished=!0,e.emit("finish")):Ys(e,t)),a}function Zs(e,t,a){t.ending=!0,Js(e,t),a&&(t.finished?v(a):e.once("finish",a)),t.ended=!0,e.writable=!1}function Xs(e){var t=this;this.next=null,this.entry=null,this.finish=function(a){var n=t.entry;for(t.entry=null;n;){var r=n.callback;e.pendingcb--,r(a),n=n.next}e.corkedRequestsFree?e.corkedRequestsFree.next=t:e.corkedRequestsFree=t}}var Qs=s((()=>{J(),Go(),lt(),kt(),ol(),Y(),Ls.WritableState=Ps,co(Ls,ut),o(Is,"nop"),o(Ms,"WriteReq"),o(Ps,"WritableState"),Ps.prototype.getBuffer=o((function(){for(var e=this.bufferedRequest,t=[];e;)t.push(e),e=e.next;return t}),"writableStateGetBuffer"),o(Ls,"Writable"),Ls.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe, not readable"))},o(Os,"writeAfterEnd"),o(js,"validChunk"),Ls.prototype.write=function(e,t,a){var n=this._writableState,r=!1;return"function"==typeof t&&(a=t,t=null),oe.isBuffer(e)?t="buffer":t||(t=n.defaultEncoding),"function"!=typeof a&&(a=Is),n.ended?Os(this,a):js(this,n,e,a)&&(n.pendingcb++,r=Bs(this,n,e,t,a)),r},Ls.prototype.cork=function(){this._writableState.corked++},Ls.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,!e.writing&&!e.corked&&!e.finished&&!e.bufferProcessing&&e.bufferedRequest&&$s(this,e))},Ls.prototype.setDefaultEncoding=o((function(e){if("string"==typeof e&&(e=e.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((e+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+e);return this._writableState.defaultEncoding=e,this}),"setDefaultEncoding"),o(Us,"decodeChunk"),o(Bs,"writeOrBuffer"),o(qs,"doWrite"),o(zs,"onwriteError"),o(Vs,"onwriteStateUpdate"),o(Ws,"onwrite"),o(Hs,"afterWrite"),o(Gs,"onwriteDrain"),o($s,"clearBuffer"),Ls.prototype._write=function(e,t,a){a(new Error("not implemented"))},Ls.prototype._writev=null,Ls.prototype.end=function(e,t,a){var n=this._writableState;"function"==typeof e?(a=e,e=null,t=null):"function"==typeof t&&(a=t,t=null),null!=e&&this.write(e,t),n.corked&&(n.corked=1,this.uncork()),!n.ending&&!n.finished&&Zs(this,n,a)},o(Ks,"needFinish"),o(Ys,"prefinish"),o(Js,"finishMaybe"),o(Zs,"endWritable"),o(Xs,"CorkedRequest")}));function el(e){if(!(this instanceof el))return new el(e);os.call(this,e),Ls.call(this,e),e&&!1===e.readable&&(this.readable=!1),e&&!1===e.writable&&(this.writable=!1),this.allowHalfOpen=!0,e&&!1===e.allowHalfOpen&&(this.allowHalfOpen=!1),this.once("end",tl)}function tl(){this.allowHalfOpen||this._writableState.ended||v(al,this)}function al(e){e.end()}var nl,rl,il,ol=s((()=>{for(J(),Go(),Y(),Ns(),Qs(),co(el,os),nl=Object.keys(Ls.prototype),il=0;il<nl.length;il++)rl=nl[il],el.prototype[rl]||(el.prototype[rl]=Ls.prototype[rl]);o(el,"Duplex"),o(tl,"onend"),o(al,"onEndNT")}));function sl(e){this.afterTransform=function(t,a){return ll(e,t,a)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null}function ll(e,t,a){var n=e._transformState;n.transforming=!1;var r=n.writecb;if(!r)return e.emit("error",new Error("no writecb in Transform class"));n.writechunk=null,n.writecb=null,null!=a&&e.push(a),r(t);var i=e._readableState;i.reading=!1,(i.needReadable||i.length<i.highWaterMark)&&e._read(i.highWaterMark)}function cl(e){if(!(this instanceof cl))return new cl(e);el.call(this,e),this._transformState=new sl(this);var t=this;this._readableState.needReadable=!0,this._readableState.sync=!1,e&&("function"==typeof e.transform&&(this._transform=e.transform),"function"==typeof e.flush&&(this._flush=e.flush)),this.once("prefinish",(function(){"function"==typeof this._flush?this._flush((function(e){ul(t,e)})):ul(t)}))}function ul(e,t){if(t)return e.emit("error",t);var a=e._writableState,n=e._transformState;if(a.length)throw new Error("Calling transform done when ws.length != 0");if(n.transforming)throw new Error("Calling transform done when still transforming");return e.push(null)}var dl=s((()=>{J(),ol(),Go(),co(cl,el),o(sl,"TransformState"),o(ll,"afterTransform"),o(cl,"Transform"),cl.prototype.push=function(e,t){return this._transformState.needTransform=!1,el.prototype.push.call(this,e,t)},cl.prototype._transform=function(e,t,a){throw new Error("Not implemented")},cl.prototype._write=function(e,t,a){var n=this._transformState;if(n.writecb=a,n.writechunk=e,n.writeencoding=t,!n.transforming){var r=this._readableState;(n.needTransform||r.needReadable||r.length<r.highWaterMark)&&this._read(r.highWaterMark)}},cl.prototype._read=function(e){var t=this._transformState;null!==t.writechunk&&t.writecb&&!t.transforming?(t.transforming=!0,this._transform(t.writechunk,t.writeencoding,t.afterTransform)):t.needTransform=!0},o(ul,"done")}));function ml(e){if(!(this instanceof ml))return new ml(e);cl.call(this,e)}var pl=s((()=>{J(),dl(),Go(),co(ml,cl),o(ml,"PassThrough"),ml.prototype._transform=function(e,t,a){a(null,e)}}));function hl(){Ct.call(this)}var gl,fl,yl,vl,bl,wl,Dl,El,Tl,Sl=s((()=>{J(),kt(),Go(),ol(),Ns(),Qs(),dl(),pl(),co(hl,Ct),hl.Readable=os,hl.Writable=Ls,hl.Duplex=el,hl.Transform=cl,hl.PassThrough=ml,hl.Stream=hl,gl=hl,o(hl,"Stream"),hl.prototype.pipe=function(e,t){var a=this;function n(t){e.writable&&!1===e.write(t)&&a.pause&&a.pause()}function r(){a.readable&&a.resume&&a.resume()}o(n,"ondata"),a.on("data",n),o(r,"ondrain"),e.on("drain",r),!e._isStdio&&(!t||!1!==t.end)&&(a.on("end",s),a.on("close",l));var i=!1;function s(){i||(i=!0,e.end())}function l(){i||(i=!0,"function"==typeof e.destroy&&e.destroy())}function c(e){if(u(),0===Ct.listenerCount(this,"error"))throw e}function u(){a.removeListener("data",n),e.removeListener("drain",r),a.removeListener("end",s),a.removeListener("close",l),a.removeListener("error",c),e.removeListener("error",c),a.removeListener("end",u),a.removeListener("close",u),e.removeListener("close",u)}return o(s,"onend"),o(l,"onclose"),o(c,"onerror"),a.on("error",c),e.on("error",c),o(u,"cleanup"),a.on("end",u),a.on("close",u),e.on("close",u),e.emit("pipe",a),e}})),Cl=s((()=>{J(),(fl=class e{static{o(this,"BaseNode")}constructor(e){this._id=e,this._isMainDocument=!1,this._dependents=[],this._dependencies=[]}get id(){return this._id}get type(){throw new Error("Unimplemented")}get startTime(){throw new Error("Unimplemented")}get endTime(){throw new Error("Unimplemented")}setIsMainDocument(e){this._isMainDocument=e}isMainDocument(){return this._isMainDocument}getDependents(){return this._dependents.slice()}getNumberOfDependents(){return this._dependents.length}getDependencies(){return this._dependencies.slice()}getNumberOfDependencies(){return this._dependencies.length}getRootNode(){let e=this;for(;e._dependencies.length;)e=e._dependencies[0];return e}addDependent(e){e.addDependency(this)}addDependency(e){if(e===this)throw new Error("Cannot add dependency on itself");this._dependencies.includes(e)||(e._dependents.push(this),this._dependencies.push(e))}removeDependent(e){e.removeDependency(this)}removeDependency(e){if(!this._dependencies.includes(e))return;let t=e._dependents.indexOf(this);e._dependents.splice(t,1),this._dependencies.splice(this._dependencies.indexOf(e),1)}removeAllDependencies(){for(let e of this._dependencies.slice())this.removeDependency(e)}isDependentOn(e){let t=!1;return this.traverse((a=>{t||(t=a===e)}),(e=>t?[]:e.getDependencies())),t}cloneWithoutRelationships(){let t=new e(this.id);return t.setIsMainDocument(this._isMainDocument),t}cloneWithRelationships(e){let t=this.getRootNode(),a=new Map;t.traverse((t=>{if(!a.has(t.id)){if(void 0===e)return void a.set(t.id,t.cloneWithoutRelationships());e(t)&&t.traverse((e=>a.set(e.id,e.cloneWithoutRelationships())),(e=>e._dependencies.filter((e=>!a.has(e.id)))))}})),t.traverse((e=>{let t=a.get(e.id);if(t)for(let n of e._dependencies){let e=a.get(n.id);if(!e)throw new Error("Dependency somehow not cloned");t.addDependency(e)}}));let n=a.get(this.id);if(!n)throw new Error("Cloned graph missing node");return n}traverse(e,t){for(let{node:a,traversalPath:n}of this.traverseGenerator(t))e(a,n)}*traverseGenerator(e){e||(e=o((e=>e.getDependents()),"getNextNodes"));let t=[[this]],a=new Set([this.id]);for(;t.length;){let n=t.shift(),r=n[0];yield{node:r,traversalPath:n};for(let i of e(r))a.has(i.id)||(a.add(i.id),t.push([i,...n]))}}static hasCycle(t,a="both"){if("both"===a)return e.hasCycle(t,"dependents")||e.hasCycle(t,"dependencies");let n=new Set,r=[],i=[t],o=new Map([[t,0]]);for(;i.length;){let e=i.pop();if(r.includes(e))return!0;if(n.has(e))continue;for(;r.length>o.get(e);)r.pop();n.add(e),r.push(e);let t="dependents"===a?e._dependents:e._dependencies;for(let e of t)i.includes(e)||(i.push(e),o.set(e,r.length))}return!1}canDependOn(e){return e.startTime<=this.startTime}}).TYPES={NETWORK:"network",CPU:"cpu"}})),kl=s((()=>{J(),yl=class e{static{o(this,"TcpConnection")}constructor(e,t,a=0,n=!0,r=!1){this._warmed=!1,this._ssl=n,this._h2=r,this._rtt=e,this._throughput=t,this._serverLatency=a,this._congestionWindow=10,this._h2OverflowBytesDownloaded=0}static maximumSaturatedConnections(e,t){let a=1e3/e*1460*8;return Math.floor(t/a)}_computeMaximumCongestionWindowInSegments(){let e=this._throughput/8*(this._rtt/1e3);return Math.floor(e/1460)}setThroughput(e){this._throughput=e}setCongestionWindow(e){this._congestionWindow=e}setWarmed(e){this._warmed=e}isWarm(){return this._warmed}isH2(){return this._h2}get congestionWindow(){return this._congestionWindow}setH2OverflowBytesDownloaded(e){this._h2&&(this._h2OverflowBytesDownloaded=e)}clone(){return Object.assign(new e(this._rtt,this._throughput),this)}simulateDownloadUntil(e,t){let{timeAlreadyElapsed:a=0,maximumTimeToElapse:n=1/0,dnsResolutionTime:r=0}=t||{};this._warmed&&this._h2&&(e-=this._h2OverflowBytesDownloaded);let i=this._rtt,o=i/2,s=this._computeMaximumCongestionWindowInSegments(),l=o;this._warmed||(l=r+o+o+o+(this._ssl?i:0));let c=Math.ceil(l/i),u=l+this._serverLatency+o;this._warmed&&this._h2&&(u=0);let d=Math.max(u-a,0),m=n-d,p=Math.min(this._congestionWindow,s),h=0;d>0?h=1460*p:c=0;let g=0,f=e-h;for(;f>0&&g<=m;){c++,g+=i,p=Math.max(Math.min(s,2*p),1);let e=1460*p;h+=e,f-=e}let y,v=d+g,b=this._h2?Math.max(h-e,0):0,w=Math.max(Math.min(h,e),0);return y=this._warmed?this._h2?{timeToFirstByte:u}:{connectionTime:l,timeToFirstByte:u}:{dnsResolutionTime:r,connectionTime:l-r,sslTime:this._ssl?i:void 0,timeToFirstByte:u},{roundTrips:c,timeElapsed:v,bytesDownloaded:w,extraBytesDownloaded:b,congestionWindow:p,connectionTiming:y}}}})),xl=s((()=>{J(),ro(),bl=eo("core/lib/lh-error.js",vl={didntCollectScreenshots:"Chrome didn't collect any screenshots during the page load. Please make sure there is content visible on the page, and then try re-running Lighthouse. ({errorCode})",badTraceRecording:"Something went wrong with recording the trace over your page load. Please run Lighthouse again. ({errorCode})",noFcp:"The page did not paint any content. Please ensure you keep the browser window in the foreground during the load and try again. ({errorCode})",noLcp:"The page did not display content that qualifies as a Largest Contentful Paint (LCP). Ensure the page has a valid LCP element and then try again. ({errorCode})",pageLoadTookTooLong:"Your page took too long to load. Please follow the opportunities in the report to reduce your page load time, and then try re-running Lighthouse. ({errorCode})",pageLoadFailed:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests.",pageLoadFailedWithStatusCode:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests. (Status code: {statusCode})",pageLoadFailedWithDetails:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests. (Details: {errorDetails})",pageLoadFailedInsecure:"The URL you have provided does not have a valid security certificate. {securityMessages}",pageLoadFailedInterstitial:"Chrome prevented page load with an interstitial. Make sure you are testing the correct URL and that the server is properly responding to all requests.",internalChromeError:"An internal Chrome error occurred. Please restart Chrome and try re-running Lighthouse.",requestContentTimeout:"Fetching resource content has exceeded the allotted time",notHtml:"The page provided is not HTML (served as MIME type {mimeType}).",urlInvalid:"The URL you have provided appears to be invalid.",protocolTimeout:"Waiting for DevTools protocol response has exceeded the allotted time. (Method: {protocolMethod})",dnsFailure:"DNS servers could not resolve the provided domain.",pageLoadFailedHung:"Lighthouse was unable to reliably load the URL you requested because the page stopped responding.",criTimeout:"Timeout waiting for initial Debugger Protocol connection.",missingRequiredArtifact:"Required {artifactName} gatherer did not run.",erroredRequiredArtifact:"Required {artifactName} gatherer encountered an error: {errorMessage}",oldChromeDoesNotSupportFeature:"This version of Chrome is too old to support '{featureName}'. Use a newer version to see full results."}),wl="__LighthouseErrorSentinel",Dl="__ErrorSentinel",El=class e extends Error{static{o(this,"LighthouseError")}constructor(t,a,n){super(t.code,n),this.name="LighthouseError",this.code=t.code,this.friendlyMessage=bl(t.message,{errorCode:this.code,...a}),this.lhrRuntimeError=!!t.lhrRuntimeError,a&&Object.assign(this,a),Error.captureStackTrace(this,e)}static fromProtocolMessage(t,a){let n=Object.values(e.errors).filter((e=>e.pattern)).find((e=>e.pattern&&e.pattern.test(a.message)));if(n)return new e(n);let r=`(${t}): ${a.message}`;a.data&&(r+=` (${a.data})`);let i=new Error(`Protocol error ${r}`);return Object.assign(i,{protocolMethod:t,protocolError:a.message})}static stringifyReplacer(t){if(t instanceof e){let{name:e,code:a,message:n,friendlyMessage:r,lhrRuntimeError:i,stack:o,cause:s,...l}=t;return{sentinel:wl,code:a,stack:o,cause:s,properties:l}}if(t instanceof Error){let{message:e,stack:a,cause:n}=t,r=t.code;return{sentinel:Dl,message:e,code:r,stack:a,cause:n}}throw new Error("Invalid value for LighthouseError stringification")}static parseReviver(t,a){if("object"==typeof a&&null!==a){if(a.sentinel===wl){let{code:t,stack:n,cause:r,properties:i}=a,o=e.errors[t],s=new e(o,i,{cause:r});return s.stack=n,s}if(a.sentinel===Dl){let{message:e,code:t,stack:n,cause:r}=a,i=new Error(e,r?{cause:r}:void 0);return Object.assign(i,{code:t,stack:n}),i}}return a}},Tl={NO_SPEEDLINE_FRAMES:{code:"NO_SPEEDLINE_FRAMES",message:vl.didntCollectScreenshots,lhrRuntimeError:!0},SPEEDINDEX_OF_ZERO:{code:"SPEEDINDEX_OF_ZERO",message:vl.didntCollectScreenshots,lhrRuntimeError:!0},NO_SCREENSHOTS:{code:"NO_SCREENSHOTS",message:vl.didntCollectScreenshots,lhrRuntimeError:!0},INVALID_SPEEDLINE:{code:"INVALID_SPEEDLINE",message:vl.didntCollectScreenshots,lhrRuntimeError:!0},NO_TRACING_STARTED:{code:"NO_TRACING_STARTED",message:vl.badTraceRecording,lhrRuntimeError:!0},NO_RESOURCE_REQUEST:{code:"NO_RESOURCE_REQUEST",message:vl.badTraceRecording,lhrRuntimeError:!0},NO_NAVSTART:{code:"NO_NAVSTART",message:vl.badTraceRecording,lhrRuntimeError:!0},NO_FCP:{code:"NO_FCP",message:vl.noFcp,lhrRuntimeError:!0},NO_DCL:{code:"NO_DCL",message:vl.badTraceRecording,lhrRuntimeError:!0},NO_FMP:{code:"NO_FMP",message:vl.badTraceRecording},NO_LCP:{code:"NO_LCP",message:vl.noLcp},NO_LCP_ALL_FRAMES:{code:"NO_LCP_ALL_FRAMES",message:vl.noLcp},UNSUPPORTED_OLD_CHROME:{code:"UNSUPPORTED_OLD_CHROME",message:vl.oldChromeDoesNotSupportFeature},NO_TTI_CPU_IDLE_PERIOD:{code:"NO_TTI_CPU_IDLE_PERIOD",message:vl.pageLoadTookTooLong},NO_TTI_NETWORK_IDLE_PERIOD:{code:"NO_TTI_NETWORK_IDLE_PERIOD",message:vl.pageLoadTookTooLong},NO_DOCUMENT_REQUEST:{code:"NO_DOCUMENT_REQUEST",message:vl.pageLoadFailed,lhrRuntimeError:!0},FAILED_DOCUMENT_REQUEST:{code:"FAILED_DOCUMENT_REQUEST",message:vl.pageLoadFailedWithDetails,lhrRuntimeError:!0},ERRORED_DOCUMENT_REQUEST:{code:"ERRORED_DOCUMENT_REQUEST",message:vl.pageLoadFailedWithStatusCode,lhrRuntimeError:!0},INSECURE_DOCUMENT_REQUEST:{code:"INSECURE_DOCUMENT_REQUEST",message:vl.pageLoadFailedInsecure,lhrRuntimeError:!0},CHROME_INTERSTITIAL_ERROR:{code:"CHROME_INTERSTITIAL_ERROR",message:vl.pageLoadFailedInterstitial,lhrRuntimeError:!0},PAGE_HUNG:{code:"PAGE_HUNG",message:vl.pageLoadFailedHung,lhrRuntimeError:!0},NOT_HTML:{code:"NOT_HTML",message:vl.notHtml,lhrRuntimeError:!0},TRACING_ALREADY_STARTED:{code:"TRACING_ALREADY_STARTED",message:vl.internalChromeError,pattern:/Tracing.*started/,lhrRuntimeError:!0},PARSING_PROBLEM:{code:"PARSING_PROBLEM",message:vl.internalChromeError,pattern:/Parsing problem/,lhrRuntimeError:!0},READ_FAILED:{code:"READ_FAILED",message:vl.internalChromeError,pattern:/Read failed/,lhrRuntimeError:!0},INVALID_URL:{code:"INVALID_URL",message:vl.urlInvalid},PROTOCOL_TIMEOUT:{code:"PROTOCOL_TIMEOUT",message:vl.protocolTimeout,lhrRuntimeError:!0},DNS_FAILURE:{code:"DNS_FAILURE",message:vl.dnsFailure,lhrRuntimeError:!0},CRI_TIMEOUT:{code:"CRI_TIMEOUT",message:vl.criTimeout,lhrRuntimeError:!0},MISSING_REQUIRED_ARTIFACT:{code:"MISSING_REQUIRED_ARTIFACT",message:vl.missingRequiredArtifact},ERRORED_REQUIRED_ARTIFACT:{code:"ERRORED_REQUIRED_ARTIFACT",message:vl.erroredRequiredArtifact}},El.errors=Tl,El.NO_ERROR="NO_ERROR",El.UNKNOWN_ERROR="UNKNOWN_ERROR"}));function Al(e){return e&&e.startsWith("chrome://")?(e.endsWith("/")&&(e=e.replace(/\/$/,"")),e.replace(/^chrome:\/\/chrome\//,"chrome://")):e}var _l,Rl,Fl,Nl,Il,Ml,Pl,Ll,Ol,jl,Ul,Bl,ql=s((()=>{J(),kr(),xl(),_l=["https:","http:","chrome:","chrome-extension:"],Rl=["data","https","wss","blob","chrome","chrome-extension","about","filesystem"],Fl=["localhost","127.0.0.1"],Nl=["blob","data","intent","file","filesystem","chrome-extension"],o(Al,"rewriteChromeInternalUrl"),(Il=class{static{o(this,"UrlUtils")}static isValid(e){try{return new URL(e),!0}catch{return!1}}static hostsMatch(e,t){try{return new URL(e).host===new URL(t).host}catch{return!1}}static originsMatch(e,t){try{return new URL(e).origin===new URL(t).origin}catch{return!1}}static getOrigin(e){try{let t=new URL(e);return"chrome-extension:"===t.protocol?br.getChromeExtensionOrigin(e):t.host&&t.origin||null}catch{return null}}static rootDomainsMatch(e,t){let a,n;try{a=br.createOrReturnURL(e),n=br.createOrReturnURL(t)}catch{return!1}return!(!a.hostname||!n.hostname)&&br.getRootDomain(a)===br.getRootDomain(n)}static getURLDisplayName(e,t){return br.getURLDisplayName(new URL(e),t)}static elideDataURI(e){try{return"data:"===new URL(e).protocol?br.truncate(e,100):e}catch{return e}}static equalWithExcludedFragments(e,t){[e,t]=[e,t].map(Al);try{let a=new URL(e);a.hash="";let n=new URL(t);return n.hash="",a.href===n.href}catch{return!1}}static isProtocolAllowed(e){try{let t=new URL(e);return _l.includes(t.protocol)}catch{return!1}}static isLikeLocalhost(e){return Fl.includes(e)||e.endsWith(".localhost")}static isSecureScheme(e){return Rl.includes(e)}static isNonNetworkProtocol(e){let t=e.includes(":")?e.slice(0,e.indexOf(":")):e;return Nl.includes(t)}static guessMimeType(e){let t;try{t=new URL(e)}catch{return}if("data:"===t.protocol){let e=t.pathname.match(/^(image\/(png|jpeg|svg\+xml|webp|gif|avif))[;,]/);return e?e[1]:void 0}let a=t.pathname.toLowerCase().match(/\.(png|jpeg|jpg|svg|webp|gif|avif)$/);if(!a)return;let n=a[1];return"svg"===n?"image/svg+xml":"jpg"===n?"image/jpeg":`image/${n}`}static normalizeUrl(e){if(e&&this.isValid(e)&&this.isProtocolAllowed(e))return new URL(e).href;throw new El(El.errors.INVALID_URL)}}).INVALID_URL_DEBUG_STRING="Lighthouse was unable to determine the URL of some script executions. It's possible a Chrome extension or other eval'd code is the source.",Ml=Il})),zl=s((()=>{J(),ql(),14336,.4,Pl={Document:.9,XHR:.9,Fetch:.9},Ll=class e{static{o(this,"NetworkAnalyzer")}static get SUMMARY(){return"__SUMMARY__"}static groupByOrigin(e){let t=new Map;return e.forEach((e=>{let a=e.parsedURL.securityOrigin,n=t.get(a)||[];n.push(e),t.set(a,n)})),t}static getSummary(e){let t;if(e.sort(((e,t)=>e-t)),0===e.length)t=e[0];else if(e.length%2==0){t=(e[Math.floor((e.length-1)/2)]+e[Math.floor((e.length-1)/2)+1])/2}else t=e[Math.floor((e.length-1)/2)];return{min:e[0],max:e[e.length-1],avg:e.reduce(((e,t)=>e+t),0)/e.length,median:t}}static summarize(t){let a=new Map,n=[];for(let[r,i]of t)a.set(r,e.getSummary(i)),n.push(...i);return a.set(e.SUMMARY,e.getSummary(n)),a}static _estimateValueByOrigin(t,a){let n=e.estimateIfConnectionWasReused(t),r=e.groupByOrigin(t),i=new Map;for(let[e,t]of r.entries()){let r=[];for(let e of t){let t=e.timing;if(!t)continue;let i=a({record:e,timing:t,connectionReused:n.get(e.requestId)});typeof i<"u"&&(r=r.concat(i))}r.length&&i.set(e,r)}return i}static _estimateRTTViaConnectionTiming(e){let{timing:t,connectionReused:a,record:n}=e;if(a)return;if(globalThis.isLightrider&&n.lrStatistics)return n.protocol.startsWith("h3")?n.lrStatistics.TCPMs:[n.lrStatistics.TCPMs/2,n.lrStatistics.TCPMs/2];let{connectStart:r,sslStart:i,sslEnd:o,connectEnd:s}=t;return s>=0&&r>=0&&n.protocol.startsWith("h3")?s-r:i>=0&&o>=0&&i!==r?[s-i,i-r]:r>=0&&s>=0?s-r:void 0}static _estimateRTTViaDownloadTiming(e){let{timing:t,connectionReused:a,record:n}=e;if(a||n.transferSize<=14336||!Number.isFinite(t.receiveHeadersEnd)||t.receiveHeadersEnd<0)return;let r=n.networkEndTime-n.networkRequestTime-t.receiveHeadersEnd,i=Math.log2(n.transferSize/14336);return i>5?void 0:r/i}static _estimateRTTViaSendStartTiming(e){let{timing:t,connectionReused:a,record:n}=e;if(a||!Number.isFinite(t.sendStart)||t.sendStart<0)return;let r=1;return n.protocol.startsWith("h3")||(r+=1),"https"===n.parsedURL.scheme&&(r+=1),t.sendStart/r}static _estimateRTTViaHeadersEndTiming(e){let{timing:t,connectionReused:a,record:n}=e;if(!Number.isFinite(t.receiveHeadersEnd)||t.receiveHeadersEnd<0||!n.resourceType)return;let r=Pl[n.resourceType]||.4,i=t.receiveHeadersEnd*r,o=1;return a||(o+=1,n.protocol.startsWith("h3")||(o+=1),"https"===n.parsedURL.scheme&&(o+=1)),Math.max((t.receiveHeadersEnd-i)/o,3)}static _estimateResponseTimeByOrigin(t,a){return e._estimateValueByOrigin(t,(({record:t,timing:n})=>{if(globalThis.isLightrider&&t.lrStatistics)return t.lrStatistics.requestMs;if(!Number.isFinite(n.receiveHeadersEnd)||n.receiveHeadersEnd<0||!Number.isFinite(n.sendEnd)||n.sendEnd<0)return;let r=n.receiveHeadersEnd-n.sendEnd,i=t.parsedURL.securityOrigin,o=a.get(i)||a.get(e.SUMMARY)||0;return Math.max(r-o,0)}))}static canTrustConnectionInformation(e){let t=new Map;for(let a of e){let e=t.get(a.connectionId)||!a.connectionReused;t.set(a.connectionId,e)}return!(t.size<=1)&&Array.from(t.values()).every((e=>e))}static estimateIfConnectionWasReused(t,a){let{forceCoarseEstimates:n=!1}=a||{};if(!n&&e.canTrustConnectionInformation(t))return new Map(t.map((e=>[e.requestId,!!e.connectionReused])));let r=new Map,i=e.groupByOrigin(t);for(let[e,t]of i.entries()){let e=t.map((e=>e.networkEndTime)).reduce(((e,t)=>Math.min(e,t)),1/0);for(let a of t)r.set(a.requestId,a.networkRequestTime>=e||"h2"===a.protocol);let a=t.reduce(((e,t)=>e.networkRequestTime>t.networkRequestTime?t:e));r.set(a.requestId,!1)}return r}static estimateRTTByOrigin(t,a){let{forceCoarseEstimates:n=!1,coarseEstimateMultiplier:r=.3,useDownloadEstimates:i=!0,useSendStartEstimates:s=!0,useHeadersEndEstimates:l=!0}=a||{},c=e.estimateIfConnectionWasReused(t),u=e.groupByOrigin(t),d=new Map;for(let[e,t]of u.entries()){let a=function(e,a=1){for(let n of t){let t=n.timing;if(!t)continue;let r=e({record:n,timing:t,connectionReused:c.get(n.requestId)});void 0!==r&&(Array.isArray(r)?u.push(...r.map((e=>e*a))):u.push(r*a))}};o(a,"collectEstimates");let u=[];n||a(this._estimateRTTViaConnectionTiming),u.length||(i&&a(this._estimateRTTViaDownloadTiming,r),s&&a(this._estimateRTTViaSendStartTiming,r),l&&a(this._estimateRTTViaHeadersEndTiming,r)),u.length&&d.set(e,u)}if(!d.size)throw new Error("No timing information available");return e.summarize(d)}static estimateServerResponseTimeByOrigin(t,a){let n=(a||{}).rttByOrigin;if(!n){n=new Map;let r=e.estimateRTTByOrigin(t,a);for(let[e,t]of r.entries())n.set(e,t.min)}let r=e._estimateResponseTimeByOrigin(t,n);return e.summarize(r)}static estimateThroughput(e){let t=0,a=e.reduce(((e,a)=>("data"===a.parsedURL?.scheme||a.failed||!a.finished||a.statusCode>300||!a.transferSize||(t+=a.transferSize,e.push({time:a.responseHeadersEndTime/1e3,isStart:!0}),e.push({time:a.networkEndTime/1e3,isStart:!1})),e)),[]).sort(((e,t)=>e.time-t.time));if(!a.length)return 1/0;let n=0,r=0,i=0;return a.forEach((e=>{e.isStart?(0===n&&(r=e.time),n++):(n--,0===n&&(i+=e.time-r))})),8*t/i}static findResourceForUrl(e,t){return e.find((e=>t.startsWith(e.url)&&Ml.equalWithExcludedFragments(e.url,t)))}static resolveRedirects(e){for(;e.redirectDestination;)e=e.redirectDestination;return e}}})),Vl=s((()=>{J(),ta(),zl(),kl(),30,Ol=["https","wss"],6,jl=class{static{o(this,"ConnectionPool")}constructor(e,t){this._options=t,this._records=e,this._connectionsByOrigin=new Map,this._connectionsByRecord=new Map,this._connectionsInUse=new Set,this._connectionReusedByRequestId=Ll.estimateIfConnectionWasReused(e,{forceCoarseEstimates:!0}),this._initializeConnections()}connectionsInUse(){return Array.from(this._connectionsInUse)}_initializeConnections(){let e=this._connectionReusedByRequestId,t=this._options.additionalRttByOrigin,a=this._options.serverResponseTimeByOrigin,n=Ll.groupByOrigin(this._records);for(let[r,i]of n.entries()){let n=[],o=t.get(r)||0,s=a.get(r)||30;for(let t of i){if(e.get(t.requestId))continue;let a=Ol.includes(t.parsedURL.scheme),r="h2"===t.protocol,i=new yl(this._options.rtt+o,this._options.throughput,s,a,r);n.push(i)}if(!n.length)throw new Error(`Could not find a connection for origin: ${r}`);let l=n[0].isH2()?1:6;for(;n.length<l;)n.push(n[0].clone());this._connectionsByOrigin.set(r,n)}}_findAvailableConnectionWithLargestCongestionWindow(e,t){let{ignoreConnectionReused:a,observedConnectionWasReused:n}=t,r=null;for(let t=0;t<e.length;t++){let i=e[t];if(!a&&i._warmed!==n||this._connectionsInUse.has(i))continue;let o=r?.congestionWindow||-1/0;i.congestionWindow>o&&(r=i)}return r}acquire(e,t={}){if(this._connectionsByRecord.has(e))throw new Error("Record already has a connection");let a=e.parsedURL.securityOrigin,n=!!this._connectionReusedByRequestId.get(e.requestId),r=this._connectionsByOrigin.get(a)||[],i=this._findAvailableConnectionWithLargestCongestionWindow(r,{ignoreConnectionReused:t.ignoreConnectionReused,observedConnectionWasReused:n});return i?(this._connectionsInUse.add(i),this._connectionsByRecord.set(e,i),i):null}acquireActiveConnectionFromRecord(e){let t=this._connectionsByRecord.get(e);if(!t)throw new Error("Could not find an active connection for record");return t}release(e){let t=this._connectionsByRecord.get(e);this._connectionsByRecord.delete(e),this._connectionsInUse.delete(t)}}})),Wl=s((()=>{J(),ta(),2,(Ul=class e{static{o(this,"DNSCache")}constructor({rtt:e}){this._rtt=e,this._resolvedDomainNames=new Map}getTimeUntilResolution(t,a){let{requestedAt:n=0,shouldUpdateCache:r=!1}=a||{},i=t.parsedURL.host,o=this._resolvedDomainNames.get(i),s=this._rtt*e.RTT_MULTIPLIER;if(o){let e=Math.max(o.resolvedAt-n,0);s=Math.min(e,s)}let l=n+s;return r&&this._updateCacheResolvedAtIfNeeded(t,l),s}_updateCacheResolvedAtIfNeeded(e,t){let a=e.parsedURL.host,n=this._resolvedDomainNames.get(a)||{resolvedAt:t};n.resolvedAt=Math.min(n.resolvedAt,t),this._resolvedDomainNames.set(a,n)}setResolvedAt(e,t){this._resolvedDomainNames.set(e,{resolvedAt:t})}}).RTT_MULTIPLIER=2})),Hl=s((()=>{J(),Cl(),Bl=class{static{o(this,"SimulatorTimingMap")}constructor(){this._nodeTimings=new Map}getNodes(){return Array.from(this._nodeTimings.keys())}setReadyToStart(e,t){this._nodeTimings.set(e,t)}setInProgress(e,t){let a={...this.getQueued(e),startTime:t.startTime,timeElapsed:0};this._nodeTimings.set(e,e.type===fl.TYPES.NETWORK?{...a,timeElapsedOvershoot:0,bytesDownloaded:0}:a)}setCompleted(e,t){let a={...this.getInProgress(e),endTime:t.endTime,connectionTiming:t.connectionTiming};this._nodeTimings.set(e,a)}setCpu(e,t){let a={...this.getCpuStarted(e),timeElapsed:t.timeElapsed};this._nodeTimings.set(e,a)}setCpuEstimated(e,t){let a={...this.getCpuStarted(e),estimatedTimeElapsed:t.estimatedTimeElapsed};this._nodeTimings.set(e,a)}setNetwork(e,t){let a={...this.getNetworkStarted(e),timeElapsed:t.timeElapsed,timeElapsedOvershoot:t.timeElapsedOvershoot,bytesDownloaded:t.bytesDownloaded};this._nodeTimings.set(e,a)}setNetworkEstimated(e,t){let a={...this.getNetworkStarted(e),estimatedTimeElapsed:t.estimatedTimeElapsed};this._nodeTimings.set(e,a)}getQueued(e){let t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);return t}getCpuStarted(e){let t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if("bytesDownloaded"in t)throw new Error(`Node ${e.id} timing not valid`);return t}getNetworkStarted(e){let t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if(!("bytesDownloaded"in t))throw new Error(`Node ${e.id} timing not valid`);return t}getInProgress(e){let t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if(!("estimatedTimeElapsed"in t))throw new Error(`Node ${e.id} not yet in progress`);return t}getCompleted(e){let t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if(!("estimatedTimeElapsed"in t))throw new Error(`Node ${e.id} not yet in progress`);if(!("endTime"in t))throw new Error(`Node ${e.id} not yet completed`);return t}}})),Gl={};c(Gl,{defaultNavigationConfig:()=>Zl,defaultSettings:()=>Jl,nonSimulatedPassConfigOverrides:()=>Xl,screenEmulationMetrics:()=>Kl,throttling:()=>$l,userAgents:()=>Yl});var $l,Kl,Yl,Jl,Zl,Xl,Ql,ec,tc,ac,nc,rc,ic,oc=s((()=>{J(),Kl={mobile:{mobile:!0,width:412,height:823,deviceScaleFactor:1.75,disabled:!1},desktop:{mobile:!1,width:1350,height:940,deviceScaleFactor:1,disabled:!1}},"Mozilla/5.0 (Linux; Android 11; moto g power (2022)) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/109.0.0.0 Mobile Safari/537.36","Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/109.0.0.0 Safari/537.36",Yl={mobile:"Mozilla/5.0 (Linux; Android 11; moto g power (2022)) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/109.0.0.0 Mobile Safari/537.36",desktop:"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/109.0.0.0 Safari/537.36"},Jl={output:"json",maxWaitForFcp:3e4,maxWaitForLoad:45e3,pauseAfterFcpMs:1e3,pauseAfterLoadMs:1e3,networkQuietThresholdMs:1e3,cpuQuietThresholdMs:1e3,formFactor:"mobile",throttling:($l={DEVTOOLS_RTT_ADJUSTMENT_FACTOR:3.75,DEVTOOLS_THROUGHPUT_ADJUSTMENT_FACTOR:.9,mobileSlow4G:{rttMs:150,throughputKbps:1638.4,requestLatencyMs:562.5,downloadThroughputKbps:1474.5600000000002,uploadThroughputKbps:675,cpuSlowdownMultiplier:4},mobileRegular3G:{rttMs:300,throughputKbps:700,requestLatencyMs:1125,downloadThroughputKbps:630,uploadThroughputKbps:630,cpuSlowdownMultiplier:4},desktopDense4G:{rttMs:40,throughputKbps:10240,cpuSlowdownMultiplier:1,requestLatencyMs:0,downloadThroughputKbps:0,uploadThroughputKbps:0}}).mobileSlow4G,throttlingMethod:"simulate",screenEmulation:Kl.mobile,emulatedUserAgent:Yl.mobile,auditMode:!1,gatherMode:!1,disableStorageReset:!1,debugNavigation:!1,channel:"node",usePassiveGathering:!1,disableFullPageScreenshot:!1,skipAboutBlank:!1,blankPage:"about:blank",budgets:null,locale:"en-US",blockedUrlPatterns:null,additionalTraceCategories:null,extraHeaders:null,precomputedLanternData:null,onlyAudits:null,onlyCategories:null,skipAudits:null},Zl={id:"defaultPass",loadFailureMode:"fatal",disableThrottling:!1,disableStorageReset:!1,pauseAfterFcpMs:0,pauseAfterLoadMs:0,networkQuietThresholdMs:0,cpuQuietThresholdMs:0,blockedUrlPatterns:[],blankPage:"about:blank",artifacts:[]},Xl={pauseAfterFcpMs:5250,pauseAfterLoadMs:5250,networkQuietThresholdMs:5250,cpuQuietThresholdMs:5250}})),sc=s((()=>{J(),ta(),Cl(),kl(),Vl(),Wl(),Hl(),oc(),Ql=$l.mobileSlow4G,10,.5,1e4,ec={NotReadyToStart:0,ReadyToStart:1,InProgress:2,Complete:3},tc={VeryHigh:0,High:.25,Medium:.5,Low:1,VeryLow:2},ac=new Map,nc=class e{static{o(this,"Simulator")}constructor(e){if(this._options=Object.assign({rtt:Ql.rttMs,throughput:1024*Ql.throughputKbps,maximumConcurrentRequests:10,cpuSlowdownMultiplier:Ql.cpuSlowdownMultiplier,layoutTaskMultiplier:.5,additionalRttByOrigin:new Map,serverResponseTimeByOrigin:new Map},e),this._rtt=this._options.rtt,this._throughput=this._options.throughput,this._maximumConcurrentRequests=Math.max(Math.min(yl.maximumSaturatedConnections(this._rtt,this._throughput),this._options.maximumConcurrentRequests),1),this._cpuSlowdownMultiplier=this._options.cpuSlowdownMultiplier,this._layoutTaskMultiplier=this._cpuSlowdownMultiplier*this._options.layoutTaskMultiplier,this._cachedNodeListByStartPosition=[],this._flexibleOrdering=!1,this._nodeTimings=new Bl,this._numberInProgressByType=new Map,this._nodes={},this._dns=new Ul({rtt:this._rtt}),this._connectionPool=null,!Number.isFinite(this._rtt))throw new Error(`Invalid rtt ${this._rtt}`);if(!Number.isFinite(this._throughput))throw new Error(`Invalid rtt ${this._throughput}`)}get rtt(){return this._rtt}_initializeConnectionPool(e){let t=[];e.getRootNode().traverse((e=>{e.type===fl.TYPES.NETWORK&&t.push(e.record)})),this._connectionPool=new jl(t,this._options)}_initializeAuxiliaryData(){this._nodeTimings=new Bl,this._numberInProgressByType=new Map,this._nodes={},this._cachedNodeListByStartPosition=[];for(let e of Object.values(ec))this._nodes[e]=new Set}_numberInProgress(e){return this._numberInProgressByType.get(e)||0}_markNodeAsReadyToStart(t,a){let n=e._computeNodeStartPosition(t),r=this._cachedNodeListByStartPosition.findIndex((t=>e._computeNodeStartPosition(t)>n)),i=-1===r?this._cachedNodeListByStartPosition.length:r;this._cachedNodeListByStartPosition.splice(i,0,t),this._nodes[ec.ReadyToStart].add(t),this._nodes[ec.NotReadyToStart].delete(t),this._nodeTimings.setReadyToStart(t,{queuedTime:a})}_markNodeAsInProgress(e,t){let a=this._cachedNodeListByStartPosition.indexOf(e);this._cachedNodeListByStartPosition.splice(a,1),this._nodes[ec.InProgress].add(e),this._nodes[ec.ReadyToStart].delete(e),this._numberInProgressByType.set(e.type,this._numberInProgress(e.type)+1),this._nodeTimings.setInProgress(e,{startTime:t})}_markNodeAsComplete(e,t,a){this._nodes[ec.Complete].add(e),this._nodes[ec.InProgress].delete(e),this._numberInProgressByType.set(e.type,this._numberInProgress(e.type)-1),this._nodeTimings.setCompleted(e,{endTime:t,connectionTiming:a});for(let a of e.getDependents())a.getDependencies().some((e=>!this._nodes[ec.Complete].has(e)))||this._markNodeAsReadyToStart(a,t)}_acquireConnection(e){return this._connectionPool.acquire(e,{ignoreConnectionReused:this._flexibleOrdering})}_getNodesSortedByStartPosition(){return Array.from(this._cachedNodeListByStartPosition)}_startNodeIfPossible(e,t){if(e.type!==fl.TYPES.CPU){if(e.type!==fl.TYPES.NETWORK)throw new Error("Unsupported");!e.isConnectionless&&(this._numberInProgress(e.type)>=this._maximumConcurrentRequests||!this._acquireConnection(e.record))||this._markNodeAsInProgress(e,t)}else 0===this._numberInProgress(e.type)&&this._markNodeAsInProgress(e,t)}_updateNetworkCapacity(){let e=this._numberInProgress(fl.TYPES.NETWORK);if(0!==e)for(let t of this._connectionPool.connectionsInUse())t.setThroughput(this._throughput/e)}_estimateTimeRemaining(e){if(e.type===fl.TYPES.CPU)return this._estimateCPUTimeRemaining(e);if(e.type===fl.TYPES.NETWORK)return this._estimateNetworkTimeRemaining(e);throw new Error("Unsupported")}_estimateCPUTimeRemaining(e){let t=this._nodeTimings.getCpuStarted(e),a=e.didPerformLayout()?this._layoutTaskMultiplier:this._cpuSlowdownMultiplier,n=Math.min(Math.round(e.event.dur/1e3*a),1e4)-t.timeElapsed;return this._nodeTimings.setCpuEstimated(e,{estimatedTimeElapsed:n}),n}_estimateNetworkTimeRemaining(e){let t=e.record,a=this._nodeTimings.getNetworkStarted(e),n=0;if(e.fromDiskCache)n=8+(t.resourceSize||0)/1024/1024*20-a.timeElapsed;else if(e.isNonNetworkProtocol)n=2+(t.resourceSize||0)/1024/1024*10-a.timeElapsed;else{let e=this._connectionPool.acquireActiveConnectionFromRecord(t),r=this._dns.getTimeUntilResolution(t,{requestedAt:a.startTime,shouldUpdateCache:!0}),i=a.timeElapsed;n=e.simulateDownloadUntil(t.transferSize-a.bytesDownloaded,{timeAlreadyElapsed:i,dnsResolutionTime:r,maximumTimeToElapse:1/0}).timeElapsed}let r=n+a.timeElapsedOvershoot;return this._nodeTimings.setNetworkEstimated(e,{estimatedTimeElapsed:r}),r}_findNextNodeCompletionTime(){let e=1/0;for(let t of this._nodes[ec.InProgress])e=Math.min(e,this._estimateTimeRemaining(t));return e}_updateProgressMadeInTimePeriod(e,t,a){let n=this._nodeTimings.getInProgress(e),r=n.estimatedTimeElapsed===t;if(e.type===fl.TYPES.CPU||e.isConnectionless)return r?this._markNodeAsComplete(e,a):n.timeElapsed+=t;if(e.type!==fl.TYPES.NETWORK)throw new Error("Unsupported");if(!("bytesDownloaded"in n))throw new Error("Invalid timing data");let i=e.record,o=this._connectionPool.acquireActiveConnectionFromRecord(i),s=this._dns.getTimeUntilResolution(i,{requestedAt:n.startTime,shouldUpdateCache:!0}),l=o.simulateDownloadUntil(i.transferSize-n.bytesDownloaded,{dnsResolutionTime:s,timeAlreadyElapsed:n.timeElapsed,maximumTimeToElapse:t-n.timeElapsedOvershoot});o.setCongestionWindow(l.congestionWindow),o.setH2OverflowBytesDownloaded(l.extraBytesDownloaded),r?(o.setWarmed(!0),this._connectionPool.release(i),this._markNodeAsComplete(e,a,l.connectionTiming)):(n.timeElapsed+=l.timeElapsed,n.timeElapsedOvershoot+=l.timeElapsed-t,n.bytesDownloaded+=l.bytesDownloaded)}_computeFinalNodeTimings(){let e=this._nodeTimings.getNodes().map((e=>[e,this._nodeTimings.getCompleted(e)]));e.sort(((e,t)=>e[1].startTime-t[1].startTime));let t=e.map((([e,t])=>[e,{startTime:t.startTime,endTime:t.endTime,duration:t.endTime-t.startTime}]));return{nodeTimings:new Map(t),completeNodeTimings:new Map(e)}}getOptions(){return this._options}simulate(e,t){if(fl.hasCycle(e))throw new Error("Cannot simulate graph with cycle");t=Object.assign({label:void 0,flexibleOrdering:!1},t),this._flexibleOrdering=!!t.flexibleOrdering,this._dns=new Ul({rtt:this._rtt}),this._initializeConnectionPool(e),this._initializeAuxiliaryData();let a=this._nodes[ec.NotReadyToStart],n=this._nodes[ec.ReadyToStart],r=this._nodes[ec.InProgress],i=e.getRootNode();i.traverse((e=>a.add(e)));let o=0,s=0;for(this._markNodeAsReadyToStart(i,o);n.size||r.size;){for(let e of this._getNodesSortedByStartPosition())this._startNodeIfPossible(e,o);if(!r.size){if(this._flexibleOrdering)throw new Error("Failed to start a node");this._flexibleOrdering=!0;continue}this._updateNetworkCapacity();let e=this._findNextNodeCompletionTime();if(o+=e,!Number.isFinite(e)||s>1e5)throw new Error("Simulation failed, depth exceeded");s++;for(let t of r)this._updateProgressMadeInTimePeriod(t,e,o)}let{nodeTimings:l,completeNodeTimings:c}=this._computeFinalNodeTimings();return ac.set(t.label||"unlabeled",c),{timeInMs:o,nodeTimings:l}}computeWastedMsFromWastedBytes(e){let{throughput:t,observedThroughput:a}=this._options,n=0===t?a:t;if(0===n)return 0;let r=8*e/n*1e3;return 10*Math.round(r/10)}static get ALL_NODE_TIMINGS(){return ac}static _computeNodeStartPosition(e){return"cpu"===e.type?e.startTime:e.startTime+(1e3*tc[e.record.priority]*1e3||0)}}})),lc=s((()=>{J()})),cc=s((()=>{J(),ea(),na()})),uc=s((()=>{J(),rc=d(lr(),1),ic=class e{static{o(this,"ArbitraryEqualityMap")}constructor(){this._equalsFn=e.deepEquals,this._entries=[]}setEqualityFn(e){this._equalsFn=e}has(e){return-1!==this._findIndexOf(e)}get(e){return this._entries[this._findIndexOf(e)]?.value}set(e,t){let a=this._findIndexOf(e);-1===a&&(a=this._entries.length),this._entries[a]={key:e,value:t}}_findIndexOf(e){for(let t=0;t<this._entries.length;t++)if(this._equalsFn(e,this._entries[t].key))return t;return-1}static deepEquals(e,t){return(0,rc.default)(e,t)}}}));function dc(e,t){return Object.assign(e,{request:o(((a,n)=>{let r=t?Object.fromEntries(t.map((e=>[e,a[e]]))):a,i=n.computedCache,o=e.name,s=i.get(o)||new ic;i.set(o,s);let l=s.get(r);if(l)return l;let c={msg:`Computing artifact: ${o}`,id:`lh:computed:${o}`};Kt.time(c,"verbose");let u=e.compute_(r,n);return s.set(r,u),u.then((()=>Kt.timeEnd(c))).catch((()=>Kt.timeEnd(c))),u}),"request")})}var mc,pc,hc,gc,fc,yc,vc,bc,wc,Dc,Ec,Tc,Sc,Cc,kc,xc,Ac,_c,Rc,Fc,Nc,Ic,Mc,Pc,Lc,Oc,jc,Uc,Bc=s((()=>{J(),ea(),uc(),o(dc,"makeComputedArtifact")})),qc=s((()=>{J(),ta(),ql(),mc="X-TCPMs",pc="X-SSLMs",hc="X-RequestMs",gc="X-ResponseMs",fc="X-TotalMs",yc="X-TotalFetchedSize",vc="X-ProtocolIsH2",bc={XHR:"XHR",Fetch:"Fetch",EventSource:"EventSource",Script:"Script",Stylesheet:"Stylesheet",Image:"Image",Media:"Media",Font:"Font",Document:"Document",TextTrack:"TextTrack",WebSocket:"WebSocket",Other:"Other",Manifest:"Manifest",SignedExchange:"SignedExchange",Ping:"Ping",Preflight:"Preflight",CSPViolationReport:"CSPViolationReport",Prefetch:"Prefetch"},(wc=class e{static{o(this,"NetworkRequest")}constructor(){this.requestId="",this.connectionId="0",this.connectionReused=!1,this.url="",this.protocol="",this.isSecure=!1,this.isValid=!1,this.parsedURL={scheme:""},this.documentURL="",this.rendererStartTime=-1,this.networkRequestTime=-1,this.responseHeadersEndTime=-1,this.networkEndTime=-1,this.transferSize=0,this.resourceSize=0,this.fromDiskCache=!1,this.fromMemoryCache=!1,this.fromPrefetchCache=!1,this.lrStatistics=void 0,this.finished=!1,this.requestMethod="",this.statusCode=-1,this.redirectSource=void 0,this.redirectDestination=void 0,this.redirects=void 0,this.failed=!1,this.localizedFailDescription="",this.initiator={type:"other"},this.timing=void 0,this.resourceType=void 0,this.mimeType="",this.priority="Low",this.initiatorRequest=void 0,this.responseHeaders=[],this.responseHeadersText="",this.fetchedViaServiceWorker=!1,this.frameId="",this.sessionId=void 0,this.sessionTargetType=void 0,this.isLinkPreload=!1}hasErrorStatusCode(){return this.statusCode>=400}setInitiatorRequest(e){this.initiatorRequest=e}onRequestWillBeSent(e){let t;this.requestId=e.requestId;try{t=new URL(e.request.url)}catch{return}this.url=e.request.url,this.documentURL=e.documentURL,this.parsedURL={scheme:t.protocol.split(":")[0],host:t.hostname,securityOrigin:t.origin},this.isSecure=Ml.isSecureScheme(this.parsedURL.scheme),this.rendererStartTime=1e3*e.timestamp,this.networkRequestTime=this.rendererStartTime,this.requestMethod=e.request.method,this.initiator=e.initiator,this.resourceType=e.type&&bc[e.type],this.priority=e.request.initialPriority,this.frameId=e.frameId,this.isLinkPreload="preload"===e.initiator.type||!!e.request.isLinkPreload,this.isValid=!0}onRequestServedFromCache(){this.fromMemoryCache=!0}onResponseReceived(e){this._onResponse(e.response,e.timestamp,e.type),this._updateProtocolForLightrider(),this.frameId=e.frameId}onDataReceived(e){this.resourceSize+=e.dataLength,-1!==e.encodedDataLength&&(this.transferSize+=e.encodedDataLength)}onLoadingFinished(e){this.finished||(this.finished=!0,this.networkEndTime=1e3*e.timestamp,e.encodedDataLength>=0&&(this.transferSize=e.encodedDataLength),this._updateResponseHeadersEndTimeIfNecessary(),this._backfillReceiveHeaderStartTiming(),this._updateTransferSizeForLightrider(),this._updateTimingsForLightrider())}onLoadingFailed(e){this.finished||(this.finished=!0,this.networkEndTime=1e3*e.timestamp,this.failed=!0,this.resourceType=e.type&&bc[e.type],this.localizedFailDescription=e.errorText,this._updateResponseHeadersEndTimeIfNecessary(),this._backfillReceiveHeaderStartTiming(),this._updateTransferSizeForLightrider(),this._updateTimingsForLightrider())}onResourceChangedPriority(e){this.priority=e.newPriority}onRedirectResponse(e){if(!e.redirectResponse)throw new Error("Missing redirectResponse data");this._onResponse(e.redirectResponse,e.timestamp,e.type),this.resourceType=void 0,this.finished=!0,this.networkEndTime=1e3*e.timestamp,this._updateResponseHeadersEndTimeIfNecessary(),this._backfillReceiveHeaderStartTiming()}setSession(e){this.sessionId=e}get isOutOfProcessIframe(){return"iframe"===this.sessionTargetType}_onResponse(t,a,n){this.url=t.url,this.connectionId=String(t.connectionId),this.connectionReused=t.connectionReused,t.protocol&&(this.protocol=t.protocol),this.responseHeadersEndTime=1e3*a,this.transferSize=t.encodedDataLength,"boolean"==typeof t.fromDiskCache&&(this.fromDiskCache=t.fromDiskCache),"boolean"==typeof t.fromPrefetchCache&&(this.fromPrefetchCache=t.fromPrefetchCache),this.statusCode=t.status,this.timing=t.timing,n&&(this.resourceType=bc[n]),this.mimeType=t.mimeType,this.responseHeadersText=t.headersText||"",this.responseHeaders=e._headersDictToHeadersArray(t.headers),this.fetchedViaServiceWorker=!!t.fromServiceWorker,this.fromMemoryCache&&(this.timing=void 0),this.timing&&this._recomputeTimesWithResourceTiming(this.timing)}_recomputeTimesWithResourceTiming(e){if(0===e.requestTime||-1===e.receiveHeadersEnd)return;this.networkRequestTime=1e3*e.requestTime;let t=this.networkRequestTime+e.receiveHeadersEnd,a=this.responseHeadersEndTime;this.responseHeadersEndTime=t,this.responseHeadersEndTime=Math.min(this.responseHeadersEndTime,a),this.responseHeadersEndTime=Math.max(this.responseHeadersEndTime,this.networkRequestTime),this.networkEndTime=Math.max(this.networkEndTime,this.responseHeadersEndTime)}_updateResponseHeadersEndTimeIfNecessary(){this.responseHeadersEndTime=Math.min(this.networkEndTime,this.responseHeadersEndTime)}_updateTransferSizeForLightrider(){if(!globalThis.isLightrider)return;let e=this.responseHeaders.find((e=>e.name===yc));if(!e)return;let t=parseFloat(e.value);isNaN(t)||(this.transferSize=t)}_updateProtocolForLightrider(){globalThis.isLightrider&&this.responseHeaders.some((e=>e.name===vc))&&(this.protocol="h2")}_backfillReceiveHeaderStartTiming(){!this.timing||void 0!==this.timing.receiveHeadersStart||(this.timing.receiveHeadersStart=this.timing.receiveHeadersEnd)}_updateTimingsForLightrider(){if(!globalThis.isLightrider)return;let e=this.responseHeaders.find((e=>e.name===fc));if(!e)return;let t=parseInt(e.value),a=this.responseHeaders.find((e=>e.name===mc)),n=this.responseHeaders.find((e=>e.name===pc)),r=this.responseHeaders.find((e=>e.name===hc)),i=this.responseHeaders.find((e=>e.name===gc)),o=a?Math.max(0,parseInt(a.value)):0,s=n?Math.max(0,parseInt(n.value)):0,l=r?Math.max(0,parseInt(r.value)):0,c=i?Math.max(0,parseInt(i.value)):0;if(!Number.isNaN(o+l+c+t)){if(o+l+c!==t){if(Math.abs(o+l+c-t)>=25)return;t=o+l+c}s>o||(this.lrStatistics={endTimeDeltaMs:this.networkEndTime-(this.networkRequestTime+t),TCPMs:o,requestMs:l,responseMs:c})}}static getRequestIdForBackend(e){return e.replace(/(:redirect)+$/,"")}static _headersDictToHeadersArray(e){let t=[];for(let a of Object.keys(e)){let n=e[a].split("\n");for(let e=0;e<n.length;++e)t.push({name:a,value:n[e]})}return t}static get TYPES(){return bc}static isNonNetworkRequest(e){return Ml.isNonNetworkProtocol(e.protocol)||Ml.isNonNetworkProtocol(e.parsedURL.scheme)}static isSecureRequest(t){return Ml.isSecureScheme(t.parsedURL.scheme)||Ml.isSecureScheme(t.protocol)||Ml.isLikeLocalhost(t.parsedURL.host)||e.isHstsRequest(t)}static isHstsRequest(t){let a=t.redirectDestination;return!!a&&("HSTS"===t.responseHeaders.find((e=>"Non-Authoritative-Reason"===e.name))?.value&&e.isSecureRequest(a))}static getResourceSizeOnNetwork(e){return Math.min(e.resourceSize||0,e.transferSize||1/0)}}).HEADER_TCP=mc,wc.HEADER_SSL=pc,wc.HEADER_REQ=hc,wc.HEADER_RES=gc,wc.HEADER_TOTAL=fc,wc.HEADER_FETCHED_SIZE=yc,wc.HEADER_PROTOCOL_IS_H2=vc})),zc=s((()=>{J(),ta(),Cl(),qc(),Dc=class e extends fl{static{o(this,"NetworkNode")}constructor(e){super(e.requestId),this._record=e}get type(){return fl.TYPES.NETWORK}get startTime(){return 1e3*this._record.networkRequestTime}get endTime(){return 1e3*this._record.networkEndTime}get record(){return this._record}get initiatorType(){return this._record.initiator&&this._record.initiator.type}get fromDiskCache(){return!!this._record.fromDiskCache}get isNonNetworkProtocol(){return wc.isNonNetworkRequest(this._record)}get isConnectionless(){return this.fromDiskCache||this.isNonNetworkProtocol}hasRenderBlockingPriority(){let e=this._record.priority,t=this._record.resourceType===wc.TYPES.Script,a=this._record.resourceType===wc.TYPES.Document;return"VeryHigh"===e||"High"===e&&t||"High"===e&&a}cloneWithoutRelationships(){let t=new e(this._record);return t.setIsMainDocument(this._isMainDocument),t}}})),Vc=s((()=>{J(),ta(),Cl(),Ec=class e extends fl{static{o(this,"CPUNode")}constructor(e,t=[]){super(`${e.tid}.${e.ts}`),this._event=e,this._childEvents=t}get type(){return fl.TYPES.CPU}get startTime(){return this._event.ts}get endTime(){return this._event.ts+this._event.dur}get event(){return this._event}get childEvents(){return this._childEvents}didPerformLayout(){return this._childEvents.some((e=>"Layout"===e.name))}getEvaluateScriptURLs(){let e=new Set;for(let t of this._childEvents)"EvaluateScript"===t.name&&(!t.args.data||!t.args.data.url||e.add(t.args.data.url));return e}cloneWithoutRelationships(){return new e(this._event,this._childEvents)}}})),Wc=s((()=>{J(),xl(),na(),Tc=class extends Xt{static{o(this,"LHTraceProcessor")}static createNoNavstartError(){return new El(El.errors.NO_NAVSTART)}static createNoResourceSendRequestError(){return new El(El.errors.NO_RESOURCE_REQUEST)}static createNoTracingStartedError(){return new El(El.errors.NO_TRACING_STARTED)}static createNoFirstContentfulPaintError(){return new El(El.errors.NO_FCP)}},Sc=Tc})),Hc=s((()=>{J(),Bc(),Wc(),Cc=class{static{o(this,"ProcessedTrace")}static async compute_(e){return Sc.processTrace(e)}},kc=dc(Cc,null)})),Gc=s((()=>{J(),zl(),Bc(),Yc(),Hc(),xc=class{static{o(this,"DocumentUrls")}static async compute_(e,t){let a,n,r=await kc.request(e.trace,t),i=await Pc.request(e.devtoolsLog,t),o=r.mainFrameInfo.frameId;for(let t of e.devtoolsLog)if("Page.frameNavigated"===t.method&&t.params.frame.id===o){let{url:e}=t.params.frame;a||(a=e),n=e}if(!a||!n)throw new Error("No main frame navigations found");let s=Ll.findResourceForUrl(i,a);return s?.redirects?.length&&(a=s.redirects[0].url),{requestedUrl:a,mainDocumentUrl:n}}},Ac=dc(xc,["devtoolsLog","trace"])})),$c=s((()=>{J(),Bc(),zc(),Vc(),na(),qc(),Hc(),Yc(),zl(),Gc(),10,_c=/^video/,Rc=class e{static{o(this,"PageDependencyGraph")}static getNetworkInitiators(e){if(!e.initiator)return[];if(e.initiator.url)return[e.initiator.url];if("script"===e.initiator.type){let t=new Set,a=e.initiator.stack;for(;a;){let e=a.callFrames||[];for(let a of e)a.url&&t.add(a.url);a=a.parent}return Array.from(t)}return[]}static getNetworkNodeOutput(e){let t=[],a=new Map,n=new Map,r=new Map;return e.forEach((e=>{if(_c.test(e.mimeType))return;for(;a.has(e.requestId);)e.requestId+=":duplicate";let i=new Dc(e);t.push(i);let o=n.get(e.url)||[];if(o.push(i),a.set(e.requestId,i),n.set(e.url,o),e.frameId&&e.resourceType===wc.TYPES.Document&&e.documentURL===e.url){let t=r.has(e.frameId)?null:i;r.set(e.frameId,t)}})),{nodes:t,idToNodeMap:a,urlToNodeMap:n,frameIdToNodeMap:r}}static getCPUNodes({mainThreadEvents:e}){let t=[],a=0;for(Xt.assertHasToplevelEvents(e);a<e.length;){let n=e[a];if(a++,!Xt.isScheduleableTask(n)||!n.dur)continue;let r=[];for(let t=n.ts+n.dur;a<e.length&&e[a].ts<t;a++)r.push(e[a]);t.push(new Ec(n,r))}return t}static linkNetworkNodes(t,a){a.nodes.forEach((n=>{let r=n.record.initiatorRequest||t.record,i=a.idToNodeMap.get(r.requestId)||t,o=!i.isDependentOn(n)&&n.canDependOn(i),s=e.getNetworkInitiators(n.record);if(s.length?s.forEach((e=>{let t=a.urlToNodeMap.get(e)||[];1===t.length&&t[0].startTime<=n.startTime&&!t[0].isDependentOn(n)?n.addDependency(t[0]):o&&i.addDependent(n)})):o&&i.addDependent(n),n!==t&&0===n.getDependencies().length&&n.canDependOn(t)&&n.addDependency(t),!n.record.redirects)return;let l=[...n.record.redirects,n.record];for(let e=1;e<l.length;e++){let t=a.idToNodeMap.get(l[e-1].requestId),n=a.idToNodeMap.get(l[e].requestId);n&&t&&n.addDependency(t)}}))}static linkCPUNodes(t,a,n){let r=new Set([wc.TYPES.XHR,wc.TYPES.Fetch,wc.TYPES.Script]);function i(e,t){let n=a.idToNodeMap.get(t);if(!n||n.startTime<=e.startTime)return;let{record:i}=n,o=i.resourceType||i.redirectDestination?.resourceType;r.has(o)&&e.addDependent(n)}function s(e,t){if(!t)return;let n=a.frameIdToNodeMap.get(t);n&&(n.startTime>=e.startTime||e.addDependency(n))}function l(e,t){if(!t)return;let n=a.urlToNodeMap.get(t)||[],r=null,i=1/0;for(let t of n){if(e.startTime<=t.startTime)return;let a=e.startTime-t.endTime;a>=-1e5&&a<i&&(r=t,i=a)}r&&e.addDependency(r)}o(i,"addDependentNetworkRequest"),o(s,"addDependencyOnFrame"),o(l,"addDependencyOnUrl");let c=new Map;for(let e of n){for(let t of e.childEvents){if(!t.args.data)continue;let a=t.args.data.url,n=(t.args.data.stackTrace||[]).map((e=>e.url)).filter(Boolean);switch(t.name){case"TimerInstall":c.set(t.args.data.timerId,e),n.forEach((t=>l(e,t)));break;case"TimerFire":{let a=c.get(t.args.data.timerId);if(!a||a.endTime>e.startTime)break;a.addDependent(e);break}case"InvalidateLayout":case"ScheduleStyleRecalculation":s(e,t.args.data.frame),n.forEach((t=>l(e,t)));break;case"EvaluateScript":s(e,t.args.data.frame),l(e,a),n.forEach((t=>l(e,t)));break;case"XHRReadyStateChange":if(4!==t.args.data.readyState)break;l(e,a),n.forEach((t=>l(e,t)));break;case"FunctionCall":case"v8.compile":s(e,t.args.data.frame),l(e,a);break;case"ParseAuthorStyleSheet":s(e,t.args.data.frame),l(e,t.args.data.styleSheetUrl);break;case"ResourceSendRequest":s(e,t.args.data.frame),i(e,t.args.data.requestId),n.forEach((t=>l(e,t)))}}0===e.getNumberOfDependencies()&&e.canDependOn(t)&&e.addDependency(t)}let u=!1,d=!1,m=!1;for(let t of n){let a=!1;!u&&t.childEvents.some((e=>"Layout"===e.name))&&(a=u=!0),!d&&t.childEvents.some((e=>"Paint"===e.name))&&(a=d=!0),!m&&t.childEvents.some((e=>"ParseHTML"===e.name))&&(a=m=!0),!(a||t.event.dur>=1e4)&&(1===t.getNumberOfDependencies()||t.getNumberOfDependents()<=1)&&e._pruneNode(t)}}static _pruneNode(e){let t=e.getDependencies(),a=e.getDependents();for(let n of t){e.removeDependency(n);for(let e of a)n.addDependent(e)}for(let t of a)e.removeDependent(t)}static createGraph(t,a,n){let r=e.getNetworkNodeOutput(a),i=e.getCPUNodes(t),{requestedUrl:o,mainDocumentUrl:s}=n;if(!o)throw new Error("requestedUrl is required to get the root request");if(!s)throw new Error("mainDocumentUrl is required to get the main resource");let l=Ll.findResourceForUrl(a,o);if(!l)throw new Error("rootRequest not found");let c=r.idToNodeMap.get(l.requestId);if(!c)throw new Error("rootNode not found");let u=Ll.findResourceForUrl(a,s);if(!u)throw new Error("mainDocumentRequest not found");let d=r.idToNodeMap.get(u.requestId);if(!d)throw new Error("mainDocumentNode not found");if(e.linkNetworkNodes(c,r),e.linkCPUNodes(c,r,i),d.setIsMainDocument(!0),Dc.hasCycle(c))throw new Error("Invalid dependency graph created, cycle detected");return c}static printGraph(e,t=100){function a(e,t,a=" "){return e+a.repeat(Math.max(t-e.length,0))}o(a,"padRight");let n=[];e.traverse((e=>n.push(e))),n.sort(((e,t)=>e.startTime-t.startTime));let r=n[0].startTime,i=(n.reduce(((e,t)=>Math.max(e,t.endTime)),0)-r)/t;n.forEach((e=>{let n=Math.round((e.startTime-r)/i),o=Math.ceil((e.endTime-e.startTime)/i),s=a("",n)+a("",o,"="),l=e.record?e.record.url:e.type;console.log(a(s,t),`| ${l.slice(0,30)}`)}))}static async compute_(t,a){let{trace:n,devtoolsLog:r}=t,[i,o]=await Promise.all([kc.request(n,a),Pc.request(r,a)]),s=t.URL||await Ac.request(t,a);return e.createGraph(i,o,s)}},Fc=dc(Rc,["devtoolsLog","trace","URL"])})),Kc=s((()=>{J(),kt(),ea(),ta(),qc(),$c(),Nc=ut,Ic=class e extends Nc{static{o(this,"NetworkRecorder")}constructor(){super(),this._records=[],this._recordsById=new Map}getRawRecords(){return Array.from(this._records)}onRequestStarted(e){this._records.push(e),this._recordsById.set(e.requestId,e),this.emit("requeststarted",e)}onRequestFinished(e){this.emit("requestfinished",e)}onRequestWillBeSent(e){let t=e.params,a=this._findRealRequestAndSetSession(t.requestId,e.targetType,e.sessionId);if(!a){let a=new wc;return a.onRequestWillBeSent(t),a.sessionId=e.sessionId,a.sessionTargetType=e.targetType,this.onRequestStarted(a),void Kt.verbose("network",`request will be sent to ${a.url}`)}if(!t.redirectResponse)return;let n={...t,initiator:a.initiator,requestId:`${a.requestId}:redirect`},r=new wc;r.onRequestWillBeSent(n),a.onRedirectResponse(t),Kt.verbose("network",`${a.url} redirected to ${r.url}`),a.redirectDestination=r,r.redirectSource=a,this.onRequestStarted(r),this.onRequestFinished(a)}onRequestServedFromCache(e){let t=e.params,a=this._findRealRequestAndSetSession(t.requestId,e.targetType,e.sessionId);a&&(Kt.verbose("network",`${a.url} served from cache`),a.onRequestServedFromCache())}onResponseReceived(e){let t=e.params,a=this._findRealRequestAndSetSession(t.requestId,e.targetType,e.sessionId);a&&(Kt.verbose("network",`${a.url} response received`),a.onResponseReceived(t))}onDataReceived(e){let t=e.params,a=this._findRealRequestAndSetSession(t.requestId,e.targetType,e.sessionId);a&&(Kt.verbose("network",`${a.url} data received`),a.onDataReceived(t))}onLoadingFinished(e){let t=e.params,a=this._findRealRequestAndSetSession(t.requestId,e.targetType,e.sessionId);a&&(Kt.verbose("network",`${a.url} loading finished`),a.onLoadingFinished(t),this.onRequestFinished(a))}onLoadingFailed(e){let t=e.params,a=this._findRealRequestAndSetSession(t.requestId,e.targetType,e.sessionId);a&&(Kt.verbose("network",`${a.url} loading failed`),a.onLoadingFailed(t),this.onRequestFinished(a))}onResourceChangedPriority(e){let t=e.params,a=this._findRealRequestAndSetSession(t.requestId,e.targetType,e.sessionId);a&&a.onResourceChangedPriority(t)}dispatch(e){switch(e.method){case"Network.requestWillBeSent":return this.onRequestWillBeSent(e);case"Network.requestServedFromCache":return this.onRequestServedFromCache(e);case"Network.responseReceived":return this.onResponseReceived(e);case"Network.dataReceived":return this.onDataReceived(e);case"Network.loadingFinished":return this.onLoadingFinished(e);case"Network.loadingFailed":return this.onLoadingFailed(e);case"Network.resourceChangedPriority":return this.onResourceChangedPriority(e);default:return}}_findRealRequestAndSetSession(e,t,a){let n=this._recordsById.get(e);if(n&&n.isValid){for(;n.redirectDestination;)n=n.redirectDestination;return n.setSession(a),n.sessionTargetType=t,n}}static _chooseInitiatorRequest(e,t){if(e.redirectSource)return e.redirectSource;let a=Fc.getNetworkInitiators(e)[0],n=t.get(a)||[];if(n=n.filter((t=>t.responseHeadersEndTime<=e.networkRequestTime&&t.finished&&!t.failed)),n.length>1){let e=n.filter((e=>e.resourceType!==wc.TYPES.Other));e.length&&(n=e)}if(n.length>1){let t=n.filter((t=>t.frameId===e.frameId));t.length&&(n=t)}if(n.length>1&&"parser"===e.initiator.type){let e=n.filter((e=>e.resourceType===wc.TYPES.Document));e.length&&(n=e)}if(n.length>1){let e=n.filter((e=>e.isLinkPreload));if(e.length){let t=n.filter((e=>!e.isLinkPreload)),a=t.every((e=>e.fromDiskCache||e.fromMemoryCache));t.length&&a&&(n=e)}}return 1===n.length?n[0]:null}static recordsFromLogs(t){let a=new e;t.forEach((e=>a.dispatch(e)));let n=a.getRawRecords().filter((e=>e.isValid)),r=new Map;for(let e of n){let t=r.get(e.url)||[];t.push(e),r.set(e.url,t)}for(let t of n){let a=e._chooseInitiatorRequest(t,r);a&&t.setInitiatorRequest(a);let n=t;for(;n.redirectDestination;)n=n.redirectDestination;if(n===t||n.redirects)continue;let i=[];for(let e=n.redirectSource;e;e=e.redirectSource)i.unshift(e);n.redirects=i}return n}}})),Yc=s((()=>{J(),ta(),Bc(),Kc(),Mc=class{static{o(this,"NetworkRecords")}static async compute_(e){return Ic.recordsFromLogs(e)}},Pc=dc(Mc,null)})),Jc=s((()=>{J(),Bc(),zl(),Yc(),Lc=class e{static{o(this,"NetworkAnalysis")}static computeRTTAndServerResponseTime(e){let t=new Map;for(let[a,n]of Ll.estimateRTTByOrigin(e).entries())t.set(a,n.min);let a=Math.min(...Array.from(t.values())),n=Ll.estimateServerResponseTimeByOrigin(e,{rttByOrigin:t}),r=new Map,i=new Map;for(let[e,o]of n.entries()){let n=t.get(e)||a;r.set(e,n-a),i.set(e,o.median)}return{rtt:a,additionalRttByOrigin:r,serverResponseTimeByOrigin:i}}static async compute_(t,a){let n=await Pc.request(t,a);return{throughput:Ll.estimateThroughput(n),...e.computeRTTAndServerResponseTime(n)}}},Oc=dc(Lc,null)})),Zc=s((()=>{J(),Bc(),oc(),sc(),Jc(),jc=class{static{o(this,"LoadSimulator")}static async compute_(e,t){let{throttlingMethod:a,throttling:n,precomputedLanternData:r}=e.settings,i=await Oc.request(e.devtoolsLog,t),o={additionalRttByOrigin:i.additionalRttByOrigin,serverResponseTimeByOrigin:i.serverResponseTimeByOrigin,observedThroughput:i.throughput};switch(r&&(o.additionalRttByOrigin=new Map(Object.entries(r.additionalRttByOrigin)),o.serverResponseTimeByOrigin=new Map(Object.entries(r.serverResponseTimeByOrigin))),a){case"provided":o.rtt=i.rtt,o.throughput=i.throughput,o.cpuSlowdownMultiplier=1,o.layoutTaskMultiplier=1;break;case"devtools":n&&(o.rtt=n.requestLatencyMs/$l.DEVTOOLS_RTT_ADJUSTMENT_FACTOR,o.throughput=1024*n.downloadThroughputKbps/$l.DEVTOOLS_THROUGHPUT_ADJUSTMENT_FACTOR),o.cpuSlowdownMultiplier=1,o.layoutTaskMultiplier=1;break;case"simulate":n&&(o.rtt=n.rttMs,o.throughput=1024*n.throughputKbps,o.cpuSlowdownMultiplier=n.cpuSlowdownMultiplier)}return new nc(o)}static convertAnalysisToSaveableLanternData(e){let t={additionalRttByOrigin:{},serverResponseTimeByOrigin:{}};for(let[a,n]of e.additionalRttByOrigin.entries())a.startsWith("http")&&(t.additionalRttByOrigin[a]=n);for(let[a,n]of e.serverResponseTimeByOrigin.entries())a.startsWith("http")&&(t.serverResponseTimeByOrigin[a]=n);return t}},Uc=dc(jc,["devtoolsLog","settings"])}));function Xc(e){if(Kt.log("Reading artifacts from disk:",e),!ca.existsSync(e))throw new Error("No saved artifacts found at "+e);let t=ca.readFileSync(Ta.join(e,ou),"utf8"),a=JSON.parse(t,El.parseReviver),n=ca.readdirSync(e);return a.devtoolsLogs={},n.filter((e=>e.endsWith(lu))).forEach((t=>{let n=t.replace(lu,""),r=JSON.parse(ca.readFileSync(Ta.join(e,t),"utf8"));a.devtoolsLogs[n]=r,"defaultPass"===n&&(a.DevtoolsLog=r),"pageLoadError-defaultPass"===n&&(a.DevtoolsLogError=r)})),a.traces={},n.filter((e=>e.endsWith(su))).forEach((t=>{let n=ca.readFileSync(Ta.join(e,t),{encoding:"utf-8"}),r=JSON.parse(n),i=t.replace(su,"");a.traces[i]=Array.isArray(r)?{traceEvents:r}:r,"defaultPass"===i&&(a.Trace=a.traces[i]),"pageLoadError-defaultPass"===i&&(a.TraceError=a.traces[i])})),Array.isArray(a.Timing)&&a.Timing.forEach((e=>e.gather=!0)),a}function Qc(e,t){return t instanceof Error?El.stringifyReplacer(t):t}async function eu(e,t){let a={msg:"Saving artifacts",id:"lh:assetSaver:saveArtifacts"};Kt.time(a),ca.mkdirSync(t,{recursive:!0});let n=ca.readdirSync(t);for(let e of n)(e.endsWith(su)||e.endsWith(lu)||e===ou)&&ca.unlinkSync(`${t}/${e}`);let{traces:r,devtoolsLogs:i,DevtoolsLog:o,Trace:s,...l}=e;if(r)for(let[e,a]of Object.entries(r))await ru(a,`${t}/${e}${su}`);if(i)for(let[e,a]of Object.entries(i))await iu(a,`${t}/${e}${lu}`);let c=JSON.stringify(l,Qc,2)+"\n";ca.writeFileSync(`${t}/${ou}`,c,"utf8"),Kt.log("Artifacts saved to disk in folder:",t),Kt.timeEnd(a)}function tu(e,t){ca.writeFileSync(`${t}/lhr.report.json`,JSON.stringify(e,null,2))}function*au(e){if(yield"[\n",e.length>0){let t=e[Symbol.iterator](),a=t.next().value;yield`  ${JSON.stringify(a)}`;let n=500,r="";for(let e of t)r+=`,\n  ${JSON.stringify(e)}`,n--,0===n&&(yield r,n=500,r="");yield r}yield"\n]"}function*nu(e){let{traceEvents:t,...a}=e;yield"{\n",yield'"traceEvents": ',yield*au(t);for(let[e,t]of Object.entries(a))yield`,\n"${e}": ${JSON.stringify(t,null,2)}`;yield"}\n"}async function ru(e,t){let a=nu(e),n=ca.createWriteStream(t);return gl.promises.pipeline(a,n)}function iu(e,t){let a=ca.createWriteStream(t);return gl.promises.pipeline((function*(){yield*au(e),yield"\n"}),a)}var ou,su,lu,cu=s((()=>{J(),ua(),ka(),Sl(),ri(),ea(),sc(),lc(),cc(),Jc(),Zc(),xl(),Xi(),ou="artifacts.json",su=".trace.json",lu=".devtoolslog.json",o(Xc,"loadArtifacts"),o(Qc,"stringifyReplacer"),o(eu,"saveArtifacts"),o(tu,"saveLhr"),o(au,"arrayOfObjectsJsonGenerator"),o(nu,"traceJsonGenerator"),o(ru,"saveTrace"),o(iu,"saveDevtoolsLog")})),uu={};c(uu,{default:()=>du});var du,mu=s((()=>{J(),du={}}));async function pu(e){if(e.flags.enableErrorReporting&&yu._shouldSample())try{let t=await Promise.resolve().then((()=>(mu(),uu)));t.init({...e.environmentData,dsn:hu});let a={...e.flags.throttling,channel:e.flags.channel||"cli",url:e.url,formFactor:e.flags.formFactor,throttlingMethod:e.flags.throttlingMethod};t.setExtras(a),yu.captureMessage=(...e)=>t.captureMessage(...e),yu.captureBreadcrumb=(...e)=>t.addBreadcrumb(...e),yu.getContext=()=>a;let n=new Map;yu.captureException=async(e,a={})=>{if(!e||e.expected)return;let r=a.tags||{};if(r.audit){let t=`audit-${r.audit}-${e.message}`;if(n.has(t))return;n.set(t,!0)}if(r.gatherer){let t=`gatherer-${r.gatherer}-${e.message}`;if(n.has(t))return;n.set(t,!0)}let i=gu.find((t=>t.pattern.test(e.message)));i&&i.rate<=Math.random()||(e.protocolMethod&&(a.fingerprint=["{{ default }}",e.protocolMethod,e.protocolError],a.tags=a.tags||{},a.tags.protocolMethod=e.protocolMethod),t.withScope((n=>{let r;a.level&&n.setLevel(a.level),a.tags&&n.setTags(a.tags),a.extra&&(r={...a.extra}),e.extra&&(r={...r,...e.extra}),r&&n.setExtras(r),t.captureException(e)})))}}catch{Kt.warn("sentry","Could not load Sentry, errors will not be reported.")}}var hu,gu,fu,yu,vu,bu,wu,Du=s((()=>{J(),ea(),hu="https://a6bb0da87ee048cc9ae2a345fc09ab2e:63a7029f46f74265981b7e005e0f69f8@sentry.io/174697",.01,gu=[],fu=o((()=>{}),"noop"),yu={init:pu,captureMessage:fu,captureBreadcrumb:fu,getContext:fu,captureException:async()=>{},_shouldSample:()=>.01>=Math.random()},o(pu,"init"),vu=yu})),Eu=s((()=>{J(),bu={}})),Tu=s((()=>{J(),Eu(),wu=class e{static{o(this,"ReportGenerator")}static replaceStrings(t,a){if(0===a.length)return t;let n=a[0],r=a.slice(1);return t.split(n.search).map((t=>e.replaceStrings(t,r))).join(n.replacement)}static sanitizeJson(e){return JSON.stringify(e).replace(/</g,"\\u003c").replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}static generateReportHtml(t){let a=e.sanitizeJson(t),n=bu.REPORT_JAVASCRIPT.replace(/<\//g,"\\u003c/");return e.replaceStrings(bu.REPORT_TEMPLATE,[{search:"%%LIGHTHOUSE_JSON%%",replacement:a},{search:"%%LIGHTHOUSE_JAVASCRIPT%%",replacement:n}])}static generateFlowReportHtml(t){let a=e.sanitizeJson(t),n=bu.FLOW_REPORT_JAVASCRIPT.replace(/<\//g,"\\u003c/");return e.replaceStrings(bu.FLOW_REPORT_TEMPLATE,[{search:"%%LIGHTHOUSE_FLOW_JSON%%",replacement:a},{search:"%%LIGHTHOUSE_FLOW_JAVASCRIPT%%",replacement:n},{search:"/*%%LIGHTHOUSE_FLOW_CSS%%*/",replacement:bu.FLOW_REPORT_CSS}])}static generateReportCSV(e){let t=o((e=>`"${e.replace(/"/g,'""')}"`),"escape"),a=o((e=>e.map((e=>null===e?"null":e.toString())).map(t)),"rowFormatter"),n=[],r=["requestedUrl","finalDisplayedUrl","fetchTime","gatherMode"];n.push(a(r)),n.push(a(r.map((t=>e[t]??null)))),n.push([]),n.push(["category","score"]);for(let t of Object.values(e.categories))n.push(a([t.id,t.score]));n.push([]),n.push(["category","audit","score","displayValue","description"]);for(let t of Object.values(e.categories))for(let r of t.auditRefs){let i=e.audits[r.id];i&&n.push(a([t.id,r.id,i.score,i.displayValue||"",i.description]))}return n.map((e=>e.join(","))).join("\r\n")}static isFlowResult(e){return"steps"in e}static generateReport(t,a){let n=Array.isArray(a);"string"==typeof a&&(a=[a]);let r=a.map((a=>{if("html"===a)return e.isFlowResult(t)?e.generateFlowReportHtml(t):e.generateReportHtml(t);if("csv"===a){if(e.isFlowResult(t))throw new Error("CSV output is not support for user flows");return e.generateReportCSV(t)}if("json"===a)return JSON.stringify(t,null,2);throw new Error("Invalid output mode: "+a)}));return n?r:r[0]}}})),Su=l(((e,t)=>{J();var a=/:\/\/(\S*?)(:\d+)?(\/|$)/,n=/([a-z0-9.-]+\.[a-z0-9]+|localhost)/i,r=/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/,i=/[^.]+\.([^.]+|(gov|com|co|ne)\.\w{2})$/i;function s(e){return"string"!=typeof e||e.length>1e4||e.startsWith("data:")?null:a.test(e)?e.match(a)[1]:n.test(e)?e.match(n)[0]:null}function l(e){let t=s(e);if(!t)return null;if(r.test(t))return t;let a=t.match(i);return a&&a[0]||t}function c(e,t){return e.length<=t.length?e:e.split(".").slice(1).join(".")}function u(e,t,a,n){let r=s(n),i=l(r);if(r&&i){if(e.has(r))return e.get(r);for(let e=r;e.length>i.length;e=c(e,i))if(t.has(e))return t.get(e);if(a.has(i))return a.get(i)}}function d(e,t,a,n){let r=u(e,t,a,n),i=r&&r.products;if(i&&"string"==typeof n)for(let e of i)for(let t of e.urlPatterns)if(t instanceof RegExp&&t.test(n)||"string"==typeof t&&n.includes(t))return e}function m(e){return e.map((e=>{let t={company:e.name,categories:[e.category],...e},a=(e.products||[]).map((e=>({company:t.company,category:t.category,categories:[t.category],facades:[],...e,urlPatterns:(e.urlPatterns||[]).map((e=>e.startsWith("REGEXP:")?new RegExp(e.slice(7)):e))})));return t.products=a,t}))}function p(e){let t=m(e),a=new Map,n=new Map,r=new Map;for(let e of t){e.totalExecutionTime=Number(e.totalExecutionTime)||0,e.totalOccurrences=Number(e.totalOccurrences)||0,e.averageExecutionTime=e.totalExecutionTime/e.totalOccurrences;for(let t of e.domains){if(a.has(t)){let n=a.get(t);throw new Error(`Duplicate domain ${t} (${e.name} and ${n.name})`)}a.set(t,e);let i=l(t);if(t.startsWith("*.")){let a=t.slice(2);a===i?n.set(i,e):r.set(a,e)}}}for(let[e,t]of n.entries())t||n.delete(e);return{getEntity:u.bind(null,a,r,n),getProduct:d.bind(null,a,r,n),getRootDomain:l,entities:t}}o(s,"getDomainFromOriginOrURL"),o(l,"getRootDomain"),o(c,"sliceSubdomainFromDomain"),o(u,"getEntityInDataset"),o(d,"getProductInDataset"),o(m,"cloneEntities"),o(p,"createAPIFromDataset"),t.exports={createAPIFromDataset:p}})),Cu=l(((e,t)=>{t.exports=[{name:"Google/Doubleclick Ads",company:"Google",homepage:"https://marketingplatform.google.com/about/enterprise/",category:"ad",domains:["adservice.google.com","adservice.google.com.au","adservice.google.com.sg","adservice.google.com.br","adservice.google.com.ua","adservice.google.co.uk","adservice.google.co.jp","adservice.google.co.in","adservice.google.co.kr","adservice.google.co.id","adservice.google.co.nz","adservice.google.ie","adservice.google.se","adservice.google.de","adservice.google.ca","adservice.google.be","adservice.google.es","adservice.google.ch","adservice.google.fr","adservice.google.nl","*.googleadservices.com","*.googlesyndication.com","*.googletagservices.com","*.2mdn.net","*.doubleclick.net"]},{name:"Facebook",homepage:"https://www.facebook.com",category:"social",domains:["*.facebook.com","*.atlassbx.com","*.fbsbx.com","fbcdn-photos-e-a.akamaihd.net","*.facebook.net","*.fbcdn.net"],products:[{name:"Facebook Messenger Customer Chat",urlPatterns:["REGEXP:connect\\.facebook\\.net\\/.*\\/sdk\\/xfbml\\.customerchat\\.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Instagram",homepage:"https://www.instagram.com",category:"social",domains:["*.cdninstagram.com","*.instagram.com"]},{name:"Google CDN",company:"Google",homepage:"https://developers.google.com/speed/libraries/",category:"cdn",domains:["ajax.googleapis.com","commondatastorage.googleapis.com","www.gstatic.com","ssl.gstatic.com"]},{name:"Google Maps",company:"Google",homepage:"https://www.google.com/maps",category:"utility",domains:["maps.google.com","maps-api-ssl.google.com","maps.googleapis.com","mts.googleapis.com","mt.googleapis.com","mt0.googleapis.com","mt1.googleapis.com","mt2.googleapis.com","mt3.googleapis.com","khm0.googleapis.com","khm1.googleapis.com","khms.googleapis.com","khms1.googleapis.com","khms2.googleapis.com","maps.gstatic.com"]},{name:"Other Google APIs/SDKs",company:"Google",homepage:"https://developers.google.com/apis-explorer/#p/",category:"utility",domains:["accounts.google.com","apis.google.com","calendar.google.com","clients2.google.com","cse.google.com","news.google.com","pay.google.com","payments.google.com","play.google.com","smartlock.google.com","www.google.com","www.google.de","www.google.co.jp","www.google.com.au","www.google.co.uk","www.google.ie","www.google.com.sg","www.google.co.in","www.google.com.br","www.google.ca","www.google.co.kr","www.google.co.nz","www.google.co.id","www.google.fr","www.google.be","www.google.com.ua","www.google.nl","www.google.ru","www.google.se","www.googleapis.com","imasdk.googleapis.com","storage.googleapis.com","translate.googleapis.com","translate.google.com","translate-pa.googleapis.com","lh3.googleusercontent.com","jnn-pa.googleapis.com","csi.gstatic.com"]},{name:"Firebase",homepage:"https://developers.google.com/apis-explorer/#p/",category:"utility",domains:["firebasestorage.googleapis.com","firestore.googleapis.com","firebaseinstallations.googleapis.com","firebase.googleapis.com","firebaseremoteconfig.googleapis.com"]},{name:"Google Analytics",company:"Google",homepage:"https://marketingplatform.google.com/about/analytics/",category:"analytics",domains:["*.google-analytics.com","*.urchin.com","analytics.google.com"]},{name:"Google Optimize",company:"Google",homepage:"https://marketingplatform.google.com/about/optimize/",category:"analytics",domains:["www.googleoptimize.com"]},{name:"Google AMP",company:"Google",homepage:"https://github.com/google/amp-client-id-library",category:"analytics",domains:["ampcid.google.com"]},{name:"Google Tag Manager",company:"Google",homepage:"https://marketingplatform.google.com/about/tag-manager/",category:"tag-manager",domains:["*.googletagmanager.com"]},{name:"Google Fonts",company:"Google",homepage:"https://fonts.google.com/",category:"cdn",domains:["fonts.googleapis.com","fonts.gstatic.com"]},{name:"Adobe TypeKit",company:"Adobe",homepage:"https://fonts.adobe.com/",category:"cdn",domains:["*.typekit.com","*.typekit.net"]},{name:"YouTube",homepage:"https://youtube.com",category:"video",domains:["*.youtube.com","*.ggpht.com","*.youtube-nocookie.com","*.ytimg.com"],products:[{name:"YouTube Embedded Player",urlPatterns:["youtube.com/embed/"],facades:[{name:"Lite YouTube",repo:"https://github.com/paulirish/lite-youtube-embed"},{name:"Ngx Lite Video",repo:"https://github.com/karim-mamdouh/ngx-lite-video"}]}]},{name:"Twitter",homepage:"https://twitter.com",category:"social",domains:["*.vine.co","*.twimg.com","*.twitpic.com","platform.twitter.com","syndication.twitter.com"]},{name:"AddThis",homepage:"https://www.addthis.com/",category:"social",domains:["*.addthis.com","*.addthiscdn.com","*.addthisedge.com"]},{name:"AddToAny",homepage:"https://www.addtoany.com/",category:"social",domains:["*.addtoany.com"]},{name:"Akamai",homepage:"https://www.akamai.com/",category:"cdn",domains:["23.62.3.183","*.akamaitechnologies.com","*.akamaitechnologies.fr","*.akamai.net","*.akamaiedge.net","*.akamaihd.net","*.akamaized.net","*.edgefcs.net","*.edgekey.net","edgesuite.net","*.srip.net"]},{name:"Blogger",homepage:"https://www.blogger.com/",category:"hosting",domains:["*.blogblog.com","*.blogger.com","*.blogspot.com","images-blogger-opensocial.googleusercontent.com"]},{name:"Gravatar",homepage:"https://en.gravatar.com/",category:"social",domains:["*.gravatar.com"]},{name:"Yandex Metrica",company:"Yandex",homepage:"https://metrica.yandex.com/about?",category:"analytics",domains:["mc.yandex.ru","mc.yandex.com","d31j93rd8oukbv.cloudfront.net"]},{name:"Hotjar",homepage:"https://www.hotjar.com/",category:"analytics",domains:["*.hotjar.com","*.hotjar.io"]},{name:"Baidu Analytics",homepage:"https://tongji.baidu.com/web/welcome/login",category:"analytics",domains:["hm.baidu.com","hmcdn.baidu.com"]},{name:"Insider",homepage:"",category:"analytics",domains:["*.useinsider.com"]},{name:"Adobe Experience Cloud",company:"Adobe",homepage:"",category:"analytics",domains:["*.2o7.net","du8783wkf05yr.cloudfront.net","*.hitbox.com","*.imageg.net","*.nedstat.com","*.omtrdc.net"]},{name:"Adobe Tag Manager",company:"Adobe",homepage:"https://www.adobe.com/experience-platform/",category:"tag-manager",domains:["*.adobedtm.com","*.demdex.net","*.everesttech.net","sstats.adobe.com","hbrt.adobe.com"]},{name:"jQuery CDN",homepage:"https://code.jquery.com/",category:"cdn",domains:["*.jquery.com"]},{name:"Cloudflare CDN",homepage:"https://cdnjs.com/",category:"cdn",domains:["cdnjs.cloudflare.com","amp.cloudflare.com"]},{name:"Cloudflare",homepage:"https://www.cloudflare.com/website-optimization/",category:"utility",domains:["ajax.cloudflare.com","*.nel.cloudflare.com","static.cloudflareinsights.com"]},{name:"WordPress",company:"Automattic",homepage:"https://wp.com/",category:"hosting",domains:["*.wordpress.com","s0.wp.com","s2.wp.com","*.w.org","c0.wp.com","s1.wp.com","i0.wp.com","i1.wp.com","i2.wp.com","widgets.wp.com"]},{name:"WordPress Site Stats",company:"Automattic",homepage:"https://wp.com/",category:"analytics",domains:["pixel.wp.com","stats.wp.com"]},{name:"Hatena Blog",homepage:"https://hatenablog.com/",category:"hosting",domains:["*.st-hatena.com","*.hatena.ne.jp"]},{name:"Shopify",homepage:"https://www.shopify.com/",category:"hosting",domains:["*.shopify.com","*.shopifyapps.com","*.shopifycdn.com","*.shopifysvc.com"]},{name:"Dealer",homepage:"https://www.dealer.com/",category:"hosting",domains:["*.dealer.com"]},{name:"PIXNET",homepage:"https://www.pixnet.net/",category:"social",domains:["*.pixfs.net","*.pixnet.net"]},{name:"Moat",homepage:"https://moat.com/",category:"ad",domains:["*.moatads.com","*.moatpixel.com"]},{name:"33 Across",homepage:"https://33across.com/",category:"ad",domains:["*.33across.com"]},{name:"OpenX",homepage:"https://www.openx.com/",category:"ad",domains:["*.deliverimp.com","*.openxadexchange.com","*.servedbyopenx.com","*.jump-time.net","*.openx.net"]},{name:"Amazon Ads",homepage:"https://ad.amazon.com/",category:"ad",domains:["*.amazon-adsystem.com"]},{name:"Rubicon Project",homepage:"https://rubiconproject.com/",category:"ad",domains:["*.rubiconproject.com","*.chango.com","*.fimserve.com"]},{name:"The Trade Desk",homepage:"https://www.thetradedesk.com/",category:"ad",domains:["*.adsrvr.org","d1eoo1tco6rr5e.cloudfront.net"]},{name:"Bidswitch",homepage:"https://www.bidswitch.com/",category:"ad",domains:["*.bidswitch.net"]},{name:"LiveRamp IdentityLink",homepage:"https://liveramp.com/discover-identitylink/",category:"analytics",domains:["*.circulate.com","*.rlcdn.com"]},{name:"Drawbridge",homepage:"https://www.drawbridge.com/",category:"ad",domains:["*.adsymptotic.com"]},{name:"AOL / Oath / Verizon Media",homepage:"https://www.oath.com/",category:"ad",domains:["*.advertising.com","*.aol.com","*.aolcdn.com","*.blogsmithmedia.com","*.oath.com","*.aol.net","*.tacoda.net","*.aol.co.uk"]},{name:"Xaxis",homepage:"https://www.xaxis.com/",category:"ad",domains:["*.247realmedia.com","*.mookie1.com","*.gmads.net"]},{name:"Freshdesk",company:"Freshworks",homepage:"https://freshdesk.com/",category:"customer-success",domains:["d36mpcpuzc4ztk.cloudfront.net"]},{name:"Help Scout",homepage:"https://www.helpscout.net/",category:"customer-success",domains:["djtflbt20bdde.cloudfront.net","*.helpscout.net"],products:[{name:"Help Scout Beacon",urlPatterns:["beacon-v2.helpscout.net"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Alexa",homepage:"https://www.alexa.com/",category:"analytics",domains:["*.alexametrics.com","d31qbv1cthcecs.cloudfront.net"]},{name:"OneSignal",homepage:"https://onesignal.com/",category:"utility",domains:["*.onesignal.com"]},{name:"Lucky Orange",homepage:"https://www.luckyorange.com/",category:"analytics",domains:["*.luckyorange.com","d10lpsik1i8c69.cloudfront.net","*.luckyorange.net"]},{name:"Crazy Egg",homepage:"https://www.crazyegg.com/",category:"analytics",domains:["*.cetrk.com","*.crazyegg.com","*.hellobar.com","dnn506yrbagrg.cloudfront.net"]},{name:"Yandex Ads",company:"Yandex",homepage:"https://yandex.com/adv/",category:"ad",domains:["an.yandex.ru"]},{name:"Salesforce",homepage:"https://www.salesforce.com/products/marketing-cloud/",category:"analytics",domains:["*.krxd.net"]},{name:"Salesforce Commerce Cloud",homepage:"https://www.salesforce.com/products/commerce-cloud/overview/",category:"hosting",domains:["*.cquotient.com","*.demandware.net","demandware.edgesuite.net"]},{name:"Optimizely",homepage:"https://www.optimizely.com/",category:"analytics",domains:["*.optimizely.com"]},{name:"LiveChat",homepage:"https://www.livechat.com/",category:"customer-success",domains:["*.livechatinc.com","*.livechat.com","*.livechat-static.com"]},{name:"VK",homepage:"https://vk.com/",category:"social",domains:["*.vk.com"]},{name:"Tumblr",homepage:"https://tumblr.com/",category:"social",domains:["*.tumblr.com"]},{name:"Wistia",homepage:"https://wistia.com/",category:"video",domains:["*.wistia.com","embedwistia-a.akamaihd.net","*.wistia.net"]},{name:"Brightcove",homepage:"https://www.brightcove.com/en/",category:"video",domains:["*.brightcove.com","*.brightcove.net","*.zencdn.net"]},{name:"JSDelivr CDN",homepage:"https://www.jsdelivr.com/",category:"cdn",domains:["*.jsdelivr.net"]},{name:"Sumo",homepage:"https://sumo.com/",category:"marketing",domains:["*.sumo.com","*.sumome.com","sumo.b-cdn.net"]},{name:"Vimeo",homepage:"https://vimeo.com/",category:"video",domains:["*.vimeo.com","*.vimeocdn.com"],products:[{name:"Vimeo Embedded Player",urlPatterns:["player.vimeo.com/video/"],facades:[{name:"Lite Vimeo",repo:"https://github.com/slightlyoff/lite-vimeo"},{name:"Lite Vimeo Embed",repo:"https://github.com/luwes/lite-vimeo-embed"},{name:"Ngx Lite Video",repo:"https://github.com/karim-mamdouh/ngx-lite-video"}]}]},{name:"Disqus",homepage:"https://disqus.com/",category:"social",domains:["*.disqus.com","*.disquscdn.com"]},{name:"Yandex APIs",company:"Yandex",homepage:"https://yandex.ru/",category:"utility",domains:["api-maps.yandex.ru","money.yandex.ru"]},{name:"Yandex CDN",company:"Yandex",homepage:"https://yandex.ru/",category:"cdn",domains:["*.yandex.st","*.yastatic.net"]},{name:"Integral Ad Science",homepage:"https://integralads.com/uk/",category:"ad",domains:["*.adsafeprotected.com","*.iasds01.com"]},{name:"Tealium",homepage:"https://tealium.com/",category:"tag-manager",domains:["*.aniview.com","*.delvenetworks.com","*.limelight.com","*.tiqcdn.com","*.llnwd.net","*.tealiumiq.com"]},{name:"Pubmatic",homepage:"https://pubmatic.com/",category:"ad",domains:["*.pubmatic.com"]},{name:"Olark",homepage:"https://www.olark.com/",category:"customer-success",domains:["*.olark.com"]},{name:"Tawk.to",homepage:"https://www.tawk.to/",category:"customer-success",domains:["*.tawk.to"]},{name:"OptinMonster",homepage:"https://optinmonster.com/",category:"marketing",domains:["*.opmnstr.com","*.optmnstr.com","*.optmstr.com"]},{name:"ZenDesk",homepage:"https://zendesk.com/",category:"customer-success",domains:["*.zdassets.com","*.zendesk.com","*.zopim.com"]},{name:"Pusher",homepage:"https://pusher.com/",category:"utility",domains:["*.pusher.com","*.pusherapp.com"]},{name:"Drift",homepage:"https://www.drift.com/",category:"marketing",domains:["*.drift.com","*.driftt.com"],products:[{name:"Drift Live Chat",urlPatterns:["REGEXP:js\\.driftt\\.com\\/include\\/.*\\/.*\\.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Sentry",homepage:"https://sentry.io/",category:"utility",domains:["*.getsentry.com","*.ravenjs.com","*.sentry-cdn.com","*.sentry.io"]},{name:"Amazon Web Services",homepage:"https://aws.amazon.com/s3/",category:"other",domains:["*.amazon.com","*.amazonaws.com","*.amazonwebapps.com","*.amazonwebservices.com","*.elasticbeanstalk.com","*.images-amazon.com","*.amazon.co.uk"]},{name:"Amazon Pay",homepage:"https://pay.amazon.com",category:"utility",domains:["payments.amazon.com","*.payments-amazon.com"]},{name:"Media.net",homepage:"https://www.media.net/",category:"ad",domains:["*.media.net","*.mnet-ad.net"]},{name:"Yahoo!",homepage:"https://www.yahoo.com/",category:"ad",domains:["*.bluelithium.com","*.hostingprod.com","*.lexity.com","*.yahoo.com","*.yahooapis.com","*.yimg.com","*.zenfs.com","*.yahoo.net"]},{name:"Adroll",homepage:"https://www.adroll.com/",category:"ad",domains:["*.adroll.com"]},{name:"Twitch",homepage:"https://twitch.tv/",category:"video",domains:["*.twitch.tv"]},{name:"Taboola",homepage:"https://www.taboola.com/",category:"ad",domains:["*.taboola.com","*.taboolasyndication.com"]},{name:"Sizmek",homepage:"https://www.sizmek.com/",category:"ad",domains:["*.serving-sys.com","*.peer39.net"]},{name:"Scorecard Research",homepage:"https://www.scorecardresearch.com/",category:"ad",domains:["*.scorecardresearch.com"]},{name:"Criteo",homepage:"https://www.criteo.com/",category:"ad",domains:["*.criteo.com","*.emailretargeting.com","*.criteo.net"]},{name:"Segment",homepage:"https://segment.com/",category:"analytics",domains:["*.segment.com","*.segment.io"]},{name:"ShareThis",homepage:"https://www.sharethis.com/",category:"social",domains:["*.sharethis.com"]},{name:"Distil Networks",homepage:"https://www.distilnetworks.com/",category:"utility",domains:["*.areyouahuman.com"]},{name:"Connexity",homepage:"https://connexity.com/",category:"analytics",domains:["*.connexity.net"]},{name:"Popads",homepage:"https://www.popads.net/",category:"ad",domains:["*.popads.net"]},{name:"CreateJS CDN",homepage:"https://code.createjs.com/",category:"cdn",domains:["*.createjs.com"]},{name:"Squarespace",homepage:"https://www.squarespace.com/",category:"hosting",domains:["*.squarespace.com"]},{name:"Media Math",homepage:"https://www.mediamath.com/",category:"ad",domains:["*.mathads.com","*.mathtag.com"]},{name:"Mixpanel",homepage:"https://mixpanel.com/",category:"analytics",domains:["*.mixpanel.com","*.mxpnl.com"]},{name:"FontAwesome CDN",homepage:"https://fontawesome.com/",category:"cdn",domains:["*.fontawesome.com"]},{name:"Hubspot",homepage:"https://hubspot.com/",category:"marketing",domains:["*.hs-scripts.com","*.hubspot.com","*.leadin.com","*.hs-analytics.net","*.hscollectedforms.net","*.hscta.net","*.hsforms.net","*.hsleadflows.net","*.hsstatic.net","*.hubspot.net","*.hsforms.com","*.hs-banner.com","*.hs-embed-reporting.com","*.hs-growth-metrics.com","*.hs-data.com","*.hsadspixel.net"]},{name:"Mailchimp",homepage:"https://mailchimp.com/",category:"marketing",domains:["*.chimpstatic.com","*.list-manage.com","*.mailchimp.com"]},{name:"MGID",homepage:"https://www.mgid.com/",category:"ad",domains:["*.mgid.com","*.dt07.net"]},{name:"Stripe",homepage:"https://stripe.com",category:"utility",domains:["*.stripe.com","*.stripecdn.com","*.stripe.network"]},{name:"PayPal",homepage:"https://paypal.com",category:"utility",domains:["*.paypal.com","*.paypalobjects.com"]},{name:"Market GID",homepage:"https://www.marketgid.com/",category:"ad",domains:["*.marketgid.com"]},{name:"Pinterest",homepage:"https://pinterest.com/",category:"social",domains:["*.pinimg.com","*.pinterest.com"]},{name:"New Relic",homepage:"https://newrelic.com/",category:"utility",domains:["*.newrelic.com","*.nr-data.net"]},{name:"AppDynamics",homepage:"https://www.appdynamics.com/",category:"utility",domains:["*.appdynamics.com","*.eum-appdynamics.com","d3tjaysgumg9lf.cloudfront.net"]},{name:"Parking Crew",homepage:"https://parkingcrew.net/",category:"other",domains:["d1lxhc4jvstzrp.cloudfront.net","*.parkingcrew.net"]},{name:"WordAds",company:"Automattic",homepage:"https://wordads.co/",category:"ad",domains:["*.pubmine.com"]},{name:"AppNexus",homepage:"https://www.appnexus.com/",category:"ad",domains:["*.adnxs.com","*.ctasnet.com","*.adrdgt.com"]},{name:"Histats",homepage:"https://www.histats.com/",category:"analytics",domains:["*.histats.com"]},{name:"DoubleVerify",homepage:"https://www.doubleverify.com/",category:"ad",domains:["*.doubleverify.com","*.dvtps.com","*.iqfp1.com"]},{name:"Mediavine",homepage:"https://www.mediavine.com/",category:"ad",domains:["*.mediavine.com"]},{name:"Wix",homepage:"https://www.wix.com/",category:"hosting",domains:["*.parastorage.com","*.wix.com","*.wixstatic.com","*.wixapps.net"]},{name:"Webflow",homepage:"https://webflow.com/",category:"hosting",domains:["*.uploads-ssl.webflow.com","*.assets-global.website-files.com","*.assets.website-files.com"]},{name:"Weebly",homepage:"https://www.weebly.com/",category:"hosting",domains:["*.editmysite.com"]},{name:"LinkedIn",homepage:"https://www.linkedin.com/",category:"social",domains:["*.bizographics.com","platform.linkedin.com","*.slideshare.com","*.slidesharecdn.com"]},{name:"LinkedIn Ads",category:"ad",domains:["*.licdn.com","*.ads.linkedin.com","ads.linkedin.com","www.linkedin.com"]},{name:"Vox Media",homepage:"https://www.voxmedia.com/",category:"content",domains:["*.vox-cdn.com","*.voxmedia.com"]},{name:"Hotmart",homepage:"https://www.hotmart.com/",category:"content",domains:["*.hotmart.com"]},{name:"SoundCloud",homepage:"https://www.soundcloud.com/",category:"content",domains:["*.sndcdn.com","*.soundcloud.com","*.stratus.sc"]},{name:"Spotify",homepage:"https://www.spotify.com/",category:"content",domains:["*.scdn.co","*.spotify.com"]},{name:"AMP",homepage:"https://amp.dev/",category:"content",domains:["*.ampproject.org"]},{name:"Beeketing",homepage:"https://beeketing.com/",category:"marketing",domains:["*.beeketing.com"]},{name:"Albacross",homepage:"https://albacross.com/",category:"marketing",domains:["*.albacross.com"]},{name:"TrafficJunky",homepage:"https://www.trafficjunky.com/",category:"ad",domains:["*.contentabc.com","*.trafficjunky.net"]},{name:"Bootstrap CDN",homepage:"https://www.bootstrapcdn.com/",category:"cdn",domains:["*.bootstrapcdn.com"]},{name:"Shareaholic",homepage:"https://www.shareaholic.com/",category:"social",domains:["*.shareaholic.com","dsms0mj1bbhn4.cloudfront.net"]},{name:"Snowplow",homepage:"https://snowplowanalytics.com/",category:"analytics",domains:["d32hwlnfiv2gyn.cloudfront.net"]},{name:"RD Station",homepage:"https://www.rdstation.com/en/",category:"marketing",domains:["d335luupugsy2.cloudfront.net"]},{name:"Jivochat",homepage:"https://www.jivochat.com/",category:"customer-success",domains:["*.jivosite.com"]},{name:"Listrak",homepage:"https://www.listrak.com/",category:"marketing",domains:["*.listrak.com","*.listrakbi.com"]},{name:"Ontame",homepage:"https://www.ontame.io",category:"analytics",domains:["*.ontame.io"]},{name:"Ipify",homepage:"https://www.ipify.org",category:"utility",domains:["*.ipify.org"]},{name:"Ensighten",homepage:"https://www.ensighten.com/",category:"tag-manager",domains:["*.ensighten.com"]},{name:"EpiServer",homepage:"https://www.episerver.com",category:"content",domains:["*.episerver.net"]},{name:"mPulse",homepage:"https://developer.akamai.com/akamai-mpulse",category:"analytics",domains:["*.akstat.io","*.go-mpulse.net","*.mpulse.net","*.mpstat.us"]},{name:"Pingdom RUM",homepage:"https://www.pingdom.com/product/performance-monitoring/",category:"analytics",domains:["*.pingdom.net"]},{name:"SpeedCurve LUX",company:"SpeedCurve",homepage:"https://speedcurve.com/features/lux/",category:"analytics",domains:["*.speedcurve.com"]},{name:"Radar",company:"Cedexis",homepage:"https://www.cedexis.com/radar/",category:"analytics",domains:["*.cedexis-test.com","*.cedexis.com","*.cmdolb.com","cedexis.leasewebcdn.com","*.cedexis-radar.net","*.cedexis.net","cedexis-test01.insnw.net","cedexisakamaitest.azureedge.net","cedexispub.cdnetworks.net","cs600.wac.alphacdn.net","cs600.wpc.edgecastdns.net","global2.cmdolb.com","img-cedexis.mncdn.com","a-cedexis.msedge.net","zn3vgszfh.fastestcdn.net"]},{name:"Byside",homepage:"https://byside.com",category:"analytics",domains:["*.byside.com"]},{name:"VWO",homepage:"https://vwo.com",category:"analytics",domains:["*.vwo.com","*.visualwebsiteoptimizer.com","d5phz18u4wuww.cloudfront.net","*.wingify.com"]},{name:"Bing Ads",homepage:"https://bingads.microsoft.com",category:"ad",domains:["*.bing.com","*.microsoft.com","*.msn.com","*.s-msft.com","*.s-msn.com","*.msads.net","*.msecnd.net"]},{name:"GoSquared",homepage:"https://www.gosquared.com",category:"analytics",domains:["*.gosquared.com","d1l6p2sc9645hc.cloudfront.net"]},{name:"Usabilla",homepage:"https://usabilla.com",category:"analytics",domains:["*.usabilla.com","d6tizftlrpuof.cloudfront.net"]},{name:"Fastly Insights",homepage:"https://insights.fastlylabs.com",category:"analytics",domains:["*.fastly-insights.com"]},{name:"Visual IQ",homepage:"https://www.visualiq.com",category:"analytics",domains:["*.myvisualiq.net"]},{name:"Snapchat",homepage:"https://www.snapchat.com",category:"analytics",domains:["*.snapchat.com","*.sc-static.net"]},{name:"Atlas Solutions",homepage:"https://atlassolutions.com",category:"analytics",domains:["*.atdmt.com"]},{name:"Quantcast",homepage:"https://www.quantcast.com",category:"analytics",domains:["*.brtstats.com","*.quantcount.com","*.quantserve.com","*.semantictec.com","*.ntv.io"]},{name:"Spiceworks",homepage:"https://www.spiceworks.com",category:"analytics",domains:["*.spiceworks.com"]},{name:"Marketo",homepage:"https://www.marketo.com",category:"analytics",domains:["*.marketo.com","*.mktoresp.com","*.marketo.net"]},{name:"Intercom",homepage:"https://www.intercom.com",category:"customer-success",domains:["*.intercomcdn.com","*.intercom.io"],products:[{name:"Intercom Widget",urlPatterns:["widget.intercom.io","js.intercomcdn.com/shim.latest.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"},{name:"Intercom Facade",repo:"https://github.com/danielbachhuber/intercom-facade/"}]}]},{name:"Unpkg",homepage:"https://unpkg.com",category:"cdn",domains:["*.unpkg.com","*.npmcdn.com"]},{name:"ReadSpeaker",homepage:"https://www.readspeaker.com",category:"other",domains:["*.readspeaker.com"]},{name:"Browsealoud",homepage:"https://www.texthelp.com/en-gb/products/browsealoud/",category:"other",domains:["*.browsealoud.com","*.texthelp.com"]},{name:"15gifts",category:"customer-success",domains:["*.15gifts.com","*.primefuse.com"]},{name:"1xRUN",category:"utility",domains:["*.1xrun.com"]},{name:"2AdPro Media Solutions",category:"ad",domains:["*.2adpro.com"]},{name:"301 Digital Media",category:"content",domains:["*.301ads.com","*.301network.com"]},{name:"360 picnic platform",company:"MediaV",category:"ad",domains:["*.mediav.com"]},{name:"365 Media Group",category:"content",domains:["*.365dm.com"]},{name:"365 Tech Services",category:"hosting",domains:["*.365webservices.co.uk"]},{name:"3D Issue",category:"utility",domains:["*.3dissue.com","*.pressjack.com"]},{name:"47Line Technologies",category:"other",domains:["*.pejs.net"]},{name:"4finance",category:"utility",domains:["*.4finance.com"]},{name:"5miles",category:"content",domains:["*.5milesapp.com"]},{name:"77Tool",company:"77Agency",category:"analytics",domains:["*.77tracking.com"]},{name:"9xb",category:"ad",domains:["*.9xb.com"]},{name:"@UK",category:"hosting",domains:["*.uk-plc.net"]},{name:"A Perfect Pocket",category:"hosting",domains:["*.aperfectpocketdata.com"]},{name:"A-FIS PTE",category:"analytics",domains:["*.websta.me"]},{name:"AB Tasty",category:"analytics",domains:["*.abtasty.com","d1447tq2m68ekg.cloudfront.net"]},{name:"ABA RESEARCH",category:"analytics",domains:["*.abaresearch.uk","qmodal.azurewebsites.net"]},{name:"ADMIZED",category:"ad",domains:["*.admized.com"]},{name:"ADNOLOGIES",category:"ad",domains:["*.heias.com"]},{name:"ADventori",category:"ad",domains:["*.adventori.com"]},{name:"AI Media Group",category:"ad",domains:["*.aimediagroup.com"]},{name:"AIR.TV",category:"ad",domains:["*.air.tv"]},{name:"AKQA",category:"ad",domains:["*.srtk.net"]},{name:"AOL ad",company:"AOL",category:"ad",domains:["*.atwola.com"]},{name:"AOL On",company:"AOL",category:"content",domains:["*.5min.com"]},{name:"AOL Sponsored Listiings",company:"AOL",category:"ad",domains:["*.adsonar.com"]},{name:"APSIS Lead",company:"APSIS International AB",category:"ad",domains:["*.prospecteye.com"]},{name:"APSIS Profile Cloud",company:"APSIS",category:"analytics",domains:["*.innomdc.com"]},{name:"APSIS Forms",company:"APSIS",category:"other",domains:["*.apsisforms.com"]},{name:"ARENA",company:"Altitude",category:"ad",domains:["*.altitude-arena.com"]},{name:"ARM",category:"analytics",domains:["*.tag4arm.com"]},{name:"ASAPP",category:"other",domains:["*.asapp.com"]},{name:"ASP",category:"hosting",domains:["*.goshowoff.com"]},{name:"AT Internet",category:"analytics",domains:["*.ati-host.net"]},{name:"ATTRAQT",category:"utility",domains:["*.attraqt.com","*.locayta.com"]},{name:"AVANSER",category:"analytics",domains:["*.avanser.com.au"]},{name:"AVG",company:"AVG Technologies",category:"utility",domains:["*.avg.com"]},{name:"AWeber",category:"ad",domains:["*.aweber.com"]},{name:"AXS",category:"content",domains:["*.axs.com"]},{name:"Accentuate",company:"Accentuate Digital",category:"utlity",homepage:"https://www.accentuate.io/",domains:["*.accentuate.io"]},{name:"Accenture",category:"analytics",domains:["*.tmvtp.com"]},{name:"Accord Holdings",category:"ad",domains:["*.agcdn.com"]},{name:"Accordant Media",category:"ad",domains:["*.a3cloud.net"]},{name:"Account Kit",category:"other",domains:["*.accountkit.com"]},{name:"Accuen Media (Omnicom Media Group)",category:"content",domains:["*.p-td.com"]},{name:"Accuweather",category:"content",domains:["*.accuweather.com"]},{name:"Acquisio",category:"ad",domains:["*.acq.io"]},{name:"Act-On Software",category:"marketing",domains:["*.actonsoftware.com"]},{name:"ActBlue",category:"other",domains:["*.actblue.com"]},{name:"Active Agent",category:"ad",domains:["*.active-agent.com"]},{name:"ActiveCampaign",category:"ad",domains:["*.trackcmp.net","app-us1.com","*.app-us1.com"]},{name:"AcuityAds",category:"ad",domains:["*.acuityplatform.com"]},{name:"Acxiom",category:"ad",domains:["*.acxiom-online.com","*.acxiomapac.com","*.delivery.net"]},{name:"Ad4Screen",category:"ad",domains:["*.a4.tl"]},{name:"Ad6Media",category:"ad",domains:["*.ad6media.fr"]},{name:"AdCurve",category:"ad",domains:["*.shop2market.com"]},{name:"AdEasy",category:"ad",domains:["*.adeasy.ru"]},{name:"AdExtent",category:"ad",domains:["*.adextent.com"]},{name:"AdForge Edge",company:"AdForge",category:"ad",domains:["*.adforgeinc.com"]},{name:"AdGear",company:"Samsung Electronics",category:"ad",domains:["*.adgear.com","*.adgrx.com"]},{name:"AdInMedia",category:"ad",domains:["*.fastapi.net"]},{name:"AdJug",category:"ad",domains:["*.adjug.com"]},{name:"AdMatic",category:"ad",domains:["*.admatic.com.tr"]},{name:"AdMedia",category:"ad",domains:["*.admedia.com"]},{name:"AdRecover",category:"ad",domains:["*.adrecover.com"]},{name:"AdRiver",category:"ad",domains:["*.adriver.ru"]},{name:"AdSniper",category:"ad",domains:["*.adsniper.ru","*.sniperlog.ru"]},{name:"AdSpeed",category:"ad",domains:["*.adspeed.net"]},{name:"AdSpruce",category:"ad",domains:["*.adspruce.com"]},{name:"AdSupply",category:"ad",domains:["*.doublepimp.com"]},{name:"AdTheorent",category:"ad",domains:["*.adentifi.com"]},{name:"AdThink AudienceInsights",company:"AdThink Media",category:"analytics",domains:["*.audienceinsights.net"]},{name:"AdTrue",company:"FPT AdTrue",category:"ad",domains:["*.adtrue.com"]},{name:"AdYapper",category:"ad",domains:["*.adyapper.com"]},{name:"Adacado",category:"ad",domains:["*.adacado.com"]},{name:"Adap.tv",category:"ad",domains:["*.adap.tv"]},{name:"Adapt Services",category:"hosting",domains:["*.adcmps.com"]},{name:"Adaptive Web",category:"hosting",domains:["*.adaptive.co.uk"]},{name:"Adara Media",category:"ad",domains:["*.yieldoptimizer.com"]},{name:"Adblade",category:"ad",domains:["*.adblade.com"]},{name:"Adbrain",category:"ad",domains:["*.adbrn.com"]},{name:"AddEvent",category:"utility",domains:["*.addevent.com"]},{name:"AddShoppers",category:"social",domains:["*.addshoppers.com","d3rr3d0n31t48m.cloudfront.net","*.shop.pe"]},{name:"AddThisEvent",category:"hosting",domains:["*.addthisevent.com"]},{name:"Addoox MetaNetwork",company:"Addoox",category:"ad",domains:["*.metanetwork.net"]},{name:"Addvantage Media",category:"ad",domains:["*.addvantagemedia.com","*.simplytechnology.net"]},{name:"AD EBis",category:"analytics",homepage:"https://www.ebis.ne.jp/",domains:["*.ebis.ne.jp"]},{name:"Adecs",category:"customer-success",domains:["*.adecs.co.uk"]},{name:"Adelphic",category:"ad",domains:["*.ipredictive.com"]},{name:"Adestra",category:"ad",domains:["*.adestra.com","*.msgfocus.com"]},{name:"Adform",category:"ad",domains:["*.adform.net","*.adformdsp.net"]},{name:"Adkontekst",category:"ad",domains:["*.adkontekst.pl"]},{name:"Adlead",category:"ad",domains:["*.webelapp.com"]},{name:"Adledge",category:"utility",domains:["*.adledge.com"]},{name:"Adloox",category:"ad",domains:["*.adlooxtracking.com"]},{name:"Adlux",category:"ad",domains:["*.adlux.com"]},{name:"Admedo",category:"ad",domains:["*.a8723.com","*.adizio.com","*.admedo.com"]},{name:"Admeta",company:"Wideorbit",category:"ad",domains:["*.atemda.com"]},{name:"Admetrics",company:"Next Tuesday",category:"analytics",domains:["*.nt.vc"]},{name:"Admiral",category:"ad",domains:["*.unknowntray.com"]},{name:"Admitad",category:"ad",domains:["*.lenmit.com"]},{name:"Admixer for Publishers",company:"Admixer",category:"ad",domains:["*.admixer.net"]},{name:"Adnium",category:"ad",domains:["*.adnium.com"]},{name:"Adnostic",company:"Dennis Publishing",category:"ad",domains:["*.adnostic.co.uk"]},{name:"Adobe Marketing Cloud",company:"Adobe Systems",category:"ad",domains:["*.adobetag.com"]},{name:"Adobe Scene7",company:"Adobe Systems",category:"content",domains:["wwwimages.adobe.com","*.scene7.com","*.everestads.net","*.everestjs.net"]},{name:"Adobe Systems",category:"content",domains:["adobe.com","www.adobe.com"]},{name:"Adobe Business Catalyst",homepage:"https://www.businesscatalyst.com/",category:"hosting",domains:["*.businesscatalyst.com"]},{name:"Adocean",company:"Gemius",category:"ad",domains:["*.adocean.pl"]},{name:"Adometry",company:"Google",category:"ad",domains:["*.dmtry.com"]},{name:"Adomik",category:"analytics",domains:["*.adomik.com"]},{name:"Adotmob",category:"ad",domains:["*.adotmob.com"]},{name:"Adrian Quevedo",category:"hosting",domains:["*.adrianquevedo.com"]},{name:"Adroit Digital Solutions",category:"ad",domains:["*.imiclk.com","*.abmr.net"]},{name:"AdsNative",category:"ad",domains:["*.adsnative.com"]},{name:"AdsWizz",category:"ad",domains:["*.adswizz.com"]},{name:"Adscale",category:"ad",domains:["*.adscale.de"]},{name:"Adschoom",company:"JSWeb Production",category:"ad",domains:["*.adschoom.com"]},{name:"Adscience",category:"ad",domains:["*.adscience.nl"]},{name:"Adsiduous",category:"ad",domains:["*.adsiduous.com"]},{name:"Adsty",category:"ad",domains:["*.adx1.com"]},{name:"Adtech (AOL)",category:"ad",domains:["*.adtechus.com"]},{name:"Adtegrity",category:"ad",domains:["*.adtpix.com"]},{name:"Adthink",company:"Adthink Media",category:"ad",domains:["*.adxcore.com","*.dcoengine.com"]},{name:"AdultWebmasterEmpire.Com",category:"ad",domains:["*.awempire.com"]},{name:"Adunity",category:"ad",domains:["*.adunity.com"]},{name:"Advance Magazine Group",category:"content",domains:["*.condenastdigital.com","*.condenet.com","*.condenast.co.uk"]},{name:"Adverline Board",company:"Adverline",category:"ad",domains:["*.adverline.com","*.adnext.fr"]},{name:"AdvertServe",category:"ad",domains:["*.advertserve.com"]},{name:"Advolution",category:"utility",domains:["*.advolution.de"]},{name:"Adwise",category:"ad",domains:["*.adwise.bg"]},{name:"Adyen",category:"utility",domains:["*.adyen.com"]},{name:"Adyoulike",category:"ad",domains:["*.adyoulike.com","*.omnitagjs.com","*.adyoulike.net"]},{name:"Adzerk",category:"ad",domains:["*.adzerk.net"]},{name:"Adzip",company:"Adbox Digital",category:"ad",domains:["*.adzip.co"]},{name:"AerServ",category:"ad",domains:["*.aerserv.com"]},{name:"Affectv",category:"ad",domains:["*.affectv.com","*.affec.tv"]},{name:"Affiliate Window",company:"Digital Window",category:"ad",domains:["*.dwin1.com"]},{name:"Affiliatly",category:"ad",domains:["*.affiliatly.com"]},{name:"Affino",category:"ad",domains:["affino.com"]},{name:"Affirm",category:"utility",domains:["*.affirm.com"]},{name:"Afterpay",company:"Block",category:"utlity",homepage:"https://www.afterpay.com/",domains:["*.afterpay.com"]},{name:"Agenda Media",category:"ad",domains:["*.agendamedia.co.uk"]},{name:"Aggregate Knowledge",company:"Neustar",category:"ad",domains:["*.agkn.com"]},{name:"AgilOne",category:"marketing",domains:["*.agilone.com"]},{name:"Agility",category:"hosting",domains:["*.agilitycms.com"]},{name:"Ahalogy",category:"social",domains:["*.ahalogy.com"]},{name:"Aheadworks",category:"utility",domains:["*.aheadworks.com"]},{name:"AirPR",category:"analytics",domains:["*.airpr.com"]},{name:"Aira",category:"ad",domains:["*.aira.net"]},{name:"Airport Parking and Hotels",category:"content",domains:["*.aph.com"]},{name:"Akanoo",category:"analytics",domains:["*.akanoo.com"]},{name:"Alchemy",company:"AndBeyond.Media",category:"ad",domains:["*.andbeyond.media"]},{name:"AlephD",company:"AOL",category:"ad",domains:["*.alephd.com"]},{name:"AliveChat",company:"AYU Technology Solutions",category:"customer-success",domains:["*.websitealive.com","*.websitealive7.com"]},{name:"All Access",category:"other",domains:["*.allaccess.com.ph"]},{name:"Alliance for Audited Media",category:"ad",domains:["*.aamsitecertifier.com"]},{name:"Allyde",category:"marketing",domains:["*.mautic.com"]},{name:"AlphaSSL",category:"utility",domains:["*.alphassl.com"]},{name:"Altitude",category:"ad",domains:["*.altitudeplatform.com"]},{name:"Altocloud",category:"analytics",domains:["*.altocloud.com"]},{name:"Amadeus",category:"content",domains:["*.e-travel.com"]},{name:"Amazon CloudFront",company:"Amazon",category:"utility",domains:["cloudfront.net"]},{name:"Ambassador",category:"ad",domains:["*.getambassador.com"]},{name:"Ambient",company:"Ericcson",category:"other",domains:["*.adnetwork.vn","*.ambientplatform.vn"]},{name:"Amelia Communication",category:"hosting",domains:["*.sara.media"]},{name:"Amobee",category:"marketing",domains:["*.amgdgt.com","*.kontera.com"]},{name:"Amplience",category:"marketing",domains:["*.10cms.com","*.amplience.com","*.amplience.net","*.bigcontent.io","*.adis.ws"]},{name:"Amplitude Mobile Analytics",company:"Amplitude",category:"analytics",domains:["*.amplitude.com","d24n15hnbwhuhn.cloudfront.net"]},{name:"Anametrix",company:"Ensighten",category:"analytics",domains:["*.anametrix.com"]},{name:"Ancora Platform",company:"Ancora Media Solutions",category:"ad",domains:["*.ancoraplatform.com"]},{name:"Anedot",category:"other",domains:["*.anedot.com"]},{name:"AnimateJS",category:"utility",domains:["*.animatedjs.com"]},{name:"AnswerDash",category:"customer-success",domains:["*.answerdash.com"]},{name:"Answers",category:"analytics",domains:["*.answcdn.com","*.answers.com","*.dsply.com"]},{name:"Apester",category:"analytics",domains:["*.apester.com","*.qmerce.com"]},{name:"Apligraf SmartWeb",company:"Apligraf",category:"utility",domains:["*.apligraf.com.br"]},{name:"Appier",category:"ad",domains:["*.appier.net"]},{name:"Appsolute",category:"utility",homepage:"https://appsolute.us/",domains:["dropahint.love"]},{name:"Apptus eSales",company:"Apptus",category:"analytics",domains:["*.apptus.com"]},{name:"Arbor",company:"LiveRamp",category:"other",domains:["*.pippio.com"]},{name:"Ardent Creative",category:"hosting",domains:["*.ardentcreative.co.uk"]},{name:"Arnold Clark Automobiles",category:"content",domains:["*.arnoldclark.com"]},{name:"Atom Content Marketing",category:"content",domains:["*.atomvault.net"]},{name:"Atom Data",category:"other",domains:["*.atomdata.io"]},{name:"Attribution",category:"ad",domains:["*.attributionapp.com"]},{name:"Audience 360",company:"Datapoint Media",category:"ad",domains:["*.dpmsrv.com"]},{name:"Audience Science",category:"ad",domains:["*.revsci.net"]},{name:"AudienceSearch",company:"Intimate Merger",category:"ad",domains:["*.im-apps.net"]},{name:"Auditorius",category:"ad",domains:["*.audtd.com"]},{name:"Augur",category:"analytics",domains:["*.augur.io"]},{name:"Auto Link Maker",company:"Apple",category:"ad",domains:["*.apple.com"]},{name:"Autopilot",category:"ad",domains:["*.autopilothq.com"]},{name:"Avail",company:"RichRelevance",category:"ad",domains:["*.avail.net"]},{name:"AvantLink",category:"ad",domains:["*.avmws.com"]},{name:"Avco Systems",category:"utility",domains:["*.avcosystems.com"]},{name:"Avid Media",category:"customer-success",domains:["*.adspdbl.com","*.metadsp.co.uk"]},{name:"Avocet Systems",category:"ad",domains:["*.avocet.io","ads.avct.cloud"]},{name:"Avora",category:"analytics",domains:["*.truedash.com"]},{name:"Azure Traffic Manager",company:"Microsoft",category:"other",domains:["*.gateway.net","*.trafficmanager.net"]},{name:"Azure Web Services",company:"Microsoft",category:"cdn",domains:["*.azurewebsites.net","*.azureedge.net","*.msedge.net","*.windows.net"]},{name:"BAM",category:"analytics",domains:["*.bam-x.com"]},{name:"Baifendian Technology",category:"marketing",domains:["*.baifendian.com"]},{name:"Bankrate",category:"utility",domains:["*.bankrate.com"]},{name:"BannerFlow",company:"Nordic Factory Solutions",category:"ad",domains:["*.bannerflow.com"]},{name:"Barclaycard SmartPay",company:"Barclaycard",category:"utility",domains:["*.barclaycardsmartpay.com"]},{name:"Barilliance",category:"analytics",domains:["*.barilliance.net","dn3y71tq7jf07.cloudfront.net"]},{name:"Barnebys",category:"other",domains:["*.barnebys.com"]},{name:"Basis",company:"Basis Technologies",category:"ad",homepage:"https://basis.net/",domains:["*.basis.net"]},{name:"Batch Media",category:"ad",domains:["*.t4ft.de"]},{name:"Bauer Consumer Media",category:"content",domains:["*.bauercdn.com","*.greatmagazines.co.uk"]},{name:"Baynote",category:"analytics",domains:["*.baynote.net"]},{name:"Bazaarvoice",category:"analytics",domains:["*.bazaarvoice.com","*.feedmagnet.com"]},{name:"Beachfront Media",category:"ad",domains:["*.bfmio.com"]},{name:"BeamPulse",category:"analytics",domains:["*.beampulse.com"]},{name:"Beeswax",category:"ad",domains:["*.bidr.io"]},{name:"Beetailer",category:"social",domains:["*.beetailer.com"]},{name:"Best Of Media S.A.",category:"content",domains:["*.servebom.com"]},{name:"Bet365",category:"ad",domains:["*.bet365affiliates.com"]},{name:"Betfair",category:"other",domains:["*.cdnbf.net"]},{name:"Betgenius",company:"Genius Sports",category:"content",domains:["*.connextra.com"]},{name:"Better Banners",category:"ad",domains:["*.betterbannerscloud.com"]},{name:"Better Business Bureau",category:"analytics",domains:["*.bbb.org"]},{name:"Between Digital",category:"ad",domains:["*.betweendigital.com"]},{name:"BidTheatre",category:"ad",domains:["*.bidtheatre.com"]},{name:"Bidtellect",category:"ad",domains:["*.bttrack.com"]},{name:"Bigcommerce",category:"marketing",domains:["*.bigcommerce.com"]},{name:"BitGravity",company:"Tata Communications",category:"content",domains:["*.bitgravity.com"]},{name:"Bitly",category:"utility",domains:["*.bitly.com","*.lemde.fr","*.bit.ly"]},{name:"Bizible",category:"ad",domains:["*.bizible.com","*.bizibly.com"]},{name:"Bizrate",category:"analytics",domains:["*.bizrate.com"]},{name:"BlastCasta",category:"social",domains:["*.poweringnews.com"]},{name:"Blindado",category:"utility",domains:["*.siteblindado.com"]},{name:"Blis",category:"ad",domains:["*.blismedia.com"]},{name:"Blogg.se",category:"hosting",domains:["*.cdnme.se","*.publishme.se"]},{name:"BloomReach",category:"ad",domains:["*.brcdn.com","*.brsrvr.com","*.brsvr.com"]},{name:"Bloomberg",category:"content",domains:["*.gotraffic.net"]},{name:"Shop Logic",company:"BloomReach",category:"marketing",domains:["*.goshoplogic.com"]},{name:"Blue State Digital",category:"ad",domains:["*.bsd.net"]},{name:"Blue Triangle Technologies",category:"analytics",domains:["*.btttag.com"]},{name:"BlueCava",category:"ad",domains:["*.bluecava.com"]},{name:"BlueKai",company:"Oracle",category:"ad",domains:["*.bkrtx.com","*.bluekai.com"]},{name:"Bluecore",category:"analytics",domains:["*.bluecore.com"]},{name:"Bluegg",category:"hosting",domains:["d1va5oqn59yrvt.cloudfront.net"]},{name:"Bold Commerce",category:"utility",domains:["*.shappify-cdn.com","*.shappify.com","*.boldapps.net"]},{name:"BoldChat",company:"LogMeIn",category:"customer-success",domains:["*.boldchat.com"]},{name:"Bombora",category:"ad",domains:["*.mlno6.com"]},{name:"Bonnier",category:"content",domains:["*.bonniercorp.com"]},{name:"Bookatable",category:"content",domains:["*.bookatable.com","*.livebookings.com"]},{name:"Booking.com",category:"content",domains:["*.bstatic.com"]},{name:"Boomtrain",category:"ad",domains:["*.boomtrain.com","*.boomtrain.net"]},{name:"BoostSuite",category:"ad",domains:["*.poweredbyeden.com"]},{name:"Boostable",category:"ad",domains:["*.boostable.com"]},{name:"Bootstrap Chinese network",category:"cdn",domains:["*.bootcss.com"]},{name:"Booxscale",category:"ad",domains:["*.booxscale.com"]},{name:"Borderfree",company:"pitney bowes",category:"utility",domains:["*.borderfree.com","*.fiftyone.com"]},{name:"BowNow",category:"analytics",homepage:"https://bow-now.jp/",domains:["*.bownow.jp"]},{name:"Box",category:"hosting",domains:["*.box.com"]},{name:"Boxever",category:"analytics",domains:["*.boxever.com"]},{name:"Braintree Payments",company:"Paypal",category:"utility",domains:["*.braintreegateway.com"]},{name:"Branch Metrics",category:"ad",domains:["*.branch.io","*.app.link"]},{name:"Brand Finance",category:"other",domains:["*.brandirectory.com"]},{name:"Brand View",category:"analytics",domains:["*.brandview.com"]},{name:"Brandscreen",category:"ad",domains:["*.rtbidder.net"]},{name:"BridgeTrack",company:"Sapient",category:"ad",domains:["*.bridgetrack.com"]},{name:"BrightRoll",company:"Yahoo!",category:"ad",domains:["*.btrll.com"]},{name:"BrightTag / Signal",company:"Signal",homepage:"https://www.signal.co",category:"tag-manager",domains:["*.btstatic.com","*.thebrighttag.com"]},{name:"Brightcove ZenCoder",company:"Brightcove",category:"other",domains:["*.zencoder.net"]},{name:"Bronto Software",category:"marketing",domains:["*.bm23.com","*.bronto.com","*.brontops.com"]},{name:"Browser-Update.org",category:"other",domains:["*.browser-update.org"]},{name:"Buffer",category:"social",domains:["*.bufferapp.com"]},{name:"Bugsnag",category:"utility",domains:["*.bugsnag.com","d2wy8f7a9ursnm.cloudfront.net"]},{name:"Burst Media",category:"ad",domains:["*.burstnet.com","*.1rx.io"]},{name:"Burt",category:"analytics",domains:["*.richmetrics.com","*.burt.io"]},{name:"Business Message",category:"ad",domains:["*.message-business.com"]},{name:"Business Week",company:"Bloomberg",category:"social",domains:["*.bwbx.io"]},{name:"Buto",company:"Big Button",category:"ad",domains:["*.buto.tv"]},{name:"Button",category:"ad",domains:["*.btncdn.com"]},{name:"BuySellAds",category:"ad",domains:["*.buysellads.com","*.buysellads.net"]},{name:"BuySight (AOL)",category:"ad",domains:["*.pulsemgr.com"]},{name:"Buyapowa",category:"ad",domains:["*.co-buying.com"]},{name:"BuzzFeed",category:"social",domains:["*.buzzfed.com"]},{name:"C1X",category:"ad",domains:["*.c1exchange.com"]},{name:"C3 Metrics",category:"analytics",domains:["*.c3tag.com"]},{name:"CANDDi",company:"Campaign and Digital Intelligence",category:"ad",domains:["*.canddi.com"]},{name:"CCM benchmark Group",category:"social",domains:["*.ccm2.net"]},{name:"CD Networks",category:"utility",domains:["*.gccdn.net"]},{name:"CDN Planet",category:"analytics",domains:["*.cdnplanet.com"]},{name:"InAuth",category:"utility",homepage:"https://www.inauth.com/",domains:["*.cdn-net.com"]},{name:"CJ Affiliate",company:"Conversant",category:"ad",domains:["*.cj.com","*.dpbolvw.net"]},{name:"CJ Affiliate by Conversant",company:"Conversant",category:"ad",domains:["*.ftjcfx.com"]},{name:"CNBC",category:"content",domains:["*.cnbc.com"]},{name:"CNET Content Solutions",company:"CBS Interactive",category:"content",domains:["*.cnetcontent.com"]},{name:"CPEx",category:"content",domains:["*.cpex.cz"]},{name:"CPXi",category:"ad",domains:["*.cpxinteractive.com"]},{name:"CUBED Attribution",company:"CUBED",category:"ad",domains:["*.withcubed.com"]},{name:"Cachefly",category:"utility",domains:["*.cachefly.net"]},{name:"Calendly",category:"other",domains:["*.calendly.com"]},{name:"CallRail",category:"analytics",domains:["*.callrail.com"]},{name:"CallTrackingMetrics",category:"analytics",domains:["*.tctm.co"]},{name:"Canned Banners",category:"ad",domains:["*.cannedbanners.com"]},{name:"Canopy Labs",category:"analytics",domains:["*.canopylabs.com"]},{name:"Capita",category:"utility",domains:["*.crcom.co.uk"]},{name:"Captify Media",category:"ad",domains:["*.cpx.to"]},{name:"Captiify",category:"ad",domains:["*.captifymedia.com"]},{name:"Captivate Ai",category:"ad",domains:["*.captivate.ai"]},{name:"Captora",category:"marketing",domains:["*.captora.com"]},{name:"Carcloud",category:"other",domains:["*.carcloud.co.uk"]},{name:"Cardlytics",category:"ad",domains:["*.cardlytics.com"]},{name:"Cardosa Enterprises",category:"analytics",domains:["*.y-track.com"]},{name:"Caspian Media",category:"ad",domains:["*.caspianmedia.com"]},{name:"Cast",category:"utility",domains:["*.cast.rocks"]},{name:"Catch",category:"other",domains:["*.getcatch.com"]},{name:"Cavisson",category:"analytics",domains:["*.cavisson.com"]},{name:"Cedato",category:"ad",domains:["*.algovid.com","*.vdoserv.com"]},{name:"Celebrus Technologies",category:"analytics",domains:["*.celebrus.com"]},{name:"Celtra",category:"ad",domains:["*.celtra.com"]},{name:"Centro",category:"ad",domains:["*.brand-server.com"]},{name:"Ceros",category:"other",domains:["ceros.com","view.ceros.com"]},{name:"Ceros Analytics",company:"Ceros",category:"analytics",domains:["api.ceros.com"]},{name:"Certona",category:"analytics",domains:["*.certona.net"]},{name:"Certum",category:"utility",domains:["*.ocsp-certum.com","*.certum.pl"]},{name:"Cgrdirect",category:"other",domains:["*.cgrdirect.co.uk"]},{name:"Channel 5 Media",category:"ad",domains:["*.five.tv"]},{name:"Channel.me",category:"customer-success",domains:["*.channel.me"]},{name:"ChannelAdvisor",category:"ad",domains:["*.channeladvisor.com","*.searchmarketing.com"]},{name:"ChannelApe",company:"ChannelApe",category:"other",homepage:"https://www.channelape.com/",domains:["*.channelape.com"]},{name:"Chargeads Oscar",company:"Chargeads",category:"ad",domains:["*.chargeads.com"]},{name:"Charities Aid Foundation",category:"utility",domains:["*.cafonline.org"]},{name:"Chartbeat",category:"analytics",domains:["*.chartbeat.com","*.chartbeat.net"]},{name:"Cheapflights Media",company:"Momondo",category:"content",domains:["*.momondo.net"]},{name:"CheckM8",category:"ad",domains:["*.checkm8.com"]},{name:"CheckRate",company:"FreeStart",category:"utility",domains:["*.checkrate.co.uk"]},{name:"Checkfront",category:"other",domains:["*.checkfront.com","dcg3jth5savst.cloudfront.net"]},{name:"CheetahMail",company:"Experian",category:"ad",domains:["*.chtah.com"]},{name:"Chitika",category:"ad",domains:["*.chitika.net"]},{name:"ChoiceStream",category:"ad",domains:["*.choicestream.com"]},{name:"Cint",category:"social",domains:["*.cint.com"]},{name:"Civic",category:"hosting",domains:["*.civiccomputing.com"]},{name:"ClearRise",category:"customer-success",domains:["*.clearrise.com"]},{name:"Clearstream",category:"ad",domains:["*.clrstm.com"]},{name:"Clerk.io ApS",category:"analytics",domains:["*.clerk.io"]},{name:"CleverDATA",category:"ad",domains:["*.1dmp.io"]},{name:"CleverTap",category:"analytics",domains:["d2r1yp2w7bby2u.cloudfront.net"]},{name:"Click Density",category:"analytics",domains:["*.clickdensity.com"]},{name:"Click4Assistance",category:"customer-success",domains:["*.click4assistance.co.uk"]},{name:"ClickDesk",category:"customer-success",domains:["*.clickdesk.com","d1gwclp1pmzk26.cloudfront.net"]},{name:"ClickDimensions",category:"ad",domains:["*.clickdimensions.com"]},{name:"Clickadu (Winner Solutions)",category:"ad",domains:["*.clickadu.com"]},{name:"Clickagy Audience Lab",company:"Clickagy",category:"ad",domains:["*.clickagy.com"]},{name:"Clickio",category:"ad",domains:[]},{name:"Clicktale",category:"analytics",domains:["*.cdngc.net","*.clicktale.net"]},{name:"Clicktripz",category:"content",domains:["*.clicktripz.com"]},{name:"Clik.com Websites",category:"content",domains:["*.clikpic.com"]},{name:"Cloud Technologies",category:"ad",domains:["*.behavioralengine.com","*.behavioralmailing.com"]},{name:"Cloud-A",category:"other",domains:["*.bulkstorage.ca"]},{name:"Cloud.typography",company:"Hoefler &amp; Co",category:"cdn",domains:["*.typography.com"]},{name:"CloudSponge",category:"ad",domains:["*.cloudsponge.com"]},{name:"CloudVPS",category:"other",domains:["*.adoftheyear.com","*.objectstore.eu"]},{name:"Cloudinary",category:"content",domains:["*.cloudinary.com"]},{name:"Cloudqp",company:"Cloudwp",category:"other",domains:["*.cloudwp.io"]},{name:"Cludo",category:"utility",domains:["*.cludo.com"]},{name:"Cognesia",category:"marketing",domains:["*.intelli-direct.com"]},{name:"CogoCast",company:"Cogo Labs",category:"ad",domains:["*.cogocast.net"]},{name:"Colbenson",category:"utility",domains:["*.colbenson.com"]},{name:"Collective",category:"ad",domains:["*.collective-media.net"]},{name:"Com Laude",category:"other",domains:["*.gdimg.net"]},{name:"Comm100",category:"customer-success",domains:["*.comm100.com"]},{name:"CommerceHub",category:"marketing",domains:["*.mercent.com"]},{name:"Commission Factory",category:"ad",domains:["*.cfjump.com"]},{name:"Communicator",category:"ad",domains:["*.communicatorcorp.com","*.communicatoremail.com"]},{name:"Comodo",category:"utility",domains:["*.comodo.com","*.trust-provider.com","*.trustlogo.com","*.usertrust.com","*.comodo.net"]},{name:"Comodo Certificate Authority",company:"Comodo",category:"utility",domains:["crt.comodoca.com","*.comodoca4.com","ocsp.comodoca.com","ocsp.usertrust.com","crt.usertrust.com"]},{name:"Compete",company:"Millwood Brown Digital",category:"analytics",domains:["*.c-col.com","*.compete.com"]},{name:"Compuware",category:"analytics",domains:["*.axf8.net"]},{name:"Conductrics",category:"analytics",domains:["*.conductrics.com"]},{name:"Confirmit",category:"analytics",domains:["*.confirmit.com"]},{name:"Connatix",category:"ad",domains:["*.connatix.com"]},{name:"Connect Events",category:"hosting",domains:["*.connectevents.com.au"]},{name:"Constant Contact",category:"ad",domains:["*.ctctcdn.com"]},{name:"Constructor.io",category:"utility",domains:["*.cnstrc.com"]},{name:"Contabo",category:"hosting",domains:["185.2.100.179"]},{name:"Content Media Corporation",category:"content",domains:["*.contentmedia.eu"]},{name:"ContentSquare",category:"analytics",domains:["d1m6l9dfulcyw7.cloudfront.net","*.content-square.net","*.contentsquare.net"]},{name:"ContextWeb",category:"ad",domains:["*.contextweb.com"]},{name:"Continental Exchange Solutions",category:"utility",domains:["*.hifx.com"]},{name:"Converge-Digital",category:"ad",domains:["*.converge-digital.com"]},{name:"Conversant",category:"analytics",domains:["*.dotomi.com","*.dtmpub.com","*.emjcd.com","mediaplex.com","*.tqlkg.com","*.fastclick.net"]},{name:"Conversant Ad Server",company:"Conversant",category:"ad",domains:["adfarm.mediaplex.com","*.mediaplex.com"]},{name:"Conversant Tag Manager",company:"Conversant",category:"tag-manager",domains:["*.mplxtms.com"]},{name:"Conversio",category:"ad",domains:["*.conversio.com"]},{name:"Conversion Labs",category:"ad",domains:["*.net.pl"]},{name:"Conversion Logic",category:"ad",domains:["*.conversionlogic.net"]},{name:"Convert Insights",category:"analytics",domains:["*.convertexperiments.com"]},{name:"ConvertMedia",category:"ad",domains:["*.admailtiser.com","*.basebanner.com","*.cmbestsrv.com","*.vidfuture.com","*.zorosrv.com"]},{name:"Convertro",category:"ad",domains:["*.convertro.com"]},{name:"Conviva",category:"content",domains:["*.conviva.com"]},{name:"Cookie Reports",category:"utility",domains:["*.cookiereports.com"]},{name:"Cookie-Script.com",category:"utility",domains:["*.cookie-script.com"]},{name:"CookieQ",company:"Baycloud Systems",category:"utility",domains:["*.cookieq.com"]},{name:"CoolaData",category:"analytics",domains:["*.cooladata.com"]},{name:"CopperEgg",category:"analytics",domains:["*.copperegg.com","d2vig74li2resi.cloudfront.net"]},{name:"Council ad Network",category:"ad",domains:["*.counciladvertising.net"]},{name:"Covert Pics",category:"content",domains:["*.covet.pics"]},{name:"Cox Digital Solutions",category:"ad",domains:["*.afy11.net"]},{name:"Creafi Online Media",category:"ad",domains:["*.creafi-online-media.com"]},{name:"Creators",category:"content",domains:["*.creators.co"]},{name:"Crimson Hexagon Analytics",company:"Crimson Hexagon",category:"analytics",domains:["*.hexagon-analytics.com"]},{name:"Crimtan",category:"ad",domains:["*.ctnsnet.com"]},{name:"Cross Pixel Media",category:"ad",domains:["*.crsspxl.com"]},{name:"Crosswise",category:"ad",domains:["*.univide.com"]},{name:"Crowd Control",company:"Lotame",category:"ad",domains:["*.crwdcntrl.net"]},{name:"Crowd Ignite",category:"ad",domains:["*.crowdignite.com"]},{name:"CrowdTwist",category:"ad",domains:["*.crowdtwist.com"]},{name:"Crowdskout",category:"ad",domains:["*.crowdskout.com"]},{name:"Crowdynews",category:"social",domains:["*.breakingburner.com"]},{name:"Curalate",category:"marketing",domains:["*.curalate.com","d116tqlcqfmz3v.cloudfront.net"]},{name:"Customer Acquisition Cloud",company:"[24]7",category:"ad",domains:["*.campanja.com"]},{name:"Customer.io",category:"ad",domains:["*.customer.io"]},{name:"Custora",category:"analytics",domains:["*.custora.com"]},{name:"Cxense",category:"ad",domains:["*.cxense.com","*.cxpublic.com","*.emediate.dk","*.emediate.eu"]},{name:"CyberKnight",company:"Namogoo",category:"utility",domains:["*.namogoo.com"]},{name:"CyberSource (Visa)",category:"utility",domains:["*.authorize.net"]},{name:"Cybernet Quest",category:"analytics",domains:["*.cqcounter.com"]},{name:"D.A. Consortium",category:"ad",domains:["*.eff1.net"]},{name:"D4t4 Solutions",category:"analytics",domains:["*.u5e.com"]},{name:"DCSL Software",category:"hosting",domains:["*.dcslsoftware.com"]},{name:"DMG Media",category:"content",domains:["*.mol.im","*.and.co.uk","*.anm.co.uk","*.dailymail.co.uk"]},{name:"DTSCOUT",category:"ad",domains:["*.dtscout.com"]},{name:"Dailykarma",category:"utility",homepage:"https://www.dailykarma.com/",domains:["*.dailykarma.io"]},{name:"Dailymotion",category:"content",domains:["*.dailymotion.com","*.dmxleo.com","*.dm.gg","*.pxlad.io","*.dmcdn.net","*.sublimevideo.net"]},{name:"Dash Hudson",company:"Dash Hudson",category:"content",domains:["*.dashhudson.com"]},{name:"Datacamp",category:"utility",domains:["*.cdn77.org"]},{name:"Datalicious",category:"tag-manager",domains:["*.supert.ag","*.optimahub.com"]},{name:"Datalogix",category:"ad",domains:["*.nexac.com"]},{name:"Datawrapper",category:"utility",domains:["*.datawrapper.de","*.dwcdn.net"]},{name:"Dataxu",category:"marketing",domains:["*.w55c.net"]},{name:"DatoCMS",homepage:"https://www.datocms.com/",category:"content",domains:["*.datocms-assets.com"]},{name:"Datonics",category:"ad",domains:["*.pro-market.net"]},{name:"Dealtime",category:"content",domains:["*.dealtime.com"]},{name:"Debenhams Geo Location",company:"Debenhams",category:"utility",domains:["176.74.183.134"]},{name:"Decibel Insight",category:"analytics",domains:["*.decibelinsight.net"]},{name:"Deep Forest Media",company:"Rakuten",category:"ad",domains:["*.dpclk.com"]},{name:"DeepIntent",category:"ad",domains:["*.deepintent.com"]},{name:"Delicious Media",category:"social",domains:["*.delicious.com"]},{name:"Delineo",category:"ad",domains:["*.delineo.com"]},{name:"Delta Projects AB",category:"ad",domains:["*.de17a.com"]},{name:"Demand Media",category:"content",domains:["*.dmtracker.com"]},{name:"DemandBase",category:"marketing",domains:["*.demandbase.com"]},{name:"DemandJump",category:"analytics",domains:["*.demandjump.com"]},{name:"Dennis Publishing",category:"content",domains:["*.alphr.com"]},{name:"Devatics",category:"analytics",domains:["*.devatics.com","*.devatics.io"]},{name:"Developer Media",category:"ad",domains:["*.developermedia.com"]},{name:"DialogTech",category:"ad",domains:["*.dialogtech.com"]},{name:"DialogTech SourceTrak",company:"DialogTech",category:"ad",domains:["d31y97ze264gaa.cloudfront.net"]},{name:"DigiCert",category:"utility",domains:["*.digicert.com"]},{name:"Digioh",category:"ad",domains:["*.lightboxcdn.com"]},{name:"Digital Look",category:"content",domains:["*.digitallook.com"]},{name:"Digital Media Exchange",company:"NDN",category:"content",domains:["*.newsinc.com"]},{name:"Digital Millennium Copyright Act Services",category:"utility",domains:["*.dmca.com"]},{name:"Digital Ocean",category:"other",domains:["95.85.62.56"]},{name:"Digital Remedy",category:"ad",domains:["*.consumedmedia.com"]},{name:"Digital Window",category:"ad",domains:["*.awin1.com","*.zenaps.com"]},{name:"DigitalScirocco",category:"analytics",domains:["*.digitalscirocco.net"]},{name:"Digitial Point",category:"utility",domains:["*.dpstatic.com"]},{name:"Diligent (Adnetik)",category:"ad",domains:["*.wtp101.com"]},{name:"Directed Edge",category:"social",domains:["*.directededge.com"]},{name:"Distribute Travel",category:"ad",domains:["*.dtrck.net"]},{name:"District M",category:"ad",domains:["*.districtm.io"]},{name:"DistroScale",category:"ad",domains:["*.jsrdn.com"]},{name:"Divido",category:"utility",domains:["*.divido.com"]},{name:"Dow Jones",category:"content",domains:["*.dowjones.com","*.dowjoneson.com"]},{name:"Drifty Co",category:"utility",domains:["*.onicframework.com"]},{name:"Drip",company:"The Numa Group",category:"ad",domains:["*.getdrip.com"]},{name:"Dropbox",category:"utility",domains:["*.dropboxusercontent.com"]},{name:"Dyn Real User Monitoring",company:"Dyn",category:"analytics",domains:["*.jisusaiche.biz","*.dynapis.com","*.jisusaiche.com","*.dynapis.info"]},{name:"DynAdmic",category:"ad",domains:["*.dyntrk.com"]},{name:"Dynamic Converter",category:"utility",domains:["*.dynamicconverter.com"]},{name:"Dynamic Dummy Image Generator",company:"Open Source",category:"utility",domains:["*.dummyimage.com"]},{name:"Dynamic Logic",category:"ad",domains:["*.dl-rms.com","*.questionmarket.com"]},{name:"Dynamic Yield",category:"customer-success",domains:["*.dynamicyield.com"]},{name:"Dynatrace",category:"analytics",domains:["*.ruxit.com","js-cdn.dynatrace.com"]},{name:"ec-concier",homepage:"https://ec-concier.com/",category:"marketing",domains:["*.ec-concier.com"]},{name:"ECT News Network",category:"content",domains:["*.ectnews.com"]},{name:"ELITechGroup",category:"analytics",domains:["*.elitechnology.com"]},{name:"EMAP",category:"content",domains:["*.emap.com"]},{name:"EMedia Solutions",category:"ad",domains:["*.e-shots.eu"]},{name:"EQ works",category:"ad",domains:["*.eqads.com"]},{name:"ESV Digital",category:"analytics",domains:["*.esearchvision.com"]},{name:"Ebiquity",category:"analytics",domains:["*.ebiquitymedia.com"]},{name:"Eco Rebates",category:"ad",domains:["*.ecorebates.com"]},{name:"Ecwid",category:"hosting",domains:["*.ecwid.com","*.shopsettings.com","d3fi9i0jj23cau.cloudfront.net","d3j0zfs7paavns.cloudfront.net"]},{name:"Edge Web Fonts",company:"Adobe Systems",category:"cdn",domains:["*.edgefonts.net"]},{name:"Edition Digital",category:"ad",domains:["*.editiondigital.com"]},{name:"Edot Web Technologies",category:"hosting",domains:["*.edot.co.za"]},{name:"Effective Measure",category:"ad",domains:["*.effectivemeasure.net"]},{name:"Effiliation sa",category:"ad",domains:["*.effiliation.com"]},{name:"Ekm Systems",category:"analytics",domains:["*.ekmsecure.com","*.ekmpinpoint.co.uk"]},{name:"Elastera",category:"hosting",domains:["*.elastera.net"]},{name:"Elastic Ad",category:"ad",domains:["*.elasticad.net"]},{name:"Elastic Load Balancing",company:"Amazon Web Services",category:"hosting",domains:["*.105app.com"]},{name:"Elecard StreamEye",company:"Elecard",category:"other",domains:["*.streameye.net"]},{name:"Elevate",company:"Elevate Technology Solutions",category:"utility",domains:["*.elevaate.technology"]},{name:"Elicit",category:"utility",domains:["*.elicitapp.com"]},{name:"Elogia",category:"ad",domains:["*.elogia.net"]},{name:"Email Attitude",company:"1000mercis",category:"ad",domains:["*.email-attitude.com"]},{name:"EmailCenter",category:"ad",domains:["*.emailcenteruk.com"]},{name:"Embedly",category:"content",domains:["*.embedly.com","*.embed.ly"]},{name:"EmpathyBroker Site Search",company:"EmpathyBroker",category:"utility",domains:["*.empathybroker.com"]},{name:"Enfusen",category:"analytics",domains:["*.enfusen.com"]},{name:"Engadget",company:"Engadget (AOL)",category:"content",domains:["*.gdgt.com"]},{name:"Engagio",category:"marketing",domains:["*.engagio.com"]},{name:"Ensighten Manage",company:"Ensighten",category:"tag-manager",domains:["*.levexis.com"]},{name:"EntityLink",category:"other",domains:["*.entitytag.co.uk"]},{name:"Entrust Datacard",category:"utility",domains:["*.entrust.com","*.entrust.net"]},{name:"Equiniti",category:"utility",domains:["*.equiniti.com"]},{name:"Errorception",category:"utility",domains:["*.errorception.com"]},{name:"Esri ArcGIS",company:"Esri",category:"utility",domains:["*.arcgis.com","*.arcgisonline.com"]},{name:"Ethnio",category:"analytics",domains:["*.ethn.io"]},{name:"Eulerian Technologies",category:"ad",domains:["*.eolcdn.com"]},{name:"Euroland",category:"utility",domains:["*.euroland.com"]},{name:"European Interactive Digital ad Alli",category:"utility",domains:["*.edaa.eu"]},{name:"Eventbrite",category:"hosting",domains:["*.evbuc.com","*.eventbrite.co.uk"]},{name:"Everflow",category:"analytics",domains:["*.tp88trk.com"]},{name:"Evergage",category:"analytics",domains:["*.evergage.com","*.evgnet.com"]},{name:"Everquote",category:"content",domains:["*.evq1.com"]},{name:"Everyday Health",category:"ad",domains:["*.agoramedia.com"]},{name:"Evidon",category:"analytics",domains:["*.evidon.com"]},{name:"Evolve Media",category:"content",domains:["*.evolvemediallc.com"]},{name:"Exactag",category:"ad",domains:["*.exactag.com"]},{name:"ExoClick",category:"ad",domains:["*.exoclick.com"]},{name:"Expedia",category:"content",domains:["*.travel-assets.com","*.trvl-media.com","*.trvl-px.com","*.uciservice.com"]},{name:"Expedia Australia",company:"Expedia",category:"content",domains:["*.expedia.com.au"]},{name:"Expedia Canada",company:"Expedia",category:"content",domains:["*.expedia.ca"]},{name:"Expedia France",company:"Expedia",category:"content",domains:["*.expedia.fr"]},{name:"Expedia Germany",company:"Expedia",category:"content",domains:["*.expedia.de"]},{name:"Expedia Italy",company:"Expedia",category:"content",domains:["*.expedia.it"]},{name:"Expedia Japan",company:"Expedia",category:"content",domains:["*.expedia.co.jp"]},{name:"Expedia USA",company:"Expedia",category:"content",domains:["*.expedia.com"]},{name:"Expedia United Kingdom",company:"Expedia",category:"content",domains:["*.expedia.co.uk"]},{name:"Experian",category:"utility",domains:["*.audienceiq.com","*.experian.com","*.experianmarketingservices.digital"]},{name:"Experian Cross-Channel Marketing Platform",company:"Experian",category:"marketing",domains:["*.eccmp.com","*.ccmp.eu"]},{name:"Exponea",category:"analytics",domains:["*.exponea.com"]},{name:"Exponential Interactive",category:"ad",domains:["*.exponential.com"]},{name:"Extensis WebInk",category:"cdn",domains:["*.webink.com"]},{name:"Extole",category:"ad",domains:["*.extole.com","*.extole.io"]},{name:"Ey-Seren",category:"analytics",domains:["*.webabacus.com"]},{name:"EyeView",category:"ad",domains:["*.eyeviewads.com"]},{name:"Eyeota",category:"ad",domains:["*.eyeota.net"]},{name:"Ezakus Pretargeting",company:"Ezakus",category:"ad",domains:["*.ezakus.net"]},{name:"Ezoic",category:"analytics",domains:["*.ezoic.net"]},{name:"FLXone",company:"Teradata",category:"ad",domains:["*.pangolin.blue","*.flx1.com","d2hlpp31teaww3.cloudfront.net","*.flxpxl.com"]},{name:"Fairfax Media",category:"content",domains:["ads.fairfax.com.au","resources.fairfax.com.au"]},{name:"Fairfax Media Analtics",company:"Fairfax Media",category:"analytics",domains:["analytics.fairfax.com.au"]},{name:"Falk Technologies",category:"ad",domains:["*.angsrvr.com"]},{name:"Fanplayr",category:"analytics",domains:["*.fanplayr.com","d38nbbai6u794i.cloudfront.net"]},{name:"Fast Thinking",company:"NE Marketing",category:"marketing",domains:["*.fast-thinking.co.uk"]},{name:"Fastest Forward",category:"analytics",domains:["*.gaug.es"]},{name:"Fastly",category:"utility",domains:["*.fastly.net"]},{name:"Feedbackify",company:"InsideMetrics",category:"analytics",domains:["*.feedbackify.com"]},{name:"Feefo.com",company:"Feefo",category:"analytics",domains:["*.feefo.com"]},{name:"Fidelity Media",category:"ad",domains:["*.fidelity-media.com"]},{name:"Filestack",category:"content",domains:["*.filepicker.io"]},{name:"Finsbury Media",category:"ad",domains:["*.finsburymedia.com"]},{name:"Firepush",category:"utility",domains:["*.firepush.io"]},{name:"FirstImpression",category:"ad",domains:["*.firstimpression.io"]},{name:"Fit Analytics",category:"other",domains:["*.fitanalytics.com"]},{name:"Fits Me",category:"analytics",domains:["*.fits.me"]},{name:"Fivetran",category:"analytics",domains:["*.fivetran.com"]},{name:"FlexShopper",category:"utility",domains:["*.flexshopper.com"]},{name:"Flickr",category:"content",domains:["*.flickr.com","*.staticflickr.com"]},{name:"Flipboard",category:"social",domains:["*.flipboard.com"]},{name:"Flipdesk",category:"customer-success",homepage:"https://flipdesk.jp/",domains:["*.flipdesk.jp"]},{name:"Flipp",category:"analytics",domains:["*.wishabi.com","d2e0sxz09bo7k2.cloudfront.net","*.wishabi.net"]},{name:"Flite",category:"ad",domains:["*.flite.com"]},{name:"Flixmedia",category:"analytics",domains:["*.flix360.com","*.flixcar.com","*.flixfacts.com","*.flixsyndication.net","*.flixfacts.co.uk"]},{name:"Flockler",category:"ad",domains:["*.flockler.com"]},{name:"Flowplayer",category:"content",domains:["*.flowplayer.org"]},{name:"Flowzymes Ky",category:"cdn",domains:["*.jquerytools.org"]},{name:"Fomo",category:"ad",domains:["*.notifyapp.io"]},{name:"Fonecall",category:"analytics",domains:["*.web-call-analytics.com"]},{name:"Fontdeck",category:"cdn",domains:["*.fontdeck.com"]},{name:"Foodity Technologies",category:"ad",domains:["*.foodity.com"]},{name:"Force24",category:"ad",domains:["*.force24.co.uk"]},{name:"ForeSee",company:"Answers",category:"analytics",domains:["*.4seeresults.com","*.answerscloud.com","*.foresee.com","*.foreseeresults.com"]},{name:"Forensiq",category:"utility",domains:["*.fqtag.com"]},{name:"Fort Awesome",category:"cdn",domains:["*.fortawesome.com"]},{name:"Forter",category:"utility",domains:["*.forter.com"]},{name:"Forward Internet Group",category:"hosting",domains:["*.f3d.io"]},{name:"Forward3D",category:"ad",domains:["*.forward3d.com"]},{name:"Fospha",category:"analytics",domains:["*.fospha.com"]},{name:"Foursixty",category:"customer-success",domains:["*.foursixty.com"]},{name:"FoxyCart",category:"utility",domains:["*.foxycart.com"]},{name:"Fraudlogix",category:"utility",domains:["*.yabidos.com"]},{name:"FreakOut",category:"ad",domains:["*.fout.jp"]},{name:"Freespee",category:"customer-success",domains:["*.freespee.com"]},{name:"Freetobook",category:"content",domains:["*.freetobook.com"]},{name:"Fresh 8 Gaming",category:"ad",domains:["*.fresh8.co"]},{name:"Fresh Relevance",category:"analytics",domains:["*.freshrelevance.com","*.cloudfront.ne","d1y9qtn9cuc3xw.cloudfront.net","d81mfvml8p5ml.cloudfront.net","dkpklk99llpj0.cloudfront.net"]},{name:"Friendbuy",category:"ad",domains:["*.friendbuy.com","djnf6e5yyirys.cloudfront.net"]},{name:"Frienefit",category:"ad",domains:["*.frienefit.com"]},{name:"FuelX",category:"ad",domains:["*.fuelx.com"]},{name:"Full Circle Studies",category:"analytics",domains:["*.securestudies.com"]},{name:"FullStory",category:"analytics",domains:["*.fullstory.com"]},{name:"Fyber",category:"ad",domains:["*.fyber.com"]},{name:"G-Forces Web Management",category:"hosting",domains:["*.gforcesinternal.co.uk"]},{name:"G4 Native",company:"Gravity4",category:"ad",domains:["*.triggit.com"]},{name:"GET ME IN!  (TicketMaster)",category:"content",domains:["*.getmein.com"]},{name:"GIPHY",category:"content",domains:["*.giphy.com"]},{name:"GainCloud",company:"GainCloud Systems",category:"other",domains:["*.egaincloud.net"]},{name:"Gath Adams",category:"content",domains:["*.iwantthatflight.com.au"]},{name:"Gecko Tribe",category:"social",domains:["*.geckotribe.com"]},{name:"Gemius",category:"ad",domains:["*.gemius.pl"]},{name:"Genesis Media",category:"ad",domains:["*.bzgint.com","*.genesismedia.com","*.genesismediaus.com"]},{name:"Genie Ventures",category:"ad",domains:["*.genieventures.co.uk"]},{name:"Geniee",category:"ad",domains:["*.href.asia","*.genieessp.jp","*.genieesspv.jp","*.gssprt.jp"]},{name:"Geniuslink",category:"analytics",domains:["*.geni.us"]},{name:"GeoRiot",category:"other",domains:["*.georiot.com"]},{name:"GeoTrust",category:"utility",domains:["*.geotrust.com"]},{name:"Geoplugin",category:"utility",domains:["*.geoplugin.com","*.geoplugin.net"]},{name:"Georeferencer",company:"Klokan Technologies",category:"utility",domains:["*.georeferencer.com"]},{name:"GetIntent RTBSuite",company:"GetIntent",category:"ad",domains:["*.adhigh.net"]},{name:"GetResponse",category:"ad",domains:["*.getresponse.com"]},{name:"GetSiteControl",company:"GetWebCraft",category:"utility",domains:["*.getsitecontrol.com"]},{name:"GetSocial",category:"social",domains:["*.getsocial.io"]},{name:"Getty Images",category:"content",domains:["*.gettyimages.com","*.gettyimages.co.uk"]},{name:"Gfycat",company:"Gycat",category:"utility",domains:["*.gfycat.com"]},{name:"Ghostery Enterprise",company:"Ghostery",category:"marketing",domains:["*.betrad.com"]},{name:"Giant Media",category:"ad",domains:["*.videostat.com"]},{name:"Gigya",category:"analytics",domains:["*.gigya.com"]},{name:"GitHub",category:"utility",domains:["*.github.com","*.githubusercontent.com","*.github.io","*.rawgit.com"]},{name:"Gladly",company:"Gladly",homepage:"https://www.gladly.com/",category:"customer-success",domains:["*.gladly.com"]},{name:"Glassdoor",category:"content",domains:["*.glassdoor.com"]},{name:"Gleam",category:"marketing",domains:["*.gleam.io"]},{name:"Global Digital Markets",category:"ad",domains:["*.gdmdigital.com"]},{name:"Global-e",category:"hosting",domains:["*.global-e.com"]},{name:"GlobalSign",category:"utility",domains:["*.globalsign.com","*.globalsign.net"]},{name:"GlobalWebIndex",category:"analytics",domains:["*.globalwebindex.net"]},{name:"Globase International",category:"ad",domains:["*.globase.com"]},{name:"GoDataFeed",category:"other",domains:["*.godatafeed.com"]},{name:"Google APIs",company:"Google",category:"utility",domains:["googleapis.com"]},{name:"Google Ad Block Detection",company:"Google",category:"ad",domains:["*.0emn.com","*.0fmm.com"]},{name:"Google Analytics Experiments",company:"Google",category:"analytics",domains:["*.gexperiments1.com"]},{name:"Google DoubleClick Ad Exchange",company:"Google",category:"ad",domains:["*.admeld.com"]},{name:"Google IPV6 Metrics",company:"Google",category:"analytics",domains:["*.ipv6test.net"]},{name:"Google Plus",company:"Google",category:"social",domains:["plus.google.com"]},{name:"Google Trusted Stores",company:"Google",category:"utility",domains:["*.googlecommerce.com"]},{name:"Google Video",company:"Google",category:"content",domains:["*.googlevideo.com"]},{name:"Google reCAPTCHA",company:"Google",category:"utility",domains:["*.recaptcha.net"]},{name:"GovMetric",company:"ROL Solutions",category:"analytics",domains:["*.govmetric.com"]},{name:"Granify",category:"analytics",domains:["*.granify.com"]},{name:"Grapeshot",category:"ad",domains:["*.gscontxt.net","*.grapeshot.co.uk"]},{name:"Gravity (AOL)",category:"analytics",domains:["*.grvcdn.com"]},{name:"Groovy Gecko",category:"content",domains:["*.ggwebcast.com","*.groovygecko.net"]},{name:"GroupM",category:"ad",domains:["*.qservz.com"]},{name:"Guardian Media",category:"ad",domains:["*.theguardian.com","*.guardian.co.uk"]},{name:"GumGum",category:"ad",domains:["*.gumgum.com"]},{name:"Gumtree",category:"content",domains:["*.gumtree.com"]},{name:"H264 Codec",company:"Cisco",category:"other",domains:["*.openh264.org"]},{name:"HERE",category:"analytics",domains:["*.medio.com"]},{name:"HP Optimost",company:"Hewlett-Packard Development Company",category:"marketing",domains:["*.hp.com","d2uncb19xzxhzx.cloudfront.net"]},{name:"Has Offers",company:"TUNE",category:"ad",domains:["*.go2cloud.org"]},{name:"Hawk Search",category:"utility",domains:["*.hawksearch.com"]},{name:"Haymarket Media Group",category:"content",domains:["*.brandrepublic.com","*.hbpl.co.uk"]},{name:"Heap",category:"analytics",domains:["*.heapanalytics.com"]},{name:"Hearst Communications",category:"content",domains:["*.h-cdn.co","*.hearstdigital.com","*.hearstlabs.com","*.hearst.io","*.cdnds.net"]},{name:"Heatmap",category:"analytics",domains:["*.heatmap.it"]},{name:"Heroku",category:"other",domains:["*.herokuapp.com"]},{name:"Hexton",category:"utility",domains:["*.hextom.com"]},{name:"Hibernia Networks",category:"utility",domains:["*.hiberniacdn.com"]},{name:"High Impact Media",category:"ad",domains:["*.reactx.com"]},{name:"Highcharts",category:"utility",domains:["*.highcharts.com"]},{name:"Highwinds",category:"utility",domains:["*.hwcdn.net"]},{name:"HitsLink",category:"analytics",domains:["*.hitslink.com"]},{name:"Hola Networks",category:"other",domains:["*.h-cdn.com"]},{name:"Hootsuite",category:"analytics",domains:["*.hootsuite.com"]},{name:"HotUKDeals",category:"analytics",domains:["*.hotukdeals.com"]},{name:"HotWords",company:"Media Response Group",category:"ad",domains:["*.hotwords.com.br"]},{name:"HotelsCombined",category:"content",domains:["*.datahc.com"]},{name:"Hoverr",category:"ad",domains:["*.hoverr.media"]},{name:"Hull.js",category:"utility",domains:["*.hull.io","*.hullapp.io"]},{name:"Hupso Website Analyzer",company:"Hupso",category:"analytics",domains:["*.hupso.com"]},{name:"I-Behavior",company:"WPP",category:"ad",domains:["*.ib-ibi.com"]},{name:"i-mobile",company:"i-mobile",category:"ad",domains:["*.i-mobile.co.jp"]},{name:"IBM Digital Analytics",company:"IBM",category:"analytics",domains:["*.cmcore.com","coremetrics.com","data.coremetrics.com","data.de.coremetrics.com","libs.de.coremetrics.com","tmscdn.de.coremetrics.com","iocdn.coremetrics.com","libs.coremetrics.com","tmscdn.coremetrics.com","*.s81c.com","*.unica.com","*.coremetrics.eu"]},{name:"IBM Digital Data Exchange",company:"IBM",category:"tag-manager",domains:["tagmanager.coremetrics.com"]},{name:"IBM Tealeaf",company:"IBM",category:"analytics",domains:["*.ibmcloud.com"]},{name:"IBM Acoustic Campaign",company:"IBM",category:"analytics",domains:["www.sc.pages01.net","www.sc.pages02.net","www.sc.pages03.net","www.sc.pages04.net","www.sc.pages05.net","www.sc.pages06.net","www.sc.pages07.net","www.sc.pages08.net","www.sc.pages09.net","www.sc.pagesA.net"]},{name:"ICF Technology",category:"content",domains:["*.camads.net"]},{name:"IFDNRG",category:"hosting",domains:["*.ifdnrg.com"]},{name:"IMRG",category:"analytics",domains:["*.peermap.com","*.imrg.org"]},{name:"IPONWEB",category:"ad",domains:["*.company-target.com","*.liadm.com","*.iponweb.net","*.p161.net"]},{name:"IQ Mobile",category:"utility",domains:["*.iqm.cc"]},{name:"IS Group",category:"hosting",domains:["*.creative-serving.com"]},{name:"IT Dienstleistungen Tim Prinzkosky",category:"utility",domains:["*.flaticons.net"]},{name:"IXI Digital",company:"Equifax",category:"ad",domains:["*.ixiaa.com"]},{name:"IcoMoon",category:"cdn",domains:["d19ayerf5ehaab.cloudfront.net","d1azc1qln24ryf.cloudfront.net"]},{name:"IdenTrust",category:"utility",domains:["*.identrust.com"]},{name:"Ido",category:"customer-success",domains:["*.idio.co"]},{name:"Ignition One",category:"marketing",domains:["*.searchignite.com"]},{name:"ImageShack",category:"content",domains:["*.yfrog.com"]},{name:"Imagen Studio",category:"utility",domains:["*.telephonesky.com"]},{name:"Imagini Holdings",category:"ad",domains:["*.vdna-assets.com"]},{name:"Img Safe",category:"content",domains:["*.imgsafe.org"]},{name:"Imgur",category:"utility",domains:["*.imgur.com"]},{name:"Impact Radius",category:"ad",domains:["*.impactradius-event.com","*.impactradius-go.com","*.7eer.net","d3cxv97fi8q177.cloudfront.net","*.evyy.net","*.ojrq.net","utt.impactcdn.com","*.sjv.io"]},{name:"Improve Digital",category:"ad",domains:["*.360yield.com"]},{name:"Improvely",category:"analytics",domains:["*.iljmp.com"]},{name:"InMobi",category:"ad",domains:["*.inmobi.com"]},{name:"InSkin Media",category:"ad",domains:["*.inskinad.com","*.inskinmedia.com"]},{name:"Inbenta",category:"customer-success",domains:["*.inbenta.com"]},{name:"Incisive Media",category:"content",domains:["*.incisivemedia.com"]},{name:"Indeed",category:"content",domains:["*.indeed.com"]},{name:"Index Exchange",company:"WPP",category:"ad",domains:["*.casalemedia.com","*.indexww.com"]},{name:"Indoona",category:"other",domains:["*.indoona.com"]},{name:"Infectious Media",category:"ad",domains:["*.impdesk.com","*.impressiondesk.com","*.inmz.net"]},{name:"Inference Mobile",category:"ad",domains:["*.inferencemobile.com"]},{name:"Infinity Tracking",category:"analytics",domains:["*.infinity-tracking.net"]},{name:"Infoline",category:"analytics",domains:["*.ioam.de"]},{name:"Infolinks",category:"ad",domains:["*.infolinks.com"]},{name:"Infopark",category:"hosting",domains:["*.scrvt.com"]},{name:"Infusionsoft",category:"ad",domains:["*.infusionsoft.com"]},{name:"Ink",category:"ad",domains:["*.inktad.com"]},{name:"Inktel Contact Center Solutions",company:"Inktel",category:"customer-success",domains:["*.inktel.com"]},{name:"Inneractive",category:"ad",domains:["*.inner-active.mobi"]},{name:"Innovid",category:"ad",homepage:"https://www.innovid.com/",domains:["*.innovid.com"]},{name:"Insight Express",category:"analytics",domains:["*.insightexpressai.com"]},{name:"Insipio",category:"other",domains:["*.insipio.com"]},{name:"Inspectlet",category:"analytics",domains:["*.inspectlet.com"]},{name:"Instansive",category:"utility",domains:["*.instansive.com"]},{name:"Instart",homepage:"https://www.instart.com/",category:"utility",domains:["*.insnw.net"]},{name:"Instembedder",category:"content",domains:["*.instaembedder.com"]},{name:"Instinctive",category:"ad",domains:["*.instinctiveads.com"]},{name:"Intelligent Reach",category:"ad",domains:["*.ist-track.com"]},{name:"Intent HQ",category:"analytics",domains:["*.intenthq.com"]},{name:"Intent IQ",category:"ad",domains:["*.intentiq.com"]},{name:"Intercept Interactive",category:"ad",domains:["*.undertone.com"]},{name:"Interest Graph",company:"AOL",category:"ad",domains:["*.gravity.com"]},{name:"Internet Brands",category:"content",domains:["*.ibpxl.com"]},{name:"Interpublic Group",category:"ad",domains:["*.mbww.com"]},{name:"Interstate",category:"analytics",domains:["*.interstateanalytics.com"]},{name:"Interview",category:"analytics",domains:["*.efm.me"]},{name:"Intilery",category:"customer-success",domains:["*.intilery-analytics.com"]},{name:"Investis",category:"utility",domains:["*.investis.com"]},{name:"Investis Flife",category:"hosting",domains:["*.quartalflife.com"]},{name:"Invodo",category:"ad",domains:["*.invodo.com"]},{name:"iSite",category:"analytics",domains:["*.isitetv.com"]},{name:"Issue",category:"content",domains:["*.issue.by"]},{name:"J.D. Williams & Co",category:"content",domains:["*.drct2u.com"]},{name:"Janrain",category:"analytics",domains:["*.janrain.com","*.janrainbackplane.com","*.rpxnow.com","d3hmp0045zy3cs.cloudfront.net"]},{name:"Jellyfish",category:"ad",domains:["*.jellyfish.net"]},{name:"JetStream",category:"content",domains:["*.xlcdn.com"]},{name:"JingDong",category:"content",domains:["*.3.com","*.jd.com"]},{name:"Jivox",category:"ad",domains:["*.jivox.com"]},{name:"Jobvite",category:"content",domains:["*.jobvite.com"]},{name:"Johnston Press",category:"content",domains:["*.johnstonpress.co.uk","*.jpress.co.uk"]},{name:"Join the Dots (Research)",category:"social",domains:["*.jtdiscuss.com"]},{name:"JotForm",category:"utility",domains:["*.jotformpro.com"]},{name:"JuicyAds",category:"ad",domains:["*.juicyads.com"]},{name:"JustPremium",category:"ad",domains:["*.net.net"]},{name:"JustPremium Ads",company:"JustPremium",category:"ad",domains:["*.justpremium.com"]},{name:"JustUno",category:"ad",domains:["*.justuno.com","d2j3qa5nc37287.cloudfront.net"]},{name:"KINX (Korea Internet Neutral eXchange)",category:"other",domains:["*.kinxcdn.com"]},{name:"KISSmetrics",category:"analytics",domains:["*.kissmetrics.com","doug1izaerwt3.cloudfront.net","dsyszv14g9ymi.cloudfront.net"]},{name:"Kaizen Platform",category:"analytics",domains:["*.kaizenplatform.net"]},{name:"Kakao",category:"social",domains:["*.daum.net","*.daumcdn.net"]},{name:"Kaltura Video Platform",company:"Kaltura",category:"content",domains:["*.kaltura.com"]},{name:"Kameleoon",category:"analytics",domains:["*.kameleoon.com","*.kameleoon.eu"]},{name:"Kampyle",category:"analytics",domains:["*.kampyle.com"]},{name:"Kantar",category:"analytics",domains:["*.sesamestats.com"]},{name:"Kargo",category:"marketing",domains:["*.kargo.com"]},{name:"KARTE",company:"Plaid",homepage:"https://karte.io/",category:"marketing",domains:["*.karte.io"]},{name:"Kauli",category:"ad",domains:["*.kau.li"]},{name:"Keen",company:"Keen",homepage:"https://keen.io/",category:"analytics",domains:["*.keen.io","d26b395fwzu5fz.cloudfront.net"]},{name:"Kelkoo",category:"hosting",domains:["*.kelkoo.com"]},{name:"Kenshoo",category:"marketing",domains:["*.xg4ken.com"]},{name:"Key CDN",category:"utility",domains:["*.kxcdn.com"]},{name:"Keynote",company:"Dynatrace",category:"analytics",domains:["*.keynote.com"]},{name:"Keywee",category:"ad",domains:["*.keywee.co"]},{name:"Kiosked",category:"ad",domains:["*.kiosked.com"]},{name:"Klarna",category:"utility",domains:["*.klarna.com"]},{name:"Klaviyo",category:"ad",domains:["*.klaviyo.com"]},{name:"Klevu Search",company:"Klevu",category:"utility",domains:["*.klevu.com"]},{name:"Klick2Contact",category:"customer-success",domains:["*.klick2contact.com"]},{name:"Knight Lab",company:"Northwestern University",category:"utility",domains:["*.knightlab.com"]},{name:"Kodajo",category:"other",domains:["*.kodajo.com"]},{name:"Komoona",category:"ad",domains:["*.komoona.com"]},{name:"Korrelate",company:"JD Power",category:"analytics",domains:["*.korrelate.net"]},{name:"LKQD",category:"ad",domains:["*.lkqd.net"]},{name:"Layer0",category:"cdn",domains:["*.layer0.co"]},{name:"Layershift",category:"hosting",domains:["109.109.138.174"]},{name:"Lead Forensics",category:"ad",domains:["*.200summit.com","*.baw5tracker.com","*.business-path-55.com","*.bux1le001.com","*.central-core-7.com","*.direct-azr-78.com","*.explore-123.com","*.forensics1000.com","*.gldsta-02-or.com","*.green-bloc9.com","*.lansrv040.com","*.lead-123.com","*.leadforensics.com","*.mavic852.com","*.mon-com-net.com","*.peak-ip-54.com","*.snta0034.com","*.svr-prc-01.com","*.syntace-094.com","*.tghbn12.com","*.trail-web.com","*.web-01-gbl.com","*.web-cntr-07.com","*.trackdiscovery.net"]},{name:"Lead Intelligence",company:"Magnetise Solutions",category:"ad",domains:["*.leadintelligence.co.uk"]},{name:"LeadLander",category:"analytics",domains:["*.formalyzer.com","*.trackalyzer.com"]},{name:"Leaflet",category:"utility",domains:["*.leafletjs.com"]},{name:"LeasdBoxer",company:"LeadBoxer",category:"ad",domains:["*.leadboxer.com"]},{name:"LeaseWeb",homepage:"https://www.leaseweb.com/",category:"cdn",domains:["*.lswcdn.net","*.leasewebcdn.com"]},{name:"Leboncoin",category:"content",domains:["*.leboncoin.fr"]},{name:"Lengow",category:"hosting",domains:["*.lengow.com"]},{name:"Lessbuttons",category:"social",domains:["*.lessbuttons.com"]},{name:"Letter Press",category:"ad",domains:["*.getletterpress.com"]},{name:"Level 3 Communications",category:"utility",domains:["footprint.net"]},{name:"Level3",category:"other",domains:["secure.footprint.net"]},{name:"Lifestreet Media",category:"social",domains:["*.lfstmedia.com"]},{name:"LiftSuggest",category:"analytics",domains:["d2blwevgjs7yom.cloudfront.net"]},{name:"Ligatus",category:"ad",domains:["*.ligadx.com"]},{name:"LightStep",category:"analytics",domains:["*.lightstep.com"]},{name:"LightWidget",category:"utility",domains:["*.lightwidget.com"]},{name:"Likelihood",company:"LIkeihood",category:"hosting",domains:["*.likelihood.com"]},{name:"LikeShop",company:"Dash Hudson",category:"content",domains:["likeshop.me"]},{name:"LINE Corporation",category:"ad",domains:["*.line-scdn.net","*.line.me"]},{name:"Linkcious",category:"analytics",domains:["*.linkcious.com"]},{name:"Linking Mobile",category:"ad",domains:["*.linkingmobile.com"]},{name:"LittleData",category:"analytics",homepage:"https://www.littledata.io/",domains:["*.littledata.io"]},{name:"LiveBurst",category:"ad",domains:["*.liveburst.com"]},{name:"LiveClicker",category:"ad",domains:["*.liveclicker.net"]},{name:"LiveHelpNow",category:"customer-success",domains:["*.livehelpnow.net"]},{name:"LiveInternet",category:"analytics",domains:["*.yadro.ru"]},{name:"LiveJournal",category:"social",domains:["*.livejournal.com","*.livejournal.net"]},{name:"LivePerson",category:"customer-success",homepage:"https://www.liveperson.com/",domains:["*.liveperson.com","*.look.io","*.liveperson.net","*.lpsnmedia.net"]},{name:"LiveRail",company:"Facebook",category:"ad",domains:["*.liverail.com","*.lrcdn.net"]},{name:"LiveTex",category:"customer-success",domains:["*.livetex.ru"]},{name:"Livefyre",category:"content",domains:["*.fyre.co","*.livefyre.com"]},{name:"Living Map Company",category:"utility",domains:["*.livingmap.com"]},{name:"Local World",category:"content",domains:["*.thelocalpeople.co.uk"]},{name:"LockerDome",category:"analytics",domains:["*.lockerdome.com"]},{name:"Logentries",company:"Rapid",category:"utility",domains:["*.logentries.com"]},{name:"Logicalis",category:"analytics",domains:["*.trovus.co.uk"]},{name:"LoginRadius",company:"LoginRadius",homepage:"https://www.loginradius.com/",category:"ad",domains:["*.loginradius.com","*.lrcontent.com"]},{name:"LongTail Ad Solutions",category:"ad",domains:["*.jwpcdn.com","*.jwplatform.com","*.jwplayer.com","*.jwpltx.com","*.jwpsrv.com","*.longtailvideo.com"]},{name:"Loop Commerce",category:"other",domains:["*.loopassets.net"]},{name:"Loop11",category:"analytics",domains:["*.loop11.com"]},{name:"LoopMe",category:"ad",domains:["*.loopme.biz","*.loopme.com","*.vntsm.com","*.loopme.me"]},{name:"Looper",category:"content",domains:["*.looper.com"]},{name:"Loyalty Point",category:"ad",domains:["*.loyaltypoint.pl"]},{name:"LoyaltyLion",category:"ad",domains:["*.loyaltylion.com","*.loyaltylion.net","dg1f2pfrgjxdq.cloudfront.net"]},{name:"Luma Tag",category:"analytics",domains:["*.lumatag.co.uk"]},{name:"Lumesse",category:"content",domains:["*.recruitmentplatform.com"]},{name:"Luminate",category:"ad",domains:["*.luminate.com"]},{name:"Lynchpin Analytics",category:"analytics",domains:["*.lypn.net"]},{name:"Lyris",category:"ad",domains:["*.clicktracks.com"]},{name:"Lytics",category:"ad",domains:["*.lytics.io"]},{name:"MEC WebTrack",company:"MEC",category:"ad",domains:["*.e-webtrack.net"]},{name:"MECLABS Institute",category:"analytics",domains:["*.meclabs.com","*.meclabsdata.com"]},{name:"MLveda",category:"utility",domains:["*.mlveda.com"]},{name:"Macromill",company:"Macromill",category:"analytics",homepage:"https://group.macromill.com/",domains:["*.macromill.com"]},{name:"Macropod BugHerd",company:"Macropod",category:"utility",domains:["*.bugherd.com"]},{name:"Madison Logic",category:"marketing",domains:["*.ml314.com"]},{name:"Madmetrics",company:"Keyade",category:"analytics",domains:["*.keyade.com"]},{name:"Magnetic",category:"ad",domains:["*.domdex.com","d3ezl4ajpp2zy8.cloudfront.net"]},{name:"Magnetic Platform",company:"Magnetic",category:"ad",domains:["*.magnetic.is"]},{name:"MailMunch",category:"ad",domains:["*.mailmunch.co"]},{name:"MailPlus",category:"ad",domains:["*.mailplus.nl"]},{name:"Mapbox",category:"utility",domains:["*.mapbox.com"]},{name:"Maptive",category:"utility",domains:["*.maptive.com"]},{name:"Marcaria.com",category:"other",domains:["*.gooo.al"]},{name:"Marchex",category:"analytics",domains:["*.voicestar.com","*.marchex.io"]},{name:"Mark and Mini",category:"ad",domains:["*.markandmini.com"]},{name:"Marker",category:"utility",domains:["*.marker.io"]},{name:"Marketing Dashboards",company:"GroupM",category:"analytics",domains:["*.m-decision.com"]},{name:"Marketizator",category:"analytics",domains:["*.marketizator.com"]},{name:"Marketplace Web Service",company:"Amazon",category:"other",domains:["*.ssl-images-amazon.com"]},{name:"Mashable",category:"social",domains:["*.mshcdn.com"]},{name:"MatchWork",category:"utility",domains:["*.matchwork.com"]},{name:"MathJax",category:"utility",domains:["*.mathjax.org"]},{name:"Mather Economics",category:"analytics",domains:["*.matheranalytics.com"]},{name:"MaxCDN Enterprise",company:"MaxCDN",category:"utility",domains:["*.netdna-cdn.com","*.netdna-ssl.com"]},{name:"MaxMind",category:"utility",domains:["*.maxmind.com"]},{name:"MaxPoint Interactive",category:"ad",domains:["*.mxptint.net"]},{name:"Maxsi",category:"analytics",domains:["*.evisitanalyst.com"]},{name:"Maxymiser",category:"analytics",domains:["*.maxymiser.net, maxymiser.hs.llnwd.net"]},{name:"McAffee",category:"utility",domains:["*.mcafeesecure.com","*.scanalert.com"]},{name:"Measured",category:"analytics",domains:["*.measured.com"],homepage:"https://www.measured.com/"},{name:"Media IQ",category:"analytics",domains:["*.mediaiqdigital.com"]},{name:"Media Management Technologies",category:"ad",domains:["*.speedshiftmedia.com"]},{name:"Media Temple",category:"hosting",domains:["*.goodlayers2.com"]},{name:"Mediabong",category:"ad",domains:["*.mediabong.net"]},{name:"Mediahawk",category:"analytics",domains:["*.mediahawk.co.uk"]},{name:"Mediahub",category:"ad",domains:["*.hubverifyandoptimize.com","*.projectwatchtower.com"]},{name:"Mediasyndicator",category:"ad",domains:["*.creativesyndicator.com"]},{name:"Medium",category:"content",domains:["*.medium.com"]},{name:"Meetrics",category:"ad",domains:["*.de.com","*.meetrics.net","*.mxcdn.net"]},{name:"Mega",company:"Mega Information Technology",category:"other",domains:["*.mgcdn.com"]},{name:"Melt",category:"ad",domains:["*.meltdsp.com","*.mesp.com"]},{name:"Meltwater Group",category:"customer-success",domains:["*.meltwaternews.com"]},{name:"Meme",category:"ad",domains:["*.viewwonder.com"]},{name:"MentAd",category:"ad",domains:["*.mentad.com"]},{name:"Mention Me",category:"ad",domains:["*.mention-me.com"]},{name:"Merchant Equipment Store",category:"utility",domains:["*.merchantequip.com"]},{name:"Merchenta",category:"customer-success",domains:["*.merchenta.com"]},{name:"Merkle Digital Data Exchange",company:"Merkle",category:"ad",domains:["*.brilig.com"]},{name:"Merkle Paid Search",company:"Merkle",category:"ad",domains:["*.rkdms.com"]},{name:"Met Office",category:"content",domains:["*.metoffice.gov.uk"]},{name:"Meta Broadcast",category:"social",domains:["*.metabroadcast.com"]},{name:"Michael Associates",category:"ad",domains:["*.checktestsite.com"]},{name:"Michelin",category:"content",domains:["*.viamichelin.com"]},{name:"Microad",category:"ad",domains:["*.microad.jp"]},{name:"Microsoft Certificate Services",company:"Microsoft",category:"utility",domains:["*.msocsp.com"]},{name:"Microsoft Hosted Libs",company:"Microsoft",category:"cdn",domains:["*.aspnetcdn.com"]},{name:"Microsoft XBox Live",company:"Microsoft",category:"marketing",domains:["*.xboxlive.com"]},{name:"Mightypop",category:"ad",domains:["*.mightypop.ca"]},{name:"Mika Tuupola",category:"utility",domains:["*.appelsiini.net"]},{name:"Millennial Media",category:"ad",domains:["*.jumptap.com"]},{name:"Mirror Image Internet",category:"utility",domains:["*.miisolutions.net"]},{name:"Mobify",category:"utility",domains:["*.mobify.com","*.mobify.net"]},{name:"Mobile Nations",category:"social",domains:["*.mobilenations.com"]},{name:"Mobivate",category:"ad",domains:["*.mobivatebulksms.com"]},{name:"Momondo",category:"content",domains:["*.momondo.dk"]},{name:"Momondo Group",category:"content",domains:["*.momondogrouo.com","*.momondogroup.com"]},{name:"Monarch Ads",category:"ad",domains:["*.monarchads.com"]},{name:"Monetate",category:"analytics",domains:["*.monetate.net"]},{name:"MonetizeMore",category:"ad",domains:["*.m2.ai"]},{name:"Monitor",company:"Econda",category:"analytics",domains:["*.econda-monitor.de"]},{name:"Monkey Frog Media",category:"content",domains:["*.monkeyfrogmedia.com"]},{name:"Monotype",category:"cdn",domains:["*.fonts.com","*.fonts.net"]},{name:"Moore-Wilson",category:"ad",domains:["*.mwdev.co.uk"]},{name:"Moovweb",category:"utility",domains:["*.moovweb.net"]},{name:"Mopinion",category:"analytics",domains:["*.mopinion.com"]},{name:"MotionPoint",category:"other",domains:["*.convertlanguage.com"]},{name:"Mouse3K",category:"analytics",domains:["*.mouse3k.com"]},{name:"MouseStats",category:"analytics",domains:["*.mousestats.com"]},{name:"Mouseflow",category:"analytics",domains:["*.mouseflow.com"]},{name:"Movable Ink",category:"analytics",domains:["*.micpn.com"]},{name:"MovingIMAGE24",category:"content",domains:["*.edge-cdn.net"]},{name:"Moxielinks",category:"ad",domains:["*.moxielinks.com"]},{name:"Moz Recommended Companies",company:"Moz",category:"analytics",domains:["d2eeipcrcdle6.cloudfront.net"]},{name:"Mozilla",category:"utility",domains:["*.mozilla.org"]},{name:"Multiview",category:"content",domains:["*.multiview.com","*.track-mv.com"]},{name:"Mux",category:"analytics",domains:["*.litix.io"]},{name:"MyAds",company:"MyBuys",category:"analytics",domains:["*.veruta.com"]},{name:"MyBuys",category:"analytics",domains:["*.mybuys.com"]},{name:"MyFonts",category:"cdn",domains:["*.myfonts.net"]},{name:"MyRegistry",category:"other",domains:["*.myregistry.com"]},{name:"MySpace",company:"Specific Media",category:"social",domains:["*.myspace.com"]},{name:"Mynewsdesk",category:"utility",domains:["*.mynewsdesk.com"]},{name:"NAVIS",category:"content",domains:["*.navistechnologies.info"]},{name:"NCC Group Real User Monitoring",company:"NCC Group",category:"analytics",domains:["*.nccgroup-webperf.com"]},{name:"NEORY Marketing Cloud",company:"NEORY",category:"marketing",domains:["*.ad-srv.net"]},{name:"Nanigans",category:"ad",domains:["*.nanigans.com"]},{name:"Nano Interactive",category:"ad",domains:["*.audiencemanager.de"]},{name:"Nanorep",company:"Nanorep Technologies",category:"customer-success",domains:["*.nanorep.com"]},{name:"Narrative",category:"ad",domains:["*.narrative.io"]},{name:"Native Ads",category:"ad",domains:["*.nativeads.com"]},{name:"Nativo",category:"ad",domains:["*.postrelease.com"]},{name:"Navegg",category:"ad",domains:["*.navdmp.com"]},{name:"NaviStone",category:"ad",domains:["*.murdoog.com"]},{name:"Naytev",category:"analytics",domains:["*.naytev.com"]},{name:"Needle",category:"analytics",domains:["*.needle.com"]},{name:"Neiman Marcus",category:"content",domains:["*.ctscdn.com"]},{name:"Nend",category:"ad",domains:["*.nend.net"]},{name:"Neodata",category:"ad",domains:["*.neodatagroup.com"]},{name:"Net Applications",category:"analytics",domains:["*.hitsprocessor.com"]},{name:"Net Reviews",category:"analytics",domains:["*.avis-verifies.com"]},{name:"NetAffiliation",company:"Kwanco",category:"ad",domains:["*.metaffiliation.com"]},{name:"NetDirector",company:"G-Forces Web Management",category:"other",domains:["*.netdirector.co.uk"]},{name:"NetFlix",category:"content",domains:["*.nflxext.com","*.nflximg.net"]},{name:"Nielsen NetRatings SiteCensus",company:"The Nielsen Company",homepage:"http://www.nielsen-online.com/intlpage.html",category:"analytics",domains:["*.imrworldwide.com"]},{name:"NetSeer",category:"ad",domains:["*.netseer.com","*.ns-cdn.com"]},{name:"NetShelter",company:"Ziff Davis Tech",category:"ad",domains:["*.netshelter.net"]},{name:"Netmining",company:"Ignition One",category:"ad",domains:["*.netmng.com"]},{name:"Netop",category:"customer-success",domains:["*.netop.com"]},{name:"Network Solutions",category:"utility",domains:["*.netsolssl.com","*.networksolutions.com"]},{name:"Neustar AdAdvisor",company:"Neustar",category:"ad",domains:["*.adadvisor.net"]},{name:"New Approach Media",category:"ad",domains:["*.newapproachmedia.co.uk"]},{name:"NewShareCounts",category:"social",domains:["*.newsharecounts.com"]},{name:"News",category:"social",domains:["*.news.com.au","*.newsanalytics.com.au","*.newsapi.com.au","*.newscdn.com.au","*.newsdata.com.au","*.newsdiscover.com.au","*.news-static.com"]},{name:"Newsquest",category:"content",domains:["*.newsquestdigital.co.uk"]},{name:"Newzulu",category:"content",domains:["*.filemobile.com","*.projects.fm"]},{name:"Nexcess.Net",category:"hosting",domains:["*.nexcesscdn.net"]},{name:"Nexstar Media Group",category:"ad",domains:["*.yashi.com"]},{name:"NextPerf",company:"Rakuten Marketing",category:"ad",domains:["*.nxtck.com"]},{name:"Nine.com.au",company:"Nine Digital",category:"content",domains:["*.9msn.com.au"]},{name:"NitroSell",category:"hosting",domains:["*.nitrosell.com"]},{name:"Nochex",category:"utility",domains:["*.nochex.com"]},{name:"Northern &amp; Shell Media Group",category:"content",domains:["*.northernandshell.co.uk"]},{name:"Nosto",category:"analytics",domains:["*.nosto.com"]},{name:"Now Interact",category:"analytics",domains:["*.nowinteract.com"]},{name:"Numberly",company:"1000mercis",category:"ad",domains:["*.mmtro.com","*.nzaza.com"]},{name:"NyaConcepts",category:"analytics",domains:["*.xclusive.ly"]},{name:"O2",category:"other",domains:["*.o2.co.uk"]},{name:"GoDaddy",homepage:"https://www.godaddy.com/",category:"utility",domains:["*.godaddy.com","*.wsimg.com"]},{name:"ObjectPlanet",category:"analytics",domains:["*.easypolls.net"]},{name:"OhMyAd",category:"ad",domains:["*.ohmyad.co"]},{name:"Okas Concepts",category:"utility",domains:["*.okasconcepts.com"]},{name:"Okta",category:"analytics",domains:["*.okta.com"]},{name:"Olapic",category:"content",domains:["*.photorank.me"]},{name:"Ometria",category:"analytics",domains:["*.ometria.com"]},{name:"Omniconvert",category:"analytics",domains:["*.omniconvert.com","d2tgfbvjf3q6hn.cloudfront.net","d3vbj265bmdenw.cloudfront.net"]},{name:"Omniroot",company:"Verizon",category:"utility",domains:["*.omniroot.com"]},{name:"OnAudience",company:"Cloud Technologies",category:"ad",domains:["*.onaudience.com"]},{name:"OnScroll",category:"ad",domains:["*.onscroll.com"]},{name:"OnState",category:"ad",domains:["*.onstate.co.uk"]},{name:"OnYourMap",category:"utility",domains:["*.onyourmap.com"]},{name:"One by AOL",company:"AOL",category:"ad",domains:["*.adtechjp.com","*.adtech.de"]},{name:"One by AOL:Mobile",company:"AOL",category:"ad",domains:["*.nexage.com"]},{name:"OneAll",category:"analytics",domains:["*.oneall.com"]},{name:"OneSoon",category:"analytics",domains:["*.adalyser.com"]},{name:"OneTag",category:"ad",domains:["*.onetag-sys.com"]},{name:"Onet",category:"ad",domains:["*.onet.pl"]},{name:"Online Rewards",company:"Mastercard",category:"ad",domains:["*.loyaltygateway.com"]},{name:"Online republic",category:"content",domains:["*.imallcdn.net"]},{name:"Ooyala",category:"ad",domains:["*.ooyala.com"]},{name:"OpenTable",company:"Priceline Group",category:"content",domains:["*.opentable.com","*.opentable.co.uk","*.toptable.co.uk"]},{name:"OpenX Ad Exchange",company:"OpenX Technologies",category:"ad",domains:["*.liftdna.com"]},{name:"Opinion Stage",category:"analytics",domains:["*.opinionstage.com"]},{name:"OpinionBar",category:"analytics",domains:["*.opinionbar.com"]},{name:"Opta",company:"Perform Group",category:"content",domains:["*.opta.net"]},{name:"OptiMonk",category:"ad",domains:["*.optimonk.com"]},{name:"Optilead",category:"analytics",domains:["*.dyn-img.com","*.leadcall.co.uk","*.optilead.co.uk"]},{name:"Optimatic",category:"ad",domains:["*.optimatic.com"]},{name:"Optimise Media Group",category:"utility",domains:["*.omguk.com"]},{name:"Optimost",company:"OpenText",category:"ad",domains:["*.optimost.com"]},{name:"Optimove",company:"Mobius Solutions",category:"analytics",domains:["*.optimove.net"]},{name:"Optorb",category:"ad",domains:["*.optorb.com"]},{name:"Oracle",category:"marketing",domains:["*.custhelp.com","*.eloqua.com","*.en25.com","*.estara.com","*.instantservice.com"]},{name:"Oracle Recommendations On Demand",company:"Oracle",category:"analytics",domains:["*.atgsvcs.com"]},{name:"Oracle Responsys",company:"Oracle",category:"marketing",domains:["*.adrsp.net","*.responsys.net"]},{name:"Order Security-VOID",company:"Order Security",category:"analytics",domains:["*.order-security.com"]},{name:"Oriel",category:"ad",domains:["*.oriel.io"]},{name:"Outbrain",homepage:"https://www.outbrain.com/",category:"ad",domains:["*.outbrain.com","*.outbrainimg.com","*.visualrevenue.com"]},{name:"OverStream",company:"Coull",category:"ad",domains:["*.coull.com"]},{name:"Overdrive",category:"content",domains:["*.contentreserve.com"]},{name:"Overstock",category:"utility",domains:["*.ostkcdn.com"]},{name:"OwnerIQ",category:"ad",domains:["*.owneriq.net"]},{name:"OzCart",category:"utility",domains:["*.ozcart.com.au"]},{name:"Ozone Media",category:"ad",domains:["*.adadyn.com"]},{name:"Loqate",company:"Loqate",category:"other",domains:["*.pcapredict.com","*.postcodeanywhere.co.uk"]},{name:"PEER 1 Hosting",category:"hosting",domains:["*.peer1.com"]},{name:"PERFORM",category:"content",domains:["*.performgroup.com"]},{name:"PICnet",category:"hosting",domains:["*.nonprofitsoapbox.com"]},{name:"Pacnet",company:"Telstra",category:"other",domains:["*.cdndelivery.net"]},{name:"Pagefair",category:"ad",domains:["*.pagefair.com","*.pagefair.net"]},{name:"Pagely",category:"other",domains:["*.optnmstr.com"]},{name:"Pagesuite",category:"ad",domains:["*.pagesuite-professional.co.uk"]},{name:"Pardot",category:"marketing",domains:["*.pardot.com"]},{name:"Parse.ly",category:"analytics",domains:["*.parsely.com","d1z2jf7jlzjs58.cloudfront.net"]},{name:"Pay per Click",company:"Eysys",category:"ad",domains:["*.eysys.com"]},{name:"PayPal Ads",category:"ad",domains:["*.where.com"]},{name:"Peaks & Pies",category:"analytics",domains:["*.bunchbox.co"]},{name:"PebblePost",category:"ad",domains:["*.pbbl.co"]},{name:"Peerius",category:"analytics",domains:["*.peerius.com"]},{name:"Peermap",company:"IMRG",category:"analytics",domains:["peermapcontent.affino.com"]},{name:"Penske Media",category:"content",domains:["*.pmc.com"]},{name:"Penton",category:"utility",domains:["*.pisces-penton.com"]},{name:"Pepper",category:"ad",domains:["*.peppercorp.com"]},{name:"Perfect Audience",company:"Marin Software",category:"ad",domains:["*.prfct.co","*.marinsm.com","*.perfectaudience.com"]},{name:"Perfect Market",category:"ad",domains:["*.perfectmarket.com"]},{name:"Perfect Privacy",category:"other",domains:["*.suitesmart.com"]},{name:"Perform Group",category:"content",domains:["*.performfeeds.com","*.premiumtv.co.uk"]},{name:"Performio",category:"ad",domains:["*.performax.cz"]},{name:"PerimeterX Bot Defender",company:"PerimeterX",category:"utility",domains:["*.perimeterx.net","*.pxi.pub"]},{name:"Periscope",category:"content",domains:["*.periscope.tv"]},{name:"Permutive",category:"ad",domains:["*.permutive.com","d3alqb8vzo7fun.cloudfront.net"]},{name:"Petametrics",category:"analytics",domains:["*.petametrics.com"]},{name:"PhotoBucket",category:"content",domains:["*.photobucket.com"]},{name:"Picreel",category:"analytics",domains:["*.pcrl.co","*.picreel.com"]},{name:"Pictela (AOL)",category:"analytics",domains:["*.pictela.net"]},{name:"PistonHeads",category:"social",domains:["*.pistonheads.com"]},{name:"Piwik",category:"analytics",domains:["*.drtvtracker.com","*.piwikpro.com","*.raac33.net"]},{name:"Pixalate",category:"utility",domains:["*.adrta.com"]},{name:"Pixlee",category:"social",domains:["*.pixlee.com"]},{name:"Placed",category:"analytics",domains:["*.placed.com"]},{name:"Planning-inc",category:"analytics",domains:["*.planning-inc.co.uk"]},{name:"PlayAd Media Group",category:"ad",domains:["*.youplay.se"]},{name:"Playbuzz",category:"hosting",domains:["*.playbuzz.com"]},{name:"Pleenq",category:"ad",domains:["*.pleenq.com"]},{name:"Plentific",category:"content",domains:["*.plentific.com"]},{name:"PluginDetect",category:"other",domains:["dtlilztwypawv.cloudfront.net"]},{name:"Po.st",company:"RadiumOne",category:"utility",domains:["*.po.st"]},{name:"Pointpin",category:"utility",domains:["*.pointp.in"]},{name:"Pointroll (Garnett)",category:"ad",domains:["*.pointroll.com"]},{name:"Polar",homepage:"https://polar.me/",category:"ad",domains:["*.polarmobile.ca","*.mediaeverywhere.com","*.mediavoice.com","*.plrsrvcs.com","*.polarcdn-engine.com","*.polarcdn-meraxes.com","*.polarcdn-pentos.com","*.polarcdn-static.com","*.polarcdn-terrax.com","*.polarcdn.com","*.polarmobile.com","*.poweredbypolar.com","*.mediaconductor.me","*.polaracademy.me"]},{name:"PollDaddy (Automattic)",category:"ad",domains:["static.polldaddy.com","*.poll.fm"]},{name:"Polldaddy",company:"Automattic",category:"analytics",domains:["polldaddy.com","*.polldaddy.com"]},{name:"Polyfill service",company:"Polyfill.io",category:"other",domains:["*.polyfill.io"]},{name:"MegaPopAds",category:"ad",domains:["*.megapopads.com"]},{name:"Populis",category:"ad",domains:["*.populisengage.com"]},{name:"Postimage.org",category:"content",domains:["*.postimg.org"]},{name:"PowerFront",category:"hosting",domains:["*.inside-graph.com"]},{name:"PowerReviews",category:"analytics",domains:["*.powerreviews.com"]},{name:"Powerlinks.com",category:"ad",domains:["*.powerlinks.com"]},{name:"Press+",category:"ad",domains:["*.pipol.com","*.ppjol.com","*.ppjol.net"]},{name:"PressArea",category:"utility",domains:["*.pressarea.com"]},{name:"Pretio Interactive",category:"ad",domains:["*.pretio.in"]},{name:"Prezi",category:"utility",domains:["*.prezi.com"]},{name:"PriceGrabber",category:"content",domains:["*.pgcdn.com","*.pricegrabber.com"]},{name:"PriceRunner",category:"content",domains:["*.pricerunner.com"]},{name:"PrintFriendly",category:"utility",domains:["*.printfriendly.com"]},{name:"Privy",category:"ad",domains:["*.privy.com","*.privymktg.com"]},{name:"Proclivity Media",category:"analytics",domains:["*.pswec.com"]},{name:"Profitshare",category:"ad",domains:["*.profitshare.ro"]},{name:"Programattik",category:"ad",domains:["*.programattik.com"]},{name:"Proper Media",category:"content",domains:["*.proper.io"]},{name:"Property Week",category:"content",domains:["*.propertyweek.com"]},{name:"Provide Support",category:"customer-success",domains:["*.providesupport.com"]},{name:"Proweb Uk",category:"hosting",domains:["*.proweb.net"]},{name:"Proximic (ComScore)",category:"ad",domains:["*.proximic.com"]},{name:"Psyma",category:"ad",domains:["*.psyma.com"]},{name:"PubFactory",company:"Safari Books Online",category:"content",domains:["*.pubfactory.com"]},{name:"PubNation",category:"ad",domains:["*.pubnation.com"]},{name:"Publicidad.net",category:"ad",domains:["*.publicidad.tv"]},{name:"PublishThis",company:"Ultra Unlimited",category:"ad",domains:["*.publishthis.com"]},{name:"Pulse Insights",category:"analytics",domains:["*.pulseinsights.com"]},{name:"Pulsepoint",category:"marketing",domains:["*.displaymarketplace.com"]},{name:"Purch",category:"ad",domains:["*.bestofmedia.com","*.purch.com"]},{name:"Pure Chat",category:"customer-success",domains:["*.purechat.com"]},{name:"PushCrew",category:"ad",domains:["*.pushcrew.com"]},{name:"Q1Media",category:"ad",domains:["*.q1media.com","*.q1mediahydraplatform.com"]},{name:"Qbase Software Development",category:"hosting",domains:["*.smartwebportal.co.uk"]},{name:"Qeryz",category:"analytics",domains:["*.qeryz.com"]},{name:"Qode Interactive",category:"hosting",domains:["*.qodeinteractive.com"]},{name:"Qrius",category:"social",domains:["*.qrius.me"]},{name:"Qualaroo",category:"analytics",domains:["*.qualaroo.com"]},{name:"Qualtrics",category:"analytics",domains:["*.qualtrics.com"]},{name:"Qubit",company:"Qubit",category:"analytics",domains:["*.qubit.com","*.qutics.com","d3c3cq33003psk.cloudfront.net","*.goqubit.com","*.qubitproducts.com"]},{name:"Qubit Deliver",company:"Qubit",category:"analytics",domains:["d1m54pdnjzjnhe.cloudfront.net","d22rutvoghj3db.cloudfront.net","dd6zx4ibq538k.cloudfront.net"]},{name:"QuestionPro",category:"analytics",domains:["*.questionpro.com"]},{name:"Queue-it",category:"other",domains:["*.queue-it.net"]},{name:"QuinStreet",category:"ad",domains:["*.Quinstreet.com","*.b2btechleadform.com","*.qnsr.com","*.qsstats.com"]},{name:"QuoVadis",category:"utility",domains:["*.quovadisglobal.com"]},{name:"Qzzr",category:"analytics",domains:["*.movementventures.com","*.qzzr.com"]},{name:"RapidAPI",category:"utility",domains:["*.rapidapi.com"]},{name:"RCS Media Group",category:"ad",domains:["*.rcsadv.it"]},{name:"REVIVVE",category:"ad",domains:["*.revivve.com"]},{name:"RSSinclude",category:"social",domains:["*.rssinclude.com"]},{name:"RTB House AdPilot",company:"RTB House",category:"ad",domains:["*.erne.co","*.creativecdn.com"]},{name:"RTB Media",category:"ad",domains:["*.rtb-media.me"]},{name:"RUN",category:"ad",domains:["*.runadtag.com","*.rundsp.com"]},{name:"Rackspace",category:"hosting",domains:["*.rackcdn.com","*.rackspacecloud.com","*.raxcdn.com","*.websitetestlink.com"]},{name:"RadiumOne",category:"ad",domains:["*.gwallet.com","*.r1-cdn.net"]},{name:"Rakuten DC Storm",company:"Rakuten",category:"analytics",domains:["*.dc-storm.com","*.h4k5.com","*.stormiq.com"]},{name:"Rakuten LinkShare",company:"Rakuten",category:"ad",domains:["*.linksynergy.com"]},{name:"Rakuten Marketing",company:"Rakuten",category:"ad",domains:["*.rakuten-static.com","*.rmtag.com","tag.rmp.rakuten.com"]},{name:"Rakuten MediaForge",company:"Rakuten",category:"ad",domains:["*.mediaforge.com"]},{name:"Rambler",company:"Rambler & Co",category:"utility",domains:["*.rambler.ru"]},{name:"Ranker",category:"content",domains:["*.ranker.com","*.rnkr-static.com"]},{name:"Ravelin",category:"utility",domains:["*.ravelin.com"]},{name:"Raygun",category:"utility",domains:["*.raygun.io"]},{name:"ReCollect",category:"utility",domains:["*.recollect.net"]},{name:"ReSRC",category:"utility",domains:["*.resrc.it"]},{name:"ReTargeter",category:"ad",domains:["*.retargeter.com"]},{name:"Reach Group",category:"ad",domains:["*.redintelligence.net"]},{name:"ReachDynamics",category:"ad",domains:["*.rdcdn.com"]},{name:"ReachForce",category:"ad",domains:["*.reachforce.com"]},{name:"ReachLocal",category:"ad",domains:["*.rtrk.co.nz"]},{name:"ReachMee",category:"content",domains:["*.reachmee.com"]},{name:"Reactful",category:"analytics",domains:["*.reactful.com"]},{name:"Realtime",company:"internet business technologies",category:"utility",domains:["*.realtime.co"]},{name:"Realtime Media (Brian Communications)",category:"ad",domains:["*.rtm.com"]},{name:"Realtime Targeting",category:"ad",domains:["*.idtargeting.com"]},{name:"Realytics",category:"analytics",domains:["dcniko1cv0rz.cloudfront.net","*.realytics.net"]},{name:"RebelMouse",category:"ad",domains:["*.rebelmouse.com","*.rbl.ms"]},{name:"Receiptful",category:"utility",domains:["*.receiptful.com"]},{name:"Recite Me",category:"other",domains:["*.reciteme.com"]},{name:"RecoBell",category:"analytics",domains:["*.recobell.io"]},{name:"Recommend",category:"analytics",domains:["*.recommend.pro"]},{name:"Red Eye International",category:"ad",domains:["*.pajmc.com"]},{name:"Redfish Group",category:"ad",domains:["*.wmps.com"]},{name:"Reevoo",category:"analytics",domains:["*.reevoo.com"]},{name:"Refersion",category:"ad",domains:["*.refersion.com"]},{name:"Refined Ads",category:"ad",domains:["*.refinedads.com"]},{name:"Reflektion",category:"analytics",domains:["*.reflektion.com","d26opx5dl8t69i.cloudfront.net"]},{name:"Reflow",company:"Scenestealer",category:"ad",domains:["*.reflow.tv"]},{name:"Reklama",category:"ad",domains:["*.o2.pl","*.wp.pl"]},{name:"Relevad ReleStar",company:"Relevad",category:"ad",domains:["*.relestar.com"]},{name:"Remarketing Pixel",company:"Adsterra Network",category:"ad",domains:["*.datadbs.com","*.remarketingpixel.com"]},{name:"Remintrex",company:"SmartUp Venture",category:"ad",domains:["*.remintrex.com"]},{name:"Republer",category:"ad",domains:["*.republer.com"]},{name:"Research Now",category:"analytics",domains:["*.researchgnow.com","*.researchnow.com"]},{name:"Research Online",company:"Skills Development Scotland",category:"content",domains:["*.researchonline.org.uk"]},{name:"Resonance Insights",category:"analytics",domains:["*.res-x.com"]},{name:"Resonate Networks",category:"analytics",domains:["*.reson8.com"]},{name:"Response Team",category:"ad",domains:["*.i-transactads.com"]},{name:"ResponseTap",category:"analytics",domains:["*.adinsight.com","*.responsetap.com"]},{name:"ResponsiveVoice",category:"other",domains:["*.responsivevoice.org"]},{name:"Retention Science",category:"ad",domains:["*.retentionscience.com","d1stxfv94hrhia.cloudfront.net"]},{name:"Revcontent",category:"content",domains:["*.revcontent.com"]},{name:"Revee",category:"ad",domains:["*.revee.com"]},{name:"Revenue Conduit",category:"utility",domains:["*.revenueconduit.com"]},{name:"RevenueMantra",category:"ad",domains:["*.revenuemantra.com"]},{name:"Reviews.co.uk",category:"analytics",domains:["*.reviews.co.uk"]},{name:"Reviews.io",category:"analytics",domains:["*.reviews.io"]},{name:"Revolver Maps",category:"analytics",domains:["*.revolvermaps.com"]},{name:"Revv",category:"utility",domains:["*.revv.co"]},{name:"RichRelevance",category:"analytics",domains:["*.richrelevance.com"]},{name:"RightNow Service Cloud",company:"Oracle",category:"customer-success",domains:["*.rightnowtech.com","*.rnengage.com"]},{name:"Rightster",category:"ad",domains:["*.ads-creativesyndicator.com"]},{name:"Riskified",category:"utility",domains:["*.riskified.com"]},{name:"Rockerbox",category:"analytics",homepage:"https://www.rockerbox.com/",domains:["getrockerbox.com"]},{name:"Rocket Fuel",category:"ad",domains:["*.rfihub.com","*.ru4.com","*.rfihub.net","*.ad1x.com"]},{name:"Rollbar",category:"utility",domains:["*.rollbar.com","d37gvrvc0wt4s1.cloudfront.net"]},{name:"RomanCart",category:"utility",domains:["*.romancart.com"]},{name:"Rondavu",category:"ad",domains:["*.rondavu.com"]},{name:"Roomkey",category:"content",domains:["*.roomkey.com"]},{name:"Roost",category:"utility",domains:["*.goroost.com"]},{name:"Roxot",category:"ad",domains:["*.rxthdr.com"]},{name:"Roxr Software",category:"analytics",domains:["*.getclicky.com"]},{name:"Rtoaster",company:"Brainpad",homepage:"https://www.brainpad.co.jp/rtoaster/",category:"marketing",domains:["*.rtoaster.jp"]},{name:"Rubikloud.com",category:"analytics",domains:["*.rubikloud.com"]},{name:"Ruler Analytics",company:"Ruler",category:"analytics",domains:["*.nyltx.com","*.ruleranalytics.com"]},{name:"Runner",company:"Rambler & Co",category:"content",domains:["*.begun.ru"]},{name:"S4M",category:"ad",domains:["*.sam4m.com"]},{name:"SAP Hybris Marketing Convert",company:"SAP",category:"ad",domains:["*.seewhy.com"]},{name:"SAS Institute",category:"ad",domains:["*.aimatch.com","*.sas.com"]},{name:"SATORI",homepage:"https://satori.marketing/",category:"marketing",domains:["satori.segs.jp"]},{name:"SC ShopMania Net SRL",category:"content",domains:["*.shopmania.com"]},{name:"SDL Media Manager",company:"SDL",category:"other",domains:["*.sdlmedia.com"]},{name:"SFR",category:"other",domains:["*.sfr.fr"]},{name:"SLI Systems",category:"utility",domains:["*.resultslist.com","*.resultspage.com","*.sli-spark.com"]},{name:"SMARTASSISTANT",company:"Smart Information Systems",category:"customer-success",domains:["*.smartassistant.com"]},{name:"SMARTSTREAM.TV",category:"ad",domains:["*.smartstream.tv"]},{name:"SPX",company:"Smaato",category:"ad",domains:["*.smaato.net"]},{name:"Sabio",category:"customer-success",domains:["*.sabio.co.uk"]},{name:"Sailthru",category:"analytics",domains:["*.sail-horizon.com","*.sail-personalize.com","*.sail-track.com"]},{name:"Sailthru Sightlines",company:"Sailthru",category:"marketing",domains:["*.sailthru.com"]},{name:"Sajari Pty",category:"utility",domains:["*.sajari.com"]},{name:"SaleCycle",category:"ad",domains:["*.salecycle.com","d16fk4ms6rqz1v.cloudfront.net","d22j4fzzszoii2.cloudfront.net","d30ke5tqu2tkyx.cloudfront.net","dn1i8v75r669j.cloudfront.net"]},{name:"Salesforce Live Agent",company:"Salesforce.com",category:"customer-success",domains:["*.salesforceliveagent.com"]},{name:"Salesforce.com",category:"ad",domains:["*.force.com","*.salesforce.com"]},{name:"Samba TV",company:"Samba",category:"content",domains:["*.samba.tv"]},{name:"Samplicio.us",category:"analytics",domains:["*.samplicio.us"]},{name:"Say Media",category:"ad",domains:["*.saymedia.com"]},{name:"Scenario",category:"analytics",domains:["*.getscenario.com"]},{name:"Schuh (image shard)",company:"Schuh",category:"other",domains:["d2ob0iztsaxy5v.cloudfront.net"]},{name:"Science Rockstars",category:"analytics",domains:["*.persuasionapi.com"]},{name:"ScientiaMobile",category:"analytics",domains:["*.wurflcloud.com","*.wurfl.io"]},{name:"Scoota",category:"ad",domains:["*.rockabox.co","*.scoota.co","d31i2625d5nv27.cloudfront.net","dyjnzf8evxrp2.cloudfront.net"]},{name:"ScribbleLive",category:"ad",domains:["*.scribblelive.com"]},{name:"SearchForce",category:"ad",domains:["*.searchforce.net"]},{name:"SearchSpring",category:"utility",domains:["*.searchspring.net"]},{name:"Searchanise",category:"analytics",domains:["*.searchanise.com"]},{name:"Sears Holdings",category:"content",domains:["*.shld.net"]},{name:"Secomapp",category:"utility",domains:["*.secomapp.com"]},{name:"SecuredVisit",company:"4Cite Marketing",category:"ad",domains:["*.securedvisit.com"]},{name:"SecurityMetrics",category:"utility",domains:["*.securitymetrics.com"]},{name:"Segmento",category:"ad",domains:["*.rutarget.ru"]},{name:"Segmint",category:"analytics",domains:["*.segmint.net"]},{name:"Sekindo",category:"content",domains:["*.sekindo.com"]},{name:"Seldon",category:"analytics",domains:["*.rummblelabs.com"]},{name:"SelectMedia International",category:"content",domains:["*.selectmedia.asia"]},{name:"Selligent",category:"ad",domains:["*.emsecure.net","*.slgnt.eu","targetemsecure.blob.core.windows.net"]},{name:"Sellpoints",category:"analytics",domains:["*.sellpoints.com"]},{name:"Semantics3",category:"analytics",domains:["*.hits.io"]},{name:"Semasio",category:"analytics",domains:["*.semasio.net"]},{name:"Semcasting Site Visitor Attribution",company:"Semcasting",category:"ad",domains:["*.smartzonessva.com"]},{name:"Sentifi",category:"social",domains:["*.sentifi.com"]},{name:"ServMetric",category:"analytics",domains:["*.servmetric.com"]},{name:"ServiceSource International",category:"marketing",domains:["*.scoutanalytics.net"]},{name:"ServiceTick",category:"analytics",domains:["*.servicetick.com"]},{name:"Servo",company:"Xervo",category:"hosting",domains:["*.onmodulus.net"]},{name:"SessionCam",company:"ServiceTick",category:"analytics",domains:["*.sessioncam.com","d2oh4tlt9mrke9.cloudfront.net"]},{name:"Seznam",category:"utility",domains:["*.imedia.cz"]},{name:"Sharethrough",category:"ad",domains:["*.sharethrough.com"]},{name:"SharpSpring",category:"marketing",domains:["*.sharpspring.com","*.marketingautomation.services"]},{name:"ShopRunner",category:"content",domains:["*.shoprunner.com","*.s-9.us"]},{name:"ShopStorm",category:"utility",domains:["*.shopstorm.com"]},{name:"Shopatron",category:"hosting",domains:["*.shopatron.com"]},{name:"Shopgate",category:"utility",domains:["*.shopgate.com"]},{name:"ShopiMind",company:"ShopIMind",category:"ad",domains:["*.shopimind.com"]},{name:"Shopkeeper Tools",category:"utility",domains:["*.shopkeepertools.com"]},{name:"Sidecar",category:"other",domains:["*.getsidecar.com","d3v27wwd40f0xu.cloudfront.net"]},{name:"Sidereel",category:"analytics",domains:["*.sidereel.com"]},{name:"Sift Science",category:"utility",domains:["*.siftscience.com"]},{name:"Signal",category:"tag-manager",domains:["*.sitetagger.co.uk"]},{name:"Signyfyd",category:"utility",domains:["*.signifyd.com"]},{name:"Silktide",category:"hosting",domains:["*.silktide.com"]},{name:"Silverpop",company:"IBM",category:"ad",domains:["*.mkt912.com","*.mkt922.com","*.mkt932.com","*.mkt941.com","*.mkt51.net","*.mkt61.net","*.pages01.net","*.pages02.net","*.pages03.net","*.pages04.net","*.pages05.net"]},{name:"Simplaex",category:"marketing",domains:["*.simplaex.net"]},{name:"SimpleReach",category:"analytics",domains:["*.simplereach.com","d8rk54i4mohrb.cloudfront.net"]},{name:"Simplestream",category:"content",domains:["*.simplestream.com"]},{name:"Simpli.fi",category:"ad",domains:["*.simpli.fi"]},{name:"Simplicity Marketing",category:"ad",domains:["*.flashtalking.com"]},{name:"SinnerSchrader Deutschland",category:"ad",domains:["*.s2Betrieb.de"]},{name:"Sirv",category:"other",domains:["*.sirv.com"]},{name:"Site Meter",category:"analytics",domains:["*.sitemeter.com"]},{name:"Site24x7 Real User Monitoring",company:"Site24x7",category:"analytics",domains:["*.site24x7rum.com"]},{name:"SiteGainer",category:"analytics",domains:["*.sitegainer.com","d191y0yd6d0jy4.cloudfront.net"]},{name:"SiteScout",company:"Centro",category:"ad",domains:["*.pixel.ad","*.sitescout.com"]},{name:"Siteimprove",category:"utility",domains:["*.siteimprove.com","*.siteimproveanalytics.com"]},{name:"Six Degrees Group",category:"hosting",domains:["*.fstech.co.uk"]},{name:"Skimbit",category:"ad",domains:["*.redirectingat.com","*.skimresources.com","*.skimresources.net"]},{name:"Skimlinks",category:"ad",domains:["*.skimlinks.com"]},{name:"SkyGlue Technology",category:"analytics",domains:["*.skyglue.com"]},{name:"SkyScanner",category:"content",domains:["*.skyscanner.net"]},{name:"Skybet",company:"Bonne Terre t/a Sky Vegas (Sky)",category:"other",domains:["*.skybet.com"]},{name:"Skype",category:"other",domains:["*.skype.com"]},{name:"Slate Group",category:"content",domains:["*.cdnslate.com"]},{name:"SlimCut Media Outstream",company:"SlimCut Media",category:"ad",domains:["*.freeskreen.com"]},{name:"Smart Insight Tracking",company:"Emarsys",category:"analytics",domains:["*.scarabresearch.com"]},{name:"Smart AdServer",category:"ad",domains:["*.01net.com","*.sascdn.com","*.sasqos.com","*.smartadserver.com"]},{name:"SmartFocus",category:"analytics",domains:["*.emv2.com","*.emv3.com","*.predictiveintent.com","*.smartfocus.com","*.themessagecloud.com"]},{name:"Smarter Click",category:"ad",domains:["*.smct.co","*.smarterclick.co.uk"]},{name:"SmarterHQ",category:"analytics",domains:["*.smarterhq.io","d1n00d49gkbray.cloudfront.net","*.smarterremarketer.net"]},{name:"Smarttools",category:"customer-success",domains:["*.smartertrack.com"]},{name:"Smartzer",category:"ad",domains:["*.smartzer.com"]},{name:"Snack Media",category:"content",domains:["*.snack-media.com"]},{name:"Snacktools",category:"ad",domains:["*.bannersnack.com"]},{name:"SnapEngage",category:"customer-success",domains:["*.snapengage.com"]},{name:"SnapWidget",category:"content",domains:["*.snapwidget.com"]},{name:"Soasta",category:"analytics",domains:["*.lognormal.net"]},{name:"SociableLabs",category:"ad",domains:["*.sociablelabs.net","*.sociablelabs.com"]},{name:"Social Annex",category:"customer-success",domains:["*.socialannex.com"]},{name:"SocialShopWave",category:"social",domains:["*.socialshopwave.com"]},{name:"Socialphotos",category:"social",domains:["*.slpht.com"]},{name:"Sociomantic Labs",company:"DunnHumby",category:"ad",domains:["*.sociomantic.com"]},{name:"SodaHead",category:"analytics",domains:["*.sodahead.com"]},{name:"Softwebzone",category:"hosting",domains:["*.softwebzone.com"]},{name:"Sojern",category:"marketing",domains:["*.sojern.com"]},{name:"Sokrati",category:"marketing",domains:["*.sokrati.com"]},{name:"Sonobi",category:"ad",domains:["*.sonobi.com"]},{name:"Sooqr Search",company:"Sooqr",category:"utility",domains:["*.sooqr.com"]},{name:"Sophus3",category:"analytics",domains:["*.s3ae.com","*.sophus3.com"]},{name:"Sorenson Media",category:"content",domains:["*.sorensonmedia.com"]},{name:"Sortable",category:"ad",domains:["*.deployads.com"]},{name:"Sotic",category:"hosting",domains:["*.sotic.net","*.soticservers.net"]},{name:"Soundest",category:"ad",domains:["*.soundestlink.com","*.soundest.net"]},{name:"Sourcepoint",category:"ad",domains:["*.decenthat.com","*.fallingfalcon.com","*.summerhamster.com","d2lv4zbk7v5f93.cloudfront.net","d3qxwzhswv93jk.cloudfront.net"]},{name:"SourceKnowledge",homepage:"https://www.sourceknowledge.com",category:"ad",domains:["*.provenpixel.com"]},{name:"SpaceNet",category:"hosting",domains:["*.nmm.de"]},{name:"Sparkflow",company:"Intercept Interactive",category:"ad",domains:["*.sparkflow.net"]},{name:"Specific Media",category:"ad",domains:["*.specificmedia.com","*.adviva.net","*.specificclick.net"]},{name:"Spicy",company:"Data-Centric Alliance",category:"ad",domains:["*.sspicy.ru"]},{name:"Spoke",category:"customer-success",domains:["*.121d8.com"]},{name:"Spongecell",category:"ad",domains:["*.spongecell.com"]},{name:"Spot.IM",category:"social",domains:["*.spot.im","*.spotim.market"]},{name:"SpotXchange",category:"ad",domains:["*.spotxcdn.com","*.spotxchange.com","*.spotx.tv"]},{name:"SpringServer",category:"ad",domains:["*.springserve.com"]},{name:"Spylight",category:"other",domains:["*.spylight.com"]},{name:"SreamAMG",company:"StreamAMG",category:"other",domains:["*.streamamg.com"]},{name:"StackAdapt",category:"ad",domains:["*.stackadapt.com"]},{name:"StackExchange",category:"social",domains:["*.sstatic.net"]},{name:"Stackla PTY",category:"social",domains:["*.stackla.com"]},{name:"Stailamedia",category:"ad",domains:["*.stailamedia.com"]},{name:"Stamped.io",category:"analytics",domains:["*.stamped.io"]},{name:"Starfield Services Root Certificate Authority",company:"Starfield Technologies",category:"utility",domains:["*.starfieldtech.com","ss2.us","*.ss2.us"]},{name:"Starfield Technologies",category:"utility",domains:["*.websiteprotection.com"]},{name:"StatCounter",category:"analytics",domains:["*.statcounter.com"]},{name:"Statful",category:"analytics",domains:["*.statful.com"]},{name:"Steelhouse",category:"ad",domains:["*.steelhousemedia.com"]},{name:"Steepto",category:"ad",domains:["*.steepto.com"]},{name:"StellaService",category:"analytics",domains:["*.stellaservice.com"]},{name:"StickyADS.tv",category:"ad",domains:["*.stickyadstv.com"]},{name:"STINGRAY",company:"FlexOne",category:"ad",domains:["*.impact-ad.jp"]},{name:"Storify",company:"Adobe Systems",category:"social",domains:["*.storify.com"]},{name:"Storm Tag Manager",company:"Rakuten",category:"tag-manager",domains:["*.stormcontainertag.com"]},{name:"Storygize",category:"ad",domains:["*.storygize.net"]},{name:"Strands",category:"utility",domains:["*.strands.com"]},{name:"StreamRail",category:"ad",domains:["*.streamrail.com","*.streamrail.net"]},{name:"StrikeAd",category:"ad",domains:["*.strikead.com"]},{name:"Struq",company:"Quantcast",category:"ad",domains:["*.struq.com"]},{name:"StrÃ¶er Digital Media",category:"ad",domains:["*.stroeerdigitalmedia.de"]},{name:"StumbleUpon",category:"content",domains:["*.stumble-upon.com","*.stumbleupon.com"]},{name:"Sub2 Technologies",category:"analytics",domains:["*.sub2tech.com"]},{name:"SublimeSkinz",category:"ad",domains:["*.ayads.co"]},{name:"Sumo Logic",category:"utility",domains:["*.sumologic.com"]},{name:"Sunday Times Driving",category:"content",domains:["*.driving.co.uk"]},{name:"SundaySky",category:"ad",domains:["*.sundaysky.com","dds6m601du5ji.cloudfront.net"]},{name:"Sunrise Integration",category:"utility",domains:["*.sunriseintegration.com"]},{name:"Supertool Network Technology",category:"analytics",domains:["*.miaozhen.com"]},{name:"Survata",category:"analytics",domains:["*.survata.com"]},{name:"SurveyGizmo",category:"analytics",domains:["*.surveygizmo.eu"]},{name:"SurveyMonkey",category:"analytics",domains:["*.surveymonkey.com"]},{name:"Survicate",category:"analytics",domains:["*.survicate.com"]},{name:"Sweet Tooth",category:"ad",domains:["*.sweettooth.io"]},{name:"Swiftype",category:"utility",domains:["*.swiftype.com","*.swiftypecdn.com"]},{name:"Switch Concepts",category:"ad",domains:["*.switchadhub.com"]},{name:"SwitchAds",company:"Switch Concepts",category:"ad",domains:["*.switchads.com"]},{name:"Swogo",category:"analytics",domains:["*.xsellapp.com"]},{name:"Swoop",category:"ad",domains:["*.swoop.com"]},{name:"Symantec",category:"utility",domains:["*.norton.com","*.symantec.com","*.symcb.com","*.symcd.com"]},{name:"Syncapse",category:"social",domains:["*.clickable.net"]},{name:"Synergetic",category:"ad",domains:["*.synergetic.ag"]},{name:"Synthetix",category:"customer-success",domains:["*.syn-finity.com","*.synthetix-ec1.com","*.synthetix.com"]},{name:"Syte",category:"other",domains:["*.syteapi.com"]},{name:"TINT",category:"content",domains:["*.71n7.com","d33w9bm0n1egwm.cloudfront.net","d36hc0p18k1aoc.cloudfront.net","d3l7tj34e9fc43.cloudfront.net"]},{name:"TNS (Kantar Group)",category:"analytics",domains:["*.tns-counter.ru"]},{name:"TRUSTe",category:"utility",domains:["*.truste.com"]},{name:"TV Genius",company:"Ericcson Media Services",category:"content",domains:["*.tvgenius.net"]},{name:"TVSquared",category:"ad",domains:["*.tvsquared.com"]},{name:"TVTY",category:"ad",domains:["*.distribeo.com","*.ogigl.com"]},{name:"Tactics bvba",category:"hosting",domains:["*.influid.co"]},{name:"Tag Inspector",company:"InfoTrust",category:"analytics",domains:["d22xmn10vbouk4.cloudfront.net"]},{name:"TagCommander",category:"tag-manager",domains:["*.commander1.com","*.tagcommander.com"]},{name:"Tagboard",category:"social",domains:["*.tagboard.com"]},{name:"Taggstar",company:"Taggstar UK",category:"ad",domains:["*.taggstar.com"]},{name:"Tail Target",company:"Tail",category:"ad",domains:["*.tailtarget.com"]},{name:"Tailored",category:"other",domains:["d24qm7bu56swjs.cloudfront.net","dw3vahmen1rfy.cloudfront.net","*.tailored.to"]},{name:"Taleo Enterprise Cloud Service",company:"Oracle",category:"content",domains:["*.taleo.net"]},{name:"Talkable",category:"ad",domains:["*.talkable.com","d2jjzw81hqbuqv.cloudfront.net"]},{name:"TapSense",category:"ad",domains:["*.tapsense.com"]},{name:"Tapad",category:"ad",domains:["*.tapad.com"]},{name:"Teads",category:"ad",domains:["*.teads.tv"]},{name:"Team Internet Tonic",company:"Team Internet",category:"ad",domains:["*.dntrax.com"]},{name:"TechTarget",category:"content",domains:["*.techtarget.com","*.ttgtmedia.com"]},{name:"Technorati",company:"Synacor",category:"ad",domains:["*.technoratimedia.com"]},{name:"Teedhaze",category:"content",domains:["*.fuel451.com"]},{name:"Tell Apart",category:"analytics",domains:["*.tellapart.com","*.tellaparts.com"]},{name:"Tencent",category:"content",domains:["*.qq.com","*.ywxi.net"]},{name:"Thanx Media",category:"utility",domains:["*.hawksearch.info"]},{name:"Thawte",category:"utility",domains:["*.thawte.com"]},{name:"Thesis",category:"analytics",homepage:"https://www.thesistesting.com/",domains:["*.ttsep.com"]},{name:"The AA",category:"ad",domains:["*.adstheaa.com"]},{name:"The ADEX",category:"ad",domains:["*.theadex.com"]},{name:"The Best Day",category:"social",domains:["*.thebestday.com"]},{name:"The Filter",company:"Exabre",category:"analytics",domains:["*.thefilter.com"]},{name:"The Guardian",category:"analytics",domains:["*.ophan.co.uk"]},{name:"The Hut Group",category:"content",domains:["*.thcdn.com"]},{name:"The Numa Group",category:"other",domains:["*.hittail.com"]},{name:"The Publisher Desk",category:"ad",domains:["*.206ads.com","*.publisherdesk.com"]},{name:"The Sydney Morning Herald",company:"Fairfax Media",category:"content",domains:["*.smh.com.au"]},{name:"The Wall Street Jounal",category:"content",domains:["*.wsj.net"]},{name:"The Wall Street Journal",category:"content",domains:["*.marketwatch.com"]},{name:"TheFind",category:"content",domains:["*.thefind.com"]},{name:"Thinglink",category:"utility",domains:["*.thinglink.com"]},{name:"Thirdpresence",category:"ad",domains:["*.thirdpresence.com"]},{name:"ThreatMetrix",category:"utility",domains:["*.online-metrix.net"]},{name:"Throtle",homepage:"https://throtle.io/",category:"analytics",domains:["*.thrtle.com","*.v12group.com"]},{name:"TicketMaster",category:"content",domains:["*.t-x.io","*.tmcs.net"]},{name:"TikTok",company:"ByteDance Ltd",homepage:"https://www.tiktok.com/en/",category:"social",domains:["*.tiktok.com","*.ipstatp.com"]},{name:"Tidio Live Chat",company:"Tidio",homepage:"https://www.tidiochat.com/en/",category:"customer-success",domains:["*.tidiochat.com"]},{name:"Tiledesk Live Chat",company:"Tiledesk SRL",homepage:"https://www.tiledesk.com/",category:"customer-success",domains:["*.tiledesk.com"]},{name:"Time",category:"content",domains:["*.timeinc.net"]},{name:"Time2Perf",category:"ad",domains:["*.time2perf.com"]},{name:"TinyURL",category:"utility",domains:["*.tinyurl.com"]},{name:"Tivo",category:"analytics",domains:["*.rovicorp.com"]},{name:"Tom&Co",category:"hosting",domains:["*.tomandco.uk"]},{name:"Toms Native Ads",company:"Purch",category:"ad",domains:["*.natoms.com"]},{name:"ToneMedia",category:"ad",domains:["*.clickfuse.com"]},{name:"Tonic",company:"Team Internet",category:"ad",domains:["*.dntx.com"]},{name:"Touch Commerce",category:"customer-success",domains:["*.inq.com","*.touchcommerce.com"]},{name:"ToutApp",category:"ad",domains:["*.toutapp.com"]},{name:"TraceView",company:"Solarwinds",category:"analytics",domains:["*.tracelytics.com","d2gfdmu30u15x7.cloudfront.net"]},{name:"TrackJS",category:"analytics",domains:["*.trackjs.com","d2zah9y47r7bi2.cloudfront.net"]},{name:"Tradedoubler",category:"ad",domains:["*.pvnsolutions.com","*.tradedoubler.com"]},{name:"Tradelab",category:"ad",domains:["*.tradelab.fr"]},{name:"TrafficFactory",category:"ad",domains:["*.trafficfactory.biz"]},{name:"TrafficHunt",category:"ad",domains:["*.traffichunt.com"]},{name:"TrafficStars",category:"ad",domains:["*.trafficstars.com","*.tsyndicate.com"]},{name:"Transifex",category:"utility",domains:["*.transifex.com"]},{name:"Travelex",category:"utility",domains:["*.travelex.net","*.travelex.co.uk"]},{name:"Travelocity Canada",company:"Travelocity",category:"content",domains:["*.travelocity.ca"]},{name:"Travelocity USA",company:"Travelocity",category:"content",domains:["*.travelocity.com"]},{name:"Travelzoo",category:"content",domains:["*.travelzoo.com"]},{name:"Treasure Data",category:"analytics",domains:["*.treasuredata.com"]},{name:"Tremor Video",category:"ad",domains:["*.tremorhub.com","*.videohub.tv"]},{name:"Trialfire",category:"analytics",domains:["*.trialfire.com"]},{name:"Tribal Fusion",company:"Exponential Interactive",category:"ad",domains:["*.tribalfusion.com"]},{name:"Triblio",category:"marketing",domains:["*.tribl.io"]},{name:"Triggered Messaging",company:"Fresh Relevance",category:"ad",domains:["*.triggeredmessaging.com"]},{name:"Trinity Mirror",category:"content",domains:["*.mirror.co.uk"]},{name:"Trinity Mirror Digital Media",category:"social",domains:["*.tm-aws.com","*.icnetwork.co.uk"]},{name:"TripAdvisor",category:"content",domains:["*.jscache.com","*.tacdn.com","*.tamgrt.com","*.tripadvisor.com","*.viator.com","*.tripadvisor.co.uk"]},{name:"TripleLift",category:"ad",domains:["*.3lift.com"]},{name:"Tru Optik",category:"ad",domains:["*.truoptik.com"]},{name:"TruConversion",category:"analytics",domains:["*.truconversion.com"]},{name:"Trueffect",category:"marketing",domains:["*.adlegend.com"]},{name:"Truefit",category:"analytics",domains:["*.truefitcorp.com"]},{name:"Trust Guard",category:"utility",domains:["*.trust-guard.com"]},{name:"Trust Pilot",category:"analytics",domains:["*.trustpilot.com"]},{name:"Amazon Trust Services",company:"Amazon",category:"utility",domains:["*.amazontrust.com","o.ss2.us"]},{name:"Google Trust Services",company:"Google",category:"utility",domains:["*.pki.goog"]},{name:"Let's Encrypt",homepage:"https://letsencrypt.org/",category:"utility",domains:["*.letsencrypt.org"]},{name:"TrustX",category:"ad",domains:["*.trustx.org"]},{name:"Trusted Shops",category:"utility",domains:["*.trustedshops.com"]},{name:"Trustev",company:"TransUnion",category:"utility",domains:["*.trustev.com"]},{name:"Trustwave",category:"utility",domains:["*.trustwave.com"]},{name:"Tryzens TradeState",company:"Tryzens",category:"analytics",domains:["*.tryzens-analytics.com"]},{name:"TubeMogul",category:"ad",domains:["*.tubemogul.com"]},{name:"Turn",category:"ad",domains:["*.turn.com"]},{name:"Tutorialize",category:"customer-success",domains:["*.tutorialize.me"]},{name:"Twenga",category:"content",domains:["*.twenga.fr","*.c4tw.net","*.twenga.co.uk"]},{name:"Twitframe",company:"Superblock",category:"utility",domains:["*.twitframe.com"]},{name:"Twitter Online Conversion Tracking",company:"Twitter",category:"ad",domains:["*.ads-twitter.com","analytics.twitter.com"]},{name:"Twitter Short URL",company:"Twitter",category:"social",domains:["*.t.co"]},{name:"Twyn Group",category:"ad",domains:["*.twyn.com"]},{name:"Tynt",company:"33 Across",category:"ad",domains:["*.tynt.com"]},{name:"Typepad",category:"hosting",domains:["*.typepad.com"]},{name:"TyrbooBytes",category:"utility",domains:["*.turbobytes.net"]},{name:"UPS i-parcel",company:"UPS",category:"other",domains:["*.i-parcel.com"]},{name:"US Media Consulting",category:"ad",domains:["*.mediade.sk"]},{name:"Ubertags",category:"tag-manager",domains:["*.ubertags.com"]},{name:"Umbel",category:"analytics",domains:["*.umbel.com"]},{name:"Unanimis",company:"Switch",category:"ad",domains:["*.unanimis.co.uk"]},{name:"Unbounce",category:"ad",domains:["*.ubembed.com","*.unbounce.com","d2xxq4ijfwetlm.cloudfront.net","d9hhrg4mnvzow.cloudfront.net"]},{name:"Underdog Media",category:"ad",domains:["*.underdog.media","*.udmserve.net"]},{name:"Understand Digital",category:"ad",domains:["*.redirecting2.net"]},{name:"Undertone",company:"Perion",category:"ad",domains:["*.legolas-media.com"]},{name:"Unidays",category:"ad",domains:["*.myunidays.com","*.unidays.world"]},{name:"Uniqodo",category:"ad",domains:["*.uniqodo.com"]},{name:"Unite",category:"ad",domains:["*.uadx.com"]},{name:"United Card Services",category:"utility",domains:["*.ucs.su"]},{name:"United Internet",category:"hosting",domains:["*.uicdn.com"]},{name:"United Internet Media",category:"ad",domains:["*.ui-portal.de"]},{name:"United Internet Media AG",category:"hosting",domains:["*.tifbs.net","*.uicdn.net","*.uimserv.net"]},{name:"Unknown",category:"other",domains:[]},{name:"Unruly Media",category:"ad",domains:["*.unrulymedia.com"]},{name:"UpBuild",category:"ad",domains:["*.upbuild.io"]},{name:"UpSellit",category:"analytics",domains:["*.upsellit.com"]},{name:"Upland Software",category:"hosting",domains:["*.clickability.com"]},{name:"Airship",category:"marketing",domains:["*.urbanairship.com","*.aswpsdkus.com"]},{name:"UsabilityTools",category:"analytics",domains:["*.usabilitytools.com"]},{name:"Usablenet.net",category:"utility",domains:["*.usablenet.net"]},{name:"Use It Better",category:"analytics",domains:["*.useitbetter.com"]},{name:"User Replay",category:"analytics",domains:["*.userreplay.net"]},{name:"UserReport",category:"analytics",domains:["*.userreport.com"]},{name:"Userneeds",category:"analytics",domains:["*.userneeds.dk"]},{name:"Userzoom",category:"analytics",domains:["*.userzoom.com"]},{name:"V12 Retail Finance",category:"utility",domains:["*.v12finance.com"]},{name:"Vacaciones eDreams",category:"content",domains:["*.odistatic.net"]},{name:"Varick Media Management",category:"ad",domains:["*.vmmpxl.com"]},{name:"Vdopia Chocolate",company:"Vdopia",category:"ad",domains:["*.vdopia.com"]},{name:"Ve",company:"Ve",homepage:"https://www.ve.com/",category:"marketing",domains:["*.veinteractive.com","*.ve.com"]},{name:"Ve Interactive",company:"Ve",category:"ad",domains:["*.vepxl1.net","*.adgenie.co.uk"]},{name:"Vee24",category:"customer-success",domains:["*.vee24.com"]},{name:"Veeseo",category:"content",domains:["*.veeseo.com"]},{name:"Venatus Media",category:"marketing",domains:["*.alcvid.com","*.venatusmedia.com"]},{name:"Veoxa",category:"ad",domains:["*.veoxa.com"]},{name:"Vergic AB",category:"customer-success",domains:["*.psplugin.com"]},{name:"Vergic Engage Platform",company:"Vergic",category:"customer-success",domains:["*.vergic.com"]},{name:"Verisign (Symantec)",category:"utility",domains:["*.verisign.com"]},{name:"Verizon",category:"utility",domains:["*.public-trust.com"]},{name:"Verizon Digital Media CDN",homepage:"https://www.verizondigitalmedia.com/",category:"cdn",domains:["*.edgecastcdn.net","*.edgecastdns.net"]},{name:"Verizon Uplynk",company:"Verizon",category:"content",domains:["*.uplynk.com"]},{name:"Vero",company:"Semblance",category:"ad",domains:["*.getvero.com","d3qxef4rp70elm.cloudfront.net"]},{name:"VertaMedia",category:"ad",domains:["*.vertamedia.com"]},{name:"Vertical Mass",category:"ad",domains:["*.vmweb.net"]},{name:"Vestorly",category:"ad",domains:["*.oodalab.com"]},{name:"Vextras",category:"other",domains:["*.vextras.com"]},{name:"Viacom",category:"content",domains:["*.mtvnservices.com"]},{name:"Vibrant Media",category:"ad",domains:["*.intellitxt.com","*.picadmedia.com"]},{name:"VidPulse",category:"analytics",domains:["*.vidpulse.com"]},{name:"Video Media Groep",category:"ad",domains:["*.vmg.host","*.inpagevideo.nl"]},{name:"VideoHub",company:"Tremor Video",category:"ad",domains:["*.scanscout.com"]},{name:"Videology",category:"ad",domains:["*.tidaltv.com"]},{name:"Vidible",category:"ad",domains:["*.vidible.tv"]},{name:"VigLink",category:"ad",domains:["*.viglink.com"]},{name:"Vindico",company:"Viant",category:"ad",domains:["*.vindicosuite.com"]},{name:"Viocorp International",category:"content",domains:["*.vioapi.com"]},{name:"ViralNinjas",category:"ad",domains:["*.viralninjas.com"]},{name:"Virool",category:"ad",domains:["*.virool.com"]},{name:"Virtual Earth",company:"Microsoft",category:"utility",domains:["*.virtualearth.net"]},{name:"Visely",company:"Visely",category:"other",homepage:"https://visely.io/",domains:["*.visely.io"]},{name:"VisScore",category:"analytics",domains:["*.visscore.com","d2hkbi3gan6yg6.cloudfront.net"]},{name:"Visible Measures",category:"ad",domains:["*.visiblemeasures.com"]},{name:"Visual Studio",company:"Microsoft",category:"utility",domains:["*.visualstudio.com"]},{name:"VisualDNA",category:"ad",domains:["*.visualdna.com"]},{name:"VisualVisitor",category:"ad",domains:["*.id-visitors.com"]},{name:"Vivocha S.p.A",category:"customer-success",domains:["*.vivocha.com"]},{name:"Vizu (Nielsen)",category:"analytics",domains:["*.vizu.com"]},{name:"Vizury",category:"ad",domains:["*.vizury.com"]},{name:"VoiceFive",category:"analytics",domains:["*.voicefive.com"]},{name:"Volvelle",company:"Optomaton",category:"ad",domains:["*.volvelle.tech"]},{name:"VouchedFor",category:"analytics",domains:["*.vouchedfor.co.uk"]},{name:"WARPCACHE",category:"utility",domains:["*.warpcache.net"]},{name:"WISHLIST",company:"Shopapps",category:"social",domains:["*.shopapps.in"]},{name:"WP Engine",category:"hosting",domains:["*.wpengine.com"]},{name:"WalkMe",category:"customer-success",domains:["*.walkme.com"]},{name:"Watching That",category:"other",domains:["*.watchingthat.com"]},{name:"Wayfair",category:"analytics",domains:["*.wayfair.com"]},{name:"Web CEO",category:"other",domains:["*.websiteceo.com"]},{name:"Web Dissector",company:"Beijing Gridsum Technologies",category:"analytics",domains:["*.gridsumdissector.com","*.webdissector.com"]},{name:"Web Forensics",category:"analytics",domains:["*.webforensics.co.uk"]},{name:"Web Security and Performance",company:"NCC Group",category:"utility",domains:["*.nccgroup.trust"]},{name:"WebEngage",category:"customer-success",domains:["*.webengage.co","*.webengage.com","d23nd6ymopvz52.cloudfront.net","d3701cc9l7v9a6.cloudfront.net"]},{name:"WebInsight",company:"dotMailer",category:"analytics",domains:["*.trackedlink.net","*.trackedweb.net"]},{name:"WebPageOne Solutions",category:"other",domains:["*.webpageone.com"]},{name:"WebSpectator",category:"ad",domains:["*.webspectator.com"]},{name:"WebTuna",company:"Application Performance",category:"analytics",domains:["*.webtuna.com"]},{name:"WebVideoCore",company:"StreamingVideoProvider",category:"content",domains:["*.webvideocore.net"]},{name:"WebWombat",category:"utility",domains:["*.ic.com.au"]},{name:"Webcollage",category:"customer-success",domains:["*.webcollage.net"]},{name:"Webcore",category:"ad",domains:["*.onefeed.co.uk"]},{name:"Webkul",company:"Webkul Software",category:"utility",domains:["*.webkul.com"]},{name:"Webmarked",category:"utility",domains:["*.webmarked.net"]},{name:"Weborama",category:"ad",domains:["*.weborama.com","*.weborama.fr"]},{name:"WebpageFX",category:"ad",domains:["*.leadmanagerfx.com"]},{name:"Webphone",company:"IP WEB SERVICES",category:"customer-success",domains:["*.webphone.net"]},{name:"Webselect selectcommerce",company:"Webselect Internet",category:"hosting",domains:["*.webselect.net"]},{name:"Webthinking",category:"hosting",domains:["*.webthinking.co.uk"]},{name:"Webtrekk",category:"analytics",domains:["*.wbtrk.net","*.webtrekk-asia.net","*.webtrekk.net","*.wt-eu02.net","*.wt-safetag.com"]},{name:"Webtrends",category:"analytics",domains:["*.webtrends.com","*.webtrendslive.com","d1q62gfb8siqnm.cloudfront.net"]},{name:"Webtype",category:"cdn",domains:["*.webtype.com"]},{name:"White Ops",category:"utility",domains:["*.acexedge.com","*.tagsrvcs.com"]},{name:"Whitespace",category:"ad",domains:["*.whitespacers.com"]},{name:"WhosOn Live Chat Software",category:"customer-success",domains:["*.whoson.com"]},{name:"Wibbitz",category:"other",domains:["*.wibbitz.com"]},{name:"Wide Area Communications",category:"hosting",domains:["*.widearea.co.uk"]},{name:"WideOrbit",category:"marketing",domains:["*.admaym.com"]},{name:"William Reed",category:"content",domains:["*.wrbm.com"]},{name:"WillyFogg.com",category:"content",domains:["*.willyfogg.com"]},{name:"Windows",company:"Microsoft",category:"utility",domains:["*.windowsupdate.com"]},{name:"WisePops",category:"utility",domains:["*.wisepops.com"]},{name:"Wishlist King",company:"Appmate",category:"other",homepage:"https://appmate.io/",domains:["*.appmate.io"]},{name:"Wishpond Technologies",category:"marketing",domains:["*.wishpond.com","*.wishpond.net"]},{name:"WizRocket Technologies",category:"analytics",domains:["*.wzrkt.com"]},{name:"Woopra",category:"analytics",domains:["*.woopra.com"]},{name:"Woosmap",category:"utility",domains:["*.woosmap.com"]},{name:"WorkCast",category:"hosting",domains:["*.workcast.net"]},{name:"World News Media",category:"content",domains:["*.wnmedia.co.uk"]},{name:"Worldpay",category:"utility",domains:["*.worldpay.com"]},{name:"Wow Analytics",category:"analytics",domains:["*.wowanalytics.co.uk"]},{name:"Wowcher",category:"ad",domains:["*.wowcher.co.uk"]},{name:"Wufoo",category:"utility",domains:["*.wufoo.com"]},{name:"Wunderkind",category:"marketing",homepage:"https://www.wunderkind.co/",domains:["*.bounceexchange.com","*.bouncex.net","*.wknd.ai","*.cdnbasket.net","*.cdnwidget.com"]},{name:"Wyng",category:"ad",domains:["*.offerpop.com"]},{name:"XMLSHOP",category:"hosting",domains:["*.xmlshop.biz"]},{name:"XiTi",company:"AT Internet",category:"analytics",domains:["*.xiti.com","*.aticdn.net"],homepage:"https://www.atinternet.com/en/"},{name:"YUDU",category:"content",domains:["*.yudu.com"]},{name:"Yahoo! Ad Exchange",company:"Yahoo!",category:"ad",domains:["*.yieldmanager.com","*.browsiprod.com"]},{name:"Yahoo! JAPAN Ads",company:"Yahoo! JAPAN",category:"ad",homepage:"https://marketing.yahoo.co.jp/service/yahooads/",domains:["yads.c.yimg.jp","s.yimg.jp","b92.yahoo.co.jp"]},{name:"Yahoo! Tag Manager",company:"Yahoo! JAPAN",category:"tag-manager",homepage:"https://marketing.yahoo.co.jp/service/tagmanager/",domains:["*.yjtag.jp"]},{name:"Yahoo! Small Business",company:"Yahoo!",category:"hosting",domains:["*.aabacosmallbusiness.com"]},{name:"Yellow Robot",category:"ad",domains:["*.backinstock.org"]},{name:"YieldPartners",category:"ad",domains:["*.yieldpartners.com"]},{name:"Yieldbot",category:"ad",domains:["*.yldbt.com"]},{name:"Yieldify",category:"ad",domains:["*.yieldify.com","*.yieldifylabs.com","d33wq5gej88ld6.cloudfront.net","dwmvwp56lzq5t.cloudfront.net"]},{name:"Yieldlab",category:"ad",domains:["*.yieldlab.net"]},{name:"Yieldmo",category:"ad",domains:["*.yieldmo.com"]},{name:"Yieldr",category:"ad",domains:["*.254a.com"]},{name:"Yo",category:"utility",domains:["*.yopify.com"]},{name:"YoYo",category:"utility",domains:["*.goadservices.com"]},{name:"Yotpo",homepage:"https://www.yotpo.com/",category:"marketing",domains:["*.yotpo.com","*.swellrewards.com"]},{name:"Yottaa",category:"hosting",domains:["*.yottaa.com","*.yottaa.net"]},{name:"YourAmigo",category:"utility",domains:["*.youramigo.com"]},{name:"YuMe",category:"ad",domains:["*.yume.com","*.yumenetworks.com"]},{name:"Yummley",category:"other",domains:["*.yummly.com"]},{name:"ZEDO",category:"ad",domains:["*.zedo.com"]},{name:"Zafu",category:"analytics",domains:["*.zafu.com"]},{name:"Zaius",category:"ad",domains:["*.zaius.com"]},{name:"Zamplus ad",category:"ad",domains:["*.zampda.net"]},{name:"Zanox",category:"ad",domains:["*.zanox.com","*.zanox.ws"]},{name:"Zapper",category:"utility",domains:["*.zapper.com"]},{name:"Zarget",category:"analytics",domains:["*.zarget.com"]},{name:"Zemanta",category:"ad",domains:["*.zemanta.com"]},{name:"Zen Internet",category:"other",domains:["*.zyen.com"]},{name:"Zenovia Digital Exchange",category:"ad",domains:["*.rhythmxchange.com","*.zenoviaexchange.com"]},{name:"ZergNet",category:"content",domains:["*.zergnet.com"]},{name:"Zerogrey",category:"hosting",domains:["*.zerogrey.com"]},{name:"Ziff Davis Tech",category:"ad",domains:["*.adziff.com","*.zdbb.net"]},{name:"Zmags",category:"marketing",domains:["*.zmags.com"]},{name:"Zolando",category:"content",domains:["*.ztat.net"]},{name:"Zoover",category:"analytics",domains:["*.zoover.nl","*.zoover.co.uk"]},{name:"Zopim",category:"customer-success",domains:["*.zopim.io"]},{name:"[24]7",category:"customer-success",domains:["*.247-inc.net","*.247inc.net","d1af033869koo7.cloudfront.net"]},{name:"adKernel",category:"ad",domains:["*.adkernel.com"]},{name:"adMarketplace",company:"AMPexchange",category:"ad",domains:["*.ampxchange.com","*.admarketplace.net"]},{name:"addtocalendar",category:"utility",domains:["*.addtocalendar.com"]},{name:"adnanny",category:"ad",domains:["*.adserver01.de"]},{name:"affilinet",category:"ad",domains:["*.reussissonsensemble.fr","*.successfultogether.co.uk"]},{name:"audioBoom",category:"social",domains:["*.audioboom.com","*.audioboo.fm"]},{name:"bPay by Barclaycard",company:"Barclays Bank",category:"utility",domains:["*.bpay.co.uk"]},{name:"bRealTime",category:"ad",domains:["*.brealtime.com"]},{name:"bd4travel",category:"analytics",domains:["*.bd4travel.com"]},{name:"bizinformation-VOID",company:"bizinformation",category:"analytics",domains:["*.bizinformation.org"]},{name:"carrot",category:"social",domains:["*.sharebutton.co"]},{name:"cloudIQ",category:"analytics",domains:["*.cloud-iq.com"]},{name:"comScore",category:"analytics",domains:["*.adxpose.com","*.comscore.com","*.sitestat.com","*.zqtk.net"]},{name:"content.ad",category:"ad",domains:["*.content.ad"]},{name:"d3 Media",company:"d3 Technologies",category:"other",domains:["*.d3sv.net"]},{name:"dexiMEDIA",category:"ad",domains:["*.deximedia.com"]},{name:"dianomi",category:"ad",domains:["*.dianomi.com","*.dianomioffers.co.uk"]},{name:"donReach",category:"social",domains:["*.donreach.com"]},{name:"dotMailer",category:"ad",domains:["*.dmtrk.com","*.dotmailer.com","*.emlfiles.com"]},{name:"dotMailer Surveys",company:"dotMailer",category:"analytics",domains:["*.dotmailer-surveys.com"]},{name:"dstillery",category:"ad",domains:["*.dstillery.com","*.media6degrees.com"]},{name:"eBay",category:"ad",domains:["*.ebay.com","*.ebayimg.com","*.fetchback.com"]},{name:"eBay Enterprise",category:"hosting",domains:["*.csdata1.com","*.gsipartners.com"]},{name:"eBuzzing",company:"Teads Managed Services",category:"ad",domains:["*.ebz.io"]},{name:"eDigital Research",category:"customer-success",domains:["*.edigitalresearch.com","*.edigitalsurvey.com","*.edrcdn.com","*.ecustomeropinions.com"]},{name:"eGain",category:"analytics",domains:["*.analytics-egain.com","*.egain.com"]},{name:"eHost",category:"hosting",domains:["*.ehosts.net"]},{name:"eKomi",category:"analytics",domains:["*.ekomi.com","*.ekomi.de"]},{name:"eWAY",company:"Web Active Pty",category:"utility",domains:["*.eway.com.au"]},{name:"eXTReMe digital",category:"analytics",domains:["*.extreme-dm.com"]},{name:"eXelate",category:"ad",domains:["*.exelator.com"]},{name:"ecommercefeed.net",category:"marketing",domains:["*.ecommercefeed.net"]},{name:"engage:BDR",category:"ad",domains:["*.bnmla.com","*.ebdr3.com"]},{name:"epago",category:"ad",domains:["*.adaos-ads.net"]},{name:"epoq internet services",category:"analytics",domains:["*.epoq.de"]},{name:"etouches",category:"hosting",domains:["*.etouches.com"]},{name:"etracker",category:"analytics",domains:["*.etracker.com","*.etracker.de"]},{name:"everestads.com",category:"content",domains:["*.verestads.net"]},{name:"exebid.DCA",company:"Data-Centric Alliance",category:"ad",domains:["*.exe.bid"]},{name:"eyeReturn Marketing",category:"marketing",domains:["*.eyereturn.com"]},{name:"feedoptimise",category:"hosting",domains:["*.feedoptimise.com","d1w78njrm56n7g.cloudfront.net"]},{name:"fifty-five",category:"ad",domains:["*.55labs.com"]},{name:"fluct",category:"ad",domains:["*.adingo.jp"]},{name:"freegeoip.net",company:"(community-funded)",category:"utility",domains:["*.freegeoip.net"]},{name:"freewheel.tv",category:"content",domains:["*.fwmrm.net"]},{name:"gnatta",category:"customer-success",domains:["*.gnatta.com"]},{name:"home.pl",category:"hosting",domains:["*.nscontext.eu"]},{name:"hyfn",category:"ad",domains:["*.hyfn.com"]},{name:"iAdvize SAS",category:"customer-success",domains:["*.iadvize.com"]},{name:"iBillboard",category:"ad",domains:["*.ibillboard.com"]},{name:"iCrossing",category:"ad",domains:["*.ic-live.com"]},{name:"iFactory",company:"RDW Group",category:"hosting",domains:["*.ifactory.com"]},{name:"iGoDigital",category:"analytics",domains:["*.igodigital.com"]},{name:"iJento",company:"Fopsha",category:"ad",domains:["*.ijento.com"]},{name:"iPage",category:"hosting",domains:["*.ipage.com"]},{name:"iPerceptions",category:"customer-success",domains:["*.iperceptions.com"]},{name:"iTunes",company:"Apple",category:"content",domains:["*.mzstatic.com"]},{name:"imgix",company:"Zebrafish Labs",category:"utility",domains:["*.imgix.net"]},{name:"infogr.am",category:"utility",domains:["*.infogr.am","*.jifo.co"]},{name:"iotec",category:"analytics",domains:["*.dsp.io"]},{name:"iovation",category:"utility",domains:["*.iesnare.com"]},{name:"ipinfo.io",category:"utility",domains:["*.ipinfo.io"]},{name:"issuu",category:"content",domains:["*.issuu.com","*.isu.pub"]},{name:"iubenda",category:"utility",domains:["*.iubenda.com"]},{name:"j2 Cloud Services",category:"ad",domains:["*.campaigner.com"]},{name:"jsonip.com",category:"analytics",domains:["*.jsonip.com"]},{name:"linkpulse",category:"analytics",domains:["*.lp4.io"]},{name:"loGo_net",category:"analytics",domains:["*.logo-net.co.uk"]},{name:"mainADV",category:"ad",domains:["*.httptrack.com","*.solocpm.com"]},{name:"mbr targeting",category:"ad",domains:["*.m6r.eu"]},{name:"media.ventive",category:"ad",domains:["*.contentspread.net"]},{name:"metrigo",category:"ad",domains:["*.metrigo.com"]},{name:"minicabit.com",category:"content",domains:["*.minicabit.com"]},{name:"mobiManage",category:"hosting",domains:["*.mobimanage.com"]},{name:"moving-pictures",category:"other",domains:["*.moving-pictures.biz","*.v6-moving-pictures.com","*.vtstat.com","*.moving-pictures.de"]},{name:"my6sense",category:"ad",domains:["*.mynativeplatform.com"]},{name:"myThings",category:"ad",domains:["*.mythings.com","*.mythingsmedia.net"]},{name:"mymovies",category:"content",domains:["*.mymovies.net"]},{name:"nRelate-VOID",company:"nRelate",category:"content",domains:["*.nrelate.com"]},{name:"nToklo",category:"analytics",domains:["*.ntoklo.com"]},{name:"neXeps",category:"ad",domains:["*.nexeps.com"]},{name:"ninemsn Pty.",category:"utility",domains:["*.ninemsn.com.au"]},{name:"nugg.ad",category:"ad",domains:["*.nuggad.net"]},{name:"numero interactive",company:"numero",category:"ad",domains:["*.numerointeractive.com"]},{name:"optMD",company:"Optimax Media Delivery",category:"ad",domains:["*.optmd.com"]},{name:"otracking.com",category:"analytics",domains:["*.otracking.com"]},{name:"paysafecard",company:"Paysafe Group",category:"utility",domains:["*.paysafecard.com"]},{name:"piano",category:"ad",domains:["*.npttech.com","*.tinypass.com"]},{name:"piclike",category:"ad",domains:["*.piclike.us"]},{name:"placehold.it",category:"utility",domains:["*.placehold.it"]},{name:"plista",category:"ad",domains:["*.plista.com"]},{name:"prebid.org",category:"utility",domains:["*.prebid.org"]},{name:"reEmbed",category:"other",domains:["*.reembed.com"]},{name:"reddit",category:"social",domains:["*.reddit.com","*.redditstatic.com"]},{name:"rewardStyle.com",category:"ad",domains:["*.rewardstyle.com"]},{name:"rss2json",category:"utility",domains:["*.rss2json.com"]},{name:"sage Pay",company:"Sage Pay Europe",category:"utility",domains:["*.sagepay.com"]},{name:"section.io",category:"utility",domains:["*.squixa.net"]},{name:"smartclip",category:"ad",domains:["*.smartclip.net"]},{name:"sovrn",category:"ad",domains:["*.lijit.com"]},{name:"stackpile.io",company:"StackPile",category:"tag-manager",domains:["*.stackpile.io"]},{name:"template-help.com",category:"hosting",domains:["*.template-help.com"]},{name:"test",company:"test only",category:"other",domains:["*.testtesttest.com"]},{name:"trueAnthem",category:"social",domains:["*.tru.am"]},{name:"tweetmeme-VOID",company:"tweetmeme",category:"analytics",domains:["*.tweetmeme.com"]},{name:"uLogin",category:"other",domains:["*.ulogin.ru"]},{name:"uLogix",category:"ad",domains:["*.ulogix.ru"]},{name:"ucfunnel ucX",company:"ucfunnel",category:"ad",domains:["*.aralego.com"]},{name:"up-value",category:"ad",domains:["*.up-value.de"]},{name:"wywy",category:"ad",domains:["*.wywy.com","*.wywyuserservice.com"]},{name:"CDK Dealer Management",company:"CDK Global",homepage:"https://www.cdkglobal.com/us",category:"hosting",domains:["*.assets-cdk.com"]},{name:"fam",company:"Fing Co Ltd.",homepage:"http://admin.fam-ad.com/report/",category:"ad",domains:["*.fam-ad.com"]},{name:"zypmedia",category:"ad",domains:["*.extend.tv"]},{name:"codigo",homepage:"https://www.codigo.se",category:"analytics",domains:["*.codigo.se"]},{name:"Playground",homepage:"https://playground.xyz",category:"ad",domains:["*.playground.xyz"]},{name:"RAM",homepage:"https://www2.rampanel.com/",category:"analytics",domains:["*.rampanel.com"]},{name:"Adition",homepage:"https://www.adition.com",category:"ad",domains:["*.adition.com"]},{name:"Widespace",homepage:"https://www.widespace.com",category:"ad",domains:["*.widespace.com"]},{name:"Colpirio",homepage:"https://www.widespace.com",category:"analytics",domains:["*.colpirio.com"]},{name:"Brandmetrics",homepage:"https://www.brandmetrics.com",category:"analytics",domains:["*.brandmetrics.com"]},{name:"EasyAd",homepage:"https://web.easy-ads.com/",category:"ad",domains:["*.easy-ads.com"]},{name:"Glimr",homepage:"https://glimr.io/",category:"analytics",domains:["*.glimr.io"]},{name:"Webtreck",homepage:"https://www.webtrekk.com/en/home/",category:"analytics",domains:["*.wcfbc.net"]},{name:"DigiTrust",homepage:"http://www.digitru.st/",category:"analytics",domains:["*.digitru.st"]},{name:"Kantar Sifo",homepage:"https://www.kantarsifo.se",category:"analytics",domains:["*.research-int.se"]},{name:"Concert",homepage:"https://concert.io/",category:"ad",domains:["*.concert.io"]},{name:"Emerse",homepage:"https://www.emerse.com/",category:"ad",domains:["*.emerse.com"]},{name:"Iterate",homepage:"https://iteratehq.com/",category:"analytics",domains:["*.iteratehq.com"]},{name:"Cookiebot",homepage:"https://www.cookiebot.com/",category:"utility",domains:["*.cookiebot.com"]},{name:"Netlify",homepage:"https://www.netlify.com/",category:"utility",domains:["*.netlify.com","*.netlifyusercontent.com"]},{name:"Scroll",homepage:"https://scroll.com/",category:"utility",domains:["*.scroll.com"]},{name:"Consumable",homepage:"https://consumable.com/",category:"ad",domains:["*.serverbid.com"]},{name:"DMD Marketing",homepage:"https://www.dmdconnects.com/",category:"ad",domains:["*.medtargetsystem.com"]},{name:"Catchpoint",homepage:"https://www.catchpoint.com/",category:"analytics",domains:["*.3gl.net"]},{name:"Terminus",homepage:"https://terminus.com/",category:"ad",domains:["*.terminus.services"]},{name:"Acceptable Ads",homepage:"https://acceptableads.com/",category:"ad",domains:["*.aaxads.com","*.aaxdetect.com"]},{name:"ClearBrain",homepage:"https://www.clearbrain.com/",category:"analytics",domains:["*.clearbrain.com"]},{name:"Optanon",homepage:"https://www.cookielaw.org/",category:"consent-provider",domains:["*.onetrust.com","*.cookielaw.org"]},{name:"TrustArc",homepage:"https://www.trustarc.com/",category:"utility",domains:["*.trustarc.com"]},{name:"iSpot.tv",homepage:"https://www.ispot.tv/",category:"ad",domains:["*.ispot.tv"]},{name:"RevJet",homepage:"https://www.revjet.com/",category:"ad",domains:["*.revjet.com"]},{name:"atlasRTX",homepage:"https://www.atlasrtx.com/",category:"customer-success",domains:["*.atlasrtx.com"]},{name:"ContactAtOnce",homepage:"https://www.contactatonce.com/",category:"customer-success",domains:["*.contactatonce.com"]},{name:"Algolia",homepage:"https://www.algolia.com/",category:"utility",domains:["*.algolianet.com","*.algolia.net","*.algolia.io"]},{name:"EMX Digital",homepage:"https://emxdigital.com",category:"ad",domains:["*.emxdgt.com"]},{name:"Moxie",homepage:"https://www.gomoxie.com/",category:"utility",domains:["*.gomoxie.solutions"]},{name:"Scripps Network Digital",homepage:"https://www.scrippsnetworksdigital.com/",category:"ad",domains:["*.snidigital.com"]},{name:"TurnTo",homepage:"https://www.turntonetworks.com/",category:"utility",domains:["*.turnto.com"]},{name:"Quantum Metric",homepage:"https://www.quantummetric.com/",category:"analytics",domains:["*.quantummetric.com"]},{name:"Carbon Ads",homepage:"https://www.carbonads.net/",category:"ad",domains:["*.carbonads.net","*.carbonads.com"]},{name:"Ably",homepage:"https://www.ably.io/",category:"utility",domains:["*.ably.io"]},{name:"Sectigo",homepage:"https://sectigo.com/",category:"utility",domains:["*.sectigo.com"]},{name:"Specless",homepage:"https://gospecless.com/",category:"ad",domains:["*.specless.tech"]},{name:"Loggly",homepage:"https://www.loggly.com/",category:"analytics",domains:["*.loggly.com","d9jmv9u00p0mv.cloudfront.net"]},{name:"Intent Media",homepage:"https://intent.com/",category:"ad",domains:["*.intentmedia.net"]},{name:"Supership",homepage:"https://supership.jp/",category:"ad",domains:["*.socdm.com"]},{name:"F@N Communications",homepage:"https://www.fancs.com/",category:"ad",domains:["*.ladsp.com"]},{name:"Vidyard",homepage:"https://www.vidyard.com/",category:"utility",domains:["*.vidyard.com"]},{name:"RapidSSL",homepage:"https://www.rapidssl.com/",category:"utility",domains:["*.rapidssl.com"]},{name:"Coherent Path",homepage:"https://coherentpath.com/",category:"utility",domains:["*.coherentpath.com"]},{name:"Attentive",homepage:"https://attentivemobile.com/",category:"ad",domains:["*.attn.tv","*.attentivemobile.com"]},{name:"emetriq",homepage:"https://www.emetriq.com/",category:"ad",domains:["*.emetriq.de","*.xplosion.de"]},{name:"Bonzai",homepage:"https://www.bonzai.co/",category:"ad",domains:["*.bonzai.co"]},{name:"Freshchat",homepage:"https://www.freshworks.com/live-chat-software/",category:"customer-success",domains:["*.freshchat.com","*.freshworksapi.com"],products:[{name:"Freshdesk Messaging",urlPatterns:["wchat.freshchat.com"],facades:[{name:"Freshdesk Messaging (formerly Freshchat) Facade",repo:"https://github.com/coliff/freshdesk-messaging-facade/"}]}]},{name:"Contentful",homepage:"https://www.contentful.com/",category:"utility",domains:["*.contentful.com"]},{name:"PureCars",homepage:"https://www.purecars.com/",category:"marketing",domains:["*.purecars.com"]},{name:"Tray Commerce",homepage:"https://www.tray.com.br/",category:"marketing",domains:["*.tcdn.com.br"]},{name:"AdScore",homepage:"https://www.adscore.com/",category:"ad",domains:["*.adsco.re"]},{name:"WebsiteBuilder.com",homepage:"https://www.websitebuilder.com",category:"hosting",domains:["*.mywebsitebuilder.com"]},{name:"mParticle",homepage:"https://www.mparticle.com/",category:"utility",domains:["*.mparticle.com"]},{name:"Ada",homepage:"https://www.ada.support/",category:"customer-success",domains:["*.ada.support"]},{name:"Quora Ads",homepage:"https://www.quora.com/business/",category:"ad",domains:["*.quora.com"]},{name:"Auth0",homepage:"https://auth0.com/",category:"utility",domains:["*.auth0.com"]},{name:"Bridgewell DSP",homepage:"https://www.bridgewell.com/",category:"ad",domains:["*.scupio.com"]},{name:"Wicked Reports",homepage:"https://www.wickedreports.com/",category:"marketing",domains:["*.wickedreports.com"]},{name:"Jaywing",homepage:"https://jaywing.com/",category:"marketing",domains:["*.jaywing.com"]},{name:"Holimetrix",homepage:"https://u360.d-bi.fr/",category:"marketing",domains:["*.d-bi.fr"]},{name:"iZooto",homepage:"https://www.izooto.com",category:"marketing",domains:["*.izooto.com"]},{name:"Ordergroove",homepage:"https://www.ordergroove.com/",category:"marketing",domains:["*.ordergroove.com"]},{name:"PageSense",homepage:"https://www.zoho.com/pagesense/",category:"analytics",domains:["*.pagesense.io"]},{name:"Vizzit",homepage:"https://www.vizzit.se",category:"analytics",domains:["*.vizzit.se"]},{name:"Click Guardian",homepage:"https://www.clickguardian.co.uk/",category:"ad",domains:["*.clickguardian.app","*.clickguardian.co.uk"]},{name:"Smartsupp",company:"Smartsupp.com",homepage:"https://www.smartsupp.com",category:"customer-success",domains:["*.smartsuppchat.com","*.smartsupp.com","smartsupp-widget-161959.c.cdn77.org","*.smartsuppcdn.com"]},{name:"Smartlook",company:"Smartsupp.com",homepage:"https://www.smartlook.com/",category:"analytics",domains:["*.smartlook.com"]},{name:"Luigis Box",company:"Luigis Box",homepage:"https://www.luigisbox.com/",category:"utility",domains:["*.luigisbox.com"]},{name:"Targito",company:"VIVmail.cz",homepage:"https://www.targito.com",category:"marketing",domains:["*.targito.com"]},{name:"Foxentry",company:"AVANTRO",homepage:"https://foxentry.cz/",category:"utility",domains:["*.foxentry.cz"]},{name:"Pendo",homepage:"https://www.pendo.io",category:"analytics",domains:["*.pendo.io"]},{name:"Braze",homepage:"https://www.braze.com",category:"analytics",domains:["*.appboycdn.com"]},{name:"Usersnap",homepage:"https://usersnap.com",category:"customer-success",domains:["*.usersnap.com"]},{name:"Rewardful",homepage:"https://www.getrewardful.com",category:"analytics",domains:["*.wdfl.co"]},{name:"Launch Darkly",homepage:"https://launchdarkly.com",category:"utility",domains:["*.launchdarkly.com"]},{name:"Statuspage",company:"Atlassian",homepage:"https://www.statuspage.io",category:"utility",domains:["*.statuspage.io"]},{name:"HyperInzerce",homepage:"https://hyperinzerce.cz",category:"ad",domains:["*.hyperinzerce.cz"]},{name:"POWr",homepage:"https://www.powr.io",category:"utility",domains:["*.powr.io"]},{name:"Coral",company:"Coral",homepage:"https://coralproject.net",category:"content",domains:["*.coral.coralproject.net"]},{name:"Bolt",homepage:"https://www.bolt.com/",category:"utility",domains:["*.bolt.com"]},{name:"Judge.me",homepage:"https://judge.me/",category:"marketing",domains:["*.judge.me"]},{name:"Tilda",homepage:"https://tilda.cc/",category:"hosting",domains:["*.tildacdn.com"]},{name:"SalesLoft",homepage:"https://salesloft.com/",category:"marketing",domains:["*.salesloft.com"]},{name:"Accessibe Accessibility Overlay",company:"Accessibe",homepage:"https://accessibe.com/",category:"utility",domains:["*.accessibe.com","*.acsbapp.com","*.acsbap.com"]},{name:"Builder",homepage:"https://www.builder.io/",category:"hosting",domains:["*.builder.io"]},{name:"Pepperjam",homepage:"https://www.pepperjam.com/",category:"marketing",domains:["*.pepperjam.com","*.affiliatetechnology.com"]},{name:"Reach",homepage:"https://withreach.com/",category:"utility",domains:["*.gointerpay.net"]},{name:"Chameleon",homepage:"https://www.trychameleon.com/",category:"marketing",domains:["*.trychameleon.com"]},{name:"Matomo",company:"InnoCraft",homepage:"https://matomo.org/",category:"analytics",domains:["*.matomo.cloud"]},{name:"Segmanta",homepage:"https://segmanta.com/",category:"marketing",domains:["*.segmanta.com"]},{name:"Podsights",homepage:"https://podsights.com/",category:"marketing",domains:["*.pdst.fm","us-central1-adaptive-growth.cloudfunctions.net"]},{name:"Chatwoot",homepage:"https://www.chatwoot.com/",category:"customer-success",domains:["*.chatwoot.com"]},{name:"Crisp",homepage:"https://crisp.chat/",category:"customer-success",domains:["*.crisp.chat"]},{name:"Admiral CMP",homepage:"https://www.getadmiral.com",category:"consent-provider",domains:["admiral.mgr.consensu.org","*.admiral.mgr.consensu.org"]},{name:"Adnuntius CMP",homepage:"https://adnuntius.com",category:"consent-provider",domains:["adnuntiusconsent.mgr.consensu.org","*.adnuntiusconsent.mgr.consensu.org"]},{name:"Clickio CMP",homepage:"https://clickio.com",category:"consent-provider",domains:["clickio.mgr.consensu.org","*.clickio.mgr.consensu.org"]},{name:"AppConsent CMP",homepage:"https://appconsent.io/en",category:"consent-provider",domains:["appconsent.mgr.consensu.org","*.appconsent.mgr.consensu.org"]},{name:"DMG Media CMP",homepage:"https://www.dmgmedia.co.uk",category:"consent-provider",domains:["dmgmedia.mgr.consensu.org","*.dmgmedia.mgr.consensu.org"]},{name:"Axel Springer CMP",homepage:"https://www.axelspringer.com",category:"consent-provider",domains:["axelspringer.mgr.consensu.org","*.axelspringer.mgr.consensu.org"]},{name:"Bedrock CMP",homepage:"https://www.bedrockstreaming.com",category:"consent-provider",domains:["bedrock.mgr.consensu.org","*.bedrock.mgr.consensu.org"]},{name:"BMIND CMP",homepage:"https://www.bmind.es",category:"consent-provider",domains:["bmind.mgr.consensu.org","*.bmind.mgr.consensu.org"]},{name:"Borlabs CMP",homepage:"https://borlabs.io",category:"consent-provider",domains:["borlabs.mgr.consensu.org","*.borlabs.mgr.consensu.org"]},{name:"Civic CMP",homepage:"https://www.civicuk.com",category:"consent-provider",domains:["cookiecontrol.mgr.consensu.org","*.cookiecontrol.mgr.consensu.org"]},{name:"Commanders Act CMP",homepage:"https://www.commandersact.com",category:"consent-provider",domains:["commandersact.mgr.consensu.org","*.commandersact.mgr.consensu.org"]},{name:"Complianz CMP",homepage:"https://complianz.io/",category:"consent-provider",domains:["complianz.mgr.consensu.org","*.complianz.mgr.consensu.org"]},{name:"Consent Desk CMP",homepage:"https://www.consentdesk.com/",category:"consent-provider",domains:["consentdesk.mgr.consensu.org","*.consentdesk.mgr.consensu.org"]},{name:"Consent Manager CMP",homepage:"https://consentmanager.net",category:"consent-provider",domains:["consentmanager.mgr.consensu.org","*.consentmanager.mgr.consensu.org"]},{name:"Conversant CMP",homepage:"https://www.conversantmedia.eu/",category:"consent-provider",domains:["conversant.mgr.consensu.org","*.conversant.mgr.consensu.org"]},{name:"Cookie Information CMP",homepage:"https://www.cookieinformation.com/",category:"consent-provider",domains:["cookieinformation.mgr.consensu.org","*.cookieinformation.mgr.consensu.org"]},{name:"Cookiebot CMP",homepage:"https://www.cookiebot.com",category:"consent-provider",domains:["cookiebot.mgr.consensu.org","*.cookiebot.mgr.consensu.org"]},{name:"Truendo CMP",homepage:"https://truendo.com/",category:"consent-provider",domains:["truendo.mgr.consensu.org","*.truendo.mgr.consensu.org"]},{name:"Dentsu CMP",homepage:"https://www.dentsuaegisnetwork.de/",category:"consent-provider",domains:["dan.mgr.consensu.org","*.dan.mgr.consensu.org"]},{name:"Didomi CMP",homepage:"https://www.didomi.io/en/",category:"consent-provider",domains:["didomi.mgr.consensu.org","*.didomi.mgr.consensu.org"]},{name:"Ensighten CMP",homepage:"https://www.ensighten.com/",category:"consent-provider",domains:["ensighten.mgr.consensu.org","*.ensighten.mgr.consensu.org"]},{name:"Evidon CMP",homepage:"https://evidon.com",category:"consent-provider",domains:["evidon.mgr.consensu.org","*.evidon.mgr.consensu.org"]},{name:"Ezoic CMP",homepage:"https://www.ezoic.com/",category:"consent-provider",domains:["ezoic.mgr.consensu.org","*.ezoic.mgr.consensu.org"]},{name:"Gemius CMP",homepage:"https://www.gemius.com",category:"consent-provider",domains:["gemius.mgr.consensu.org","*.gemius.mgr.consensu.org"]},{name:"NitroPay CMP",homepage:"https://nitropay.com/",category:"consent-provider",domains:["nitropay.mgr.consensu.org","*.nitropay.mgr.consensu.org"]},{name:"Google FundingChoices",homepage:"https://fundingchoices.google.com/start/",category:"consent-provider",domains:["fundingchoices.mgr.consensu.org","*.fundingchoices.mgr.consensu.org","fundingchoicesmessages.google.com","*.fundingchoicesmessages.google.com"]},{name:"Gravito CMP",homepage:"https://www.gravito.net/",category:"consent-provider",domains:["gravito.mgr.consensu.org","*.gravito.mgr.consensu.org"]},{name:"ID Ward CMP",homepage:"https://id-ward.com/enterprise",category:"consent-provider",domains:["idward.mgr.consensu.org","*.idward.mgr.consensu.org"]},{name:"iubenda CMP",homepage:"https://www.iubenda.com",category:"consent-provider",domains:["iubenda.mgr.consensu.org","*.iubenda.mgr.consensu.org"]},{name:"Jump CMP",homepage:"https://jumpgroup.it/",category:"consent-provider",domains:["avacy.mgr.consensu.org","*.avacy.mgr.consensu.org"]},{name:"LiveRamp CMP",homepage:"https://liveramp.com/",category:"consent-provider",domains:["faktor.mgr.consensu.org","*.faktor.mgr.consensu.org"]},{name:"Madvertise CMP",homepage:"https://madvertise.com/en/",category:"consent-provider",domains:["madvertise.mgr.consensu.org","*.madvertise.mgr.consensu.org"]},{name:"Mairdumont Netletic CMP",homepage:"https://www.mairdumont-netletix.com/",category:"consent-provider",domains:["mdnxmp.mgr.consensu.org","*.mdnxmp.mgr.consensu.org"]},{name:"Marfeel CMP",homepage:"https://www.marfeel.com/",category:"consent-provider",domains:["marfeel.mgr.consensu.org","*.marfeel.mgr.consensu.org"]},{name:"Mediavine CMP",homepage:"https://www.mediavine.com/",category:"consent-provider",domains:["mediavine.mgr.consensu.org","*.mediavine.mgr.consensu.org"]},{name:"ConsentServe CMP",homepage:"https://www.consentserve.com/",category:"consent-provider",domains:["consentserve.mgr.consensu.org","*.consentserve.mgr.consensu.org"]},{name:"Next14 CMP",homepage:"https://www.next14.com/",category:"consent-provider",domains:["next14.mgr.consensu.org","*.next14.mgr.consensu.org"]},{name:"AdRoll CMP",homepage:"https://www.adroll.com/",category:"consent-provider",domains:["adroll.mgr.consensu.org","*.adroll.mgr.consensu.org"]},{name:"Ogury CMP",homepage:"https://www.ogury.com/",category:"consent-provider",domains:["ogury.mgr.consensu.org","*.ogury.mgr.consensu.org"]},{name:"OneTag CMP",homepage:"https://onetag.net",category:"consent-provider",domains:["onetag.mgr.consensu.org","*.onetag.mgr.consensu.org"]},{name:"OneTrust CMP",homepage:"https://onetrust.com",category:"consent-provider",domains:["onetrust.mgr.consensu.org","*.onetrust.mgr.consensu.org"]},{name:"optAd360 CMP",homepage:"https://www.optad360.com/",category:"consent-provider",domains:["optad360.mgr.consensu.org","*.optad360.mgr.consensu.org"]},{name:"Osano CMP",homepage:"https://www.osano.com",category:"consent-provider",domains:["osano.mgr.consensu.org","*.osano.mgr.consensu.org"]},{name:"Playwire CMP",homepage:"https://www.playwire.com",category:"consent-provider",domains:["playwire.mgr.consensu.org","*.playwire.mgr.consensu.org"]},{name:"Pulselive CMP",homepage:"https://www.pulselive.com",category:"consent-provider",domains:["pulselive.mgr.consensu.org","*.pulselive.mgr.consensu.org"]},{name:"Quantcast Choice",homepage:"https://quantcast.com",category:"consent-provider",domains:["quantcast.mgr.consensu.org","*.quantcast.mgr.consensu.org"]},{name:"RCS Pubblicita CMP",homepage:"http://www.rcspubblicita.it/site/home.html",category:"consent-provider",domains:["rcsmediagroup.mgr.consensu.org","*.rcsmediagroup.mgr.consensu.org"]},{name:"Rich Audience CMP",homepage:"https://richaudience.com",category:"consent-provider",domains:["richaudience.mgr.consensu.org","*.richaudience.mgr.consensu.org"]},{name:"Ringier Axel Springer CMP",homepage:"https://www.ringieraxelspringer.pl/en/home/",category:"consent-provider",domains:["rasp.mgr.consensu.org","*.rasp.mgr.consensu.org"]},{name:"Secure Privacy CMP",homepage:"https://secureprivacy.ai/",category:"consent-provider",domains:["secureprivacy.mgr.consensu.org","*.secureprivacy.mgr.consensu.org"]},{name:"Securiti CMP",homepage:"https://securiti.ai/",category:"consent-provider",domains:["securiti.mgr.consensu.org","*.securiti.mgr.consensu.org"]},{name:"Seznam.cz CMP",homepage:"https://www.seznam.cz/",category:"consent-provider",domains:["seznam.mgr.consensu.org","*.seznam.mgr.consensu.org"]},{name:"ShareThis CMP",homepage:"https://sharethis.com",category:"consent-provider",domains:["sharethis.mgr.consensu.org","*.sharethis.mgr.consensu.org"]},{name:"ShinyStat CMP",homepage:"https://www.shinystat.com",category:"consent-provider",domains:["shinystat.mgr.consensu.org","*.shinystat.mgr.consensu.org"]},{name:"Sibbo CMP",homepage:"https://sibboventures.com/en/",category:"consent-provider",domains:["sibboventures.mgr.consensu.org","*.sibboventures.mgr.consensu.org"]},{name:"Singlespot CMP",homepage:"https://www.singlespot.com/en",category:"consent-provider",domains:["singlespot.mgr.consensu.org","*.singlespot.mgr.consensu.org"]},{name:"Sirdata CMP",homepage:"https://www.sirdata.com",category:"consent-provider",domains:["sddan.mgr.consensu.org","*.sddan.mgr.consensu.org"]},{name:"Snigel CMP",homepage:"https://snigel.com",category:"consent-provider",domains:["snigelweb.mgr.consensu.org","*.snigelweb.mgr.consensu.org"]},{name:"Sourcepoint CMP",homepage:"https://sourcepoint.com",category:"consent-provider",domains:["sourcepoint.mgr.consensu.org","*.sourcepoint.mgr.consensu.org"]},{name:"Pubtech CMP",homepage:"https://www.pubtech.ai/",category:"consent-provider",domains:["pubtech.mgr.consensu.org","*.pubtech.mgr.consensu.org"]},{name:"AdMetrics Pro CMP",homepage:"https://admetricspro.com",category:"consent-provider",domains:["cmp.mgr.consensu.org","*.cmp.mgr.consensu.org"]},{name:"Traffective CMP",homepage:"https://traffective.com",category:"consent-provider",domains:["traffective.mgr.consensu.org","*.traffective.mgr.consensu.org"]},{name:"UniConsent CMP",homepage:"https://uniconsent.com",category:"consent-provider",domains:["uniconsent.mgr.consensu.org","*.uniconsent.mgr.consensu.org"]},{name:"TrustArc CMP",homepage:"https://trustarc.com/",category:"consent-provider",domains:["trustarc.mgr.consensu.org","*.trustarc.mgr.consensu.org"]},{name:"Usercentrics CMP",homepage:"https://usercentrics.com",category:"consent-provider",domains:["usercentrics.mgr.consensu.org","*.usercentrics.mgr.consensu.org","*.usercentrics.eu","*.services.usercentrics.eu"]},{name:"WebAds CMP",homepage:"https://www.webads.nl/",category:"consent-provider",domains:["webads.mgr.consensu.org","*.webads.mgr.consensu.org"]},{name:"Trustcommander",company:"Commandersact",homepage:"https://www.commandersact.com",category:"consent-provider",domains:["*.trustcommander.net"]},{name:"Hubvisor",homepage:"https://www.hubvisor.io",category:"ad",domains:["*.hubvisor.io"]},{name:"Castle",homepage:"https://castle.io",category:"utility",domains:["*.castle.io","d2t77mnxyo7adj.cloudfront.net"]},{name:"Wigzo",homepage:"https://www.wigzo.com/",category:"marketing",domains:["*.wigzo.com","*.wigzopush.com"]},{name:"Convertful",homepage:"https://convertful.com/",category:"marketing",domains:["*.convertful.com"]},{name:"OpenLink",company:"MediaWallah",homepage:"https://www.mediawallah.com/",category:"ad",domains:["*.mediawallahscript.com"]},{name:"TPMN",company:"TPMN",homepage:"http://tpmn.io/",category:"ad",domains:["*.tpmn.co.kr"]},{name:"HERO",company:"Klarna",homepage:"https://www.usehero.com/",category:"customer-success",domains:["*.usehero.com"]},{name:"Zync",company:"Zeta Global",homepage:"https://zetaglobal.com/",category:"marketing",domains:["*.rezync.com"]},{name:"AdFuel Video",company:"AdFuel",homepage:"https://goadfuel.com/",category:"ad",domains:["*.videoplayerhub.com"]},{name:"Prefix Box AI Search",company:"Prefix Box",homepage:"https://www.prefixbox.com/",category:"utility",domains:["*.prefixbox.com"]},{name:"SpeedSize Service Worker",company:"SpeedSize",homepage:"https://speedsize.com/",category:"utility",domains:["di6367dava8ow.cloudfront.net","d2d22nphq0yz8t.cloudfront.net"]},{name:"Vonage Video API",company:"Vonage",homepage:"https://www.vonage.com/communications-apis/video/",category:"video",domains:["*.opentok.com"]},{name:"Checkout.com",company:"Checkout.com",homepage:"https://www.checkout.com",category:"utility",domains:["*.checkout.com"]},{name:"Noibu",company:"Noibu",homepage:"https://www.noibu.com",category:"utility",domains:["*.noibu.com"]},{name:"Clarity",company:"Microsoft",homepage:"https://clarity.microsoft.com/",category:"utility",domains:["*.clarity.ms"]},{name:"goinstore",company:"Emplifi",homepage:"https://goinstore.com/",category:"customer-success",domains:["*.goinstore.com"]},{name:"SegmentStream",company:"SegmentStream",homepage:"https://segmentstream.com/",category:"marketing",domains:["*.segmentstream.com"]},{name:"Amazon Associates",company:"Amazon",homepage:"https://affiliate-program.amazon.co.uk/",category:"marketing",domains:["*.associates-amazon.com"]},{name:"DotMetrics",company:"Ipsos",homepage:"https://www.dotmetrics.net/",category:"analytics",domains:["*.dotmetrics.net"]},{name:"Truffle Bid",company:"Truffle",homepage:"https://truffle.bid/",category:"ad",domains:["*.truffle.bid"]},{name:"Hybrid",company:"Hybrid",homepage:"https://hybrid.ai/",category:"ad",domains:["*.hybrid.ai"]},{name:"AdMan Media",company:"AdMan",homepage:"https://admanmedia.com/",category:"video",domains:["*.admanmedia.com"]},{name:"ID5 Identity Cloud",company:"ID5",homepage:"https://id5.io/",category:"ad",domains:["id5-sync.com","*.id5-sync.com"]},{name:"Audience Rate",company:"Audience Rate Limited",homepage:"https://www.audiencerate.com/",category:"ad",domains:["*.audrte.com"]},{name:"Seedtag",company:"Seedtag Advertising",homepage:"https://www.seedtag.com/",category:"ad",domains:["*.seedtag.com"]},{name:"IVI",company:"IVI Technologies",homepage:"http://ivitechnologies.com/",category:"ad",domains:["*.ivitrack.com"]},{name:"Sportradar",company:"Sportradar",homepage:"https://www.sportradar.com/",category:"ad",domains:["*.sportradarserving.com"]},{name:"ZEOTAP",company:"ZEOTAP",homepage:"https://zeotap.com/",category:"ad",domains:["*.zeotap.com"]},{name:"Web Content Assessor",company:"TMT Digital",homepage:"https://mediatrust.com/",category:"ad",domains:["*.webcontentassessor.com"]},{name:"Genie",company:"Media Force",homepage:"https://hellogenie.com/",category:"ad",domains:["*.mfadsrvr.com"]},{name:"mediarithmics",company:"mediarithmics",homepage:"https://www.mediarithmics.com/",category:"ad",domains:["*.mediarithmics.com"]},{name:"Ozone Project",company:"The Ozone Project",homepage:"https://www.ozoneproject.com/",category:"ad",domains:["*.the-ozone-project.com"]},{name:"FiftyAurora",company:"Fifty",homepage:"https://fifty.io/",category:"ad",domains:["*.fiftyt.com"]},{name:"smadex",company:"entravision",homepage:"https://smadex.com/",category:"ad",domains:["*.smadex.com"]},{name:"AWX",company:"Trinity Mirror",category:"ad",domains:["*.tm-awx.com"]},{name:"XPO",company:"Knorex",category:"ad",homepage:"https://www.knorex.com/",domains:["*.brand-display.com"]},{name:"Viafoura",company:"Viafoura",category:"ad",homepage:"https://viafoura.com/",domains:["*.viafoura.co","*.viafoura.net"]},{name:"Adnami",company:"Adnami",category:"ad",homepage:"https://www.adnami.io/",domains:["*.adnami.io"]},{name:"LiveRamp Privacy Manager",company:"LiveRamp",category:"ad",homepage:"https://liveramp.com/privacy-legal-compliance/",domains:["*.privacymanager.io"]},{name:"Onfocus",company:"Onfocus SAS",category:"ad",domains:["*.4dex.io"]},{name:"viewTag",company:"Advanced Store",category:"ad",domains:["*.ad4m.at"]},{name:"MRP Prelytics",company:"Market Resource Partners",category:"ad",homepage:"https://www.mrpfd.com/",domains:["*.mrpdata.net"]},{name:"iPROM",company:"iPROM",category:"ad",homepage:"https://iprom.eu/",domains:["*.iprom.net"]},{name:"Plausible",company:"Plausible",homepage:"https://plausible.io/",category:"analytics",domains:["*.plausible.io"]},{name:"Micro Analytics",company:"Micro Analytics",homepage:"https://microanalytics.io/",category:"analytics",domains:["padmin.microanalytics.io","www.microanalytics.io","dev.microanalytics.io","status.microanalytics.io"]},{name:"Scale8",company:"Scale8",homepage:"https://scale8.com/",category:"analytics",domains:["www.scale8.com","api-dev.scale8.com","cdn.scale8.com","ui.scale8.com"]},{name:"Cabin",company:"Cabin",homepage:"https://withcabin.com/",category:"analytics",domains:["*.withcabin.com"]},{name:"Appcues",company:"Appcues",homepage:"https://www.appcues.com/",category:"analytics",domains:["*.appcues.com"]},{name:"Fathom Analytics",company:"Fathom",homepage:"https://usefathom.com/",category:"analytics",domains:["*.usefathom.com"]}]})),ku=l(((e,t)=>{J();var{createAPIFromDataset:a}=Su(),n=Cu();t.exports=a(n)})),xu=l(((e,t)=>{J(),t.exports=ku()}));function Au(e){return Nu.default.getEntity(e)}function _u(e){return Nu.default.getProduct(e)}function Ru(e,t){let a=Au(e);return!(!a||a===t)}function Fu(e,t){return!Ru(e,t)}var Nu,Iu,Mu,Pu,Lu,Ou,ju=s((()=>{J(),Nu=d(xu(),1),o(Au,"getEntity"),o(_u,"getProduct"),o(Ru,"isThirdParty"),o(Fu,"isFirstParty"),Iu={getEntity:Au,getProduct:_u,isThirdParty:Ru,isFirstParty:Fu}})),Uu=s((()=>{J(),Bc(),Yc(),kr(),ql(),ju(),Mu=class e{static{o(this,"EntityClassification")}static makeupChromeExtensionEntity_(e,t,a){let n=br.getChromeExtensionOrigin(t),r=new URL(n).host,i=a||r,o=e.get(n);if(o)return o;let s={name:i,company:i,category:"Chrome Extension",homepage:"https://chromewebstore.google.com/detail/"+r,categories:[],domains:[],averageExecutionTime:0,totalExecutionTime:0,totalOccurrences:0};return e.set(n,s),s}static _makeUpAnEntity(t,a){if(!Ml.isValid(a))return;let n=br.createOrReturnURL(a);if("chrome-extension:"===n.protocol)return e.makeupChromeExtensionEntity_(t,a);if(!n.protocol.startsWith("http"))return;let r=br.getRootDomain(a);if(!r)return;if(t.has(r))return t.get(r);let i={name:r,company:r,category:"",categories:[],domains:[r],averageExecutionTime:0,totalExecutionTime:0,totalOccurrences:0,isUnrecognized:!0};return t.set(r,i),i}static _preloadChromeExtensionsToCache(t,a){for(let n of a.values()){if("Runtime.executionContextCreated"!==n.method)continue;let a=n.params.context.origin;a.startsWith("chrome-extension:")&&(t.has(a)||e.makeupChromeExtensionEntity_(t,a,n.params.context.name))}}static async compute_(t,a){let n=await Pc.request(t.devtoolsLog,a),r=new Map,i=new Map,s=new Map;e._preloadChromeExtensionsToCache(r,t.devtoolsLog);for(let t of n){let{url:a}=t;if(i.has(a))continue;let n=Iu.getEntity(a)||e._makeUpAnEntity(r,a);if(!n)continue;let o=s.get(n)||new Set;o.add(a),s.set(n,o),i.set(a,n)}let l=t.URL.mainDocumentUrl||t.URL.finalDisplayedUrl,c=Iu.getEntity(l)||e._makeUpAnEntity(r,l);function u(e){return i.get(e)===c}return o(u,"isFirstParty"),{entityByUrl:i,urlsByEntity:s,firstParty:c,isFirstParty:u}}},Pu=dc(Mu,["URL","devtoolsLog"])})),Bu=s((()=>{J(),ua(),ka(),ea(),Lu=d(lr(),1),Ar(),xr(),Mi(),uo(),cu(),Du(),Tu(),xl(),Xi(),oi(),Uu(),ql(),Ou=class e{static{o(this,"Runner")}static async audit(t,a){let{resolvedConfig:n,computedCache:r}=a,i=n.settings;try{let a={msg:"Audit phase",id:"lh:runner:audit"};Kt.time(a,"verbose");let o=[];if(i.gatherMode&&!i.auditMode)return;if(!n.audits)throw new Error("No audits to evaluate.");let s=await e._runAudits(i,n.audits,t,o,r),l={msg:"Generating results...",id:"lh:runner:generate"};Kt.time(l),t.LighthouseRunWarnings&&o.push(...t.LighthouseRunWarnings);let c={"axe-core":t.Accessibility?.version},u={};n.categories&&(u=Tr.scoreAllCategories(n.categories,s)),Kt.timeEnd(l),Kt.timeEnd(a);let d=t.FullPageScreenshot;(n.settings.disableFullPageScreenshot||d instanceof Error)&&(d=void 0);let m={lighthouseVersion:Ii,requestedUrl:t.URL.requestedUrl,mainDocumentUrl:t.URL.mainDocumentUrl,finalDisplayedUrl:t.URL.finalDisplayedUrl,finalUrl:t.URL.mainDocumentUrl,fetchTime:t.fetchTime,gatherMode:t.GatherContext.gatherMode,runtimeError:e.getArtifactRuntimeError(t),runWarnings:o,userAgent:t.HostUserAgent,environment:{networkUserAgent:t.NetworkUserAgent,hostUserAgent:t.HostUserAgent,benchmarkIndex:t.BenchmarkIndex,benchmarkIndexes:t.BenchmarkIndexes,credits:c},audits:s,configSettings:i,categories:u,categoryGroups:n.groups||void 0,stackPacks:io(t.Stacks),entities:await e.getEntityClassification(t,{computedCache:r}),fullPageScreenshot:d,timing:this._getTiming(t),i18n:{rendererFormattedStrings:fi(i.locale),icuMessagePaths:{}}};m.i18n.icuMessagePaths=wi(m,i.locale);let p=m;if(i.auditMode){tu(p,e._getDataSavePath(i))}return{lhr:p,artifacts:t,report:wu.generateReport(p,i.output)}}catch(t){throw e.createRunnerError(t,i)}}static async getEntityClassification(e,t){let a=e.devtoolsLogs?.[Dr.DEFAULT_PASS];if(!a)return;let n=await Pu.request({URL:e.URL,devtoolsLog:a},t),r=[];for(let[e,t]of n.urlsByEntity){let a=new Set;for(let e of t){let t=Ml.getOrigin(e);t&&a.add(t)}let i={name:e.name,homepage:e.homepage,origins:[...a]};e===n.firstParty&&(i.isFirstParty=!0),e.isUnrecognized&&(i.isUnrecognized=!0),e.category&&(i.category=e.category),r.push(i)}return r}static async gather(t,a){let n=a.resolvedConfig.settings;try{let e,r=vu.getContext();if(vu.captureBreadcrumb({message:"Run started",category:"lifecycle",data:r}),n.auditMode&&!n.gatherMode){e=Xc(this._getDataSavePath(n))}else{let r={msg:"Gather phase",id:"lh:runner:gather"};if(Kt.time(r,"verbose"),e=await t({resolvedConfig:a.resolvedConfig}),Kt.timeEnd(r),e.Timing=Kt.takeTimeEntries(),n.gatherMode){let t=this._getDataSavePath(n);await eu(e,t)}}return e}catch(t){throw e.createRunnerError(t,n)}}static createRunnerError(e,t){return e.friendlyMessage&&(e.friendlyMessage=vi(e.friendlyMessage,t.locale)),vu.captureException(e,{level:"fatal"}),e}static _getTiming(e){let t=[...e.Timing||[],...Kt.takeTimeEntries()].map((e=>[`${e.startTime}-${e.name}-${e.duration}`,e])),a=Array.from(new Map(t).values()).map((e=>({startTime:parseFloat(e.startTime.toFixed(2)),name:e.name,duration:parseFloat(e.duration.toFixed(2)),entryType:e.entryType}))).sort(((e,t)=>e.startTime-t.startTime)),n=a.find((e=>"lh:runner:gather"===e.name)),r=a.find((e=>"lh:runner:audit"===e.name));return{entries:a,total:(n?.duration||0)+(r?.duration||0)}}static async _runAudits(t,a,n,r,i){let o={msg:"Analyzing and running audits...",id:"lh:runner:auditing"};if(Kt.time(o),n.settings){let e={locale:void 0,gatherMode:void 0,auditMode:void 0,output:void 0,channel:void 0,budgets:void 0},a=Object.assign({},n.settings,e),r=Object.assign({},t,e),i=new Set([...Object.keys(a),...Object.keys(r)]);for(let e of i)if(!(0,Lu.default)(a[e],r[e]))throw new Error(`Cannot change settings between gathering and auditing. Difference found at: ${e}`);if(!(0,Lu.default)(a,r))throw new Error("Cannot change settings between gathering and auditing")}let s={settings:t,computedCache:i},l={};for(let t of a){let a=t.implementation.meta.id,i=await e._runAudit(t,n,s,r);l[a]=i}return Kt.timeEnd(o),l}static async _runAudit(e,t,a,n){let r,i=e.implementation,o={msg:`Auditing: ${vi(i.meta.title,"en-US")}`,id:`lh:audit:${i.meta.id}`};Kt.time(o);try{if(t.PageLoadError)throw t.PageLoadError;for(let e of i.meta.requiredArtifacts){let a=void 0===t[e],n="traces"===e&&!t.traces[Dr.DEFAULT_PASS],r="devtoolsLogs"===e&&!t.devtoolsLogs[Dr.DEFAULT_PASS];if(a||n||r)throw Kt.warn("Runner",`${e} gatherer, required by audit ${i.meta.id}, did not run.`),new El(El.errors.MISSING_REQUIRED_ARTIFACT,{artifactName:e});if(t[e]instanceof Error){let a=t[e];Kt.warn("Runner",`${e} gatherer, required by audit ${i.meta.id}, encountered an error: ${a.message}`);let n=new El(El.errors.ERRORED_REQUIRED_ARTIFACT,{artifactName:e,errorMessage:a.message},{cause:a});throw n.expected=!0,n}}let o={options:Object.assign({},i.defaultOptions,e.options),...a},s=i.meta.requiredArtifacts.concat(i.meta.__internalOptionalArtifacts||[]).reduce(((e,a)=>{let n=t[a];return e[a]=n,e}),{}),l=await i.audit(s,o);n.push(...l.runWarnings||[]),r=Dr.generateAuditResult(i,l)}catch(e){"MISSING_REQUIRED_ARTIFACT"!==e.code&&"ERRORED_REQUIRED_ARTIFACT"!==e.code&&Kt.warn(i.meta.id,`Caught exception: ${e.message}`),vu.captureException(e,{tags:{audit:i.meta.id},level:"error"});let t=e.friendlyMessage?e.friendlyMessage:e.message,a=e.cause?.stack??e.stack;r=Dr.generateErrorAuditResult(i,t,a)}return Kt.timeEnd(o),r}static getArtifactRuntimeError(e){let t=[e.PageLoadError,...Object.values(e)];for(let e of t)if(e instanceof El&&e.lhrRuntimeError){let t=e.friendlyMessage||e.message;return{code:e.code,message:t}}}static getAuditList(){let e=["audit.js","violation-audit.js","accessibility/axe-audit.js","multi-check-audit.js","byte-efficiency/byte-efficiency-audit.js","manual/manual-audit.js"];return["accessibility","audit.js","autocomplete.js","bf-cache.js","bootup-time.js","byte-efficiency","content-width.js","critical-request-chains.js","csp-xss.js","deprecations.js","diagnostics.js","dobetterweb","errors-in-console.js","final-screenshot.js","font-display.js","image-aspect-ratio.js","image-size-responsive.js","installable-manifest.js","is-on-https.js","largest-contentful-paint-element.js","layout-shift-elements.js","lcp-lazy-loaded.js","long-tasks.js","main-thread-tasks.js","mainthread-work-breakdown.js","manual","maskable-icon.js","metrics","metrics.js","multi-check-audit.js","network-requests.js","network-rtt.js","network-server-latency.js","no-unload-listeners.js","non-composited-animations.js","oopif-iframe-test-audit.js","performance-budget.js","predictive-perf.js","preload-fonts.js","prioritize-lcp-image.js","redirects.js","screenshot-thumbnails.js","script-elements-test-audit.js","script-treemap-data.js","seo","server-response-time.js","splash-screen.js","themed-omnibox.js","third-party-facades.js","third-party-summary.js","timing-budget.js","unsized-images.js","user-timings.js","uses-rel-preconnect.js","uses-rel-preload.js","valid-source-maps.js","viewport.js","violation-audit.js","work-during-interaction.js",...["charset.js","doctype.js","dom-size.js","geolocation-on-start.js","inspector-issues.js","js-libraries.js","no-document-write.js","notification-on-start.js","paste-preventing-inputs.js","uses-http2.js","uses-passive-event-listeners.js"].map((e=>`dobetterweb/${e}`)),...["cumulative-layout-shift.js","first-contentful-paint.js","first-meaningful-paint.js","interaction-to-next-paint.js","interactive.js","largest-contentful-paint.js","max-potential-fid.js","speed-index.js","total-blocking-time.js"].map((e=>`metrics/${e}`)),...["canonical.js","crawlable-anchors.js","font-size.js","hreflang.js","http-status-code.js","is-crawlable.js","link-text.js","manual","meta-description.js","plugins.js","robots-txt.js","tap-targets.js"].map((e=>`seo/${e}`)),...["structured-data.js"].map((e=>`seo/manual/${e}`)),...["accesskeys.js","aria-allowed-attr.js","aria-allowed-role.js","aria-command-name.js","aria-dialog-name.js","aria-hidden-body.js","aria-hidden-focus.js","aria-input-field-name.js","aria-meter-name.js","aria-progressbar-name.js","aria-required-attr.js","aria-required-children.js","aria-required-parent.js","aria-roles.js","aria-text.js","aria-toggle-field-name.js","aria-tooltip-name.js","aria-treeitem-name.js","aria-valid-attr-value.js","aria-valid-attr.js","axe-audit.js","button-name.js","bypass.js","color-contrast.js","definition-list.js","dlitem.js","document-title.js","duplicate-id-active.js","duplicate-id-aria.js","empty-heading.js","form-field-multiple-labels.js","frame-title.js","heading-order.js","html-has-lang.js","html-lang-valid.js","html-xml-lang-mismatch.js","identical-links-same-purpose.js","image-alt.js","image-redundant-alt.js","input-button-name.js","input-image-alt.js","label-content-name-mismatch.js","label.js","landmark-one-main.js","link-in-text-block.js","link-name.js","list.js","listitem.js","manual","meta-refresh.js","meta-viewport.js","object-alt.js","select-name.js","skip-link.js","tabindex.js","table-duplicate-name.js","table-fake-caption.js","target-size.js","td-has-header.js","td-headers-attr.js","th-has-data-cells.js","valid-lang.js","video-caption.js"].map((e=>`accessibility/${e}`)),...["custom-controls-labels.js","custom-controls-roles.js","focus-traps.js","focusable-controls.js","interactive-element-affordance.js","logical-tab-order.js","managed-focus.js","offscreen-content-hidden.js","use-landmarks.js","visual-order-follows-dom.js"].map((e=>`accessibility/manual/${e}`)),...["byte-efficiency-audit.js","duplicated-javascript.js","efficient-animated-content.js","legacy-javascript.js","modern-image-formats.js","offscreen-images.js","polyfill-graph-data.json","render-blocking-resources.js","total-byte-weight.js","unminified-css.js","unminified-javascript.js","unused-css-rules.js","unused-javascript.js","uses-long-cache-ttl.js","uses-optimized-images.js","uses-responsive-images-snapshot.js","uses-responsive-images.js","uses-text-compression.js"].map((e=>`byte-efficiency/${e}`)),...["manual-audit.js","pwa-cross-browser.js","pwa-each-page-has-url.js","pwa-page-transitions.js"].map((e=>`manual/${e}`))].filter((t=>/\.js$/.test(t)&&!e.includes(t))).sort()}static getGathererList(){return["accessibility.js","anchor-elements.js","bf-cache-failures.js","cache-contents.js","console-messages.js","css-usage.js","devtools-log-compat.js","devtools-log.js","dobetterweb","full-page-screenshot.js","global-listeners.js","iframe-elements.js","image-elements.js","inputs.js","inspector-issues.js","installability-errors.js","js-usage.js","link-elements.js","main-document-content.js","meta-elements.js","network-user-agent.js","script-elements.js","scripts.js","seo","service-worker.js","source-maps.js","stacks.js","trace-compat.js","trace-elements.js","trace.js","viewport-dimensions.js","web-app-manifest.js",...["embedded-content.js","font-size.js","robots-txt.js","tap-targets.js"].map((e=>`seo/${e}`)),...["doctype.js","domstats.js","optimized-images.js","response-compression.js","tags-blocking-first-paint.js"].map((e=>`dobetterweb/${e}`))].filter((e=>/\.js$/.test(e)&&"gatherer.js"!==e)).sort()}static _getDataSavePath(e){let{auditMode:t,gatherMode:a}=e;return"string"==typeof t?Ta.resolve(process.cwd(),t):"string"==typeof a?Ta.resolve(process.cwd(),a):Ta.join(process.cwd(),"latest-run")}}}));function qu(e){return(!e||"string"==typeof e)&&(e=new Error(e)),{__failedInBrowser:!0,name:e.name||"Error",message:e.message||"unknown error",stack:e.stack}}function zu(e){let t=window.__ElementMatches||window.Element.prototype.matches,a=[],n=o((r=>{for(let i of r){if(!e||t.call(i,e)){let e=i;a.push(e)}i.shadowRoot&&n(i.shadowRoot.querySelectorAll("*"))}}),"_findAllElements");return n(document.querySelectorAll("*")),a}function Vu(e,t=[],a=500){let n=["autofill-information","autofill-prediction","title"];e instanceof ShadowRoot&&(e=e.host);try{let r=e.cloneNode();e.ownerDocument.createElement("template").content.append(r),t.concat(n).forEach((e=>{r.removeAttribute(e)}));let i=0;for(let t of r.getAttributeNames()){if(i>a){r.removeAttribute(t);continue}let n=r.getAttribute(t);if(null===n)continue;let o=!1;if("src"===t&&"currentSrc"in e){let t=e,a=t.currentSrc,r=t.ownerDocument.location.href;new URL(n,r).toString()!==a&&(n=a,o=!0)}let s=Xu(n,75);if(s!==n&&(o=!0),n=s,o)if("style"===t){r.style.cssText=n}else r.setAttribute(t,n);i+=t.length+n.length}let o=/^[\s\S]*?>/,[s]=r.outerHTML.match(o)||[];return s&&i>a?s.slice(0,s.length-1)+" …>":s||""}catch{return`<${e.localName}>`}}function Wu(){function e(){let e=Date.now(),t=0;for(;Date.now()-e<500;){let e="";for(let t=0;t<1e4;t++)e+="a";if(1===e.length)throw new Error("will never happen, but prevents compiler optimizations");t++}let a=(Date.now()-e)/1e3;return Math.round(t/10/a)}function t(){let e=[],t=[];for(let a=0;a<1e5;a++)e[a]=t[a]=a;let a=Date.now(),n=0;for(;n%10!=0||Date.now()-a<500;){let a=n%2==0?e:t,r=n%2==0?t:e;for(let e=0;e<a.length;e++)r[e]=a[e];n++}let r=(Date.now()-a)/1e3;return Math.round(n/10/r)}return o(e,"benchmarkIndexGC"),o(t,"benchmarkIndexNoGC"),(e()+t())/2}function Hu(e){let t=o((e=>e.nodeType===Node.DOCUMENT_FRAGMENT_NODE),"isShadowRoot"),a=o((e=>t(e)?e.host:e.parentNode),"getNodeParent");function n(e){if(t(e))return"a";let a,n=0;for(;a=e.previousSibling;)((e=a).nodeType!==Node.TEXT_NODE||0!==(e.nodeValue||"").trim().length)&&n++;return n}o(n,"getNodeIndex");let r=e,i=[];for(;r&&a(r);){let e=n(r);i.push([e,r.nodeName]),r=a(r)}return i.reverse(),i.join(",")}function Gu(e){function t(e){let t=e.tagName.toLowerCase();return e.id?t+="#"+e.id:e.classList.length>0&&(t+="."+e.classList[0]),t}o(t,"getSelectorPart");let a=[];for(;a.length<4&&(a.unshift(t(e)),e.parentElement&&"HTML"!==(e=e.parentElement).tagName););return a.join(" > ")}function $u(e){function t(e,t){return e.style[t]||window.getComputedStyle(e)[t]}o(t,"getStyleAttrValue");let a=document.querySelector("html");if(!a)throw new Error("html element not found in document");if(a.scrollHeight<=a.clientHeight||!["scroll","auto","visible"].includes(t(a,"overflowY")))return!1;let n=e;for(;n;){let e=t(n,"position");if("fixed"===e||"sticky"===e)return!0;n=n.parentElement}return!1}function Ku(e){let t=e.tagName.toLowerCase();if("html"!==t&&"body"!==t){let t=e instanceof HTMLElement&&e.innerText||e.getAttribute("alt")||e.getAttribute("aria-label");if(t)return Xu(t,80);{let t=e.querySelector("[alt], [aria-label]");if(t)return Ku(t)}}return null}function Yu(e){let t=(window.__HTMLElementBoundingClientRect||window.HTMLElement.prototype.getBoundingClientRect).call(e);return{top:Math.round(t.top),bottom:Math.round(t.bottom),left:Math.round(t.left),right:Math.round(t.right),width:Math.round(t.width),height:Math.round(t.height)}}function Ju(e){let t=Math.floor(40/e),a=window.requestIdleCallback;window.requestIdleCallback=(e,n)=>a(o((a=>{let n=Date.now();a.__timeRemaining=a.timeRemaining,a.timeRemaining=()=>{let e=a.__timeRemaining();return Math.min(e,Math.max(0,t-(Date.now()-n)))},a.timeRemaining.toString=()=>"function timeRemaining() { [native code] }",e(a)}),"cbWrap"),n),window.requestIdleCallback.toString=()=>"function requestIdleCallback() { [native code] }"}function Zu(e){window.__lighthouseNodesDontTouchOrAllVarianceGoesAway||(window.__lighthouseNodesDontTouchOrAllVarianceGoesAway=new Map);let t=Gu(e=e instanceof ShadowRoot?e.host:e),a=window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.get(e);return a||(a=[void 0===window.__lighthouseExecutionContextUniqueIdentifier?"page":window.__lighthouseExecutionContextUniqueIdentifier,window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.size,e.tagName].join("-"),window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.set(e,a)),{lhId:a,devtoolsNodePath:Hu(e),selector:t,boundingRect:Yu(e),snippet:Vu(e),nodeLabel:Ku(e)||t}}function Xu(e,t){return br.truncate(e,t)}function Qu(){if(globalThis.isDevtools||globalThis.isLightrider)return!0;let e=Zr("core/lib/page-functions.js");try{return e.resolve("lighthouse-logger"),!1}catch{return!0}}function ed(){if(!Qu())return"";let e=(()=>{o((()=>{}),"a")}).toString().replace("/* @__PURE__ */","").match(/=\s*([\w_]+)\(/);if(!e)throw new Error("Could not determine esbuild function wrapper name");let t=o(((e,t)=>Object.defineProperty(e,"name",{value:t,configurable:!0})),"esbuildFunctionWrapper");return`let ${e[1]}=${t}`}function td(e){let t=e.toString().match(/function ([\w$]+)/);if(!t)throw new Error(`could not find function name for: ${e}`);return t[1]}var ad,nd,rd,id,od,sd,ld,cd,ud,dd,md,pd,hd,gd,fd,yd,vd,bd=s((()=>{J(),ni(),kr(),o(qu,"wrapRuntimeEvalErrorInBrowser"),o(zu,"getElementsInDocument"),o(Vu,"getOuterHTMLSnippet"),o(Wu,"computeBenchmarkIndex"),o(Hu,"getNodePath"),o(Gu,"getNodeSelector"),o($u,"isPositionFixed"),o(Ku,"getNodeLabel"),o(Yu,"getBoundingClientRect"),o(Ju,"wrapRequestIdleCallback"),o(Zu,"getNodeDetails"),o(Xu,"truncate"),o(Qu,"isBundledEnvironment"),ad=ed(),o(ed,"createEsbuildFunctionWrapper"),o(td,"getRuntimeFunctionName"),nd={truncate:td(Xu),getNodeLabel:td(Ku),getOuterHTMLSnippet:td(Vu),getNodeDetails:td(Zu)},Xu.toString=()=>`function ${nd.truncate}(string, characterLimit) {\n  const Util = { ${br.truncate} };\n  return Util.truncate(string, characterLimit);\n}`,rd=Ku.toString(),Ku.toString=()=>`function ${nd.getNodeLabel}(element) {\n  ${Xu};\n  return (${rd})(element);\n}`,id=Vu.toString(),Vu.toString=()=>`function ${nd.getOuterHTMLSnippet}(element, ignoreAttrs = [], snippetCharacterLimit = 500) {\n  ${Xu};\n  return (${id})(element, ignoreAttrs, snippetCharacterLimit);\n}`,od=Zu.toString(),Zu.toString=()=>`function ${nd.getNodeDetails}(element) {\n  ${Xu};\n  ${Hu};\n  ${Gu};\n  ${Yu};\n  ${id};\n  ${rd};\n  return (${od})(element);\n}`,sd={wrapRuntimeEvalErrorInBrowser:qu,getElementsInDocument:zu,getOuterHTMLSnippet:Vu,computeBenchmarkIndex:Wu,getNodeDetails:Zu,getNodePath:Hu,getNodeSelector:Gu,getNodeLabel:Ku,isPositionFixed:$u,wrapRequestIdleCallback:Ju,getBoundingClientRect:Yu,truncate:Xu,esbuildFunctionWrapperString:ad,getRuntimeFunctionName:td}})),wd=s((()=>{J(),ta(),bd(),ld=class e{static{o(this,"ExecutionContext")}constructor(e){this._session=e,this._executionContextId=void 0,this._executionContextIdentifiersCreated=0,e.on("Page.frameNavigated",(()=>this.clearContextId())),e.on("Runtime.executionContextDestroyed",(e=>{e.executionContextId===this._executionContextId&&this.clearContextId()}))}getContextId(){return this._executionContextId}clearContextId(){this._executionContextId=void 0}async _getOrCreateIsolatedContextId(){if("number"==typeof this._executionContextId)return this._executionContextId;await this._session.sendCommand("Page.enable"),await this._session.sendCommand("Runtime.enable");let e=(await this._session.sendCommand("Page.getFrameTree")).frameTree.frame.id,t=await this._session.sendCommand("Page.createIsolatedWorld",{frameId:e,worldName:"lighthouse_isolated_context"});return this._executionContextId=t.executionContextId,this._executionContextIdentifiersCreated++,t.executionContextId}async _evaluateInContext(t,a){let n=this._session.hasNextProtocolTimeout()?this._session.getNextProtocolTimeout():6e4,r=void 0===a?void 0:this._executionContextIdentifiersCreated,i={expression:`(function wrapInNativePromise() {\n        ${e._cachedNativesPreamble};\n        globalThis.__lighthouseExecutionContextUniqueIdentifier =\n          ${r};\n        ${sd.esbuildFunctionWrapperString}\n        return new Promise(function (resolve) {\n          return Promise.resolve()\n            .then(_ => ${t})\n            .catch(${sd.wrapRuntimeEvalErrorInBrowser})\n            .then(resolve);\n        });\n      }())\n      //# sourceURL=_lighthouse-eval.js`,includeCommandLineAPI:!0,awaitPromise:!0,returnByValue:!0,timeout:n,contextId:a};this._session.setNextProtocolTimeout(n);let o=await this._session.sendCommand("Runtime.evaluate",i),s=o.exceptionDetails;if(s){let e=["Runtime.evaluate exception",`Expression: ${t.replace(/\s+/g," ").substring(0,100)}\n---- (elided)`,s.stackTrace?null:`Parse error at: ${s.lineNumber+1}:${s.columnNumber+1}`,s.exception?.description||s.text].filter(Boolean),a=new Error(e.join("\n"));return Promise.reject(a)}if(void 0===o.result)return Promise.reject(new Error('Runtime.evaluate response did not contain a "result" object'));let l=o.result.value;return l?.__failedInBrowser?Promise.reject(Object.assign(new Error,l)):l}async evaluateAsync(e,t={}){let a=t.useIsolation?await this._getOrCreateIsolatedContextId():void 0;try{return await this._evaluateInContext(e,a)}catch(t){if(a&&t.message.includes("Cannot find context")){this.clearContextId();let t=await this._getOrCreateIsolatedContextId();return this._evaluateInContext(e,t)}throw t}}evaluate(t,a){let n=e.serializeArguments(a.args),r=`(() => {\n      ${e.serializeDeps(a.deps)}\n      return (${t})(${n});\n    })()`;return this.evaluateAsync(r,a)}async evaluateOnNewDocument(t,a){let n=e.serializeArguments(a.args),r=e.serializeDeps(a.deps),i=`(() => {\n      ${e._cachedNativesPreamble};\n      ${r};\n      (${t})(${n});\n    })()\n    //# sourceURL=_lighthouse-eval.js`;await this._session.sendCommand("Page.addScriptToEvaluateOnNewDocument",{source:i})}async cacheNativesOnNewDocument(){await this.evaluateOnNewDocument((()=>{window.__nativePromise=window.Promise,window.__nativeURL=window.URL,window.__nativePerformance=window.performance,window.__nativeFetch=window.fetch,window.__ElementMatches=window.Element.prototype.matches,window.__HTMLElementBoundingClientRect=window.HTMLElement.prototype.getBoundingClientRect}),{args:[]})}static _cachedNativesPreamble=["const Promise = globalThis.__nativePromise || globalThis.Promise","const URL = globalThis.__nativeURL || globalThis.URL","const performance = globalThis.__nativePerformance || globalThis.performance","const fetch = globalThis.__nativeFetch || globalThis.fetch"].join(";\n");static serializeArguments(e){return e.map((e=>void 0===e?"undefined":JSON.stringify(e))).join(",")}static serializeDeps(e){return(e=[sd.esbuildFunctionWrapperString,...e||[]]).map((e=>{if("function"==typeof e){let t=e.toString(),a=sd.getRuntimeFunctionName(e);return a!==e.name?`${t}; const ${e.name} = ${a};`:t}return e})).join("\n")}}})),Dd=s((()=>{J(),kt(),xl(),3e4,cd=Ct,ud=class extends cd{static{o(this,"ProtocolSession")}constructor(e){super(),this._cdpSession=e,this._targetInfo=void 0,this._nextProtocolTimeout=void 0,this._handleProtocolEvent=this._handleProtocolEvent.bind(this),this._cdpSession.on("*",this._handleProtocolEvent)}id(){return this._cdpSession.id()}_handleProtocolEvent(e,...t){this.emit(e,...t)}setTargetInfo(e){this._targetInfo=e}hasNextProtocolTimeout(){return void 0!==this._nextProtocolTimeout}getNextProtocolTimeout(){return this._nextProtocolTimeout||3e4}setNextProtocolTimeout(e){this._nextProtocolTimeout=e}sendCommand(e,...t){let a=this.getNextProtocolTimeout();this._nextProtocolTimeout=void 0;let n,r=new Promise(((t,r)=>{a!==1/0&&(n=setTimeout(r,a,new El(El.errors.PROTOCOL_TIMEOUT,{protocolMethod:e})))})),i=this._cdpSession.send(e,...t);return Promise.race([i,r]).finally((()=>{n&&clearTimeout(n)}))}async dispose(){this._cdpSession.off("*",this._handleProtocolEvent),await this._cdpSession.detach()}}})),Ed=s((()=>{J(),kt(),ea(),Dd(),dd=Ct,md=class extends dd{static{o(this,"TargetManager")}constructor(e){super(),this._enabled=!1,this._rootCdpSession=e,this._mainFrameId="",this._targetIdToTargets=new Map,this._executionContextIdToDescriptions=new Map,this._onSessionAttached=this._onSessionAttached.bind(this),this._onFrameNavigated=this._onFrameNavigated.bind(this),this._onExecutionContextCreated=this._onExecutionContextCreated.bind(this),this._onExecutionContextDestroyed=this._onExecutionContextDestroyed.bind(this),this._onExecutionContextsCleared=this._onExecutionContextsCleared.bind(this)}async _onFrameNavigated(e){if(!e.frame.parentId&&this._enabled)try{await this._rootCdpSession.send("Target.setAutoAttach",{autoAttach:!0,flatten:!0,waitForDebuggerOnStart:!0})}catch(e){if(this._enabled)throw e}}_findSession(e){for(let{session:t,cdpSession:a}of this._targetIdToTargets.values())if(a.id()===e)return t;throw new Error(`session ${e} not found`)}rootSession(){let e=this._rootCdpSession.id();return this._findSession(e)}mainFrameExecutionContexts(){return[...this._executionContextIdToDescriptions.values()].filter((e=>e.auxData.frameId===this._mainFrameId))}async _onSessionAttached(e){let t=new ud(e);try{let a=await t.sendCommand("Target.getTargetInfo").catch((()=>null)),n=a?.targetInfo?.type;if(!a||"page"!==n&&"iframe"!==n)return;let r=a.targetInfo.targetId;if(this._targetIdToTargets.has(r))return;t.setTargetInfo(a.targetInfo);let i=a.targetInfo.url||a.targetInfo.targetId;Kt.verbose("target-manager",`target ${i} attached`);let o=this._getProtocolEventListener(n,t.id());e.on("*",o),e.on("sessionattached",this._onSessionAttached);let s={target:a.targetInfo,cdpSession:e,session:t,protocolListener:o};this._targetIdToTargets.set(r,s),await t.sendCommand("Network.enable"),await t.sendCommand("Target.setAutoAttach",{autoAttach:!0,flatten:!0,waitForDebuggerOnStart:!0})}catch(e){if(/Target closed/.test(e.message))return;throw e}finally{await t.sendCommand("Runtime.runIfWaitingForDebugger").catch((()=>{}))}}_onExecutionContextCreated(e){"__puppeteer_utility_world__"!==e.context.name&&"lighthouse_isolated_context"!==e.context.name&&this._executionContextIdToDescriptions.set(e.context.uniqueId,e.context)}_onExecutionContextDestroyed(e){this._executionContextIdToDescriptions.delete(e.executionContextUniqueId)}_onExecutionContextsCleared(){this._executionContextIdToDescriptions.clear()}_getProtocolEventListener(e,t){return o(((a,n)=>{let r={method:a,params:n,targetType:e,sessionId:t};this.emit("protocolevent",r)}),"onProtocolEvent")}async enable(){this._enabled||(this._enabled=!0,this._targetIdToTargets=new Map,this._executionContextIdToDescriptions=new Map,this._rootCdpSession.on("Page.frameNavigated",this._onFrameNavigated),this._rootCdpSession.on("Runtime.executionContextCreated",this._onExecutionContextCreated),this._rootCdpSession.on("Runtime.executionContextDestroyed",this._onExecutionContextDestroyed),this._rootCdpSession.on("Runtime.executionContextsCleared",this._onExecutionContextsCleared),await this._rootCdpSession.send("Page.enable"),await this._rootCdpSession.send("Runtime.enable"),this._mainFrameId=(await this._rootCdpSession.send("Page.getFrameTree")).frameTree.frame.id,await this._onSessionAttached(this._rootCdpSession))}async disable(){this._rootCdpSession.off("Page.frameNavigated",this._onFrameNavigated),this._rootCdpSession.off("Runtime.executionContextCreated",this._onExecutionContextCreated),this._rootCdpSession.off("Runtime.executionContextDestroyed",this._onExecutionContextDestroyed),this._rootCdpSession.off("Runtime.executionContextsCleared",this._onExecutionContextsCleared);for(let{cdpSession:e,protocolListener:t}of this._targetIdToTargets.values())e.off("*",t),e.off("sessionattached",this._onSessionAttached);await this._rootCdpSession.send("Page.disable"),await this._rootCdpSession.send("Runtime.disable"),this._enabled=!1,this._targetIdToTargets=new Map,this._executionContextIdToDescriptions=new Map,this._mainFrameId=""}}})),Td=s((()=>{J(),ta(),pd=class{static{o(this,"Fetcher")}constructor(e){this.session=e}async fetchResource(e,t={timeout:2e3}){return globalThis.isLightrider?this._wrapWithTimeout(this._fetchWithFetchApi(e),t.timeout):this._fetchResourceOverProtocol(e,t)}async _fetchWithFetchApi(e){let t=await fetch(e),a=null;try{a=await t.text()}catch{}return{content:a,status:t.status}}async _readIOStream(e,t={timeout:2e3}){let a,n=Date.now(),r="";for(;!a||!a.eof;){if(Date.now()-n>t.timeout)throw new Error("Waiting for the end of the IO stream exceeded the allotted time.");a=await this.session.sendCommand("IO.read",{handle:e});let i=a.base64Encoded?Buffer.from(a.data,"base64").toString("utf-8"):a.data;r=r.concat(i)}return r}async _loadNetworkResource(e){let t=await this.session.sendCommand("Page.getFrameTree"),a=await this.session.sendCommand("Network.loadNetworkResource",{frameId:t.frameTree.frame.id,url:e,options:{disableCache:!0,includeCredentials:!0}});return{stream:a.resource.success&&a.resource.stream||null,status:a.resource.httpStatusCode||null}}async _fetchResourceOverProtocol(e,t){let a=Date.now(),n=await this._wrapWithTimeout(this._loadNetworkResource(e),t.timeout),r=n.status&&n.status>=200&&n.status<=299;if(!n.stream||!r)return{status:n.status,content:null};let i=t.timeout-(Date.now()-a),o=await this._readIOStream(n.stream,{timeout:i});return{status:n.status,content:o}}async _wrapWithTimeout(e,t){let a,n=new Promise(((e,n)=>{a=setTimeout(n,t,new Error("Timed out fetching resource"))}));return await Promise.race([e,n]).finally((()=>clearTimeout(a)))}}})),Sd=s((()=>{J(),kt(),ea(),ta(),Kc(),qc(),ql(),hd=ut,gd=class extends hd{static{o(this,"NetworkMonitor")}_networkRecorder=void 0;_frameNavigations=[];constructor(e){super(),this._targetManager=e,this._session=e.rootSession(),this._onFrameNavigated=e=>this._frameNavigations.push(e.frame),this._onProtocolMessage=e=>{this._networkRecorder&&this._networkRecorder.dispatch(e)}}async enable(){if(this._networkRecorder)return;this._frameNavigations=[],this._networkRecorder=new Ic;let e=o((e=>t=>{this.emit(e,t),this._emitNetworkStatus()}),"reEmit");this._networkRecorder.on("requeststarted",e("requeststarted")),this._networkRecorder.on("requestfinished",e("requestfinished")),this._session.on("Page.frameNavigated",this._onFrameNavigated),this._targetManager.on("protocolevent",this._onProtocolMessage)}async disable(){this._networkRecorder&&(this._session.off("Page.frameNavigated",this._onFrameNavigated),this._targetManager.off("protocolevent",this._onProtocolMessage),this._frameNavigations=[],this._networkRecorder=void 0)}async getNavigationUrls(){let e=this._frameNavigations;if(!e.length)return{};let t=e.filter((e=>!e.parentId));t.length||Kt.warn("NetworkMonitor","No detected navigations");let a=t[0]?.url;if(this._networkRecorder){let e=this._networkRecorder.getRawRecords().find((e=>e.url===a));for(;e?.redirectSource;)e=e.redirectSource,a=e.url}return{requestedUrl:a,mainDocumentUrl:t[t.length-1]?.url}}getInflightRequests(){return this._networkRecorder?this._networkRecorder.getRawRecords().filter((e=>!e.finished)):[]}isIdle(){return this._isActiveIdlePeriod(0)}isCriticalIdle(){if(!this._networkRecorder)return!1;let e=this._networkRecorder.getRawRecords().find((e=>"Document"===e.resourceType))?.frameId;return this._isActiveIdlePeriod(0,(t=>t.frameId===e&&("VeryHigh"===t.priority||"High"===t.priority)))}is2Idle(){return this._isActiveIdlePeriod(2)}_isActiveIdlePeriod(e,t){if(!this._networkRecorder)return!1;let a=this._networkRecorder.getRawRecords(),n=0;for(let e=0;e<a.length;e++){let r=a[e];r.finished||t&&!t(r)||wc.isNonNetworkRequest(r)||n++}return n<=e}_emitNetworkStatus(){let e=this.isIdle(),t=this.is2Idle(),a=this.isCriticalIdle();this.emit(e?"networkidle":"networkbusy"),this.emit(t?"network-2-idle":"network-2-busy"),this.emit(a?"network-critical-idle":"network-critical-busy"),t&&e?Kt.verbose("NetworkRecorder","network fully-quiet"):t&&!e?Kt.verbose("NetworkRecorder","network semi-quiet"):Kt.verbose("NetworkRecorder","network busy")}static findNetworkQuietPeriods(e,t,a=1/0){let n=[];e.forEach((e=>{Ml.isNonNetworkProtocol(e.protocol)||"ws"===e.protocol||"wss"===e.protocol||(n.push({time:1e3*e.networkRequestTime,isStart:!0}),e.finished&&n.push({time:1e3*e.networkEndTime,isStart:!1}))})),n=n.filter((e=>e.time<=a)).sort(((e,t)=>e.time-t.time));let r=0,i=0,o=[];return n.forEach((e=>{e.isStart?(r===t&&o.push({start:i,end:e.time}),r++):(r--,r===t&&(i=e.time))})),r<=t&&o.push({start:i,end:a}),o.filter((e=>e.start!==e.end))}}})),Cd=s((()=>{J(),ea(),wd(),Ed(),Td(),Sd(),fd=o((()=>{throw new Error("Session not connected")}),"throwNotConnectedFn"),yd={setTargetInfo:fd,hasNextProtocolTimeout:fd,getNextProtocolTimeout:fd,setNextProtocolTimeout:fd,on:fd,once:fd,off:fd,sendCommand:fd,dispose:fd},vd=class{static{o(this,"Driver")}constructor(e){this._page=e,this._targetManager=void 0,this._networkMonitor=void 0,this._executionContext=void 0,this._fetcher=void 0,this.defaultSession=yd}get executionContext(){return this._executionContext?this._executionContext:fd()}get fetcher(){return this._fetcher?this._fetcher:fd()}get targetManager(){return this._targetManager?this._targetManager:fd()}get networkMonitor(){return this._networkMonitor?this._networkMonitor:fd()}async url(){return this._page.url()}async connect(){if(this.defaultSession!==yd)return;let e={msg:"Connecting to browser",id:"lh:driver:connect"};Kt.time(e);let t=await this._page.target().createCDPSession();this._targetManager=new md(t),await this._targetManager.enable(),this._networkMonitor=new gd(this._targetManager),await this._networkMonitor.enable(),this.defaultSession=this._targetManager.rootSession(),this._executionContext=new ld(this.defaultSession),this._fetcher=new pd(this.defaultSession),Kt.timeEnd(e)}async disconnect(){this.defaultSession!==yd&&(await(this._targetManager?.disable()),await(this._networkMonitor?.disable()),await this.defaultSession.dispose())}}}));function kd(e,t){return new Error(`Dependency "${e.id}" failed with exception: ${t.message}`)}function xd(){return{startInstrumentation:{},startSensitiveInstrumentation:{},stopSensitiveInstrumentation:{},stopInstrumentation:{},getArtifact:{}}}async function Ad(e){let{driver:t,page:a,artifactDefinitions:n,artifactState:r,baseArtifacts:i,phase:o,gatherMode:s,computedCache:l,settings:c}=e,u=Fd[o],d=u&&r[u]||{},m="getArtifact"===o;for(let e of n){Kt.verbose(`artifacts:${o}`,e.id);let n=e.gatherer.instance,u=(d[e.id]||Promise.resolve()).then((async()=>{let u=m?await _d(e,r.getArtifact):{},d={msg:`Getting artifact: ${e.id}`,id:`lh:gather:getArtifact:${e.id}`};m&&Kt.time(d);let p=await n[o]({gatherMode:s,driver:t,page:a,baseArtifacts:i,dependencies:u,computedCache:l,settings:c});return m&&Kt.timeEnd(d),p}));await u.catch((t=>{vu.captureException(t,{tags:{gatherer:e.id,phase:o},level:"error"}),Kt.error(e.id,t.message)})),r[o][e.id]=u}}async function _d(e,t){if(!e.dependencies)return{};let a=Object.entries(e.dependencies).map((async([e,a])=>{let n=t[a.id];if(void 0===n)throw new Error(`"${a.id}" did not run`);if(n instanceof Error)throw kd(a,n);let r=Promise.resolve().then((()=>n)).catch((e=>Promise.reject(kd(a,e))));return[e,await r]}));return Object.fromEntries(await Promise.all(a))}async function Rd(e){let t={};for(let[a,n]of Object.entries(e.getArtifact)){let e=await n.catch((e=>e));void 0!==e&&(t[a]=e)}return t}var Fd,Nd,Id,Md,Pd,Ld,Od,jd,Ud=s((()=>{J(),ea(),Du(),o(kd,"createDependencyError"),o(xd,"getEmptyArtifactState"),Fd={startInstrumentation:void 0,startSensitiveInstrumentation:"startInstrumentation",stopSensitiveInstrumentation:"startSensitiveInstrumentation",stopInstrumentation:"stopSensitiveInstrumentation",getArtifact:"stopInstrumentation"},o(Ad,"collectPhaseArtifacts"),o(_d,"collectArtifactDependencies"),o(Rd,"awaitArtifacts")})),Bd=s((()=>{J(),Nd=["server-response-time","render-blocking-resources","redirects","critical-request-chains","uses-text-compression","uses-rel-preconnect","uses-rel-preload","font-display","unminified-javascript","unminified-css","unused-css-rules"],Id=[...Nd,"largest-contentful-paint-element","prioritize-lcp-image","unused-javascript","efficient-animated-content","total-byte-weight","lcp-lazy-loaded"],Md={fcpRelevantAudits:Nd,lcpRelevantAudits:Id,tbtRelevantAudits:["long-tasks","third-party-summary","third-party-facades","bootup-time","mainthread-work-breakdown","dom-size","duplicated-javascript","legacy-javascript","viewport"],clsRelevantAudits:["layout-shift-elements","non-composited-animations","unsized-images"],inpRelevantAudits:["work-during-interaction"]}})),qd=s((()=>{J(),ta(),oc(),ro(),Bd(),Ld=eo("core/config/default-config.js",Pd={performanceCategoryTitle:"Performance",budgetsGroupTitle:"Budgets",budgetsGroupDescription:"Performance budgets set standards for the performance of your site.",metricGroupTitle:"Metrics",loadOpportunitiesGroupTitle:"Opportunities",loadOpportunitiesGroupDescription:"These suggestions can help your page load faster. They don't [directly affect](https://developer.chrome.com/docs/lighthouse/performance/performance-scoring/) the Performance score.",firstPaintImprovementsGroupTitle:"First Paint Improvements",firstPaintImprovementsGroupDescription:"The most critical aspect of performance is how quickly pixels are rendered onscreen. Key metrics: First Contentful Paint, First Meaningful Paint",overallImprovementsGroupTitle:"Overall Improvements",overallImprovementsGroupDescription:"Enhance the overall loading experience, so the page is responsive and ready to use as soon as possible. Key metrics: Time to Interactive, Speed Index",diagnosticsGroupTitle:"Diagnostics",diagnosticsGroupDescription:"More information about the performance of your application. These numbers don't [directly affect](https://developer.chrome.com/docs/lighthouse/performance/performance-scoring/) the Performance score.",a11yCategoryTitle:"Accessibility",a11yCategoryDescription:"These checks highlight opportunities to [improve the accessibility of your web app](https://developer.chrome.com/docs/lighthouse/accessibility/). Automatic detection can only detect a subset of issues and does not guarantee the accessibility of your web app, so [manual testing](https://web.dev/how-to-review/) is also encouraged.",a11yCategoryManualDescription:"These items address areas which an automated testing tool cannot cover. Learn more in our guide on [conducting an accessibility review](https://web.dev/how-to-review/).",a11yBestPracticesGroupTitle:"Best practices",a11yBestPracticesGroupDescription:"These items highlight common accessibility best practices.",a11yColorContrastGroupTitle:"Contrast",a11yColorContrastGroupDescription:"These are opportunities to improve the legibility of your content.",a11yNamesLabelsGroupTitle:"Names and labels",a11yNamesLabelsGroupDescription:"These are opportunities to improve the semantics of the controls in your application. This may enhance the experience for users of assistive technology, like a screen reader.",a11yNavigationGroupTitle:"Navigation",a11yNavigationGroupDescription:"These are opportunities to improve keyboard navigation in your application.",a11yAriaGroupTitle:"ARIA",a11yAriaGroupDescription:"These are opportunities to improve the usage of ARIA in your application which may enhance the experience for users of assistive technology, like a screen reader.",a11yLanguageGroupTitle:"Internationalization and localization",a11yLanguageGroupDescription:"These are opportunities to improve the interpretation of your content by users in different locales.",a11yAudioVideoGroupTitle:"Audio and video",a11yAudioVideoGroupDescription:"These are opportunities to provide alternative content for audio and video. This may improve the experience for users with hearing or vision impairments.",a11yTablesListsVideoGroupTitle:"Tables and lists",a11yTablesListsVideoGroupDescription:"These are opportunities to improve the experience of reading tabular or list data using assistive technology, like a screen reader.",seoCategoryTitle:"SEO",seoCategoryDescription:"These checks ensure that your page is following basic search engine optimization advice. There are many additional factors Lighthouse does not score here that may affect your search ranking, including performance on [Core Web Vitals](https://web.dev/learn-core-web-vitals/). [Learn more about Google Search Essentials](https://support.google.com/webmasters/answer/35769).",seoCategoryManualDescription:"Run these additional validators on your site to check additional SEO best practices.",seoMobileGroupTitle:"Mobile Friendly",seoMobileGroupDescription:"Make sure your pages are mobile friendly so users don’t have to pinch or zoom in order to read the content pages. [Learn how to make pages mobile-friendly](https://developers.google.com/search/mobile-sites/).",seoContentGroupTitle:"Content Best Practices",seoContentGroupDescription:"Format your HTML in a way that enables crawlers to better understand your app’s content.",seoCrawlingGroupTitle:"Crawling and Indexing",seoCrawlingGroupDescription:"To appear in search results, crawlers need access to your app.",pwaCategoryTitle:"PWA",pwaCategoryDescription:"These checks validate the aspects of a Progressive Web App. [Learn what makes a good Progressive Web App](https://web.dev/pwa-checklist/).",pwaCategoryManualDescription:"These checks are required by the baseline [PWA Checklist](https://web.dev/pwa-checklist/) but are not automatically checked by Lighthouse. They do not affect your score but it's important that you verify them manually.",bestPracticesCategoryTitle:"Best Practices",bestPracticesTrustSafetyGroupTitle:"Trust and Safety",bestPracticesUXGroupTitle:"User Experience",bestPracticesBrowserCompatGroupTitle:"Browser Compatibility",bestPracticesGeneralGroupTitle:"General",pwaInstallableGroupTitle:"Installable",pwaOptimizedGroupTitle:"PWA Optimized"}),Od={settings:Jl,artifacts:[{id:"DevtoolsLog",gatherer:"devtools-log"},{id:"Trace",gatherer:"trace"},{id:"Accessibility",gatherer:"accessibility"},{id:"AnchorElements",gatherer:"anchor-elements"},{id:"CacheContents",gatherer:"cache-contents"},{id:"ConsoleMessages",gatherer:"console-messages"},{id:"CSSUsage",gatherer:"css-usage"},{id:"Doctype",gatherer:"dobetterweb/doctype"},{id:"DOMStats",gatherer:"dobetterweb/domstats"},{id:"EmbeddedContent",gatherer:"seo/embedded-content"},{id:"FontSize",gatherer:"seo/font-size"},{id:"Inputs",gatherer:"inputs"},{id:"GlobalListeners",gatherer:"global-listeners"},{id:"IFrameElements",gatherer:"iframe-elements"},{id:"ImageElements",gatherer:"image-elements"},{id:"InstallabilityErrors",gatherer:"installability-errors"},{id:"InspectorIssues",gatherer:"inspector-issues"},{id:"JsUsage",gatherer:"js-usage"},{id:"LinkElements",gatherer:"link-elements"},{id:"MainDocumentContent",gatherer:"main-document-content"},{id:"MetaElements",gatherer:"meta-elements"},{id:"NetworkUserAgent",gatherer:"network-user-agent"},{id:"OptimizedImages",gatherer:"dobetterweb/optimized-images"},{id:"ResponseCompression",gatherer:"dobetterweb/response-compression"},{id:"RobotsTxt",gatherer:"seo/robots-txt"},{id:"ServiceWorker",gatherer:"service-worker"},{id:"ScriptElements",gatherer:"script-elements"},{id:"Scripts",gatherer:"scripts"},{id:"SourceMaps",gatherer:"source-maps"},{id:"Stacks",gatherer:"stacks"},{id:"TagsBlockingFirstPaint",gatherer:"dobetterweb/tags-blocking-first-paint"},{id:"TapTargets",gatherer:"seo/tap-targets"},{id:"TraceElements",gatherer:"trace-elements"},{id:"ViewportDimensions",gatherer:"viewport-dimensions"},{id:"WebAppManifest",gatherer:"web-app-manifest"},{id:"devtoolsLogs",gatherer:"devtools-log-compat"},{id:"traces",gatherer:"trace-compat"},{id:"FullPageScreenshot",gatherer:"full-page-screenshot"},{id:"BFCacheFailures",gatherer:"bf-cache-failures"}],audits:["is-on-https","viewport","metrics/first-contentful-paint","metrics/largest-contentful-paint","metrics/first-meaningful-paint","metrics/speed-index","screenshot-thumbnails","final-screenshot","metrics/total-blocking-time","metrics/max-potential-fid","metrics/cumulative-layout-shift","metrics/interaction-to-next-paint","errors-in-console","server-response-time","metrics/interactive","user-timings","critical-request-chains","redirects","installable-manifest","splash-screen","themed-omnibox","maskable-icon","content-width","image-aspect-ratio","image-size-responsive","preload-fonts","deprecations","mainthread-work-breakdown","bootup-time","uses-rel-preload","uses-rel-preconnect","font-display","diagnostics","network-requests","network-rtt","network-server-latency","main-thread-tasks","metrics","performance-budget","timing-budget","third-party-summary","third-party-facades","largest-contentful-paint-element","lcp-lazy-loaded","layout-shift-elements","long-tasks","no-unload-listeners","non-composited-animations","unsized-images","valid-source-maps","prioritize-lcp-image","csp-xss","script-treemap-data","manual/pwa-cross-browser","manual/pwa-page-transitions","manual/pwa-each-page-has-url","accessibility/accesskeys","accessibility/aria-allowed-attr","accessibility/aria-allowed-role","accessibility/aria-command-name","accessibility/aria-dialog-name","accessibility/aria-hidden-body","accessibility/aria-hidden-focus","accessibility/aria-input-field-name","accessibility/aria-meter-name","accessibility/aria-progressbar-name","accessibility/aria-required-attr","accessibility/aria-required-children","accessibility/aria-required-parent","accessibility/aria-roles","accessibility/aria-text","accessibility/aria-toggle-field-name","accessibility/aria-tooltip-name","accessibility/aria-treeitem-name","accessibility/aria-valid-attr-value","accessibility/aria-valid-attr","accessibility/button-name","accessibility/bypass","accessibility/color-contrast","accessibility/definition-list","accessibility/dlitem","accessibility/document-title","accessibility/duplicate-id-active","accessibility/duplicate-id-aria","accessibility/empty-heading","accessibility/form-field-multiple-labels","accessibility/frame-title","accessibility/heading-order","accessibility/html-has-lang","accessibility/html-lang-valid","accessibility/html-xml-lang-mismatch","accessibility/identical-links-same-purpose","accessibility/image-alt","accessibility/image-redundant-alt","accessibility/input-button-name","accessibility/input-image-alt","accessibility/label-content-name-mismatch","accessibility/label","accessibility/landmark-one-main","accessibility/link-name","accessibility/link-in-text-block","accessibility/list","accessibility/listitem","accessibility/meta-refresh","accessibility/meta-viewport","accessibility/object-alt","accessibility/select-name","accessibility/skip-link","accessibility/tabindex","accessibility/table-duplicate-name","accessibility/table-fake-caption","accessibility/target-size","accessibility/td-has-header","accessibility/td-headers-attr","accessibility/th-has-data-cells","accessibility/valid-lang","accessibility/video-caption","accessibility/manual/custom-controls-labels","accessibility/manual/custom-controls-roles","accessibility/manual/focus-traps","accessibility/manual/focusable-controls","accessibility/manual/interactive-element-affordance","accessibility/manual/logical-tab-order","accessibility/manual/managed-focus","accessibility/manual/offscreen-content-hidden","accessibility/manual/use-landmarks","accessibility/manual/visual-order-follows-dom","byte-efficiency/uses-long-cache-ttl","byte-efficiency/total-byte-weight","byte-efficiency/offscreen-images","byte-efficiency/render-blocking-resources","byte-efficiency/unminified-css","byte-efficiency/unminified-javascript","byte-efficiency/unused-css-rules","byte-efficiency/unused-javascript","byte-efficiency/modern-image-formats","byte-efficiency/uses-optimized-images","byte-efficiency/uses-text-compression","byte-efficiency/uses-responsive-images","byte-efficiency/efficient-animated-content","byte-efficiency/duplicated-javascript","byte-efficiency/legacy-javascript","byte-efficiency/uses-responsive-images-snapshot","dobetterweb/doctype","dobetterweb/charset","dobetterweb/dom-size","dobetterweb/geolocation-on-start","dobetterweb/inspector-issues","dobetterweb/no-document-write","dobetterweb/js-libraries","dobetterweb/notification-on-start","dobetterweb/paste-preventing-inputs","dobetterweb/uses-http2","dobetterweb/uses-passive-event-listeners","seo/meta-description","seo/http-status-code","seo/font-size","seo/link-text","seo/crawlable-anchors","seo/is-crawlable","seo/robots-txt","seo/tap-targets","seo/hreflang","seo/plugins","seo/canonical","seo/manual/structured-data","work-during-interaction","bf-cache"],groups:{metrics:{title:Ld(Pd.metricGroupTitle)},"load-opportunities":{title:Ld(Pd.loadOpportunitiesGroupTitle),description:Ld(Pd.loadOpportunitiesGroupDescription)},budgets:{title:Ld(Pd.budgetsGroupTitle),description:Ld(Pd.budgetsGroupDescription)},diagnostics:{title:Ld(Pd.diagnosticsGroupTitle),description:Ld(Pd.diagnosticsGroupDescription)},"pwa-installable":{title:Ld(Pd.pwaInstallableGroupTitle)},"pwa-optimized":{title:Ld(Pd.pwaOptimizedGroupTitle)},"a11y-best-practices":{title:Ld(Pd.a11yBestPracticesGroupTitle),description:Ld(Pd.a11yBestPracticesGroupDescription)},"a11y-color-contrast":{title:Ld(Pd.a11yColorContrastGroupTitle),description:Ld(Pd.a11yColorContrastGroupDescription)},"a11y-names-labels":{title:Ld(Pd.a11yNamesLabelsGroupTitle),description:Ld(Pd.a11yNamesLabelsGroupDescription)},"a11y-navigation":{title:Ld(Pd.a11yNavigationGroupTitle),description:Ld(Pd.a11yNavigationGroupDescription)},"a11y-aria":{title:Ld(Pd.a11yAriaGroupTitle),description:Ld(Pd.a11yAriaGroupDescription)},"a11y-language":{title:Ld(Pd.a11yLanguageGroupTitle),description:Ld(Pd.a11yLanguageGroupDescription)},"a11y-audio-video":{title:Ld(Pd.a11yAudioVideoGroupTitle),description:Ld(Pd.a11yAudioVideoGroupDescription)},"a11y-tables-lists":{title:Ld(Pd.a11yTablesListsVideoGroupTitle),description:Ld(Pd.a11yTablesListsVideoGroupDescription)},"seo-mobile":{title:Ld(Pd.seoMobileGroupTitle),description:Ld(Pd.seoMobileGroupDescription)},"seo-content":{title:Ld(Pd.seoContentGroupTitle),description:Ld(Pd.seoContentGroupDescription)},"seo-crawl":{title:Ld(Pd.seoCrawlingGroupTitle),description:Ld(Pd.seoCrawlingGroupDescription)},"best-practices-trust-safety":{title:Ld(Pd.bestPracticesTrustSafetyGroupTitle)},"best-practices-ux":{title:Ld(Pd.bestPracticesUXGroupTitle)},"best-practices-browser-compat":{title:Ld(Pd.bestPracticesBrowserCompatGroupTitle)},"best-practices-general":{title:Ld(Pd.bestPracticesGeneralGroupTitle)},hidden:{title:""}},categories:{performance:{title:Ld(Pd.performanceCategoryTitle),supportedModes:["navigation","timespan","snapshot"],auditRefs:[{id:"first-contentful-paint",weight:10,group:"metrics",acronym:"FCP",relevantAudits:Md.fcpRelevantAudits},{id:"largest-contentful-paint",weight:25,group:"metrics",acronym:"LCP",relevantAudits:Md.lcpRelevantAudits},{id:"total-blocking-time",weight:30,group:"metrics",acronym:"TBT",relevantAudits:Md.tbtRelevantAudits},{id:"cumulative-layout-shift",weight:25,group:"metrics",acronym:"CLS",relevantAudits:Md.clsRelevantAudits},{id:"speed-index",weight:10,group:"metrics",acronym:"SI"},{id:"interaction-to-next-paint",weight:0,group:"metrics",acronym:"INP",relevantAudits:Md.inpRelevantAudits},{id:"interactive",weight:0,group:"hidden",acronym:"TTI"},{id:"max-potential-fid",weight:0,group:"hidden"},{id:"first-meaningful-paint",weight:0,acronym:"FMP",group:"hidden"},{id:"render-blocking-resources",weight:0},{id:"uses-responsive-images",weight:0},{id:"offscreen-images",weight:0},{id:"unminified-css",weight:0},{id:"unminified-javascript",weight:0},{id:"unused-css-rules",weight:0},{id:"unused-javascript",weight:0},{id:"uses-optimized-images",weight:0},{id:"modern-image-formats",weight:0},{id:"uses-text-compression",weight:0},{id:"uses-rel-preconnect",weight:0},{id:"server-response-time",weight:0},{id:"redirects",weight:0},{id:"uses-rel-preload",weight:0},{id:"uses-http2",weight:0},{id:"efficient-animated-content",weight:0},{id:"duplicated-javascript",weight:0},{id:"legacy-javascript",weight:0},{id:"prioritize-lcp-image",weight:0},{id:"total-byte-weight",weight:0},{id:"uses-long-cache-ttl",weight:0},{id:"dom-size",weight:0},{id:"critical-request-chains",weight:0},{id:"user-timings",weight:0},{id:"bootup-time",weight:0},{id:"mainthread-work-breakdown",weight:0},{id:"font-display",weight:0},{id:"third-party-summary",weight:0},{id:"third-party-facades",weight:0},{id:"largest-contentful-paint-element",weight:0},{id:"lcp-lazy-loaded",weight:0},{id:"layout-shift-elements",weight:0},{id:"uses-passive-event-listeners",weight:0},{id:"no-document-write",weight:0},{id:"long-tasks",weight:0},{id:"non-composited-animations",weight:0},{id:"unsized-images",weight:0},{id:"viewport",weight:0},{id:"uses-responsive-images-snapshot",weight:0},{id:"work-during-interaction",weight:0},{id:"bf-cache",weight:0},{id:"performance-budget",weight:0,group:"budgets"},{id:"timing-budget",weight:0,group:"budgets"},{id:"network-requests",weight:0,group:"hidden"},{id:"network-rtt",weight:0,group:"hidden"},{id:"network-server-latency",weight:0,group:"hidden"},{id:"main-thread-tasks",weight:0,group:"hidden"},{id:"diagnostics",weight:0,group:"hidden"},{id:"metrics",weight:0,group:"hidden"},{id:"screenshot-thumbnails",weight:0,group:"hidden"},{id:"final-screenshot",weight:0,group:"hidden"},{id:"script-treemap-data",weight:0,group:"hidden"}]},accessibility:{title:Ld(Pd.a11yCategoryTitle),description:Ld(Pd.a11yCategoryDescription),manualDescription:Ld(Pd.a11yCategoryManualDescription),supportedModes:["navigation","snapshot"],auditRefs:[{id:"accesskeys",weight:7,group:"a11y-navigation"},{id:"aria-allowed-attr",weight:10,group:"a11y-aria"},{id:"aria-allowed-role",weight:1,group:"a11y-aria"},{id:"aria-command-name",weight:7,group:"a11y-aria"},{id:"aria-dialog-name",weight:7,group:"a11y-aria"},{id:"aria-hidden-body",weight:10,group:"a11y-aria"},{id:"aria-hidden-focus",weight:7,group:"a11y-aria"},{id:"aria-input-field-name",weight:7,group:"a11y-aria"},{id:"aria-meter-name",weight:7,group:"a11y-aria"},{id:"aria-progressbar-name",weight:7,group:"a11y-aria"},{id:"aria-required-attr",weight:10,group:"a11y-aria"},{id:"aria-required-children",weight:10,group:"a11y-aria"},{id:"aria-required-parent",weight:10,group:"a11y-aria"},{id:"aria-roles",weight:7,group:"a11y-aria"},{id:"aria-text",weight:7,group:"a11y-aria"},{id:"aria-toggle-field-name",weight:7,group:"a11y-aria"},{id:"aria-tooltip-name",weight:7,group:"a11y-aria"},{id:"aria-treeitem-name",weight:7,group:"a11y-aria"},{id:"aria-valid-attr-value",weight:10,group:"a11y-aria"},{id:"aria-valid-attr",weight:10,group:"a11y-aria"},{id:"button-name",weight:10,group:"a11y-names-labels"},{id:"bypass",weight:7,group:"a11y-navigation"},{id:"color-contrast",weight:7,group:"a11y-color-contrast"},{id:"definition-list",weight:7,group:"a11y-tables-lists"},{id:"dlitem",weight:7,group:"a11y-tables-lists"},{id:"document-title",weight:7,group:"a11y-names-labels"},{id:"duplicate-id-active",weight:7,group:"a11y-navigation"},{id:"duplicate-id-aria",weight:10,group:"a11y-aria"},{id:"form-field-multiple-labels",weight:3,group:"a11y-names-labels"},{id:"frame-title",weight:7,group:"a11y-names-labels"},{id:"heading-order",weight:3,group:"a11y-navigation"},{id:"html-has-lang",weight:7,group:"a11y-language"},{id:"html-lang-valid",weight:7,group:"a11y-language"},{id:"html-xml-lang-mismatch",weight:3,group:"a11y-language"},{id:"image-alt",weight:10,group:"a11y-names-labels"},{id:"image-redundant-alt",weight:1,group:"a11y-names-labels"},{id:"input-button-name",weight:10,group:"a11y-names-labels"},{id:"input-image-alt",weight:10,group:"a11y-names-labels"},{id:"label-content-name-mismatch",weight:7,group:"a11y-names-labels"},{id:"label",weight:7,group:"a11y-names-labels"},{id:"link-in-text-block",weight:7,group:"a11y-color-contrast"},{id:"link-name",weight:7,group:"a11y-names-labels"},{id:"list",weight:7,group:"a11y-tables-lists"},{id:"listitem",weight:7,group:"a11y-tables-lists"},{id:"meta-refresh",weight:10,group:"a11y-best-practices"},{id:"meta-viewport",weight:10,group:"a11y-best-practices"},{id:"object-alt",weight:7,group:"a11y-names-labels"},{id:"select-name",weight:7,group:"a11y-names-labels"},{id:"skip-link",weight:3,group:"a11y-names-labels"},{id:"tabindex",weight:7,group:"a11y-navigation"},{id:"table-duplicate-name",weight:1,group:"a11y-tables-lists"},{id:"table-fake-caption",weight:7,group:"a11y-tables-lists"},{id:"td-has-header",weight:10,group:"a11y-tables-lists"},{id:"td-headers-attr",weight:7,group:"a11y-tables-lists"},{id:"th-has-data-cells",weight:7,group:"a11y-tables-lists"},{id:"valid-lang",weight:7,group:"a11y-language"},{id:"video-caption",weight:10,group:"a11y-audio-video"},{id:"focusable-controls",weight:0},{id:"interactive-element-affordance",weight:0},{id:"logical-tab-order",weight:0},{id:"visual-order-follows-dom",weight:0},{id:"focus-traps",weight:0},{id:"managed-focus",weight:0},{id:"use-landmarks",weight:0},{id:"offscreen-content-hidden",weight:0},{id:"custom-controls-labels",weight:0},{id:"custom-controls-roles",weight:0},{id:"empty-heading",weight:0,group:"hidden"},{id:"identical-links-same-purpose",weight:0,group:"hidden"},{id:"landmark-one-main",weight:0,group:"hidden"},{id:"target-size",weight:0,group:"hidden"}]},"best-practices":{title:Ld(Pd.bestPracticesCategoryTitle),supportedModes:["navigation","timespan","snapshot"],auditRefs:[{id:"is-on-https",weight:5,group:"best-practices-trust-safety"},{id:"geolocation-on-start",weight:1,group:"best-practices-trust-safety"},{id:"notification-on-start",weight:1,group:"best-practices-trust-safety"},{id:"csp-xss",weight:0,group:"best-practices-trust-safety"},{id:"paste-preventing-inputs",weight:3,group:"best-practices-ux"},{id:"image-aspect-ratio",weight:1,group:"best-practices-ux"},{id:"image-size-responsive",weight:1,group:"best-practices-ux"},{id:"preload-fonts",weight:1,group:"best-practices-ux"},{id:"doctype",weight:1,group:"best-practices-browser-compat"},{id:"charset",weight:1,group:"best-practices-browser-compat"},{id:"no-unload-listeners",weight:1,group:"best-practices-general"},{id:"js-libraries",weight:0,group:"best-practices-general"},{id:"deprecations",weight:5,group:"best-practices-general"},{id:"errors-in-console",weight:1,group:"best-practices-general"},{id:"valid-source-maps",weight:0,group:"best-practices-general"},{id:"inspector-issues",weight:1,group:"best-practices-general"}]},seo:{title:Ld(Pd.seoCategoryTitle),description:Ld(Pd.seoCategoryDescription),manualDescription:Ld(Pd.seoCategoryManualDescription),supportedModes:["navigation","snapshot"],auditRefs:[{id:"viewport",weight:1,group:"seo-mobile"},{id:"document-title",weight:1,group:"seo-content"},{id:"meta-description",weight:1,group:"seo-content"},{id:"http-status-code",weight:1,group:"seo-crawl"},{id:"link-text",weight:1,group:"seo-content"},{id:"crawlable-anchors",weight:1,group:"seo-crawl"},{id:"is-crawlable",weight:1,group:"seo-crawl"},{id:"robots-txt",weight:1,group:"seo-crawl"},{id:"image-alt",weight:1,group:"seo-content"},{id:"hreflang",weight:1,group:"seo-content"},{id:"canonical",weight:1,group:"seo-content"},{id:"font-size",weight:1,group:"seo-mobile"},{id:"plugins",weight:1,group:"seo-content"},{id:"tap-targets",weight:1,group:"seo-mobile"},{id:"structured-data",weight:0}]},pwa:{title:Ld(Pd.pwaCategoryTitle),description:Ld(Pd.pwaCategoryDescription),manualDescription:Ld(Pd.pwaCategoryManualDescription),supportedModes:["navigation"],auditRefs:[{id:"installable-manifest",weight:2,group:"pwa-installable"},{id:"splash-screen",weight:1,group:"pwa-optimized"},{id:"themed-omnibox",weight:1,group:"pwa-optimized"},{id:"content-width",weight:1,group:"pwa-optimized"},{id:"viewport",weight:2,group:"pwa-optimized"},{id:"maskable-icon",weight:1,group:"pwa-optimized"},{id:"pwa-cross-browser",weight:0},{id:"pwa-page-transitions",weight:0},{id:"pwa-each-page-has-url",weight:0}]}}},Object.defineProperty(Od,"UIStrings",{enumerable:!1,get:()=>Pd}),jd=Od}));function zd(e,t){let a={timespan:0,snapshot:1,navigation:2},n=Math.min(...e.instance.meta.supportedModes.map((e=>a[e]))),r=Math.min(...t.instance.meta.supportedModes.map((e=>a[e])));return n===a.timespan?r===a.timespan:n!==a.snapshot||r===a.snapshot}function Vd(e,t){if(!t.startsWith("lighthouse-plugin-"))throw new Error(`plugin name '${t}' does not start with 'lighthouse-plugin-'`);if(e.categories?.[t])throw new Error(`plugin name '${t}' not allowed because it is the id of a category already found in config`)}function Wd(e){let t=e.gatherer.instance;if("object"!=typeof t.meta)throw new Error(`Gatherer for ${e.id} did not provide a meta object.`);if(0===t.meta.supportedModes.length)throw new Error(`Gatherer for ${e.id} did not support any gather modes.`);if("function"!=typeof t.getArtifact||t.getArtifact===Jt.prototype.getArtifact)throw new Error(`Gatherer for ${e.id} did not define a "getArtifact" method.`)}function Hd(e){if(!e||!e.length)return{warnings:[]};let t=[],a=e[0];if("fatal"!==a.loadFailureMode){let e=a.loadFailureMode,n=[`"${a.id}" is the first navigation but had a failure mode of ${e}.`,"The first navigation will always be treated as loadFailureMode=fatal."].join(" ");t.push(n),a.loadFailureMode="fatal"}let n=e.map((e=>e.id)),r=n.find(((e,t)=>n.slice(t+1).some((t=>e===t))));if(r)throw new Error(`Navigation must have unique identifiers, but "${r}" was repeated.`);return{warnings:t}}function Gd(e){let{implementation:t,path:a}=e,n=a||t?.meta?.id||"Unknown audit";if("function"!=typeof t.audit||t.audit===Dr.audit)throw new Error(`${n} has no audit() method.`);if("string"!=typeof t.meta.id)throw new Error(`${n} has no meta.id property, or the property is not a string.`);if(!to(t.meta.title))throw new Error(`${n} has no meta.title property, or the property is not a string.`);let r=t.meta.scoreDisplayMode||Dr.SCORING_MODES.BINARY;if(!to(t.meta.failureTitle)&&r===Dr.SCORING_MODES.BINARY)throw new Error(`${n} has no meta.failureTitle and should.`);if(!to(t.meta.description))throw new Error(`${n} has no meta.description property, or the property is not a string.`);if(""===t.meta.description)throw new Error(`${n} has an empty meta.description string. Please add a description for the UI.`);if(!Array.isArray(t.meta.requiredArtifacts))throw new Error(`${n} has no meta.requiredArtifacts property, or the property is not an array.`)}function $d(e,t,a){if(!e)return;let n=new Map((t||[]).map((e=>[e.implementation.meta.id,e])));Object.keys(e).forEach((t=>{e[t].auditRefs.forEach(((e,r)=>{if(!e.id)throw new Error(`missing an audit id at ${t}[${r}]`);let i=n.get(e.id);if(!i)throw new Error(`could not find ${e.id} audit for category ${t}`);let o="manual"===i.implementation.meta.scoreDisplayMode;if("accessibility"===t&&!e.group&&!o)throw new Error(`${e.id} accessibility audit does not have a group`);if(e.weight>0&&o)throw new Error(`${e.id} is manual but has a positive weight`);if(e.group&&(!a||!a[e.group]))throw new Error(`${e.id} references unknown group ${e.group}`)}))}))}function Kd(e){if(!e.formFactor)throw new Error("`settings.formFactor` must be defined as 'mobile' or 'desktop'. See https://github.com/GoogleChrome/lighthouse/blob/main/docs/emulation.md");if(!e.screenEmulation.disabled&&e.screenEmulation.mobile!==("mobile"===e.formFactor))throw new Error(`Screen emulation mobile setting (${e.screenEmulation.mobile}) does not match formFactor setting (${e.formFactor}). See https://github.com/GoogleChrome/lighthouse/blob/main/docs/emulation.md`);let t=e.skipAudits?.find((t=>e.onlyAudits?.includes(t)));if(t)throw new Error(`${t} appears in both skipAudits and onlyAudits`)}function Yd(e){let t=new Set;for(let a of e)for(let e of a.artifacts)if(t.add(e.id),e.dependencies)for(let[a,{id:n}]of Object.entries(e.dependencies))t.has(n)||Zd(e.id,a)}function Jd(e){let{warnings:t}=Hd(e.navigations),a=new Set;for(let t of e.artifacts||[]){if(a.has(t.id))throw new Error(`Config defined multiple artifacts with id '${t.id}'`);a.add(t.id),Wd(t)}for(let t of e.audits||[])Gd(t);return $d(e.categories,e.audits,e.groups),Kd(e.settings),{warnings:t}}function Zd(e,t){throw new Error([`Failed to find dependency "${t}" for "${e}" artifact`,"Check that...",`  1. A gatherer exposes a matching Symbol that satisfies "${t}".`,`  2. "${t}" is configured to run before "${e}"`].join("\n"))}function Xd(e,t){throw new Error([`Dependency "${t}" for "${e}" artifact is invalid.`,"The dependency must be collected before the dependent."].join("\n"))}var Qd=s((()=>{J(),xr(),aa(),ro(),o(zd,"isValidArtifactDependency"),o(Vd,"assertValidPluginName"),o(Wd,"assertValidArtifact"),o(Hd,"assertValidNavigations"),o(Gd,"assertValidAudit"),o($d,"assertValidCategories"),o(Kd,"assertValidSettings"),o(Yd,"assertArtifactTopologicalOrder"),o(Jd,"assertValidConfig"),o(Zd,"throwInvalidDependencyOrder"),o(Xd,"throwInvalidArtifactDependency")}));function em(e,t){if(!e)return new Set;let a=(t=t||Object.keys(e)).map((t=>e[t])).flatMap((e=>e?.auditRefs||[]));return new Set(a.map((e=>e.id)))}function tm(e,t){if(!e)return null;if(!t)return e;let a=new Map(e.map((e=>[e.id,e]))),n=new Set([...gm,...t.flatMap((e=>e.implementation.meta.requiredArtifacts))]),r=0;for(;r!==n.size;){r=n.size;for(let e of n){let t=a.get(e);if(t&&t.dependencies)for(let e of Object.values(t.dependencies))n.add(e.id)}}return e.filter((e=>n.has(e.id)))}function am(e,t){return e?e.filter((e=>e.gatherer.instance.meta.supportedModes.includes(t))):null}function nm(e,t){if(!e)return e;let a=new Set(t.map((e=>e.id)).concat(pm));return e.map((e=>({...e,artifacts:e.artifacts.filter((e=>a.has(e.id)))}))).filter((e=>e.artifacts.length))}function rm(e,t){if(!e)return null;let a=new Set(t.map((e=>e.id)).concat(pm));return e.filter((e=>e.implementation.meta.requiredArtifacts.every((e=>a.has(e)))))}function im(e,t){return e?e.filter((e=>{let a=e.implementation.meta;return!a.supportedModes||a.supportedModes.includes(t)})):null}function om(e,t){if(!e)return null;let a=Object.entries(e).filter((([e,a])=>!a.supportedModes||a.supportedModes.includes(t)));return Object.fromEntries(a)}function sm(e,t){if(!e||!t)return e;let a=Object.entries(e).filter((([e])=>t.includes(e)));return Object.fromEntries(a)}function lm(e,t){if(t)for(let a of t)e?.[a]||Kt.warn("config",`unrecognized category in 'onlyCategories': ${a}`)}function cm(e,t){if(!e)return e;let a=new Map(t.map((e=>[e.implementation.meta.id,e.implementation.meta]))),n=Object.entries(e).map((([e,t])=>{let n={...t,auditRefs:t.auditRefs.filter((e=>a.has(e.id)))},r=n.auditRefs.length<t.auditRefs.length,i=n.auditRefs.every((e=>{let t=a.get(e.id);return!!t&&t.scoreDisplayMode===Dr.SCORING_MODES.MANUAL}));return r&&i&&(n.auditRefs=[]),[e,n]})).filter((e=>"object"==typeof e[1]&&e[1].auditRefs.length));return Object.fromEntries(n)}function um(e,t){let a=am(e.artifacts,t),n=rm(im(e.audits,t),a||[]),r=cm(om(e.categories,t),n||[]);return{...e,artifacts:a,audits:n,categories:r}}function dm(e,t){let{onlyAudits:a,onlyCategories:n,skipAudits:r}=t;lm(e.categories,n);let i=em(e.categories,void 0);n?i=em(e.categories,n):a?i=new Set:(!e.categories||!Object.keys(e.categories).length)&&(i=new Set(e.audits?.map((e=>e.implementation.meta.id))));let o=new Set([...i,...a||[],...hm].filter((e=>!r||!r.includes(e)))),s=o.size&&e.audits?e.audits.filter((e=>o.has(e.implementation.meta.id))):e.audits,l=sm(cm(e.categories,s||[]),n),c=tm(e.artifacts,s);c&&e.settings.disableFullPageScreenshot&&(c=c.filter((({id:e})=>"FullPageScreenshot"!==e)));let u=nm(e.navigations,c||[]);return{...e,artifacts:c,navigations:u,audits:s,categories:l}}var mm,pm,hm,gm,fm=s((()=>{J(),ea(),xr(),mm={fetchTime:"",LighthouseRunWarnings:"",BenchmarkIndex:"",BenchmarkIndexes:"",settings:"",Timing:"",URL:"",PageLoadError:"",HostFormFactor:"",HostUserAgent:"",GatherContext:""},pm=Object.keys(mm),hm=[],gm=["Stacks","NetworkUserAgent","FullPageScreenshot"],o(em,"getAuditIdsInCategories"),o(tm,"filterArtifactsByAvailableAudits"),o(am,"filterArtifactsByGatherMode"),o(nm,"filterNavigationsByAvailableArtifacts"),o(rm,"filterAuditsByAvailableArtifacts"),o(im,"filterAuditsByGatherMode"),o(om,"filterCategoriesByGatherMode"),o(sm,"filterCategoriesByExplicitFilters"),o(lm,"warnOnUnknownOnlyCategories"),o(cm,"filterCategoriesByAvailableAudits"),o(um,"filterConfigByGatherMode"),o(dm,"filterConfigByExplicitFilters")}));function ym(e){return Array.isArray(e)&&e.every(vm)}function vm(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)}function bm(e){return"number"==typeof e&&!isNaN(e)}var wm,Dm=s((()=>{J(),o(ym,"isArrayOfUnknownObjects"),o(vm,"isObjectOfUnknownProperties"),o(bm,"isNumber"),wm=class e{static{o(this,"Budget")}static assertNoExcessProperties(e,t){let a=Object.keys(e);if(a.length>0){let e=a.join(", ");throw new Error(`${t} has unrecognized properties: [${e}]`)}}static assertNoDuplicateStrings(e,t){let a=new Set;for(let n of e){if(a.has(n))throw new Error(`${t} has duplicate entry of type '${n}'`);a.add(n)}}static validateResourceBudget(t){let{resourceType:a,budget:n,...r}=t;e.assertNoExcessProperties(r,"Resource Budget");let i=["total","document","script","stylesheet","image","media","font","other","third-party"];if(!i.includes(a))throw new Error(`Invalid resource type: ${a}. \nValid resource types are: ${i.join(", ")}`);if(!bm(n))throw new Error(`Invalid budget: ${n}`);return{resourceType:a,budget:n}}static throwInvalidPathError(e,t){throw new Error(`Invalid path ${e}. ${t}\n'Path' should be specified using the 'robots.txt' format.\nLearn more about the 'robots.txt' format here:\nhttps://developers.google.com/search/reference/robots_txt#url-matching-based-on-path-values`)}static validatePath(e){if(void 0!==e)return"string"!=typeof e?void this.throwInvalidPathError(e,"Path should be a string."):(e.startsWith("/")?(e.match(/\*/g)||[]).length>1?this.throwInvalidPathError(e,"Path should only contain one '*'."):(e.match(/\$/g)||[]).length>1?this.throwInvalidPathError(e,"Path should only contain one '$' character."):e.includes("$")&&!e.endsWith("$")&&this.throwInvalidPathError(e,"'$' character should only occur at end of path."):this.throwInvalidPathError(e,"Path should start with '/'."),e)}static getMatchingBudget(e,t){if(null!==e&&void 0!==t)for(let a=e.length-1;a>=0;a--){let n=e[a];if(this.urlMatchesPattern(t,n.path))return n}}static urlMatchesPattern(e,t="/"){let a=new URL(e),n=a.pathname+a.search,r=t.includes("*"),i=t.includes("$");if(!r&&!i)return n.startsWith(t);if(!r&&i)return n===t.slice(0,-1);if(r&&!i){let[e,a]=t.split("*"),r=n.slice(e.length);return n.startsWith(e)&&r.includes(a)}if(r&&i){let[e,a]=t.split("*"),r=n.slice(e.length);return n.startsWith(e)&&r.endsWith(a.slice(0,-1))}return!1}static validateTimingBudget(t){let{metric:a,budget:n,...r}=t;e.assertNoExcessProperties(r,"Timing Budget");let i=["first-contentful-paint","interactive","first-meaningful-paint","max-potential-fid","total-blocking-time","speed-index","largest-contentful-paint","cumulative-layout-shift"];if(!i.includes(a))throw new Error(`Invalid timing metric: ${a}. \nValid timing metrics are: ${i.join(", ")}`);if(!bm(n))throw new Error(`Invalid budget: ${n}`);return{metric:a,budget:n}}static validateHostname(e){let t=`${e} is not a valid hostname.`;if(0===e.length)throw new Error(t);if(e.includes("/"))throw new Error(t);if(e.includes(":"))throw new Error(t);if(e.includes("*")&&(!e.startsWith("*.")||e.lastIndexOf("*")>0))throw new Error(t);return e}static validateHostnames(t){if(Array.isArray(t)&&t.every((e=>"string"==typeof e)))return t.map(e.validateHostname);if(void 0!==t)throw new Error("firstPartyHostnames should be defined as an array of strings.")}static initializeBudget(t){if(!ym(t=JSON.parse(JSON.stringify(t))))throw new Error("Budget file is not defined as an array of budgets.");return t.map(((t,a)=>{let n={},{path:r,options:i,resourceSizes:o,resourceCounts:s,timings:l,...c}=t;if(e.assertNoExcessProperties(c,"Budget"),n.path=e.validatePath(r),vm(i)){let{firstPartyHostnames:t,...a}=i;e.assertNoExcessProperties(a,"Options property"),n.options={},n.options.firstPartyHostnames=e.validateHostnames(t)}else if(void 0!==i)throw new Error(`Invalid options property in budget at index ${a}`);if(ym(o))n.resourceSizes=o.map(e.validateResourceBudget),e.assertNoDuplicateStrings(n.resourceSizes.map((e=>e.resourceType)),`budgets[${a}].resourceSizes`);else if(void 0!==o)throw new Error(`Invalid resourceSizes entry in budget at index ${a}`);if(ym(s))n.resourceCounts=s.map(e.validateResourceBudget),e.assertNoDuplicateStrings(n.resourceCounts.map((e=>e.resourceType)),`budgets[${a}].resourceCounts`);else if(void 0!==s)throw new Error(`Invalid resourceCounts entry in budget at index ${a}`);if(ym(l))n.timings=l.map(e.validateTimingBudget),e.assertNoDuplicateStrings(n.timings.map((e=>e.metric)),`budgets[${a}].timings`);else if(void 0!==l)throw new Error(`Invalid timings entry in budget at index ${a}`);return n}))}}}));function Em(e){return Array.isArray(e)&&e.every(Tm)}function Tm(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)}function Sm(e){return"string"==typeof e&&("navigation"===e||"timespan"===e||"snapshot"===e)}function Cm(e){return!!Array.isArray(e)&&e.every(Sm)}function km(e,t,a=""){a&&(a+=" ");let n=Object.keys(e);if(n.length>0){let e=n.join(", ");throw new Error(`${t} has unrecognized ${a}properties: [${e}]`)}}var xm,Am,_m,Rm=s((()=>{J(),ro(),o(Em,"isArrayOfUnknownObjects"),o(Tm,"isObjectOfUnknownProperties"),o(Sm,"objectIsGatherMode"),o(Cm,"isArrayOfGatherModes"),o(km,"assertNoExcessProperties"),xm=class e{static{o(this,"ConfigPlugin")}static _parseAuditsList(e,t){if(void 0!==e){if(!Em(e))throw new Error(`${t} has an invalid audits array.`);return e.map((e=>{let{path:a,...n}=e;if(km(n,t,"audit"),"string"!=typeof a)throw new Error(`${t} has a missing audit path.`);return{path:a}}))}}static _parseAuditRefsList(e,t){if(!Em(e))throw new Error(`${t} has no valid auditsRefs.`);return e.map((e=>{let{id:a,weight:n,group:r,...i}=e;if(km(i,t,"auditRef"),"string"!=typeof a)throw new Error(`${t} has an invalid auditRef id.`);if("number"!=typeof n)throw new Error(`${t} has an invalid auditRef weight.`);if("string"!=typeof r&&typeof r<"u")throw new Error(`${t} has an invalid auditRef group.`);return{id:a,weight:n,group:r&&`${t}-${r}`}}))}static _parseCategory(t,a){if(!Tm(t))throw new Error(`${a} has no valid category.`);let{title:n,description:r,manualDescription:i,auditRefs:o,supportedModes:s,...l}=t;if(km(l,a,"category"),!to(n))throw new Error(`${a} has an invalid category tile.`);if(!to(r)&&void 0!==r)throw new Error(`${a} has an invalid category description.`);if(!to(i)&&void 0!==i)throw new Error(`${a} has an invalid category manualDescription.`);if(!Cm(s)&&void 0!==s)throw new Error(`${a} supportedModes must be an array, valid array values are "navigation", "timespan", and "snapshot".`);return{title:n,auditRefs:e._parseAuditRefsList(o,a),description:r,manualDescription:i,supportedModes:s}}static _parseGroups(e,t){if(void 0===e)return;if(!Tm(e))throw new Error(`${t} groups json is not defined as an object.`);let a=Object.entries(e),n={};return a.forEach((([e,a])=>{if(!Tm(a))throw new Error(`${t} has a group not defined as an object.`);let{title:r,description:i,...o}=a;if(km(o,t,"group"),!to(r))throw new Error(`${t} has an invalid group title.`);if(!to(i)&&void 0!==i)throw new Error(`${t} has an invalid group description.`);n[`${t}-${e}`]={title:r,description:i}})),n}static parsePlugin(t,a){if(!Tm(t=JSON.parse(JSON.stringify(t))))throw new Error(`${a} is not defined as an object.`);let{audits:n,category:r,groups:i,...o}=t;return km(o,a),{audits:e._parseAuditsList(n,a),categories:{[a]:e._parseCategory(r,a)},groups:e._parseGroups(i,a)}}},Am=xm})),Fm=s((()=>{J(),ua(),ni(),_m='/*! axe v4.7.2\n * Copyright (c) 2023 Deque Systems, Inc.\n *\n * Your use of this Source Code Form is subject to the terms of the Mozilla Public\n * License, v. 2.0. If a copy of the MPL was not distributed with this\n * file, You can obtain one at http://mozilla.org/MPL/2.0/.\n *\n * This entire copyright notice must appear in every copy of this file you\n * distribute or in any file that contains substantial portions of this source\n * code.\n */\n!function e(t){var n=t,a=t.document;function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}var o=o||{};function u(e){this.name="SupportError",this.cause=e.cause,this.message="`".concat(e.cause,"` - feature unsupported in your environment."),e.ruleId&&(this.ruleId=e.ruleId,this.message+=" Skipping ".concat(this.ruleId," rule.")),this.stack=(new Error).stack}o.version="4.7.2","function"==typeof define&&define.amd&&define("axe-core",[],(function(){return o})),"object"===("undefined"==typeof module?"undefined":r(module))&&module.exports&&"function"==typeof e.toString&&(o.source="("+e.toString()+\')(typeof window === "object" ? window : this);\',module.exports=o),"function"==typeof t.getComputedStyle&&(t.axe=o),(u.prototype=Object.create(Error.prototype)).constructor=u;var i=["node"],l=["variant"],s=["matches"],c=["chromium"],d=["noImplicit"],p=["noPresentational"],f=["precision","format","inGamut"],D=["space"],m=["algorithm"],h=["method"],g=["maxDeltaE","deltaEMethod","steps","maxSteps"],b=["node"],v=["nodes"],y=["node"],F=["relatedNodes"],w=["environmentData"],E=["environmentData"],C=["node"],x=["environmentData"],A=["environmentData"],k=["environmentData"];function B(e,t,n){return(B=O()?Reflect.construct.bind():function(e,t,n){var a=[null];return a.push.apply(a,t),t=new(Function.bind.apply(e,a)),n&&N(t,n.prototype),t}).apply(null,arguments)}function T(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&N(e,t)}function N(e,t){return(N=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e})(e,t)}function R(e){var t=O();return function(){var n,a=S(e);n=t?(n=S(this).constructor,Reflect.construct(a,arguments,n)):a.apply(this,arguments),a=this;if(n&&("object"===r(n)||"function"==typeof n))return n;if(void 0!==n)throw new TypeError("Derived constructors may only return object or undefined");return _(a)}}function _(e){if(void 0===e)throw new ReferenceError("this hasn\'t been initialised - super() hasn\'t been called");return e}function O(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}function S(e){return(S=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function M(e,t,n){I(e,t),t.set(e,n)}function P(e,t){I(e,t),t.add(e)}function I(e,t){if(t.has(e))throw new TypeError("Cannot initialize the same private elements twice on an object")}function j(e,t){return(t=z(e,t,"get")).get?t.get.call(e):t.value}function L(e,t,n){if(t.has(e))return n;throw new TypeError("attempted to get private field on non-instance")}function q(e,t,n){if((t=z(e,t,"set")).set)t.set.call(e,n);else{if(!t.writable)throw new TypeError("attempted to set read only private field");t.value=n}}function z(e,t,n){if(t.has(e))return t.get(e);throw new TypeError("attempted to "+n+" private field on non-instance")}function V(e,t){if(null==e)return{};var n,a=function(e,t){if(null==e)return{};var n,a,r={},o=Object.keys(e);for(a=0;a<o.length;a++)n=o[a],0<=t.indexOf(n)||(r[n]=e[n]);return r}(e,t);if(Object.getOwnPropertySymbols)for(var r=Object.getOwnPropertySymbols(e),o=0;o<r.length;o++)n=r[o],0<=t.indexOf(n)||Object.prototype.propertyIsEnumerable.call(e,n)&&(a[n]=e[n]);return a}function $(e){return function(e){if(Array.isArray(e))return te(e)}(e)||H(e)||ee(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function H(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}function U(){return(U=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var n,a=arguments[t];for(n in a)Object.prototype.hasOwnProperty.call(a,n)&&(e[n]=a[n])}return e}).apply(this,arguments)}function G(e,t){return Y(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var a,r,o,u,i=[],l=!0,s=!1;try{if(o=(n=n.call(e)).next,0===t){if(Object(n)!==n)return;l=!1}else for(;!(l=(a=o.call(n)).done)&&(i.push(a.value),i.length!==t);l=!0);}catch(e){s=!0,r=e}finally{try{if(!l&&null!=n.return&&(u=n.return(),Object(u)!==u))return}finally{if(s)throw r}}return i}}(e,t)||ee(e,t)||W()}function W(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function Y(e){if(Array.isArray(e))return e}function K(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function X(e,t){for(var n=0;n<t.length;n++){var a=t[n];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,J(a.key),a)}}function Z(e,t,n){return t&&X(e.prototype,t),n&&X(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}function J(e){return e=function(e,t){if("object"!==r(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0===n)return String(e);if(n=n.call(e,"string"),"object"===r(n))throw new TypeError("@@toPrimitive must return a primitive value.");return n}(e),"symbol"===r(e)?e:String(e)}function Q(e,t){var n,a,r,o,u="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(u)return a=!(n=!0),{s:function(){u=u.call(e)},n:function(){var e=u.next();return n=e.done,e},e:function(e){a=!0,r=e},f:function(){try{n||null==u.return||u.return()}finally{if(a)throw r}}};if(Array.isArray(e)||(u=ee(e))||t&&e&&"number"==typeof e.length)return u&&(e=u),o=0,{s:t=function(){},n:function(){return o>=e.length?{done:!0}:{done:!1,value:e[o++]}},e:function(e){throw e},f:t};throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function ee(e,t){var n;if(e)return"string"==typeof e?te(e,t):"Map"===(n="Object"===(n=Object.prototype.toString.call(e).slice(8,-1))&&e.constructor?e.constructor.name:n)||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?te(e,t):void 0}function te(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,a=new Array(t);n<t;n++)a[n]=e[n];return a}function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function ne(e,t){return function(){return t||e((t={exports:{}}).exports,t),t.exports}}function ae(e,t){for(var n in t)de(e,n,{get:t[n],enumerable:!0})}function re(e){return function(e,t,n){if(t&&"object"===r(t)||"function"==typeof t){var a,o=Q(De(t));try{for(o.s();!(a=o.n()).done;)!function(){var r=a.value;fe.call(e,r)||"default"===r||de(e,r,{get:function(){return t[r]},enumerable:!(n=me(t,r))||n.enumerable})}()}catch(e){o.e(e)}finally{o.f()}}return e}((t=de(null!=e?ce(pe(e)):{},"default",e&&e.__esModule&&"default"in e?{get:function(){return e.default},enumerable:!0}:{value:e,enumerable:!0}),de(t,"__esModule",{value:!0})),e);var t}function oe(e,t,n){(t="symbol"!==r(t)?t+"":t)in e?de(e,t,{enumerable:!0,configurable:!0,writable:!0,value:n}):e[t]=n}var ue,ie,le,se,ce=Object.create,de=Object.defineProperty,pe=Object.getPrototypeOf,fe=Object.prototype.hasOwnProperty,De=Object.getOwnPropertyNames,me=Object.getOwnPropertyDescriptor,he=ne((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isIdentStart=function(e){return"a"<=e&&e<="z"||"A"<=e&&e<="Z"||"-"===e||"_"===e},e.isIdent=function(e){return"a"<=e&&e<="z"||"A"<=e&&e<="Z"||"0"<=e&&e<="9"||"-"===e||"_"===e},e.isHex=function(e){return"a"<=e&&e<="f"||"A"<=e&&e<="F"||"0"<=e&&e<="9"},e.escapeIdentifier=function(t){for(var n=t.length,a="",r=0;r<n;){var o=t.charAt(r);if(e.identSpecialChars[o])a+="\\\\"+o;else if("_"===o||"-"===o||"A"<=o&&o<="Z"||"a"<=o&&o<="z"||0!==r&&"0"<=o&&o<="9")a+=o;else{if(55296==(63488&(o=o.charCodeAt(0)))){var u=t.charCodeAt(r++);if(55296!=(64512&o)||56320!=(64512&u))throw Error("UCS-2(decode): illegal sequence");o=((1023&o)<<10)+(1023&u)+65536}a+="\\\\"+o.toString(16)+" "}r++}return a},e.escapeStr=function(t){for(var n,a=t.length,r="",o=0;o<a;){var u=t.charAt(o);\'"\'===u?u=\'\\\\"\':"\\\\"===u?u="\\\\\\\\":void 0!==(n=e.strReplacementsRev[u])&&(u=n),r+=u,o++}return\'"\'+r+\'"\'},e.identSpecialChars={"!":!0,\'"\':!0,"#":!0,$:!0,"%":!0,"&":!0,"\'":!0,"(":!0,")":!0,"*":!0,"+":!0,",":!0,".":!0,"/":!0,";":!0,"<":!0,"=":!0,">":!0,"?":!0,"@":!0,"[":!0,"\\\\":!0,"]":!0,"^":!0,"`":!0,"{":!0,"|":!0,"}":!0,"~":!0},e.strReplacementsRev={"\\n":"\\\\n","\\r":"\\\\r","\\t":"\\\\t","\\f":"\\\\f","\\v":"\\\\v"},e.singleQuoteEscapeChars={n:"\\n",r:"\\r",t:"\\t",f:"\\f","\\\\":"\\\\","\'":"\'"},e.doubleQuotesEscapeChars={n:"\\n",r:"\\r",t:"\\t",f:"\\f","\\\\":"\\\\",\'"\':\'"\'}})),ge=ne((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=he();e.parseCssSelector=function(e,n,a,r,o,u){var i=e.length,l="";function s(a,r){var o="";for(n++,l=e.charAt(n);n<i;){if(l===a)return n++,o;var u;if("\\\\"===l)if(n++,(l=e.charAt(n))===a)o+=a;else if(void 0!==(u=r[l]))o+=u;else{if(t.isHex(l)){var s=l;for(n++,l=e.charAt(n);t.isHex(l);)s+=l,n++,l=e.charAt(n);" "===l&&(n++,l=e.charAt(n)),o+=String.fromCharCode(parseInt(s,16));continue}o+=l}else o+=l;n++,l=e.charAt(n)}return o}function c(){var a="";for(l=e.charAt(n);n<i;){if(!t.isIdent(l)){if("\\\\"!==l)return a;if(i<=++n)throw Error("Expected symbol but end of file reached.");if(l=e.charAt(n),!t.identSpecialChars[l]&&t.isHex(l)){var r=l;for(n++,l=e.charAt(n);t.isHex(l);)r+=l,n++,l=e.charAt(n);" "===l&&(n++,l=e.charAt(n)),a+=String.fromCharCode(parseInt(r,16));continue}}a+=l,n++,l=e.charAt(n)}return a}function d(){for(l=e.charAt(n);" "===l||"\\t"===l||"\\n"===l||"\\r"===l||"\\f"===l;)n++,l=e.charAt(n)}function p(){var t=f();if(!t)return null;var a=t;for(l=e.charAt(n);","===l;){if(n++,d(),"selectors"!==a.type&&(a={type:"selectors",selectors:[t]}),!(t=f()))throw Error(\'Rule expected after ",".\');a.selectors.push(t)}return a}function f(){d();var t={type:"ruleSet"},a=D();if(!a)return null;for(var r=t;a&&(a.type="rule",r.rule=a,r=a,d(),l=e.charAt(n),!(i<=n||","===l||")"===l));)if(o[l]){var u=l;if(n++,d(),!(a=D()))throw Error(\'Rule expected after "\'+u+\'".\');a.nestingOperator=u}else(a=D())&&(a.nestingOperator=null);return t}function D(){for(var o=null;n<i;)if("*"===(l=e.charAt(n)))n++,(o=o||{}).tagName="*";else if(t.isIdentStart(l)||"\\\\"===l)(o=o||{}).tagName=c();else if("."===l)n++,((o=o||{}).classNames=o.classNames||[]).push(c());else if("#"===l)n++,(o=o||{}).id=c();else if("["===l){n++,d();var f={name:c()};if(d(),"]"===l)n++;else{var D="";if(r[l]&&(D=l,n++,l=e.charAt(n)),i<=n)throw Error(\'Expected "=" but end of file reached.\');if("="!==l)throw Error(\'Expected "=" but "\'+l+\'" found.\');f.operator=D+"=",n++,d();var m="";if(f.valueType="string",\'"\'===l)m=s(\'"\',t.doubleQuotesEscapeChars);else if("\'"===l)m=s("\'",t.singleQuoteEscapeChars);else if(u&&"$"===l)n++,m=c(),f.valueType="substitute";else{for(;n<i&&"]"!==l;)m+=l,n++,l=e.charAt(n);m=m.trim()}if(d(),i<=n)throw Error(\'Expected "]" but end of file reached.\');if("]"!==l)throw Error(\'Expected "]" but "\'+l+\'" found.\');n++,f.value=m}((o=o||{}).attrs=o.attrs||[]).push(f)}else{if(":"!==l)break;if(n++,f={name:D=c()},"("===l){n++;var h="";if(d(),"selector"===a[D])f.valueType="selector",h=p();else{if(f.valueType=a[D]||"string",\'"\'===l)h=s(\'"\',t.doubleQuotesEscapeChars);else if("\'"===l)h=s("\'",t.singleQuoteEscapeChars);else if(u&&"$"===l)n++,h=c(),f.valueType="substitute";else{for(;n<i&&")"!==l;)h+=l,n++,l=e.charAt(n);h=h.trim()}d()}if(i<=n)throw Error(\'Expected ")" but end of file reached.\');if(")"!==l)throw Error(\'Expected ")" but "\'+l+\'" found.\');n++,f.value=h}((o=o||{}).pseudos=o.pseudos||[]).push(f)}return o}var m=p();if(n<i)throw Error(\'Rule expected but "\'+e.charAt(n)+\'" found.\');return m}})),be=ne((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=he();e.renderEntity=function e(n){var a="";switch(n.type){case"ruleSet":for(var r=n.rule,o=[];r;)r.nestingOperator&&o.push(r.nestingOperator),o.push(e(r)),r=r.rule;a=o.join(" ");break;case"selectors":a=n.selectors.map(e).join(", ");break;case"rule":n.tagName&&(a="*"===n.tagName?"*":t.escapeIdentifier(n.tagName)),n.id&&(a+="#"+t.escapeIdentifier(n.id)),n.classNames&&(a+=n.classNames.map((function(e){return"."+t.escapeIdentifier(e)})).join("")),n.attrs&&(a+=n.attrs.map((function(e){return"operator"in e?"substitute"===e.valueType?"["+t.escapeIdentifier(e.name)+e.operator+"$"+e.value+"]":"["+t.escapeIdentifier(e.name)+e.operator+t.escapeStr(e.value)+"]":"["+t.escapeIdentifier(e.name)+"]"})).join("")),n.pseudos&&(a+=n.pseudos.map((function(n){return n.valueType?"selector"===n.valueType?":"+t.escapeIdentifier(n.name)+"("+e(n.value)+")":"substitute"===n.valueType?":"+t.escapeIdentifier(n.name)+"($"+n.value+")":"numeric"===n.valueType?":"+t.escapeIdentifier(n.name)+"("+n.value+")":":"+t.escapeIdentifier(n.name)+"("+t.escapeIdentifier(n.value)+")":":"+t.escapeIdentifier(n.name)})).join(""));break;default:throw Error(\'Unknown entity type: "\'+n.type+\'".\')}return a}})),ve=ne((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=ge(),n=be();function a(){this.pseudos={},this.attrEqualityMods={},this.ruleNestingOperators={},this.substitutesEnabled=!1}a.prototype.registerSelectorPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.pseudos[a[n]]="selector";return this},a.prototype.unregisterSelectorPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.pseudos[a[n]];return this},a.prototype.registerNumericPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.pseudos[a[n]]="numeric";return this},a.prototype.unregisterNumericPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.pseudos[a[n]];return this},a.prototype.registerNestingOperators=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.ruleNestingOperators[a[n]]=!0;return this},a.prototype.unregisterNestingOperators=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.ruleNestingOperators[a[n]];return this},a.prototype.registerAttrEqualityMods=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.attrEqualityMods[a[n]]=!0;return this},a.prototype.unregisterAttrEqualityMods=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.attrEqualityMods[a[n]];return this},a.prototype.enableSubstitutes=function(){return this.substitutesEnabled=!0,this},a.prototype.disableSubstitutes=function(){return this.substitutesEnabled=!1,this},a.prototype.parse=function(e){return t.parseCssSelector(e,0,this.pseudos,this.attrEqualityMods,this.ruleNestingOperators,this.substitutesEnabled)},a.prototype.render=function(e){return n.renderEntity(e).trim()},e.CssSelectorParser=a})),ye=ne((function(e,t){"use strict";t.exports=function(){}})),Fe=ne((function(e,t){"use strict";var n=ye()();t.exports=function(e){return e!==n&&null!==e}})),we=ne((function(e,t){"use strict";var n=Fe(),a=Array.prototype.forEach,r=Object.create;t.exports=function(e){var t=r(null);return a.call(arguments,(function(e){if(n(e)){var a,r=Object(e),o=t;for(a in r)o[a]=r[a]}})),t}})),Ee=ne((function(e,t){"use strict";t.exports=function(){var e=Math.sign;return"function"==typeof e&&1===e(10)&&-1===e(-20)}})),Ce=ne((function(e,t){"use strict";t.exports=function(e){return e=Number(e),isNaN(e)||0===e?e:0<e?1:-1}})),xe=ne((function(e,t){"use strict";t.exports=Ee()()?Math.sign:Ce()})),Ae=ne((function(e,t){"use strict";var n=xe(),a=Math.abs,r=Math.floor;t.exports=function(e){return isNaN(e)?0:0!==(e=Number(e))&&isFinite(e)?n(e)*r(a(e)):e}})),ke=ne((function(e,t){"use strict";var n=Ae(),a=Math.max;t.exports=function(e){return a(0,n(e))}})),Be=ne((function(e,t){"use strict";var n=ke();t.exports=function(e,t,a){return isNaN(e)?0<=t?a&&t?t-1:t:1:!1!==e&&n(e)}})),Te=ne((function(e,t){"use strict";t.exports=function(e){if("function"!=typeof e)throw new TypeError(e+" is not a function");return e}})),Ne=ne((function(e,t){"use strict";var n=Fe();t.exports=function(e){if(n(e))return e;throw new TypeError("Cannot use null or undefined")}})),Re=ne((function(e,t){"use strict";var n=Te(),a=Ne(),r=Function.prototype.bind,o=Function.prototype.call,u=Object.keys,i=Object.prototype.propertyIsEnumerable;t.exports=function(e,t){return function(l,s){var c,d=arguments[2],p=arguments[3];return l=Object(a(l)),n(s),c=u(l),p&&c.sort("function"==typeof p?r.call(p,l):void 0),"function"!=typeof e&&(e=c[e]),o.call(e,c,(function(e,n){return i.call(l,e)?o.call(s,d,l[e],e,l,n):t}))}}})),_e=ne((function(e,t){"use strict";t.exports=Re()("forEach")})),Oe=ne((function(){})),Se=ne((function(e,t){"use strict";t.exports=function(){var e=Object.assign;return"function"==typeof e&&(e(e={foo:"raz"},{bar:"dwa"},{trzy:"trzy"}),e.foo+e.bar+e.trzy==="razdwatrzy")}})),Me=ne((function(e,t){"use strict";t.exports=function(){try{return Object.keys("primitive"),!0}catch(e){return!1}}})),Pe=ne((function(e,t){"use strict";var n=Fe(),a=Object.keys;t.exports=function(e){return a(n(e)?Object(e):e)}})),Ie=ne((function(e,t){"use strict";t.exports=Me()()?Object.keys:Pe()})),je=ne((function(e,t){"use strict";var n=Ie(),a=Ne(),r=Math.max;t.exports=function(e,t){var o,u,i,l=r(arguments.length,2);for(e=Object(a(e)),i=function(n){try{e[n]=t[n]}catch(n){o=o||n}},u=1;u<l;++u)n(t=arguments[u]).forEach(i);if(void 0!==o)throw o;return e}})),Le=ne((function(e,t){"use strict";t.exports=Se()()?Object.assign:je()})),qe=ne((function(e,t){"use strict";var n=Fe(),a={function:!0,object:!0};t.exports=function(e){return n(e)&&a[r(e)]||!1}})),ze=ne((function(e,t){"use strict";var n=Le(),a=qe(),r=Fe(),o=Error.captureStackTrace;t.exports=function(e){e=new Error(e);var u=arguments[1],i=arguments[2];return r(i)||a(u)&&(i=u,u=null),r(i)&&n(e,i),r(u)&&(e.code=u),o&&o(e,t.exports),e}})),Ve=ne((function(e,t){"use strict";var n=Ne(),a=Object.defineProperty,r=Object.getOwnPropertyDescriptor,o=Object.getOwnPropertyNames,u=Object.getOwnPropertySymbols;t.exports=function(e,t){var i,l=Object(n(t));if(e=Object(n(e)),o(l).forEach((function(n){try{a(e,n,r(t,n))}catch(n){i=n}})),"function"==typeof u&&u(l).forEach((function(n){try{a(e,n,r(t,n))}catch(n){i=n}})),void 0!==i)throw i;return e}})),$e=ne((function(e,t){"use strict";function n(e,t){return t}var a,r,o,u,i,l=ke();try{Object.defineProperty(n,"length",{configurable:!0,writable:!1,enumerable:!1,value:1})}catch(e){}1===n.length?(a={configurable:!0,writable:!1,enumerable:!1},r=Object.defineProperty,t.exports=function(e,t){return t=l(t),e.length===t?e:(a.value=t,r(e,"length",a))}):(u=Ve(),i=[],o=function(e){var t,n=0;if(i[e])return i[e];for(t=[];e--;)t.push("a"+(++n).toString(36));return new Function("fn","return function ("+t.join(", ")+") { return fn.apply(this, arguments); };")},t.exports=function(e,t){if(t=l(t),e.length===t)return e;t=o(t)(e);try{u(t,e)}catch(e){}return t})})),He=ne((function(e,t){"use strict";t.exports=function(e){return null!=e}})),Ue=ne((function(e,t){"use strict";var n=He(),a={object:!0,function:!0,undefined:!0};t.exports=function(e){return!!n(e)&&hasOwnProperty.call(a,r(e))}})),Ge=ne((function(e,t){"use strict";var n=Ue();t.exports=function(e){if(!n(e))return!1;try{return!!e.constructor&&e.constructor.prototype===e}catch(e){return!1}}})),We=ne((function(e,t){"use strict";var n=Ge();t.exports=function(e){if("function"!=typeof e)return!1;if(!hasOwnProperty.call(e,"length"))return!1;try{if("number"!=typeof e.length)return!1;if("function"!=typeof e.call)return!1;if("function"!=typeof e.apply)return!1}catch(e){return!1}return!n(e)}})),Ye=ne((function(e,t){"use strict";var n=We(),a=/^\\s*class[\\s{/}]/,r=Function.prototype.toString;t.exports=function(e){return!!n(e)&&!a.test(r.call(e))}})),Ke=ne((function(e,t){"use strict";var n="razdwatrzy";t.exports=function(){return"function"==typeof n.contains&&!0===n.contains("dwa")&&!1===n.contains("foo")}})),Xe=ne((function(e,t){"use strict";var n=String.prototype.indexOf;t.exports=function(e){return-1<n.call(this,e,arguments[1])}})),Ze=ne((function(e,t){"use strict";t.exports=Ke()()?String.prototype.contains:Xe()})),Je=ne((function(e,t){"use strict";var n=He(),a=Ye(),r=Le(),o=we(),u=Ze();(t.exports=function(e,t){var a,i,l,s;return arguments.length<2||"string"!=typeof e?(s=t,t=e,e=null):s=arguments[2],n(e)?(a=u.call(e,"c"),i=u.call(e,"e"),l=u.call(e,"w")):i=!(a=l=!0),e={value:t,configurable:a,enumerable:i,writable:l},s?r(o(s),e):e}).gs=function(e,t,i){var l,s;return"string"!=typeof e?(s=i,i=t,t=e,e=null):s=arguments[3],n(t)?a(t)?n(i)?a(i)||(s=i,i=void 0):i=void 0:(s=t,t=i=void 0):t=void 0,e=n(e)?(l=u.call(e,"c"),u.call(e,"e")):!(l=!0),t={get:t,set:i,configurable:l,enumerable:e},s?r(o(s),t):t}})),Qe=ne((function(e,t){"use strict";var n=Je(),a=Te(),o=Function.prototype.apply,u=Function.prototype.call,i=Object.create,l=Object.defineProperty,s=Object.defineProperties,c=Object.prototype.hasOwnProperty,d={configurable:!0,enumerable:!1,writable:!0},p=function(e,t){var n;return a(t),c.call(this,"__ee__")?n=this.__ee__:(n=d.value=i(null),l(this,"__ee__",d),d.value=null),n[e]?"object"===r(n[e])?n[e].push(t):n[e]=[n[e],t]:n[e]=t,this},f=function(e,t){var n,r;return a(t),r=this,p.call(this,e,n=function(){D.call(r,e,n),o.call(t,this,arguments)}),n.__eeOnceListener__=t,this},D=function(e,t){var n,o,u,i;if(a(t),c.call(this,"__ee__")&&(n=this.__ee__)[e])if(o=n[e],"object"===r(o))for(i=0;u=o[i];++i)u!==t&&u.__eeOnceListener__!==t||(2===o.length?n[e]=o[i?0:1]:o.splice(i,1));else o!==t&&o.__eeOnceListener__!==t||delete n[e];return this},m=function(e){var t,n,a,i,l;if(c.call(this,"__ee__")&&(i=this.__ee__[e]))if("object"===r(i)){for(n=arguments.length,l=new Array(n-1),t=1;t<n;++t)l[t-1]=arguments[t];for(i=i.slice(),t=0;a=i[t];++t)o.call(a,this,l)}else switch(arguments.length){case 1:u.call(i,this);break;case 2:u.call(i,this,arguments[1]);break;case 3:u.call(i,this,arguments[1],arguments[2]);break;default:for(n=arguments.length,l=new Array(n-1),t=1;t<n;++t)l[t-1]=arguments[t];o.call(i,this,l)}},h={on:p,once:f,off:D,emit:m},g={on:n(p),once:n(f),off:n(D),emit:n(m)},b=s({},g);t.exports=e=function(e){return null==e?i(b):s(Object(e),g)},e.methods=h})),et=ne((function(e,t){"use strict";t.exports=function(){var e,t=Array.from;return"function"==typeof t&&(e=t(t=["raz","dwa"]),Boolean(e&&e!==t&&"dwa"===e[1]))}})),tt=ne((function(e,t){"use strict";t.exports=function(){return"object"===("undefined"==typeof globalThis?"undefined":r(globalThis))&&!!globalThis&&globalThis.Array===Array}})),nt=ne((function(e,n){function a(){if("object"===("undefined"==typeof self?"undefined":r(self))&&self)return self;if("object"===(void 0===t?"undefined":r(t))&&t)return t;throw new Error("Unable to resolve global `this`")}n.exports=function(){if(this)return this;try{Object.defineProperty(Object.prototype,"__global__",{get:function(){return this},configurable:!0})}catch(e){return a()}try{return __global__||a()}finally{delete Object.prototype.__global__}}()})),at=ne((function(e,t){"use strict";t.exports=tt()()?globalThis:nt()})),rt=ne((function(e,t){"use strict";var n=at(),a={object:!0,symbol:!0};t.exports=function(){var e,t=n.Symbol;if("function"!=typeof t)return!1;e=t("test symbol");try{String(e)}catch(e){return!1}return!!a[r(t.iterator)]&&!!a[r(t.toPrimitive)]&&!!a[r(t.toStringTag)]}})),ot=ne((function(e,t){"use strict";t.exports=function(e){return!!e&&("symbol"===r(e)||!!e.constructor&&"Symbol"===e.constructor.name&&"Symbol"===e[e.constructor.toStringTag])}})),ut=ne((function(e,t){"use strict";var n=ot();t.exports=function(e){if(n(e))return e;throw new TypeError(e+" is not a symbol")}})),it=ne((function(e,t){"use strict";var n=Je(),a=Object.create,r=Object.defineProperty,o=Object.prototype,u=a(null);t.exports=function(e){for(var t,a,i=0;u[e+(i||"")];)++i;return u[e+=i||""]=!0,r(o,t="@@"+e,n.gs(null,(function(e){a||(a=!0,r(this,t,n(e)),a=!1)}))),t}})),lt=ne((function(e,t){"use strict";var n=Je(),a=at().Symbol;t.exports=function(e){return Object.defineProperties(e,{hasInstance:n("",a&&a.hasInstance||e("hasInstance")),isConcatSpreadable:n("",a&&a.isConcatSpreadable||e("isConcatSpreadable")),iterator:n("",a&&a.iterator||e("iterator")),match:n("",a&&a.match||e("match")),replace:n("",a&&a.replace||e("replace")),search:n("",a&&a.search||e("search")),species:n("",a&&a.species||e("species")),split:n("",a&&a.split||e("split")),toPrimitive:n("",a&&a.toPrimitive||e("toPrimitive")),toStringTag:n("",a&&a.toStringTag||e("toStringTag")),unscopables:n("",a&&a.unscopables||e("unscopables"))})}})),st=ne((function(e,t){"use strict";var n=Je(),a=ut(),r=Object.create(null);t.exports=function(e){return Object.defineProperties(e,{for:n((function(t){return r[t]||(r[t]=e(String(t)))})),keyFor:n((function(e){for(var t in a(e),r)if(r[t]===e)return t}))})}})),ct=ne((function(e,t){"use strict";var n,a,o,u=Je(),i=ut(),l=at().Symbol,s=it(),c=lt(),d=st(),p=Object.create,f=Object.defineProperties,D=Object.defineProperty;if("function"==typeof l)try{String(l()),o=!0}catch(e){}else l=null;a=function(e){if(this instanceof a)throw new TypeError("Symbol is not a constructor");return n(e)},t.exports=n=function e(t){var n;if(this instanceof e)throw new TypeError("Symbol is not a constructor");return o?l(t):(n=p(a.prototype),t=void 0===t?"":String(t),f(n,{__description__:u("",t),__name__:u("",s(t))}))},c(n),d(n),f(a.prototype,{constructor:u(n),toString:u("",(function(){return this.__name__}))}),f(n.prototype,{toString:u((function(){return"Symbol ("+i(this).__description__+")"})),valueOf:u((function(){return i(this)}))}),D(n.prototype,n.toPrimitive,u("",(function(){var e=i(this);return"symbol"===r(e)?e:e.toString()}))),D(n.prototype,n.toStringTag,u("c","Symbol")),D(a.prototype,n.toStringTag,u("c",n.prototype[n.toStringTag])),D(a.prototype,n.toPrimitive,u("c",n.prototype[n.toPrimitive]))})),dt=ne((function(e,t){"use strict";t.exports=rt()()?at().Symbol:ct()})),pt=ne((function(e,t){"use strict";var n=Object.prototype.toString,a=n.call(function(){return arguments}());t.exports=function(e){return n.call(e)===a}})),ft=ne((function(e,t){"use strict";var n=Object.prototype.toString,a=RegExp.prototype.test.bind(/^[object [A-Za-z0-9]*Function]$/);t.exports=function(e){return"function"==typeof e&&a(n.call(e))}})),Dt=ne((function(e,t){"use strict";var n=Object.prototype.toString,a=n.call("");t.exports=function(e){return"string"==typeof e||e&&"object"===r(e)&&(e instanceof String||n.call(e)===a)||!1}})),mt=ne((function(e,t){"use strict";var n=dt().iterator,a=pt(),r=ft(),o=ke(),u=Te(),i=Ne(),l=Fe(),s=Dt(),c=Array.isArray,d=Function.prototype.call,p={configurable:!0,enumerable:!0,writable:!0,value:null},f=Object.defineProperty;t.exports=function(e){var t,D,m,h,g,b,v,y,F,w,E=arguments[1],C=arguments[2];if(e=Object(i(e)),l(E)&&u(E),this&&this!==Array&&r(this))t=this;else{if(!E){if(a(e))return 1!==(g=e.length)?Array.apply(null,e):((h=new Array(1))[0]=e[0],h);if(c(e)){for(h=new Array(g=e.length),D=0;D<g;++D)h[D]=e[D];return h}}h=[]}if(!c(e))if(void 0!==(F=e[n])){for(v=u(F).call(e),t&&(h=new t),y=v.next(),D=0;!y.done;)w=E?d.call(E,C,y.value,D):y.value,t?(p.value=w,f(h,D,p)):h[D]=w,y=v.next(),++D;g=D}else if(s(e)){for(g=e.length,t&&(h=new t),m=D=0;D<g;++D)w=e[D],D+1<g&&55296<=(b=w.charCodeAt(0))&&b<=56319&&(w+=e[++D]),w=E?d.call(E,C,w,m):w,t?(p.value=w,f(h,m,p)):h[m]=w,++m;g=m}if(void 0===g)for(g=o(e.length),t&&(h=new t(g)),D=0;D<g;++D)w=E?d.call(E,C,e[D],D):e[D],t?(p.value=w,f(h,D,p)):h[D]=w;return t&&(p.value=null,h.length=g),h}})),ht=ne((function(e,t){"use strict";t.exports=et()()?Array.from:mt()})),gt=ne((function(e,t){"use strict";var n=ht(),a=Array.isArray;t.exports=function(e){return a(e)?e:n(e)}})),bt=ne((function(e,t){"use strict";var n=gt(),a=Fe(),r=Te(),o=Array.prototype.slice,u=function(e){return this.map((function(t,n){return t?t(e[n]):e[n]})).concat(o.call(e,this.length))};t.exports=function(e){return(e=n(e)).forEach((function(e){a(e)&&r(e)})),u.bind(e)}})),vt=ne((function(e,t){"use strict";var n=Te();t.exports=function(e){var t;return"function"==typeof e?{set:e,get:e}:(t={get:n(e.get)},void 0!==e.set?(t.set=n(e.set),e.delete&&(t.delete=n(e.delete)),e.clear&&(t.clear=n(e.clear))):t.set=t.get,t)}})),yt=ne((function(e,t){"use strict";var n=ze(),a=$e(),r=Je(),o=Qe().methods,u=bt(),i=vt(),l=Function.prototype.apply,s=Function.prototype.call,c=Object.create,d=Object.defineProperties,p=o.on,f=o.emit;t.exports=function(e,t,o){var D,m,h,g,b,v,y,F,w,E,C,x=c(null),A=!1!==t?t:isNaN(e.length)?1:e.length;return o.normalizer&&(E=i(o.normalizer),m=E.get,h=E.set,g=E.delete,b=E.clear),null!=o.resolvers&&(C=u(o.resolvers)),E=m?a((function(t){var a,r,o=arguments;if(C&&(o=C(o)),null!==(a=m(o))&&hasOwnProperty.call(x,a))return y&&D.emit("get",a,o,this),x[a];if(r=1===o.length?s.call(e,this,o[0]):l.call(e,this,o),null===a){if(null!==(a=m(o)))throw n("Circular invocation","CIRCULAR_INVOCATION");a=h(o)}else if(hasOwnProperty.call(x,a))throw n("Circular invocation","CIRCULAR_INVOCATION");return x[a]=r,F&&D.emit("set",a,null,r),r}),A):0===t?function(){var t;if(hasOwnProperty.call(x,"data"))return y&&D.emit("get","data",arguments,this),x.data;if(t=arguments.length?l.call(e,this,arguments):s.call(e,this),hasOwnProperty.call(x,"data"))throw n("Circular invocation","CIRCULAR_INVOCATION");return x.data=t,F&&D.emit("set","data",null,t),t}:function(t){var a,r=arguments;if(C&&(r=C(arguments)),a=String(r[0]),hasOwnProperty.call(x,a))return y&&D.emit("get",a,r,this),x[a];if(r=1===r.length?s.call(e,this,r[0]):l.call(e,this,r),hasOwnProperty.call(x,a))throw n("Circular invocation","CIRCULAR_INVOCATION");return x[a]=r,F&&D.emit("set",a,null,r),r},D={original:e,memoized:E,profileName:o.profileName,get:function(e){return C&&(e=C(e)),m?m(e):String(e[0])},has:function(e){return hasOwnProperty.call(x,e)},delete:function(e){var t;hasOwnProperty.call(x,e)&&(g&&g(e),t=x[e],delete x[e],w)&&D.emit("delete",e,t)},clear:function(){var e=x;b&&b(),x=c(null),D.emit("clear",e)},on:function(e,t){return"get"===e?y=!0:"set"===e?F=!0:"delete"===e&&(w=!0),p.call(this,e,t)},emit:f,updateEnv:function(){e=D.original}},o=m?a((function(e){var t=arguments;C&&(t=C(t)),null!==(t=m(t))&&D.delete(t)}),A):0===t?function(){return D.delete("data")}:function(e){return C&&(e=C(arguments)[0]),D.delete(e)},A=a((function(){var e=arguments;return 0===t?x.data:(C&&(e=C(e)),e=m?m(e):String(e[0]),x[e])})),v=a((function(){var e=arguments;return 0===t?D.has("data"):(C&&(e=C(e)),null!==(e=m?m(e):String(e[0]))&&D.has(e))})),d(E,{__memoized__:r(!0),delete:r(o),clear:r(D.clear),_get:r(A),_has:r(v)}),D}})),Ft=ne((function(e,t){"use strict";var n=Te(),a=_e(),r=Oe(),o=yt(),u=Be();t.exports=function e(t){var i,l,s;if(n(t),(i=Object(arguments[1])).async&&i.promise)throw new Error("Options \'async\' and \'promise\' cannot be used together");return hasOwnProperty.call(t,"__memoized__")&&!i.force?t:(l=u(i.length,t.length,i.async&&r.async),s=o(t,l,i),a(r,(function(e,t){i[t]&&e(i[t],s,i)})),e.__profiler__&&e.__profiler__(s),s.updateEnv(),s.memoized)}})),wt=ne((function(e,t){"use strict";t.exports=function(e){var t,n,a=e.length;if(!a)return"";for(t=String(e[n=0]);--a;)t+=""+e[++n];return t}})),Et=ne((function(e,t){"use strict";t.exports=function(e){return e?function(t){for(var n=String(t[0]),a=0,r=e;--r;)n+=""+t[++a];return n}:function(){return""}}})),Ct=ne((function(e,t){"use strict";t.exports=function(){var e=Number.isNaN;return"function"==typeof e&&!e({})&&e(NaN)&&!e(34)}})),xt=ne((function(e,t){"use strict";t.exports=function(e){return e!=e}})),At=ne((function(e,t){"use strict";t.exports=Ct()()?Number.isNaN:xt()})),kt=ne((function(e,t){"use strict";var n=At(),a=ke(),r=Ne(),o=Array.prototype.indexOf,u=Object.prototype.hasOwnProperty,i=Math.abs,l=Math.floor;t.exports=function(e){var t,s,c;if(!n(e))return o.apply(this,arguments);for(s=a(r(this).length),e=arguments[1],t=e=isNaN(e)?0:0<=e?l(e):a(this.length)-l(i(e));t<s;++t)if(u.call(this,t)&&(c=this[t],n(c)))return t;return-1}})),Bt=ne((function(e,t){"use strict";var n=kt(),a=Object.create;t.exports=function(){var e=0,t=[],r=a(null);return{get:function(e){var a,r=0,o=t,u=e.length;if(0===u)return o[u]||null;if(o=o[u]){for(;r<u-1;){if(-1===(a=n.call(o[0],e[r])))return null;o=o[1][a],++r}return-1===(a=n.call(o[0],e[r]))?null:o[1][a]||null}return null},set:function(a){var o,u=0,i=t,l=a.length;if(0===l)i[l]=++e;else{for(i[l]||(i[l]=[[],[]]),i=i[l];u<l-1;)-1===(o=n.call(i[0],a[u]))&&(o=i[0].push(a[u])-1,i[1].push([[],[]])),i=i[1][o],++u;-1===(o=n.call(i[0],a[u]))&&(o=i[0].push(a[u])-1),i[1][o]=++e}return r[e]=a,e},delete:function(e){var a,o=0,u=t,i=r[e],l=i.length,s=[];if(0===l)delete u[l];else if(u=u[l]){for(;o<l-1;){if(-1===(a=n.call(u[0],i[o])))return;s.push(u,a),u=u[1][a],++o}if(-1===(a=n.call(u[0],i[o])))return;for(e=u[1][a],u[0].splice(a,1),u[1].splice(a,1);!u[0].length&&s.length;)a=s.pop(),(u=s.pop())[0].splice(a,1),u[1].splice(a,1)}delete r[e]},clear:function(){t=[],r=a(null)}}}})),Tt=ne((function(e,t){"use strict";var n=kt();t.exports=function(){var e=0,t=[],a=[];return{get:function(e){return-1===(e=n.call(t,e[0]))?null:a[e]},set:function(n){return t.push(n[0]),a.push(++e),e},delete:function(e){-1!==(e=n.call(a,e))&&(t.splice(e,1),a.splice(e,1))},clear:function(){t=[],a=[]}}}})),Nt=ne((function(e,t){"use strict";var n=kt(),a=Object.create;t.exports=function(e){var t=0,r=[[],[]],o=a(null);return{get:function(t){for(var a,o=0,u=r;o<e-1;){if(-1===(a=n.call(u[0],t[o])))return null;u=u[1][a],++o}return-1!==(a=n.call(u[0],t[o]))&&u[1][a]||null},set:function(a){for(var u,i=0,l=r;i<e-1;)-1===(u=n.call(l[0],a[i]))&&(u=l[0].push(a[i])-1,l[1].push([[],[]])),l=l[1][u],++i;return-1===(u=n.call(l[0],a[i]))&&(u=l[0].push(a[i])-1),l[1][u]=++t,o[t]=a,t},delete:function(t){for(var a,u=0,i=r,l=[],s=o[t];u<e-1;){if(-1===(a=n.call(i[0],s[u])))return;l.push(i,a),i=i[1][a],++u}if(-1!==(a=n.call(i[0],s[u]))){for(t=i[1][a],i[0].splice(a,1),i[1].splice(a,1);!i[0].length&&l.length;)a=l.pop(),(i=l.pop())[0].splice(a,1),i[1].splice(a,1);delete o[t]}},clear:function(){r=[[],[]],o=a(null)}}}})),Rt=ne((function(e,t){"use strict";var n=Te(),a=_e(),r=Function.prototype.call;t.exports=function(e,t){var o={},u=arguments[2];return n(t),a(e,(function(e,n,a,i){o[n]=r.call(t,u,e,n,a,i)})),o}})),_t=ne((function(e,t){"use strict";function n(e){if("function"!=typeof e)throw new TypeError(e+" is not a function");return e}function o(e){var t,r,o=a.createTextNode(""),u=0;return new e((function(){var e;if(t)r&&(t=r.concat(t));else{if(!r)return;t=r}if(r=t,t=null,"function"==typeof r)e=r,r=null,e();else for(o.data=u=++u%2;r;)e=r.shift(),r.length||(r=null),e()})).observe(o,{characterData:!0}),function(e){n(e),t?"function"==typeof t?t=[t,e]:t.push(e):(t=e,o.data=u=++u%2)}}t.exports=function(){if("object"===("undefined"==typeof process?"undefined":r(process))&&process&&"function"==typeof process.nextTick)return process.nextTick;if("function"==typeof queueMicrotask)return function(e){queueMicrotask(n(e))};if("object"===(void 0===a?"undefined":r(a))&&a){if("function"==typeof MutationObserver)return o(MutationObserver);if("function"==typeof WebKitMutationObserver)return o(WebKitMutationObserver)}return"function"==typeof setImmediate?function(e){setImmediate(n(e))}:"function"==typeof setTimeout||"object"===("undefined"==typeof setTimeout?"undefined":r(setTimeout))?function(e){setTimeout(n(e),0)}:null}()})),Ot=ne((function(){"use strict";var e=ht(),t=Rt(),n=Ve(),a=$e(),r=_t(),o=Array.prototype.slice,u=Function.prototype.apply,i=Object.create;Oe().async=function(l,s){var c,d,p,f=i(null),D=i(null),m=s.memoized,h=s.original;s.memoized=a((function(e){var t=arguments,n=t[t.length-1];return"function"==typeof n&&(c=n,t=o.call(t,0,-1)),m.apply(d=this,p=t)}),m);try{n(s.memoized,m)}catch(l){}s.on("get",(function(e){var t,n,a;c&&(f[e]?("function"==typeof f[e]?f[e]=[f[e],c]:f[e].push(c),c=null):(t=c,n=d,a=p,c=d=p=null,r((function(){var r;hasOwnProperty.call(D,e)?(r=D[e],s.emit("getasync",e,a,n),u.call(t,r.context,r.args)):(c=t,d=n,p=a,m.apply(n,a))}))))})),s.original=function(){var t,n,a,o;return c?(t=e(arguments),a=c,c=d=p=null,t.push(n=function t(n){var a,i,l=t.id;if(null==l)r(u.bind(t,this,arguments));else if(delete t.id,a=f[l],delete f[l],a)return i=e(arguments),s.has(l)&&(n?s.delete(l):(D[l]={context:this,args:i},s.emit("setasync",l,"function"==typeof a?1:a.length))),"function"==typeof a?o=u.call(a,this,i):a.forEach((function(e){o=u.call(e,this,i)}),this),o}),o=u.call(h,this,t),n.cb=a,c=n,o):u.call(h,this,arguments)},s.on("set",(function(e){c?(f[e]?"function"==typeof f[e]?f[e]=[f[e],c.cb]:f[e].push(c.cb):f[e]=c.cb,delete c.cb,c.id=e,c=null):s.delete(e)})),s.on("delete",(function(e){var t;hasOwnProperty.call(f,e)||D[e]&&(t=D[e],delete D[e],s.emit("deleteasync",e,o.call(t.args,1)))})),s.on("clear",(function(){var e=D;D=i(null),s.emit("clearasync",t(e,(function(e){return o.call(e.args,1)})))}))}})),St=ne((function(e,t){"use strict";var n=Array.prototype.forEach,a=Object.create;t.exports=function(e){var t=a(null);return n.call(arguments,(function(e){t[e]=!0})),t}})),Mt=ne((function(e,t){"use strict";t.exports=function(e){return"function"==typeof e}})),Pt=ne((function(e,t){"use strict";var n=Mt();t.exports=function(e){try{return e&&n(e.toString)?e.toString():String(e)}catch(e){throw new TypeError("Passed argument cannot be stringifed")}}})),It=ne((function(e,t){"use strict";var n=Ne(),a=Pt();t.exports=function(e){return a(n(e))}})),jt=ne((function(e,t){"use strict";var n=Mt();t.exports=function(e){try{return e&&n(e.toString)?e.toString():String(e)}catch(e){return"<Non-coercible to string value>"}}})),Lt=ne((function(e,t){"use strict";var n=jt(),a=/[\\n\\r\\u2028\\u2029]/g;t.exports=function(e){return(e=100<(e=n(e)).length?e.slice(0,99)+"…":e).replace(a,(function(e){return JSON.stringify(e).slice(1,-1)}))}})),qt=ne((function(e,t){function n(e){return!!e&&("object"===r(e)||"function"==typeof e)&&"function"==typeof e.then}t.exports=n,t.exports.default=n})),zt=ne((function(){"use strict";var e=Rt(),t=St(),n=It(),a=Lt(),r=qt(),o=_t(),u=Object.create,i=t("then","then:finally","done","done:finally");Oe().promise=function(t,l){var s=u(null),c=u(null),d=u(null);if(!0===t)t=null;else if(t=n(t),!i[t])throw new TypeError("\'"+a(t)+"\' is not valid promise mode");l.on("set",(function(e,n,a){var u=!1;if(r(a)){s[e]=1,d[e]=a;var i=function(t){var n=s[e];if(u)throw new Error("Memoizee error: Detected unordered then|done & finally resolution, which in turn makes proper detection of success/failure impossible (when in \'done:finally\' mode)\\nConsider to rely on \'then\' or \'done\' mode instead.");n&&(delete s[e],c[e]=t,l.emit("setasync",e,n))},p=function(){u=!0,s[e]&&(delete s[e],delete d[e],l.delete(e))},f=t;if("then"===(f=f||"then")){var D=function(){o(p)};"function"==typeof(a=a.then((function(e){o(i.bind(this,e))}),D)).finally&&a.finally(D)}else if("done"===f){if("function"!=typeof a.done)throw new Error("Memoizee error: Retrieved promise does not implement \'done\' in \'done\' mode");a.done(i,p)}else if("done:finally"===f){if("function"!=typeof a.done)throw new Error("Memoizee error: Retrieved promise does not implement \'done\' in \'done:finally\' mode");if("function"!=typeof a.finally)throw new Error("Memoizee error: Retrieved promise does not implement \'finally\' in \'done:finally\' mode");a.done(i),a.finally(p)}}else c[e]=a,l.emit("setasync",e,1)})),l.on("get",(function(e,t,n){var a,u;s[e]?++s[e]:(a=d[e],u=function(){l.emit("getasync",e,t,n)},r(a)?"function"==typeof a.done?a.done(u):a.then((function(){o(u)})):u())})),l.on("delete",(function(e){var t;delete d[e],s[e]?delete s[e]:hasOwnProperty.call(c,e)&&(t=c[e],delete c[e],l.emit("deleteasync",e,[t]))})),l.on("clear",(function(){var t=c;c=u(null),s=u(null),d=u(null),l.emit("clearasync",e(t,(function(e){return[e]})))}))}})),Vt=ne((function(){"use strict";var e=Te(),t=_e(),n=Oe(),a=Function.prototype.apply;n.dispose=function(r,o,u){var i;e(r),u.async&&n.async||u.promise&&n.promise?(o.on("deleteasync",i=function(e,t){a.call(r,null,t)}),o.on("clearasync",(function(e){t(e,(function(e,t){i(t,e)}))}))):(o.on("delete",i=function(e,t){r(t)}),o.on("clear",(function(e){t(e,(function(e,t){i(t,e)}))})))}})),$t=ne((function(e,t){"use strict";t.exports=2147483647})),Ht=ne((function(e,t){"use strict";var n=ke(),a=$t();t.exports=function(e){if(e=n(e),a<e)throw new TypeError(e+" exceeds maximum possible timeout");return e}})),Ut=ne((function(){"use strict";var e=ht(),t=_e(),n=_t(),a=qt(),r=Ht(),o=Oe(),u=Function.prototype,i=Math.max,l=Math.min,s=Object.create;o.maxAge=function(c,d,p){var f,D,m,h;(c=r(c))&&(f=s(null),D=p.async&&o.async||p.promise&&o.promise?"async":"",d.on("set"+D,(function(e){f[e]=setTimeout((function(){d.delete(e)}),c),"function"==typeof f[e].unref&&f[e].unref(),h&&(h[e]&&"nextTick"!==h[e]&&clearTimeout(h[e]),h[e]=setTimeout((function(){delete h[e]}),m),"function"==typeof h[e].unref)&&h[e].unref()})),d.on("delete"+D,(function(e){clearTimeout(f[e]),delete f[e],h&&("nextTick"!==h[e]&&clearTimeout(h[e]),delete h[e])})),p.preFetch&&(m=!0===p.preFetch||isNaN(p.preFetch)?.333:i(l(Number(p.preFetch),1),0))&&(h={},m=(1-m)*c,d.on("get"+D,(function(t,r,o){h[t]||(h[t]="nextTick",n((function(){var n;"nextTick"===h[t]&&(delete h[t],d.delete(t),p.async&&(r=e(r)).push(u),n=d.memoized.apply(o,r),p.promise)&&a(n)&&("function"==typeof n.done?n.done(u,u):n.then(u,u))})))}))),d.on("clear"+D,(function(){t(f,(function(e){clearTimeout(e)})),f={},h&&(t(h,(function(e){"nextTick"!==e&&clearTimeout(e)})),h={})})))}})),Gt=ne((function(e,t){"use strict";var n=ke(),a=Object.create,r=Object.prototype.hasOwnProperty;t.exports=function(e){var t,o=0,u=1,i=a(null),l=a(null),s=0;return e=n(e),{hit:function(n){var a=l[n],c=++s;if(i[c]=n,l[n]=c,!a)return++o<=e?void 0:(n=i[u],t(n),n);if(delete i[a],u===a)for(;!r.call(i,++u););},delete:t=function(e){var t=l[e];if(t&&(delete i[t],delete l[e],--o,u===t))if(o)for(;!r.call(i,++u););else s=0,u=1},clear:function(){o=0,u=1,i=a(null),l=a(null),s=0}}}})),Wt=ne((function(){"use strict";var e=ke(),t=Gt(),n=Oe();n.max=function(a,r,o){var u;(a=e(a))&&(u=t(a),a=o.async&&n.async||o.promise&&n.promise?"async":"",r.on("set"+a,o=function(e){void 0!==(e=u.hit(e))&&r.delete(e)}),r.on("get"+a,o),r.on("delete"+a,u.delete),r.on("clear"+a,u.clear))}})),Yt=ne((function(){"use strict";var e=Je(),t=Oe(),n=Object.create,a=Object.defineProperties;t.refCounter=function(r,o,u){var i=n(null);u=u.async&&t.async||u.promise&&t.promise?"async":"";o.on("set"+u,(function(e,t){i[e]=t||1})),o.on("get"+u,(function(e){++i[e]})),o.on("delete"+u,(function(e){delete i[e]})),o.on("clear"+u,(function(){i={}})),a(o.memoized,{deleteRef:e((function(){var e=o.get(arguments);return null!==e&&i[e]?!--i[e]&&(o.delete(e),!0):null})),getRefCount:e((function(){var e=o.get(arguments);return null!==e&&i[e]||0}))})}})),Kt=ne((function(e,t){"use strict";var n=we(),a=Be(),r=Ft();t.exports=function(e){var t,o=n(arguments[1]);return o.normalizer||0!==(t=o.length=a(o.length,e.length,o.async))&&(o.primitive?!1===t?o.normalizer=wt():1<t&&(o.normalizer=Et()(t)):o.normalizer=!1===t?Bt()():1===t?Tt()():Nt()(t)),o.async&&Ot(),o.promise&&zt(),o.dispose&&Vt(),o.maxAge&&Ut(),o.max&&Wt(),o.refCounter&&Yt(),r(e,o)}})),Xt=ne((function(e,a){!function(){"use strict";var e={name:"doT",version:"1.1.1",templateSettings:{evaluate:/\\{\\{([\\s\\S]+?(\\}?)+)\\}\\}/g,interpolate:/\\{\\{=([\\s\\S]+?)\\}\\}/g,encode:/\\{\\{!([\\s\\S]+?)\\}\\}/g,use:/\\{\\{#([\\s\\S]+?)\\}\\}/g,useParams:/(^|[^\\w$])def(?:\\.|\\[[\\\'\\"])([\\w$\\.]+)(?:[\\\'\\"]\\])?\\s*\\:\\s*([\\w$\\.]+|\\"[^\\"]+\\"|\\\'[^\\\']+\\\'|\\{[^\\}]+\\})/g,define:/\\{\\{##\\s*([\\w\\.$]+)\\s*(\\:|=)([\\s\\S]+?)#\\}\\}/g,defineParams:/^\\s*([\\w$]+):([\\s\\S]+)/,conditional:/\\{\\{\\?(\\?)?\\s*([\\s\\S]*?)\\s*\\}\\}/g,iterate:/\\{\\{~\\s*(?:\\}\\}|([\\s\\S]+?)\\s*\\:\\s*([\\w$]+)\\s*(?:\\:\\s*([\\w$]+))?\\s*\\}\\})/g,varname:"it",strip:!0,append:!0,selfcontained:!1,doNotSkipEncoded:!1},template:void 0,compile:void 0,log:!0};if("object"!==("undefined"==typeof globalThis?"undefined":r(globalThis)))try{Object.defineProperty(Object.prototype,"__magic__",{get:function(){return this},configurable:!0}),__magic__.globalThis=__magic__,delete Object.prototype.__magic__}catch(e){t.globalThis=function(){if("undefined"!=typeof self)return self;if(void 0!==t)return t;if(void 0!==n)return n;if(void 0!==this)return this;throw new Error("Unable to locate global `this`")}()}e.encodeHTMLSource=function(e){var t={"&":"&#38;","<":"&#60;",">":"&#62;",\'"\':"&#34;","\'":"&#39;","/":"&#47;"},n=e?/[&<>"\'\\/]/g:/&(?!#?\\w+;)|<|>|"|\'|\\//g;return function(e){return e?e.toString().replace(n,(function(e){return t[e]||e})):""}},void 0!==a&&a.exports?a.exports=e:"function"==typeof define&&define.amd?define((function(){return e})):globalThis.doT=e;var o={append:{start:"\'+(",end:")+\'",startencode:"\'+encodeHTML("},split:{start:"\';out+=(",end:");out+=\'",startencode:"\';out+=encodeHTML("}},u=/$^/;function i(e){return e.replace(/\\\\(\'|\\\\)/g,"$1").replace(/[\\r\\t\\n]/g," ")}e.template=function(t,n,a){var r,l,s=(n=n||e.templateSettings).append?o.append:o.split,c=0;a=n.use||n.define?function e(t,n,a){return("string"==typeof n?n:n.toString()).replace(t.define||u,(function(e,n,r,o){return(n=0===n.indexOf("def.")?n.substring(4):n)in a||(":"===r?(t.defineParams&&o.replace(t.defineParams,(function(e,t,r){a[n]={arg:t,text:r}})),n in a||(a[n]=o)):new Function("def","def[\'"+n+"\']="+o)(a)),""})).replace(t.use||u,(function(n,r){return t.useParams&&(r=r.replace(t.useParams,(function(e,t,n,r){var o;if(a[n]&&a[n].arg&&r)return o=(n+":"+r).replace(/\'|\\\\/g,"_"),a.__exp=a.__exp||{},a.__exp[o]=a[n].text.replace(new RegExp("(^|[^\\\\w$])"+a[n].arg+"([^\\\\w$])","g"),"$1"+r+"$2"),t+"def.__exp[\'"+o+"\']"}))),(r=new Function("def","return "+r)(a))&&e(t,r,a)}))}(n,t,a||{}):t,a=("var out=\'"+(n.strip?a.replace(/(^|\\r|\\n)\\t* +| +\\t*(\\r|\\n|$)/g," ").replace(/\\r|\\n|\\t|\\/\\*[\\s\\S]*?\\*\\//g,""):a).replace(/\'|\\\\/g,"\\\\$&").replace(n.interpolate||u,(function(e,t){return s.start+i(t)+s.end})).replace(n.encode||u,(function(e,t){return r=!0,s.startencode+i(t)+s.end})).replace(n.conditional||u,(function(e,t,n){return t?n?"\';}else if("+i(n)+"){out+=\'":"\';}else{out+=\'":n?"\';if("+i(n)+"){out+=\'":"\';}out+=\'"})).replace(n.iterate||u,(function(e,t,n,a){return t?(c+=1,l=a||"i"+c,t=i(t),"\';var arr"+c+"="+t+";if(arr"+c+"){var "+n+","+l+"=-1,l"+c+"=arr"+c+".length-1;while("+l+"<l"+c+"){"+n+"=arr"+c+"["+l+"+=1];out+=\'"):"\';} } out+=\'"})).replace(n.evaluate||u,(function(e,t){return"\';"+i(t)+"out+=\'"}))+"\';return out;").replace(/\\n/g,"\\\\n").replace(/\\t/g,"\\\\t").replace(/\\r/g,"\\\\r").replace(/(\\s|;|\\}|^|\\{)out\\+=\'\';/g,"$1").replace(/\\+\'\'/g,"");r&&(n.selfcontained||!globalThis||globalThis._encodeHTML||(globalThis._encodeHTML=e.encodeHTMLSource(n.doNotSkipEncoded)),a="var encodeHTML = typeof _encodeHTML !== \'undefined\' ? _encodeHTML : ("+e.encodeHTMLSource.toString()+"("+(n.doNotSkipEncoded||"")+"));"+a);try{return new Function(n.varname,a)}catch(t){throw"undefined"!=typeof console&&console.log("Could not create a template function: "+a),t}},e.compile=function(t,n){return e.template(t,null,n)}}()})),Zt=ne((function(e,o){var u;u=function(){"use strict";function e(e){return"function"==typeof e}var o=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)},u=0,i=void 0,l=void 0,s=function(e,t){m[u]=e,m[u+1]=t,2===(u+=2)&&(l?l(h):y())},c=void 0!==t?t:void 0,d=(d=c||{}).MutationObserver||d.WebKitMutationObserver,p="undefined"==typeof self&&"undefined"!=typeof process&&"[object process]"==={}.toString.call(process),f="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel;function D(){var e=setTimeout;return function(){return e(h,1)}}var m=new Array(1e3);function h(){for(var e=0;e<u;e+=2)(0,m[e])(m[e+1]),m[e]=void 0,m[e+1]=void 0;u=0}var g,b,v,y=void 0;function F(e,t){var n,a=this,r=new this.constructor(C),o=(void 0===r[E]&&I(r),a._state);return o?(n=arguments[o-1],s((function(){return M(o,r,n,a._result)}))):O(a,r,e,t),r}function w(e){var t;return e&&"object"===r(e)&&e.constructor===this?e:(T(t=new this(C),e),t)}y=p?function(){return process.nextTick(h)}:d?(b=0,p=new d(h),v=a.createTextNode(""),p.observe(v,{characterData:!0}),function(){v.data=b=++b%2}):f?((g=new MessageChannel).port1.onmessage=h,function(){return g.port2.postMessage(0)}):(void 0===c?function(){try{var e=Function("return this")().require("vertx");return void 0!==(i=e.runOnLoop||e.runOnContext)?function(){i(h)}:D()}catch(e){return D()}}:D)();var E=Math.random().toString(36).substring(2);function C(){}var x=void 0,A=1,k=2;function B(t,n,a){var r,o;n.constructor===t.constructor&&a===F&&n.constructor.resolve===w?(r=t,(o=n)._state===A?R(r,o._result):o._state===k?_(r,o._result):O(o,void 0,(function(e){return T(r,e)}),(function(e){return _(r,e)}))):void 0!==a&&e(a)?function(e,t,n){s((function(e){var a=!1,r=function(e,t,n,a){try{e.call(t,n,a)}catch(e){return e}}(n,t,(function(n){a||(a=!0,(t!==n?T:R)(e,n))}),(function(t){a||(a=!0,_(e,t))}),e._label);!a&&r&&(a=!0,_(e,r))}),e)}(t,n,a):R(t,n)}function T(e,t){if(e===t)_(e,new TypeError("You cannot resolve a promise with itself"));else if(a=r(n=t),null===n||"object"!==a&&"function"!==a)R(e,t);else{n=void 0;try{n=t.then}catch(t){return void _(e,t)}B(e,t,n)}var n,a}function N(e){e._onerror&&e._onerror(e._result),S(e)}function R(e,t){e._state===x&&(e._result=t,e._state=A,0!==e._subscribers.length)&&s(S,e)}function _(e,t){e._state===x&&(e._state=k,e._result=t,s(N,e))}function O(e,t,n,a){var r=e._subscribers,o=r.length;e._onerror=null,r[o]=t,r[o+A]=n,r[o+k]=a,0===o&&e._state&&s(S,e)}function S(e){var t=e._subscribers,n=e._state;if(0!==t.length){for(var a,r=void 0,o=e._result,u=0;u<t.length;u+=3)a=t[u],r=t[u+n],a?M(n,a,r,o):r(o);e._subscribers.length=0}}function M(t,n,a,r){var o=e(a),u=void 0,i=void 0,l=!0;if(o){try{u=a(r)}catch(t){l=!1,i=t}if(n===u)return void _(n,new TypeError("A promises callback cannot return that same promise."))}else u=r;n._state===x&&(o&&l?T(n,u):!1===l?_(n,i):t===A?R(n,u):t===k&&_(n,u))}var P=0;function I(e){e[E]=P++,e._state=void 0,e._result=void 0,e._subscribers=[]}L.prototype._enumerate=function(e){for(var t=0;this._state===x&&t<e.length;t++)this._eachEntry(e[t],t)},L.prototype._eachEntry=function(e,t){var n=this._instanceConstructor,a=n.resolve;if(a===w){var r,o=void 0,u=void 0,i=!1;try{o=e.then}catch(t){i=!0,u=t}o===F&&e._state!==x?this._settledAt(e._state,t,e._result):"function"!=typeof o?(this._remaining--,this._result[t]=e):n===q?(r=new n(C),i?_(r,u):B(r,e,o),this._willSettleAt(r,t)):this._willSettleAt(new n((function(t){return t(e)})),t)}else this._willSettleAt(a(e),t)},L.prototype._settledAt=function(e,t,n){var a=this.promise;a._state===x&&(this._remaining--,e===k?_(a,n):this._result[t]=n),0===this._remaining&&R(a,this._result)},L.prototype._willSettleAt=function(e,t){var n=this;O(e,void 0,(function(e){return n._settledAt(A,t,e)}),(function(e){return n._settledAt(k,t,e)}))};var j=L;function L(e,t){this._instanceConstructor=e,this.promise=new e(C),this.promise[E]||I(this.promise),o(t)?(this.length=t.length,this._remaining=t.length,this._result=new Array(this.length),0!==this.length&&(this.length=this.length||0,this._enumerate(t),0!==this._remaining)||R(this.promise,this._result)):_(this.promise,new Error("Array Methods must be provided an Array"))}z.prototype.catch=function(e){return this.then(null,e)},z.prototype.finally=function(t){var n=this.constructor;return e(t)?this.then((function(e){return n.resolve(t()).then((function(){return e}))}),(function(e){return n.resolve(t()).then((function(){throw e}))})):this.then(t,t)};var q=z;function z(e){if(this[E]=P++,this._result=this._state=void 0,this._subscribers=[],C!==e){if("function"!=typeof e)throw new TypeError("You must pass a resolver function as the first argument to the promise constructor");if(!(this instanceof z))throw new TypeError("Failed to construct \'Promise\': Please use the \'new\' operator, this object constructor cannot be called as a function.");var t=this;try{e((function(e){T(t,e)}),(function(e){_(t,e)}))}catch(e){_(t,e)}}}return q.prototype.then=F,q.all=function(e){return new j(this,e).promise},q.race=function(e){var t=this;return o(e)?new t((function(n,a){for(var r=e.length,o=0;o<r;o++)t.resolve(e[o]).then(n,a)})):new t((function(e,t){return t(new TypeError("You must pass an array to race."))}))},q.resolve=w,q.reject=function(e){var t=new this(C);return _(t,e),t},q._setScheduler=function(e){l=e},q._setAsap=function(e){s=e},q._asap=s,q.polyfill=function(){var e=void 0;if(void 0!==n)e=n;else if("undefined"!=typeof self)e=self;else try{e=Function("return this")()}catch(e){throw new Error("polyfill failed because global object is unavailable in this environment")}var t=e.Promise;if(t){var a=null;try{a=Object.prototype.toString.call(t.resolve())}catch(e){}if("[object Promise]"===a&&!t.cast)return}e.Promise=q},q.Promise=q},"object"===r(e)&&void 0!==o?o.exports=u():"function"==typeof define&&define.amd?define(u):e.ES6Promise=u()})),Jt=ne((function(e){var t,n,a=1e5,o=(t=Object.prototype.toString,n=Object.prototype.hasOwnProperty,{Class:function(e){return t.call(e).replace(/^\\[object *|\\]$/g,"")},HasProperty:function(e,t){return t in e},HasOwnProperty:function(e,t){return n.call(e,t)},IsCallable:function(e){return"function"==typeof e},ToInt32:function(e){return e>>0},ToUint32:function(e){return e>>>0}}),u=Math.LN2,i=Math.abs,l=Math.floor,s=Math.log,c=Math.min,d=Math.pow,p=Math.round;function f(e,t,n){return e<t?t:n<e?n:e}var D,m,h,g,b,v,y,F,w,E,C,x=Object.getOwnPropertyNames||function(e){if(e!==Object(e))throw new TypeError("Object.getOwnPropertyNames called on non-object");var t,n=[];for(t in e)o.HasOwnProperty(e,t)&&n.push(t);return n};function A(e){if(x&&D)for(var t=x(e),n=0;n<t.length;n+=1)D(e,t[n],{value:e[t[n]],writable:!1,enumerable:!1,configurable:!1})}function k(e){if(D){if(e.length>a)throw new RangeError("Array too large for polyfill");for(var t=0;t<e.length;t+=1)!function(t){D(e,t,{get:function(){return e._getter(t)},set:function(n){e._setter(t,n)},enumerable:!0,configurable:!1})}(t)}}function B(e,t){return e<<(t=32-t)>>t}function T(e,t){return e<<(t=32-t)>>>t}function N(e){return T(e[0],8)}function R(e,t,n){var a,r,o,p,f,D,m,h=(1<<t-1)-1;function g(e){var t=l(e);return(e=e-t)<.5||!(.5<e||t%2)?t:t+1}for(e!=e?(r=(1<<t)-1,o=d(2,n-1),a=0):e===1/0||e===-1/0?(r=(1<<t)-1,a=e<(o=0)?1:0):0===e?a=1/e==-1/(o=r=0)?1:0:(a=e<0,(e=i(e))>=d(2,1-h)?(r=c(l(s(e)/u),1023),2<=(o=g(e/d(2,r)*d(2,n)))/d(2,n)&&(r+=1,o=1),h<r?(r=(1<<t)-1,o=0):(r+=h,o-=d(2,n))):(r=0,o=g(e/d(2,1-h-n)))),f=[],p=n;p;--p)f.push(o%2?1:0),o=l(o/2);for(p=t;p;--p)f.push(r%2?1:0),r=l(r/2);for(f.push(a?1:0),f.reverse(),D=f.join(""),m=[];D.length;)m.push(parseInt(D.substring(0,8),2)),D=D.substring(8);return m}function _(e,t,n){for(var a,r,o,u,i,l,s=[],c=e.length;c;--c)for(r=e[c-1],a=8;a;--a)s.push(r%2?1:0),r>>=1;return s.reverse(),l=s.join(""),o=(1<<t-1)-1,u=parseInt(l.substring(0,1),2)?-1:1,i=parseInt(l.substring(1,1+t),2),l=parseInt(l.substring(1+t),2),i===(1<<t)-1?0===l?1/0*u:NaN:0<i?u*d(2,i-o)*(1+l/d(2,n)):0!==l?u*d(2,-(o-1))*(l/d(2,n)):u<0?-0:0}function O(e){if((e=o.ToInt32(e))<0)throw new RangeError("ArrayBuffer size is not a small enough positive integer");var t;for(this.byteLength=e,this._bytes=[],this._bytes.length=e,t=0;t<this.byteLength;t+=1)this._bytes[t]=0;A(this)}function S(){}function M(e,t,n){var a=function(e,t,n){var u,i,l,s;if(arguments.length&&"number"!=typeof e)if("object"===r(e)&&e.constructor===a)for(this.length=(u=e).length,this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new O(this.byteLength),l=this.byteOffset=0;l<this.length;l+=1)this._setter(l,u._getter(l));else if("object"!==r(e)||e instanceof O||"ArrayBuffer"===o.Class(e)){if("object"!==r(e)||!(e instanceof O||"ArrayBuffer"===o.Class(e)))throw new TypeError("Unexpected argument type(s)");if(this.buffer=e,this.byteOffset=o.ToUint32(t),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteOffset%this.BYTES_PER_ELEMENT)throw new RangeError("ArrayBuffer length minus the byteOffset is not a multiple of the element size.");if(arguments.length<3){if(this.byteLength=this.buffer.byteLength-this.byteOffset,this.byteLength%this.BYTES_PER_ELEMENT)throw new RangeError("length of buffer minus byteOffset not a multiple of the element size");this.length=this.byteLength/this.BYTES_PER_ELEMENT}else this.length=o.ToUint32(n),this.byteLength=this.length*this.BYTES_PER_ELEMENT;if(this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer")}else for(this.length=o.ToUint32((i=e).length),this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new O(this.byteLength),l=this.byteOffset=0;l<this.length;l+=1)s=i[l],this._setter(l,Number(s));else{if(this.length=o.ToInt32(e),n<0)throw new RangeError("ArrayBufferView size is not a small enough positive integer");this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new O(this.byteLength),this.byteOffset=0}this.constructor=a,A(this),k(this)};return(a.prototype=new S).BYTES_PER_ELEMENT=e,a.prototype._pack=t,a.prototype._unpack=n,a.BYTES_PER_ELEMENT=e,a.prototype.get=a.prototype._getter=function(e){if(arguments.length<1)throw new SyntaxError("Not enough arguments");if(!((e=o.ToUint32(e))>=this.length)){for(var t=[],n=0,a=this.byteOffset+e*this.BYTES_PER_ELEMENT;n<this.BYTES_PER_ELEMENT;n+=1,a+=1)t.push(this.buffer._bytes[a]);return this._unpack(t)}},a.prototype._setter=function(e,t){if(arguments.length<2)throw new SyntaxError("Not enough arguments");if((e=o.ToUint32(e))<this.length)for(var n=this._pack(t),a=0,r=this.byteOffset+e*this.BYTES_PER_ELEMENT;a<this.BYTES_PER_ELEMENT;a+=1,r+=1)this.buffer._bytes[r]=n[a]},a.prototype.set=function(e,t){if(arguments.length<1)throw new SyntaxError("Not enough arguments");var n,a,u,i,l,s,c,d,p,f;if("object"===r(e)&&e.constructor===this.constructor){if(n=e,(u=o.ToUint32(t))+n.length>this.length)throw new RangeError("Offset plus length of array is out of range");if(d=this.byteOffset+u*this.BYTES_PER_ELEMENT,p=n.length*this.BYTES_PER_ELEMENT,n.buffer===this.buffer){for(f=[],l=0,s=n.byteOffset;l<p;l+=1,s+=1)f[l]=n.buffer._bytes[s];for(l=0,c=d;l<p;l+=1,c+=1)this.buffer._bytes[c]=f[l]}else for(l=0,s=n.byteOffset,c=d;l<p;l+=1,s+=1,c+=1)this.buffer._bytes[c]=n.buffer._bytes[s]}else{if("object"!==r(e)||void 0===e.length)throw new TypeError("Unexpected argument type(s)");if(i=o.ToUint32((a=e).length),(u=o.ToUint32(t))+i>this.length)throw new RangeError("Offset plus length of array is out of range");for(l=0;l<i;l+=1)s=a[l],this._setter(u+l,Number(s))}},a.prototype.subarray=function(e,t){e=o.ToInt32(e),t=o.ToInt32(t),arguments.length<1&&(e=0),arguments.length<2&&(t=this.length),e<0&&(e=this.length+e),t<0&&(t=this.length+t),e=f(e,0,this.length);var n=(t=f(t,0,this.length))-e;return new this.constructor(this.buffer,this.byteOffset+e*this.BYTES_PER_ELEMENT,n=n<0?0:n)},a}function P(e,t){return o.IsCallable(e.get)?e.get(t):e[t]}function I(t,n,a){if(0===arguments.length)t=new e.ArrayBuffer(0);else if(!(t instanceof e.ArrayBuffer||"ArrayBuffer"===o.Class(t)))throw new TypeError("TypeError");if(this.buffer=t||new e.ArrayBuffer(0),this.byteOffset=o.ToUint32(n),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteLength=arguments.length<3?this.buffer.byteLength-this.byteOffset:o.ToUint32(a),this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer");A(this)}function j(t){return function(n,a){if((n=o.ToUint32(n))+t.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");n+=this.byteOffset;for(var r=new e.Uint8Array(this.buffer,n,t.BYTES_PER_ELEMENT),u=[],i=0;i<t.BYTES_PER_ELEMENT;i+=1)u.push(P(r,i));return Boolean(a)===Boolean(C)&&u.reverse(),P(new t(new e.Uint8Array(u).buffer),0)}}function L(t){return function(n,a,r){if((n=o.ToUint32(n))+t.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");a=new t([a]);for(var u=new e.Uint8Array(a.buffer),i=[],l=0;l<t.BYTES_PER_ELEMENT;l+=1)i.push(P(u,l));Boolean(r)===Boolean(C)&&i.reverse(),new e.Uint8Array(this.buffer,n,t.BYTES_PER_ELEMENT).set(i)}}D=Object.defineProperty&&function(){try{return Object.defineProperty({},"x",{}),1}catch(e){}}()?Object.defineProperty:function(e,t,n){if(!e===Object(e))throw new TypeError("Object.defineProperty called on non-object");return o.HasProperty(n,"get")&&Object.prototype.__defineGetter__&&Object.prototype.__defineGetter__.call(e,t,n.get),o.HasProperty(n,"set")&&Object.prototype.__defineSetter__&&Object.prototype.__defineSetter__.call(e,t,n.set),o.HasProperty(n,"value")&&(e[t]=n.value),e},e.ArrayBuffer=e.ArrayBuffer||O,E=M(1,(function(e){return[255&e]}),(function(e){return B(e[0],8)})),m=M(1,(function(e){return[255&e]}),N),h=M(1,(function(e){return[(e=p(Number(e)))<0?0:255<e?255:255&e]}),N),g=M(2,(function(e){return[e>>8&255,255&e]}),(function(e){return B(e[0]<<8|e[1],16)})),b=M(2,(function(e){return[e>>8&255,255&e]}),(function(e){return T(e[0]<<8|e[1],16)})),v=M(4,(function(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}),(function(e){return B(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)})),y=M(4,(function(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}),(function(e){return T(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)})),F=M(4,(function(e){return R(e,8,23)}),(function(e){return _(e,8,23)})),w=M(8,(function(e){return R(e,11,52)}),(function(e){return _(e,11,52)})),e.Int8Array=e.Int8Array||E,e.Uint8Array=e.Uint8Array||m,e.Uint8ClampedArray=e.Uint8ClampedArray||h,e.Int16Array=e.Int16Array||g,e.Uint16Array=e.Uint16Array||b,e.Int32Array=e.Int32Array||v,e.Uint32Array=e.Uint32Array||y,e.Float32Array=e.Float32Array||F,e.Float64Array=e.Float64Array||w,E=new e.Uint16Array([4660]),C=18===P(new e.Uint8Array(E.buffer),0),I.prototype.getUint8=j(e.Uint8Array),I.prototype.getInt8=j(e.Int8Array),I.prototype.getUint16=j(e.Uint16Array),I.prototype.getInt16=j(e.Int16Array),I.prototype.getUint32=j(e.Uint32Array),I.prototype.getInt32=j(e.Int32Array),I.prototype.getFloat32=j(e.Float32Array),I.prototype.getFloat64=j(e.Float64Array),I.prototype.setUint8=L(e.Uint8Array),I.prototype.setInt8=L(e.Int8Array),I.prototype.setUint16=L(e.Uint16Array),I.prototype.setInt16=L(e.Int16Array),I.prototype.setUint32=L(e.Uint32Array),I.prototype.setInt32=L(e.Int32Array),I.prototype.setFloat32=L(e.Float32Array),I.prototype.setFloat64=L(e.Float64Array),e.DataView=e.DataView||I})),Qt=ne((function(e){!function(e){"use strict";var t,n,a;function o(){if(void 0===this)throw new TypeError("Constructor WeakMap requires \'new\'");if(a(this,"_id","_WeakMap_"+i()+"."+i()),0<arguments.length)throw new TypeError("WeakMap iterable is not supported")}function u(e,n){if(!l(e)||!t.call(e,"_id"))throw new TypeError(n+" method called on incompatible receiver "+r(e))}function i(){return Math.random().toString().substring(2)}function l(e){return Object(e)===e}e.WeakMap||(t=Object.prototype.hasOwnProperty,n=Object.defineProperty&&function(){try{return 1===Object.defineProperty({},"x",{value:1}).x}catch(e){}}(),e.WeakMap=((a=function(e,t,a){n?Object.defineProperty(e,t,{configurable:!0,writable:!0,value:a}):e[t]=a})(o.prototype,"delete",(function(e){var t;return u(this,"delete"),!!l(e)&&!(!(t=e[this._id])||t[0]!==e||(delete e[this._id],0))})),a(o.prototype,"get",(function(e){var t;return u(this,"get"),l(e)&&(t=e[this._id])&&t[0]===e?t[1]:void 0})),a(o.prototype,"has",(function(e){var t;return u(this,"has"),!!l(e)&&!(!(t=e[this._id])||t[0]!==e)})),a(o.prototype,"set",(function(e,t){var n;if(u(this,"set"),l(e))return(n=e[this._id])&&n[0]===e?n[1]=t:a(e,this._id,[e,t]),this;throw new TypeError("Invalid value used as weak map key")})),a(o,"_polyfill",!0),o))}("undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self?self:void 0!==t?t:void 0!==n?n:e)})),en={helpUrlBase:"https://dequeuniversity.com/rules/",gridSize:200,results:[],resultGroups:[],resultGroupMap:{},impact:Object.freeze(["minor","moderate","serious","critical"]),preload:Object.freeze({assets:["cssom","media"],timeout:1e4}),allOrigins:"<unsafe_all_origins>",sameOrigin:"<same_origin>"},tn=([{name:"NA",value:"inapplicable",priority:0,group:"inapplicable"},{name:"PASS",value:"passed",priority:1,group:"passes"},{name:"CANTTELL",value:"cantTell",priority:2,group:"incomplete"},{name:"FAIL",value:"failed",priority:3,group:"violations"}].forEach((function(e){var t=e.name,n=e.value,a=e.priority;e=e.group;en[t]=n,en[t+"_PRIO"]=a,en[t+"_GROUP"]=e,en.results[a]=n,en.resultGroups[a]=e,en.resultGroupMap[n]=e})),Object.freeze(en.results),Object.freeze(en.resultGroups),Object.freeze(en.resultGroupMap),Object.freeze(en),en),nn=function(){"object"===("undefined"==typeof console?"undefined":r(console))&&console.log&&Function.prototype.apply.call(console.log,console,arguments)},an=/[\\t\\r\\n\\f]/g;function rn(){K(this,rn),this.parent=void 0}Z(rn,[{key:"props",get:function(){throw new Error(\'VirtualNode class must have a "props" object consisting of "nodeType" and "nodeName" properties\')}},{key:"attrNames",get:function(){throw new Error(\'VirtualNode class must have an "attrNames" property\')}},{key:"attr",value:function(){throw new Error(\'VirtualNode class must have an "attr" function\')}},{key:"hasAttr",value:function(){throw new Error(\'VirtualNode class must have a "hasAttr" function\')}},{key:"hasClass",value:function(e){var t=this.attr("class");return!!t&&(e=" "+e+" ",0<=(" "+t+" ").replace(an," ").indexOf(e))}}]);var on=rn,un={},ln=(ae(un,{DqElement:function(){return Jn},aggregate:function(){return ln},aggregateChecks:function(){return Dn},aggregateNodeResults:function(){return hn},aggregateResult:function(){return bn},areStylesSet:function(){return vn},assert:function(){return yn},checkHelper:function(){return Qn},clone:function(){return ea},closest:function(){return ca},collectResultsFromFrames:function(){return tr},contains:function(){return nr},convertSelector:function(){return ia},cssParser:function(){return ta},deepMerge:function(){return ar},escapeSelector:function(){return wn},extendMetaData:function(){return rr},filterHtmlAttrs:function(){return fp},finalizeRuleResult:function(){return mn},findBy:function(){return Ja},getAllChecks:function(){return Za},getAncestry:function(){return Gn},getBaseLang:function(){return nd},getCheckMessage:function(){return cd},getCheckOption:function(){return dd},getEnvironmentData:function(){return pd},getFlattenedTree:function(){return td},getFrameContexts:function(){return Cd},getFriendlyUriEnd:function(){return kn},getNodeAttributes:function(){return Bn},getNodeFromTree:function(){return Xn},getPreloadConfig:function(){return up},getRootNode:function(){return lr},getRule:function(){return xd},getScroll:function(){return Ad},getScrollState:function(){return Bd},getSelector:function(){return Hn},getSelectorData:function(){return qn},getShadowSelector:function(){return Rn},getStandards:function(){return Td},getStyleSheetFactory:function(){return Rd},getXpath:function(){return Wn},injectStyle:function(){return _d},isHidden:function(){return Od},isHtmlElement:function(){return Sd},isNodeInContext:function(){return Md},isShadowRoot:function(){return ur},isValidLang:function(){return Ep},isXHTML:function(){return Nn},matchAncestry:function(){return Id},matches:function(){return sa},matchesExpression:function(){return la},matchesSelector:function(){return Tn},memoize:function(){return Dr},mergeResults:function(){return er},nodeLookup:function(){return Ld},nodeSorter:function(){return jd},parseCrossOriginStylesheet:function(){return Hd},parseSameOriginStylesheet:function(){return Vd},parseStylesheet:function(){return $d},performanceTimer:function(){return Yd},pollyfillElementsFromPoint:function(){return Kd},preload:function(){return ip},preloadCssom:function(){return tp},preloadMedia:function(){return rp},processMessage:function(){return sd},publishMetaData:function(){return sp},querySelectorAll:function(){return cp},querySelectorAllFilter:function(){return ep},queue:function(){return ha},respondable:function(){return Ga},ruleShouldRun:function(){return pp},select:function(){return mp},sendCommandToFrame:function(){return Ya},setScrollState:function(){return hp},shadowSelect:function(){return gp},shadowSelectAll:function(){return bp},shouldPreload:function(){return op},toArray:function(){return Fn},tokenList:function(){return Gc},uniqueArray:function(){return Zd},uuid:function(){return Ta},validInputTypes:function(){return vp},validLangs:function(){return Fp}}),function(e,t,n){return t=t.slice(),n&&t.push(n),n=t.map((function(t){return e.indexOf(t)})).sort(),e[n.pop()]}),sn=tn.CANTTELL_PRIO,cn=tn.FAIL_PRIO,dn=[],pn=(dn[tn.PASS_PRIO]=!0,dn[tn.CANTTELL_PRIO]=null,dn[tn.FAIL_PRIO]=!1,["any","all","none"]);function fn(e,t){pn.reduce((function(n,a){return n[a]=(e[a]||[]).map((function(e){return t(e,a)})),n}),{})}var Dn=function(e){var t=Object.assign({},e),n=(fn(t,(function(e,t){var n=void 0===e.result?-1:dn.indexOf(e.result);e.priority=-1!==n?n:tn.CANTTELL_PRIO,"none"===t&&(e.priority===tn.PASS_PRIO?e.priority=tn.FAIL_PRIO:e.priority===tn.FAIL_PRIO&&(e.priority=tn.PASS_PRIO))})),{all:t.all.reduce((function(e,t){return Math.max(e,t.priority)}),0),none:t.none.reduce((function(e,t){return Math.max(e,t.priority)}),0),any:t.any.reduce((function(e,t){return Math.min(e,t.priority)}),4)%4}),a=(t.priority=Math.max(n.all,n.none,n.any),[]);return pn.forEach((function(e){t[e]=t[e].filter((function(a){return a.priority===t.priority&&a.priority===n[e]})),t[e].forEach((function(e){return a.push(e.impact)}))})),[sn,cn].includes(t.priority)?t.impact=ln(tn.impact,a):t.impact=null,fn(t,(function(e){delete e.result,delete e.priority})),t.result=tn.results[t.priority],delete t.priority,t},mn=function(e){var t=o._audit.rules.find((function(t){return t.id===e.id}));return t&&t.impact&&e.nodes.forEach((function(e){["any","all","none"].forEach((function(n){(e[n]||[]).forEach((function(e){e.impact=t.impact}))}))})),Object.assign(e,hn(e.nodes)),delete e.nodes,e},hn=function(e){var t={},n=((e=e.map((function(e){if(e.any&&e.all&&e.none)return Dn(e);if(Array.isArray(e.node))return mn(e);throw new TypeError("Invalid Result type")})))&&e.length?(n=e.map((function(e){return e.result})),t.result=ln(tn.results,n,t.result)):t.result="inapplicable",tn.resultGroups.forEach((function(e){return t[e]=[]})),e.forEach((function(e){var n=tn.resultGroupMap[e.result];t[n].push(e)})),tn.FAIL_GROUP);return 0===t[n].length&&(n=tn.CANTTELL_GROUP),0<t[n].length?(e=t[n].map((function(e){return e.impact})),t.impact=ln(tn.impact,e)||null):t.impact=null,t};function gn(e,t,n){var a=Object.assign({},t);a.nodes=(a[n]||[]).concat(),tn.resultGroups.forEach((function(e){delete a[e]})),e[n].push(a)}var bn=function(e){var t={};return tn.resultGroups.forEach((function(e){return t[e]=[]})),e.forEach((function(e){e.error?gn(t,e,tn.CANTTELL_GROUP):e.result===tn.NA?gn(t,e,tn.NA_GROUP):tn.resultGroups.forEach((function(n){Array.isArray(e[n])&&0<e[n].length&&gn(t,e,n)}))})),t},vn=function e(n,a,r){var o=t.getComputedStyle(n,null);if(!o)return!1;for(var u=0;u<a.length;++u){var i=a[u];if(o.getPropertyValue(i.property)===i.value)return!0}return!(!n.parentNode||n.nodeName.toUpperCase()===r.toUpperCase())&&e(n.parentNode,a,r)},yn=function(e,t){if(!e)throw new Error(t)},Fn=function(e){return Array.prototype.slice.call(e)},wn=function(e){for(var t,n=String(e),a=n.length,r=-1,o="",u=n.charCodeAt(0);++r<a;)0==(t=n.charCodeAt(r))?o+="�":o+=1<=t&&t<=31||127==t||0==r&&48<=t&&t<=57||1==r&&48<=t&&t<=57&&45==u?"\\\\"+t.toString(16)+" ":0==r&&1==a&&45==t||!(128<=t||45==t||95==t||48<=t&&t<=57||65<=t&&t<=90||97<=t&&t<=122)?"\\\\"+n.charAt(r):n.charAt(r);return o};function En(e,t){return[e.substring(0,t),e.substring(t)]}function Cn(e){return e.replace(/\\s+$/,"")}var xn,An,kn=function(){var e,t,n,a,r,o,u,i,l=0<arguments.length&&void 0!==arguments[0]?arguments[0]:"",s=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};if(!(l.length<=1||"data:"===l.substr(0,5)||"javascript:"===l.substr(0,11)||l.includes("?")))return e=s.currentDomain,s=void 0===(s=s.maxLength)?25:s,u=o=i=r=a="",(n=l).includes("#")&&(l=(t=G(En(l,l.indexOf("#")),2))[0],u=t[1]),l.includes("?")&&(l=(t=G(En(l,l.indexOf("?")),2))[0],o=t[1]),l.includes("://")?(a=(t=G(l.split("://"),2))[0],r=(t=G(En(l=t[1],l.indexOf("/")),2))[0],l=t[1]):"//"===l.substr(0,2)&&(r=(t=G(En(l=l.substr(2),l.indexOf("/")),2))[0],l=t[1]),(r="www."===r.substr(0,4)?r.substr(4):r)&&r.includes(":")&&(r=(t=G(En(r,r.indexOf(":")),2))[0],i=t[1]),n=(t={original:n,protocol:a,domain:r,port:i,path:l,query:o,hash:u}).domain,a=t.hash,i=(r=t.path).substr(r.substr(0,r.length-2).lastIndexOf("/")+1),a?i&&(i+a).length<=s?Cn(i+a):i.length<2&&2<a.length&&a.length<=s?Cn(a):void 0:n&&n.length<s&&r.length<=1||r==="/"+i&&n&&e&&n!==e&&(n+r).length<=s?Cn(n+r):(-1===(l=i.lastIndexOf("."))||1<l)&&(-1!==l||2<i.length)&&i.length<=s&&!i.match(/index(\\.[a-zA-Z]{2-4})?/)&&!function(e){var t=0<arguments.length&&void 0!==e?e:"";return 0!==t.length&&(t.match(/[0-9]/g)||"").length>=t.length/2}(i)?Cn(i):void 0},Bn=function(e){return(e.attributes instanceof t.NamedNodeMap?e:e.cloneNode(!1)).attributes},Tn=function(e,t){return!!e[xn=xn&&e[xn]?xn:function(e){for(var t,n=["matches","matchesSelector","mozMatchesSelector","webkitMatchesSelector","msMatchesSelector"],a=n.length,r=0;r<a;r++)if(e[t=n[r]])return t}(e)]&&e[xn](t)},Nn=function(e){return!!e.createElement&&"A"===e.createElement("A").localName},Rn=function(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};if(!t)return"";var r=t.getRootNode&&t.getRootNode()||a;if(11!==r.nodeType)return e(t,n,r);for(var o=[];11===r.nodeType;){if(!r.host)return"";o.unshift({elm:t,doc:r}),r=(t=r.host).getRootNode()}return o.unshift({elm:t,doc:r}),o.map((function(t){var a=t.elm;t=t.doc;return e(a,n,t)}))},_n=["class","style","id","selected","checked","disabled","tabindex","aria-checked","aria-selected","aria-invalid","aria-activedescendant","aria-busy","aria-disabled","aria-expanded","aria-grabbed","aria-pressed","aria-valuenow"],On=31,Sn=/([\\\\"])/g,Mn=/(\\r\\n|\\r|\\n)/g;function Pn(e){return e.replace(Sn,"\\\\$1").replace(Mn,"\\\\a ")}function In(e,t){var n,a=t.name;return-1!==a.indexOf("href")||-1!==a.indexOf("src")?(n=kn(e.getAttribute(a)))?wn(t.name)+\'$="\'+Pn(n)+\'"\':wn(t.name)+\'="\'+Pn(e.getAttribute(a))+\'"\':wn(a)+\'="\'+Pn(t.value)+\'"\'}function jn(e,t){return e.count<t.count?-1:e.count===t.count?0:1}function Ln(e){return!_n.includes(e.name)&&-1===e.name.indexOf(":")&&(!e.value||e.value.length<On)}function qn(e){for(var t={classes:{},tags:{},attributes:{}},n=(e=Array.isArray(e)?e:[e]).slice(),a=[];n.length;)!function(){var e,r=n.pop(),o=r.actualNode;for(o.querySelectorAll&&(e=o.nodeName,t.tags[e]?t.tags[e]++:t.tags[e]=1,o.classList&&Array.from(o.classList).forEach((function(e){e=wn(e),t.classes[e]?t.classes[e]++:t.classes[e]=1})),o.hasAttributes())&&Array.from(Bn(o)).filter(Ln).forEach((function(e){(e=In(o,e))&&(t.attributes[e]?t.attributes[e]++:t.attributes[e]=1)})),r.children.length&&(a.push(n),n=r.children.slice());!n.length&&a.length;)n=a.pop()}();return t}function zn(e){return void 0===An&&(An=Nn(a)),wn(An?e.localName:e.nodeName.toLowerCase())}function Vn(e,t){var n,a,r,o,u,i,l,s,c,d="",p=(a=e,r=[],o=t.classes,u=t.tags,a.classList&&Array.from(a.classList).forEach((function(e){e=wn(e),o[e]<u[a.nodeName]&&r.push({name:e,count:o[e],species:"class"})})),r.sort(jn));i=e,l=[],s=t.attributes,c=t.tags,i.hasAttributes()&&Array.from(Bn(i)).filter(Ln).forEach((function(e){(e=In(i,e))&&s[e]<c[i.nodeName]&&l.push({name:e,count:s[e],species:"attribute"})})),t=l.sort(jn);return p.length&&1===p[0].count?n=[p[0]]:t.length&&1===t[0].count?(n=[t[0]],d=zn(e)):((n=p.concat(t)).sort(jn),(n=n.slice(0,3)).some((function(e){return"class"===e.species}))?n.sort((function(e,t){return e.species!==t.species&&"class"===e.species?-1:e.species===t.species?0:1})):d=zn(e)),d+n.reduce((function(e,t){switch(t.species){case"class":return e+"."+t.name;case"attribute":return e+"["+t.name+"]"}return e}),"")}function $n(e,t,n){if(!o._selectorData)throw new Error("Expect axe._selectorData to be set up");var r,u,i=void 0!==(t=t.toRoot)&&t;do{var l=function(e){var t;if(e.getAttribute("id"))return t=e.getRootNode&&e.getRootNode()||a,(e="#"+wn(e.getAttribute("id")||"")).match(/player_uid_/)||1!==t.querySelectorAll(e).length?void 0:e}(e);l||(l=Vn(e,o._selectorData),l+=function(e,t){var n=e.parentNode&&Array.from(e.parentNode.children||"")||[];return n.find((function(n){return n!==e&&Tn(n,t)}))?":nth-child("+(1+n.indexOf(e))+")":""}(e,l)),r=r?l+" > "+r:l,u=u?u.filter((function(e){return Tn(e,r)})):Array.from(n.querySelectorAll(r)),e=e.parentElement}while((1<u.length||i)&&e&&11!==e.nodeType);return 1===u.length?r:-1!==r.indexOf(" > ")?":root"+r.substring(r.indexOf(" > ")):":root"}function Hn(e,t){return Rn($n,e,t)}function Un(e){var t,n=e.nodeName.toLowerCase(),a=e.parentElement;return a?(t="","head"!==n&&"body"!==n&&1<a.children.length&&(e=Array.prototype.indexOf.call(a.children,e)+1,t=":nth-child(".concat(e,")")),Un(a)+" > "+n+t):n}function Gn(e,t){return Rn(Un,e,t)}var Wn=function(e){return function e(t,n){var a,r,o,u;if(!t)return[];if(!n&&9===t.nodeType)return[{str:"html"}];if(n=n||[],t.parentNode&&t.parentNode!==t&&(n=e(t.parentNode,n)),t.previousSibling){for(r=1,a=t.previousSibling;1===a.nodeType&&a.nodeName===t.nodeName&&r++,a=a.previousSibling;);1===r&&(r=null)}else if(t.nextSibling)for(a=t.nextSibling;a=1===a.nodeType&&a.nodeName===t.nodeName?(r=1,null):(r=null,a.previousSibling););return 1===t.nodeType&&((o={}).str=t.nodeName.toLowerCase(),(u=t.getAttribute&&wn(t.getAttribute("id")))&&1===t.ownerDocument.querySelectorAll("#"+u).length&&(o.id=t.getAttribute("id")),1<r&&(o.count=r),n.push(o)),n}(e).reduce((function(e,t){return t.id?"/".concat(t.str,"[@id=\'").concat(t.id,"\']"):e+"/".concat(t.str)+(0<t.count?"[".concat(t.count,"]"):"")}),"")},Yn={},Kn={set:function(e,t){var n;yn("string"==typeof(n=e),"key must be a string, "+r(n)+" given"),yn(""!==n,"key must not be empty"),Yn[e]=t},get:function(e,t){var n;return yn("function"==typeof(n=t)||void 0===n,"creator must be a function or undefined, "+r(n)+" given"),e in Yn?Yn[e]:"function"==typeof t?(n=t(),yn(void 0!==n,"Cache creator function should not return undefined"),this.set(e,n),Yn[e]):void 0},clear:function(){Yn={}}},Xn=function(e,t){return t=t||e,Kn.get("nodeMap")?Kn.get("nodeMap").get(t):null};function Zn(e){var n,a,r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};this.spec=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},e instanceof on?(this._virtualNode=e,this._element=e.actualNode):(this._element=e,this._virtualNode=Xn(e)),this.fromFrame=1<(null==(n=this.spec.selector)?void 0:n.length),r.absolutePaths&&(this._options={toRoot:!0}),this.nodeIndexes=[],Array.isArray(this.spec.nodeIndexes)?this.nodeIndexes=this.spec.nodeIndexes:"number"==typeof(null==(n=this._virtualNode)?void 0:n.nodeIndex)&&(this.nodeIndexes=[this._virtualNode.nodeIndex]),this.source=null,o._audit.noHtml||(this.source=null!=(r=this.spec.source)?r:null!=(n=this._element)&&n.outerHTML?((r=n.outerHTML)||"function"!=typeof t.XMLSerializer||(r=(new t.XMLSerializer).serializeToString(n)),(n=r||"").length>(a=a||300)&&(a=n.indexOf(">"),n=n.substring(0,a+1)),n):"")}Zn.prototype={get selector(){return this.spec.selector||[Hn(this.element,this._options)]},get ancestry(){return this.spec.ancestry||[Gn(this.element)]},get xpath(){return this.spec.xpath||[Wn(this.element)]},get element(){return this._element},toJSON:function(){return{selector:this.selector,source:this.source,xpath:this.xpath,ancestry:this.ancestry,nodeIndexes:this.nodeIndexes}}},Zn.fromFrame=function(e,t,n){return e=Zn.mergeSpecs(e,n),new Zn(n.element,t,e)},Zn.mergeSpecs=function(e,t){return U({},e,{selector:[].concat($(t.selector),$(e.selector)),ancestry:[].concat($(t.ancestry),$(e.ancestry)),xpath:[].concat($(t.xpath),$(e.xpath)),nodeIndexes:[].concat($(t.nodeIndexes),$(e.nodeIndexes))})};var Jn=Zn,Qn=function(e,n,a,r){return{isAsync:!1,async:function(){return this.isAsync=!0,function(t){t instanceof Error==0?(e.result=t,a(e)):r(t)}},data:function(t){e.data=t},relatedNodes:function(a){t.Node&&(a=a instanceof t.Node||a instanceof on?[a]:Fn(a),e.relatedNodes=[],a.forEach((function(a){(a=a instanceof on?a.actualNode:a)instanceof t.Node&&(a=new Jn(a,n),e.relatedNodes.push(a))})))}}},ea=function e(n){var a,o,u,i=n;if(null!=(a=t)&&a.Node&&n instanceof t.Node||null!=(a=t)&&a.HTMLCollection&&n instanceof t.HTMLCollection)return n;if(null!==n&&"object"===r(n))if(Array.isArray(n))for(i=[],o=0,u=n.length;o<u;o++)i[o]=e(n[o]);else for(o in i={},n)i[o]=e(n[o]);return i},ta=((Po=new(re(ve()).CssSelectorParser)).registerSelectorPseudos("not"),Po.registerSelectorPseudos("is"),Po.registerNestingOperators(">"),Po.registerAttrEqualityMods("^","$","*","~"),Po);function na(e,t){return u=t,1===(o=e).props.nodeType&&("*"===u.tag||o.props.nodeName===u.tag)&&(r=e,!(o=t).classes||o.classes.every((function(e){return r.hasClass(e.value)})))&&(a=e,!(u=t).attributes||u.attributes.every((function(e){var t=a.attr(e.key);return null!==t&&e.test(t)})))&&(o=e,!(u=t).id||o.props.id===u.id)&&(n=e,!((o=t).pseudos&&!o.pseudos.every((function(e){if("not"===e.name)return!e.expressions.some((function(e){return la(n,e)}));if("is"===e.name)return e.expressions.some((function(e){return la(n,e)}));throw new Error("the pseudo selector "+e.name+" has not yet been implemented")}))));var n,a,r,o,u}aa=/(?=[\\-\\[\\]{}()*+?.\\\\\\^$|,#\\s])/g;var aa,ra=function(e){return e.replace(aa,"\\\\")},oa=/\\\\/g;function ua(e){return e.map((function(e){for(var t=[],n=e.rule;n;)t.push({tag:n.tagName?n.tagName.toLowerCase():"*",combinator:n.nestingOperator||" ",id:n.id,attributes:function(e){if(e)return e.map((function(e){var t,n,a=e.name.replace(oa,""),r=(e.value||"").replace(oa,"");switch(e.operator){case"^=":n=new RegExp("^"+ra(r));break;case"$=":n=new RegExp(ra(r)+"$");break;case"~=":n=new RegExp("(^|\\\\s)"+ra(r)+"(\\\\s|$)");break;case"|=":n=new RegExp("^"+ra(r)+"(-|$)");break;case"=":t=function(e){return r===e};break;case"*=":t=function(e){return e&&e.includes(r)};break;case"!=":t=function(e){return r!==e};break;default:t=function(e){return null!==e}}return""===r&&/^[*$^]=$/.test(e.operator)&&(t=function(){return!1}),{key:a,value:r,type:void 0===e.value?"attrExist":"attrValue",test:t=t||function(e){return e&&n.test(e)}}}))}(n.attrs),classes:function(e){if(e)return e.map((function(e){return{value:e=e.replace(oa,""),regexp:new RegExp("(^|\\\\s)"+ra(e)+"(\\\\s|$)")}}))}(n.classNames),pseudos:function(e){if(e)return e.map((function(e){var t;return["is","not"].includes(e.name)&&(t=ua(t=(t=e.value).selectors||[t])),{name:e.name,expressions:t,value:e.value}}))}(n.pseudos)}),n=n.rule;return t}))}function ia(e){return ua((e=ta.parse(e)).selectors||[e])}function la(e,t,n){return function e(t,n,a,r){if(!t)return!1;for(var o=Array.isArray(n)?n[a]:n,u=na(t,o);!u&&r&&t.parent;)u=na(t=t.parent,o);if(0<a){if(!1===[" ",">"].includes(o.combinator))throw new Error("axe.utils.matchesExpression does not support the combinator: "+o.combinator);u=u&&e(t.parent,n,a-1," "===o.combinator)}return u}(e,t,t.length-1,n)}var sa=function(e,t){return ia(t).some((function(t){return la(e,t)}))},ca=function(e,t){for(;e;){if(sa(e,t))return e;if(void 0===e.parent)throw new TypeError("Cannot resolve parent for non-DOM nodes");e=e.parent}return null};function da(){}function pa(e){if("function"!=typeof e)throw new TypeError("Queue methods require functions as arguments")}for(var fa,Da,ma,ha=function(){function e(e){t=e,setTimeout((function(){null!=t&&nn("Uncaught error (of queue)",t)}),1)}var t,n=[],a=0,o=0,u=da,i=!1,l=e;function s(e){return u=da,l(e),n}function c(){for(var e=n.length;a<e;a++){var t=n[a];try{t.call(null,function(e){return function(t){n[e]=t,--o||u===da||(i=!0,u(n))}}(a),s)}catch(e){s(e)}}}var d={defer:function(e){var a;if("object"===r(e)&&e.then&&e.catch&&(a=e,e=function(e,t){a.then(e).catch(t)}),pa(e),void 0===t){if(i)throw new Error("Queue already completed");return n.push(e),++o,c(),d}},then:function(e){if(pa(e),u!==da)throw new Error("queue `then` already set");return t||(u=e,o)||(i=!0,u(n)),d},catch:function(n){if(pa(n),l!==e)throw new Error("queue `catch` already set");return t?(n(t),t=null):l=n,d},abort:s};return d},ga=t.crypto||t.msCrypto,ba=(!fa&&ga&&ga.getRandomValues&&(Da=new Uint8Array(16),fa=function(){return ga.getRandomValues(Da),Da}),fa||(ma=new Array(16),fa=function(){for(var e,t=0;t<16;t++)0==(3&t)&&(e=4294967296*Math.random()),ma[t]=e>>>((3&t)<<3)&255;return ma}),"function"==typeof t.Buffer?t.Buffer:Array),va=[],ya={},Fa=0;Fa<256;Fa++)va[Fa]=(Fa+256).toString(16).substr(1),ya[va[Fa]]=Fa;function wa(e,t){return t=t||0,va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[+t]]}var Ea=[1|(Po=fa())[0],Po[1],Po[2],Po[3],Po[4],Po[5]],Ca=16383&(Po[6]<<8|Po[7]),xa=0,Aa=0;function ka(e,t,n){var a=t&&n||0,r=t||[],o=(n=null!=(e=e||{}).clockseq?e.clockseq:Ca,null!=e.msecs?e.msecs:(new Date).getTime()),u=null!=e.nsecs?e.nsecs:Aa+1;if((i=o-xa+(u-Aa)/1e4)<0&&null==e.clockseq&&(n=n+1&16383),1e4<=(u=(i<0||xa<o)&&null==e.nsecs?0:u))throw new Error("uuid.v1(): Can\'t create more than 10M uuids/sec");xa=o,Ca=n;for(var i=(1e4*(268435455&(o+=122192928e5))+(Aa=u))%4294967296,l=(u=(r[a++]=i>>>24&255,r[a++]=i>>>16&255,r[a++]=i>>>8&255,r[a++]=255&i,o/4294967296*1e4&268435455),r[a++]=u>>>8&255,r[a++]=255&u,r[a++]=u>>>24&15|16,r[a++]=u>>>16&255,r[a++]=n>>>8|128,r[a++]=255&n,e.node||Ea),s=0;s<6;s++)r[a+s]=l[s];return t||wa(r)}function Ba(e,t,n){var a=t&&n||0,r=("string"==typeof e&&(t="binary"==e?new ba(16):null,e=null),(e=e||{}).random||(e.rng||fa)());if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,t)for(var o=0;o<16;o++)t[a+o]=r[o];return t||wa(r)}(Po=Ba).v1=ka,Po.v4=Ba,Po.parse=function(e,t,n){var a=t&&n||0,r=0;for(t=t||[],e.toLowerCase().replace(/[0-9a-f]{2}/g,(function(e){r<16&&(t[a+r++]=ya[e])}));r<16;)t[a+r++]=0;return t},Po.unparse=wa,Po.BufferClass=ba,o._uuid=ka();var Ta=Ba,Na=Object.freeze(["EvalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError"]);function Ra(){var e="axeAPI",t="";return(e=void 0!==o&&o._audit&&o._audit.application?o._audit.application:e)+"."+(void 0!==o?o.version:t)}function _a(e){Sa(e),yn(t.parent===e,"Source of the response must be the parent window.")}function Oa(e){Sa(e),yn(e.parent===t,"Respondable target must be a frame in the current window")}function Sa(e){yn(t!==e,"Messages can not be sent to the same window.")}var Ma={},Pa=[];function Ia(){var e="".concat(Ba(),":").concat(Ba());return Pa.includes(e)?Ia():(Pa.push(e),e)}function ja(e,t,n,a){var r,u;return"function"==typeof a&&function(e,t,n){var a=!(2<arguments.length&&void 0!==n)||n;yn(!Ma[e],"A replyHandler already exists for this message channel."),Ma[e]={replyHandler:t,sendToParent:a}}(t.channelId,a,n),(n?_a:Oa)(e),t.message instanceof Error&&!n?(o.log(t.message),!1):(n=(a=U({messageId:Ia()},t)).topic,t=a.channelId,u=a.message,t={channelId:t,topic:n,messageId:a.messageId,keepalive:!!a.keepalive,source:Ra()},u instanceof Error?t.error={name:u.name,message:u.message,stack:u.stack}:t.payload=u,r=JSON.stringify(t),!(!(n=o._audit.allowedOrigins)||!n.length||(n.forEach((function(t){try{e.postMessage(r,t)}catch(n){if(n instanceof e.DOMException)throw new Error(\'allowedOrigins value "\'.concat(t,\'" is not a valid origin\'));throw n}})),0)))}function La(e,t,n){var a=!(2<arguments.length&&void 0!==n)||n;return function(n,r,o){ja(e,{channelId:t,message:n,keepalive:r},a,o)}}function qa(e,n){var a,u,i,l=e.origin,s=e.data;e=e.source;try{var c=function(e){var n,a,o,u;try{n=JSON.parse(e)}catch(e){return}if(null!==(e=n)&&"object"===r(e)&&"string"==typeof e.channelId&&e.source===Ra())return a=(e=n).topic,o=e.channelId,u=e.messageId,e=e.keepalive,{topic:a,message:"object"===r(n.error)?function(e){var n=e.message||"Unknown error occurred",a=Na.includes(e.name)?e.name:"Error";return a=t[a]||Error,e.stack&&(n+="\\n"+e.stack.replace(e.message,"")),new a(n)}(n.error):n.payload,messageId:u,channelId:o,keepalive:!!e}}(s)||{},d=c.channelId,p=c.message,f=c.messageId;if(u=l,((i=o._audit.allowedOrigins)&&i.includes("*")||i.includes(u))&&(a=f,!Pa.includes(a))&&(Pa.push(a),1))if(p instanceof Error&&e.parent!==t)o.log(p);else try{if(c.topic){var D=La(e,d);_a(e),n(c,D)}else{var m=e,h=(b=c).channelId,g=b.message,b=b.keepalive,v=(y=function(e){return Ma[e]}(h)||{}).replyHandler,y=y.sendToParent;if(v){(y?_a:Oa)(m),m=La(m,h,y),!b&&h&&function(e){delete Ma[e]}(h);try{v(g,b,m)}catch(n){o.log(n),m(n,b)}}}}catch(n){var F=e,w=n,E=d;if(!F.parent!==t)o.log(w);else try{ja(F,{topic:null,channelId:E,message:w,messageId:Ia(),keepalive:!0},!0)}catch(n){return void o.log(n)}}}catch(n){o.log(n)}}var za,Va,$a={open:function(e){var n;if("function"==typeof t.addEventListener)return t.addEventListener("message",n=function(t){qa(t,e)},!1),function(){t.removeEventListener("message",n,!1)}},post:function(e,n,a){return"function"==typeof t.addEventListener&&ja(e,n,!1,a)}};function Ha(e){e.updateMessenger($a)}var Ua={};function Ga(e,t,n,a,r){return t={topic:t,message:n,channelId:"".concat(Ba(),":").concat(Ba()),keepalive:a},Va(e,t,r)}function Wa(e,t){var n=e.topic,a=e.message;e=e.keepalive;if(n=Ua[n])try{n(a,e,t)}catch(n){o.log(n),t(n,e)}}function Ya(e,t,n,a){var r,o=e.contentWindow,u=null!=(u=null==(u=t.options)?void 0:u.pingWaitTime)?u:500;o?0===u?Ka(e,t,n,a):(r=setTimeout((function(){r=setTimeout((function(){t.debug?a(Xa("No response from frame",e)):n(null)}),0)}),u),Ga(o,"axe.ping",null,void 0,(function(){clearTimeout(r),Ka(e,t,n,a)}))):(nn("Frame does not have a content window",e),n(null))}function Ka(e,t,n,a){var r=null!=(r=null==(r=t.options)?void 0:r.frameWaitTime)?r:6e4,o=e.contentWindow,u=setTimeout((function(){a(Xa("Axe in frame timed out",e))}),r);Ga(o,"axe.start",t,void 0,(function(e){clearTimeout(u),(e instanceof Error==0?n:a)(e)}))}function Xa(e,t){var n;return o._tree&&(n=Hn(t)),new Error(e+": "+(n||t))}Ga.updateMessenger=function(e){var t=e.open;e=e.post,yn("function"==typeof t,"open callback must be a function"),yn("function"==typeof e,"post callback must be a function"),za&&za(),t=t(Wa);za=t?(yn("function"==typeof t,"open callback must return a cleanup function"),t):null,Va=e},Ga.subscribe=function(e,t){yn("function"==typeof t,"Subscriber callback must be a function"),yn(!Ua[e],"Topic ".concat(e," is already registered to.")),Ua[e]=t},Ga.isInFrame=function(){return!!(0<arguments.length&&void 0!==arguments[0]?arguments[0]:t).frameElement},Ha(Ga);var Za=function(e){return[].concat(e.any||[]).concat(e.all||[]).concat(e.none||[])},Ja=function(e,t,n){if(Array.isArray(e))return e.find((function(e){return"object"===r(e)&&e[t]===n}))};function Qa(e,t){for(var n=0<arguments.length&&void 0!==e?e:[],a=1<arguments.length&&void 0!==t?t:[],r=Math.max(null==n?void 0:n.length,null==a?void 0:a.length),o=0;o<r;o++){var u=null==n?void 0:n[o],i=null==a?void 0:a[o];if("number"!=typeof u||isNaN(u))return 0===o?1:-1;if("number"!=typeof i||isNaN(i))return 0===o?-1:1;if(u!==i)return u-i}return 0}var er=function(e,t){var n=[];return e.forEach((function(e){var a,r=(r=e)&&r.results?Array.isArray(r.results)?r.results.length?r.results:null:[r.results]:null;r&&r.length&&(a=function(e,t){return e.frameElement?new Jn(e.frameElement,t):e.frameSpec?e.frameSpec:null}(e,t),r.forEach((function(e){e.nodes&&a&&(u=e.nodes,r=t,o=a,u.forEach((function(e){e.node=Jn.fromFrame(e.node,r,o),Za(e).forEach((function(e){e.relatedNodes=e.relatedNodes.map((function(e){return Jn.fromFrame(e,r,o)}))}))})));var r,o,u=Ja(n,"id",e.id);if(u){if(e.nodes.length){for(var i=u.nodes,l=e.nodes,s=l[0].node,c=0;c<i.length;c++){var d=i[c].node,p=Qa(d.nodeIndexes,s.nodeIndexes);if(0<p||0===p&&s.selector.length<d.selector.length)return void i.splice.apply(i,[c,0].concat($(l)))}i.push.apply(i,$(l))}}else n.push(e)})))})),n.forEach((function(e){e.nodes&&e.nodes.sort((function(e,t){return Qa(e.node.nodeIndexes,t.node.nodeIndexes)}))})),n};function tr(e,t,n,a,r,o){var u=ha();e.frames.forEach((function(e){var r=e.node,o=V(e,i);u.defer((function(e,u){Ya(r,{options:t,command:n,parameter:a,context:o},(function(t){return e(t?{results:t,frameElement:r}:null)}),u)}))})),u.then((function(e){r(er(e,t))})).catch(o)}function nr(e,t){if(!e.shadowId&&!t.shadowId&&e.actualNode&&"function"==typeof e.actualNode.contains)return e.actualNode.contains(t.actualNode);do{if(e===t)return!0;if(t.nodeIndex<e.nodeIndex)return!1}while(t=t.parent);return!1}var ar=function e(){for(var t={},n=arguments.length,a=new Array(n),o=0;o<n;o++)a[o]=arguments[o];return a.forEach((function(n){if(n&&"object"===r(n)&&!Array.isArray(n))for(var a=0,o=Object.keys(n);a<o.length;a++){var u=o[a];!t.hasOwnProperty(u)||"object"!==r(n[u])||Array.isArray(t[u])?t[u]=n[u]:t[u]=e(t[u],n[u])}})),t},rr=function(e,t){Object.assign(e,t),Object.keys(t).filter((function(e){return"function"==typeof t[e]})).forEach((function(n){e[n]=null;try{e[n]=t[n](e)}catch(n){}}))},or=["article","aside","blockquote","body","div","footer","h1","h2","h3","h4","h5","h6","header","main","nav","p","section","span"],ur=function(e){return!!(e.shadowRoot&&(e=e.nodeName.toLowerCase(),or.includes(e)||/^[a-z][a-z0-9_.-]*-[a-z0-9_.-]*$/.test(e)))},ir={},lr=(ae(ir,{createGrid:function(){return Xr},findElmsInContext:function(){return cr},findNearbyElms:function(){return ao},findUp:function(){return pr},findUpVirtual:function(){return dr},focusDisabled:function(){return po},getComposedParent:function(){return Mr},getElementByReference:function(){return ho},getElementCoordinates:function(){return Ir},getElementStack:function(){return ko},getModalDialog:function(){return uo},getOverflowHiddenAncestors:function(){return gr},getRootNode:function(){return sr},getScrollOffset:function(){return Pr},getTabbableElements:function(){return Bo},getTextElementStack:function(){return Di},getViewportSize:function(){return jr},getVisibleChildTextRects:function(){return fi},hasContent:function(){return yi},hasContentVirtual:function(){return vi},hasLangText:function(){return Fi},idrefs:function(){return No},insertedIntoFocusOrder:function(){return wi},isCurrentPageLink:function(){return mo},isFocusable:function(){return Qo},isHTML5:function(){return Ai},isHiddenForEveryone:function(){return _r},isHiddenWithCSS:function(){return xi},isInTabOrder:function(){return ki},isInTextBlock:function(){return Ri},isInert:function(){return io},isModalOpen:function(){return _i},isMultiline:function(){return Oi},isNativelyFocusable:function(){return Jo},isNode:function(){return Si},isOffscreen:function(){return Lr},isOpaque:function(){return Bc},isSkipLink:function(){return Tc},isVisible:function(){return Oc},isVisibleOnScreen:function(){return zr},isVisibleToScreenReaders:function(){return Pu},isVisualContent:function(){return hi},reduceToElementsBelowFloating:function(){return Sc},shadowElementsFromPoint:function(){return Lc},urlPropsFromAttribute:function(){return qc},visuallyContains:function(){return Mc},visuallyOverlaps:function(){return zc},visuallySort:function(){return go}}),function(e){var t=e.getRootNode&&e.getRootNode()||a;return t===e?a:t}),sr=lr,cr=function(e){var t=e.context,n=e.value,a=e.attr;e=void 0===(e=e.elm)?"":e,n=wn(n),t=9===t.nodeType||11===t.nodeType?t:sr(t);return Array.from(t.querySelectorAll(e+"["+a+"="+n+"]"))},dr=function(e,t){var n=e.actualNode;if(!e.shadowId&&"function"==typeof e.actualNode.closest)return e.actualNode.closest(t)||null;for(;(n=(n=n.assignedSlot||n.parentNode)&&11===n.nodeType?n.host:n)&&!Tn(n,t)&&n!==a.documentElement;);return n&&Tn(n,t)?n:null},pr=function(e,t){return dr(Xn(e),t)},fr=re(Kt()),Dr=(o._memoizedFns=[],function(e){return e=(0,fr.default)(e),o._memoizedFns.push(e),e});function mr(e,t){return(0|e.left)<(0|t.right)&&(0|e.right)>(0|t.left)&&(0|e.top)<(0|t.bottom)&&(0|e.bottom)>(0|t.top)}var hr=Dr((function(e){var t=[];return e?("hidden"===e.getComputedStylePropertyValue("overflow")&&t.push(e),t.concat(hr(e.parent))):t})),gr=hr,br=/rect\\s*\\(([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px\\s*\\)/,vr=/(\\w+)\\((\\d+)/;function yr(e){return["style","script","noscript","template"].includes(e.props.nodeName)}function Fr(e){return"area"!==e.props.nodeName&&"none"===e.getComputedStylePropertyValue("display")}function wr(e){return!(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor&&["hidden","collapse"].includes(e.getComputedStylePropertyValue("visibility"))}function Er(e){return!!(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor&&"hidden"===e.getComputedStylePropertyValue("content-visibility")}function Cr(e){return"true"===e.attr("aria-hidden")}function xr(e){return"0"===e.getComputedStylePropertyValue("opacity")}function Ar(e){var t=Ad(e.actualNode),n=parseInt(e.getComputedStylePropertyValue("height"));e=parseInt(e.getComputedStylePropertyValue("width"));return!!t&&(0===n||0===e)}function kr(e){var t,n;return!(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor&&(t=e.boundingClientRect,!!(n=gr(e)).length)&&n.some((function(e){return(e=e.boundingClientRect).width<2||e.height<2||!mr(t,e)}))}function Br(e){var t=e.getComputedStylePropertyValue("clip").match(br),n=e.getComputedStylePropertyValue("clip-path").match(vr);if(t&&5===t.length&&(e=e.getComputedStylePropertyValue("position"),["fixed","absolute"].includes(e)))return t[3]-t[1]<=0&&t[2]-t[4]<=0;if(n){e=n[1];var a=parseInt(n[2],10);switch(e){case"inset":return 50<=a;case"circle":return 0===a}}return!1}function Tr(e,t){var n,a=ca(e,"map");return!a||!((a=a.attr("name"))&&(e=lr(e.actualNode))&&9===e.nodeType&&(n=cp(o._tree,\'img[usemap="#\'.concat(wn(a),\'"]\')))&&n.length)||n.some((function(e){return!t(e)}))}function Nr(e){var t;return"details"===(null==(t=e.parent)?void 0:t.props.nodeName)&&(("summary"!==e.props.nodeName||e.parent.children.find((function(e){return"summary"===e.props.nodeName}))!==e)&&!e.parent.hasAttr("open"))}var Rr=[Fr,wr,Er,Nr];function _r(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).skipAncestors,n=void 0!==(n=n.isAncestor)&&n;return e=Ld(e).vNode,(t?Or:Sr)(e,n)}var Or=Dr((function(e,t){return!!yr(e)||!(!e.actualNode||!Rr.some((function(n){return n(e,{isAncestor:t})}))&&e.actualNode.isConnected)})),Sr=Dr((function(e,t){return!!Or(e,t)||!!e.parent&&Sr(e.parent,!0)})),Mr=function e(t){if(t.assignedSlot)return e(t.assignedSlot);if(t.parentNode){if(1===(t=t.parentNode).nodeType)return t;if(t.host)return t.host}return null},Pr=function(e){var t,n;return 9===(e=!e.nodeType&&e.document?e.document:e).nodeType?(t=e.documentElement,n=e.body,{left:t&&t.scrollLeft||n&&n.scrollLeft||0,top:t&&t.scrollTop||n&&n.scrollTop||0}):{left:e.scrollLeft,top:e.scrollTop}},Ir=function(e){var t=(n=Pr(a)).left,n=n.top;return{top:(e=e.getBoundingClientRect()).top+n,right:e.right+t,bottom:e.bottom+n,left:e.left+t,width:e.right-e.left,height:e.bottom-e.top}},jr=function(e){var t=e.document,n=t.documentElement;return e.innerWidth?{width:e.innerWidth,height:e.innerHeight}:n?{width:n.clientWidth,height:n.clientHeight}:{width:(e=t.body).clientWidth,height:e.clientHeight}},Lr=function(e){if((1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor)return!1;var n=Ld(e).domNode;if(n){var r=a.documentElement,o=t.getComputedStyle(n),u=t.getComputedStyle(a.body||r).getPropertyValue("direction"),i=Ir(n);if(i.bottom<0&&(function(e,t){for(e=Mr(e);e&&"html"!==e.nodeName.toLowerCase();){if(e.scrollTop&&0<=(t+=e.scrollTop))return;e=Mr(e)}return 1}(n,i.bottom)||"absolute"===o.position))return!0;if(0!==i.left||0!==i.right)if("ltr"===u){if(i.right<=0)return!0}else if(n=Math.max(r.scrollWidth,jr(t).width),i.left>=n)return!0;return!1}},qr=[xr,Ar,kr,Br,Lr];function zr(e){return e=Ld(e).vNode,Vr(e)}var Vr=Dr((function(e,t){return e.actualNode&&"area"===e.props.nodeName?!Tr(e,Vr):!(_r(e,{skipAncestors:!0,isAncestor:t})||e.actualNode&&qr.some((function(n){return n(e,{isAncestor:t})})))&&(!e.parent||Vr(e.parent,!0))}));function $r(e,n){var a=Math.min(e.top,n.top),r=Math.max(e.right,n.right),o=Math.max(e.bottom,n.bottom);e=Math.min(e.left,n.left);return new t.DOMRect(e,a,r-e,o-a)}function Hr(e,t){var n=e.x,a=(e=e.y,t.top),r=t.right,o=t.bottom;t=t.left;return a<=e&&n<=r&&e<=o&&t<=n}var Ur=0,Gr=.1,Wr=.2,Yr=.3,Kr=0;function Xr(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:a.body,n=1<arguments.length?arguments[1]:void 0,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!Kn.get("gridCreated")||r){Kn.set("gridCreated",!0),r||(i=(i=Xn(a.documentElement))||new Uc(a.documentElement),Kr=0,i._stackingOrder=[Jr(Ur,null)],Qr(n=null!=n?n:new eo,i),Ad(i.actualNode)&&(u=new eo(i),i._subGrid=u));for(var u,i,l=a.createTreeWalker(e,t.NodeFilter.SHOW_ELEMENT,null,!1),s=r?l.nextNode():l.currentNode;s;){var c=Xn(s),d=(c&&c.parent?r=c.parent:s.assignedSlot?r=Xn(s.assignedSlot):s.parentElement?r=Xn(s.parentElement):s.parentNode&&Xn(s.parentNode)&&(r=Xn(s.parentNode)),(c=c||new o.VirtualNode(s,r))._stackingOrder=function(e,t,n){var a=t._stackingOrder.slice();if(function(e,t){var n=e.getComputedStylePropertyValue("position"),a=e.getComputedStylePropertyValue("z-index");return"fixed"===n||"sticky"===n||"auto"!==a&&"static"!==n||"1"!==e.getComputedStylePropertyValue("opacity")||"none"!==(e.getComputedStylePropertyValue("-webkit-transform")||e.getComputedStylePropertyValue("-ms-transform")||e.getComputedStylePropertyValue("transform")||"none")||(n=e.getComputedStylePropertyValue("mix-blend-mode"))&&"normal"!==n||(n=e.getComputedStylePropertyValue("filter"))&&"none"!==n||(n=e.getComputedStylePropertyValue("perspective"))&&"none"!==n||(n=e.getComputedStylePropertyValue("clip-path"))&&"none"!==n||"none"!==(e.getComputedStylePropertyValue("-webkit-mask")||e.getComputedStylePropertyValue("mask")||"none")||"none"!==(e.getComputedStylePropertyValue("-webkit-mask-image")||e.getComputedStylePropertyValue("mask-image")||"none")||"none"!==(e.getComputedStylePropertyValue("-webkit-mask-border")||e.getComputedStylePropertyValue("mask-border")||"none")||"isolate"===e.getComputedStylePropertyValue("isolation")||"transform"===(n=e.getComputedStylePropertyValue("will-change"))||"opacity"===n||"touch"===e.getComputedStylePropertyValue("-webkit-overflow-scrolling")?1:(n=e.getComputedStylePropertyValue("contain"),["layout","paint","strict","content"].includes(n)||"auto"!==a&&Zr(t)?1:void 0)}(e,t)){var r=a.findIndex((function(e){return e=e.value,[Ur,Wr,Yr].includes(e)}));r=(-1!==r&&a.splice(r,a.length-r),function(e,t){return"static"!==e.getComputedStylePropertyValue("position")||Zr(t)?e.getComputedStylePropertyValue("z-index"):"auto"}(e,t));if(["auto","0"].includes(r)){for(var o=n.toString();o.length<10;)o="0"+o;a.push(Jr(parseFloat("".concat(Gr).concat(o)),e))}else a.push(Jr(parseInt(r),e))}else"static"!==e.getComputedStylePropertyValue("position")?a.push(Jr(Yr,e)):"none"!==e.getComputedStylePropertyValue("float")&&a.push(Jr(Wr,e));return a}(c,r,Kr++),function(e,t){for(var n=null,a=[e];t;){if(Ad(t.actualNode)){n=t;break}if(t._scrollRegionParent){n=t._scrollRegionParent;break}a.push(t),t=Xn(t.actualNode.parentElement||t.actualNode.parentNode)}return a.forEach((function(e){return e._scrollRegionParent=n})),n}(c,r)),p=(d=d?d._subGrid:n,Ad(c.actualNode)&&(p=new eo(c),c._subGrid=p),c.boundingClientRect);0!==p.width&&0!==p.height&&zr(s)&&Qr(d,c),ur(s)&&Xr(s.shadowRoot,d,c),s=l.nextNode()}}return tn.gridSize}function Zr(e){if(e)return e=e.getComputedStylePropertyValue("display"),["flex","inline-flex","grid","inline-grid"].includes(e)}function Jr(e,t){return{value:e,vNode:t}}function Qr(e,t){t.clientRects.forEach((function(n){null==t._grid&&(t._grid=e),n=e.getGridPositionOfRect(n),e.loopGridPosition(n,(function(e){e.includes(t)||e.push(t)}))}))}Z(to,[{key:"toGridIndex",value:function(e){return Math.floor(e/tn.gridSize)}},{key:"getCellFromPoint",value:function(e){var t=e.x;e=e.y,yn(this.boundaries,"Grid does not have cells added"),e=this.toGridIndex(e),t=this.toGridIndex(t);return null!=(t=(e=(yn(Hr({y:e,x:t},this.boundaries),"Element midpoint exceeds the grid bounds"),null!=(e=this.cells[e-this.cells._negativeIndex])?e:[]))[t-e._negativeIndex])?t:[]}},{key:"loopGridPosition",value:function(e,t){var n=(o=e).left,a=o.right,r=o.top,o=o.bottom;this.boundaries&&(e=$r(this.boundaries,e)),this.boundaries=e,no(this.cells,r,o,(function(e,r){no(e,n,a,(function(e,n){t(e,{row:r,col:n})}))}))}},{key:"getGridPositionOfRect",value:function(e){var n=e.top,a=e.right,r=e.bottom,o=e.left,u=1<arguments.length&&void 0!==arguments[1]?arguments[1]:0;n=this.toGridIndex(n-u),a=this.toGridIndex(a+u-1),r=this.toGridIndex(r+u-1),o=this.toGridIndex(o-u);return new t.DOMRect(o,n,a-o,r-n)}}]);var eo=to;function to(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null;K(this,to),this.container=e,this.cells=[]}function no(e,t,n,a){if(null!=e._negativeIndex||(e._negativeIndex=0),t<e._negativeIndex){for(var r=0;r<e._negativeIndex-t;r++)e.splice(0,0,[]);e._negativeIndex=t}for(var o,u=t-e._negativeIndex,i=n-e._negativeIndex,l=u;l<=i;l++)null==e[o=l]&&(e[o]=[]),a(e[l],l+e._negativeIndex)}function ao(e){var t,n,a,r,o=1<arguments.length&&void 0!==arguments[1]?arguments[1]:0;return Xr(),null!=(a=e._grid)&&null!=(a=a.cells)&&a.length?(a=e.boundingClientRect,t=e._grid,n=ro(e),a=t.getGridPositionOfRect(a,o),r=[],t.loopGridPosition(a,(function(t){var a,o=Q(t);try{for(o.s();!(a=o.n()).done;){var u=a.value;u&&u!==e&&!r.includes(u)&&n===ro(u)&&r.push(u)}}catch(t){o.e(t)}finally{o.f()}})),r):[]}var ro=Dr((function(e){return!!e&&("fixed"===e.getComputedStylePropertyValue("position")||ro(e.parent))}));function oo(e,n){var a=Math.max(e.left,n.left),r=Math.min(e.right,n.right),o=Math.max(e.top,n.top);e=Math.min(e.bottom,n.bottom);return r<=a||e<=o?null:new t.DOMRect(a,o,r-a,e-o)}var uo=Dr((function(){var e;return o._tree&&(e=ep(o._tree[0],"dialog[open]",(function(e){var t=e.boundingClientRect;return a.elementsFromPoint(t.left+1,t.top+1).includes(e.actualNode)&&zr(e)}))).length?e.find((function(e){var t=e.boundingClientRect;return a.elementsFromPoint(t.left-10,t.top-10).includes(e.actualNode)}))||(null!=(e=e.find((function(e){e=null!=(e=function(e){Xr();var n=o._tree[0]._grid,a=new t.DOMRect(0,0,t.innerWidth,t.innerHeight);if(n)for(var r=0;r<n.cells.length;r++){var u=n.cells[r];if(u)for(var i=0;i<u.length;i++){var l=u[i];if(l)for(var s=0;s<l.length;s++){var c=l[s],d=oo(c.boundingClientRect,a);if("html"!==c.props.nodeName&&c!==e&&"none"!==c.getComputedStylePropertyValue("pointer-events")&&d)return{vNode:c,rect:d}}}}}(e))?e:{};var n=e.vNode;e=e.rect;return!!n&&!a.elementsFromPoint(e.left+1,e.top+1).includes(n.actualNode)})))?e:null):null}));function io(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).skipAncestors,n=n.isAncestor;return(t?lo:so)(e,n)}var lo=Dr((function(e,t){return!!e.hasAttr("inert")||!(t||!e.actualNode||!(t=uo())||nr(t,e))})),so=Dr((function(e,t){return!!lo(e,t)||!!e.parent&&so(e.parent,!0)})),co=["button","command","fieldset","keygen","optgroup","option","select","textarea","input"],po=function(e){var t=Ld(e).vNode;if(e=t.props.nodeName,co.includes(e)&&t.hasAttr("disabled")||io(t))return!0;for(var n=t.parent,a=[],r=!1;n&&n.shadowId===t.shadowId&&!r&&(a.push(n),"legend"!==n.props.nodeName);){if(void 0!==n._inDisabledFieldset){r=n._inDisabledFieldset;break}"fieldset"===n.props.nodeName&&n.hasAttr("disabled")&&(r=!0),n=n.parent}return a.forEach((function(e){return e._inDisabledFieldset=r})),!!r||"area"!==t.props.nodeName&&!!t.actualNode&&_r(t)},fo=/^\\/\\#/,Do=/^#[!/]/;function mo(e){var n,a,r,o,u=e.getAttribute("href");return!(!u||"#"===u)&&(!!fo.test(u)||(o=e.hash,n=e.protocol,a=e.hostname,r=e.port,e=e.pathname,!Do.test(o)&&("#"===u.charAt(0)||("string"!=typeof(null==(o=t.location)?void 0:o.origin)||-1===t.location.origin.indexOf("://")?null:(u=t.location.origin+t.location.pathname,o=a?"".concat(n,"//").concat(a).concat(r?":".concat(r):""):t.location.origin,(o+=e?("/"!==e[0]?"/":"")+e:t.location.pathname)===u)))))}var ho=function(e,t){var n=e.getAttribute(t);return n&&("href"!==t||mo(e))?(-1!==n.indexOf("#")&&(n=decodeURIComponent(n.substr(n.indexOf("#")+1))),(t=a.getElementById(n))||((t=a.getElementsByName(n)).length?t[0]:null)):null};function go(e,n){Xr();for(var a=Math.max(e._stackingOrder.length,n._stackingOrder.length),r=0;r<a;r++){if(void 0===n._stackingOrder[r])return-1;if(void 0===e._stackingOrder[r])return 1;if(n._stackingOrder[r].value>e._stackingOrder[r].value)return 1;if(n._stackingOrder[r].value<e._stackingOrder[r].value)return-1}var o=e.actualNode,u=n.actualNode;if(o.getRootNode&&o.getRootNode()!==u.getRootNode()){for(var i=[];o;)i.push({root:o.getRootNode(),node:o}),o=o.getRootNode().host;for(;u&&!i.find((function(e){return e.root===u.getRootNode()}));)u=u.getRootNode().host;if((o=i.find((function(e){return e.root===u.getRootNode()})).node)===u)return e.actualNode.getRootNode()!==o.getRootNode()?-1:1}var l,s=(d=t.Node).DOCUMENT_POSITION_FOLLOWING,c=d.DOCUMENT_POSITION_CONTAINS,d=d.DOCUMENT_POSITION_CONTAINED_BY;s=(l=o.compareDocumentPosition(u))&s?1:-1,c=l&c||l&d;return(l=bo(e))===(d=bo(n))||c?s:d-l}function bo(e){return-1!==e.getComputedStylePropertyValue("display").indexOf("inline")?2:function e(t){if(!t)return!1;if(void 0!==t._isFloated)return t._isFloated;var n=t.getComputedStylePropertyValue("float");return"none"!==n?t._isFloated=!0:(n=e(t.parent),t._isFloated=n,n)}(e)?1:0}var vo={};function yo(e,t){e=e.boundingClientRect,t=t.boundingClientRect;var n,a,r,o=(n=e,a=t,r={},[["x","left","right","width"],["y","top","bottom","height"]].forEach((function(e){var t,o=(e=G(e,4))[0],u=e[1],i=e[2];e=e[3];a[u]<n[u]&&a[i]>n[i]?r[o]=n[u]+n[e]/2:(e=a[u]+a[e]/2,t=Math.abs(e-n[u]),e=Math.abs(e-n[i]),r[o]=e<=t?n[u]:n[i])})),r);e=function(e,t,n){var a=e.x;if(function(e,t){var n=e.x;return(e=e.y)>=t.top&&n<=t.right&&e<=t.bottom&&n>=t.left}({x:a,y:e=e.y},n)){var r=function(e,t,n){var a,r,o=e.x;e=e.y;return o===t.left&&t.right<n.right?a=t.right:o===t.right&&t.left>n.left&&(a=t.left),e===t.top&&t.bottom<n.bottom?r=t.bottom:e===t.bottom&&t.top>n.top&&(r=t.top),a||r?r?a&&Math.abs(o-a)<Math.abs(e-r)?{x:a,y:e}:{x:o,y:r}:{x:a,y:e}:null}({x:a,y:e},t,n);if(null!==r)return r;n=t}t=(r=n).top,n=r.right;var o=r.bottom,u=(r=r.left)<=a&&a<=n,i=t<=e&&e<=o;r=Math.abs(r-a)<Math.abs(n-a)?r:n,n=Math.abs(t-e)<Math.abs(o-e)?t:o;return!u&&i?{x:r,y:e}:u&&!i?{x:a,y:n}:u||i?Math.abs(a-r)<Math.abs(e-n)?{x:r,y:e}:{x:a,y:n}:{x:r,y:n}}(o,e,t);return t=o,o=e,e=Math.abs(t.x-o.x),t=Math.abs(t.y-o.y),e&&t?Math.sqrt(Math.pow(e,2)+Math.pow(t,2)):e||t}function Fo(e){var n=e.left,a=e.top,r=e.width;e=e.height;return new t.DOMPoint(n+r/2,a+e/2)}function wo(e,t){var n=e.boundingClientRect,a=t.boundingClientRect;return!(n.left>=a.right||n.right<=a.left||n.top>=a.bottom||n.bottom<=a.top)&&0<go(e,t)}function Eo(e,t){var n,a=[e],r=Q(t);try{function o(){var e=n.value;a=a.reduce((function(t,n){return t.concat(function(e,t){var n=e.top,a=e.left,r=e.bottom,o=e.right,u=n<t.bottom&&r>t.top,i=a<t.right&&o>t.left,l=[];return Co(t.top,n,r)&&i&&l.push({top:n,left:a,bottom:t.top,right:o}),Co(t.right,a,o)&&u&&l.push({top:n,left:t.right,bottom:r,right:o}),Co(t.bottom,n,r)&&i&&l.push({top:t.bottom,right:o,bottom:r,left:a}),Co(t.left,a,o)&&u&&l.push({top:n,left:a,bottom:r,right:t.left}),0===l.length&&l.push(e),l.map(xo)}(n,e))}),[])}for(r.s();!(n=r.n()).done;)o()}catch(e){r.e(e)}finally{r.f()}return a}ae(vo,{getBoundingRect:function(){return $r},getIntersectionRect:function(){return oo},getOffset:function(){return yo},getRectCenter:function(){return Fo},hasVisualOverlap:function(){return wo},isPointInRect:function(){return Hr},rectsOverlap:function(){return mr},splitRects:function(){return Eo}});var Co=function(e,t,n){return t<e&&e<n};function xo(e){return U({},e,{x:e.left,y:e.top,height:e.bottom-e.top,width:e.right-e.left})}function Ao(e,t,n){var r=2<arguments.length&&void 0!==n&&n,o=Fo(t),u=e.getCellFromPoint(o)||[],i=Math.floor(o.x),l=Math.floor(o.y);o=u.filter((function(e){return e.clientRects.some((function(e){var t=e.left,n=e.top;return i<Math.floor(t+e.width)&&i>=Math.floor(t)&&l<Math.floor(n+e.height)&&l>=Math.floor(n)}))}));return(u=e.container)&&(o=Ao(u._grid,u.boundingClientRect,!0).concat(o)),r?o:o.sort(go).map((function(e){return e.actualNode})).concat(a.documentElement).filter((function(e,t,n){return n.indexOf(e)===t}))}var ko=function(e){Xr();var t=(e=Xn(e))._grid;return t?Ao(t,e.boundingClientRect):[]},Bo=function(e){return cp(e,"*").filter((function(e){var t=e.isFocusable;return(e=(e=e.actualNode.getAttribute("tabindex"))&&!isNaN(parseInt(e,10))?parseInt(e):null)?t&&0<=e:t}))},To={},No=(ae(To,{accessibleText:function(){return Ro},accessibleTextVirtual:function(){return ni},autocomplete:function(){return oi},formControlValue:function(){return Xu},formControlValueMethods:function(){return Yu},hasUnicode:function(){return Ju},isHumanInterpretable:function(){return ri},isIconLigature:function(){return Qu},isValidAutocomplete:function(){return ui},label:function(){return ci},labelText:function(){return Tu},labelVirtual:function(){return si},nativeElementType:function(){return di},nativeTextAlternative:function(){return Su},nativeTextMethods:function(){return Ou},removeUnicode:function(){return ai},sanitize:function(){return Zo},subtreeText:function(){return Bu},titleText:function(){return Cu},unsupported:function(){return Mu},visible:function(){return li},visibleTextNodes:function(){return pi},visibleVirtual:function(){return ju}}),function(e,t){e=e.actualNode||e;try{var n=sr(e),a=[];if(r=e.getAttribute(t))for(var r=Gc(r),o=0;o<r.length;o++)a.push(n.getElementById(r[o]));return a}catch(e){throw new TypeError("Cannot resolve id references for non-DOM nodes")}}),Ro=function(e,t){return e=Xn(e),ni(e,t)},_o=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=Ld(e).vNode;return 1!==(null==n?void 0:n.props.nodeType)||1!==n.props.nodeType||t.inLabelledByContext||t.inControlContext||!n.attr("aria-labelledby")?"":No(n,"aria-labelledby").filter((function(e){return e})).reduce((function(e,a){return a=Ro(a,U({inLabelledByContext:!0,startNode:t.startNode||n},t)),e?"".concat(e," ").concat(a):a}),"")};function Oo(e){return 1===(null==(e=Ld(e).vNode)?void 0:e.props.nodeType)&&e.attr("aria-label")||""}var So={"aria-activedescendant":{type:"idref",allowEmpty:!0},"aria-atomic":{type:"boolean",global:!0},"aria-autocomplete":{type:"nmtoken",values:["inline","list","both","none"]},"aria-braillelabel":{type:"string",global:!0},"aria-brailleroledescription":{type:"string",global:!0},"aria-busy":{type:"boolean",global:!0},"aria-checked":{type:"nmtoken",values:["false","mixed","true","undefined"]},"aria-colcount":{type:"int",minValue:-1},"aria-colindex":{type:"int",minValue:1},"aria-colspan":{type:"int",minValue:1},"aria-controls":{type:"idrefs",allowEmpty:!0,global:!0},"aria-current":{type:"nmtoken",allowEmpty:!0,values:["page","step","location","date","time","true","false"],global:!0},"aria-describedby":{type:"idrefs",allowEmpty:!0,global:!0},"aria-description":{type:"string",allowEmpty:!0,global:!0},"aria-details":{type:"idref",allowEmpty:!0,global:!0},"aria-disabled":{type:"boolean",global:!0},"aria-dropeffect":{type:"nmtokens",values:["copy","execute","link","move","none","popup"],global:!0},"aria-errormessage":{type:"idref",allowEmpty:!0,global:!0},"aria-expanded":{type:"nmtoken",values:["true","false","undefined"]},"aria-flowto":{type:"idrefs",allowEmpty:!0,global:!0},"aria-grabbed":{type:"nmtoken",values:["true","false","undefined"],global:!0},"aria-haspopup":{type:"nmtoken",allowEmpty:!0,values:["true","false","menu","listbox","tree","grid","dialog"],global:!0},"aria-hidden":{type:"nmtoken",values:["true","false","undefined"],global:!0},"aria-invalid":{type:"nmtoken",values:["grammar","false","spelling","true"],global:!0},"aria-keyshortcuts":{type:"string",allowEmpty:!0,global:!0},"aria-label":{type:"string",allowEmpty:!0,global:!0},"aria-labelledby":{type:"idrefs",allowEmpty:!0,global:!0},"aria-level":{type:"int",minValue:1},"aria-live":{type:"nmtoken",values:["assertive","off","polite"],global:!0},"aria-modal":{type:"boolean"},"aria-multiline":{type:"boolean"},"aria-multiselectable":{type:"boolean"},"aria-orientation":{type:"nmtoken",values:["horizontal","undefined","vertical"]},"aria-owns":{type:"idrefs",allowEmpty:!0,global:!0},"aria-placeholder":{type:"string",allowEmpty:!0},"aria-posinset":{type:"int",minValue:1},"aria-pressed":{type:"nmtoken",values:["false","mixed","true","undefined"]},"aria-readonly":{type:"boolean"},"aria-relevant":{type:"nmtokens",values:["additions","all","removals","text"],global:!0},"aria-required":{type:"boolean"},"aria-roledescription":{type:"string",allowEmpty:!0,global:!0},"aria-rowcount":{type:"int",minValue:-1},"aria-rowindex":{type:"int",minValue:1},"aria-rowspan":{type:"int",minValue:0},"aria-selected":{type:"nmtoken",values:["false","true","undefined"]},"aria-setsize":{type:"int",minValue:-1},"aria-sort":{type:"nmtoken",values:["ascending","descending","none","other"]},"aria-valuemax":{type:"decimal"},"aria-valuemin":{type:"decimal"},"aria-valuenow":{type:"decimal"},"aria-valuetext":{type:"string"}},Mo={alert:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},alertdialog:{type:"widget",allowedAttrs:["aria-expanded","aria-modal"],superclassRole:["alert","dialog"],accessibleNameRequired:!0},application:{type:"landmark",allowedAttrs:["aria-activedescendant","aria-expanded"],superclassRole:["structure"],accessibleNameRequired:!0},article:{type:"structure",allowedAttrs:["aria-posinset","aria-setsize","aria-expanded"],superclassRole:["document"]},banner:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},blockquote:{type:"structure",superclassRole:["section"]},button:{type:"widget",allowedAttrs:["aria-expanded","aria-pressed"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},caption:{type:"structure",requiredContext:["figure","table","grid","treegrid"],superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},cell:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-colindex","aria-colspan","aria-rowindex","aria-rowspan","aria-expanded"],superclassRole:["section"],nameFromContent:!0},checkbox:{type:"widget",requiredAttrs:["aria-checked"],allowedAttrs:["aria-readonly","aria-required"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},code:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},columnheader:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-sort","aria-colindex","aria-colspan","aria-expanded","aria-readonly","aria-required","aria-rowindex","aria-rowspan","aria-selected"],superclassRole:["cell","gridcell","sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},combobox:{type:"widget",requiredAttrs:["aria-expanded","aria-controls"],allowedAttrs:["aria-owns","aria-autocomplete","aria-readonly","aria-required","aria-activedescendant","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!0},command:{type:"abstract",superclassRole:["widget"]},complementary:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},composite:{type:"abstract",superclassRole:["widget"]},contentinfo:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},comment:{type:"structure",allowedAttrs:["aria-level","aria-posinset","aria-setsize"],superclassRole:["article"]},definition:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"]},deletion:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},dialog:{type:"widget",allowedAttrs:["aria-expanded","aria-modal"],superclassRole:["window"],accessibleNameRequired:!0},directory:{type:"structure",deprecated:!0,allowedAttrs:["aria-expanded"],superclassRole:["list"],nameFromContent:!0},document:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["structure"]},emphasis:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},feed:{type:"structure",requiredOwned:["article"],allowedAttrs:["aria-expanded"],superclassRole:["list"]},figure:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},form:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},grid:{type:"composite",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-level","aria-multiselectable","aria-readonly","aria-activedescendant","aria-colcount","aria-expanded","aria-rowcount"],superclassRole:["composite","table"],accessibleNameRequired:!1},gridcell:{type:"widget",requiredContext:["row"],allowedAttrs:["aria-readonly","aria-required","aria-selected","aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan"],superclassRole:["cell","widget"],nameFromContent:!0},group:{type:"structure",allowedAttrs:["aria-activedescendant","aria-expanded"],superclassRole:["section"]},heading:{type:"structure",requiredAttrs:["aria-level"],allowedAttrs:["aria-expanded"],superclassRole:["sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},img:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],accessibleNameRequired:!0,childrenPresentational:!0},input:{type:"abstract",superclassRole:["widget"]},insertion:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},landmark:{type:"abstract",superclassRole:["section"]},link:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0},list:{type:"structure",requiredOwned:["listitem"],allowedAttrs:["aria-expanded"],superclassRole:["section"]},listbox:{type:"widget",requiredOwned:["group","option"],allowedAttrs:["aria-multiselectable","aria-readonly","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!0},listitem:{type:"structure",requiredContext:["list"],allowedAttrs:["aria-level","aria-posinset","aria-setsize","aria-expanded"],superclassRole:["section"],nameFromContent:!0},log:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},main:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},marquee:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},math:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],childrenPresentational:!0},menu:{type:"composite",requiredOwned:["group","menuitemradio","menuitem","menuitemcheckbox","menu","separator"],allowedAttrs:["aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"]},menubar:{type:"composite",requiredOwned:["group","menuitemradio","menuitem","menuitemcheckbox","menu","separator"],allowedAttrs:["aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["menu"]},menuitem:{type:"widget",requiredContext:["menu","menubar","group"],allowedAttrs:["aria-posinset","aria-setsize","aria-expanded"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0},menuitemcheckbox:{type:"widget",requiredContext:["menu","menubar","group"],requiredAttrs:["aria-checked"],allowedAttrs:["aria-expanded","aria-posinset","aria-readonly","aria-setsize"],superclassRole:["checkbox","menuitem"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},menuitemradio:{type:"widget",requiredContext:["menu","menubar","group"],requiredAttrs:["aria-checked"],allowedAttrs:["aria-expanded","aria-posinset","aria-readonly","aria-setsize"],superclassRole:["menuitemcheckbox","radio"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},meter:{type:"structure",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-valuetext"],superclassRole:["range"],accessibleNameRequired:!0,childrenPresentational:!0},mark:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},navigation:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},none:{type:"structure",superclassRole:["structure"],prohibitedAttrs:["aria-label","aria-labelledby"]},note:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"]},option:{type:"widget",requiredContext:["group","listbox"],allowedAttrs:["aria-selected","aria-checked","aria-posinset","aria-setsize"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},paragraph:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},presentation:{type:"structure",superclassRole:["structure"],prohibitedAttrs:["aria-label","aria-labelledby"]},progressbar:{type:"widget",allowedAttrs:["aria-expanded","aria-valuemax","aria-valuemin","aria-valuenow","aria-valuetext"],superclassRole:["range"],accessibleNameRequired:!0,childrenPresentational:!0},radio:{type:"widget",requiredAttrs:["aria-checked"],allowedAttrs:["aria-posinset","aria-setsize","aria-required"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},radiogroup:{type:"composite",allowedAttrs:["aria-readonly","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!1},range:{type:"abstract",superclassRole:["widget"]},region:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"],accessibleNameRequired:!1},roletype:{type:"abstract",superclassRole:[]},row:{type:"structure",requiredContext:["grid","rowgroup","table","treegrid"],requiredOwned:["cell","columnheader","gridcell","rowheader"],allowedAttrs:["aria-colindex","aria-level","aria-rowindex","aria-selected","aria-activedescendant","aria-expanded","aria-posinset","aria-setsize"],superclassRole:["group","widget"],nameFromContent:!0},rowgroup:{type:"structure",requiredContext:["grid","table","treegrid"],requiredOwned:["row"],superclassRole:["structure"],nameFromContent:!0},rowheader:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-sort","aria-colindex","aria-colspan","aria-expanded","aria-readonly","aria-required","aria-rowindex","aria-rowspan","aria-selected"],superclassRole:["cell","gridcell","sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},scrollbar:{type:"widget",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-controls","aria-orientation","aria-valuemax","aria-valuemin","aria-valuetext"],superclassRole:["range"],childrenPresentational:!0},search:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},searchbox:{type:"widget",allowedAttrs:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-placeholder","aria-readonly","aria-required"],superclassRole:["textbox"],accessibleNameRequired:!0},section:{type:"abstract",superclassRole:["structure"],nameFromContent:!0},sectionhead:{type:"abstract",superclassRole:["structure"],nameFromContent:!0},select:{type:"abstract",superclassRole:["composite","group"]},separator:{type:"structure",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-orientation","aria-valuetext"],superclassRole:["structure","widget"],childrenPresentational:!0},slider:{type:"widget",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-orientation","aria-readonly","aria-required","aria-valuetext"],superclassRole:["input","range"],accessibleNameRequired:!0,childrenPresentational:!0},spinbutton:{type:"widget",allowedAttrs:["aria-valuemax","aria-valuemin","aria-readonly","aria-required","aria-activedescendant","aria-valuetext","aria-valuenow"],superclassRole:["composite","input","range"],accessibleNameRequired:!0},status:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},strong:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},structure:{type:"abstract",superclassRole:["roletype"]},subscript:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},superscript:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},switch:{type:"widget",requiredAttrs:["aria-checked"],allowedAttrs:["aria-readonly","aria-required"],superclassRole:["checkbox"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},suggestion:{type:"structure",requiredOwned:["insertion","deletion"],superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},tab:{type:"widget",requiredContext:["tablist"],allowedAttrs:["aria-posinset","aria-selected","aria-setsize","aria-expanded"],superclassRole:["sectionhead","widget"],nameFromContent:!0,childrenPresentational:!0},table:{type:"structure",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-colcount","aria-rowcount","aria-expanded"],superclassRole:["section"],accessibleNameRequired:!1,nameFromContent:!0},tablist:{type:"composite",requiredOwned:["tab"],allowedAttrs:["aria-level","aria-multiselectable","aria-orientation","aria-activedescendant","aria-expanded"],superclassRole:["composite"]},tabpanel:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"],accessibleNameRequired:!1},term:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},text:{type:"structure",superclassRole:["section"],nameFromContent:!0},textbox:{type:"widget",allowedAttrs:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-placeholder","aria-readonly","aria-required"],superclassRole:["input"],accessibleNameRequired:!0},time:{type:"structure",superclassRole:["section"]},timer:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["status"]},toolbar:{type:"structure",allowedAttrs:["aria-orientation","aria-activedescendant","aria-expanded"],superclassRole:["group"],accessibleNameRequired:!0},tooltip:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},tree:{type:"composite",requiredOwned:["group","treeitem"],allowedAttrs:["aria-multiselectable","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!1},treegrid:{type:"composite",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-activedescendant","aria-colcount","aria-expanded","aria-level","aria-multiselectable","aria-orientation","aria-readonly","aria-required","aria-rowcount"],superclassRole:["grid","tree"],accessibleNameRequired:!1},treeitem:{type:"widget",requiredContext:["group","tree"],allowedAttrs:["aria-checked","aria-expanded","aria-level","aria-posinset","aria-selected","aria-setsize"],superclassRole:["listitem","option"],accessibleNameRequired:!0,nameFromContent:!0},widget:{type:"abstract",superclassRole:["roletype"]},window:{type:"abstract",superclassRole:["roletype"]}},Po={a:{variant:{href:{matches:"[href]",contentTypes:["interactive","phrasing","flow"],allowedRoles:["button","checkbox","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab","treeitem","doc-backlink","doc-biblioref","doc-glossref","doc-noteref"],namingMethods:["subtreeText"]},default:{contentTypes:["phrasing","flow"],allowedRoles:!0}}},abbr:{contentTypes:["phrasing","flow"],allowedRoles:!0},address:{contentTypes:["flow"],allowedRoles:!0},area:{variant:{href:{matches:"[href]",allowedRoles:!1},default:{allowedRoles:["button","link"]}},contentTypes:["phrasing","flow"],namingMethods:["altText"]},article:{contentTypes:["sectioning","flow"],allowedRoles:["feed","presentation","none","document","application","main","region"],shadowRoot:!0},aside:{contentTypes:["sectioning","flow"],allowedRoles:["feed","note","presentation","none","region","search","doc-dedication","doc-example","doc-footnote","doc-pullquote","doc-tip"]},audio:{variant:{controls:{matches:"[controls]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application"],chromiumRole:"Audio"},b:{contentTypes:["phrasing","flow"],allowedRoles:!0},base:{allowedRoles:!1,noAriaAttrs:!0},bdi:{contentTypes:["phrasing","flow"],allowedRoles:!0},bdo:{contentTypes:["phrasing","flow"],allowedRoles:!0},blockquote:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},body:{allowedRoles:!1,shadowRoot:!0},br:{contentTypes:["phrasing","flow"],allowedRoles:["presentation","none"],namingMethods:["titleText","singleSpace"]},button:{contentTypes:["interactive","phrasing","flow"],allowedRoles:["checkbox","combobox","link","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab"],namingMethods:["subtreeText"]},canvas:{allowedRoles:!0,contentTypes:["embedded","phrasing","flow"],chromiumRole:"Canvas"},caption:{allowedRoles:!1},cite:{contentTypes:["phrasing","flow"],allowedRoles:!0},code:{contentTypes:["phrasing","flow"],allowedRoles:!0},col:{allowedRoles:!1,noAriaAttrs:!0},colgroup:{allowedRoles:!1,noAriaAttrs:!0},data:{contentTypes:["phrasing","flow"],allowedRoles:!0},datalist:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0,implicitAttrs:{"aria-multiselectable":"false"}},dd:{allowedRoles:!1},del:{contentTypes:["phrasing","flow"],allowedRoles:!0},dfn:{contentTypes:["phrasing","flow"],allowedRoles:!0},details:{contentTypes:["interactive","flow"],allowedRoles:!1},dialog:{contentTypes:["flow"],allowedRoles:["alertdialog"]},div:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},dl:{contentTypes:["flow"],allowedRoles:["group","list","presentation","none"],chromiumRole:"DescriptionList"},dt:{allowedRoles:["listitem"]},em:{contentTypes:["phrasing","flow"],allowedRoles:!0},embed:{contentTypes:["interactive","embedded","phrasing","flow"],allowedRoles:["application","document","img","presentation","none"],chromiumRole:"EmbeddedObject"},fieldset:{contentTypes:["flow"],allowedRoles:["none","presentation","radiogroup"],namingMethods:["fieldsetLegendText"]},figcaption:{allowedRoles:["group","none","presentation"]},figure:{contentTypes:["flow"],allowedRoles:!0,namingMethods:["figureText","titleText"]},footer:{contentTypes:["flow"],allowedRoles:["group","none","presentation","doc-footnote"],shadowRoot:!0},form:{contentTypes:["flow"],allowedRoles:["search","none","presentation"]},h1:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"1"}},h2:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"2"}},h3:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"3"}},h4:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"4"}},h5:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"5"}},h6:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"6"}},head:{allowedRoles:!1,noAriaAttrs:!0},header:{contentTypes:["flow"],allowedRoles:["group","none","presentation","doc-footnote"],shadowRoot:!0},hgroup:{contentTypes:["heading","flow"],allowedRoles:!0},hr:{contentTypes:["flow"],allowedRoles:["none","presentation","doc-pagebreak"],namingMethods:["titleText","singleSpace"]},html:{allowedRoles:!1,noAriaAttrs:!0},i:{contentTypes:["phrasing","flow"],allowedRoles:!0},iframe:{contentTypes:["interactive","embedded","phrasing","flow"],allowedRoles:["application","document","img","none","presentation"],chromiumRole:"Iframe"},img:{variant:{nonEmptyAlt:{matches:[{attributes:{alt:"/.+/"}},{hasAccessibleName:!0}],allowedRoles:["button","checkbox","link","menuitem","menuitemcheckbox","menuitemradio","option","progressbar","radio","scrollbar","separator","slider","switch","tab","treeitem","doc-cover"]},usemap:{matches:"[usemap]",contentTypes:["interactive","embedded","flow"]},default:{allowedRoles:["presentation","none"],contentTypes:["embedded","flow"]}},namingMethods:["altText"]},input:{variant:{button:{matches:{properties:{type:"button"}},allowedRoles:["checkbox","combobox","link","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab"]},buttonType:{matches:{properties:{type:["button","submit","reset"]}},namingMethods:["valueText","titleText","buttonDefaultText"]},checkboxPressed:{matches:{properties:{type:"checkbox"},attributes:{"aria-pressed":"/.*/"}},allowedRoles:["button","menuitemcheckbox","option","switch"],implicitAttrs:{"aria-checked":"false"}},checkbox:{matches:{properties:{type:"checkbox"},attributes:{"aria-pressed":null}},allowedRoles:["menuitemcheckbox","option","switch"],implicitAttrs:{"aria-checked":"false"}},noRoles:{matches:{properties:{type:["color","date","datetime-local","file","month","number","password","range","reset","submit","time","week"]}},allowedRoles:!1},hidden:{matches:{properties:{type:"hidden"}},contentTypes:["flow"],allowedRoles:!1,noAriaAttrs:!0},image:{matches:{properties:{type:"image"}},allowedRoles:["link","menuitem","menuitemcheckbox","menuitemradio","radio","switch"],namingMethods:["altText","valueText","labelText","titleText","buttonDefaultText"]},radio:{matches:{properties:{type:"radio"}},allowedRoles:["menuitemradio"],implicitAttrs:{"aria-checked":"false"}},textWithList:{matches:{properties:{type:"text"},attributes:{list:"/.*/"}},allowedRoles:!1},default:{contentTypes:["interactive","flow"],allowedRoles:["combobox","searchbox","spinbutton"],implicitAttrs:{"aria-valuenow":""},namingMethods:["labelText","placeholderText"]}}},ins:{contentTypes:["phrasing","flow"],allowedRoles:!0},kbd:{contentTypes:["phrasing","flow"],allowedRoles:!0},label:{contentTypes:["interactive","phrasing","flow"],allowedRoles:!1,chromiumRole:"Label"},legend:{allowedRoles:!1},li:{allowedRoles:["menuitem","menuitemcheckbox","menuitemradio","option","none","presentation","radio","separator","tab","treeitem","doc-biblioentry","doc-endnote"],implicitAttrs:{"aria-setsize":"1","aria-posinset":"1"}},link:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},main:{contentTypes:["flow"],allowedRoles:!1,shadowRoot:!0},map:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},math:{contentTypes:["embedded","phrasing","flow"],allowedRoles:!1},mark:{contentTypes:["phrasing","flow"],allowedRoles:!0},menu:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},meta:{variant:{itemprop:{matches:"[itemprop]",contentTypes:["phrasing","flow"]}},allowedRoles:!1,noAriaAttrs:!0},meter:{contentTypes:["phrasing","flow"],allowedRoles:!1,chromiumRole:"progressbar"},nav:{contentTypes:["sectioning","flow"],allowedRoles:["doc-index","doc-pagelist","doc-toc","menu","menubar","none","presentation","tablist"],shadowRoot:!0},noscript:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},object:{variant:{usemap:{matches:"[usemap]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application","document","img"],chromiumRole:"PluginObject"},ol:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},optgroup:{allowedRoles:!1},option:{allowedRoles:!1,implicitAttrs:{"aria-selected":"false"}},output:{contentTypes:["phrasing","flow"],allowedRoles:!0,namingMethods:["subtreeText"]},p:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},param:{allowedRoles:!1,noAriaAttrs:!0},picture:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},pre:{contentTypes:["flow"],allowedRoles:!0},progress:{contentTypes:["phrasing","flow"],allowedRoles:!1,implicitAttrs:{"aria-valuemax":"100","aria-valuemin":"0","aria-valuenow":"0"}},q:{contentTypes:["phrasing","flow"],allowedRoles:!0},rp:{allowedRoles:!0},rt:{allowedRoles:!0},ruby:{contentTypes:["phrasing","flow"],allowedRoles:!0},s:{contentTypes:["phrasing","flow"],allowedRoles:!0},samp:{contentTypes:["phrasing","flow"],allowedRoles:!0},script:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},section:{contentTypes:["sectioning","flow"],allowedRoles:["alert","alertdialog","application","banner","complementary","contentinfo","dialog","document","feed","group","log","main","marquee","navigation","none","note","presentation","search","status","tabpanel","doc-abstract","doc-acknowledgments","doc-afterword","doc-appendix","doc-bibliography","doc-chapter","doc-colophon","doc-conclusion","doc-credit","doc-credits","doc-dedication","doc-endnotes","doc-epigraph","doc-epilogue","doc-errata","doc-example","doc-foreword","doc-glossary","doc-index","doc-introduction","doc-notice","doc-pagelist","doc-part","doc-preface","doc-prologue","doc-pullquote","doc-qna","doc-toc"],shadowRoot:!0},select:{variant:{combobox:{matches:{attributes:{multiple:null,size:[null,"1"]}},allowedRoles:["menu"]},default:{allowedRoles:!1}},contentTypes:["interactive","phrasing","flow"],implicitAttrs:{"aria-valuenow":""},namingMethods:["labelText"]},slot:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},small:{contentTypes:["phrasing","flow"],allowedRoles:!0},source:{allowedRoles:!1,noAriaAttrs:!0},span:{contentTypes:["phrasing","flow"],allowedRoles:!0,shadowRoot:!0},strong:{contentTypes:["phrasing","flow"],allowedRoles:!0},style:{allowedRoles:!1,noAriaAttrs:!0},svg:{contentTypes:["embedded","phrasing","flow"],allowedRoles:!0,chromiumRole:"SVGRoot",namingMethods:["svgTitleText"]},sub:{contentTypes:["phrasing","flow"],allowedRoles:!0},summary:{allowedRoles:!1,namingMethods:["subtreeText"]},sup:{contentTypes:["phrasing","flow"],allowedRoles:!0},table:{contentTypes:["flow"],allowedRoles:!0,namingMethods:["tableCaptionText","tableSummaryText"]},tbody:{allowedRoles:!0},template:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},textarea:{contentTypes:["interactive","phrasing","flow"],allowedRoles:!1,implicitAttrs:{"aria-valuenow":"","aria-multiline":"true"},namingMethods:["labelText","placeholderText"]},tfoot:{allowedRoles:!0},thead:{allowedRoles:!0},time:{contentTypes:["phrasing","flow"],allowedRoles:!0},title:{allowedRoles:!1,noAriaAttrs:!0},td:{allowedRoles:!0},th:{allowedRoles:!0},tr:{allowedRoles:!0},track:{allowedRoles:!1,noAriaAttrs:!0},u:{contentTypes:["phrasing","flow"],allowedRoles:!0},ul:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},var:{contentTypes:["phrasing","flow"],allowedRoles:!0},video:{variant:{controls:{matches:"[controls]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application"],chromiumRole:"video"},wbr:{contentTypes:["phrasing","flow"],allowedRoles:["presentation","none"]}},Io={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},jo={ariaAttrs:So,ariaRoles:U({},Mo,{"doc-abstract":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-acknowledgments":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-afterword":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-appendix":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-backlink":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-biblioentry":{type:"listitem",allowedAttrs:["aria-expanded","aria-level","aria-posinset","aria-setsize"],superclassRole:["listitem"],deprecated:!0},"doc-bibliography":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-biblioref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-chapter":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-colophon":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-conclusion":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-cover":{type:"img",allowedAttrs:["aria-expanded"],superclassRole:["img"]},"doc-credit":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-credits":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-dedication":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-endnote":{type:"listitem",allowedAttrs:["aria-expanded","aria-level","aria-posinset","aria-setsize"],superclassRole:["listitem"],deprecated:!0},"doc-endnotes":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-epigraph":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-epilogue":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-errata":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-example":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-footnote":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-foreword":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-glossary":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-glossref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-index":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]},"doc-introduction":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-noteref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-notice":{type:"note",allowedAttrs:["aria-expanded"],superclassRole:["note"]},"doc-pagebreak":{type:"separator",allowedAttrs:["aria-expanded","aria-orientation"],superclassRole:["separator"],childrenPresentational:!0},"doc-pagelist":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]},"doc-part":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-preface":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-prologue":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-pullquote":{type:"none",superclassRole:["none"]},"doc-qna":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-subtitle":{type:"sectionhead",allowedAttrs:["aria-expanded"],superclassRole:["sectionhead"]},"doc-tip":{type:"note",allowedAttrs:["aria-expanded"],superclassRole:["note"]},"doc-toc":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]}},{"graphics-document":{type:"structure",superclassRole:["document"],accessibleNameRequired:!0},"graphics-object":{type:"structure",superclassRole:["group"],nameFromContent:!0},"graphics-symbol":{type:"structure",superclassRole:["img"],accessibleNameRequired:!0,childrenPresentational:!0}}),htmlElms:Po,cssColors:Io},Lo=U({},jo),qo=Lo,zo=function(e){return!!(e=qo.ariaRoles[e])&&!!e.unsupported},Vo=function(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).allowAbstract,n=void 0!==(n=n.flagUnsupported)&&n,a=qo.ariaRoles[e],r=zo(e);return!(!a||n&&r||!t&&"abstract"===a.type)},$o=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=t.fallback,a=t.abstracts,r=t.dpub;return 1===(e=e instanceof on?e:Xn(e)).props.nodeType&&(t=(e.attr("role")||"").trim().toLowerCase(),(n?Gc(t):[t]).find((function(e){return!(!r&&"doc-"===e.substr(0,4))&&Vo(e,{allowAbstract:a})})))||null},Ho=function(e){return Object.keys(qo.htmlElms).filter((function(t){return(t=qo.htmlElms[t]).contentTypes?t.contentTypes.includes(e):!!t.variant&&!(!t.variant.default||!t.variant.default.contentTypes)&&t.variant.default.contentTypes.includes(e)}))},Uo=function(){return Kn.get("globalAriaAttrs",(function(){return Object.keys(qo.ariaAttrs).filter((function(e){return qo.ariaAttrs[e].global}))}))},Go=Dr((function(e){for(var t=[],n=e.rows,a=0,r=n.length;a<r;a++)for(var o=n[a].cells,u=(t[a]=t[a]||[],0),i=0,l=o.length;i<l;i++)for(var s=0;s<o[i].colSpan;s++){for(var c=o[i].getAttribute("rowspan"),d=0===parseInt(c)||0===o[i].rowspan?n.length:o[i].rowSpan,p=0;p<d;p++){for(t[a+p]=t[a+p]||[];t[a+p][u];)u++;t[a+p][u]=o[i]}u++}return t})),Wo=Dr((function(e,t){var n,a;for(t=t||Go(pr(e,"table")),n=0;n<t.length;n++)if(t[n]&&-1!==(a=t[n].indexOf(e)))return{x:a,y:n}})),Yo=function(e){var t,n=(e=Ld(e)).vNode,a=(e=e.domNode,n.attr("scope")),r=n.attr("role");if(["td","th"].includes(n.props.nodeName))return"columnheader"===r?"col":"rowheader"===r?"row":"col"===a||"row"===a?a:"th"===n.props.nodeName&&(n.actualNode?(r=Go(pr(e,"table")))[(t=Wo(e,r)).y].reduce((function(e,t){return e&&"TH"===t.nodeName.toUpperCase()}),!0)?"col":r.map((function(e){return e[t.x]})).reduce((function(e,t){return e&&t&&"TH"===t.nodeName.toUpperCase()}),!0)?"row":"auto":"auto");throw new TypeError("Expected TD or TH element")},Ko=function(e){return-1!==["col","auto"].indexOf(Yo(e))},Xo=function(e){return["row","auto"].includes(Yo(e))},Zo=function(e){return e?e.replace(/\\r\\n/g,"\\n").replace(/\\u00A0/g," ").replace(/[\\s]{2,}/g," ").trim():""},Jo=function(e){var t=Ld(e).vNode;if(t&&!po(t))switch(t.props.nodeName){case"a":case"area":if(t.hasAttr("href"))return!0;break;case"input":return"hidden"!==t.props.type;case"textarea":case"select":case"summary":case"button":return!0;case"details":return!cp(t,"summary").length}return!1};function Qo(e){return 1===(e=Ld(e).vNode).props.nodeType&&!(po(e)||!Jo(e)&&(!(e=e.attr("tabindex"))||isNaN(parseInt(e,10))))}var eu=Ho("sectioning").map((function(e){return"".concat(e,":not([role])")})).join(", ")+" , main:not([role]), [role=article], [role=complementary], [role=main], [role=navigation], [role=region]";function tu(e){var t=Zo(_o(e));e=Zo(Oo(e));return t||e}var nu={a:function(e){return e.hasAttr("href")?"link":null},area:function(e){return e.hasAttr("href")?"link":null},article:"article",aside:"complementary",body:"document",button:"button",datalist:"listbox",dd:"definition",dfn:"term",details:"group",dialog:"dialog",dt:"term",fieldset:"group",figure:"figure",footer:function(e){return ca(e,eu)?null:"contentinfo"},form:function(e){return tu(e)?"form":null},h1:"heading",h2:"heading",h3:"heading",h4:"heading",h5:"heading",h6:"heading",header:function(e){return ca(e,eu)?null:"banner"},hr:"separator",img:function(e){var t=e.hasAttr("alt")&&!e.attr("alt"),n=Uo().find((function(t){return e.hasAttr(t)}));return!t||n||Qo(e)?"img":"presentation"},input:function(e){var t,n;switch(e.hasAttr("list")&&(n=(t=No(e.actualNode,"list").filter((function(e){return!!e}))[0])&&"datalist"===t.nodeName.toLowerCase()),e.props.type){case"checkbox":return"checkbox";case"number":return"spinbutton";case"radio":return"radio";case"range":return"slider";case"search":return n?"combobox":"searchbox";case"button":case"image":case"reset":case"submit":return"button";case"text":case"tel":case"url":case"email":case"":return n?"combobox":"textbox";default:return"textbox"}},li:"listitem",main:"main",math:"math",menu:"list",nav:"navigation",ol:"list",optgroup:"group",option:"option",output:"status",progress:"progressbar",section:function(e){return tu(e)?"region":null},select:function(e){return e.hasAttr("multiple")||1<parseInt(e.attr("size"))?"listbox":"combobox"},summary:"button",table:"table",tbody:"rowgroup",td:function(e){return e=ca(e,"table"),e=$o(e),["grid","treegrid"].includes(e)?"gridcell":"cell"},textarea:"textbox",tfoot:"rowgroup",th:function(e){return Ko(e)?"columnheader":Xo(e)?"rowheader":void 0},thead:"rowgroup",tr:"row",ul:"list"},au=function(e,t){var n=r(t);if(Array.isArray(t)&&void 0!==e)return t.includes(e);if("function"===n)return!!t(e);if(null!=e){if(t instanceof RegExp)return t.test(e);if(/^\\/.*\\/$/.test(t))return n=t.substring(1,t.length-1),new RegExp(n).test(e)}return t===e};function ru(e,t){return au(!!ni(e),t)}var ou=function(e,t){if("object"!==r(t)||Array.isArray(t)||t instanceof RegExp)throw new Error("Expect matcher to be an object");return Object.keys(t).every((function(n){return au(e(n),t[n])}))};function uu(e,t){return e=Ld(e).vNode,ou((function(t){return e.attr(t)}),t)}function iu(e,t){return!!t(e)}function lu(e,t){return au($o(e),t)}function su(e,t){return au(bu(e),t)}function cu(e,t){return e=Ld(e).vNode,au(e.props.nodeName,t)}function du(e,t){return e=Ld(e).vNode,ou((function(t){return e.props[t]}),t)}function pu(e,t){return au(wu(e),t)}var fu={hasAccessibleName:ru,attributes:uu,condition:iu,explicitRole:lu,implicitRole:su,nodeName:cu,properties:du,semanticRole:pu},Du=function e(t,n){return t=Ld(t).vNode,Array.isArray(n)?n.some((function(n){return e(t,n)})):"string"==typeof n?sa(t,n):Object.keys(n).every((function(e){var a;if(fu[e])return a=n[e],(0,fu[e])(t,a);throw new Error(\'Unknown matcher type "\'.concat(e,\'"\'))}))},mu=function(e,t){return Du(e,t)},hu=(mu.hasAccessibleName=ru,mu.attributes=uu,mu.condition=iu,mu.explicitRole=lu,mu.fromDefinition=Du,mu.fromFunction=ou,mu.fromPrimative=au,mu.implicitRole=su,mu.nodeName=cu,mu.properties=du,mu.semanticRole=pu,mu),gu=function(e){var t=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).noMatchAccessibleName,n=void 0!==t&&t,a=qo.htmlElms[e.props.nodeName];if(!a)return{};if(!a.variant)return a;var r,o,u=a.variant,i=V(a,l);for(r in u)if(u.hasOwnProperty(r)&&"default"!==r){for(var c=u[r],d=c.matches,p=V(c,s),f=Array.isArray(d)?d:[d],D=0;D<f.length&&n;D++)if(f[D].hasOwnProperty("hasAccessibleName"))return a;if(hu(e,d))for(var m in p)p.hasOwnProperty(m)&&(i[m]=p[m])}for(o in u.default)u.default.hasOwnProperty(o)&&void 0===i[o]&&(i[o]=u.default[o]);return i},bu=function(e){var t,n=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).chromium,a=e instanceof on?e:Xn(e);if(e=a.actualNode,a)return t=a.props.nodeName,!(t=nu[t])&&n?gu(a).chromiumRole||null:"function"==typeof t?t(a):t||null;throw new ReferenceError("Cannot get implicit role of a node outside the current scope.")},vu={td:["tr"],th:["tr"],tr:["thead","tbody","tfoot","table"],thead:["table"],tbody:["table"],tfoot:["table"],li:["ol","ul"],dt:["dl","div"],dd:["dl","div"],div:["dl"]};function yu(e,t){var n=t.chromium;t=V(t,c);return(n=bu(e,{chromium:n}))?function e(t,n){var a=vu[t.props.nodeName];if(a){if(t.parent)return a.includes(t.parent.props.nodeName)?(a=$o(t.parent,n),["none","presentation"].includes(a)&&!Fu(t.parent)?a:a?null:e(t.parent,n)):null;if(t.actualNode)throw new ReferenceError("Cannot determine role presentational inheritance of a required parent outside the current scope.")}return null}(e,t)||n:null}function Fu(e){return Uo().some((function(t){return e.hasAttr(t)}))||Qo(e)}var wu=function(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).noPresentational,n=function(e,t){var n,a=(r=1<arguments.length&&void 0!==t?t:{}).noImplicit,r=V(r,d),o=Ld(e).vNode;return 1!==o.props.nodeType?null:!(n=$o(o,r))||["presentation","none"].includes(n)&&Fu(o)?a?null:yu(o,r):n}(e,V(n,p));return t&&["presentation","none"].includes(n)?null:n},Eu=["iframe"],Cu=function(e){var t=Ld(e).vNode;return 1!==t.props.nodeType||!e.hasAttr("title")||!mu(t,Eu)&&["none","presentation"].includes(wu(t))?"":t.attr("title")},xu=function(e){var t,n,a=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).strict;return 1===(e=e instanceof on?e:Xn(e)).props.nodeType&&(t=wu(e),!(!(n=qo.ariaRoles[t])||!n.nameFromContent)||!a&&(!n||["presentation","none"].includes(t)))},Au=function(e){var t=e.actualNode,n=e.children;if(n)return e.hasAttr("aria-owns")?(e=No(t,"aria-owns").filter((function(e){return!!e})).map((function(e){return o.utils.getNodeFromTree(e)})),[].concat($(n),$(e))):$(n);throw new Error("getOwnedVirtual requires a virtual node")},ku=Ho("phrasing").concat(["#text"]),Bu=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=ni.alreadyProcessed;t.startNode=t.startNode||e;var a=(o=t).strict,r=o.inControlContext,o=o.inLabelledByContext,u=gu(e,{noMatchAccessibleName:!0}).contentTypes;return n(e,t)||1!==e.props.nodeType||null!=u&&u.includes("embedded")||!xu(e,{strict:a})&&!t.subtreeDescendant?"":(a||(t=U({subtreeDescendant:!r&&!o},t)),Au(e).reduce((function(e,n){var a=t,r=n.props.nodeName;return(n=ni(n,a))?(ku.includes(r)||(" "!==n[0]&&(n+=" "),e&&" "!==e[e.length-1]&&(n=" "+n)),e+n):e}),""))},Tu=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=ni.alreadyProcessed;if(t.inControlContext||t.inLabelledByContext||n(e,t))return"";t.startNode||(t.startNode=e);var a,r=U({inControlContext:!0},t);n=function(e){if(!e.attr("id"))return[];if(e.actualNode)return cr({elm:"label",attr:"for",value:e.attr("id"),context:e.actualNode});throw new TypeError("Cannot resolve explicit label reference for non-DOM nodes")}(e);return(t=ca(e,"label"))?(a=[].concat($(n),[t.actualNode])).sort(jd):a=n,a.map((function(e){return Ro(e,r)})).filter((function(e){return""!==e})).join(" ")},Nu={submit:"Submit",image:"Submit",reset:"Reset",button:""};function Ru(e,t){return t.attr(e)||""}function _u(e,t,n){t=t.actualNode;var a=[e=e.toLowerCase(),t.nodeName.toLowerCase()].join(",");return(t=t.querySelector(a))&&t.nodeName.toLowerCase()===e?Ro(t,n):""}var Ou={valueText:function(e){return e.actualNode.value||""},buttonDefaultText:function(e){return e=e.actualNode,Nu[e.type]||""},tableCaptionText:_u.bind(null,"caption"),figureText:_u.bind(null,"figcaption"),svgTitleText:_u.bind(null,"title"),fieldsetLegendText:_u.bind(null,"legend"),altText:Ru.bind(null,"alt"),tableSummaryText:Ru.bind(null,"summary"),titleText:Cu,subtreeText:Bu,labelText:Tu,singleSpace:function(){return" "},placeholderText:Ru.bind(null,"placeholder")},Su=function(e){var t,n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=e.actualNode;return 1!==e.props.nodeType||["presentation","none"].includes(wu(e))?"":(t=(gu(e,{noMatchAccessibleName:!0}).namingMethods||[]).map((function(e){return Ou[e]})).reduce((function(t,a){return t||a(e,n)}),""),n.debug&&o.log(t||"{empty-value}",a,n),t)},Mu={accessibleNameFromFieldValue:["combobox","listbox","progressbar"]};function Pu(e){return e=Ld(e).vNode,Iu(e)}var Iu=Dr((function(e,t){return!Cr(e)&&!io(e,{skipAncestors:!0,isAncestor:t})&&(e.actualNode&&"area"===e.props.nodeName?!Tr(e,Iu):!_r(e,{skipAncestors:!0,isAncestor:t})&&(!e.parent||Iu(e.parent,!0)))})),ju=function e(t,n,a){var r=Ld(t).vNode,o=n?Pu:zr,u=!t.actualNode||t.actualNode&&o(t);o=r.children.map((function(t){var r=(o=t.props).nodeType,o=o.nodeValue;if(3===r){if(o&&u)return o}else if(!a)return e(t,n)})).join("");return Zo(o)},Lu=["button","checkbox","color","file","hidden","image","password","radio","reset","submit"],qu=function(e){var t=(e=e instanceof on?e:Xn(e)).props.nodeName;return"textarea"===t||"input"===t&&!Lu.includes((e.attr("type")||"").toLowerCase())},zu=function(e){return"select"===(e=e instanceof on?e:Xn(e)).props.nodeName},Vu=function(e){return"textbox"===$o(e)},$u=function(e){return"listbox"===$o(e)},Hu=function(e){return"combobox"===$o(e)},Uu=["progressbar","scrollbar","slider","spinbutton"],Gu=function(e){return e=$o(e),Uu.includes(e)},Wu=["textbox","progressbar","scrollbar","slider","spinbutton","combobox","listbox"],Yu={nativeTextboxValue:function(e){return e=Ld(e).vNode,qu(e)&&e.props.value||""},nativeSelectValue:function(e){if(e=Ld(e).vNode,!zu(e))return"";var t=(e=cp(e,"option")).filter((function(e){return e.props.selected}));return t.length||t.push(e[0]),t.map((function(e){return ju(e)})).join(" ")||""},ariaTextboxValue:function(e){var t=(e=Ld(e)).vNode;e=e.domNode;return Vu(t)?e&&_r(e)?e.textContent:ju(t,!0):""},ariaListboxValue:Ku,ariaComboboxValue:function(e,t){e=Ld(e).vNode;return Hu(e)&&(e=Au(e).filter((function(e){return"listbox"===wu(e)}))[0])?Ku(e,t):""},ariaRangeValue:function(e){e=Ld(e).vNode;return Gu(e)&&e.hasAttr("aria-valuenow")?(e=+e.attr("aria-valuenow"),isNaN(e)?"0":String(e)):""}};function Ku(e,t){e=Ld(e).vNode;return $u(e)&&0!==(e=Au(e).filter((function(e){return"option"===wu(e)&&"true"===e.attr("aria-selected")}))).length?ni(e[0],t):""}var Xu=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=e.actualNode,a=Mu.accessibleNameFromFieldValue||[],r=wu(e);return t.startNode===e||!Wu.includes(r)||a.includes(r)?"":(a=Object.keys(Yu).map((function(e){return Yu[e]})).reduce((function(n,a){return n||a(e,t)}),""),t.debug&&nn(a||"{empty-value}",n,t),a)};function Zu(){return/[#*0-9]\\uFE0F?\\u20E3|[\\xA9\\xAE\\u203C\\u2049\\u2122\\u2139\\u2194-\\u2199\\u21A9\\u21AA\\u231A\\u231B\\u2328\\u23CF\\u23ED-\\u23EF\\u23F1\\u23F2\\u23F8-\\u23FA\\u24C2\\u25AA\\u25AB\\u25B6\\u25C0\\u25FB\\u25FC\\u25FE\\u2600-\\u2604\\u260E\\u2611\\u2614\\u2615\\u2618\\u2620\\u2622\\u2623\\u2626\\u262A\\u262E\\u262F\\u2638-\\u263A\\u2640\\u2642\\u2648-\\u2653\\u265F\\u2660\\u2663\\u2665\\u2666\\u2668\\u267B\\u267E\\u267F\\u2692\\u2694-\\u2697\\u2699\\u269B\\u269C\\u26A0\\u26A7\\u26AA\\u26B0\\u26B1\\u26BD\\u26BE\\u26C4\\u26C8\\u26CF\\u26D1\\u26D3\\u26E9\\u26F0-\\u26F5\\u26F7\\u26F8\\u26FA\\u2702\\u2708\\u2709\\u270F\\u2712\\u2714\\u2716\\u271D\\u2721\\u2733\\u2734\\u2744\\u2747\\u2757\\u2763\\u27A1\\u2934\\u2935\\u2B05-\\u2B07\\u2B1B\\u2B1C\\u2B55\\u3030\\u303D\\u3297\\u3299]\\uFE0F?|[\\u261D\\u270C\\u270D](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\u270A\\u270B](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\u23E9-\\u23EC\\u23F0\\u23F3\\u25FD\\u2693\\u26A1\\u26AB\\u26C5\\u26CE\\u26D4\\u26EA\\u26FD\\u2705\\u2728\\u274C\\u274E\\u2753-\\u2755\\u2795-\\u2797\\u27B0\\u27BF\\u2B50]|\\u26F9(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\u2764\\uFE0F?(?:\\u200D(?:\\uD83D\\uDD25|\\uD83E\\uDE79))?|\\uD83C(?:[\\uDC04\\uDD70\\uDD71\\uDD7E\\uDD7F\\uDE02\\uDE37\\uDF21\\uDF24-\\uDF2C\\uDF36\\uDF7D\\uDF96\\uDF97\\uDF99-\\uDF9B\\uDF9E\\uDF9F\\uDFCD\\uDFCE\\uDFD4-\\uDFDF\\uDFF5\\uDFF7]\\uFE0F?|[\\uDF85\\uDFC2\\uDFC7](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDFC3\\uDFC4\\uDFCA](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDFCB\\uDFCC](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDCCF\\uDD8E\\uDD91-\\uDD9A\\uDE01\\uDE1A\\uDE2F\\uDE32-\\uDE36\\uDE38-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF20\\uDF2D-\\uDF35\\uDF37-\\uDF7C\\uDF7E-\\uDF84\\uDF86-\\uDF93\\uDFA0-\\uDFC1\\uDFC5\\uDFC6\\uDFC8\\uDFC9\\uDFCF-\\uDFD3\\uDFE0-\\uDFF0\\uDFF8-\\uDFFF]|\\uDDE6\\uD83C[\\uDDE8-\\uDDEC\\uDDEE\\uDDF1\\uDDF2\\uDDF4\\uDDF6-\\uDDFA\\uDDFC\\uDDFD\\uDDFF]|\\uDDE7\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEF\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9\\uDDFB\\uDDFC\\uDDFE\\uDDFF]|\\uDDE8\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDEE\\uDDF0-\\uDDF5\\uDDF7\\uDDFA-\\uDDFF]|\\uDDE9\\uD83C[\\uDDEA\\uDDEC\\uDDEF\\uDDF0\\uDDF2\\uDDF4\\uDDFF]|\\uDDEA\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDED\\uDDF7-\\uDDFA]|\\uDDEB\\uD83C[\\uDDEE-\\uDDF0\\uDDF2\\uDDF4\\uDDF7]|\\uDDEC\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEE\\uDDF1-\\uDDF3\\uDDF5-\\uDDFA\\uDDFC\\uDDFE]|\\uDDED\\uD83C[\\uDDF0\\uDDF2\\uDDF3\\uDDF7\\uDDF9\\uDDFA]|\\uDDEE\\uD83C[\\uDDE8-\\uDDEA\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9]|\\uDDEF\\uD83C[\\uDDEA\\uDDF2\\uDDF4\\uDDF5]|\\uDDF0\\uD83C[\\uDDEA\\uDDEC-\\uDDEE\\uDDF2\\uDDF3\\uDDF5\\uDDF7\\uDDFC\\uDDFE\\uDDFF]|\\uDDF1\\uD83C[\\uDDE6-\\uDDE8\\uDDEE\\uDDF0\\uDDF7-\\uDDFB\\uDDFE]|\\uDDF2\\uD83C[\\uDDE6\\uDDE8-\\uDDED\\uDDF0-\\uDDFF]|\\uDDF3\\uD83C[\\uDDE6\\uDDE8\\uDDEA-\\uDDEC\\uDDEE\\uDDF1\\uDDF4\\uDDF5\\uDDF7\\uDDFA\\uDDFF]|\\uDDF4\\uD83C\\uDDF2|\\uDDF5\\uD83C[\\uDDE6\\uDDEA-\\uDDED\\uDDF0-\\uDDF3\\uDDF7-\\uDDF9\\uDDFC\\uDDFE]|\\uDDF6\\uD83C\\uDDE6|\\uDDF7\\uD83C[\\uDDEA\\uDDF4\\uDDF8\\uDDFA\\uDDFC]|\\uDDF8\\uD83C[\\uDDE6-\\uDDEA\\uDDEC-\\uDDF4\\uDDF7-\\uDDF9\\uDDFB\\uDDFD-\\uDDFF]|\\uDDF9\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDED\\uDDEF-\\uDDF4\\uDDF7\\uDDF9\\uDDFB\\uDDFC\\uDDFF]|\\uDDFA\\uD83C[\\uDDE6\\uDDEC\\uDDF2\\uDDF3\\uDDF8\\uDDFE\\uDDFF]|\\uDDFB\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDEE\\uDDF3\\uDDFA]|\\uDDFC\\uD83C[\\uDDEB\\uDDF8]|\\uDDFD\\uD83C\\uDDF0|\\uDDFE\\uD83C[\\uDDEA\\uDDF9]|\\uDDFF\\uD83C[\\uDDE6\\uDDF2\\uDDFC]|\\uDFF3\\uFE0F?(?:\\u200D(?:\\u26A7\\uFE0F?|\\uD83C\\uDF08))?|\\uDFF4(?:\\u200D\\u2620\\uFE0F?|\\uDB40\\uDC67\\uDB40\\uDC62\\uDB40(?:\\uDC65\\uDB40\\uDC6E\\uDB40\\uDC67|\\uDC73\\uDB40\\uDC63\\uDB40\\uDC74|\\uDC77\\uDB40\\uDC6C\\uDB40\\uDC73)\\uDB40\\uDC7F)?)|\\uD83D(?:[\\uDC08\\uDC26](?:\\u200D\\u2B1B)?|[\\uDC3F\\uDCFD\\uDD49\\uDD4A\\uDD6F\\uDD70\\uDD73\\uDD76-\\uDD79\\uDD87\\uDD8A-\\uDD8D\\uDDA5\\uDDA8\\uDDB1\\uDDB2\\uDDBC\\uDDC2-\\uDDC4\\uDDD1-\\uDDD3\\uDDDC-\\uDDDE\\uDDE1\\uDDE3\\uDDE8\\uDDEF\\uDDF3\\uDDFA\\uDECB\\uDECD-\\uDECF\\uDEE0-\\uDEE5\\uDEE9\\uDEF0\\uDEF3]\\uFE0F?|[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66\\uDC67\\uDC6B-\\uDC6D\\uDC72\\uDC74-\\uDC76\\uDC78\\uDC7C\\uDC83\\uDC85\\uDC8F\\uDC91\\uDCAA\\uDD7A\\uDD95\\uDD96\\uDE4C\\uDE4F\\uDEC0\\uDECC](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC6E\\uDC70\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD74\\uDD90](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC00-\\uDC07\\uDC09-\\uDC14\\uDC16-\\uDC25\\uDC27-\\uDC3A\\uDC3C-\\uDC3E\\uDC40\\uDC44\\uDC45\\uDC51-\\uDC65\\uDC6A\\uDC79-\\uDC7B\\uDC7D-\\uDC80\\uDC84\\uDC88-\\uDC8E\\uDC90\\uDC92-\\uDCA9\\uDCAB-\\uDCFC\\uDCFF-\\uDD3D\\uDD4B-\\uDD4E\\uDD50-\\uDD67\\uDDA4\\uDDFB-\\uDE2D\\uDE2F-\\uDE34\\uDE37-\\uDE44\\uDE48-\\uDE4A\\uDE80-\\uDEA2\\uDEA4-\\uDEB3\\uDEB7-\\uDEBF\\uDEC1-\\uDEC5\\uDED0-\\uDED2\\uDED5-\\uDED7\\uDEDC-\\uDEDF\\uDEEB\\uDEEC\\uDEF4-\\uDEFC\\uDFE0-\\uDFEB\\uDFF0]|\\uDC15(?:\\u200D\\uD83E\\uDDBA)?|\\uDC3B(?:\\u200D\\u2744\\uFE0F?)?|\\uDC41\\uFE0F?(?:\\u200D\\uD83D\\uDDE8\\uFE0F?)?|\\uDC68(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDC68\\uDC69]\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC69(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?[\\uDC68\\uDC69]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?|\\uDC69\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?))|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC6F(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDD75(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDE2E(?:\\u200D\\uD83D\\uDCA8)?|\\uDE35(?:\\u200D\\uD83D\\uDCAB)?|\\uDE36(?:\\u200D\\uD83C\\uDF2B\\uFE0F?)?)|\\uD83E(?:[\\uDD0C\\uDD0F\\uDD18-\\uDD1F\\uDD30-\\uDD34\\uDD36\\uDD77\\uDDB5\\uDDB6\\uDDBB\\uDDD2\\uDDD3\\uDDD5\\uDEC3-\\uDEC5\\uDEF0\\uDEF2-\\uDEF8](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDD26\\uDD35\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD4\\uDDD6-\\uDDDD](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDDDE\\uDDDF](?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD0D\\uDD0E\\uDD10-\\uDD17\\uDD20-\\uDD25\\uDD27-\\uDD2F\\uDD3A\\uDD3F-\\uDD45\\uDD47-\\uDD76\\uDD78-\\uDDB4\\uDDB7\\uDDBA\\uDDBC-\\uDDCC\\uDDD0\\uDDE0-\\uDDFF\\uDE70-\\uDE7C\\uDE80-\\uDE88\\uDE90-\\uDEBD\\uDEBF-\\uDEC2\\uDECE-\\uDEDB\\uDEE0-\\uDEE8]|\\uDD3C(?:\\u200D[\\u2640\\u2642]\\uFE0F?|\\uD83C[\\uDFFB-\\uDFFF])?|\\uDDD1(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1))|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFC-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFD-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFD\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFE]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?))?|\\uDEF1(?:\\uD83C(?:\\uDFFB(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFC-\\uDFFF])?|\\uDFFC(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])?|\\uDFFD(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])?|\\uDFFE(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])?|\\uDFFF(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFE])?))?)/g}var Ju=function(e,t){var n=t.emoji,a=t.nonBmp;t=t.punctuations;return n?/[#*0-9]\\uFE0F?\\u20E3|[\\xA9\\xAE\\u203C\\u2049\\u2122\\u2139\\u2194-\\u2199\\u21A9\\u21AA\\u231A\\u231B\\u2328\\u23CF\\u23ED-\\u23EF\\u23F1\\u23F2\\u23F8-\\u23FA\\u24C2\\u25AA\\u25AB\\u25B6\\u25C0\\u25FB\\u25FC\\u25FE\\u2600-\\u2604\\u260E\\u2611\\u2614\\u2615\\u2618\\u2620\\u2622\\u2623\\u2626\\u262A\\u262E\\u262F\\u2638-\\u263A\\u2640\\u2642\\u2648-\\u2653\\u265F\\u2660\\u2663\\u2665\\u2666\\u2668\\u267B\\u267E\\u267F\\u2692\\u2694-\\u2697\\u2699\\u269B\\u269C\\u26A0\\u26A7\\u26AA\\u26B0\\u26B1\\u26BD\\u26BE\\u26C4\\u26C8\\u26CF\\u26D1\\u26D3\\u26E9\\u26F0-\\u26F5\\u26F7\\u26F8\\u26FA\\u2702\\u2708\\u2709\\u270F\\u2712\\u2714\\u2716\\u271D\\u2721\\u2733\\u2734\\u2744\\u2747\\u2757\\u2763\\u27A1\\u2934\\u2935\\u2B05-\\u2B07\\u2B1B\\u2B1C\\u2B55\\u3030\\u303D\\u3297\\u3299]\\uFE0F?|[\\u261D\\u270C\\u270D](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\u270A\\u270B](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\u23E9-\\u23EC\\u23F0\\u23F3\\u25FD\\u2693\\u26A1\\u26AB\\u26C5\\u26CE\\u26D4\\u26EA\\u26FD\\u2705\\u2728\\u274C\\u274E\\u2753-\\u2755\\u2795-\\u2797\\u27B0\\u27BF\\u2B50]|\\u26F9(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\u2764\\uFE0F?(?:\\u200D(?:\\uD83D\\uDD25|\\uD83E\\uDE79))?|\\uD83C(?:[\\uDC04\\uDD70\\uDD71\\uDD7E\\uDD7F\\uDE02\\uDE37\\uDF21\\uDF24-\\uDF2C\\uDF36\\uDF7D\\uDF96\\uDF97\\uDF99-\\uDF9B\\uDF9E\\uDF9F\\uDFCD\\uDFCE\\uDFD4-\\uDFDF\\uDFF5\\uDFF7]\\uFE0F?|[\\uDF85\\uDFC2\\uDFC7](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDFC3\\uDFC4\\uDFCA](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDFCB\\uDFCC](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDCCF\\uDD8E\\uDD91-\\uDD9A\\uDE01\\uDE1A\\uDE2F\\uDE32-\\uDE36\\uDE38-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF20\\uDF2D-\\uDF35\\uDF37-\\uDF7C\\uDF7E-\\uDF84\\uDF86-\\uDF93\\uDFA0-\\uDFC1\\uDFC5\\uDFC6\\uDFC8\\uDFC9\\uDFCF-\\uDFD3\\uDFE0-\\uDFF0\\uDFF8-\\uDFFF]|\\uDDE6\\uD83C[\\uDDE8-\\uDDEC\\uDDEE\\uDDF1\\uDDF2\\uDDF4\\uDDF6-\\uDDFA\\uDDFC\\uDDFD\\uDDFF]|\\uDDE7\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEF\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9\\uDDFB\\uDDFC\\uDDFE\\uDDFF]|\\uDDE8\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDEE\\uDDF0-\\uDDF5\\uDDF7\\uDDFA-\\uDDFF]|\\uDDE9\\uD83C[\\uDDEA\\uDDEC\\uDDEF\\uDDF0\\uDDF2\\uDDF4\\uDDFF]|\\uDDEA\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDED\\uDDF7-\\uDDFA]|\\uDDEB\\uD83C[\\uDDEE-\\uDDF0\\uDDF2\\uDDF4\\uDDF7]|\\uDDEC\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEE\\uDDF1-\\uDDF3\\uDDF5-\\uDDFA\\uDDFC\\uDDFE]|\\uDDED\\uD83C[\\uDDF0\\uDDF2\\uDDF3\\uDDF7\\uDDF9\\uDDFA]|\\uDDEE\\uD83C[\\uDDE8-\\uDDEA\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9]|\\uDDEF\\uD83C[\\uDDEA\\uDDF2\\uDDF4\\uDDF5]|\\uDDF0\\uD83C[\\uDDEA\\uDDEC-\\uDDEE\\uDDF2\\uDDF3\\uDDF5\\uDDF7\\uDDFC\\uDDFE\\uDDFF]|\\uDDF1\\uD83C[\\uDDE6-\\uDDE8\\uDDEE\\uDDF0\\uDDF7-\\uDDFB\\uDDFE]|\\uDDF2\\uD83C[\\uDDE6\\uDDE8-\\uDDED\\uDDF0-\\uDDFF]|\\uDDF3\\uD83C[\\uDDE6\\uDDE8\\uDDEA-\\uDDEC\\uDDEE\\uDDF1\\uDDF4\\uDDF5\\uDDF7\\uDDFA\\uDDFF]|\\uDDF4\\uD83C\\uDDF2|\\uDDF5\\uD83C[\\uDDE6\\uDDEA-\\uDDED\\uDDF0-\\uDDF3\\uDDF7-\\uDDF9\\uDDFC\\uDDFE]|\\uDDF6\\uD83C\\uDDE6|\\uDDF7\\uD83C[\\uDDEA\\uDDF4\\uDDF8\\uDDFA\\uDDFC]|\\uDDF8\\uD83C[\\uDDE6-\\uDDEA\\uDDEC-\\uDDF4\\uDDF7-\\uDDF9\\uDDFB\\uDDFD-\\uDDFF]|\\uDDF9\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDED\\uDDEF-\\uDDF4\\uDDF7\\uDDF9\\uDDFB\\uDDFC\\uDDFF]|\\uDDFA\\uD83C[\\uDDE6\\uDDEC\\uDDF2\\uDDF3\\uDDF8\\uDDFE\\uDDFF]|\\uDDFB\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDEE\\uDDF3\\uDDFA]|\\uDDFC\\uD83C[\\uDDEB\\uDDF8]|\\uDDFD\\uD83C\\uDDF0|\\uDDFE\\uD83C[\\uDDEA\\uDDF9]|\\uDDFF\\uD83C[\\uDDE6\\uDDF2\\uDDFC]|\\uDFF3\\uFE0F?(?:\\u200D(?:\\u26A7\\uFE0F?|\\uD83C\\uDF08))?|\\uDFF4(?:\\u200D\\u2620\\uFE0F?|\\uDB40\\uDC67\\uDB40\\uDC62\\uDB40(?:\\uDC65\\uDB40\\uDC6E\\uDB40\\uDC67|\\uDC73\\uDB40\\uDC63\\uDB40\\uDC74|\\uDC77\\uDB40\\uDC6C\\uDB40\\uDC73)\\uDB40\\uDC7F)?)|\\uD83D(?:[\\uDC08\\uDC26](?:\\u200D\\u2B1B)?|[\\uDC3F\\uDCFD\\uDD49\\uDD4A\\uDD6F\\uDD70\\uDD73\\uDD76-\\uDD79\\uDD87\\uDD8A-\\uDD8D\\uDDA5\\uDDA8\\uDDB1\\uDDB2\\uDDBC\\uDDC2-\\uDDC4\\uDDD1-\\uDDD3\\uDDDC-\\uDDDE\\uDDE1\\uDDE3\\uDDE8\\uDDEF\\uDDF3\\uDDFA\\uDECB\\uDECD-\\uDECF\\uDEE0-\\uDEE5\\uDEE9\\uDEF0\\uDEF3]\\uFE0F?|[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66\\uDC67\\uDC6B-\\uDC6D\\uDC72\\uDC74-\\uDC76\\uDC78\\uDC7C\\uDC83\\uDC85\\uDC8F\\uDC91\\uDCAA\\uDD7A\\uDD95\\uDD96\\uDE4C\\uDE4F\\uDEC0\\uDECC](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC6E\\uDC70\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD74\\uDD90](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC00-\\uDC07\\uDC09-\\uDC14\\uDC16-\\uDC25\\uDC27-\\uDC3A\\uDC3C-\\uDC3E\\uDC40\\uDC44\\uDC45\\uDC51-\\uDC65\\uDC6A\\uDC79-\\uDC7B\\uDC7D-\\uDC80\\uDC84\\uDC88-\\uDC8E\\uDC90\\uDC92-\\uDCA9\\uDCAB-\\uDCFC\\uDCFF-\\uDD3D\\uDD4B-\\uDD4E\\uDD50-\\uDD67\\uDDA4\\uDDFB-\\uDE2D\\uDE2F-\\uDE34\\uDE37-\\uDE44\\uDE48-\\uDE4A\\uDE80-\\uDEA2\\uDEA4-\\uDEB3\\uDEB7-\\uDEBF\\uDEC1-\\uDEC5\\uDED0-\\uDED2\\uDED5-\\uDED7\\uDEDC-\\uDEDF\\uDEEB\\uDEEC\\uDEF4-\\uDEFC\\uDFE0-\\uDFEB\\uDFF0]|\\uDC15(?:\\u200D\\uD83E\\uDDBA)?|\\uDC3B(?:\\u200D\\u2744\\uFE0F?)?|\\uDC41\\uFE0F?(?:\\u200D\\uD83D\\uDDE8\\uFE0F?)?|\\uDC68(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDC68\\uDC69]\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC69(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?[\\uDC68\\uDC69]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?|\\uDC69\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?))|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC6F(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDD75(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDE2E(?:\\u200D\\uD83D\\uDCA8)?|\\uDE35(?:\\u200D\\uD83D\\uDCAB)?|\\uDE36(?:\\u200D\\uD83C\\uDF2B\\uFE0F?)?)|\\uD83E(?:[\\uDD0C\\uDD0F\\uDD18-\\uDD1F\\uDD30-\\uDD34\\uDD36\\uDD77\\uDDB5\\uDDB6\\uDDBB\\uDDD2\\uDDD3\\uDDD5\\uDEC3-\\uDEC5\\uDEF0\\uDEF2-\\uDEF8](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDD26\\uDD35\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD4\\uDDD6-\\uDDDD](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDDDE\\uDDDF](?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD0D\\uDD0E\\uDD10-\\uDD17\\uDD20-\\uDD25\\uDD27-\\uDD2F\\uDD3A\\uDD3F-\\uDD45\\uDD47-\\uDD76\\uDD78-\\uDDB4\\uDDB7\\uDDBA\\uDDBC-\\uDDCC\\uDDD0\\uDDE0-\\uDDFF\\uDE70-\\uDE7C\\uDE80-\\uDE88\\uDE90-\\uDEBD\\uDEBF-\\uDEC2\\uDECE-\\uDEDB\\uDEE0-\\uDEE8]|\\uDD3C(?:\\u200D[\\u2640\\u2642]\\uFE0F?|\\uD83C[\\uDFFB-\\uDFFF])?|\\uDDD1(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1))|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFC-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFD-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFD\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFE]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?))?|\\uDEF1(?:\\uD83C(?:\\uDFFB(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFC-\\uDFFF])?|\\uDFFC(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])?|\\uDFFD(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])?|\\uDFFE(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])?|\\uDFFF(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFE])?))?)/g.test(e):a?/[\\u1D00-\\u1D7F\\u1D80-\\u1DBF\\u1DC0-\\u1DFF\\u20A0-\\u20CF\\u20D0-\\u20FF\\u2100-\\u214F\\u2150-\\u218F\\u2190-\\u21FF\\u2200-\\u22FF\\u2300-\\u23FF\\u2400-\\u243F\\u2440-\\u245F\\u2460-\\u24FF\\u2500-\\u257F\\u2580-\\u259F\\u25A0-\\u25FF\\u2600-\\u26FF\\u2700-\\u27BF\\uE000-\\uF8FF]/g.test(e)||/[\\uDB80-\\uDBBF][\\uDC00-\\uDFFF]/g.test(e):!!t&&/[\\u2000-\\u206F\\u2E00-\\u2E7F\\\\\'!"#$%&\\xa3\\xa2\\xa5\\xa7\\u20ac()*+,\\-.\\/:;<=>?@\\[\\]^_`{|}~\\xb1]/g.test(e)},Qu=function(e){var n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:.15,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:3,o=e.actualNode.nodeValue.trim();if(!Zo(o)||Ju(o,{emoji:!0,nonBmp:!0}))return!1;var u=Kn.get("canvasContext",(function(){return a.createElement("canvas").getContext("2d",{willReadFrequently:!0})})),i=u.canvas,l=(Kn.get("fonts")||Kn.set("fonts",{}),Kn.get("fonts"));if(l[D=t.getComputedStyle(e.parent.actualNode).getPropertyValue("font-family")]||(l[D]={occurrences:0,numLigatures:0}),(l=l[D]).occurrences>=r){if(l.numLigatures/l.occurrences==1)return!0;if(0===l.numLigatures)return!1}l.occurrences++;var s="".concat(r=30,"px ").concat(D),c=(u.font=s,o.charAt(0)),d=u.measureText(c).width,p=(d<30&&(d*=p=30/d,s="".concat(r*=p,"px ").concat(D)),i.width=d,i.height=r,u.font=s,u.textAlign="left",u.textBaseline="top",u.fillText(c,0,0),new Uint32Array(u.getImageData(0,0,d,r).data.buffer));if(!p.some((function(e){return e})))return l.numLigatures++,!0;u.clearRect(0,0,d,r),u.fillText(o,0,0);var f=new Uint32Array(u.getImageData(0,0,d,r).data.buffer),D=p.reduce((function(e,t,n){return 0===t&&0===f[n]||0!==t&&0!==f[n]?e:++e}),0);i=o.split("").reduce((function(e,t){return e+u.measureText(t).width}),0),s=u.measureText(o).width;return n<=D/p.length&&n<=1-s/i&&(l.numLigatures++,!0)};function ei(e){var t,n,a,r,u,i=function(e,t){return t.startNode||(t=U({startNode:e},t)),1===e.props.nodeType&&t.inLabelledByContext&&void 0===t.includeHidden&&(t=U({includeHidden:!Pu(e)},t)),t}(e,1<arguments.length&&void 0!==arguments[1]?arguments[1]:{});return function(e,t){if(e&&1===e.props.nodeType&&!t.includeHidden)return!Pu(e)}(e,i)||(t=e,n=(u=i).ignoreIconLigature,a=u.pixelThreshold,r=null!=(r=u.occurrenceThreshold)?r:u.occuranceThreshold,3===t.props.nodeType&&n&&Qu(t,a,r))?"":(u=[_o,Oo,Su,Xu,Bu,ti,Cu].reduce((function(t,n){return""!==(t=i.startNode===e?Zo(t):t)?t:n(e,i)}),""),i.debug&&o.log(u||"{empty-value}",e.actualNode,i),u)}function ti(e){return 3!==e.props.nodeType?"":e.props.nodeValue}ei.alreadyProcessed=function(e,t){return t.processed=t.processed||[],!!t.processed.includes(e)||(t.processed.push(e),!1)};var ni=ei,ai=function(e,t){var n=t.emoji,a=t.nonBmp;t=t.punctuations;return n&&(e=e.replace(/[#*0-9]\\uFE0F?\\u20E3|[\\xA9\\xAE\\u203C\\u2049\\u2122\\u2139\\u2194-\\u2199\\u21A9\\u21AA\\u231A\\u231B\\u2328\\u23CF\\u23ED-\\u23EF\\u23F1\\u23F2\\u23F8-\\u23FA\\u24C2\\u25AA\\u25AB\\u25B6\\u25C0\\u25FB\\u25FC\\u25FE\\u2600-\\u2604\\u260E\\u2611\\u2614\\u2615\\u2618\\u2620\\u2622\\u2623\\u2626\\u262A\\u262E\\u262F\\u2638-\\u263A\\u2640\\u2642\\u2648-\\u2653\\u265F\\u2660\\u2663\\u2665\\u2666\\u2668\\u267B\\u267E\\u267F\\u2692\\u2694-\\u2697\\u2699\\u269B\\u269C\\u26A0\\u26A7\\u26AA\\u26B0\\u26B1\\u26BD\\u26BE\\u26C4\\u26C8\\u26CF\\u26D1\\u26D3\\u26E9\\u26F0-\\u26F5\\u26F7\\u26F8\\u26FA\\u2702\\u2708\\u2709\\u270F\\u2712\\u2714\\u2716\\u271D\\u2721\\u2733\\u2734\\u2744\\u2747\\u2757\\u2763\\u27A1\\u2934\\u2935\\u2B05-\\u2B07\\u2B1B\\u2B1C\\u2B55\\u3030\\u303D\\u3297\\u3299]\\uFE0F?|[\\u261D\\u270C\\u270D](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\u270A\\u270B](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\u23E9-\\u23EC\\u23F0\\u23F3\\u25FD\\u2693\\u26A1\\u26AB\\u26C5\\u26CE\\u26D4\\u26EA\\u26FD\\u2705\\u2728\\u274C\\u274E\\u2753-\\u2755\\u2795-\\u2797\\u27B0\\u27BF\\u2B50]|\\u26F9(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\u2764\\uFE0F?(?:\\u200D(?:\\uD83D\\uDD25|\\uD83E\\uDE79))?|\\uD83C(?:[\\uDC04\\uDD70\\uDD71\\uDD7E\\uDD7F\\uDE02\\uDE37\\uDF21\\uDF24-\\uDF2C\\uDF36\\uDF7D\\uDF96\\uDF97\\uDF99-\\uDF9B\\uDF9E\\uDF9F\\uDFCD\\uDFCE\\uDFD4-\\uDFDF\\uDFF5\\uDFF7]\\uFE0F?|[\\uDF85\\uDFC2\\uDFC7](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDFC3\\uDFC4\\uDFCA](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDFCB\\uDFCC](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDCCF\\uDD8E\\uDD91-\\uDD9A\\uDE01\\uDE1A\\uDE2F\\uDE32-\\uDE36\\uDE38-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF20\\uDF2D-\\uDF35\\uDF37-\\uDF7C\\uDF7E-\\uDF84\\uDF86-\\uDF93\\uDFA0-\\uDFC1\\uDFC5\\uDFC6\\uDFC8\\uDFC9\\uDFCF-\\uDFD3\\uDFE0-\\uDFF0\\uDFF8-\\uDFFF]|\\uDDE6\\uD83C[\\uDDE8-\\uDDEC\\uDDEE\\uDDF1\\uDDF2\\uDDF4\\uDDF6-\\uDDFA\\uDDFC\\uDDFD\\uDDFF]|\\uDDE7\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEF\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9\\uDDFB\\uDDFC\\uDDFE\\uDDFF]|\\uDDE8\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDEE\\uDDF0-\\uDDF5\\uDDF7\\uDDFA-\\uDDFF]|\\uDDE9\\uD83C[\\uDDEA\\uDDEC\\uDDEF\\uDDF0\\uDDF2\\uDDF4\\uDDFF]|\\uDDEA\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDED\\uDDF7-\\uDDFA]|\\uDDEB\\uD83C[\\uDDEE-\\uDDF0\\uDDF2\\uDDF4\\uDDF7]|\\uDDEC\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEE\\uDDF1-\\uDDF3\\uDDF5-\\uDDFA\\uDDFC\\uDDFE]|\\uDDED\\uD83C[\\uDDF0\\uDDF2\\uDDF3\\uDDF7\\uDDF9\\uDDFA]|\\uDDEE\\uD83C[\\uDDE8-\\uDDEA\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9]|\\uDDEF\\uD83C[\\uDDEA\\uDDF2\\uDDF4\\uDDF5]|\\uDDF0\\uD83C[\\uDDEA\\uDDEC-\\uDDEE\\uDDF2\\uDDF3\\uDDF5\\uDDF7\\uDDFC\\uDDFE\\uDDFF]|\\uDDF1\\uD83C[\\uDDE6-\\uDDE8\\uDDEE\\uDDF0\\uDDF7-\\uDDFB\\uDDFE]|\\uDDF2\\uD83C[\\uDDE6\\uDDE8-\\uDDED\\uDDF0-\\uDDFF]|\\uDDF3\\uD83C[\\uDDE6\\uDDE8\\uDDEA-\\uDDEC\\uDDEE\\uDDF1\\uDDF4\\uDDF5\\uDDF7\\uDDFA\\uDDFF]|\\uDDF4\\uD83C\\uDDF2|\\uDDF5\\uD83C[\\uDDE6\\uDDEA-\\uDDED\\uDDF0-\\uDDF3\\uDDF7-\\uDDF9\\uDDFC\\uDDFE]|\\uDDF6\\uD83C\\uDDE6|\\uDDF7\\uD83C[\\uDDEA\\uDDF4\\uDDF8\\uDDFA\\uDDFC]|\\uDDF8\\uD83C[\\uDDE6-\\uDDEA\\uDDEC-\\uDDF4\\uDDF7-\\uDDF9\\uDDFB\\uDDFD-\\uDDFF]|\\uDDF9\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDED\\uDDEF-\\uDDF4\\uDDF7\\uDDF9\\uDDFB\\uDDFC\\uDDFF]|\\uDDFA\\uD83C[\\uDDE6\\uDDEC\\uDDF2\\uDDF3\\uDDF8\\uDDFE\\uDDFF]|\\uDDFB\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDEE\\uDDF3\\uDDFA]|\\uDDFC\\uD83C[\\uDDEB\\uDDF8]|\\uDDFD\\uD83C\\uDDF0|\\uDDFE\\uD83C[\\uDDEA\\uDDF9]|\\uDDFF\\uD83C[\\uDDE6\\uDDF2\\uDDFC]|\\uDFF3\\uFE0F?(?:\\u200D(?:\\u26A7\\uFE0F?|\\uD83C\\uDF08))?|\\uDFF4(?:\\u200D\\u2620\\uFE0F?|\\uDB40\\uDC67\\uDB40\\uDC62\\uDB40(?:\\uDC65\\uDB40\\uDC6E\\uDB40\\uDC67|\\uDC73\\uDB40\\uDC63\\uDB40\\uDC74|\\uDC77\\uDB40\\uDC6C\\uDB40\\uDC73)\\uDB40\\uDC7F)?)|\\uD83D(?:[\\uDC08\\uDC26](?:\\u200D\\u2B1B)?|[\\uDC3F\\uDCFD\\uDD49\\uDD4A\\uDD6F\\uDD70\\uDD73\\uDD76-\\uDD79\\uDD87\\uDD8A-\\uDD8D\\uDDA5\\uDDA8\\uDDB1\\uDDB2\\uDDBC\\uDDC2-\\uDDC4\\uDDD1-\\uDDD3\\uDDDC-\\uDDDE\\uDDE1\\uDDE3\\uDDE8\\uDDEF\\uDDF3\\uDDFA\\uDECB\\uDECD-\\uDECF\\uDEE0-\\uDEE5\\uDEE9\\uDEF0\\uDEF3]\\uFE0F?|[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66\\uDC67\\uDC6B-\\uDC6D\\uDC72\\uDC74-\\uDC76\\uDC78\\uDC7C\\uDC83\\uDC85\\uDC8F\\uDC91\\uDCAA\\uDD7A\\uDD95\\uDD96\\uDE4C\\uDE4F\\uDEC0\\uDECC](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC6E\\uDC70\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD74\\uDD90](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC00-\\uDC07\\uDC09-\\uDC14\\uDC16-\\uDC25\\uDC27-\\uDC3A\\uDC3C-\\uDC3E\\uDC40\\uDC44\\uDC45\\uDC51-\\uDC65\\uDC6A\\uDC79-\\uDC7B\\uDC7D-\\uDC80\\uDC84\\uDC88-\\uDC8E\\uDC90\\uDC92-\\uDCA9\\uDCAB-\\uDCFC\\uDCFF-\\uDD3D\\uDD4B-\\uDD4E\\uDD50-\\uDD67\\uDDA4\\uDDFB-\\uDE2D\\uDE2F-\\uDE34\\uDE37-\\uDE44\\uDE48-\\uDE4A\\uDE80-\\uDEA2\\uDEA4-\\uDEB3\\uDEB7-\\uDEBF\\uDEC1-\\uDEC5\\uDED0-\\uDED2\\uDED5-\\uDED7\\uDEDC-\\uDEDF\\uDEEB\\uDEEC\\uDEF4-\\uDEFC\\uDFE0-\\uDFEB\\uDFF0]|\\uDC15(?:\\u200D\\uD83E\\uDDBA)?|\\uDC3B(?:\\u200D\\u2744\\uFE0F?)?|\\uDC41\\uFE0F?(?:\\u200D\\uD83D\\uDDE8\\uFE0F?)?|\\uDC68(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDC68\\uDC69]\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC69(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?[\\uDC68\\uDC69]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?|\\uDC69\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?))|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC6F(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDD75(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDE2E(?:\\u200D\\uD83D\\uDCA8)?|\\uDE35(?:\\u200D\\uD83D\\uDCAB)?|\\uDE36(?:\\u200D\\uD83C\\uDF2B\\uFE0F?)?)|\\uD83E(?:[\\uDD0C\\uDD0F\\uDD18-\\uDD1F\\uDD30-\\uDD34\\uDD36\\uDD77\\uDDB5\\uDDB6\\uDDBB\\uDDD2\\uDDD3\\uDDD5\\uDEC3-\\uDEC5\\uDEF0\\uDEF2-\\uDEF8](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDD26\\uDD35\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD4\\uDDD6-\\uDDDD](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDDDE\\uDDDF](?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD0D\\uDD0E\\uDD10-\\uDD17\\uDD20-\\uDD25\\uDD27-\\uDD2F\\uDD3A\\uDD3F-\\uDD45\\uDD47-\\uDD76\\uDD78-\\uDDB4\\uDDB7\\uDDBA\\uDDBC-\\uDDCC\\uDDD0\\uDDE0-\\uDDFF\\uDE70-\\uDE7C\\uDE80-\\uDE88\\uDE90-\\uDEBD\\uDEBF-\\uDEC2\\uDECE-\\uDEDB\\uDEE0-\\uDEE8]|\\uDD3C(?:\\u200D[\\u2640\\u2642]\\uFE0F?|\\uD83C[\\uDFFB-\\uDFFF])?|\\uDDD1(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1))|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFC-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFD-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFD\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFE]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?))?|\\uDEF1(?:\\uD83C(?:\\uDFFB(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFC-\\uDFFF])?|\\uDFFC(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])?|\\uDFFD(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])?|\\uDFFE(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])?|\\uDFFF(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFE])?))?)/g,"")),a&&(e=(e=e.replace(/[\\u1D00-\\u1D7F\\u1D80-\\u1DBF\\u1DC0-\\u1DFF\\u20A0-\\u20CF\\u20D0-\\u20FF\\u2100-\\u214F\\u2150-\\u218F\\u2190-\\u21FF\\u2200-\\u22FF\\u2300-\\u23FF\\u2400-\\u243F\\u2440-\\u245F\\u2460-\\u24FF\\u2500-\\u257F\\u2580-\\u259F\\u25A0-\\u25FF\\u2600-\\u26FF\\u2700-\\u27BF\\uE000-\\uF8FF]/g,"")).replace(/[\\uDB80-\\uDBBF][\\uDC00-\\uDFFF]/g,"")),t?e.replace(/[\\u2000-\\u206F\\u2E00-\\u2E7F\\\\\'!"#$%&\\xa3\\xa2\\xa5\\xa7\\u20ac()*+,\\-.\\/:;<=>?@\\[\\]^_`{|}~\\xb1]/g,""):e},ri=function(e){return e.length&&!["x","i"].includes(e)&&(e=ai(e,{emoji:!0,nonBmp:!0,punctuations:!0}),Zo(e))?1:0},oi={stateTerms:["on","off"],standaloneTerms:["name","honorific-prefix","given-name","additional-name","family-name","honorific-suffix","nickname","username","new-password","current-password","organization-title","organization","street-address","address-line1","address-line2","address-line3","address-level4","address-level3","address-level2","address-level1","country","country-name","postal-code","cc-name","cc-given-name","cc-additional-name","cc-family-name","cc-number","cc-exp","cc-exp-month","cc-exp-year","cc-csc","cc-type","transaction-currency","transaction-amount","language","bday","bday-day","bday-month","bday-year","sex","url","photo","one-time-code"],qualifiers:["home","work","mobile","fax","pager"],qualifiedTerms:["tel","tel-country-code","tel-national","tel-area-code","tel-local","tel-local-prefix","tel-local-suffix","tel-extension","email","impp"],locations:["billing","shipping"]},ui=function(e){var t=void 0!==(t=(u=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).looseTyped)&&t,n=void 0===(n=u.stateTerms)?[]:n,a=void 0===(a=u.locations)?[]:a,r=void 0===(r=u.qualifiers)?[]:r,o=void 0===(o=u.standaloneTerms)?[]:o,u=void 0===(u=u.qualifiedTerms)?[]:u;return e=e.toLowerCase().trim(),!(!(n=n.concat(oi.stateTerms)).includes(e)&&""!==e)||(r=r.concat(oi.qualifiers),a=a.concat(oi.locations),o=o.concat(oi.standaloneTerms),u=u.concat(oi.qualifiedTerms),!("webauthn"===(n=e.split(/\\s+/g))[n.length-1]&&(n.pop(),0===n.length)||!t&&(8<n[0].length&&"section-"===n[0].substr(0,8)&&n.shift(),a.includes(n[0])&&n.shift(),r.includes(n[0])&&(n.shift(),o=[]),1!==n.length))&&(t=n[n.length-1],o.includes(t)||u.includes(t)))},ii=function(e){var t;return e.attr("aria-labelledby")&&(t=No(e.actualNode,"aria-labelledby").map((function(e){return(e=Xn(e))?ju(e):""})).join(" ").trim())?t:(t=(t=e.attr("aria-label"))&&Zo(t))||null},li=function(e,t,n){return e=Xn(e),ju(e,t,n)},si=function(e){if(t=ii(e))return t;if(e.attr("id")){if(!e.actualNode)throw new TypeError("Cannot resolve explicit label reference for non-DOM nodes");var t,n=wn(e.attr("id"));if(t=(n=sr(e.actualNode).querySelector(\'label[for="\'+n+\'"]\'))&&li(n,!0))return t}return(t=(n=ca(e,"label"))&&ju(n,!0))||null},ci=function(e){return e=Xn(e),si(e)},di=[{matches:[{nodeName:"textarea"},{nodeName:"input",properties:{type:["text","password","search","tel","email","url"]}}],namingMethods:"labelText"},{matches:{nodeName:"input",properties:{type:["button","submit","reset"]}},namingMethods:["valueText","titleText","buttonDefaultText"]},{matches:{nodeName:"input",properties:{type:"image"}},namingMethods:["altText","valueText","labelText","titleText","buttonDefaultText"]},{matches:"button",namingMethods:"subtreeText"},{matches:"fieldset",namingMethods:"fieldsetLegendText"},{matches:"OUTPUT",namingMethods:"subtreeText"},{matches:[{nodeName:"select"},{nodeName:"input",properties:{type:/^(?!text|password|search|tel|email|url|button|submit|reset)/}}],namingMethods:"labelText"},{matches:"summary",namingMethods:"subtreeText"},{matches:"figure",namingMethods:["figureText","titleText"]},{matches:"img",namingMethods:"altText"},{matches:"table",namingMethods:["tableCaptionText","tableSummaryText"]},{matches:["hr","br"],namingMethods:["titleText","singleSpace"]}],pi=function e(t){var n=zr(t),a=[];return t.children.forEach((function(t){3===t.actualNode.nodeType?n&&a.push(t):a=a.concat(e(t))})),a},fi=Dr((function(e){var t=Xn(e),n=t.boundingClientRect,r=[],o=gr(t);return e.childNodes.forEach((function(e){var t,u,i,l;3!==e.nodeType||""===Zo(e.nodeValue)||((t=a.createRange()).selectNodeContents(e),e=Array.from(t.getClientRects()),u=n,e.some((function(e){return!Hr(Fo(e),u)})))||r.push.apply(r,$((i=o,l=[],e.forEach((function(e){e.width<1||e.height<1||(e=i.reduce((function(e,t){return e&&oo(e,t.boundingClientRect)}),e))&&l.push(e)})),l)))})),r.length?r:[n]})),Di=function(e){Xr();var t=Xn(e)._grid;return t?fi(e).map((function(e){return Ao(t,e)})):[]},mi=["checkbox","img","meter","progressbar","scrollbar","radio","slider","spinbutton","textbox"],hi=function(e){var t=Ld(e).vNode;if(e=o.commons.aria.getExplicitRole(t))return-1!==mi.indexOf(e);switch(t.props.nodeName){case"img":case"iframe":case"object":case"video":case"audio":case"canvas":case"svg":case"math":case"button":case"select":case"textarea":case"keygen":case"progress":case"meter":return!0;case"input":return"hidden"!==t.props.type;default:return!1}},gi=["head","title","template","script","style","iframe","object","video","audio","noscript"];function bi(e){return!gi.includes(e.props.nodeName)&&e.children.some((function(e){return 3===(e=e.props).nodeType&&e.nodeValue.trim()}))}var vi=function e(t,n,a){return bi(t)||hi(t.actualNode)||!a&&!!ii(t)||!n&&t.children.some((function(t){return 1===t.actualNode.nodeType&&e(t)}))},yi=function(e,t,n){return e=Xn(e),vi(e,t,n)};function Fi(e){return!(void 0!==e.children&&!bi(e))||(1===e.props.nodeType&&hi(e)?!!o.commons.text.accessibleTextVirtual(e):e.children.some((function(e){return!e.attr("lang")&&Fi(e)&&!_r(e)})))}var wi=function(e){return-1<parseInt(e.getAttribute("tabindex"),10)&&Qo(e)&&!Jo(e)};function Ei(e,t){var n=(e=Ld(e)).vNode;e=e.domNode;return n?(void 0===n._isHiddenWithCSS&&(n._isHiddenWithCSS=Ci(e,t)),n._isHiddenWithCSS):Ci(e,t)}function Ci(e,n){if(9===e.nodeType)return!1;if(11===e.nodeType&&(e=e.host),["STYLE","SCRIPT"].includes(e.nodeName.toUpperCase()))return!1;var a,r=t.getComputedStyle(e,null);if(r)return"none"===r.getPropertyValue("display")||(a=["hidden","collapse"],r=r.getPropertyValue("visibility"),!(!a.includes(r)||n))||!!(a.includes(r)&&n&&a.includes(n))||!(!(n=Mr(e))||a.includes(r))&&Ei(n,r);throw new Error("Style does not exist for the given element.")}var xi=Ei,Ai=function(e){return null!==(e=e.doctype)&&"html"===e.name&&!e.publicId&&!e.systemId};function ki(e){return 1===(e=Ld(e).vNode).props.nodeType&&!(parseInt(e.attr("tabindex",10))<=-1)&&Qo(e)}var Bi=function(e){(e instanceof on||null!=(n=t)&&n.Node&&e instanceof t.Node)&&(e=o.commons.aria.getRole(e));var n=qo.ariaRoles[e];return(null==n?void 0:n.type)||null},Ti=["block","list-item","table","flex","grid","inline-block"];function Ni(e){return e=t.getComputedStyle(e).getPropertyValue("display"),Ti.includes(e)||"table-"===e.substr(0,6)}var Ri=function(e,t){var n,a,r,o;return!Ni(e)&&(n=function(e){for(var t=Mr(e);t&&!Ni(t);)t=Mr(t);return Xn(t)}(e),r=a="",o=0,function e(t,n){!1!==n(t.actualNode)&&t.children.forEach((function(t){return e(t,n)}))}(n,(function(t){if(2===o)return!1;if(3===t.nodeType&&(a+=t.nodeValue),1===t.nodeType){var n=(t.nodeName||"").toUpperCase();if(t===e&&(o=1),!["BR","HR"].includes(n))return!("none"===t.style.display||"hidden"===t.style.overflow||!["",null,"none"].includes(t.style.float)||!["",null,"relative"].includes(t.style.position))&&("widget"===Bi(t)?(r+=t.textContent,!1):void 0);0===o?r=a="":o=2}})),a=Zo(a),null!=t&&t.noLengthCompare?0!==a.length:(r=Zo(r),a.length>r.length))},_i=function(e){if(e=(e=e||{}).modalPercent||.75,Kn.get("isModalOpen"))return Kn.get("isModalOpen");if(ep(o._tree[0],"dialog, [role=dialog], [aria-modal=true]",zr).length)return Kn.set("isModalOpen",!0),!0;for(var n=jr(t),u=n.width*e,i=n.height*e,l=(e=(n.width-u)/2,(n.height-i)/2),s=[{x:e,y:l},{x:n.width-e,y:l},{x:n.width/2,y:n.height/2},{x:e,y:n.height-l},{x:n.width-e,y:n.height-l}].map((function(e){return Array.from(a.elementsFromPoint(e.x,e.y))})),c=0;c<s.length;c++){var d=function(e){var n=s[e].find((function(e){return e=t.getComputedStyle(e),parseInt(e.width,10)>=u&&parseInt(e.height,10)>=i&&"none"!==e.getPropertyValue("pointer-events")&&("absolute"===e.position||"fixed"===e.position)}));if(n&&s.every((function(e){return e.includes(n)})))return Kn.set("isModalOpen",!0),{v:!0}}(c);if("object"===r(d))return d.v}Kn.set("isModalOpen",void 0)};function Oi(e){var t,n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:2,a=e.ownerDocument.createRange(),r=(a.setStart(e,0),a.setEnd(e,e.childNodes.length),0),o=0,u=Q(a.getClientRects());try{for(u.s();!(t=u.n()).done;){var i=t.value;if(!(i.height<=n))if(r>i.top+n)r=Math.max(r,i.bottom);else{if(0!==o)return!0;r=i.bottom,o++}}}catch(e){u.e(e)}finally{u.f()}return!1}var Si=function(e){return e instanceof t.Node},Mi={},Pi={set:function(e,t){if("string"!=typeof e)throw new Error("Incomplete data: key must be a string");return t&&(Mi[e]=t),Mi[e]},get:function(e){return Mi[e]},clear:function(){Mi={}}},Ii=function(e,n){var a=e.nodeName.toUpperCase();return["IMG","CANVAS","OBJECT","IFRAME","VIDEO","SVG"].includes(a)?(Pi.set("bgColor","imgNode"),!0):((e="none"!==(a=(n=n||t.getComputedStyle(e)).getPropertyValue("background-image")))&&(n=/gradient/.test(a),Pi.set("bgColor",n?"bgGradient":"bgImage")),e)},ji=(ae(Po={},{Colorjs:function(){return mc},CssSelectorParser:function(){return ji.CssSelectorParser},doT:function(){return Li.default},emojiRegexText:function(){return Zu},memoize:function(){return qi.default}}),re(ve())),Li=re(Xt()),qi=re(Kt());function zi(e,t){var n=e.length,a=(Array.isArray(e[0])||(e=[e]),(t=Array.isArray(t[0])?t:t.map((function(e){return[e]})))[0].length),r=t[0].map((function(e,n){return t.map((function(e){return e[n]}))}));e=e.map((function(e){return r.map((function(t){var n=0;if(Array.isArray(e))for(var a=0;a<e.length;a++)n+=e[a]*(t[a]||0);else{var r,o=Q(t);try{for(o.s();!(r=o.n()).done;){var u=r.value;n+=e*u}}catch(t){o.e(t)}finally{o.f()}}return n}))}));return 1===n&&(e=e[0]),1===a?e.map((function(e){return e[0]})):e}function Vi(e){return"string"===$i(e)}function $i(e){return(Object.prototype.toString.call(e).match(/^\\[object\\s+(.*?)\\]$/)[1]||"").toLowerCase()}function Hi(e,t){e=+e,t=+t;var n=(Math.floor(e)+"").length;return n<t?+e.toFixed(t-n):(n=Math.pow(10,n-t),Math.round(e/n)*n)}function Ui(e){var t,n;if(e)return e=e.trim(),t=/^-?[\\d.]+$/,(e=e.match(/^([a-z]+)\\((.+?)\\)$/i))?(n=[],e[2].replace(/\\/?\\s*([-\\w.]+(?:%|deg)?)/g,(function(e,a){/%$/.test(a)?(a=new Number(a.slice(0,-1)/100)).type="<percentage>":/deg$/.test(a)?((a=new Number(+a.slice(0,-3))).type="<angle>",a.unit="deg"):t.test(a)&&((a=new Number(a)).type="<number>"),e.startsWith("/")&&((a=a instanceof Number?a:new Number(a)).alpha=!0),n.push(a)})),{name:e[1].toLowerCase(),rawName:e[1],rawArgs:e[2],args:n}):void 0}function Gi(e){return e[e.length-1]}function Wi(e,t,n){return isNaN(e)?t:isNaN(t)?e:e+(t-e)*n}function Yi(e,t,n){return(n-e)/(t-e)}function Ki(e,t,n){return Wi(t[0],t[1],Yi(e[0],e[1],n))}function Xi(e){return e.map((function(e){return e.split("|").map((function(e){var t,n=(e=e.trim()).match(/^(<[a-z]+>)\\[(-?[.\\d]+),\\s*(-?[.\\d]+)\\]?$/);return n?((t=new String(n[1])).range=[+n[2],+n[3]],t):e}))}))}function Zi(){K(this,Zi)}Io=Object.freeze({__proto__:null,isString:Vi,type:$i,toPrecision:Hi,parseFunction:Ui,last:Gi,interpolate:Wi,interpolateInv:Yi,mapRange:Ki,parseCoordGrammar:Xi,multiplyMatrices:zi}),Z(Zi,[{key:"add",value:function(e,t,n){if("string"!=typeof arguments[0])for(var e in arguments[0])this.add(e,arguments[0][e],t);else(Array.isArray(e)?e:[e]).forEach((function(e){this[e]=this[e]||[],t&&this[e][n?"unshift":"push"](t)}),this)}},{key:"run",value:function(e,t){this[e]=this[e]||[],this[e].forEach((function(e){e.call(t&&t.context?t.context:t,t)}))}}]);var Ji=new Zi,Qi={gamut_mapping:"lch.c",precision:5,deltaE:"76"},el={D50:[.3457/.3585,1,.2958/.3585],D65:[.3127/.329,1,.3583/.329]};function tl(e){return Array.isArray(e)?e:el[e]}function nl(e,t,n,a){var r=3<arguments.length&&void 0!==a?a:{};if(e=tl(e),t=tl(t),!e||!t)throw new TypeError("Missing white point to convert ".concat(e?"":"from").concat(e||t?"":"/").concat(t?"":"to"));if(e===t)return n;if(r={W1:e,W2:t,XYZ:n,options:r},Ji.run("chromatic-adaptation-start",r),r.M||(r.W1===el.D65&&r.W2===el.D50?r.M=[[1.0479298208405488,.022946793341019088,-.05019222954313557],[.029627815688159344,.990434484573249,-.01707382502938514],[-.009243058152591178,.015055144896577895,.7518742899580008]]:r.W1===el.D50&&r.W2===el.D65&&(r.M=[[.9554734527042182,-.023098536874261423,.0632593086610217],[-.028369706963208136,1.0099954580058226,.021041398966943008],[.012314001688319899,-.020507696433477912,1.3303659366080753]])),Ji.run("chromatic-adaptation-end",r),r.M)return zi(r.M,r.XYZ);throw new TypeError("Only Bradford CAT with white points D50 and D65 supported for now.")}function al(e){K(this,al),P(this,le),P(this,ue),M(this,ie,{writable:!0,value:void 0}),this.id=e.id,this.name=e.name,this.base=e.base?al.get(e.base):null,this.aliases=e.aliases,this.base&&(this.fromBase=e.fromBase,this.toBase=e.toBase);var t,n=null!=(n=e.coords)?n:this.base.coords;this.coords=n,n=null!=(n=null!=(n=e.white)?n:this.base.white)?n:"D65";for(t in this.white=tl(n),this.formats=null!=(n=e.formats)?n:{},this.formats){var a=this.formats[t];a.type||(a.type="function"),a.name||(a.name=t)}!e.cssId||null!=(n=this.formats.functions)&&n.color?null==(n=this.formats)||!n.color||null!=(n=this.formats)&&n.color.id||(this.formats.color.id=this.id):(this.formats.color={id:e.cssId},Object.defineProperty(this,"cssId",{value:e.cssId})),this.referred=e.referred,q(this,ie,L(this,le,ol).call(this).reverse()),Ji.run("colorspace-init-end",this)}function rl(e){var t;return e.coords&&!e.coordGrammar&&(e.type||(e.type="function"),e.name||(e.name="color"),e.coordGrammar=Xi(e.coords),t=Object.entries(this.coords).map((function(t,n){(t=G(t,2))[0],t=t[1],n=e.coordGrammar[n][0],t=t.range||t.refRange;var a=n.range,r="";return"<percentage>"==n?(a=[0,100],r="%"):"<angle>"==n&&(r="deg"),{fromRange:t,toRange:a,suffix:r}})),e.serializeCoords=function(e,n){return e.map((function(e,a){var r=(a=t[a]).fromRange,o=a.toRange;a=a.suffix;return e=Hi(e=r&&o?Ki(r,o,e):e,n),a&&(e+=a),e}))}),e}function ol(){for(var e=[this],t=this;t=t.base;)e.push(t);return e}ue=new WeakSet,ie=new WeakMap,le=new WeakSet,Z(al,[{key:"inGamut",value:function(e){var t,n=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).epsilon,a=void 0===n?75e-6:n;return this.isPolar?(e=this.toBase(e),this.base.inGamut(e,{epsilon:a})):(t=Object.values(this.coords),e.every((function(e,n){var r;return"angle"===(n=t[n]).type||!n.range||!!Number.isNaN(e)||(r=(n=G(n.range,2))[0],n=n[1],(void 0===r||r-a<=e)&&(void 0===n||e<=n+a))})))}},{key:"cssId",get:function(){var e;return(null==(e=this.formats.functions)||null==(e=e.color)?void 0:e.id)||this.id}},{key:"isPolar",get:function(){for(var e in this.coords)if("angle"===this.coords[e].type)return!0;return!1}},{key:"getFormat",value:function(e){return"object"===r(e)||(e="default"===e?Object.values(this.formats)[0]:this.formats[e])?L(this,ue,rl).call(this,e):null}},{key:"to",value:function(e,t){var n;if(1===arguments.length&&(e=(n=[e.space,e.coords])[0],t=n[1]),this!==(e=al.get(e))){t=t.map((function(e){return Number.isNaN(e)?0:e}));for(var a,r,o=j(this,ie),u=j(e,ie),i=0;i<o.length&&o[i]===u[i];i++)a=o[i],r=i;if(!a)throw new Error("Cannot convert between color spaces ".concat(this," and ").concat(e,": no connection space was found"));for(var l=o.length-1;r<l;l--)t=o[l].toBase(t);for(var s=r+1;s<u.length;s++)t=u[s].fromBase(t)}return t}},{key:"from",value:function(e,t){var n;return 1===arguments.length&&(e=(n=[e.space,e.coords])[0],t=n[1]),(e=al.get(e)).to(this,t)}},{key:"toString",value:function(){return"".concat(this.name," (").concat(this.id,")")}},{key:"getMinCoords",value:function(){var e,t=[];for(e in this.coords){var n=(n=this.coords[e]).range||n.refRange;t.push(null!=(n=null==n?void 0:n.min)?n:0)}return t}}],[{key:"all",get:function(){return $(new Set(Object.values(al.registry)))}},{key:"register",value:function(e,t){if(1===arguments.length&&(e=(t=arguments[0]).id),t=this.get(t),this.registry[e]&&this.registry[e]!==t)throw new Error("Duplicate color space registration: \'".concat(e,"\'"));if(this.registry[e]=t,1===arguments.length&&t.aliases){var n,a=Q(t.aliases);try{for(a.s();!(n=a.n()).done;){var r=n.value;this.register(r,t)}}catch(e){a.e(e)}finally{a.f()}}return t}},{key:"get",value:function(e){if(!e||e instanceof al)return e;if("string"===$i(e)){var t=al.registry[e.toLowerCase()];if(t)return t;throw new TypeError(\'No color space found with id = "\'.concat(e,\'"\'))}for(var n=arguments.length,a=new Array(1<n?n-1:0),r=1;r<n;r++)a[r-1]=arguments[r];if(a.length)return al.get.apply(al,a);throw new TypeError("".concat(e," is not a valid color space"))}},{key:"resolveCoord",value:function(e,t){var n,a;if(a="string"===$i(e)?e.includes(".")?(n=(a=G(e.split("."),2))[0],a[1]):(n=void 0,e):Array.isArray(e)?(n=(a=G(e,2))[0],a[1]):(n=e.space,e.coordId),!(n=(n=al.get(n))||t))throw new TypeError("Cannot resolve coordinate reference ".concat(e,": No color space specified and relative references are not allowed here"));if(("number"===(t=$i(a))||"string"===t&&0<=a)&&(e=Object.entries(n.coords)[a]))return U({space:n,id:e[0],index:a},e[1]);n=al.get(n);var r,o=a.toLowerCase(),u=0;for(r in n.coords){var i,l=n.coords[r];if(r.toLowerCase()===o||(null==(i=l.name)?void 0:i.toLowerCase())===o)return U({space:n,id:r,index:u},l);u++}throw new TypeError(\'No "\'.concat(a,\'" coordinate found in \').concat(n.name,". Its coordinates are: ").concat(Object.keys(n.coords).join(", ")))}}]);var ul,il=al,ll=(oe(il,"registry",{}),oe(il,"DEFAULT_FORMAT",{type:"functions",name:"color"}),new il({id:"xyz-d65",name:"XYZ D65",coords:{x:{name:"X"},y:{name:"Y"},z:{name:"Z"}},white:"D65",formats:{color:{ids:["xyz-d65","xyz"]}},aliases:["xyz"]}));T(sl,il),ul=R(sl),ve=Z(sl);function sl(e){var t;return K(this,sl),e.coords||(e.coords={r:{range:[0,1],name:"Red"},g:{range:[0,1],name:"Green"},b:{range:[0,1],name:"Blue"}}),e.base||(e.base=ll),e.toXYZ_M&&e.fromXYZ_M&&(null==e.toBase&&(e.toBase=function(n){return n=zi(e.toXYZ_M,n),t.white!==t.base.white?nl(t.white,t.base.white,n):n}),null==e.fromBase)&&(e.fromBase=function(n){return n=nl(t.base.white,t.white,n),zi(e.fromXYZ_M,n)}),null==e.referred&&(e.referred="display"),t=ul.call(this,e)}function cl(e){var t={str:null==(n=String(e))?void 0:n.trim()};if(Ji.run("parse-start",t),t.color)return t.color;if(t.parsed=Ui(t.str),t.parsed){var n=function(){var e=t.parsed.name;if("color"===e){var n,a=t.parsed.args.shift(),o=0<t.parsed.rawArgs.indexOf("/")?t.parsed.args.pop():1,u=Q(il.all);try{for(u.s();!(n=u.n()).done;){var i,l=n.value,s=l.getFormat("color");if(s&&(a===s.id||null!=(i=s.ids)&&i.includes(a))){var c=function(){var e=Object.keys(l.coords).length,n=Array(e).fill(0);return n.forEach((function(e,a){return n[a]=t.parsed.args[a]||0})),{v:{v:{spaceId:l.id,coords:n,alpha:o}}}}();if("object"===r(c))return c.v}}}catch(n){u.e(n)}finally{u.f()}var d,p="";throw a in il.registry&&(d=null==(d=il.registry[a].formats)||null==(d=d.functions)||null==(d=d.color)?void 0:d.id)&&(p="Did you mean color(".concat(d,")?")),new TypeError("Cannot parse color(".concat(a,"). ")+(p||"Missing a plugin?"))}var f,D=Q(il.all);try{for(D.s();!(f=D.n()).done;){var m=function(){var n,a,r=f.value,o=r.getFormat(e);if(o&&"function"===o.type)return n=1,(o.lastAlpha||Gi(t.parsed.args).alpha)&&(n=t.parsed.args.pop()),a=t.parsed.args,o.coordGrammar&&Object.entries(r.coords).forEach((function(t,n){var r=(t=G(t,2))[0],u=(t=t[1],o.coordGrammar[n]),i=null==(l=a[n])?void 0:l.type;if(!(u=u.find((function(e){return e==i}))))throw l=t.name||r,new TypeError("".concat(i," not allowed for ").concat(l," in ").concat(e,"()"));r=u.range;var l=t.range||t.refRange;(r="<percentage>"===i?r||[0,1]:r)&&l&&(a[n]=Ki(r,l,a[n]))})),{v:{v:{spaceId:r.id,coords:a,alpha:n}}}}();if("object"===r(m))return m.v}}catch(n){D.e(n)}finally{D.f()}}();if("object"===r(n))return n.v}else{var a,o=Q(il.all);try{for(o.s();!(a=o.n()).done;){var u,i=a.value;for(u in i.formats){var l=i.formats[u];if("custom"===l.type&&(!l.test||l.test(t.str))){var s=l.parse(t.str);if(s)return null==s.alpha&&(s.alpha=1),s}}}}catch(e){o.e(e)}finally{o.f()}}throw new TypeError("Could not parse ".concat(e," as a color. Missing a plugin?"))}function dl(e){var t;if(e)return(t=(e=Vi(e)?cl(e):e).space||e.spaceId)instanceof il||(e.space=il.get(t)),void 0===e.alpha&&(e.alpha=1),e;throw new TypeError("Empty color reference")}function pl(e,t){return(t=il.get(t)).from(e)}function fl(e,t){var n=(t=il.resolveCoord(t,e.space)).space;t=t.index;return pl(e,n)[t]}function Dl(e,t,n){return t=il.get(t),e.coords=t.to(e.space,n),e}function ml(e,t,n){if(e=dl(e),2===arguments.length&&"object"===$i(t)){var a,r=t;for(a in r)ml(e,a,r[a])}else{"function"==typeof n&&(n=n(fl(e,t)));var o=(u=il.resolveCoord(t,e.space)).space,u=u.index,i=pl(e,o);i[u]=n,Dl(e,o,i)}return e}Kt=new il({id:"xyz-d50",name:"XYZ D50",white:"D50",base:ll,fromBase:function(e){return nl(ll.white,"D50",e)},toBase:function(e){return nl("D50",ll.white,e)},formats:{color:{}}});var hl=24389/27,gl=el.D50,bl=new il({id:"lab",name:"Lab",coords:{l:{refRange:[0,100],name:"L"},a:{refRange:[-125,125]},b:{refRange:[-125,125]}},white:gl,base:Kt,fromBase:function(e){return e=e.map((function(e,t){return e/gl[t]})).map((function(e){return 216/24389<e?Math.cbrt(e):(hl*e+16)/116})),[116*e[1]-16,500*(e[0]-e[1]),200*(e[1]-e[2])]},toBase:function(e){var t=[];return t[1]=(e[0]+16)/116,t[0]=e[1]/500+t[1],t[2]=t[1]-e[2]/200,[24/116<t[0]?Math.pow(t[0],3):(116*t[0]-16)/hl,8<e[0]?Math.pow((e[0]+16)/116,3):e[0]/hl,24/116<t[2]?Math.pow(t[2],3):(116*t[2]-16)/hl].map((function(e,t){return e*gl[t]}))},formats:{lab:{coords:["<number> | <percentage>","<number>","<number>"]}}});function vl(e){return(e%360+360)%360}var yl=new il({id:"lch",name:"LCH",coords:{l:{refRange:[0,100],name:"Lightness"},c:{refRange:[0,150],name:"Chroma"},h:{refRange:[0,360],type:"angle",name:"Hue"}},base:bl,fromBase:function(e){var t=(e=G(e,3))[0],n=e[1],a=(e=e[2],Math.abs(n)<.02&&Math.abs(e)<.02?NaN:180*Math.atan2(e,n)/Math.PI);return[t,Math.sqrt(Math.pow(n,2)+Math.pow(e,2)),vl(a)]},toBase:function(e){var t=(e=G(e,3))[0],n=e[1];e=e[2];return n<0&&(n=0),isNaN(e)&&(e=0),[t,n*Math.cos(e*Math.PI/180),n*Math.sin(e*Math.PI/180)]},formats:{lch:{coords:["<number> | <percentage>","<number>","<number> | <angle>"]}}}),Fl=Math.pow(25,7),wl=Math.PI,El=180/wl,Cl=wl/180;function xl(e,t){var n=void 0===(n=(r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).kL)?1:n,a=void 0===(a=r.kC)?1:a,r=void 0===(r=r.kH)?1:r,o=(i=G(bl.from(e),3))[0],u=i[1],i=i[2],l=yl.from(bl,[o,u,i])[1],s=(d=G(bl.from(t),3))[0],c=d[1],d=d[2],p=(l=((l=l<0?0:l)+(p=(p=yl.from(bl,[s,c,d])[1])<0?0:p))/2,Math.pow(l,7)),f=(p=(1+(l=.5*(1-Math.sqrt(p/(p+Fl)))))*u,u=(1+l)*c,l=Math.sqrt(Math.pow(p,2)+Math.pow(i,2)),c=Math.sqrt(Math.pow(u,2)+Math.pow(d,2)),i=0==p&&0===i?0:Math.atan2(i,p),p=0==u&&0===d?0:Math.atan2(d,u),d=(i<0&&(i+=2*wl),p<0&&(p+=2*wl),s-o),u=c-l,(p*=El)-(i*=El)),D=(i=i+p,p=Math.abs(f),f=(l*c==0?D=0:p<=180?D=f:180<f?D=f-360:f<-180?D=360+f:console.log("the unthinkable has happened"),2*Math.sqrt(c*l)*Math.sin(D*Cl/2)),(o+s)/2);o=(l+c)/2,s=Math.pow(o,7),l=l*c==0?i:p<=180?i/2:i<360?(i+360)/2:(i-360)/2,p=1+.015*(c=Math.pow(D-50,2))/Math.sqrt(20+c),i=1+.045*o,D=1,c=1+.015*o*((D-=.17*Math.cos((l-30)*Cl))+.24*Math.cos(2*l*Cl)+.32*Math.cos((3*l+6)*Cl)-.2*Math.cos((4*l-63)*Cl)),o=30*Math.exp(-1*Math.pow((l-275)/25,2)),D=2*Math.sqrt(s/(s+Fl)),l=-1*Math.sin(2*o*Cl)*D,s=Math.pow(d/(n*p),2),s=(s+=Math.pow(u/(a*i),2))+Math.pow(f/(r*c),2)+u/(a*i)*l*(f/(r*c));return Math.sqrt(s)}var Al=75e-6;function kl(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:e.space,n=void 0===(n=(2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).epsilon)?Al:n,a=(e=dl(e),t=il.get(t),e.coords);return t!==e.space&&(a=t.from(e)),t.inGamut(a,{epsilon:n})}function Bl(e){return{space:e.space,coords:e.coords.slice(),alpha:e.alpha}}function Tl(e){var t=void 0===(t=(r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).method)?Qi.gamut_mapping:t,n=void 0===(r=r.space)?e.space:r;if(Vi(arguments[1])&&(n=arguments[1]),!kl(e,n=il.get(n),{epsilon:0})){var a,r=Nl(e,n);if("clip"!==t&&!kl(e,n)){var o=Tl(Bl(r),{method:"clip",space:n});if(2<xl(e,o)){for(var u=il.resolveCoord(t),i=u.space,l=u.id,s=Nl(r,i),c=(u.range||u.refRange)[0],d=fl(s,l);.01<d-c;)xl(s,Tl(Bl(s),{space:n,method:"clip"}))-2<.01?c=fl(s,l):d=fl(s,l),ml(s,l,(c+d)/2);r=Nl(s,n)}else r=o}"clip"!==t&&kl(r,n,{epsilon:0})||(a=Object.values(n.coords).map((function(e){return e.range||[]})),r.coords=r.coords.map((function(e,t){var n=(t=G(a[t],2))[0];t=t[1];return void 0!==n&&(e=Math.max(n,e)),void 0!==t?Math.min(e,t):e}))),n!==e.space&&(r=Nl(r,e.space)),e.coords=r.coords}return e}function Nl(e,t){var n=(2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).inGamut,a=(e=dl(e),(t=il.get(t)).from(e));a={space:t,coords:a,alpha:e.alpha};return n?Tl(a):a}function Rl(e){var t=void 0===(n=(r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).precision)?Qi.precision:n,n=void 0===(n=r.format)?"default":n,a=void 0===(a=r.inGamut)||a,r=V(r,f),o=n,u=(n=null!=(u=null!=(u=(e=dl(e)).space.getFormat(n))?u:e.space.getFormat("default"))?u:il.DEFAULT_FORMAT,a=a||n.toGamut,(u=e.coords).map((function(e){return e||0})));if(a&&!kl(e)&&(u=Tl(Bl(e),!0===a?void 0:a).coords),"custom"===n.type){if(r.precision=t,!n.serialize)throw new TypeError("format ".concat(o," can only be used to parse colors, not for serialization"));i=n.serialize(u,e.alpha,r)}else{a=n.name||"color",o=(n.serializeCoords?u=n.serializeCoords(u,t):null!==t&&(u=u.map((function(e){return Hi(e,t)}))),$(u)),r=("color"===a&&(u=n.id||(null==(r=n.ids)?void 0:r[0])||e.space.id,o.unshift(u)),e.alpha),u=(null!==t&&(r=Hi(r,t)),e.alpha<1&&!n.noAlpha?"".concat(n.commas?",":" /"," ").concat(r):"");var i="".concat(a,"(").concat(o.join(n.commas?", ":" ")).concat(u,")")}return i}Nl.returns=Tl.returns="color";var _l=new ve({id:"rec2020-linear",name:"Linear REC.2020",white:"D65",toXYZ_M:[[.6369580483012914,.14461690358620832,.1688809751641721],[.2627002120112671,.6779980715188708,.05930171646986196],[0,.028072693049087428,1.060985057710791]],fromXYZ_M:[[1.716651187971268,-.355670783776392,-.25336628137366],[-.666684351832489,1.616481236634939,.0157685458139111],[.017639857445311,-.042770613257809,.942103121235474]],formats:{color:{}}}),Ol=1.09929682680944,Sl=.018053968510807,Ml=new ve({id:"rec2020",name:"REC.2020",base:_l,toBase:function(e){return e.map((function(e){return e<4.5*Sl?e/4.5:Math.pow((e+Ol-1)/Ol,1/.45)}))},fromBase:function(e){return e.map((function(e){return Sl<=e?Ol*Math.pow(e,.45)-(Ol-1):4.5*e}))},formats:{color:{}}}),Pl=new ve({id:"p3-linear",name:"Linear P3",white:"D65",toXYZ_M:[[.4865709486482162,.26566769316909306,.1982172852343625],[.2289745640697488,.6917385218365064,.079286914093745],[0,.04511338185890264,1.043944368900976]],fromXYZ_M:[[2.493496911941425,-.9313836179191239,-.40271078445071684],[-.8294889695615747,1.7626640603183463,.023624685841943577],[.03584583024378447,-.07617238926804182,.9568845240076872]]}),Il=new ve({id:"srgb-linear",name:"Linear sRGB",white:"D65",toXYZ_M:[[.41239079926595934,.357584339383878,.1804807884018343],[.21263900587151027,.715168678767756,.07219231536073371],[.01933081871559182,.11919477979462598,.9505321522496607]],fromXYZ_M:[[3.2409699419045226,-1.537383177570094,-.4986107602930034],[-.9692436362808796,1.8759675015077202,.04155505740717559],[.05563007969699366,-.20397695888897652,1.0569715142428786]],formats:{color:{}}}),jl={aliceblue:[240/255,248/255,1],antiquewhite:[250/255,235/255,215/255],aqua:[0,1,1],aquamarine:[127/255,1,212/255],azure:[240/255,1,1],beige:[245/255,245/255,220/255],bisque:[1,228/255,196/255],black:[0,0,0],blanchedalmond:[1,235/255,205/255],blue:[0,0,1],blueviolet:[138/255,43/255,226/255],brown:[165/255,42/255,42/255],burlywood:[222/255,184/255,135/255],cadetblue:[95/255,158/255,160/255],chartreuse:[127/255,1,0],chocolate:[210/255,105/255,30/255],coral:[1,127/255,80/255],cornflowerblue:[100/255,149/255,237/255],cornsilk:[1,248/255,220/255],crimson:[220/255,20/255,60/255],cyan:[0,1,1],darkblue:[0,0,139/255],darkcyan:[0,139/255,139/255],darkgoldenrod:[184/255,134/255,11/255],darkgray:[169/255,169/255,169/255],darkgreen:[0,100/255,0],darkgrey:[169/255,169/255,169/255],darkkhaki:[189/255,183/255,107/255],darkmagenta:[139/255,0,139/255],darkolivegreen:[85/255,107/255,47/255],darkorange:[1,140/255,0],darkorchid:[.6,50/255,.8],darkred:[139/255,0,0],darksalmon:[233/255,150/255,122/255],darkseagreen:[143/255,188/255,143/255],darkslateblue:[72/255,61/255,139/255],darkslategray:[47/255,79/255,79/255],darkslategrey:[47/255,79/255,79/255],darkturquoise:[0,206/255,209/255],darkviolet:[148/255,0,211/255],deeppink:[1,20/255,147/255],deepskyblue:[0,191/255,1],dimgray:[105/255,105/255,105/255],dimgrey:[105/255,105/255,105/255],dodgerblue:[30/255,144/255,1],firebrick:[178/255,34/255,34/255],floralwhite:[1,250/255,240/255],forestgreen:[34/255,139/255,34/255],fuchsia:[1,0,1],gainsboro:[220/255,220/255,220/255],ghostwhite:[248/255,248/255,1],gold:[1,215/255,0],goldenrod:[218/255,165/255,32/255],gray:[128/255,128/255,128/255],green:[0,128/255,0],greenyellow:[173/255,1,47/255],grey:[128/255,128/255,128/255],honeydew:[240/255,1,240/255],hotpink:[1,105/255,180/255],indianred:[205/255,92/255,92/255],indigo:[75/255,0,130/255],ivory:[1,1,240/255],khaki:[240/255,230/255,140/255],lavender:[230/255,230/255,250/255],lavenderblush:[1,240/255,245/255],lawngreen:[124/255,252/255,0],lemonchiffon:[1,250/255,205/255],lightblue:[173/255,216/255,230/255],lightcoral:[240/255,128/255,128/255],lightcyan:[224/255,1,1],lightgoldenrodyellow:[250/255,250/255,210/255],lightgray:[211/255,211/255,211/255],lightgreen:[144/255,238/255,144/255],lightgrey:[211/255,211/255,211/255],lightpink:[1,182/255,193/255],lightsalmon:[1,160/255,122/255],lightseagreen:[32/255,178/255,170/255],lightskyblue:[135/255,206/255,250/255],lightslategray:[119/255,136/255,.6],lightslategrey:[119/255,136/255,.6],lightsteelblue:[176/255,196/255,222/255],lightyellow:[1,1,224/255],lime:[0,1,0],limegreen:[50/255,205/255,50/255],linen:[250/255,240/255,230/255],magenta:[1,0,1],maroon:[128/255,0,0],mediumaquamarine:[.4,205/255,170/255],mediumblue:[0,0,205/255],mediumorchid:[186/255,85/255,211/255],mediumpurple:[147/255,112/255,219/255],mediumseagreen:[60/255,179/255,113/255],mediumslateblue:[123/255,104/255,238/255],mediumspringgreen:[0,250/255,154/255],mediumturquoise:[72/255,209/255,.8],mediumvioletred:[199/255,21/255,133/255],midnightblue:[25/255,25/255,112/255],mintcream:[245/255,1,250/255],mistyrose:[1,228/255,225/255],moccasin:[1,228/255,181/255],navajowhite:[1,222/255,173/255],navy:[0,0,128/255],oldlace:[253/255,245/255,230/255],olive:[128/255,128/255,0],olivedrab:[107/255,142/255,35/255],orange:[1,165/255,0],orangered:[1,69/255,0],orchid:[218/255,112/255,214/255],palegoldenrod:[238/255,232/255,170/255],palegreen:[152/255,251/255,152/255],paleturquoise:[175/255,238/255,238/255],palevioletred:[219/255,112/255,147/255],papayawhip:[1,239/255,213/255],peachpuff:[1,218/255,185/255],peru:[205/255,133/255,63/255],pink:[1,192/255,203/255],plum:[221/255,160/255,221/255],powderblue:[176/255,224/255,230/255],purple:[128/255,0,128/255],rebeccapurple:[.4,.2,.6],red:[1,0,0],rosybrown:[188/255,143/255,143/255],royalblue:[65/255,105/255,225/255],saddlebrown:[139/255,69/255,19/255],salmon:[250/255,128/255,114/255],sandybrown:[244/255,164/255,96/255],seagreen:[46/255,139/255,87/255],seashell:[1,245/255,238/255],sienna:[160/255,82/255,45/255],silver:[192/255,192/255,192/255],skyblue:[135/255,206/255,235/255],slateblue:[106/255,90/255,205/255],slategray:[112/255,128/255,144/255],slategrey:[112/255,128/255,144/255],snow:[1,250/255,250/255],springgreen:[0,1,127/255],steelblue:[70/255,130/255,180/255],tan:[210/255,180/255,140/255],teal:[0,128/255,128/255],thistle:[216/255,191/255,216/255],tomato:[1,99/255,71/255],turquoise:[64/255,224/255,208/255],violet:[238/255,130/255,238/255],wheat:[245/255,222/255,179/255],white:[1,1,1],whitesmoke:[245/255,245/255,245/255],yellow:[1,1,0],yellowgreen:[154/255,205/255,50/255]},Ll=new ve({id:"srgb",name:"sRGB",base:Il,fromBase:function(e){return e.map((function(e){var t=e<0?-1:1,n=e*t;return.0031308<n?t*(1.055*Math.pow(n,1/2.4)-.055):12.92*e}))},toBase:function(e){return e.map((function(e){var t=e<0?-1:1,n=e*t;return n<.04045?e/12.92:t*Math.pow((.055+n)/1.055,2.4)}))},formats:{rgb:{coords:Ll=Array(3).fill("<percentage> | <number>[0, 255]")},rgb_number:{name:"rgb",commas:!0,coords:ql=Array(3).fill("<number>[0, 255]"),noAlpha:!0},color:{},rgba:{coords:Ll,commas:!0,lastAlpha:!0},rgba_number:{name:"rgba",commas:!0,coords:ql},hex:{type:"custom",toGamut:!0,test:function(e){return/^#([a-f0-9]{3,4}){1,2}$/i.test(e)},parse:function(e){e.length<=5&&(e=e.replace(/[a-f0-9]/gi,"$&$&"));var t=[];return e.replace(/[a-f0-9]{2}/gi,(function(e){t.push(parseInt(e,16)/255)})),{spaceId:"srgb",coords:t.slice(0,3),alpha:t.slice(3)[0]}},serialize:function(e,t){var n=void 0===(n=(2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).collapse)||n,a=(t<1&&e.push(t),e=e.map((function(e){return Math.round(255*e)})),n&&e.every((function(e){return e%17==0})));return"#"+e.map((function(e){return a?(e/17).toString(16):e.toString(16).padStart(2,"0")})).join("")}},keyword:{type:"custom",test:function(e){return/^[a-z]+$/i.test(e)},parse:function(e){var t={spaceId:"srgb",coords:null,alpha:1};if("transparent"===(e=e.toLowerCase())?(t.coords=jl.black,t.alpha=0):t.coords=jl[e],t.coords)return t}}}}),ql=new ve({id:"p3",name:"P3",base:Pl,fromBase:Ll.fromBase,toBase:Ll.toBase,formats:{color:{id:"display-p3"}}});if(Qi.display_space=Ll,"undefined"!=typeof CSS&&CSS.supports)for(var zl=0,Vl=[bl,Ml,ql];zl<Vl.length;zl++){var $l=Vl[zl],Hl=$l.getMinCoords();Hl=Rl({space:$l,coords:Hl,alpha:1});if(CSS.supports("color",Hl)){Qi.display_space=$l;break}}function Ul(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"lab",a=(n=il.get(n)).from(e),r=n.from(t);return Math.sqrt(a.reduce((function(e,t,n){return n=r[n],isNaN(t)||isNaN(n)?e:e+Math.pow(n-t,2)}),0))}function Gl(e){return fl(e,[ll,"y"])}function Wl(e,t){ml(e,[ll,"y"],t)}var Yl=Object.freeze({__proto__:null,getLuminance:Gl,setLuminance:Wl,register:function(e){Object.defineProperty(e.prototype,"luminance",{get:function(){return Gl(this)},set:function(e){Wl(this,e)}})}});function Kl(e){return.022<=e?e:e+Math.pow(.022-e,1.414)}function Xl(e){var t=e<0?-1:1;e=Math.abs(e);return t*Math.pow(e,2.4)}var Zl=24389/27,Jl=el.D65,Ql=new il({id:"lab-d65",name:"Lab D65",coords:{l:{refRange:[0,100],name:"L"},a:{refRange:[-125,125]},b:{refRange:[-125,125]}},white:Jl,base:ll,fromBase:function(e){return e=e.map((function(e,t){return e/Jl[t]})).map((function(e){return 216/24389<e?Math.cbrt(e):(Zl*e+16)/116})),[116*e[1]-16,500*(e[0]-e[1]),200*(e[1]-e[2])]},toBase:function(e){var t=[];return t[1]=(e[0]+16)/116,t[0]=e[1]/500+t[1],t[2]=t[1]-e[2]/200,[24/116<t[0]?Math.pow(t[0],3):(116*t[0]-16)/Zl,8<e[0]?Math.pow((e[0]+16)/116,3):e[0]/Zl,24/116<t[2]?Math.pow(t[2],3):(116*t[2]-16)/Zl].map((function(e,t){return e*Jl[t]}))},formats:{"lab-d65":{coords:["<number> | <percentage>","<number>","<number>"]}}}),es=.5*Math.pow(5,.5)+.5,ts=Object.freeze({__proto__:null,contrastWCAG21:function(e,t){var n;return e=dl(e),t=dl(t),(e=Math.max(Gl(e),0))<(t=Math.max(Gl(t),0))&&(e=(n=[t,e])[0],t=n[1]),(e+.05)/(t+.05)},contrastAPCA:function(e,t){t=dl(t),e=dl(e);var n=(t=G((t=Nl(t,"srgb")).coords,3))[0],a=t[1],r=(t=t[2],.2126729*Xl(n)+.7151522*Xl(a)+.072175*Xl(t));n=(e=G((e=Nl(e,"srgb")).coords,3))[0],a=e[1],t=e[2],e=.2126729*Xl(n)+.7151522*Xl(a)+.072175*Xl(t),t=(n=Kl(r))<(a=Kl(e)),r=Math.abs(a-n)<5e-4?0:t?1.14*(Math.pow(a,.56)-Math.pow(n,.57)):1.14*(Math.pow(a,.65)-Math.pow(n,.62));return 100*(Math.abs(r)<.1?0:0<r?r-.027:r+.027)},contrastMichelson:function(e,t){e=dl(e),t=dl(t);var n=((e=Math.max(Gl(e),0))<(t=Math.max(Gl(t),0))&&(e=(n=[t,e])[0],t=n[1]),e+t);return 0===n?0:(e-t)/n},contrastWeber:function(e,t){var n;return e=dl(e),t=dl(t),(e=Math.max(Gl(e),0))<(t=Math.max(Gl(t),0))&&(e=(n=[t,e])[0],t=n[1]),0===t?5e4:(e-t)/t},contrastLstar:function(e,t){return e=dl(e),t=dl(t),e=fl(e,[bl,"l"]),t=fl(t,[bl,"l"]),Math.abs(e-t)},contrastDeltaPhi:function(e,t){return e=dl(e),t=dl(t),e=fl(e,[Ql,"l"]),t=fl(t,[Ql,"l"]),e=Math.abs(Math.pow(e,es)-Math.pow(t,es)),(t=Math.pow(e,1/es)*Math.SQRT2-40)<7.5?0:t}});function ns(e){var t=(e=G(pl(e,ll),3))[0],n=e[1];return[4*t/(e=t+15*n+3*e[2]),9*n/e]}function as(e){var t=(e=G(pl(e,ll),3))[0],n=e[1];return[t/(e=t+n+e[2]),n/e]}var rs=Object.freeze({__proto__:null,uv:ns,xy:as,register:function(e){Object.defineProperty(e.prototype,"uv",{get:function(){return ns(this)}}),Object.defineProperty(e.prototype,"xy",{get:function(){return as(this)}})}}),os=Math.PI/180,us=new il({id:"xyz-abs-d65",name:"Absolute XYZ D65",coords:{x:{refRange:[0,9504.7],name:"Xa"},y:{refRange:[0,1e4],name:"Ya"},z:{refRange:[0,10888.3],name:"Za"}},base:ll,fromBase:function(e){return e.map((function(e){return Math.max(203*e,0)}))},toBase:function(e){return e.map((function(e){return Math.max(e/203,0)}))}}),is=2610/Math.pow(2,14),ls=Math.pow(2,14)/2610,ss=3424/Math.pow(2,12),cs=2413/Math.pow(2,7),ds=2392/Math.pow(2,7),ps=1.7*2523/Math.pow(2,5),fs=Math.pow(2,5)/(1.7*2523),Ds=16295499532821565e-27,ms=[[.41478972,.579999,.014648],[-.20151,1.120649,.0531008],[-.0166008,.2648,.6684799]],hs=[[1.9242264357876067,-1.0047923125953657,.037651404030618],[.35031676209499907,.7264811939316552,-.06538442294808501],[-.09098281098284752,-.3127282905230739,1.5227665613052603]],gs=[[.5,.5,0],[3.524,-4.066708,.542708],[.199076,1.096799,-1.295875]],bs=[[1,.1386050432715393,.05804731615611886],[.9999999999999999,-.1386050432715393,-.05804731615611886],[.9999999999999998,-.09601924202631895,-.8118918960560388]],vs=new il({id:"jzazbz",name:"Jzazbz",coords:{jz:{refRange:[0,1],name:"Jz"},az:{refRange:[-.5,.5]},bz:{refRange:[-.5,.5]}},base:us,fromBase:function(e){var t=(e=G(e,3))[0],n=e[1];e=e[2],n=zi(ms,[1.15*t-(1.15-1)*e,.66*n-(.66-1)*t,e]).map((function(e){var t=ss+cs*Math.pow(e/1e4,is);e=1+ds*Math.pow(e/1e4,is);return Math.pow(t/e,ps)})),e=(t=G(zi(gs,n),3))[0],n=t[1],t=t[2];return[(1-.56)*e/(1+-.56*e)-Ds,n,t]},toBase:function(e){var t=(e=G(e,3))[0],n=e[1];e=e[2],t=zi(bs,[(t+Ds)/(1-.56- -.56*(t+Ds)),n,e]).map((function(e){var t=ss-Math.pow(e,fs);e=ds*Math.pow(e,fs)-cs;return 1e4*Math.pow(t/e,ls)})),e=(n=G(zi(hs,t),3))[0],t=n[1];return[e=(e+(1.15-1)*(n=n[2]))/1.15,(t+(.66-1)*e)/.66,n]},formats:{color:{}}}),ys=new il({id:"jzczhz",name:"JzCzHz",coords:{jz:{refRange:[0,1],name:"Jz"},cz:{refRange:[0,1],name:"Chroma"},hz:{refRange:[0,360],type:"angle",name:"Hue"}},base:vs,fromBase:function(e){var t=(e=G(e,3))[0],n=e[1],a=(e=e[2],Math.abs(n)<2e-4&&Math.abs(e)<2e-4?NaN:180*Math.atan2(e,n)/Math.PI);return[t,Math.sqrt(Math.pow(n,2)+Math.pow(e,2)),vl(a)]},toBase:function(e){return[e[0],e[1]*Math.cos(e[2]*Math.PI/180),e[1]*Math.sin(e[2]*Math.PI/180)]},formats:{color:{}}}),Fs=2610/16384,ws=[[.3592,.6976,-.0358],[-.1922,1.1004,.0755],[.007,.0749,.8434]],Es=[[.5,.5,0],[6610/4096,-13613/4096,7003/4096],[17933/4096,-17390/4096,-543/4096]],Cs=[[.9999888965628402,.008605050147287059,.11103437159861648],[1.00001110343716,-.008605050147287059,-.11103437159861648],[1.0000320633910054,.56004913547279,-.3206339100541203]],xs=[[2.0701800566956137,-1.326456876103021,.20661600684785517],[.3649882500326575,.6804673628522352,-.04542175307585323],[-.04959554223893211,-.04942116118675749,1.1879959417328034]],As=new il({id:"ictcp",name:"ICTCP",coords:{i:{refRange:[0,1],name:"I"},ct:{refRange:[-.5,.5],name:"CT"},cp:{refRange:[-.5,.5],name:"CP"}},base:us,fromBase:function(e){var t=e=zi(ws,e);return t=e.map((function(e){var t=.8359375+2413/128*Math.pow(e/1e4,Fs);e=1+18.6875*Math.pow(e/1e4,Fs);return Math.pow(t/e,2523/32)})),zi(Es,t)},toBase:function(e){return e=zi(Cs,e).map((function(e){var t=Math.max(Math.pow(e,32/2523)-.8359375,0);e=2413/128-18.6875*Math.pow(e,32/2523);return 1e4*Math.pow(t/e,16384/2610)})),zi(xs,e)},formats:{color:{}}}),ks=[[.8190224432164319,.3619062562801221,-.12887378261216414],[.0329836671980271,.9292868468965546,.03614466816999844],[.048177199566046255,.26423952494422764,.6335478258136937]],Bs=[[1.2268798733741557,-.5578149965554813,.28139105017721583],[-.04057576262431372,1.1122868293970594,-.07171106666151701],[-.07637294974672142,-.4214933239627914,1.5869240244272418]],Ts=[[.2104542553,.793617785,-.0040720468],[1.9779984951,-2.428592205,.4505937099],[.0259040371,.7827717662,-.808675766]],Ns=[[.9999999984505198,.39633779217376786,.2158037580607588],[1.0000000088817609,-.10556134232365635,-.06385417477170591],[1.0000000546724108,-.08948418209496575,-1.2914855378640917]],Rs=new il({id:"oklab",name:"OKLab",coords:{l:{refRange:[0,1],name:"L"},a:{refRange:[-.4,.4]},b:{refRange:[-.4,.4]}},white:"D65",base:ll,fromBase:function(e){return e=zi(ks,e).map((function(e){return Math.cbrt(e)})),zi(Ts,e)},toBase:function(e){return e=zi(Ns,e).map((function(e){return Math.pow(e,3)})),zi(Bs,e)},formats:{oklab:{coords:["<number> | <percentage>","<number>","<number>"]}}}),_s=Object.freeze({__proto__:null,deltaE76:function(e,t){return Ul(e,t,"lab")},deltaECMC:function(e,t){var n=void 0===(n=(a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).l)?2:n,a=void 0===(a=a.c)?1:a,r=(u=G(bl.from(e),3))[0],o=u[1],u=u[2],i=(l=G(yl.from(bl,[r,o,u]),3))[1],l=l[2],s=(d=G(bl.from(t),3))[0],c=d[1],d=d[2],p=yl.from(bl,[s,c,d])[1];s=r-s,p=(i=i<0?0:i)-(p=p<0?0:p),u-=d,d=Math.pow(o-c,2)+Math.pow(u,2)-Math.pow(p,2),o=.511,16<=r&&(o=.040975*r/(1+.01765*r)),c=.0638*i/(1+.0131*i)+.638,u=164<=(l=Number.isNaN(l)?0:l)&&l<=345?.56+Math.abs(.2*Math.cos((l+168)*os)):.36+Math.abs(.4*Math.cos((l+35)*os)),r=Math.pow(i,4),i=c*((l=Math.sqrt(r/(r+1900)))*u+1-l),r=Math.pow(s/(n*o),2),r=(r+=Math.pow(p/(a*c),2))+d/Math.pow(i,2);return Math.sqrt(r)},deltaE2000:xl,deltaEJz:function(e,t){var n=(e=G(ys.from(e),3))[0],a=e[1],r=(e=e[2],(t=G(ys.from(t),3))[0]),o=t[1];t=t[2],n-=r,r=a-o,Number.isNaN(e)&&Number.isNaN(t)?t=e=0:Number.isNaN(e)?e=t:Number.isNaN(t)&&(t=e),e-=t,t=2*Math.sqrt(a*o)*Math.sin(e/2*(Math.PI/180));return Math.sqrt(Math.pow(n,2)+Math.pow(r,2)+Math.pow(t,2))},deltaEITP:function(e,t){var n=(e=G(As.from(e),3))[0],a=e[1],r=(e=e[2],(t=G(As.from(t),3))[0]),o=t[1];t=t[2];return 720*Math.sqrt(Math.pow(n-r,2)+.25*Math.pow(a-o,2)+Math.pow(e-t,2))},deltaEOK:function(e,t){var n=(e=G(Rs.from(e),3))[0],a=e[1],r=(e=e[2],(t=G(Rs.from(t),3))[0]);a-=t[1],e-=t[2];return Math.sqrt(Math.pow(n-r,2)+Math.pow(a,2)+Math.pow(e,2))}});function Os(e,t){var n,a,r=(a=a=Vi(a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{})?{method:a}:a).method,o=void 0===r?Qi.deltaE:r,u=V(a,h);for(n in e=dl(e),t=dl(t),_s)if("deltae"+o.toLowerCase()===n.toLowerCase())return _s[n](e,t,u);throw new TypeError("Unknown deltaE method: ".concat(o))}var Ss=Object.freeze({__proto__:null,lighten:function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:.25;return ml(e,[il.get("oklch","lch"),"l"],(function(e){return e*(1+t)}))},darken:function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:.25;return ml(e,[il.get("oklch","lch"),"l"],(function(e){return e*(1-t)}))}});function Ms(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:.5,a=3<arguments.length&&void 0!==arguments[3]?arguments[3]:{},r=(e=(r=[dl(e),dl(t)])[0],t=r[1],"object"===$i(n)&&(n=(r=[.5,n])[0],a=r[1]),a);return Is(e,t,{space:r.space,outputSpace:r.outputSpace,premultiplied:r.premultiplied})(n)}function Ps(e,t){var n,a,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},o=(s=(js(e)&&(r=t,e=(s=G((n=e).rangeArgs.colors,2))[0],t=s[1]),r)).maxDeltaE,u=s.deltaEMethod,i=(r=void 0===(r=s.steps)?2:r,void 0===(l=s.maxSteps)?1e3:l),l=V(s,g),s=(n||(e=(s=[dl(e),dl(t)])[0],t=s[1],n=Is(e,t,l)),Os(e,t)),c=(l=0<o?Math.max(r,Math.ceil(s/o)+1):r,[]);if(void 0!==i&&(l=Math.min(l,i)),c=1===l?[{p:.5,color:n(.5)}]:(a=1/(l-1),Array.from({length:l},(function(e,t){return{p:t*=a,color:n(t)}}))),0<o)for(var d=c.reduce((function(e,t,n){return 0===n?0:(t=Os(t.color,c[n-1].color,u),Math.max(e,t))}),0);o<d;){d=0;for(var p=1;p<c.length&&c.length<i;p++){var f=c[p-1],D=c[p],m=(D.p+f.p)/2,h=n(m);d=Math.max(d,Os(h,f.color),Os(h,D.color));c.splice(p,0,{p:m,color:n(m)}),p++}}return c=c.map((function(e){return e.color}))}function Is(e,t){var n,a,r,o,u,i,l,s,c,d,p,f,D=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};return js(e)?(r=e,o=t,Is.apply(void 0,$(r.rangeArgs.colors).concat([U({},r.rangeArgs.options,o)]))):(p=D.space,f=D.outputSpace,n=D.progression,a=D.premultiplied,e=dl(e),t=dl(t),e=Bl(e),t=Bl(t),r={colors:[e,t],options:D},p=p?il.get(p):il.registry[Qi.interpolationSpace]||e.space,f=f?il.get(f):p,e=Nl(e,p),t=Nl(t,p),e=Tl(e),t=Tl(t),p.coords.h&&"angle"===p.coords.h.type&&(o=D.hue=D.hue||"shorter",s=[(i=[fl(e,D=[p,"h"]),fl(t,D)])[0],i=i[1]],l="raw"===(l=o)?s:(c=(s=G(s.map(vl),2))[0],d=(s=s[1])-c,"increasing"===l?d<0&&(s+=360):"decreasing"===l?0<d&&(c+=360):"longer"===l?-180<d&&d<180&&(0<d?s+=360:c+=360):"shorter"===l&&(180<d?c+=360:d<-180&&(s+=360)),[c,s]),u=(d=G(l,2))[0],i=d[1],ml(e,D,u),ml(t,D,i)),a&&(e.coords=e.coords.map((function(t){return t*e.alpha})),t.coords=t.coords.map((function(e){return e*t.alpha}))),Object.assign((function(r){r=n?n(r):r;var o=e.coords.map((function(e,n){return Wi(e,t.coords[n],r)})),u=Wi(e.alpha,t.alpha,r);o={space:p,coords:o,alpha:u};return a&&(o.coords=o.coords.map((function(e){return e/u}))),f!==p?Nl(o,f):o}),{rangeArgs:r}))}function js(e){return"function"===$i(e)&&!!e.rangeArgs}Qi.interpolationSpace="lab";var Ls=Object.freeze({__proto__:null,mix:Ms,steps:Ps,range:Is,isRange:js,register:function(e){e.defineFunction("mix",Ms,{returns:"color"}),e.defineFunction("range",Is,{returns:"function<color>"}),e.defineFunction("steps",Ps,{returns:"array<color>"})}}),qs=new il({id:"hsl",name:"HSL",coords:{h:{refRange:[0,360],type:"angle",name:"Hue"},s:{range:[0,100],name:"Saturation"},l:{range:[0,100],name:"Lightness"}},base:Ll,fromBase:function(e){var t=Math.max.apply(Math,$(e)),n=Math.min.apply(Math,$(e)),a=(e=G(e,3))[0],r=e[1],o=e[2],u=NaN,i=(e=0,(n+t)/2),l=t-n;if(0!=l){switch(e=0==i||1==i?0:(t-i)/Math.min(i,1-i),t){case a:u=(r-o)/l+(r<o?6:0);break;case r:u=(o-a)/l+2;break;case o:u=(a-r)/l+4}u*=60}return[u,100*e,100*i]},toBase:function(e){var t=(e=G(e,3))[0],n=e[1],a=e[2];function r(e){e=(e+t/30)%12;var r=n*Math.min(a,1-a);return a-r*Math.max(-1,Math.min(e-3,9-e,1))}return(t%=360)<0&&(t+=360),n/=100,a/=100,[r(0),r(8),r(4)]},formats:{hsl:{toGamut:!0,coords:["<number> | <angle>","<percentage>","<percentage>"]},hsla:{coords:["<number> | <angle>","<percentage>","<percentage>"],commas:!0,lastAlpha:!0}}}),zs=new il({id:"hsv",name:"HSV",coords:{h:{refRange:[0,360],type:"angle",name:"Hue"},s:{range:[0,100],name:"Saturation"},v:{range:[0,100],name:"Value"}},base:qs,fromBase:function(e){var t=(e=G(e,3))[0],n=e[1];e=e[2];return[t,0==(n=(e/=100)+(n/=100)*Math.min(e,1-e))?0:200*(1-e/n),100*n]},toBase:function(e){var t=(e=G(e,3))[0],n=e[1];e=e[2];return[t,0==(n=(e/=100)*(1-(n/=100)/2))||1==n?0:(e-n)/Math.min(n,1-n)*100,100*n]},formats:{color:{toGamut:!0}}}),Vs=new il({id:"hwb",name:"HWB",coords:{h:{refRange:[0,360],type:"angle",name:"Hue"},w:{range:[0,100],name:"Whiteness"},b:{range:[0,100],name:"Blackness"}},base:zs,fromBase:function(e){var t=(e=G(e,3))[0],n=e[1];return[t,(e=e[2])*(100-n)/100,100-e]},toBase:function(e){var t=(e=G(e,3))[0],n=e[1],a=(e=e[2],(n/=100)+(e/=100));return 1<=a?[t,0,n/a*100]:[t,100*(0==(a=1-e)?0:1-n/a),100*a]},formats:{hwb:{toGamut:!0,coords:["<number> | <angle>","<percentage>","<percentage>"]}}}),$s=new ve({id:"a98rgb-linear",name:"Linear Adobe® 98 RGB compatible",white:"D65",toXYZ_M:[[.5766690429101305,.1855582379065463,.1882286462349947],[.29734497525053605,.6273635662554661,.07529145849399788],[.02703136138641234,.07068885253582723,.9913375368376388]],fromXYZ_M:[[2.0415879038107465,-.5650069742788596,-.34473135077832956],[-.9692436362808795,1.8759675015077202,.04155505740717557],[.013444280632031142,-.11836239223101838,1.0151749943912054]]}),Hs=new ve({id:"a98rgb",name:"Adobe® 98 RGB compatible",base:$s,toBase:function(e){return e.map((function(e){return Math.pow(Math.abs(e),563/256)*Math.sign(e)}))},fromBase:function(e){return e.map((function(e){return Math.pow(Math.abs(e),256/563)*Math.sign(e)}))},formats:{color:{id:"a98-rgb"}}}),Us=new ve({id:"prophoto-linear",name:"Linear ProPhoto",white:"D50",base:Kt,toXYZ_M:[[.7977604896723027,.13518583717574031,.0313493495815248],[.2880711282292934,.7118432178101014,8565396060525902e-20],[0,0,.8251046025104601]],fromXYZ_M:[[1.3457989731028281,-.25558010007997534,-.05110628506753401],[-.5446224939028347,1.5082327413132781,.02053603239147973],[0,0,1.2119675456389454]]}),Gs=new ve({id:"prophoto",name:"ProPhoto",base:Us,toBase:function(e){return e.map((function(e){return e<.03125?e/16:Math.pow(e,1.8)}))},fromBase:function(e){return e.map((function(e){return 1/512<=e?Math.pow(e,1/1.8):16*e}))},formats:{color:{id:"prophoto-rgb"}}}),Ws=new il({id:"oklch",name:"OKLCh",coords:{l:{refRange:[0,1],name:"Lightness"},c:{refRange:[0,.4],name:"Chroma"},h:{refRange:[0,360],type:"angle",name:"Hue"}},white:"D65",base:Rs,fromBase:function(e){var t=(e=G(e,3))[0],n=e[1],a=(e=e[2],Math.abs(n)<2e-4&&Math.abs(e)<2e-4?NaN:180*Math.atan2(e,n)/Math.PI);return[t,Math.sqrt(Math.pow(n,2)+Math.pow(e,2)),vl(a)]},toBase:function(e){var t,n=(e=G(e,3))[0],a=e[1];e=e[2],a=isNaN(e)?t=0:(t=a*Math.cos(e*Math.PI/180),a*Math.sin(e*Math.PI/180));return[n,t,a]},formats:{oklch:{coords:["<number> | <percentage>","<number>","<number> | <angle>"]}}}),Ys=2610/Math.pow(2,14),Ks=Math.pow(2,14)/2610,Xs=2523/Math.pow(2,5),Zs=Math.pow(2,5)/2523,Js=3424/Math.pow(2,12),Qs=2413/Math.pow(2,7),ec=2392/Math.pow(2,7),tc=new ve({id:"rec2100pq",name:"REC.2100-PQ",base:_l,toBase:function(e){return e.map((function(e){return 1e4*Math.pow(Math.max(Math.pow(e,Zs)-Js,0)/(Qs-ec*Math.pow(e,Zs)),Ks)/203}))},fromBase:function(e){return e.map((function(e){e=Math.max(203*e/1e4,0);var t=Js+Qs*Math.pow(e,Ys);e=1+ec*Math.pow(e,Ys);return Math.pow(t/e,Xs)}))},formats:{color:{id:"rec2100-pq"}}}),nc=.17883277,ac=.28466892,rc=.55991073,oc=3.7743,uc=new ve({id:"rec2100hlg",cssid:"rec2100-hlg",name:"REC.2100-HLG",referred:"scene",base:_l,toBase:function(e){return e.map((function(e){return e<=.5?Math.pow(e,2)/3*oc:Math.exp((e-rc)/nc+ac)/12*oc}))},fromBase:function(e){return e.map((function(e){return(e/=oc)<=1/12?Math.sqrt(3*e):nc*Math.log(12*e-ac)+rc}))},formats:{color:{id:"rec2100-hlg"}}}),ic={};function lc(e){var t=e.id;e.toCone_M,e.fromCone_M,ic[t]=e}function sc(e,t,n){var a=ic[2<arguments.length&&void 0!==n?n:"Bradford"],r=(u=G(zi(a.toCone_M,e),3))[0],o=u[1],u=u[2],i=G(zi(a.toCone_M,t),3);r=zi([[i[0]/r,0,0],[0,i[1]/o,0],[0,0,i[2]/u]],a.toCone_M);return zi(a.fromCone_M,r)}Ji.add("chromatic-adaptation-start",(function(e){e.options.method&&(e.M=sc(e.W1,e.W2,e.options.method))})),Ji.add("chromatic-adaptation-end",(function(e){e.M||(e.M=sc(e.W1,e.W2,e.options.method))})),lc({id:"von Kries",toCone_M:[[.40024,.7076,-.08081],[-.2263,1.16532,.0457],[0,0,.91822]],fromCone_M:[[1.8599364,-1.1293816,.2198974],[.3611914,.6388125,-64e-7],[0,0,1.0890636]]}),lc({id:"Bradford",toCone_M:[[.8951,.2664,-.1614],[-.7502,1.7135,.0367],[.0389,-.0685,1.0296]],fromCone_M:[[.9869929,-.1470543,.1599627],[.4323053,.5183603,.0492912],[-.0085287,.0400428,.9684867]]}),lc({id:"CAT02",toCone_M:[[.7328,.4296,-.1624],[-.7036,1.6975,.0061],[.003,.0136,.9834]],fromCone_M:[[1.0961238,-.278869,.1827452],[.454369,.4735332,.0720978],[-.0096276,-.005698,1.0153256]]}),lc({id:"CAT16",toCone_M:[[.401288,.650173,-.051461],[-.250268,1.204414,.045854],[-.002079,.048952,.953127]],fromCone_M:[[1.862067855087233,-1.011254630531685,.1491867754444518],[.3875265432361372,.6214474419314753,-.008973985167612518],[-.01584149884933386,-.03412293802851557,1.04996443687785]]}),Object.assign(el,{A:[1.0985,1,.35585],C:[.98074,1,1.18232],D55:[.95682,1,.92149],D75:[.94972,1,1.22638],E:[1,1,1],F2:[.99186,1,.67393],F7:[.95041,1,1.08747],F11:[1.00962,1,.6435]}),el.ACES=[.32168/.33767,1,.34065/.33767];var cc=new ve({id:"acescg",name:"ACEScg",coords:{r:{range:[0,65504],name:"Red"},g:{range:[0,65504],name:"Green"},b:{range:[0,65504],name:"Blue"}},referred:"scene",white:el.ACES,toXYZ_M:[[.6624541811085053,.13400420645643313,.1561876870049078],[.27222871678091454,.6740817658111484,.05368951740793705],[-.005574649490394108,.004060733528982826,1.0103391003129971]],fromXYZ_M:[[1.6410233796943257,-.32480329418479,-.23642469523761225],[-.6636628587229829,1.6153315916573379,.016756347685530137],[.011721894328375376,-.008284441996237409,.9883948585390215]],formats:{color:{}}}),dc=Math.pow(2,-16),pc=-.35828683,fc=(Math.log2(65504)+9.72)/17.52,Dc=(ve=new ve({id:"acescc",name:"ACEScc",coords:{r:{range:[pc,fc],name:"Red"},g:{range:[pc,fc],name:"Green"},b:{range:[pc,fc],name:"Blue"}},referred:"scene",base:cc,toBase:function(e){return e.map((function(e){return e<=(9.72-15)/17.52?2*(Math.pow(2,17.52*e-9.72)-dc):e<fc?Math.pow(2,17.52*e-9.72):65504}))},fromBase:function(e){return e.map((function(e){return e<=0?(Math.log2(dc)+9.72)/17.52:e<dc?(Math.log2(dc+.5*e)+9.72)/17.52:(Math.log2(e)+9.72)/17.52}))},formats:{color:{}}}),Object.freeze({__proto__:null,XYZ_D65:ll,XYZ_D50:Kt,XYZ_ABS_D65:us,Lab_D65:Ql,Lab:bl,LCH:yl,sRGB_Linear:Il,sRGB:Ll,HSL:qs,HWB:Vs,HSV:zs,P3_Linear:Pl,P3:ql,A98RGB_Linear:$s,A98RGB:Hs,ProPhoto_Linear:Us,ProPhoto:Gs,REC_2020_Linear:_l,REC_2020:Ml,OKLab:Rs,OKLCH:Ws,Jzazbz:vs,JzCzHz:ys,ICTCP:As,REC_2100_PQ:tc,REC_2100_HLG:uc,ACEScg:cc,ACEScc:ve})),mc=(se=new WeakMap,Z(hc,[{key:"space",get:function(){return j(this,se)}},{key:"spaceId",get:function(){return j(this,se).id}},{key:"clone",value:function(){return new hc(this.space,this.coords,this.alpha)}},{key:"toJSON",value:function(){return{spaceId:this.spaceId,coords:this.coords,alpha:this.alpha}}},{key:"display",value:function(){for(var e=arguments.length,t=new Array(e),n=0;n<e;n++)t[n]=arguments[n];var a=function(e){var t=void 0===(t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).space)?Qi.display_space:t,n=V(n,D),a=Rl(e,n);return"undefined"==typeof CSS||CSS.supports("color",a)||!Qi.display_space?(a=new String(a)).color=e:(t=Nl(e,t),(a=new String(Rl(t,n))).color=t),a}.apply(void 0,[this].concat(t));return a.color=new hc(a.color),a}}],[{key:"get",value:function(e){if(e instanceof hc)return e;for(var t=arguments.length,n=new Array(1<t?t-1:0),a=1;a<t;a++)n[a-1]=arguments[a];return B(hc,[e].concat(n))}},{key:"defineFunction",value:function(e,t){function n(){var e,n=t.apply(void 0,arguments);return"color"===o?n=hc.get(n):"function<color>"===o?(e=n,n=function(){var t=e.apply(void 0,arguments);return hc.get(t)},Object.assign(n,e)):"array<color>"===o&&(n=n.map((function(e){return hc.get(e)}))),n}var a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:t,r=void 0===(r=a.instance)||r,o=a.returns;e in hc||(hc[e]=n),r&&(hc.prototype[e]=function(){for(var e=arguments.length,t=new Array(e),a=0;a<e;a++)t[a]=arguments[a];return n.apply(void 0,[this].concat(t))})}},{key:"defineFunctions",value:function(e){for(var t in e)hc.defineFunction(t,e[t],e[t])}},{key:"extend",value:function(e){if(e.register)e.register(hc);else for(var t in e)hc.defineFunction(t,e[t])}}]),hc);function hc(){var e=this;K(this,hc),M(this,se,{writable:!0,value:void 0});for(var t,n,a,r=arguments.length,o=new Array(r),u=0;u<r;u++)o[u]=arguments[u];a=(a=1===o.length?dl(o[0]):a)?(t=a.space||a.spaceId,n=a.coords,a.alpha):(t=o[0],n=o[1],o[2]),q(this,se,il.get(t)),this.coords=n?n.slice():[0,0,0],this.alpha=a<1?a:1;for(var i=0;i<this.coords.length;i++)"NaN"===this.coords[i]&&(this.coords[i]=NaN);for(var l in j(this,se).coords)!function(t){Object.defineProperty(e,t,{get:function(){return e.get(t)},set:function(n){return e.set(t,n)}})}(l)}mc.defineFunctions({get:fl,getAll:pl,set:ml,setAll:Dl,to:Nl,equals:function(e,t){return e=dl(e),t=dl(t),e.space===t.space&&e.alpha===t.alpha&&e.coords.every((function(e,n){return e===t.coords[n]}))},inGamut:kl,toGamut:Tl,distance:Ul,toString:Rl}),Object.assign(mc,{util:Io,hooks:Ji,WHITES:el,Space:il,spaces:il.registry,parse:cl,defaults:Qi});for(var gc,bc=0,vc=Object.keys(Dc);bc<vc.length;bc++){var yc=vc[bc];il.register(Dc[yc])}for(gc in il.registry)Fc(gc,il.registry[gc]);function Fc(e,t){Object.keys(t.coords),Object.values(t.coords).map((function(e){return e.name}));var n=e.replace(/-/g,"_");Object.defineProperty(mc.prototype,n,{get:function(){var n=this,a=this.getAll(e);return"undefined"==typeof Proxy?a:new Proxy(a,{has:function(e,n){try{return il.resolveCoord([t,n]),!0}catch(e){}return Reflect.has(e,n)},get:function(e,n,a){if(n&&"symbol"!==r(n)&&!(n in e)){var o=il.resolveCoord([t,n]).index;if(0<=o)return e[o]}return Reflect.get(e,n,a)},set:function(a,o,u,i){if(o&&"symbol"!==r(o)&&!(o in a)||0<=o){var l=il.resolveCoord([t,o]).index;if(0<=l)return a[l]=u,n.setAll(e,a),!0}return Reflect.set(a,o,u,i)}})},set:function(t){this.setAll(e,t)},configurable:!0,enumerable:!0})}Ji.add("colorspace-init-end",(function(e){var t;Fc(e.id,e),null!=(t=e.aliases)&&t.forEach((function(t){Fc(t,e)}))})),mc.extend(_s),mc.extend({deltaE:Os}),mc.extend(Ss),mc.extend({contrast:function(e,t){var n,a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},r=(a=a=Vi(a)?{algorithm:a}:a).algorithm,o=V(a,m);if(!r)throw a=Object.keys(ts).map((function(e){return e.replace(/^contrast/,"")})).join(", "),new TypeError("contrast() function needs a contrast algorithm. Please specify one of: ".concat(a));for(n in e=dl(e),t=dl(t),ts)if("contrast"+r.toLowerCase()===n.toLowerCase())return ts[n](e,t,o);throw new TypeError("Unknown contrast algorithm: ".concat(r))}}),mc.extend(rs),mc.extend(Yl),mc.extend(Ls),mc.extend(ts);pc=re(Zt()),Kt=re(Jt());var wc=(re(Qt()),Li.default.templateSettings.strip=!1,"Promise"in t||pc.default.polyfill(),"Uint32Array"in t||(t.Uint32Array=Kt.Uint32Array),t.Uint32Array&&("some"in t.Uint32Array.prototype||Object.defineProperty(t.Uint32Array.prototype,"some",{value:Array.prototype.some}),"reduce"in t.Uint32Array.prototype||Object.defineProperty(t.Uint32Array.prototype,"reduce",{value:Array.prototype.reduce})),/^#[0-9a-f]{3,8}$/i),Ec=/hsl\\(\\s*([\\d.]+)(rad|turn)/;function Cc(e,t,n){var a=3<arguments.length&&void 0!==arguments[3]?arguments[3]:1;K(this,Cc),this.red=e,this.green=t,this.blue=n,this.alpha=a}Z(Cc,[{key:"toHexString",value:function(){var e=Math.round(this.red).toString(16),t=Math.round(this.green).toString(16),n=Math.round(this.blue).toString(16);return"#"+(15.5<this.red?e:"0"+e)+(15.5<this.green?t:"0"+t)+(15.5<this.blue?n:"0"+n)}},{key:"toJSON",value:function(){return{red:this.red,green:this.green,blue:this.blue,alpha:this.alpha}}},{key:"parseString",value:function(e){e=e.replace(Ec,(function(e,t,n){var a=t+n;switch(n){case"rad":return e.replace(a,180*t/Math.PI);case"turn":return e.replace(a,360*t)}}));try{var t=new mc(e).to("srgb");this.red=Math.round(255*Ac(t.r,0,1)),this.green=Math.round(255*Ac(t.g,0,1)),this.blue=Math.round(255*Ac(t.b,0,1)),this.alpha=+t.alpha}catch(t){throw new Error(\'Unable to parse color "\'.concat(e,\'"\'))}return this}},{key:"parseRgbString",value:function(e){this.parseString(e)}},{key:"parseHexString",value:function(e){e.match(wc)&&![6,8].includes(e.length)&&this.parseString(e)}},{key:"parseColorFnString",value:function(e){this.parseString(e)}},{key:"getRelativeLuminance",value:function(){var e=this.red/255,t=this.green/255,n=this.blue/255;return.2126*(e<=.03928?e/12.92:Math.pow((.055+e)/1.055,2.4))+.7152*(t<=.03928?t/12.92:Math.pow((.055+t)/1.055,2.4))+.0722*(n<=.03928?n/12.92:Math.pow((.055+n)/1.055,2.4))}}]);var xc=Cc;function Ac(e,t,n){return Math.min(Math.max(t,e),n)}var kc=function(e){var t=new xc;return t.parseString(e.getPropertyValue("background-color")),0!==t.alpha&&(e=e.getPropertyValue("opacity"),t.alpha=t.alpha*e),t},Bc=function(e){var n=t.getComputedStyle(e);return Ii(e,n)||1===kc(n).alpha};function Tc(e){var t;return!(!e.href||(t=Kn.get("firstPageLink",Nc))&&e.compareDocumentPosition(t.actualNode)!==e.DOCUMENT_POSITION_FOLLOWING)}function Nc(){return(t.location.origin?cp(o._tree,\'a[href]:not([href^="javascript:"])\').find((function(e){return!mo(e.actualNode)})):cp(o._tree,\'a:not([href^="#"]):not([href^="/#"]):not([href^="javascript:"])\')[0])||null}var Rc=/rect\\s*\\(([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px\\s*\\)/,_c=/(\\w+)\\((\\d+)/;var Oc=function e(n,a,r){if(!n)throw new TypeError("Cannot determine if element is visible for non-DOM nodes");var u,i,l,s=n instanceof on?n:Xn(n),c=(n=s?s.actualNode:n,"_isVisible"+(a?"ScreenReader":"")),d=(p=null!=(p=t.Node)?p:{}).DOCUMENT_NODE,p=p.DOCUMENT_FRAGMENT_NODE,f=(s?s.props:n).nodeType,D=s?s.props.nodeName:n.nodeName.toLowerCase();return s&&void 0!==s[c]?s[c]:f===d||!["style","script","noscript","template"].includes(D)&&(n&&f===p&&(n=n.host),(!a||"true"!==(s?s.attr("aria-hidden"):n.getAttribute("aria-hidden")))&&(n?null!==(d=t.getComputedStyle(n,null))&&("area"===D?(u=a,i=r,!!(p=pr(f=n,"map"))&&!!(p=p.getAttribute("name"))&&!(!(f=sr(f))||9!==f.nodeType||!(l=cp(o._tree,\'img[usemap="#\'.concat(wn(p),\'"]\')))||!l.length)&&l.some((function(t){return e(t.actualNode,u,i)}))):"none"!==d.getPropertyValue("display")&&(D=parseInt(d.getPropertyValue("height")),f=parseInt(d.getPropertyValue("width")),l=(p=Ad(n))&&0===D,p=p&&0===f,D="absolute"===d.getPropertyValue("position")&&(D<2||f<2)&&"hidden"===d.getPropertyValue("overflow"),!(!a&&(function(e){var t=e.getPropertyValue("clip").match(Rc),n=e.getPropertyValue("clip-path").match(_c);if(t&&5===t.length&&(e=e.getPropertyValue("position"),["fixed","absolute"].includes(e)))return t[3]-t[1]<=0&&t[2]-t[4]<=0;if(n){e=n[1];var a=parseInt(n[2],10);switch(e){case"inset":return 50<=a;case"circle":return 0===a}}}(d)||"0"===d.getPropertyValue("opacity")||l||p||D)||!r&&("hidden"===d.getPropertyValue("visibility")||!a&&Lr(n))))&&(f=!1,(p=n.assignedSlot||n.parentNode)&&(f=e(p,a,!0)),s&&(s[c]=f),f)):(D=!0,(r=s.parent)&&(D=e(r,a,!0)),s&&(s[c]=D),D)))},Sc=function(e,n){for(var a=["fixed","sticky"],r=[],o=!1,u=0;u<e.length;++u){var i=e[u],l=(i===n&&(o=!0),t.getComputedStyle(i));o||-1===a.indexOf(l.position)?r.push(i):r=[]}return r};function Mc(e,n){var a=Pc(n);do{var r,o,u,i,l,s,c=Pc(e);if(c===a||c===n)return i=e,r=n,u=(o=t.getComputedStyle(r)).getPropertyValue("overflow"),"inline"===o.getPropertyValue("display")||(i=Array.from(i.getClientRects()),l=r.getBoundingClientRect(),s={left:l.left,top:l.top,width:l.width,height:l.height},(["scroll","auto"].includes(u)||r instanceof t.HTMLHtmlElement)&&(s.width=r.scrollWidth,s.height=r.scrollHeight),1===i.length&&"hidden"===u&&"nowrap"===o.getPropertyValue("white-space")&&(i[0]=s),i.some((function(e){return!(Math.ceil(e.left)<Math.floor(s.left)||Math.ceil(e.top)<Math.floor(s.top)||Math.floor(e.left+e.width)>Math.ceil(s.left+s.width)||Math.floor(e.top+e.height)>Math.ceil(s.top+s.height))})))}while(e=c);return!1}function Pc(e){for(var t=Xn(e).parent;t;){if(Ad(t.actualNode))return t.actualNode;t=t.parent}}var Ic,jc,Lc=function e(t,n){var r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:a,o=3<arguments.length&&void 0!==arguments[3]?arguments[3]:0;if(999<o)throw new Error("Infinite loop detected");return Array.from(r.elementsFromPoint(t,n)||[]).filter((function(e){return sr(e)===r})).reduce((function(a,r){var u;return ur(r)&&(u=e(t,n,r.shadowRoot,o+1),!(a=a.concat(u)).length||!Mc(a[0],r))||a.push(r),a}),[])},qc=function(e,t){var n,r;if(e.hasAttribute(t))return r=e.nodeName.toUpperCase(),n=e,["A","AREA"].includes(r)&&!e.ownerSVGElement||((n=a.createElement("a")).href=e.getAttribute(t)),r=["https:","ftps:"].includes(n.protocol)?n.protocol.replace(/s:$/,":"):n.protocol,t=(e=(e=(t=e=/^\\//.test(n.pathname)?n.pathname:"/".concat(n.pathname)).split("/").pop())&&-1!==e.indexOf(".")?{pathname:t.replace(e,""),filename:/index./.test(e)?"":e}:{pathname:t,filename:""}).pathname,e=e.filename,{protocol:r,hostname:n.hostname,port:(r=n.port,["443","80"].includes(r)?"":r),pathname:/\\/$/.test(t)?t:"".concat(t,"/"),search:function(e){var t={};if(e&&e.length){var n=e.substring(1).split("&");if(n&&n.length)for(var a=0;a<n.length;a++){var r=(o=G(n[a].split("="),2))[0],o=void 0===(o=o[1])?"":o;t[decodeURIComponent(r)]=decodeURIComponent(o)}}return t}(n.search),hash:(r=n.hash)&&(t=r.match(/#!?\\/?/g))&&"#"!==G(t,1)[0]?r:"",filename:e}},zc=function(e,n){var a=n.getBoundingClientRect(),r=a.top,o=a.left,u=r-n.scrollTop,i=(r=r-n.scrollTop+n.scrollHeight,o-n.scrollLeft);o=o-n.scrollLeft+n.scrollWidth;return!(e.left>o&&e.left>a.right||e.top>r&&e.top>a.bottom||e.right<i&&e.right<a.left||e.bottom<u&&e.bottom<a.top)&&(o=t.getComputedStyle(n),!(e.left>a.right||e.top>a.bottom)||"scroll"===o.overflow||"auto"===o.overflow||n instanceof t.HTMLBodyElement||n instanceof t.HTMLHtmlElement)},Vc=0;function $c(e,t,n){var a;return K(this,$c),(a=jc.call(this)).shadowId=n,a.children=[],a.actualNode=e,(a.parent=t)||(Vc=0),a.nodeIndex=Vc++,a._isHidden=null,a._cache={},void 0===Ic&&(Ic=Nn(e.ownerDocument)),a._isXHTML=Ic,"input"===e.nodeName.toLowerCase()&&(n=e.getAttribute("type"),n=a._isXHTML?n:(n||"").toLowerCase(),vp().includes(n)||(n="text"),a._type=n),Kn.get("nodeMap")&&Kn.get("nodeMap").set(e,_(a)),a}T($c,on),jc=R($c),Z($c,[{key:"props",get:function(){var e,t,n,a,r,o,u,i,l;return this._cache.hasOwnProperty("props")||(e=(l=this.actualNode).nodeType,t=l.nodeName,n=l.id,a=l.multiple,r=l.nodeValue,o=l.value,u=l.selected,i=l.checked,l=l.indeterminate,this._cache.props={nodeType:e,nodeName:this._isXHTML?t:t.toLowerCase(),id:n,type:this._type,multiple:a,nodeValue:r,value:o,selected:u,checked:i,indeterminate:l}),this._cache.props}},{key:"attr",value:function(e){return"function"!=typeof this.actualNode.getAttribute?null:this.actualNode.getAttribute(e)}},{key:"hasAttr",value:function(e){return"function"==typeof this.actualNode.hasAttribute&&this.actualNode.hasAttribute(e)}},{key:"attrNames",get:function(){var e;return this._cache.hasOwnProperty("attrNames")||(e=(this.actualNode.attributes instanceof t.NamedNodeMap?this.actualNode:this.actualNode.cloneNode(!1)).attributes,this._cache.attrNames=Array.from(e).map((function(e){return e.name}))),this._cache.attrNames}},{key:"getComputedStylePropertyValue",value:function(e){var n="computedStyle_"+e;return this._cache.hasOwnProperty(n)||(this._cache.hasOwnProperty("computedStyle")||(this._cache.computedStyle=t.getComputedStyle(this.actualNode)),this._cache[n]=this._cache.computedStyle.getPropertyValue(e)),this._cache[n]}},{key:"isFocusable",get:function(){return this._cache.hasOwnProperty("isFocusable")||(this._cache.isFocusable=Qo(this.actualNode)),this._cache.isFocusable}},{key:"tabbableElements",get:function(){return this._cache.hasOwnProperty("tabbableElements")||(this._cache.tabbableElements=Bo(this)),this._cache.tabbableElements}},{key:"clientRects",get:function(){return this._cache.hasOwnProperty("clientRects")||(this._cache.clientRects=Array.from(this.actualNode.getClientRects()).filter((function(e){return 0<e.width}))),this._cache.clientRects}},{key:"boundingClientRect",get:function(){return this._cache.hasOwnProperty("boundingClientRect")||(this._cache.boundingClientRect=this.actualNode.getBoundingClientRect()),this._cache.boundingClientRect}}]);var Hc,Uc=$c,Gc=function(e){return(e||"").trim().replace(/\\s{2,}/g," ").split(" ")},Wc=" [idsMap]";function Yc(e,t,n){var a=e[0]._selectorMap;if(a){for(var r=e[0].shadowId,o=0;o<t.length;o++)if(1<t[o].length&&t[o].some(Kc))return;var u=new Set,i=(t.forEach((function(e){var t,n=function(e,t,n){var a=e[e.length-1],r=null,o=1<e.length||!!a.pseudos||!!a.classes;if(Kc(a))r=t["*"];else{if(a.id){if(!t[Wc]||null==(e=t[Wc][a.id])||!e.length)return;r=t[Wc][a.id].filter((function(e){return e.shadowId===n}))}if(a.tag&&"*"!==a.tag){if(null==(e=t[a.tag])||!e.length)return;e=t[a.tag];r=r?Xc(e,r):e}if(a.classes){if(null==(e=t["[class]"])||!e.length)return;e=t["[class]"],r=r?Xc(e,r):e}if(a.attributes)for(var u=0;u<a.attributes.length;u++){var i=a.attributes[u];if("attrValue"===i.type&&(o=!0),null==(l=t["[".concat(i.key,"]")])||!l.length)return;var l=t["[".concat(i.key,"]")];r=r?Xc(l,r):l}}return{nodes:r,isComplexSelector:o}}(e,a,r);null!=n&&null!=(t=n.nodes)&&t.forEach((function(t){n.isComplexSelector&&!la(t,e)||u.add(t)}))})),[]);return u.forEach((function(e){return i.push(e)})),(i=n?i.filter(n):i).sort((function(e,t){return e.nodeIndex-t.nodeIndex}))}}function Kc(e){return"*"===e.tag&&!e.attributes&&!e.id&&!e.classes}function Xc(e,t){return e.filter((function(e){return t.includes(e)}))}function Zc(e,t,n){n[e]=n[e]||[],n[e].push(t)}function Jc(e,t){1===e.props.nodeType&&(Zc(e.props.nodeName,e,t),Zc("*",e,t),e.attrNames.forEach((function(n){"id"===n&&(t[Wc]=t[Wc]||{},Gc(e.attr(n)).forEach((function(n){Zc(n,e,t[Wc])}))),Zc("[".concat(n,"]"),e,t)})))}function Qc(e,t,n){return Jc(e=new Uc(e,t,n),Kn.get("selectorMap")),e}function ed(e,n,a){var r,o,u;function i(e,t,a){return(t=ed(t,n,a))?e.concat(t):e}return u=(e=e.documentElement?e.documentElement:e).nodeName.toLowerCase(),ur(e)?(Hc=!0,r=Qc(e,a,n),n="a"+Math.random().toString().substring(2),o=Array.from(e.shadowRoot.childNodes),r.children=o.reduce((function(e,t){return i(e,t,r)}),[]),[r]):"content"===u&&"function"==typeof e.getDistributedNodes?(o=Array.from(e.getDistributedNodes())).reduce((function(e,t){return i(e,t,a)}),[]):"slot"===u&&"function"==typeof e.assignedNodes?((o=Array.from(e.assignedNodes())).length||(o=function(e){var t=[];for(e=e.firstChild;e;)t.push(e),e=e.nextSibling;return t}(e)),t.getComputedStyle(e),o.reduce((function(e,t){return i(e,t,a)}),[])):1===e.nodeType?(r=Qc(e,a,n),o=Array.from(e.childNodes),r.children=o.reduce((function(e,t){return i(e,t,r)}),[]),[r]):3===e.nodeType?[Qc(e,a)]:void 0}var td=function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:a.documentElement,t=1<arguments.length?arguments[1]:void 0,n=(Hc=!1,{});return Kn.set("nodeMap",new WeakMap),Kn.set("selectorMap",n),(e=ed(e,t,null))[0]._selectorMap=n,e[0]._hasShadowRoot=Hc,e},nd=function(e){return e?e.trim().split("-")[0].toLowerCase():""},ad=function(e){var t={};return t.none=e.none.concat(e.all),t.any=e.any,Object.keys(t).map((function(e){var n;return t[e].length&&(n=o._audit.data.failureSummaries[e])&&"function"==typeof n.failureMessage?n.failureMessage(t[e].map((function(e){return e.message||""}))):void 0})).filter((function(e){return void 0!==e})).join("\\n\\n")};function rd(){var e=o._audit.data.incompleteFallbackMessage;return"string"!=typeof(e="function"==typeof e?e():e)?"":e}var od=tn.resultGroups,ud=function(e,t){var n=o.utils.aggregateResult(e);return od.forEach((function(e){t.resultTypes&&!t.resultTypes.includes(e)&&(n[e]||[]).forEach((function(e){Array.isArray(e.nodes)&&0<e.nodes.length&&(e.nodes=[e.nodes[0]])})),n[e]=(n[e]||[]).map((function(e){return e=Object.assign({},e),Array.isArray(e.nodes)&&0<e.nodes.length&&(e.nodes=e.nodes.map((function(e){var n,a;return"object"===r(e.node)&&(e.html=e.node.source,t.elementRef&&!e.node.fromFrame&&(e.element=e.node.element),!1===t.selectors&&!e.node.fromFrame||(e.target=e.node.selector),t.ancestry&&(e.ancestry=e.node.ancestry),t.xpath)&&(e.xpath=e.node.xpath),delete e.result,delete e.node,n=e,a=t,["any","all","none"].forEach((function(e){Array.isArray(n[e])&&n[e].filter((function(e){return Array.isArray(e.relatedNodes)})).forEach((function(e){e.relatedNodes=e.relatedNodes.map((function(e){var t,n={html:null!=(n=null==e?void 0:e.source)?n:"Undefined"};return!a.elementRef||null!=e&&e.fromFrame||(n.element=null!=(t=null==e?void 0:e.element)?t:null),(!1!==a.selectors||null!=e&&e.fromFrame)&&(n.target=null!=(t=null==e?void 0:e.selector)?t:[":root"]),a.ancestry&&(n.ancestry=null!=(t=null==e?void 0:e.ancestry)?t:[":root"]),a.xpath&&(n.xpath=null!=(t=null==e?void 0:e.xpath)?t:["/"]),n}))}))})),e}))),od.forEach((function(t){return delete e[t]})),delete e.pageLevel,delete e.result,e}))})),n},id=/\\$\\{\\s?data\\s?\\}/g;function ld(e,t){if("string"==typeof t)return e.replace(id,t);for(var n in t){var a;t.hasOwnProperty(n)&&(a=new RegExp("\\\\${\\\\s?data\\\\."+n+"\\\\s?}","g"),n=void 0===t[n]?"":String(t[n]),e=e.replace(a,n))}return e}var sd=function e(t,n){var a;if(t)return Array.isArray(n)?(n.values=n.join(", "),"string"==typeof t.singular&&"string"==typeof t.plural?ld(1===n.length?t.singular:t.plural,n):ld(t,n)):"string"==typeof t?ld(t,n):"string"==typeof n?ld(t[n],n):(a=t.default||rd(),e(a=n&&n.messageKey&&t[n.messageKey]?t[n.messageKey]:a,n))},cd=function(e,t,n){var a=o._audit.data.checks[e];if(!a)throw new Error("Cannot get message for unknown check: ".concat(e,"."));if(a.messages[t])return sd(a.messages[t],n);throw new Error(\'Check "\'.concat(e,\'"" does not have a "\').concat(t,\'" message.\'))},dd=function(e,t,n){t=((n.rules&&n.rules[t]||{}).checks||{})[e.id];var a=(n.checks||{})[e.id],r=e.enabled;e=e.options;return a&&(a.hasOwnProperty("enabled")&&(r=a.enabled),a.hasOwnProperty("options"))&&(e=a.options),t&&(t.hasOwnProperty("enabled")&&(r=t.enabled),t.hasOwnProperty("options"))&&(e=t.options),{enabled:r,options:e,absolutePaths:n.absolutePaths}};function pd(){var e,n,a,u,i=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null,l=1<arguments.length&&void 0!==arguments[1]?arguments[1]:t;return i&&"object"===r(i)?i:"object"!==r(l)?{}:{testEngine:{name:"axe-core",version:o.version},testRunner:{name:o._audit.brand},testEnvironment:(i=l).navigator&&"object"===r(i.navigator)?(e=i.navigator,n=i.innerHeight,a=i.innerWidth,i=function(e){return(e=e.screen).orientation||e.msOrientation||e.mozOrientation}(i)||{},u=i.angle,i=i.type,{userAgent:e.userAgent,windowWidth:a,windowHeight:n,orientationAngle:u,orientationType:i}):{},timestamp:(new Date).toISOString(),url:null==(e=l.location)?void 0:e.href}}function fd(e,t){var n=t.focusable;t=t.page;return{node:e,include:[],exclude:[],initiator:!1,focusable:n&&(!(n=(n=e).getAttribute("tabindex"))||(n=parseInt(n,10),isNaN(n))||0<=n),size:function(e){var t=parseInt(e.getAttribute("width"),10),n=parseInt(e.getAttribute("height"),10);return(isNaN(t)||isNaN(n))&&(e=e.getBoundingClientRect(),t=isNaN(t)?e.width:t,n=isNaN(n)?e.height:n),{width:t,height:n}}(e),page:t}}function Dd(e){var n=0<arguments.length&&void 0!==e?e:[],a=[];vd(n)||(n=[n]);for(var r=0;r<n.length;r++){var o=function(e){return e instanceof t.Node?e:"string"==typeof e?[e]:(gd(e)?(function(e){yd(Array.isArray(e.fromFrames),"fromFrames property must be an array"),yd(e.fromFrames.every((function(e){return!Fd(e,"fromFrames")})),"Invalid context; fromFrames selector must be appended, rather than nested"),yd(!Fd(e,"fromShadowDom"),"fromFrames and fromShadowDom cannot be used on the same object")}(e),e=e.fromFrames):bd(e)&&(e=[e]),function(e){if(Array.isArray(e)){var t,n=[],a=Q(e);try{for(a.s();!(t=a.n()).done;){var r=t.value;if(bd(r)&&(function(e){yd(Array.isArray(e.fromShadowDom),"fromShadowDom property must be an array"),yd(e.fromShadowDom.every((function(e){return!Fd(e,"fromFrames")})),"shadow selector must be inside fromFrame instead"),yd(e.fromShadowDom.every((function(e){return!Fd(e,"fromShadowDom")})),"fromShadowDom selector must be appended, rather than nested")}(r),r=r.fromShadowDom),"string"!=typeof r&&!function(e){return Array.isArray(e)&&e.every((function(e){return"string"==typeof e}))}(r))return;n.push(r)}}catch(e){a.e(e)}finally{a.f()}return n}}(e))}(n[r]);o&&a.push(o)}return a}function md(e){return["include","exclude"].some((function(t){return Fd(e,t)&&hd(e[t])}))}function hd(e){return"string"==typeof e||e instanceof t.Node||gd(e)||bd(e)||vd(e)}function gd(e){return Fd(e,"fromFrames")}function bd(e){return Fd(e,"fromShadowDom")}function vd(e){return e&&"object"===r(e)&&"number"==typeof e.length&&e instanceof t.Node==0}function yd(e,t){yn(e,"Invalid context; ".concat(t,"\\nSee: https://github.com/dequelabs/axe-core/blob/master/doc/context.md"))}function Fd(e,t){return!(!e||"object"!==r(e))&&Object.prototype.hasOwnProperty.call(e,t)}function wd(e,n){for(var a=[],r=0,o=e[n].length;r<o;r++){var u=e[n][r];u instanceof t.Node?u.documentElement instanceof t.Node?a.push(e.flatTree[0]):a.push(Xn(u)):u&&u.length&&(1<u.length?function(e,t,n){e.frames=e.frames||[],bp(n.shift()).forEach((function(a){var r=e.frames.find((function(e){return e.node===a}));r||(r=fd(a,e),e.frames.push(r)),r[t].push(n)}))}(e,n,u):(u=bp(u[0]),a.push.apply(a,$(u.map((function(e){return Xn(e)}))))))}return a.filter((function(e){return e}))}function Ed(e,n){var o=this,u=(e=ea(e),this.frames=[],this.page="boolean"==typeof(null==(u=e)?void 0:u.page)?e.page:void 0,this.initiator="boolean"!=typeof(null==(u=e)?void 0:u.initiator)||e.initiator,this.focusable="boolean"!=typeof(null==(u=e)?void 0:u.focusable)||e.focusable,this.size="object"===r(null==(u=e)?void 0:u.size)?e.size:{},e=function(e){if(md(e)){var t=" must be used inside include or exclude. It should not be on the same object.";yd(!Fd(e,"fromFrames"),"fromFrames"+t),yd(!Fd(e,"fromShadowDom"),"fromShadowDom"+t)}else{if(!hd(e))return{include:[a],exclude:[]};e={include:e,exclude:[]}}return 0===(t=Dd(e.include)).length&&t.push(a),{include:t,exclude:e=Dd(e.exclude)}}(e),this.flatTree=null!=n?n:td(function(e){for(var n=e.include,r=(e=e.exclude,Array.from(n).concat(Array.from(e))),o=0;o<r.length;o++){var u=r[o];if(u instanceof t.Element)return u.ownerDocument.documentElement;if(u instanceof t.Document)return u.documentElement}return a.documentElement}(e)),this.exclude=e.exclude,this.include=e.include,this.include=wd(this,"include"),this.exclude=wd(this,"exclude"),mp("frame, iframe",this).forEach((function(e){var t;Md(e,o)&&(t=o,Pu(e=e.actualNode))&&!Ja(t.frames,"node",e)&&t.frames.push(fd(e,t))})),void 0===this.page&&(this.page=function(e){return 1===(e=e.include).length&&e[0].actualNode===a.documentElement}(this),this.frames.forEach((function(e){e.page=o.page}))),this);if(0===u.include.length&&0===u.frames.length)throw u=Ga.isInFrame()?"frame":"page",new Error("No elements found for include in "+u+" Context");Array.isArray(this.include)||(this.include=Array.from(this.include)),this.include.sort(jd)}function Cd(e){return!1===(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).iframes?[]:new Ed(e).frames.map((function(e){var t=e.node;return(e=V(e,b)).initiator=!1,{frameSelector:Gn(t),frameContext:e}}))}var xd=function(e){var t=o._audit.rules.find((function(t){return t.id===e}));if(t)return t;throw new Error("Cannot find rule by id: ".concat(e))};function Ad(e){var n,a,r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:0,o=e.scrollWidth>e.clientWidth+r;r=e.scrollHeight>e.clientHeight+r;if(o||r)return n=kd(a=t.getComputedStyle(e),"overflow-x"),a=kd(a,"overflow-y"),o&&n||r&&a?{elm:e,top:e.scrollTop,left:e.scrollLeft}:void 0}function kd(e,t){return e=e.getPropertyValue(t),["scroll","auto"].includes(e)}var Bd=function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:t,n=e.document.documentElement;return[void 0!==e.pageXOffset?{elm:e,top:e.pageYOffset,left:e.pageXOffset}:{elm:n,top:n.scrollTop,left:n.scrollLeft}].concat(function e(t){return Array.from(t.children||t.childNodes||[]).reduce((function(t,n){var a=Ad(n);return a&&t.push(a),t.concat(e(n))}),[])}(a.body))};function Td(){return ea(qo)}var Nd,Rd=function(e){if(e)return function(t){var n=t.data,a=void 0!==(a=t.isCrossOrigin)&&a,r=t.shadowId,o=t.root,u=t.priority,i=(t=void 0!==(t=t.isLink)&&t,e.createElement("style"));return t?(t=e.createTextNode(\'@import "\'.concat(n.href,\'"\')),i.appendChild(t)):i.appendChild(e.createTextNode(n)),e.head.appendChild(i),{sheet:i.sheet,isCrossOrigin:a,shadowId:r,root:o,priority:u}};throw new Error("axe.utils.getStyleSheetFactory should be invoked with an argument")},_d=function(e){var t;return Nd&&Nd.parentNode?(void 0===Nd.styleSheet?Nd.appendChild(a.createTextNode(e)):Nd.styleSheet.cssText+=e,Nd):e?(t=a.head||a.getElementsByTagName("head")[0],(Nd=a.createElement("style")).type="text/css",void 0===Nd.styleSheet?Nd.appendChild(a.createTextNode(e)):Nd.styleSheet.cssText=e,t.appendChild(Nd),Nd):void 0},Od=function e(n,a){var r,o=Xn(n);return 9!==n.nodeType&&(11===n.nodeType&&(n=n.host),o&&null!==o._isHidden?o._isHidden:!(r=t.getComputedStyle(n,null))||!n.parentNode||"none"===r.getPropertyValue("display")||!a&&"hidden"===r.getPropertyValue("visibility")||"true"===n.getAttribute("aria-hidden")||(a=e(n.assignedSlot||n.parentNode,!0),o&&(o._isHidden=a),a))},Sd=function(e){var t=null!=(t=null==(t=e.props)?void 0:t.nodeName)?t:e.nodeName.toLowerCase();return"http://www.w3.org/2000/svg"!==e.namespaceURI&&!!qo.htmlElms[t]};function Md(e,t){var n=void 0===(n=t.include)?[]:n;t=void 0===(t=t.exclude)?[]:t,n=n.filter((function(t){return nr(t,e)}));return 0!==n.length&&(0===(t=t.filter((function(t){return nr(t,e)}))).length||(n=Pd(n),nr(Pd(t),n)))}function Pd(e){var t,n,a=Q(e);try{for(a.s();!(n=a.n()).done;){var r=n.value;t&&nr(r,t)||(t=r)}}catch(e){a.e(e)}finally{a.f()}return t}var Id=function(e,t){return e.length===t.length&&e.every((function(e,n){var a=t[n];return Array.isArray(e)?e.length===a.length&&e.every((function(e,t){return a[t]===e})):e===a}))},jd=function(e,t){return(e=e.actualNode||e)===(t=t.actualNode||t)?0:4&e.compareDocumentPosition(t)?-1:1};function Ld(e){return e instanceof on?{vNode:e,domNode:e.actualNode}:{vNode:Xn(e),domNode:e}}var qd,zd,Vd=function(e,t,n,a){var r,o=4<arguments.length&&void 0!==arguments[4]&&arguments[4],u=Array.from(e.cssRules);return u?(r=u.filter((function(e){return 3===e.type}))).length?(r=r.filter((function(e){return e.href})).map((function(e){return e.href})).filter((function(e){return!a.includes(e)})).map((function(e,r){r=[].concat($(n),[r]);var o=/^https?:\\/\\/|^\\/\\//i.test(e);return Hd(e,t,r,a,o)})),(u=u.filter((function(e){return 3!==e.type}))).length&&r.push(Promise.resolve(t.convertDataToStylesheet({data:u.map((function(e){return e.cssText})).join(),isCrossOrigin:o,priority:n,root:t.rootNode,shadowId:t.shadowId}))),Promise.all(r)):Promise.resolve({isCrossOrigin:o,priority:n,root:t.rootNode,shadowId:t.shadowId,sheet:e}):Promise.resolve()},$d=function(e,t,n,a){var r=4<arguments.length&&void 0!==arguments[4]&&arguments[4];return function(e){try{return!(!e.cssRules&&e.href)}catch(e){return!1}}(e)?Vd(e,t,n,a,r):Hd(e.href,t,n,a,!0)},Hd=function(e,n,a,r,o){return r.push(e),new Promise((function(n,a){var r=new t.XMLHttpRequest;r.open("GET",e),r.timeout=tn.preload.timeout,r.addEventListener("error",a),r.addEventListener("timeout",a),r.addEventListener("loadend",(function(e){if(e.loaded&&r.responseText)return n(r.responseText);a(r.responseText)})),r.send()})).then((function(e){return e=n.convertDataToStylesheet({data:e,isCrossOrigin:o,priority:a,root:n.rootNode,shadowId:n.shadowId}),$d(e.sheet,n,a,r,e.isCrossOrigin)}))};function Ud(){if(t.performance&&t.performance)return t.performance.now()}qd=null,zd=Ud();var Gd,Wd,Yd={start:function(){this.mark("mark_axe_start")},end:function(){this.mark("mark_axe_end"),this.measure("axe","mark_axe_start","mark_axe_end"),this.logMeasures("axe")},auditStart:function(){this.mark("mark_audit_start")},auditEnd:function(){this.mark("mark_audit_end"),this.measure("audit_start_to_end","mark_audit_start","mark_audit_end"),this.logMeasures()},mark:function(e){t.performance&&void 0!==t.performance.mark&&t.performance.mark(e)},measure:function(e,n,a){t.performance&&void 0!==t.performance.measure&&t.performance.measure(e,n,a)},logMeasures:function(e){function n(e){nn("Measure "+e.name+" took "+e.duration+"ms")}if(t.performance&&void 0!==t.performance.getEntriesByType)for(var a=t.performance.getEntriesByName("mark_axe_start")[0],r=t.performance.getEntriesByType("measure").filter((function(e){return e.startTime>=a.startTime})),o=0;o<r.length;++o){var u=r[o];if(u.name===e)return void n(u);n(u)}},timeElapsed:function(){return Ud()-zd},reset:function(){qd=qd||Ud(),zd=Ud()}};function Kd(){var e,t,n,r;return a.elementsFromPoint||a.msElementsFromPoint||((e=a.createElement("x")).style.cssText="pointer-events:auto",e="auto"===e.style.pointerEvents,t=e?"pointer-events":"visibility",n=e?"none":"hidden",(r=a.createElement("style")).innerHTML=e?"* { pointer-events: all }":"* { visibility: visible }",function(e,o){var u,i,l,s=[],c=[];for(a.head.appendChild(r);(u=a.elementFromPoint(e,o))&&-1===s.indexOf(u);)s.push(u),c.push({value:u.style.getPropertyValue(t),priority:u.style.getPropertyPriority(t)}),u.style.setProperty(t,n,"important");for(s.indexOf(a.documentElement)<s.length-1&&(s.splice(s.indexOf(a.documentElement),1),s.push(a.documentElement)),i=c.length;l=c[--i];)s[i].style.setProperty(t,l.value||"",l.priority);return a.head.removeChild(r),s})}function Xd(e){return"function"==typeof e||"[object Function]"===Gd.call(e)}"function"!=typeof Object.assign&&(Object.assign=function(e){if(null==e)throw new TypeError("Cannot convert undefined or null to object");for(var t=Object(e),n=1;n<arguments.length;n++){var a=arguments[n];if(null!=a)for(var r in a)a.hasOwnProperty(r)&&(t[r]=a[r])}return t}),Array.prototype.find||Object.defineProperty(Array.prototype,"find",{value:function(e){if(null===this)throw new TypeError("Array.prototype.find called on null or undefined");if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var t,n=Object(this),a=n.length>>>0,r=arguments[1],o=0;o<a;o++)if(t=n[o],e.call(r,t,o,n))return t}}),Array.prototype.findIndex||Object.defineProperty(Array.prototype,"findIndex",{value:function(e,t){if(null===this)throw new TypeError("Array.prototype.find called on null or undefined");if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var n,a=Object(this),r=a.length>>>0,o=0;o<r;o++)if(n=a[o],e.call(t,n,o,a))return o;return-1}}),"function"==typeof t.addEventListener&&(a.elementsFromPoint=Kd()),Array.prototype.includes||Object.defineProperty(Array.prototype,"includes",{value:function(e){var t=Object(this),n=parseInt(t.length,10)||0;if(0!==n){var a,r,o=parseInt(arguments[1],10)||0;for(0<=o?a=o:(a=n+o)<0&&(a=0);a<n;){if(e===(r=t[a])||e!=e&&r!=r)return!0;a++}}return!1}}),Array.prototype.some||Object.defineProperty(Array.prototype,"some",{value:function(e){if(null==this)throw new TypeError("Array.prototype.some called on null or undefined");if("function"!=typeof e)throw new TypeError;for(var t=Object(this),n=t.length>>>0,a=2<=arguments.length?arguments[1]:void 0,r=0;r<n;r++)if(r in t&&e.call(a,t[r],r,t))return!0;return!1}}),Array.from||Object.defineProperty(Array,"from",{value:(Gd=Object.prototype.toString,Wd=Math.pow(2,53)-1,function(e){var t=Object(e);if(null==e)throw new TypeError("Array.from requires an array-like object - not null or undefined");var n,a=1<arguments.length?arguments[1]:void 0;if(void 0!==a){if(!Xd(a))throw new TypeError("Array.from: when provided, the second argument must be a function");2<arguments.length&&(n=arguments[2])}for(var r,o=function(e){return e=function(e){return e=Number(e),isNaN(e)?0:0!==e&&isFinite(e)?(0<e?1:-1)*Math.floor(Math.abs(e)):e}(e),Math.min(Math.max(e,0),Wd)}(t.length),u=Xd(this)?Object(new this(o)):new Array(o),i=0;i<o;)r=t[i],u[i]=a?void 0===n?a(r,i):a.call(n,r,i):r,i+=1;return u.length=o,u})}),String.prototype.includes||(String.prototype.includes=function(e,t){return!((t="number"!=typeof t?0:t)+e.length>this.length)&&-1!==this.indexOf(e,t)}),Array.prototype.flat||Object.defineProperty(Array.prototype,"flat",{configurable:!0,value:function e(){var t=isNaN(arguments[0])?1:Number(arguments[0]);return t?Array.prototype.reduce.call(this,(function(n,a){return Array.isArray(a)?n.push.apply(n,e.call(a,t-1)):n.push(a),n}),[]):Array.prototype.slice.call(this)},writable:!0}),!t.Node||"isConnected"in t.Node.prototype||Object.defineProperty(t.Node.prototype,"isConnected",{get:function(){return!(this.ownerDocument&&this.ownerDocument.compareDocumentPosition(this)&this.DOCUMENT_POSITION_DISCONNECTED)}});var Zd=function(e,t){return e.concat(t).filter((function(e,t,n){return n.indexOf(e)===t}))};function Jd(e,t,n,a,r){return(r=r||{}).vNodes=e,r.vNodesIndex=0,r.anyLevel=t,r.thisLevel=n,r.parentShadowId=a,r}var Qd=[],ep=function(e,t,n){if(a=Yc(e=Array.isArray(e)?e:[e],t=ia(t),n))return a;for(var a=e,r=(e=t,n),o=[],u=Jd(Array.isArray(a)?a:[a],e,null,a[0].shadowId,Qd.pop()),i=[];u.vNodesIndex<u.vNodes.length;){for(var l,s=u.vNodes[u.vNodesIndex++],c=null,d=null,p=((null==(l=u.anyLevel)?void 0:l.length)||0)+((null==(l=u.thisLevel)?void 0:l.length)||0),f=!1,D=0;D<p;D++){var m=D<((null==(m=u.anyLevel)?void 0:m.length)||0)?u.anyLevel[D]:u.thisLevel[D-((null==(m=u.anyLevel)?void 0:m.length)||0)];if((!m[0].id||s.shadowId===u.parentShadowId)&&la(s,m[0]))if(1===m.length)f||r&&!r(s)||(i.push(s),f=!0);else{var h=m.slice(1);if(!1===[" ",">"].includes(h[0].combinator))throw new Error("axe.utils.querySelectorAll does not support the combinator: "+m[1].combinator);(">"===h[0].combinator?c=c||[]:d=d||[]).push(h)}m[0].id&&s.shadowId!==u.parentShadowId||null==(h=u.anyLevel)||!h.includes(m)||(d=d||[]).push(m)}for(s.children&&s.children.length&&(o.push(u),u=Jd(s.children,d,c,s.shadowId,Qd.pop()));u.vNodesIndex===u.vNodes.length&&o.length;)Qd.push(u),u=o.pop()}return i},tp=function(e){var t,n,r,u;e=void 0===(e=e.treeRoot)?o._tree[0]:e;return t=[],e=ep(e,"*",(function(e){return!t.includes(e.shadowId)&&(t.push(e.shadowId),!0)})).map((function(e){return{shadowId:e.shadowId,rootNode:lr(e.actualNode)}})),(e=Zd(e,[])).length?(n=a.implementation.createHTMLDocument("Dynamic document for loading cssom"),n=Rd(n),r=n,u=[],e.forEach((function(e,t){var n=e.rootNode,a=function(e,t,n){return t=11===e.nodeType&&t?function(e,t){return Array.from(e.children).filter(np).reduce((function(n,a){var r=a.nodeName.toUpperCase();a="STYLE"===r?a.textContent:a,a=t({data:a,isLink:"LINK"===r,root:e});return n.push(a.sheet),n}),[])}(e,n):function(e){return Array.from(e.styleSheets).filter((function(e){return!!e.media&&ap(e.media.mediaText)}))}(e),function(e){var t=[];return e.filter((function(e){if(e.href){if(t.includes(e.href))return!1;t.push(e.href)}return!0}))}(t)}(n,e=e.shadowId,r);if(!a)return Promise.all(u);var o=t+1,i={rootNode:n,shadowId:e,convertDataToStylesheet:r,rootIndex:o},l=[];t=Promise.all(a.map((function(e,t){return $d(e,i,[o,t],l)})));u.push(t)})),Promise.all(u).then((function e(t){return t.reduce((function(t,n){return Array.isArray(n)?t.concat(e(n)):t.concat(n)}),[])}))):Promise.resolve()};function np(e){var t=e.nodeName.toUpperCase(),n=e.getAttribute("href"),a=e.getAttribute("rel");n="LINK"===t&&n&&a&&e.rel.toUpperCase().includes("STYLESHEET");return"STYLE"===t||n&&ap(e.media)}function ap(e){return!e||!e.toUpperCase().includes("PRINT")}var rp=function(e){return e=void 0===(e=e.treeRoot)?o._tree[0]:e,e=ep(e,"video, audio",(function(e){return(e=e.actualNode).hasAttribute("src")?!!e.getAttribute("src"):!(Array.from(e.getElementsByTagName("source")).filter((function(e){return!!e.getAttribute("src")})).length<=0)})),Promise.all(e.map((function(e){var t;e=e.actualNode;return t=e,new Promise((function(e){0<t.readyState&&e(t),t.addEventListener("loadedmetadata",(function n(){t.removeEventListener("loadedmetadata",n),e(t)}))}))})))};function op(e){return!e||void 0===e.preload||null===e.preload||("boolean"==typeof e.preload?e.preload:(e=e.preload,"object"===r(e)&&Array.isArray(e.assets)))}function up(e){var t=(n=tn.preload).assets,n=n.timeout;n={assets:t,timeout:n};if(e.preload&&"boolean"!=typeof e.preload){if(!e.preload.assets.every((function(e){return t.includes(e.toLowerCase())})))throw new Error("Requested assets, not supported. Supported assets are: ".concat(t.join(", "),"."));n.assets=Zd(e.preload.assets.map((function(e){return e.toLowerCase()})),[]),e.preload.timeout&&"number"==typeof e.preload.timeout&&!isNaN(e.preload.timeout)&&(n.timeout=e.preload.timeout)}return n}var ip=function(e){var t={cssom:tp,media:rp};return op(e)?new Promise((function(n,a){var r=(o=up(e)).assets,o=o.timeout,u=setTimeout((function(){return a(new Error("Preload assets timed out."))}),o);Promise.all(r.map((function(n){return t[n](e).then((function(e){return t={},(a=J(a=n))in t?Object.defineProperty(t,a,{value:e,enumerable:!0,configurable:!0,writable:!0}):t[a]=e,t;var t,a}))}))).then((function(e){e=e.reduce((function(e,t){return U({},e,t)}),{}),clearTimeout(u),n(e)})).catch((function(e){clearTimeout(u),a(e)}))})):Promise.resolve()};function lp(e,t,n){return function(a){var o,u=(o=e[a.id]||{}).messages||{};delete(o=Object.assign({},o)).messages,n.reviewOnFail||void 0!==a.result?o.message=a.result===t?u.pass:u.fail:("object"!==r(u.incomplete)||Array.isArray(a.data)||(o.message=function(e,t){function n(e){return e.incomplete&&e.incomplete.default?e.incomplete.default:rd()}if(!e||!e.missingData)return e&&e.messageKey?t.incomplete[e.messageKey]:n(t);try{var a=t.incomplete[e.missingData[0].reason];if(a)return a;throw new Error}catch(a){return"string"==typeof e.missingData?t.incomplete[e.missingData]:n(t)}}(a.data,u)),o.message||(o.message=u.incomplete)),"function"!=typeof o.message&&(o.message=sd(o.message,a.data)),rr(a,o)}}var sp=function(e){var t=o._audit.data.checks||{},n=o._audit.data.rules||{},a=Ja(o._audit.rules,"id",e.id)||{},r=(e.tags=ea(a.tags||[]),lp(t,!0,a)),u=lp(t,!1,a);e.nodes.forEach((function(e){e.any.forEach(r),e.all.forEach(r),e.none.forEach(u)})),rr(e,ea(n[e.id]||{}))},cp=function(e,t){return ep(e,t)};function dp(e,t){var n,a=o._audit&&o._audit.tagExclude?o._audit.tagExclude:[],r=t.hasOwnProperty("include")||t.hasOwnProperty("exclude")?(n=t.include||[],n=Array.isArray(n)?n:[n],r=t.exclude||[],(r=Array.isArray(r)?r:[r]).concat(a.filter((function(e){return-1===n.indexOf(e)})))):(n=Array.isArray(t)?t:[t],a.filter((function(e){return-1===n.indexOf(e)})));return!!(n.some((function(t){return-1!==e.tags.indexOf(t)}))||0===n.length&&!1!==e.enabled)&&r.every((function(t){return-1===e.tags.indexOf(t)}))}var pp=function(e,t,n){var a=n.runOnly||{};n=(n.rules||{})[e.id];return!(e.pageLevel&&!t.page)&&("rule"===a.type?-1!==a.values.indexOf(e.id):n&&"boolean"==typeof n.enabled?n.enabled:"tag"===a.type&&a.values?dp(e,a.values):dp(e,[]))};function fp(e,t){var n,a,r;return t?(r=e.cloneNode(!1),n=Bn(r),r=1===r.nodeType?(a=r.outerHTML,Kn.get(a,(function(){return Dp(r,n,e,t)}))):Dp(r,n,e,t),Array.from(e.childNodes).forEach((function(e){r.appendChild(fp(e,t))})),r):e}function Dp(e,t,n,r){return t&&(e=a.createElement(e.nodeName),Array.from(t).forEach((function(t){var a,o,u;a=n,o=t.name,void 0!==(u=r)[o]&&(!0===u[o]||Tn(a,u[o]))||e.setAttribute(t.name,t.value)}))),e}function mp(e,t){var n=[];if(o._selectCache)for(var a=0,r=o._selectCache.length;a<r;a++){var u=o._selectCache[a];if(u.selector===e)return u.result}for(var i,l=t.include.reduce((function(e,t){return e.length&&nr(e[e.length-1],t)||e.push(t),e}),[]),s=(i=t).exclude&&0!==i.exclude.length?function(e){return Md(e,i)}:null,c=0;c<l.length;c++){var d=l[c];n=function(e,t){if(0===e.length)return t;var n;e.length<t.length&&(n=e,e=t,t=n);for(var a=0,r=t.length;a<r;a++)e.includes(t[a])||e.push(t[a]);return e}(n,ep(d,e,s))}return o._selectCache&&o._selectCache.push({selector:e,result:n}),n}var hp=function(e){e.forEach((function(e){var n=e.elm,a=e.top;e=e.left;if(n===t)return n.scroll(e,a);n.scrollTop=a,n.scrollLeft=e}))};function gp(e){return function e(t,n){var a=t.shift();return n=a?n.querySelector(a):null,0===t.length?n:null!=n&&n.shadowRoot?e(t,n.shadowRoot):null}(Array.isArray(e)?$(e):[e],a)}function bp(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:a,n=Array.isArray(e)?$(e):[e];return 0===e.length?[]:function e(t,n){t=function(e){return Y(e)||H(e)||ee(e)||W()}(t);var a=t[0],r=t.slice(1);if(t=n.querySelectorAll(a),0===r.length)return Array.from(t);var o,u=[],i=Q(t);try{for(i.s();!(o=i.n()).done;){var l=o.value;null!=l&&l.shadowRoot&&u.push.apply(u,$(e(r,l.shadowRoot)))}}catch(e){i.e(e)}finally{i.f()}return u}(n,t)}var vp=function(){return["hidden","text","search","tel","url","email","password","date","month","week","time","datetime-local","number","range","color","checkbox","radio","file","submit","image","reset","button"]},yp=[,[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,,,,,1,1,1,1,,,1,1,1,,1,,1,,1,1],[1,1,1,,1,1,,1,1,1,,1,,,1,1,1,,,1,1,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,,,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1],[,1,,,,,,1,,1,,,,,1,,1,,,,1,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,,,1,,,,,1,1,1,,1,,1,,1,,,,,,1],[1,,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,,1,,1,,,,,1,,1,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,,1,1,1,,1,,1,1,1,,,1,1,1,1,1,1,1,1],[,,1,,,1,,1,,,,1,1,1,,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1,1,1,1,1,,,1,1,1],[1,1,1,1,1,,,1,,,1,,,1,1,1,,,,,1,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1],[,1,,1,1,1,,1,1,,1,,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,,,1,1,1,,,1,1,,,,,,1,1],[1,1,1,,,,,1,,,,1,1,,1,,,,,,1,,,,,1],[,1,,,1,,,1,,,,,,1],[,1,,1,,,,1,,,,1],[1,,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,,1,,,1,1,1,1],[,1,1,1,1,1,,,1,,,1,,1,1,,1,,1,,,,,1,,1],[,1,,,,1,,,1,1,,1,,1,1,1,1,,1,1,,,1,,,1],[,1,1,,,,,,1,,,,1,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,,1,1,1,,,1,1,1,1,1,1,,1,,,,,1,1,,1,,1],[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,1,1],[,1,1,1,,,,1,1,1,,1,1,,,1,1,,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,,1,,,,,1,1,1,,,1,,1,,,1,1],[,,,,1,,,,,,,,,,,,,,,,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,,1,1,1,,1,1,,,,1,1,1,1,1,,,1,1,1,,,,,1],[1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,1,,,,,,,1],[,1,1,,1,1,,1,,,,,,,,,,,,,1],,[1,1,1,,,,,,,,,,,,,1],[,,,,,,,,1,,,1,,,1,1,,,,,1]],[,[1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,,1],[,,,1,,,,,,,,,,,,,,,1],[,1,,,1,1,,1,,1,1,,,,1,1,,,1,1,,,,1],[1,,,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,,,,1],,[,1,1,1,1,1,,1,1,1,,1,1,,1,1,,,1,1,1,1,,1,1,,1],[,1,,,1,,,1,,1,,,1,1,1,1,,,1,1,,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,,,1,1,1,1,1,1,1,,,1,,,1,,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,,,,1],[,,,,,,,1,,,,1,,1,1],[,1,1,1,1,1,1,1,,,,1,1,1,1,1,,,1,1,,1,1,1,1,1],[,1,,,1,1,,1,,1,1,1,,,1,1,,,1,,1,1,1,1,,1],[,1,1,1,,1,1,,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1],[,,,,,,,,,,,,,,,,1],,[,1,1,1,1,1,,1,1,1,,,1,,1,1,,1,1,1,1,1,,1,,1],[,,1,,,1,,,1,1,,,1,,1,1,,1],[,1,1,,1,,,,1,1,,1,,1,1,1,1,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,1,,1,,1,1],,[,1,1,,1,,,1,,1,,,,1,1,1,,,,,,1,,,,1],[1,1,,,1,1,,1,,,,,1,,1]],[,[,1],[,,,1,,,,1,,,,1,,,,1,,,1,,,1],[,,,,,,,,,,,,,,,,,,1,1,,,,,,1],,[1,,,,,1],[,1,,,,1,,,,1],[,1,,,,,,,,,,,1,,,1,,,,,,,,,1,1],[,,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,1,,1],[,1],[,1,,1,,1,,1,,1,,1,1,1,,1,1,,1,,,,,,,1],[1,,,,,1,,,1,1,,1,,1,,1,1,,,,,1,,,1],[,1,1,,,1,,1,,1,,1,,1,1,1,1,,,1,,1,,1,1,1],[1,1,1,1,1,,1,,1,,,,1,1,1,1,,1,1,,,1,1,1,1],[1,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],,[,1,,,,,,1,1,1,,1,,,,1,,,1,1,1,,,1],[1,,,,,1,,1,1,1,,1,1,1,1,1,,1,,1,,1,,,1,1],[1,,1,1,,,,,1,,,,,,1,1,,,1,1,1,1,,,1,,1],[1,,,,,,,,,,,,,,,,,1],[,,,,,1,,,1,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,,,1],[,1,,,,1]],[,[1,1,1,,1,,1,1,1,1,1,1,1,1,1,,1,,1,,1,1,,,1,1,1],[,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],,[,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1],,[1,1,,,,1,1,,,,,,1,,,,1,,1,,1,1,,1],[1],[,,,,,,,,,,,1,,,,,,,,,,,1],[,1,,,,,,,1,1,,,1,,1,,,,1,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,,1],[,,1,,,,,1,,1],[1,,,,1,,,,,1,,,,1,1,,,,1,1,,,,,1],[,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[1,,,1,1,,,,,,,1,,1,,1,1,1,1,1,1],[,,,,,1,,,,,,,1,,,,,,,1],,[,,1,1,1,1,1,,1,1,1,,,1,1,,,1,1,,1,1,1,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,,,,1],,[1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,,,1,1,1,1,,,,,,1,,1,,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,,,,1,,1,,,1,1,1,1,1],[,,,,,,,,,,,1,,,,,,,,,1,,,,1],[,1,1,,1,1,,1,,,,1,1,,1,1,,,1,,1,1,,1],[,1,,1,,1,,,1,,,1,1,,1,1,,,1,1,1],[,1,1,1,1,1,,1,1,,,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,,,,,,,,,1,,1,,1,1,,,,1,,,1],[,1,,,1,1,,,,,,,,,1,1,1,,,,,1],[1,,,1,1,,,,1,1,1,1,1,,,1,,,1,,,1,,1,,1],[,1,1,,1,1,,1,1,,,,1,1,1,,,1,1,,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,,,,1,,,,,,,,,1],[,1,,,,,,,,1,,,,,1,,,,1,,,1],[,1,1,1,1,,,1,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1],[,,,,,1,,1,,,,,1,1,1,1,1,,,1,,,,1],[,1,,,,,,,,1,,,,,,,,,,,,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,1,,,,1,,1,1,1,1,1,,1,1,,,,,,1],[,1,1,1,1,1,1,1,,1,1,,,1,1,,,,1,,1,1,,1,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,1,1,,1,,,1,1,1,1,,,1,,,,,,,1],[,1,,,,,,,,1,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1],[,1,1,,,,,,,,,,,,1,1,,,,,,1],[,1,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,,,,,1],[1,1,,,1,,,1,1,1,,,,1],,[,,,,,,,,,,,,,1,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,1,,,,,,,1],[1,1,1,,1,,1,1,1,1,1,1,1,1,,1,,,1,,1,,,1,1],[,,,,,,,,,1],[,1,,,,1,,,,,,1,,,1,,,,,1],[,1,1,,1,1,,,,,,,,,,,,,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,1,1,1,,,,1,1,,,,1,,1],[1,1,1,1,1,1,,,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,,1,1],[,,,,,,,,,,,,,,,1,,,,1],,[1,1,,1,,1,,,,,,1,,1,,1,1,,1,,1,1,,1,1,,1],[,,1,,,,,,1,,,,1,,1,,,,,1],[1,,,,,,,,,1,,,,,,1,,,,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,,1,,,,,,1,,,1,,,,,,,,1],[,1,,1,,,,,,,,,,,,1],,[1,1,,,,,,,,,,,,,,,,,,,,,,1,1],[1]],[,[1,,,,,,,,,1,,,,,1,,1,,1],[,1,1,,1,1,,1,1,1,,,1,1,1,,,,1,,,1,,,,1],[,1,,,,,,,1,,,,1,,,,,,1],[1,1,1,1,1,1,,,,1,,,,,,,,,1,1,1,1],[1],[,1,1,,,1,1,,,,,1,,1,,,,,,,,1,,,,1],[1,,1,,,1,,1,,,,,1,1,1,1,,,,1,,,,1],[,,1,,,,,,,1,,,,,,,1,,,,,,,1],[1,,,,,,,,,,,,,,1,,,,1],[,,,1,,1,,,,,1,,,,1,1,,,,1],[1,,,,,1,,,,1,,1,1,,,1,1,,1,1,1,,1,1,1,,1],[,1,1,,,,,1,,1,,1,1,1,,1,1,,,1,,1,1,1],[,1,,,,1,,,,1,,,1,,1,1,,,1,1,,,,,,1],[1,,1,1,,1,,1,1,,1,,1,1,1,1,1,,,1,1,,,,,,1],[1,,,,,,,,,,,,,,,,,,1,,,1,,1],[,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,,1,,1],[,1,,,,1,,,1,1,,1,,,1,1,,,1,,,1,,,1,1],[1,1,,1,1,1,,1,1,1,,1,,1,1,1,,,1,,1,1],[1,,1,1,1,1,,,,1,,1,1,1,,1,,,1,1,1,,1,1,1,1,1],[1,,,,,,,,,,,,,1],[,,1,,,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,,,1,,1,,1,,,,1],[,,,1,,,,,,,,,1],[,1,,,,,,,,,,,,,,1,,,,,,,,,1],[,,,,,,,,1,1,,,,,,,,,1,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,,,1,1,1],[,,,,,1,,,,1,1,1,,,1,1,,,1,,1,1,,1],[,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,1,,,,,,,,,,,,,1],[,,1,,,1,,1,1,1,,1,1,,1,,,,1,,1,1],,[,,1,,,1,,,,,,1,,,,1],[,,,,,,,,,1,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,,1,1,,1,,1,,,1,1,1,,,1],[,,,,,1,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,1,,1,1,,1,,,1],[,,,,,1,,,,,,,,,,,,,,1],[,1,1,1,1,,,,,1,,,1,,1,,,,1,1,,,,1,1],[,1,,,1,,,1,,1,1,,1,,,,,,,1],[,,1,,1,,,1,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,,,,,,,,,,1,,1,1],[,,,,,,,,,,,,1],,[,1,1,1,1,,,,1,1,,1,1,1,1,1,1,,1,1,1,1,,1,,1],[1,,,,1,,,,,,,,,,1],[1,,,,,,,,,1],,[,1,,,,1,,,,,,,,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,,1,,,,1,1,,,1,1,,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,1],[1,1,1,,,,,1,1,1,,1,1,1,1,,,1,1,,1,1,,,,,1],[,1,,,,,,,1,1,,,1,1,1,,1,,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,,,1,,,,1,,,1,,,,1,,,,,,,1,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1],[1,1,1,,1,,,1,1,1,1,,1,1,1,1,,,,1,,1,,1,,,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,,1,1,,,,,,,,,1],,[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,,1,,1,,,,1],[,1,,,1,1,,1,1,1,,,1,1,1,1,1,,1,1,1,,1,,,1],[1,,,1,,,,1,1,1,,,,,1,1,,,,1,,1],[1,1,,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,,1,,1,,,,,,,,1,,1],[,1,,,,1,,1,1,,,,1,1,,1,,,,1,1,1,,1],,[,1,,,,,,1,,,,,,,1],[,,,,,,,,1,,,,1,,1,,,,,,,,,,,,1]],[,[,1,1,,1,1,1,1,,1,1,1,,1,1,,1,1,,1,1,1,1,1,1,,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,,,1,,,,,,,,1,,,,,,1,,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,,1,,1,1,1,1,1,1,1,,1,1,,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1],[,1,1,,,,,1,1,1,,,1,,1,1,,,,1,,1,,,1,1],[,,,,,,,1,,,,1,1,1,1,1,,1,,,,,,,,1],[1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,,1,,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,1,1,,1,,1,1,1,,1,,1,1,,1,1,,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,,1,,,,,1,,1],[,1,1,1,,1,,1,,1,,,,1,,1,,,1,,,,,,1,1],[,1,,,1,1,,1,,1,,1,1,1,1,1,,1,1,,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,,1,,1,,1,,,,,,1,,1,,,,1,1]],[,[,1,,1,,,,,,,,,,,,,,,1,,,,1],[,,,,,,,,,1,,1,1,1,,1,,,1,,1,1],[1,1,,,,,,,1,,,,,,,1,,,,,,1],[,1,,,,,,,,,,1,,,,,,,,,1,1],,[,,,,,,,,,,,,,,,1,,,,1,,1],[,,1,1,,1,,1,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,,,,,,,,1],[1,,1,1,,,,1,,,,,,,,,1,,,1,,,1,1],[,1,1,,1,1,,1,1,1,1,1,1,1,1,1,,,1,1,,1,1,,1],[,1,,,1,1,,,,,,1,,1,,1,,,1,,1,1],[1,1,1,1,,1,,1,,1,,1,1,,1,1,1,1,1,,1,1,1,1,1],[,1,1,,,1,,1,,1,1,1,,,1,1,1,,1,1,1,1,,1,1],[,,,,1,,,1,,,,,,,1,,,,1,1],[,1,,,,,,,,,,1,,1,,1,,,,,1,,,,,1],,[1,1,,1,,1,,1,1,,,,,,1,1,,,1,1,1,1,1,1,1,1,1],[1,1,,1,,,,,,1,,,,,,1,1,,,,1,1,,,1],[,1,1,,1,1,,,,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,,,1,,,,1,,,,1,1],[,,,,1],[,,,,,,,,,1,,,1],,[,,1,,1,,,,,,,,,1,,,,,,,,,,,,1],[,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,,,1],[,1,,1,,,,,,1,,,,,1,1,,,,,1,1],[,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,,,1,,1,1,1],[,1,,,,1,,,,,,,1],[,1,,,1,,,1,,1,,1,1,,1,,,,,1,,1,,,,1,1],[,1,,,1,,,1,1,1,,1,1,1,1,1,,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,1,1,,,,1,1,,,,,,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,,1,1,,1,1,1,1,1],[,1,,,,1,,,,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,1,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,,1,1,1,,1,1,1,,,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,,,,,,,1,1,,,,,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,1,,1,1,1,1],,[,1,1,,,,,1,,1,,,,1,1,1,,,1,,,,,1],[,,,,,,,,,,,,,1],[,,,,,1,,,,,,,,1,1,,,,,1,,1,,,1,1],[,,,,,,,,,,,,,,1]],[,[,1],,,,,,,,,,,,,,,,,,,,[1,1,1,1,1,,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,1,1,1,1],[,1,,1,,1,,,1,1,1,,1,1,1,1,1,,,1,,,,1,,1,1],[,1,,1,,1,,,1,,,,,1,,,,,,1,1],[,1,,1,,,,,1,,,,1,,1,1,1,1,1,1,1,1,,1],[,1,,,,,,,,,,,,,,,1]],[,[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,,,,,,,,,1,1,,,,1],[,,,,,,1],[,,1],[,1,1,,,1,,1,,1,1,,1,1,1,,,,1,1,1,,,,,1],,[,1,,,,1,,,,,,1,,,1,,,,1,1,,1],[,,,,,,,1,,,,,,,,,1],[,1,,,,1,1,,,,,,1,1,1,,,,1,,1,1],[,,,,,,,1,,1,,,,,,,,,,1],[,1,1,,,,,,1,1,,,,1,,,,,,,1,,,1],,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,,1,,,1,,,,,1,,1,,1,,1,,,,,1],[1,1,1,1,1,1,1,1,,,,,1,1,,1,1,,1,,,1,,1],[,,,,,,,,,,,,,,1,,,,,,1],,[,,,,,,,,,1,,,,,,1,,,,,1],[,,1,,,,,,,1,,,1,1],[,,,1,,,,,1,,,,,1,,,,,,1,,,,1],[1,,1,1,,1,1,1,1,1,,1,,,,1,1,1,,,1,1,,,,1,1],,[1,1,,,,,,,,,,1,,1,,1,,,1],[,,,,1,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,1],[,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,,1,,,1,,,,,,,,1,,,,,,1,,,,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,1,,,,1,1,1,1,1,1,,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,1,,1,1,,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,,1,,1,,1,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,,,,,,1,,1,,,,,1,1,,,,,1],[1,,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,,1,,,,1,1,1,1,1,,,1,1,,1,,1],[,1,1,1,1,,,,,1,,1,1,1,1,1,,,1,1,,,,1,1,1],[,1,1,1,1,1,,1,,,,,1,,1,,1,,,1,,,1,1,,1]],[,[1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,,,,,1,,,,,1,1,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,,,,1,,1,1,,1,1,1,1,1,,,1,,1,,1],[1,1,1,,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,,1,,,,,,,,,,1,1,1,1,1,1,1,,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,1,1,,,,,,1,1,1,1,1,,,,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,,1,1,1],[,1,1,1,,1,,1,1,1,1,,,1,1,1,,1,1,1,1,1,,,1,1],[1,1,,,,1,,,1,1,1,,1,,1,,1,,1,1,1,1,1,,1,,1],[,1,,,,,,,1,,1,,1,1,1,1,,,,,,,,,1]],[,[,,,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,1,,,1,,,,,,1,,,1,,,,1],,[,1,,,,1,,1,,1,1,,1,1,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],[1,1,1,,,1,,,,,,,,,1,1,,,,,,,,,,1],[,1,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1,,,1],[,,,,,,,,,1],[1,1,,,,,,1,1,1,,1,1,,,,1,1,,1,,1,1,1,,1],[,1,1,1,,1,1,,,1,,1,1,1,1,,,,,,,1,,1],[,1,1,1,1,,,1,,1,,,,1,1,1,1,,1,1,,1],[,1,,,1,1,,1,,,,1,,1,1,,1,,1,,,1,,,1,,1],[,,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,,,,,1],,[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1],[,1,,,,,,,1,1,,1,,,,,1,,,1,,1],[,1,,,,1,,,1,,,,,,,,1,,1,,,1],[,,,,,,,,,,,,,1,1,,,,1,,,1],[,,,,,1,,,1,,,,1],[,1],,[,1],[1,,,,,,,,,,,,,,1,,,,,1]],[,[,1,,,,1,1,1,1,1,1,,1,1,1,1,1,,1,1,,1,1,,,1],[,,1,,,,,,,,,1],,,[1,,,1,1,,,,,,,,1,1,,1,1,,1],,[,,,,,,,,,,,,,,,,,,1,,1],,[1,,,1,1,,1,1,,,,,1,,1,,,,,1,1,,1],,[,1,,,,,,,,1,1,1,1,1,,1,1,,,,1,1],[,,,,,,,,,,,,,,,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,,1,1,1,1,1,1],[,,,,,,,,,,,1,,1,,,1],[1,,,,,,,,,,,,,,,,,,1,,1],,,[,1,,,,,,,,,,,,,,1,,,,1,1],[,,,,,,,,,1,,,1,,,,,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,1,1,,,,,,1],,[,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,1,1,,1,1,1,1,1,1,,,1,1,1,1,1,,1,1],[,1,,,,,,,,1],[,,,,1,,,1,,,1,1,,,,,,,,,,1,,,,1],[,1,,1,1,,,1,1,1,,,,1,1,1,1,,1,1,1,1,,1],[,,,,,,,1],[,1,1,,,,,1,,1,,,,,,1,,,,,,1,,1,,1],[,1,,,,,,1,,,,1,,,,,,,,,,1],[,,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1,1,1,1,,1],[,1,,,,,,,,1],[,1,1,,1,,,,,,,,1,,,,,,1,,,1,,1,,1],[,1,,1,,1,,1,1,1,,1,1,1,,1,,,1,1,,1,1,1,1,1],[,1,1,1,1,1,,,1,1,,,,1,1,1,,,,1,1,,,1,1],[,,1,1,1,1,,1,,1,,1,,1,1,1,1,,,,,1,,1,,1],[1,1,1,1,1,1,1,1,,1,,1,,1,1,1,,,1,1,,,,1,,1],[,,,1],,[,1,1,,1,,,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1],[,1,,,,,,1,,1,,1,,,,,,,1,1,,1,1],[,,,,,,1,,1,1,,1,,1,,,,,,,,,,1],[,1,1,,1,,,,1,,,,1,1,1,,,,1,,1,1,1,,1,1],,[,1,1,,,,,,,,,,,,,1,,,1,,,,,1],[,1,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,1,,,,1,,,,,1,,,,,,,1]],[,[,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[,1,1,1,1,1,,1,,1,1,,,1,1,1,1,,1,,,,,1,1,1],[,,1,1,,1,,1,1,,,,1,1,1,1,,,1,,1,1,1,1,,1],[,1,,1,,,,,,,,1,,1,,1,,,,,,,,,,1],[,,1,,1,,,1,,,,,1,1,,,1,,1,1,1,1],[,1],[,1,1,,1,,1,1,,1,,,1,1,1,,,,1,,,1,,1],[1,1,,1,1,1,,,,,,,,,,,,,1,,1,1,1],[,1,1,,,,,,,1,,,1,,1,,1,,1,1,,,1,,,1],[,,1,,,,,,,,,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,,1,,,,,1,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,,1,,1,1,1,,,1,1,1,1,,,,1,1],[,,,1,1,,,1,,1,,1,,1,1,1,1,,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,,1,,1,,,,1,1,,,1,1,,1,1,,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1,,1,1,,,1],[,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,,1,,,1,,,1,,1,1,1,1,1,,1,,1,1],[,,,,,1,,,,1,,,,,1,1,,,,1],[,1,,1,1,1,,1,,,1,1,1,,,1,,,1,,1,,,1],[,,1,,,,,,,,,1,,1,,,,,1,,1],[,1,1,,,,,,,,1,1,1,,,,,,,,1,,,,,1],[,,,,,,,,1,,,,,1,,,1]],[,[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,,1,1,1,1,1,1,1,1,,,,,,,,,1,1],[,,,,,,,,1,,,,1,,1,,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,1,,1,,1,,,,1,1,,1,,1,,,,1,1,1,1,1,,,1],,[,1,,,,,,,,1,,,1,1,,,1,,1,1,,1,,1],[,1,,,1,,,,,,,,1,,,,,,,1],[1,1,,,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1],,[,1,,,,,,1,,1,,1,1,1,1,1,,,1,,1,1,,,,1],[,1,1,,,1,,1,,1,,,1,1,1,1,,,1,,,1,,,,1],[,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1],[,1,,,1,1,,1,1,,,1,1,,1,1,,1,,1,,1],[1,,1,,,,,1,,1,,1,1,1,1,,,,,1,1,,,,1,1],[,1,1,,,,,1,1,,,1,,1,1,1,1,,,,,,,,,,1],,[,1,1,,,1,,,,1,,1,1,1,1,1,,,,1,,,,1,,1],[,,,1,1,,,1,,,,,1,,1,1,1,,1,1,,,,,,1],[,1,,,,,,,,,,,1,,,,1,,,,,,,1,,1],[,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,1,,,,,1,,1,,,1,1,,1,1,,1],[,1,,,,,,1,,,,,1,1,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1,,,1,,,,,1],[,,,,,,,1,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,,1,,,,,,,1,,,,,,,,1,,,1],[,1,,,,,,,1],[,,,,,,,,,,1],[,1,,,,,,1,1,,,,,,1],,[,1,1,,,,,,1,,,,,1,1,,,,1],[1,,1,,1,,,,,1,,,,,1,,,,,,,,,1,1],[,1,1,,,,,,,,,1,1,1,1,,,,1,,,,,1,,,1],,[,1,1,,1,,,1,1,,,1,,,1,1,1,,1,,1,1,1,,,,1],[,,,,,1,,,,,1,,,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,,,1,,,,,1,,,,,1,,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,1],[,1,,,,,,1,,,,,,,1,1,1,,,1],[,1,,,,,,,,,,1,1,1,,,,,1,,,1],[,,,,,1,,1,,,,,1,1,1,,1,1,,1,1,1,,,1,1],[1,1,,,,,,,1,,,,,1,1,,,,,,,,,,,1],,[,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,,1,,,,,1,,,1,,,,1,,1],[,1,,,,,,,,,1]]];function Fp(e){e=Array.isArray(e)?e:yp;var t=[];return e.forEach((function(e,n){var a=String.fromCharCode(n+96).replace("`","");Array.isArray(e)?t=t.concat(Fp(e).map((function(e){return a+e}))):t.push(a)})),t}var wp,Ep=function(e){for(var t=yp;e.length<3;)e+="`";for(var n=0;n<=e.length-1;n++)if(!(t=t[e.charCodeAt(n)-96]))return!1;return!0};T(Cp,on),wp=R(Cp),Z(Cp,[{key:"props",get:function(){return this._props}},{key:"attr",value:function(e){return null!=(e=this._attrs[e])?e:null}},{key:"hasAttr",value:function(e){return void 0!==this._attrs[e]}},{key:"attrNames",get:function(){return Object.keys(this._attrs)}}]),us=Cp;function Cp(e){var t,n,a;return K(this,Cp),(t=wp.call(this))._props=function(e){var t=null!=(t=e.nodeName)?t:kp[e.nodeType],n=null!=(n=null!=(n=e.nodeType)?n:Ap[e.nodeName])?n:1,a=(yn("number"==typeof n,"nodeType has to be a number, got \'".concat(n,"\'")),yn("string"==typeof t,"nodeName has to be a string, got \'".concat(t,"\'")),t=t.toLowerCase(),null);return"input"===t&&(a=(e.type||e.attributes&&e.attributes.type||"").toLowerCase(),vp().includes(a)||(a="text")),e=U({},e,{nodeType:n,nodeName:t}),a&&(e.type=a),delete e.attributes,Object.freeze(e)}(e),t._attrs=(e=e.attributes,n=void 0===e?{}:e,a={htmlFor:"for",className:"class"},Object.keys(n).reduce((function(e,t){var o=n[t];return yn("object"!==r(o)||null===o,"expects attributes not to be an object, \'".concat(t,"\' was")),void 0!==o&&(e[a[t]||t]=null!==o?String(o):null),e}),{})),t}var xp,Ap={"#cdata-section":2,"#text":3,"#comment":8,"#document":9,"#document-fragment":11},kp={},Bp=(Object.keys(Ap).forEach((function(e){kp[Ap[e]]=e})),us),Tp=function(e,t){if(e=e||function(){},t=t||o.log,!o._audit)throw new Error("No audit configured");var n=o.utils.queue(),r=[],u=(Object.keys(o.plugins).forEach((function(e){n.defer((function(t){function n(e){r.push(e),t()}try{o.plugins[e].cleanup(t,n)}catch(e){n(e)}}))})),o.utils.getFlattenedTree(a.body));o.utils.querySelectorAll(u,"iframe, frame").forEach((function(e){n.defer((function(t,n){return o.utils.sendCommandToFrame(e.actualNode,{command:"cleanup-plugin"},t,n)}))})),n.then((function(n){0===r.length?e(n):t(r)})).catch(t)},Np={};function Rp(e){return Np.hasOwnProperty(e)}function _p(e){return"string"==typeof e&&Np[e]?Np[e]:"function"==typeof e?e:xp}var Op={},Sp=(ae(Op,{allowedAttr:function(){return Sp},arialabelText:function(){return Oo},arialabelledbyText:function(){return _o},getAccessibleRefs:function(){return Pp},getElementUnallowedRoles:function(){return qp},getExplicitRole:function(){return $o},getImplicitRole:function(){return bu},getOwnedVirtual:function(){return Au},getRole:function(){return wu},getRoleType:function(){return Bi},getRolesByType:function(){return Vp},getRolesWithNameFromContents:function(){return Gp},implicitNodes:function(){return Yp},implicitRole:function(){return bu},isAccessibleRef:function(){return Kp},isAriaRoleAllowedOnElement:function(){return Ip},isComboboxPopup:function(){return Xp},isUnsupportedRole:function(){return zo},isValidRole:function(){return Vo},label:function(){return Jp},labelVirtual:function(){return ii},lookupTable:function(){return Wp},namedFromContents:function(){return xu},requiredAttr:function(){return Qp},requiredContext:function(){return ef},requiredOwned:function(){return tf},validateAttr:function(){return af},validateAttrValue:function(){return nf}}),function(e){e=qo.ariaRoles[e];var t=$(Uo());return e&&(e.allowedAttrs&&t.push.apply(t,$(e.allowedAttrs)),e.requiredAttrs)&&t.push.apply(t,$(e.requiredAttrs)),t}),Mp=/^idrefs?$/,Pp=function(e){e=e.actualNode||e;var t=(t=sr(e)).documentElement||t,n=Kn.get("idRefsByRoot",(function(){return new WeakMap})),a=n.get(t);return a||(n.set(t,a={}),function e(t,n,a){if(t.hasAttribute){var r;"LABEL"===t.nodeName.toUpperCase()&&t.hasAttribute("for")&&(n[r=t.getAttribute("for")]=n[r]||[],n[r].push(t));for(var o=0;o<a.length;++o){var u=a[o];if(u=Zo(t.getAttribute(u)||""))for(var i=Gc(u),l=0;l<i.length;++l)n[i[l]]=n[i[l]]||[],n[i[l]].push(t)}}for(var s=0;s<t.childNodes.length;s++)1===t.childNodes[s].nodeType&&e(t.childNodes[s],n,a)}(t,a,Object.keys(qo.ariaAttrs).filter((function(e){return e=qo.ariaAttrs[e].type,Mp.test(e)})))),a[e.id]||[]},Ip=function(e,t){e=e instanceof on?e:Xn(e);var n=bu(e);e=gu(e);return Array.isArray(e.allowedRoles)?e.allowedRoles.includes(t):t!==n&&!!e.allowedRoles},jp=["doc-backlink","doc-biblioentry","doc-biblioref","doc-cover","doc-endnote","doc-glossref","doc-noteref"],Lp={header:"banner",footer:"contentinfo"},qp=function(e){var t,n,a,r=!(1<arguments.length&&void 0!==arguments[1])||arguments[1],o=Ld(e).vNode;return Sd(o)?(a=o.props.nodeName,t=bu(o)||Lp[a],a=[],((n=o)?(n.hasAttr("role")&&(n=Gc(n.attr("role").toLowerCase()),a=a.concat(n)),a.filter((function(e){return Vo(e)}))):a).filter((function(e){var n=o,a=t;return!(r&&e===a||(!jp.includes(e)||Bi(e)===a)&&Ip(n,e))}))):[]},zp=function(e){return Object.keys(qo.ariaRoles).filter((function(t){return qo.ariaRoles[t].type===e}))},Vp=function(e){return zp(e)},$p=function(){return Kn.get("ariaRolesNameFromContent",(function(){return Object.keys(qo.ariaRoles).filter((function(e){return qo.ariaRoles[e].nameFromContent}))}))};function Hp(e){return null===e}function Up(e){return null!==e}var Gp=function(){return $p()},Wp=((Il={attributes:{"aria-activedescendant":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-atomic":{type:"boolean",values:["true","false"],unsupported:!1},"aria-autocomplete":{type:"nmtoken",values:["inline","list","both","none"],unsupported:!1},"aria-busy":{type:"boolean",values:["true","false"],unsupported:!1},"aria-checked":{type:"nmtoken",values:["true","false","mixed","undefined"],unsupported:!1},"aria-colcount":{type:"int",unsupported:!1},"aria-colindex":{type:"int",unsupported:!1},"aria-colspan":{type:"int",unsupported:!1},"aria-controls":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-current":{type:"nmtoken",allowEmpty:!0,values:["page","step","location","date","time","true","false"],unsupported:!1},"aria-describedby":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-describedat":{unsupported:!0,unstandardized:!0},"aria-details":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-disabled":{type:"boolean",values:["true","false"],unsupported:!1},"aria-dropeffect":{type:"nmtokens",values:["copy","move","reference","execute","popup","none"],unsupported:!1},"aria-errormessage":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-expanded":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-flowto":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-grabbed":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-haspopup":{type:"nmtoken",allowEmpty:!0,values:["true","false","menu","listbox","tree","grid","dialog"],unsupported:!1},"aria-hidden":{type:"boolean",values:["true","false"],unsupported:!1},"aria-invalid":{type:"nmtoken",allowEmpty:!0,values:["true","false","spelling","grammar"],unsupported:!1},"aria-keyshortcuts":{type:"string",allowEmpty:!0,unsupported:!1},"aria-label":{type:"string",allowEmpty:!0,unsupported:!1},"aria-labelledby":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-level":{type:"int",unsupported:!1},"aria-live":{type:"nmtoken",values:["off","polite","assertive"],unsupported:!1},"aria-modal":{type:"boolean",values:["true","false"],unsupported:!1},"aria-multiline":{type:"boolean",values:["true","false"],unsupported:!1},"aria-multiselectable":{type:"boolean",values:["true","false"],unsupported:!1},"aria-orientation":{type:"nmtoken",values:["horizontal","vertical"],unsupported:!1},"aria-owns":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-placeholder":{type:"string",allowEmpty:!0,unsupported:!1},"aria-posinset":{type:"int",unsupported:!1},"aria-pressed":{type:"nmtoken",values:["true","false","mixed","undefined"],unsupported:!1},"aria-readonly":{type:"boolean",values:["true","false"],unsupported:!1},"aria-relevant":{type:"nmtokens",values:["additions","removals","text","all"],unsupported:!1},"aria-required":{type:"boolean",values:["true","false"],unsupported:!1},"aria-roledescription":{type:"string",allowEmpty:!0,unsupported:!1},"aria-rowcount":{type:"int",unsupported:!1},"aria-rowindex":{type:"int",unsupported:!1},"aria-rowspan":{type:"int",unsupported:!1},"aria-selected":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-setsize":{type:"int",unsupported:!1},"aria-sort":{type:"nmtoken",values:["ascending","descending","other","none"],unsupported:!1},"aria-valuemax":{type:"decimal",unsupported:!1},"aria-valuemin":{type:"decimal",unsupported:!1},"aria-valuenow":{type:"decimal",unsupported:!1},"aria-valuetext":{type:"string",unsupported:!1}},globalAttributes:["aria-atomic","aria-busy","aria-controls","aria-current","aria-describedby","aria-details","aria-disabled","aria-dropeffect","aria-flowto","aria-grabbed","aria-haspopup","aria-hidden","aria-invalid","aria-keyshortcuts","aria-label","aria-labelledby","aria-live","aria-owns","aria-relevant","aria-roledescription"]}).role={alert:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},alertdialog:{type:"widget",attributes:{allowed:["aria-expanded","aria-modal","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["dialog","section"]},application:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage","aria-activedescendant"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["article","audio","embed","iframe","object","section","svg","video"]},article:{type:"structure",attributes:{allowed:["aria-expanded","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["article"],unsupported:!1},banner:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["header"],unsupported:!1,allowedElements:["section"]},button:{type:"widget",attributes:{allowed:["aria-expanded","aria-pressed","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["button",\'input[type="button"]\',\'input[type="image"]\',\'input[type="reset"]\',\'input[type="submit"]\',"summary"],unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Up}}]},cell:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-rowindex","aria-rowspan","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["td","th"],unsupported:!1},checkbox:{type:"widget",attributes:{allowed:["aria-checked","aria-required","aria-readonly","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:[\'input[type="checkbox"]\'],unsupported:!1,allowedElements:["button"]},columnheader:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-required","aria-readonly","aria-selected","aria-sort","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["th"],unsupported:!1},combobox:{type:"composite",attributes:{allowed:["aria-autocomplete","aria-required","aria-activedescendant","aria-orientation","aria-errormessage"],required:["aria-expanded"]},owned:{all:["listbox","tree","grid","dialog","textbox"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:"input",properties:{type:["text","search","tel","url","email"]}}]},command:{nameFrom:["author"],type:"abstract",unsupported:!1},complementary:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["aside"],unsupported:!1,allowedElements:["section"]},composite:{nameFrom:["author"],type:"abstract",unsupported:!1},contentinfo:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["footer"],unsupported:!1,allowedElements:["section"]},definition:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["dd","dfn"],unsupported:!1},dialog:{type:"widget",attributes:{allowed:["aria-expanded","aria-modal","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["dialog"],unsupported:!1,allowedElements:["section"]},directory:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:["ol","ul"]},document:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["body"],unsupported:!1,allowedElements:["article","embed","iframe","object","section","svg"]},"doc-abstract":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-acknowledgments":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-afterword":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-appendix":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-backlink":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Up}}]},"doc-biblioentry":{type:"listitem",attributes:{allowed:["aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author"],context:["doc-bibliography"],unsupported:!1,allowedElements:["li"]},"doc-bibliography":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["doc-biblioentry"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-biblioref":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Up}}]},"doc-chapter":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-colophon":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-conclusion":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-cover":{type:"img",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1},"doc-credit":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-credits":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-dedication":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-endnote":{type:"listitem",attributes:{allowed:["aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,namefrom:["author"],context:["doc-endnotes"],unsupported:!1,allowedElements:["li"]},"doc-endnotes":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["doc-endnote"]},namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-epigraph":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1},"doc-epilogue":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-errata":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-example":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","section"]},"doc-footnote":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","footer","header"]},"doc-foreword":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-glossary":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:["term","definition"],namefrom:["author"],context:null,unsupported:!1,allowedElements:["dl"]},"doc-glossref":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Up}}]},"doc-index":{type:"navigation",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},"doc-introduction":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-noteref":{type:"link",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Up}}]},"doc-notice":{type:"note",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-pagebreak":{type:"separator",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["hr"]},"doc-pagelist":{type:"navigation",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},"doc-part":{type:"landmark",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-preface":{type:"landmark",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-prologue":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-pullquote":{type:"none",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","section"]},"doc-qna":{type:"section",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-subtitle":{type:"sectionhead",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["h1","h2","h3","h4","h5","h6"]}},"doc-tip":{type:"note",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside"]},"doc-toc":{type:"navigation",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},feed:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["article"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["article","aside","section"]},figure:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["figure"],unsupported:!1},form:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["form"],unsupported:!1},grid:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-colcount","aria-level","aria-multiselectable","aria-readonly","aria-rowcount","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author"],context:null,implicit:["table"],unsupported:!1},gridcell:{type:"widget",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-selected","aria-readonly","aria-required","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["td","th"],unsupported:!1},group:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["details","optgroup"],unsupported:!1,allowedElements:["dl","figcaption","fieldset","figure","footer","header","ol","ul"]},heading:{type:"structure",attributes:{required:["aria-level"],allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["h1","h2","h3","h4","h5","h6"],unsupported:!1},img:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["img"],unsupported:!1,allowedElements:["embed","iframe","object","svg"]},input:{nameFrom:["author"],type:"abstract",unsupported:!1},landmark:{nameFrom:["author"],type:"abstract",unsupported:!1},link:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["a[href]","area[href]"],unsupported:!1,allowedElements:["button",{nodeName:"input",properties:{type:["image","button"]}}]},list:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{all:["listitem"]},nameFrom:["author"],context:null,implicit:["ol","ul","dl"],unsupported:!1},listbox:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-multiselectable","aria-readonly","aria-required","aria-expanded","aria-orientation","aria-errormessage"]},owned:{all:["option"]},nameFrom:["author"],context:null,implicit:["select"],unsupported:!1,allowedElements:["ol","ul"]},listitem:{type:"structure",attributes:{allowed:["aria-level","aria-posinset","aria-setsize","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["list"],implicit:["li","dt"],unsupported:!1},log:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},main:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["main"],unsupported:!1,allowedElements:["article","section"]},marquee:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},math:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["math"],unsupported:!1},menu:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:{one:["menuitem","menuitemradio","menuitemcheckbox"]},nameFrom:["author"],context:null,implicit:[\'menu[type="context"]\'],unsupported:!1,allowedElements:["ol","ul"]},menubar:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:{one:["menuitem","menuitemradio","menuitemcheckbox"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},menuitem:{type:"widget",attributes:{allowed:["aria-posinset","aria-setsize","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:[\'menuitem[type="command"]\'],unsupported:!1,allowedElements:["button","li",{nodeName:"iput",properties:{type:["image","button"]}},{nodeName:"a",attributes:{href:Up}}]},menuitemcheckbox:{type:"widget",attributes:{allowed:["aria-checked","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:[\'menuitem[type="checkbox"]\'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["checkbox","image","button"]}},{nodeName:"a",attributes:{href:Up}}]},menuitemradio:{type:"widget",attributes:{allowed:["aria-checked","aria-selected","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:[\'menuitem[type="radio"]\'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["image","button","radio"]}},{nodeName:"a",attributes:{href:Up}}]},navigation:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["nav"],unsupported:!1,allowedElements:["section"]},none:{type:"structure",attributes:null,owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:["article","aside","dl","embed","figcaption","fieldset","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hr","iframe","li","ol","section","ul"]},{nodeName:"img",attributes:{alt:Up}}]},note:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["aside"]},option:{type:"widget",attributes:{allowed:["aria-selected","aria-posinset","aria-setsize","aria-checked","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["listbox"],implicit:["option"],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["checkbox","button"]}},{nodeName:"a",attributes:{href:Up}}]},presentation:{type:"structure",attributes:null,owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:["article","aside","dl","embed","figcaption","fieldset","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hr","iframe","li","ol","section","ul"]},{nodeName:"img",attributes:{alt:Up}}]},progressbar:{type:"widget",attributes:{allowed:["aria-valuetext","aria-valuenow","aria-valuemax","aria-valuemin","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["progress"],unsupported:!1},radio:{type:"widget",attributes:{allowed:["aria-selected","aria-posinset","aria-setsize","aria-required","aria-errormessage","aria-checked"]},owned:null,nameFrom:["author","contents"],context:null,implicit:[\'input[type="radio"]\'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["image","button"]}}]},radiogroup:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-required","aria-expanded","aria-readonly","aria-errormessage","aria-orientation"]},owned:{all:["radio"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["ol","ul","fieldset"]}},range:{nameFrom:["author"],type:"abstract",unsupported:!1},region:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["section[aria-label]","section[aria-labelledby]","section[title]"],unsupported:!1,allowedElements:{nodeName:["article","aside"]}},roletype:{type:"abstract",unsupported:!1},row:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-colindex","aria-expanded","aria-level","aria-selected","aria-rowindex","aria-errormessage"]},owned:{one:["cell","columnheader","rowheader","gridcell"]},nameFrom:["author","contents"],context:["rowgroup","grid","treegrid","table"],implicit:["tr"],unsupported:!1},rowgroup:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-errormessage"]},owned:{all:["row"]},nameFrom:["author","contents"],context:["grid","table","treegrid"],implicit:["tbody","thead","tfoot"],unsupported:!1},rowheader:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-required","aria-readonly","aria-selected","aria-sort","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["th"],unsupported:!1},scrollbar:{type:"widget",attributes:{required:["aria-controls","aria-valuenow"],allowed:["aria-valuetext","aria-orientation","aria-errormessage","aria-valuemax","aria-valuemin"]},owned:null,nameFrom:["author"],context:null,unsupported:!1},search:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["aside","form","section"]}},searchbox:{type:"widget",attributes:{allowed:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-readonly","aria-required","aria-placeholder","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="search"]\'],unsupported:!1,allowedElements:{nodeName:"input",properties:{type:"text"}}},section:{nameFrom:["author","contents"],type:"abstract",unsupported:!1},sectionhead:{nameFrom:["author","contents"],type:"abstract",unsupported:!1},select:{nameFrom:["author"],type:"abstract",unsupported:!1},separator:{type:"structure",attributes:{allowed:["aria-expanded","aria-orientation","aria-valuenow","aria-valuemax","aria-valuemin","aria-valuetext","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["hr"],unsupported:!1,allowedElements:["li"]},slider:{type:"widget",attributes:{allowed:["aria-valuetext","aria-orientation","aria-readonly","aria-errormessage","aria-valuemax","aria-valuemin"],required:["aria-valuenow"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="range"]\'],unsupported:!1},spinbutton:{type:"widget",attributes:{allowed:["aria-valuetext","aria-required","aria-readonly","aria-errormessage","aria-valuemax","aria-valuemin"],required:["aria-valuenow"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="number"]\'],unsupported:!1,allowedElements:{nodeName:"input",properties:{type:["text","tel"]}}},status:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["output"],unsupported:!1,allowedElements:["section"]},structure:{type:"abstract",unsupported:!1},switch:{type:"widget",attributes:{allowed:["aria-errormessage"],required:["aria-checked"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:["button",{nodeName:"input",properties:{type:["checkbox","image","button"]}},{nodeName:"a",attributes:{href:Up}}]},tab:{type:"widget",attributes:{allowed:["aria-selected","aria-expanded","aria-setsize","aria-posinset","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["tablist"],unsupported:!1,allowedElements:[{nodeName:["button","h1","h2","h3","h4","h5","h6","li"]},{nodeName:"input",properties:{type:"button"}},{nodeName:"a",attributes:{href:Up}}]},table:{type:"structure",attributes:{allowed:["aria-colcount","aria-rowcount","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author","contents"],context:null,implicit:["table"],unsupported:!1},tablist:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-level","aria-multiselectable","aria-orientation","aria-errormessage"]},owned:{all:["tab"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},tabpanel:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},term:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["dt"],unsupported:!1},textbox:{type:"widget",attributes:{allowed:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-readonly","aria-required","aria-placeholder","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="text"]\',\'input[type="email"]\',\'input[type="password"]\',\'input[type="tel"]\',\'input[type="url"]\',"input:not([type])","textarea"],unsupported:!1},timer:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1},toolbar:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:[\'menu[type="toolbar"]\'],unsupported:!1,allowedElements:["ol","ul"]},tooltip:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1},tree:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-multiselectable","aria-required","aria-expanded","aria-orientation","aria-errormessage"]},owned:{all:["treeitem"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},treegrid:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-colcount","aria-expanded","aria-level","aria-multiselectable","aria-readonly","aria-required","aria-rowcount","aria-orientation","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author"],context:null,unsupported:!1},treeitem:{type:"widget",attributes:{allowed:["aria-checked","aria-selected","aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["group","tree"],unsupported:!1,allowedElements:["li",{nodeName:"a",attributes:{href:Up}}]},widget:{type:"abstract",unsupported:!1},window:{nameFrom:["author"],type:"abstract",unsupported:!1}},Il.implicitHtmlRole=nu,Il.elementsAllowedNoRole=[{nodeName:["base","body","caption","col","colgroup","datalist","dd","details","dt","head","html","keygen","label","legend","main","map","math","meta","meter","noscript","optgroup","param","picture","progress","script","source","style","template","textarea","title","track"]},{nodeName:"area",attributes:{href:Up}},{nodeName:"input",properties:{type:["color","data","datatime","file","hidden","month","number","password","range","reset","submit","time","week"]}},{nodeName:"link",attributes:{href:Up}},{nodeName:"menu",attributes:{type:"context"}},{nodeName:"menuitem",attributes:{type:["command","checkbox","radio"]}},{nodeName:"select",condition:function(e){return e instanceof o.AbstractVirtualNode||(e=o.utils.getNodeFromTree(e)),1<Number(e.attr("size"))},properties:{multiple:!0}},{nodeName:["clippath","cursor","defs","desc","feblend","fecolormatrix","fecomponenttransfer","fecomposite","feconvolvematrix","fediffuselighting","fedisplacementmap","fedistantlight","fedropshadow","feflood","fefunca","fefuncb","fefuncg","fefuncr","fegaussianblur","feimage","femerge","femergenode","femorphology","feoffset","fepointlight","fespecularlighting","fespotlight","fetile","feturbulence","filter","hatch","hatchpath","lineargradient","marker","mask","meshgradient","meshpatch","meshrow","metadata","mpath","pattern","radialgradient","solidcolor","stop","switch","view"]}],Il.elementsAllowedAnyRole=[{nodeName:"a",attributes:{href:Hp}},{nodeName:"img",attributes:{alt:Hp}},{nodeName:["abbr","address","canvas","div","p","pre","blockquote","ins","del","output","span","table","tbody","thead","tfoot","td","em","strong","small","s","cite","q","dfn","abbr","time","code","var","samp","kbd","sub","sup","i","b","u","mark","ruby","rt","rp","bdi","bdo","br","wbr","th","tr"]}],Il.evaluateRoleForElement={A:function(e){var t=e.node;e=e.out;return"http://www.w3.org/2000/svg"===t.namespaceURI||!t.href.length||e},AREA:function(e){return!e.node.href},BUTTON:function(e){var t=e.node,n=e.role;e=e.out;return"menu"===t.getAttribute("type")?"menuitem"===n:e},IMG:function(e){var t=e.node,n=e.role,a=e.out;switch(t.alt){case null:return a;case"":return"presentation"===n||"none"===n;default:return"presentation"!==n&&"none"!==n}},INPUT:function(e){var t=e.node,n=e.role,a=e.out;switch(t.type){case"button":case"image":return a;case"checkbox":return!("button"!==n||!t.hasAttribute("aria-pressed"))||a;case"radio":return"menuitemradio"===n;case"text":return"combobox"===n||"searchbox"===n||"spinbutton"===n;case"tel":return"combobox"===n||"spinbutton"===n;case"url":case"search":case"email":return"combobox"===n;default:return!1}},LI:function(e){var t=e.node;e=e.out;return!o.utils.matchesSelector(t,"ol li, ul li")||e},MENU:function(e){return"context"!==e.node.getAttribute("type")},OPTION:function(e){return e=e.node,!o.utils.matchesSelector(e,"select > option, datalist > option, optgroup > option")},SELECT:function(e){var t=e.node;e=e.role;return!t.multiple&&t.size<=1&&"menu"===e},SVG:function(e){var t=e.node;e=e.out;return!(!t.parentNode||"http://www.w3.org/2000/svg"!==t.parentNode.namespaceURI)||e}},Il.rolesOfType={widget:["button","checkbox","dialog","gridcell","link","log","marquee","menuitem","menuitemcheckbox","menuitemradio","option","progressbar","radio","scrollbar","searchbox","slider","spinbutton","status","switch","tab","tabpanel","textbox","timer","tooltip","tree","treeitem"]},Il),Yp=function(e){var t=null;return(e=Wp.role[e])&&e.implicit?ea(e.implicit):t},Kp=function(e){return!!Pp(e).length};function Xp(e){var t=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).popupRoles,n=wu(e);if(!(t=null!=t?t:So["aria-haspopup"].values).includes(n))return!1;if(t=function(e){for(;e=e.parent;)if(null!==wu(e,{noPresentational:!0}))return e;return null}(e),Zp(t))return!0;if(!(n=e.props.id))return!1;if(e.actualNode)return t=lr(e.actualNode).querySelectorAll(\'[aria-owns~="\'.concat(n,\'"][role~="combobox"]:not(select),\\n     [aria-controls~="\').concat(n,\'"][role~="combobox"]:not(select)\')),Array.from(t).some(Zp);throw new Error("Unable to determine combobox popup without an actualNode")}var Zp=function(e){return e&&"combobox"===wu(e)},Jp=function(e){return e=Xn(e),ii(e)},Qp=function(e){return(e=qo.ariaRoles[e])&&Array.isArray(e.requiredAttrs)?$(e.requiredAttrs):[]},ef=function(e){return(e=qo.ariaRoles[e])&&Array.isArray(e.requiredContext)?$(e.requiredContext):null},tf=function(e){return(e=qo.ariaRoles[e])&&Array.isArray(e.requiredOwned)?$(e.requiredOwned):null},nf=function(e,t){var n,a=(e=e instanceof on?e:Xn(e)).attr(t),r=qo.ariaAttrs[t];if(!r)return!0;if(r.allowEmpty&&(!a||""===a.trim()))return!0;switch(r.type){case"boolean":return["true","false"].includes(a.toLowerCase());case"nmtoken":return"string"==typeof a&&r.values.includes(a.toLowerCase());case"nmtokens":return(n=Gc(a)).reduce((function(e,t){return e&&r.values.includes(t)}),0!==n.length);case"idref":try{var o=sr(e.actualNode);return!(!a||!o.getElementById(a))}catch(e){throw new TypeError("Cannot resolve id references for partial DOM")}case"idrefs":return No(e,t).some((function(e){return!!e}));case"string":return""!==a.trim();case"decimal":return!(!(n=a.match(/^[-+]?([0-9]*)\\.?([0-9]*)$/))||!n[1]&&!n[2]);case"int":return o=void 0!==r.minValue?r.minValue:-1/0,/^[-+]?[0-9]+$/.test(a)&&parseInt(a)>=o}},af=function(e){return!!qo.ariaAttrs[e]};function rf(e,t,n){var a=(r=n.props).nodeName,r=r.type,o=function(e){return e?(e=e.toLowerCase(),["mixed","true"].includes(e)?e:"false"):""}(n.attr("aria-checked"));return"input"!==a||"checkbox"!==r||!o||o===(a=function(e){return e.props.indeterminate?"mixed":e.props.checked?"true":"false"}(n))||(this.data({messageKey:"checkbox",checkState:a}),!1)}function of(e){var t,n,a=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).invalidTableRowAttrs,r=2<arguments.length?arguments[2]:void 0;a=null!=(t=null==a||null==(t=a.filter)?void 0:t.call(a,(function(e){return r.hasAttr(e)})))?t:[];return 0===a.length||!(t=(t=function(e){if(e.parent)return ca(e,\'table:not([role]), [role~="treegrid"], [role~="table"], [role~="grid"]\')}(r))&&wu(t))||"treegrid"===t||(n="row".concat(1<a.length?"Plural":"Singular"),this.data({messageKey:n,invalidAttrs:a,ownerRole:t}),!1)}var uf={row:of,checkbox:rf};var lf={};function sf(e){return 3===e.props.nodeType?0<e.props.nodeValue.trim().length:vi(e,!1,!0)}function cf(e,t,n,a){var r=$o(e);if(!(n=n||ef(r)))return null;for(var o=n.includes("group"),u=a?e:e.parent;u;){var i=wu(u,{noPresentational:!0});if(i){if("group"!==i||!o)return n.includes(i)?null:n;t.includes(r)&&n.push(r),n=n.filter((function(e){return"group"!==e}))}u=u.parent}return n}ae(lf,{getAriaRolesByType:function(){return zp},getAriaRolesSupportingNameFromContent:function(){return $p},getElementSpec:function(){return gu},getElementsByContentType:function(){return Ho},getGlobalAriaAttrs:function(){return Uo},implicitHtmlRoles:function(){return nu}});var df={ARTICLE:!0,ASIDE:!0,NAV:!0,SECTION:!0},pf={application:!0,article:!0,banner:!1,complementary:!0,contentinfo:!0,form:!0,main:!0,navigation:!0,region:!0,search:!1};var ff={},Df=(ae(ff,{Color:function(){return xc},centerPointOfRect:function(){return Df},elementHasImage:function(){return Ii},elementIsDistinct:function(){return hf},filteredRectStack:function(){return bf},flattenColors:function(){return Ff},flattenShadowColors:function(){return wf},getBackgroundColor:function(){return Nf},getBackgroundStack:function(){return Ef},getContrast:function(){return Of},getForegroundColor:function(){return Sf},getOwnBackgroundColor:function(){return kc},getRectStack:function(){return gf},getStackingContext:function(){return xf},getTextShadowColors:function(){return Cf},hasValidContrastRatio:function(){return Mf},incompleteData:function(){return Pi},stackingContextToColor:function(){return Af}}),function(e){if(!(e.left>t.innerWidth||e.top>t.innerHeight))return{x:Math.min(Math.ceil(e.left+e.width/2),t.innerWidth-1),y:Math.min(Math.ceil(e.top+e.height/2),t.innerHeight-1)}});function mf(e){return e.getPropertyValue("font-family").split(/[,;]/g).map((function(e){return e.trim().toLowerCase()}))}var hf=function(e,n){var a,r=t.getComputedStyle(e);return"none"!==r.getPropertyValue("background-image")||!!["border-bottom","border-top","outline"].reduce((function(e,t){var n=new xc;return n.parseString(r.getPropertyValue(t+"-color")),e||"none"!==r.getPropertyValue(t+"-style")&&0<parseFloat(r.getPropertyValue(t+"-width"))&&0!==n.alpha}),!1)||(a=t.getComputedStyle(n),mf(r)[0]!==mf(a)[0])||(e=["text-decoration-line","text-decoration-style","font-weight","font-style","font-size"].reduce((function(e,t){return e||r.getPropertyValue(t)!==a.getPropertyValue(t)}),!1),(n=r.getPropertyValue("text-decoration")).split(" ").length<3?e||n!==a.getPropertyValue("text-decoration"):e)},gf=function(e){var t=ko(e);return!(e=Di(e))||e.length<=1?[t]:e.some((function(e){return void 0===e}))?null:(e.splice(0,0,t),e)},bf=function(e){var t,n,a=gf(e);return a&&1===a.length?a[0]:a&&1<a.length?(t=a.shift(),a.forEach((function(r,o){var u,i;0!==o&&(u=a[o-1],i=a[o],n=u.every((function(e,t){return e===i[t]}))||t.includes(e))})),n?a[0]:(Pi.set("bgColor","elmPartiallyObscuring"),null)):(Pi.set("bgColor","outsideViewport"),null)},vf={normal:function(e,t){return t},multiply:function(e,t){return t*e},screen:function(e,t){return e+t-e*t},overlay:function(e,t){return this["hard-light"](t,e)},darken:function(e,t){return Math.min(e,t)},lighten:function(e,t){return Math.max(e,t)},"color-dodge":function(e,t){return 0===e?0:1===t?1:Math.min(1,e/(1-t))},"color-burn":function(e,t){return 1===e?1:0===t?0:1-Math.min(1,(1-e)/t)},"hard-light":function(e,t){return t<=.5?this.multiply(e,2*t):this.screen(e,2*t-1)},"soft-light":function(e,t){return t<=.5?e-(1-2*t)*e*(1-e):e+(2*t-1)*((e<=.25?((16*e-12)*e+4)*e:Math.sqrt(e))-e)},difference:function(e,t){return Math.abs(e-t)},exclusion:function(e,t){return e+t-2*e*t}};function yf(e,t,n,a,r){return t*(1-a)*e+t*a*vf[r](n/255,e/255)*255+(1-t)*a*n}var Ff=function(e,t){var n,a,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"normal",o=yf(e.red,e.alpha,t.red,t.alpha,r),u=yf(e.green,e.alpha,t.green,t.alpha,r),i=(r=yf(e.blue,e.alpha,t.blue,t.alpha,r),n=e.alpha+t.alpha*(1-e.alpha),i=0,a=1,Math.min(Math.max(i,n),a));return 0===i?new xc(o,u,r,i):(n=Math.round(o/i),a=Math.round(u/i),o=Math.round(r/i),new xc(n,a,o,i))};function wf(e,t){var n=(1-(r=e.alpha))*t.red+r*e.red,a=(1-r)*t.green+r*e.green,r=(1-r)*t.blue+r*e.blue;t=e.alpha+t.alpha*(1-e.alpha);return new xc(n,a,r,t)}function Ef(e){for(var n=Di(e).map((function(n){return function(e){var n=e.indexOf(a.body),r=kc(t.getComputedStyle(a.documentElement));return 1<n&&0===r.alpha&&!Ii(a.documentElement)&&(1<n&&(e.splice(n,1),e.push(a.body)),0<(r=e.indexOf(a.documentElement)))&&(e.splice(r,1),e.push(a.documentElement)),e}(n=Sc(n,e))})),r=0;r<n.length;r++){var o=n[r];if(o[0]!==e)return Pi.set("bgColor","bgOverlap"),null;if(0!==r&&!function(e,t){if(e!==t){if(null===e||null===t)return;if(e.length!==t.length)return;for(var n=0;n<e.length;++n)if(e[n]!==t[n])return}return 1}(o,n[0]))return Pi.set("bgColor","elmPartiallyObscuring"),null}return n[0]||null}var Cf=function(e){var n,a,r,o=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},u=o.minRatio,i=o.maxRatio,l=t.getComputedStyle(e);return"none"===(o=l.getPropertyValue("text-shadow"))?[]:(n=l.getPropertyValue("font-size"),a=parseInt(n),yn(!1===isNaN(a),"Unable to determine font-size value ".concat(n)),r=[],function(e){var t={pixels:[]},n=e.trim(),a=[t];if(!n)return[];for(;n;){var r=n.match(/^rgba?\\([0-9,.\\s]+\\)/i)||n.match(/^[a-z]+/i)||n.match(/^#[0-9a-f]+/i),o=n.match(/^([0-9.-]+)px/i)||n.match(/^(0)/);if(r)yn(!t.colorStr,"Multiple colors identified in text-shadow: ".concat(e)),n=n.replace(r[0],"").trim(),t.colorStr=r[0];else if(o)yn(t.pixels.length<3,"Too many pixel units in text-shadow: ".concat(e)),n=n.replace(o[0],"").trim(),r=parseFloat(("."===o[1][0]?"0":"")+o[1]),t.pixels.push(r);else{if(","!==n[0])throw new Error("Unable to process text-shadows: ".concat(e));yn(2<=t.pixels.length,"Missing pixel value in text-shadow: ".concat(e)),a.push(t={pixels:[]}),n=n.substr(1).trim()}}return a}(o).forEach((function(e){var t=e.colorStr,n=(e=e.pixels,t=t||l.getPropertyValue("color"),(e=G(e,3))[0]),o=e[1];e=void 0===(e=e[2])?0:e;(!u||a*u<=e)&&(!i||e<a*i)&&(t=function(e){var t=e.colorStr,n=e.offsetX,a=e.offsetY,r=e.blurRadius;e=e.fontSize;return r<n||r<a?new xc(0,0,0,0):((n=new xc).parseString(t),n.alpha*=function(e,t){return 0===e?1:.185/(e/t+.4)}(r,e),n)}({colorStr:t,offsetY:n,offsetX:o,blurRadius:e,fontSize:a}),r.push(t))})),r)};function xf(e,t){var n,a,r,o=Xn(e);return o._stackingContext||(a=[],r=new Map,(t=null!=(n=t)?n:Ef(e)).forEach((function(e){var t=(t=e=Xn(e),(o=new xc).parseString(t.getComputedStylePropertyValue("background-color")),o),n=e._stackingOrder.filter((function(e){return!!e.vNode})),o=(n.forEach((function(e,t){e=e.vNode;var o=null==(o=n[t-1])?void 0:o.vNode;o=Tf(r,e,o);0!==t||r.get(e)||a.unshift(o),r.set(e,o)})),null==(o=n[n.length-1])?void 0:o.vNode);e=Tf(r,e,o);n.length||a.unshift(e),e.bgColor=t})),o._stackingContext=a)}function Af(e){var t;return null!=(t=e.descendants)&&t.length?(t=e.descendants.reduce(kf,Bf()),(t=Ff(t,e.bgColor,e.descendants[0].blendMode)).alpha*=e.opacity):(t=e.bgColor).alpha*=e.opacity,{color:t,blendMode:e.blendMode}}function kf(e,t){e=e instanceof xc?e:Af(e).color;var n=Af(t).color;return Ff(n,e,t.blendMode)}function Bf(e,t){return{vNode:e,ancestor:t,opacity:parseFloat(null!=(t=null==e?void 0:e.getComputedStylePropertyValue("opacity"))?t:1),bgColor:new xc(0,0,0,0),blendMode:(null==e?void 0:e.getComputedStylePropertyValue("mix-blend-mode"))||void 0,descendants:[]}}function Tf(e,t,n){var a=e.get(n);e=null!=(e=e.get(t))?e:Bf(t,a);return a&&n!==t&&!a.descendants.includes(e)&&a.descendants.unshift(e),e}function Nf(e){var n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:[],r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:.1,o=Xn(e),u=o._cache.getBackgroundColor;return u?(n.push.apply(n,$(u.bgElms)),Pi.set("bgColor",u.incompleteData),u.bgColor):(u=function(e,n,r){var o=Ef(e);if(!o)return null;var u=fi(e);(r=Cf(e,{minRatio:r})).length&&(r=[{color:r.reduce(wf)}]);for(var i=0;i<o.length;i++){var l=o[i],s=t.getComputedStyle(l);if(Ii(l,s))return n.push(l),null;var c=kc(s);if(0!==c.alpha){if("inline"!==s.getPropertyValue("display")&&!Rf(l,u))return n.push(l),Pi.set("bgColor","elmPartiallyObscured"),null;if(n.push(l),1===c.alpha)break}}var d=(r=(d=xf(e,o)).map(Af).concat(r),function(e,n){var r,o,u,i,l=[];return n||(n=a.documentElement,i=a.body,n=t.getComputedStyle(n),r=t.getComputedStyle(i),o=kc(n),i=0!==(u=kc(r)).alpha&&Rf(i,e.getBoundingClientRect()),(0!==u.alpha&&0===o.alpha||i&&1!==u.alpha)&&l.unshift({color:u,blendMode:_f(r.getPropertyValue("mix-blend-mode"))}),0===o.alpha)||i&&1===u.alpha||l.unshift({color:o,blendMode:_f(n.getPropertyValue("mix-blend-mode"))}),l}(e,o.includes(a.body)));return r.unshift.apply(r,$(d)),0===r.length?new xc(255,255,255,1):(e=r.reduce((function(e,t){return Ff(t.color,e.color instanceof xc?e.color:e,t.blendMode)})),Ff(e.color instanceof xc?e.color:e,new xc(255,255,255,1)))}(e,n,r),o._cache.getBackgroundColor={bgColor:u,bgElms:n,incompleteData:Pi.get("bgColor")},u)}function Rf(e,n){n=Array.isArray(n)?n:[n];var a=e.getBoundingClientRect(),r=a.right,o=a.bottom,u=t.getComputedStyle(e).getPropertyValue("overflow");return(["scroll","auto"].includes(u)||e instanceof t.HTMLHtmlElement)&&(r=a.left+e.scrollWidth,o=a.top+e.scrollHeight),n.every((function(e){return e.top>=a.top&&e.bottom<=o&&e.left>=a.left&&e.right<=r}))}function _f(e){return e||void 0}var Of=function(e,t){return t&&e?(t.alpha<1&&(t=Ff(t,e)),e=e.getRelativeLuminance(),t=t.getRelativeLuminance(),(Math.max(t,e)+.05)/(Math.min(t,e)+.05)):null};function Sf(e,n,a){for(var r=3<arguments.length&&void 0!==arguments[3]?arguments[3]:{},o=t.getComputedStyle(e),u=[],i=0,l=[function(){var e,t,n=o,a=void 0===(a=(a=r).textStrokeEmMin)?0:a;return 0===(t=parseFloat(n.getPropertyValue("-webkit-text-stroke-width")))||(e=n.getPropertyValue("font-size"),t/=parseFloat(e),isNaN(t))||t<a?null:(e=n.getPropertyValue("-webkit-text-stroke-color"),(new xc).parseString(e))},function(){return e=o,(new xc).parseString(e.getPropertyValue("-webkit-text-fill-color")||e.getPropertyValue("color"));var e},function(){return Cf(e,{minRatio:0})}];i<l.length;i++){var s=(0,l[i])();if(s&&(u=u.concat(s),1===s.alpha))break}var c,d,p=u.reduce((function(e,t){return Ff(e,t)}));return null===(a=null==a?Nf(e,[]):a)?(c=Pi.get("bgColor"),Pi.set("fgColor",c),null):(d=function e(t,n){var a,r=Q(t);try{for(r.s();!(a=r.n()).done;){var o,u=a.value;if((null==(o=u.vNode)?void 0:o.actualNode)===n)return u;var i=e(u.descendants,n);if(i)return i}}catch(e){r.e(e)}finally{r.f()}}(c=xf(e),e),Ff(function(e,t,n){for(;t;){var a;1===t.opacity&&t.ancestor||(e.alpha*=t.opacity,a=(null==(a=t.ancestor)?void 0:a.descendants)||n,(a=(a=1!==t.opacity?a.slice(0,a.indexOf(t)):a).map(Af)).length&&(a=a.reduce((function(e,t){return Ff(t.color,e.color instanceof xc?e.color:e)}),{color:new xc(0,0,0,0),blendMode:"normal"}),e=Ff(e,a))),t=t.ancestor}return e}(p,d,c),new xc(255,255,255,1)))}var Mf=function(e,t,n,a){return e=Of(e,t),{isValid:(t=a&&Math.ceil(72*n)/96<14||!a&&Math.ceil(72*n)/96<18?4.5:3)<e,contrastRatio:e,expectedContrastRatio:t}},Pf=Dr((function(e,n){function a(e,t){return r.getPropertyValue(e)===t}var r=t.getComputedStyle(e,n);return a("content","none")||a("display","none")||a("visibility","hidden")||!1===a("position","absolute")||0===kc(r).alpha&&a("background-image","none")?0:(e=If(r.getPropertyValue("width")),n=If(r.getPropertyValue("height")),"px"!==e.unit||"px"!==n.unit?0===e.value||0===n.value?0:1/0:e.value*n.value)}));function If(e){var t=(e=G(e.match(/^([0-9.]+)([a-z]+)$/i)||[],3))[1];e=void 0===(e=e[2])?"":e;return{value:parseFloat(void 0===t?"":t),unit:e.toLowerCase()}}function jf(e,t){return e=e.getRelativeLuminance(),t=t.getRelativeLuminance(),(Math.max(e,t)+.05)/(Math.min(e,t)+.05)}var Lf=["block","list-item","table","flex","grid","inline-block"];function qf(e){return e=t.getComputedStyle(e).getPropertyValue("display"),-1!==Lf.indexOf(e)||"table-"===e.substr(0,6)}var zf=["block","list-item","table","flex","grid","inline-block"];function Vf(e){return e=t.getComputedStyle(e).getPropertyValue("display"),-1!==zf.indexOf(e)||"table-"===e.substr(0,6)}function $f(e){return e=parseInt(e.attr("tabindex"),10),!isNaN(e)&&e<0}function Hf(e,t){return t=Uf(t),e=Uf(e),!(!t||!e)&&t.includes(e)}function Uf(e){return e=ai(e,{emoji:!0,nonBmp:!0,punctuations:!0}),Zo(e)}function Gf(e){return""!==(e||"").trim()}function Wf(e,t){var n=1<arguments.length&&void 0!==t&&t;return e.map((function(e){return{vChild:e,nested:n}}))}function Yf(e,t){return e=e.boundingClientRect,t=t.boundingClientRect,e.top>=t.top&&e.left>=t.left&&e.bottom<=t.bottom&&e.right<=t.right}function Kf(e){return{width:Math.round(10*e.width)/10,height:Math.round(10*e.height)/10}}function Xf(e,t){return e.actualNode.contains(t.actualNode)&&!ki(t)}function Zf(e,t){var n=t.width;t=t.height;return e<=n+.05&&e<=t+.05}function Jf(e){return e.map((function(e){return e.actualNode}))}function Qf(e,t){var n=null==(n=t.data)?void 0:n.headingOrder,a=tD(t.node.ancestry,1);return n&&(t=n.map((function(e){return U({},e,{ancestry:a.concat(e.ancestry)})})),-1===(n=function(e,t){for(;t.length;){var n=eD(e,t);if(-1!==n)return n;t=tD(t,1)}return-1}(e,a))?e.push.apply(e,$(t)):e.splice.apply(e,[n,0].concat($(t)))),e}function eD(e,t){return e.findIndex((function(e){return Id(e.ancestry,t)}))}function tD(e,t){return e.slice(0,e.length-t)}ae(Ll={},{aria:function(){return Op},color:function(){return ff},dom:function(){return ir},forms:function(){return nD},matches:function(){return hu},math:function(){return vo},standards:function(){return lf},table:function(){return oD},text:function(){return To},utils:function(){return un}});var nD={},aD=(ae(nD,{isAriaCombobox:function(){return Hu},isAriaListbox:function(){return $u},isAriaRange:function(){return Gu},isAriaTextbox:function(){return Vu},isDisabled:function(){return rD},isNativeSelect:function(){return zu},isNativeTextbox:function(){return qu}}),["fieldset","button","select","input","textarea"]),rD=function e(t){var n,a,r=t._isDisabled;return"boolean"!=typeof r&&(n=t.props.nodeName,a=t.attr("aria-disabled"),r=!(!aD.includes(n)||!t.hasAttr("disabled"))||(a?"true"===a.toLowerCase():!!t.parent&&e(t.parent)),t._isDisabled=r),r},oD={},uD=(ae(oD,{getAllCells:function(){return uD},getCellPosition:function(){return Wo},getHeaders:function(){return lD},getScope:function(){return Yo},isColumnHeader:function(){return Ko},isDataCell:function(){return sD},isDataTable:function(){return cD},isHeader:function(){return dD},isRowHeader:function(){return Xo},toArray:function(){return Go},toGrid:function(){return Go},traverse:function(){return pD}}),function(e){for(var t,n,a=[],r=0,o=e.rows.length;r<o;r++)for(t=0,n=e.rows[r].cells.length;t<n;t++)a.push(e.rows[r].cells[t]);return a});function iD(e,t,n){for(var a,r="row"===e?"_rowHeaders":"_colHeaders",u="row"===e?Xo:Ko,i=(s=n[t.y][t.x]).colSpan-1,l=s.getAttribute("rowspan"),s=(l=0===parseInt(l)||0===s.rowspan?n.length:s.rowSpan,t.y+(l-1)),c=t.x+i,d="row"===e?t.y:0,p="row"===e?0:t.x,f=[],D=s;d<=D&&!a;D--)for(var m=c;p<=m;m--){var h=n[D]?n[D][m]:void 0;if(h){var g=o.utils.getNodeFromTree(h);if(g[r]){a=g[r];break}f.push(h)}}return a=(a||[]).concat(f.filter(u)),f.forEach((function(e){o.utils.getNodeFromTree(e)[r]=a})),a}var lD=function(e,t){if(e.getAttribute("headers")){var n=No(e,"headers");if(n.filter((function(e){return e})).length)return n}return t=t||Go(pr(e,"table")),e=iD("row",n=Wo(e,t),t),n=iD("col",n,t),[].concat(e,n).reverse()},sD=function(e){var t;return!(!e.children.length&&!e.textContent.trim())&&(t=e.getAttribute("role"),Vo(t)?["cell","gridcell"].includes(t):"TD"===e.nodeName.toUpperCase())},cD=function(e){var n=(e.getAttribute("role")||"").toLowerCase();if(("presentation"===n||"none"===n)&&!Qo(e))return!1;if("true"===e.getAttribute("contenteditable")||pr(e,\'[contenteditable="true"]\'))return!0;if("grid"===n||"treegrid"===n||"table"===n)return!0;if("landmark"===Bi(n))return!0;if("0"===e.getAttribute("datatable"))return!1;if(e.getAttribute("summary"))return!0;if(e.tHead||e.tFoot||e.caption)return!0;for(var a=0,r=e.children.length;a<r;a++)if("COLGROUP"===e.children[a].nodeName.toUpperCase())return!0;for(var o,u,i,l=0,s=e.rows.length,c=!1,d=0;d<s;d++)for(var p,f=0,D=(p=e.rows[d]).cells.length;f<D;f++){if("TH"===(o=p.cells[f]).nodeName.toUpperCase())return!0;if(c||o.offsetWidth===o.clientWidth&&o.offsetHeight===o.clientHeight||(c=!0),o.getAttribute("scope")||o.getAttribute("headers")||o.getAttribute("abbr"))return!0;if(["columnheader","rowheader"].includes((o.getAttribute("role")||"").toLowerCase()))return!0;if(1===o.children.length&&"ABBR"===o.children[0].nodeName.toUpperCase())return!0;l++}if(e.getElementsByTagName("table").length)return!1;if(s<2)return!1;if(1===(n=e.rows[Math.ceil(s/2)]).cells.length&&1===n.cells[0].colSpan)return!1;if(5<=n.cells.length)return!0;if(c)return!0;for(d=0;d<s;d++){if(p=e.rows[d],u&&u!==t.getComputedStyle(p).getPropertyValue("background-color"))return!0;if(u=t.getComputedStyle(p).getPropertyValue("background-color"),i&&i!==t.getComputedStyle(p).getPropertyValue("background-image"))return!0;i=t.getComputedStyle(p).getPropertyValue("background-image")}return 20<=s||!(Ir(e).width>.95*jr(t).width||l<10||e.querySelector("object, embed, iframe, applet"))},dD=function(e){return!(!Ko(e)&&!Xo(e))||!!e.getAttribute("id")&&(e=wn(e.getAttribute("id")),!!a.querySelector(\'[headers~="\'.concat(e,\'"]\')))},pD=function(e,t,n,a){if(Array.isArray(t)&&(a=n,n=t,t={x:0,y:0}),"string"==typeof e)switch(e){case"left":e={x:-1,y:0};break;case"up":e={x:0,y:-1};break;case"right":e={x:1,y:0};break;case"down":e={x:0,y:1}}return function e(t,n,a,r){var o,u=a[n.y]?a[n.y][n.x]:void 0;return u?"function"==typeof r&&!0===(o=r(u,n,a))?[u]:((o=e(t,{x:n.x+t.x,y:n.y+t.y},a,r)).unshift(u),o):[]}(e,{x:t.x+e.x,y:t.y+e.y},n,a)};var fD=/[;,\\s]/,DD=/^[0-9.]+$/;function mD(e){return e=t.getComputedStyle(function(e){for(var t=e,n=e.textContent.trim(),a=n;a===n&&void 0!==t;){var r=-1;if(0===(e=t).children.length)return e;for(;r++,""===(a=e.children[r].textContent.trim())&&r+1<e.children.length;);t=e.children[r]}return e}(e)),{fontWeight:function(e){switch(e){case"lighter":return 100;case"normal":return 400;case"bold":return 700;case"bolder":return 900}return e=parseInt(e),isNaN(e)?400:e}(e.getPropertyValue("font-weight")),fontSize:parseInt(e.getPropertyValue("font-size")),isItalic:"italic"===e.getPropertyValue("font-style")}}function hD(e,t,n){return n.reduce((function(n,a){return n||(!a.size||e.fontSize/a.size>t.fontSize)&&(!a.weight||e.fontWeight-a.weight>t.fontWeight)&&(!a.italic||e.isItalic&&!t.isItalic)}),!1)}var gD=zp("landmark"),bD=["alert","log","status"];function vD(e){return"caption"===e.props.nodeName}qs=zr;var yD=function(e,t,n){return n.initiator};var FD={emoji:!0,nonBmp:!1,punctuations:!0};var wD=function(e,t){try{return"svg"===t.props.nodeName||!!ca(t,"svg")}catch(e){return!1}};var ED=function(e,t){var n=$o(t);return!(n&&!["none","presentation"].includes(n)&&!(Mo[n]||{}).accessibleNameRequired&&!Qo(t))};var CD=[function(e,t){return xD(t)},function(e,t){return"area"!==t.props.nodeName},function(e,t){return!wD(0,t)},function(e,t){return Qo(t)},function(e,t){return ki(t)||!AD(t)},function(e){return!Ri(e,{noLengthCompare:!0})}];function xD(e){return"widget"===Bi(e)}var AD=Dr((function e(t){return!(null==t||!t.parent)&&(!(!xD(t.parent)||!ki(t.parent))||e(t.parent))})),kD={"abstractrole-evaluate":function(e,t,n){return 0<(n=Gc(n.attr("role")).filter((function(e){return"abstract"===Bi(e)}))).length&&(this.data(n),!0)},"accesskeys-after":function(e){var t={};return e.filter((function(e){if(e.data){var n=e.data.toUpperCase();if(!t[n])return(t[n]=e).relatedNodes=[],!0;t[n].relatedNodes.push(e.relatedNodes[0])}return!1})).map((function(e){return e.result=!!e.relatedNodes.length,e}))},"accesskeys-evaluate":function(e,t,n){return _r(n)||(this.data(n.attr("accesskey")),this.relatedNodes([e])),!0},"alt-space-value-evaluate":function(e,t,n){return"string"==typeof(n=n.attr("alt"))&&/^\\s+$/.test(n)},"aria-allowed-attr-evaluate":function(e,t,n){var a,r=[],o=wu(n),u=Sp(o),i=(Array.isArray(t[o])&&(u=Zd(t[o].concat(u))),Q(n.attrNames));try{for(i.s();!(a=i.n()).done;){var l=a.value;af(l)&&!u.includes(l)&&r.push(l)}}catch(e){i.e(e)}finally{i.f()}return!r.length||(this.data(r.map((function(e){return e+\'="\'+n.attr(e)+\'"\'}))),!(o||Sd(n)||Qo(n))&&void 0)},"aria-allowed-attr-matches":function(e,t){var n=/^aria-/,a=t.attrNames;if(a.length)for(var r=0,o=a.length;r<o;r++)if(n.test(a[r]))return!0;return!1},"aria-allowed-role-evaluate":function(e){var t=2<arguments.length?arguments[2]:void 0,n=void 0===(n=(a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).allowImplicit)||n,a=void 0===(a=a.ignoredTags)?[]:a,r=t.props.nodeName;return!!a.map((function(e){return e.toLowerCase()})).includes(r)||!(a=qp(t,n)).length||(this.data(a),!Pu(t)&&void 0)},"aria-allowed-role-matches":function(e,t){return null!==$o(t,{dpub:!0,fallback:!0})},"aria-busy-evaluate":function(e,t,n){return"true"===n.attr("aria-busy")},"aria-conditional-attr-evaluate":function(e,t,n){var a=wu(n);return!uf[a]||uf[a].call(this,e,t,n)},"aria-conditional-checkbox-attr-evaluate":rf,"aria-conditional-row-attr-evaluate":of,"aria-errormessage-evaluate":function(e,t,n){t=Array.isArray(t)?t:[];var a=n.attr("aria-errormessage"),r=n.hasAttr("aria-errormessage"),o=n.attr("aria-invalid");return!n.hasAttr("aria-invalid")||"false"===o||-1!==t.indexOf(a)||!r||(this.data(Gc(a)),function(e){if(""===e.trim())return qo.ariaAttrs["aria-errormessage"].allowEmpty;var t;try{t=e&&No(n,"aria-errormessage")[0]}catch(t){return void this.data({messageKey:"idrefs",values:Gc(e)})}return t?Pu(t)?"alert"===t.getAttribute("role")||"assertive"===t.getAttribute("aria-live")||"polite"===t.getAttribute("aria-live")||-1<Gc(n.attr("aria-describedby")).indexOf(e):(this.data({messageKey:"hidden",values:Gc(e)}),!1):void 0}.call(this,a))},"aria-has-attr-matches":function(e,t){var n=/^aria-/;return t.attrNames.some((function(e){return n.test(e)}))},"aria-hidden-body-evaluate":function(e,t,n){return"true"!==n.attr("aria-hidden")},"aria-hidden-focus-matches":function(e){return function e(t){return!t||"true"!==t.getAttribute("aria-hidden")&&e(Mr(t))}(Mr(e))},"aria-label-evaluate":function(e,t,n){return!!Zo(Oo(n))},"aria-labelledby-evaluate":function(e,t,n){try{return!!Zo(_o(n))}catch(e){}},"aria-level-evaluate":function(e,t,n){if(n=n.attr("aria-level"),!(6<(n=parseInt(n,10))))return!0},"aria-prohibited-attr-evaluate":function(e){var t,n=2<arguments.length?arguments[2]:void 0,a=(null==(a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{})?void 0:a.elementsAllowedAriaLabel)||[],r=n.props.nodeName,o=wu(n,{chromium:!0});return 0!==(a=function(e,t,n){var a=qo.ariaRoles[e];return a?a.prohibitedAttrs||[]:e||n.includes(t)?[]:["aria-label","aria-labelledby"]}(o,r,a).filter((function(e){return!!n.attrNames.includes(e)&&""!==Zo(n.attr(e))}))).length&&(t=n.hasAttr("role")?"hasRole":"noRole",t+=1<a.length?"Plural":"Singular",this.data({role:o,nodeName:r,messageKey:t,prohibited:a}),o=Bu(n,{subtreeDescendant:!0}),""===Zo(o)||void 0)},"aria-required-attr-evaluate":function(e){var t,n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=2<arguments.length?arguments[2]:void 0,r=$o(a),o=a.attrNames,u=Qp(r);return Array.isArray(n[r])&&(u=Zd(n[r],u)),!(r&&o.length&&u.length&&(n=a,"separator"!==r||Qo(n))&&(o=a,"combobox"!==r||"false"!==o.attr("aria-expanded"))&&(t=gu(a),(n=u.filter((function(e){return!(a.attr(e)||void 0!==(null==(n=(n=t).implicitAttrs)?void 0:n[e]));var n}))).length&&(this.data(n),1)))},"aria-required-children-evaluate":function(e,t,n){t=t&&Array.isArray(t.reviewEmpty)?t.reviewEmpty:[];var a,o,u=$o(n,{dpub:!0}),i=tf(u);return null===i||(a=(n=function(e,t){function n(e){if(1!==(e=r[e]).props.nodeType)return"continue";var n,o=wu(e,{noPresentational:!0}),u=(n=e,Uo().find((function(e){return n.hasAttr(e)}))),i=!!u||Qo(e);!o&&!i||["group","rowgroup"].includes(o)&&t.some((function(e){return e===o}))?r.push.apply(r,$(e.children)):(o||i)&&a.push({role:o,attr:u||"tabindex",ownedElement:e})}for(var a=[],r=Au(e).filter((function(e){return 1!==e.props.nodeType||Pu(e)})),o=0;o<r.length;o++)n(o);return{ownedRoles:a,ownedElements:r}}(n,i)).ownedRoles,n=n.ownedElements,(o=a.filter((function(e){return e=e.role,!i.includes(e)}))).length?(this.relatedNodes(o.map((function(e){return e.ownedElement}))),this.data({messageKey:"unallowed",values:o.map((function(e){var t=e.ownedElement,n=(e=e.attr,t.props),a=n.nodeName;return 3===n.nodeType?"#text":(n=$o(t,{dpub:!0}))?"[role=".concat(n,"]"):e?a+"[".concat(e,"]"):a})).filter((function(e,t,n){return n.indexOf(e)===t})).join(", ")}),!1):!(o=function(e,t){for(var n=0;n<t.length;n++){var a=function(n){var a=t[n].role;if(e.includes(a))return e=e.filter((function(e){return e!==a})),{v:null}}(n);if("object"===r(a))return a.v}return e.length?e:null}(i,a))||(this.data(o),!(!t.includes(u)||n.some(sf))&&void 0))},"aria-required-children-matches":function(e,t){return t=$o(t,{dpub:!0}),!!tf(t)},"aria-required-parent-evaluate":function(e,t,n){var a=t&&Array.isArray(t.ownGroupRoles)?t.ownGroupRoles:[],r=cf(n,a);if(!r)return!0;var o=function(e){for(var t,n=[];e;)e.getAttribute("id")&&(t=wn(e.getAttribute("id")),t=sr(e).querySelector("[aria-owns~=".concat(t,"]")))&&n.push(t),e=e.parentElement;return n.length?n:null}(e);if(o)for(var u=0,i=o.length;u<i;u++)if(!(r=cf(Xn(o[u]),a,r,!0)))return!0;return this.data(r),!1},"aria-required-parent-matches":function(e,t){return t=$o(t),!!ef(t)},"aria-roledescription-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=wu(2<arguments.length?arguments[2]:void 0);return!!(t.supportedRoles||[]).includes(n)||!(!n||"presentation"===n||"none"===n)&&void 0},"aria-unsupported-attr-evaluate":function(e,t,n){return!!(n=n.attrNames.filter((function(t){var n=qo.ariaAttrs[t];return!!af(t)&&(t=n.unsupported,"object"!==r(t)?!!t:!hu(e,t.exceptions))}))).length&&(this.data(n),!0)},"aria-valid-attr-evaluate":function(e,t,n){t=Array.isArray(t.value)?t.value:[];var a=[],r=/^aria-/;return n.attrNames.forEach((function(e){-1===t.indexOf(e)&&r.test(e)&&!af(e)&&a.push(e)})),!a.length||(this.data(a),!1)},"aria-valid-attr-value-evaluate":function(e,t,n){t=Array.isArray(t.value)?t.value:[];var a="",r="",u=[],i=/^aria-/,l=["aria-errormessage"],s={"aria-controls":function(){return"false"!==n.attr("aria-expanded")&&"false"!==n.attr("aria-selected")},"aria-current":function(e){e||(a=\'aria-current="\'.concat(n.attr("aria-current"),\'"\'),r="ariaCurrent")},"aria-owns":function(){return"false"!==n.attr("aria-expanded")},"aria-describedby":function(e){e||(a=\'aria-describedby="\'.concat(n.attr("aria-describedby"),\'"\'),r=o._tree&&o._tree[0]._hasShadowRoot?"noIdShadow":"noId")},"aria-labelledby":function(e){e||(a=\'aria-labelledby="\'.concat(n.attr("aria-labelledby"),\'"\'),r=o._tree&&o._tree[0]._hasShadowRoot?"noIdShadow":"noId")}};return n.attrNames.forEach((function(e){if(!l.includes(e)&&!t.includes(e)&&i.test(e)){var o,c=n.attr(e);try{o=nf(n,e)}catch(o){return a="".concat(e,\'="\').concat(c,\'"\'),void(r="idrefs")}s[e]&&!s[e](o)||o||(""===c&&(o=e,"string"!==(null==(o=qo.ariaAttrs[e])?void 0:o.type))?(a=e,r="empty"):u.push("".concat(e,\'="\').concat(c,\'"\')))}})),u.length?(this.data(u),!1):!a||void this.data({messageKey:r,needsReview:a})},"attr-non-space-content-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=2<arguments.length?arguments[2]:void 0;if(t.attribute&&"string"==typeof t.attribute)return n.hasAttr(t.attribute)?(n=n.attr(t.attribute),!!Zo(n)||(this.data({messageKey:"emptyAttr"}),!1)):(this.data({messageKey:"noAttr"}),!1);throw new TypeError("attr-non-space-content requires options.attribute to be a string")},"autocomplete-appropriate-evaluate":function(e,t,n){var a,o,u;return"input"!==n.props.nodeName||(o={bday:["text","search","date"],email:["text","search","email"],username:["text","search","email"],"street-address":["text"],tel:["text","search","tel"],"tel-country-code":["text","search","tel"],"tel-national":["text","search","tel"],"tel-area-code":["text","search","tel"],"tel-local":["text","search","tel"],"tel-local-prefix":["text","search","tel"],"tel-local-suffix":["text","search","tel"],"tel-extension":["text","search","tel"],"cc-number":a=["text","search","number","tel"],"cc-exp":["text","search","month","tel"],"cc-exp-month":a,"cc-exp-year":a,"cc-csc":a,"transaction-amount":a,"bday-day":a,"bday-month":a,"bday-year":a,"new-password":["text","search","password"],"current-password":["text","search","password"],url:u=["text","search","url"],photo:u,impp:u},"object"===r(t)&&Object.keys(t).forEach((function(e){o[e]||(o[e]=[]),o[e]=o[e].concat(t[e])})),u=(a=n.attr("autocomplete").split(/\\s+/g).map((function(e){return e.toLowerCase()})))[a.length-1],!!oi.stateTerms.includes(u))||(a=o[u],u=n.hasAttr("type")?Zo(n.attr("type")).toLowerCase():"text",u=vp().includes(u)?u:"text",void 0===a?"text"===u:a.includes(u))},"autocomplete-matches":function(e,t){if(!(n=t.attr("autocomplete"))||""===Zo(n))return!1;if(n=t.props.nodeName,!1===["textarea","input","select"].includes(n))return!1;if("input"===n&&["submit","reset","button","hidden"].includes(t.props.type))return!1;if(n=t.attr("aria-disabled")||"false",t.hasAttr("disabled")||"true"===n.toLowerCase())return!1;var n=t.attr("role"),a=t.attr("tabindex");return("-1"!==a||!n||void 0!==(n=qo.ariaRoles[n])&&"widget"===n.type)&&!("-1"===a&&t.actualNode&&!zr(t)&&!Pu(t))},"autocomplete-valid-evaluate":function(e,t,n){return n=n.attr("autocomplete")||"",ui(n,t)},"avoid-inline-spacing-evaluate":function(e,t){return!(0<(t=t.cssProperties.filter((function(t){if("important"===e.style.getPropertyPriority(t))return t}))).length&&(this.data(t),1))},"bypass-matches":function(e,t,n){return!yD(0,0,n)||!!e.querySelector("a[href]")},"caption-evaluate":function(e,t,n){return!cp(n,"track").some((function(e){return"captions"===(e.attr("kind")||"").toLowerCase()}))&&void 0},"caption-faked-evaluate":function(e){var t=Go(e),n=t[0];return t.length<=1||n.length<=1||e.rows.length<=1||n.reduce((function(e,t,a){return e||t!==n[a+1]&&void 0!==n[a+1]}),!1)},"color-contrast-evaluate":function(e,n,a){var r=n.ignoreUnicode,o=n.ignoreLength,u=n.ignorePseudo,i=n.boldValue,l=n.boldTextPt,s=n.largeTextPt,c=n.contrastRatio,d=n.shadowOutlineEmMax,p=n.pseudoSizeThreshold;if(!zr(e))return this.data({messageKey:"hidden"}),!0;var f=ju(a,!1,!0);if(r&&(v=Ju(r=f,b={nonBmp:!0}),r=""===Zo(ai(r,b)),v)&&r)this.data({messageKey:"nonBmp"});else{var D,m,h,g,b=t.getComputedStyle(e),v=parseFloat(b.getPropertyValue("font-size"));r=b.getPropertyValue("font-weight"),i=parseFloat(r)>=i||"bold"===r,r=Math.ceil(72*v)/96,r=(l=i&&r<l||!i&&r<s?c.normal:c.large).expected,s=l.minThreshold,c=l.maxThreshold,l=function(e,t){var n=void 0===(n=t.pseudoSizeThreshold)?.25:n;if(!(t=void 0!==(t=t.ignorePseudo)&&t)){var a=(t=e.boundingClientRect).width*t.height*n;do{if(a<Pf(e.actualNode,":before")+Pf(e.actualNode,":after"))return e}while(e=e.parent)}}(a,{ignorePseudo:u,pseudoSizeThreshold:p});if(!l)return p=Sf(e,!(a=[]),u=Nf(e,a,d),n),m=D=n=null,0===(e=Cf(e,{minRatio:.001,maxRatio:d})).length?n=Of(u,p):p&&u&&(m=[].concat($(e),[u]).reduce(wf),d=Of(u,p),e=Of(u,m),h=Of(m,p),(n=Math.max(d,e,h))!==d)&&(D=h<e?"shadowOnBgColor":"fgOnShadowColor"),d=r<n,"number"==typeof s&&("number"!=typeof n||n<s)||"number"==typeof c&&("number"!=typeof n||c<n)?(this.data({contrastRatio:n}),!0):(h=Math.floor(100*n)/100,null===u?g=Pi.get("bgColor"):d||(g=D),e=1===f.length,(s=1==h)?g=Pi.set("bgColor","equalRatio"):d||!e||o||(g="shortTextContent"),this.data({fgColor:p?p.toHexString():void 0,bgColor:u?u.toHexString():void 0,contrastRatio:h,fontSize:"".concat((72*v/96).toFixed(1),"pt (").concat(v,"px)"),fontWeight:i?"bold":"normal",messageKey:g,expectedContrastRatio:r+":1",shadowColor:m?m.toHexString():void 0}),null===p||null===u||s||e&&!o&&!d?(g=null,Pi.clear(),void this.relatedNodes(a)):(d||this.relatedNodes(a),d));this.data({fontSize:"".concat((72*v/96).toFixed(1),"pt (").concat(v,"px)"),fontWeight:i?"bold":"normal",messageKey:"pseudoContent",expectedContrastRatio:r+":1"}),this.relatedNodes(l.actualNode)}},"color-contrast-matches":function(e,n){var r=(o=n.props).nodeName,o=o.type;if("option"!==r&&("select"!==r||e.options.length)&&!("input"===r&&["hidden","range","color","checkbox","radio","image"].includes(o)||rD(n)||io(n))){if(["input","select","textarea"].includes(r)){if(o=t.getComputedStyle(e),o=parseInt(o.getPropertyValue("text-indent"),10)){var u={top:(u=e.getBoundingClientRect()).top,bottom:u.bottom,left:u.left+o,right:u.right+o};if(!zc(u,e))return!1}return!0}if(o=dr(n,"label"),"label"===r||o){if(u=o||e,r=o?Xn(o):n,u.htmlFor&&(u=(o=sr(u).getElementById(u.htmlFor))&&Xn(o))&&rD(u))return!1;if((o=cp(r,\'input:not([type="hidden"],[type="image"],[type="button"],[type="submit"],[type="reset"]), select, textarea\')[0])&&rD(o))return!1}for(var i,l=[],s=n;s;)s.props.id&&(i=Pp(s).filter((function(e){return Gc(e.getAttribute("aria-labelledby")||"").includes(s.props.id)})).map((function(e){return Xn(e)})),l.push.apply(l,$(i))),s=s.parent;if(!(0<l.length&&l.every(rD))&&""!==(r=ju(u=n,!1,!0))&&""!==ai(r,FD)&&u.children.some((function(e){return"#text"===e.props.nodeName&&!Qu(e)}))){for(var c=a.createRange(),d=n.children,p=0;p<d.length;p++){var f=d[p];3===f.actualNode.nodeType&&""!==Zo(f.actualNode.nodeValue)&&c.selectNodeContents(f.actualNode)}for(var D=c.getClientRects(),m=0;m<D.length;m++)if(zc(D[m],e))return!0}}return!1},"css-orientation-lock-evaluate":function(e,t,n,a){a=void 0===(a=(a||{}).cssom)?void 0:a;var r=void 0===(t=(t||{}).degreeThreshold)?0:t;if(a&&a.length){function o(){var e=c[s],t=(e=l[e]).root;if(!(e=e.rules.filter(d)).length)return"continue";e.forEach((function(e){e=e.cssRules,Array.from(e).forEach((function(e){var n=function(e){var t=e.selectorText;e=e.style;return!(!t||e.length<=0)&&(!(!(t=e.transform||e.webkitTransform||e.msTransform||!1)&&!e.rotate)&&(t=function(e){return e&&(e=e.match(/(rotate|rotateZ|rotate3d|matrix|matrix3d)\\(([^)]+)\\)(?!.*(rotate|rotateZ|rotate3d|matrix|matrix3d))/))?p((e=G(e,3))[1],e=e[2]):0}(t),!!(t+=e=p("rotate",e.rotate))&&(t=Math.abs(t),!(Math.abs(t-180)%180<=r)&&Math.abs(t-90)%90<=r)))}(e);n&&"HTML"!==e.selectorText.toUpperCase()&&(e=Array.from(t.querySelectorAll(e.selectorText))||[],i=i.concat(e)),u=u||n}))}))}for(var u=!1,i=[],l=a.reduce((function(e,t){var n=t.sheet,a=t.root;return e[t=(t=t.shadowId)||"topDocument"]||(e[t]={root:a,rules:[]}),n&&n.cssRules&&(a=Array.from(n.cssRules),e[t].rules=e[t].rules.concat(a)),e}),{}),s=0,c=Object.keys(l);s<c.length;s++)o();return!u||(i.length&&this.relatedNodes(i),!1)}function d(e){var t=e.type;e=e.cssText;return 4===t&&(/orientation:\\s*landscape/i.test(e)||/orientation:\\s*portrait/i.test(e))}function p(e,t){switch(e){case"rotate":case"rotateZ":return f(t);case"rotate3d":var n=G(t.split(",").map((function(e){return e.trim()})),4),a=n[2];n=n[3];return 0===parseInt(a)?void 0:f(n);case"matrix":case"matrix3d":var r,o;return(a=(a=t).split(",")).length<=6?(r=(o=G(a,2))[0],o=o[1],D(Math.atan2(parseFloat(o),parseFloat(r)))):(o=parseFloat(a[8]),r=Math.asin(o),o=Math.cos(r),D(Math.acos(parseFloat(a[0])/o)));default:return 0}}function f(e){var t=G(e.match(/(deg|grad|rad|turn)/)||[],1)[0];if(!t)return 0;var n=parseFloat(e.replace(t,""));switch(t){case"rad":return D(n);case"grad":var a=n;return(a%=400)<0&&(a+=400),Math.round(a/400*360);case"turn":return Math.round(360/(1/n));default:return parseInt(n)}}function D(e){return Math.round(e*(180/Math.PI))}},"data-table-large-matches":function(e){return!!cD(e)&&3<=(e=Go(e)).length&&3<=e[0].length&&3<=e[1].length&&3<=e[2].length},"data-table-matches":function(e){return cD(e)},"deprecatedrole-evaluate":function(e,t,n){n=wu(n,{dpub:!0,fallback:!0});var a=qo.ariaRoles[n];return!(null==a||!a.deprecated||(this.data(n),0))},"dlitem-evaluate":function(e){var t=(e=Mr(e)).nodeName.toUpperCase(),n=$o(e);return"DIV"===t&&["presentation","none",null].includes(n)&&(t=(e=Mr(e)).nodeName.toUpperCase(),n=$o(e)),"DL"===t&&!(n&&!["presentation","none","list"].includes(n))},"doc-has-title-evaluate":function(){var e=a.title;return!!Zo(e)},"duplicate-id-active-matches":function(e){var t=e.getAttribute("id").trim();return t=\'*[id="\'.concat(wn(t),\'"]\'),t=Array.from(sr(e).querySelectorAll(t)),!Kp(e)&&t.some(Qo)},"duplicate-id-after":function(e){var t=[];return e.filter((function(e){return-1===t.indexOf(e.data)&&(t.push(e.data),!0)}))},"duplicate-id-aria-matches":function(e){return Kp(e)},"duplicate-id-evaluate":function(e){var t,n=e.getAttribute("id").trim();return!n||(t=sr(e),(t=Array.from(t.querySelectorAll(\'[id="\'.concat(wn(n),\'"]\'))).filter((function(t){return t!==e}))).length&&this.relatedNodes(t),this.data(n),0===t.length)},"duplicate-id-misc-matches":function(e){var t=e.getAttribute("id").trim();return t=\'*[id="\'.concat(wn(t),\'"]\'),t=Array.from(sr(e).querySelectorAll(t)),!Kp(e)&&t.every((function(e){return!Qo(e)}))},"duplicate-img-label-evaluate":function(e,t,n){return!["none","presentation"].includes(wu(n))&&!!(t=ca(n,t.parentSelector))&&""!==(t=ju(t,!0).toLowerCase())&&t===ni(n).toLowerCase()},"exists-evaluate":function(){},"explicit-evaluate":function(e,t,n){var a=this;if(!n.attr("id"))return!1;if(n.actualNode){var r=sr(n.actualNode),o=wn(n.attr("id"));r=Array.from(r.querySelectorAll(\'label[for="\'.concat(o,\'"]\')));if(this.relatedNodes(r),!r.length)return!1;try{return r.some((function(e){return!zr(e)||(e=Zo(Ro(e,{inControlContext:!0,startNode:n})),a.data({explicitLabel:e}),!!e)}))}catch(e){}}},"fallbackrole-evaluate":function(e,t,n){var a=Gc(n.attr("role"));return!(a.length<=1)&&(!(!bu(n)&&2===a.length&&a.includes("none")&&a.includes("presentation"))||void 0)},"focusable-content-evaluate":function(e,t,n){var a=n.tabbableElements;return!!a&&0<a.filter((function(e){return e!==n})).length},"focusable-disabled-evaluate":function(e,t,n){var a=["button","fieldset","input","select","textarea"];return!((n=n.tabbableElements)&&n.length&&(n=n.filter((function(e){return a.includes(e.props.nodeName)})),this.relatedNodes(n.map((function(e){return e.actualNode}))),0!==n.length)&&!_i())||!!n.every((function(e){var t=e.getComputedStylePropertyValue("pointer-events"),n=parseInt(e.getComputedStylePropertyValue("width")),a=parseInt(e.getComputedStylePropertyValue("height"));return e.actualNode.onfocus||(0===n||0===a)&&"none"===t}))&&void 0},"focusable-element-evaluate":function(e,t,n){return!(!n.hasAttr("contenteditable")||!function e(t){return"true"===(t=t.attr("contenteditable"))||""===t||"false"!==t&&(!!(t=ca(n.parent,"[contenteditable]"))&&e(t))}(n))||ki(n)},"focusable-modal-open-evaluate":function(e,t,n){return!(n=n.tabbableElements.map((function(e){return e.actualNode})))||!n.length||!_i()||void this.relatedNodes(n)},"focusable-no-name-evaluate":function(e,t,n){var a=n.attr("tabindex");if(!(Qo(n)&&-1<a))return!1;try{return!ni(n)}catch(e){}},"focusable-not-tabbable-evaluate":function(e,t,n){var a=["button","fieldset","input","select","textarea"];return!((n=n.tabbableElements)&&n.length&&(n=n.filter((function(e){return!a.includes(e.props.nodeName)})),this.relatedNodes(n.map((function(e){return e.actualNode}))),0!==n.length)&&!_i())||!!n.every((function(e){var t=e.getComputedStylePropertyValue("pointer-events"),n=parseInt(e.getComputedStylePropertyValue("width")),a=parseInt(e.getComputedStylePropertyValue("height"));return e.actualNode.onfocus||(0===n||0===a)&&"none"===t}))&&void 0},"frame-focusable-content-evaluate":function(e,t,n){if(n.children)try{return!n.children.some((function e(t){if(ki(t))return!0;if(!t.children){if(1===t.props.nodeType)throw new Error("Cannot determine children");return!1}return t.children.some((function(t){return e(t)}))}))}catch(e){}},"frame-focusable-content-matches":function(e,t,n){var a;return!n.initiator&&!n.focusable&&1<(null==(a=n.size)?void 0:a.width)*(null==(a=n.size)?void 0:a.height)},"frame-tested-after":function(e){var t={};return e.filter((function(e){var n;return"html"!==e.node.ancestry[e.node.ancestry.length-1]?(n=e.node.ancestry.flat(1/0).join(" > "),t[n]=e,!0):(n=e.node.ancestry.slice(0,e.node.ancestry.length-1).flat(1/0).join(" > "),t[n]&&(t[n].result=!0),!1)}))},"frame-tested-evaluate":function(e,t){return!t.isViolation&&void 0},"frame-title-has-text-matches":function(e){return e=e.getAttribute("title"),!!Zo(e)},"has-alt-evaluate":function(e,t,n){var a=n.props.nodeName;return!!["img","input","area"].includes(a)&&n.hasAttr("alt")},"has-descendant-after":function(e){return e.some((function(e){return!0===e.result}))&&e.forEach((function(e){e.result=!0})),e},"has-descendant-evaluate":function(e,t,n){if(t&&t.selector&&"string"==typeof t.selector)return!(!t.passForModal||!_i())||(n=ep(n,t.selector,Pu),this.relatedNodes(n.map((function(e){return e.actualNode}))),0<n.length);throw new TypeError("has-descendant requires options.selector to be a string")},"has-global-aria-attribute-evaluate":function(e,t,n){var a=Uo().filter((function(e){return n.hasAttr(e)}));return this.data(a),0<a.length},"has-implicit-chromium-role-matches":function(e,t){return null!==bu(t,{chromium:!0})},"has-lang-evaluate":function(e,t,n){var r=void 0!==a&&Nn(a);return t.attributes.includes("xml:lang")&&t.attributes.includes("lang")&&Gf(n.attr("xml:lang"))&&!Gf(n.attr("lang"))&&!r?(this.data({messageKey:"noXHTML"}),!1):!!t.attributes.some((function(e){return Gf(n.attr(e))}))||(this.data({messageKey:"noLang"}),!1)},"has-text-content-evaluate":function(e,t,n){try{return""!==Zo(Bu(n))}catch(e){}},"has-widget-role-evaluate":function(e){return null!==(e=e.getAttribute("role"))&&("widget"===(e=Bi(e))||"composite"===e)},"heading-matches":function(e,t){return"heading"===wu(t)},"heading-order-after":function(e){(t=$(t=e)).sort((function(e,t){return e=e.node,t=t.node,e.ancestry.length-t.ancestry.length}));var t,n=t.reduce(Qf,[]).filter((function(e){return-1!==e.level}));return e.forEach((function(e){e.result=function(e,t){var n=null!=(n=null==(n=t[e=eD(t,e.node.ancestry)])?void 0:n.level)?n:-1;t=null!=(t=null==(t=t[e-1])?void 0:t.level)?t:-1;return 0===e||(-1!==n?n-t<=1:void 0)}(e,n)})),e},"heading-order-evaluate":function(){var e,t=Kn.get("headingOrder");return t||(t=(e=ep(o._tree[0],"h1, h2, h3, h4, h5, h6, [role=heading], iframe, frame",Pu)).map((function(e){return{ancestry:[Gn(e.actualNode)],level:(t=(t=wu(e))&&t.includes("heading"),n=e.attr("aria-level"),a=parseInt(n,10),e=G(e.props.nodeName.match(/h(\\d)/)||[],2)[1],t?e&&!n?parseInt(e,10):isNaN(a)||a<1?e?parseInt(e,10):2:a||-1:-1)};var t,n,a})),this.data({headingOrder:t}),Kn.set("headingOrder",e)),!0},"help-same-as-label-evaluate":function(e,t,n){n=si(n);var a=e.getAttribute("title");return!!n&&(a||(a="",e.getAttribute("aria-describedby")&&(a=No(e,"aria-describedby").map((function(e){return e?Ro(e):""})).join(""))),Zo(a)===Zo(n))},"hidden-content-evaluate":function(e,n,a){if(!["SCRIPT","HEAD","TITLE","NOSCRIPT","STYLE","TEMPLATE"].includes(e.nodeName.toUpperCase())&&vi(a)){if("none"===(a=t.getComputedStyle(e)).getPropertyValue("display"))return;if("hidden"===a.getPropertyValue("visibility")&&(!(e=(a=Mr(e))&&t.getComputedStyle(a))||"hidden"!==e.getPropertyValue("visibility")))return}return!0},"hidden-explicit-label-evaluate":function(e,t,n){if(n.hasAttr("id")){if(!n.actualNode)return;var a,r=sr(e);e=wn(e.getAttribute("id"));if((r=r.querySelector(\'label[for="\'.concat(e,\'"]\')))&&!Pu(r)){try{a=ni(n).trim()}catch(e){return}return""===a}}return!1},"html-namespace-matches":function(e,t){return!wD(0,t)},"html5-scope-evaluate":function(e){return!Ai(a)||"TH"===e.nodeName.toUpperCase()},"identical-links-same-purpose-after":function(e){if(e.length<2)return e;function t(e){var t=n[e],u=t.data,i=u.name,l=u.urlProps;if(o[i])return"continue";var s=(u=n.filter((function(t,n){return t.data.name===i&&n!==e}))).every((function(e){return function e(t,n){var a,o;return!(!t||!n)&&(a=Object.getOwnPropertyNames(t),o=Object.getOwnPropertyNames(n),a.length===o.length)&&a.every((function(a){var o=t[a];a=n[a];return r(o)===r(a)&&("object"===r(o)||"object"===r(a)?e(o,a):o===a)}))}(e.data.urlProps,l)}));u.length&&!s&&(t.result=void 0),t.relatedNodes=[],(s=t.relatedNodes).push.apply(s,$(u.map((function(e){return e.relatedNodes[0]})))),o[i]=u,a.push(t)}for(var n=e.filter((function(e){return void 0!==e.result})),a=[],o={},u=0;u<n.length;u++)t(u);return a},"identical-links-same-purpose-evaluate":function(e,t,n){if(n=To.accessibleTextVirtual(n),n=To.sanitize(To.removeUnicode(n,{emoji:!0,nonBmp:!0,punctuations:!0})).toLowerCase())return n={name:n,urlProps:ir.urlPropsFromAttribute(e,"href")},this.data(n),this.relatedNodes([e]),!0},"identical-links-same-purpose-matches":function(e,t){return!(!ni(t)||(t=wu(e))&&"link"!==t)},"implicit-evaluate":function(e,t,n){try{var a,r=ca(n,"label");return!!r&&(a=Zo(ni(r,{inControlContext:!0,startNode:n})),r.actualNode&&this.relatedNodes([r.actualNode]),this.data({implicitLabel:a}),!!a)}catch(e){}},"inline-style-property-evaluate":function(e,n){var a=n.cssProperty,r=n.absoluteValues,o=n.minValue,u=n.maxValue,i=void 0===(i=n.normalValue)?0:i,l=n.noImportant;n=n.multiLineOnly;return!!(!l&&"important"!==e.style.getPropertyPriority(a)||n&&!Oi(e))||(l={},"number"==typeof o&&(l.minValue=o),"number"==typeof u&&(l.maxValue=u),n=e.style.getPropertyValue(a),["inherit","unset","revert","revert-layer"].includes(n)?(this.data(U({value:n},l)),!0):(n=function(e,n){var a=n.cssProperty,r=n.absoluteValues;n=n.normalValue;return"normal"===(a=(e=t.getComputedStyle(e)).getPropertyValue(a))?n:(n=parseFloat(a),r?n:(r=parseFloat(e.getPropertyValue("font-size")),e=Math.round(n/r*100)/100,isNaN(e)?a:e))}(e,{absoluteValues:r,cssProperty:a,normalValue:i}),this.data(U({value:n},l)),"number"==typeof n?("number"!=typeof o||o<=n)&&("number"!=typeof u||n<=u):void 0))},"inserted-into-focus-order-matches":function(e){return wi(e)},"internal-link-present-evaluate":function(e,t,n){return cp(n,"a[href]").some((function(e){return/^#[^/!]/.test(e.attr("href"))}))},"invalid-children-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=2<arguments.length?arguments[2]:void 0,a=[],r=[];if(n.children){for(var o=Wf(n.children);o.length;){var u=(i=o.shift()).vChild,i=i.nested;if(t.divGroups&&!i&&"div"===(l=u).props.nodeName&&null===$o(l)){if(!u.children)return;var l=Wf(u.children,!0);o.push.apply(o,$(l))}else l=function(e,t,n){var a=void 0===(a=n.validRoles)?[]:a,r=(n=void 0===(n=n.validNodeNames)?[]:n,(u=e.props).nodeName),o=u.nodeType,u=u.nodeValue;t=t?"div > ":"";return 3===o&&""!==u.trim()?t+"#text":!(1!==o||!Pu(e))&&((u=$o(e))?!a.includes(u)&&t+"[role=".concat(u,"]"):!n.includes(r)&&t+r)}(u,i,t),l&&(r.includes(l)||r.push(l),1===(null==u||null==(i=u.actualNode)?void 0:i.nodeType))&&a.push(u.actualNode)}return 0!==r.length&&(this.data({values:r.join(", ")}),this.relatedNodes(a),!0)}},"invalidrole-evaluate":function(e,t,n){return!!(n=Gc(n.attr("role"))).every((function(e){return!Vo(e,{allowAbstract:!0})}))&&(this.data(n),!0)},"is-element-focusable-evaluate":function(e,t,n){return Qo(n)},"is-initiator-matches":yD,"is-on-screen-evaluate":qs,"is-visible-matches":zr,"is-visible-on-screen-matches":function(e,t){return zr(t)},"label-content-name-mismatch-evaluate":function(e,t,n){var a=null==t?void 0:t.pixelThreshold,r=null!=(r=null==t?void 0:t.occurrenceThreshold)?r:null==t?void 0:t.occuranceThreshold;if(t=Ro(e).toLowerCase(),!(ri(t)<1))return!(e=Zo(Bu(n,{subtreeDescendant:!0,ignoreIconLigature:!0,pixelThreshold:a,occurrenceThreshold:r})).toLowerCase())||(ri(e)<1?!!Hf(e,t)||void 0:Hf(e,t))},"label-content-name-mismatch-matches":function(e,t){var n=wu(e);return!!(n&&zp("widget").includes(n)&&$p().includes(n)&&(Zo(Oo(t))||Zo(_o(e)))&&Zo(ju(t)))},"label-matches":function(e,t){return"input"!==t.props.nodeName||!1===t.hasAttr("type")||(t=t.attr("type").toLowerCase(),!1===["hidden","image","button","submit","reset"].includes(t))},"landmark-has-body-context-matches":function(e,t){return e.hasAttribute("role")||!dr(t,"article, aside, main, nav, section")},"landmark-is-top-level-evaluate":function(e){var t=zp("landmark"),n=Mr(e),a=wu(e);for(this.data({role:a});n;){var r=n.getAttribute("role");if((r=r||"FORM"===n.nodeName.toUpperCase()?r:bu(n))&&t.includes(r)&&("main"!==r||"complementary"!==a))return!1;n=Mr(n)}return!0},"landmark-is-unique-after":function(e){var t=[];return e.filter((function(e){var n=t.find((function(t){return e.data.role===t.data.role&&e.data.accessibleText===t.data.accessibleText}));return n?(n.result=!1,n.relatedNodes.push(e.relatedNodes[0]),!1):(t.push(e),e.relatedNodes=[],!0)}))},"landmark-is-unique-evaluate":function(e,t,n){var a=wu(e);return n=(n=ni(n))?n.toLowerCase():null,this.data({role:a,accessibleText:n}),this.relatedNodes([e]),!0},"landmark-unique-matches":function(e,t){var n,a,r,o=["article","aside","main","nav","section"].join(",");return n=t.actualNode,a=zp("landmark"),!!(r=wu(n))&&("HEADER"===(n=n.nodeName.toUpperCase())||"FOOTER"===n?!ca(t,o):"SECTION"===n||"FORM"===n?!!ni(t):0<=a.indexOf(r)||"region"===r)&&Pu(e)},"layout-table-matches":function(e){return!cD(e)&&!Qo(e)},"link-in-text-block-evaluate":function(e,t){var n=t.requiredContrastRatio;if(t=t.allowSameColor,qf(e))return!1;for(var a=Mr(e);a&&1===a.nodeType&&!qf(a);)a=Mr(a);if(a){this.relatedNodes([a]);var r=Sf(e),o=Sf(a),u=(e=Nf(e),Nf(a)),i=r&&o?jf(r,o):void 0;if((i=i&&Math.floor(100*i)/100)&&n<=i)return!0;var l=e&&u?jf(e,u):void 0;if((l=l&&Math.floor(100*l)/100)&&n<=l)return!0;if(l){if(i)return!(!t||1!==i||1!==l)||(1===i&&1<l?this.data({messageKey:"bgContrast",contrastRatio:l,requiredContrastRatio:n,nodeBackgroundColor:e?e.toHexString():void 0,parentBackgroundColor:u?u.toHexString():void 0}):this.data({messageKey:"fgContrast",contrastRatio:i,requiredContrastRatio:n,nodeColor:r?r.toHexString():void 0,parentColor:o?o.toHexString():void 0}),!1)}else l=null!=(t=Pi.get("bgColor"))?t:"bgContrast",this.data({messageKey:l}),Pi.clear()}},"link-in-text-block-matches":function(e){var t=Zo(e.innerText),n=e.getAttribute("role");return!(n&&"link"!==n||!t||!zr(e))&&Ri(e)},"link-in-text-block-style-evaluate":function(e){if(Vf(e))return!1;for(var n=Mr(e);n&&1===n.nodeType&&!Vf(n);)n=Mr(n);return n?(this.relatedNodes([n]),!!hf(e,n)||!!function(e){for(var n=0,a=["before","after"];n<a.length;n++){var r=a[n];if("none"!==t.getComputedStyle(e,":".concat(r)).getPropertyValue("content"))return 1}}(e)&&void this.data({messageKey:"pseudoContent"})):void 0},"listitem-evaluate":function(e,t,n){var a;if(n=n.parent)return a=n.props.nodeName,n=$o(n),!!["presentation","none","list"].includes(n)||(n&&Vo(n)?(this.data({messageKey:"roleNotValid"}),!1):["ul","ol","menu"].includes(a))},"matches-definition-evaluate":function(e,t,n){return hu(n,t.matcher)},"meta-refresh-evaluate":function(e,t,n){var a=(r=t||{}).minDelay,r=r.maxDelay;return!(n=G((n.attr("content")||"").trim().split(fD),1)[0]).match(DD)||(n=parseFloat(n),this.data({redirectDelay:n}),"number"==typeof a&&n<=t.minDelay)||"number"==typeof r&&n>t.maxDelay},"meta-viewport-scale-evaluate":function(e,t,n){var a,r=void 0===(r=(t=t||{}).scaleMinimum)?2:r;return t=void 0!==(t=t.lowerBound)&&t,!((n=n.attr("content")||"")&&(n=n.split(/[;,]/).reduce((function(e,t){var n;return(t=t.trim())&&(n=(t=G(t.split("="),2))[0],t=t[1],n)&&t&&(n=n.toLowerCase().trim(),t=t.toLowerCase().trim(),"maximum-scale"===n&&"yes"===t&&(t=1),"maximum-scale"===n&&parseFloat(t)<0||(e[n]=t)),e}),{}),!(t&&n["maximum-scale"]&&parseFloat(n["maximum-scale"])<t))&&(t||"no"!==n["user-scalable"]?(a=parseFloat(n["user-scalable"]),!t&&n["user-scalable"]&&(a||0===a)&&-1<a&&a<1?(this.data("user-scalable"),1):n["maximum-scale"]&&parseFloat(n["maximum-scale"])<r&&(this.data("maximum-scale"),1)):(this.data("user-scalable=no"),1)))},"multiple-label-evaluate":function(e){var t=wn(e.getAttribute("id")),n=e.parentNode,a=(a=sr(e)).documentElement||a,r=Array.from(a.querySelectorAll(\'label[for="\'.concat(t,\'"]\')));for(r.length&&(r=r.filter((function(e){return!_r(e)})));n;)"LABEL"===n.nodeName.toUpperCase()&&-1===r.indexOf(n)&&r.push(n),n=n.parentNode;return this.relatedNodes(r),1<r.length&&(1<(a=r.filter(Pu)).length||!No(e,"aria-labelledby").includes(a[0]))&&void 0},"nested-interactive-matches":function(e,t){return!!(t=wu(t))&&!!qo.ariaRoles[t].childrenPresentational},"no-autoplay-audio-evaluate":function(e,t){var n,a;if(e.duration)return t=void 0===(t=t.allowedDuration)?3:t,((n=e).currentSrc?(a=function(e){if(e=e.match(/#t=(.*)/))return G(e,2)[1].split(",").map((function(e){if(/:/.test(e)){for(var t=e.split(":"),n=0,a=1;0<t.length;)n+=a*parseInt(t.pop(),10),a*=60;return parseFloat(n)}return parseFloat(e)}))}(n.currentSrc))?1!==a.length?Math.abs(a[1]-a[0]):Math.abs(n.duration-a[0]):Math.abs(n.duration-(n.currentTime||0)):0)<=t&&!e.hasAttribute("loop")||!!e.hasAttribute("controls");console.warn("axe.utils.preloadMedia did not load metadata")},"no-autoplay-audio-matches":function(e){return!!e.currentSrc&&!e.hasAttribute("paused")&&!e.hasAttribute("muted")},"no-empty-role-matches":function(e,t){return!!t.hasAttr("role")&&!!t.attr("role").trim()},"no-explicit-name-required-matches":ED,"no-focusable-content-evaluate":function(e,t,n){if(n.children)try{var a,r=function e(t){if(!t.children){if(1===t.props.nodeType)throw new Error("Cannot determine children");return[]}var n=[];return t.children.forEach((function(t){"widget"===Bi(t)&&Qo(t)?n.push(t):n.push.apply(n,$(e(t)))})),n}(n);return!r.length||(0<(a=r.filter($f)).length?(this.data({messageKey:"notHidden"}),this.relatedNodes(a)):this.relatedNodes(r),!1)}catch(e){}},"no-implicit-explicit-label-evaluate":function(e,t,n){var a,r,o=wu(n,{noImplicit:!0});this.data(o);try{a=Zo(Tu(n)).toLowerCase(),r=Zo(ni(n)).toLowerCase()}catch(e){return}return!(!r&&!a||(r||!a)&&r.includes(a))&&void 0},"no-naming-method-matches":function(e,t){var n=gu(t).namingMethods;return!(n&&0!==n.length||"combobox"===$o(t)&&cp(t,\'input:not([type="hidden"])\').length||Xp(t,{popupRoles:["listbox"]}))},"no-negative-tabindex-matches":function(e,t){return t=parseInt(t.attr("tabindex"),10),isNaN(t)||0<=t},"no-role-matches":function(e,t){return!t.attr("role")},"non-empty-if-present-evaluate":function(e,t,n){var a=n.props.nodeName,r=(n.attr("type")||"").toLowerCase();return(n=n.attr("value"))&&this.data({messageKey:"has-label"}),!("input"!==a||!["submit","reset"].includes(r))&&null===n},"not-html-matches":function(e,t){return"html"!==t.props.nodeName},"object-is-loaded-matches":function(e,t){return[ED,function(e){var t;return null==e||null==(t=e.ownerDocument)||!t.createRange||((t=e.ownerDocument.createRange()).setStart(e,0),t.setEnd(e,e.childNodes.length),0===t.getClientRects().length)}].every((function(n){return n(e,t)}))},"only-dlitems-evaluate":function(e,t,n){var a=["definition","term","list"];return(n=n.children.reduce((function(e,t){var n=t.actualNode;return"DIV"===n.nodeName.toUpperCase()&&null===wu(n)?e.concat(t.children):e.concat(t)}),[]).reduce((function(e,t){var n,r=(t=t.actualNode).nodeName.toUpperCase();return 1===t.nodeType&&Pu(t)?(n=$o(t),("DT"!==r&&"DD"!==r||n)&&!a.includes(n)&&e.badNodes.push(t)):3===t.nodeType&&""!==t.nodeValue.trim()&&(e.hasNonEmptyTextNode=!0),e}),{badNodes:[],hasNonEmptyTextNode:!1})).badNodes.length&&this.relatedNodes(n.badNodes),!!n.badNodes.length||n.hasNonEmptyTextNode},"only-listitems-evaluate":function(e,t,n){var a=!1,r=!1,o=!0,u=[],i=[],l=[];if(n.children.forEach((function(e){var t,n,s=e.actualNode;3===s.nodeType&&""!==s.nodeValue.trim()?a=!0:1===s.nodeType&&Pu(s)&&(o=!1,t="LI"===s.nodeName.toUpperCase(),n="listitem"===(e=wu(e)),t||n||u.push(s),t&&!n&&(i.push(s),l.includes(e)||l.push(e)),n)&&(r=!0)})),a||u.length)this.relatedNodes(u);else{if(o||r)return!1;this.relatedNodes(i),this.data({messageKey:"roleNotValid",roles:l.join(", ")})}return!0},"p-as-heading-evaluate":function(e,t,n){var a=(u=Array.from(e.parentNode.children)).indexOf(e),r=(t=t||{}).margins||[],o=u.slice(a+1).find((function(e){return"P"===e.nodeName.toUpperCase()})),u=u.slice(0,a).reverse().find((function(e){return"P"===e.nodeName.toUpperCase()})),i=(a=mD(e),o?mD(o):null),l=(u=u?mD(u):null,t.passLength);return t=t.failLength,e=e.textContent.trim().length,(o=null==o?void 0:o.textContent.trim().length)*l<e||!i||!hD(a,i,r)||!!((l=dr(n,"blockquote"))&&"BLOCKQUOTE"===l.nodeName.toUpperCase()||u&&!hD(a,u,r)||o*t<e)&&void 0},"p-as-heading-matches":function(e){var t=Array.from(e.parentNode.childNodes),n=e.textContent.trim();return!(0===n.length||2<=(n.match(/[.!?:;](?![.!?:;])/g)||[]).length)&&0!==t.slice(t.indexOf(e)+1).filter((function(e){return"P"===e.nodeName.toUpperCase()&&""!==e.textContent.trim()})).length},"page-no-duplicate-after":function(e){return e.filter((function(e){return"ignored"!==e.data}))},"page-no-duplicate-evaluate":function(e,t,n){if(!t||!t.selector||"string"!=typeof t.selector)throw new TypeError("page-no-duplicate requires options.selector to be a string");var a="page-no-duplicate;"+t.selector;if(!Kn.get(a))return Kn.set(a,!0),a=ep(o._tree[0],t.selector,Pu),"string"==typeof t.nativeScopeFilter&&(a=a.filter((function(e){return e.actualNode.hasAttribute("role")||!dr(e,t.nativeScopeFilter)}))),this.relatedNodes(a.filter((function(e){return e!==n})).map((function(e){return e.actualNode}))),a.length<=1;this.data("ignored")},"presentation-role-conflict-matches":function(e,t){return null!==bu(t,{chromiumRoles:!0})},"presentational-role-evaluate":function(e,t,n){var a=$o(n);if(["presentation","none"].includes(a)&&["iframe","frame"].includes(n.props.nodeName)&&n.hasAttr("title"))this.data({messageKey:"iframe",nodeName:n.props.nodeName});else{var r,o=wu(n);if(["presentation","none"].includes(o))return this.data({role:o}),!0;["presentation","none"].includes(a)&&(a=Uo().some((function(e){return n.hasAttr(e)})),r=Qo(n),this.data({messageKey:a&&!r?"globalAria":!a&&r?"focusable":"both",role:o}))}return!1},"region-after":function(e){var t=e.filter((function(e){return e.data.isIframe}));return e.forEach((function(e){if(!e.result&&1!==e.node.ancestry.length){var n,a=e.node.ancestry.slice(0,-1),r=Q(t);try{for(r.s();!(n=r.n()).done;){var o=n.value;if(Id(a,o.node.ancestry)){e.result=o.result;break}}}catch(e){r.e(e)}finally{r.f()}}})),t.forEach((function(e){e.result||(e.result=!0)})),e},"region-evaluate":function(e,t,n){return this.data({isIframe:["iframe","frame"].includes(n.props.nodeName)}),!Kn.get("regionlessNodes",(function(){return function e(t,n){var r=t.actualNode;if("button"===wu(t)||function(e,t){var n=e.actualNode,a=wu(e);return n=(n.getAttribute("aria-live")||"").toLowerCase().trim(),!!(["assertive","polite"].includes(n)||bD.includes(a)||gD.includes(a)||t.regionMatcher&&hu(e,t.regionMatcher))}(t,n)||["iframe","frame"].includes(t.props.nodeName)||Tc(t.actualNode)&&ho(t.actualNode,"href")||!Pu(r)){for(var o=t;o;)o._hasRegionDescendant=!0,o=o.parent;return["iframe","frame"].includes(t.props.nodeName)?[t]:[]}return r!==a.body&&yi(r,!0)?[t]:t.children.filter((function(e){return 1===(e=e.actualNode).nodeType})).map((function(t){return e(t,n)})).reduce((function(e,t){return e.concat(t)}),[])}(o._tree[0],t).map((function(e){for(;e.parent&&!e.parent._hasRegionDescendant&&e.parent.actualNode!==a.body;)e=e.parent;return e})).filter((function(e,t,n){return n.indexOf(e)===t}))})).includes(n)},"same-caption-summary-evaluate":function(e,t,n){var a;if(void 0!==n.children)return a=n.attr("summary"),!(!(n=!!(n=n.children.find(vD))&&Zo(Bu(n)))||!a)&&Zo(a).toLowerCase()===Zo(n).toLowerCase()},"scope-value-evaluate":function(e,t){return e=e.getAttribute("scope").toLowerCase(),-1!==t.values.indexOf(e)},"scrollable-region-focusable-matches":function(e,t){return void 0!==Ad(e,13)&&!1===Xp(t)&&cp(t,"*").some((function(e){return vi(e,!0,!0)}))},"skip-link-evaluate":function(e){return!!(e=ho(e,"href"))&&(Pu(e)||void 0)},"skip-link-matches":function(e){return Tc(e)&&Lr(e)},"structured-dlitems-evaluate":function(e,t,n){var a=n.children;if(!a||!a.length)return!1;for(var r,o=!1,u=!1,i=0;i<a.length;i++){if((o="DT"===(r=a[i].props.nodeName.toUpperCase())||o)&&"DD"===r)return!1;"DD"===r&&(u=!0)}return o||u},"svg-namespace-matches":wD,"svg-non-empty-title-evaluate":function(e,t,n){if(n.children){if(n=n.children.find((function(e){return"title"===e.props.nodeName})),!n)return this.data({messageKey:"noTitle"}),!1;try{if(""===Bu(n,{includeHidden:!0}).trim())return this.data({messageKey:"emptyTitle"}),!1}catch(e){return}return!0}},"tabindex-evaluate":function(e,t,n){return n=parseInt(n.attr("tabindex"),10),!!isNaN(n)||n<=0},"table-or-grid-role-matches":function(e,t){return t=wu(t),["treegrid","grid","table"].includes(t)},"target-offset-evaluate":function(e,t,n){var a,r,o=(null==t?void 0:t.minOffset)||24,u=[],i=o,l=Q(ao(n,o));try{for(l.s();!(a=l.n()).done;){var s,c=a.value;"widget"===Bi(c)&&Qo(c)&&(r=yo(n,c),o<=.05+(s=Math.round(10*r)/10)||(i=Math.min(i,s),u.push(c)))}}catch(e){l.e(e)}finally{l.f()}return 0===u.length?(this.data({closestOffset:i,minOffset:o}),!0):(this.relatedNodes(u.map((function(e){return e.actualNode}))),u.some(ki)?(this.data({closestOffset:i,minOffset:o}),!ki(n)&&void 0):void this.data({messageKey:"nonTabbableNeighbor",closestOffset:i,minOffset:o}))},"target-size-evaluate":function(e,t,n){t=(null==t?void 0:t.minSize)||24;var a,r,o=n.boundingClientRect,u=Zf.bind(null,t),i=ao(n),l=(a=n,i.filter((function(e){return!Yf(e,a)&&Xf(a,e)}))),s=(i=function(e,t){var n,a=[],r=[],o=Q(t);try{for(o.s();!(n=o.n()).done;){var u=n.value;!Xf(e,u)&&wo(e,u)&&"none"!==u.getComputedStylePropertyValue("pointer-events")&&(Yf(e,u)?a:r).push(u)}}catch(e){o.e(e)}finally{o.f()}return{fullyObscuringElms:a,partialObscuringElms:r}}(n,i)).fullyObscuringElms;i=i.partialObscuringElms;return s.length&&!l.length?(this.relatedNodes(Jf(s)),this.data({messageKey:"obscured"}),!0):(r=!ki(n)&&void 0,u(o)||l.length?(i=function(e,t){return e=e.boundingClientRect,0===t.length?null:(t=t.map((function(e){return e.boundingClientRect})),function(e,t){return e.reduce((function(e,n){var a=Zf(t,e);return a!==Zf(t,n)?a?e:n:(a=e.width*e.height,n.width*n.height<a?e:n)}))}(Eo(e,t)))}(n,n=i.filter((function(e){return"widget"===Bi(e)&&Qo(e)}))),!l.length||!s.length&&u(i||o)?0===n.length||u(i)?(this.data(U({minSize:t},Kf(i||o))),this.relatedNodes(Jf(n)),!0):(s=n.every(ki),u="partiallyObscured".concat(s?"":"NonTabbable"),this.data(U({messageKey:u,minSize:t},Kf(i))),this.relatedNodes(Jf(n)),s?r:void 0):(this.data({minSize:t,messageKey:"contentOverflow"}),void this.relatedNodes(Jf(l)))):(this.data(U({minSize:t},Kf(o))),r))},"td-has-header-evaluate":function(e){var t=[],n=uD(e),a=Go(e);return n.forEach((function(e){yi(e)&&sD(e)&&!Jp(e)&&!lD(e,a).some((function(e){return null!==e&&!!yi(e)}))&&t.push(e)})),!t.length||(this.relatedNodes(t),!1)},"td-headers-attr-evaluate":function(e){for(var t=[],n=[],a=[],r=0;r<e.rows.length;r++)for(var o=e.rows[r],u=0;u<o.cells.length;u++)t.push(o.cells[u]);var i=t.reduce((function(e,t){return t.getAttribute("id")&&e.push(t.getAttribute("id")),e}),[]);return t.forEach((function(e){var t,r=!1;if(e.hasAttribute("headers")&&Pu(e))return(t=e.getAttribute("headers").trim())?void(0!==(t=Gc(t)).length&&(e.getAttribute("id")&&(r=-1!==t.indexOf(e.getAttribute("id").trim())),t=t.some((function(e){return!i.includes(e)})),r||t)&&a.push(e)):n.push(e)})),0<a.length?(this.relatedNodes(a),!1):!n.length||void this.relatedNodes(n)},"th-has-data-cells-evaluate":function(e){var t=uD(e),n=this,a=[],r=(t=(t.forEach((function(e){var t;(t=((t=e.getAttribute("headers"))&&(a=a.concat(t.split(/\\s+/))),e.getAttribute("aria-labelledby")))&&(a=a.concat(t.split(/\\s+/)))})),t.filter((function(e){return""!==Zo(e.textContent)&&("TH"===e.nodeName.toUpperCase()||-1!==["rowheader","columnheader"].indexOf(e.getAttribute("role")))}))),Go(e)),o=!0;return t.forEach((function(e){var t,u;e.getAttribute("id")&&a.includes(e.getAttribute("id"))||(t=Wo(e,r),u=!1,(u=!(u=Ko(e)?pD("down",t,r).find((function(t){return!Ko(t)&&lD(t,r).includes(e)})):u)&&Xo(e)?pD("right",t,r).find((function(t){return!Xo(t)&&lD(t,r).includes(e)})):u)||n.relatedNodes(e),o=o&&u)})),!!o||void 0},"title-only-evaluate":function(e,t,n){var a=si(n),r=Cu(n);return n=n.attr("aria-describedby"),!(a||!r&&!n)},"unique-frame-title-after":function(e){var t={};return e.forEach((function(e){t[e.data]=void 0!==t[e.data]?++t[e.data]:0})),e.forEach((function(e){e.result=!!t[e.data]})),e},"unique-frame-title-evaluate":function(e,t,n){return n=Zo(n.attr("title")).toLowerCase(),this.data(n),!0},"unsupportedrole-evaluate":function(e,t,n){n=wu(n,{dpub:!0,fallback:!0});var a=zo(n);return a&&this.data(n),a},"valid-lang-evaluate":function(e,t,n){var a=[];return t.attributes.forEach((function(e){var r,o,u=n.attr(e);"string"==typeof u&&(r=nd(u),o=t.value?!t.value.map(nd).includes(r):!Ep(r),""!==r&&o||""!==u&&!Zo(u))&&a.push(e+\'="\'+n.attr(e)+\'"\')})),!!a.length&&!("html"!==n.props.nodeName&&!Fi(n)||(this.data(a),0))},"valid-scrollable-semantics-evaluate":function(e,t){return(n=$o(n=e))&&(pf[n]||t.roles.includes(n))||(t=(t=e).nodeName.toUpperCase(),df[t])||!1;var n},"widget-not-inline-matches":function(e,t){return CD.every((function(n){return n(e,t)}))},"window-is-top-matches":function(e){return e.ownerDocument.defaultView.self===e.ownerDocument.defaultView.top},"xml-lang-mismatch-evaluate":function(e,t,n){return nd(n.attr("lang"))===nd(n.attr("xml:lang"))},"xml-lang-mismatch-matches":function(e){var t=nd(e.getAttribute("lang"));e=nd(e.getAttribute("xml:lang"));return Ep(t)&&Ep(e)}},BD=function(e){this.id=e.id,this.data=null,this.relatedNodes=[],this.result=null};function TD(e){if("string"!=typeof e)return e;if(kD[e])return kD[e];if(/^\\s*function[\\s\\w]*\\(/.test(e))return new Function("return "+e+";")();throw new ReferenceError("Function ID does not exist in the metadata-function-map: ".concat(e))}function ND(e){var t=0<arguments.length&&void 0!==e?e:{};return Array.isArray(t)||"object"!==r(t)?{value:t}:t}function RD(e){e&&(this.id=e.id,this.configure(e))}RD.prototype.enabled=!0,RD.prototype.run=function(e,t,n,a,r){var o=((t=t||{}).hasOwnProperty("enabled")?t:this).enabled,u=this.getOptions(t.options);if(o){var i;o=new BD(this),t=Qn(o,t,a,r);try{i=this.evaluate.call(t,e.actualNode,u,e,n)}catch(t){return e&&e.actualNode&&(t.errorNode=new Jn(e).toJSON()),void r(t)}t.isAsync||(o.result=i,a(o))}else a(null)},RD.prototype.runSync=function(e,t,n){if(!(void 0===(r=(t=t||{}).enabled)?this.enabled:r))return null;var a,r=this.getOptions(t.options),o=new BD(this);(t=Qn(o,t)).async=function(){throw new Error("Cannot run async check while in a synchronous run")};try{a=this.evaluate.call(t,e.actualNode,r,e,n)}catch(t){throw e&&e.actualNode&&(t.errorNode=new Jn(e).toJSON()),t}return o.result=a,o},RD.prototype.configure=function(e){var t=this;e.evaluate&&!kD[e.evaluate]||(this._internalCheck=!0),e.hasOwnProperty("enabled")&&(this.enabled=e.enabled),e.hasOwnProperty("options")&&(this._internalCheck?this.options=ND(e.options):this.options=e.options),["evaluate","after"].filter((function(t){return e.hasOwnProperty(t)})).forEach((function(n){return t[n]=TD(e[n])}))},RD.prototype.getOptions=function(e){return this._internalCheck?ar(this.options,ND(e||{})):e||this.options};var _D=RD,OD=function(e){this.id=e.id,this.result=tn.NA,this.pageLevel=e.pageLevel,this.impact=null,this.nodes=[]};function SD(e,t){this._audit=t,this.id=e.id,this.selector=e.selector||"*",e.impact&&(yn(tn.impact.includes(e.impact),"Impact ".concat(e.impact," is not a valid impact")),this.impact=e.impact),this.excludeHidden="boolean"!=typeof e.excludeHidden||e.excludeHidden,this.enabled="boolean"!=typeof e.enabled||e.enabled,this.pageLevel="boolean"==typeof e.pageLevel&&e.pageLevel,this.reviewOnFail="boolean"==typeof e.reviewOnFail&&e.reviewOnFail,this.any=e.any||[],this.all=e.all||[],this.none=e.none||[],this.tags=e.tags||[],this.preload=!!e.preload,this.actIds=e.actIds,e.matches&&(this.matches=TD(e.matches))}function MD(e){var t,n;if(e.length)return t=!1,n={},e.forEach((function(e){var a=e.results.filter((function(e){return e}));(n[e.type]=a).length&&(t=!0)})),t?n:null}SD.prototype.matches=function(){return!0},SD.prototype.gather=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n="mark_gather_start_"+this.id,a="mark_gather_end_"+this.id,r="mark_isVisibleToScreenReaders_start_"+this.id,o="mark_isVisibleToScreenReaders_end_"+this.id,u=(t.performanceTimer&&Yd.mark(n),mp(this.selector,e));return this.excludeHidden&&(t.performanceTimer&&Yd.mark(r),u=u.filter(Pu),t.performanceTimer)&&(Yd.mark(o),Yd.measure("rule_"+this.id+"#gather_axe.utils.isVisibleToScreenReaders",r,o)),t.performanceTimer&&(Yd.mark(a),Yd.measure("rule_"+this.id+"#gather",n,a)),u},SD.prototype.runChecks=function(e,t,n,a,r,o){var u=this,i=ha();this[e].forEach((function(e){var r=u._audit.checks[e.id||e],o=dd(r,u.id,n);i.defer((function(e,n){r.run(t,o,a,e,n)}))})),i.then((function(t){t=t.filter((function(e){return e})),r({type:e,results:t})})).catch(o)},SD.prototype.runChecksSync=function(e,t,n,a){var r=this,o=[];return this[e].forEach((function(e){e=r._audit.checks[e.id||e];var u=dd(e,r.id,n);o.push(e.runSync(t,u,a))})),{type:e,results:o=o.filter((function(e){return e}))}},SD.prototype.run=function(e){var t,n=this,a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},r=2<arguments.length?arguments[2]:void 0,o=3<arguments.length?arguments[3]:void 0,i=(a.performanceTimer&&this._trackPerformance(),ha()),l=new OD(this);try{t=this.gatherAndMatchNodes(e,a)}catch(t){return void o(new u({cause:t,ruleId:this.id}))}a.performanceTimer&&this._logGatherPerformance(t),t.forEach((function(t){i.defer((function(r,o){var u=ha();["any","all","none"].forEach((function(r){u.defer((function(o,u){n.runChecks(r,t,a,e,o,u)}))})),u.then((function(e){var o=MD(e);o&&(o.node=new Jn(t,a),l.nodes.push(o),n.reviewOnFail)&&(["any","all"].forEach((function(e){o[e].forEach((function(e){!1===e.result&&(e.result=void 0)}))})),o.none.forEach((function(e){!0===e.result&&(e.result=void 0)}))),r()})).catch((function(e){return o(e)}))}))})),i.defer((function(e){return setTimeout(e,0)})),a.performanceTimer&&this._logRulePerformance(),i.then((function(){return r(l)})).catch((function(e){return o(e)}))},SD.prototype.runSync=function(e){var t,n=this,a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},r=(a.performanceTimer&&this._trackPerformance(),new OD(this));try{t=this.gatherAndMatchNodes(e,a)}catch(t){throw new u({cause:t,ruleId:this.id})}return a.performanceTimer&&this._logGatherPerformance(t),t.forEach((function(t){var o=[],u=(["any","all","none"].forEach((function(r){o.push(n.runChecksSync(r,t,a,e))})),MD(o));u&&(u.node=t.actualNode?new Jn(t,a):null,r.nodes.push(u),n.reviewOnFail)&&(["any","all"].forEach((function(e){u[e].forEach((function(e){!1===e.result&&(e.result=void 0)}))})),u.none.forEach((function(e){!0===e.result&&(e.result=void 0)})))})),a.performanceTimer&&this._logRulePerformance(),r},SD.prototype._trackPerformance=function(){this._markStart="mark_rule_start_"+this.id,this._markEnd="mark_rule_end_"+this.id,this._markChecksStart="mark_runchecks_start_"+this.id,this._markChecksEnd="mark_runchecks_end_"+this.id},SD.prototype._logGatherPerformance=function(e){nn("gather (",e.length,"):",Yd.timeElapsed()+"ms"),Yd.mark(this._markChecksStart)},SD.prototype._logRulePerformance=function(){Yd.mark(this._markChecksEnd),Yd.mark(this._markEnd),Yd.measure("runchecks_"+this.id,this._markChecksStart,this._markChecksEnd),Yd.measure("rule_"+this.id,this._markStart,this._markEnd)},SD.prototype.gatherAndMatchNodes=function(e,t){var n=this,a="mark_matches_start_"+this.id,r="mark_matches_end_"+this.id,o=this.gather(e,t);return t.performanceTimer&&Yd.mark(a),o=o.filter((function(t){return n.matches(t.actualNode,t,e)})),t.performanceTimer&&(Yd.mark(r),Yd.measure("rule_"+this.id+"#matches",a,r)),o},SD.prototype.after=function(e,t){var n,a,r,o=this,u=Za(n=this).map((function(e){return(e=n._audit.checks[e.id||e])&&"function"==typeof e.after?e:null})).filter(Boolean),i=this.id;return u.forEach((function(n){u=e.nodes,a=n.id,r=[],u.forEach((function(e){Za(e).forEach((function(t){t.id===a&&(t.node=e.node,r.push(t))}))}));var a,r,u=r,l=dd(n,i,t),s=n.after(u,l);o.reviewOnFail&&s.forEach((function(e){var t=(o.any.includes(e.id)||o.all.includes(e.id))&&!1===e.result,n=o.none.includes(e.id)&&!0===e.result;(t||n)&&(e.result=void 0)})),u.forEach((function(e){delete e.node,-1===s.indexOf(e)&&(e.filtered=!0)}))})),e.nodes=(a=["any","all","none"],r=(u=e).nodes.filter((function(e){var t=0;return a.forEach((function(n){e[n]=e[n].filter((function(e){return!0!==e.filtered})),t+=e[n].length})),0<t})),r=u.pageLevel&&r.length?[r.reduce((function(e,t){if(e)return a.forEach((function(n){e[n].push.apply(e[n],t[n])})),e}))]:r),e},SD.prototype.configure=function(e){e.hasOwnProperty("selector")&&(this.selector=e.selector),e.hasOwnProperty("excludeHidden")&&(this.excludeHidden="boolean"!=typeof e.excludeHidden||e.excludeHidden),e.hasOwnProperty("enabled")&&(this.enabled="boolean"!=typeof e.enabled||e.enabled),e.hasOwnProperty("pageLevel")&&(this.pageLevel="boolean"==typeof e.pageLevel&&e.pageLevel),e.hasOwnProperty("reviewOnFail")&&(this.reviewOnFail="boolean"==typeof e.reviewOnFail&&e.reviewOnFail),e.hasOwnProperty("any")&&(this.any=e.any),e.hasOwnProperty("all")&&(this.all=e.all),e.hasOwnProperty("none")&&(this.none=e.none),e.hasOwnProperty("tags")&&(this.tags=e.tags),e.hasOwnProperty("actIds")&&(this.actIds=e.actIds),e.hasOwnProperty("matches")&&(this.matches=TD(e.matches)),e.impact&&(yn(tn.impact.includes(e.impact),"Impact ".concat(e.impact," is not a valid impact")),this.impact=e.impact)};var PD=SD,ID=re(Xt()),jD=/\\{\\{.+?\\}\\}/g;function LD(){return t.origin&&"null"!==t.origin?t.origin:t.location&&t.location.origin&&"null"!==t.location.origin?t.location.origin:void 0}function qD(e,t,n){for(var a=0,r=e.length;a<r;a++)t[n](e[a])}function zD(e){K(this,zD),this.lang="en",this.defaultConfig=e,this.standards=qo,this._init(),this._defaultLocale=null}function VD(e,t,n){return n.performanceTimer&&Yd.mark("mark_rule_start_"+e.id),function(a,r){e.run(t,n,(function(e){a(e)}),(function(t){n.debug?r(t):(t=Object.assign(new OD(e),{result:tn.CANTTELL,description:"An error occured while running this rule",message:t.message,stack:t.stack,error:t,errorNode:t.errorNode}),a(t))}))}}function $D(e,t,n){var a=e.brand,r=e.application;e=e.lang;return tn.helpUrlBase+a+"/"+(n||o.version.substring(0,o.version.lastIndexOf(".")))+"/"+t+"?application="+encodeURIComponent(r)+(e&&"en"!==e?"&lang="+encodeURIComponent(e):"")}Z(zD,[{key:"_setDefaultLocale",value:function(){if(!this._defaultLocale){for(var e={checks:{},rules:{},failureSummaries:{},incompleteFallbackMessage:"",lang:this.lang},t=Object.keys(this.data.checks),n=0;n<t.length;n++){var a=t[n],r=(u=this.data.checks[a].messages).pass,o=u.fail,u=u.incomplete;e.checks[a]={pass:r,fail:o,incomplete:u}}for(var i=Object.keys(this.data.rules),l=0;l<i.length;l++){var s=i[l],c=(d=this.data.rules[s]).description,d=d.help;e.rules[s]={description:c,help:d}}for(var p=Object.keys(this.data.failureSummaries),f=0;f<p.length;f++){var D=p[f],m=this.data.failureSummaries[D].failureMessage;e.failureSummaries[D]={failureMessage:m}}e.incompleteFallbackMessage=this.data.incompleteFallbackMessage,this._defaultLocale=e}}},{key:"_resetLocale",value:function(){var e=this._defaultLocale;e&&this.applyLocale(e)}},{key:"_applyCheckLocale",value:function(e){for(var t,n,a,o=Object.keys(e),u=0;u<o.length;u++){var i=o[u];if(!this.data.checks[i])throw new Error(\'Locale provided for unknown check: "\'.concat(i,\'"\'));this.data.checks[i]=(t=this.data.checks[i],a=n=void 0,n=(i=e[i]).pass,a=i.fail,"string"==typeof n&&jD.test(n)&&(n=ID.default.compile(n)),"string"==typeof a&&jD.test(a)&&(a=ID.default.compile(a)),U({},t,{messages:{pass:n||t.messages.pass,fail:a||t.messages.fail,incomplete:"object"===r(t.messages.incomplete)?U({},t.messages.incomplete,i.incomplete):i.incomplete}}))}}},{key:"_applyRuleLocale",value:function(e){for(var t,n,a=Object.keys(e),r=0;r<a.length;r++){var o=a[r];if(!this.data.rules[o])throw new Error(\'Locale provided for unknown rule: "\'.concat(o,\'"\'));this.data.rules[o]=(t=this.data.rules[o],n=void 0,n=(o=e[o]).help,o=o.description,"string"==typeof n&&jD.test(n)&&(n=ID.default.compile(n)),"string"==typeof o&&jD.test(o)&&(o=ID.default.compile(o)),U({},t,{help:n||t.help,description:o||t.description}))}}},{key:"_applyFailureSummaries",value:function(e){for(var t=Object.keys(e),n=0;n<t.length;n++){var a=t[n];if(!this.data.failureSummaries[a])throw new Error(\'Locale provided for unknown failureMessage: "\'.concat(a,\'"\'));this.data.failureSummaries[a]=function(e,t){return U({},e,{failureMessage:(t="string"==typeof(t=t.failureMessage)&&jD.test(t)?ID.default.compile(t):t)||e.failureMessage})}(this.data.failureSummaries[a],e[a])}}},{key:"applyLocale",value:function(e){var t,n;this._setDefaultLocale(),e.checks&&this._applyCheckLocale(e.checks),e.rules&&this._applyRuleLocale(e.rules),e.failureSummaries&&this._applyFailureSummaries(e.failureSummaries,"failureSummaries"),e.incompleteFallbackMessage&&(this.data.incompleteFallbackMessage=(t=this.data.incompleteFallbackMessage,(n="string"==typeof(n=e.incompleteFallbackMessage)&&jD.test(n)?ID.default.compile(n):n)||t)),e.lang&&(this.lang=e.lang)}},{key:"setAllowedOrigins",value:function(e){var t,n=LD(),a=(this.allowedOrigins=[],Q(e));try{for(a.s();!(t=a.n()).done;){var r=t.value;if(r===tn.allOrigins)return void(this.allowedOrigins=["*"]);r!==tn.sameOrigin?this.allowedOrigins.push(r):n&&this.allowedOrigins.push(n)}}catch(e){a.e(e)}finally{a.f()}}},{key:"_init",value:function(){(t=this.defaultConfig)?(e=ea(t)).commons=t.commons:e={},e.reporter=e.reporter||null,e.noHtml=e.noHtml||!1,e.allowedOrigins||(t=LD(),e.allowedOrigins=t?[t]:[]),e.rules=e.rules||[],e.checks=e.checks||[],e.data=U({checks:{},rules:{}},e.data);var e,t=e;this.lang=t.lang||"en",this.reporter=t.reporter,this.commands={},this.rules=[],this.checks={},this.brand="axe",this.application="axeAPI",this.tagExclude=["experimental"],this.noHtml=t.noHtml,this.allowedOrigins=t.allowedOrigins,qD(t.rules,this,"addRule"),qD(t.checks,this,"addCheck"),this.data={},this.data.checks=t.data&&t.data.checks||{},this.data.rules=t.data&&t.data.rules||{},this.data.failureSummaries=t.data&&t.data.failureSummaries||{},this.data.incompleteFallbackMessage=t.data&&t.data.incompleteFallbackMessage||"",this._constructHelpUrls()}},{key:"registerCommand",value:function(e){this.commands[e.id]=e.callback}},{key:"addRule",value:function(e){e.metadata&&(this.data.rules[e.id]=e.metadata);var t=this.getRule(e.id);t?t.configure(e):this.rules.push(new PD(e,this))}},{key:"addCheck",value:function(e){var t=e.metadata;"object"===r(t)&&(this.data.checks[e.id]=t,"object"===r(t.messages))&&Object.keys(t.messages).filter((function(e){return t.messages.hasOwnProperty(e)&&"string"==typeof t.messages[e]})).forEach((function(e){0===t.messages[e].indexOf("function")&&(t.messages[e]=new Function("return "+t.messages[e]+";")())})),this.checks[e.id]?this.checks[e.id].configure(e):this.checks[e.id]=new _D(e)}},{key:"run",value:function(e,t,n,a){this.normalizeOptions(t),o._selectCache=[],i=this.rules,r=e,u=t;var r,u,i=i.reduce((function(e,t){return pp(t,r,u)&&(t.preload?e.later:e.now).push(t),e}),{now:[],later:[]}),l=i.now,s=i.later,c=ha();l.forEach((function(n){c.defer(VD(n,e,t))})),i=ha();(l=(s.length&&i.defer((function(e){ip(t).then((function(t){return e(t)})).catch((function(t){console.warn("Couldn\'t load preload assets: ",t),e(void 0)}))})),ha())).defer(c),l.defer(i),l.then((function(r){var u,i=r.pop(),l=(i&&i.length&&(i=i[0])&&(e=U({},e,i)),r[0]);s.length?(u=ha(),s.forEach((function(n){n=VD(n,e,t),u.defer(n)})),u.then((function(e){o._selectCache=void 0,n(l.concat(e).filter((function(e){return!!e})))})).catch(a)):(o._selectCache=void 0,n(l.filter((function(e){return!!e}))))})).catch(a)}},{key:"after",value:function(e,t){var n=this.rules;return e.map((function(e){var a=Ja(n,"id",e.id);if(a)return a.after(e,t);throw new Error("Result for unknown rule. You may be running mismatch axe-core versions")}))}},{key:"getRule",value:function(e){return this.rules.find((function(t){return t.id===e}))}},{key:"normalizeOptions",value:function(e){var t=[],n=[];if(this.rules.forEach((function(e){n.push(e.id),e.tags.forEach((function(e){t.includes(e)||t.push(e)}))})),["object","string"].includes(r(e.runOnly))){if("string"==typeof e.runOnly&&(e.runOnly=[e.runOnly]),Array.isArray(e.runOnly)){var a=e.runOnly.find((function(e){return t.includes(e)})),u=e.runOnly.find((function(e){return n.includes(e)}));if(a&&u)throw new Error("runOnly cannot be both rules and tags");e.runOnly=u?{type:"rule",values:e.runOnly}:{type:"tag",values:e.runOnly}}if((a=e.runOnly).value&&!a.values&&(a.values=a.value,delete a.value),!Array.isArray(a.values)||0===a.values.length)throw new Error("runOnly.values must be a non-empty array");if(["rule","rules"].includes(a.type))a.type="rule",a.values.forEach((function(e){if(!n.includes(e))throw new Error("unknown rule `"+e+"` in options.runOnly")}));else{if(!["tag","tags",void 0].includes(a.type))throw new Error("Unknown runOnly type \'".concat(a.type,"\'"));a.type="tag",u=a.values.filter((function(e){return!t.includes(e)&&!/wcag2[1-3]a{1,3}/.test(e)})),0!==u.length&&o.log("Could not find tags `"+u.join("`, `")+"`")}}return"object"===r(e.rules)&&Object.keys(e.rules).forEach((function(e){if(!n.includes(e))throw new Error("unknown rule `"+e+"` in options.rules")})),e}},{key:"setBranding",value:function(e){var t={brand:this.brand,application:this.application};"string"==typeof e&&(this.application=e),e&&e.hasOwnProperty("brand")&&e.brand&&"string"==typeof e.brand&&(this.brand=e.brand),e&&e.hasOwnProperty("application")&&e.application&&"string"==typeof e.application&&(this.application=e.application),this._constructHelpUrls(t)}},{key:"_constructHelpUrls",value:function(){var e=this,t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null,n=(o.version.match(/^[1-9][0-9]*\\.[0-9]+/)||["x.y"])[0];this.rules.forEach((function(a){e.data.rules[a.id]||(e.data.rules[a.id]={});var r=e.data.rules[a.id];("string"!=typeof r.helpUrl||t&&r.helpUrl===$D(t,a.id,n))&&(r.helpUrl=$D(e,a.id,n))}))}},{key:"resetRulesAndChecks",value:function(){this._init(),this._resetLocale()}}]);var HD=zD;function UD(){Kn.get("globalDocumentSet")&&(Kn.set("globalDocumentSet",!1),a=null),Kn.get("globalWindowSet")&&(Kn.set("globalWindowSet",!1),t=null)}var GD=function(){UD(),o._memoizedFns.forEach((function(e){return e.clear()})),Kn.clear(),o._tree=void 0,o._selectorData=void 0,o._selectCache=void 0},WD=function(e,t,n,a){try{e=new Ed(e),o._tree=e.flatTree,o._selectorData=qn(e.flatTree)}catch(r){return GD(),a(r)}var r=ha(),u=o._audit;t.performanceTimer&&Yd.auditStart(),e.frames.length&&!1!==t.iframes&&r.defer((function(n,a){tr(e,t,"rules",null,n,a)})),r.defer((function(n,a){u.run(e,t,n,a)})),r.then((function(r){try{t.performanceTimer&&Yd.auditEnd();var o=er(r.map((function(e){return{results:e}})));e.initiator&&((o=u.after(o,t)).forEach(sp),o=o.map(mn));try{n(o,GD)}catch(r){GD(),nn(r)}}catch(r){GD(),a(r)}})).catch((function(e){GD(),a(e)}))};function YD(e){this._run=e.run,this._collect=e.collect,this._registry={},e.commands.forEach((function(e){o._audit.registerCommand(e)}))}function KD(e){var t,n=(e=G(e,3))[0],u=e[1],i=(e=e[2],new TypeError("axe.run arguments are invalid"));if(!md(t=n)&&!hd(t)){if(void 0!==e)throw i;e=u,u=n,n=a}if("object"!==r(u)){if(void 0!==e)throw i;e=u,u={}}if("function"!=typeof e&&void 0!==e)throw i;return(u=ea(u)).reporter=null!=(t=null!=(t=u.reporter)?t:null==(i=o._audit)?void 0:i.reporter)?t:"v1",{context:n,options:u,callback:e}}t.top!==t&&(Ga.subscribe("axe.start",(function(e,t,n){function r(e){e instanceof Error==0&&(e=new Error(e)),n(e)}var u=n,i=e&&e.context||{},l=(i.hasOwnProperty("include")&&!i.include.length&&(i.include=[a]),e&&e.options||{});switch(e.command){case"rules":return WD(i,l,(function(e,t){u(e),t()}),r);case"cleanup-plugin":return Tp(u,r);default:if(o._audit&&o._audit.commands&&o._audit.commands[e.command])return o._audit.commands[e.command](e,n)}})),Ga.subscribe("axe.ping",(function(e,t,n){n({axe:!0})}))),YD.prototype.run=function(){return this._run.apply(this,arguments)},YD.prototype.collect=function(){return this._collect.apply(this,arguments)},YD.prototype.cleanup=function(e){var t=o.utils.queue(),n=this;Object.keys(this._registry).forEach((function(e){t.defer((function(t){n._registry[e].cleanup(t)}))})),t.then(e)},YD.prototype.add=function(e){this._registry[e.id]=e};var XD=function(){};function ZD(e){var t=e.node,n=V(e,y);n.node=t.toJSON();for(var a=0,r=["any","all","none"];a<r.length;a++){var o=r[a];n[o]=n[o].map((function(e){var t=e.relatedNodes;return U({},V(e,F),{relatedNodes:t.map((function(e){return e.toJSON()}))})}))}return n}var JD=function(e,t,n){if("function"==typeof t&&(n=t,t={}),!e||!Array.isArray(e))return n(e);n(e.map((function(e){for(var t=U({},e),n=0,a=["passes","violations","incomplete","inapplicable"];n<a.length;n++){var r=a[n];t[r]&&Array.isArray(t[r])&&(t[r]=t[r].map((function(e){var t,n=e.node;e=V(e,C);return U({node:n="function"==typeof(null==(t=n)?void 0:t.toJSON)?n.toJSON():n},e)})))}return t})))};Vs={base:{Audit:HD,CheckResult:BD,Check:_D,Context:Ed,RuleResult:OD,Rule:PD,metadataFunctionMap:kD},public:{reporters:Np},helpers:{failureSummary:ad,incompleteFallbackMessage:rd,processAggregate:ud},utils:{setDefaultFrameMessenger:Ha,cacheNodeSelectors:Jc,getNodesMatchingExpression:Yc,convertSelector:ia},commons:{dom:{nativelyHidden:yr,displayHidden:Fr,visibilityHidden:wr,contentVisibiltyHidden:Er,ariaHidden:Cr,opacityHidden:xr,scrollHidden:Ar,overflowHidden:kr,clipHidden:Br,areaHidden:Tr,detailsHidden:Nr}}};o._thisWillBeDeletedDoNotUse=Vs,o.constants=tn,o.log=nn,o.AbstractVirtualNode=on,o.SerialVirtualNode=Bp,o.VirtualNode=Uc,o._cache=Kn,o.imports=Po,o.cleanup=Tp,o.configure=function(e){var t=o._audit;if(!t)throw new Error("No audit configured");if(e.axeVersion||e.ver){var n=e.axeVersion||e.ver;if(!/^\\d+\\.\\d+\\.\\d+(-canary)?/.test(n))throw new Error("Invalid configured version ".concat(n));var a=(r=G(n.split("-"),2))[0],r=r[1],u=(a=G(a.split(".").map(Number),3))[0],i=a[1],l=(a=a[2],(s=G(o.version.split("-"),2))[0]),s=s[1],c=(l=G(l.split(".").map(Number),3))[0],d=l[1];l=l[2];if(u!==c||d<i||d===i&&l<a||u===c&&i===d&&a===l&&r&&r!==s)throw new Error("Configured version ".concat(n," is not compatible with current axe version ").concat(o.version))}if(e.reporter&&("function"==typeof e.reporter||Rp(e.reporter))&&(t.reporter=e.reporter),e.checks){if(!Array.isArray(e.checks))throw new TypeError("Checks property must be an array");e.checks.forEach((function(e){if(!e.id)throw new TypeError("Configured check ".concat(JSON.stringify(e)," is invalid. Checks must be an object with at least an id property"));t.addCheck(e)}))}var p,f=[];if(e.rules){if(!Array.isArray(e.rules))throw new TypeError("Rules property must be an array");e.rules.forEach((function(e){if(!e.id)throw new TypeError("Configured rule ".concat(JSON.stringify(e)," is invalid. Rules must be an object with at least an id property"));f.push(e.id),t.addRule(e)}))}if(e.disableOtherRules&&t.rules.forEach((function(e){!1===f.includes(e.id)&&(e.enabled=!1)})),void 0!==e.branding?t.setBranding(e.branding):t._constructHelpUrls(),e.tagExclude&&(t.tagExclude=e.tagExclude),e.locale&&t.applyLocale(e.locale),e.standards&&(p=e.standards,Object.keys(Lo).forEach((function(e){p[e]&&(Lo[e]=ar(Lo[e],p[e]))}))),e.noHtml&&(t.noHtml=!0),e.allowedOrigins){if(!Array.isArray(e.allowedOrigins))throw new TypeError("Allowed origins property must be an array");if(e.allowedOrigins.includes("*"))throw new Error(\'"*" is not allowed. Use "\'.concat(tn.allOrigins,\'" instead\'));t.setAllowedOrigins(e.allowedOrigins)}},o.frameMessenger=function(e){Ga.updateMessenger(e)},o.getRules=function(e){var t=(e=e||[]).length?o._audit.rules.filter((function(t){return!!e.filter((function(e){return-1!==t.tags.indexOf(e)})).length})):o._audit.rules,n=o._audit.data.rules||{};return t.map((function(e){var t=n[e.id]||{};return{ruleId:e.id,description:t.description,help:t.help,helpUrl:t.helpUrl,tags:e.tags,actIds:e.actIds}}))},o._load=function(e){o._audit=new HD(e)},o.plugins={},o.registerPlugin=function(e){o.plugins[e.id]=new YD(e)},o.hasReporter=Rp,o.getReporter=_p,o.addReporter=function(e,t,n){Np[e]=t,n&&(xp=t)},o.reset=function(){var e=o._audit;if(!e)throw new Error("No audit configured");e.resetRulesAndChecks(),Object.keys(Lo).forEach((function(e){Lo[e]=jo[e]}))},o._runRules=WD,o.runVirtualRule=function(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},a=(n.reporter=n.reporter||o._audit.reporter||"v1",o._selectorData={},t instanceof on||(t=new Bp(t)),xd(e));if(a)return a=(a=Object.create(a,{excludeHidden:{value:!1}})).runSync({initiator:!0,include:[t],exclude:[],frames:[],page:!1,focusable:!0,size:{},flatTree:[]},n),sp(a),mn(a),(a=bn([a])).violations.forEach((function(e){return e.nodes.forEach((function(e){e.failureSummary=ad(e)}))})),U({},pd(),a,{toolOptions:n});throw new Error("unknown rule `"+e+"`")},o.run=function(){for(var e=arguments.length,n=new Array(e),r=0;r<e;r++)n[r]=arguments[r];var u=n[0],i=!!a;if(!(c=t&&"Node"in t&&"NodeList"in t)||!i){if(!u||!u.ownerDocument)throw new Error(\'Required "window" or "document" globals not defined and cannot be deduced from the context. Either set the globals before running or pass in a valid Element.\');i||(Kn.set("globalDocumentSet",!0),a=u.ownerDocument),c||(Kn.set("globalWindowSet",!0),t=a.defaultView)}u=(i=KD(n)).context;var l=i.options,s=void 0===(c=i.callback)?XD:c,c=(i=function(e){var t,n,a;return"function"==typeof Promise&&e===XD?t=new Promise((function(e,t){n=t,a=e})):a=n=XD,{thenable:t,reject:n,resolve:a}}(s)).thenable,d=i.resolve,p=i.reject;try{yn(o._audit,"No audit configured"),yn(!o._running,"Axe is already running. Use `await axe.run()` to wait for the previous run to finish before starting a new run.")}catch(e){i=e;var f=s;if(UD(),"function"!=typeof f||f===XD)throw i;return void f(i.message)}return o._running=!0,l.performanceTimer&&o.utils.performanceTimer.start(),o._runRules(u,l,(function(e,t){l.performanceTimer&&o.utils.performanceTimer.end();try{var n=e,a=l,r=function(e){o._running=!1,t();try{s(null,e)}catch(e){o.log(e)}d(e)};void 0!==(n=_p(a.reporter)(n,a,r))&&r(n)}catch(e){o._running=!1,t(),s(e),p(e)}}),(function(e){l.performanceTimer&&o.utils.performanceTimer.end(),o._running=!1,UD(),s(e),p(e)})),c},o.setup=function(e){if(o._tree)throw new Error("Axe is already setup. Call `axe.teardown()` before calling `axe.setup` again.");return o._tree=td(e),o._selectorData=qn(o._tree),o._tree[0]},o.teardown=GD,o.runPartial=function(){for(var e=arguments.length,t=new Array(e),n=0;n<e;n++)t[n]=arguments[n];var a=(r=KD(t)).options,r=r.context,u=(yn(o._audit,"Axe is not configured. Audit is missing."),yn(!o._running,"Axe is already running. Use `await axe.run()` to wait for the previous run to finish before starting a new run."),new Ed(r,o._tree));return o._tree=u.flatTree,o._selectorData=qn(u.flatTree),o._running=!0,new Promise((function(e,t){o._audit.run(u,a,e,t)})).then((function(e){e=e.map((function(e){var t=e.nodes;e=V(e,v);return U({nodes:t.map(ZD)},e)}));var t,n=u.frames.map((function(e){return e=e.node,new Jn(e,a).toJSON()}));return u.initiator&&(t=pd()),o._running=!1,GD(),{results:e,frames:n,environmentData:t}})).catch((function(e){return o._running=!1,GD(),Promise.reject(e)}))},o.finishRun=function(e){var t,n=ea(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}),a=(e.find((function(e){return e.environmentData}))||{}).environmentData;o._audit.normalizeOptions(n),n.reporter=null!=(p=null!=(p=n.reporter)?p:null==(p=o._audit)?void 0:p.reporter)?p:"v1";var r=[],u=Q(p=e);try{for(u.s();!(t=u.n()).done;){var i,l=t.value,s=r.shift();l&&(l.frameSpec=null!=s?s:null,i=function(e){var t=e.frames,n=e.frameSpec;return n?t.map((function(e){return Jn.mergeSpecs(e,n)})):t}(l),r.unshift.apply(r,$(i)))}}catch(e){u.e(e)}finally{u.f()}var c,d,p=er(e);return(p=o._audit.after(p,n)).forEach(sp),p=p.map(mn),c=p,d=U({environmentData:a},n),new Promise((function(e){_p(d.reporter)(c,d,e)}))},o.commons=Ll,o.utils=un,o.addReporter("na",(function(e,t,n){console.warn(\'"na" reporter will be deprecated in axe v4.0. Use the "v2" reporter instead.\'),"function"==typeof t&&(n=t,t={});var a=t.environmentData,r=V(r=t,w);n(U({},pd(a),{toolOptions:r},ud(e,t)))})),o.addReporter("no-passes",(function(e,t,n){"function"==typeof t&&(n=t,t={});var a=t.environmentData,r=V(r=t,E);t.resultTypes=["violations"],e=ud(e,t).violations,n(U({},pd(a),{toolOptions:r,violations:e}))})),o.addReporter("rawEnv",(function(e,t,n){"function"==typeof t&&(n=t,t={});var a=t.environmentData;t=V(t,x),JD(e,t,(function(e){var t=pd(a);n({raw:e,env:t})}))})),o.addReporter("raw",JD),o.addReporter("v1",(function(e,t,n){function a(e){e.nodes.forEach((function(e){e.failureSummary=ad(e)}))}"function"==typeof t&&(n=t,t={});var r=t.environmentData,o=V(o=t,A);(e=ud(e,t)).incomplete.forEach(a),e.violations.forEach(a),n(U({},pd(r),{toolOptions:o},e))})),o.addReporter("v2",(function(e,t,n){"function"==typeof t&&(n=t,t={});var a=t.environmentData,r=V(r=t,k);e=ud(e,t),n(U({},pd(a),{toolOptions:r},e))}),!0),o._load({lang:"en",data:{rules:{accesskeys:{description:"Ensures every accesskey attribute value is unique",help:"accesskey attribute value should be unique"},"area-alt":{description:"Ensures <area> elements of image maps have alternate text",help:"Active <area> elements must have alternate text"},"aria-allowed-attr":{description:"Ensures ARIA attributes are allowed for an element\'s role",help:"Elements must only use allowed ARIA attributes"},"aria-allowed-role":{description:"Ensures role attribute has an appropriate value for the element",help:"ARIA role should be appropriate for the element"},"aria-command-name":{description:"Ensures every ARIA button, link and menuitem has an accessible name",help:"ARIA commands must have an accessible name"},"aria-dialog-name":{description:"Ensures every ARIA dialog and alertdialog node has an accessible name",help:"ARIA dialog and alertdialog nodes should have an accessible name"},"aria-hidden-body":{description:"Ensures aria-hidden=\'true\' is not present on the document body.",help:"aria-hidden=\'true\' must not be present on the document body"},"aria-hidden-focus":{description:"Ensures aria-hidden elements are not focusable nor contain focusable elements",help:"ARIA hidden element must not be focusable or contain focusable elements"},"aria-input-field-name":{description:"Ensures every ARIA input field has an accessible name",help:"ARIA input fields must have an accessible name"},"aria-meter-name":{description:"Ensures every ARIA meter node has an accessible name",help:"ARIA meter nodes must have an accessible name"},"aria-progressbar-name":{description:"Ensures every ARIA progressbar node has an accessible name",help:"ARIA progressbar nodes must have an accessible name"},"aria-required-attr":{description:"Ensures elements with ARIA roles have all required ARIA attributes",help:"Required ARIA attributes must be provided"},"aria-required-children":{description:"Ensures elements with an ARIA role that require child roles contain them",help:"Certain ARIA roles must contain particular children"},"aria-required-parent":{description:"Ensures elements with an ARIA role that require parent roles are contained by them",help:"Certain ARIA roles must be contained by particular parents"},"aria-roledescription":{description:"Ensure aria-roledescription is only used on elements with an implicit or explicit role",help:"aria-roledescription must be on elements with a semantic role"},"aria-roles":{description:"Ensures all elements with a role attribute use a valid value",help:"ARIA roles used must conform to valid values"},"aria-text":{description:\'Ensures "role=text" is used on elements with no focusable descendants\',help:\'"role=text" should have no focusable descendants\'},"aria-toggle-field-name":{description:"Ensures every ARIA toggle field has an accessible name",help:"ARIA toggle fields must have an accessible name"},"aria-tooltip-name":{description:"Ensures every ARIA tooltip node has an accessible name",help:"ARIA tooltip nodes must have an accessible name"},"aria-treeitem-name":{description:"Ensures every ARIA treeitem node has an accessible name",help:"ARIA treeitem nodes should have an accessible name"},"aria-valid-attr-value":{description:"Ensures all ARIA attributes have valid values",help:"ARIA attributes must conform to valid values"},"aria-valid-attr":{description:"Ensures attributes that begin with aria- are valid ARIA attributes",help:"ARIA attributes must conform to valid names"},"audio-caption":{description:"Ensures <audio> elements have captions",help:"<audio> elements must have a captions track"},"autocomplete-valid":{description:"Ensure the autocomplete attribute is correct and suitable for the form field",help:"autocomplete attribute must be used correctly"},"avoid-inline-spacing":{description:"Ensure that text spacing set through style attributes can be adjusted with custom stylesheets",help:"Inline text spacing must be adjustable with custom stylesheets"},blink:{description:"Ensures <blink> elements are not used",help:"<blink> elements are deprecated and must not be used"},"button-name":{description:"Ensures buttons have discernible text",help:"Buttons must have discernible text"},bypass:{description:"Ensures each page has at least one mechanism for a user to bypass navigation and jump straight to the content",help:"Page must have means to bypass repeated blocks"},"color-contrast-enhanced":{description:"Ensures the contrast between foreground and background colors meets WCAG 2 AAA enhanced contrast ratio thresholds",help:"Elements must meet enhanced color contrast ratio thresholds"},"color-contrast":{description:"Ensures the contrast between foreground and background colors meets WCAG 2 AA minimum contrast ratio thresholds",help:"Elements must meet minimum color contrast ratio thresholds"},"css-orientation-lock":{description:"Ensures content is not locked to any specific display orientation, and the content is operable in all display orientations",help:"CSS Media queries must not lock display orientation"},"definition-list":{description:"Ensures <dl> elements are structured correctly",help:"<dl> elements must only directly contain properly-ordered <dt> and <dd> groups, <script>, <template> or <div> elements"},dlitem:{description:"Ensures <dt> and <dd> elements are contained by a <dl>",help:"<dt> and <dd> elements must be contained by a <dl>"},"document-title":{description:"Ensures each HTML document contains a non-empty <title> element",help:"Documents must have <title> element to aid in navigation"},"duplicate-id-active":{description:"Ensures every id attribute value of active elements is unique",help:"IDs of active elements must be unique"},"duplicate-id-aria":{description:"Ensures every id attribute value used in ARIA and in labels is unique",help:"IDs used in ARIA and labels must be unique"},"duplicate-id":{description:"Ensures every id attribute value is unique",help:"id attribute value must be unique"},"empty-heading":{description:"Ensures headings have discernible text",help:"Headings should not be empty"},"empty-table-header":{description:"Ensures table headers have discernible text",help:"Table header text should not be empty"},"focus-order-semantics":{description:"Ensures elements in the focus order have a role appropriate for interactive content",help:"Elements in the focus order should have an appropriate role"},"form-field-multiple-labels":{description:"Ensures form field does not have multiple label elements",help:"Form field must not have multiple label elements"},"frame-focusable-content":{description:"Ensures <frame> and <iframe> elements with focusable content do not have tabindex=-1",help:"Frames with focusable content must not have tabindex=-1"},"frame-tested":{description:"Ensures <iframe> and <frame> elements contain the axe-core script",help:"Frames should be tested with axe-core"},"frame-title-unique":{description:"Ensures <iframe> and <frame> elements contain a unique title attribute",help:"Frames must have a unique title attribute"},"frame-title":{description:"Ensures <iframe> and <frame> elements have an accessible name",help:"Frames must have an accessible name"},"heading-order":{description:"Ensures the order of headings is semantically correct",help:"Heading levels should only increase by one"},"hidden-content":{description:"Informs users about hidden content.",help:"Hidden content on the page should be analyzed"},"html-has-lang":{description:"Ensures every HTML document has a lang attribute",help:"<html> element must have a lang attribute"},"html-lang-valid":{description:"Ensures the lang attribute of the <html> element has a valid value",help:"<html> element must have a valid value for the lang attribute"},"html-xml-lang-mismatch":{description:"Ensure that HTML elements with both valid lang and xml:lang attributes agree on the base language of the page",help:"HTML elements with lang and xml:lang must have the same base language"},"identical-links-same-purpose":{description:"Ensure that links with the same accessible name serve a similar purpose",help:"Links with the same name must have a similar purpose"},"image-alt":{description:"Ensures <img> elements have alternate text or a role of none or presentation",help:"Images must have alternate text"},"image-redundant-alt":{description:"Ensure image alternative is not repeated as text",help:"Alternative text of images should not be repeated as text"},"input-button-name":{description:"Ensures input buttons have discernible text",help:"Input buttons must have discernible text"},"input-image-alt":{description:\'Ensures <input type="image"> elements have alternate text\',help:"Image buttons must have alternate text"},"label-content-name-mismatch":{description:"Ensures that elements labelled through their content must have their visible text as part of their accessible name",help:"Elements must have their visible text as part of their accessible name"},"label-title-only":{description:"Ensures that every form element has a visible label and is not solely labeled using hidden labels, or the title or aria-describedby attributes",help:"Form elements should have a visible label"},label:{description:"Ensures every form element has a label",help:"Form elements must have labels"},"landmark-banner-is-top-level":{description:"Ensures the banner landmark is at top level",help:"Banner landmark should not be contained in another landmark"},"landmark-complementary-is-top-level":{description:"Ensures the complementary landmark or aside is at top level",help:"Aside should not be contained in another landmark"},"landmark-contentinfo-is-top-level":{description:"Ensures the contentinfo landmark is at top level",help:"Contentinfo landmark should not be contained in another landmark"},"landmark-main-is-top-level":{description:"Ensures the main landmark is at top level",help:"Main landmark should not be contained in another landmark"},"landmark-no-duplicate-banner":{description:"Ensures the document has at most one banner landmark",help:"Document should not have more than one banner landmark"},"landmark-no-duplicate-contentinfo":{description:"Ensures the document has at most one contentinfo landmark",help:"Document should not have more than one contentinfo landmark"},"landmark-no-duplicate-main":{description:"Ensures the document has at most one main landmark",help:"Document should not have more than one main landmark"},"landmark-one-main":{description:"Ensures the document has a main landmark",help:"Document should have one main landmark"},"landmark-unique":{help:"Ensures landmarks are unique",description:"Landmarks should have a unique role or role/label/title (i.e. accessible name) combination"},"link-in-text-block":{description:"Ensure links are distinguished from surrounding text in a way that does not rely on color",help:"Links must be distinguishable without relying on color"},"link-name":{description:"Ensures links have discernible text",help:"Links must have discernible text"},list:{description:"Ensures that lists are structured correctly",help:"<ul> and <ol> must only directly contain <li>, <script> or <template> elements"},listitem:{description:"Ensures <li> elements are used semantically",help:"<li> elements must be contained in a <ul> or <ol>"},marquee:{description:"Ensures <marquee> elements are not used",help:"<marquee> elements are deprecated and must not be used"},"meta-refresh-no-exceptions":{description:\'Ensures <meta http-equiv="refresh"> is not used for delayed refresh\',help:"Delayed refresh must not be used"},"meta-refresh":{description:\'Ensures <meta http-equiv="refresh"> is not used for delayed refresh\',help:"Delayed refresh under 20 hours must not be used"},"meta-viewport-large":{description:\'Ensures <meta name="viewport"> can scale a significant amount\',help:"Users should be able to zoom and scale the text up to 500%"},"meta-viewport":{description:\'Ensures <meta name="viewport"> does not disable text scaling and zooming\',help:"Zooming and scaling must not be disabled"},"nested-interactive":{description:"Ensures interactive controls are not nested as they are not always announced by screen readers or can cause focus problems for assistive technologies",help:"Interactive controls must not be nested"},"no-autoplay-audio":{description:"Ensures <video> or <audio> elements do not autoplay audio for more than 3 seconds without a control mechanism to stop or mute the audio",help:"<video> or <audio> elements must not play automatically"},"object-alt":{description:"Ensures <object> elements have alternate text",help:"<object> elements must have alternate text"},"p-as-heading":{description:"Ensure bold, italic text and font-size is not used to style <p> elements as a heading",help:"Styled <p> elements must not be used as headings"},"page-has-heading-one":{description:"Ensure that the page, or at least one of its frames contains a level-one heading",help:"Page should contain a level-one heading"},"presentation-role-conflict":{description:"Elements marked as presentational should not have global ARIA or tabindex to ensure all screen readers ignore them",help:"Ensure elements marked as presentational are consistently ignored"},region:{description:"Ensures all page content is contained by landmarks",help:"All page content should be contained by landmarks"},"role-img-alt":{description:"Ensures [role=\'img\'] elements have alternate text",help:"[role=\'img\'] elements must have an alternative text"},"scope-attr-valid":{description:"Ensures the scope attribute is used correctly on tables",help:"scope attribute should be used correctly"},"scrollable-region-focusable":{description:"Ensure elements that have scrollable content are accessible by keyboard",help:"Scrollable region must have keyboard access"},"select-name":{description:"Ensures select element has an accessible name",help:"Select element must have an accessible name"},"server-side-image-map":{description:"Ensures that server-side image maps are not used",help:"Server-side image maps must not be used"},"skip-link":{description:"Ensure all skip links have a focusable target",help:"The skip-link target should exist and be focusable"},"svg-img-alt":{description:"Ensures <svg> elements with an img, graphics-document or graphics-symbol role have an accessible text",help:"<svg> elements with an img role must have an alternative text"},tabindex:{description:"Ensures tabindex attribute values are not greater than 0",help:"Elements should not have tabindex greater than zero"},"table-duplicate-name":{description:"Ensure the <caption> element does not contain the same text as the summary attribute",help:"tables should not have the same summary and caption"},"table-fake-caption":{description:"Ensure that tables with a caption use the <caption> element.",help:"Data or header cells must not be used to give caption to a data table."},"target-size":{description:"Ensure touch target have sufficient size and space",help:"All touch targets must be 24px large, or leave sufficient space"},"td-has-header":{description:"Ensure that each non-empty data cell in a <table> larger than 3 by 3  has one or more table headers",help:"Non-empty <td> elements in larger <table> must have an associated table header"},"td-headers-attr":{description:"Ensure that each cell in a table that uses the headers attribute refers only to other cells in that table",help:"Table cells that use the headers attribute must only refer to cells in the same table"},"th-has-data-cells":{description:"Ensure that <th> elements and elements with role=columnheader/rowheader have data cells they describe",help:"Table headers in a data table must refer to data cells"},"valid-lang":{description:"Ensures lang attributes have valid values",help:"lang attribute must have a valid value"},"video-caption":{description:"Ensures <video> elements have captions",help:"<video> elements must have captions"}},checks:{abstractrole:{impact:"serious",messages:{pass:"Abstract roles are not used",fail:{singular:"Abstract role cannot be directly used: ${data.values}",plural:"Abstract roles cannot be directly used: ${data.values}"}}},"aria-allowed-attr":{impact:"critical",messages:{pass:"ARIA attributes are used correctly for the defined role",fail:{singular:"ARIA attribute is not allowed: ${data.values}",plural:"ARIA attributes are not allowed: ${data.values}"},incomplete:"Check that there is no problem if the ARIA attribute is ignored on this element: ${data.values}"}},"aria-allowed-role":{impact:"minor",messages:{pass:"ARIA role is allowed for given element",fail:{singular:"ARIA role ${data.values} is not allowed for given element",plural:"ARIA roles ${data.values} are not allowed for given element"},incomplete:{singular:"ARIA role ${data.values} must be removed when the element is made visible, as it is not allowed for the element",plural:"ARIA roles ${data.values} must be removed when the element is made visible, as they are not allowed for the element"}}},"aria-busy":{impact:"serious",messages:{pass:"Element has an aria-busy attribute",fail:\'Element uses aria-busy="true" while showing a loader\'}},"aria-conditional-attr":{impact:"serious",messages:{pass:"ARIA attribute is allowed",fail:{checkbox:\'Remove aria-checked, or set it to "${data.checkState}" to match the real checkbox state\',rowSingular:"This attribute is supported with treegrid rows, but not ${data.ownerRole}: ${data.invalidAttrs}",rowPlural:"These attributes are supported with treegrid rows, but not ${data.ownerRole}: ${data.invalidAttrs}"}}},"aria-errormessage":{impact:"critical",messages:{pass:"aria-errormessage exists and references elements visible to screen readers that use a supported aria-errormessage technique",fail:{singular:"aria-errormessage value `${data.values}` must use a technique to announce the message (e.g., aria-live, aria-describedby, role=alert, etc.)",plural:"aria-errormessage values `${data.values}` must use a technique to announce the message (e.g., aria-live, aria-describedby, role=alert, etc.)",hidden:"aria-errormessage value `${data.values}` cannot reference a hidden element"},incomplete:{singular:"ensure aria-errormessage value `${data.values}` references an existing element",plural:"ensure aria-errormessage values `${data.values}` reference existing elements",idrefs:"unable to determine if aria-errormessage element exists on the page: ${data.values}"}}},"aria-hidden-body":{impact:"critical",messages:{pass:"No aria-hidden attribute is present on document body",fail:"aria-hidden=true should not be present on the document body"}},"aria-level":{impact:"serious",messages:{pass:"aria-level values are valid",incomplete:"aria-level values greater than 6 are not supported in all screenreader and browser combinations"}},"aria-prohibited-attr":{impact:"serious",messages:{pass:"ARIA attribute is allowed",fail:{hasRolePlural:\'${data.prohibited} attributes cannot be used with role "${data.role}".\',hasRoleSingular:\'${data.prohibited} attribute cannot be used with role "${data.role}".\',noRolePlural:"${data.prohibited} attributes cannot be used on a ${data.nodeName} with no valid role attribute.",noRoleSingular:"${data.prohibited} attribute cannot be used on a ${data.nodeName} with no valid role attribute."},incomplete:{hasRoleSingular:\'${data.prohibited} attribute is not well supported with role "${data.role}".\',hasRolePlural:\'${data.prohibited} attributes are not well supported with role "${data.role}".\',noRoleSingular:"${data.prohibited} attribute is not well supported on a ${data.nodeName} with no valid role attribute.",noRolePlural:"${data.prohibited} attributes are not well supported on a ${data.nodeName} with no valid role attribute."}}},"aria-required-attr":{impact:"critical",messages:{pass:"All required ARIA attributes are present",fail:{singular:"Required ARIA attribute not present: ${data.values}",plural:"Required ARIA attributes not present: ${data.values}"}}},"aria-required-children":{impact:"critical",messages:{pass:"Required ARIA children are present",fail:{singular:"Required ARIA child role not present: ${data.values}",plural:"Required ARIA children role not present: ${data.values}",unallowed:"Element has children which are not allowed: ${data.values}"},incomplete:{singular:"Expecting ARIA child role to be added: ${data.values}",plural:"Expecting ARIA children role to be added: ${data.values}"}}},"aria-required-parent":{impact:"critical",messages:{pass:"Required ARIA parent role present",fail:{singular:"Required ARIA parent role not present: ${data.values}",plural:"Required ARIA parents role not present: ${data.values}"}}},"aria-roledescription":{impact:"serious",messages:{pass:"aria-roledescription used on a supported semantic role",incomplete:"Check that the aria-roledescription is announced by supported screen readers",fail:"Give the element a role that supports aria-roledescription"}},"aria-unsupported-attr":{impact:"critical",messages:{pass:"ARIA attribute is supported",fail:"ARIA attribute is not widely supported in screen readers and assistive technologies: ${data.values}"}},"aria-valid-attr-value":{impact:"critical",messages:{pass:"ARIA attribute values are valid",fail:{singular:"Invalid ARIA attribute value: ${data.values}",plural:"Invalid ARIA attribute values: ${data.values}"},incomplete:{noId:"ARIA attribute element ID does not exist on the page: ${data.needsReview}",noIdShadow:"ARIA attribute element ID does not exist on the page or is a descendant of a different shadow DOM tree: ${data.needsReview}",ariaCurrent:\'ARIA attribute value is invalid and will be treated as "aria-current=true": ${data.needsReview}\',idrefs:"Unable to determine if ARIA attribute element ID exists on the page: ${data.needsReview}",empty:"ARIA attribute value is ignored while empty: ${data.needsReview}"}}},"aria-valid-attr":{impact:"critical",messages:{pass:"ARIA attribute name is valid",fail:{singular:"Invalid ARIA attribute name: ${data.values}",plural:"Invalid ARIA attribute names: ${data.values}"}}},deprecatedrole:{impact:"minor",messages:{pass:"ARIA role is not deprecated",fail:"The role used is deprecated: ${data}"}},fallbackrole:{impact:"serious",messages:{pass:"Only one role value used",fail:"Use only one role value, since fallback roles are not supported in older browsers",incomplete:"Use only role \'presentation\' or \'none\' since they are synonymous."}},"has-global-aria-attribute":{impact:"minor",messages:{pass:{singular:"Element has global ARIA attribute: ${data.values}",plural:"Element has global ARIA attributes: ${data.values}"},fail:"Element does not have global ARIA attribute"}},"has-widget-role":{impact:"minor",messages:{pass:"Element has a widget role.",fail:"Element does not have a widget role."}},invalidrole:{impact:"critical",messages:{pass:"ARIA role is valid",fail:{singular:"Role must be one of the valid ARIA roles: ${data.values}",plural:"Roles must be one of the valid ARIA roles: ${data.values}"}}},"is-element-focusable":{impact:"minor",messages:{pass:"Element is focusable.",fail:"Element is not focusable."}},"no-implicit-explicit-label":{impact:"moderate",messages:{pass:"There is no mismatch between a <label> and accessible name",incomplete:"Check that the <label> does not need be part of the ARIA ${data} field\'s name"}},unsupportedrole:{impact:"critical",messages:{pass:"ARIA role is supported",fail:"The role used is not widely supported in screen readers and assistive technologies: ${data}"}},"valid-scrollable-semantics":{impact:"minor",messages:{pass:"Element has valid semantics for an element in the focus order.",fail:"Element has invalid semantics for an element in the focus order."}},"color-contrast-enhanced":{impact:"serious",messages:{pass:"Element has sufficient color contrast of ${data.contrastRatio}",fail:{default:"Element has insufficient color contrast of ${data.contrastRatio} (foreground color: ${data.fgColor}, background color: ${data.bgColor}, font size: ${data.fontSize}, font weight: ${data.fontWeight}). Expected contrast ratio of ${data.expectedContrastRatio}",fgOnShadowColor:"Element has insufficient color contrast of ${data.contrastRatio} between the foreground and shadow color (foreground color: ${data.fgColor}, text-shadow color: ${data.shadowColor}, font size: ${data.fontSize}, font weight: ${data.fontWeight}). Expected contrast ratio of ${data.expectedContrastRatio}",shadowOnBgColor:"Element has insufficient color contrast of ${data.contrastRatio} between the shadow color and background color (text-shadow color: ${data.shadowColor}, background color: ${data.bgColor}, font size: ${data.fontSize}, font weight: ${data.fontWeight}). Expected contrast ratio of ${data.expectedContrastRatio}"},incomplete:{default:"Unable to determine contrast ratio",bgImage:"Element\'s background color could not be determined due to a background image",bgGradient:"Element\'s background color could not be determined due to a background gradient",imgNode:"Element\'s background color could not be determined because element contains an image node",bgOverlap:"Element\'s background color could not be determined because it is overlapped by another element",fgAlpha:"Element\'s foreground color could not be determined because of alpha transparency",elmPartiallyObscured:"Element\'s background color could not be determined because it\'s partially obscured by another element",elmPartiallyObscuring:"Element\'s background color could not be determined because it partially overlaps other elements",outsideViewport:"Element\'s background color could not be determined because it\'s outside the viewport",equalRatio:"Element has a 1:1 contrast ratio with the background",shortTextContent:"Element content is too short to determine if it is actual text content",nonBmp:"Element content contains only non-text characters",pseudoContent:"Element\'s background color could not be determined due to a pseudo element"}}},"color-contrast":{impact:"serious",messages:{pass:{default:"Element has sufficient color contrast of ${data.contrastRatio}",hidden:"Element is hidden"},fail:{default:"Element has insufficient color contrast of ${data.contrastRatio} (foreground color: ${data.fgColor}, background color: ${data.bgColor}, font size: ${data.fontSize}, font weight: ${data.fontWeight}). Expected contrast ratio of ${data.expectedContrastRatio}",fgOnShadowColor:"Element has insufficient color contrast of ${data.contrastRatio} between the foreground and shadow color (foreground color: ${data.fgColor}, text-shadow color: ${data.shadowColor}, font size: ${data.fontSize}, font weight: ${data.fontWeight}). Expected contrast ratio of ${data.expectedContrastRatio}",shadowOnBgColor:"Element has insufficient color contrast of ${data.contrastRatio} between the shadow color and background color (text-shadow color: ${data.shadowColor}, background color: ${data.bgColor}, font size: ${data.fontSize}, font weight: ${data.fontWeight}). Expected contrast ratio of ${data.expectedContrastRatio}"},incomplete:{default:"Unable to determine contrast ratio",bgImage:"Element\'s background color could not be determined due to a background image",bgGradient:"Element\'s background color could not be determined due to a background gradient",imgNode:"Element\'s background color could not be determined because element contains an image node",bgOverlap:"Element\'s background color could not be determined because it is overlapped by another element",fgAlpha:"Element\'s foreground color could not be determined because of alpha transparency",elmPartiallyObscured:"Element\'s background color could not be determined because it\'s partially obscured by another element",elmPartiallyObscuring:"Element\'s background color could not be determined because it partially overlaps other elements",outsideViewport:"Element\'s background color could not be determined because it\'s outside the viewport",equalRatio:"Element has a 1:1 contrast ratio with the background",shortTextContent:"Element content is too short to determine if it is actual text content",nonBmp:"Element content contains only non-text characters",pseudoContent:"Element\'s background color could not be determined due to a pseudo element"}}},"link-in-text-block-style":{impact:"serious",messages:{pass:"Links can be distinguished from surrounding text by visual styling",incomplete:{default:"Check if the link needs styling to distinguish it from nearby text",pseudoContent:"Check if the link\'s pseudo style is sufficient to distinguish it from the surrounding text"},fail:"The link has no styling (such as underline) to distinguish it from the surrounding text"}},"link-in-text-block":{impact:"serious",messages:{pass:"Links can be distinguished from surrounding text in some way other than by color",fail:{fgContrast:"The link has insufficient color contrast of ${data.contrastRatio}:1 with the surrounding text. (Minimum contrast is ${data.requiredContrastRatio}:1, link text: ${data.nodeColor}, surrounding text: ${data.parentColor})",bgContrast:"The link background has insufficient color contrast of ${data.contrastRatio} (Minimum contrast is ${data.requiredContrastRatio}:1, link background color: ${data.nodeBackgroundColor}, surrounding background color: ${data.parentBackgroundColor})"},incomplete:{default:"Element\'s foreground contrast ratio could not be determined",bgContrast:"Element\'s background contrast ratio could not be determined",bgImage:"Element\'s contrast ratio could not be determined due to a background image",bgGradient:"Element\'s contrast ratio could not be determined due to a background gradient",imgNode:"Element\'s contrast ratio could not be determined because element contains an image node",bgOverlap:"Element\'s contrast ratio could not be determined because of element overlap"}}},"autocomplete-appropriate":{impact:"serious",messages:{pass:"the autocomplete value is on an appropriate element",fail:"the autocomplete value is inappropriate for this type of input"}},"autocomplete-valid":{impact:"serious",messages:{pass:"the autocomplete attribute is correctly formatted",fail:"the autocomplete attribute is incorrectly formatted"}},accesskeys:{impact:"serious",messages:{pass:"Accesskey attribute value is unique",fail:"Document has multiple elements with the same accesskey"}},"focusable-content":{impact:"serious",messages:{pass:"Element contains focusable elements",fail:"Element should have focusable content"}},"focusable-disabled":{impact:"serious",messages:{pass:"No focusable elements contained within element",incomplete:"Check if the focusable elements immediately move the focus indicator",fail:"Focusable content should be disabled or be removed from the DOM"}},"focusable-element":{impact:"serious",messages:{pass:"Element is focusable",fail:"Element should be focusable"}},"focusable-modal-open":{impact:"serious",messages:{pass:"No focusable elements while a modal is open",incomplete:"Check that focusable elements are not tabbable in the current state"}},"focusable-no-name":{impact:"serious",messages:{pass:"Element is not in tab order or has accessible text",fail:"Element is in tab order and does not have accessible text",incomplete:"Unable to determine if element has an accessible name"}},"focusable-not-tabbable":{impact:"serious",messages:{pass:"No focusable elements contained within element",incomplete:"Check if the focusable elements immediately move the focus indicator",fail:"Focusable content should have tabindex=\'-1\' or be removed from the DOM"}},"frame-focusable-content":{impact:"serious",messages:{pass:"Element does not have focusable descendants",fail:"Element has focusable descendants",incomplete:"Could not determine if element has descendants"}},"landmark-is-top-level":{impact:"moderate",messages:{pass:"The ${data.role} landmark is at the top level.",fail:"The ${data.role} landmark is contained in another landmark."}},"no-focusable-content":{impact:"serious",messages:{pass:"Element does not have focusable descendants",fail:{default:"Element has focusable descendants",notHidden:"Using a negative tabindex on an element inside an interactive control does not prevent assistive technologies from focusing the element (even with \'aria-hidden=true\')"},incomplete:"Could not determine if element has descendants"}},"page-has-heading-one":{impact:"moderate",messages:{pass:"Page has at least one level-one heading",fail:"Page must have a level-one heading"}},"page-has-main":{impact:"moderate",messages:{pass:"Document has at least one main landmark",fail:"Document does not have a main landmark"}},"page-no-duplicate-banner":{impact:"moderate",messages:{pass:"Document does not have more than one banner landmark",fail:"Document has more than one banner landmark"}},"page-no-duplicate-contentinfo":{impact:"moderate",messages:{pass:"Document does not have more than one contentinfo landmark",fail:"Document has more than one contentinfo landmark"}},"page-no-duplicate-main":{impact:"moderate",messages:{pass:"Document does not have more than one main landmark",fail:"Document has more than one main landmark"}},tabindex:{impact:"serious",messages:{pass:"Element does not have a tabindex greater than 0",fail:"Element has a tabindex greater than 0"}},"alt-space-value":{impact:"critical",messages:{pass:"Element has a valid alt attribute value",fail:"Element has an alt attribute containing only a space character, which is not ignored by all screen readers"}},"duplicate-img-label":{impact:"minor",messages:{pass:"Element does not duplicate existing text in <img> alt text",fail:"Element contains <img> element with alt text that duplicates existing text"}},"explicit-label":{impact:"critical",messages:{pass:"Form element has an explicit <label>",fail:"Form element does not have an explicit <label>",incomplete:"Unable to determine if form element has an explicit <label>"}},"help-same-as-label":{impact:"minor",messages:{pass:"Help text (title or aria-describedby) does not duplicate label text",fail:"Help text (title or aria-describedby) text is the same as the label text"}},"hidden-explicit-label":{impact:"critical",messages:{pass:"Form element has a visible explicit <label>",fail:"Form element has explicit <label> that is hidden",incomplete:"Unable to determine if form element has explicit <label> that is hidden"}},"implicit-label":{impact:"critical",messages:{pass:"Form element has an implicit (wrapped) <label>",fail:"Form element does not have an implicit (wrapped) <label>",incomplete:"Unable to determine if form element has an implicit (wrapped} <label>"}},"label-content-name-mismatch":{impact:"serious",messages:{pass:"Element contains visible text as part of it\'s accessible name",fail:"Text inside the element is not included in the accessible name"}},"multiple-label":{impact:"moderate",messages:{pass:"Form field does not have multiple label elements",incomplete:"Multiple label elements is not widely supported in assistive technologies. Ensure the first label contains all necessary information."}},"title-only":{impact:"serious",messages:{pass:"Form element does not solely use title attribute for its label",fail:"Only title used to generate label for form element"}},"landmark-is-unique":{impact:"moderate",messages:{pass:"Landmarks must have a unique role or role/label/title (i.e. accessible name) combination",fail:"The landmark must have a unique aria-label, aria-labelledby, or title to make landmarks distinguishable"}},"has-lang":{impact:"serious",messages:{pass:"The <html> element has a lang attribute",fail:{noXHTML:"The xml:lang attribute is not valid on HTML pages, use the lang attribute.",noLang:"The <html> element does not have a lang attribute"}}},"valid-lang":{impact:"serious",messages:{pass:"Value of lang attribute is included in the list of valid languages",fail:"Value of lang attribute not included in the list of valid languages"}},"xml-lang-mismatch":{impact:"moderate",messages:{pass:"Lang and xml:lang attributes have the same base language",fail:"Lang and xml:lang attributes do not have the same base language"}},dlitem:{impact:"serious",messages:{pass:"Description list item has a <dl> parent element",fail:"Description list item does not have a <dl> parent element"}},listitem:{impact:"serious",messages:{pass:\'List item has a <ul>, <ol> or role="list" parent element\',fail:{default:"List item does not have a <ul>, <ol> parent element",roleNotValid:\'List item does not have a <ul>, <ol> parent element without a role, or a role="list"\'}}},"only-dlitems":{impact:"serious",messages:{pass:"dl element only has direct children that are allowed inside; <dt>, <dd>, or <div> elements",fail:"dl element has direct children that are not allowed: ${data.values}"}},"only-listitems":{impact:"serious",messages:{pass:"List element only has direct children that are allowed inside <li> elements",fail:"List element has direct children that are not allowed: ${data.values}"}},"structured-dlitems":{impact:"serious",messages:{pass:"When not empty, element has both <dt> and <dd> elements",fail:"When not empty, element does not have at least one <dt> element followed by at least one <dd> element"}},caption:{impact:"critical",messages:{pass:"The multimedia element has a captions track",incomplete:"Check that captions is available for the element"}},"frame-tested":{impact:"critical",messages:{pass:"The iframe was tested with axe-core",fail:"The iframe could not be tested with axe-core",incomplete:"The iframe still has to be tested with axe-core"}},"no-autoplay-audio":{impact:"moderate",messages:{pass:"<video> or <audio> does not output audio for more than allowed duration or has controls mechanism",fail:"<video> or <audio> outputs audio for more than allowed duration and does not have a controls mechanism",incomplete:"Check that the <video> or <audio> does not output audio for more than allowed duration or provides a controls mechanism"}},"css-orientation-lock":{impact:"serious",messages:{pass:"Display is operable, and orientation lock does not exist",fail:"CSS Orientation lock is applied, and makes display inoperable",incomplete:"CSS Orientation lock cannot be determined"}},"meta-viewport-large":{impact:"minor",messages:{pass:"<meta> tag does not prevent significant zooming on mobile devices",fail:"<meta> tag limits zooming on mobile devices"}},"meta-viewport":{impact:"critical",messages:{pass:"<meta> tag does not disable zooming on mobile devices",fail:"${data} on <meta> tag disables zooming on mobile devices"}},"target-offset":{impact:"serious",messages:{pass:"Target has sufficient offset from its closest neighbor (${data.closestOffset}px should be at least ${data.minOffset}px)",fail:"Target has insufficient offset from its closest neighbor (${data.closestOffset}px should be at least ${data.minOffset}px)",incomplete:{default:"Element with negative tabindex has insufficient offset from its closest neighbor (${data.closestOffset}px should be at least ${data.minOffset}px). Is this a target?",nonTabbableNeighbor:"Target has insufficient offset from a neighbor with negative tabindex (${data.closestOffset}px should be at least ${data.minOffset}px). Is the neighbor a target?"}}},"target-size":{impact:"serious",messages:{pass:{default:"Control has sufficient size (${data.width}px by ${data.height}px, should be at least ${data.minSize}px by ${data.minSize}px)",obscured:"Control is ignored because it is fully obscured and thus not clickable"},fail:{default:"Target has insufficient size (${data.width}px by ${data.height}px, should be at least ${data.minSize}px by ${data.minSize}px)",partiallyObscured:"Target has insufficient size because it is partially obscured (smallest space is ${data.width}px by ${data.height}px, should be at least ${data.minSize}px by ${data.minSize}px)"},incomplete:{default:"Element with negative tabindex has insufficient size (${data.width}px by ${data.height}px, should be at least ${data.minSize}px by ${data.minSize}px). Is this a target?",contentOverflow:"Element size could not be accurately determined due to overflow content",partiallyObscured:"Element with negative tabindex has insufficient size because it is partially obscured (smallest space is ${data.width}px by ${data.height}px, should be at least ${data.minSize}px by ${data.minSize}px). Is this a target?",partiallyObscuredNonTabbable:"Target has insufficient size because it is partially obscured by a neighbor with negative tabindex (smallest space is ${data.width}px by ${data.height}px, should be at least ${data.minSize}px by ${data.minSize}px). Is the neighbor a target?"}}},"header-present":{impact:"serious",messages:{pass:"Page has a heading",fail:"Page does not have a heading"}},"heading-order":{impact:"moderate",messages:{pass:"Heading order valid",fail:"Heading order invalid",incomplete:"Unable to determine previous heading"}},"identical-links-same-purpose":{impact:"minor",messages:{pass:"There are no other links with the same name, that go to a different URL",incomplete:"Check that links have the same purpose, or are intentionally ambiguous."}},"internal-link-present":{impact:"serious",messages:{pass:"Valid skip link found",fail:"No valid skip link found"}},landmark:{impact:"serious",messages:{pass:"Page has a landmark region",fail:"Page does not have a landmark region"}},"meta-refresh-no-exceptions":{impact:"minor",messages:{pass:"<meta> tag does not immediately refresh the page",fail:"<meta> tag forces timed refresh of page"}},"meta-refresh":{impact:"critical",messages:{pass:"<meta> tag does not immediately refresh the page",fail:"<meta> tag forces timed refresh of page (less than 20 hours)"}},"p-as-heading":{impact:"serious",messages:{pass:"<p> elements are not styled as headings",fail:"Heading elements should be used instead of styled <p> elements",incomplete:"Unable to determine if <p> elements are styled as headings"}},region:{impact:"moderate",messages:{pass:"All page content is contained by landmarks",fail:"Some page content is not contained by landmarks"}},"skip-link":{impact:"moderate",messages:{pass:"Skip link target exists",incomplete:"Skip link target should become visible on activation",fail:"No skip link target"}},"unique-frame-title":{impact:"serious",messages:{pass:"Element\'s title attribute is unique",fail:"Element\'s title attribute is not unique"}},"duplicate-id-active":{impact:"serious",messages:{pass:"Document has no active elements that share the same id attribute",fail:"Document has active elements with the same id attribute: ${data}"}},"duplicate-id-aria":{impact:"critical",messages:{pass:"Document has no elements referenced with ARIA or labels that share the same id attribute",fail:"Document has multiple elements referenced with ARIA with the same id attribute: ${data}"}},"duplicate-id":{impact:"minor",messages:{pass:"Document has no static elements that share the same id attribute",fail:"Document has multiple static elements with the same id attribute: ${data}"}},"aria-label":{impact:"serious",messages:{pass:"aria-label attribute exists and is not empty",fail:"aria-label attribute does not exist or is empty"}},"aria-labelledby":{impact:"serious",messages:{pass:"aria-labelledby attribute exists and references elements that are visible to screen readers",fail:"aria-labelledby attribute does not exist, references elements that do not exist or references elements that are empty",incomplete:"ensure aria-labelledby references an existing element"}},"avoid-inline-spacing":{impact:"serious",messages:{pass:"No inline styles with \'!important\' that affect text spacing has been specified",fail:{singular:"Remove \'!important\' from inline style ${data.values}, as overriding this is not supported by most browsers",plural:"Remove \'!important\' from inline styles ${data.values}, as overriding this is not supported by most browsers"}}},"button-has-visible-text":{impact:"critical",messages:{pass:"Element has inner text that is visible to screen readers",fail:"Element does not have inner text that is visible to screen readers",incomplete:"Unable to determine if element has children"}},"doc-has-title":{impact:"serious",messages:{pass:"Document has a non-empty <title> element",fail:"Document does not have a non-empty <title> element"}},exists:{impact:"minor",messages:{pass:"Element does not exist",incomplete:"Element exists"}},"has-alt":{impact:"critical",messages:{pass:"Element has an alt attribute",fail:"Element does not have an alt attribute"}},"has-visible-text":{impact:"minor",messages:{pass:"Element has text that is visible to screen readers",fail:"Element does not have text that is visible to screen readers",incomplete:"Unable to determine if element has children"}},"important-letter-spacing":{impact:"serious",messages:{pass:"Letter-spacing in the style attribute is not set to !important, or meets the minimum",fail:"letter-spacing in the style attribute must not use !important, or be at ${data.minValue}em (current ${data.value}em)"}},"important-line-height":{impact:"serious",messages:{pass:"line-height in the style attribute is not set to !important, or meets the minimum",fail:"line-height in the style attribute must not use !important, or be at ${data.minValue}em (current ${data.value}em)"}},"important-word-spacing":{impact:"serious",messages:{pass:"word-spacing in the style attribute is not set to !important, or meets the minimum",fail:"word-spacing in the style attribute must not use !important, or be at ${data.minValue}em (current ${data.value}em)"}},"is-on-screen":{impact:"serious",messages:{pass:"Element is not visible",fail:"Element is visible"}},"non-empty-alt":{impact:"critical",messages:{pass:"Element has a non-empty alt attribute",fail:{noAttr:"Element has no alt attribute",emptyAttr:"Element has an empty alt attribute"}}},"non-empty-if-present":{impact:"critical",messages:{pass:{default:"Element does not have a value attribute","has-label":"Element has a non-empty value attribute"},fail:"Element has a value attribute and the value attribute is empty"}},"non-empty-placeholder":{impact:"serious",messages:{pass:"Element has a placeholder attribute",fail:{noAttr:"Element has no placeholder attribute",emptyAttr:"Element has an empty placeholder attribute"}}},"non-empty-title":{impact:"serious",messages:{pass:"Element has a title attribute",fail:{noAttr:"Element has no title attribute",emptyAttr:"Element has an empty title attribute"}}},"non-empty-value":{impact:"critical",messages:{pass:"Element has a non-empty value attribute",fail:{noAttr:"Element has no value attribute",emptyAttr:"Element has an empty value attribute"}}},"presentational-role":{impact:"minor",messages:{pass:\'Element\\\'s default semantics were overriden with role="${data.role}"\',fail:{default:\'Element\\\'s default semantics were not overridden with role="none" or role="presentation"\',globalAria:"Element\'s role is not presentational because it has a global ARIA attribute",focusable:"Element\'s role is not presentational because it is focusable",both:"Element\'s role is not presentational because it has a global ARIA attribute and is focusable",iframe:\'Using the "title" attribute on an ${data.nodeName} element with a presentational role behaves inconsistently between screen readers\'}}},"role-none":{impact:"minor",messages:{pass:\'Element\\\'s default semantics were overriden with role="none"\',fail:\'Element\\\'s default semantics were not overridden with role="none"\'}},"role-presentation":{impact:"minor",messages:{pass:\'Element\\\'s default semantics were overriden with role="presentation"\',fail:\'Element\\\'s default semantics were not overridden with role="presentation"\'}},"svg-non-empty-title":{impact:"serious",messages:{pass:"Element has a child that is a title",fail:{noTitle:"Element has no child that is a title",emptyTitle:"Element child title is empty"},incomplete:"Unable to determine element has a child that is a title"}},"caption-faked":{impact:"serious",messages:{pass:"The first row of a table is not used as a caption",fail:"The first child of the table should be a caption instead of a table cell"}},"html5-scope":{impact:"moderate",messages:{pass:"Scope attribute is only used on table header elements (<th>)",fail:"In HTML 5, scope attributes may only be used on table header elements (<th>)"}},"same-caption-summary":{impact:"minor",messages:{pass:"Content of summary attribute and <caption> are not duplicated",fail:"Content of summary attribute and <caption> element are identical",incomplete:"Unable to determine if <table> element has a caption"}},"scope-value":{impact:"critical",messages:{pass:"Scope attribute is used correctly",fail:"The value of the scope attribute may only be \'row\' or \'col\'"}},"td-has-header":{impact:"critical",messages:{pass:"All non-empty data cells have table headers",fail:"Some non-empty data cells do not have table headers"}},"td-headers-attr":{impact:"serious",messages:{pass:"The headers attribute is exclusively used to refer to other cells in the table",incomplete:"The headers attribute is empty",fail:"The headers attribute is not exclusively used to refer to other cells in the table"}},"th-has-data-cells":{impact:"serious",messages:{pass:"All table header cells refer to data cells",fail:"Not all table header cells refer to data cells",incomplete:"Table data cells are missing or empty"}},"hidden-content":{impact:"minor",messages:{pass:"All content on the page has been analyzed.",fail:"There were problems analyzing the content on this page.",incomplete:"There is hidden content on the page that was not analyzed. You will need to trigger the display of this content in order to analyze it."}}},failureSummaries:{any:{failureMessage:function(e){var t="Fix any of the following:",n=e;if(n)for(var a=-1,r=n.length-1;a<r;)t+="\\n  "+n[a+=1].split("\\n").join("\\n  ");return t}},none:{failureMessage:function(e){var t="Fix all of the following:",n=e;if(n)for(var a=-1,r=n.length-1;a<r;)t+="\\n  "+n[a+=1].split("\\n").join("\\n  ");return t}}},incompleteFallbackMessage:"axe couldn\'t tell the reason. Time to break out the element inspector!"},rules:[{id:"accesskeys",selector:"[accesskey]",excludeHidden:!1,tags:["cat.keyboard","best-practice"],all:[],any:[],none:["accesskeys"]},{id:"area-alt",selector:"map area[href]",excludeHidden:!1,tags:["cat.text-alternatives","wcag2a","wcag244","wcag412","section508","section508.22.a","ACT","TTv5","TT6.a"],actIds:["c487ae"],all:[],any:[{options:{attribute:"alt"},id:"non-empty-alt"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-allowed-attr",matches:"aria-allowed-attr-matches",tags:["cat.aria","wcag2a","wcag412"],actIds:["5c01ea"],all:[{options:{validTreeRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]},id:"aria-allowed-attr"},{options:{invalidTableRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]},id:"aria-conditional-attr"}],any:[],none:["aria-unsupported-attr",{options:{elementsAllowedAriaLabel:["applet","input"]},id:"aria-prohibited-attr"}]},{id:"aria-allowed-role",excludeHidden:!1,selector:"[role]",matches:"aria-allowed-role-matches",tags:["cat.aria","best-practice"],all:[],any:[{options:{allowImplicit:!0,ignoredTags:[]},id:"aria-allowed-role"}],none:[]},{id:"aria-command-name",selector:\'[role="link"], [role="button"], [role="menuitem"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","ACT","TTv5","TT6.a"],actIds:["97a4e1"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-dialog-name",selector:\'[role="dialog"], [role="alertdialog"]\',matches:"no-naming-method-matches",tags:["cat.aria","best-practice"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-hidden-body",selector:"body",excludeHidden:!1,matches:"is-initiator-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:["aria-hidden-body"],none:[]},{id:"aria-hidden-focus",selector:\'[aria-hidden="true"]\',matches:"aria-hidden-focus-matches",excludeHidden:!1,tags:["cat.name-role-value","wcag2a","wcag412","TTv5","TT6.a"],actIds:["6cfa84"],all:["focusable-modal-open","focusable-disabled","focusable-not-tabbable"],any:[],none:[]},{id:"aria-input-field-name",selector:\'[role="combobox"], [role="listbox"], [role="searchbox"], [role="slider"], [role="spinbutton"], [role="textbox"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","ACT","TTv5","TT5.c"],actIds:["e086e5"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["no-implicit-explicit-label"]},{id:"aria-meter-name",selector:\'[role="meter"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag111"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-progressbar-name",selector:\'[role="progressbar"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag111"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-required-attr",selector:"[role]",tags:["cat.aria","wcag2a","wcag412"],actIds:["4e8ab6"],all:[],any:["aria-required-attr"],none:[]},{id:"aria-required-children",selector:"[role]",matches:"aria-required-children-matches",tags:["cat.aria","wcag2a","wcag131"],actIds:["bc4a75","ff89c9"],all:[],any:[{options:{reviewEmpty:["doc-bibliography","doc-endnotes","grid","list","listbox","menu","menubar","table","tablist","tree","treegrid","rowgroup"]},id:"aria-required-children"},"aria-busy"],none:[]},{id:"aria-required-parent",selector:"[role]",matches:"aria-required-parent-matches",tags:["cat.aria","wcag2a","wcag131"],actIds:["ff89c9"],all:[],any:[{options:{ownGroupRoles:["listitem","treeitem"]},id:"aria-required-parent"}],none:[]},{id:"aria-roledescription",selector:"[aria-roledescription]",tags:["cat.aria","wcag2a","wcag412","deprecated"],enabled:!1,all:[],any:[{options:{supportedRoles:["button","img","checkbox","radio","combobox","menuitemcheckbox","menuitemradio"]},id:"aria-roledescription"}],none:[]},{id:"aria-roles",selector:"[role]",matches:"no-empty-role-matches",tags:["cat.aria","wcag2a","wcag412"],actIds:["674b10"],all:[],any:[],none:["invalidrole","abstractrole","unsupportedrole","deprecatedrole"]},{id:"aria-text",selector:"[role=text]",tags:["cat.aria","best-practice"],all:[],any:["no-focusable-content"],none:[]},{id:"aria-toggle-field-name",selector:\'[role="checkbox"], [role="menuitemcheckbox"], [role="menuitemradio"], [role="radio"], [role="switch"], [role="option"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","ACT","TTv5","TT5.c"],actIds:["e086e5"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["no-implicit-explicit-label"]},{id:"aria-tooltip-name",selector:\'[role="tooltip"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-treeitem-name",selector:\'[role="treeitem"]\',matches:"no-naming-method-matches",tags:["cat.aria","best-practice"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-valid-attr-value",matches:"aria-has-attr-matches",tags:["cat.aria","wcag2a","wcag412"],actIds:["6a7281"],all:[{options:[],id:"aria-valid-attr-value"},"aria-errormessage","aria-level"],any:[],none:[]},{id:"aria-valid-attr",matches:"aria-has-attr-matches",tags:["cat.aria","wcag2a","wcag412"],actIds:["5f99a7"],all:[],any:[{options:[],id:"aria-valid-attr"}],none:[]},{id:"audio-caption",selector:"audio",enabled:!1,excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag121","section508","section508.22.a","deprecated"],actIds:["2eb176","afb423"],all:[],any:[],none:["caption"]},{id:"autocomplete-valid",matches:"autocomplete-matches",tags:["cat.forms","wcag21aa","wcag135","ACT"],actIds:["73f2c2"],all:[{options:{stateTerms:["none","false","true","disabled","enabled","undefined","null"]},id:"autocomplete-valid"}],any:[],none:[]},{id:"avoid-inline-spacing",selector:"[style]",matches:"is-visible-on-screen-matches",tags:["cat.structure","wcag21aa","wcag1412","ACT"],actIds:["24afc2","9e45ec","78fd32"],all:[{options:{cssProperty:"letter-spacing",minValue:.12},id:"important-letter-spacing"},{options:{cssProperty:"word-spacing",minValue:.16},id:"important-word-spacing"},{options:{multiLineOnly:!0,cssProperty:"line-height",minValue:1.5,normalValue:1},id:"important-line-height"}],any:[],none:[]},{id:"blink",selector:"blink",excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag222","section508","section508.22.j","TTv5","TT2.b"],all:[],any:[],none:["is-on-screen"]},{id:"button-name",selector:"button",matches:"no-explicit-name-required-matches",tags:["cat.name-role-value","wcag2a","wcag412","section508","section508.22.a","ACT","TTv5","TT6.a"],actIds:["97a4e1","m6b1q3"],all:[],any:["button-has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"bypass",selector:"html",pageLevel:!0,matches:"bypass-matches",reviewOnFail:!0,tags:["cat.keyboard","wcag2a","wcag241","section508","section508.22.o","TTv5","TT9.a"],actIds:["cf77f2","047fe0","b40fd1","3e12e1","ye5d6e"],all:[],any:["internal-link-present",{options:{selector:":is(h1, h2, h3, h4, h5, h6):not([role]), [role=heading]"},id:"header-present"},{options:{selector:"main, [role=main]"},id:"landmark"}],none:[]},{id:"color-contrast-enhanced",matches:"color-contrast-matches",excludeHidden:!1,enabled:!1,tags:["cat.color","wcag2aaa","wcag146","ACT"],actIds:["09o5cg"],all:[],any:[{options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:7,minThreshold:4.5},large:{expected:4.5,minThreshold:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.1,textStrokeEmMin:.03},id:"color-contrast-enhanced"}],none:[]},{id:"color-contrast",matches:"color-contrast-matches",excludeHidden:!1,tags:["cat.color","wcag2aa","wcag143","ACT","TTv5","TT13.c"],actIds:["afw4f7","09o5cg"],all:[],any:[{options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:4.5},large:{expected:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.2,textStrokeEmMin:.03},id:"color-contrast"}],none:[]},{id:"css-orientation-lock",selector:"html",tags:["cat.structure","wcag134","wcag21aa","experimental"],actIds:["b33eff"],all:[{options:{degreeThreshold:2},id:"css-orientation-lock"}],any:[],none:[],preload:!0},{id:"definition-list",selector:"dl",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:[],none:["structured-dlitems",{options:{validRoles:["definition","term","listitem"],validNodeNames:["dt","dd"],divGroups:!0},id:"only-dlitems"}]},{id:"dlitem",selector:"dd, dt",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:["dlitem"],none:[]},{id:"document-title",selector:"html",matches:"is-initiator-matches",tags:["cat.text-alternatives","wcag2a","wcag242","ACT","TTv5","TT12.a"],actIds:["2779a5"],all:[],any:["doc-has-title"],none:[]},{id:"duplicate-id-active",selector:"[id]",matches:"duplicate-id-active-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag411"],actIds:["3ea0c8"],all:[],any:["duplicate-id-active"],none:[]},{id:"duplicate-id-aria",selector:"[id]",matches:"duplicate-id-aria-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag411"],actIds:["3ea0c8"],all:[],any:["duplicate-id-aria"],none:[]},{id:"duplicate-id",selector:"[id]",matches:"duplicate-id-misc-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag411"],actIds:["3ea0c8"],all:[],any:["duplicate-id"],none:[]},{id:"empty-heading",selector:\'h1, h2, h3, h4, h5, h6, [role="heading"]\',matches:"heading-matches",tags:["cat.name-role-value","best-practice"],actIds:["ffd0e9"],impact:"minor",all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"empty-table-header",selector:\'th:not([role]), [role="rowheader"], [role="columnheader"]\',tags:["cat.name-role-value","best-practice"],all:[],any:["has-visible-text"],none:[]},{id:"focus-order-semantics",selector:"div, h1, h2, h3, h4, h5, h6, [role=heading], p, span",matches:"inserted-into-focus-order-matches",tags:["cat.keyboard","best-practice","experimental"],all:[],any:[{options:[],id:"has-widget-role"},{options:{roles:["tooltip"]},id:"valid-scrollable-semantics"}],none:[]},{id:"form-field-multiple-labels",selector:"input, select, textarea",matches:"label-matches",tags:["cat.forms","wcag2a","wcag332","TTv5","TT5.c"],all:[],any:[],none:["multiple-label"]},{id:"frame-focusable-content",selector:"html",matches:"frame-focusable-content-matches",tags:["cat.keyboard","wcag2a","wcag211","TTv5","TT4.a"],actIds:["akn7bn"],all:[],any:["frame-focusable-content"],none:[]},{id:"frame-tested",selector:"html, frame, iframe",tags:["cat.structure","review-item","best-practice"],all:[{options:{isViolation:!1},id:"frame-tested"}],any:[],none:[]},{id:"frame-title-unique",selector:"frame[title], iframe[title]",matches:"frame-title-has-text-matches",tags:["cat.text-alternatives","wcag412","wcag2a","TTv5","TT12.d"],actIds:["4b1c6c"],all:[],any:[],none:["unique-frame-title"],reviewOnFail:!0},{id:"frame-title",selector:"frame, iframe",matches:"no-negative-tabindex-matches",tags:["cat.text-alternatives","wcag2a","wcag412","section508","section508.22.i","TTv5","TT12.d"],actIds:["cae760"],all:[],any:[{options:{attribute:"title"},id:"non-empty-title"},"aria-label","aria-labelledby","presentational-role"],none:[]},{id:"heading-order",selector:"h1, h2, h3, h4, h5, h6, [role=heading]",matches:"heading-matches",tags:["cat.semantics","best-practice"],all:[],any:["heading-order"],none:[]},{id:"hidden-content",selector:"*",excludeHidden:!1,tags:["cat.structure","experimental","review-item","best-practice"],all:[],any:["hidden-content"],none:[]},{id:"html-has-lang",selector:"html",matches:"is-initiator-matches",tags:["cat.language","wcag2a","wcag311","ACT","TTv5","TT11.a"],actIds:["b5c3f8"],all:[],any:[{options:{attributes:["lang","xml:lang"]},id:"has-lang"}],none:[]},{id:"html-lang-valid",selector:\'html[lang]:not([lang=""]), html[xml\\\\:lang]:not([xml\\\\:lang=""])\',tags:["cat.language","wcag2a","wcag311","ACT","TTv5","TT11.a"],actIds:["bf051a"],all:[],any:[],none:[{options:{attributes:["lang","xml:lang"]},id:"valid-lang"}]},{id:"html-xml-lang-mismatch",selector:"html[lang][xml\\\\:lang]",matches:"xml-lang-mismatch-matches",tags:["cat.language","wcag2a","wcag311","ACT"],actIds:["5b7ae0"],all:["xml-lang-mismatch"],any:[],none:[]},{id:"identical-links-same-purpose",selector:\'a[href], area[href], [role="link"]\',excludeHidden:!1,enabled:!1,matches:"identical-links-same-purpose-matches",tags:["cat.semantics","wcag2aaa","wcag249"],actIds:["b20e66"],all:["identical-links-same-purpose"],any:[],none:[]},{id:"image-alt",selector:"img",matches:"no-explicit-name-required-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","ACT","TTv5","TT7.a","TT7.b"],actIds:["23a2a8"],all:[],any:["has-alt","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:["alt-space-value"]},{id:"image-redundant-alt",selector:"img",tags:["cat.text-alternatives","best-practice"],all:[],any:[],none:[{options:{parentSelector:"button, [role=button], a[href], p, li, td, th"},id:"duplicate-img-label"}]},{id:"input-button-name",selector:\'input[type="button"], input[type="submit"], input[type="reset"]\',matches:"no-explicit-name-required-matches",tags:["cat.name-role-value","wcag2a","wcag412","section508","section508.22.a","ACT","TTv5","TT5.c"],actIds:["97a4e1"],all:[],any:["non-empty-if-present",{options:{attribute:"value"},id:"non-empty-value"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"input-image-alt",selector:\'input[type="image"]\',matches:"no-explicit-name-required-matches",tags:["cat.text-alternatives","wcag2a","wcag111","wcag412","section508","section508.22.a","ACT","TTv5","TT7.a"],actIds:["59796f"],all:[],any:[{options:{attribute:"alt"},id:"non-empty-alt"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"label-content-name-mismatch",matches:"label-content-name-mismatch-matches",tags:["cat.semantics","wcag21a","wcag253","experimental"],actIds:["2ee8b8"],all:[],any:[{options:{pixelThreshold:.1,occurrenceThreshold:3},id:"label-content-name-mismatch"}],none:[]},{id:"label-title-only",selector:"input, select, textarea",matches:"label-matches",tags:["cat.forms","best-practice"],all:[],any:[],none:["title-only"]},{id:"label",selector:"input, textarea",matches:"label-matches",tags:["cat.forms","wcag2a","wcag412","section508","section508.22.n","ACT","TTv5","TT5.c"],actIds:["e086e5"],all:[],any:["implicit-label","explicit-label","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},{options:{attribute:"placeholder"},id:"non-empty-placeholder"},"presentational-role"],none:["help-same-as-label","hidden-explicit-label"]},{id:"landmark-banner-is-top-level",selector:"header:not([role]), [role=banner]",matches:"landmark-has-body-context-matches",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-complementary-is-top-level",selector:"aside:not([role]), [role=complementary]",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-contentinfo-is-top-level",selector:"footer:not([role]), [role=contentinfo]",matches:"landmark-has-body-context-matches",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-main-is-top-level",selector:"main:not([role]), [role=main]",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-no-duplicate-banner",selector:"header:not([role]), [role=banner]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"header:not([role]), [role=banner]",nativeScopeFilter:"article, aside, main, nav, section"},id:"page-no-duplicate-banner"}],none:[]},{id:"landmark-no-duplicate-contentinfo",selector:"footer:not([role]), [role=contentinfo]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"footer:not([role]), [role=contentinfo]",nativeScopeFilter:"article, aside, main, nav, section"},id:"page-no-duplicate-contentinfo"}],none:[]},{id:"landmark-no-duplicate-main",selector:"main:not([role]), [role=main]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"main:not([role]), [role=\'main\']"},id:"page-no-duplicate-main"}],none:[]},{id:"landmark-one-main",selector:"html",tags:["cat.semantics","best-practice"],all:[{options:{selector:"main:not([role]), [role=\'main\']",passForModal:!0},id:"page-has-main"}],any:[],none:[]},{id:"landmark-unique",selector:"[role=banner], [role=complementary], [role=contentinfo], [role=main], [role=navigation], [role=region], [role=search], [role=form], form, footer, header, aside, main, nav, section",tags:["cat.semantics","best-practice"],matches:"landmark-unique-matches",all:[],any:["landmark-is-unique"],none:[]},{id:"link-in-text-block",selector:"a[href], [role=link]",matches:"link-in-text-block-matches",excludeHidden:!1,tags:["cat.color","wcag2a","wcag141","TTv5","TT13.a"],all:[],any:[{options:{requiredContrastRatio:3,allowSameColor:!0},id:"link-in-text-block"},"link-in-text-block-style"],none:[]},{id:"link-name",selector:"a[href]",tags:["cat.name-role-value","wcag2a","wcag412","wcag244","section508","section508.22.a","ACT","TTv5","TT6.a"],actIds:["c487ae"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["focusable-no-name"]},{id:"list",selector:"ul, ol",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:[],none:[{options:{validRoles:["listitem"],validNodeNames:["li"]},id:"only-listitems"}]},{id:"listitem",selector:"li",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:["listitem"],none:[]},{id:"marquee",selector:"marquee",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag222","TTv5","TT2.b"],all:[],any:[],none:["is-on-screen"]},{id:"meta-refresh-no-exceptions",selector:\'meta[http-equiv="refresh"][content]\',excludeHidden:!1,enabled:!1,tags:["cat.time-and-media","wcag2aaa","wcag224","wcag325"],actIds:["bisz58"],all:[],any:[{options:{minDelay:72e3,maxDelay:!1},id:"meta-refresh-no-exceptions"}],none:[]},{id:"meta-refresh",selector:\'meta[http-equiv="refresh"][content]\',excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag221","TTv5","TT8.a"],actIds:["bc659a","bisz58"],all:[],any:[{options:{minDelay:0,maxDelay:72e3},id:"meta-refresh"}],none:[]},{id:"meta-viewport-large",selector:\'meta[name="viewport"]\',matches:"is-initiator-matches",excludeHidden:!1,tags:["cat.sensory-and-visual-cues","best-practice"],all:[],any:[{options:{scaleMinimum:5,lowerBound:2},id:"meta-viewport-large"}],none:[]},{id:"meta-viewport",selector:\'meta[name="viewport"]\',matches:"is-initiator-matches",excludeHidden:!1,tags:["cat.sensory-and-visual-cues","wcag2aa","wcag144","ACT"],actIds:["b4f0c3"],all:[],any:[{options:{scaleMinimum:2},id:"meta-viewport"}],none:[]},{id:"nested-interactive",matches:"nested-interactive-matches",tags:["cat.keyboard","wcag2a","wcag412","TTv5","TT6.a"],actIds:["307n5z"],all:[],any:["no-focusable-content"],none:[]},{id:"no-autoplay-audio",excludeHidden:!1,selector:"audio[autoplay], video[autoplay]",matches:"no-autoplay-audio-matches",reviewOnFail:!0,tags:["cat.time-and-media","wcag2a","wcag142","ACT","TTv5","TT2.a"],actIds:["80f0bf"],preload:!0,all:[{options:{allowedDuration:3},id:"no-autoplay-audio"}],any:[],none:[]},{id:"object-alt",selector:"object[data]",matches:"object-is-loaded-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a"],actIds:["8fc3b6"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"p-as-heading",selector:"p",matches:"p-as-heading-matches",tags:["cat.semantics","wcag2a","wcag131","experimental"],all:[{options:{margins:[{weight:150,italic:!0},{weight:150,size:1.15},{italic:!0,size:1.15},{size:1.4}],passLength:1,failLength:.5},id:"p-as-heading"}],any:[],none:[]},{id:"page-has-heading-one",selector:"html",tags:["cat.semantics","best-practice"],all:[{options:{selector:"h1:not([role], [aria-level]), :is(h1, h2, h3, h4, h5, h6):not([role])[aria-level=1], [role=heading][aria-level=1]",passForModal:!0},id:"page-has-heading-one"}],any:[],none:[]},{id:"presentation-role-conflict",selector:\'img[alt=\\\'\\\'], [role="none"], [role="presentation"]\',matches:"has-implicit-chromium-role-matches",tags:["cat.aria","best-practice","ACT"],actIds:["46ca7f"],all:[],any:[],none:["is-element-focusable","has-global-aria-attribute"]},{id:"region",selector:"body *",tags:["cat.keyboard","best-practice"],all:[],any:[{options:{regionMatcher:"dialog, [role=dialog], [role=alertdialog], svg"},id:"region"}],none:[]},{id:"role-img-alt",selector:"[role=\'img\']:not(img, area, input, object)",matches:"html-namespace-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","ACT","TTv5","TT7.a"],actIds:["23a2a8"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"scope-attr-valid",selector:"td[scope], th[scope]",tags:["cat.tables","best-practice"],all:["html5-scope",{options:{values:["row","col","rowgroup","colgroup"]},id:"scope-value"}],any:[],none:[]},{id:"scrollable-region-focusable",selector:"*:not(select,textarea)",matches:"scrollable-region-focusable-matches",tags:["cat.keyboard","wcag2a","wcag211","TTv5","TT4.a"],actIds:["0ssw9k"],all:[],any:["focusable-content","focusable-element"],none:[]},{id:"select-name",selector:"select",tags:["cat.forms","wcag2a","wcag412","section508","section508.22.n","ACT","TTv5","TT5.c"],actIds:["e086e5"],all:[],any:["implicit-label","explicit-label","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:["help-same-as-label","hidden-explicit-label"]},{id:"server-side-image-map",selector:"img[ismap]",tags:["cat.text-alternatives","wcag2a","wcag211","section508","section508.22.f","TTv5","TT4.a"],all:[],any:[],none:["exists"]},{id:"skip-link",selector:\'a[href^="#"], a[href^="/#"]\',matches:"skip-link-matches",tags:["cat.keyboard","best-practice"],all:[],any:["skip-link"],none:[]},{id:"svg-img-alt",selector:\'[role="img"], [role="graphics-symbol"], svg[role="graphics-document"]\',matches:"svg-namespace-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","ACT","TTv5","TT7.a"],actIds:["7d6734"],all:[],any:["svg-non-empty-title","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"tabindex",selector:"[tabindex]",tags:["cat.keyboard","best-practice"],all:[],any:["tabindex"],none:[]},{id:"table-duplicate-name",selector:"table",tags:["cat.tables","best-practice"],all:[],any:[],none:["same-caption-summary"]},{id:"table-fake-caption",selector:"table",matches:"data-table-matches",tags:["cat.tables","experimental","wcag2a","wcag131","section508","section508.22.g"],all:["caption-faked"],any:[],none:[]},{id:"target-size",selector:"*",enabled:!1,matches:"widget-not-inline-matches",tags:["wcag22aa","wcag258","cat.sensory-and-visual-cues"],all:[],any:[{options:{minSize:24},id:"target-size"},{options:{minOffset:24},id:"target-offset"}],none:[]},{id:"td-has-header",selector:"table",matches:"data-table-large-matches",tags:["cat.tables","experimental","wcag2a","wcag131","section508","section508.22.g","TTv5","TT14.b"],all:["td-has-header"],any:[],none:[]},{id:"td-headers-attr",selector:"table",matches:"table-or-grid-role-matches",tags:["cat.tables","wcag2a","wcag131","section508","section508.22.g","TTv5","TT14.b"],actIds:["a25f45"],all:["td-headers-attr"],any:[],none:[]},{id:"th-has-data-cells",selector:"table",matches:"data-table-matches",tags:["cat.tables","wcag2a","wcag131","section508","section508.22.g","TTv5","14.b"],actIds:["d0f69e"],all:["th-has-data-cells"],any:[],none:[]},{id:"valid-lang",selector:"[lang]:not(html), [xml\\\\:lang]:not(html)",tags:["cat.language","wcag2aa","wcag312","ACT","TTv5","TT11.b"],actIds:["de46e4"],all:[],any:[],none:[{options:{attributes:["lang","xml:lang"]},id:"valid-lang"}]},{id:"video-caption",selector:"video",tags:["cat.text-alternatives","wcag2a","wcag122","section508","section508.22.a","TTv5","TT17.a"],actIds:["eac66b"],all:[],any:[],none:["caption"]}],checks:[{id:"abstractrole",evaluate:"abstractrole-evaluate"},{id:"aria-allowed-attr",evaluate:"aria-allowed-attr-evaluate",options:{validTreeRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]}},{id:"aria-allowed-role",evaluate:"aria-allowed-role-evaluate",options:{allowImplicit:!0,ignoredTags:[]}},{id:"aria-busy",evaluate:"aria-busy-evaluate"},{id:"aria-conditional-attr",evaluate:"aria-conditional-attr-evaluate",options:{invalidTableRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]}},{id:"aria-errormessage",evaluate:"aria-errormessage-evaluate"},{id:"aria-hidden-body",evaluate:"aria-hidden-body-evaluate"},{id:"aria-level",evaluate:"aria-level-evaluate"},{id:"aria-prohibited-attr",evaluate:"aria-prohibited-attr-evaluate",options:{elementsAllowedAriaLabel:["applet","input"]}},{id:"aria-required-attr",evaluate:"aria-required-attr-evaluate"},{id:"aria-required-children",evaluate:"aria-required-children-evaluate",options:{reviewEmpty:["doc-bibliography","doc-endnotes","grid","list","listbox","menu","menubar","table","tablist","tree","treegrid","rowgroup"]}},{id:"aria-required-parent",evaluate:"aria-required-parent-evaluate",options:{ownGroupRoles:["listitem","treeitem"]}},{id:"aria-roledescription",evaluate:"aria-roledescription-evaluate",options:{supportedRoles:["button","img","checkbox","radio","combobox","menuitemcheckbox","menuitemradio"]}},{id:"aria-unsupported-attr",evaluate:"aria-unsupported-attr-evaluate"},{id:"aria-valid-attr-value",evaluate:"aria-valid-attr-value-evaluate",options:[]},{id:"aria-valid-attr",evaluate:"aria-valid-attr-evaluate",options:[]},{id:"deprecatedrole",evaluate:"deprecatedrole-evaluate"},{id:"fallbackrole",evaluate:"fallbackrole-evaluate"},{id:"has-global-aria-attribute",evaluate:"has-global-aria-attribute-evaluate"},{id:"has-widget-role",evaluate:"has-widget-role-evaluate",options:[]},{id:"invalidrole",evaluate:"invalidrole-evaluate"},{id:"is-element-focusable",evaluate:"is-element-focusable-evaluate"},{id:"no-implicit-explicit-label",evaluate:"no-implicit-explicit-label-evaluate"},{id:"unsupportedrole",evaluate:"unsupportedrole-evaluate"},{id:"valid-scrollable-semantics",evaluate:"valid-scrollable-semantics-evaluate",options:{roles:["tooltip"]}},{id:"color-contrast-enhanced",evaluate:"color-contrast-evaluate",options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:7,minThreshold:4.5},large:{expected:4.5,minThreshold:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.1,textStrokeEmMin:.03}},{id:"color-contrast",evaluate:"color-contrast-evaluate",options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:4.5},large:{expected:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.2,textStrokeEmMin:.03}},{id:"link-in-text-block-style",evaluate:"link-in-text-block-style-evaluate"},{id:"link-in-text-block",evaluate:"link-in-text-block-evaluate",options:{requiredContrastRatio:3,allowSameColor:!0}},{id:"autocomplete-appropriate",evaluate:"autocomplete-appropriate-evaluate",deprecated:!0},{id:"autocomplete-valid",evaluate:"autocomplete-valid-evaluate",options:{stateTerms:["none","false","true","disabled","enabled","undefined","null"]}},{id:"accesskeys",evaluate:"accesskeys-evaluate",after:"accesskeys-after"},{id:"focusable-content",evaluate:"focusable-content-evaluate"},{id:"focusable-disabled",evaluate:"focusable-disabled-evaluate"},{id:"focusable-element",evaluate:"focusable-element-evaluate"},{id:"focusable-modal-open",evaluate:"focusable-modal-open-evaluate"},{id:"focusable-no-name",evaluate:"focusable-no-name-evaluate"},{id:"focusable-not-tabbable",evaluate:"focusable-not-tabbable-evaluate"},{id:"frame-focusable-content",evaluate:"frame-focusable-content-evaluate"},{id:"landmark-is-top-level",evaluate:"landmark-is-top-level-evaluate"},{id:"no-focusable-content",evaluate:"no-focusable-content-evaluate"},{id:"page-has-heading-one",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:"h1:not([role], [aria-level]), :is(h1, h2, h3, h4, h5, h6):not([role])[aria-level=1], [role=heading][aria-level=1]",passForModal:!0}},{id:"page-has-main",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:"main:not([role]), [role=\'main\']",passForModal:!0}},{id:"page-no-duplicate-banner",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"header:not([role]), [role=banner]",nativeScopeFilter:"article, aside, main, nav, section"}},{id:"page-no-duplicate-contentinfo",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"footer:not([role]), [role=contentinfo]",nativeScopeFilter:"article, aside, main, nav, section"}},{id:"page-no-duplicate-main",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"main:not([role]), [role=\'main\']"}},{id:"tabindex",evaluate:"tabindex-evaluate"},{id:"alt-space-value",evaluate:"alt-space-value-evaluate"},{id:"duplicate-img-label",evaluate:"duplicate-img-label-evaluate",options:{parentSelector:"button, [role=button], a[href], p, li, td, th"}},{id:"explicit-label",evaluate:"explicit-evaluate"},{id:"help-same-as-label",evaluate:"help-same-as-label-evaluate",enabled:!1},{id:"hidden-explicit-label",evaluate:"hidden-explicit-label-evaluate"},{id:"implicit-label",evaluate:"implicit-evaluate"},{id:"label-content-name-mismatch",evaluate:"label-content-name-mismatch-evaluate",options:{pixelThreshold:.1,occurrenceThreshold:3}},{id:"multiple-label",evaluate:"multiple-label-evaluate"},{id:"title-only",evaluate:"title-only-evaluate"},{id:"landmark-is-unique",evaluate:"landmark-is-unique-evaluate",after:"landmark-is-unique-after"},{id:"has-lang",evaluate:"has-lang-evaluate",options:{attributes:["lang","xml:lang"]}},{id:"valid-lang",evaluate:"valid-lang-evaluate",options:{attributes:["lang","xml:lang"]}},{id:"xml-lang-mismatch",evaluate:"xml-lang-mismatch-evaluate"},{id:"dlitem",evaluate:"dlitem-evaluate"},{id:"listitem",evaluate:"listitem-evaluate"},{id:"only-dlitems",evaluate:"invalid-children-evaluate",options:{validRoles:["definition","term","listitem"],validNodeNames:["dt","dd"],divGroups:!0}},{id:"only-listitems",evaluate:"invalid-children-evaluate",options:{validRoles:["listitem"],validNodeNames:["li"]}},{id:"structured-dlitems",evaluate:"structured-dlitems-evaluate"},{id:"caption",evaluate:"caption-evaluate"},{id:"frame-tested",evaluate:"frame-tested-evaluate",after:"frame-tested-after",options:{isViolation:!1}},{id:"no-autoplay-audio",evaluate:"no-autoplay-audio-evaluate",options:{allowedDuration:3}},{id:"css-orientation-lock",evaluate:"css-orientation-lock-evaluate",options:{degreeThreshold:2}},{id:"meta-viewport-large",evaluate:"meta-viewport-scale-evaluate",options:{scaleMinimum:5,lowerBound:2}},{id:"meta-viewport",evaluate:"meta-viewport-scale-evaluate",options:{scaleMinimum:2}},{id:"target-offset",evaluate:"target-offset-evaluate",options:{minOffset:24}},{id:"target-size",evaluate:"target-size-evaluate",options:{minSize:24}},{id:"header-present",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:":is(h1, h2, h3, h4, h5, h6):not([role]), [role=heading]"}},{id:"heading-order",evaluate:"heading-order-evaluate",after:"heading-order-after"},{id:"identical-links-same-purpose",evaluate:"identical-links-same-purpose-evaluate",after:"identical-links-same-purpose-after"},{id:"internal-link-present",evaluate:"internal-link-present-evaluate"},{id:"landmark",evaluate:"has-descendant-evaluate",options:{selector:"main, [role=main]"}},{id:"meta-refresh-no-exceptions",evaluate:"meta-refresh-evaluate",options:{minDelay:72e3,maxDelay:!1}},{id:"meta-refresh",evaluate:"meta-refresh-evaluate",options:{minDelay:0,maxDelay:72e3}},{id:"p-as-heading",evaluate:"p-as-heading-evaluate",options:{margins:[{weight:150,italic:!0},{weight:150,size:1.15},{italic:!0,size:1.15},{size:1.4}],passLength:1,failLength:.5}},{id:"region",evaluate:"region-evaluate",after:"region-after",options:{regionMatcher:"dialog, [role=dialog], [role=alertdialog], svg"}},{id:"skip-link",evaluate:"skip-link-evaluate"},{id:"unique-frame-title",evaluate:"unique-frame-title-evaluate",after:"unique-frame-title-after"},{id:"duplicate-id-active",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"duplicate-id-aria",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"duplicate-id",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"aria-label",evaluate:"aria-label-evaluate"},{id:"aria-labelledby",evaluate:"aria-labelledby-evaluate"},{id:"avoid-inline-spacing",evaluate:"avoid-inline-spacing-evaluate",options:{cssProperties:["line-height","letter-spacing","word-spacing"]}},{id:"button-has-visible-text",evaluate:"has-text-content-evaluate"},{id:"doc-has-title",evaluate:"doc-has-title-evaluate"},{id:"exists",evaluate:"exists-evaluate"},{id:"has-alt",evaluate:"has-alt-evaluate"},{id:"has-visible-text",evaluate:"has-text-content-evaluate"},{id:"important-letter-spacing",evaluate:"inline-style-property-evaluate",options:{cssProperty:"letter-spacing",minValue:.12}},{id:"important-line-height",evaluate:"inline-style-property-evaluate",options:{multiLineOnly:!0,cssProperty:"line-height",minValue:1.5,normalValue:1}},{id:"important-word-spacing",evaluate:"inline-style-property-evaluate",options:{cssProperty:"word-spacing",minValue:.16}},{id:"is-on-screen",evaluate:"is-on-screen-evaluate"},{id:"non-empty-alt",evaluate:"attr-non-space-content-evaluate",options:{attribute:"alt"}},{id:"non-empty-if-present",evaluate:"non-empty-if-present-evaluate"},{id:"non-empty-placeholder",evaluate:"attr-non-space-content-evaluate",options:{attribute:"placeholder"}},{id:"non-empty-title",evaluate:"attr-non-space-content-evaluate",options:{attribute:"title"}},{id:"non-empty-value",evaluate:"attr-non-space-content-evaluate",options:{attribute:"value"}},{id:"presentational-role",evaluate:"presentational-role-evaluate"},{id:"role-none",evaluate:"matches-definition-evaluate",deprecated:!0,options:{matcher:{attributes:{role:"none"}}}},{id:"role-presentation",evaluate:"matches-definition-evaluate",deprecated:!0,options:{matcher:{attributes:{role:"presentation"}}}},{id:"svg-non-empty-title",evaluate:"svg-non-empty-title-evaluate"},{id:"caption-faked",evaluate:"caption-faked-evaluate"},{id:"html5-scope",evaluate:"html5-scope-evaluate"},{id:"same-caption-summary",evaluate:"same-caption-summary-evaluate"},{id:"scope-value",evaluate:"scope-value-evaluate",options:{values:["row","col","rowgroup","colgroup"]}},{id:"td-has-header",evaluate:"td-has-header-evaluate"},{id:"td-headers-attr",evaluate:"td-headers-attr-evaluate"},{id:"th-has-data-cells",evaluate:"th-has-data-cells-evaluate"},{id:"hidden-content",evaluate:"hidden-content-evaluate"}]})}("object"==typeof window?window:this);'})),Nm={};async function Im(){let e=window.axe,t=`lighthouse-${Math.random()}`;e.configure({branding:{application:t},noHtml:!0});let a=await e.run(document,{elementRef:!0,runOnly:{type:"tag",values:["wcag2a","wcag2aa"]},resultTypes:["violations","inapplicable"],rules:{accesskeys:{enabled:!0},"area-alt":{enabled:!1},"aria-allowed-role":{enabled:!0},"aria-dialog-name":{enabled:!0},"aria-roledescription":{enabled:!1},"aria-treeitem-name":{enabled:!0},"aria-text":{enabled:!0},"audio-caption":{enabled:!1},blink:{enabled:!1},"duplicate-id":{enabled:!1},"empty-heading":{enabled:!0},"frame-focusable-content":{enabled:!1},"frame-title-unique":{enabled:!1},"heading-order":{enabled:!0},"html-xml-lang-mismatch":{enabled:!0},"identical-links-same-purpose":{enabled:!0},"image-redundant-alt":{enabled:!0},"input-button-name":{enabled:!0},"label-content-name-mismatch":{enabled:!0},"landmark-one-main":{enabled:!0},"link-in-text-block":{enabled:!0},marquee:{enabled:!1},"meta-viewport":{enabled:!0},"nested-interactive":{enabled:!1},"no-autoplay-audio":{enabled:!1},"role-img-alt":{enabled:!1},"scrollable-region-focusable":{enabled:!1},"select-name":{enabled:!0},"server-side-image-map":{enabled:!1},"skip-link":{enabled:!0},"svg-img-alt":{enabled:!1},tabindex:{enabled:!0},"table-duplicate-name":{enabled:!0},"table-fake-caption":{enabled:!0},"target-size":{enabled:!0},"td-has-header":{enabled:!0}}});return document.documentElement.scrollTop=0,{violations:a.violations.map(Pm),incomplete:a.incomplete.map(Pm),notApplicable:a.inapplicable.map((e=>({id:e.id}))),passes:a.passes.map((e=>({id:e.id}))),version:a.testEngine.version}}async function Mm(){let e={x:window.scrollX,y:window.scrollY};try{return await Im()}finally{window.scrollTo(e.x,e.y)}}function Pm(e){let t,a=e.nodes.map((e=>{let{target:t,failureSummary:a,element:n}=e,r=getNodeDetails(n),i=new Set,s=o((e=>[null,"minor","moderate","serious","critical"].indexOf(e)),"impactToNumber"),l=[...e.any,...e.all,...e.none].sort(((e,t)=>s(t.impact)-s(e.impact)));for(let e of l)for(let t of e.relatedNodes||[]){let e=t.element;if(i.size>=3)break;e&&n!==e&&i.add(e)}return{target:t,failureSummary:a,node:r,relatedNodes:[...i].map(getNodeDetails)}})),n=e.error;return n instanceof Error&&(t={name:n.name,message:n.message}),{id:e.id,impact:e.impact||void 0,tags:e.tags,nodes:a,error:t}}c(Nm,{default:()=>Om});var Lm,Om,jm=s((()=>{J(),aa(),Fm(),bd(),o(Im,"runA11yChecks"),o(Mm,"runA11yChecksAndResetScroll"),o(Pm,"createAxeRuleResultArtifact"),Lm=class extends Jt{static{o(this,"Accessibility")}meta={supportedModes:["snapshot","navigation"]};static pageFns={runA11yChecks:Im,createAxeRuleResultArtifact:Pm};getArtifact(e){return e.driver.executionContext.evaluate(Mm,{args:[],useIsolation:!0,deps:[_m,sd.getNodeDetails,Pm,Im]})}},Om=Lm}));function Um(e){if(!/No node.*found/.test(e.message)&&!/Node.*does not belong to the document/.test(e.message))throw e}async function Bm(e,t){try{return(await e.sendCommand("DOM.resolveNode",{backendNodeId:t})).object.objectId}catch(e){return Um(e)}}async function qm(e,t){try{let{nodeId:a}=await e.sendCommand("DOM.pushNodeByPathToFrontend",{path:t}),{object:{objectId:n}}=await e.sendCommand("DOM.resolveNode",{nodeId:a});return n}catch(e){return Um(e)}}var zm=s((()=>{J(),o(Um,"handlePotentialMissingNodeError"),o(Bm,"resolveNodeIdToObjectId"),o(qm,"resolveDevtoolsNodePathToObjectId")})),Vm={};function Wm(){let e=o((e=>{try{return new URL(e,window.location.href).href}catch{return""}}),"resolveURLOrEmpty");function t(e){return(e.getAttribute("onclick")||"").slice(0,1024)}return o(t,"getTruncatedOnclick"),getElementsInDocument("a").map((a=>a instanceof HTMLAnchorElement?{href:a.href,rawHref:a.getAttribute("href")||"",onclick:t(a),role:a.getAttribute("role")||"",name:a.name,text:a.innerText,rel:a.rel,target:a.target,id:a.getAttribute("id")||"",node:getNodeDetails(a)}:{href:e(a.href.baseVal),rawHref:a.getAttribute("href")||"",onclick:t(a),role:a.getAttribute("role")||"",text:a.textContent||"",rel:"",target:a.target.baseVal||"",id:a.getAttribute("id")||"",node:getNodeDetails(a)}))}async function Hm(e,t){let a=await qm(e,t);return a?(await e.sendCommand("DOMDebugger.getEventListeners",{objectId:a})).listeners.map((({type:e})=>({type:e}))):[]}c(Vm,{default:()=>$m});var Gm,$m,Km=s((()=>{J(),aa(),bd(),zm(),o(Wm,"collectAnchorElements"),o(Hm,"getEventListeners"),Gm=class extends Jt{static{o(this,"AnchorElements")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){let t=e.driver.defaultSession,a=await e.driver.executionContext.evaluate(Wm,{args:[],useIsolation:!0,deps:[sd.getElementsInDocument,sd.getNodeDetails]});await t.sendCommand("DOM.enable"),await t.sendCommand("DOM.getDocument",{depth:-1,pierce:!0});let n=a.map((async e=>{let a=await Hm(t,e.node.devtoolsNodePath);return{...e,listeners:a}})),r=await Promise.all(n);return await t.sendCommand("DOM.disable"),r}},$m=Gm}));function Ym(){return{promise:Promise.resolve(),cancel(){}}}function Jm(e){let t=o((()=>{throw new Error("waitForFrameNavigated.cancel() called before it was defined")}),"cancel");return{promise:new Promise(((a,n)=>{e.once("Page.frameNavigated",a),t=o((()=>{e.off("Page.frameNavigated",a),n(new Error("Wait for navigated cancelled"))}),"cancel")})),cancel:t}}function Zm(e,t,a){let n=o((()=>{throw new Error("waitForFcp.cancel() called before it was defined")}),"cancel");return{promise:new Promise(((r,i)=>{let s,l=setTimeout((()=>{i(new El(El.errors.NO_FCP))}),a),c=o((e=>{"firstContentfulPaint"===e.name&&(s=setTimeout((()=>{r(),n()}),t))}),"lifecycleListener");e.on("Page.lifecycleEvent",c);let u=!1;n=o((()=>{u||(u=!0,e.off("Page.lifecycleEvent",c),l&&clearTimeout(l),s&&clearTimeout(s),i(new Error("Wait for FCP canceled")))}),"cancel")})),cancel:n}}function Xm(e,t,a){let n,r=!1,i=o((()=>{throw new Error("waitForNetworkIdle.cancel() called before it was defined")}),"cancel"),{networkQuietThresholdMs:s,busyEvent:l,idleEvent:c,isIdle:u}=a;return{promise:new Promise(((d,m)=>{let p=o((()=>{t.once(l,h),n=setTimeout((()=>{i(),d()}),s)}),"onIdle"),h=o((()=>{t.once(c,p),n&&clearTimeout(n)}),"onBusy"),g=o((()=>{r=!0,u(t)?p():h()}),"domContentLoadedListener"),f=o((()=>{if(!r)return void Kt.verbose("waitFor","Waiting on DomContentLoaded");let e=t.getInflightRequests();if(Kt.isVerbose()&&e.length<20&&e.length>0){Kt.verbose("waitFor",`=== Waiting on ${e.length} requests to finish`);for(let t of e)Kt.verbose("waitFor",`Waiting on ${t.url.slice(0,120)} to finish`)}}),"logStatus");t.on("requeststarted",f),t.on("requestfinished",f),t.on(l,f),a.pretendDCLAlreadyFired?g():e.once("Page.domContentEventFired",g);let y=!1;i=o((()=>{y||(y=!0,n&&clearTimeout(n),a.pretendDCLAlreadyFired||e.off("Page.domContentEventFired",g),t.removeListener(l,h),t.removeListener(c,p),t.removeListener("requeststarted",f),t.removeListener("requestfinished",f),t.removeListener(l,f))}),"cancel")})),cancel:i}}function Qm(e,t){if(!t)return{promise:Promise.resolve(),cancel:()=>{}};let a,n=!1;async function r(e,i){if(n)return;let o=await e.evaluate(tp,{args:[],useIsolation:!0});if(!n&&"number"==typeof o)if(o>=t)Kt.verbose("waitFor",`CPU has been idle for ${o} ms`),i();else{Kt.verbose("waitFor",`CPU has been idle for ${o} ms`),a=setTimeout((()=>r(e,i)),t-o)}}o(r,"checkForQuiet");let i=o((()=>{throw new Error("waitForCPUIdle.cancel() called before it was defined")}),"cancel"),s=new ld(e);return{promise:new Promise(((e,t)=>{s.evaluate(ep,{args:[],useIsolation:!0}).then((()=>r(s,e))).catch(t),i=o((()=>{n||(n=!0,a&&clearTimeout(a),t(new Error("Wait for CPU idle canceled")))}),"cancel")})),cancel:i}}function ep(){void 0===window.____lastLongTask&&(window.____lastLongTask=performance.now(),new window.PerformanceObserver((e=>{let t=e.getEntries();for(let e of t)if("longtask"===e.entryType){let t=e.startTime+e.duration;window.____lastLongTask=Math.max(window.____lastLongTask||0,t)}})).observe({type:"longtask",buffered:!0}))}function tp(){return new Promise((e=>{let t=performance.now(),a=window.____lastLongTask||0;setTimeout((()=>{let n=window.____lastLongTask||0;e(a===n?t-a:0)}),150)}))}function ap(e,t){let a=o((()=>{throw new Error("waitForLoadEvent.cancel() called before it was defined")}),"cancel");return{promise:new Promise(((n,r)=>{let i,s=o((function(){i=setTimeout(n,t)}),"loadListener");e.once("Page.loadEventFired",s);let l=!1;a=o((()=>{l||(l=!0,e.off("Page.loadEventFired",s),i&&clearTimeout(i))}),"cancel")})),cancel:a}}async function np(e){try{return e.setNextProtocolTimeout(1e3),await e.sendCommand("Runtime.evaluate",{expression:'"ping"',returnByValue:!0,timeout:1e3}),!1}catch{return!0}}async function rp(e,t,a){let n,{pauseAfterFcpMs:r,pauseAfterLoadMs:i,networkQuietThresholdMs:s,cpuQuietThresholdMs:l,maxWaitForLoadedMs:c,maxWaitForFcpMs:u}=a,{waitForFcp:d,waitForLoadEvent:m,waitForNetworkIdle:p,waitForCPUIdle:h}=a._waitForTestOverrides||op,g=u?d(e,r,u):Ym(),f=m(e,i),y=p(e,t,{networkQuietThresholdMs:s,busyEvent:"network-2-busy",idleEvent:"network-2-idle",isIdle:e=>e.is2Idle()}),v=p(e,t,{networkQuietThresholdMs:s,busyEvent:"network-critical-busy",idleEvent:"network-critical-idle",isIdle:e=>e.isCriticalIdle()}),b=Ym(),w=Promise.all([g.promise,f.promise,y.promise,v.promise]).then((()=>(b=h(e,l),b.promise))).then((()=>o((async function(){return Kt.verbose("waitFor","loadEventFired and network considered idle"),{timedOut:!1}}),"cleanupFn"))).catch((e=>function(){throw e})),D=new Promise(((e,t)=>{n=setTimeout(e,c)})).then((a=>async()=>{if(Kt.warn("waitFor","Timed out waiting for page load. Checking if page is hung..."),await np(e))throw Kt.warn("waitFor","Page appears to be hung, killing JavaScript..."),await e.sendCommand("Emulation.setScriptExecutionDisabled",{value:!0}),await e.sendCommand("Runtime.terminateExecution"),new El(El.errors.PAGE_HUNG);let a=t.getInflightRequests().map((e=>e.url));return a.length>0&&Kt.warn("waitFor","Remaining inflight requests URLs",a),{timedOut:!0}})),E=await Promise.race([w,D]);return n&&clearTimeout(n),g.cancel(),f.cancel(),y.cancel(),b.cancel(),E()}function ip(e){function t(){let e=o((()=>{}),"resolve"),t=new Promise((t=>e=t));return console.log(["You have enabled Lighthouse navigation debug mode.",'When you have finished inspecting the page, evaluate "continueLighthouseRun()"',"in the console to continue with the Lighthouse run."].join(" ")),window.continueLighthouseRun=e,t}return o(t,"createInPagePromise"),e.defaultSession.setNextProtocolTimeout(2**31-1),e.executionContext.evaluate(t,{args:[]})}var op,sp=s((()=>{J(),ea(),xl(),wd(),o(Ym,"waitForNothing"),o(Jm,"waitForFrameNavigated"),o(Zm,"waitForFcp"),o(Xm,"waitForNetworkIdle"),o(Qm,"waitForCPUIdle"),o(ep,"registerPerformanceObserverInPage"),o(tp,"checkTimeSinceLastLongTaskInPage"),o(ap,"waitForLoadEvent"),o(np,"isPageHung"),op={waitForFcp:Zm,waitForLoadEvent:ap,waitForCPUIdle:Qm,waitForNetworkIdle:Xm},o(rp,"waitForFullyLoaded"),o(ip,"waitForUserToContinue")})),lp={};c(lp,{DevtoolsMessageLog:()=>up,default:()=>dp});var cp,up,dp,mp=s((()=>{J(),aa(),cp=class e extends Jt{static{o(this,"DevtoolsLog")}static symbol=Symbol("DevtoolsLog");meta={symbol:e.symbol,supportedModes:["timespan","navigation"]};constructor(){super(),this._messageLog=new up(/^(Page|Network|Target|Runtime)\./),this._onProtocolMessage=e=>this._messageLog.record(e)}async startSensitiveInstrumentation({driver:e}){this._messageLog.reset(),this._messageLog.beginRecording(),e.targetManager.on("protocolevent",this._onProtocolMessage),await e.defaultSession.sendCommand("Page.enable")}async stopSensitiveInstrumentation({driver:e}){this._messageLog.endRecording(),e.targetManager.off("protocolevent",this._onProtocolMessage)}async getArtifact(){return this._messageLog.messages}},up=class{static{o(this,"DevtoolsMessageLog")}constructor(e){this._filter=e,this._messages=[],this._isRecording=!1}get messages(){return this._messages}reset(){this._messages=[]}beginRecording(){this._isRecording=!0}endRecording(){this._isRecording=!1}record(e){this._isRecording&&"string"==typeof e.method&&(this._filter&&!this._filter.test(e.method)||this._messages.push(e))}},dp=cp})),pp={};c(pp,{default:()=>gp});var hp,gp,fp=s((()=>{J(),aa(),sp(),mp(),100,100,hp=class e extends Jt{static{o(this,"BFCacheFailures")}meta={supportedModes:["navigation","timespan"],dependencies:{DevtoolsLog:dp.symbol}};static processBFCacheEventList(e){let t={Circumstantial:{},PageSupportNeeded:{},SupportPending:{}};for(let a of e){t[a.type][a.reason]=[]}return{notRestoredReasonsTree:t}}static processBFCacheEventTree(e){let t={Circumstantial:{},PageSupportNeeded:{},SupportPending:{}};function a(e){for(let a of e.explanations){let n=t[a.type],r=n[a.reason]||[];r.push(e.url),n[a.reason]=r}for(let t of e.children)a(t)}return o(a,"traverse"),a(e),{notRestoredReasonsTree:t}}static processBFCacheEvent(t){return t?.notRestoredExplanationsTree?e.processBFCacheEventTree(t.notRestoredExplanationsTree):e.processBFCacheEventList(t?.notRestoredExplanations||[])}async activelyCollectBFCacheEvent(e){let t,a=e.driver.defaultSession;function n(e){t=e}o(n,"onBfCacheNotUsed"),a.on("Page.backForwardCacheNotUsed",n);let r=await a.sendCommand("Page.getNavigationHistory"),i=r.entries[r.currentIndex];await Promise.all([a.sendCommand("Page.navigate",{url:"chrome://terms"}),ap(a,100).promise]);let[,s]=await Promise.all([a.sendCommand("Page.navigateToHistoryEntry",{entryId:i.id}),Jm(a).promise]);if(await new Promise((e=>setTimeout(e,100))),"BackForwardCacheRestore"!==s.type&&!t)throw new Error("bfcache failed but the failure reasons were not emitted in time");return a.off("Page.backForwardCacheNotUsed",n),t}passivelyCollectBFCacheEvents(e){let t=[];for(let a of e.dependencies.DevtoolsLog)"Page.backForwardCacheNotUsed"===a.method&&t.push(a.params);return t}async getArtifact(t){let a=this.passivelyCollectBFCacheEvents(t);if("navigation"===t.gatherMode&&!t.settings.usePassiveGathering){let e=await this.activelyCollectBFCacheEvent(t);e&&a.push(e)}return a.map(e.processBFCacheEvent)}},gp=hp})),yp={};function vp(){return caches.keys().then((e=>Promise.all(e.map((e=>caches.open(e)))))).then((e=>{let t=[];return Promise.all(e.map((e=>e.keys().then((e=>{t.push(...e.map((e=>e.url)))}))))).then((e=>t))}))}c(yp,{default:()=>wp});var bp,wp,Dp=s((()=>{J(),aa(),o(vp,"getCacheContents"),bp=class extends Jt{static{o(this,"CacheContents")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){return await e.driver.executionContext.evaluate(vp,{args:[]})}},wp=bp})),Ep={};function Tp(e){if(typeof e.value<"u"||"undefined"===e.type)return String(e.value);if("string"==typeof e.description&&e.description!==e.className)return e.description;return`[${e.subtype||e.type} ${e.className||"Object"}]`}c(Ep,{default:()=>Cp});var Sp,Cp,kp=s((()=>{J(),aa(),o(Tp,"remoteObjectToString"),Sp=class extends Jt{static{o(this,"ConsoleMessages")}meta={supportedModes:["timespan","navigation"]};constructor(){super(),this._logEntries=[],this._onConsoleAPICalled=this.onConsoleAPICalled.bind(this),this._onExceptionThrown=this.onExceptionThrown.bind(this),this._onLogEntryAdded=this.onLogEntry.bind(this)}onConsoleAPICalled(e){let{type:t}=e;if("warning"!==t&&"error"!==t)return;let a=(e.args||[]).map(Tp).join(" ");if(!a&&!e.stackTrace)return;let{url:n,lineNumber:r,columnNumber:i}=e.stackTrace?.callFrames[0]||{},o={eventType:"consoleAPI",source:"warning"===t?"console.warn":"console.error",level:t,text:a,stackTrace:e.stackTrace,timestamp:e.timestamp,url:n,lineNumber:r,columnNumber:i};this._logEntries.push(o)}onExceptionThrown(e){let t=e.exceptionDetails.exception?e.exceptionDetails.exception.description:e.exceptionDetails.text;if(!t)return;let a={eventType:"exception",source:"exception",level:"error",text:t,stackTrace:e.exceptionDetails.stackTrace,timestamp:e.timestamp,url:e.exceptionDetails.url,scriptId:e.exceptionDetails.scriptId,lineNumber:e.exceptionDetails.lineNumber,columnNumber:e.exceptionDetails.columnNumber};this._logEntries.push(a)}onLogEntry(e){let{source:t,level:a,text:n,stackTrace:r,timestamp:i,url:o,lineNumber:s}=e.entry,l=e.entry.stackTrace?.callFrames[0];this._logEntries.push({eventType:"protocolLog",source:t,level:a,text:n,stackTrace:r,timestamp:i,url:o,scriptId:l?.scriptId,lineNumber:s,columnNumber:l?.columnNumber})}async startInstrumentation(e){let t=e.driver.defaultSession;t.on("Log.entryAdded",this._onLogEntryAdded),await t.sendCommand("Log.enable"),await t.sendCommand("Log.startViolationsReport",{config:[{name:"discouragedAPIUse",threshold:-1}]}),t.on("Runtime.consoleAPICalled",this._onConsoleAPICalled),t.on("Runtime.exceptionThrown",this._onExceptionThrown),await t.sendCommand("Runtime.enable")}async stopInstrumentation({driver:e}){await e.defaultSession.sendCommand("Log.stopViolationsReport"),await e.defaultSession.off("Log.entryAdded",this._onLogEntryAdded),await e.defaultSession.sendCommand("Log.disable"),await e.defaultSession.off("Runtime.consoleAPICalled",this._onConsoleAPICalled),await e.defaultSession.off("Runtime.exceptionThrown",this._onExceptionThrown),await e.defaultSession.sendCommand("Runtime.disable")}async getArtifact(){return this._logEntries}},Cp=Sp})),xp={};c(xp,{default:()=>_p});var Ap,_p,Rp=s((()=>{J(),ea(),aa(),Du(),Ap=class extends Jt{static{o(this,"CSSUsage")}constructor(){super(),this._session=void 0,this._sheetPromises=new Map,this._ruleUsage=void 0,this._onStylesheetAdded=this._onStylesheetAdded.bind(this)}meta={supportedModes:["snapshot","timespan","navigation"]};async _onStylesheetAdded(e){if(!this._session)throw new Error("Session not initialized");let t=e.header.styleSheetId,a=this._session.sendCommand("CSS.getStyleSheetText",{styleSheetId:t}).then((t=>({header:e.header,content:t.text}))).catch((t=>(Kt.warn("CSSUsage",`Error fetching content of stylesheet with URL "${e.header.sourceURL}"`),vu.captureException(t,{tags:{gatherer:"CSSUsage"},extra:{url:e.header.sourceURL},level:"error"}),t)));this._sheetPromises.set(t,a)}async startCSSUsageTracking(e){let t=e.driver.defaultSession;this._session=t,t.on("CSS.styleSheetAdded",this._onStylesheetAdded),await t.sendCommand("DOM.enable"),await t.sendCommand("CSS.enable"),await t.sendCommand("CSS.startRuleUsageTracking")}async stopCSSUsageTracking(e){let t=e.driver.defaultSession,a=await t.sendCommand("CSS.stopRuleUsageTracking");this._ruleUsage=a.ruleUsage,t.off("CSS.styleSheetAdded",this._onStylesheetAdded)}async startInstrumentation(e){"timespan"===e.gatherMode&&await this.startCSSUsageTracking(e)}async stopInstrumentation(e){"timespan"===e.gatherMode&&await this.stopCSSUsageTracking(e)}async getArtifact(e){let t=e.driver.defaultSession,a=e.driver.executionContext;"timespan"!==e.gatherMode&&(await this.startCSSUsageTracking(e),await a.evaluateAsync("getComputedStyle(document.body)"),await this.stopCSSUsageTracking(e));let n=new Map,r=await Promise.all(this._sheetPromises.values());for(let e of r)e instanceof Error||n.set(e.content,e);if(await t.sendCommand("CSS.disable"),await t.sendCommand("DOM.disable"),!this._ruleUsage)throw new Error("Issue collecting rule usages");return{rules:this._ruleUsage,stylesheets:Array.from(n.values())}}},_p=Ap})),Fp={};c(Fp,{default:()=>Ip});var Np,Ip,Mp=s((()=>{J(),mp(),aa(),Np=class extends Jt{static{o(this,"DevtoolsLogCompat")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:dp.symbol}};async getArtifact(e){return{defaultPass:e.dependencies.DevtoolsLog}}},Ip=Np})),Pp={};function Lp(){if(!document.doctype)return null;let e=document.compatMode,{name:t,publicId:a,systemId:n}=document.doctype;return{name:t,publicId:a,systemId:n,documentCompatMode:e}}c(Pp,{default:()=>jp});var Op,jp,Up=s((()=>{J(),aa(),o(Lp,"getDoctype"),Op=class extends Jt{static{o(this,"Doctype")}meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(Lp,{args:[],useIsolation:!0})}},jp=Op})),Bp={};function qp(e=document.body,t=!0){let a=null,n=-1,r=-1,i=0,s=null,l=o((function(e,o=1){o>n&&(a=e,n=o),e.children.length>r&&(s=e,r=e.children.length);let c=e.firstElementChild;for(;c;)l(c,o+1),t&&c.shadowRoot&&l(c.shadowRoot,o+1),c=c.nextElementSibling,i++;return{maxDepth:n,maxWidth:r,numElements:i}}),"_calcDOMWidthAndHeight"),c=l(e);return{depth:{max:c.maxDepth,...getNodeDetails(a)},width:{max:c.maxWidth,...getNodeDetails(s)},totalBodyElements:c.numElements}}c(Bp,{default:()=>Vp});var zp,Vp,Wp=s((()=>{J(),aa(),bd(),o(qp,"getDOMStats"),zp=class extends Jt{static{o(this,"DOMStats")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){let t=e.driver;await t.defaultSession.sendCommand("DOM.enable");let a=await t.executionContext.evaluate(qp,{args:[],useIsolation:!0,deps:[sd.getNodeDetails]});return await t.defaultSession.sendCommand("DOM.disable"),a}},Vp=zp})),Hp={};c(Hp,{default:()=>Kp});var Gp,$p,Kp,Yp,Jp=s((()=>{J(),ea(),aa(),ql(),qc(),Du(),Yc(),mp(),5e3,2048e3,.92,.85,4096,Gp=/^image\/((x|ms|x-ms)-)?(png|bmp|jpeg)$/,$p=class e extends Jt{static{o(this,"OptimizedImages")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:dp.symbol}};constructor(){super(),this._encodingStartAt=0}static filterImageRequests(e){let t=new Set;return e.reduce(((e,a)=>{if(t.has(a.url)||!a.finished||a.isOutOfProcessIframe)return e;t.add(a.url);let n=a.resourceType===wc.TYPES.Image&&Gp.test(a.mimeType),r=wc.getResourceSizeOnNetwork(a);return n&&r>4096&&e.push({requestId:a.requestId,url:a.url,mimeType:a.mimeType,resourceSize:r}),e}),[])}_getEncodedResponse(e,t,a){let n={requestId:t=wc.getRequestIdForBackend(t),encoding:a,quality:"jpeg"===a?.92:.85,sizeOnly:!0};return e.sendCommand("Audits.getEncodedResponse",n)}async calculateImageStats(e,t){let a=t.resourceSize;if(Date.now()-this._encodingStartAt>5e3||a>2048e3)return{originalSize:a,jpegSize:void 0,webpSize:void 0};let n=await this._getEncodedResponse(e,t.requestId,"jpeg"),r=await this._getEncodedResponse(e,t.requestId,"webp");return{originalSize:a,jpegSize:n.encodedSize,webpSize:r.encodedSize}}async computeOptimizedImages(e,t){this._encodingStartAt=Date.now();let a=[];for(let n of t)try{let t={failed:!1,...await this.calculateImageStats(e,n),...n};a.push(t)}catch(e){Kt.warn("optimized-images",e.message),vu.captureException(e,{tags:{gatherer:"OptimizedImages"},extra:{imageUrl:Ml.elideDataURI(n.url)},level:"warning"});let t={failed:!0,errMsg:e.message,...n};a.push(t)}return a}async getArtifact(t){let a=t.dependencies.DevtoolsLog,n=await Pc.request(a,t),r=e.filterImageRequests(n).sort(((e,t)=>t.resourceSize-e.resourceSize)),i=await this.computeOptimizedImages(t.driver.defaultSession,r),o=i.filter((e=>!e.failed));if(i.length&&!o.length)throw new Error("All image optimizations failed");return i}},Kp=$p})),Zp=s((()=>{J(),Yp={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"}}));function Xp(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0}var Qp,eh=s((()=>{J(),o(Xp,"ZStream"),Qp=Xp}));function th(e,t,a,n,r){if(t.subarray&&e.subarray)e.set(t.subarray(a,a+n),r);else for(var i=0;i<n;i++)e[r+i]=t[a+i]}var ah,nh,rh=s((()=>{J(),o(th,"arraySet"),ah=Uint8Array,nh=Uint16Array}));function ih(e){for(var t=e.length;--t>=0;)e[t]=0}function oh(e,t,a,n,r){this.static_tree=e,this.extra_bits=t,this.extra_base=a,this.elems=n,this.max_length=r,this.has_stree=e&&e.length}function sh(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t}function lh(e){return e<256?og[e]:og[256+(e>>>7)]}function ch(e,t){e.pending_buf[e.pending++]=255&t,e.pending_buf[e.pending++]=t>>>8&255}function uh(e,t,a){e.bi_valid>Kh-a?(e.bi_buf|=t<<e.bi_valid&65535,ch(e,e.bi_buf),e.bi_buf=t>>Kh-e.bi_valid,e.bi_valid+=a-Kh):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=a)}function dh(e,t,a){uh(e,a[2*t],a[2*t+1])}function mh(e,t){var a=0;do{a|=1&e,e>>>=1,a<<=1}while(--t>0);return a>>>1}function ph(e){16===e.bi_valid?(ch(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=255&e.bi_buf,e.bi_buf>>=8,e.bi_valid-=8)}function hh(e,t){var a,n,r,i,o,s,l=t.dyn_tree,c=t.max_code,u=t.stat_desc.static_tree,d=t.stat_desc.has_stree,m=t.stat_desc.extra_bits,p=t.stat_desc.extra_base,h=t.stat_desc.max_length,g=0;for(i=0;i<=$h;i++)e.bl_count[i]=0;for(l[2*e.heap[e.heap_max]+1]=0,a=e.heap_max+1;a<Gh;a++)(i=l[2*l[2*(n=e.heap[a])+1]+1]+1)>h&&(i=h,g++),l[2*n+1]=i,!(n>c)&&(e.bl_count[i]++,o=0,n>=p&&(o=m[n-p]),s=l[2*n],e.opt_len+=s*(i+o),d&&(e.static_len+=s*(u[2*n+1]+o)));if(0!==g){do{for(i=h-1;0===e.bl_count[i];)i--;e.bl_count[i]--,e.bl_count[i+1]+=2,e.bl_count[h]--,g-=2}while(g>0);for(i=h;0!==i;i--)for(n=e.bl_count[i];0!==n;)!((r=e.heap[--a])>c)&&(l[2*r+1]!==i&&(e.opt_len+=(i-l[2*r+1])*l[2*r],l[2*r+1]=i),n--)}}function gh(e,t,a){var n,r,i=new Array($h+1),o=0;for(n=1;n<=$h;n++)i[n]=o=o+a[n-1]<<1;for(r=0;r<=t;r++){var s=e[2*r+1];0!==s&&(e[2*r]=mh(i[s]++,s))}}function fh(){var e,t,a,n,r,i=new Array($h+1);for(a=0,n=0;n<qh-1;n++)for(lg[n]=a,e=0;e<1<<eg[n];e++)sg[a++]=n;for(sg[a-1]=n,r=0,n=0;n<16;n++)for(cg[n]=r,e=0;e<1<<tg[n];e++)og[r++]=n;for(r>>=7;n<Wh;n++)for(cg[n]=r<<7,e=0;e<1<<tg[n]-7;e++)og[256+r++]=n;for(t=0;t<=$h;t++)i[t]=0;for(e=0;e<=143;)rg[2*e+1]=8,e++,i[8]++;for(;e<=255;)rg[2*e+1]=9,e++,i[9]++;for(;e<=279;)rg[2*e+1]=7,e++,i[7]++;for(;e<=287;)rg[2*e+1]=8,e++,i[8]++;for(gh(rg,Vh+1,i),e=0;e<Wh;e++)ig[2*e+1]=5,ig[2*e]=mh(e,5);ug=new oh(rg,eg,zh+1,Vh,$h),dg=new oh(ig,tg,0,Wh,$h),mg=new oh(new Array(0),ag,0,Hh,Yh)}function yh(e){var t;for(t=0;t<Vh;t++)e.dyn_ltree[2*t]=0;for(t=0;t<Wh;t++)e.dyn_dtree[2*t]=0;for(t=0;t<Hh;t++)e.bl_tree[2*t]=0;e.dyn_ltree[2*Jh]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0}function vh(e){e.bi_valid>8?ch(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0}function bh(e,t,a,n){vh(e),n&&(ch(e,a),ch(e,~a)),th(e.pending_buf,e.window,t,a,e.pending),e.pending+=a}function wh(e,t,a,n){var r=2*t,i=2*a;return e[r]<e[i]||e[r]===e[i]&&n[t]<=n[a]}function Dh(e,t,a){for(var n=e.heap[a],r=a<<1;r<=e.heap_len&&(r<e.heap_len&&wh(t,e.heap[r+1],e.heap[r],e.depth)&&r++,!wh(t,n,e.heap[r],e.depth));)e.heap[a]=e.heap[r],a=r,r<<=1;e.heap[a]=n}function Eh(e,t,a){var n,r,i,o,s=0;if(0!==e.last_lit)do{n=e.pending_buf[e.d_buf+2*s]<<8|e.pending_buf[e.d_buf+2*s+1],r=e.pending_buf[e.l_buf+s],s++,0===n?dh(e,r,t):(dh(e,(i=sg[r])+zh+1,t),0!==(o=eg[i])&&uh(e,r-=lg[i],o),dh(e,i=lh(--n),a),0!==(o=tg[i])&&uh(e,n-=cg[i],o))}while(s<e.last_lit);dh(e,Jh,t)}function Th(e,t){var a,n,r,i=t.dyn_tree,o=t.stat_desc.static_tree,s=t.stat_desc.has_stree,l=t.stat_desc.elems,c=-1;for(e.heap_len=0,e.heap_max=Gh,a=0;a<l;a++)0!==i[2*a]?(e.heap[++e.heap_len]=c=a,e.depth[a]=0):i[2*a+1]=0;for(;e.heap_len<2;)i[2*(r=e.heap[++e.heap_len]=c<2?++c:0)]=1,e.depth[r]=0,e.opt_len--,s&&(e.static_len-=o[2*r+1]);for(t.max_code=c,a=e.heap_len>>1;a>=1;a--)Dh(e,i,a);r=l;do{a=e.heap[1],e.heap[1]=e.heap[e.heap_len--],Dh(e,i,1),n=e.heap[1],e.heap[--e.heap_max]=a,e.heap[--e.heap_max]=n,i[2*r]=i[2*a]+i[2*n],e.depth[r]=(e.depth[a]>=e.depth[n]?e.depth[a]:e.depth[n])+1,i[2*a+1]=i[2*n+1]=r,e.heap[1]=r++,Dh(e,i,1)}while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],hh(e,t),gh(i,c,e.bl_count)}function Sh(e,t,a){var n,r,i=-1,o=t[1],s=0,l=7,c=4;for(0===o&&(l=138,c=3),t[2*(a+1)+1]=65535,n=0;n<=a;n++)r=o,o=t[2*(n+1)+1],!(++s<l&&r===o)&&(s<c?e.bl_tree[2*r]+=s:0!==r?(r!==i&&e.bl_tree[2*r]++,e.bl_tree[2*Zh]++):s<=10?e.bl_tree[2*Xh]++:e.bl_tree[2*Qh]++,s=0,i=r,0===o?(l=138,c=3):r===o?(l=6,c=3):(l=7,c=4))}function Ch(e,t,a){var n,r,i=-1,o=t[1],s=0,l=7,c=4;for(0===o&&(l=138,c=3),n=0;n<=a;n++)if(r=o,o=t[2*(n+1)+1],!(++s<l&&r===o)){if(s<c)do{dh(e,r,e.bl_tree)}while(0!=--s);else 0!==r?(r!==i&&(dh(e,r,e.bl_tree),s--),dh(e,Zh,e.bl_tree),uh(e,s-3,2)):s<=10?(dh(e,Xh,e.bl_tree),uh(e,s-3,3)):(dh(e,Qh,e.bl_tree),uh(e,s-11,7));s=0,i=r,0===o?(l=138,c=3):r===o?(l=6,c=3):(l=7,c=4)}}function kh(e){var t;for(Sh(e,e.dyn_ltree,e.l_desc.max_code),Sh(e,e.dyn_dtree,e.d_desc.max_code),Th(e,e.bl_desc),t=Hh-1;t>=3&&0===e.bl_tree[2*ng[t]+1];t--);return e.opt_len+=3*(t+1)+5+5+4,t}function xh(e,t,a,n){var r;for(uh(e,t-257,5),uh(e,a-1,5),uh(e,n-4,4),r=0;r<n;r++)uh(e,e.bl_tree[2*ng[r]+1],3);Ch(e,e.dyn_ltree,t-1),Ch(e,e.dyn_dtree,a-1)}function Ah(e){var t,a=4093624447;for(t=0;t<=31;t++,a>>>=1)if(1&a&&0!==e.dyn_ltree[2*t])return Ph;if(0!==e.dyn_ltree[18]||0!==e.dyn_ltree[20]||0!==e.dyn_ltree[26])return Lh;for(t=32;t<zh;t++)if(0!==e.dyn_ltree[2*t])return Lh;return Ph}function _h(e){pg||(fh(),pg=!0),e.l_desc=new sh(e.dyn_ltree,ug),e.d_desc=new sh(e.dyn_dtree,dg),e.bl_desc=new sh(e.bl_tree,mg),e.bi_buf=0,e.bi_valid=0,yh(e)}function Rh(e,t,a,n){uh(e,(jh<<1)+(n?1:0),3),bh(e,t,a,!0)}function Fh(e){uh(e,Uh<<1,3),dh(e,Jh,rg),ph(e)}function Nh(e,t,a,n){var r,i,o=0;e.level>0?(e.strm.data_type===Oh&&(e.strm.data_type=Ah(e)),Th(e,e.l_desc),Th(e,e.d_desc),o=kh(e),r=e.opt_len+3+7>>>3,(i=e.static_len+3+7>>>3)<=r&&(r=i)):r=i=a+5,a+4<=r&&-1!==t?Rh(e,t,a,n):e.strategy===Mh||i===r?(uh(e,(Uh<<1)+(n?1:0),3),Eh(e,rg,ig)):(uh(e,(Bh<<1)+(n?1:0),3),xh(e,e.l_desc.max_code+1,e.d_desc.max_code+1,o+1),Eh(e,e.dyn_ltree,e.dyn_dtree)),yh(e),n&&vh(e)}function Ih(e,t,a){return e.pending_buf[e.d_buf+2*e.last_lit]=t>>>8&255,e.pending_buf[e.d_buf+2*e.last_lit+1]=255&t,e.pending_buf[e.l_buf+e.last_lit]=255&a,e.last_lit++,0===t?e.dyn_ltree[2*a]++:(e.matches++,t--,e.dyn_ltree[2*(sg[a]+zh+1)]++,e.dyn_dtree[2*lh(t)]++),e.last_lit===e.lit_bufsize-1}var Mh,Ph,Lh,Oh,jh,Uh,Bh,qh,zh,Vh,Wh,Hh,Gh,$h,Kh,Yh,Jh,Zh,Xh,Qh,eg,tg,ag,ng,rg,ig,og,sg,lg,cg,ug,dg,mg,pg,hg=s((()=>{J(),rh(),Mh=4,Ph=0,Lh=1,Oh=2,o(ih,"zero"),jh=0,Uh=1,Bh=2,3,258,Wh=30,Hh=19,Gh=2*(Vh=(zh=256)+1+(qh=29))+1,$h=15,Kh=16,Yh=7,Jh=256,Zh=16,Xh=17,Qh=18,eg=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],tg=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],ag=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],ng=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],512,ih(rg=new Array(2*(Vh+2))),ih(ig=new Array(2*Wh)),ih(og=new Array(512)),ih(sg=new Array(256)),ih(lg=new Array(qh)),ih(cg=new Array(Wh)),o(oh,"StaticTreeDesc"),o(sh,"TreeDesc"),o(lh,"d_code"),o(ch,"put_short"),o(uh,"send_bits"),o(dh,"send_code"),o(mh,"bi_reverse"),o(ph,"bi_flush"),o(hh,"gen_bitlen"),o(gh,"gen_codes"),o(fh,"tr_static_init"),o(yh,"init_block"),o(vh,"bi_windup"),o(bh,"copy_block"),o(wh,"smaller"),o(Dh,"pqdownheap"),o(Eh,"compress_block"),o(Th,"build_tree"),o(Sh,"scan_tree"),o(Ch,"send_tree"),o(kh,"build_bl_tree"),o(xh,"send_all_trees"),o(Ah,"detect_data_type"),pg=!1,o(_h,"_tr_init"),o(Rh,"_tr_stored_block"),o(Fh,"_tr_align"),o(Nh,"_tr_flush_block"),o(Ih,"_tr_tally")}));function gg(e,t,a,n){for(var r=65535&e|0,i=e>>>16&65535|0,o=0;0!==a;){a-=o=a>2e3?2e3:a;do{i=i+(r=r+t[n++]|0)|0}while(--o);r%=65521,i%=65521}return r|i<<16|0}var fg,yg=s((()=>{J(),o(gg,"adler32"),fg=gg}));function vg(){for(var e,t=[],a=0;a<256;a++){e=a;for(var n=0;n<8;n++)e=1&e?3988292384^e>>>1:e>>>1;t[a]=e}return t}function bg(e,t,a,n){var r=wg,i=n+a;e^=-1;for(var o=n;o<i;o++)e=e>>>8^r[255&(e^t[o])];return-1^e}var wg,Dg,Eg=s((()=>{J(),o(vg,"makeTable"),wg=vg(),o(bg,"crc32"),Dg=bg}));function Tg(e,t){return e.msg=Yp[t],t}function Sg(e){return(e<<1)-(e>4?9:0)}function Cg(e){for(var t=e.length;--t>=0;)e[t]=0}function kg(e){var t=e.state,a=t.pending;a>e.avail_out&&(a=e.avail_out),0!==a&&(th(e.output,t.pending_buf,t.pending_out,a,e.next_out),e.next_out+=a,t.pending_out+=a,e.total_out+=a,e.avail_out-=a,t.pending-=a,0===t.pending&&(t.pending_out=0))}function xg(e,t){Nh(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,kg(e.strm)}function Ag(e,t){e.pending_buf[e.pending++]=t}function _g(e,t){e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=255&t}function Rg(e,t,a,n){var r=e.avail_in;return r>n&&(r=n),0===r?0:(e.avail_in-=r,th(t,e.input,e.next_in,r,a),1===e.state.wrap?e.adler=fg(e.adler,t,r,a):2===e.state.wrap&&(e.adler=Dg(e.adler,t,r,a)),e.next_in+=r,e.total_in+=r,r)}function Fg(e,t){var a,n,r=e.max_chain_length,i=e.strstart,o=e.prev_length,s=e.nice_match,l=e.strstart>e.w_size-vf?e.strstart-(e.w_size-vf):0,c=e.window,u=e.w_mask,d=e.prev,m=e.strstart+yf,p=c[i+o-1],h=c[i+o];e.prev_length>=e.good_match&&(r>>=2),s>e.lookahead&&(s=e.lookahead);do{if(c[(a=t)+o]===h&&c[a+o-1]===p&&c[a]===c[i]&&c[++a]===c[i+1]){i+=2,a++;do{}while(c[++i]===c[++a]&&c[++i]===c[++a]&&c[++i]===c[++a]&&c[++i]===c[++a]&&c[++i]===c[++a]&&c[++i]===c[++a]&&c[++i]===c[++a]&&c[++i]===c[++a]&&i<m);if(n=yf-(m-i),i=m-yf,n>o){if(e.match_start=t,o=n,n>=s)break;p=c[i+o-1],h=c[i+o]}}}while((t=d[t&u])>l&&0!=--r);return o<=e.lookahead?o:e.lookahead}function Ng(e){var t,a,n,r,i,o=e.w_size;do{if(r=e.window_size-e.lookahead-e.strstart,e.strstart>=o+(o-vf)){th(e.window,e.window,o,o,0),e.match_start-=o,e.strstart-=o,e.block_start-=o,t=a=e.hash_size;do{n=e.head[--t],e.head[t]=n>=o?n-o:0}while(--a);t=a=o;do{n=e.prev[--t],e.prev[t]=n>=o?n-o:0}while(--a);r+=o}if(0===e.strm.avail_in)break;if(a=Rg(e.strm,e.window,e.strstart+e.lookahead,r),e.lookahead+=a,e.lookahead+e.insert>=ff)for(i=e.strstart-e.insert,e.ins_h=e.window[i],e.ins_h=(e.ins_h<<e.hash_shift^e.window[i+1])&e.hash_mask;e.insert&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[i+ff-1])&e.hash_mask,e.prev[i&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=i,i++,e.insert--,!(e.lookahead+e.insert<ff)););}while(e.lookahead<vf&&0!==e.strm.avail_in)}function Ig(e,t){var a=65535;for(a>e.pending_buf_size-5&&(a=e.pending_buf_size-5);;){if(e.lookahead<=1){if(Ng(e),0===e.lookahead&&t===Gg)return xf;if(0===e.lookahead)break}e.strstart+=e.lookahead,e.lookahead=0;var n=e.block_start+a;if((0===e.strstart||e.strstart>=n)&&(e.lookahead=e.strstart-n,e.strstart=n,xg(e,!1),0===e.strm.avail_out)||e.strstart-e.block_start>=e.w_size-vf&&(xg(e,!1),0===e.strm.avail_out))return xf}return e.insert=0,t===Yg?(xg(e,!0),0===e.strm.avail_out?_f:Rf):(e.strstart>e.block_start&&(xg(e,!1),e.strm.avail_out),xf)}function Mg(e,t){for(var a,n;;){if(e.lookahead<vf){if(Ng(e),e.lookahead<vf&&t===Gg)return xf;if(0===e.lookahead)break}if(a=0,e.lookahead>=ff&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+ff-1])&e.hash_mask,a=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),0!==a&&e.strstart-a<=e.w_size-vf&&(e.match_length=Fg(e,a)),e.match_length>=ff)if(n=Ih(e,e.strstart-e.match_start,e.match_length-ff),e.lookahead-=e.match_length,e.match_length<=e.max_lazy_match&&e.lookahead>=ff){e.match_length--;do{e.strstart++,e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+ff-1])&e.hash_mask,a=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart}while(0!=--e.match_length);e.strstart++}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+1])&e.hash_mask;else n=Ih(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(n&&(xg(e,!1),0===e.strm.avail_out))return xf}return e.insert=e.strstart<ff-1?e.strstart:ff-1,t===Yg?(xg(e,!0),0===e.strm.avail_out?_f:Rf):e.last_lit&&(xg(e,!1),0===e.strm.avail_out)?xf:Af}function Pg(e,t){for(var a,n,r;;){if(e.lookahead<vf){if(Ng(e),e.lookahead<vf&&t===Gg)return xf;if(0===e.lookahead)break}if(a=0,e.lookahead>=ff&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+ff-1])&e.hash_mask,a=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=ff-1,0!==a&&e.prev_length<e.max_lazy_match&&e.strstart-a<=e.w_size-vf&&(e.match_length=Fg(e,a),e.match_length<=5&&(e.strategy===nf||e.match_length===ff&&e.strstart-e.match_start>4096)&&(e.match_length=ff-1)),e.prev_length>=ff&&e.match_length<=e.prev_length){r=e.strstart+e.lookahead-ff,n=Ih(e,e.strstart-1-e.prev_match,e.prev_length-ff),e.lookahead-=e.prev_length-1,e.prev_length-=2;do{++e.strstart<=r&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+ff-1])&e.hash_mask,a=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart)}while(0!=--e.prev_length);if(e.match_available=0,e.match_length=ff-1,e.strstart++,n&&(xg(e,!1),0===e.strm.avail_out))return xf}else if(e.match_available){if((n=Ih(e,0,e.window[e.strstart-1]))&&xg(e,!1),e.strstart++,e.lookahead--,0===e.strm.avail_out)return xf}else e.match_available=1,e.strstart++,e.lookahead--}return e.match_available&&(n=Ih(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<ff-1?e.strstart:ff-1,t===Yg?(xg(e,!0),0===e.strm.avail_out?_f:Rf):e.last_lit&&(xg(e,!1),0===e.strm.avail_out)?xf:Af}function Lg(e,t){for(var a,n,r,i,o=e.window;;){if(e.lookahead<=yf){if(Ng(e),e.lookahead<=yf&&t===Gg)return xf;if(0===e.lookahead)break}if(e.match_length=0,e.lookahead>=ff&&e.strstart>0&&((n=o[r=e.strstart-1])===o[++r]&&n===o[++r]&&n===o[++r])){i=e.strstart+yf;do{}while(n===o[++r]&&n===o[++r]&&n===o[++r]&&n===o[++r]&&n===o[++r]&&n===o[++r]&&n===o[++r]&&n===o[++r]&&r<i);e.match_length=yf-(i-r),e.match_length>e.lookahead&&(e.match_length=e.lookahead)}if(e.match_length>=ff?(a=Ih(e,1,e.match_length-ff),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(a=Ih(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++),a&&(xg(e,!1),0===e.strm.avail_out))return xf}return e.insert=0,t===Yg?(xg(e,!0),0===e.strm.avail_out?_f:Rf):e.last_lit&&(xg(e,!1),0===e.strm.avail_out)?xf:Af}function Og(e,t){for(var a;;){if(0===e.lookahead&&(Ng(e),0===e.lookahead)){if(t===Gg)return xf;break}if(e.match_length=0,a=Ih(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++,a&&(xg(e,!1),0===e.strm.avail_out))return xf}return e.insert=0,t===Yg?(xg(e,!0),0===e.strm.avail_out?_f:Rf):e.last_lit&&(xg(e,!1),0===e.strm.avail_out)?xf:Af}function jg(e,t,a,n,r){this.good_length=e,this.max_lazy=t,this.nice_length=a,this.max_chain=n,this.func=r}function Ug(e){e.window_size=2*e.w_size,Cg(e.head),e.max_lazy_match=Nf[e.level].max_lazy,e.good_match=Nf[e.level].good_length,e.nice_match=Nf[e.level].nice_length,e.max_chain_length=Nf[e.level].max_chain,e.strstart=0,e.block_start=0,e.lookahead=0,e.insert=0,e.match_length=e.prev_length=ff-1,e.match_available=0,e.ins_h=0}function Bg(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=cf,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new nh(2*hf),this.dyn_dtree=new nh(2*(2*mf+1)),this.bl_tree=new nh(2*(2*pf+1)),Cg(this.dyn_ltree),Cg(this.dyn_dtree),Cg(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new nh(gf+1),this.heap=new nh(2*df+1),Cg(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new nh(2*df+1),Cg(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}function qg(e){var t;return e&&e.state?(e.total_in=e.total_out=0,e.data_type=lf,(t=e.state).pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?wf:Cf,e.adler=2===t.wrap?0:1,t.last_flush=Gg,_h(t),Zg):Tg(e,Qg)}function zg(e){var t=qg(e);return t===Zg&&Ug(e.state),t}function Vg(e,t,a,n,r,i){if(!e)return Qg;var o=1;if(t===af&&(t=6),n<0?(o=0,n=-n):n>15&&(o=2,n-=16),r<1||r>uf||a!==cf||n<8||n>15||t<0||t>9||i<0||i>sf)return Tg(e,Qg);8===n&&(n=9);var s=new Bg;return e.state=s,s.strm=e,s.wrap=o,s.gzhead=null,s.w_bits=n,s.w_size=1<<s.w_bits,s.w_mask=s.w_size-1,s.hash_bits=r+7,s.hash_size=1<<s.hash_bits,s.hash_mask=s.hash_size-1,s.hash_shift=~~((s.hash_bits+ff-1)/ff),s.window=new ah(2*s.w_size),s.head=new nh(s.hash_size),s.prev=new nh(s.w_size),s.lit_bufsize=1<<r+6,s.pending_buf_size=4*s.lit_bufsize,s.pending_buf=new ah(s.pending_buf_size),s.d_buf=1*s.lit_bufsize,s.l_buf=3*s.lit_bufsize,s.level=t,s.strategy=i,s.method=a,zg(e)}function Wg(e,t){var a,n,r,i;if(!e||!e.state||t>Jg||t<0)return e?Tg(e,Qg):Qg;if(n=e.state,!e.output||!e.input&&0!==e.avail_in||n.status===kf&&t!==Yg)return Tg(e,0===e.avail_out?tf:Qg);if(n.strm=e,a=n.last_flush,n.last_flush=t,n.status===wf)if(2===n.wrap)e.adler=0,Ag(n,31),Ag(n,139),Ag(n,8),n.gzhead?(Ag(n,(n.gzhead.text?1:0)+(n.gzhead.hcrc?2:0)+(n.gzhead.extra?4:0)+(n.gzhead.name?8:0)+(n.gzhead.comment?16:0)),Ag(n,255&n.gzhead.time),Ag(n,n.gzhead.time>>8&255),Ag(n,n.gzhead.time>>16&255),Ag(n,n.gzhead.time>>24&255),Ag(n,9===n.level?2:n.strategy>=rf||n.level<2?4:0),Ag(n,255&n.gzhead.os),n.gzhead.extra&&n.gzhead.extra.length&&(Ag(n,255&n.gzhead.extra.length),Ag(n,n.gzhead.extra.length>>8&255)),n.gzhead.hcrc&&(e.adler=Dg(e.adler,n.pending_buf,n.pending,0)),n.gzindex=0,n.status=Df):(Ag(n,0),Ag(n,0),Ag(n,0),Ag(n,0),Ag(n,0),Ag(n,9===n.level?2:n.strategy>=rf||n.level<2?4:0),Ag(n,Ff),n.status=Cf);else{var o=cf+(n.w_bits-8<<4)<<8;o|=(n.strategy>=rf||n.level<2?0:n.level<6?1:6===n.level?2:3)<<6,0!==n.strstart&&(o|=bf),o+=31-o%31,n.status=Cf,_g(n,o),0!==n.strstart&&(_g(n,e.adler>>>16),_g(n,65535&e.adler)),e.adler=1}if(n.status===Df)if(n.gzhead.extra){for(r=n.pending;n.gzindex<(65535&n.gzhead.extra.length)&&(n.pending!==n.pending_buf_size||(n.gzhead.hcrc&&n.pending>r&&(e.adler=Dg(e.adler,n.pending_buf,n.pending-r,r)),kg(e),r=n.pending,n.pending!==n.pending_buf_size));)Ag(n,255&n.gzhead.extra[n.gzindex]),n.gzindex++;n.gzhead.hcrc&&n.pending>r&&(e.adler=Dg(e.adler,n.pending_buf,n.pending-r,r)),n.gzindex===n.gzhead.extra.length&&(n.gzindex=0,n.status=Ef)}else n.status=Ef;if(n.status===Ef)if(n.gzhead.name){r=n.pending;do{if(n.pending===n.pending_buf_size&&(n.gzhead.hcrc&&n.pending>r&&(e.adler=Dg(e.adler,n.pending_buf,n.pending-r,r)),kg(e),r=n.pending,n.pending===n.pending_buf_size)){i=1;break}i=n.gzindex<n.gzhead.name.length?255&n.gzhead.name.charCodeAt(n.gzindex++):0,Ag(n,i)}while(0!==i);n.gzhead.hcrc&&n.pending>r&&(e.adler=Dg(e.adler,n.pending_buf,n.pending-r,r)),0===i&&(n.gzindex=0,n.status=Tf)}else n.status=Tf;if(n.status===Tf)if(n.gzhead.comment){r=n.pending;do{if(n.pending===n.pending_buf_size&&(n.gzhead.hcrc&&n.pending>r&&(e.adler=Dg(e.adler,n.pending_buf,n.pending-r,r)),kg(e),r=n.pending,n.pending===n.pending_buf_size)){i=1;break}i=n.gzindex<n.gzhead.comment.length?255&n.gzhead.comment.charCodeAt(n.gzindex++):0,Ag(n,i)}while(0!==i);n.gzhead.hcrc&&n.pending>r&&(e.adler=Dg(e.adler,n.pending_buf,n.pending-r,r)),0===i&&(n.status=Sf)}else n.status=Sf;if(n.status===Sf&&(n.gzhead.hcrc?(n.pending+2>n.pending_buf_size&&kg(e),n.pending+2<=n.pending_buf_size&&(Ag(n,255&e.adler),Ag(n,e.adler>>8&255),e.adler=0,n.status=Cf)):n.status=Cf),0!==n.pending){if(kg(e),0===e.avail_out)return n.last_flush=-1,Zg}else if(0===e.avail_in&&Sg(t)<=Sg(a)&&t!==Yg)return Tg(e,tf);if(n.status===kf&&0!==e.avail_in)return Tg(e,tf);if(0!==e.avail_in||0!==n.lookahead||t!==Gg&&n.status!==kf){var s=n.strategy===rf?Og(n,t):n.strategy===of?Lg(n,t):Nf[n.level].func(n,t);if((s===_f||s===Rf)&&(n.status=kf),s===xf||s===_f)return 0===e.avail_out&&(n.last_flush=-1),Zg;if(s===Af&&(t===$g?Fh(n):t!==Jg&&(Rh(n,0,0,!1),t===Kg&&(Cg(n.head),0===n.lookahead&&(n.strstart=0,n.block_start=0,n.insert=0))),kg(e),0===e.avail_out))return n.last_flush=-1,Zg}return t!==Yg?Zg:n.wrap<=0?Xg:(2===n.wrap?(Ag(n,255&e.adler),Ag(n,e.adler>>8&255),Ag(n,e.adler>>16&255),Ag(n,e.adler>>24&255),Ag(n,255&e.total_in),Ag(n,e.total_in>>8&255),Ag(n,e.total_in>>16&255),Ag(n,e.total_in>>24&255)):(_g(n,e.adler>>>16),_g(n,65535&e.adler)),kg(e),n.wrap>0&&(n.wrap=-n.wrap),0!==n.pending?Zg:Xg)}function Hg(e){var t;return e&&e.state?(t=e.state.status)!==wf&&t!==Df&&t!==Ef&&t!==Tf&&t!==Sf&&t!==Cf&&t!==kf?Tg(e,Qg):(e.state=null,t===Cf?Tg(e,ef):Zg):Qg}var Gg,$g,Kg,Yg,Jg,Zg,Xg,Qg,ef,tf,af,nf,rf,of,sf,lf,cf,uf,df,mf,pf,hf,gf,ff,yf,vf,bf,wf,Df,Ef,Tf,Sf,Cf,kf,xf,Af,_f,Rf,Ff,Nf,If=s((()=>{J(),rh(),hg(),yg(),Eg(),Zp(),Gg=0,$g=1,Kg=3,Yg=4,Jg=5,Zg=0,Xg=1,Qg=-2,ef=-3,tf=-5,af=-1,nf=1,rf=2,of=3,sf=4,lf=2,cf=8,uf=9,29,256,mf=30,pf=19,hf=2*(df=286)+1,gf=15,vf=(yf=258)+(ff=3)+1,bf=32,wf=42,Df=69,Ef=73,Tf=91,Sf=103,Cf=113,kf=666,xf=1,Af=2,_f=3,Rf=4,Ff=3,o(Tg,"err"),o(Sg,"rank"),o(Cg,"zero"),o(kg,"flush_pending"),o(xg,"flush_block_only"),o(Ag,"put_byte"),o(_g,"putShortMSB"),o(Rg,"read_buf"),o(Fg,"longest_match"),o(Ng,"fill_window"),o(Ig,"deflate_stored"),o(Mg,"deflate_fast"),o(Pg,"deflate_slow"),o(Lg,"deflate_rle"),o(Og,"deflate_huff"),o(jg,"Config"),Nf=[new jg(0,0,0,0,Ig),new jg(4,4,8,4,Mg),new jg(4,5,16,8,Mg),new jg(4,6,32,32,Mg),new jg(4,4,16,16,Pg),new jg(8,16,32,32,Pg),new jg(8,16,128,128,Pg),new jg(8,32,128,256,Pg),new jg(32,128,258,1024,Pg),new jg(32,258,258,4096,Pg)],o(Ug,"lm_init"),o(Bg,"DeflateState"),o(qg,"deflateResetKeep"),o(zg,"deflateReset"),o(Vg,"deflateInit2"),o(Wg,"deflate"),o(Hg,"deflateEnd")})),Mf=s((()=>{J()})),Pf={};function Lf(e){if(e<Uf||e>Hf)throw new TypeError("Bad argument");this.mode=e,this.init_done=!1,this.write_in_progress=!1,this.pending_close=!1,this.windowBits=0,this.level=0,this.memLevel=0,this.strategy=0,this.dictionary=null}function Of(e,t){for(var a=0;a<e.length;a++)this[t+a]=e[a]}c(Pf,{DEFLATE:()=>Uf,DEFLATERAW:()=>Vf,GUNZIP:()=>zf,GZIP:()=>qf,INFLATE:()=>Bf,INFLATERAW:()=>Wf,NONE:()=>jf,UNZIP:()=>Hf,Z_BEST_COMPRESSION:()=>ly,Z_BEST_SPEED:()=>sy,Z_BINARY:()=>gy,Z_BLOCK:()=>Zf,Z_BUF_ERROR:()=>iy,Z_DATA_ERROR:()=>ry,Z_DEFAULT_COMPRESSION:()=>cy,Z_DEFAULT_STRATEGY:()=>hy,Z_DEFLATED:()=>vy,Z_ERRNO:()=>ay,Z_FILTERED:()=>uy,Z_FINISH:()=>Jf,Z_FIXED:()=>py,Z_FULL_FLUSH:()=>Yf,Z_HUFFMAN_ONLY:()=>dy,Z_NEED_DICT:()=>ty,Z_NO_COMPRESSION:()=>oy,Z_NO_FLUSH:()=>Gf,Z_OK:()=>Qf,Z_PARTIAL_FLUSH:()=>$f,Z_RLE:()=>my,Z_STREAM_END:()=>ey,Z_STREAM_ERROR:()=>ny,Z_SYNC_FLUSH:()=>Kf,Z_TEXT:()=>fy,Z_TREES:()=>Xf,Z_UNKNOWN:()=>yy,Zlib:()=>Lf});var jf,Uf,Bf,qf,zf,Vf,Wf,Hf,Gf,$f,Kf,Yf,Jf,Zf,Xf,Qf,ey,ty,ay,ny,ry,iy,oy,sy,ly,cy,uy,dy,my,py,hy,gy,fy,yy,vy,by,wy=s((()=>{J(),Zp(),eh(),If(),Mf(),jf=0,Uf=1,Bf=2,qf=3,zf=4,Vf=5,Wf=6,Hf=7,Gf=0,$f=1,Kf=2,Yf=3,Jf=4,Zf=5,Xf=6,Qf=0,ey=1,ty=2,ay=-1,ny=-2,ry=-3,iy=-5,oy=0,sy=1,ly=9,cy=-1,uy=1,dy=2,my=3,py=4,hy=0,gy=0,fy=1,yy=2,vy=8,o(Lf,"Zlib"),Lf.prototype.init=function(e,t,a,n,r){var i;switch(this.windowBits=e,this.level=t,this.memLevel=a,this.strategy=n,(this.mode===qf||this.mode===zf)&&(this.windowBits+=16),this.mode===Hf&&(this.windowBits+=32),(this.mode===Vf||this.mode===Wf)&&(this.windowBits=-this.windowBits),this.strm=new Qp,this.mode){case Uf:case qf:case Vf:i=Vg(this.strm,this.level,vy,this.windowBits,this.memLevel,this.strategy);break;case Bf:case zf:case Wf:case Hf:this.strm,i=void this.windowBits;break;default:throw new Error("Unknown mode "+this.mode)}i===Qf?(this.write_in_progress=!1,this.init_done=!0):this._error(i)},Lf.prototype.params=function(){throw new Error("deflateParams Not supported")},Lf.prototype._writeCheck=function(){if(!this.init_done)throw new Error("write before init");if(this.mode===jf)throw new Error("already finalized");if(this.write_in_progress)throw new Error("write already in progress");if(this.pending_close)throw new Error("close is pending")},Lf.prototype.write=function(e,t,a,n,r,i,o){this._writeCheck(),this.write_in_progress=!0;var s=this;return process.nextTick((function(){s.write_in_progress=!1;var l=s._write(e,t,a,n,r,i,o);s.callback(l[0],l[1]),s.pending_close&&s.close()})),this},o(Of,"bufferSet"),Lf.prototype.writeSync=function(e,t,a,n,r,i,o){return this._writeCheck(),this._write(e,t,a,n,r,i,o)},Lf.prototype._write=function(e,t,a,n,r,i,o){if(this.write_in_progress=!0,e!==Gf&&e!==$f&&e!==Kf&&e!==Yf&&e!==Jf&&e!==Zf)throw new Error("Invalid flush value");null==t&&(t=new Buffer(0),n=0,a=0),r._set?r.set=r._set:r.set=Of;var s,l=this.strm;switch(l.avail_in=n,l.input=t,l.next_in=a,l.avail_out=o,l.output=r,l.next_out=i,this.mode){case Uf:case qf:case Vf:s=Wg(l,e);break;case Hf:case Bf:case zf:case Wf:s=void 0;break;default:throw new Error("Unknown mode "+this.mode)}return s!==ey&&s!==Qf&&this._error(s),this.write_in_progress=!1,[l.avail_in,l.avail_out]},Lf.prototype.close=function(){this.write_in_progress?this.pending_close=!0:(this.pending_close=!1,this.mode===Uf||this.mode===qf||this.mode===Vf?Hg(this.strm):this.strm,this.mode=jf)},Lf.prototype.reset=function(){switch(this.mode){case Uf:case Vf:by=zg(this.strm);break;case Bf:case Wf:by=void this.strm}by!==Qf&&this._error(by)},Lf.prototype._error=function(e){this.onerror(Yp[e]+": "+this.strm.msg,e),this.write_in_progress=!1,this.pending_close&&this.close()}}));function Dy(e,t){if(!e)throw new Error(t)}function Ey(e,t,a){return"function"==typeof t&&(a=t,t={}),Ty(new ky(t),e,a)}function Ty(e,t,a){var n=[],r=0;function i(){for(var t;null!==(t=e.read());)n.push(t),r+=t.length;e.once("readable",i)}function s(t){e.removeListener("end",l),e.removeListener("readable",i),a(t)}function l(){var t=Buffer.concat(n,r);n=[],a(null,t),e.close()}e.on("error",s),e.on("end",l),e.end(t),i(),o(i,"flow"),o(s,"onError"),o(l,"onEnd")}function Sy(e){if(!(this instanceof Sy))return new Sy(e);Fy.call(this,e,Ny.DEFLATE)}function Cy(e){if(!(this instanceof Cy))return new Cy(e);Fy.call(this,e,Ny.INFLATE)}function ky(e){if(!(this instanceof ky))return new ky(e);Fy.call(this,e,Ny.GZIP)}function xy(e){if(!(this instanceof xy))return new xy(e);Fy.call(this,e,Ny.GUNZIP)}function Ay(e){if(!(this instanceof Ay))return new Ay(e);Fy.call(this,e,Ny.DEFLATERAW)}function _y(e){if(!(this instanceof _y))return new _y(e);Fy.call(this,e,Ny.INFLATERAW)}function Ry(e){if(!(this instanceof Ry))return new Ry(e);Fy.call(this,e,Ny.UNZIP)}function Fy(e,t){if(this._opts=e=e||{},this._chunkSize=e.chunkSize||Ny.Z_DEFAULT_CHUNK,cl.call(this,e),e.flush&&e.flush!==Ny.Z_NO_FLUSH&&e.flush!==Ny.Z_PARTIAL_FLUSH&&e.flush!==Ny.Z_SYNC_FLUSH&&e.flush!==Ny.Z_FULL_FLUSH&&e.flush!==Ny.Z_FINISH&&e.flush!==Ny.Z_BLOCK)throw new Error("Invalid flush flag: "+e.flush);if(this._flushFlag=e.flush||Ny.Z_NO_FLUSH,e.chunkSize&&(e.chunkSize<Ny.Z_MIN_CHUNK||e.chunkSize>Ny.Z_MAX_CHUNK))throw new Error("Invalid chunk size: "+e.chunkSize);if(e.windowBits&&(e.windowBits<Ny.Z_MIN_WINDOWBITS||e.windowBits>Ny.Z_MAX_WINDOWBITS))throw new Error("Invalid windowBits: "+e.windowBits);if(e.level&&(e.level<Ny.Z_MIN_LEVEL||e.level>Ny.Z_MAX_LEVEL))throw new Error("Invalid compression level: "+e.level);if(e.memLevel&&(e.memLevel<Ny.Z_MIN_MEMLEVEL||e.memLevel>Ny.Z_MAX_MEMLEVEL))throw new Error("Invalid memLevel: "+e.memLevel);if(e.strategy&&e.strategy!=Ny.Z_FILTERED&&e.strategy!=Ny.Z_HUFFMAN_ONLY&&e.strategy!=Ny.Z_RLE&&e.strategy!=Ny.Z_FIXED&&e.strategy!=Ny.Z_DEFAULT_STRATEGY)throw new Error("Invalid strategy: "+e.strategy);if(e.dictionary&&!Buffer.isBuffer(e.dictionary))throw new Error("Invalid dictionary: it should be a Buffer instance");this._binding=new Ny.Zlib(t);var a=this;this._hadError=!1,this._binding.onerror=function(e,t){a._binding=null,a._hadError=!0;var n=new Error(e);n.errno=t,n.code=Ny.codes[t],a.emit("error",n)};var n=Ny.Z_DEFAULT_COMPRESSION;"number"==typeof e.level&&(n=e.level);var r=Ny.Z_DEFAULT_STRATEGY;"number"==typeof e.strategy&&(r=e.strategy),this._binding.init(e.windowBits||Ny.Z_DEFAULT_WINDOWBITS,n,e.memLevel||Ny.Z_DEFAULT_MEMLEVEL,r,e.dictionary),this._buffer=new Buffer(this._chunkSize),this._offset=0,this._closed=!1,this._level=n,this._strategy=r,this.once("end",this.close)}var Ny,Iy,My=s((()=>{J(),Sl(),wy(),Go(),o(Dy,"assert"),Ny={},Object.keys(Pf).forEach((function(e){Ny[e]=Pf[e]})),Ny.Z_MIN_WINDOWBITS=8,Ny.Z_MAX_WINDOWBITS=15,Ny.Z_DEFAULT_WINDOWBITS=15,Ny.Z_MIN_CHUNK=64,Ny.Z_MAX_CHUNK=1/0,Ny.Z_DEFAULT_CHUNK=16384,Ny.Z_MIN_MEMLEVEL=1,Ny.Z_MAX_MEMLEVEL=9,Ny.Z_DEFAULT_MEMLEVEL=8,Ny.Z_MIN_LEVEL=-1,Ny.Z_MAX_LEVEL=9,Ny.Z_DEFAULT_LEVEL=Ny.Z_DEFAULT_COMPRESSION,Iy={Z_OK:Ny.Z_OK,Z_STREAM_END:Ny.Z_STREAM_END,Z_NEED_DICT:Ny.Z_NEED_DICT,Z_ERRNO:Ny.Z_ERRNO,Z_STREAM_ERROR:Ny.Z_STREAM_ERROR,Z_DATA_ERROR:Ny.Z_DATA_ERROR,Z_MEM_ERROR:Ny.Z_MEM_ERROR,Z_BUF_ERROR:Ny.Z_BUF_ERROR,Z_VERSION_ERROR:Ny.Z_VERSION_ERROR},Object.keys(Iy).forEach((function(e){Iy[Iy[e]]=e})),o(Ey,"gzip"),o(Ty,"zlibBuffer"),o(Sy,"Deflate"),o(Cy,"Inflate"),o(ky,"Gzip"),o(xy,"Gunzip"),o(Ay,"DeflateRaw"),o(_y,"InflateRaw"),o(Ry,"Unzip"),o(Fy,"Zlib"),co(Fy,cl),Fy.prototype.params=function(e,t,a){if(e<Ny.Z_MIN_LEVEL||e>Ny.Z_MAX_LEVEL)throw new RangeError("Invalid compression level: "+e);if(t!=Ny.Z_FILTERED&&t!=Ny.Z_HUFFMAN_ONLY&&t!=Ny.Z_RLE&&t!=Ny.Z_FIXED&&t!=Ny.Z_DEFAULT_STRATEGY)throw new TypeError("Invalid strategy: "+t);if(this._level!==e||this._strategy!==t){var n=this;this.flush(Ny.Z_SYNC_FLUSH,(function(){n._binding.params(e,t),n._hadError||(n._level=e,n._strategy=t,a&&a())}))}else process.nextTick(a)},Fy.prototype.reset=function(){return this._binding.reset()},Fy.prototype._flush=function(e){this._transform(new Buffer(0),"",e)},Fy.prototype.flush=function(e,t){var a=this._writableState;if(("function"==typeof e||void 0===e&&!t)&&(t=e,e=Ny.Z_FULL_FLUSH),a.ended)t&&process.nextTick(t);else if(a.ending)t&&this.once("end",t);else if(a.needDrain){var n=this;this.once("drain",(function(){n.flush(t)}))}else this._flushFlag=e,this.write(new Buffer(0),"",t)},Fy.prototype.close=function(e){if(e&&process.nextTick(e),!this._closed){this._closed=!0,this._binding.close();var t=this;process.nextTick((function(){t.emit("close")}))}},Fy.prototype._transform=function(e,t,a){var n,r=this._writableState,i=(r.ending||r.ended)&&(!e||r.length===e.length);if(null===!e&&!Buffer.isBuffer(e))return a(new Error("invalid input"));i?n=Ny.Z_FINISH:(n=this._flushFlag,e.length>=r.length&&(this._flushFlag=this._opts.flush||Ny.Z_NO_FLUSH)),this._processChunk(e,n,a)},Fy.prototype._processChunk=function(e,t,a){var n=e&&e.length,r=this._chunkSize-this._offset,i=0,s=this,l="function"==typeof a;if(!l){var c,u=[],d=0;this.on("error",(function(e){c=e}));do{var m=this._binding.writeSync(t,e,i,n,this._buffer,this._offset,r)}while(!this._hadError&&g(m[0],m[1]));if(this._hadError)throw c;var p=Buffer.concat(u,d);return this.close(),p}var h=this._binding.write(t,e,i,n,this._buffer,this._offset,r);function g(o,c){if(!s._hadError){var m=r-c;if(Dy(m>=0,"have should not go down"),m>0){var p=s._buffer.slice(s._offset,s._offset+m);s._offset+=m,l?s.push(p):(u.push(p),d+=p.length)}if((0===c||s._offset>=s._chunkSize)&&(r=s._chunkSize,s._offset=0,s._buffer=new Buffer(s._chunkSize)),0===c){if(i+=n-o,n=o,!l)return!0;var h=s._binding.write(t,e,i,n,s._buffer,s._offset,s._chunkSize);return h.callback=g,void(h.buffer=e)}if(!l)return!1;a()}}h.buffer=e,h.callback=g,o(g,"callback")},co(Sy,Fy),co(Cy,Fy),co(ky,Fy),co(xy,Fy),co(Ay,Fy),co(_y,Fy),co(Ry,Fy)}));async function Py(e,t,a=1e3){return t=wc.getRequestIdForBackend(t),e.setNextProtocolTimeout(a),(await e.sendCommand("Network.getResponseBody",{requestId:t})).body}var Ly=s((()=>{J(),qc(),o(Py,"fetchResponseBodyFromCache")})),Oy={};c(Oy,{default:()=>Vy});var jy,Uy,By,qy,zy,Vy,Wy=s((()=>{J(),lt(),My(),ea(),aa(),ql(),qc(),mp(),Ly(),Yc(),"chrome-extension:",jy=["content-encoding","x-original-content-encoding","x-content-encoding-over-network"],Uy=["gzip","br","deflate"],By=["image","audio","video"],qy=[wc.TYPES.Document,wc.TYPES.Script,wc.TYPES.Stylesheet,wc.TYPES.XHR,wc.TYPES.Fetch,wc.TYPES.EventSource],zy=class e extends Jt{static{o(this,"ResponseCompression")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:dp.symbol}};static filterUnoptimizedResponses(e){let t=[];return e.forEach((e=>{if(e.isOutOfProcessIframe)return;let a=e.mimeType,n=e.resourceType||wc.TYPES.Other,r=e.resourceSize,i=!(a&&By.some((e=>a.startsWith(e))))&&qy.includes(n),o=e.url.startsWith("chrome-extension:");i&&r&&e.finished&&!o&&e.transferSize&&304!==e.statusCode&&((e.responseHeaders||[]).find((e=>jy.includes(e.name.toLowerCase())&&Uy.includes(e.value)))||t.push({requestId:e.requestId,url:e.url,mimeType:a,transferSize:e.transferSize,resourceSize:r,gzipSize:0}))})),t}async getCompressibleRecords(t,a){let n=t.driver.defaultSession,r=e.filterUnoptimizedResponses(a);return Promise.all(r.map((e=>Py(n,e.requestId).then((t=>t?new Promise(((a,n)=>Ey(t,((t,r)=>{if(t)return n(t);e.gzipSize=oe.byteLength(r,"utf8"),a(e)})))):e)).catch((t=>{if(!t?.message?.includes("No resource with given identifier found"))throw t.extra={url:Ml.elideDataURI(e.url)},t;return Kt.error("ResponseCompression",t.message),e.gzipSize=void 0,e})))))}async getArtifact(e){let t=e.dependencies.DevtoolsLog,a=await Pc.request(t,e);return this.getCompressibleRecords(e,a)}},Vy=zy})),Hy={};function Gy(){window.___linkMediaChanges=[],Object.defineProperty(HTMLLinkElement.prototype,"media",{set:function(e){let t={href:this.href,media:e,msSinceHTMLEnd:Date.now()-performance.timing.responseEnd,matches:window.matchMedia(e).matches};window.___linkMediaChanges.push(t),this.setAttribute("media",e)}})}async function $y(){let e=window.___linkMediaChanges;try{let t=[...document.querySelectorAll("link")].filter((e=>{let t="stylesheet"===e.rel&&window.matchMedia(e.media).matches&&!e.disabled,a="import"===e.rel&&!e.hasAttribute("async");return t||a})).map((t=>({tagName:"LINK",url:t.href,href:t.href,rel:t.rel,media:t.media,disabled:t.disabled,mediaChanges:e.filter((e=>e.href===t.href))}))),a=[...document.querySelectorAll("head script[src]")].filter((e=>!(e instanceof SVGScriptElement)&&!(e.hasAttribute("async")||e.hasAttribute("defer")||/^data:/.test(e.src)||/^blob:/.test(e.src)||"module"===e.getAttribute("type")))).map((e=>({tagName:"SCRIPT",url:e.src,src:e.src})));return[...t,...a]}catch(e){throw new Error(`${"Unable to gather Scripts/Stylesheets/HTML Imports on the page"}: ${e.message}`)}}c(Hy,{default:()=>Yy});var Ky,Yy,Jy=s((()=>{J(),Yc(),mp(),aa(),o(Gy,"installMediaListener"),o($y,"collectTagsThatBlockFirstPaint"),Ky=class e extends Jt{static{o(this,"TagsBlockingFirstPaint")}meta={supportedModes:["navigation"],dependencies:{DevtoolsLog:dp.symbol}};static _filteredAndIndexedByUrl(e){let t=new Map;for(let a of e){if(!a.finished)continue;let e="parser"===a.initiator.type,n=/(css|script)/.test(a.mimeType)&&e,r=a.failed;(a.mimeType&&a.mimeType.includes("html")||n||r&&e)&&t.set(a.url,a)}return t}static async findBlockingTags(t,a){let n=a.reduce(((e,t)=>Math.min(e,t.networkEndTime)),1/0),r=await t.executionContext.evaluate($y,{args:[]}),i=e._filteredAndIndexedByUrl(a),o=[];for(let e of r){let t=i.get(e.url);if(!t||t.isLinkPreload)continue;let a,r=t.networkEndTime;if("LINK"===e.tagName){let i=e.mediaChanges.filter((e=>!e.matches)).map((e=>e.msSinceHTMLEnd));if(i.length>0){let e=Math.min(...i),a=Math.max(t.networkRequestTime,n+e/1e3);r=Math.min(r,a)}a=e.mediaChanges}let{tagName:s,url:l}=e;o.push({tag:{tagName:s,url:l,mediaChanges:a},transferSize:t.transferSize,startTime:t.networkRequestTime,endTime:r}),i.delete(e.url)}return o}async startSensitiveInstrumentation(e){let{executionContext:t}=e.driver;await t.evaluateOnNewDocument(Gy,{args:[]})}async getArtifact(t){let a=t.dependencies.DevtoolsLog,n=await Pc.request(a,t);return e.findBlockingTags(t.driver,n)}},Yy=Ky}));function Zy(e,t){let a=e.match(/Chrome\/([\d.]+)/)?.[1]||"99.0.1234.0",[n]=a.split(".",1),r="mobile"===t;return{brands:[{brand:"Chromium",version:n},{brand:"Google Chrome",version:n},{brand:"Lighthouse",version:Ii}],fullVersion:a,...r?{platform:"Android",platformVersion:"11.0",architecture:"",model:"moto g power (2022)"}:{platform:"macOS",platformVersion:"10.15.7",architecture:"x86",model:""},mobile:r}}async function Xy(e,t){if(!1!==t.emulatedUserAgent){let a=t.emulatedUserAgent;await e.sendCommand("Network.setUserAgentOverride",{userAgent:a,userAgentMetadata:Zy(a,t.formFactor)})}if(!0!==t.screenEmulation.disabled){let{width:a,height:n,deviceScaleFactor:r,mobile:i}=t.screenEmulation,o={width:a,height:n,deviceScaleFactor:r,mobile:i};await e.sendCommand("Emulation.setDeviceMetricsOverride",o),await e.sendCommand("Emulation.setTouchEmulationEnabled",{enabled:o.mobile})}}async function Qy(e,t){if("devtools"!==t.throttlingMethod)return av(e);await Promise.all([tv(e,t.throttling),nv(e,t.throttling)])}async function ev(e){await Promise.all([av(e),rv(e)])}function tv(e,t){let a={offline:!1,latency:t.requestLatencyMs||0,downloadThroughput:t.downloadThroughputKbps||0,uploadThroughput:t.uploadThroughputKbps||0};return a.downloadThroughput=Math.floor(1024*a.downloadThroughput/8),a.uploadThroughput=Math.floor(1024*a.uploadThroughput/8),e.sendCommand("Network.emulateNetworkConditions",a)}function av(e){return e.sendCommand("Network.emulateNetworkConditions",iv)}function nv(e,t){let a=t.cpuSlowdownMultiplier;return e.sendCommand("Emulation.setCPUThrottlingRate",{rate:a})}function rv(e){return e.sendCommand("Emulation.setCPUThrottlingRate",ov)}var iv,ov,sv=s((()=>{J(),Xi(),iv={latency:0,downloadThroughput:0,uploadThroughput:0,offline:!1},ov={rate:1},o(Zy,"parseUseragentIntoMetadata"),o(Xy,"emulate"),o(Qy,"throttle"),o(ev,"clearThrottling"),o(tv,"enableNetworkThrottling"),o(av,"clearNetworkThrottling"),o(nv,"enableCPUThrottling"),o(rv,"clearCPUThrottling")})),lv={};function cv(e){return e.replace(/(-\w)/g,(e=>e[1].toUpperCase()))}function uv(){let e=cv(window.screen.orientation.type);return{width:window.outerWidth,height:window.outerHeight,screenOrientation:{type:e,angle:window.screen.orientation.angle},deviceScaleFactor:window.devicePixelRatio}}function dv(){return{width:window.innerWidth,height:window.innerHeight}}function mv(){return new Promise((e=>{requestAnimationFrame((()=>requestAnimationFrame(e)))}))}c(lv,{default:()=>hv});var pv,hv,gv=s((()=>{J(),aa(),sv(),bd(),sp(),30,16383,o(cv,"kebabCaseToCamelCase"),o(uv,"getObservedDeviceMetrics"),o(dv,"getScreenshotAreaSize"),o(mv,"waitForDoubleRaf"),pv=class extends Jt{static{o(this,"FullPageScreenshot")}meta={supportedModes:["snapshot","timespan","navigation"]};async _resizeViewport(e,t){let a=e.driver.defaultSession,n=await a.sendCommand("Page.getLayoutMetrics"),r=Math.round(t.height*n.cssContentSize.height/n.cssLayoutViewport.clientHeight),i=Math.min(r,16383),o=Xm(a,e.driver.networkMonitor,{pretendDCLAlreadyFired:!0,networkQuietThresholdMs:1e3,busyEvent:"network-critical-busy",idleEvent:"network-critical-idle",isIdle:e=>e.isCriticalIdle()});await a.sendCommand("Emulation.setDeviceMetricsOverride",{mobile:t.mobile,deviceScaleFactor:1,height:i,width:0}),await Promise.race([new Promise((e=>setTimeout(e,5e3))),o.promise]),o.cancel(),await e.driver.executionContext.evaluate(mv,{args:[]})}async _takeScreenshot(e){let t="data:image/webp;base64,"+(await e.driver.defaultSession.sendCommand("Page.captureScreenshot",{format:"webp",quality:30})).data,a=await e.driver.executionContext.evaluate(dv,{args:[],useIsolation:!0});return{data:t,width:a.width,height:a.height}}async _resolveNodes(e){function t(){let e={};if(!window.__lighthouseNodesDontTouchOrAllVarianceGoesAway)return e;let t=window.__lighthouseNodesDontTouchOrAllVarianceGoesAway;for(let[a,n]of t.entries()){let t=getBoundingClientRect(a);e[n]=t}return e}function a({useIsolation:a}){return e.driver.executionContext.evaluate(t,{args:[],useIsolation:a,deps:[sd.getBoundingClientRect]})}return o(t,"resolveNodes"),o(a,"resolveNodesInPage"),{...await a({useIsolation:!1}),...await a({useIsolation:!0})}}async getArtifact(e){let t=e.driver.defaultSession,a=e.driver.executionContext,n=e.settings,r=!n.screenEmulation.disabled,i={...n.screenEmulation};try{if(!n.usePassiveGathering){if(!r){let e=await a.evaluate(uv,{args:[],useIsolation:!0,deps:[cv]});i.height=e.height,i.width=e.width,i.deviceScaleFactor=e.deviceScaleFactor,i.mobile="mobile"===n.formFactor}await this._resizeViewport(e,i)}let[t,o]=await Promise.all([this._takeScreenshot(e),this._resolveNodes(e)]);return{screenshot:t,nodes:o}}finally{n.usePassiveGathering||(r?await Xy(t,n):await t.sendCommand("Emulation.setDeviceMetricsOverride",{mobile:i.mobile,deviceScaleFactor:i.deviceScaleFactor,height:i.height,width:0}))}}},hv=pv})),fv={};c(fv,{default:()=>vv});var yv,vv,bv=s((()=>{J(),ea(),aa(),yv=class e extends Jt{static{o(this,"GlobalListeners")}meta={supportedModes:["snapshot","timespan","navigation"]};static _filterForAllowlistedTypes(e){return"pagehide"===e.type||"unload"===e.type||"visibilitychange"===e.type}getListenerIndentifier(e){return`${e.type}:${e.scriptId}:${e.columnNumber}:${e.lineNumber}`}dedupeListeners(e){let t=new Set;return e.filter((e=>{let a=this.getListenerIndentifier(e);return!t.has(a)&&(t.add(a),!0)}))}async getArtifact(t){let a=t.driver.defaultSession,n=[];for(let r of t.driver.targetManager.mainFrameExecutionContexts()){let t;try{let{result:e}=await a.sendCommand("Runtime.evaluate",{expression:"window",returnByValue:!1,uniqueContextId:r.uniqueId});if(!e.objectId)throw new Error("Error fetching information about the global object");t=e.objectId}catch(e){Kt.warn("Execution context is no longer valid",r,e);continue}let i=await a.sendCommand("DOMDebugger.getEventListeners",{objectId:t});for(let t of i.listeners)if(e._filterForAllowlistedTypes(t)){let{type:e,scriptId:a,lineNumber:r,columnNumber:i}=t;n.push({type:e,scriptId:a,lineNumber:r,columnNumber:i})}}return this.dedupeListeners(n)}},vv=yv})),wv={};function Dv(){let e=window.__HTMLElementBoundingClientRect||window.HTMLElement.prototype.getBoundingClientRect;return getElementsInDocument("iframe").map((t=>{let a=e.call(t),{top:n,bottom:r,left:i,right:o,width:s,height:l}=a;return{id:t.id,src:t.src,clientRect:{top:n,bottom:r,left:i,right:o,width:s,height:l},isPositionFixed:isPositionFixed(t),node:getNodeDetails(t)}}))}c(wv,{default:()=>Tv});var Ev,Tv,Sv=s((()=>{J(),aa(),bd(),o(Dv,"collectIFrameElements"),Ev=class extends Jt{static{o(this,"IFrameElements")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){return await e.driver.executionContext.evaluate(Dv,{args:[],useIsolation:!0,deps:[sd.getElementsInDocument,sd.isPositionFixed,sd.getNodeDetails]})}},Tv=Ev})),Cv={};function kv(e){return!!e&&!!e.cssProperties.find((({name:e})=>e===Nv))}function xv(e=[],t){let a;for(let n=e.length-1;n>=0;n--)if(t(e[n].rule.style)){a=e[n].rule;break}if(a)return{type:"Regular",...a.style,parentRule:{origin:a.origin,selectors:a.selectorList.selectors}}}function Av(e=[]){for(let{inlineStyle:t,matchedCSSRules:a}of e){if(kv(t))return{type:"Inline",...t};let e=xv(a,kv);if(e)return e}}function _v({attributesStyle:e,inlineStyle:t,matchedCSSRules:a,inherited:n}){if(kv(t))return{type:"Inline",...t};let r=xv(a,kv);if(r)return r;if(kv(e))return{type:"Attributes",...e};let i=Av(n);return i||void 0}function Rv(e){return e?Array.from(e.trim()).length:0}async function Fv(e,t){let a=_v(await e.sendCommand("CSS.getMatchedStylesForNode",{nodeId:t}));if(a)return{type:a.type,range:a.range,styleSheetId:a.styleSheetId,parentRule:a.parentRule&&{origin:a.parentRule.origin,selectors:a.parentRule.selectors}}}c(Cv,{default:()=>Mv,findMostSpecificMatchedCSSRule:()=>xv,getEffectiveFontRule:()=>_v});var Nv,Iv,Mv,Pv=s((()=>{J(),aa(),Nv="font-size",12,50,o(kv,"hasFontSizeDeclaration"),o(xv,"findMostSpecificMatchedCSSRule"),o(Av,"findInheritedCSSRule"),o(_v,"getEffectiveFontRule"),o(Rv,"getTextLength"),o(Fv,"fetchSourceRule"),Iv=class e extends Jt{static{o(this,"FontSize")}meta={supportedModes:["snapshot","navigation"]};static async fetchFailingNodeSourceRules(e,t){let a=t.sort(((e,t)=>t.textLength-e.textLength)).slice(0,50);await e.sendCommand("DOM.getDocument",{depth:-1,pierce:!0});let{nodeIds:n}=await e.sendCommand("DOM.pushNodesByBackendIdsToFrontend",{backendNodeIds:a.map((e=>e.parentNode.backendNodeId))}),r=a.map((async(t,a)=>{t.nodeId=n[a];try{let r=await Fv(e,n[a]);t.cssRule=r}catch{t.cssRule=void 0}return t})),i=await Promise.all(r),o=i.reduce(((e,{textLength:t})=>e+t),0);return{analyzedFailingNodesData:i,analyzedFailingTextLength:o}}getTextNodesInLayoutFromSnapshot(e){let t=e.strings,a=o((e=>t[e]),"getString"),n=o((e=>parseFloat(t[e])),"getFloat"),r=[];for(let i=0;i<e.documents.length;i++){let s=e.documents[i];if(!(s.nodes.backendNodeId&&s.nodes.parentIndex&&s.nodes.attributes&&s.nodes.nodeName))throw new Error("Unexpected response from DOMSnapshot.captureSnapshot.");let l=s.nodes,c=o((e=>({backendNodeId:l.backendNodeId[e],attributes:l.attributes[e].map(a),nodeName:a(l.nodeName[e])})),"getParentData");for(let e of s.textBoxes.layoutIndex){let a=t[s.layout.text[e]];if(!a)continue;let i=s.layout.nodeIndex[e],o=s.layout.styles[e],[u]=o,d=n(u),m=l.parentIndex[i],p=l.parentIndex[m],h=c(m),g=void 0!==p?c(p):void 0;r.push({nodeIndex:i,backendNodeId:l.backendNodeId[i],fontSize:d,textLength:Rv(a),parentNode:{...h,parentNode:g}})}}return r}findFailingNodes(e){let t=[],a=0,n=0;for(let r of this.getTextNodesInLayoutFromSnapshot(e))a+=r.textLength,r.fontSize<12&&(n+=r.textLength,t.push({nodeId:0,parentNode:r.parentNode,textLength:r.textLength,fontSize:r.fontSize}));return{totalTextLength:a,failingTextLength:n,failingNodes:t}}async getArtifact(t){let a=t.driver.defaultSession,n=new Map,r=o((e=>n.set(e.header.styleSheetId,e.header)),"onStylesheetAdded");a.on("CSS.styleSheetAdded",r),await Promise.all([a.sendCommand("DOMSnapshot.enable"),a.sendCommand("DOM.enable"),a.sendCommand("CSS.enable")]);let i=await a.sendCommand("DOMSnapshot.captureSnapshot",{computedStyles:["font-size"]}),{totalTextLength:s,failingTextLength:l,failingNodes:c}=this.findFailingNodes(i),{analyzedFailingNodesData:u,analyzedFailingTextLength:d}=await e.fetchFailingNodeSourceRules(a,c);return a.off("CSS.styleSheetAdded",r),u.filter((e=>e.cssRule?.styleSheetId)).forEach((e=>e.cssRule.stylesheet=n.get(e.cssRule.styleSheetId))),await Promise.all([a.sendCommand("DOMSnapshot.disable"),a.sendCommand("DOM.disable"),a.sendCommand("CSS.disable")]),{analyzedFailingNodesData:u,analyzedFailingTextLength:d,failingTextLength:l,totalTextLength:s}}},Mv=Iv})),Lv={};function Ov(e){let t=e.getBoundingClientRect();return{top:t.top,bottom:t.bottom,left:t.left,right:t.right}}function jv(e,t){return e.parentElement&&"PICTURE"===e.parentElement.tagName?window.getComputedStyle(e.parentElement).getPropertyValue("position"):t.getPropertyValue("position")}function Uv(e){return e.filter((e=>"img"===e.localName)).map((e=>{let t=window.getComputedStyle(e),a=!!e.parentElement&&"PICTURE"===e.parentElement.tagName,n=!a&&!e.srcset;return{src:e.currentSrc,srcset:e.srcset,displayedWidth:e.width,displayedHeight:e.height,clientRect:Ov(e),attributeWidth:e.getAttribute("width"),attributeHeight:e.getAttribute("height"),naturalDimensions:n?{width:e.naturalWidth,height:e.naturalHeight}:void 0,cssRules:void 0,computedStyles:{position:jv(e,t),objectFit:t.getPropertyValue("object-fit"),imageRendering:t.getPropertyValue("image-rendering")},isCss:!1,isPicture:a,loading:e.loading,isInShadowDOM:e.getRootNode()instanceof ShadowRoot,fetchPriority:e.fetchPriority,node:getNodeDetails(e)}}))}function Bv(e){let t=/^url\("([^"]+)"\)$/,a=[];for(let n of e){let e=window.getComputedStyle(n);if(!e.backgroundImage||!t.test(e.backgroundImage))continue;let r=e.backgroundImage.match(t)[1];a.push({src:r,srcset:"",displayedWidth:n.clientWidth,displayedHeight:n.clientHeight,clientRect:Ov(n),attributeWidth:null,attributeHeight:null,naturalDimensions:void 0,cssEffectiveRules:void 0,computedStyles:{position:jv(n,e),objectFit:"",imageRendering:e.getPropertyValue("image-rendering")},isCss:!0,isPicture:!1,isInShadowDOM:n.getRootNode()instanceof ShadowRoot,node:getNodeDetails(n)})}return a}function qv(){let e=getElementsInDocument();return Uv(e).concat(Bv(e))}function zv(e){return new Promise(((t,a)=>{let n=new Image;n.addEventListener("error",(e=>a(new Error("determineNaturalSize failed img load")))),n.addEventListener("load",(()=>{t({naturalWidth:n.naturalWidth,naturalHeight:n.naturalHeight})})),n.src=e}))}function Vv(e,t){if(!e||!e.cssProperties)return;let a=e.cssProperties.find((({name:e})=>e===t));return a?a.value:void 0}function Wv(e,t){let a=xv(e,o((e=>Vv(e,t)),"isDeclarationofInterest"));if(a)return Vv(a,t)}function Hv({attributesStyle:e,inlineStyle:t,matchedCSSRules:a},n){let r=Vv(t,n);if(r)return r;let i=Vv(e,n);return i||(Wv(a,n)||null)}function Gv(e){return e.naturalDimensions?e.naturalDimensions.height*e.naturalDimensions.width:e.displayedHeight*e.displayedWidth}c(Lv,{default:()=>Kv});var $v,Kv,Yv=s((()=>{J(),ea(),aa(),bd(),Pv(),o(Ov,"getClientRect"),o(jv,"getPosition"),o(Uv,"getHTMLImages"),o(Bv,"getCSSImages"),o(qv,"collectImageElementInfo"),o(zv,"determineNaturalSize"),o(Vv,"findSizeDeclaration"),o(Wv,"findMostSpecificCSSRule"),o(Hv,"getEffectiveSizingRule"),o(Gv,"getPixelArea"),$v=class extends Jt{static{o(this,"ImageElements")}meta={supportedModes:["snapshot","timespan","navigation"]};constructor(){super(),this._naturalSizeCache=new Map}async fetchElementWithSizeInformation(e,t){let a=t.src,n=this._naturalSizeCache.get(a);if(!n)try{e.defaultSession.setNextProtocolTimeout(250),n=await e.executionContext.evaluate(zv,{args:[a],useIsolation:!0}),this._naturalSizeCache.set(a,n)}catch{}n&&(t.naturalDimensions={width:n.naturalWidth,height:n.naturalHeight})}async fetchSourceRules(e,t,a){try{let{nodeId:n}=await e.sendCommand("DOM.pushNodeByPathToFrontend",{path:t});if(!n)return;let r=await e.sendCommand("CSS.getMatchedStylesForNode",{nodeId:n}),i=Hv(r,"width"),o=Hv(r,"height"),s=Hv(r,"aspect-ratio");a.cssEffectiveRules={width:i,height:o,aspectRatio:s}}catch(e){if(/No node.*found/.test(e.message))return;throw e}}async collectExtraDetails(e,t){let a=!1;setTimeout((e=>a=!0),5e3);let n=0;for(let r of t)a?n++:(!r.isInShadowDOM&&!r.isCss&&await this.fetchSourceRules(e.defaultSession,r.node.devtoolsNodePath,r),(r.isPicture||r.isCss||r.srcset)&&await this.fetchElementWithSizeInformation(e,r));a&&Kt.warn("ImageElements",`Reached gathering budget of 5s. Skipped extra details for ${n}/${t.length}`)}async getArtifact(e){let t=e.driver.defaultSession,a=await e.driver.executionContext.evaluate(qv,{args:[],useIsolation:!0,deps:[sd.getElementsInDocument,sd.getBoundingClientRect,sd.getNodeDetails,Ov,jv,Uv,Bv]});return await Promise.all([t.sendCommand("DOM.enable"),t.sendCommand("CSS.enable"),t.sendCommand("DOM.getDocument",{depth:-1,pierce:!0})]),a.sort(((e,t)=>Gv(t)-Gv(e))),await this.collectExtraDetails(e.driver,a),await Promise.all([t.sendCommand("DOM.disable"),t.sendCommand("CSS.disable")]),a}},Kv=$v})),Jv={};function Zv(){let e=[],t=new Map,a=new Map,n=getElementsInDocument("form");for(let e of n)t.set(e,{id:e.id,name:e.name,autocomplete:e.autocomplete,node:getNodeDetails(e)});let r=getElementsInDocument("label");for(let e of r)a.set(e,{for:e.htmlFor,node:getNodeDetails(e)});let i=getElementsInDocument("textarea, input, select");for(let n of i){let r,i=n.form,o=i?[...t.keys()].indexOf(i):void 0,s=[...n.labels||[]].map((e=>[...a.keys()].indexOf(e)));n.readOnly||(r=!n.dispatchEvent(new ClipboardEvent("paste",{cancelable:!0}))),e.push({parentFormIndex:o,labelIndices:s,id:n.id,name:n.name,type:n.type,placeholder:n instanceof HTMLSelectElement?void 0:n.placeholder,autocomplete:{property:n.autocomplete,attribute:n.getAttribute("autocomplete"),prediction:n.getAttribute("autofill-prediction")},preventsPaste:r,node:getNodeDetails(n)})}return{inputs:e,forms:[...t.values()],labels:[...a.values()]}}c(Jv,{default:()=>Qv});var Xv,Qv,eb=s((()=>{J(),aa(),bd(),o(Zv,"collectElements"),Xv=class extends Jt{static{o(this,"Inputs")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){return e.driver.executionContext.evaluate(Zv,{args:[],useIsolation:!0,deps:[sd.getElementsInDocument,sd.getNodeDetails]})}},Qv=Xv})),tb={};c(tb,{default:()=>nb});var ab,nb,rb=s((()=>{J(),aa(),Yc(),mp(),ab=class extends Jt{static{o(this,"InspectorIssues")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:dp.symbol}};constructor(){super(),this._issues=[],this._onIssueAdded=this.onIssueAdded.bind(this)}onIssueAdded(e){this._issues.push(e.issue)}async startInstrumentation(e){let t=e.driver.defaultSession;t.on("Audits.issueAdded",this._onIssueAdded),await t.sendCommand("Audits.enable")}async stopInstrumentation(e){let t=e.driver.defaultSession;t.off("Audits.issueAdded",this._onIssueAdded),await t.sendCommand("Audits.disable")}async getArtifact(e){let t=e.dependencies.DevtoolsLog,a=await Pc.request(t,e),n={attributionReportingIssue:[],blockedByResponseIssue:[],bounceTrackingIssue:[],clientHintIssue:[],contentSecurityPolicyIssue:[],corsIssue:[],deprecationIssue:[],federatedAuthRequestIssue:[],genericIssue:[],heavyAdIssue:[],lowTextContrastIssue:[],mixedContentIssue:[],navigatorUserAgentIssue:[],quirksModeIssue:[],cookieIssue:[],sharedArrayBufferIssue:[],stylesheetLoadingIssue:[],federatedAuthUserInfoRequestIssue:[]},r=Object.keys(n);for(let e of r){let t=`${e}Details`,r=this._issues.map((e=>e.details[t]));for(let t of r){if(!t)continue;let r="request"in t&&t.request&&t.request.requestId;r?a.find((e=>e.requestId===r))&&n[e].push(t):n[e].push(t)}}return n}},nb=ab})),ib={};c(ib,{default:()=>sb});var ob,sb,lb=s((()=>{J(),ea(),aa(),ob=class e extends Jt{static{o(this,"InstallabilityErrors")}meta={supportedModes:["snapshot","navigation"]};static async getInstallabilityErrors(e){let t={msg:"Get webapp installability errors",id:"lh:gather:getInstallabilityErrors"};Kt.time(t);let a=(await e.sendCommand("Page.getInstallabilityErrors")).installabilityErrors;return Kt.timeEnd(t),{errors:a}}async getArtifact(t){let a=t.driver;try{return await e.getInstallabilityErrors(a.defaultSession)}catch{return{errors:[{errorId:"protocol-timeout",errorArguments:[]}]}}}},sb=ob})),cb={};c(cb,{default:()=>db});var ub,db,mb,pb,hb=s((()=>{J(),aa(),ub=class extends Jt{static{o(this,"JsUsage")}meta={supportedModes:["snapshot","timespan","navigation"]};constructor(){super(),this._scriptUsages=[]}async startInstrumentation(e){let t=e.driver.defaultSession;await t.sendCommand("Profiler.enable"),await t.sendCommand("Profiler.startPreciseCoverage",{detailed:!1})}async stopInstrumentation(e){let t=e.driver.defaultSession,a=await t.sendCommand("Profiler.takePreciseCoverage");this._scriptUsages=a.result,await t.sendCommand("Profiler.stopPreciseCoverage"),await t.sendCommand("Profiler.disable")}async getArtifact(){let e={};for(let t of this._scriptUsages)""===t.url||"_lighthouse-eval.js"===t.url||"__puppeteer_evaluation_script__"!==t.url&&(e[t.scriptId]=t);return e}},db=ub})),gb=l(((e,t)=>{J();var a=/^utf-?8|ascii|utf-?16-?le|ucs-?2|base-?64|latin-?1$/i,n=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,r=/\s|\uFEFF|\xA0/,i=/\r?\n[\x20\x09]+/g,s=/[;,"]/,l=/[;,"]|\s/,c=/^[!#$%&'*+\-\.^_`|~\da-zA-Z]+$/,u=1,d=2,m=4;function p(e){return e.replace(n,"")}function h(e){return r.test(e)}function g(e,t){for(;h(e[t]);)t++;return t}function f(e){return l.test(e)||!c.test(e)}function y(e,t){return Object.keys(e).length===Object.keys(t).length&&Object.keys(e).every((a=>a in t&&e[a]===t[a]))}o(p,"trim"),o(h,"hasWhitespace"),o(g,"skipWhitespace"),o(f,"needsQuotes"),o(y,"shallowCompareObjects");var v=class e{static{o(this,"Link")}constructor(e){this.refs=[],e&&this.parse(e)}rel(e){for(var t=[],a=e.toLowerCase(),n=0;n<this.refs.length;n++)this.refs[n].rel.toLowerCase()===a&&t.push(this.refs[n]);return t}get(e,t){e=e.toLowerCase();for(var a=[],n=0;n<this.refs.length;n++)this.refs[n][e]===t&&a.push(this.refs[n]);return a}set(e){return this.refs.push(e),this}setUnique(e){return this.refs.some((t=>y(t,e)))||this.refs.push(e),this}has(e,t){e=e.toLowerCase();for(var a=0;a<this.refs.length;a++)if(this.refs[a][e]===t)return!0;return!1}parse(t,a){t=p(t=(a=a||0)?t.slice(a):t).replace(i,"");for(var n=u,r=t.length,o=(a=0,null);a<r;)if(n===u){if(h(t[a])){a++;continue}if("<"!==t[a])throw new Error('Unexpected character "'+t[a]+'" at offset '+a);if(null!=o&&(null!=o.rel?this.refs.push(...e.expandRelations(o)):this.refs.push(o)),-1===(f=t.indexOf(">",a)))throw new Error("Expected end of URI delimiter at offset "+a);o={uri:t.slice(a+1,f)},a=f,n=d,a++}else if(n===d){if(h(t[a])){a++;continue}if(";"===t[a])n=m,a++;else{if(","!==t[a])throw new Error('Unexpected character "'+t[a]+'" at offset '+a);n=u,a++}}else{if(n!==m)throw new Error('Unknown parser state "'+n+'"');if(";"===t[a]||h(t[a])){a++;continue}-1===(f=t.indexOf("=",a))&&(f=t.indexOf(";",a)),-1===f&&(f=t.length);var l=p(t.slice(a,f)).toLowerCase(),c="";if('"'===t[a=g(t,a=f+1)])for(a++;a<r;){if('"'===t[a]){a++;break}"\\"===t[a]&&a++,c+=t[a],a++}else{for(var f=a+1;!s.test(t[f])&&f<r;)f++;c=t.slice(a,f),a=f}switch(o[l]&&e.isSingleOccurenceAttr(l)||("*"===l[l.length-1]?o[l]=e.parseExtendedValue(c):(c="type"===l?c.toLowerCase():c,null!=o[l]?Array.isArray(o[l])?o[l].push(c):o[l]=[o[l],c]:o[l]=c)),t[a]){case",":n=u;break;case";":n=m}a++}return null!=o&&(null!=o.rel?this.refs.push(...e.expandRelations(o)):this.refs.push(o)),o=null,this}toString(){for(var t=[],a="",n=null,r=0;r<this.refs.length;r++)n=this.refs[r],a=Object.keys(this.refs[r]).reduce((function(t,a){return"uri"===a?t:t+"; "+e.formatAttribute(a,n[a])}),"<"+n.uri+">"),t.push(a);return t.join(", ")}};v.isCompatibleEncoding=function(e){return a.test(e)},v.parse=function(e,t){return(new v).parse(e,t)},v.isSingleOccurenceAttr=function(e){return"rel"===e||"type"===e||"media"===e||"title"===e||"title*"===e},v.isTokenAttr=function(e){return"rel"===e||"type"===e||"anchor"===e},v.escapeQuotes=function(e){return e.replace(/"/g,'\\"')},v.expandRelations=function(e){return e.rel.split(" ").map((function(t){var a=Object.assign({},e);return a.rel=t,a}))},v.parseExtendedValue=function(e){var t=/([^']+)?(?:'([^']*)')?(.+)/.exec(e);return{language:t[2].toLowerCase(),encoding:v.isCompatibleEncoding(t[1])?null:t[1].toLowerCase(),value:v.isCompatibleEncoding(t[1])?decodeURIComponent(t[3]):t[3]}},v.formatExtendedAttribute=function(e,t){var a=(t.encoding||"utf-8").toUpperCase();return e+"="+a+"'"+(t.language||"en")+"'"+(Buffer.isBuffer(t.value)&&v.isCompatibleEncoding(a)?t.value.toString(a):Buffer.isBuffer(t.value)?t.value.toString("hex").replace(/[0-9a-f]{2}/gi,"%$1"):encodeURIComponent(t.value))},v.formatAttribute=function(e,t){return Array.isArray(t)?t.map((t=>v.formatAttribute(e,t))).join("; "):"*"===e[e.length-1]||"string"!=typeof t?v.formatExtendedAttribute(e,t):(v.isTokenAttr(e)?t=f(t)?'"'+v.escapeQuotes(t)+'"':v.escapeQuotes(t):f(t)&&(t='"'+(t=(t=encodeURIComponent(t)).replace(/%20/g," ").replace(/%2C/g,",").replace(/%3B/g,";"))+'"'),e+"="+t)},t.exports=v})),fb=s((()=>{J(),Bc(),zl(),Yc(),mb=class{static{o(this,"MainResource")}static async compute_(e,t){let{mainDocumentUrl:a}=e.URL;if(!a)throw new Error("mainDocumentUrl must exist to get the main resource");let n=await Pc.request(e.devtoolsLog,t),r=Ll.findResourceForUrl(n,a);if(!r)throw new Error("Unable to identify the main resource");return r}},pb=dc(mb,["URL","devtoolsLog"])})),yb={};function vb(e,t){try{return new URL(e,t).href}catch{return null}}function bb(e){return"anonymous"===e?"anonymous":"use-credentials"===e?"use-credentials":null}function wb(){let e=getElementsInDocument("link"),t=[];for(let a of e){if(!(a instanceof HTMLLinkElement))continue;let e=a.getAttribute("href")||"",n=a.closest("head")?"head":"body";t.push({rel:a.rel,href:a.href,hreflang:a.hreflang,as:a.as,crossOrigin:a.crossOrigin,hrefRaw:e,source:n,fetchPriority:a.fetchPriority,node:getNodeDetails(a)})}return t}c(yb,{UIStrings:()=>Eb,default:()=>Cb});var Db,Eb,Tb,Sb,Cb,kb=s((()=>{J(),Db=d(gb(),1),aa(),bd(),mp(),fb(),kr(),ro(),Tb=eo("core/gather/gatherers/link-elements.js",Eb={headerParseWarning:"Error parsing `link` header ({error}): `{header}`"}),o(vb,"normalizeUrlOrNull"),o(bb,"getCrossoriginFromHeader"),o(wb,"getLinkElementsInDOM"),Sb=class e extends Jt{static{o(this,"LinkElements")}constructor(){super(),this.meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:dp.symbol}}}static getLinkElementsInDOM(e){return e.driver.executionContext.evaluate(wb,{args:[],useIsolation:!0,deps:[sd.getNodeDetails,sd.getElementsInDocument]})}static async getLinkElementsInHeaders(e,t){let a=await pb.request({devtoolsLog:t,URL:e.baseArtifacts.URL},e),n=[];for(let t of a.responseHeaders){if("link"!==t.name.toLowerCase())continue;let a=[];try{a=Db.default.parse(t.value).refs}catch(a){let n=br.truncate(t.value,100),r=Tb(Eb.headerParseWarning,{error:a.message,header:n});e.baseArtifacts.LighthouseRunWarnings.push(r)}for(let t of a)n.push({rel:t.rel||"",href:vb(t.uri,e.baseArtifacts.URL.finalDisplayedUrl),hrefRaw:t.uri||"",hreflang:t.hreflang||"",as:t.as||"",crossOrigin:bb(t.crossorigin),source:"headers",fetchPriority:t.fetchpriority,node:null})}return n}async getArtifact(t){let a=t.dependencies.DevtoolsLog,n=await e.getLinkElementsInDOM(t),r=await e.getLinkElementsInHeaders(t,a),i=n.concat(r);for(let e of i)e.rel=e.rel.toLowerCase();return i}},Cb=Sb})),xb={};c(xb,{default:()=>_b});var Ab,_b,Rb=s((()=>{J(),aa(),mp(),Ly(),fb(),Ab=class extends Jt{static{o(this,"MainDocumentContent")}meta={supportedModes:["navigation"],dependencies:{DevtoolsLog:dp.symbol}};async getArtifact(e){let t=e.dependencies.DevtoolsLog,a=await pb.request({devtoolsLog:t,URL:e.baseArtifacts.URL},e);return Py(e.driver.defaultSession,a.requestId)}},_b=Ab})),Fb={};function Nb(){let e={getElementsInDocument:getElementsInDocument,getNodeDetails:getNodeDetails};return e.getElementsInDocument("head meta").map((t=>{let a=o((e=>{let a=t.attributes.getNamedItem(e);if(a)return a.value}),"getAttribute");return{name:t.name.toLowerCase(),content:t.content,property:a("property"),httpEquiv:t.httpEquiv?t.httpEquiv.toLowerCase():void 0,charset:a("charset"),node:e.getNodeDetails(t)}}))}c(Fb,{default:()=>Mb});var Ib,Mb,Pb=s((()=>{J(),aa(),bd(),o(Nb,"collectMetaElements"),Ib=class extends Jt{static{o(this,"MetaElements")}meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(Nb,{args:[],useIsolation:!0,deps:[sd.getElementsInDocument,sd.getNodeDetails]})}},Mb=Ib})),Lb={};c(Lb,{default:()=>jb});var Ob,jb,Ub=s((()=>{J(),aa(),mp(),Ob=class e extends Jt{static{o(this,"NetworkUserAgent")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:dp.symbol}};static getNetworkUserAgent(e){for(let t of e){if("Network.requestWillBeSent"!==t.method)continue;let e=t.params.request.headers["User-Agent"];if(e)return e}return""}async getArtifact(t){return e.getNetworkUserAgent(t.dependencies.DevtoolsLog)}},jb=Ob})),Bb={};function qb(){return getElementsInDocument("script").map((e=>({type:e.type||null,src:e.src||null,id:e.id||null,async:e.async,defer:e.defer,source:e.closest("head")?"head":"body",node:getNodeDetails(e)})))}c(Bb,{default:()=>Vb});var zb,Vb,Wb=s((()=>{J(),aa(),Yc(),qc(),bd(),mp(),o(qb,"collectAllScriptElements"),zb=class extends Jt{static{o(this,"ScriptElements")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:dp.symbol}};async _getArtifact(e,t){let a=await e.driver.executionContext.evaluate(qb,{args:[],useIsolation:!0,deps:[sd.getNodeDetails,sd.getElementsInDocument]}),n=t.filter((e=>e.resourceType===wc.TYPES.Script)).filter((e=>!e.isOutOfProcessIframe));for(let e=0;e<n.length;e++){let t=n[e];a.find((e=>e.src===t.url))||a.push({type:null,src:t.url,id:null,async:!1,defer:!1,source:"network",node:null})}return a}async getArtifact(e){let t=e.dependencies.DevtoolsLog,a=await Pc.request(t,e);return this._getArtifact(e,a)}},Vb=zb})),Hb={};async function Gb(e,t,a){if(a){let a=[];for(let n of e){let e=await t(n);a.push(e)}return a}{let a=e.map(t);return await Promise.all(a)}}function $b(e){return!e.embedderName||e.hasSourceURL&&"_lighthouse-eval.js"===e.url}c(Hb,{default:()=>Yb});var Kb,Yb,Jb=s((()=>{J(),aa(),o(Gb,"runInSeriesOrParallel"),o($b,"isLighthouseRuntimeEvaluateScript"),Kb=class e extends Jt{static{o(this,"Scripts")}static symbol=Symbol("Scripts");meta={symbol:e.symbol,supportedModes:["timespan","navigation"]};_scriptParsedEvents=[];_scriptContents=[];constructor(){super(),this.onScriptParsed=this.onScriptParsed.bind(this)}onScriptParsed(e){$b(e)||this._scriptParsedEvents.push(e)}async startInstrumentation(e){let t=e.driver.defaultSession;t.on("Debugger.scriptParsed",this.onScriptParsed),await t.sendCommand("Debugger.enable")}async stopInstrumentation(e){let t=e.driver.defaultSession,a=e.baseArtifacts.HostFormFactor;t.off("Debugger.scriptParsed",this.onScriptParsed),this._scriptContents=await Gb(this._scriptParsedEvents,(({scriptId:e})=>t.sendCommand("Debugger.getScriptSource",{scriptId:e}).then((e=>e.scriptSource)).catch((()=>{}))),"mobile"===a),await t.sendCommand("Debugger.disable")}async getArtifact(){return this._scriptParsedEvents.map(((e,t)=>({name:e.url,...e,url:e.embedderName||e.url,content:this._scriptContents[t]})))}},Yb=Kb})),Zb={};function Xb(){let e={getElementsInDocument:getElementsInDocument,getNodeDetails:getNodeDetails};return e.getElementsInDocument("object, embed, applet").map((t=>({tagName:t.tagName,type:t.getAttribute("type"),src:t.getAttribute("src"),data:t.getAttribute("data"),code:t.getAttribute("code"),params:Array.from(t.children).filter((e=>"PARAM"===e.tagName)).map((e=>({name:e.getAttribute("name")||"",value:e.getAttribute("value")||""}))),node:e.getNodeDetails(t)})))}c(Zb,{default:()=>ew});var Qb,ew,tw=s((()=>{J(),aa(),bd(),o(Xb,"getEmbeddedContent"),Qb=class extends Jt{static{o(this,"EmbeddedContent")}meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(Xb,{args:[],deps:[sd.getElementsInDocument,sd.getNodeDetails]})}},ew=Qb})),aw={};c(aw,{default:()=>rw});var nw,rw,iw=s((()=>{J(),aa(),nw=class extends Jt{static{o(this,"RobotsTxt")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){let{finalDisplayedUrl:t}=e.baseArtifacts.URL,a=new URL("/robots.txt",t).href;return e.driver.fetcher.fetchResource(a).catch((e=>({status:null,content:null,errorMessage:e.message})))}},rw=nw}));function ow(e,{x:t,y:a}){return e.left<=t&&e.right>=t&&e.top<=a&&e.bottom>=a}function sw(e,t){return t.top>=e.top&&t.right<=e.right&&t.bottom<=e.bottom&&t.left>=e.left}function lw(e){return e.filter((e=>e.width>1&&e.height>1))}function cw(e){let t=new Set(e);for(let a of e)for(let n of e)if(a!==n&&t.has(n)&&sw(n,a)){t.delete(a);break}return Array.from(t)}function uw(e){return{x:e.left+e.width/2,y:e.top+e.height/2}}function dw(e,t){return e.left<=t.right&&t.left<=e.right&&e.top<=t.bottom&&t.top<=e.bottom}function mw(e,t){if(0===e.length)throw new Error("No rects to take bounds of");let a=Number.MAX_VALUE,n=-Number.MAX_VALUE,r=Number.MAX_VALUE,i=-Number.MAX_VALUE;for(let t of e)a=Math.min(a,t.left),n=Math.max(n,t.right),r=Math.min(r,t.top),i=Math.max(i,t.bottom);let o=t/2;return a-=o,n+=o,r-=o,i+=o,{left:a,right:n,top:r,bottom:i,width:n-a,height:i-r}}function pw(e){return mw(e,0)}function hw({left:e,top:t,right:a,bottom:n}){return{left:e,top:t,right:a,bottom:n,width:a-e,height:n-t}}function gw({x:e,y:t,width:a,height:n}){return{left:e,top:t,right:e+a,bottom:t+n,width:a,height:n}}function fw(e,t){let a=Math.min(e.bottom,t.bottom)-Math.max(e.top,t.top);if(a<=0)return 0;let n=Math.min(e.right,t.right)-Math.max(e.left,t.left);return n<=0?0:n*a}function yw(e,t){return hw({left:e.left+e.width/2-t/2,top:e.top+e.height/2-t/2,right:e.right-e.width/2+t/2,bottom:e.bottom-e.height/2+t/2})}function vw(e){return e.width*e.height}function bw(e){let t=e[0];for(let a of e)vw(a)>vw(t)&&(t=a);return t}function ww(e,t){for(let a of e)for(let e of t)if(!sw(a,e)&&!sw(e,a))return!1;return!0}var Dw=s((()=>{J(),o(ow,"rectContainsPoint"),o(sw,"rectContains"),o(lw,"filterOutTinyRects"),o(cw,"filterOutRectsContainedByOthers"),o(uw,"getRectCenterPoint"),o(dw,"rectsTouchOrOverlap"),o(mw,"getBoundingRectWithPadding"),o(pw,"getBoundingRect"),o(hw,"addRectWidthAndHeight"),o(gw,"addRectTopAndBottom"),o(fw,"getRectOverlapArea"),o(yw,"getRectAtCenter"),o(vw,"getRectArea"),o(bw,"getLargestRect"),o(ww,"allRectsContainedWithinEachOther")})),Ew={};function Tw(e){return!!(e.offsetWidth||e.offsetHeight||e.getClientRects().length)}function Sw(e){let t=Array.from(e.getClientRects()).map((e=>{let{width:t,height:a,left:n,top:r,right:i,bottom:o}=e;return{width:t,height:a,left:n,top:r,right:i,bottom:o}}));for(let a of e.children)t.push(...Sw(a));return t}function Cw(e,t){return!!e.parentElement&&(!!e.parentElement.matches(t)||Cw(e.parentElement,t))}function kw(e){if(!e.parentElement)return!1;let t=e.parentElement,a=e.textContent||"";if((t.textContent||"").length-a.length<5)return!1;for(let t of e.parentElement.childNodes){if(t===e)continue;let a=(t.textContent||"").trim();if(t.nodeType===Node.TEXT_NODE&&a.length>0)return!0}return!1}function xw(e){let{display:t}=getComputedStyle(e);return("inline"===t||"inline-block"===t)&&(!!kw(e)||!!e.parentElement&&xw(e.parentElement))}function Aw(e,t){let a=window.innerHeight,n=Math.floor(t.y/a)*a;window.scrollY!==n&&window.scrollTo(0,n);let r=document.elementFromPoint(t.x,t.y-window.scrollY);return r===e||e.contains(r)}function _w(e){return document.querySelectorAll("*").forEach((t=>{let a=getComputedStyle(t).position;("fixed"===a||"sticky"===a)&&t.classList.add(e)})),o((function(){Array.from(document.getElementsByClassName(e)).forEach((t=>{t.classList.remove(e)}))}),"undo")}function Rw(e,t){let a=[];window.scrollTo(0,0);let n=getElementsInDocument(e),r=[];n.forEach((t=>{Cw(t,e)||xw(t)||Tw(t)&&r.push({tapTargetElement:t,clientRects:Sw(t)})}));let i=_w(t),o=[];r.forEach((({tapTargetElement:e,clientRects:t})=>{let a=t.filter((e=>0!==e.width&&0!==e.height));a=a.filter((t=>{let a=getRectCenterPoint(t);return Aw(e,a)})),a.length>0&&o.push({tapTargetElement:e,visibleClientRects:a})}));for(let{tapTargetElement:e,visibleClientRects:t}of o)a.push({clientRects:t,href:e.href||"",node:getNodeDetails(e)});return i(),a}function Fw(e,t){let a={x:window.scrollX,y:window.scrollY};try{return Rw(e,t)}finally{window.scrollTo(a.x,a.y)}}c(Ew,{default:()=>Mw});var Nw,Iw,Mw,Pw=s((()=>{J(),aa(),bd(),Dw(),Nw=["button","a","input","textarea","select","option","[role=button]","[role=checkbox]","[role=link]","[role=menuitem]","[role=menuitemcheckbox]","[role=menuitemradio]","[role=option]","[role=scrollbar]","[role=slider]","[role=spinbutton]"].join(","),o(Tw,"elementIsVisible"),o(Sw,"getClientRects"),o(Cw,"elementHasAncestorTapTarget"),o(kw,"hasTextNodeSiblingsFormingTextBlock"),o(xw,"elementIsInTextBlock"),o(Aw,"elementCenterIsAtZAxisTop"),o(_w,"disableFixedAndStickyElementPointerEvents"),o(Rw,"gatherTapTargets"),o(Fw,"gatherTapTargetsAndResetScroll"),Iw=class extends Jt{static{o(this,"TapTargets")}constructor(){super(),this.meta={supportedModes:["snapshot","navigation"]}}async addStyleRule(e,t){let a=await e.sendCommand("Page.getFrameTree"),{styleSheetId:n}=await e.sendCommand("CSS.createStyleSheet",{frameId:a.frameTree.frame.id}),r=`.${t} { pointer-events: none !important }`;return await e.sendCommand("CSS.setStyleSheetText",{styleSheetId:n,text:r}),n}async removeStyleRule(e,t){await e.sendCommand("CSS.setStyleSheetText",{styleSheetId:t,text:""})}async getArtifact(e){let t=e.driver.defaultSession;await t.sendCommand("DOM.enable"),await t.sendCommand("CSS.enable");let a="lighthouse-disable-pointer-events",n=await this.addStyleRule(t,a),r=await e.driver.executionContext.evaluate(Fw,{args:[Nw,a],useIsolation:!0,deps:[sd.getNodeDetails,sd.getElementsInDocument,_w,Tw,Cw,Aw,Sw,kw,xw,uw,sd.getNodePath,sd.getNodeSelector,sd.getNodeLabel,Rw]});return await this.removeStyleRule(t,n),await t.sendCommand("CSS.disable"),await t.sendCommand("DOM.disable"),r}},Mw=Iw}));function Lw(e){return new Promise(((t,a)=>{let n=o((r=>{let i=r.versions.filter((e=>"redundant"!==e.status)),o=i.find((e=>"activated"===e.status));(!i.length||o)&&(e.off("ServiceWorker.workerVersionUpdated",n),e.sendCommand("ServiceWorker.disable").then((e=>t(r)),a))}),"versionUpdatedListener");e.on("ServiceWorker.workerVersionUpdated",n),e.sendCommand("ServiceWorker.enable").catch(a)}))}function Ow(e){return new Promise(((t,a)=>{e.once("ServiceWorker.workerRegistrationUpdated",(n=>{e.sendCommand("ServiceWorker.disable").then((e=>t(n)),a)})),e.sendCommand("ServiceWorker.enable").catch(a)}))}var jw=s((()=>{J(),o(Lw,"getServiceWorkerVersions"),o(Ow,"getServiceWorkerRegistrations")})),Uw={};c(Uw,{default:()=>qw});var Bw,qw,zw=s((()=>{J(),aa(),jw(),Bw=class extends Jt{static{o(this,"ServiceWorker")}meta={supportedModes:["navigation"]};async getArtifact(e){let t=e.driver.defaultSession,{versions:a}=await Lw(t),{registrations:n}=await Ow(t);return{versions:a,registrations:n}}},qw=Bw})),Vw=l((e=>{function t(e){if(-1===e.indexOf("..")&&-1===e.indexOf("."))return e;let t=("/"===e[0]?e.substring(1):e).split("/"),a=[];for(let e of t)"."!==e&&(".."===e?a.pop():a.push(e));let n=a.join("/");return"/"===e[0]&&n&&(n="/"+n),"/"!==n[n.length-1]&&("/"===e[e.length-1]||"."===t[t.length-1]||".."===t[t.length-1])&&(n+="/"),n}J(),Object.defineProperty(e,"__esModule",{value:!0}),e.ParsedURL=e.normalizePath=void 0,o(t,"normalizePath"),e.normalizePath=t;var a=class e{static{o(this,"ParsedURL")}isValid;url;scheme;user;host;port;path;queryParams;fragment;folderPathComponents;lastPathComponent;blobInnerScheme;#e;#t;constructor(t){this.isValid=!1,this.url=t,this.scheme="",this.user="",this.host="",this.port="",this.path="",this.queryParams="",this.fragment="",this.folderPathComponents="",this.lastPathComponent="";let a=this.url.startsWith("blob:"),n=(a?t.substring(5):t).match(e.urlRegex());if(n)this.isValid=!0,a?(this.blobInnerScheme=n[2].toLowerCase(),this.scheme="blob"):this.scheme=n[2].toLowerCase(),this.user=n[3]??"",this.host=n[4]??"",this.port=n[5]??"",this.path=n[6]??"/",this.queryParams=n[7]??"",this.fragment=n[8]??"";else{if(this.url.startsWith("data:"))return void(this.scheme="data");if(this.url.startsWith("blob:"))return void(this.scheme="blob");if("about:blank"===this.url)return void(this.scheme="about");this.path=this.url}let r=this.path.lastIndexOf("/");-1!==r?(this.folderPathComponents=this.path.substring(0,r),this.lastPathComponent=this.path.substring(r+1)):this.lastPathComponent=this.path}static concatenate(e,...t){return e.concat(...t)}static beginsWithWindowsDriveLetter(e){return/^[A-Za-z]:/.test(e)}static beginsWithScheme(e){return/^[A-Za-z][A-Za-z0-9+.-]*:/.test(e)}static isRelativeURL(e){return!this.beginsWithScheme(e)||this.beginsWithWindowsDriveLetter(e)}get displayName(){return this.#e?this.#e:this.isDataURL()?this.dataURLDisplayName():this.isBlobURL()||this.isAboutBlank()?this.url:(this.#e=this.lastPathComponent,this.#e||(this.#e=(this.host||"")+"/"),"/"===this.#e&&(this.#e=this.url),this.#e)}static urlRegexInstance=null};e.ParsedURL=a})),Ww=l(((e,t)=>{J();var a=Vw();t.exports={ParsedURL:a}})),Hw=l(((e,t)=>{function a(e,t,a,n,r){let i=n||0,o=void 0!==r?r:e.length;for(;i<o;){let n=i+o>>1;a(t,e[n])>0?i=n+1:o=n}return o}function n(e,t,a,n,r){let i=n||0,o=void 0!==r?r:e.length;for(;i<o;){let n=i+o>>1;a(t,e[n])>=0?i=n+1:o=n}return o}J(),o(a,"lowerBound"),o(n,"upperBound"),t.exports={ArrayUtilities:{lowerBound:a,upperBound:n},DevToolsPath:{EmptyUrlString:""}}})),Gw=l(((e,t)=>{J();var a=Ww(),n=Hw();function r(e){return e.startsWith(")]}")&&(e=e.substring(e.indexOf("\n"))),65279===e.charCodeAt(0)&&(e=e.slice(1)),JSON.parse(e)}Object.defineProperty(e,"__esModule",{value:!0}),e.SourceMap=e.SourceMapEntry=e.parseSourceMap=void 0,o(r,"parseSourceMap"),e.parseSourceMap=r;var i=class{static{o(this,"SourceMapEntry")}lineNumber;columnNumber;sourceURL;sourceLineNumber;sourceColumnNumber;name;constructor(e,t,a,n,r,i){this.lineNumber=e,this.columnNumber=t,this.sourceURL=a,this.sourceLineNumber=n,this.sourceColumnNumber=r,this.name=i}static compare(e,t){return e.lineNumber!==t.lineNumber?e.lineNumber-t.lineNumber:e.columnNumber-t.columnNumber}};e.SourceMapEntry=i;var s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l=new Map;for(let e=0;e<64;++e)l.set(s.charAt(e),e);var c=new WeakMap,u=class e{static{o(this,"SourceMap")}#e;#t;#a;#n;#r;#i;constructor(e,t,a){this.#e=a,this.#t=e,this.#a=t,this.#n=t.startsWith("data:")?e:t,this.#r=null,this.#i=new Map,"sections"in this.#e&&this.#e.sections.find((e=>"url"in e))&&console.warn(`SourceMap "${t}" contains unsupported "URL" field in one of its sections.`),this.eachSection(this.parseSources.bind(this))}compiledURL(){return this.#t}url(){return this.#a}sourceURLs(){return[...this.#i.keys()]}embeddedContentByURL(e){let t=this.#i.get(e);return t?t.content:null}findEntry(e,t){let a=this.mappings(),r=n.ArrayUtilities.upperBound(a,void 0,((a,n)=>e-n.lineNumber||t-n.columnNumber));return r?a[r-1]:null}findEntryRanges(e,t){let a=this.mappings(),r=n.ArrayUtilities.upperBound(a,void 0,((a,n)=>e-n.lineNumber||t-n.columnNumber));if(!r)return null;let i=r-1,o=a[i].sourceURL;if(!o)return null;let s=r<a.length?a[r].lineNumber:2**31-1,l=r<a.length?a[r].columnNumber:2**31-1,c=new TextUtils.TextRange.TextRange(a[i].lineNumber,a[i].columnNumber,s,l),u=this.reversedMappings(o),d=a[i].sourceLineNumber,m=a[i].sourceColumnNumber,p=n.ArrayUtilities.upperBound(u,void 0,((e,t)=>d-a[t].sourceLineNumber||m-a[t].sourceColumnNumber));if(!p)return null;let h=p<u.length?a[u[p]].sourceLineNumber:2**31-1,g=p<u.length?a[u[p]].sourceColumnNumber:2**31-1;return{range:c,sourceRange:new TextUtils.TextRange.TextRange(d,m,h,g),sourceURL:o}}sourceLineMapping(e,t,a){let r=this.mappings(),i=this.reversedMappings(e),o=n.ArrayUtilities.lowerBound(i,t,u),s=n.ArrayUtilities.upperBound(i,t,u);if(o>=i.length||r[i[o]].sourceLineNumber!==t)return null;let l=i.slice(o,s);if(!l.length)return null;let c=n.ArrayUtilities.lowerBound(l,a,((e,t)=>e-r[t].sourceColumnNumber));return c>=l.length?r[l[l.length-1]]:r[l[c]];function u(e,t){return e-r[t].sourceLineNumber}}findReverseIndices(e,t,a){let r=this.mappings(),i=this.reversedMappings(e),o=n.ArrayUtilities.upperBound(i,void 0,((e,n)=>t-r[n].sourceLineNumber||a-r[n].sourceColumnNumber)),s=o;for(;s>0&&r[i[s-1]].sourceLineNumber===r[i[o-1]].sourceLineNumber&&r[i[s-1]].sourceColumnNumber===r[i[o-1]].sourceColumnNumber;)--s;return i.slice(s,o)}findReverseEntries(e,t,a){let n=this.mappings();return this.findReverseIndices(e,t,a).map((e=>n[e]))}findReverseRanges(e,t,a){let n=this.mappings(),r=this.findReverseIndices(e,t,a),i=[];for(let e=0;e<r.length;++e){let t=r[e],a=t+1;for(;e+1<r.length&&a===r[e+1];)++a,++e;let o=n[t].lineNumber,s=n[t].columnNumber,l=a<n.length?n[a].lineNumber:2**31-1,c=a<n.length?n[a].columnNumber:2**31-1;i.push(new TextUtils.TextRange.TextRange(o,s,l,c))}return i}mappings(){return this.#o(),this.#r??[]}reversedMappings(e){return this.#o(),this.#i.get(e)?.reverseMappings??[]}#o(){null===this.#r&&(this.#r=[],this.eachSection(this.parseMap.bind(this)),this.mappings().sort(i.compare),this.#s(this.#r),this.#e=null)}#s(e){let t=new Map;for(let a=0;a<e.length;a++){let n=e[a].sourceURL;if(!n)continue;let r=t.get(n);r||(r=[],t.set(n,r)),r.push(a)}for(let[e,n]of t.entries()){let t=this.#i.get(e);t&&(n.sort(a),t.reverseMappings=n)}function a(t,a){let n=e[t],r=e[a];return n.sourceLineNumber-r.sourceLineNumber||n.sourceColumnNumber-r.sourceColumnNumber||n.lineNumber-r.lineNumber||n.columnNumber-r.columnNumber}o(a,"sourceMappingComparator")}eachSection(e){if(this.#e)if("sections"in this.#e)for(let t of this.#e.sections)"map"in t&&e(t.map,t.offset.line,t.offset.column);else e(this.#e,0,0)}parseSources(e){let t=[],n=e.sourceRoot??"",r=new Set(e.x_google_ignoreList);for(let i=0;i<e.sources.length;++i){let o=e.sources[i];a.ParsedURL.ParsedURL.isRelativeURL(o)&&(o=n&&!n.endsWith("/")&&o&&!o.startsWith("/")?n.concat("/",o):n.concat(o));let s=o,l=e.sourcesContent&&e.sourcesContent[i];if(t.push(s),!this.#i.has(s)){let e=l??null,t=r.has(i);this.#i.set(s,{content:e,ignoreListHint:t,reverseMappings:null})}}c.set(e,t)}parseMap(t,a,n){let r=0,o=0,s=0,l=0,u=c.get(t),d=t.names??[],m=new e.StringCharIterator(t.mappings),p=u&&u[r];for(;;){if(","===m.peek())m.next();else{for(;";"===m.peek();)a+=1,n=0,m.next();if(!m.hasNext())break}if(n+=this.decodeVLQ(m),!m.hasNext()||this.isSeparator(m.peek())){this.mappings().push(new i(a,n));continue}let e=this.decodeVLQ(m);(e&&(r+=e,u&&(p=u[r])),o+=this.decodeVLQ(m),s+=this.decodeVLQ(m),m.hasNext()&&!this.isSeparator(m.peek()))?(l+=this.decodeVLQ(m),this.mappings().push(new i(a,n,p,o,s,d[l]))):this.mappings().push(new i(a,n,p,o,s))}}isSeparator(e){return","===e||";"===e}decodeVLQ(t){let a=0,n=0,r=e._VLQ_CONTINUATION_MASK;for(;r&e._VLQ_CONTINUATION_MASK;)r=l.get(t.next())||0,a+=(r&e._VLQ_BASE_MASK)<<n,n+=e._VLQ_BASE_SHIFT;let i=1&a;return a>>=1,i?-a:a}mapsOrigin(){let e=this.mappings();if(e.length>0){let t=e[0];return 0===t?.lineNumber||0===t.columnNumber}return!1}hasIgnoreListHint(e){return this.#i.get(e)?.ignoreListHint??!1}findRanges(e,t){let a=this.mappings(),n=[];if(!a.length)return[];let r=null;(0!==a[0].lineNumber||0!==a[0].columnNumber)&&t?.isStartMatching&&(r=TextUtils.TextRange.TextRange.createUnboundedFromLocation(0,0),n.push(r));for(let{sourceURL:t,lineNumber:i,columnNumber:o}of a){let a=t&&e(t);r||!a?r&&!a&&(r.endLine=i,r.endColumn=o,r=null):(r=TextUtils.TextRange.TextRange.createUnboundedFromLocation(i,o),n.push(r))}return n}};e.SourceMap=u,function(e){e._VLQ_BASE_SHIFT=5,e._VLQ_BASE_MASK=31,e._VLQ_CONTINUATION_MASK=32;class t{static{o(this,"StringCharIterator")}string;position;constructor(e){this.string=e,this.position=0}next(){return this.string.charAt(this.position++)}peek(){return this.string.charAt(this.position)}hasNext(){return this.position<this.string.length}}e.StringCharIterator=t}(u=e.SourceMap||(e.SourceMap={})),t.exports=u,u.parseSourceMap=r})),$w=l(((e,t)=>{J();var a={SourceMap:Gw()};a.SourceMap.prototype.computeLastGeneratedColumns=function(){let e=this.mappings();if(!e.length||void 0===e[0].lastColumnNumber)for(let t=0;t<e.length-1;t++){let a=e[t],n=e[t+1];a.lineNumber===n.lineNumber&&(a.lastColumnNumber=n.columnNumber)}},t.exports=a})),Kw={};c(Kw,{default:()=>Zw});var Yw,Jw,Zw,Xw=s((()=>{J(),Yw=d($w(),1),aa(),Jb(),Jw=class extends Jt{static{o(this,"SourceMaps")}meta={supportedModes:["timespan","navigation"],dependencies:{Scripts:Yb.symbol}};async fetchSourceMap(e,t){let a=await e.fetcher.fetchResource(t,{timeout:1500});if(null===a.content)throw new Error(`Failed fetching source map (${a.status})`);return Yw.default.SourceMap.parseSourceMap(a.content)}parseSourceMapFromDataUrl(e){let t=Buffer.from(e.split(",")[1],"base64");return Yw.default.SourceMap.parseSourceMap(t.toString())}_resolveUrl(e,t){try{return new URL(e,t).href}catch{return}}async _retrieveMapFromScript(e,t){if(!t.sourceMapURL)throw new Error("precondition failed: event.sourceMapURL should exist");let a=t.sourceMapURL.startsWith("data:"),n=t.name,r=a?t.sourceMapURL:this._resolveUrl(t.sourceMapURL,t.name);if(!r)return{scriptId:t.scriptId,scriptUrl:n,errorMessage:`Could not resolve map url: ${t.sourceMapURL}`};let i=a?void 0:r;try{let o=a?this.parseSourceMapFromDataUrl(r):await this.fetchSourceMap(e,r);if("number"!=typeof o.version)throw new Error("Map has no numeric `version` field");if(!Array.isArray(o.sources))throw new Error("Map has no `sources` list");if("string"!=typeof o.mappings)throw new Error("Map has no `mappings` field");return o.sections&&(o.sections=o.sections.filter((e=>e.map))),{scriptId:t.scriptId,scriptUrl:n,sourceMapUrl:i,map:o}}catch(e){return{scriptId:t.scriptId,scriptUrl:n,sourceMapUrl:i,errorMessage:e.toString()}}}async getArtifact(e){let t=e.dependencies.Scripts.filter((e=>e.sourceMapURL)).map((t=>this._retrieveMapFromScript(e.driver,t)));return Promise.all(t)}},Zw=Jw})),Qw={};async function eD(){let e=[],t=d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests;for(let[a,n]of Object.entries(t))try{let t,r=new Promise((e=>t=setTimeout((()=>e(!1)),1e3))),i=await Promise.race([n.test(window),r]);t&&clearTimeout(t),i&&e.push({id:n.id,name:a,version:i.version,npm:n.npm})}catch{}return e}c(Qw,{default:()=>aD});var tD,aD,nD=s((()=>{J(),ua(),ni(),ea(),aa(),'function _createTimeoutHelper(){let e;return{timeoutPromise:new Promise(((t,o)=>{e=setTimeout((()=>o(new Error("Timed out"))),5e3)})),clearTimeout:()=>clearTimeout(e)}}var UNKNOWN_VERSION=null,d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests={GWT:{id:"gwt",icon:"gwt",url:"http://www.gwtproject.org/",test:function(e){var t=e.document,o=t.getElementById("__gwt_historyFrame"),n=t.gwt_uid,r=t.body.__listener,i=t.body.__eventBits,s=e.__gwt_activeModules,c=e.__gwt_jsonp__,u=e.__gwt_scriptsLoaded||e.__gwt_stylesLoaded||e.__gwt_activeModules;if(o||n||r||i||s||c||u){for(var a=t.getElementsByTagName("iframe"),l=UNKNOWN_VERSION,N=0;N<a.length;N++)try{if(a[N].tabIndex<0&&a[N].contentWindow&&a[N].contentWindow.$gwt_version){l=a[N].contentWindow.$gwt_version;break}}catch(e){}return"0.0.999"==l&&(l="Google Internal"),{version:l}}return!1}},Ink:{id:"ink",icon:"ink",url:"http://ink.sapo.pt/",test:function(e){return!(!e.Ink||!e.Ink.createModule)&&{version:UNKNOWN_VERSION}}},Vaadin:{id:"vaadin",icon:"vaadin",url:"https://vaadin.com/",test:function(e){return!(!e.vaadin||!e.vaadin.registerWidgetset)&&{version:UNKNOWN_VERSION}}},Bootstrap:{id:"bootstrap",icon:"bootstrap",url:"http://getbootstrap.com/",npm:"bootstrap",test:function(e){var t,o=e.$&&e.$.fn;if(o&&(["affix","alert","button","carousel","collapse","dropdown","modal","popover","scrollspy","tab","tooltip"].some((function(o){if(e.$.fn[o]){if(e.$.fn[o].Constructor&&e.$.fn[o].Constructor.VERSION)return t=e.$.fn[o].Constructor.VERSION,!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:\'|\\")(?:bs\\\\.){1}"+o).test(e.$.fn[o].toString()))return t=">= 3.0.0 & <= 3.1.1",!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:\'|\\")"+o).test(e.$.fn[o].toString()))return t=">= 2.0.0 & <= 2.3.2",!0}return!1})),t))return{version:t};return!1}},Zurb:{id:"zurb",icon:"zurb",url:"https://foundation.zurb.com/",npm:"foundation-sites",test:function(e){return!(!e.Foundation||!e.Foundation.Toggler)&&{version:e.Foundation.version||UNKNOWN_VERSION}}},Polymer:{id:"polymer",icon:"polymer",url:"https://www.polymer-project.org/",npm:"@polymer/polymer",test:function(e){return!(!e.Polymer||!e.Polymer.dom)&&{version:e.Polymer.version||UNKNOWN_VERSION}}},LitElement:{id:"litelement",icon:"polymer",url:"https://lit-element.polymer-project.org/",npm:"lit-element",test:function(e){if(e.litElementVersions&&e.litElementVersions.length){var t=[...e.litElementVersions].sort(((e,t)=>e.localeCompare(t,void 0,{numeric:!0})));return{version:t[t.length-1]}}return!1}},"lit-html":{id:"lit-html",icon:"polymer",url:"https://lit-html.polymer-project.org/",npm:"lit-element",test:function(e){if(e.litHtmlVersions&&e.litHtmlVersions.length){var t=[...e.litHtmlVersions].sort(((e,t)=>e.localeCompare(t,void 0,{numeric:!0})));return{version:t[t.length-1]}}return!1}},Highcharts:{id:"highcharts",icon:"highcharts",url:"http://www.highcharts.com",npm:"highcharts",test:function(e){return!(!e.Highcharts||!e.Highcharts.Point)&&{version:e.Highcharts.version||UNKNOWN_VERSION}}},InfoVis:{id:"jit",icon:"jit",url:"http://philogb.github.com/jit/",test:function(e){return!(!e.$jit||!e.$jit.PieChart)&&{version:e.$jit.version||UNKNOWN_VERSION}}},FlotCharts:{id:"flotcharts",icon:"flotcharts",url:"http://www.flotcharts.org/",npm:"flot",test:function(e){return!(!e.$||!e.$.plot)&&{version:e.$.plot.version||UNKNOWN_VERSION}}},CreateJS:{id:"createjs",icon:"createjs",url:"https://createjs.com/",npm:"createjs",test:function(e){return!(!e.createjs||!e.createjs.promote)&&{version:UNKNOWN_VERSION}}},"Google Maps":{id:"gmaps",icon:"gmaps",url:"https://developers.google.com/maps/",test:function(e){return!(!e.google||!e.google.maps)&&{version:e.google.maps.version||UNKNOWN_VERSION}}},jQuery:{id:"jquery",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!!(t&&t.fn&&t.fn.jquery)&&{version:t.fn.jquery.replace(/[^\\d+\\.+]/g,"")||UNKNOWN_VERSION}}},"jQuery (Fast path)":{id:"jquery-fast",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.fn)&&{version:UNKNOWN_VERSION}}},"jQuery UI":{id:"jquery_ui",icon:"jquery_ui",url:"http://jqueryui.com",npm:"jquery-ui",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;if(t&&t.fn&&t.fn.jquery&&t.ui){for(var o="accordion,datepicker,dialog,draggable,droppable,progressbar,resizable,selectable,slider,menu,grid,tabs".split(","),n=[],r=0;r<o.length;r++)t.ui[o[r]]&&n.push(o[r].substr(0,1).toUpperCase()+o[r].substr(1));return{version:t.ui.version||UNKNOWN_VERSION,details:n.length?"Plugins used: "+n.join(","):""}}return!1}},Dojo:{id:"dojo",icon:"dojo",url:"http://dojotoolkit.org",npm:"dojo",test:function(e){return!(!e.dojo||!e.dojo.delegate)&&{version:e.dojo.version?e.dojo.version.toString():UNKNOWN_VERSION,details:"Details: "+(e.dijit?"Uses Dijit":"none")}}},Prototype:{id:"prototype",icon:"prototype",url:"http://prototypejs.org",test:function(e){return!(!e.Prototype||!e.Prototype.BrowserFeatures)&&{version:e.Prototype.Version||UNKNOWN_VERSION}}},Scriptaculous:{id:"scriptaculous",icon:"scriptaculous",url:"http://script.aculo.us",test:function(e){return!(!e.Scriptaculous||!e.Scriptaculous.load)&&{version:e.Scriptaculous.Version||UNKNOWN_VERSION}}},MooTools:{id:"mootools",icon:"mootools",url:"https://mootools.net/",test:function(e){return!(!e.MooTools||!e.MooTools.build)&&{version:e.MooTools.version||UNKNOWN_VERSION}}},Spry:{id:"spry",icon:"spry",url:"http://labs.adobe.com/technologies/spry",test:function(e){return!(!e.Spry||!e.Spry.Data)&&{version:UNKNOWN_VERSION}}},"YUI 2":{id:"yui",icon:"yui",url:"http://developer.yahoo.com/yui/2/",test:function(e){return!(!e.YAHOO||!e.YAHOO.util)&&{version:e.YAHOO.VERSION||UNKNOWN_VERSION}}},"YUI 3":{id:"yui3",icon:"yui3",url:"https://yuilibrary.com/",npm:"yui",test:function(e){return!(!e.YUI||!e.YUI.Env)&&{version:e.YUI.version||UNKNOWN_VERSION}}},Qooxdoo:{id:"qooxdoo",icon:"qooxdoo",url:"http://www.qooxdoo.org/",npm:"qooxdoo",test:function(e){return!(!e.qx||!e.qx.Bootstrap)&&{version:UNKNOWN_VERSION}}},"Ext JS":{id:"extjs",icon:"extjs",url:"https://www.sencha.com/products/extjs/",test:function(e){return e.Ext&&e.Ext.versions?{version:e.Ext.versions.core.version}:!!e.Ext&&{version:e.Ext.version||UNKNOWN_VERSION}}},Ezoic:{id:"ezoic",icon:"ezoic",url:"https://www.ezoic.com/",test:function(e){return!(!e.__ez||!e.__ez.template)&&{version:UNKNOWN_VERSION}}},base2:{id:"base2",icon:"base2",url:"http://code.google.com/p/base2",test:function(e){return!(!e.base2||!e.base2.dom)&&{version:e.base2.version||UNKNOWN_VERSION}}},"Closure Library":{id:"closure",icon:"closure",url:"https://developers.google.com/closure/library/",npm:"google-closure-library",test:function(e){return!(!e.goog||!e.goog.provide)&&{version:UNKNOWN_VERSION}}},"Rapha&euml;l":{id:"raphael",icon:"raphael",url:"http://dmitrybaranovskiy.github.io/raphael/",test:function(e){return!(!e.Raphael||!e.Raphael.circle)&&{version:e.Raphael.version||UNKNOWN_VERSION}}},React:{id:"react",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),n=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||null!=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return t(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()||o&&o.innerText.length>0||n||e.React&&e.React.Component)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"React (Fast path)":{id:"react-fast",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),n=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||o||n||e.React)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"Next.js":{id:"next",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!(!e.__NEXT_DATA__||!e.__NEXT_DATA__.buildId)&&{version:window.next&&window.next.version||UNKNOWN_VERSION}}},"Next.js (Fast path)":{id:"next-fast",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!!e.__NEXT_DATA__&&{version:UNKNOWN_VERSION}}},Preact:{id:"preact",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t="undefined"!=typeof Symbol&&Symbol.for&&Symbol.for("preactattr");function o(e){return"__k"in e&&"props"in e.__k&&"type"in e.__k||("_component"in e||"__preactattr_"in e||t&&null!=e[t])}function n(e){return null!=e&&o(e)&&e}var r=n(document.body)||n(document.body.firstElementChild);if(r||(r=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return o(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()),r||e.preact){var i=UNKNOWN_VERSION;return r&&("__k"in r&&(i="10"),"__preactattr_"in r&&(i="8"),t&&null!=r[t]&&(i="7")),{version:i}}return!1}},"Preact (Fast path)":{id:"preact-fast",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t=UNKNOWN_VERSION;function o(e){return null!=e&&function(e){return null!=e.__k?(t="10",!0):null!=e._component||null!=e.__preactattr_}(e)}return!(!o(document.body)&&!o(document.body.firstElementChild)&&!e.preact)&&{version:t}}},Modernizr:{id:"modernizr",icon:"modernizr",url:"https://modernizr.com/",npm:"modernizr",test:function(e){return!(!e.Modernizr||!e.Modernizr.addTest)&&{version:e.Modernizr._version||UNKNOWN_VERSION}}},"Processing.js":{id:"processingjs",icon:"processingjs",url:"http://processingjs.org",npm:"processing-js",test:function(e){return!(!e.Processing||!e.Processing.box)&&{version:Processing.version||UNKNOWN_VERSION}}},Backbone:{id:"backbone",icon:"backbone",url:"http://backbonejs.org/",npm:"backbone",test:function(e){return!(!e.Backbone||!e.Backbone.Model.extend)&&{version:e.Backbone.VERSION||UNKNOWN_VERSION}}},Leaflet:{id:"leaflet",icon:"leaflet",url:"http://leafletjs.com",npm:"leaflet",test:function(e){return!(!e.L||!e.L.GeoJSON||!e.L.marker&&!e.L.Marker)&&{version:e.L.version||e.L.VERSION||UNKNOWN_VERSION}}},Mapbox:{id:"mapbox",icon:"mapbox",url:"https://www.mapbox.com/",npm:"mapbox-gl",test:function(e){return!!(e.L&&e.L.mapbox&&e.L.mapbox.geocoder)&&{version:e.L.mapbox.VERSION||UNKNOWN_VERSION}}},"Lo-Dash":{id:"lodash",icon:"lodash",url:"https://lodash.com/",npm:"lodash",test:function(e){var t="function"==typeof(t=e._)&&t,o="function"==typeof(o=t&&t.chain)&&o,n=(o||t||function(){return{}})(1);return!(!t||!n.__wrapped__)&&{version:t.VERSION||UNKNOWN_VERSION}}},Underscore:{id:"underscore",icon:"underscore",url:"http://underscorejs.org/",npm:"underscore",test:function(e){return!(!e._||"function"!=typeof e._.tap||d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests["Lo-Dash"].test(e))&&{version:e._.VERSION||UNKNOWN_VERSION}}},Sammy:{id:"sammy",icon:"sammy",url:"http://sammyjs.org",test:function(e){return!(!e.Sammy||!e.Sammy.Application.curry)&&{version:e.Sammy.VERSION||UNKNOWN_VERSION}}},Rico:{id:"rico",icon:"rico",url:"http://openrico.sourceforge.net/examples/index.html",test:function(e){return!(!e.Rico||!window.Rico.checkIfComplete)&&{version:e.Rico.Version||UNKNOWN_VERSION}}},MochiKit:{id:"mochikit",icon:"mochikit",url:"https://mochi.github.io/mochikit/",test:function(e){return!(!e.MochiKit||!e.MochiKit.Base.module)&&{version:MochiKit.VERSION||UNKNOWN_VERSION}}},"gRapha&euml;l":{id:"graphael",icon:"graphael",url:"https://github.com/DmitryBaranovskiy/g.raphael",test:function(e){return!(!e.Raphael||!e.Raphael.fn.g)&&{version:UNKNOWN_VERSION}}},Glow:{id:"glow",icon:"glow",url:"http://www.bbc.co.uk/glow/",test:function(e){return e.gloader&&e.gloader.getRequests?{version:UNKNOWN_VERSION}:e.glow&&e.glow.dom?{version:e.glow.VERSION||UNKNOWN_VERSION}:!!e.Glow&&{version:e.Glow.version||UNKNOWN_VERSION}}},"Socket.IO":{id:"socketio",icon:"socketio",url:"https://socket.io/",npm:"socket.io",test:function(e){return!(!e.io||!e.io.sockets&&!e.io.Socket)&&{version:e.io.version||UNKNOWN_VERSION}}},Mustache:{id:"mustache",icon:"mustache",url:"http://mustache.github.io/",npm:"mustache",test:function(e){return!(!e.Mustache||!e.Mustache.to_html)&&{version:e.Mustache.version||UNKNOWN_VERSION}}},"Fabric.js":{id:"fabricjs",icon:"icon38",url:"http://fabricjs.com/",npm:"fabric",test:function(e){return!(!e.fabric||!e.fabric.util)&&{version:e.fabric.version||UNKNOWN_VERSION}}},FuseJS:{id:"fusejs",icon:"fusejs",url:"http://fusejs.io/",npm:"fuse.js",test:function(e){return!!e.Fuse&&{version:UNKNOWN_VERSION}}},"Tween.js":{id:"tweenjs",icon:"icon38",url:"https://github.com/tweenjs/tween.js",npm:"tween.js",test:function(e){return!(!e.TWEEN||!e.TWEEN.Easing)&&{version:UNKNOWN_VERSION}}},SproutCore:{id:"sproutcore",icon:"sproutcore",url:"http://sproutcore.com/",test:function(e){return!(!e.SC||!e.SC.Application)&&{version:UNKNOWN_VERSION}}},"Zepto.js":{id:"zepto",icon:"zepto",url:"http://zeptojs.com",npm:"zepto",test:function(e){return!(!e.Zepto||!e.Zepto.fn)&&{version:UNKNOWN_VERSION}}},"three.js":{id:"threejs",icon:"icon38",url:"https://threejs.org/",npm:"three",test:function(e){return e.THREE&&e.THREE.REVISION?{version:"r"+e.THREE.REVISION}:!!e.THREE&&{version:UNKNOWN_VERSION}}},PhiloGL:{id:"philogl",icon:"philogl",url:"http://www.senchalabs.org/philogl/",npm:"philogl",test:function(e){return!(!e.PhiloGL||!e.PhiloGL.Camera)&&{version:e.PhiloGL.version||UNKNOWN_VERSION}}},CamanJS:{id:"camanjs",icon:"camanjs",url:"http://camanjs.com/",npm:"caman",test:function(e){return e.Caman&&e.Caman.version?{version:e.Caman.version.release}:!!e.Caman&&{version:UNKNOWN_VERSION}}},yepnope:{id:"yepnope",icon:"yepnope",url:"http://yepnopejs.com/",test:function(e){return!(!e.yepnope||!e.yepnope.injectJs)&&{version:UNKNOWN_VERSION}}},LABjs:{id:"labjs",icon:"icon38",url:"https://github.com/getify/LABjs",test:function(e){return!(!e.$LAB||!e.$LAB.setOptions)&&{version:UNKNOWN_VERSION}}},"Head JS":{id:"headjs",icon:"headjs",url:"http://headjs.com/",npm:"headjs",test:function(e){return!(!e.head||!e.head.js)&&{version:UNKNOWN_VERSION}}},ControlJS:{id:"controljs",icon:"icon38",url:"http://stevesouders.com/controljs/",test:function(e){return!(!e.CJS||!e.CJS.start)&&{version:UNKNOWN_VERSION}}},RequireJS:{id:"requirejs",icon:"requirejs",url:"http://requirejs.org/",npm:"requirejs",test:function(e){var t=e.require||e.requirejs;return!(!t||!(t.load||t.s&&t.s.contexts&&t.s.contexts._&&(t.s.contexts._.loaded||t.s.contexts._.load)))&&{version:t.version||UNKNOWN_VERSION}}},RightJS:{id:"rightjs",icon:"rightjs",url:"http://rightjs.org/",test:function(e){return!(!e.RightJS||!e.RightJS.isNode)&&{version:e.RightJS.version||UNKNOWN_VERSION}}},"jQuery Tools":{id:"jquerytools",icon:"jquerytools",url:"http://jquerytools.github.io/",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.tools)&&{version:t.tools.version||UNKNOWN_VERSION}}},Pusher:{id:"pusher",icon:"pusher",url:"https://pusher.com/docs/",npm:"pusher-js",test:function(e){return!(!e.Pusher||!e.Pusher.Channel)&&{version:e.Pusher.VERSION||UNKNOWN_VERSION}}},"Paper.js":{id:"paperjs",icon:"paperjs",url:"http://paperjs.org/",npm:"paper",test:function(e){return!(!e.paper||!e.paper.Point)&&{version:e.paper.version||UNKNOWN_VERSION}}},Swiffy:{id:"swiffy",icon:"icon38",url:"https://developers.google.com/swiffy/",test:function(e){return!(!e.swiffy||!e.swiffy.Stage)&&{version:UNKNOWN_VERSION}}},Move:{id:"move",icon:"move",url:"https://github.com/rsms/move",npm:"move",test:function(e){return!(!e.move||!e.move.compile)&&{version:e.move.version()||UNKNOWN_VERSION}}},AmplifyJS:{id:"amplifyjs",icon:"amplifyjs",url:"http://amplifyjs.com/",npm:"amplifyjs",test:function(e){return!(!e.amplify||!e.amplify.publish)&&{version:UNKNOWN_VERSION}}},"Popcorn.js":{id:"popcornjs",icon:"popcornjs",url:"https://github.com/mozilla/popcorn-js/",test:function(e){return!(!e.Popcorn||!e.Popcorn.Events)&&{version:e.Popcorn.version||UNKNOWN_VERSION}}},D3:{id:"d3",icon:"d3",url:"https://d3js.org/",npm:"d3",test:function(e){return!(!e.d3||!e.d3.select)&&{version:e.d3.version||UNKNOWN_VERSION}}},Handlebars:{id:"handlebars",icon:"handlebars",url:"http://handlebarsjs.com/",npm:"handlebars",test:function(e){return!(!e.Handlebars||!e.Handlebars.compile)&&{version:e.Handlebars.VERSION||UNKNOWN_VERSION}}},Handsontable:{id:"handsontable",icon:"handsontable",url:"https://handsontable.com/",npm:"handsontable",test:function(e){return!(!e.Handsontable||!e.Handsontable.Core)&&{version:e.Handsontable.version||UNKNOWN_VERSION}}},Knockout:{id:"knockout",icon:"knockout",url:"http://knockoutjs.com/",npm:"knockout",test:function(e){return!(!e.ko||!e.ko.applyBindings)&&{version:e.ko.version||UNKNOWN_VERSION}}},Spine:{id:"spine",icon:"icon38",url:"http://spine.github.io/",test:function(e){return!(!e.Spine||!e.Spine.Controller)&&{version:e.Spine.version||UNKNOWN_VERSION}}},"jQuery Mobile":{id:"jquery-mobile",icon:"jquery_mobile",url:"http://jquerymobile.com/",npm:"jquery-mobile",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.mobile)&&{version:t.mobile.version||UNKNOWN_VERSION}}},"WebFont Loader":{id:"webfontloader",icon:"icon38",url:"https://github.com/typekit/webfontloader",npm:"webfontloader",test:function(e){return!(!e.WebFont||!e.WebFont.load)&&{version:UNKNOWN_VERSION}}},Angular:{id:"angular",icon:"angular",url:"https://angular.io/",npm:"@angular/core",test:function(e){var t=e.document.querySelector("[ng-version]");return t?{version:t.getAttribute("ng-version")||UNKNOWN_VERSION}:!!(e.ng&&e.ng.probe instanceof Function)&&{version:UNKNOWN_VERSION}}},AngularJS:{id:"angularjs",icon:"angularjs",url:"https://angularjs.org/",npm:"angular",test:function(e){var t=e.angular;return!!(t&&t.version&&t.version.full)&&{version:t.version.full}}},Ionic:{id:"ionic",icon:"ionic",url:"https://ionicframework.com/",npm:"@ionic/cli",test:function(e){var t=e.document.querySelector("ion-app");return!(!t||"ION-APP"!==t.nodeName)&&{version:UNKNOWN_VERSION}}},"Ember.js":{id:"emberjs",icon:"emberjs",url:"https://emberjs.com/",npm:"ember-source",test:function(e){var t=e.Ember||e.Em;return!(!t||!t.GUID_KEY)&&{version:t.VERSION||UNKNOWN_VERSION}}},"Hammer.js":{id:"hammerjs",icon:"hammerjs",url:"http://eightmedia.github.io/hammer.js/",npm:"hammerjs",test:function(e){return!(!e.Hammer||!e.Hammer.Pinch)&&{version:e.Hammer.VERSION||"&lt; 1.0.10"}}},"Visibility.js":{id:"visibilityjs",icon:"icon38",url:"https://github.com/ai/visibilityjs",npm:"visibilityjs",test:function(e){return!(!e.Visibility||!e.Visibility.every)&&{version:UNKNOWN_VERSION}}},"Velocity.js":{id:"velocityjs",icon:"icon38",url:"http://velocityjs.org/",npm:"velocity-animate",test:function(e){var t=e.jQuery||e.$,o=t?t.Velocity:e.Velocity;return o&&o.RegisterEffect&&o.version?{version:o.version.major+"."+o.version.minor+"."+o.version.patch}:!(!o||!o.RegisterEffect)&&{version:UNKNOWN_VERSION}}},"IfVisible.js":{id:"ifvisiblejs",icon:"icon38",url:"http://serkanyersen.github.io/ifvisible.js/",npm:"ifvisible.js",test:function(e){var t=e.ifvisible;return!(!t||"ifvisible.object.event.identifier"!==t.__ceGUID)&&{version:UNKNOWN_VERSION}}},"Pixi.js":{id:"pixi",icon:"pixi",url:"http://www.pixijs.com/",npm:"pixi.js",test:function(e){var t=e.PIXI;return!!(t&&t.WebGLRenderer&&t.VERSION)&&{version:t.VERSION.replace("v","")||UNKNOWN_VERSION}}},"DC.js":{id:"dcjs",icon:"dcjs",url:"http://dc-js.github.io/dc.js/",npm:"dc",test:function(e){var t=e.dc;return!(!t||!t.registerChart)&&{version:t.version||UNKNOWN_VERSION}}},"GreenSock JS":{id:"greensock",icon:"greensock",url:"https://greensock.com/gsap",npm:"gsap",test:function(e){return!(!e.TweenMax||!e.TweenMax.pauseAll)&&{version:e.TweenMax.version||UNKNOWN_VERSION}}},FastClick:{id:"fastclick",icon:"fastclick",url:"https://github.com/ftlabs/fastclick",npm:"fastclick",test:function(e){return!(!e.FastClick||!e.FastClick.notNeeded)&&{version:UNKNOWN_VERSION}}},Isotope:{id:"isotope",icon:"isotope",url:"https://isotope.metafizzy.co/",npm:"isotope-layout",test:function(e){return!!(e.Isotope||null!=e.$&&e.$.Isotope)&&{version:UNKNOWN_VERSION}}},Marionette:{id:"marionette",icon:"marionette",url:"https://marionettejs.com/",npm:"backbone.marionette",test:function(e){return!(!e.Marionette||!e.Marionette.Application)&&{version:e.Marionette.VERSION||UNKNOWN_VERSION}}},Can:{id:"canjs",icon:"canjs",url:"https://canjs.com/",npm:"can",test:function(e){return!(!e.can||!e.can.Construct)&&{version:e.can.VERSION||UNKNOWN_VERSION}}},Vue:{id:"vue",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!(null===document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return null!=e.__vue__?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()&&!e.Vue)&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Vue (Fast path)":{id:"vue-fast",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!!e.Vue&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Nuxt.js":{id:"nuxt",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!!(e.__NUXT__||e.$nuxt||[...e.document.querySelectorAll("*")].some((e=>e.__vue__?.nuxt)))&&{version:UNKNOWN_VERSION}}},"Nuxt.js (Fast path)":{id:"nuxt-fast",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!(!e.__NUXT__&&!e.$nuxt)&&{version:UNKNOWN_VERSION}}},Two:{id:"two",icon:"two",url:"https://two.js.org/",npm:"two.js",test:function(e){return!(!e.Two||!e.Two.Utils)&&{version:e.Two.Version||UNKNOWN_VERSION}}},Brewser:{id:"brewser",icon:"brewser",url:"https://robertpataki.github.io/brewser/",npm:"brewser",test:function(e){return!(!e.BREWSER||!e.BREWSER.ua)&&{version:BREWSER.VERSION||UNKNOWN_VERSION}}},"Material Design Lite":{id:"materialdesignlite",icon:"mdl",url:"https://getmdl.io/",npm:"material-design-lite",test:function(e){return!(!e.componentHandler||!e.componentHandler.upgradeElement)&&{version:UNKNOWN_VERSION}}},"Kendo UI":{id:"kendoui",icon:"kendoui",url:"https://github.com/telerik/kendo-ui-core",npm:"kendo-ui-core",test:function(e){return!!(e.kendo&&e.kendo.View&&e.kendo.View.extend)&&{version:e.kendo.version||UNKNOWN_VERSION}}},"Matter.js":{id:"matterjs",icon:"matter-js",url:"http://brm.io/matter-js/",npm:"matter-js",test:function(e){return!(!e.Matter||!e.Matter.Engine)&&{version:UNKNOWN_VERSION}}},Riot:{id:"riot",icon:"riot",url:"http://riotjs.com/",npm:"riot",test:function(e){return!(!e.riot||!e.riot.mixin)&&{version:e.riot.version||UNKNOWN_VERSION}}},"Sea.js":{id:"seajs",icon:"icon38",url:"https://seajs.github.io/seajs/docs/",npm:"seajs",test:function(e){return!(!e.seajs||!e.seajs.use)&&{version:e.seajs.version||UNKNOWN_VERSION}}},"Moment.js":{id:"momentjs",icon:"momentjs",url:"http://momentjs.com/",npm:"moment",test:function(e){return!(!e.moment||!e.moment.isMoment&&!e.moment.lang)&&{version:e.moment.version||UNKNOWN_VERSION}}},"Moment Timezone":{id:"moment-timezone",icon:"momentjs",url:"http://momentjs.com/timezone/",npm:"moment-timezone",test:function(e){return!(!e.moment||!e.moment.tz)&&{version:e.moment.tz.version||UNKNOWN_VERSION}}},ScrollMagic:{id:"scrollmagic",icon:"scrollmagic",url:"http://scrollmagic.io/",npm:"scrollmagic",test:function(e){return!(!e.ScrollMagic||!e.ScrollMagic.Controller)&&{version:ScrollMagic.version||UNKNOWN_VERSION}}},SWFObject:{id:"swfobject",icon:"icon38",url:"https://github.com/swfobject/swfobject",test:function(e){return e.swfobject&&e.swfobject.embedSWF?{version:e.swfobject.version||UNKNOWN_VERSION}:!(!e.deconcept||!e.deconcept.SWFObject)&&{version:UNKNOWN_VERSION}}},FlexSlider:{id:"flexslider",icon:"icon38",url:"https://woocommerce.com/flexslider/",npm:"flexslider",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.flexslider)&&{version:UNKNOWN_VERSION}}},SPF:{id:"spf",icon:"icon38",url:"https://youtube.github.io/spfjs/",npm:"spf",test:function(e){return!(!e.spf||!e.spf.init)&&{version:UNKNOWN_VERSION}}},"Numeral.js":{id:"numeraljs",icon:"icon38",url:"http://numeraljs.com/",npm:"numeraljs",test:function(e){return!(!e.numeral||!e.isNumeral)&&{version:e.numeral.version||UNKNOWN_VERSION}}},"boomerang.js":{id:"boomerangjs",icon:"icon38",url:"https://soasta.github.io/boomerang/",npm:"boomerangjs",test:function(e){return!!(e.BOOMR&&e.BOOMR.utils&&e.BOOMR.init)&&{version:e.BOOMR.version||UNKNOWN_VERSION}}},Framer:{id:"framer",icon:"framer",url:"https://framer.com/",npm:"framerjs",test:function(e){return!(!e.Framer||!e.Framer.Layer)&&{version:e.Framer.Version.build||UNKNOWN_VERSION}}},Marko:{id:"marko",icon:"marko",url:"https://markojs.com/",npm:"marko",test:function(e){return!!document.querySelector("[data-marko-key], [data-marko]")&&{version:UNKNOWN_VERSION}}},AMP:{id:"amp",icon:"amp",url:"https://amp.dev/",npm:"https://www.npmjs.com/org/ampproject",test:function(e){var t=e.document.documentElement.getAttribute("amp-version");return!!t&&{version:t}}},Gatsby:{id:"gatsby",icon:"gatsby",url:"https://www.gatsbyjs.org/",npm:"gatsby",test:function(e){return!!document.getElementById("___gatsby")&&{version:UNKNOWN_VERSION}}},Shopify:{id:"shopify",icon:"shopify",url:"https://www.shopify.com/",npm:null,test:function(e){return!(!e.Shopify||!e.Shopify.shop)&&{version:UNKNOWN_VERSION}}},Magento:{id:"magento",icon:"magento",url:"https://magento.com/",npm:null,test:function(e){const t=/\\/static(?:\\/version\\d+)?\\/frontend\\/.+\\/.+\\/requirejs\\/require(?:\\.min)?\\.js/;return!!Array.from(document.querySelectorAll("script[src]")||[]).some((e=>t.test(e.src)))&&{version:2}}},WordPress:{id:"wordpress",icon:"wordpress",url:"https://wordpress.org/",npm:null,test:function(e){const t=!!document.querySelector(\'link[rel="https://api.w.org/"]\'),o=!!document.querySelectorAll(\'link[href*="wp-includes"], script[src*="wp-includes"]\').length;if(!t&&!o)return!1;const n=document.querySelector(\'meta[name=generator][content^="WordPress"]\');return{version:n?n.getAttribute("content").replace(/^\\w+\\s/,""):UNKNOWN_VERSION}}},Wix:{id:"wix",icon:"wix",url:"https://www.wix.com/",npm:null,test:function(e){return(e.wixPerformanceMeasurements&&e.wixPerformanceMeasurements.info||!(!e.wixBiSession||!e.wixBiSession.info))&&{version:UNKNOWN_VERSION}}},Workbox:{id:"workbox",icon:"workbox",url:"https://developers.google.com/web/tools/workbox/",npm:"workbox-sw",test:async function(e){var t=e.navigator;if(!("serviceWorker"in t))return!1;const{timeoutPromise:o,clearTimeout:n}=_createTimeoutHelper(),r=t.serviceWorker.getRegistration().then((function(e){var o=t.serviceWorker.controller?t.serviceWorker.controller.scriptURL:e.active.scriptURL;return fetch(o,{credentials:"include",headers:{"service-worker":"script"}}).then((function(e){return e.text()})).then((function(e){if(/new Workbox|new workbox|workbox\\.precaching\\.|workbox\\.strategies/gm.test(e)){var t=/workbox.*?\\b((0|[1-9]\\d*)\\.(0|[1-9]\\d*)\\.(0|[1-9]\\d*)(-(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*)(\\.(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*))*)?(\\+[0-9a-zA-Z-]+(\\.[0-9a-zA-Z-]+)*)?)\\b/gim.exec(e),o=UNKNOWN_VERSION;return Array.isArray(t)&&t.length>1&&t[1]&&(o=t[1]),{version:o}}return!1}))})).catch((function(e){return!1}));return Promise.race([r,o]).catch((function(e){return!1})).finally((e=>(n(),e)))}},Boq:{id:"boq",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/143",npm:null,test:function(e){return!!e.WIZ_global_data&&{version:UNKNOWN_VERSION}}},Wiz:{id:"wiz",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/147",npm:null,test:function(e){return!!document.__wizdispatcher&&{version:UNKNOWN_VERSION}}},"core-js":{id:"corejs",icon:"icon38",url:"https://github.com/zloirock/core-js",npm:"core-js",test:function(e){const t=e["__core-js_shared__"],o=e.core;if(t){const e=t.versions;return{version:Array.isArray(e)?e.map((e=>`core-js-${e.mode}@${e.version}`)).join("; "):UNKNOWN_VERSION}}return!!o&&{version:o.version||UNKNOWN_VERSION}}},Drupal:{id:"drupal",icon:"drupal",url:"https://www.drupal.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="Drupal"]\'),o=t?t.getAttribute("content").replace(/\\D+/gi,""):UNKNOWN_VERSION,n=/\\/sites\\/(?:default|all)\\/(?:themes|modules|files)/,r=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(r.some((e=>n.test(e.src)))||r.some((e=>n.test(e.href)))||t||e.Drupal&&e.Drupal.behaviors)&&{version:o}}},TYPO3:{id:"typo3",icon:"typo3",url:"https://typo3.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="TYPO3"]\'),o=/\\/(typo3conf|typo3temp|fileadmin)/,n=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||n.some((e=>o.test(e.src)))||n.some((e=>o.test(e.href))))&&{version:UNKNOWN_VERSION}}},"Create React App":{id:"create-react-app",icon:"cra",url:"https://create-react-app.dev/",npm:"react-scripts",test:function(e){let t,o,n=e.document.body.firstElementChild;do{"noscript"===n.localName?t=n:"root"===n.id&&(o=n)}while(n=n.nextElementSibling);return!!(o&&t&&/You need to enable JavaScript to run this app/.test(t.textContent))&&{version:UNKNOWN_VERSION}}},"Guess.js":{id:"guessjs",icon:"guessjs",url:"https://guess-js.github.io/",test:function(e){return!(!e.__GUESS__||!e.__GUESS__.guess)&&{version:UNKNOWN_VERSION}}},"October CMS":{id:"octobercms",icon:"october",url:"https://octobercms.com/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="OctoberCMS"]\'),o=document.querySelector(\'meta[name="generator"][content^="October CMS"]\'),n=/\\/modules\\/system\\/assets\\/(css|js)\\/framework(\\.extras|\\.combined)?(-min)?/,r=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||o||r.some((e=>n.test(e.src||e.href))))&&{version:UNKNOWN_VERSION}}},Joomla:{id:"joomla",icon:"joomla",url:"https://www.joomla.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name=generator][content^="Joomla"]\'),o=!!document.querySelectorAll(\'script[src*="/media/jui/js/bootstrap.min.js"]\').length;return t?{version:t.getAttribute("content").replace(/^\\w+\\s/,"")}:!(!e.Joomla&&!o)&&{version:UNKNOWN_VERSION}}},Sugar:{id:"sugar",icon:"sugar",url:"https://sugarjs.com",npm:"sugar",test:function(e){return e.Sugar?{version:e.Sugar.VERSION||UNKNOWN_VERSION}:!!e.Array.SugarMethods&&{version:UNKNOWN_VERSION}}},Bento:{id:"bentojs",icon:"bentojs",url:"https://bentojs.dev",npm:"https://www.npmjs.com/org/bentoproject",test:function(e){return!(!e.BENTO||!e.BENTO.push)&&{version:UNKNOWN_VERSION}}},"WP Rocket":{id:"wp-rocket",icon:"wp-rocket",url:"https://wp-rocket.me/",npm:null,test:async function(e){const t="undefined"!=typeof RocketLazyLoadScripts||"undefined"!=typeof RocketPreloadLinksConfig||"undefined"!=typeof rocket_lazy,o=!!document.querySelector("style#wpr-usedcss"),n=document.lastChild.nodeType===Node.COMMENT_NODE&&document.lastChild.textContent.includes("WP Rocket");return!!(o||t||n)&&{version:UNKNOWN_VERSION}}},NitroPack:{id:"nitropack",icon:"nitropack",url:"https://nitropack.io/",npm:null,test:async function(e){return!!document.querySelector(\'meta[name="generator"][content="NitroPack"]\')&&{version:UNKNOWN_VERSION}}},Remix:{id:"remix",icon:"remix",url:"https://remix.run/",npm:"remix",test:function(e){return!!e.__remixContext&&{version:UNKNOWN_VERSION}}}};',o(eD,"detectLibraries"),tD=class e extends Jt{static{o(this,"Stacks")}constructor(){super(),this.meta={supportedModes:["snapshot","navigation"]}}static async collectStacks(e){let t={msg:"Collect stacks",id:"lh:gather:collectStacks"};Kt.time(t);let a=(await e.evaluate(eD,{args:[],deps:['function _createTimeoutHelper(){let e;return{timeoutPromise:new Promise(((t,o)=>{e=setTimeout((()=>o(new Error("Timed out"))),5e3)})),clearTimeout:()=>clearTimeout(e)}}var UNKNOWN_VERSION=null,d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests={GWT:{id:"gwt",icon:"gwt",url:"http://www.gwtproject.org/",test:function(e){var t=e.document,o=t.getElementById("__gwt_historyFrame"),n=t.gwt_uid,r=t.body.__listener,i=t.body.__eventBits,s=e.__gwt_activeModules,c=e.__gwt_jsonp__,u=e.__gwt_scriptsLoaded||e.__gwt_stylesLoaded||e.__gwt_activeModules;if(o||n||r||i||s||c||u){for(var a=t.getElementsByTagName("iframe"),l=UNKNOWN_VERSION,N=0;N<a.length;N++)try{if(a[N].tabIndex<0&&a[N].contentWindow&&a[N].contentWindow.$gwt_version){l=a[N].contentWindow.$gwt_version;break}}catch(e){}return"0.0.999"==l&&(l="Google Internal"),{version:l}}return!1}},Ink:{id:"ink",icon:"ink",url:"http://ink.sapo.pt/",test:function(e){return!(!e.Ink||!e.Ink.createModule)&&{version:UNKNOWN_VERSION}}},Vaadin:{id:"vaadin",icon:"vaadin",url:"https://vaadin.com/",test:function(e){return!(!e.vaadin||!e.vaadin.registerWidgetset)&&{version:UNKNOWN_VERSION}}},Bootstrap:{id:"bootstrap",icon:"bootstrap",url:"http://getbootstrap.com/",npm:"bootstrap",test:function(e){var t,o=e.$&&e.$.fn;if(o&&(["affix","alert","button","carousel","collapse","dropdown","modal","popover","scrollspy","tab","tooltip"].some((function(o){if(e.$.fn[o]){if(e.$.fn[o].Constructor&&e.$.fn[o].Constructor.VERSION)return t=e.$.fn[o].Constructor.VERSION,!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:\'|\\")(?:bs\\\\.){1}"+o).test(e.$.fn[o].toString()))return t=">= 3.0.0 & <= 3.1.1",!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:\'|\\")"+o).test(e.$.fn[o].toString()))return t=">= 2.0.0 & <= 2.3.2",!0}return!1})),t))return{version:t};return!1}},Zurb:{id:"zurb",icon:"zurb",url:"https://foundation.zurb.com/",npm:"foundation-sites",test:function(e){return!(!e.Foundation||!e.Foundation.Toggler)&&{version:e.Foundation.version||UNKNOWN_VERSION}}},Polymer:{id:"polymer",icon:"polymer",url:"https://www.polymer-project.org/",npm:"@polymer/polymer",test:function(e){return!(!e.Polymer||!e.Polymer.dom)&&{version:e.Polymer.version||UNKNOWN_VERSION}}},LitElement:{id:"litelement",icon:"polymer",url:"https://lit-element.polymer-project.org/",npm:"lit-element",test:function(e){if(e.litElementVersions&&e.litElementVersions.length){var t=[...e.litElementVersions].sort(((e,t)=>e.localeCompare(t,void 0,{numeric:!0})));return{version:t[t.length-1]}}return!1}},"lit-html":{id:"lit-html",icon:"polymer",url:"https://lit-html.polymer-project.org/",npm:"lit-element",test:function(e){if(e.litHtmlVersions&&e.litHtmlVersions.length){var t=[...e.litHtmlVersions].sort(((e,t)=>e.localeCompare(t,void 0,{numeric:!0})));return{version:t[t.length-1]}}return!1}},Highcharts:{id:"highcharts",icon:"highcharts",url:"http://www.highcharts.com",npm:"highcharts",test:function(e){return!(!e.Highcharts||!e.Highcharts.Point)&&{version:e.Highcharts.version||UNKNOWN_VERSION}}},InfoVis:{id:"jit",icon:"jit",url:"http://philogb.github.com/jit/",test:function(e){return!(!e.$jit||!e.$jit.PieChart)&&{version:e.$jit.version||UNKNOWN_VERSION}}},FlotCharts:{id:"flotcharts",icon:"flotcharts",url:"http://www.flotcharts.org/",npm:"flot",test:function(e){return!(!e.$||!e.$.plot)&&{version:e.$.plot.version||UNKNOWN_VERSION}}},CreateJS:{id:"createjs",icon:"createjs",url:"https://createjs.com/",npm:"createjs",test:function(e){return!(!e.createjs||!e.createjs.promote)&&{version:UNKNOWN_VERSION}}},"Google Maps":{id:"gmaps",icon:"gmaps",url:"https://developers.google.com/maps/",test:function(e){return!(!e.google||!e.google.maps)&&{version:e.google.maps.version||UNKNOWN_VERSION}}},jQuery:{id:"jquery",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!!(t&&t.fn&&t.fn.jquery)&&{version:t.fn.jquery.replace(/[^\\d+\\.+]/g,"")||UNKNOWN_VERSION}}},"jQuery (Fast path)":{id:"jquery-fast",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.fn)&&{version:UNKNOWN_VERSION}}},"jQuery UI":{id:"jquery_ui",icon:"jquery_ui",url:"http://jqueryui.com",npm:"jquery-ui",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;if(t&&t.fn&&t.fn.jquery&&t.ui){for(var o="accordion,datepicker,dialog,draggable,droppable,progressbar,resizable,selectable,slider,menu,grid,tabs".split(","),n=[],r=0;r<o.length;r++)t.ui[o[r]]&&n.push(o[r].substr(0,1).toUpperCase()+o[r].substr(1));return{version:t.ui.version||UNKNOWN_VERSION,details:n.length?"Plugins used: "+n.join(","):""}}return!1}},Dojo:{id:"dojo",icon:"dojo",url:"http://dojotoolkit.org",npm:"dojo",test:function(e){return!(!e.dojo||!e.dojo.delegate)&&{version:e.dojo.version?e.dojo.version.toString():UNKNOWN_VERSION,details:"Details: "+(e.dijit?"Uses Dijit":"none")}}},Prototype:{id:"prototype",icon:"prototype",url:"http://prototypejs.org",test:function(e){return!(!e.Prototype||!e.Prototype.BrowserFeatures)&&{version:e.Prototype.Version||UNKNOWN_VERSION}}},Scriptaculous:{id:"scriptaculous",icon:"scriptaculous",url:"http://script.aculo.us",test:function(e){return!(!e.Scriptaculous||!e.Scriptaculous.load)&&{version:e.Scriptaculous.Version||UNKNOWN_VERSION}}},MooTools:{id:"mootools",icon:"mootools",url:"https://mootools.net/",test:function(e){return!(!e.MooTools||!e.MooTools.build)&&{version:e.MooTools.version||UNKNOWN_VERSION}}},Spry:{id:"spry",icon:"spry",url:"http://labs.adobe.com/technologies/spry",test:function(e){return!(!e.Spry||!e.Spry.Data)&&{version:UNKNOWN_VERSION}}},"YUI 2":{id:"yui",icon:"yui",url:"http://developer.yahoo.com/yui/2/",test:function(e){return!(!e.YAHOO||!e.YAHOO.util)&&{version:e.YAHOO.VERSION||UNKNOWN_VERSION}}},"YUI 3":{id:"yui3",icon:"yui3",url:"https://yuilibrary.com/",npm:"yui",test:function(e){return!(!e.YUI||!e.YUI.Env)&&{version:e.YUI.version||UNKNOWN_VERSION}}},Qooxdoo:{id:"qooxdoo",icon:"qooxdoo",url:"http://www.qooxdoo.org/",npm:"qooxdoo",test:function(e){return!(!e.qx||!e.qx.Bootstrap)&&{version:UNKNOWN_VERSION}}},"Ext JS":{id:"extjs",icon:"extjs",url:"https://www.sencha.com/products/extjs/",test:function(e){return e.Ext&&e.Ext.versions?{version:e.Ext.versions.core.version}:!!e.Ext&&{version:e.Ext.version||UNKNOWN_VERSION}}},Ezoic:{id:"ezoic",icon:"ezoic",url:"https://www.ezoic.com/",test:function(e){return!(!e.__ez||!e.__ez.template)&&{version:UNKNOWN_VERSION}}},base2:{id:"base2",icon:"base2",url:"http://code.google.com/p/base2",test:function(e){return!(!e.base2||!e.base2.dom)&&{version:e.base2.version||UNKNOWN_VERSION}}},"Closure Library":{id:"closure",icon:"closure",url:"https://developers.google.com/closure/library/",npm:"google-closure-library",test:function(e){return!(!e.goog||!e.goog.provide)&&{version:UNKNOWN_VERSION}}},"Rapha&euml;l":{id:"raphael",icon:"raphael",url:"http://dmitrybaranovskiy.github.io/raphael/",test:function(e){return!(!e.Raphael||!e.Raphael.circle)&&{version:e.Raphael.version||UNKNOWN_VERSION}}},React:{id:"react",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),n=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||null!=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return t(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()||o&&o.innerText.length>0||n||e.React&&e.React.Component)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"React (Fast path)":{id:"react-fast",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),n=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||o||n||e.React)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"Next.js":{id:"next",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!(!e.__NEXT_DATA__||!e.__NEXT_DATA__.buildId)&&{version:window.next&&window.next.version||UNKNOWN_VERSION}}},"Next.js (Fast path)":{id:"next-fast",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!!e.__NEXT_DATA__&&{version:UNKNOWN_VERSION}}},Preact:{id:"preact",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t="undefined"!=typeof Symbol&&Symbol.for&&Symbol.for("preactattr");function o(e){return"__k"in e&&"props"in e.__k&&"type"in e.__k||("_component"in e||"__preactattr_"in e||t&&null!=e[t])}function n(e){return null!=e&&o(e)&&e}var r=n(document.body)||n(document.body.firstElementChild);if(r||(r=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return o(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()),r||e.preact){var i=UNKNOWN_VERSION;return r&&("__k"in r&&(i="10"),"__preactattr_"in r&&(i="8"),t&&null!=r[t]&&(i="7")),{version:i}}return!1}},"Preact (Fast path)":{id:"preact-fast",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t=UNKNOWN_VERSION;function o(e){return null!=e&&function(e){return null!=e.__k?(t="10",!0):null!=e._component||null!=e.__preactattr_}(e)}return!(!o(document.body)&&!o(document.body.firstElementChild)&&!e.preact)&&{version:t}}},Modernizr:{id:"modernizr",icon:"modernizr",url:"https://modernizr.com/",npm:"modernizr",test:function(e){return!(!e.Modernizr||!e.Modernizr.addTest)&&{version:e.Modernizr._version||UNKNOWN_VERSION}}},"Processing.js":{id:"processingjs",icon:"processingjs",url:"http://processingjs.org",npm:"processing-js",test:function(e){return!(!e.Processing||!e.Processing.box)&&{version:Processing.version||UNKNOWN_VERSION}}},Backbone:{id:"backbone",icon:"backbone",url:"http://backbonejs.org/",npm:"backbone",test:function(e){return!(!e.Backbone||!e.Backbone.Model.extend)&&{version:e.Backbone.VERSION||UNKNOWN_VERSION}}},Leaflet:{id:"leaflet",icon:"leaflet",url:"http://leafletjs.com",npm:"leaflet",test:function(e){return!(!e.L||!e.L.GeoJSON||!e.L.marker&&!e.L.Marker)&&{version:e.L.version||e.L.VERSION||UNKNOWN_VERSION}}},Mapbox:{id:"mapbox",icon:"mapbox",url:"https://www.mapbox.com/",npm:"mapbox-gl",test:function(e){return!!(e.L&&e.L.mapbox&&e.L.mapbox.geocoder)&&{version:e.L.mapbox.VERSION||UNKNOWN_VERSION}}},"Lo-Dash":{id:"lodash",icon:"lodash",url:"https://lodash.com/",npm:"lodash",test:function(e){var t="function"==typeof(t=e._)&&t,o="function"==typeof(o=t&&t.chain)&&o,n=(o||t||function(){return{}})(1);return!(!t||!n.__wrapped__)&&{version:t.VERSION||UNKNOWN_VERSION}}},Underscore:{id:"underscore",icon:"underscore",url:"http://underscorejs.org/",npm:"underscore",test:function(e){return!(!e._||"function"!=typeof e._.tap||d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests["Lo-Dash"].test(e))&&{version:e._.VERSION||UNKNOWN_VERSION}}},Sammy:{id:"sammy",icon:"sammy",url:"http://sammyjs.org",test:function(e){return!(!e.Sammy||!e.Sammy.Application.curry)&&{version:e.Sammy.VERSION||UNKNOWN_VERSION}}},Rico:{id:"rico",icon:"rico",url:"http://openrico.sourceforge.net/examples/index.html",test:function(e){return!(!e.Rico||!window.Rico.checkIfComplete)&&{version:e.Rico.Version||UNKNOWN_VERSION}}},MochiKit:{id:"mochikit",icon:"mochikit",url:"https://mochi.github.io/mochikit/",test:function(e){return!(!e.MochiKit||!e.MochiKit.Base.module)&&{version:MochiKit.VERSION||UNKNOWN_VERSION}}},"gRapha&euml;l":{id:"graphael",icon:"graphael",url:"https://github.com/DmitryBaranovskiy/g.raphael",test:function(e){return!(!e.Raphael||!e.Raphael.fn.g)&&{version:UNKNOWN_VERSION}}},Glow:{id:"glow",icon:"glow",url:"http://www.bbc.co.uk/glow/",test:function(e){return e.gloader&&e.gloader.getRequests?{version:UNKNOWN_VERSION}:e.glow&&e.glow.dom?{version:e.glow.VERSION||UNKNOWN_VERSION}:!!e.Glow&&{version:e.Glow.version||UNKNOWN_VERSION}}},"Socket.IO":{id:"socketio",icon:"socketio",url:"https://socket.io/",npm:"socket.io",test:function(e){return!(!e.io||!e.io.sockets&&!e.io.Socket)&&{version:e.io.version||UNKNOWN_VERSION}}},Mustache:{id:"mustache",icon:"mustache",url:"http://mustache.github.io/",npm:"mustache",test:function(e){return!(!e.Mustache||!e.Mustache.to_html)&&{version:e.Mustache.version||UNKNOWN_VERSION}}},"Fabric.js":{id:"fabricjs",icon:"icon38",url:"http://fabricjs.com/",npm:"fabric",test:function(e){return!(!e.fabric||!e.fabric.util)&&{version:e.fabric.version||UNKNOWN_VERSION}}},FuseJS:{id:"fusejs",icon:"fusejs",url:"http://fusejs.io/",npm:"fuse.js",test:function(e){return!!e.Fuse&&{version:UNKNOWN_VERSION}}},"Tween.js":{id:"tweenjs",icon:"icon38",url:"https://github.com/tweenjs/tween.js",npm:"tween.js",test:function(e){return!(!e.TWEEN||!e.TWEEN.Easing)&&{version:UNKNOWN_VERSION}}},SproutCore:{id:"sproutcore",icon:"sproutcore",url:"http://sproutcore.com/",test:function(e){return!(!e.SC||!e.SC.Application)&&{version:UNKNOWN_VERSION}}},"Zepto.js":{id:"zepto",icon:"zepto",url:"http://zeptojs.com",npm:"zepto",test:function(e){return!(!e.Zepto||!e.Zepto.fn)&&{version:UNKNOWN_VERSION}}},"three.js":{id:"threejs",icon:"icon38",url:"https://threejs.org/",npm:"three",test:function(e){return e.THREE&&e.THREE.REVISION?{version:"r"+e.THREE.REVISION}:!!e.THREE&&{version:UNKNOWN_VERSION}}},PhiloGL:{id:"philogl",icon:"philogl",url:"http://www.senchalabs.org/philogl/",npm:"philogl",test:function(e){return!(!e.PhiloGL||!e.PhiloGL.Camera)&&{version:e.PhiloGL.version||UNKNOWN_VERSION}}},CamanJS:{id:"camanjs",icon:"camanjs",url:"http://camanjs.com/",npm:"caman",test:function(e){return e.Caman&&e.Caman.version?{version:e.Caman.version.release}:!!e.Caman&&{version:UNKNOWN_VERSION}}},yepnope:{id:"yepnope",icon:"yepnope",url:"http://yepnopejs.com/",test:function(e){return!(!e.yepnope||!e.yepnope.injectJs)&&{version:UNKNOWN_VERSION}}},LABjs:{id:"labjs",icon:"icon38",url:"https://github.com/getify/LABjs",test:function(e){return!(!e.$LAB||!e.$LAB.setOptions)&&{version:UNKNOWN_VERSION}}},"Head JS":{id:"headjs",icon:"headjs",url:"http://headjs.com/",npm:"headjs",test:function(e){return!(!e.head||!e.head.js)&&{version:UNKNOWN_VERSION}}},ControlJS:{id:"controljs",icon:"icon38",url:"http://stevesouders.com/controljs/",test:function(e){return!(!e.CJS||!e.CJS.start)&&{version:UNKNOWN_VERSION}}},RequireJS:{id:"requirejs",icon:"requirejs",url:"http://requirejs.org/",npm:"requirejs",test:function(e){var t=e.require||e.requirejs;return!(!t||!(t.load||t.s&&t.s.contexts&&t.s.contexts._&&(t.s.contexts._.loaded||t.s.contexts._.load)))&&{version:t.version||UNKNOWN_VERSION}}},RightJS:{id:"rightjs",icon:"rightjs",url:"http://rightjs.org/",test:function(e){return!(!e.RightJS||!e.RightJS.isNode)&&{version:e.RightJS.version||UNKNOWN_VERSION}}},"jQuery Tools":{id:"jquerytools",icon:"jquerytools",url:"http://jquerytools.github.io/",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.tools)&&{version:t.tools.version||UNKNOWN_VERSION}}},Pusher:{id:"pusher",icon:"pusher",url:"https://pusher.com/docs/",npm:"pusher-js",test:function(e){return!(!e.Pusher||!e.Pusher.Channel)&&{version:e.Pusher.VERSION||UNKNOWN_VERSION}}},"Paper.js":{id:"paperjs",icon:"paperjs",url:"http://paperjs.org/",npm:"paper",test:function(e){return!(!e.paper||!e.paper.Point)&&{version:e.paper.version||UNKNOWN_VERSION}}},Swiffy:{id:"swiffy",icon:"icon38",url:"https://developers.google.com/swiffy/",test:function(e){return!(!e.swiffy||!e.swiffy.Stage)&&{version:UNKNOWN_VERSION}}},Move:{id:"move",icon:"move",url:"https://github.com/rsms/move",npm:"move",test:function(e){return!(!e.move||!e.move.compile)&&{version:e.move.version()||UNKNOWN_VERSION}}},AmplifyJS:{id:"amplifyjs",icon:"amplifyjs",url:"http://amplifyjs.com/",npm:"amplifyjs",test:function(e){return!(!e.amplify||!e.amplify.publish)&&{version:UNKNOWN_VERSION}}},"Popcorn.js":{id:"popcornjs",icon:"popcornjs",url:"https://github.com/mozilla/popcorn-js/",test:function(e){return!(!e.Popcorn||!e.Popcorn.Events)&&{version:e.Popcorn.version||UNKNOWN_VERSION}}},D3:{id:"d3",icon:"d3",url:"https://d3js.org/",npm:"d3",test:function(e){return!(!e.d3||!e.d3.select)&&{version:e.d3.version||UNKNOWN_VERSION}}},Handlebars:{id:"handlebars",icon:"handlebars",url:"http://handlebarsjs.com/",npm:"handlebars",test:function(e){return!(!e.Handlebars||!e.Handlebars.compile)&&{version:e.Handlebars.VERSION||UNKNOWN_VERSION}}},Handsontable:{id:"handsontable",icon:"handsontable",url:"https://handsontable.com/",npm:"handsontable",test:function(e){return!(!e.Handsontable||!e.Handsontable.Core)&&{version:e.Handsontable.version||UNKNOWN_VERSION}}},Knockout:{id:"knockout",icon:"knockout",url:"http://knockoutjs.com/",npm:"knockout",test:function(e){return!(!e.ko||!e.ko.applyBindings)&&{version:e.ko.version||UNKNOWN_VERSION}}},Spine:{id:"spine",icon:"icon38",url:"http://spine.github.io/",test:function(e){return!(!e.Spine||!e.Spine.Controller)&&{version:e.Spine.version||UNKNOWN_VERSION}}},"jQuery Mobile":{id:"jquery-mobile",icon:"jquery_mobile",url:"http://jquerymobile.com/",npm:"jquery-mobile",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.mobile)&&{version:t.mobile.version||UNKNOWN_VERSION}}},"WebFont Loader":{id:"webfontloader",icon:"icon38",url:"https://github.com/typekit/webfontloader",npm:"webfontloader",test:function(e){return!(!e.WebFont||!e.WebFont.load)&&{version:UNKNOWN_VERSION}}},Angular:{id:"angular",icon:"angular",url:"https://angular.io/",npm:"@angular/core",test:function(e){var t=e.document.querySelector("[ng-version]");return t?{version:t.getAttribute("ng-version")||UNKNOWN_VERSION}:!!(e.ng&&e.ng.probe instanceof Function)&&{version:UNKNOWN_VERSION}}},AngularJS:{id:"angularjs",icon:"angularjs",url:"https://angularjs.org/",npm:"angular",test:function(e){var t=e.angular;return!!(t&&t.version&&t.version.full)&&{version:t.version.full}}},Ionic:{id:"ionic",icon:"ionic",url:"https://ionicframework.com/",npm:"@ionic/cli",test:function(e){var t=e.document.querySelector("ion-app");return!(!t||"ION-APP"!==t.nodeName)&&{version:UNKNOWN_VERSION}}},"Ember.js":{id:"emberjs",icon:"emberjs",url:"https://emberjs.com/",npm:"ember-source",test:function(e){var t=e.Ember||e.Em;return!(!t||!t.GUID_KEY)&&{version:t.VERSION||UNKNOWN_VERSION}}},"Hammer.js":{id:"hammerjs",icon:"hammerjs",url:"http://eightmedia.github.io/hammer.js/",npm:"hammerjs",test:function(e){return!(!e.Hammer||!e.Hammer.Pinch)&&{version:e.Hammer.VERSION||"&lt; 1.0.10"}}},"Visibility.js":{id:"visibilityjs",icon:"icon38",url:"https://github.com/ai/visibilityjs",npm:"visibilityjs",test:function(e){return!(!e.Visibility||!e.Visibility.every)&&{version:UNKNOWN_VERSION}}},"Velocity.js":{id:"velocityjs",icon:"icon38",url:"http://velocityjs.org/",npm:"velocity-animate",test:function(e){var t=e.jQuery||e.$,o=t?t.Velocity:e.Velocity;return o&&o.RegisterEffect&&o.version?{version:o.version.major+"."+o.version.minor+"."+o.version.patch}:!(!o||!o.RegisterEffect)&&{version:UNKNOWN_VERSION}}},"IfVisible.js":{id:"ifvisiblejs",icon:"icon38",url:"http://serkanyersen.github.io/ifvisible.js/",npm:"ifvisible.js",test:function(e){var t=e.ifvisible;return!(!t||"ifvisible.object.event.identifier"!==t.__ceGUID)&&{version:UNKNOWN_VERSION}}},"Pixi.js":{id:"pixi",icon:"pixi",url:"http://www.pixijs.com/",npm:"pixi.js",test:function(e){var t=e.PIXI;return!!(t&&t.WebGLRenderer&&t.VERSION)&&{version:t.VERSION.replace("v","")||UNKNOWN_VERSION}}},"DC.js":{id:"dcjs",icon:"dcjs",url:"http://dc-js.github.io/dc.js/",npm:"dc",test:function(e){var t=e.dc;return!(!t||!t.registerChart)&&{version:t.version||UNKNOWN_VERSION}}},"GreenSock JS":{id:"greensock",icon:"greensock",url:"https://greensock.com/gsap",npm:"gsap",test:function(e){return!(!e.TweenMax||!e.TweenMax.pauseAll)&&{version:e.TweenMax.version||UNKNOWN_VERSION}}},FastClick:{id:"fastclick",icon:"fastclick",url:"https://github.com/ftlabs/fastclick",npm:"fastclick",test:function(e){return!(!e.FastClick||!e.FastClick.notNeeded)&&{version:UNKNOWN_VERSION}}},Isotope:{id:"isotope",icon:"isotope",url:"https://isotope.metafizzy.co/",npm:"isotope-layout",test:function(e){return!!(e.Isotope||null!=e.$&&e.$.Isotope)&&{version:UNKNOWN_VERSION}}},Marionette:{id:"marionette",icon:"marionette",url:"https://marionettejs.com/",npm:"backbone.marionette",test:function(e){return!(!e.Marionette||!e.Marionette.Application)&&{version:e.Marionette.VERSION||UNKNOWN_VERSION}}},Can:{id:"canjs",icon:"canjs",url:"https://canjs.com/",npm:"can",test:function(e){return!(!e.can||!e.can.Construct)&&{version:e.can.VERSION||UNKNOWN_VERSION}}},Vue:{id:"vue",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!(null===document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return null!=e.__vue__?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()&&!e.Vue)&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Vue (Fast path)":{id:"vue-fast",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!!e.Vue&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Nuxt.js":{id:"nuxt",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!!(e.__NUXT__||e.$nuxt||[...e.document.querySelectorAll("*")].some((e=>e.__vue__?.nuxt)))&&{version:UNKNOWN_VERSION}}},"Nuxt.js (Fast path)":{id:"nuxt-fast",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!(!e.__NUXT__&&!e.$nuxt)&&{version:UNKNOWN_VERSION}}},Two:{id:"two",icon:"two",url:"https://two.js.org/",npm:"two.js",test:function(e){return!(!e.Two||!e.Two.Utils)&&{version:e.Two.Version||UNKNOWN_VERSION}}},Brewser:{id:"brewser",icon:"brewser",url:"https://robertpataki.github.io/brewser/",npm:"brewser",test:function(e){return!(!e.BREWSER||!e.BREWSER.ua)&&{version:BREWSER.VERSION||UNKNOWN_VERSION}}},"Material Design Lite":{id:"materialdesignlite",icon:"mdl",url:"https://getmdl.io/",npm:"material-design-lite",test:function(e){return!(!e.componentHandler||!e.componentHandler.upgradeElement)&&{version:UNKNOWN_VERSION}}},"Kendo UI":{id:"kendoui",icon:"kendoui",url:"https://github.com/telerik/kendo-ui-core",npm:"kendo-ui-core",test:function(e){return!!(e.kendo&&e.kendo.View&&e.kendo.View.extend)&&{version:e.kendo.version||UNKNOWN_VERSION}}},"Matter.js":{id:"matterjs",icon:"matter-js",url:"http://brm.io/matter-js/",npm:"matter-js",test:function(e){return!(!e.Matter||!e.Matter.Engine)&&{version:UNKNOWN_VERSION}}},Riot:{id:"riot",icon:"riot",url:"http://riotjs.com/",npm:"riot",test:function(e){return!(!e.riot||!e.riot.mixin)&&{version:e.riot.version||UNKNOWN_VERSION}}},"Sea.js":{id:"seajs",icon:"icon38",url:"https://seajs.github.io/seajs/docs/",npm:"seajs",test:function(e){return!(!e.seajs||!e.seajs.use)&&{version:e.seajs.version||UNKNOWN_VERSION}}},"Moment.js":{id:"momentjs",icon:"momentjs",url:"http://momentjs.com/",npm:"moment",test:function(e){return!(!e.moment||!e.moment.isMoment&&!e.moment.lang)&&{version:e.moment.version||UNKNOWN_VERSION}}},"Moment Timezone":{id:"moment-timezone",icon:"momentjs",url:"http://momentjs.com/timezone/",npm:"moment-timezone",test:function(e){return!(!e.moment||!e.moment.tz)&&{version:e.moment.tz.version||UNKNOWN_VERSION}}},ScrollMagic:{id:"scrollmagic",icon:"scrollmagic",url:"http://scrollmagic.io/",npm:"scrollmagic",test:function(e){return!(!e.ScrollMagic||!e.ScrollMagic.Controller)&&{version:ScrollMagic.version||UNKNOWN_VERSION}}},SWFObject:{id:"swfobject",icon:"icon38",url:"https://github.com/swfobject/swfobject",test:function(e){return e.swfobject&&e.swfobject.embedSWF?{version:e.swfobject.version||UNKNOWN_VERSION}:!(!e.deconcept||!e.deconcept.SWFObject)&&{version:UNKNOWN_VERSION}}},FlexSlider:{id:"flexslider",icon:"icon38",url:"https://woocommerce.com/flexslider/",npm:"flexslider",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.flexslider)&&{version:UNKNOWN_VERSION}}},SPF:{id:"spf",icon:"icon38",url:"https://youtube.github.io/spfjs/",npm:"spf",test:function(e){return!(!e.spf||!e.spf.init)&&{version:UNKNOWN_VERSION}}},"Numeral.js":{id:"numeraljs",icon:"icon38",url:"http://numeraljs.com/",npm:"numeraljs",test:function(e){return!(!e.numeral||!e.isNumeral)&&{version:e.numeral.version||UNKNOWN_VERSION}}},"boomerang.js":{id:"boomerangjs",icon:"icon38",url:"https://soasta.github.io/boomerang/",npm:"boomerangjs",test:function(e){return!!(e.BOOMR&&e.BOOMR.utils&&e.BOOMR.init)&&{version:e.BOOMR.version||UNKNOWN_VERSION}}},Framer:{id:"framer",icon:"framer",url:"https://framer.com/",npm:"framerjs",test:function(e){return!(!e.Framer||!e.Framer.Layer)&&{version:e.Framer.Version.build||UNKNOWN_VERSION}}},Marko:{id:"marko",icon:"marko",url:"https://markojs.com/",npm:"marko",test:function(e){return!!document.querySelector("[data-marko-key], [data-marko]")&&{version:UNKNOWN_VERSION}}},AMP:{id:"amp",icon:"amp",url:"https://amp.dev/",npm:"https://www.npmjs.com/org/ampproject",test:function(e){var t=e.document.documentElement.getAttribute("amp-version");return!!t&&{version:t}}},Gatsby:{id:"gatsby",icon:"gatsby",url:"https://www.gatsbyjs.org/",npm:"gatsby",test:function(e){return!!document.getElementById("___gatsby")&&{version:UNKNOWN_VERSION}}},Shopify:{id:"shopify",icon:"shopify",url:"https://www.shopify.com/",npm:null,test:function(e){return!(!e.Shopify||!e.Shopify.shop)&&{version:UNKNOWN_VERSION}}},Magento:{id:"magento",icon:"magento",url:"https://magento.com/",npm:null,test:function(e){const t=/\\/static(?:\\/version\\d+)?\\/frontend\\/.+\\/.+\\/requirejs\\/require(?:\\.min)?\\.js/;return!!Array.from(document.querySelectorAll("script[src]")||[]).some((e=>t.test(e.src)))&&{version:2}}},WordPress:{id:"wordpress",icon:"wordpress",url:"https://wordpress.org/",npm:null,test:function(e){const t=!!document.querySelector(\'link[rel="https://api.w.org/"]\'),o=!!document.querySelectorAll(\'link[href*="wp-includes"], script[src*="wp-includes"]\').length;if(!t&&!o)return!1;const n=document.querySelector(\'meta[name=generator][content^="WordPress"]\');return{version:n?n.getAttribute("content").replace(/^\\w+\\s/,""):UNKNOWN_VERSION}}},Wix:{id:"wix",icon:"wix",url:"https://www.wix.com/",npm:null,test:function(e){return(e.wixPerformanceMeasurements&&e.wixPerformanceMeasurements.info||!(!e.wixBiSession||!e.wixBiSession.info))&&{version:UNKNOWN_VERSION}}},Workbox:{id:"workbox",icon:"workbox",url:"https://developers.google.com/web/tools/workbox/",npm:"workbox-sw",test:async function(e){var t=e.navigator;if(!("serviceWorker"in t))return!1;const{timeoutPromise:o,clearTimeout:n}=_createTimeoutHelper(),r=t.serviceWorker.getRegistration().then((function(e){var o=t.serviceWorker.controller?t.serviceWorker.controller.scriptURL:e.active.scriptURL;return fetch(o,{credentials:"include",headers:{"service-worker":"script"}}).then((function(e){return e.text()})).then((function(e){if(/new Workbox|new workbox|workbox\\.precaching\\.|workbox\\.strategies/gm.test(e)){var t=/workbox.*?\\b((0|[1-9]\\d*)\\.(0|[1-9]\\d*)\\.(0|[1-9]\\d*)(-(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*)(\\.(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*))*)?(\\+[0-9a-zA-Z-]+(\\.[0-9a-zA-Z-]+)*)?)\\b/gim.exec(e),o=UNKNOWN_VERSION;return Array.isArray(t)&&t.length>1&&t[1]&&(o=t[1]),{version:o}}return!1}))})).catch((function(e){return!1}));return Promise.race([r,o]).catch((function(e){return!1})).finally((e=>(n(),e)))}},Boq:{id:"boq",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/143",npm:null,test:function(e){return!!e.WIZ_global_data&&{version:UNKNOWN_VERSION}}},Wiz:{id:"wiz",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/147",npm:null,test:function(e){return!!document.__wizdispatcher&&{version:UNKNOWN_VERSION}}},"core-js":{id:"corejs",icon:"icon38",url:"https://github.com/zloirock/core-js",npm:"core-js",test:function(e){const t=e["__core-js_shared__"],o=e.core;if(t){const e=t.versions;return{version:Array.isArray(e)?e.map((e=>`core-js-${e.mode}@${e.version}`)).join("; "):UNKNOWN_VERSION}}return!!o&&{version:o.version||UNKNOWN_VERSION}}},Drupal:{id:"drupal",icon:"drupal",url:"https://www.drupal.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="Drupal"]\'),o=t?t.getAttribute("content").replace(/\\D+/gi,""):UNKNOWN_VERSION,n=/\\/sites\\/(?:default|all)\\/(?:themes|modules|files)/,r=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(r.some((e=>n.test(e.src)))||r.some((e=>n.test(e.href)))||t||e.Drupal&&e.Drupal.behaviors)&&{version:o}}},TYPO3:{id:"typo3",icon:"typo3",url:"https://typo3.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="TYPO3"]\'),o=/\\/(typo3conf|typo3temp|fileadmin)/,n=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||n.some((e=>o.test(e.src)))||n.some((e=>o.test(e.href))))&&{version:UNKNOWN_VERSION}}},"Create React App":{id:"create-react-app",icon:"cra",url:"https://create-react-app.dev/",npm:"react-scripts",test:function(e){let t,o,n=e.document.body.firstElementChild;do{"noscript"===n.localName?t=n:"root"===n.id&&(o=n)}while(n=n.nextElementSibling);return!!(o&&t&&/You need to enable JavaScript to run this app/.test(t.textContent))&&{version:UNKNOWN_VERSION}}},"Guess.js":{id:"guessjs",icon:"guessjs",url:"https://guess-js.github.io/",test:function(e){return!(!e.__GUESS__||!e.__GUESS__.guess)&&{version:UNKNOWN_VERSION}}},"October CMS":{id:"octobercms",icon:"october",url:"https://octobercms.com/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="OctoberCMS"]\'),o=document.querySelector(\'meta[name="generator"][content^="October CMS"]\'),n=/\\/modules\\/system\\/assets\\/(css|js)\\/framework(\\.extras|\\.combined)?(-min)?/,r=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||o||r.some((e=>n.test(e.src||e.href))))&&{version:UNKNOWN_VERSION}}},Joomla:{id:"joomla",icon:"joomla",url:"https://www.joomla.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name=generator][content^="Joomla"]\'),o=!!document.querySelectorAll(\'script[src*="/media/jui/js/bootstrap.min.js"]\').length;return t?{version:t.getAttribute("content").replace(/^\\w+\\s/,"")}:!(!e.Joomla&&!o)&&{version:UNKNOWN_VERSION}}},Sugar:{id:"sugar",icon:"sugar",url:"https://sugarjs.com",npm:"sugar",test:function(e){return e.Sugar?{version:e.Sugar.VERSION||UNKNOWN_VERSION}:!!e.Array.SugarMethods&&{version:UNKNOWN_VERSION}}},Bento:{id:"bentojs",icon:"bentojs",url:"https://bentojs.dev",npm:"https://www.npmjs.com/org/bentoproject",test:function(e){return!(!e.BENTO||!e.BENTO.push)&&{version:UNKNOWN_VERSION}}},"WP Rocket":{id:"wp-rocket",icon:"wp-rocket",url:"https://wp-rocket.me/",npm:null,test:async function(e){const t="undefined"!=typeof RocketLazyLoadScripts||"undefined"!=typeof RocketPreloadLinksConfig||"undefined"!=typeof rocket_lazy,o=!!document.querySelector("style#wpr-usedcss"),n=document.lastChild.nodeType===Node.COMMENT_NODE&&document.lastChild.textContent.includes("WP Rocket");return!!(o||t||n)&&{version:UNKNOWN_VERSION}}},NitroPack:{id:"nitropack",icon:"nitropack",url:"https://nitropack.io/",npm:null,test:async function(e){return!!document.querySelector(\'meta[name="generator"][content="NitroPack"]\')&&{version:UNKNOWN_VERSION}}},Remix:{id:"remix",icon:"remix",url:"https://remix.run/",npm:"remix",test:function(e){return!!e.__remixContext&&{version:UNKNOWN_VERSION}}}};']})).map((e=>({detector:"js",id:e.id,name:e.name,version:"number"==typeof e.version?String(e.version):e.version||void 0,npm:e.npm||void 0})));return Kt.timeEnd(t),a}async getArtifact(t){try{return await e.collectStacks(t.driver.executionContext)}catch{return[]}}},aD=tD})),rD={};c(rD,{default:()=>oD});var iD,oD,sD,lD,cD,uD,dD,mD,pD,hD,gD,fD=s((()=>{J(),sa(),aa(),iD=class extends Jt{static{o(this,"TraceCompat")}meta={supportedModes:["timespan","navigation"],dependencies:{Trace:oa.symbol}};async getArtifact(e){return{defaultPass:e.dependencies.Trace}}},oD=iD})),yD=s((()=>{J(),Bc(),Hc(),Wc(),sD=class{static{o(this,"ProcessedNavigation")}static isProcessedTrace(e){return"timeOriginEvt"in e}static async compute_(e,t){if(this.isProcessedTrace(e))return Sc.processNavigation(e);let a=await kc.request(e,t);return Sc.processNavigation(a)}},lD=dc(sD,null)})),vD=s((()=>{J(),Hc(),Bc(),cD=new Set(["keydown","keypress","keyup"]),uD=new Set(["mousedown","mouseup","pointerdown","pointerup","click"]),dD={keyboard:cD,tapOrClick:uD,drag:uD},mD=class e{static{o(this,"Responsiveness")}static getHighPercentileResponsiveness(e){let t=e.frameTreeEvents.filter((e=>"Responsiveness.Renderer.UserInteraction"===e.name)).sort(((e,t)=>t.args.data.maxDuration-e.args.data.maxDuration));return 0===t.length?null:t[Math.min(9,Math.floor(t.length/50))]}static findInteractionEvent(e,{traceEvents:t}){let a=t.filter((e=>"EventTiming"===e.name&&"e"!==e.ph));if(a.length&&a.every((e=>!e.args.data?.frame)))return{name:"FallbackTiming",duration:e.args.data.maxDuration};let n,{maxDuration:r,interactionType:i}=e.args.data,o=Number.POSITIVE_INFINITY;for(let t of a){if(t.args.data.frame!==e.args.frame)continue;let{type:a,duration:s}=t.args.data,l=dD[i];if(!l)throw new Error(`unexpected responsiveness interactionType '${i}'`);if(!l.has(a))continue;let c=Math.abs(s-r);c<o&&(n=t,o=c)}if(!n)throw new Error(`no interaction event found for responsiveness type '${i}'`);if(o>5)throw new Error(`no interaction event found within 5ms of responsiveness maxDuration (max: ${r}, closest ${n.args.data.duration})`);return n}static async compute_(t,a){let{settings:n,trace:r}=t;if("simulate"===n.throttlingMethod)throw new Error("Responsiveness currently unsupported by simulated throttling");let i=await kc.request(r,a),o=e.getHighPercentileResponsiveness(i);if(!o)return null;let s=e.findInteractionEvent(o,r);return JSON.parse(JSON.stringify(s))}},pD=dc(mD,["trace","settings"])})),bD=s((()=>{J(),Bc(),Hc(),500,hD=class e{static{o(this,"CumulativeLayoutShift")}static getLayoutShiftEvents(e){let t=[],a=!1,n=e.timestamps.timeOrigin,r=e.frameEvents.find((e=>"viewport"===e.name));r&&(n=r.ts);for(let r of e.frameTreeEvents)if("LayoutShift"===r.name&&r.args.data&&void 0!==r.args.data.is_main_frame){if(void 0===r.args.data.weighted_score_delta)throw new Error("CLS missing weighted_score_delta");if(r.args.data.had_recent_input){if((r.ts-n)/1e3>500||a)continue}else a=!0;t.push({ts:r.ts,isMainFrame:r.args.data.is_main_frame,weightedScore:r.args.data.weighted_score_delta,impactedNodes:r.args.data.impacted_nodes})}return t}static calculate(e){let t=0,a=0,n=Number.NEGATIVE_INFINITY,r=Number.NEGATIVE_INFINITY;for(let i of e)(i.ts-n>5e6||i.ts-r>1e6)&&(n=i.ts,a=0),r=i.ts,a+=i.weightedScore,t=Math.max(t,a);return t}static async compute_(t,a){let n=await kc.request(t,a),r=e.getLayoutShiftEvents(n),i=r.filter((e=>e.isMainFrame));return{cumulativeLayoutShift:e.calculate(r),cumulativeLayoutShiftMainFrame:e.calculate(i)}}},gD=dc(hD,null)})),wD={};function DD(){let e,t=this.nodeType===document.ELEMENT_NODE?this:this.parentElement;return t&&(e={node:getNodeDetails(t)}),e}c(wD,{default:()=>TD});var ED,TD,SD=s((()=>{J(),aa(),zm(),bd(),Dw(),Du(),sa(),Hc(),yD(),xl(),vD(),bD(),wd(),o(DD,"getNodeDetailsData"),ED=class e extends Jt{static{o(this,"TraceElements")}meta={supportedModes:["timespan","navigation"],dependencies:{Trace:oa.symbol}};animationIdToName=new Map;constructor(){super(),this._onAnimationStarted=this._onAnimationStarted.bind(this)}_onAnimationStarted({animation:{id:e,name:t}}){t&&this.animationIdToName.set(e,t)}static traceRectToLHRect(e){return gw({x:e[0],y:e[1],width:e[2],height:e[3]})}static getTopLayoutShiftElements(t){let a=new Map;return gD.getLayoutShiftEvents(t).forEach((t=>{if(!t||!t.impactedNodes)return;let n=0,r=new Map;t.impactedNodes.forEach((t=>{if(!t.node_id||!t.old_rect||!t.new_rect)return;let a=e.traceRectToLHRect(t.old_rect),i=e.traceRectToLHRect(t.new_rect),o=vw(a)+vw(i)-fw(a,i);r.set(t.node_id,o),n+=o}));for(let[e,i]of r.entries()){let r=a.get(e)||0;r+=i/n*t.weightedScore,a.set(e,r)}})),[...a.entries()].sort(((e,t)=>t[1]-e[1])).slice(0,5).map((([e,t])=>({nodeId:e,score:t})))}static async getResponsivenessElement(e,t){let{settings:a}=t;try{let n=await pD.request({trace:e,settings:a},t);return n&&"FallbackTiming"!==n.name?{nodeId:n.args.data.nodeId}:void 0}catch{return}}async getAnimatedElements(e){let t=new Map;for(let a of e){if("Animation"!==a.name||!a.id2||!a.id2.local)continue;let e=a.id2.local,n=t.get(e)||{begin:void 0,status:void 0};"b"===a.ph?n.begin=a:"n"===a.ph&&a.args.data&&void 0!==a.args.data.compositeFailed&&(n.status=a),t.set(e,n)}let a=new Map;for(let{begin:e,status:n}of t.values()){let t=e?.args?.data?.nodeId,r=e?.args?.data?.id,i=n?.args?.data?.compositeFailed,o=n?.args?.data?.unsupportedProperties;if(!t||!r)continue;let s=a.get(t)||new Set;s.add({animationId:r,failureReasonsMask:i,unsupportedProperties:o}),a.set(t,s)}let n=[];for(let[e,t]of a){let a=[];for(let{animationId:e,failureReasonsMask:n,unsupportedProperties:r}of t){let t=this.animationIdToName.get(e);a.push({name:t,failureReasonsMask:n,unsupportedProperties:r})}n.push({nodeId:e,animations:a})}return n}static async getLcpElement(e,t){let a;try{a=await lD.request(e,t)}catch(e){if("timespan"===t.gatherMode&&e.code===El.errors.NO_FCP.code)return;throw e}let n=a.largestContentfulPaintEvt?.args?.data;if(void 0!==n?.nodeId&&n.type)return{nodeId:n.nodeId,type:n.type}}async startInstrumentation(e){await e.driver.defaultSession.sendCommand("Animation.enable"),e.driver.defaultSession.on("Animation.animationStarted",this._onAnimationStarted)}async stopInstrumentation(e){e.driver.defaultSession.off("Animation.animationStarted",this._onAnimationStarted),await e.driver.defaultSession.sendCommand("Animation.disable")}async getArtifact(t){let a=t.driver.defaultSession,n=t.dependencies.Trace;if(!n)throw new Error("Trace is missing!");let r=await kc.request(n,t),{mainThreadEvents:i}=r,o=await e.getLcpElement(n,t),s=e.getTopLayoutShiftElements(r),l=await this.getAnimatedElements(i),c=await e.getResponsivenessElement(n,t),u=new Map([["largest-contentful-paint",o?[o]:[]],["layout-shift",s],["animation",l],["responsiveness",c?[c]:[]]]),d=[];for(let[e,t]of u)for(let n=0;n<t.length;n++){let r,i=t[n].nodeId;try{let e=await Bm(a,i);if(!e)continue;let t=ld.serializeDeps([sd.getNodeDetails,DD]);r=await a.sendCommand("Runtime.callFunctionOn",{objectId:e,functionDeclaration:`function () {\n              ${t}\n              return getNodeDetailsData.call(this);\n            }`,returnByValue:!0,awaitPromise:!0})}catch(e){vu.captureException(e,{tags:{gatherer:"TraceElements"},level:"error"});continue}r?.result?.value&&d.push({traceEventType:e,...r.result.value,score:t[n].score,animations:t[n].animations,nodeId:i,type:t[n].type})}return d}},TD=ED})),CD={};function kD(){return{innerWidth:window.innerWidth,innerHeight:window.innerHeight,outerWidth:window.outerWidth,outerHeight:window.outerHeight,devicePixelRatio:window.devicePixelRatio}}c(CD,{default:()=>AD});var xD,AD,_D=s((()=>{J(),aa(),o(kD,"getViewportDimensions"),xD=class extends Jt{static{o(this,"ViewportDimensions")}meta={supportedModes:["snapshot","timespan","navigation"]};async getArtifact(e){let t=await e.driver.executionContext.evaluate(kD,{args:[],useIsolation:!0});if(!Object.values(t).every(Number.isFinite)){let e=JSON.stringify(t);throw new Error(`ViewportDimensions results were not numeric: ${e}`)}return t}},AD=xD}));function RD(e,t){let a,n;return"string"==typeof e?a=t?e.trim():e:(void 0!==e&&(n="ERROR: expected a string."),a=void 0),{raw:e,value:a,warning:n}}function FD(e){let t=RD(e);return t.value,t}function ND(e){return RD(e.name,!0)}function ID(e){return RD(e.short_name,!0)}function MD(e,t){let a=new URL(e),n=new URL(t);return a.origin===n.origin}function PD(e,t,a){let n,r=e.start_url;if(""===r)return{raw:r,value:a,warning:"ERROR: start_url string empty"};if(void 0===r)return{raw:r,value:a};if("string"!=typeof r)return{raw:r,value:a,warning:"ERROR: expected a string."};try{n=new URL(r,t).href}catch{return{raw:r,value:a,warning:`ERROR: invalid start_url relative to ${t}`}}return MD(n,a)?{raw:r,value:n}:{raw:r,value:a,warning:"ERROR: start_url must be same-origin as document"}}function LD(e){let t=RD(e.display,!0),a=t.value;if(!a)return{raw:e,value:$D,warning:t.warning};let n=a.toLowerCase();return GD.includes(n)?{raw:e,value:n,warning:void 0}:{raw:e,value:$D,warning:"ERROR: 'display' has invalid value "+n+`. will fall back to ${$D}.`}}function OD(e){let t=RD(e.orientation,!0);return t.value&&!KD.includes(t.value.toLowerCase())&&(t.value=void 0,t.warning="ERROR: 'orientation' has an invalid value, will be ignored."),t}function jD(e,t){let a=RD(e.src,!0);if(""===a.value&&(a.value=void 0),a.value)try{a.value=new URL(a.value,t).href}catch{a.warning=`ERROR: invalid icon url will be ignored: '${e.src}'`,a.value=void 0}let n=RD(e.type,!0),r=RD(e.purpose),i={raw:e.purpose,value:["any"],warning:void 0};void 0!==r.value&&(i.value=r.value.split(/\s+/).map((e=>e.toLowerCase())));let o={raw:e.density,value:1,warning:void 0};void 0!==o.raw&&(o.value=parseFloat(o.raw),(isNaN(o.value)||!isFinite(o.value)||o.value<=0)&&(o.value=1,o.warning="ERROR: icon density cannot be NaN, +∞, or less than or equal to +0."));let s,l=RD(e.sizes);if(void 0!==l.value){let t=new Set;l.value.trim().split(/\s+/).forEach((e=>t.add(e.toLowerCase()))),s={raw:e.sizes,value:t.size>0?Array.from(t):void 0,warning:void 0}}else s={...l,value:void 0};return{raw:e,value:{src:a,type:n,density:o,sizes:s,purpose:i},warning:void 0}}function UD(e,t){let a=e.icons;if(void 0===a)return{raw:a,value:[],warning:void 0};if(!Array.isArray(a))return{raw:a,value:[],warning:"ERROR: 'icons' expected to be an array but is not."};let n=a.filter((e=>void 0!==e.src)).map((e=>jD(e,t))),r=n.filter((e=>{let t=[e.warning,e.value.type.warning,e.value.src.warning,e.value.sizes.warning,e.value.density.warning].filter(Boolean),a=!!e.value.src.value;return!!t.length&&!a}));return{raw:a,value:n.filter((e=>void 0!==e.value.src.value)),warning:r.length?"WARNING: Some icons were ignored due to warnings.":void 0}}function BD(e){let t=RD(e.platform,!0),a=RD(e.id,!0),n=RD(e.url,!0);if(n.value)try{n.value=new URL(n.value).href}catch{n.value=void 0,n.warning=`ERROR: invalid application URL ${e.url}`}return{raw:e,value:{platform:t,id:a,url:n},warning:void 0}}function qD(e){let t=e.related_applications;if(void 0===t)return{raw:t,value:void 0,warning:void 0};if(!Array.isArray(t))return{raw:t,value:void 0,warning:"ERROR: 'related_applications' expected to be an array but is not."};let a=t.filter((e=>!!e.platform)).map(BD).filter((e=>!!e.value.id.value||!!e.value.url.value));return{raw:t,value:a,warning:void 0}}function zD(e){let t,a,n=e.prefer_related_applications;return"boolean"==typeof n?t=n:(void 0!==n&&(a="ERROR: 'prefer_related_applications' expected to be a boolean."),t=void 0),{raw:n,value:t,warning:a}}function VD(e){return FD(e.theme_color)}function WD(e){return FD(e.background_color)}function HD(e,t,a){if(void 0===t||void 0===a)throw new Error("Manifest and document URLs required for manifest parsing.");let n;try{n=JSON.parse(e)}catch(a){return{raw:e,value:void 0,warning:"ERROR: file isn't valid JSON: "+a,url:t}}let r,i={name:ND(n),short_name:ID(n),start_url:PD(n,t,a),display:LD(n),orientation:OD(n),icons:UD(n,t),related_applications:qD(n),prefer_related_applications:zD(n),theme_color:VD(n),background_color:WD(n)};try{new URL(t).protocol.startsWith("http")||(r="WARNING: manifest URL not available over a valid network protocol")}catch{r=`ERROR: invalid manifest URL: '${t}'`}return{raw:e,value:i,warning:r,url:t}}var GD,$D,KD,YD=s((()=>{J(),GD=["fullscreen","standalone","minimal-ui","browser"],$D="browser",KD=["any","natural","landscape","portrait","portrait-primary","portrait-secondary","landscape-primary","landscape-secondary"],o(RD,"parseString"),o(FD,"parseColor"),o(ND,"parseName"),o(ID,"parseShortName"),o(MD,"checkSameOrigin"),o(PD,"parseStartUrl"),o(LD,"parseDisplay"),o(OD,"parseOrientation"),o(jD,"parseIcon"),o(UD,"parseIcons"),o(BD,"parseApplication"),o(qD,"parseRelatedApplications"),o(zD,"parsePreferRelatedApplications"),o(VD,"parseThemeColor"),o(WD,"parseBackgroundColor"),o(HD,"parseManifest")})),JD={};c(JD,{default:()=>XD});var ZD,XD,QD,eE,tE,aE,nE=s((()=>{J(),ea(),YD(),aa(),ZD=class e extends Jt{static{o(this,"WebAppManifest")}meta={supportedModes:["snapshot","navigation"]};static async fetchAppManifest(e){let t;e.setNextProtocolTimeout(1e4);try{t=await e.sendCommand("Page.getAppManifest")}catch(e){if("PROTOCOL_TIMEOUT"===e.code)return Kt.error("WebAppManifest","Failed fetching manifest",e),null;throw e}let a=t.data;if(!a)return null;return 65279===a.charCodeAt(0)&&(a=Buffer.from(a).slice(3).toString()),{...t,data:a}}static async getWebAppManifest(t,a){let n={msg:"Get webapp manifest",id:"lh:gather:getWebAppManifest"};Kt.time(n);let r=await e.fetchAppManifest(t);if(!r)return null;let i=HD(r.data,r.url,a);return Kt.timeEnd(n),i}async getArtifact(t){let a=t.driver,{finalDisplayedUrl:n}=t.baseArtifacts.URL;try{return await e.getWebAppManifest(a.defaultSession,n)}catch{return null}}},XD=ZD})),rE=s((()=>{J(),xr(),ro(),eE=eo("core/audits/accessibility/axe-audit.js",QD={failingElementsHeader:"Failing Elements"}),tE=class extends Dr{static{o(this,"AxeAudit")}static audit(e){if((e.Accessibility.notApplicable||[]).find((e=>e.id===this.meta.id)))return{score:null,notApplicable:!0};let t=e.Accessibility.incomplete||[],a=t.find((e=>e.id===this.meta.id));if(a?.error)return{score:null,errorMessage:`axe-core Error: ${a.error.message||"Unknown error"}`};let n=this.meta.scoreDisplayMode===Dr.SCORING_MODES.INFORMATIVE,r=e.Accessibility.violations||[],i=(n?r.concat(t):r).find((e=>e.id===this.meta.id)),o=i?.impact,s=i?.tags;if(n&&!i)return{score:null,notApplicable:!0};let l=[];i?.nodes&&(l=i.nodes.map((e=>({node:{...Dr.makeNodeItem(e.node),explanation:e.failureSummary},subItems:e.relatedNodes.length?{type:"subitems",items:e.relatedNodes.map((e=>({relatedNode:Dr.makeNodeItem(e)})))}:void 0}))));let c,u=[{key:"node",valueType:"node",subItemsHeading:{key:"relatedNode",valueType:"node"},label:eE(QD.failingElementsHeader)}];return(o||s)&&(c={type:"debugdata",impact:o,tags:s}),{score:+(void 0===i),details:{...Dr.makeTableDetails(u,l),debugData:c}}}},aE=tE})),iE={};c(iE,{UIStrings:()=>oE,default:()=>cE});var oE,sE,lE,cE,uE=s((()=>{J(),rE(),ro(),sE=eo("core/audits/accessibility/accesskeys.js",oE={title:"`[accesskey]` values are unique",failureTitle:"`[accesskey]` values are not unique",description:"Access keys let users quickly focus a part of the page. For proper navigation, each access key must be unique. [Learn more about access keys](https://dequeuniversity.com/rules/axe/4.7/accesskeys)."}),lE=class extends aE{static{o(this,"Accesskeys")}static get meta(){return{id:"accesskeys",title:sE(oE.title),failureTitle:sE(oE.failureTitle),description:sE(oE.description),requiredArtifacts:["Accessibility"]}}},cE=lE})),dE={};c(dE,{UIStrings:()=>mE,default:()=>gE});var mE,pE,hE,gE,fE=s((()=>{J(),rE(),ro(),pE=eo("core/audits/accessibility/aria-allowed-attr.js",mE={title:"`[aria-*]` attributes match their roles",failureTitle:"`[aria-*]` attributes do not match their roles",description:"Each ARIA `role` supports a specific subset of `aria-*` attributes. Mismatching these invalidates the `aria-*` attributes. [Learn how to match ARIA attributes to their roles](https://dequeuniversity.com/rules/axe/4.7/aria-allowed-attr)."}),hE=class extends aE{static{o(this,"ARIAAllowedAttr")}static get meta(){return{id:"aria-allowed-attr",title:pE(mE.title),failureTitle:pE(mE.failureTitle),description:pE(mE.description),requiredArtifacts:["Accessibility"]}}},gE=hE})),yE={};c(yE,{UIStrings:()=>vE,default:()=>DE});var vE,bE,wE,DE,EE=s((()=>{J(),rE(),ro(),bE=eo("core/audits/accessibility/aria-allowed-role.js",vE={title:'Values assigned to `role=""` are valid ARIA roles.',failureTitle:'Values assigned to `role=""` are not valid ARIA roles.',description:"ARIA `role`s enable assistive technologies to know the role of each element on the web page. If the `role` values are misspelled, not existing ARIA `role` values, or abstract roles, then the purpose of the element will not be communicated to users of assistive technologies. [Learn more about ARIA roles](https://dequeuniversity.com/rules/axe/4.7/aria-allowed-roles)."}),wE=class extends aE{static{o(this,"ARIAAllowedRole")}static get meta(){return{id:"aria-allowed-role",title:bE(vE.title),failureTitle:bE(vE.failureTitle),description:bE(vE.description),requiredArtifacts:["Accessibility"]}}},DE=wE})),TE={};c(TE,{UIStrings:()=>SE,default:()=>xE});var SE,CE,kE,xE,AE=s((()=>{J(),rE(),ro(),CE=eo("core/audits/accessibility/aria-command-name.js",SE={title:"`button`, `link`, and `menuitem` elements have accessible names",failureTitle:"`button`, `link`, and `menuitem` elements do not have accessible names.",description:"When an element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to make command elements more accessible](https://dequeuniversity.com/rules/axe/4.7/aria-command-name)."}),kE=class extends aE{static{o(this,"AriaCommandName")}static get meta(){return{id:"aria-command-name",title:CE(SE.title),failureTitle:CE(SE.failureTitle),description:CE(SE.description),requiredArtifacts:["Accessibility"]}}},xE=kE})),_E={};c(_E,{UIStrings:()=>RE,default:()=>IE});var RE,FE,NE,IE,ME=s((()=>{J(),rE(),ro(),FE=eo("core/audits/accessibility/aria-dialog-name.js",RE={title:'Elements with `role="dialog"` or `role="alertdialog"` have accessible names.',failureTitle:'Elements with `role="dialog"` or `role="alertdialog"` do not have accessible names.',description:"ARIA dialog elements without accessible names may prevent screen readers users from discerning the purpose of these elements. [Learn how to make ARIA dialog elements more accessible](https://dequeuniversity.com/rules/axe/4.7/aria-dialog-name)."}),NE=class extends aE{static{o(this,"AriaDialogName")}static get meta(){return{id:"aria-dialog-name",title:FE(RE.title),failureTitle:FE(RE.failureTitle),description:FE(RE.description),requiredArtifacts:["Accessibility"]}}},IE=NE})),PE={};c(PE,{UIStrings:()=>LE,default:()=>UE});var LE,OE,jE,UE,BE=s((()=>{J(),rE(),ro(),OE=eo("core/audits/accessibility/aria-hidden-body.js",LE={title:'`[aria-hidden="true"]` is not present on the document `<body>`',failureTitle:'`[aria-hidden="true"]` is present on the document `<body>`',description:'Assistive technologies, like screen readers, work inconsistently when `aria-hidden="true"` is set on the document `<body>`. [Learn how `aria-hidden` affects the document body](https://dequeuniversity.com/rules/axe/4.7/aria-hidden-body).'}),jE=class extends aE{static{o(this,"AriaHiddenBody")}static get meta(){return{id:"aria-hidden-body",title:OE(LE.title),failureTitle:OE(LE.failureTitle),description:OE(LE.description),requiredArtifacts:["Accessibility"]}}},UE=jE})),qE={};c(qE,{UIStrings:()=>zE,default:()=>HE});var zE,VE,WE,HE,GE=s((()=>{J(),rE(),ro(),VE=eo("core/audits/accessibility/aria-hidden-focus.js",zE={title:'`[aria-hidden="true"]` elements do not contain focusable descendents',failureTitle:'`[aria-hidden="true"]` elements contain focusable descendents',description:'Focusable descendents within an `[aria-hidden="true"]` element prevent those interactive elements from being available to users of assistive technologies like screen readers. [Learn how `aria-hidden` affects focusable elements](https://dequeuniversity.com/rules/axe/4.7/aria-hidden-focus).'}),WE=class extends aE{static{o(this,"AriaHiddenFocus")}static get meta(){return{id:"aria-hidden-focus",title:VE(zE.title),failureTitle:VE(zE.failureTitle),description:VE(zE.description),requiredArtifacts:["Accessibility"]}}},HE=WE})),$E={};c($E,{UIStrings:()=>KE,default:()=>ZE});var KE,YE,JE,ZE,XE=s((()=>{J(),rE(),ro(),YE=eo("core/audits/accessibility/aria-input-field-name.js",KE={title:"ARIA input fields have accessible names",failureTitle:"ARIA input fields do not have accessible names",description:"When an input field doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more about input field labels](https://dequeuniversity.com/rules/axe/4.7/aria-input-field-name)."}),JE=class extends aE{static{o(this,"AriaInputFieldName")}static get meta(){return{id:"aria-input-field-name",title:YE(KE.title),failureTitle:YE(KE.failureTitle),description:YE(KE.description),requiredArtifacts:["Accessibility"]}}},ZE=JE})),QE={};c(QE,{UIStrings:()=>eT,default:()=>nT});var eT,tT,aT,nT,rT=s((()=>{J(),rE(),ro(),tT=eo("core/audits/accessibility/aria-meter-name.js",eT={title:"ARIA `meter` elements have accessible names",failureTitle:"ARIA `meter` elements do not have accessible names.",description:"When a meter element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to name `meter` elements](https://dequeuniversity.com/rules/axe/4.7/aria-meter-name)."}),aT=class extends aE{static{o(this,"AriaMeterName")}static get meta(){return{id:"aria-meter-name",title:tT(eT.title),failureTitle:tT(eT.failureTitle),description:tT(eT.description),requiredArtifacts:["Accessibility"]}}},nT=aT})),iT={};c(iT,{UIStrings:()=>oT,default:()=>cT});var oT,sT,lT,cT,uT=s((()=>{J(),rE(),ro(),sT=eo("core/audits/accessibility/aria-progressbar-name.js",oT={title:"ARIA `progressbar` elements have accessible names",failureTitle:"ARIA `progressbar` elements do not have accessible names.",description:"When a `progressbar` element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to label `progressbar` elements](https://dequeuniversity.com/rules/axe/4.7/aria-progressbar-name)."}),lT=class extends aE{static{o(this,"AriaProgressbarName")}static get meta(){return{id:"aria-progressbar-name",title:sT(oT.title),failureTitle:sT(oT.failureTitle),description:sT(oT.description),requiredArtifacts:["Accessibility"]}}},cT=lT})),dT={};c(dT,{UIStrings:()=>mT,default:()=>gT});var mT,pT,hT,gT,fT=s((()=>{J(),rE(),ro(),pT=eo("core/audits/accessibility/aria-required-attr.js",mT={title:"`[role]`s have all required `[aria-*]` attributes",failureTitle:"`[role]`s do not have all required `[aria-*]` attributes",description:"Some ARIA roles have required attributes that describe the state of the element to screen readers. [Learn more about roles and required attributes](https://dequeuniversity.com/rules/axe/4.7/aria-required-attr)."}),hT=class extends aE{static{o(this,"ARIARequiredAttr")}static get meta(){return{id:"aria-required-attr",title:pT(mT.title),failureTitle:pT(mT.failureTitle),description:pT(mT.description),requiredArtifacts:["Accessibility"]}}},gT=hT})),yT={};c(yT,{UIStrings:()=>vT,default:()=>DT});var vT,bT,wT,DT,ET=s((()=>{J(),rE(),ro(),bT=eo("core/audits/accessibility/aria-required-children.js",vT={title:"Elements with an ARIA `[role]` that require children to contain a specific `[role]` have all required children.",failureTitle:"Elements with an ARIA `[role]` that require children to contain a specific `[role]` are missing some or all of those required children.",description:"Some ARIA parent roles must contain specific child roles to perform their intended accessibility functions. [Learn more about roles and required children elements](https://dequeuniversity.com/rules/axe/4.7/aria-required-children)."}),wT=class extends aE{static{o(this,"AriaRequiredChildren")}static get meta(){return{id:"aria-required-children",title:bT(vT.title),failureTitle:bT(vT.failureTitle),description:bT(vT.description),requiredArtifacts:["Accessibility"]}}},DT=wT})),TT={};c(TT,{UIStrings:()=>ST,default:()=>xT});var ST,CT,kT,xT,AT=s((()=>{J(),rE(),ro(),CT=eo("core/audits/accessibility/aria-required-parent.js",ST={title:"`[role]`s are contained by their required parent element",failureTitle:"`[role]`s are not contained by their required parent element",description:"Some ARIA child roles must be contained by specific parent roles to properly perform their intended accessibility functions. [Learn more about ARIA roles and required parent element](https://dequeuniversity.com/rules/axe/4.7/aria-required-parent)."}),kT=class extends aE{static{o(this,"AriaRequiredParent")}static get meta(){return{id:"aria-required-parent",title:CT(ST.title),failureTitle:CT(ST.failureTitle),description:CT(ST.description),requiredArtifacts:["Accessibility"]}}},xT=kT})),_T={};c(_T,{UIStrings:()=>RT,default:()=>IT});var RT,FT,NT,IT,MT=s((()=>{J(),rE(),ro(),FT=eo("core/audits/accessibility/aria-roles.js",RT={title:"`[role]` values are valid",failureTitle:"`[role]` values are not valid",description:"ARIA roles must have valid values in order to perform their intended accessibility functions. [Learn more about valid ARIA roles](https://dequeuniversity.com/rules/axe/4.7/aria-roles)."}),NT=class extends aE{static{o(this,"AriaRoles")}static get meta(){return{id:"aria-roles",title:FT(RT.title),failureTitle:FT(RT.failureTitle),description:FT(RT.description),requiredArtifacts:["Accessibility"]}}},IT=NT})),PT={};c(PT,{UIStrings:()=>LT,default:()=>UT});var LT,OT,jT,UT,BT=s((()=>{J(),rE(),ro(),OT=eo("core/audits/accessibility/aria-text.js",LT={title:"Elements with the `role=text` attribute do not have focusable descendents.",failureTitle:"Elements with the `role=text` attribute do have focusable descendents.",description:"Adding `role=text` around a text node split by markup enables VoiceOver to treat it as one phrase, but the element's focusable descendents will not be announced. [Learn more about the `role=text` attribute](https://dequeuniversity.com/rules/axe/4.7/aria-text)."}),jT=class extends aE{static{o(this,"AriaText")}static get meta(){return{id:"aria-text",title:OT(LT.title),failureTitle:OT(LT.failureTitle),description:OT(LT.description),requiredArtifacts:["Accessibility"]}}},UT=jT})),qT={};c(qT,{UIStrings:()=>zT,default:()=>HT});var zT,VT,WT,HT,GT=s((()=>{J(),rE(),ro(),VT=eo("core/audits/accessibility/aria-toggle-field-name.js",zT={title:"ARIA toggle fields have accessible names",failureTitle:"ARIA toggle fields do not have accessible names",description:"When a toggle field doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more about toggle fields](https://dequeuniversity.com/rules/axe/4.7/aria-toggle-field-name)."}),WT=class extends aE{static{o(this,"AriaToggleFieldName")}static get meta(){return{id:"aria-toggle-field-name",title:VT(zT.title),failureTitle:VT(zT.failureTitle),description:VT(zT.description),requiredArtifacts:["Accessibility"]}}},HT=WT})),$T={};c($T,{UIStrings:()=>KT,default:()=>ZT});var KT,YT,JT,ZT,XT=s((()=>{J(),rE(),ro(),YT=eo("core/audits/accessibility/aria-tooltip-name.js",KT={title:"ARIA `tooltip` elements have accessible names",failureTitle:"ARIA `tooltip` elements do not have accessible names.",description:"When a tooltip element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to name `tooltip` elements](https://dequeuniversity.com/rules/axe/4.7/aria-tooltip-name)."}),JT=class extends aE{static{o(this,"AriaTooltipName")}static get meta(){return{id:"aria-tooltip-name",title:YT(KT.title),failureTitle:YT(KT.failureTitle),description:YT(KT.description),requiredArtifacts:["Accessibility"]}}},ZT=JT})),QT={};c(QT,{UIStrings:()=>eS,default:()=>nS});var eS,tS,aS,nS,rS=s((()=>{J(),rE(),ro(),tS=eo("core/audits/accessibility/aria-treeitem-name.js",eS={title:"ARIA `treeitem` elements have accessible names",failureTitle:"ARIA `treeitem` elements do not have accessible names.",description:"When a `treeitem` element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more about labeling `treeitem` elements](https://dequeuniversity.com/rules/axe/4.7/aria-treeitem-name)."}),aS=class extends aE{static{o(this,"AriaTreeitemName")}static get meta(){return{id:"aria-treeitem-name",title:tS(eS.title),failureTitle:tS(eS.failureTitle),description:tS(eS.description),requiredArtifacts:["Accessibility"]}}},nS=aS})),iS={};c(iS,{UIStrings:()=>oS,default:()=>cS});var oS,sS,lS,cS,uS=s((()=>{J(),rE(),ro(),sS=eo("core/audits/accessibility/aria-valid-attr-value.js",oS={title:"`[aria-*]` attributes have valid values",failureTitle:"`[aria-*]` attributes do not have valid values",description:"Assistive technologies, like screen readers, can't interpret ARIA attributes with invalid values. [Learn more about valid values for ARIA attributes](https://dequeuniversity.com/rules/axe/4.7/aria-valid-attr-value)."}),lS=class extends aE{static{o(this,"ARIAValidAttr")}static get meta(){return{id:"aria-valid-attr-value",title:sS(oS.title),failureTitle:sS(oS.failureTitle),description:sS(oS.description),requiredArtifacts:["Accessibility"]}}},cS=lS})),dS={};c(dS,{UIStrings:()=>mS,default:()=>gS});var mS,pS,hS,gS,fS=s((()=>{J(),rE(),ro(),pS=eo("core/audits/accessibility/aria-valid-attr.js",mS={title:"`[aria-*]` attributes are valid and not misspelled",failureTitle:"`[aria-*]` attributes are not valid or misspelled",description:"Assistive technologies, like screen readers, can't interpret ARIA attributes with invalid names. [Learn more about valid ARIA attributes](https://dequeuniversity.com/rules/axe/4.7/aria-valid-attr)."}),hS=class extends aE{static{o(this,"ARIAValidAttr")}static get meta(){return{id:"aria-valid-attr",title:pS(mS.title),failureTitle:pS(mS.failureTitle),description:pS(mS.description),requiredArtifacts:["Accessibility"]}}},gS=hS})),yS={};c(yS,{UIStrings:()=>vS,default:()=>DS});var vS,bS,wS,DS,ES=s((()=>{J(),rE(),ro(),bS=eo("core/audits/accessibility/button-name.js",vS={title:"Buttons have an accessible name",failureTitle:"Buttons do not have an accessible name",description:'When a button doesn\'t have an accessible name, screen readers announce it as "button", making it unusable for users who rely on screen readers. [Learn how to make buttons more accessible](https://dequeuniversity.com/rules/axe/4.7/button-name).'}),wS=class extends aE{static{o(this,"ButtonName")}static get meta(){return{id:"button-name",title:bS(vS.title),failureTitle:bS(vS.failureTitle),description:bS(vS.description),requiredArtifacts:["Accessibility"]}}},DS=wS})),TS={};c(TS,{UIStrings:()=>SS,default:()=>xS});var SS,CS,kS,xS,AS=s((()=>{J(),rE(),ro(),CS=eo("core/audits/accessibility/bypass.js",SS={title:"The page contains a heading, skip link, or landmark region",failureTitle:"The page does not contain a heading, skip link, or landmark region",description:"Adding ways to bypass repetitive content lets keyboard users navigate the page more efficiently. [Learn more about bypass blocks](https://dequeuniversity.com/rules/axe/4.7/bypass)."}),kS=class extends aE{static{o(this,"Bypass")}static get meta(){return{id:"bypass",title:CS(SS.title),failureTitle:CS(SS.failureTitle),description:CS(SS.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},xS=kS})),_S={};c(_S,{UIStrings:()=>RS,default:()=>IS});var RS,FS,NS,IS,MS=s((()=>{J(),rE(),ro(),FS=eo("core/audits/accessibility/color-contrast.js",RS={title:"Background and foreground colors have a sufficient contrast ratio",failureTitle:"Background and foreground colors do not have a sufficient contrast ratio.",description:"Low-contrast text is difficult or impossible for many users to read. [Learn how to provide sufficient color contrast](https://dequeuniversity.com/rules/axe/4.7/color-contrast)."}),NS=class extends aE{static{o(this,"ColorContrast")}static get meta(){return{id:"color-contrast",title:FS(RS.title),failureTitle:FS(RS.failureTitle),description:FS(RS.description),requiredArtifacts:["Accessibility"]}}},IS=NS})),PS={};c(PS,{UIStrings:()=>LS,default:()=>US});var LS,OS,jS,US,BS=s((()=>{J(),rE(),ro(),OS=eo("core/audits/accessibility/definition-list.js",LS={title:"`<dl>`'s contain only properly-ordered `<dt>` and `<dd>` groups, `<script>`, `<template>` or `<div>` elements.",failureTitle:"`<dl>`'s do not contain only properly-ordered `<dt>` and `<dd>` groups, `<script>`, `<template>` or `<div>` elements.",description:"When definition lists are not properly marked up, screen readers may produce confusing or inaccurate output. [Learn how to structure definition lists correctly](https://dequeuniversity.com/rules/axe/4.7/definition-list)."}),jS=class extends aE{static{o(this,"DefinitionList")}static get meta(){return{id:"definition-list",title:OS(LS.title),failureTitle:OS(LS.failureTitle),description:OS(LS.description),requiredArtifacts:["Accessibility"]}}},US=jS})),qS={};c(qS,{UIStrings:()=>zS,default:()=>HS});var zS,VS,WS,HS,GS=s((()=>{J(),rE(),ro(),VS=eo("core/audits/accessibility/dlitem.js",zS={title:"Definition list items are wrapped in `<dl>` elements",failureTitle:"Definition list items are not wrapped in `<dl>` elements",description:"Definition list items (`<dt>` and `<dd>`) must be wrapped in a parent `<dl>` element to ensure that screen readers can properly announce them. [Learn how to structure definition lists correctly](https://dequeuniversity.com/rules/axe/4.7/dlitem)."}),WS=class extends aE{static{o(this,"DLItem")}static get meta(){return{id:"dlitem",title:VS(zS.title),failureTitle:VS(zS.failureTitle),description:VS(zS.description),requiredArtifacts:["Accessibility"]}}},HS=WS})),$S={};c($S,{UIStrings:()=>KS,default:()=>ZS});var KS,YS,JS,ZS,XS=s((()=>{J(),rE(),ro(),YS=eo("core/audits/accessibility/document-title.js",KS={title:"Document has a `<title>` element",failureTitle:"Document doesn't have a `<title>` element",description:"The title gives screen reader users an overview of the page, and search engine users rely on it heavily to determine if a page is relevant to their search. [Learn more about document titles](https://dequeuniversity.com/rules/axe/4.7/document-title)."}),JS=class extends aE{static{o(this,"DocumentTitle")}static get meta(){return{id:"document-title",title:YS(KS.title),failureTitle:YS(KS.failureTitle),description:YS(KS.description),requiredArtifacts:["Accessibility"]}}},ZS=JS})),QS={};c(QS,{UIStrings:()=>eC,default:()=>nC});var eC,tC,aC,nC,rC=s((()=>{J(),rE(),ro(),tC=eo("core/audits/accessibility/duplicate-id-active.js",eC={title:"`[id]` attributes on active, focusable elements are unique",failureTitle:"`[id]` attributes on active, focusable elements are not unique",description:"All focusable elements must have a unique `id` to ensure that they're visible to assistive technologies. [Learn how to fix duplicate `id`s](https://dequeuniversity.com/rules/axe/4.7/duplicate-id-active)."}),aC=class extends aE{static{o(this,"DuplicateIdActive")}static get meta(){return{id:"duplicate-id-active",title:tC(eC.title),failureTitle:tC(eC.failureTitle),description:tC(eC.description),requiredArtifacts:["Accessibility"]}}},nC=aC})),iC={};c(iC,{UIStrings:()=>oC,default:()=>cC});var oC,sC,lC,cC,uC=s((()=>{J(),rE(),ro(),sC=eo("core/audits/accessibility/duplicate-id-aria.js",oC={title:"ARIA IDs are unique",failureTitle:"ARIA IDs are not unique",description:"The value of an ARIA ID must be unique to prevent other instances from being overlooked by assistive technologies. [Learn how to fix duplicate ARIA IDs](https://dequeuniversity.com/rules/axe/4.7/duplicate-id-aria)."}),lC=class extends aE{static{o(this,"DuplicateIdAria")}static get meta(){return{id:"duplicate-id-aria",title:sC(oC.title),failureTitle:sC(oC.failureTitle),description:sC(oC.description),requiredArtifacts:["Accessibility"]}}},cC=lC})),dC={};c(dC,{UIStrings:()=>mC,default:()=>gC});var mC,pC,hC,gC,fC=s((()=>{J(),rE(),ro(),pC=eo("core/audits/accessibility/empty-heading.js",mC={title:"All heading elements contain content.",failureTitle:"Heading elements do not contain content.",description:"A heading with no content or inaccessible text prevent screen reader users from accessing information on the page's structure. [Learn more about headings](https://dequeuniversity.com/rules/axe/4.7/empty-heading)."}),hC=class extends aE{static{o(this,"EmptyHeading")}static get meta(){return{id:"empty-heading",title:pC(mC.title),failureTitle:pC(mC.failureTitle),description:pC(mC.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},gC=hC})),yC={};c(yC,{UIStrings:()=>vC,default:()=>DC});var vC,bC,wC,DC,EC=s((()=>{J(),rE(),ro(),bC=eo("core/audits/accessibility/form-field-multiple-labels.js",vC={title:"No form fields have multiple labels",failureTitle:"Form fields have multiple labels",description:"Form fields with multiple labels can be confusingly announced by assistive technologies like screen readers which use either the first, the last, or all of the labels. [Learn how to use form labels](https://dequeuniversity.com/rules/axe/4.7/form-field-multiple-labels)."}),wC=class extends aE{static{o(this,"FormFieldMultipleLabels")}static get meta(){return{id:"form-field-multiple-labels",title:bC(vC.title),failureTitle:bC(vC.failureTitle),description:bC(vC.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},DC=wC})),TC={};c(TC,{UIStrings:()=>SC,default:()=>xC});var SC,CC,kC,xC,AC=s((()=>{J(),rE(),ro(),CC=eo("core/audits/accessibility/frame-title.js",SC={title:"`<frame>` or `<iframe>` elements have a title",failureTitle:"`<frame>` or `<iframe>` elements do not have a title",description:"Screen reader users rely on frame titles to describe the contents of frames. [Learn more about frame titles](https://dequeuniversity.com/rules/axe/4.7/frame-title)."}),kC=class extends aE{static{o(this,"FrameTitle")}static get meta(){return{id:"frame-title",title:CC(SC.title),failureTitle:CC(SC.failureTitle),description:CC(SC.description),requiredArtifacts:["Accessibility"]}}},xC=kC})),_C={};c(_C,{UIStrings:()=>RC,default:()=>IC});var RC,FC,NC,IC,MC=s((()=>{J(),rE(),ro(),FC=eo("core/audits/accessibility/heading-order.js",RC={title:"Heading elements appear in a sequentially-descending order",failureTitle:"Heading elements are not in a sequentially-descending order",description:"Properly ordered headings that do not skip levels convey the semantic structure of the page, making it easier to navigate and understand when using assistive technologies. [Learn more about heading order](https://dequeuniversity.com/rules/axe/4.7/heading-order)."}),NC=class extends aE{static{o(this,"HeadingOrder")}static get meta(){return{id:"heading-order",title:FC(RC.title),failureTitle:FC(RC.failureTitle),description:FC(RC.description),requiredArtifacts:["Accessibility"]}}},IC=NC})),PC={};c(PC,{UIStrings:()=>LC,default:()=>UC});var LC,OC,jC,UC,BC=s((()=>{J(),rE(),ro(),OC=eo("core/audits/accessibility/html-has-lang.js",LC={title:"`<html>` element has a `[lang]` attribute",failureTitle:"`<html>` element does not have a `[lang]` attribute",description:"If a page doesn't specify a `lang` attribute, a screen reader assumes that the page is in the default language that the user chose when setting up the screen reader. If the page isn't actually in the default language, then the screen reader might not announce the page's text correctly. [Learn more about the `lang` attribute](https://dequeuniversity.com/rules/axe/4.7/html-has-lang)."}),jC=class extends aE{static{o(this,"HTMLHasLang")}static get meta(){return{id:"html-has-lang",title:OC(LC.title),failureTitle:OC(LC.failureTitle),description:OC(LC.description),requiredArtifacts:["Accessibility"]}}},UC=jC})),qC={};c(qC,{UIStrings:()=>zC,default:()=>HC});var zC,VC,WC,HC,GC=s((()=>{J(),rE(),ro(),VC=eo("core/audits/accessibility/html-lang-valid.js",zC={title:"`<html>` element has a valid value for its `[lang]` attribute",failureTitle:"`<html>` element does not have a valid value for its `[lang]` attribute.",description:"Specifying a valid [BCP 47 language](https://www.w3.org/International/questions/qa-choosing-language-tags#question) helps screen readers announce text properly. [Learn how to use the `lang` attribute](https://dequeuniversity.com/rules/axe/4.7/html-lang-valid)."}),WC=class extends aE{static{o(this,"HTMLLangValid")}static get meta(){return{id:"html-lang-valid",title:VC(zC.title),failureTitle:VC(zC.failureTitle),description:VC(zC.description),requiredArtifacts:["Accessibility"]}}},HC=WC})),$C={};c($C,{UIStrings:()=>KC,default:()=>ZC});var KC,YC,JC,ZC,XC=s((()=>{J(),rE(),ro(),YC=eo("core/audits/accessibility/html-xml-lang-mismatch.js",KC={title:"`<html>` element has an `[xml:lang]` attribute with the same base language as the `[lang]` attribute.",failureTitle:"`<html>` element does not have an `[xml:lang]` attribute with the same base language as the `[lang]` attribute.",description:"If the webpage does not specify a consistent language, then the screen reader might not announce the page's text correctly. [Learn more about the `lang` attribute](https://dequeuniversity.com/rules/axe/4.7/html-xml-lang-mismatch)."}),JC=class extends aE{static{o(this,"HTMLXMLLangMismatch")}static get meta(){return{id:"html-xml-lang-mismatch",title:YC(KC.title),failureTitle:YC(KC.failureTitle),description:YC(KC.description),requiredArtifacts:["Accessibility"]}}},ZC=JC})),QC={};c(QC,{UIStrings:()=>ek,default:()=>nk});var ek,tk,ak,nk,rk=s((()=>{J(),rE(),ro(),tk=eo("core/audits/accessibility/identical-links-same-purpose.js",ek={title:"Identical links have the same purpose.",failureTitle:"Identical links do not have the same purpose.",description:"Links with the same destination should have the same description, to help users understand the link's purpose and decide whether to follow it. [Learn more about identical links](https://dequeuniversity.com/rules/axe/4.7/identical-links-same-purpose)."}),ak=class extends aE{static{o(this,"IdenticalLinksSamePurpose")}static get meta(){return{id:"identical-links-same-purpose",title:tk(ek.title),failureTitle:tk(ek.failureTitle),description:tk(ek.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},nk=ak})),ik={};c(ik,{UIStrings:()=>ok,default:()=>ck});var ok,sk,lk,ck,uk=s((()=>{J(),rE(),ro(),sk=eo("core/audits/accessibility/image-alt.js",ok={title:"Image elements have `[alt]` attributes",failureTitle:"Image elements do not have `[alt]` attributes",description:"Informative elements should aim for short, descriptive alternate text. Decorative elements can be ignored with an empty alt attribute. [Learn more about the `alt` attribute](https://dequeuniversity.com/rules/axe/4.7/image-alt)."}),lk=class extends aE{static{o(this,"ImageAlt")}static get meta(){return{id:"image-alt",title:sk(ok.title),failureTitle:sk(ok.failureTitle),description:sk(ok.description),requiredArtifacts:["Accessibility"]}}},ck=lk})),dk={};c(dk,{UIStrings:()=>mk,default:()=>gk});var mk,pk,hk,gk,fk=s((()=>{J(),rE(),ro(),pk=eo("core/audits/accessibility/image-redundant-alt.js",mk={title:"Image elements do not have `[alt]` attributes that are redundant text.",failureTitle:"Image elements have `[alt]` attributes that are redundant text.",description:"Informative elements should aim for short, descriptive alternative text. Alternative text that is exactly the same as the text adjacent to the link or image is potentially confusing for screen reader users, because the text will be read twice. [Learn more about the `alt` attribute](https://dequeuniversity.com/rules/axe/4.7/image-redundant-alt)."}),hk=class extends aE{static{o(this,"ImageRedundantAlt")}static get meta(){return{id:"image-redundant-alt",title:pk(mk.title),failureTitle:pk(mk.failureTitle),description:pk(mk.description),requiredArtifacts:["Accessibility"]}}},gk=hk})),yk={};c(yk,{UIStrings:()=>vk,default:()=>Dk});var vk,bk,wk,Dk,Ek=s((()=>{J(),rE(),ro(),bk=eo("core/audits/accessibility/input-button-name.js",vk={title:"Input buttons have discernible text.",failureTitle:"Input buttons do not have discernible text.",description:"Adding discernable and accessible text to input buttons may help screen reader users understand the purpose of the input button. [Learn more about input buttons](https://dequeuniversity.com/rules/axe/4.7/input-button-name)."}),wk=class extends aE{static{o(this,"InputButtonName")}static get meta(){return{id:"input-button-name",title:bk(vk.title),failureTitle:bk(vk.failureTitle),description:bk(vk.description),requiredArtifacts:["Accessibility"]}}},Dk=wk})),Tk={};c(Tk,{UIStrings:()=>Sk,default:()=>xk});var Sk,Ck,kk,xk,Ak=s((()=>{J(),rE(),ro(),Ck=eo("core/audits/accessibility/input-image-alt.js",Sk={title:'`<input type="image">` elements have `[alt]` text',failureTitle:'`<input type="image">` elements do not have `[alt]` text',description:"When an image is being used as an `<input>` button, providing alternative text can help screen reader users understand the purpose of the button. [Learn about input image alt text](https://dequeuniversity.com/rules/axe/4.7/input-image-alt)."}),kk=class extends aE{static{o(this,"InputImageAlt")}static get meta(){return{id:"input-image-alt",title:Ck(Sk.title),failureTitle:Ck(Sk.failureTitle),description:Ck(Sk.description),requiredArtifacts:["Accessibility"]}}},xk=kk})),_k={};c(_k,{UIStrings:()=>Rk,default:()=>Ik});var Rk,Fk,Nk,Ik,Mk=s((()=>{J(),rE(),ro(),Fk=eo("core/audits/accessibility/label-content-name-mismatch.js",Rk={title:"Elements with visible text labels have matching accessible names.",failureTitle:"Elements with visible text labels do not have matching accessible names.",description:"Visible text labels that do not match the accessible name can result in a confusing experience for screen reader users. [Learn more about accessible names](https://dequeuniversity.com/rules/axe/4.7/label-content-name-mismatch)."}),Nk=class extends aE{static{o(this,"LabelContentNameMismatch")}static get meta(){return{id:"label-content-name-mismatch",title:Fk(Rk.title),failureTitle:Fk(Rk.failureTitle),description:Fk(Rk.description),requiredArtifacts:["Accessibility"]}}},Ik=Nk})),Pk={};c(Pk,{UIStrings:()=>Lk,default:()=>Uk});var Lk,Ok,jk,Uk,Bk=s((()=>{J(),rE(),ro(),Ok=eo("core/audits/accessibility/label.js",Lk={title:"Form elements have associated labels",failureTitle:"Form elements do not have associated labels",description:"Labels ensure that form controls are announced properly by assistive technologies, like screen readers. [Learn more about form element labels](https://dequeuniversity.com/rules/axe/4.7/label)."}),jk=class extends aE{static{o(this,"Label")}static get meta(){return{id:"label",title:Ok(Lk.title),failureTitle:Ok(Lk.failureTitle),description:Ok(Lk.description),requiredArtifacts:["Accessibility"]}}},Uk=jk})),qk={};c(qk,{UIStrings:()=>zk,default:()=>Hk});var zk,Vk,Wk,Hk,Gk=s((()=>{J(),rE(),ro(),Vk=eo("core/audits/accessibility/landmark-one-main.js",zk={title:"Document has a main landmark.",failureTitle:"Document does not have a main landmark.",description:"One main landmark helps screen reader users navigate a web page. [Learn more about landmarks](https://dequeuniversity.com/rules/axe/4.7/landmark-one-main)."}),Wk=class extends aE{static{o(this,"LandmarkOneMain")}static get meta(){return{id:"landmark-one-main",title:Vk(zk.title),failureTitle:Vk(zk.failureTitle),description:Vk(zk.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},Hk=Wk})),$k={};c($k,{UIStrings:()=>Kk,default:()=>Zk});var Kk,Yk,Jk,Zk,Xk=s((()=>{J(),rE(),ro(),Yk=eo("core/audits/accessibility/link-in-text-block.js",Kk={title:"Links are distinguishable without relying on color.",failureTitle:"Links rely on color to be distinguishable.",description:"Low-contrast text is difficult or impossible for many users to read. Link text that is discernible improves the experience for users with low vision. [Learn how to make links distinguishable](https://dequeuniversity.com/rules/axe/4.7/link-in-text-block)."}),Jk=class extends aE{static{o(this,"LinkInTextBlock")}static get meta(){return{id:"link-in-text-block",title:Yk(Kk.title),failureTitle:Yk(Kk.failureTitle),description:Yk(Kk.description),requiredArtifacts:["Accessibility"]}}},Zk=Jk})),Qk={};c(Qk,{UIStrings:()=>ex,default:()=>nx});var ex,tx,ax,nx,rx=s((()=>{J(),rE(),ro(),tx=eo("core/audits/accessibility/link-name.js",ex={title:"Links have a discernible name",failureTitle:"Links do not have a discernible name",description:"Link text (and alternate text for images, when used as links) that is discernible, unique, and focusable improves the navigation experience for screen reader users. [Learn how to make links accessible](https://dequeuniversity.com/rules/axe/4.7/link-name)."}),ax=class extends aE{static{o(this,"LinkName")}static get meta(){return{id:"link-name",title:tx(ex.title),failureTitle:tx(ex.failureTitle),description:tx(ex.description),requiredArtifacts:["Accessibility"]}}},nx=ax})),ix={};c(ix,{UIStrings:()=>ox,default:()=>cx});var ox,sx,lx,cx,ux=s((()=>{J(),rE(),ro(),sx=eo("core/audits/accessibility/list.js",ox={title:"Lists contain only `<li>` elements and script supporting elements (`<script>` and `<template>`).",failureTitle:"Lists do not contain only `<li>` elements and script supporting elements (`<script>` and `<template>`).",description:"Screen readers have a specific way of announcing lists. Ensuring proper list structure aids screen reader output. [Learn more about proper list structure](https://dequeuniversity.com/rules/axe/4.7/list)."}),lx=class extends aE{static{o(this,"List")}static get meta(){return{id:"list",title:sx(ox.title),failureTitle:sx(ox.failureTitle),description:sx(ox.description),requiredArtifacts:["Accessibility"]}}},cx=lx})),dx={};c(dx,{UIStrings:()=>mx,default:()=>gx});var mx,px,hx,gx,fx,yx,vx=s((()=>{J(),rE(),ro(),px=eo("core/audits/accessibility/listitem.js",mx={title:"List items (`<li>`) are contained within `<ul>`, `<ol>` or `<menu>` parent elements",failureTitle:"List items (`<li>`) are not contained within `<ul>`, `<ol>` or `<menu>` parent elements.",description:"Screen readers require list items (`<li>`) to be contained within a parent `<ul>`, `<ol>` or `<menu>` to be announced properly. [Learn more about proper list structure](https://dequeuniversity.com/rules/axe/4.7/listitem)."}),hx=class extends aE{static{o(this,"ListItem")}static get meta(){return{id:"listitem",title:px(mx.title),failureTitle:px(mx.failureTitle),description:px(mx.description),requiredArtifacts:["Accessibility"]}}},gx=hx})),bx=s((()=>{J(),xr(),fx=class extends Dr{static{o(this,"ManualAudit")}static get partialMeta(){return{scoreDisplayMode:Dr.SCORING_MODES.MANUAL,requiredArtifacts:[]}}static audit(){return{score:0}}},yx=fx})),wx={};c(wx,{default:()=>Ex});var Dx,Ex,Tx=s((()=>{J(),bx(),Dx=class extends yx{static{o(this,"CustomControlsLabels")}static get meta(){return Object.assign({id:"custom-controls-labels",description:"Custom interactive controls have associated labels, provided by aria-label or aria-labelledby. [Learn more about custom controls and labels](https://developer.chrome.com/docs/lighthouse/accessibility/custom-controls-labels/).",title:"Custom controls have associated labels"},super.partialMeta)}},Ex=Dx})),Sx={};c(Sx,{default:()=>kx});var Cx,kx,xx=s((()=>{J(),bx(),Cx=class extends yx{static{o(this,"CustomControlsRoles")}static get meta(){return Object.assign({id:"custom-controls-roles",description:"Custom interactive controls have appropriate ARIA roles. [Learn how to add roles to custom controls](https://developer.chrome.com/docs/lighthouse/accessibility/custom-control-roles/).",title:"Custom controls have ARIA roles"},super.partialMeta)}},kx=Cx})),Ax={};c(Ax,{default:()=>Rx});var _x,Rx,Fx=s((()=>{J(),bx(),_x=class extends yx{static{o(this,"FocusTraps")}static get meta(){return Object.assign({id:"focus-traps",description:"A user can tab into and out of any control or region without accidentally trapping their focus. [Learn how to avoid focus traps](https://developer.chrome.com/docs/lighthouse/accessibility/focus-traps/).",title:"User focus is not accidentally trapped in a region"},super.partialMeta)}},Rx=_x})),Nx={};c(Nx,{default:()=>Mx});var Ix,Mx,Px=s((()=>{J(),bx(),Ix=class extends yx{static{o(this,"FocusableControls")}static get meta(){return Object.assign({id:"focusable-controls",description:"Custom interactive controls are keyboard focusable and display a focus indicator. [Learn how to make custom controls focusable](https://developer.chrome.com/docs/lighthouse/accessibility/focusable-controls/).",title:"Interactive controls are keyboard focusable"},super.partialMeta)}},Mx=Ix})),Lx={};c(Lx,{default:()=>jx});var Ox,jx,Ux=s((()=>{J(),bx(),Ox=class extends yx{static{o(this,"InteractiveElementAffordance")}static get meta(){return Object.assign({id:"interactive-element-affordance",description:"Interactive elements, such as links and buttons, should indicate their state and be distinguishable from non-interactive elements. [Learn how to decorate interactive elements with affordance hints](https://developer.chrome.com/docs/lighthouse/accessibility/interactive-element-affordance/).",title:"Interactive elements indicate their purpose and state"},super.partialMeta)}},jx=Ox})),Bx={};c(Bx,{default:()=>zx});var qx,zx,Vx=s((()=>{J(),bx(),qx=class extends yx{static{o(this,"LogicalTabOrder")}static get meta(){return Object.assign({id:"logical-tab-order",description:"Tabbing through the page follows the visual layout. Users cannot focus elements that are offscreen. [Learn more about logical tab ordering](https://developer.chrome.com/docs/lighthouse/accessibility/logical-tab-order/).",title:"The page has a logical tab order"},super.partialMeta)}},zx=qx})),Wx={};c(Wx,{default:()=>Gx});var Hx,Gx,$x=s((()=>{J(),bx(),Hx=class extends yx{static{o(this,"ManagedFocus")}static get meta(){return Object.assign({id:"managed-focus",description:"If new content, such as a dialog, is added to the page, the user's focus is directed to it. [Learn how to direct focus to new content](https://developer.chrome.com/docs/lighthouse/accessibility/managed-focus/).",title:"The user's focus is directed to new content added to the page"},super.partialMeta)}},Gx=Hx})),Kx={};c(Kx,{default:()=>Jx});var Yx,Jx,Zx=s((()=>{J(),bx(),Yx=class extends yx{static{o(this,"OffscreenContentHidden")}static get meta(){return Object.assign({id:"offscreen-content-hidden",description:"Offscreen content is hidden with display: none or aria-hidden=true. [Learn how to properly hide offscreen content](https://developer.chrome.com/docs/lighthouse/accessibility/offscreen-content-hidden/).",title:"Offscreen content is hidden from assistive technology"},super.partialMeta)}},Jx=Yx})),Xx={};c(Xx,{default:()=>eA});var Qx,eA,tA=s((()=>{J(),bx(),Qx=class extends yx{static{o(this,"UseLandmarks")}static get meta(){return Object.assign({id:"use-landmarks",description:"Landmark elements (`<main>`, `<nav>`, etc.) are used to improve the keyboard navigation of the page for assistive technology. [Learn more about landmark elements](https://developer.chrome.com/docs/lighthouse/accessibility/use-landmarks/).",title:"HTML5 landmark elements are used to improve navigation"},super.partialMeta)}},eA=Qx})),aA={};c(aA,{default:()=>rA});var nA,rA,iA=s((()=>{J(),bx(),nA=class extends yx{static{o(this,"VisualOrderFollowsDOM")}static get meta(){return Object.assign({id:"visual-order-follows-dom",description:"DOM order matches the visual order, improving navigation for assistive technology. [Learn more about DOM and visual ordering](https://developer.chrome.com/docs/lighthouse/accessibility/visual-order-follows-dom/).",title:"Visual order on the page follows DOM order"},super.partialMeta)}},rA=nA})),oA={};c(oA,{UIStrings:()=>sA,default:()=>uA});var sA,lA,cA,uA,dA=s((()=>{J(),rE(),ro(),lA=eo("core/audits/accessibility/meta-refresh.js",sA={title:'The document does not use `<meta http-equiv="refresh">`',failureTitle:'The document uses `<meta http-equiv="refresh">`',description:"Users do not expect a page to refresh automatically, and doing so will move focus back to the top of the page. This may create a frustrating or confusing experience. [Learn more about the refresh meta tag](https://dequeuniversity.com/rules/axe/4.7/meta-refresh)."}),cA=class extends aE{static{o(this,"MetaRefresh")}static get meta(){return{id:"meta-refresh",title:lA(sA.title),failureTitle:lA(sA.failureTitle),description:lA(sA.description),requiredArtifacts:["Accessibility"]}}},uA=cA})),mA={};c(mA,{UIStrings:()=>pA,default:()=>fA});var pA,hA,gA,fA,yA=s((()=>{J(),rE(),ro(),hA=eo("core/audits/accessibility/meta-viewport.js",pA={title:'`[user-scalable="no"]` is not used in the `<meta name="viewport">` element and the `[maximum-scale]` attribute is not less than 5.',failureTitle:'`[user-scalable="no"]` is used in the `<meta name="viewport">` element or the `[maximum-scale]` attribute is less than 5.',description:"Disabling zooming is problematic for users with low vision who rely on screen magnification to properly see the contents of a web page. [Learn more about the viewport meta tag](https://dequeuniversity.com/rules/axe/4.7/meta-viewport)."}),gA=class extends aE{static{o(this,"MetaViewport")}static get meta(){return{id:"meta-viewport",title:hA(pA.title),failureTitle:hA(pA.failureTitle),description:hA(pA.description),requiredArtifacts:["Accessibility"]}}},fA=gA})),vA={};c(vA,{UIStrings:()=>bA,default:()=>EA});var bA,wA,DA,EA,TA=s((()=>{J(),rE(),ro(),wA=eo("core/audits/accessibility/object-alt.js",bA={title:"`<object>` elements have alternate text",failureTitle:"`<object>` elements do not have alternate text",description:"Screen readers cannot translate non-text content. Adding alternate text to `<object>` elements helps screen readers convey meaning to users. [Learn more about alt text for `object` elements](https://dequeuniversity.com/rules/axe/4.7/object-alt)."}),DA=class extends aE{static{o(this,"ObjectAlt")}static get meta(){return{id:"object-alt",title:wA(bA.title),failureTitle:wA(bA.failureTitle),description:wA(bA.description),requiredArtifacts:["Accessibility"]}}},EA=DA})),SA={};c(SA,{UIStrings:()=>CA,default:()=>AA});var CA,kA,xA,AA,_A=s((()=>{J(),rE(),ro(),kA=eo("core/audits/accessibility/select-name.js",CA={title:"Select elements have associated label elements.",failureTitle:"Select elements do not have associated label elements.",description:"Form elements without effective labels can create frustrating experiences for screen reader users. [Learn more about the `select` element](https://dequeuniversity.com/rules/axe/4.7/select-name)."}),xA=class extends aE{static{o(this,"SelectName")}static get meta(){return{id:"select-name",title:kA(CA.title),failureTitle:kA(CA.failureTitle),description:kA(CA.description),requiredArtifacts:["Accessibility"]}}},AA=xA})),RA={};c(RA,{UIStrings:()=>FA,default:()=>MA});var FA,NA,IA,MA,PA=s((()=>{J(),rE(),ro(),NA=eo("core/audits/accessibility/skip-link.js",FA={title:"Skip links are focusable.",failureTitle:"Skip links are not focusable.",description:"Including a skip link can help users skip to the main content to save time. [Learn more about skip links](https://dequeuniversity.com/rules/axe/4.7/skip-link)."}),IA=class extends aE{static{o(this,"SkipLink")}static get meta(){return{id:"skip-link",title:NA(FA.title),failureTitle:NA(FA.failureTitle),description:NA(FA.description),requiredArtifacts:["Accessibility"]}}},MA=IA})),LA={};c(LA,{UIStrings:()=>OA,default:()=>BA});var OA,jA,UA,BA,qA=s((()=>{J(),rE(),ro(),jA=eo("core/audits/accessibility/tabindex.js",OA={title:"No element has a `[tabindex]` value greater than 0",failureTitle:"Some elements have a `[tabindex]` value greater than 0",description:"A value greater than 0 implies an explicit navigation ordering. Although technically valid, this often creates frustrating experiences for users who rely on assistive technologies. [Learn more about the `tabindex` attribute](https://dequeuniversity.com/rules/axe/4.7/tabindex)."}),UA=class extends aE{static{o(this,"TabIndex")}static get meta(){return{id:"tabindex",title:jA(OA.title),failureTitle:jA(OA.failureTitle),description:jA(OA.description),requiredArtifacts:["Accessibility"]}}},BA=UA})),zA={};c(zA,{UIStrings:()=>VA,default:()=>GA});var VA,WA,HA,GA,$A=s((()=>{J(),rE(),ro(),WA=eo("core/audits/accessibility/table-duplicate-name.js",VA={title:"Tables have different content in the summary attribute and `<caption>`.",failureTitle:"Tables have the same content in the summary attribute and `<caption>.`",description:"The summary attribute should describe the table structure, while `<caption>` should have the onscreen title. Accurate table mark-up helps users of screen readers. [Learn more about summary and caption](https://dequeuniversity.com/rules/axe/4.7/table-duplicate-name)."}),HA=class extends aE{static{o(this,"TableDuplicateName")}static get meta(){return{id:"table-duplicate-name",title:WA(VA.title),failureTitle:WA(VA.failureTitle),description:WA(VA.description),requiredArtifacts:["Accessibility"]}}},GA=HA})),KA={};c(KA,{UIStrings:()=>YA,default:()=>XA});var YA,JA,ZA,XA,QA=s((()=>{J(),rE(),ro(),JA=eo("core/audits/accessibility/table-fake-caption.js",YA={title:"Tables use `<caption>` instead of cells with the `[colspan]` attribute to indicate a caption.",failureTitle:"Tables do not use `<caption>` instead of cells with the `[colspan]` attribute to indicate a caption.",description:"Screen readers have features to make navigating tables easier. Ensuring that tables use the actual caption element instead of cells with the `[colspan]` attribute may improve the experience for screen reader users. [Learn more about captions](https://dequeuniversity.com/rules/axe/4.7/table-fake-caption)."}),ZA=class extends aE{static{o(this,"TableFakeCaption")}static get meta(){return{id:"table-fake-caption",title:JA(YA.title),failureTitle:JA(YA.failureTitle),description:JA(YA.description),requiredArtifacts:["Accessibility"]}}},XA=ZA})),e_={};c(e_,{UIStrings:()=>t_,default:()=>r_});var t_,a_,n_,r_,i_=s((()=>{J(),rE(),ro(),a_=eo("core/audits/accessibility/target-size.js",t_={title:"Touch targets have sufficient size and spacing.",failureTitle:"Touch targets do not have sufficient size or spacing.",description:"Touch targets with sufficient size and spacing help users who may have difficulty targeting small controls to activate the targets. [Learn more about touch targets](https://dequeuniversity.com/rules/axe/4.7/target-size)."}),n_=class extends aE{static{o(this,"TargetSize")}static get meta(){return{id:"target-size",title:a_(t_.title),failureTitle:a_(t_.failureTitle),description:a_(t_.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},r_=n_})),o_={};c(o_,{UIStrings:()=>s_,default:()=>u_});var s_,l_,c_,u_,d_=s((()=>{J(),rE(),ro(),l_=eo("core/audits/accessibility/td-has-header.js",s_={title:"`<td>` elements in a large `<table>` have one or more table headers.",failureTitle:"`<td>` elements in a large `<table>` do not have table headers.",description:"Screen readers have features to make navigating tables easier. Ensuring that `<td>` elements in a large table (3 or more cells in width and height) have an associated table header may improve the experience for screen reader users. [Learn more about table headers](https://dequeuniversity.com/rules/axe/4.7/td-has-header)."}),c_=class extends aE{static{o(this,"TDHasHeader")}static get meta(){return{id:"td-has-header",title:l_(s_.title),failureTitle:l_(s_.failureTitle),description:l_(s_.description),requiredArtifacts:["Accessibility"]}}},u_=c_})),m_={};c(m_,{UIStrings:()=>p_,default:()=>f_});var p_,h_,g_,f_,y_=s((()=>{J(),rE(),ro(),h_=eo("core/audits/accessibility/td-headers-attr.js",p_={title:"Cells in a `<table>` element that use the `[headers]` attribute refer to table cells within the same table.",failureTitle:"Cells in a `<table>` element that use the `[headers]` attribute refer to an element `id` not found within the same table.",description:"Screen readers have features to make navigating tables easier. Ensuring `<td>` cells using the `[headers]` attribute only refer to other cells in the same table may improve the experience for screen reader users. [Learn more about the `headers` attribute](https://dequeuniversity.com/rules/axe/4.7/td-headers-attr)."}),g_=class extends aE{static{o(this,"TDHeadersAttr")}static get meta(){return{id:"td-headers-attr",title:h_(p_.title),failureTitle:h_(p_.failureTitle),description:h_(p_.description),requiredArtifacts:["Accessibility"]}}},f_=g_})),v_={};c(v_,{UIStrings:()=>b_,default:()=>E_});var b_,w_,D_,E_,T_=s((()=>{J(),rE(),ro(),w_=eo("core/audits/accessibility/th-has-data-cells.js",b_={title:'`<th>` elements and elements with `[role="columnheader"/"rowheader"]` have data cells they describe.',failureTitle:'`<th>` elements and elements with `[role="columnheader"/"rowheader"]` do not have data cells they describe.',description:"Screen readers have features to make navigating tables easier. Ensuring table headers always refer to some set of cells may improve the experience for screen reader users. [Learn more about table headers](https://dequeuniversity.com/rules/axe/4.7/th-has-data-cells)."}),D_=class extends aE{static{o(this,"THHasDataCells")}static get meta(){return{id:"th-has-data-cells",title:w_(b_.title),failureTitle:w_(b_.failureTitle),description:w_(b_.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},E_=D_})),S_={};c(S_,{UIStrings:()=>C_,default:()=>A_});var C_,k_,x_,A_,__=s((()=>{J(),rE(),ro(),k_=eo("core/audits/accessibility/valid-lang.js",C_={title:"`[lang]` attributes have a valid value",failureTitle:"`[lang]` attributes do not have a valid value",description:"Specifying a valid [BCP 47 language](https://www.w3.org/International/questions/qa-choosing-language-tags#question) on elements helps ensure that text is pronounced correctly by a screen reader. [Learn how to use the `lang` attribute](https://dequeuniversity.com/rules/axe/4.7/valid-lang)."}),x_=class extends aE{static{o(this,"ValidLang")}static get meta(){return{id:"valid-lang",title:k_(C_.title),failureTitle:k_(C_.failureTitle),description:k_(C_.description),requiredArtifacts:["Accessibility"]}}},A_=x_})),R_={};c(R_,{UIStrings:()=>F_,default:()=>M_});var F_,N_,I_,M_,P_=s((()=>{J(),rE(),ro(),N_=eo("core/audits/accessibility/video-caption.js",F_={title:'`<video>` elements contain a `<track>` element with `[kind="captions"]`',failureTitle:'`<video>` elements do not contain a `<track>` element with `[kind="captions"]`.',description:"When a video provides a caption it is easier for deaf and hearing impaired users to access its information. [Learn more about video captions](https://dequeuniversity.com/rules/axe/4.7/video-caption)."}),I_=class extends aE{static{o(this,"VideoCaption")}static get meta(){return{id:"video-caption",title:N_(F_.title),failureTitle:N_(F_.failureTitle),description:N_(F_.description),scoreDisplayMode:aE.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},M_=I_})),L_={};c(L_,{UIStrings:()=>O_,default:()=>V_});var O_,j_,U_,B_,q_,z_,V_,W_,H_,G_,$_=s((()=>{J(),ea(),xr(),ro(),j_=eo("core/audits/autocomplete.js",O_={title:"`<input>` elements correctly use `autocomplete`",failureTitle:"`<input>` elements do not have correct `autocomplete` attributes",description:"`autocomplete` helps users submit forms quicker. To reduce user effort, consider enabling by setting the `autocomplete` attribute to a valid value. [Learn more about `autocomplete` in forms](https://developers.google.com/web/fundamentals/design-and-ux/input/forms#use_metadata_to_enable_auto-complete)",columnSuggestions:"Suggested Token",columnCurrent:"Current Value",warningInvalid:'`autocomplete` token(s): "{token}" is invalid in {snippet}',warningOrder:'Review order of tokens: "{tokens}" in {snippet}',reviewOrder:"Review order of tokens",manualReview:"Requires manual review"}),U_=["name","honorific-prefix","given-name","additional-name","family-name","honorific-suffix","nickname","username","new-password","current-password","one-time-code","organization-title","organization","street-address","address-line1","address-line2","address-line3","address-level4","address-level3","address-level2","address-level1","country","country-name","postal-code","cc-name","cc-given-name","cc-additional-name","cc-family-name","cc-number","cc-exp","cc-exp-month","cc-exp-year","cc-csc","cc-type","transaction-currency","transaction-amount","language","bday","bday-day","bday-month","bday-year","sex","url","photo","tel","tel-country-code","tel-national","tel-area-code","on","tel-local","tel-local-prefix","tel-local-suffix","tel-extension","email","impp","off","additional-name-initial","home","work","mobile","fax","pager","shipping","billing"],B_=["NO_SERVER_DATA","UNKNOWN_TYPE","EMPTY_TYPE","HTML_TYPE_UNSPECIFIED","HTML_TYPE_UNRECOGNIZED"],q_={NO_SERVER_DATA:j_(O_.manualReview),UNKNOWN_TYPE:j_(O_.manualReview),EMPTY_TYPE:j_(O_.manualReview),NAME_FIRST:"given-name",NAME_MIDDLE:"additional-name",NAME_LAST:"family-name",NAME_FULL:"name",NAME_MIDDLE_INITIAL:"additional-name-initial",NAME_SUFFIX:"honorific-suffix",NAME_BILLING_FIRST:"billing given-name",NAME_BILLING_MIDDLE:"billing additional-name",NAME_BILLING_LAST:"billing family-name",NAME_BILLING_MIDDLE_INITIAL:"billing additional-name-initial",NAME_BILLING_FULL:"billing name",NAME_BILLING_SUFFIX:"billing honorific-suffix",EMAIL_ADDRESS:"email",MERCHANT_EMAIL_SIGNUP:"email",PHONE_HOME_NUMBER:"tel-local",PHONE_HOME_CITY_CODE:"tel-area-code",PHONE_HOME_COUNTRY_CODE:"tel-country-code",PHONE_HOME_CITY_AND_NUMBER:"tel-national",PHONE_HOME_WHOLE_NUMBER:"tel",PHONE_HOME_EXTENSION:"tel-extension",PHONE_BILLING_NUMBER:"billing tel-local",PHONE_BILLING_CITY_CODE:"billing tel-area-code",PHONE_BILLING_COUNTRY_CODE:"tel-country-code",PHONE_BILLING_CITY_AND_NUMBER:"tel-national",PHONE_BILLING_WHOLE_NUMBER:"tel",ADDRESS_HOME_STREET_ADDRESS:"street-address",ADDRESS_HOME_LINE1:"address-line1",ADDRESS_HOME_LINE2:"address-line2",ADDRESS_HOME_LINE3:"address-line3",ADDRESS_HOME_STATE:"address-level1",ADDRESS_HOME_CITY:"address-level2",ADDRESS_HOME_DEPENDENT_LOCALITY:"address-level3",ADDRESS_HOME_ZIP:"postal-code",ADDRESS_HOME_COUNTRY:"country-name",ADDRESS_BILLING_DEPENDENT_LOCALITY:"billing address-level3",ADDRESS_BILLING_STREET_ADDRESS:"billing street-address",ADDRESS_BILLING_LINE1:"billing address-line1",ADDRESS_BILLING_LINE2:"billing address-line2",ADDRESS_BILLING_LINE3:"billing address-line3",ADDRESS_BILLING_APT_NUM:"billing address-level3",ADDRESS_BILLING_CITY:"billing address-level2",ADDRESS_BILLING_STATE:"billing address-level1",ADDRESS_BILLING_ZIP:"billing postal-code",ADDRESS_BILLING_COUNTRY:"billing country-name",CREDIT_CARD_NAME_FULL:"cc-name",CREDIT_CARD_NAME_FIRST:"cc-given-name",CREDIT_CARD_NAME_LAST:"cc-family-name",CREDIT_CARD_NUMBER:"cc-number",CREDIT_CARD_EXP_MONTH:"cc-exp-month",CREDIT_CARD_EXP_2_DIGIT_YEAR:"cc-exp-year",CREDIT_CARD_EXP_4_DIGIT_YEAR:"cc-exp-year",CREDIT_CARD_EXP_DATE_2_DIGIT_YEAR:"cc-exp",CREDIT_CARD_EXP_DATE_4_DIGIT_YEAR:"cc-exp",CREDIT_CARD_TYPE:"cc-type",CREDIT_CARD_VERIFICATION_CODE:"cc-csc",COMPANY_NAME:"organization",PASSWORD:"current-password",ACCOUNT_CREATION_PASSWORD:"new-password",HTML_TYPE_UNSPECIFIED:j_(O_.manualReview),HTML_TYPE_NAME:"name",HTML_TYPE_HONORIFIC_PREFIX:"honorific-prefix",HTML_TYPE_GIVEN_NAME:"given-name",HTML_TYPE_ADDITIONAL_NAME:"additional-name",HTML_TYPE_FAMILY_NAME:"family-name",HTML_TYPE_ORGANIZATION:"organization",HTML_TYPE_STREET_ADDRESS:"street-address",HTML_TYPE_ADDRESS_LINE1:"address-line1",HTML_TYPE_ADDRESS_LINE2:"address-line2",HTML_TYPE_ADDRESS_LINE3:"address-line3",HTML_TYPE_ADDRESS_LEVEL1:"address-level1",HTML_TYPE_ADDRESS_LEVEL2:"address-level2",HTML_TYPE_ADDRESS_LEVEL3:"address-level3",HTML_TYPE_COUNTRY_CODE:"tel-country-code",HTML_TYPE_COUNTRY_NAME:"country-name",HTML_TYPE_POSTAL_CODE:"postal-code",HTML_TYPE_FULL_ADDRESS:"street-address",HTML_TYPE_CREDIT_CARD_NAME_FULL:"cc-name",HTML_TYPE_CREDIT_CARD_NAME_FIRST:"cc-given-name",HTML_TYPE_CREDIT_CARD_NAME_LAST:"cc-family-name",HTML_TYPE_CREDIT_CARD_NUMBER:"cc-number",HTML_TYPE_CREDIT_CARD_EXP:"cc-exp",HTML_TYPE_CREDIT_CARD_EXP_MONTH:"cc-exp-month",HTML_TYPE_CREDIT_CARD_EXP_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_VERIFICATION_CODE:"cc-csc",HTML_TYPE_CREDIT_CARD_TYPE:"cc-csc",HTML_TYPE_TEL:"tel",HTML_TYPE_TEL_COUNTRY_CODE:"tel-country-code",HTML_TYPE_TEL_NATIONAL:"tel-national",HTML_TYPE_TEL_AREA_CODE:"tel-area-code",HTML_TYPE_TEL_LOCAL:"tel-local",HTML_TYPE_TEL_LOCAL_PREFIX:"tel-local-prefix",HTML_TYPE_TEL_LOCAL_SUFFIX:"tel-local-suffix",HTML_TYPE_TEL_EXTENSION:"tel-extension",HTML_TYPE_EMAIL:"email",HTML_TYPE_ADDITIONAL_NAME_INITIAL:"additional-name-initial",HTML_TYPE_CREDIT_CARD_EXP_DATE_2_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_DATE_4_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_2_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_4_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_UPI_VPA:j_(O_.manualReview),HTML_TYPE_ONE_TIME_CODE:"one-time-code",HTML_TYPE_UNRECOGNIZED:j_(O_.manualReview),HTML_TYPE_TRANSACTION_AMOUNT:"transaction-amount",HTML_TYPE_TRANSACTION_CURRENCY:"transaction-currency"},z_=class extends Dr{static{o(this,"AutocompleteAudit")}static get meta(){return{id:"autocomplete",title:j_(O_.title),failureTitle:j_(O_.failureTitle),description:j_(O_.description),requiredArtifacts:["Inputs"]}}static checkAttributeValidity(e){if(!e.autocomplete.attribute)return{hasValidTokens:!1};let t=e.autocomplete.attribute.split(" ");for(let e of t)if("section-"!==e.slice(0,8)&&!U_.includes(e))return{hasValidTokens:!1};return e.autocomplete.property?{hasValidTokens:!0,isValidOrder:!0}:{hasValidTokens:!0,isValidOrder:!1}}static audit(e){let t=[],a=[],n=!1;for(let r of e.Inputs.inputs){let e=this.checkAttributeValidity(r);if(e.hasValidTokens&&e.isValidOrder||!r.autocomplete.prediction||B_.includes(r.autocomplete.prediction)&&!r.autocomplete.attribute)continue;n=!0;let i=q_[r.autocomplete.prediction];(r.autocomplete.attribute||(r.autocomplete.attribute=""),r.autocomplete.attribute&&a.push(j_(O_.warningInvalid,{token:r.autocomplete.attribute,snippet:r.node.snippet})),!1===e.isValidOrder&&(a.push(j_(O_.warningOrder,{tokens:r.autocomplete.attribute,snippet:r.node.snippet})),i=O_.reviewOrder),r.autocomplete.prediction in q_||!e.isValidOrder)?t.push({node:Dr.makeNodeItem(r.node),suggestion:i,current:r.autocomplete.attribute}):Kt.warn(`Autocomplete prediction (${r.autocomplete.prediction})\n            not found in our mapping`)}let r,i=[{key:"node",valueType:"node",label:j_(no.columnFailingElem)},{key:"current",valueType:"text",label:j_(O_.columnCurrent)},{key:"suggestion",valueType:"text",label:j_(O_.columnSuggestions)}],o=Dr.makeTableDetails(i,t);return t.length>0&&(r=j_(no.displayValueElementsFound,{nodeCount:t.length})),{score:t.length>0?0:1,notApplicable:!n,displayValue:r,details:o,warnings:a}}},V_=z_})),K_=s((()=>{J(),ro(),H_=eo("core/lib/bf-cache-strings.js",W_={notMainFrame:"Navigation happened in a frame other than the main frame.",backForwardCacheDisabled:"Back/forward cache is disabled by flags. Visit chrome://flags/#back-forward-cache to enable it locally on this device.",relatedActiveContentsExist:"The page was opened using '`window.open()`' and another tab has a reference to it, or the page opened a window.",HTTPStatusNotOK:"Only pages with a status code of 2XX can be cached.",schemeNotHTTPOrHTTPS:"Only pages whose URL scheme is HTTP / HTTPS can be cached.",loading:"The page did not finish loading before navigating away.",wasGrantedMediaAccess:"Pages that have granted access to record video or audio are not currently eligible for back/forward cache.",HTTPMethodNotGET:"Only pages loaded via a GET request are eligible for back/forward cache.",subframeIsNavigating:"An iframe on the page started a navigation that did not complete.",timeout:"The page exceeded the maximum time in back/forward cache and was expired.",cacheLimit:"The page was evicted from the cache to allow another page to be cached.",JavaScriptExecution:"Chrome detected an attempt to execute JavaScript while in the cache.",rendererProcessKilled:"The renderer process for the page in back/forward cache was killed.",rendererProcessCrashed:"The renderer process for the page in back/forward cache crashed.",grantedMediaStreamAccess:"Pages that have granted media stream access are not currently eligible for back/forward cache.",cacheFlushed:"The cache was intentionally cleared.",serviceWorkerVersionActivation:"The page was evicted from back/forward cache due to a service worker activation.",sessionRestored:"Chrome restarted and cleared the back/forward cache entries.",serviceWorkerPostMessage:"A service worker attempted to send the page in back/forward cache a `MessageEvent`.",enteredBackForwardCacheBeforeServiceWorkerHostAdded:"A service worker was activated while the page was in back/forward cache.",serviceWorkerClaim:"The page was claimed by a service worker while it is in back/forward cache.",haveInnerContents:"Pages that use portals are not currently eligible for back/forward cache.",timeoutPuttingInCache:"The page timed out entering back/forward cache (likely due to long-running pagehide handlers).",backForwardCacheDisabledByLowMemory:"Back/forward cache is disabled due to insufficient memory.",backForwardCacheDisabledByCommandLine:"Back/forward cache is disabled by the command line.",networkRequestDatapipeDrainedAsBytesConsumer:"Pages that have inflight fetch() or XHR are not currently eligible for back/forward cache.",networkRequestRedirected:"The page was evicted from back/forward cache because an active network request involved a redirect.",networkRequestTimeout:"The page was evicted from the cache because a network connection was open too long. Chrome limits the amount of time that a page may receive data while cached.",networkExceedsBufferLimit:"The page was evicted from the cache because an active network connection received too much data. Chrome limits the amount of data that a page may receive while cached.",navigationCancelledWhileRestoring:"Navigation was cancelled before the page could be restored from back/forward cache.",backForwardCacheDisabledForPrerender:"Back/forward cache is disabled for prerenderer.",userAgentOverrideDiffers:"Browser has changed the user agent override header.",foregroundCacheLimit:"The page was evicted from the cache to allow another page to be cached.",backForwardCacheDisabledForDelegate:"Back/forward cache is not supported by delegate.",unloadHandlerExistsInMainFrame:"The page has an unload handler in the main frame.",unloadHandlerExistsInSubFrame:"The page has an unload handler in a sub frame.",serviceWorkerUnregistration:"ServiceWorker was unregistered while a page was in back/forward cache.",noResponseHead:"Pages that do not have a valid response head cannot enter back/forward cache.",cacheControlNoStore:"Pages with cache-control:no-store header cannot enter back/forward cache.",ineligibleAPI:"Ineligible APIs were used.",internalError:"Internal error.",webSocket:"Pages with WebSocket cannot enter back/forward cache.",webTransport:"Pages with WebTransport cannot enter back/forward cache.",webRTC:"Pages with WebRTC cannot enter back/forward cache.",mainResourceHasCacheControlNoStore:"Pages whose main resource has cache-control:no-store cannot enter back/forward cache.",mainResourceHasCacheControlNoCache:"Pages whose main resource has cache-control:no-cache cannot enter back/forward cache.",subresourceHasCacheControlNoStore:"Pages whose subresource has cache-control:no-store cannot enter back/forward cache.",subresourceHasCacheControlNoCache:"Pages whose subresource has cache-control:no-cache cannot enter back/forward cache.",containsPlugins:"Pages containing plugins are not currently eligible for back/forward cache.",documentLoaded:"The document did not finish loading before navigating away.",dedicatedWorkerOrWorklet:"Pages that use a dedicated worker or worklet are not currently eligible for back/forward cache.",outstandingNetworkRequestOthers:"Pages with an in-flight network request are not currently eligible for back/forward cache.",outstandingIndexedDBTransaction:"Page with ongoing indexed DB transactions are not currently eligible for back/forward cache.",requestedNotificationsPermission:"Pages that have requested notifications permissions are not currently eligible for back/forward cache.",requestedMIDIPermission:"Pages that have requested MIDI permissions are not currently eligible for back/forward cache.",requestedAudioCapturePermission:"Pages that have requested audio capture permissions are not currently eligible for back/forward cache.",requestedVideoCapturePermission:"Pages that have requested video capture permissions are not currently eligible for back/forward cache.",requestedBackForwardCacheBlockedSensors:"Pages that have requested sensor permissions are not currently eligible for back/forward cache.",requestedBackgroundWorkPermission:"Pages that have requested background sync or fetch permissions are not currently eligible for back/forward cache.",broadcastChannel:"The page cannot be cached because it has a BroadcastChannel instance with registered listeners.",indexedDBConnection:"Pages that have an open IndexedDB connection are not currently eligible for back/forward cache.",webXR:"Pages that use WebXR are not currently eligible for back/forward cache.",sharedWorker:"Pages that use SharedWorker are not currently eligible for back/forward cache.",webLocks:"Pages that use WebLocks are not currently eligible for back/forward cache.",webHID:"Pages that use WebHID are not currently eligible for back/forward cache.",webShare:"Pages that use WebShare are not currently eligible for back/forwad cache.",requestedStorageAccessGrant:"Pages that have requested storage access are not currently eligible for back/forward cache.",webNfc:"Pages that use WebNfc are not currently eligible for back/forwad cache.",outstandingNetworkRequestFetch:"Pages with an in-flight fetch network request are not currently eligible for back/forward cache.",outstandingNetworkRequestXHR:"Pages with an in-flight XHR network request are not currently eligible for back/forward cache.",appBanner:"Pages that requested an AppBanner are not currently eligible for back/forward cache.",printing:"Pages that show Printing UI are not currently eligible for back/forward cache.",webDatabase:"Pages that use WebDatabase are not currently eligible for back/forward cache.",pictureInPicture:"Pages that use Picture-in-Picture are not currently eligible for back/forward cache.",portal:"Pages that use portals are not currently eligible for back/forward cache.",speechRecognizer:"Pages that use SpeechRecognizer are not currently eligible for back/forward cache.",idleManager:"Pages that use IdleManager are not currently eligible for back/forward cache.",paymentManager:"Pages that use PaymentManager are not currently eligible for back/forward cache.",speechSynthesis:"Pages that use SpeechSynthesis are not currently eligible for back/forward cache.",keyboardLock:"Pages that use Keyboard lock are not currently eligible for back/forward cache.",webOTPService:"Pages that use WebOTPService are not currently eligible for bfcache.",outstandingNetworkRequestDirectSocket:"Pages with an in-flight network request are not currently eligible for back/forward cache.",injectedJavascript:"Pages that `JavaScript` is injected into by extensions are not currently eligible for back/forward cache.",injectedStyleSheet:"Pages that a `StyleSheet` is injected into by extensions are not currently eligible for back/forward cache.",contentSecurityHandler:"Pages that use SecurityHandler are not eligible for back/forward cache.",contentWebAuthenticationAPI:"Pages that use WebAuthetication API are not eligible for back/forward cache.",contentFileChooser:"Pages that use FileChooser API are not eligible for back/forward cache.",contentSerial:"Pages that use Serial API are not eligible for back/forward cache.",contentFileSystemAccess:"Pages that use File System Access API are not eligible for back/forward cache.",contentMediaDevicesDispatcherHost:"Pages that use Media Device Dispatcher are not eligible for back/forward cache.",contentWebBluetooth:"Pages that use WebBluetooth API are not eligible for back/forward cache.",contentWebUSB:"Pages that use WebUSB API are not eligible for back/forward cache.",contentMediaSession:"Pages that use MediaSession API and set a playback state are not eligible for back/forward cache.",contentMediaSessionService:"Pages that use MediaSession API and set action handlers are not eligible for back/forward cache.",contentMediaPlay:"A media player was playing upon navigating away.",contentScreenReader:"Back/forward cache is disabled due to screen reader.",embedderPopupBlockerTabHelper:"Popup blocker was present upon navigating away.",embedderSafeBrowsingTriggeredPopupBlocker:"Safe Browsing considered this page to be abusive and blocked popup.",embedderSafeBrowsingThreatDetails:"Safe Browsing details were shown upon navigating away.",embedderAppBannerManager:"App Banner was present upon navigating away.",embedderDomDistillerViewerSource:"DOM Distiller Viewer was present upon navigating away.",embedderDomDistillerSelfDeletingRequestDelegate:"DOM distillation was in progress upon navigating away.",embedderOomInterventionTabHelper:"Out-Of-Memory Intervention bar was present upon navigating away.",embedderOfflinePage:"The offline page was shown upon navigating away.",embedderChromePasswordManagerClientBindCredentialManager:"Chrome Password Manager was present upon navigating away.",embedderPermissionRequestManager:"There were permission requests upon navigating away.",embedderModalDialog:"Modal dialog such as form resubmission or http password dialog was shown for the page upon navigating away.",embedderExtensions:"Back/forward cache is disabled due to extensions.",embedderExtensionMessaging:"Back/forward cache is disabled due to extensions using messaging API.",embedderExtensionMessagingForOpenPort:"Extensions with long-lived connection should close the connection before entering back/forward cache.",embedderExtensionSentMessageToCachedFrame:"Extensions with long-lived connection attempted to send messages to frames in back/forward cache.",errorDocument:"Back/forward cache is disabled due to a document error.",fencedFramesEmbedder:"Pages using FencedFrames cannot be stored in bfcache.",keepaliveRequest:"Back/forward cache is disabled due to a keepalive request.",authorizationHeader:"Back/forward cache is disabled due to a keepalive request.",indexedDBEvent:"Back/forward cache is disabled due to an IndexedDB event.",cookieDisabled:"Back/forward cache is disabled because cookies are disabled on a page that uses `Cache-Control: no-store`."}),G_={NotPrimaryMainFrame:{name:H_(W_.notMainFrame)},BackForwardCacheDisabled:{name:H_(W_.backForwardCacheDisabled)},RelatedActiveContentsExist:{name:H_(W_.relatedActiveContentsExist)},HTTPStatusNotOK:{name:H_(W_.HTTPStatusNotOK)},SchemeNotHTTPOrHTTPS:{name:H_(W_.schemeNotHTTPOrHTTPS)},Loading:{name:H_(W_.loading)},WasGrantedMediaAccess:{name:H_(W_.wasGrantedMediaAccess)},HTTPMethodNotGET:{name:H_(W_.HTTPMethodNotGET)},SubframeIsNavigating:{name:H_(W_.subframeIsNavigating)},Timeout:{name:H_(W_.timeout)},CacheLimit:{name:H_(W_.cacheLimit)},JavaScriptExecution:{name:H_(W_.JavaScriptExecution)},RendererProcessKilled:{name:H_(W_.rendererProcessKilled)},RendererProcessCrashed:{name:H_(W_.rendererProcessCrashed)},GrantedMediaStreamAccess:{name:H_(W_.grantedMediaStreamAccess)},CacheFlushed:{name:H_(W_.cacheFlushed)},ServiceWorkerVersionActivation:{name:H_(W_.serviceWorkerVersionActivation)},SessionRestored:{name:H_(W_.sessionRestored)},ServiceWorkerPostMessage:{name:H_(W_.serviceWorkerPostMessage)},EnteredBackForwardCacheBeforeServiceWorkerHostAdded:{name:H_(W_.enteredBackForwardCacheBeforeServiceWorkerHostAdded)},ServiceWorkerClaim:{name:H_(W_.serviceWorkerClaim)},HaveInnerContents:{name:H_(W_.haveInnerContents)},TimeoutPuttingInCache:{name:H_(W_.timeoutPuttingInCache)},BackForwardCacheDisabledByLowMemory:{name:H_(W_.backForwardCacheDisabledByLowMemory)},BackForwardCacheDisabledByCommandLine:{name:H_(W_.backForwardCacheDisabledByCommandLine)},NetworkRequestDatapipeDrainedAsBytesConsumer:{name:H_(W_.networkRequestDatapipeDrainedAsBytesConsumer)},NetworkRequestRedirected:{name:H_(W_.networkRequestRedirected)},NetworkRequestTimeout:{name:H_(W_.networkRequestTimeout)},NetworkExceedsBufferLimit:{name:H_(W_.networkExceedsBufferLimit)},NavigationCancelledWhileRestoring:{name:H_(W_.navigationCancelledWhileRestoring)},BackForwardCacheDisabledForPrerender:{name:H_(W_.backForwardCacheDisabledForPrerender)},UserAgentOverrideDiffers:{name:H_(W_.userAgentOverrideDiffers)},ForegroundCacheLimit:{name:H_(W_.foregroundCacheLimit)},BackForwardCacheDisabledForDelegate:{name:H_(W_.backForwardCacheDisabledForDelegate)},UnloadHandlerExistsInMainFrame:{name:H_(W_.unloadHandlerExistsInMainFrame)},UnloadHandlerExistsInSubFrame:{name:H_(W_.unloadHandlerExistsInSubFrame)},ServiceWorkerUnregistration:{name:H_(W_.serviceWorkerUnregistration)},NoResponseHead:{name:H_(W_.noResponseHead)},CacheControlNoStore:{name:H_(W_.cacheControlNoStore)},CacheControlNoStoreCookieModified:{name:H_(W_.cacheControlNoStore)},CacheControlNoStoreHTTPOnlyCookieModified:{name:H_(W_.cacheControlNoStore)},DisableForRenderFrameHostCalled:{name:H_(W_.ineligibleAPI)},BlocklistedFeatures:{name:H_(W_.ineligibleAPI)},SchedulerTrackedFeatureUsed:{name:H_(W_.ineligibleAPI)},DomainNotAllowed:{name:H_(W_.internalError)},ConflictingBrowsingInstance:{name:H_(W_.internalError)},NotMostRecentNavigationEntry:{name:H_(W_.internalError)},IgnoreEventAndEvict:{name:H_(W_.internalError)},BrowsingInstanceNotSwapped:{name:H_(W_.internalError)},ActivationNavigationsDisallowedForBug1234857:{name:H_(W_.internalError)},Unknown:{name:H_(W_.internalError)},RenderFrameHostReused_SameSite:{name:H_(W_.internalError)},RenderFrameHostReused_CrossSite:{name:H_(W_.internalError)},WebSocket:{name:H_(W_.webSocket)},WebTransport:{name:H_(W_.webTransport)},WebRTC:{name:H_(W_.webRTC)},MainResourceHasCacheControlNoStore:{name:H_(W_.mainResourceHasCacheControlNoStore)},MainResourceHasCacheControlNoCache:{name:H_(W_.mainResourceHasCacheControlNoCache)},SubresourceHasCacheControlNoStore:{name:H_(W_.subresourceHasCacheControlNoStore)},SubresourceHasCacheControlNoCache:{name:H_(W_.subresourceHasCacheControlNoCache)},ContainsPlugins:{name:H_(W_.containsPlugins)},DocumentLoaded:{name:H_(W_.documentLoaded)},DedicatedWorkerOrWorklet:{name:H_(W_.dedicatedWorkerOrWorklet)},OutstandingNetworkRequestOthers:{name:H_(W_.outstandingNetworkRequestOthers)},OutstandingIndexedDBTransaction:{name:H_(W_.outstandingIndexedDBTransaction)},RequestedNotificationsPermission:{name:H_(W_.requestedNotificationsPermission)},RequestedMIDIPermission:{name:H_(W_.requestedMIDIPermission)},RequestedAudioCapturePermission:{name:H_(W_.requestedAudioCapturePermission)},RequestedVideoCapturePermission:{name:H_(W_.requestedVideoCapturePermission)},RequestedBackForwardCacheBlockedSensors:{name:H_(W_.requestedBackForwardCacheBlockedSensors)},RequestedBackgroundWorkPermission:{name:H_(W_.requestedBackgroundWorkPermission)},BroadcastChannel:{name:H_(W_.broadcastChannel)},IndexedDBConnection:{name:H_(W_.indexedDBConnection)},WebXR:{name:H_(W_.webXR)},SharedWorker:{name:H_(W_.sharedWorker)},WebLocks:{name:H_(W_.webLocks)},WebHID:{name:H_(W_.webHID)},WebShare:{name:H_(W_.webShare)},RequestedStorageAccessGrant:{name:H_(W_.requestedStorageAccessGrant)},WebNfc:{name:H_(W_.webNfc)},OutstandingNetworkRequestFetch:{name:H_(W_.outstandingNetworkRequestFetch)},OutstandingNetworkRequestXHR:{name:H_(W_.outstandingNetworkRequestXHR)},AppBanner:{name:H_(W_.appBanner)},Printing:{name:H_(W_.printing)},WebDatabase:{name:H_(W_.webDatabase)},PictureInPicture:{name:H_(W_.pictureInPicture)},Portal:{name:H_(W_.portal)},SpeechRecognizer:{name:H_(W_.speechRecognizer)},IdleManager:{name:H_(W_.idleManager)},PaymentManager:{name:H_(W_.paymentManager)},SpeechSynthesis:{name:H_(W_.speechSynthesis)},KeyboardLock:{name:H_(W_.keyboardLock)},WebOTPService:{name:H_(W_.webOTPService)},OutstandingNetworkRequestDirectSocket:{name:H_(W_.outstandingNetworkRequestDirectSocket)},InjectedJavascript:{name:H_(W_.injectedJavascript)},InjectedStyleSheet:{name:H_(W_.injectedStyleSheet)},Dummy:{name:H_(W_.internalError)},ContentSecurityHandler:{name:H_(W_.contentSecurityHandler)},ContentWebAuthenticationAPI:{name:H_(W_.contentWebAuthenticationAPI)},ContentFileChooser:{name:H_(W_.contentFileChooser)},ContentSerial:{name:H_(W_.contentSerial)},ContentFileSystemAccess:{name:H_(W_.contentFileSystemAccess)},ContentMediaDevicesDispatcherHost:{name:H_(W_.contentMediaDevicesDispatcherHost)},ContentWebBluetooth:{name:H_(W_.contentWebBluetooth)},ContentWebUSB:{name:H_(W_.contentWebUSB)},ContentMediaSession:{name:H_(W_.contentMediaSession)},ContentMediaSessionService:{name:H_(W_.contentMediaSessionService)},ContentMediaPlay:{name:H_(W_.contentMediaPlay)},ContentScreenReader:{name:H_(W_.contentScreenReader)},EmbedderPopupBlockerTabHelper:{name:H_(W_.embedderPopupBlockerTabHelper)},EmbedderSafeBrowsingTriggeredPopupBlocker:{name:H_(W_.embedderSafeBrowsingTriggeredPopupBlocker)},EmbedderSafeBrowsingThreatDetails:{name:H_(W_.embedderSafeBrowsingThreatDetails)},EmbedderAppBannerManager:{name:H_(W_.embedderAppBannerManager)},EmbedderDomDistillerViewerSource:{name:H_(W_.embedderDomDistillerViewerSource)},EmbedderDomDistillerSelfDeletingRequestDelegate:{name:H_(W_.embedderDomDistillerSelfDeletingRequestDelegate)},EmbedderOomInterventionTabHelper:{name:H_(W_.embedderOomInterventionTabHelper)},EmbedderOfflinePage:{name:H_(W_.embedderOfflinePage)},EmbedderChromePasswordManagerClientBindCredentialManager:{name:H_(W_.embedderChromePasswordManagerClientBindCredentialManager)},EmbedderPermissionRequestManager:{name:H_(W_.embedderPermissionRequestManager)},EmbedderModalDialog:{name:H_(W_.embedderModalDialog)},EmbedderExtensions:{name:H_(W_.embedderExtensions)},EmbedderExtensionMessaging:{name:H_(W_.embedderExtensionMessaging)},EmbedderExtensionMessagingForOpenPort:{name:H_(W_.embedderExtensionMessagingForOpenPort)},EmbedderExtensionSentMessageToCachedFrame:{name:H_(W_.embedderExtensionSentMessageToCachedFrame)},ErrorDocument:{name:H_(W_.errorDocument)},FencedFramesEmbedder:{name:H_(W_.fencedFramesEmbedder)},KeepaliveRequest:{name:H_(W_.keepaliveRequest)},AuthorizationHeader:{name:H_(W_.authorizationHeader)},IndexedDBEvent:{name:H_(W_.indexedDBEvent)},CookieDisabled:{name:H_(W_.cookieDisabled)}}})),Y_={};c(Y_,{UIStrings:()=>J_,default:()=>tR});var J_,Z_,X_,Q_,eR,tR,aR,nR,rR,iR,oR,sR=s((()=>{J(),xr(),ro(),K_(),Z_=eo("core/audits/bf-cache.js",J_={title:"Page didn't prevent back/forward cache restoration",failureTitle:"Page prevented back/forward cache restoration",description:"Many navigations are performed by going back to a previous page, or forwards again. The back/forward cache (bfcache) can speed up these return navigations. [Learn more about the bfcache](https://developer.chrome.com/docs/lighthouse/performance/bf-cache/)",actionableFailureType:"Actionable",notActionableFailureType:"Not actionable",supportPendingFailureType:"Pending browser support",failureReasonColumn:"Failure reason",failureTypeColumn:"Failure type",displayValue:"{itemCount, plural,\n    =1 {1 failure reason}\n    other {# failure reasons}\n    }"}),X_=["PageSupportNeeded","SupportPending","Circumstantial"],Q_={PageSupportNeeded:Z_(J_.actionableFailureType),Circumstantial:Z_(J_.notActionableFailureType),SupportPending:Z_(J_.supportPendingFailureType)},eR=class extends Dr{static{o(this,"BFCache")}static get meta(){return{id:"bf-cache",title:Z_(J_.title),failureTitle:Z_(J_.failureTitle),description:Z_(J_.description),supportedModes:["navigation","timespan"],requiredArtifacts:["BFCacheFailures"]}}static async audit(e){let t=e.BFCacheFailures;if(!t.length)return{score:1};let{notRestoredReasonsTree:a}=t[0],n=0,r=[];for(let e of X_){let t=a[e];for(let[a,i]of Object.entries(t))n+=i.length,r.push({reason:G_[a]?.name??a,failureType:Q_[e],subItems:{type:"subitems",items:i.map((e=>({frameUrl:e})))},protocolReason:a})}let i=[{key:"reason",valueType:"text",subItemsHeading:{key:"frameUrl",valueType:"url"},label:Z_(J_.failureReasonColumn)},{key:"failureType",valueType:"text",label:Z_(J_.failureTypeColumn)}],o=Dr.makeTableDetails(i,r),s=n?Z_(J_.displayValue,{itemCount:n}):void 0;return{score:r.length?0:1,displayValue:s,details:o}}},tR=eR})),lR=s((()=>{J(),aR={parseHTML:{id:"parseHTML",label:"Parse HTML & CSS",traceEventNames:["ParseHTML","ParseAuthorStyleSheet"]},styleLayout:{id:"styleLayout",label:"Style & Layout",traceEventNames:["ScheduleStyleRecalculation","UpdateLayoutTree","InvalidateLayout","Layout"]},paintCompositeRender:{id:"paintCompositeRender",label:"Rendering",traceEventNames:["Animation","HitTest","PaintSetup","Paint","PaintImage","RasterTask","ScrollLayer","UpdateLayer","UpdateLayerTree","CompositeLayers","PrePaint"]},scriptParseCompile:{id:"scriptParseCompile",label:"Script Parsing & Compilation",traceEventNames:["v8.compile","v8.compileModule","v8.parseOnBackground"]},scriptEvaluation:{id:"scriptEvaluation",label:"Script Evaluation",traceEventNames:["EventDispatch","EvaluateScript","v8.evaluateModule","FunctionCall","TimerFire","FireIdleCallback","FireAnimationFrame","RunMicrotasks","V8.Execute"]},garbageCollection:{id:"garbageCollection",label:"Garbage Collection",traceEventNames:["MinorGC","MajorGC","BlinkGC.AtomicPhase","ThreadState::performIdleLazySweep","ThreadState::completeSweep","BlinkGCMarking"]},other:{id:"other",label:"Other",traceEventNames:["MessageLoop::RunTask","TaskQueueManager::ProcessTaskFromWorkQueue","ThreadControllerImpl::DoWork"]}},nR={};for(let e of Object.values(aR))for(let t of e.traceEventNames)nR[t]=e})),cR=s((()=>{J(),ta(),lR(),rR=class e{static{o(this,"MainThreadTasks")}static _createNewTaskNode(e,t){let a="X"===e.ph&&!t,n="B"===e.ph&&t&&"E"===t.ph;if(!a&&!n)throw new Error("Invalid parameters for _createNewTaskNode");let r=e.ts,i=t?t.ts:e.ts+Number(e.dur||0);return{event:e,endEvent:t,startTime:r,endTime:i,duration:i-r,unbounded:!1,parent:void 0,children:[],attributableURLs:[],group:aR.other,selfTime:NaN}}static _assignAllTimersUntilTs(e,t,a,n){for(;n.length;){let r=n.pop();if(!r)break;if(r.ts>t){n.push(r);break}if(r.ts<e.startTime)continue;let i=r.args.data.timerId;a.timers.set(i,e)}}static _createTasksFromStartAndEndEvents(t,a,n){let r=[],i=a.slice().reverse();for(let a=0;a<t.length;a++){let o=t[a];if("X"===o.ph){r.push(e._createNewTaskNode(o));continue}let s=-1,l=0,c=a+1;for(let e=i.length-1;e>=0;e--){let a=i[e];for(;c<t.length&&!(t[c].ts>=a.ts);c++)t[c].name===o.name&&l++;if(a.name===o.name&&!(a.ts<o.ts)){if(l>0){l--;continue}s=e;break}}let u,d=!1;-1===s?(u={...o,ph:"E",ts:n},d=!0):u=s===i.length-1?i.pop():i.splice(s,1)[0];let m=e._createNewTaskNode(o,u);m.unbounded=d,r.push(m)}if(i.length)throw new Error(`Fatal trace logic error - ${i.length} unmatched end events`);return r}static _createTaskRelationships(t,a,n){let r,i=a.slice().reverse();for(let a=0;a<t.length;a++){let o=t[a];if("XHRReadyStateChange"===o.event.name){let e=o.event.args.data,t=e?.url;e&&t&&1===e.readyState&&n.xhrs.set(t,o)}for(;r&&Number.isFinite(r.endTime)&&r.endTime<=o.startTime;)e._assignAllTimersUntilTs(r,r.endTime,n,i),r=r.parent;if(r){if(o.endTime>r.endTime){let e=o.endTime-r.endTime;if(e<1e3)r.endTime=o.endTime,r.duration+=e;else if(o.unbounded)o.endTime=r.endTime,o.duration=o.endTime-o.startTime;else{if(!(o.startTime-r.startTime<1e3)||r.children.length){let t=new Error("Fatal trace logic error - child cannot end after parent");throw t.timeDelta=e,t.nextTaskEvent=o.event,t.nextTaskEndEvent=o.endEvent,t.nextTaskEndTime=o.endTime,t.currentTaskEvent=r.event,t.currentTaskEndEvent=r.endEvent,t.currentTaskEndTime=r.endTime,t}{let e=o,t=r,a=r.parent;if(a){let n=a.children.length-1;if(a.children[n]!==t)throw new Error("Fatal trace logic error - impossible children");a.children.pop(),a.children.push(e)}e.parent=a,e.startTime=t.startTime,e.duration=e.endTime-e.startTime,r=e,o=t}}}o.parent=r,r.children.push(o),e._assignAllTimersUntilTs(r,o.startTime,n,i)}r=o}r&&e._assignAllTimersUntilTs(r,r.endTime,n,i)}static _createTasksFromEvents(t,a,n){let r=[],i=[],o=[];for(let e of t)("X"===e.ph||"B"===e.ph)&&r.push(e),"E"===e.ph&&i.push(e),"TimerInstall"===e.name&&o.push(e);let s=e._createTasksFromStartAndEndEvents(r,i,n).sort(((e,t)=>e.startTime-t.startTime||t.duration-e.duration));return e._createTaskRelationships(s,o,a),s.sort(((e,t)=>e.startTime-t.startTime||t.duration-e.duration))}static _computeRecursiveSelfTime(t,a){if(a&&t.endTime>a.endTime)throw new Error("Fatal trace logic error - child cannot end after parent");let n=t.children.map((a=>e._computeRecursiveSelfTime(a,t))).reduce(((e,t)=>e+t),0);return t.selfTime=t.duration-n,t.duration}static _computeRecursiveAttributableURLs(t,a,n,r){let i=t.event.args,o={...i.beginData||{},...i.data||{}},s=o.frame||"",l=r.frameURLsById.get(s),c=(o.stackTrace||[]).map((e=>e.url)),u=c[0];s&&l&&l.startsWith("about:")&&u&&(r.frameURLsById.set(s,u),l=u);let d=[];switch(t.event.name){case"v8.compile":case"EvaluateScript":case"FunctionCall":case"ParseHTML":d=[o.url,l];break;case"v8.compileModule":d=[t.event.args.fileName];break;case"TimerFire":{let e=t.event.args.data.timerId,a=r.timers.get(e);if(!a)break;d=a.attributableURLs;break}case"ParseAuthorStyleSheet":d=[o.styleSheetUrl,l];break;case"UpdateLayoutTree":case"Layout":case"Paint":if(l){d=[l];break}if(n.length)break;d=r.lastTaskURLs;break;case"XHRReadyStateChange":case"XHRLoad":{let e=o.url,t=o.readyState;if(!e||"number"==typeof t&&4!==t)break;let a=r.xhrs.get(e);if(!a)break;d=a.attributableURLs;break}default:d=[]}let m=Array.from(a);for(let e of[...d,...c])e&&(n.includes(e)||n.push(e),m[m.length-1]!==e&&m.push(e));t.attributableURLs=m,t.children.forEach((t=>e._computeRecursiveAttributableURLs(t,m,n,r))),!m.length&&!t.parent&&n.length&&e._setRecursiveEmptyAttributableURLs(t,n)}static _setRecursiveEmptyAttributableURLs(t,a){t.attributableURLs.length||(t.attributableURLs=a.slice(),t.children.forEach((t=>e._setRecursiveEmptyAttributableURLs(t,a))))}static _computeRecursiveTaskGroup(t,a){let n=nR[t.event.name];t.group=n||a||aR.other,t.children.forEach((a=>e._computeRecursiveTaskGroup(a,t.group)))}static getMainThreadTasks(t,a,n,r){let i=new Map,o=new Map,s=new Map;a.forEach((({id:e,url:t})=>s.set(e,t)));let l={timers:i,xhrs:o,frameURLsById:s,lastTaskURLs:[]},c=e._createTasksFromEvents(t,l,n);for(let t of c)t.parent||(e._computeRecursiveSelfTime(t,void 0),e._computeRecursiveAttributableURLs(t,[],[],l),e._computeRecursiveTaskGroup(t),l.lastTaskURLs=t.attributableURLs);let u=r??c[0].startTime;for(let e of c)if(e.startTime=(e.startTime-u)/1e3,e.endTime=(e.endTime-u)/1e3,e.duration/=1e3,e.selfTime/=1e3,!Number.isFinite(e.selfTime))throw new Error("Invalid task timing data");return c}static printTaskTreeToDebugString(e,t={}){let a=Math.max(...e.map((e=>e.endTime)),0),{printWidth:n=100,startTime:r=0,endTime:i=a,taskLabelFn:s=o((e=>e.event.name),"taskLabelFn")}=t;function l(e){let t=0;for(;e.parent;e=e.parent)t++;return t}o(l,"computeTaskDepth");let c=(i-r)/n,u=new Map,d=new Map;for(let t of e){if(t.startTime>i||t.endTime<r)continue;let e=l(t),a=d.get(e)||[];a.push(t),d.set(e,a);let n=String.fromCharCode(65+u.size%26);u.set(t,{id:n,task:t})}let m=[`Trace Duration: ${a.toFixed(0)}ms`,`Range: [${r}, ${i}]`,`█ = ${c.toFixed(2)}ms`,""],p=Array.from(d.entries()).sort(((e,t)=>e[0]-t[0]));for(let[,e]of p){let t=Array.from({length:n}).map((()=>" "));for(let a of e){let e=Math.max(a.startTime,r),n=Math.min(a.endTime,i),{id:o}=u.get(a)||{id:"?"},s=Math.floor(e/c),l=Math.floor(n/c),d=Math.floor((s+l)/2);for(let e=s;e<=l;e++)t[e]="█";for(let e=0;e<o.length;e++)t[d]=o}m.push(t.join(""))}m.push("");for(let{id:e,task:t}of u.values())m.push(`${e} = ${s(t)}`);return m.join("\n")}}})),uR=s((()=>{J(),Bc(),cR(),Hc(),iR=class{static{o(this,"MainThreadTasks")}static async compute_(e,t){let{mainThreadEvents:a,frames:n,timestamps:r}=await kc.request(e,t);return rR.getMainThreadTasks(a,n,r.traceEnd,r.timeOrigin)}},oR=dc(iR,null)}));function dR(e){let t=new Set;for(let a of e)a.resourceType===wc.TYPES.Script&&t.add(a.url);return t}function mR(e,t){let a=e.attributableURLs.find((e=>t.has(e))),n=e.attributableURLs[0],r=a||n;return(!r||"about:blank"===r)&&(r=hR.has(e.event.name)?"Browser":gR.has(e.event.name)?"Browser GC":"Unattributable"),r}function pR(e,t){let a=dR(t),n=new Map;for(let t of e){let e=mR(t,a),r=n.get(e)||{},i=r[t.group.id]||0;r[t.group.id]=i+t.selfTime,n.set(e,r)}return n}var hR,gR,fR=s((()=>{J(),qc(),hR=new Set(["CpuProfiler::StartProfiling"]),gR=new Set(["V8.GCCompactor","MajorGC","MinorGC"]),o(dR,"getJavaScriptURLs"),o(mR,"getAttributableURLForTask"),o(pR,"getExecutionTimingsByURL")})),yR={};c(yR,{UIStrings:()=>vR,default:()=>DR});var vR,bR,wR,DR,ER,TR,SR,CR,kR,xR,AR,_R,RR,FR,NR,IR,MR,PR=s((()=>{J(),xr(),lR(),ro(),Yc(),uR(),fR(),bR=eo("core/audits/bootup-time.js",vR={title:"JavaScript execution time",failureTitle:"Reduce JavaScript execution time",description:"Consider reducing the time spent parsing, compiling, and executing JS. You may find delivering smaller JS payloads helps with this. [Learn how to reduce Javascript execution time](https://developer.chrome.com/docs/lighthouse/performance/bootup-time/).",columnTotal:"Total CPU Time",columnScriptEval:"Script Evaluation",columnScriptParse:"Script Parse",chromeExtensionsWarning:"Chrome extensions negatively affected this page's load performance. Try auditing the page in incognito mode or from a Chrome profile without extensions."}),wR=class e extends Dr{static{o(this,"BootupTime")}static get meta(){return{id:"bootup-time",title:bR(vR.title),failureTitle:bR(vR.failureTitle),description:bR(vR.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","devtoolsLogs"]}}static get defaultOptions(){return{p10:1282,median:3500,thresholdInMs:50}}static async audit(t,a){let n,r=a.settings||{},i=t.traces[e.DEFAULT_PASS],o=t.devtoolsLogs[e.DEFAULT_PASS],s=await Pc.request(o,a),l=await oR.request(i,a),c="simulate"===r.throttlingMethod?r.throttling.cpuSlowdownMultiplier:1,u=pR(l,s),d=!1,m=0,p=Array.from(u).map((([e,t])=>{let n=0;for(let[e,a]of Object.entries(t))t[e]=a*c,n+=a*c;let r=t[aR.scriptEvaluation.id]||0,i=t[aR.scriptParseCompile.id]||0;return n>=a.options.thresholdInMs&&(m+=r+i),d=d||e.startsWith("chrome-extension:")&&r>100,{url:e,total:n,scripting:r,scriptParseCompile:i}})).filter((e=>e.total>=a.options.thresholdInMs)).sort(((e,t)=>t.total-e.total));d&&(n=[bR(vR.chromeExtensionsWarning)]);let h=[{key:"url",valueType:"url",label:bR(no.columnURL)},{key:"total",granularity:1,valueType:"ms",label:bR(vR.columnTotal)},{key:"scripting",granularity:1,valueType:"ms",label:bR(vR.columnScriptEval)},{key:"scriptParseCompile",granularity:1,valueType:"ms",label:bR(vR.columnScriptParse)}],g=e.makeTableDetails(h,p,{wastedMs:m,sortedBy:["total"]});return{score:Dr.computeLogNormalScore({p10:a.options.p10,median:a.options.median},m),numericValue:m,numericUnit:"millisecond",displayValue:m>0?bR(no.seconds,{timeInMs:m}):"",details:g,runWarnings:n}}},DR=wR})),LR=s((()=>{J(),Cl(),qc(),yD(),$c(),Zc(),ER=class{static{o(this,"LanternMetric")}static getScriptUrls(e,t){let a=new Set;return e.traverse((e=>{e.type!==fl.TYPES.CPU&&e.record.resourceType===wc.TYPES.Script&&(t&&!t(e)||a.add(e.record.url))})),a}static get COEFFICIENTS(){throw new Error("COEFFICIENTS unimplemented!")}static getScaledCoefficients(e){return this.COEFFICIENTS}static getOptimisticGraph(e,t){throw new Error("Optimistic graph unimplemented!")}static getPessimisticGraph(e,t){throw new Error("Pessmistic graph unimplemented!")}static getEstimateFromSimulation(e,t){return e}static async computeMetricWithGraphs(e,t,a){if("navigation"!==(e.gatherContext||{gatherMode:"navigation"}).gatherMode)throw new Error("Lantern metrics can only be computed on navigations");let n=this.name.replace("Lantern",""),r=await Fc.request(e,t),i=await lD.request(e.trace,t),o=e.simulator||await Uc.request(e,t),s=this.getOptimisticGraph(r,i),l=this.getPessimisticGraph(r,i),c={label:`optimistic${n}`},u=o.simulate(s,c);c={label:`optimisticFlex${n}`,flexibleOrdering:!0};let d=o.simulate(s,c);c={label:`pessimistic${n}`};let m=o.simulate(l,c),p=this.getEstimateFromSimulation(u.timeInMs<d.timeInMs?u:d,{...a,optimistic:!0}),h=this.getEstimateFromSimulation(m,{...a,optimistic:!1}),g=this.getScaledCoefficients(o.rtt),f=g.intercept>0?Math.min(1,p.timeInMs/1e3):1;return{timing:g.intercept*f+g.optimistic*p.timeInMs+g.pessimistic*h.timeInMs,optimisticEstimate:p,pessimisticEstimate:h,optimisticGraph:s,pessimisticGraph:l}}static async compute_(e,t){return this.computeMetricWithGraphs(e,t)}}})),OR=s((()=>{J(),Bc(),LR(),Cl(),TR=class extends ER{static{o(this,"LanternFirstContentfulPaint")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getBlockingNodeData(e,t,a,n){let r=new Map,i=[];e.traverse((e=>{if(e.type===fl.TYPES.CPU){e.startTime<=t&&i.push(e);let a=e.getEvaluateScriptURLs();for(let t of a){let a=r.get(t)||e;r.set(t,e.startTime<a.startTime?e:a)}}})),i.sort(((e,t)=>e.startTime-t.startTime));let o=ER.getScriptUrls(e,(e=>e.endTime<=t&&a(e))),s=new Set,l=new Set;for(let e of o){let t=r.get(e);if(t){if(i.includes(t)){l.add(t.id);continue}s.add(e)}}let c=i.find((e=>e.didPerformLayout()));c&&l.add(c.id);let u=i.find((e=>e.childEvents.some((e=>"Paint"===e.name))));u&&l.add(u.id);let d=i.find((e=>e.childEvents.some((e=>"ParseHTML"===e.name))));return d&&l.add(d.id),n&&i.filter(n).forEach((e=>l.add(e.id))),{definitelyNotRenderBlockingScriptUrls:s,blockingCpuNodeIds:l}}static getFirstPaintBasedGraph(e,t,a,n){let{definitelyNotRenderBlockingScriptUrls:r,blockingCpuNodeIds:i}=this.getBlockingNodeData(e,t,a,n);return e.cloneWithRelationships((e=>{if(e.type===fl.TYPES.NETWORK){if((e.endTime>t||e.startTime>t)&&!e.isMainDocument())return!1;let n=e.record.url;return!r.has(n)&&a(e)}return i.has(e.id)}))}static getOptimisticGraph(e,t){return this.getFirstPaintBasedGraph(e,t.timestamps.firstContentfulPaint,(e=>e.hasRenderBlockingPriority()&&"script"!==e.initiatorType))}static getPessimisticGraph(e,t){return this.getFirstPaintBasedGraph(e,t.timestamps.firstContentfulPaint,(e=>e.hasRenderBlockingPriority()))}},SR=dc(TR,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),jR=s((()=>{J(),Bc(),LR(),xl(),OR(),CR=class extends ER{static{o(this,"LanternFirstMeaningfulPaint")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e,t){let a=t.timestamps.firstMeaningfulPaint;if(!a)throw new El(El.errors.NO_FMP);return SR.getFirstPaintBasedGraph(e,a,(e=>e.hasRenderBlockingPriority()&&"script"!==e.initiatorType))}static getPessimisticGraph(e,t){let a=t.timestamps.firstMeaningfulPaint;if(!a)throw new El(El.errors.NO_FMP);return SR.getFirstPaintBasedGraph(e,a,(e=>e.hasRenderBlockingPriority()),(e=>e.didPerformLayout()))}static async compute_(e,t){let a=await SR.request(e,t),n=await this.computeMetricWithGraphs(e,t);return n.timing=Math.max(n.timing,a.timing),n}},kR=dc(CR,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),UR=s((()=>{J(),Bc(),LR(),Cl(),qc(),jR(),20,xR=class e extends ER{static{o(this,"LanternInteractive")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e){return e.cloneWithRelationships((e=>{if(e.type===fl.TYPES.CPU)return e.event.dur>2e4;let t=e.record.resourceType===wc.TYPES.Image,a=e.record.resourceType===wc.TYPES.Script;return!t&&(a||"High"===e.record.priority||"VeryHigh"===e.record.priority)}))}static getPessimisticGraph(e){return e}static getEstimateFromSimulation(t,a){if(!a.fmpResult)throw new Error("missing fmpResult");let n=e.getLastLongTaskEndTime(t.nodeTimings),r=a.optimistic?a.fmpResult.optimisticEstimate.timeInMs:a.fmpResult.pessimisticEstimate.timeInMs;return{timeInMs:Math.max(r,n),nodeTimings:t.nodeTimings}}static async compute_(e,t){let a=await kR.request(e,t),n=await this.computeMetricWithGraphs(e,t,{fmpResult:a});return n.timing=Math.max(n.timing,a.timing),n}static getLastLongTaskEndTime(e,t=50){return Array.from(e.entries()).filter((([e,a])=>e.type===fl.TYPES.CPU&&a.duration>t)).map((([e,t])=>t.endTime)).reduce(((e,t)=>Math.max(e||0,t||0)),0)}},AR=dc(xR,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),BR=s((()=>{J(),Bc(),LR(),xl(),OR(),_R=class e extends ER{static{o(this,"LanternLargestContentfulPaint")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static isNotLowPriorityImageNode(e){if("network"!==e.type)return!0;let t="Image"===e.record.resourceType,a="Low"===e.record.priority||"VeryLow"===e.record.priority;return!t||!a}static getOptimisticGraph(t,a){let n=a.timestamps.largestContentfulPaint;if(!n)throw new El(El.errors.NO_LCP);return SR.getFirstPaintBasedGraph(t,n,e.isNotLowPriorityImageNode)}static getPessimisticGraph(e,t){let a=t.timestamps.largestContentfulPaint;if(!a)throw new El(El.errors.NO_LCP);return SR.getFirstPaintBasedGraph(e,a,(e=>!0),(e=>e.didPerformLayout()))}static getEstimateFromSimulation(t){let a=Array.from(t.nodeTimings.entries()).filter((t=>e.isNotLowPriorityImageNode(t[0]))).map((e=>e[1].endTime));return{timeInMs:Math.max(...a),nodeTimings:t.nodeTimings}}static async compute_(e,t){let a=await SR.request(e,t),n=await this.computeMetricWithGraphs(e,t);return n.timing=Math.max(n.timing,a.timing),n}},RR=dc(_R,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),qR=s((()=>{J(),Bc(),Yc(),yD(),xl(),FR=class{static{o(this,"LCPImageRecord")}static async compute_(e,t){let{trace:a,devtoolsLog:n}=e,r=await Pc.request(n,t),i=await lD.request(a,t);if(void 0===i.timings.largestContentfulPaint)throw new El(El.errors.NO_LCP);let o=i.largestContentfulPaintEvt;if(!o)return;let s=a.traceEvents.filter((e=>"LargestImagePaint::Candidate"===e.name&&e.args.frame===o.args.frame&&e.args.data?.DOMNodeId===o.args.data?.nodeId&&e.args.data?.size===o.args.data?.size)).sort(((e,t)=>t.ts-e.ts))[0],l=s?.args.data?.imageUrl;return l?r.filter((e=>e.url===l&&e.finished&&e.frameId===s.args.frame&&e.networkRequestTime<(i.timestamps.largestContentfulPaint||0))).map((e=>{for(;e.redirectDestination;)e=e.redirectDestination;return e})).filter((e=>"Image"===e.resourceType)).sort(((e,t)=>e.networkEndTime-t.networkEndTime))[0]:void 0}},NR=dc(FR,["devtoolsLog","trace"])})),zR=s((()=>{J(),xr(),UR(),ro(),Yc(),Zc(),$c(),BR(),OR(),qR(),IR=eo("core/audits/byte-efficiency/byte-efficiency-audit.js",{}),150,935,MR=class e extends Dr{static{o(this,"ByteEfficiencyAudit")}static scoreForWastedMs(e){return Dr.computeLogNormalScore({p10:150,median:935},e)}static estimateTransferSize(e,t,a){if(e){if(e.resourceType===a)return e.transferSize||0;{let a=e.transferSize||0,n=e.resourceSize||0,r=Number.isFinite(n)&&n>0?a/n:1;return Math.round(t*r)}}switch(a){case"Stylesheet":return Math.round(.2*t);case"Script":case"Document":return Math.round(.33*t);default:return Math.round(.5*t)}}static async audit(e,t){let a=e.GatherContext,n=e.devtoolsLogs[Dr.DEFAULT_PASS],r={devtoolsLog:n,settings:t?.settings||{}},i=await Pc.request(n,t);if(!i.some((e=>e.transferSize))&&"timespan"===a.gatherMode)return{score:1,notApplicable:!0};let o=Dr.makeMetricComputationDataInput(e,t),[s,l]=await Promise.all([this.audit_(e,i,t),Uc.request(r,t)]);return this.createAuditProduct(s,l,o,t)}static computeWasteWithGraph(e,t,a,n){n=Object.assign({label:""},n);let r=`${this.meta.id}-${n.label}-before`,i=`${this.meta.id}-${n.label}-after`,o=a.simulate(t,{label:r}),s=n.providedWastedBytesByUrl||new Map;if(!n.providedWastedBytesByUrl)for(let{url:t,wastedBytes:a}of e)s.set(t,(s.get(t)||0)+a);let l=new Map;t.traverse((e=>{if("network"!==e.type)return;let t=s.get(e.record.url);if(!t)return;let a=e.record.transferSize;l.set(e.record.requestId,a),e.record.transferSize=Math.max(a-t,0)}));let c=a.simulate(t,{label:i});t.traverse((e=>{if("network"!==e.type)return;let t=l.get(e.record.requestId);void 0!==t&&(e.record.transferSize=t)}));let u=o.timeInMs-c.timeInMs;return{savings:10*Math.round(Math.max(u,0)/10),simulationBeforeChanges:o,simulationAfterChanges:c}}static computeWasteWithTTIGraph(e,t,a,n){n=Object.assign({includeLoad:!0},n);let{savings:r,simulationBeforeChanges:i,simulationAfterChanges:o}=this.computeWasteWithGraph(e,t,a,{...n,label:"overallLoad"}),s=AR.getLastLongTaskEndTime(i.nodeTimings)-AR.getLastLongTaskEndTime(o.nodeTimings);return n.includeLoad&&(s=Math.max(s,r)),10*Math.round(Math.max(s,0)/10)}static async createAuditProduct(t,a,n,r){let i,o=t.items.sort(((e,t)=>t.wastedBytes-e.wastedBytes)),s=o.reduce(((e,t)=>e+t.wastedBytes),0),l={FCP:0,LCP:0};if("navigation"===n.gatherContext.gatherMode){let e=await Fc.request(n,r),{pessimisticGraph:s}=await SR.request(n,r),{pessimisticGraph:c}=await RR.request(n,r);i=this.computeWasteWithTTIGraph(o,e,a,{providedWastedBytesByUrl:t.wastedBytesByUrl});let{savings:u}=this.computeWasteWithGraph(o,s,a,{providedWastedBytesByUrl:t.wastedBytesByUrl,label:"fcp"}),{savings:d}=this.computeWasteWithGraph(o,c,a,{providedWastedBytesByUrl:t.wastedBytesByUrl,label:"lcp"}),m=0,p=await NR.request(n,r);if(p){let e=o.find((e=>e.url===p.url));e&&(m=a.computeWastedMsFromWastedBytes(e.wastedBytes))}l.FCP=u,l.LCP=Math.max(d,m)}else i=a.computeWastedMsFromWastedBytes(s);let c=t.displayValue||"";typeof t.displayValue>"u"&&s&&(c=IR(no.displayValueByteSavings,{wastedBytes:s}));let u=t.sortedBy||["wastedBytes"],d=Dr.makeOpportunityDetails(t.headings,o,{overallSavingsMs:i,overallSavingsBytes:s,sortedBy:u});return d.debugData={type:"debugdata",metricSavings:l},{explanation:t.explanation,warnings:t.warnings,displayValue:c,numericValue:i,numericUnit:"millisecond",score:e.scoreForWastedMs(i),details:d,metricSavings:l}}static audit_(e,t,a){throw new Error("audit_ unimplemented")}}}));function VR(e,t,a){let n=a.split("\n"),r={},i=t,o=i;e.computeLastGeneratedColumns();for(let t of e.mappings()){let a=t.sourceURL,i=t.lineNumber,s=t.columnNumber,l=t.lastColumnNumber;if(!a)continue;let c=n[i];if(null==c){let t=`${e.url()} mapping for line out of bounds: ${i+1}`;return Kt.error("JSBundles",t),{errorMessage:t}}if(s>c.length){let t=`${e.url()} mapping for column out of bounds: ${i+1}:${s}`;return Kt.error("JSBundles",t),{errorMessage:t}}let u=0;if(void 0!==l){if(l>c.length){let t=`${e.url()} mapping for last column out of bounds: ${i+1}:${l}`;return Kt.error("JSBundles",t),{errorMessage:t}}u=l-s}else u=c.length-s+1;r[a]=(r[a]||0)+u,o-=u}return{files:r,unmappedBytes:o,totalBytes:i}}var WR,HR,GR,$R,KR,YR=s((()=>{J(),ea(),Bc(),WR=d($w(),1),o(VR,"computeGeneratedFileSizes"),HR=class{static{o(this,"JSBundles")}static async compute_(e){let{SourceMaps:t,Scripts:a}=e,n=[];for(let e of t){if(!e.map)continue;let{scriptId:t,map:r}=e;if(!r.mappings)continue;let i=a.find((e=>e.scriptId===t));if(!i)continue;let o=e.scriptUrl||"compiled.js",s=e.sourceMapUrl||"compiled.js.map",l=new WR.default.SourceMap(o,s,r),c={rawMap:r,script:i,map:l,sizes:VR(l,i.length||0,i.content||"")};n.push(c)}return n}},GR=dc(HR,["Scripts","SourceMaps"])})),JR=s((()=>{J(),Bc(),YR(),.1,512,$R=class e{static{o(this,"ModuleDuplication")}static normalizeSource(e){let t=(e=e.replace(/\?$/,"")).lastIndexOf("node_modules");return-1!==t&&(e=e.substring(t)),e}static _shouldIgnoreSource(e){return!!(e.includes("webpack/bootstrap")||e.includes("(webpack)/buildin")||e.includes("external "))}static _normalizeAggregatedData(e){for(let[t,a]of e.entries()){let n=a;if(n.sort(((e,t)=>t.resourceSize-e.resourceSize)),n.length>1){let e=n[0].resourceSize;n=n.filter((t=>t.resourceSize/e>=.1))}n=n.filter((e=>e.resourceSize>=512)),n.length>1?e.set(t,n):e.delete(t)}}static async compute_(t,a){let n=await GR.request(t,a),r=new Map;for(let{rawMap:t,sizes:a}of n){if("errorMessage"in a)continue;let n=[];r.set(t,n);for(let r=0;r<t.sources.length;r++){if(this._shouldIgnoreSource(t.sources[r]))continue;let i=(t.sourceRoot||"")+t.sources[r],o=a.files[i];n.push({source:e.normalizeSource(t.sources[r]),resourceSize:o})}}let i=new Map;for(let{rawMap:e,script:t}of n){let a=r.get(e);if(a)for(let e of a){let a=i.get(e.source);a||(a=[],i.set(e.source,a)),a.push({scriptId:t.scriptId,scriptUrl:t.url,resourceSize:e.resourceSize})}}return this._normalizeAggregatedData(i),i}},KR=dc($R,["Scripts","SourceMaps"])}));function ZR(e){return!(!e.startLine&&!e.startColumn)}function XR(e,t){let a=e.find((e=>e.url===t.url));for(;a?.redirectDestination;)a=a.redirectDestination;return a}var QR=s((()=>{J(),o(ZR,"isInline"),o(XR,"getRequestForScript")})),eF={};function tF(e,t,a=0){let n=e.indexOf(t,a);return-1===n?e.length:n}c(eF,{UIStrings:()=>aF,default:()=>iF});var aF,nF,rF,iF,oF=s((()=>{J(),zR(),JR(),ro(),QR(),nF=eo("core/audits/byte-efficiency/duplicated-javascript.js",aF={title:"Remove duplicate modules in JavaScript bundles",description:"Remove large, duplicate JavaScript modules from bundles to reduce unnecessary bytes consumed by network activity. "}),1024,o(tF,"indexOfOrEnd"),rF=class e extends MR{static{o(this,"DuplicatedJavascript")}static get meta(){return{id:"duplicated-javascript",title:nF(aF.title),description:nF(aF.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces","SourceMaps","Scripts","GatherContext","URL"]}}static _getNodeModuleName(e){let t=e.split("node_modules/"),a=tF(e=t[t.length-1],"/");return"@"===e[0]?e.slice(0,tF(e,"/",a+1)):e.slice(0,a)}static async _getDuplicationGroupedByNodeModules(t,a){let n=await KR.request(t,a),r=new Map;for(let[t,a]of n.entries()){if(!t.includes("node_modules")){r.set(t,a);continue}let n="node_modules/"+e._getNodeModuleName(t),i=r.get(n)||[];for(let{scriptId:e,scriptUrl:t,resourceSize:n}of a){let a=i.find((t=>t.scriptId===e));a||(a={scriptId:e,scriptUrl:t,resourceSize:0},i.push(a)),a.resourceSize+=n}r.set(n,i)}for(let e of n.values())e.sort(((e,t)=>t.resourceSize-e.resourceSize));return r}static _estimateTransferRatio(e,t){return MR.estimateTransferSize(e,t,"Script")/t}static async audit_(t,a,n){let r=n.options?.ignoreThresholdInBytes||1024,i=await e._getDuplicationGroupedByNodeModules(t,n),o=new Map,s=[],l=0,c=new Set,u=new Map;for(let[n,d]of i.entries()){let i=[],m=0;for(let n=0;n<d.length;n++){let r=d[n],s=r.scriptId,l=t.Scripts.find((e=>e.scriptId===s)),c=l?.url||"",p=o.get(c);if(void 0===p){if(!l||void 0===l.length)continue;let t=l.length,n=XR(a,l);p=e._estimateTransferRatio(n,t),o.set(c,p)}if(void 0===p)continue;let h=Math.round(r.resourceSize*p);i.push({url:c,sourceTransferBytes:h}),0!==n&&(m+=h,u.set(c,(u.get(c)||0)+h))}if(m<=r){l+=m;for(let e of i)c.add(e.url)}else s.push({source:n,wastedBytes:m,url:"",totalBytes:0,subItems:{type:"subitems",items:i}})}return l>r&&s.push({source:"Other",wastedBytes:l,url:"",totalBytes:0,subItems:{type:"subitems",items:Array.from(c).map((e=>({url:e})))}}),{items:s,headings:[{key:"source",valueType:"code",subItemsHeading:{key:"url",valueType:"url"},label:nF(no.columnSource)},{key:null,valueType:"bytes",subItemsHeading:{key:"sourceTransferBytes"},granularity:10,label:nF(no.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",granularity:10,label:nF(no.columnWastedBytes)}],wastedBytesByUrl:u}}},iF=rF})),sF={};c(sF,{UIStrings:()=>lF,default:()=>dF});var lF,cF,uF,dF,mF=s((()=>{J(),qc(),zR(),ro(),cF=eo("core/audits/byte-efficiency/efficient-animated-content.js",lF={title:"Use video formats for animated content",description:"Large GIFs are inefficient for delivering animated content. Consider using MPEG4/WebM videos for animations and PNG/WebP for static images instead of GIF to save network bytes. [Learn more about efficient video formats](https://developer.chrome.com/docs/lighthouse/performance/efficient-animated-content/)"}),102400,uF=class e extends MR{static{o(this,"EfficientAnimatedContent")}static get meta(){return{id:"efficient-animated-content",title:cF(lF.title),description:cF(lF.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces","GatherContext","URL"]}}static getPercentSavings(e){return Math.round(29.1*Math.log10(e)-100.7)/100}static audit_(t,a){return{items:a.filter((e=>"image/gif"===e.mimeType&&e.resourceType===wc.TYPES.Image&&(e.resourceSize||0)>102400)).map((t=>{let a=t.resourceSize||0;return{url:t.url,totalBytes:a,wastedBytes:Math.round(a*e.getPercentSavings(a))}})),headings:[{key:"url",valueType:"url",label:cF(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:cF(no.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:cF(no.columnWastedBytes)}]}}},dF=uF})),pF={};c(pF,{UIStrings:()=>gF,default:()=>bF});var hF,gF,fF,yF,vF,bF,wF=s((()=>{J(),ua(),xr(),zR(),Uu(),YR(),ro(),QR(),Xi(),'{\n  "moduleSizes": [11897, 498, 265, 277, 263, 453, 219, 216, 546, 339, 1608, 671, 1525, 420, 214, 504, 98, 524, 196, 268, 642, 204, 742, 618, 169, 394, 127, 433, 1473, 779, 239, 144, 182, 254, 77, 508, 124, 1388, 75, 133, 301, 362, 170, 1078, 182, 490, 195, 321, 316, 447, 551, 216, 284, 253, 17, 107, 295, 356, 345, 1939, 1596, 291, 139, 259, 1291, 179, 528, 174, 61, 326, 20, 444, 522, 104, 1945, 120, 1943, 680, 1409, 850, 630, 288, 38, 695, 569, 106, 587, 208, 370, 606, 766, 535, 616, 200, 170, 224, 422, 970, 978, 498, 284, 241, 210, 151, 194, 178, 814, 205, 189, 215, 111, 236, 147, 237, 191, 691, 212, 432, 499, 445, 176, 333, 129, 414, 617, 380, 251, 199, 524, 515, 681, 160, 259, 295, 283, 178, 472, 786, 520, 202, 575, 575, 349, 549, 458, 166, 173, 508, 1522, 743, 414, 431, 393, 899, 137, 270, 131, 472, 457, 205, 778, 801, 133, 3000],\n  "dependencies": {\n    "Array.prototype.fill": [0, 5, 8, 11, 21, 23, 25, 26, 29, 36, 37, 54, 55, 57, 58, 60, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 116],\n    "Array.prototype.filter": [0, 11, 12, 13, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 117],\n    "Array.prototype.find": [0, 5, 11, 12, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 55, 57, 58, 60, 62, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 119],\n    "Array.prototype.findIndex": [0, 5, 11, 12, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 55, 57, 58, 60, 62, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 118],\n    "Array.prototype.forEach": [0, 9, 11, 12, 14, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 120],\n    "Array.from": [0, 10, 11, 19, 20, 21, 22, 23, 25, 26, 27, 29, 36, 37, 41, 46, 49, 50, 54, 57, 58, 60, 61, 64, 66, 72, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 121],\n    "Array.isArray": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 62, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 122],\n    "Array.prototype.map": [0, 11, 12, 13, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 123],\n    "Array.of": [0, 11, 21, 22, 23, 25, 26, 27, 29, 36, 37, 54, 57, 58, 60, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 124],\n    "Array.prototype.some": [0, 11, 12, 14, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 125],\n    "Date.now": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 126],\n    "Date.prototype.toISOString": [0, 11, 21, 22, 23, 25, 26, 28, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 98, 99, 101, 102, 103, 104, 108, 109, 114, 127],\n    "Date.prototype.toJSON": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 128],\n    "Date.prototype.toString": [0, 25, 26, 29, 54, 58, 60, 74, 94, 114, 129],\n    "Function.prototype.name": [0, 130],\n    "Number.isInteger": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 67, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 131],\n    "Number.isSafeInteger": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 67, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 132],\n    "Object.defineProperties": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 133],\n    "Object.defineProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 134],\n    "Object.freeze": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 136],\n    "Object.getPrototypeOf": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 138],\n    "Object.isExtensible": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 139],\n    "Object.isFrozen": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 140],\n    "Object.isSealed": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 141],\n    "Object.keys": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 142],\n    "Object.preventExtensions": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 143],\n    "Object.seal": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 144],\n    "Object.setPrototypeOf": [0, 4, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 89, 92, 94, 101, 102, 103, 104, 114, 145],\n    "Reflect.apply": [0, 11, 21, 23, 25, 26, 29, 36, 37, 40, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 147],\n    "Reflect.construct": [0, 3, 11, 16, 21, 22, 23, 25, 26, 29, 36, 37, 40, 43, 54, 55, 57, 58, 60, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 148],\n    "Reflect.defineProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 149],\n    "Reflect.deleteProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 150],\n    "Reflect.get": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 65, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 153],\n    "Reflect.getOwnPropertyDescriptor": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 151],\n    "Reflect.getPrototypeOf": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 152],\n    "Reflect.has": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 154],\n    "Reflect.isExtensible": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 155],\n    "Reflect.ownKeys": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 156],\n    "Reflect.preventExtensions": [0, 11, 21, 23, 25, 26, 29, 36, 37, 39, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 157],\n    "Reflect.setPrototypeOf": [0, 4, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 89, 92, 94, 101, 102, 103, 104, 114, 158],\n    "String.prototype.codePointAt": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 97, 101, 102, 103, 104, 108, 109, 114, 159],\n    "String.fromCodePoint": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 160],\n    "String.raw": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 109, 114, 161],\n    "String.prototype.repeat": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 99, 101, 102, 103, 104, 108, 109, 114, 162],\n    "Object.entries": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 90, 92, 94, 101, 102, 103, 104, 114, 135],\n    "Object.getOwnPropertyDescriptors": [0, 11, 21, 23, 25, 26, 27, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 137],\n    "Object.values": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 90, 92, 94, 101, 102, 103, 104, 114, 146],\n    "focus-visible": [163]\n  },\n  "maxSize": 87683\n}',hF=JSON.parse('{\n  "moduleSizes": [11897, 498, 265, 277, 263, 453, 219, 216, 546, 339, 1608, 671, 1525, 420, 214, 504, 98, 524, 196, 268, 642, 204, 742, 618, 169, 394, 127, 433, 1473, 779, 239, 144, 182, 254, 77, 508, 124, 1388, 75, 133, 301, 362, 170, 1078, 182, 490, 195, 321, 316, 447, 551, 216, 284, 253, 17, 107, 295, 356, 345, 1939, 1596, 291, 139, 259, 1291, 179, 528, 174, 61, 326, 20, 444, 522, 104, 1945, 120, 1943, 680, 1409, 850, 630, 288, 38, 695, 569, 106, 587, 208, 370, 606, 766, 535, 616, 200, 170, 224, 422, 970, 978, 498, 284, 241, 210, 151, 194, 178, 814, 205, 189, 215, 111, 236, 147, 237, 191, 691, 212, 432, 499, 445, 176, 333, 129, 414, 617, 380, 251, 199, 524, 515, 681, 160, 259, 295, 283, 178, 472, 786, 520, 202, 575, 575, 349, 549, 458, 166, 173, 508, 1522, 743, 414, 431, 393, 899, 137, 270, 131, 472, 457, 205, 778, 801, 133, 3000],\n  "dependencies": {\n    "Array.prototype.fill": [0, 5, 8, 11, 21, 23, 25, 26, 29, 36, 37, 54, 55, 57, 58, 60, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 116],\n    "Array.prototype.filter": [0, 11, 12, 13, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 117],\n    "Array.prototype.find": [0, 5, 11, 12, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 55, 57, 58, 60, 62, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 119],\n    "Array.prototype.findIndex": [0, 5, 11, 12, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 55, 57, 58, 60, 62, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 118],\n    "Array.prototype.forEach": [0, 9, 11, 12, 14, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 120],\n    "Array.from": [0, 10, 11, 19, 20, 21, 22, 23, 25, 26, 27, 29, 36, 37, 41, 46, 49, 50, 54, 57, 58, 60, 61, 64, 66, 72, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 121],\n    "Array.isArray": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 62, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 122],\n    "Array.prototype.map": [0, 11, 12, 13, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 123],\n    "Array.of": [0, 11, 21, 22, 23, 25, 26, 27, 29, 36, 37, 54, 57, 58, 60, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 124],\n    "Array.prototype.some": [0, 11, 12, 14, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 125],\n    "Date.now": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 126],\n    "Date.prototype.toISOString": [0, 11, 21, 22, 23, 25, 26, 28, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 98, 99, 101, 102, 103, 104, 108, 109, 114, 127],\n    "Date.prototype.toJSON": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 128],\n    "Date.prototype.toString": [0, 25, 26, 29, 54, 58, 60, 74, 94, 114, 129],\n    "Function.prototype.name": [0, 130],\n    "Number.isInteger": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 67, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 131],\n    "Number.isSafeInteger": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 67, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 132],\n    "Object.defineProperties": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 133],\n    "Object.defineProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 134],\n    "Object.freeze": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 136],\n    "Object.getPrototypeOf": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 138],\n    "Object.isExtensible": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 139],\n    "Object.isFrozen": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 140],\n    "Object.isSealed": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 141],\n    "Object.keys": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 142],\n    "Object.preventExtensions": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 143],\n    "Object.seal": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 144],\n    "Object.setPrototypeOf": [0, 4, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 89, 92, 94, 101, 102, 103, 104, 114, 145],\n    "Reflect.apply": [0, 11, 21, 23, 25, 26, 29, 36, 37, 40, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 147],\n    "Reflect.construct": [0, 3, 11, 16, 21, 22, 23, 25, 26, 29, 36, 37, 40, 43, 54, 55, 57, 58, 60, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 148],\n    "Reflect.defineProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 149],\n    "Reflect.deleteProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 150],\n    "Reflect.get": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 65, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 153],\n    "Reflect.getOwnPropertyDescriptor": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 151],\n    "Reflect.getPrototypeOf": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 152],\n    "Reflect.has": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 154],\n    "Reflect.isExtensible": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 155],\n    "Reflect.ownKeys": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 156],\n    "Reflect.preventExtensions": [0, 11, 21, 23, 25, 26, 29, 36, 37, 39, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 157],\n    "Reflect.setPrototypeOf": [0, 4, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 89, 92, 94, 101, 102, 103, 104, 114, 158],\n    "String.prototype.codePointAt": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 97, 101, 102, 103, 104, 108, 109, 114, 159],\n    "String.fromCodePoint": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 160],\n    "String.raw": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 109, 114, 161],\n    "String.prototype.repeat": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 99, 101, 102, 103, 104, 108, 109, 114, 162],\n    "Object.entries": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 90, 92, 94, 101, 102, 103, 104, 114, 135],\n    "Object.getOwnPropertyDescriptors": [0, 11, 21, 23, 25, 26, 27, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 137],\n    "Object.values": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 90, 92, 94, 101, 102, 103, 104, 114, 146],\n    "focus-visible": [163]\n  },\n  "maxSize": 87683\n}'),fF=eo("core/audits/byte-efficiency/legacy-javascript.js",gF={title:"Avoid serving legacy JavaScript to modern browsers",description:"Polyfills and transforms enable legacy browsers to use new JavaScript features. However, many aren't necessary for modern browsers. For your bundled JavaScript, adopt a modern script deployment strategy using module/nomodule feature detection to reduce the amount of code shipped to modern browsers, while retaining support for legacy browsers. [Learn how to use modern JavaScript](https://web.dev/publish-modern-javascript/)"}),yF=class{static{o(this,"CodePatternMatcher")}constructor(e){let t=e.map((e=>`(${e.expression})`)).join("|");this.re=new RegExp(`(^\r\n|\r|\n)|${t}`,"g"),this.patterns=e}match(e){this.re.lastIndex=0;let t,a=new Set,n=[],r=0,i=0;for(;null!==(t=this.re.exec(e));){let e=t.slice(1),[o,...s]=e;if(o){r++,i=t.index+1;continue}let l=this.patterns[s.findIndex(Boolean)];if(a.has(l)){let e=n.find((e=>e.name===l.name));e&&(e.count+=1)}else a.add(l),n.push({name:l.name,line:r,column:t.index-i,count:1})}return n}},vF=class extends MR{static{o(this,"LegacyJavascript")}static get meta(){return{id:"legacy-javascript",scoreDisplayMode:MR.SCORING_MODES.NUMERIC,description:fF(gF.description),title:fF(gF.title),requiredArtifacts:["devtoolsLogs","traces","Scripts","SourceMaps","GatherContext","URL"]}}static buildPolyfillExpression(e,t){let a=o((e=>`['"]${e}['"]`),"qt"),n="";if(n+=e?`${e}\\.${t}\\s?=[^=]`:`(?:window\\.|[\\s;]+)${t}\\s?=[^=]`,e&&(n+=`|${e}\\[${a(t)}\\]\\s?=[^=]`),n+=`|defineProperty\\(${e||"window"},\\s?${a(t)}`,e){let r=e.replace(".prototype","");n+=`|\\$export\\([^,]+,${a(r)},{${t}:`,n+=`|{target:${a(r)}\\S*},{${t}:`}else n+=`|function ${t}\\(`;return n}static getPolyfillData(){let e=[{name:"focus-visible",modules:["focus-visible"]}],t=[["Array.prototype.fill","es6.array.fill"],["Array.prototype.filter","es6.array.filter"],["Array.prototype.find","es6.array.find"],["Array.prototype.findIndex","es6.array.find-index"],["Array.prototype.forEach","es6.array.for-each"],["Array.from","es6.array.from"],["Array.isArray","es6.array.is-array"],["Array.prototype.map","es6.array.map"],["Array.of","es6.array.of"],["Array.prototype.some","es6.array.some"],["Date.now","es6.date.now"],["Date.prototype.toISOString","es6.date.to-iso-string"],["Date.prototype.toJSON","es6.date.to-json"],["Date.prototype.toString","es6.date.to-string"],["Function.prototype.name","es6.function.name"],["Number.isInteger","es6.number.is-integer"],["Number.isSafeInteger","es6.number.is-safe-integer"],["Object.defineProperties","es6.object.define-properties"],["Object.defineProperty","es6.object.define-property"],["Object.freeze","es6.object.freeze"],["Object.getPrototypeOf","es6.object.get-prototype-of"],["Object.isExtensible","es6.object.is-extensible"],["Object.isFrozen","es6.object.is-frozen"],["Object.isSealed","es6.object.is-sealed"],["Object.keys","es6.object.keys"],["Object.preventExtensions","es6.object.prevent-extensions"],["Object.seal","es6.object.seal"],["Object.setPrototypeOf","es6.object.set-prototype-of"],["Reflect.apply","es6.reflect.apply"],["Reflect.construct","es6.reflect.construct"],["Reflect.defineProperty","es6.reflect.define-property"],["Reflect.deleteProperty","es6.reflect.delete-property"],["Reflect.get","es6.reflect.get"],["Reflect.getOwnPropertyDescriptor","es6.reflect.get-own-property-descriptor"],["Reflect.getPrototypeOf","es6.reflect.get-prototype-of"],["Reflect.has","es6.reflect.has"],["Reflect.isExtensible","es6.reflect.is-extensible"],["Reflect.ownKeys","es6.reflect.own-keys"],["Reflect.preventExtensions","es6.reflect.prevent-extensions"],["Reflect.setPrototypeOf","es6.reflect.set-prototype-of"],["String.prototype.codePointAt","es6.string.code-point-at"],["String.fromCodePoint","es6.string.from-code-point"],["String.raw","es6.string.raw"],["String.prototype.repeat","es6.string.repeat"],["Object.entries","es7.object.entries"],["Object.getOwnPropertyDescriptors","es7.object.get-own-property-descriptors"],["Object.values","es7.object.values"]];for(let[a,n]of t)e.push({name:a,modules:[n,n.replace("es6.","es.").replace("es7.","es.").replace("typed.","typed-array.")],corejs:!0});return e}static getCoreJsPolyfillData(){return this.getPolyfillData().filter((e=>e.corejs)).map((e=>({name:e.name,coreJs2Module:e.modules[0],coreJs3Module:e.modules[1]})))}static getPolyfillPatterns(){let e=[];for(let{name:t}of this.getCoreJsPolyfillData()){let a=t.split("."),n=a.length>1?a.slice(0,a.length-1).join("."):null,r=a[a.length-1];e.push({name:t,expression:this.buildPolyfillExpression(n,r)})}return e}static getTransformPatterns(){return[{name:"@babel/plugin-transform-classes",expression:"Cannot call a class as a function",estimateBytes:e=>150+17*e.count},{name:"@babel/plugin-transform-regenerator",expression:/regeneratorRuntime\(?\)?\.a?wrap/.source,estimateBytes:e=>80*e.count},{name:"@babel/plugin-transform-spread",expression:/\.apply\(void 0,\s?_toConsumableArray/.source,estimateBytes:e=>1169+20*e.count}]}static detectAcrossScripts(e,t,a,n){let r=new Map,i=this.getPolyfillData();for(let a of Object.values(t)){if(!a.content)continue;let t=e.match(a.content),o=n.find((e=>e.script.scriptId===a.scriptId));if(o)for(let{name:e,modules:a}of i){if(t.some((t=>t.name===e)))continue;let n=o.rawMap.sources.find((e=>a.some((t=>e.endsWith(`${t}.js`)))));if(!n)continue;let r=o.map.mappings().find((e=>e.sourceURL===n));r?t.push({name:e,line:r.lineNumber,column:r.columnNumber,count:1}):t.push({name:e,line:0,column:0,count:1})}t.length&&r.set(a,t)}return r}static estimateWastedBytes(e){let t=e.filter((e=>!e.name.startsWith("@"))),a=e.filter((e=>e.name.startsWith("@"))),n=0,r=new Set;for(let e of t){let t=hF.dependencies[e.name];if(t)for(let e of t)r.add(e)}n+=[...r].reduce(((e,t)=>e+hF.moduleSizes[t]),0),n=Math.min(n,hF.maxSize);let i=0;for(let e of a){let t=this.getTransformPatterns().find((t=>t.name===e.name));!t||!t.estimateBytes||(i+=t.estimateBytes(e))}return n+i}static async estimateTransferRatioForScript(e,t,a,n){let r=e.get(t);if(void 0!==r)return r;let i=a.Scripts.find((e=>e.url===t));if(i&&null!==i.content){let e=XR(n,i),t=i.length||0;r=MR.estimateTransferSize(e,t,"Script")/t}else r=1;return e.set(t,r),r}static async audit_(e,t,a){let n=e.devtoolsLogs[Dr.DEFAULT_PASS],r=await Pu.request({URL:e.URL,devtoolsLog:n},a),i=await GR.request(e,a),o=[],s=new yF([...this.getPolyfillPatterns(),...this.getTransformPatterns()]),l=new Map,c=this.detectAcrossScripts(s,e.Scripts,t,i);for(let[a,n]of c.entries()){let r=await this.estimateTransferRatioForScript(l,a.url,e,t),s=Math.round(this.estimateWastedBytes(n)*r),c={url:a.url,wastedBytes:s,subItems:{type:"subitems",items:[]},totalBytes:0},u=i.find((e=>e.script.scriptId===a.scriptId));for(let e of n){let{name:t,line:n,column:r}=e,i={signal:t,location:MR.makeSourceLocation(a.url,n,r,u)};c.subItems.items.push(i)}o.push(c)}let u=new Map;for(let e of o)r.isFirstParty(e.url)&&u.set(e.url,e.wastedBytes);return{items:o,headings:[{key:"url",valueType:"url",subItemsHeading:{key:"location",valueType:"source-location"},label:fF(no.columnURL)},{key:null,valueType:"code",subItemsHeading:{key:"signal"},label:""},{key:"wastedBytes",valueType:"bytes",label:fF(no.columnWastedBytes)}],wastedBytesByUrl:u}}},bF=vF})),DF={};c(DF,{UIStrings:()=>EF,default:()=>CF});var EF,TF,SF,CF,kF,xF,AF,_F,RF,FF,NF=s((()=>{J(),zR(),ql(),ro(),TF=eo("core/audits/byte-efficiency/modern-image-formats.js",EF={title:"Serve images in next-gen formats",description:"Image formats like WebP and AVIF often provide better compression than PNG or JPEG, which means faster downloads and less data consumption. [Learn more about modern image formats](https://developer.chrome.com/docs/lighthouse/performance/uses-webp-images/)."}),8192,SF=class e extends MR{static{o(this,"ModernImageFormats")}static get meta(){return{id:"modern-image-formats",title:TF(EF.title),description:TF(EF.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["OptimizedImages","devtoolsLogs","traces","URL","GatherContext","ImageElements"]}}static estimateWebPSizeFromDimensions(e){let t=e.naturalWidth*e.naturalHeight;return Math.round(.2*t)}static estimateAvifSizeFromDimensions(e){let t=e.naturalWidth*e.naturalHeight;return Math.round(t*(2/12))}static estimateAvifSizeFromWebPAndJpegEstimates(e){if(!e.jpegSize||!e.webpSize)return;return 5*e.jpegSize/10/2+8*e.webpSize/10/2}static audit_(t){let a=t.URL.finalDisplayedUrl,n=t.OptimizedImages,r=t.ImageElements,i=new Map;r.forEach((e=>i.set(e.src,e)));let o=[],s=[];for(let t of n){let n=i.get(t.url);if(t.failed){s.push(`Unable to decode ${Ml.getURLDisplayName(t.url)}`);continue}if("image/webp"===t.mimeType||"image/avif"===t.mimeType)continue;let r=t.jpegSize,l=t.webpSize,c=e.estimateAvifSizeFromWebPAndJpegEstimates({jpegSize:r,webpSize:l}),u=!0;if(typeof l>"u"){if(!n){s.push(`Unable to locate resource ${Ml.getURLDisplayName(t.url)}`);continue}if(!n.naturalDimensions)continue;let a=n.naturalDimensions.height,r=n.naturalDimensions.width;if(!r||!a)continue;l=e.estimateWebPSizeFromDimensions({naturalHeight:a,naturalWidth:r}),c=e.estimateAvifSizeFromDimensions({naturalHeight:a,naturalWidth:r}),u=!1}if(void 0===l||void 0===c)continue;let d=t.originalSize-l,m=t.originalSize-c;if(m<8192)continue;let p=Ml.elideDataURI(t.url),h=!Ml.originsMatch(a,t.url);o.push({node:n?MR.makeNodeItem(n.node):void 0,url:p,fromProtocol:u,isCrossOrigin:h,totalBytes:t.originalSize,wastedBytes:m,wastedWebpBytes:d})}return{warnings:s,items:o,headings:[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:TF(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:TF(no.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:TF(no.columnWastedBytes)}]}}},CF=SF})),IF=s((()=>{J(),na(),Hc(),yD(),Yc(),kF=class{static{o(this,"Metric")}constructor(){}static getMetricComputationInput(e){return{trace:e.trace,devtoolsLog:e.devtoolsLog,gatherContext:e.gatherContext,settings:e.settings,URL:e.URL}}static computeSimulatedMetric(e,t){throw new Error("Unimplemented")}static computeObservedMetric(e,t){throw new Error("Unimplemented")}static async compute_(e,t){let a=e.gatherContext||{gatherMode:"navigation"},{trace:n,devtoolsLog:r,settings:i}=e;if(!n||!r||!i)throw new Error("Did not provide necessary metric computation data");let o=await kc.request(n,t),s="timespan"===a.gatherMode?void 0:await lD.request(n,t),l=Object.assign({networkRecords:await Pc.request(r,t),gatherContext:a,processedTrace:o,processedNavigation:s},e);switch(Xt.assertHasToplevelEvents(l.processedTrace.mainThreadEvents),i.throttlingMethod){case"simulate":if("navigation"!==a.gatherMode)throw new Error(`${a.gatherMode} does not support throttlingMethod simulate`);return this.computeSimulatedMetric(l,t);case"provided":case"devtools":return this.computeObservedMetric(l,t);default:throw new TypeError(`Unrecognized throttling method: ${i.throttlingMethod}`)}}},xF=kF})),MF=s((()=>{J(),IF(),AF=class extends xF{static{o(this,"NavigationMetric")}static computeSimulatedMetric(e,t){throw new Error("Unimplemented")}static computeObservedMetric(e,t){throw new Error("Unimplemented")}static async compute_(e,t){if("navigation"!==e.gatherContext.gatherMode)throw new Error(`${this.name} can only be computed on navigations`);return super.compute_(e,t)}}})),PF=s((()=>{J(),Bc(),MF(),UR(),Sd(),na(),xl(),_F=5e3,2,RF=class e extends AF{static{o(this,"Interactive")}static _findNetworkQuietPeriods(e,t){let a=t.timestamps.traceEnd/1e3,n=e.filter((e=>e.finished&&"GET"===e.requestMethod&&!e.failed&&e.statusCode<400));return gd.findNetworkQuietPeriods(n,2,a)}static _findCPUQuietPeriods(e,t){let a=t.timestamps.timeOrigin/1e3,n=t.timestamps.traceEnd/1e3;if(0===e.length)return[{start:0,end:n}];let r=[];return e.forEach(((t,i)=>{0===i&&r.push({start:0,end:t.start+a}),i===e.length-1?r.push({start:t.end+a,end:n}):r.push({start:t.end+a,end:e[i+1].start+a})})),r}static findOverlappingQuietPeriods(e,t,a){let n=a.timestamps.firstContentfulPaint/1e3,r=o((e=>e.end>n+_F&&e.end-e.start>=_F),"isLongEnoughQuietPeriod"),i=this._findNetworkQuietPeriods(t,a).filter(r),s=this._findCPUQuietPeriods(e,a).filter(r),l=s.slice(),c=i.slice(),u=l.shift(),d=c.shift();for(;u&&d;)if(u.start>=d.start){if(d.end>=u.start+_F)return{cpuQuietPeriod:u,networkQuietPeriod:d,cpuQuietPeriods:s,networkQuietPeriods:i};d=c.shift()}else{if(u.end>=d.start+_F)return{cpuQuietPeriod:u,networkQuietPeriod:d,cpuQuietPeriods:s,networkQuietPeriods:i};u=l.shift()}throw new El(u?El.errors.NO_TTI_NETWORK_IDLE_PERIOD:El.errors.NO_TTI_CPU_IDLE_PERIOD)}static computeSimulatedMetric(e,t){let a=AF.getMetricComputationInput(e);return AR.request(a,t)}static computeObservedMetric(t){let{processedTrace:a,processedNavigation:n,networkRecords:r}=t;if(!n.timestamps.domContentLoaded)throw new El(El.errors.NO_DCL);let i=Xt.getMainThreadTopLevelEvents(a).filter((e=>e.duration>=50)),o=e.findOverlappingQuietPeriods(i,r,n).cpuQuietPeriod,s=1e3*Math.max(o.start,n.timestamps.firstContentfulPaint/1e3,n.timestamps.domContentLoaded/1e3),l=(s-n.timestamps.timeOrigin)/1e3;return Promise.resolve({timing:l,timestamp:s})}},FF=dc(RF,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),LF={};c(LF,{UIStrings:()=>OF,default:()=>BF});var OF,jF,UF,BF,qF,zF,VF,WF,HF,GF=s((()=>{J(),zR(),qc(),Du(),ql(),ro(),PF(),Hc(),jF=eo("core/audits/byte-efficiency/offscreen-images.js",OF={title:"Defer offscreen images",description:"Consider lazy-loading offscreen and hidden images after all critical resources have finished loading to lower time to interactive. [Learn how to defer offscreen images](https://developer.chrome.com/docs/lighthouse/performance/offscreen-images/)."}),100,3,2048,75,50,UF=class e extends MR{static{o(this,"OffscreenImages")}static get meta(){return{id:"offscreen-images",title:jF(OF.title),description:jF(OF.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["ImageElements","ViewportDimensions","GatherContext","devtoolsLogs","traces","URL"]}}static computeVisiblePixels(e,t){let a=t.innerWidth,n=t.innerHeight,r=3*t.innerHeight,i=Math.max(e.top,-100),o=Math.min(e.right,a+100),s=Math.min(e.bottom,n+r),l=Math.max(e.left,-100);return Math.max(o-l,0)*Math.max(s-i,0)}static computeWaste(e,t,a){let n=a.find((t=>t.url===e.src));if(!n||"lazy"===e.loading||"eager"===e.loading)return null;let r=Ml.elideDataURI(e.src),i=e.displayedWidth*e.displayedHeight,o=this.computeVisiblePixels(e.clientRect,t),s=0===i?1:1-o/i,l=wc.getResourceSizeOnNetwork(n),c=Math.round(l*s);return Number.isFinite(s)?{node:MR.makeNodeItem(e.node),url:r,requestStartTime:n.networkRequestTime,totalBytes:l,wastedBytes:c,wastedPercent:100*s}:new Error(`Invalid image sizing information ${r}`)}static filterLanternResults(e,t){let a=t.pessimisticEstimate.nodeTimings,n=0,r=new Map;for(let[e,t]of a)"cpu"===e.type&&t.duration>=50?n=Math.max(n,t.startTime):"network"===e.type&&r.set(e.record.url,t.startTime);return e.filter((e=>!(e.wastedBytes<2048||e.wastedPercent<75)&&(r.get(e.url)||0)<n-50))}static filterObservedResults(e,t){return e.filter((e=>!(e.wastedBytes<2048||e.wastedPercent<75)&&e.requestStartTime<t/1e3-50))}static computeWasteWithTTIGraph(e,t,a){return super.computeWasteWithTTIGraph(e,t,a,{includeLoad:!1})}static async audit_(t,a,n){let r=t.ImageElements,i=t.ViewportDimensions,o=t.GatherContext,s=t.traces[MR.DEFAULT_PASS],l=t.devtoolsLogs[MR.DEFAULT_PASS],c=t.URL,u=[],d=new Map;for(let t of r){let n=e.computeWaste(t,i,a);if(null===n)continue;if(n instanceof Error){u.push(n.message),vu.captureException(n,{tags:{audit:this.meta.id},level:"warning"});continue}let r=d.get(n.url);(!r||r.wastedBytes>n.wastedBytes)&&d.set(n.url,n)}let m,p=n.settings,h=Array.from(d.values());try{let t={trace:s,devtoolsLog:l,gatherContext:o,settings:p,URL:c},a=await FF.request(t,n),r=a;m="simulate"===n.settings.throttlingMethod?e.filterLanternResults(h,r):e.filterObservedResults(h,a.timestamp)}catch(t){if("simulate"===n.settings.throttlingMethod)throw t;m=e.filterObservedResults(h,await kc.request(s,n).then((e=>e.timestamps.traceEnd)))}return{warnings:u,items:m,headings:[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:jF(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:jF(no.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:jF(no.columnWastedBytes)}]}}},BF=UF})),$F=s((()=>{J(),Bc(),zR(),Yc(),kr(),qF=100,zF=class e{static{o(this,"UnusedCSS")}static indexStylesheetsById(e,t){let a=t.filter((e=>e.resourceSize>0)).reduce(((e,t)=>(e[t.url]=t,e)),{});return e.reduce(((e,t)=>(e[t.header.styleSheetId]=Object.assign({usedRules:[],networkRecord:a[t.header.sourceURL]},t),e)),{})}static indexUsedRules(e,t){e.forEach((e=>{let a=t[e.styleSheetId];a&&e.used&&a.usedRules.push(e)}))}static computeUsage(e){let t=0,a=e.content.length;for(let a of e.usedRules)t+=a.endOffset-a.startOffset;let n=MR.estimateTransferSize(e.networkRecord,a,"Stylesheet"),r=(a-t)/a;return{wastedBytes:Math.round(r*n),wastedPercent:100*r,totalBytes:n}}static determineContentPreview(e){let t=br.truncate(e||"",500,"").replace(/( {2,}|\t)+/g,"  ").replace(/\n\s+}/g,"\n}").trim();if(t.length>qF){let e=t.indexOf("{"),a=t.indexOf("}");if(-1===e||-1===a||e>a||e>qF)t=br.truncate(t,qF);else if(a<qF)t=t.slice(0,a+1)+" …";else{let a=br.truncate(t,qF,""),n=a.lastIndexOf(";");t=n<e?a+"… } …":t.slice(0,n+1)+" … } …"}}return t}static mapSheetToResult(t){let a=t.header.sourceURL;return(!a||t.header.isInline)&&(a=e.determineContentPreview(t.content)),{url:a,...e.computeUsage(t)}}static async compute_(t,a){let{CSSUsage:n,devtoolsLog:r}=t,i=await Pc.request(r,a),o=e.indexStylesheetsById(n.stylesheets,i);return e.indexUsedRules(n.rules,o),Object.keys(o).map((t=>e.mapSheetToResult(o[t])))}},VF=dc(zF,["CSSUsage","devtoolsLog"])})),KF=s((()=>{J(),Bc(),MF(),OR(),WF=class extends AF{static{o(this,"FirstContentfulPaint")}static computeSimulatedMetric(e,t){let a=AF.getMetricComputationInput(e);return SR.request(a,t)}static async computeObservedMetric(e){let{processedNavigation:t}=e;return{timing:t.timings.firstContentfulPaint,timestamp:t.timestamps.firstContentfulPaint}}},HF=dc(WF,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),YF={};function JF(e){let t={};return Array.from(e.keys()).forEach((a=>{if("network"!==a.type)return;let n=e.get(a);n&&(t[a.record.url]={node:a,nodeTiming:n})})),t}function ZF(e,t,a){let n=e.get(t);if(!n)return;let r=XF(t,n,a);n.duration-r.duration&&(t.traverse((t=>{e.delete(t)})),e.set(t,r))}function XF(e,t,a){let n={...t};return a.some((e=>"amp"===e.id))&&e.type===fl.TYPES.NETWORK&&e.record.resourceType===wc.TYPES.Stylesheet&&t.endTime>2100&&(n.endTime=Math.max(t.startTime,2100),n.duration=n.endTime-n.startTime),n}c(YF,{UIStrings:()=>QF,default:()=>aN});var QF,eN,tN,aN,nN=s((()=>{J(),xr(),ro(),Cl(),zR(),$F(),qc(),yD(),Zc(),KF(),50,eN=eo("core/audits/byte-efficiency/render-blocking-resources.js",QF={title:"Eliminate render-blocking resources",description:"Resources are blocking the first paint of your page. Consider delivering critical JS/CSS inline and deferring all non-critical JS/styles. [Learn how to eliminate render-blocking resources](https://developer.chrome.com/docs/lighthouse/performance/render-blocking-resources/)."}),o(JF,"getNodesAndTimingByUrl"),o(ZF,"adjustNodeTimings"),o(XF,"computeStackSpecificTiming"),tN=class e extends Dr{static{o(this,"RenderBlockingResources")}static get meta(){return{id:"render-blocking-resources",title:eN(QF.title),supportedModes:["navigation"],scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,description:eN(QF.description),requiredArtifacts:["URL","TagsBlockingFirstPaint","traces","devtoolsLogs","CSSUsage","GatherContext","Stacks"]}}static async computeResults(t,a){let n=t.GatherContext,r=t.traces[Dr.DEFAULT_PASS],i=t.devtoolsLogs[Dr.DEFAULT_PASS],o={devtoolsLog:i,settings:a.settings},s=await lD.request(r,a),l=await Uc.request(o,a),c=await e.computeWastedCSSBytes(t,a),u={trace:r,devtoolsLog:i,gatherContext:n,simulator:l,settings:{...a.settings,throttlingMethod:"simulate"},URL:t.URL},d=await HF.request(u,a),m=s.timestamps.firstContentfulPaint/1e3,p=JF(d.optimisticEstimate.nodeTimings),h=[],g=new Set;for(let e of t.TagsBlockingFirstPaint){if(e.endTime>m||!p[e.tag.url])continue;let{node:a,nodeTiming:n}=p[e.tag.url],r=XF(a,n,t.Stacks);a.traverse((e=>g.add(e.id)));let i=Math.round(r.duration);i<50||h.push({url:e.tag.url,totalBytes:e.transferSize,wastedMs:i})}return h.length?{results:h,wastedMs:e.estimateSavingsWithGraphs(l,d.optimisticGraph,g,c,t.Stacks)}:{results:h,wastedMs:0}}static estimateSavingsWithGraphs(e,t,a,n,r){let{nodeTimings:i}=e.simulate(t),o=new Map(i),s=0,l=t.cloneWithRelationships((e=>{ZF(o,e,r);let t=a.has(e.id);if(e.type!==fl.TYPES.NETWORK)return!t;let i=e.record.resourceType===wc.TYPES.Stylesheet;if(t&&i){let t=n.get(e.record.url)||0;s+=(e.record.transferSize||0)-t}return!t}));if("network"!==l.type)throw new Error("minimalFCPGraph not a NetworkNode");let c=Math.max(...Array.from(Array.from(o).map((e=>e[1].endTime)))),u=l.record.transferSize,d=u||0;l.record.transferSize=d+s;let m=e.simulate(l).timeInMs;return l.record.transferSize=u,Math.round(Math.max(c-m,0))}static async computeWastedCSSBytes(e,t){let a=new Map;try{let n=await VF.request({CSSUsage:e.CSSUsage,devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS]},t);for(let e of n)a.set(e.url,e.wastedBytes)}catch{}return a}static async audit(t,a){let n,{results:r,wastedMs:i}=await e.computeResults(t,a);r.length>0&&(n=eN(no.displayValueMsSavings,{wastedMs:i}));let o=[{key:"url",valueType:"url",label:eN(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:eN(no.columnTransferSize)},{key:"wastedMs",valueType:"timespanMs",label:eN(no.columnWastedMs)}],s=Dr.makeOpportunityDetails(o,r,{overallSavingsMs:i});return{displayValue:n,score:MR.scoreForWastedMs(i),numericValue:i,numericUnit:"millisecond",details:s,metricSavings:{FCP:i,LCP:i}}}},aN=tN})),rN={};c(rN,{UIStrings:()=>iN,default:()=>lN});var iN,oN,sN,lN,cN=s((()=>{J(),xr(),ro(),qc(),Yc(),oN=eo("core/audits/byte-efficiency/total-byte-weight.js",iN={title:"Avoids enormous network payloads",failureTitle:"Avoid enormous network payloads",description:"Large network payloads cost users real money and are highly correlated with long load times. [Learn how to reduce payload sizes](https://developer.chrome.com/docs/lighthouse/performance/total-byte-weight/).",displayValue:"Total size was {totalBytes, number, bytes} KiB"}),sN=class extends Dr{static{o(this,"TotalByteWeight")}static get meta(){return{id:"total-byte-weight",title:oN(iN.title),failureTitle:oN(iN.failureTitle),description:oN(iN.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs"]}}static get defaultOptions(){return{p10:2731008,median:4096e3}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=await Pc.request(a,t),r=0,i=[];n.forEach((e=>{if(wc.isNonNetworkRequest(e)||!e.transferSize)return;let t={url:e.url,totalBytes:e.transferSize};r+=t.totalBytes,i.push(t)})),i=i.sort(((e,t)=>t.totalBytes-e.totalBytes||e.url.localeCompare(t.url))).slice(0,10);let o=Dr.computeLogNormalScore({p10:t.options.p10,median:t.options.median},r),s=[{key:"url",valueType:"url",label:oN(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:oN(no.columnTransferSize)}],l=Dr.makeTableDetails(s,i,{sortedBy:["totalBytes"]});return{score:o,numericValue:r,numericUnit:"byte",displayValue:oN(iN.displayValue,{totalBytes:r}),details:l}}},lN=sN}));function uN(e,t){for(let a=t;a>0;a--){let t=Math.max(0,a-6),n=e.slice(t,a);if(!gN.test(n))return hN.test(n)}return!0}function dN(e,t){let a=0,n=!1,r=!1,i=!1,o=!1,s=!1,l=!1,c=null,u=[];for(let d=0;d<e.length;d++){let m=e.substr(d,2),p=m.charAt(0),h=" "===p||"\n"===p||"\t"===p,g="'"===p||'"'===p||"`"===p;n?"\n"===p&&(n=!1):r?(i&&a++,"*/"===m&&(i&&a++,r=!1,d++)):o?(a++,"`"===c&&"${"===m?(u.push("templateBrace"),o=!1,a++,d++):"\\"===p?(a++,d++):p===c&&(o=!1)):s?(a++,"\\"===p?(a++,d++):"["===p?l=!0:"]"===p&&l?l=!1:"/"===p&&!l&&(s=!1)):"/*"===m?(r=!0,i="!"===e.charAt(d+2),i&&(a+=2),d++):"//"===m&&t.singlelineComments?(n=!0,r=!1,i=!1,d++):"/"===p&&t.regex&&uN(e,d)?(s=!0,a++):"{"===p&&u.length?(u.push("normalBrace"),a++):"}"===p&&u.length?("templateBrace"===u[u.length-1]&&(o=!0,c="`"),u.pop(),a++):g?(o=!0,c=p,a++):h||a++}return r||o?e.length:a}function mN(e){return dN(e,{singlelineComments:!0,regex:!0})}function pN(e){return dN(e,{singlelineComments:!1,regex:!1})}var hN,gN,fN=s((()=>{J(),hN=/(return|case|{|\(|\[|\.\.\.|;|,|<|>|<=|>=|==|!=|===|!==|\+|-|\*|%|\*\*|\+\+|--|<<|>>|>>>|&|\||\^|!|~|&&|\|\||\?|:|=|\+=|-=|\*=|%=|\*\*=|<<=|>>=|>>>=|&=|\|=|\^=|=>|\/|\/=|\})$/,gN=/( |\n|\t)+$/,o(uN,"hasPunctuatorBefore"),o(dN,"computeTokenLength"),o(mN,"computeJSTokenLength"),o(pN,"computeCSSTokenLength")})),yN={};c(yN,{UIStrings:()=>vN,default:()=>DN});var vN,bN,wN,DN,EN=s((()=>{J(),zR(),$F(),ro(),fN(),bN=eo("core/audits/byte-efficiency/unminified-css.js",vN={title:"Minify CSS",description:"Minifying CSS files can reduce network payload sizes. [Learn how to minify CSS](https://developer.chrome.com/docs/lighthouse/performance/unminified-css/)."}),5,2048,wN=class e extends MR{static{o(this,"UnminifiedCSS")}static get meta(){return{id:"unminified-css",title:bN(vN.title),description:bN(vN.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["CSSUsage","devtoolsLogs","traces","URL","GatherContext"]}}static computeTokenLength(e){return pN(e)}static computeWaste(t,a){let n=t.content,r=e.computeTokenLength(n),i=t.header.sourceURL;(!i||t.header.isInline)&&(i=VF.determineContentPreview(t.content));let o=MR.estimateTransferSize(a,n.length,"Stylesheet"),s=1-r/n.length;return{url:i,totalBytes:o,wastedBytes:Math.round(o*s),wastedPercent:100*s}}static audit_(t,a){let n=[];for(let r of t.CSSUsage.stylesheets){let t=a.find((e=>e.url===r.header.sourceURL));if(!r.content)continue;let i=e.computeWaste(r,t);i.wastedPercent<5||i.wastedBytes<2048||!Number.isFinite(i.wastedBytes)||n.push(i)}return{items:n,headings:[{key:"url",valueType:"url",label:bN(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:bN(no.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:bN(no.columnWastedBytes)}]}}},DN=wN})),TN={};c(TN,{UIStrings:()=>SN,default:()=>xN});var SN,CN,kN,xN,AN=s((()=>{J(),zR(),ro(),fN(),QR(),kr(),CN=eo("core/audits/byte-efficiency/unminified-javascript.js",SN={title:"Minify JavaScript",description:"Minifying JavaScript files can reduce payload sizes and script parse time. [Learn how to minify JavaScript](https://developer.chrome.com/docs/lighthouse/performance/unminified-javascript/)."}),10,2048,kN=class e extends MR{static{o(this,"UnminifiedJavaScript")}static get meta(){return{id:"unminified-javascript",title:CN(SN.title),description:CN(SN.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["Scripts","devtoolsLogs","traces","GatherContext","URL"]}}static computeWaste(e,t,a){let n=e.length,r=mN(e),i=MR.estimateTransferSize(a,n,"Script"),o=1-r/n;return{url:t,totalBytes:i,wastedBytes:Math.round(i*o),wastedPercent:100*o}}static audit_(t,a){let n=[],r=[];for(let i of t.Scripts){if(!i.content)continue;let t=XR(a,i),o=ZR(i)?`inline: ${br.truncate(i.content,40)}`:i.url;try{let a=e.computeWaste(i.content,o,t);if(a.wastedPercent<10||a.wastedBytes<2048||!Number.isFinite(a.wastedBytes))continue;n.push(a)}catch(e){r.push(`Unable to process script ${i.url}: ${e.message}`)}}return{items:n,warnings:r,headings:[{key:"url",valueType:"url",label:CN(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:CN(no.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:CN(no.columnWastedBytes)}]}}},xN=kN})),_N={};c(_N,{UIStrings:()=>RN,default:()=>IN});var RN,FN,NN,IN,MN,PN,LN=s((()=>{J(),zR(),$F(),ro(),FN=eo("core/audits/byte-efficiency/unused-css-rules.js",RN={title:"Reduce unused CSS",description:"Reduce unused rules from stylesheets and defer CSS not used for above-the-fold content to decrease bytes consumed by network activity. [Learn how to reduce unused CSS](https://developer.chrome.com/docs/lighthouse/performance/unused-css-rules/)."}),10240,NN=class extends MR{static{o(this,"UnusedCSSRules")}static get meta(){return{id:"unused-css-rules",title:FN(RN.title),description:FN(RN.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["CSSUsage","URL","devtoolsLogs","traces","GatherContext"]}}static async audit_(e,t,a){return{items:(await VF.request({CSSUsage:e.CSSUsage,devtoolsLog:e.devtoolsLogs[MR.DEFAULT_PASS]},a)).filter((e=>e&&e.wastedBytes>10240)),headings:[{key:"url",valueType:"url",label:FN(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:FN(no.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:FN(no.columnWastedBytes)}]}}},IN=NN})),ON=s((()=>{J(),Bc(),MN=class e{static{o(this,"UnusedJavascriptSummary")}static computeWaste(e){let t=0;for(let a of e.functions)t=Math.max(t,...a.ranges.map((e=>e.endOffset)));let a=new Uint8Array(t);for(let t of e.functions)for(let e of t.ranges)if(0===e.count)for(let t=e.startOffset;t<e.endOffset;t++)a[t]=1;let n=0;for(let e of a)n+=e;return{unusedByIndex:a,unusedLength:n,contentLength:t}}static createItem(e,t){let a=t.unusedLength/t.contentLength||0,n=Math.round(t.contentLength*a);return{scriptId:e,totalBytes:t.contentLength,wastedBytes:n,wastedPercent:100*a}}static createSourceWastedBytes(e,t){if(!t.script.content)return;let a={},n=t.script.content.split("\n").map((e=>e.length)),r=0,i=n.map((e=>{let t=r;return r+=e+1,t}));t.map.computeLastGeneratedColumns();for(let r of t.map.mappings()){let t=i[r.lineNumber];t+=r.columnNumber;let o=void 0!==r.lastColumnNumber?r.lastColumnNumber-1:n[r.lineNumber];for(let n=r.columnNumber;n<=o;n++){if(1===e.unusedByIndex[t]){let e=r.sourceURL||"(unmapped)";a[e]=(a[e]||0)+1}t+=1}}let o=Object.entries(a).sort((([e,t],[a,n])=>n-t)),s={};for(let[e,t]of o)s[e]=t;return s}static async compute_(t){let{scriptId:a,scriptCoverage:n,bundle:r}=t,i=e.computeWaste(n),o=e.createItem(a,i);return r?{...o,sourcesWastedBytes:e.createSourceWastedBytes(i,r)}:o}},PN=dc(MN,["bundle","scriptCoverage","scriptId"])})),jN={};function UN(e){if(!e.length)return"";let t=e.reduce(((e,t)=>e>t?e:t)),a=e.reduce(((e,t)=>e>t?t:e));for(;!t.startsWith(a);)a=a.slice(0,-1);return a}function BN(e,t){return t&&e.startsWith(t)?"…"+e.slice(t.length):e}c(jN,{UIStrings:()=>qN,default:()=>GN});var qN,zN,VN,WN,HN,GN,$N=s((()=>{J(),zR(),ON(),YR(),ro(),QR(),zN=eo("core/audits/byte-efficiency/unused-javascript.js",qN={title:"Reduce unused JavaScript",description:"Reduce unused JavaScript and defer loading scripts until they are required to decrease bytes consumed by network activity. [Learn how to reduce unused JavaScript](https://developer.chrome.com/docs/lighthouse/performance/unused-javascript/)."}),VN=20480,WN=512,o(UN,"commonPrefix"),o(BN,"trimCommonPrefix"),HN=class extends MR{static{o(this,"UnusedJavaScript")}static get meta(){return{id:"unused-javascript",title:zN(qN.title),description:zN(qN.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["JsUsage","Scripts","SourceMaps","GatherContext","devtoolsLogs","traces","URL"]}}static async audit_(e,t,a){let n=await GR.request(e,a),{unusedThreshold:r=VN,bundleSourceUnusedThreshold:i=WN}=a.options||{},o=[];for(let[s,l]of Object.entries(e.JsUsage)){let c=e.Scripts.find((e=>e.scriptId===s));if(!c)continue;let u=XR(t,c);if(!u)continue;let d=n.find((e=>e.script.scriptId===s)),m=await PN.request({scriptId:s,scriptCoverage:l,bundle:d},a);if(0===m.wastedBytes||0===m.totalBytes)continue;let p=MR.estimateTransferSize(u,m.totalBytes,"Script")/m.totalBytes,h={url:c.url,totalBytes:Math.round(p*m.totalBytes),wastedBytes:Math.round(p*m.wastedBytes),wastedPercent:m.wastedPercent};if(h.wastedBytes<=r||(o.push(h),!d||"errorMessage"in d.sizes))continue;let g=d.sizes;if(m.sourcesWastedBytes){let e=Object.entries(m.sourcesWastedBytes).sort(((e,t)=>t[1]-e[1])).slice(0,5).map((([e,t])=>{let a="(unmapped)"===e?g.unmappedBytes:g.files[e];return{source:e,unused:Math.round(t*p),total:Math.round(a*p)}})).filter((e=>e.unused>=i)),t=UN(d.map.sourceURLs());h.subItems={type:"subitems",items:e.map((({source:e,unused:a,total:n})=>({source:BN(e,t),sourceBytes:n,sourceWastedBytes:a})))}}}return{items:o,headings:[{key:"url",valueType:"url",subItemsHeading:{key:"source",valueType:"code"},label:zN(no.columnURL)},{key:"totalBytes",valueType:"bytes",subItemsHeading:{key:"sourceBytes"},label:zN(no.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",subItemsHeading:{key:"sourceWastedBytes"},label:zN(no.columnWastedBytes)}]}}},GN=HN})),KN=l(((e,t)=>{J(),t.exports=o((function(e){if("string"!=typeof e)return null;var t={},a=e.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g,(function(e,a,n,r){var i=n||r;return t[a]=!i||i.toLowerCase(),""}));if(t["max-age"])try{var n=parseInt(t["max-age"],10);if(isNaN(n))return null;t["max-age"]=n}catch{}return a?null:t}),"parseCacheControl")})),YN={};c(YN,{UIStrings:()=>ZN,default:()=>eI});var JN,ZN,XN,QN,eI,tI=s((()=>{J(),JN=d(KN(),1),xr(),qc(),ql(),Cr(),ro(),Yc(),XN=eo("core/audits/byte-efficiency/uses-long-cache-ttl.js",ZN={title:"Uses efficient cache policy on static assets",failureTitle:"Serve static assets with an efficient cache policy",description:"A long cache lifetime can speed up repeat visits to your page. [Learn more about efficient cache policies](https://developer.chrome.com/docs/lighthouse/performance/uses-long-cache-ttl/).",displayValue:"{itemCount, plural,\n    =1 {1 resource found}\n    other {# resources found}\n    }"}),.925,QN=class e extends Dr{static{o(this,"CacheHeaders")}static get meta(){return{id:"uses-long-cache-ttl",title:XN(ZN.title),failureTitle:XN(ZN.failureTitle),description:XN(ZN.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs"]}}static get defaultOptions(){return{p10:28672,median:131072}}static getCacheHitProbability(e){let t=[0,.2,1,3,8,12,24,48,72,168,8760,1/0];if(12!==t.length)throw new Error("deciles 0-10 and 1 for overflow");let a=e/3600,n=t.findIndex((e=>e>=a));if(n===t.length-1)return 1;if(0===n)return 0;let r=t[n];return mr(t[n-1],(n-1)/10,r,n/10,a)}static computeCacheLifetimeInSeconds(e,t){if(t&&void 0!==t["max-age"])return t["max-age"];let a=e.get("expires");if(a){let e=new Date(a).getTime();return e?Math.ceil((e-Date.now())/1e3):0}return null}static isCacheableAsset(e){let t=new Set([200,203,206]),a=new Set([wc.TYPES.Font,wc.TYPES.Image,wc.TYPES.Media,wc.TYPES.Script,wc.TYPES.Stylesheet]);return!wc.isNonNetworkRequest(e)&&(t.has(e.statusCode)&&a.has(e.resourceType||"Other"))}static shouldSkipRecord(e,t){return!!(!t&&(e.get("pragma")||"").includes("no-cache")||t&&(t["must-revalidate"]||t["no-cache"]||t["no-store"]||t["stale-while-revalidate"]||t.private))}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=await Pc.request(n,a),i=[],o=0;for(let t of r){if(!e.isCacheableAsset(t))continue;let a=new Map;for(let e of t.responseHeaders||[])if(a.has(e.name.toLowerCase())){let t=a.get(e.name.toLowerCase());a.set(e.name.toLowerCase(),`${t}, ${e.value}`)}else a.set(e.name.toLowerCase(),e.value);let n=(0,JN.default)(a.get("cache-control"));if(this.shouldSkipRecord(a,n))continue;let r=e.computeCacheLifetimeInSeconds(a,n);if(null!==r&&(!Number.isFinite(r)||r<=0))continue;r=r||0;let s=e.getCacheHitProbability(r);if(s>.925)continue;let l,c=Ml.elideDataURI(t.url),u=t.transferSize||0,d=(1-s)*u;o+=d,n&&(l={type:"debugdata",...n}),i.push({url:c,debugData:l,cacheLifetimeMs:1e3*r,cacheHitProbability:s,totalBytes:u,wastedBytes:d})}i.sort(((e,t)=>e.cacheLifetimeMs-t.cacheLifetimeMs||t.totalBytes-e.totalBytes||e.url.localeCompare(t.url)));let s=Dr.computeLogNormalScore({p10:a.options.p10,median:a.options.median},o),l=[{key:"url",valueType:"url",label:XN(no.columnURL)},{key:"cacheLifetimeMs",valueType:"ms",label:XN(no.columnCacheTTL),displayUnit:"duration"},{key:"totalBytes",valueType:"bytes",label:XN(no.columnTransferSize),displayUnit:"kb",granularity:1}],c=Dr.makeTableDetails(l,i,{wastedBytes:o,sortedBy:["totalBytes"],skipSumming:["cacheLifetimeMs"]});return{score:s,numericValue:o,numericUnit:"byte",displayValue:XN(ZN.displayValue,{itemCount:i.length}),details:c}}},eI=QN})),aI={};c(aI,{UIStrings:()=>nI,default:()=>oI});var nI,rI,iI,oI,sI,lI,cI=s((()=>{J(),zR(),ql(),ro(),rI=eo("core/audits/byte-efficiency/uses-optimized-images.js",nI={title:"Efficiently encode images",description:"Optimized images load faster and consume less cellular data. [Learn how to efficiently encode images](https://developer.chrome.com/docs/lighthouse/performance/uses-optimized-images/)."}),4096,iI=class e extends MR{static{o(this,"UsesOptimizedImages")}static get meta(){return{id:"uses-optimized-images",title:rI(nI.title),description:rI(nI.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["OptimizedImages","ImageElements","GatherContext","devtoolsLogs","traces","URL"]}}static computeSavings(e){let t=e.originalSize-e.jpegSize;return{bytes:t,percent:100*t/e.originalSize}}static estimateJPEGSizeFromDimensions(e){let t=e.naturalWidth*e.naturalHeight;return Math.round(t*(2/8))}static audit_(t){let a=t.URL.finalDisplayedUrl,n=t.OptimizedImages,r=t.ImageElements,i=new Map;r.forEach((e=>i.set(e.src,e)));let o=[],s=[];for(let t of n){let n=i.get(t.url);if(t.failed){s.push(`Unable to decode ${Ml.getURLDisplayName(t.url)}`);continue}if(!1===/(jpeg|bmp)/.test(t.mimeType))continue;let r=t.jpegSize,l=!0;if(typeof r>"u"){if(!n){s.push(`Unable to locate resource ${Ml.getURLDisplayName(t.url)}`);continue}if(!n.naturalDimensions)continue;let a=n.naturalDimensions.height,i=n.naturalDimensions.width;if(!a||!i)continue;r=e.estimateJPEGSizeFromDimensions({naturalHeight:a,naturalWidth:i}),l=!1}if(t.originalSize<r+4096)continue;let c=Ml.elideDataURI(t.url),u=!Ml.originsMatch(a,t.url),d=e.computeSavings({...t,jpegSize:r});o.push({node:n?MR.makeNodeItem(n.node):void 0,url:c,fromProtocol:l,isCrossOrigin:u,totalBytes:t.originalSize,wastedBytes:d.bytes})}return{warnings:s,items:o,headings:[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:rI(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:rI(no.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:rI(no.columnWastedBytes)}]}}},oI=iI})),uI=s((()=>{J(),ql(),Bc(),sI=class e{static{o(this,"ImageRecords")}static indexNetworkRecords(e){return e.reduce(((e,t)=>((/^image/.test(t.mimeType)||/\.(avif|webp)$/i.test(t.url))&&t.finished&&200===t.statusCode&&(e[t.url]=t),e)),{})}static async compute_(t){let a=e.indexNetworkRecords(t.networkRecords),n=[];for(let e of t.ImageElements){let t=a[e.src]?.mimeType;n.push({...e,mimeType:t||Ml.guessMimeType(e.src)})}return n.sort(((e,t)=>{let n=a[e.src]||{};return(a[t.src]||{}).resourceSize-n.resourceSize})),n}},lI=dc(sI,["ImageElements","networkRecords"])})),dI={};c(dI,{UIStrings:()=>mI,default:()=>gI,str_:()=>pI});var mI,pI,hI,gI,fI=s((()=>{J(),zR(),qc(),uI(),ql(),ro(),pI=eo("core/audits/byte-efficiency/uses-responsive-images.js",mI={title:"Properly size images",description:"Serve images that are appropriately-sized to save cellular data and improve load time. [Learn how to size images](https://developer.chrome.com/docs/lighthouse/performance/uses-responsive-images/)."}),4096,12288,hI=class e extends MR{static{o(this,"UsesResponsiveImages")}static get meta(){return{id:"uses-responsive-images",title:pI(mI.title),description:pI(mI.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["ImageElements","ViewportDimensions","GatherContext","devtoolsLogs","traces","URL"]}}static getDisplayedDimensions(e,t){if(e.displayedWidth&&e.displayedHeight)return{width:e.displayedWidth*t.devicePixelRatio,height:e.displayedHeight*t.devicePixelRatio};let a=t.innerWidth,n=2*t.innerHeight,r=e.naturalWidth/e.naturalHeight,i=a,o=n;return r>a/n?o=a/r:i=n*r,{width:i*t.devicePixelRatio,height:o*t.devicePixelRatio}}static computeWaste(e,t,a){let n=a.find((t=>t.url===e.src));if(!n)return null;let r=this.getDisplayedDimensions(e,t),i=r.width*r.height,o=Ml.elideDataURI(e.src),s=1-i/(e.naturalWidth*e.naturalHeight),l=wc.getResourceSizeOnNetwork(n),c=Math.round(l*s);return{node:MR.makeNodeItem(e.node),url:o,totalBytes:l,wastedBytes:c,wastedPercent:100*s}}static determineAllowableWaste(e){return e.srcset||e.isPicture?12288:4096}static async audit_(t,a,n){let r=await lI.request({ImageElements:t.ImageElements,networkRecords:a},n),i=t.ViewportDimensions,o=new Map,s=[];for(let t of r){if("image/svg+xml"===t.mimeType||t.isCss||!t.naturalDimensions)continue;let n=t.naturalDimensions.height,r=t.naturalDimensions.width;if(!r||!n)continue;let l=e.computeWaste({...t,naturalHeight:n,naturalWidth:r},i,a);if(!l)continue;let c=l.wastedBytes>this.determineAllowableWaste(t),u=o.get(l.url);c&&!s.includes(l.url)?(!u||u.wastedBytes>l.wastedBytes)&&o.set(l.url,l):(o.delete(l.url),s.push(l.url))}return{items:Array.from(o.values()),headings:[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:pI(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:pI(no.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:pI(no.columnWastedBytes)}]}}},gI=hI})),yI={};c(yI,{UIStrings:()=>vI,default:()=>DI});var vI,bI,wI,DI,EI=s((()=>{J(),xr(),fI(),ql(),ro(),bI=eo("core/audits/byte-efficiency/uses-responsive-images-snapshot.js",vI={title:"Images were appropriate for their displayed size",failureTitle:"Images were larger than their displayed size",columnDisplayedDimensions:"Displayed dimensions",columnActualDimensions:"Actual dimensions"}),1365,wI=class extends Dr{static{o(this,"UsesResponsiveImagesSnapshot")}static get meta(){return{id:"uses-responsive-images-snapshot",title:bI(vI.title),failureTitle:bI(vI.failureTitle),description:pI(mI.description),supportedModes:["snapshot"],requiredArtifacts:["ImageElements","ViewportDimensions"]}}static async audit(e){let t=1,a=[];for(let n of e.ImageElements){if(n.isCss||!n.naturalDimensions)continue;let r=n.naturalDimensions,i=gI.getDisplayedDimensions({...n,naturalWidth:r.width,naturalHeight:r.height},e.ViewportDimensions),o=r.width*r.height,s=i.width*i.height;o<=s||(o-s>1365&&(t=0),a.push({node:Dr.makeNodeItem(n.node),url:Ml.elideDataURI(n.src),displayedDimensions:`${i.width}x${i.height}`,actualDimensions:`${r.width}x${r.height}`}))}let n=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:bI(no.columnURL)},{key:"displayedDimensions",valueType:"text",label:bI(vI.columnDisplayedDimensions)},{key:"actualDimensions",valueType:"text",label:bI(vI.columnActualDimensions)}];return{score:t,details:Dr.makeTableDetails(n,a)}}},DI=wI})),TI={};c(TI,{UIStrings:()=>SI,default:()=>xI});var SI,CI,kI,xI,AI=s((()=>{J(),zR(),ql(),ro(),CI=eo("core/audits/byte-efficiency/uses-text-compression.js",SI={title:"Enable text compression",description:"Text-based resources should be served with compression (gzip, deflate or brotli) to minimize total network bytes. [Learn more about text compression](https://developer.chrome.com/docs/lighthouse/performance/uses-text-compression/)."}),1400,.1,kI=class extends MR{static{o(this,"ResponsesAreCompressed")}static get meta(){return{id:"uses-text-compression",title:CI(SI.title),description:CI(SI.description),scoreDisplayMode:MR.SCORING_MODES.NUMERIC,requiredArtifacts:["ResponseCompression","GatherContext","devtoolsLogs","traces","URL"]}}static audit_(e){let t=e.ResponseCompression,a=[];t.forEach((e=>{if(!e.gzipSize||e.gzipSize<0)return;let t=e.resourceSize,n=e.gzipSize,r=t-n;if(1-n/t<.1||r<1400||e.transferSize<n)return;let i=Ml.elideDataURI(e.url);a.find((t=>t.url===i&&t.totalBytes===e.resourceSize))||a.push({url:i,totalBytes:t,wastedBytes:r})}));let n=[{key:"url",valueType:"url",label:CI(no.columnURL)},{key:"totalBytes",valueType:"bytes",label:CI(no.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:CI(no.columnWastedBytes)}];return{items:a,headings:n}}},xI=kI})),_I={};c(_I,{UIStrings:()=>RI,default:()=>II});var RI,FI,NI,II,MI,PI,LI=s((()=>{J(),xr(),ro(),FI=eo("core/audits/content-width.js",RI={title:"Content is sized correctly for the viewport",failureTitle:"Content is not sized correctly for the viewport",description:"If the width of your app's content doesn't match the width of the viewport, your app might not be optimized for mobile screens. [Learn how to size content for the viewport](https://developer.chrome.com/docs/lighthouse/pwa/content-width/).",explanation:"The viewport size of {innerWidth}px does not match the window size of {outerWidth}px."}),NI=class extends Dr{static{o(this,"ContentWidth")}static get meta(){return{id:"content-width",title:FI(RI.title),failureTitle:FI(RI.failureTitle),description:FI(RI.description),requiredArtifacts:["ViewportDimensions"]}}static audit(e,t){let a,n=e.ViewportDimensions.innerWidth===e.ViewportDimensions.outerWidth;return"desktop"===t.settings.formFactor?{score:1,notApplicable:!0}:(n||(a=FI(RI.explanation,{innerWidth:e.ViewportDimensions.innerWidth,outerWidth:e.ViewportDimensions.outerWidth})),{score:Number(n),explanation:a})}},II=NI})),OI=s((()=>{J(),Bc(),qc(),fb(),$c(),MI=class e{static{o(this,"CriticalRequestChains")}static isCritical(e,t){if(!t)throw new Error("mainResource not provided");if(e.requestId===t.requestId)return!0;if(e.isLinkPreload)return!1;for(;e.redirectDestination;)e=e.redirectDestination;let a=e.resourceType===wc.TYPES.Document&&e.frameId!==t.frameId;return!([wc.TYPES.Image,wc.TYPES.XHR,wc.TYPES.Fetch,wc.TYPES.EventSource].includes(e.resourceType||"Other")||a||e.mimeType&&e.mimeType.startsWith("image/")||!e.initiatorRequest)&&["VeryHigh","High","Medium"].includes(e.priority)}static extractChainsFromGraph(t,a){let n={};function r(e){let t=n;for(let a of e)t[a.requestId]||(t[a.requestId]={request:a,children:{}}),t=t[a.requestId].children}o(r,"addChain");let i=new Set;function s(e){return e.getDependents().filter((e=>e.getDependencies().every((e=>i.has(e)))))}return o(s,"getNextNodes"),a.traverse(((a,n)=>{if(i.add(a),"network"!==a.type||!e.isCritical(a.record,t))return;let o=n.filter((e=>"network"===e.type)).reverse().map((e=>e.record));o.some((a=>!e.isCritical(a,t)))||wc.isNonNetworkRequest(a.record)||r(o)}),s),n}static async compute_(t,a){let n=await pb.request(t,a),r=await Fc.request(t,a);return e.extractChainsFromGraph(n,r)}},PI=dc(MI,["URL","devtoolsLog","trace"])})),jI={};c(jI,{UIStrings:()=>UI,default:()=>zI});var UI,BI,qI,zI,VI=s((()=>{J(),xr(),ro(),OI(),BI=eo("core/audits/critical-request-chains.js",UI={title:"Avoid chaining critical requests",description:"The Critical Request Chains below show you what resources are loaded with a high priority. Consider reducing the length of chains, reducing the download size of resources, or deferring the download of unnecessary resources to improve page load. [Learn how to avoid chaining critical requests](https://developer.chrome.com/docs/lighthouse/performance/critical-request-chains/).",displayValue:"{itemCount, plural,\n    =1 {1 chain found}\n    other {# chains found}\n    }"}),qI=class e extends Dr{static{o(this,"CriticalRequestChains")}static get meta(){return{id:"critical-request-chains",title:BI(UI.title),description:BI(UI.description),scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","URL"]}}static _traverse(e,t){function a(e,n,r,i=0){let o=Object.keys(e);0!==o.length&&o.forEach((o=>{let s=e[o];r||(r=s.request.networkRequestTime),t({depth:n,id:o,node:s,chainDuration:s.request.networkEndTime-r,chainTransferSize:i+s.request.transferSize}),s.children&&a(s.children,n+1,r)}),"")}o(a,"walk"),a(e,0)}static _getLongestChain(t){let a={duration:0,length:0,transferSize:0};return e._traverse(t,(e=>{let t=e.chainDuration;t>a.duration&&(a.duration=t,a.transferSize=e.chainTransferSize,a.length=e.depth)})),a.length++,a}static flattenRequests(t){let a={},n=new Map;function r(e){let t=e.node.request,r={url:t.url,startTime:t.networkRequestTime/1e3,endTime:t.networkEndTime/1e3,responseReceivedTime:t.responseHeadersEndTime/1e3,transferSize:t.transferSize},i=n.get(e.id);if(i?i.request=r:(i={request:r},a[e.id]=i),e.node.children)for(let t of Object.keys(e.node.children)){let e={request:{}};n.set(t,e),i.children||(i.children={}),i.children[t]=e}n.set(e.id,i)}return o(r,"flatten"),e._traverse(t,r),a}static async audit(t,a){let n=t.traces[Dr.DEFAULT_PASS],r=t.devtoolsLogs[Dr.DEFAULT_PASS],i=t.URL,s=await PI.request({devtoolsLog:r,trace:n,URL:i},a),l=0;function c(e,t){Object.keys(e).forEach((a=>{let n=e[a];n.children?c(n.children,t+1):l++}),"")}o(c,"walk");let u=e.flattenRequests(s),d=Object.keys(u)[0],m=d&&u[d].children;m&&Object.keys(m).length>0&&c(m,0);let p=e._getLongestChain(s);return{score:+(0===l),notApplicable:0===l,displayValue:l?BI(UI.displayValue,{itemCount:l}):"",details:{type:"criticalrequestchain",chains:u,longestChain:p}}}},zI=qI})),WI=l((e=>{J(),Object.defineProperty(e,"__esModule",{value:!0}),e.Type=e.Severity=e.Finding=void 0;var t,a,n=class e{static{o(this,"Finding")}constructor(e,t,a,n,r){this.type=e,this.description=t,this.severity=a,this.directive=n,this.value=r}static getHighestSeverity(e){if(0===e.length)return t.NONE;let a=e.map((e=>e.severity)),n=o(((e,t)=>e<t?e:t),"min");return a.reduce(n,t.NONE)}equals(t){return t instanceof e&&(t.type===this.type&&t.description===this.description&&t.severity===this.severity&&t.directive===this.directive&&t.value===this.value)}};e.Finding=n,(a=t=e.Severity||(e.Severity={}))[a.HIGH=10]="HIGH",a[a.SYNTAX=20]="SYNTAX",a[a.MEDIUM=30]="MEDIUM",a[a.HIGH_MAYBE=40]="HIGH_MAYBE",a[a.STRICT_CSP=45]="STRICT_CSP",a[a.MEDIUM_MAYBE=50]="MEDIUM_MAYBE",a[a.INFO=60]="INFO",a[a.NONE=100]="NONE",function(e){e[e.MISSING_SEMICOLON=100]="MISSING_SEMICOLON",e[e.UNKNOWN_DIRECTIVE=101]="UNKNOWN_DIRECTIVE",e[e.INVALID_KEYWORD=102]="INVALID_KEYWORD",e[e.NONCE_CHARSET=106]="NONCE_CHARSET",e[e.MISSING_DIRECTIVES=300]="MISSING_DIRECTIVES",e[e.SCRIPT_UNSAFE_INLINE=301]="SCRIPT_UNSAFE_INLINE",e[e.SCRIPT_UNSAFE_EVAL=302]="SCRIPT_UNSAFE_EVAL",e[e.PLAIN_URL_SCHEMES=303]="PLAIN_URL_SCHEMES",e[e.PLAIN_WILDCARD=304]="PLAIN_WILDCARD",e[e.SCRIPT_ALLOWLIST_BYPASS=305]="SCRIPT_ALLOWLIST_BYPASS",e[e.OBJECT_ALLOWLIST_BYPASS=306]="OBJECT_ALLOWLIST_BYPASS",e[e.NONCE_LENGTH=307]="NONCE_LENGTH",e[e.IP_SOURCE=308]="IP_SOURCE",e[e.DEPRECATED_DIRECTIVE=309]="DEPRECATED_DIRECTIVE",e[e.SRC_HTTP=310]="SRC_HTTP",e[e.STRICT_DYNAMIC=400]="STRICT_DYNAMIC",e[e.STRICT_DYNAMIC_NOT_STANDALONE=401]="STRICT_DYNAMIC_NOT_STANDALONE",e[e.NONCE_HASH=402]="NONCE_HASH",e[e.UNSAFE_INLINE_FALLBACK=403]="UNSAFE_INLINE_FALLBACK",e[e.ALLOWLIST_FALLBACK=404]="ALLOWLIST_FALLBACK",e[e.IGNORED=405]="IGNORED",e[e.REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS=500]="REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS",e[e.REPORTING_DESTINATION_MISSING=600]="REPORTING_DESTINATION_MISSING",e[e.REPORT_TO_ONLY=601]="REPORT_TO_ONLY"}(e.Type||(e.Type={}))})),HI=l((e=>{J(),Object.defineProperty(e,"__esModule",{value:!0}),e.CspError=e.isHash=e.HASH_PATTERN=e.STRICT_HASH_PATTERN=e.isNonce=e.NONCE_PATTERN=e.STRICT_NONCE_PATTERN=e.isUrlScheme=e.isKeyword=e.isDirective=e.Version=e.FETCH_DIRECTIVES=e.Directive=e.TrustedTypesSink=e.Keyword=e.Csp=void 0;var t,a,n,r,i=WI(),s=class a{static{o(this,"Csp")}constructor(){this.directives={}}clone(){let e=new a;for(let[t,a]of Object.entries(this.directives))a&&(e.directives[t]=[...a]);return e}convertToString(){let e="";for(let[t,a]of Object.entries(this.directives)){if(e+=t,void 0!==a)for(let t,n=0;t=a[n];n++)e+=" ",e+=t;e+="; "}return e}getEffectiveCsp(e,a){let o=a||[],s=this.clone(),l=s.getEffectiveDirective(n.SCRIPT_SRC),c=this.directives[l]||[],u=s.directives[l];if(u&&(s.policyHasScriptNonces()||s.policyHasScriptHashes()))if(e>=r.CSP2)c.includes(t.UNSAFE_INLINE)&&(h(u,t.UNSAFE_INLINE),o.push(new i.Finding(i.Type.IGNORED,"unsafe-inline is ignored if a nonce or a hash is present. (CSP2 and above)",i.Severity.NONE,l,t.UNSAFE_INLINE)));else for(let e of c)(e.startsWith("'nonce-")||e.startsWith("'sha"))&&h(u,e);if(u&&this.policyHasStrictDynamic())if(e>=r.CSP3)for(let e of c)(!e.startsWith("'")||e===t.SELF||e===t.UNSAFE_INLINE)&&(h(u,e),o.push(new i.Finding(i.Type.IGNORED,"Because of strict-dynamic this entry is ignored in CSP3 and above",i.Severity.NONE,l,e)));else h(u,t.STRICT_DYNAMIC);return e<r.CSP3&&(delete s.directives[n.REPORT_TO],delete s.directives[n.WORKER_SRC],delete s.directives[n.MANIFEST_SRC],delete s.directives[n.TRUSTED_TYPES],delete s.directives[n.REQUIRE_TRUSTED_TYPES_FOR]),s}getEffectiveDirective(t){return!(t in this.directives)&&e.FETCH_DIRECTIVES.includes(t)?n.DEFAULT_SRC:t}getEffectiveDirectives(e){return[...new Set(e.map((e=>this.getEffectiveDirective(e))))]}policyHasScriptNonces(){let e=this.getEffectiveDirective(n.SCRIPT_SRC);return(this.directives[e]||[]).some((e=>d(e)))}policyHasScriptHashes(){let e=this.getEffectiveDirective(n.SCRIPT_SRC);return(this.directives[e]||[]).some((e=>m(e)))}policyHasStrictDynamic(){let e=this.getEffectiveDirective(n.SCRIPT_SRC);return(this.directives[e]||[]).includes(t.STRICT_DYNAMIC)}};function l(e){return Object.values(n).includes(e)}function c(e){return Object.values(t).includes(e)}function u(e){return new RegExp("^[a-zA-Z][+a-zA-Z0-9.-]*:$").test(e)}function d(t,a){return(a?e.STRICT_NONCE_PATTERN:e.NONCE_PATTERN).test(t)}function m(t,a){return(a?e.STRICT_HASH_PATTERN:e.HASH_PATTERN).test(t)}e.Csp=s,(a=t=e.Keyword||(e.Keyword={})).SELF="'self'",a.NONE="'none'",a.UNSAFE_INLINE="'unsafe-inline'",a.UNSAFE_EVAL="'unsafe-eval'",a.WASM_EVAL="'wasm-eval'",a.WASM_UNSAFE_EVAL="'wasm-unsafe-eval'",a.STRICT_DYNAMIC="'strict-dynamic'",a.UNSAFE_HASHED_ATTRIBUTES="'unsafe-hashed-attributes'",a.UNSAFE_HASHES="'unsafe-hashes'",a.REPORT_SAMPLE="'report-sample'",a.BLOCK="'block'",a.ALLOW="'allow'",function(e){e.SCRIPT="'script'"}(e.TrustedTypesSink||(e.TrustedTypesSink={})),function(e){e.CHILD_SRC="child-src",e.CONNECT_SRC="connect-src",e.DEFAULT_SRC="default-src",e.FONT_SRC="font-src",e.FRAME_SRC="frame-src",e.IMG_SRC="img-src",e.MEDIA_SRC="media-src",e.OBJECT_SRC="object-src",e.SCRIPT_SRC="script-src",e.SCRIPT_SRC_ATTR="script-src-attr",e.SCRIPT_SRC_ELEM="script-src-elem",e.STYLE_SRC="style-src",e.STYLE_SRC_ATTR="style-src-attr",e.STYLE_SRC_ELEM="style-src-elem",e.PREFETCH_SRC="prefetch-src",e.MANIFEST_SRC="manifest-src",e.WORKER_SRC="worker-src",e.BASE_URI="base-uri",e.PLUGIN_TYPES="plugin-types",e.SANDBOX="sandbox",e.DISOWN_OPENER="disown-opener",e.FORM_ACTION="form-action",e.FRAME_ANCESTORS="frame-ancestors",e.NAVIGATE_TO="navigate-to",e.REPORT_TO="report-to",e.REPORT_URI="report-uri",e.BLOCK_ALL_MIXED_CONTENT="block-all-mixed-content",e.UPGRADE_INSECURE_REQUESTS="upgrade-insecure-requests",e.REFLECTED_XSS="reflected-xss",e.REFERRER="referrer",e.REQUIRE_SRI_FOR="require-sri-for",e.TRUSTED_TYPES="trusted-types",e.REQUIRE_TRUSTED_TYPES_FOR="require-trusted-types-for",e.WEBRTC="webrtc"}(n=e.Directive||(e.Directive={})),e.FETCH_DIRECTIVES=[n.CHILD_SRC,n.CONNECT_SRC,n.DEFAULT_SRC,n.FONT_SRC,n.FRAME_SRC,n.IMG_SRC,n.MANIFEST_SRC,n.MEDIA_SRC,n.OBJECT_SRC,n.SCRIPT_SRC,n.SCRIPT_SRC_ATTR,n.SCRIPT_SRC_ELEM,n.STYLE_SRC,n.STYLE_SRC_ATTR,n.STYLE_SRC_ELEM,n.WORKER_SRC],function(e){e[e.CSP1=1]="CSP1",e[e.CSP2=2]="CSP2",e[e.CSP3=3]="CSP3"}(r=e.Version||(e.Version={})),o(l,"isDirective"),e.isDirective=l,o(c,"isKeyword"),e.isKeyword=c,o(u,"isUrlScheme"),e.isUrlScheme=u,e.STRICT_NONCE_PATTERN=new RegExp("^'nonce-[a-zA-Z0-9+/_-]+[=]{0,2}'$"),e.NONCE_PATTERN=new RegExp("^'nonce-(.+)'$"),o(d,"isNonce"),e.isNonce=d,e.STRICT_HASH_PATTERN=new RegExp("^'(sha256|sha384|sha512)-[a-zA-Z0-9+/]+[=]{0,2}'$"),e.HASH_PATTERN=new RegExp("^'(sha256|sha384|sha512)-(.+)'$"),o(m,"isHash"),e.isHash=m;var p=class extends Error{static{o(this,"CspError")}constructor(e){super(e)}};function h(e,t){if(e.includes(t)){let a=e.findIndex((e=>t===e));e.splice(a,1)}}e.CspError=p,o(h,"arrayRemove")})),GI=l((e=>{J();var t=e&&e.__createBinding||(Object.create?function(e,t,a,n){void 0===n&&(n=a),Object.defineProperty(e,n,{enumerable:!0,get:function(){return t[a]}})}:function(e,t,a,n){void 0===n&&(n=a),e[n]=t[a]}),a=e&&e.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),n=e&&e.__importStar||function(e){if(e&&e.__esModule)return e;var n={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&t(n,e,r);return a(n,e),n};Object.defineProperty(e,"__esModule",{value:!0}),e.checkInvalidKeyword=e.checkMissingSemicolon=e.checkUnknownDirective=void 0;var r=n(HI()),i=HI(),s=WI();function l(e){let t=[];for(let a of Object.keys(e.directives))r.isDirective(a)||(a.endsWith(":")?t.push(new s.Finding(s.Type.UNKNOWN_DIRECTIVE,"CSP directives don't end with a colon.",s.Severity.SYNTAX,a)):t.push(new s.Finding(s.Type.UNKNOWN_DIRECTIVE,'Directive "'+a+'" is not a known CSP directive.',s.Severity.SYNTAX,a)));return t}function c(e){let t=[];for(let[a,n]of Object.entries(e.directives))if(void 0!==n)for(let e of n)r.isDirective(e)&&t.push(new s.Finding(s.Type.MISSING_SEMICOLON,'Did you forget the semicolon? "'+e+'" seems to be a directive, not a value.',s.Severity.SYNTAX,a,e));return t}function u(e){let t=[],a=Object.values(i.Keyword).map((e=>e.replace(/'/g,"")));for(let[n,i]of Object.entries(e.directives))if(void 0!==i)for(let e of i)if(a.some((t=>t===e))||e.startsWith("nonce-")||e.match(/^(sha256|sha384|sha512)-/))t.push(new s.Finding(s.Type.INVALID_KEYWORD,'Did you forget to surround "'+e+'" with single-ticks?',s.Severity.SYNTAX,n,e));else if(e.startsWith("'")){if(n===r.Directive.REQUIRE_TRUSTED_TYPES_FOR){if(e===r.TrustedTypesSink.SCRIPT)continue}else if(n===r.Directive.TRUSTED_TYPES){if("'allow-duplicates'"===e||"'none'"===e)continue}else if(r.isKeyword(e)||r.isHash(e)||r.isNonce(e))continue;t.push(new s.Finding(s.Type.INVALID_KEYWORD,e+" seems to be an invalid CSP keyword.",s.Severity.SYNTAX,n,e))}return t}o(l,"checkUnknownDirective"),e.checkUnknownDirective=l,o(c,"checkMissingSemicolon"),e.checkMissingSemicolon=c,o(u,"checkInvalidKeyword"),e.checkInvalidKeyword=u})),$I=l((e=>{J(),Object.defineProperty(e,"__esModule",{value:!0}),e.URLS=void 0,e.URLS=["//gstatic.com/fsn/angular_js-bundle1.js","//www.gstatic.com/fsn/angular_js-bundle1.js","//www.googleadservices.com/pageadimg/imgad","//yandex.st/angularjs/1.2.16/angular-cookies.min.js","//yastatic.net/angularjs/1.2.23/angular.min.js","//yuedust.yuedu.126.net/js/components/angular/angular.js","//art.jobs.netease.com/script/angular.js","//csu-c45.kxcdn.com/angular/angular.js","//elysiumwebsite.s3.amazonaws.com/uploads/blog-media/rockstar/angular.min.js","//inno.blob.core.windows.net/new/libs/AngularJS/1.2.1/angular.min.js","//gift-talk.kakao.com/public/javascripts/angular.min.js","//ajax.googleapis.com/ajax/libs/angularjs/1.2.0rc1/angular-route.min.js","//master-sumok.ru/vendors/angular/angular-cookies.js","//ayicommon-a.akamaihd.net/static/vendor/angular-1.4.2.min.js","//pangxiehaitao.com/framework/angular-1.3.9/angular-animate.min.js","//cdnjs.cloudflare.com/ajax/libs/angular.js/1.2.16/angular.min.js","//96fe3ee995e96e922b6b-d10c35bd0a0de2c718b252bc575fdb73.ssl.cf1.rackcdn.com/angular.js","//oss.maxcdn.com/angularjs/1.2.20/angular.min.js","//reports.zemanta.com/smedia/common/angularjs/1.2.11/angular.js","//cdn.shopify.com/s/files/1/0225/6463/t/1/assets/angular-animate.min.js","//parademanagement.com.s3-website-ap-southeast-1.amazonaws.com/js/angular.min.js","//cdn.jsdelivr.net/angularjs/1.1.2/angular.min.js","//eb2883ede55c53e09fd5-9c145fb03d93709ea57875d307e2d82e.ssl.cf3.rackcdn.com/components/angular-resource.min.js","//andors-trail.googlecode.com/git/AndorsTrailEdit/lib/angular.min.js","//cdn.walkme.com/General/EnvironmentTests/angular/angular.min.js","//laundrymail.com/angular/angular.js","//s3-eu-west-1.amazonaws.com/staticancpa/js/angular-cookies.min.js","//collade.demo.stswp.com/js/vendor/angular.min.js","//mrfishie.github.io/sailor/bower_components/angular/angular.min.js","//askgithub.com/static/js/angular.min.js","//services.amazon.com/solution-providers/assets/vendor/angular-cookies.min.js","//raw.githubusercontent.com/angular/code.angularjs.org/master/1.0.7/angular-resource.js","//prb-resume.appspot.com/bower_components/angular-animate/angular-animate.js","//dl.dropboxusercontent.com/u/30877786/angular.min.js","//static.tumblr.com/x5qdx0r/nPOnngtff/angular-resource.min_1_.js","//storage.googleapis.com/assets-prod.urbansitter.net/us-sym/assets/vendor/angular-sanitize/angular-sanitize.min.js","//twitter.github.io/labella.js/bower_components/angular/angular.min.js","//cdn2-casinoroom.global.ssl.fastly.net/js/lib/angular-animate.min.js","//www.adobe.com/devnet-apps/flashshowcase/lib/angular/angular.1.1.5.min.js","//eternal-sunset.herokuapp.com/bower_components/angular/angular.js","//cdn.bootcss.com/angular.js/1.2.0/angular.min.js"]})),KI=l((e=>{J(),Object.defineProperty(e,"__esModule",{value:!0}),e.URLS=void 0,e.URLS=["//vk.com/swf/video.swf","//ajax.googleapis.com/ajax/libs/yui/2.8.0r4/build/charts/assets/charts.swf"]})),YI=l((e=>{J(),Object.defineProperty(e,"__esModule",{value:!0}),e.URLS=e.NEEDS_EVAL=void 0,e.NEEDS_EVAL=["googletagmanager.com","www.googletagmanager.com","www.googleadservices.com","google-analytics.com","ssl.google-analytics.com","www.google-analytics.com"],e.URLS=["//bebezoo.1688.com/fragment/index.htm","//www.google-analytics.com/gtm/js","//googleads.g.doubleclick.net/pagead/conversion/1036918760/wcm","//www.googleadservices.com/pagead/conversion/1070110417/wcm","//www.google.com/tools/feedback/escalation-options","//pin.aliyun.com/check_audio","//offer.alibaba.com/market/CID100002954/5/fetchKeyword.do","//ccrprod.alipay.com/ccr/arriveTime.json","//group.aliexpress.com/ajaxAcquireGroupbuyProduct.do","//detector.alicdn.com/2.7.3/index.php","//suggest.taobao.com/sug","//translate.google.com/translate_a/l","//count.tbcdn.cn//counter3","//wb.amap.com/channel.php","//translate.googleapis.com/translate_a/l","//afpeng.alimama.com/ex","//accounts.google.com/o/oauth2/revoke","//pagead2.googlesyndication.com/relatedsearch","//yandex.ru/soft/browsers/check","//api.facebook.com/restserver.php","//mts0.googleapis.com/maps/vt","//syndication.twitter.com/widgets/timelines/765840589183213568","//www.youtube.com/profile_style","//googletagmanager.com/gtm/js","//mc.yandex.ru/watch/24306916/1","//share.yandex.net/counter/gpp/","//ok.go.mail.ru/lady_on_lady_recipes_r.json","//d1f69o4buvlrj5.cloudfront.net/__efa_15_1_ornpba.xekq.arg/optout_check","//www.googletagmanager.com/gtm/js","//api.vk.com/method/wall.get","//www.sharethis.com/get-publisher-info.php","//google.ru/maps/vt","//pro.netrox.sc/oapi/h_checksite.ashx","//vimeo.com/api/oembed.json/","//de.blog.newrelic.com/wp-admin/admin-ajax.php","//ajax.googleapis.com/ajax/services/search/news","//ssl.google-analytics.com/gtm/js","//pubsub.pubnub.com/subscribe/demo/hello_world/","//pass.yandex.ua/services","//id.rambler.ru/script/topline_info.js","//m.addthis.com/live/red_lojson/100eng.json","//passport.ngs.ru/ajax/check","//catalog.api.2gis.ru/ads/search","//gum.criteo.com/sync","//maps.google.com/maps/vt","//ynuf.alipay.com/service/um.json","//securepubads.g.doubleclick.net/gampad/ads","//c.tiles.mapbox.com/v3/texastribune.tx-congress-cvap/6/15/26.grid.json","//rexchange.begun.ru/banners","//an.yandex.ru/page/147484","//links.services.disqus.com/api/ping","//api.map.baidu.com/","//tj.gongchang.com/api/keywordrecomm/","//data.gongchang.com/livegrail/","//ulogin.ru/token.php","//beta.gismeteo.ru/api/informer/layout.js/120x240-3/ru/","//maps.googleapis.com/maps/api/js/GeoPhotoService.GetMetadata","//a.config.skype.com/config/v1/Skype/908_1.33.0.111/SkypePersonalization","//maps.beeline.ru/w","//target.ukr.net/","//www.meteoprog.ua/data/weather/informer/Poltava.js","//cdn.syndication.twimg.com/widgets/timelines/599200054310604802","//wslocker.ru/client/user.chk.php","//community.adobe.com/CommunityPod/getJSON","//maps.google.lv/maps/vt","//dev.virtualearth.net/REST/V1/Imagery/Metadata/AerialWithLabels/26.318581","//awaps.yandex.ru/10/8938/02400400.","//a248.e.akamai.net/h5.hulu.com/h5.mp4","//nominatim.openstreetmap.org/","//plugins.mozilla.org/en-us/plugins_list.json","//h.cackle.me/widget/32153/bootstrap","//graph.facebook.com/1/","//fellowes.ugc.bazaarvoice.com/data/reviews.json","//widgets.pinterest.com/v3/pidgets/boards/ciciwin/hedgehog-squirrel-crafts/pins/","//www.linkedin.com/countserv/count/share","//se.wikipedia.org/w/api.php","//cse.google.com/api/007627024705277327428/cse/r3vs7b0fcli/queries/js","//relap.io/api/v2/similar_pages_jsonp.js","//c1n3.hypercomments.com/stream/subscribe","//maps.google.de/maps/vt","//books.google.com/books","//connect.mail.ru/share_count","//tr.indeed.com/m/newjobs","//www-onepick-opensocial.googleusercontent.com/gadgets/proxy","//www.panoramio.com/map/get_panoramas.php","//client.siteheart.com/streamcli/client","//www.facebook.com/restserver.php","//autocomplete.travelpayouts.com/avia","//www.googleapis.com/freebase/v1/topic/m/0344_","//mts1.googleapis.com/mapslt/ft","//api.twitter.com/1/statuses/oembed.json","//fast.wistia.com/embed/medias/o75jtw7654.json","//partner.googleadservices.com/gampad/ads","//pass.yandex.ru/services","//gupiao.baidu.com/stocks/stockbets","//widget.admitad.com/widget/init","//api.instagram.com/v1/tags/partykungen23328/media/recent","//video.media.yql.yahoo.com/v1/video/sapi/streams/063fb76c-6c70-38c5-9bbc-04b7c384de2b","//ib.adnxs.com/jpt","//pass.yandex.com/services","//www.google.de/maps/vt","//clients1.google.com/complete/search","//api.userlike.com/api/chat/slot/proactive/","//www.youku.com/index_cookielist/s/jsonp","//mt1.googleapis.com/mapslt/ft","//api.mixpanel.com/track/","//wpd.b.qq.com/cgi/get_sign.php","//pipes.yahooapis.com/pipes/pipe.run","//gdata.youtube.com/feeds/api/videos/WsJIHN1kNWc","//9.chart.apis.google.com/chart","//cdn.syndication.twitter.com/moments/709229296800440320","//api.flickr.com/services/feeds/photos_friends.gne","//cbks0.googleapis.com/cbk","//www.blogger.com/feeds/5578653387562324002/posts/summary/4427562025302749269","//query.yahooapis.com/v1/public/yql","//kecngantang.blogspot.com/feeds/posts/default/-/Komik","//www.travelpayouts.com/widgets/50f53ce9ada1b54bcc000031.json","//i.cackle.me/widget/32586/bootstrap","//translate.yandex.net/api/v1.5/tr.json/detect","//a.tiles.mapbox.com/v3/zentralmedia.map-n2raeauc.jsonp","//maps.google.ru/maps/vt","//c1n2.hypercomments.com/stream/subscribe","//rec.ydf.yandex.ru/cookie","//cdn.jsdelivr.net"]})),JI=l((e=>{function t(e){return e=(e=e.replace(/^\w[+\w.-]*:\/\//i,"")).replace(/^\/\//,"")}function a(e){let a=new URL("https://"+t(e).replace(":*","").replace("*","wildcard_placeholder")).hostname.replace("wildcard_placeholder","*"),n=/^\[[\d:]+\]/;return t(e).match(n)&&!a.match(n)?"["+a+"]":a}function n(e){return e.startsWith("//")?e.replace("//","https://"):e}function r(e,t){let a=new URL(n(e.replace(":*","").replace("*","wildcard_placeholder"))),r=t.map((e=>new URL(n(e)))),i=a.hostname.toLowerCase(),o=i.startsWith("wildcard_placeholder."),s=i.replace(/^\wildcard_placeholder/i,""),l=a.pathname,c="/"!==l;for(let e of r){let t=e.hostname;if(t.endsWith(s)&&(o||i===t)){if(c)if(l.endsWith("/")){if(!e.pathname.startsWith(l))continue}else if(e.pathname!==l)continue;return e}}return null}function i(e,t){let a=Object.keys(e.directives);for(let n of a){let a=e.directives[n];a&&t(n,a)}}J(),Object.defineProperty(e,"__esModule",{value:!0}),e.applyCheckFunktionToDirectives=e.matchWildcardUrls=e.getHostname=e.getSchemeFreeUrl=void 0,o(t,"getSchemeFreeUrl"),e.getSchemeFreeUrl=t,o(a,"getHostname"),e.getHostname=a,o(n,"setScheme"),o(r,"matchWildcardUrls"),e.matchWildcardUrls=r,o(i,"applyCheckFunktionToDirectives"),e.applyCheckFunktionToDirectives=i})),ZI=l((e=>{J();var t=e&&e.__createBinding||(Object.create?function(e,t,a,n){void 0===n&&(n=a),Object.defineProperty(e,n,{enumerable:!0,get:function(){return t[a]}})}:function(e,t,a,n){void 0===n&&(n=a),e[n]=t[a]}),a=e&&e.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),n=e&&e.__importStar||function(e){if(e&&e.__esModule)return e;var n={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&t(n,e,r);return a(n,e),n};Object.defineProperty(e,"__esModule",{value:!0}),e.checkHasConfiguredReporting=e.checkSrcHttp=e.checkNonceLength=e.checkDeprecatedDirective=e.checkIpSource=e.looksLikeIpAddress=e.checkFlashObjectAllowlistBypass=e.checkScriptAllowlistBypass=e.checkMissingDirectives=e.checkMultipleMissingBaseUriDirective=e.checkMissingBaseUriDirective=e.checkMissingScriptSrcDirective=e.checkMissingObjectSrcDirective=e.checkWildcards=e.checkPlainUrlSchemes=e.checkScriptUnsafeEval=e.checkScriptUnsafeInline=e.URL_SCHEMES_CAUSING_XSS=e.DIRECTIVES_CAUSING_XSS=void 0;var r=n($I()),i=n(KI()),s=n(YI()),l=n(HI()),c=HI(),u=WI(),d=n(JI());function m(e){let t=e.getEffectiveDirective(c.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(c.Keyword.UNSAFE_INLINE)?[new u.Finding(u.Type.SCRIPT_UNSAFE_INLINE,"'unsafe-inline' allows the execution of unsafe in-page scripts and event handlers.",u.Severity.HIGH,t,c.Keyword.UNSAFE_INLINE)]:[]}function p(e){let t=e.getEffectiveDirective(c.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(c.Keyword.UNSAFE_EVAL)?[new u.Finding(u.Type.SCRIPT_UNSAFE_EVAL,"'unsafe-eval' allows the execution of code injected into DOM APIs such as eval().",u.Severity.MEDIUM_MAYBE,t,c.Keyword.UNSAFE_EVAL)]:[]}function h(t){let a=[],n=t.getEffectiveDirectives(e.DIRECTIVES_CAUSING_XSS);for(let r of n){let n=t.directives[r]||[];for(let t of n)e.URL_SCHEMES_CAUSING_XSS.includes(t)&&a.push(new u.Finding(u.Type.PLAIN_URL_SCHEMES,t+" URI in "+r+" allows the execution of unsafe scripts.",u.Severity.HIGH,r,t))}return a}function g(t){let a=[],n=t.getEffectiveDirectives(e.DIRECTIVES_CAUSING_XSS);for(let e of n){let n=t.directives[e]||[];for(let t of n)if("*"===d.getSchemeFreeUrl(t)){a.push(new u.Finding(u.Type.PLAIN_WILDCARD,e+" should not allow '*' as source",u.Severity.HIGH,e,t));continue}}return a}function f(e){let t=[];return c.Directive.OBJECT_SRC in e.directives?t=e.directives[c.Directive.OBJECT_SRC]:c.Directive.DEFAULT_SRC in e.directives&&(t=e.directives[c.Directive.DEFAULT_SRC]),void 0!==t&&t.length>=1?[]:[new u.Finding(u.Type.MISSING_DIRECTIVES,"Missing object-src allows the injection of plugins which can execute JavaScript. Can you set it to 'none'?",u.Severity.HIGH,c.Directive.OBJECT_SRC)]}function y(e){return c.Directive.SCRIPT_SRC in e.directives||c.Directive.DEFAULT_SRC in e.directives?[]:[new u.Finding(u.Type.MISSING_DIRECTIVES,"script-src directive is missing.",u.Severity.HIGH,c.Directive.SCRIPT_SRC)]}function v(e){return b([e])}function b(e){let t=o((e=>e.policyHasScriptNonces()||e.policyHasScriptHashes()&&e.policyHasStrictDynamic()),"needsBaseUri"),a=o((e=>c.Directive.BASE_URI in e.directives),"hasBaseUri");if(e.some(t)&&!e.some(a)){let e="Missing base-uri allows the injection of base tags. They can be used to set the base URL for all relative (script) URLs to an attacker controlled domain. Can you set it to 'none' or 'self'?";return[new u.Finding(u.Type.MISSING_DIRECTIVES,e,u.Severity.HIGH,c.Directive.BASE_URI)]}return[]}function w(e){return[...f(e),...y(e),...v(e)]}function D(e){let t=[],a=e.getEffectiveDirective(c.Directive.SCRIPT_SRC),n=e.directives[a]||[];if(n.includes(c.Keyword.NONE))return t;for(let e of n){if(e===c.Keyword.SELF){t.push(new u.Finding(u.Type.SCRIPT_ALLOWLIST_BYPASS,"'self' can be problematic if you host JSONP, AngularJS or user uploaded files.",u.Severity.MEDIUM_MAYBE,a,e));continue}if(e.startsWith("'")||l.isUrlScheme(e)||-1===e.indexOf("."))continue;let i="//"+d.getSchemeFreeUrl(e),o=d.matchWildcardUrls(i,r.URLS),m=d.matchWildcardUrls(i,s.URLS);if(m){let e=s.NEEDS_EVAL.includes(m.hostname),t=n.includes(c.Keyword.UNSAFE_EVAL);e&&!t&&(m=null)}if(m||o){let n="",r="";m&&(n=m.hostname,r=" JSONP endpoints"),o&&(n=o.hostname,r+=""===r.trim()?"":" and",r+=" Angular libraries"),t.push(new u.Finding(u.Type.SCRIPT_ALLOWLIST_BYPASS,n+" is known to host"+r+" which allow to bypass this CSP.",u.Severity.HIGH,a,e))}else t.push(new u.Finding(u.Type.SCRIPT_ALLOWLIST_BYPASS,"No bypass found; make sure that this URL doesn't serve JSONP replies or Angular libraries.",u.Severity.MEDIUM_MAYBE,a,e))}return t}function E(e){let t=[],a=e.getEffectiveDirective(c.Directive.OBJECT_SRC),n=e.directives[a]||[],r=e.directives[c.Directive.PLUGIN_TYPES];if(r&&!r.includes("application/x-shockwave-flash"))return[];for(let e of n){if(e===c.Keyword.NONE)return[];let n="//"+d.getSchemeFreeUrl(e),r=d.matchWildcardUrls(n,i.URLS);r?t.push(new u.Finding(u.Type.OBJECT_ALLOWLIST_BYPASS,r.hostname+" is known to host Flash files which allow to bypass this CSP.",u.Severity.HIGH,a,e)):a===c.Directive.OBJECT_SRC&&t.push(new u.Finding(u.Type.OBJECT_ALLOWLIST_BYPASS,"Can you restrict object-src to 'none' only?",u.Severity.MEDIUM_MAYBE,a,e))}return t}function T(e){return!!(e.startsWith("[")&&e.endsWith("]")||/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/.test(e))}function S(e){let t=[],a=o(((e,a)=>{for(let n of a){let a=d.getHostname(n);T(a)&&("127.0.0.1"===a?t.push(new u.Finding(u.Type.IP_SOURCE,e+" directive allows localhost as source. Please make sure to remove this in production environments.",u.Severity.INFO,e,n)):t.push(new u.Finding(u.Type.IP_SOURCE,e+" directive has an IP-Address as source: "+a+" (will be ignored by browsers!). ",u.Severity.INFO,e,n)))}}),"checkIp");return d.applyCheckFunktionToDirectives(e,a),t}function C(e){let t=[];return c.Directive.REFLECTED_XSS in e.directives&&t.push(new u.Finding(u.Type.DEPRECATED_DIRECTIVE,"reflected-xss is deprecated since CSP2. Please, use the X-XSS-Protection header instead.",u.Severity.INFO,c.Directive.REFLECTED_XSS)),c.Directive.REFERRER in e.directives&&t.push(new u.Finding(u.Type.DEPRECATED_DIRECTIVE,"referrer is deprecated since CSP2. Please, use the Referrer-Policy header instead.",u.Severity.INFO,c.Directive.REFERRER)),c.Directive.DISOWN_OPENER in e.directives&&t.push(new u.Finding(u.Type.DEPRECATED_DIRECTIVE,"disown-opener is deprecated since CSP3. Please, use the Cross Origin Opener Policy header instead.",u.Severity.INFO,c.Directive.DISOWN_OPENER)),t}function k(e){let t=new RegExp("^'nonce-(.+)'$"),a=[];return d.applyCheckFunktionToDirectives(e,((e,n)=>{for(let r of n){let n=r.match(t);n&&(n[1].length<8&&a.push(new u.Finding(u.Type.NONCE_LENGTH,"Nonces should be at least 8 characters long.",u.Severity.MEDIUM,e,r)),l.isNonce(r,!0)||a.push(new u.Finding(u.Type.NONCE_CHARSET,"Nonces should only use the base64 charset.",u.Severity.INFO,e,r)))}})),a}function x(e){let t=[];return d.applyCheckFunktionToDirectives(e,((e,a)=>{for(let n of a){let a=e===c.Directive.REPORT_URI?"Use HTTPS to send violation reports securely.":"Allow only resources downloaded over HTTPS.";n.startsWith("http://")&&t.push(new u.Finding(u.Type.SRC_HTTP,a,u.Severity.MEDIUM,e,n))}})),t}function A(e){return(e.directives[c.Directive.REPORT_URI]||[]).length>0?[]:(e.directives[c.Directive.REPORT_TO]||[]).length>0?[new u.Finding(u.Type.REPORT_TO_ONLY,"This CSP policy only provides a reporting destination via the 'report-to' directive. This directive is only supported in Chromium-based browsers so it is recommended to also use a 'report-uri' directive.",u.Severity.INFO,c.Directive.REPORT_TO)]:[new u.Finding(u.Type.REPORTING_DESTINATION_MISSING,"This CSP policy does not configure a reporting destination. This makes it difficult to maintain the CSP policy over time and monitor for any breakages.",u.Severity.INFO,c.Directive.REPORT_URI)]}e.DIRECTIVES_CAUSING_XSS=[c.Directive.SCRIPT_SRC,c.Directive.OBJECT_SRC,c.Directive.BASE_URI],e.URL_SCHEMES_CAUSING_XSS=["data:","http:","https:"],o(m,"checkScriptUnsafeInline"),e.checkScriptUnsafeInline=m,o(p,"checkScriptUnsafeEval"),e.checkScriptUnsafeEval=p,o(h,"checkPlainUrlSchemes"),e.checkPlainUrlSchemes=h,o(g,"checkWildcards"),e.checkWildcards=g,o(f,"checkMissingObjectSrcDirective"),e.checkMissingObjectSrcDirective=f,o(y,"checkMissingScriptSrcDirective"),e.checkMissingScriptSrcDirective=y,o(v,"checkMissingBaseUriDirective"),e.checkMissingBaseUriDirective=v,o(b,"checkMultipleMissingBaseUriDirective"),e.checkMultipleMissingBaseUriDirective=b,o(w,"checkMissingDirectives"),e.checkMissingDirectives=w,o(D,"checkScriptAllowlistBypass"),e.checkScriptAllowlistBypass=D,o(E,"checkFlashObjectAllowlistBypass"),e.checkFlashObjectAllowlistBypass=E,o(T,"looksLikeIpAddress"),e.looksLikeIpAddress=T,o(S,"checkIpSource"),e.checkIpSource=S,o(C,"checkDeprecatedDirective"),e.checkDeprecatedDirective=C,o(k,"checkNonceLength"),e.checkNonceLength=k,o(x,"checkSrcHttp"),e.checkSrcHttp=x,o(A,"checkHasConfiguredReporting"),e.checkHasConfiguredReporting=A})),XI=l((e=>{J();var t=e&&e.__createBinding||(Object.create?function(e,t,a,n){void 0===n&&(n=a),Object.defineProperty(e,n,{enumerable:!0,get:function(){return t[a]}})}:function(e,t,a,n){void 0===n&&(n=a),e[n]=t[a]}),a=e&&e.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),n=e&&e.__importStar||function(e){if(e&&e.__esModule)return e;var n={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&t(n,e,r);return a(n,e),n};Object.defineProperty(e,"__esModule",{value:!0}),e.checkRequiresTrustedTypesForScripts=e.checkAllowlistFallback=e.checkUnsafeInlineFallback=e.checkStrictDynamicNotStandalone=e.checkStrictDynamic=void 0;var r=n(HI()),i=HI(),s=WI();function l(e){let t=e.getEffectiveDirective(r.Directive.SCRIPT_SRC),a=e.directives[t]||[];return a.some((e=>!e.startsWith("'")))&&!a.includes(i.Keyword.STRICT_DYNAMIC)?[new s.Finding(s.Type.STRICT_DYNAMIC,"Host allowlists can frequently be bypassed. Consider using 'strict-dynamic' in combination with CSP nonces or hashes.",s.Severity.STRICT_CSP,t)]:[]}function c(e){let t=e.getEffectiveDirective(r.Directive.SCRIPT_SRC);return!(e.directives[t]||[]).includes(i.Keyword.STRICT_DYNAMIC)||e.policyHasScriptNonces()||e.policyHasScriptHashes()?[]:[new s.Finding(s.Type.STRICT_DYNAMIC_NOT_STANDALONE,"'strict-dynamic' without a CSP nonce/hash will block all scripts.",s.Severity.INFO,t)]}function u(e){if(!e.policyHasScriptNonces()&&!e.policyHasScriptHashes())return[];let t=e.getEffectiveDirective(r.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(i.Keyword.UNSAFE_INLINE)?[]:[new s.Finding(s.Type.UNSAFE_INLINE_FALLBACK,"Consider adding 'unsafe-inline' (ignored by browsers supporting nonces/hashes) to be backward compatible with older browsers.",s.Severity.STRICT_CSP,t)]}function d(e){let t=e.getEffectiveDirective(r.Directive.SCRIPT_SRC),a=e.directives[t]||[];return a.includes(i.Keyword.STRICT_DYNAMIC)?a.some((e=>["http:","https:","*"].includes(e)||e.includes(".")))?[]:[new s.Finding(s.Type.ALLOWLIST_FALLBACK,"Consider adding https: and http: url schemes (ignored by browsers supporting 'strict-dynamic') to be backward compatible with older browsers.",s.Severity.STRICT_CSP,t)]:[]}function m(e){let t=e.getEffectiveDirective(r.Directive.REQUIRE_TRUSTED_TYPES_FOR);return(e.directives[t]||[]).includes(r.TrustedTypesSink.SCRIPT)?[]:[new s.Finding(s.Type.REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS,"Consider requiring Trusted Types for scripts to lock down DOM XSS injection sinks. You can do this by adding \"require-trusted-types-for 'script'\" to your policy.",s.Severity.INFO,r.Directive.REQUIRE_TRUSTED_TYPES_FOR)]}o(l,"checkStrictDynamic"),e.checkStrictDynamic=l,o(c,"checkStrictDynamicNotStandalone"),e.checkStrictDynamicNotStandalone=c,o(u,"checkUnsafeInlineFallback"),e.checkUnsafeInlineFallback=u,o(d,"checkAllowlistFallback"),e.checkAllowlistFallback=d,o(m,"checkRequiresTrustedTypesForScripts"),e.checkRequiresTrustedTypesForScripts=m})),QI=l((e=>{J(),Object.defineProperty(e,"__esModule",{value:!0}),e.evaluateForSyntaxErrors=e.evaluateForWarnings=e.evaluateForFailure=void 0;var t=GI(),a=ZI(),n=XI(),r=HI();function i(e,t){return e.some((e=>e.equals(t)))}function s(e){let t=[];if(0===e.length)return t;let a=e[0];for(let n of a)e.every((e=>i(e,n)))&&t.push(n);return t}function l(e){let t=[];for(let a of e)for(let e of a)i(t,e)||t.push(e);return t}function c(e,t){let a=[];for(let n of e)a.push(t(n));return s(a)}function u(e,t){let a=[];for(let n of e)a.push(t(n));return l(a)}function d(e){let t=[...c(e,a.checkMissingScriptSrcDirective),...c(e,a.checkMissingObjectSrcDirective),...a.checkMultipleMissingBaseUriDirective(e)],i=e.map((e=>e.getEffectiveCsp(r.Version.CSP3))),o=i.filter((e=>{let t=e.getEffectiveDirective(r.Directive.SCRIPT_SRC);return e.directives[t]}));return[...t,...[...c(o,n.checkStrictDynamic),...c(o,a.checkScriptUnsafeInline),...c(i,a.checkWildcards),...c(i,a.checkPlainUrlSchemes)]]}function m(e){return[...u(e,n.checkUnsafeInlineFallback),...u(e,n.checkAllowlistFallback)]}function p(e){let n=[];for(let r of e){let e=[...a.checkNonceLength(r),...t.checkUnknownDirective(r),...a.checkDeprecatedDirective(r),...t.checkMissingSemicolon(r),...t.checkInvalidKeyword(r)];n.push(e)}return n}o(i,"arrayContains"),o(s,"setIntersection"),o(l,"setUnion"),o(c,"atLeastOnePasses"),o(u,"atLeastOneFails"),o(d,"evaluateForFailure"),e.evaluateForFailure=d,o(m,"evaluateForWarnings"),e.evaluateForWarnings=m,o(p,"evaluateForSyntaxErrors"),e.evaluateForSyntaxErrors=p})),eM=l((e=>{J();var t=e&&e.__createBinding||(Object.create?function(e,t,a,n){void 0===n&&(n=a),Object.defineProperty(e,n,{enumerable:!0,get:function(){return t[a]}})}:function(e,t,a,n){void 0===n&&(n=a),e[n]=t[a]}),a=e&&e.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),n=e&&e.__importStar||function(e){if(e&&e.__esModule)return e;var n={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&t(n,e,r);return a(n,e),n};Object.defineProperty(e,"__esModule",{value:!0}),e.TEST_ONLY=e.CspParser=void 0;var r=n(HI()),i=class{static{o(this,"CspParser")}constructor(e){this.csp=new r.Csp,this.parse(e)}parse(e){this.csp=new r.Csp;let t=e.split(";");for(let e=0;e<t.length;e++){let a=t[e].trim().match(/\S+/g);if(Array.isArray(a)){let e=a[0].toLowerCase();if(e in this.csp.directives)continue;r.isDirective(e);let t=[];for(let e,n=1;e=a[n];n++)e=s(e),t.includes(e)||t.push(e);this.csp.directives[e]=t}}return this.csp}};function s(e){let t=(e=e.trim()).toLowerCase();return r.isKeyword(t)||r.isUrlScheme(e)?t:e}e.CspParser=i,o(s,"normalizeDirectiveValue"),e.TEST_ONLY={normalizeDirectiveValue:s}}));function tM(e){let t=uM[e.type];return t?yi(t)?t:"string"==typeof t?cM(t,{keyword:e.value||""}):(t=t[e.directive],t||(Kt.warn("CSP Evaluator",`No translation found for description: ${e.description}`),e.description)):(Kt.warn("CSP Evaluator",`No translation found for description: ${e.description}`),e.description)}function aM(e){return new oM.CspParser(e).csp}function nM(e){let t=e.map(aM);return{bypasses:(0,rM.evaluateForFailure)(t),warnings:(0,rM.evaluateForWarnings)(t),syntax:(0,rM.evaluateForSyntaxErrors)(t)}}var rM,iM,oM,sM,lM,cM,uM,dM=s((()=>{J(),rM=d(QI(),1),iM=d(WI(),1),oM=d(eM(),1),sM=d(HI(),1),ea(),ro(),Mi(),cM=eo("core/lib/csp-evaluator.js",lM={missingBaseUri:"Missing base-uri allows injected <base> tags to set the base URL for all relative URLs (e.g. scripts) to an attacker controlled domain. Consider setting base-uri to 'none' or 'self'.",missingScriptSrc:"script-src directive is missing. This can allow the execution of unsafe scripts.",missingObjectSrc:"Missing object-src allows the injection of plugins that execute unsafe scripts. Consider setting object-src to 'none' if you can.",strictDynamic:"Host allowlists can frequently be bypassed. Consider using CSP nonces or hashes instead, along with 'strict-dynamic' if necessary.",unsafeInline:"'unsafe-inline' allows the execution of unsafe in-page scripts and event handlers. Consider using CSP nonces or hashes to allow scripts individually.",unsafeInlineFallback:"Consider adding 'unsafe-inline' (ignored by browsers supporting nonces/hashes) to be backward compatible with older browsers.",allowlistFallback:"Consider adding https: and http: URL schemes (ignored by browsers supporting 'strict-dynamic') to be backward compatible with older browsers.",reportToOnly:"The reporting destination is only configured via the report-to directive. This directive is only supported in Chromium-based browsers so it is recommended to also use a report-uri directive.",reportingDestinationMissing:"No CSP configures a reporting destination. This makes it difficult to maintain the CSP over time and monitor for any breakages.",nonceLength:"Nonces should be at least 8 characters long.",nonceCharset:"Nonces should use the base64 charset.",missingSemicolon:"Did you forget the semicolon? {keyword} seems to be a directive, not a keyword.",unknownDirective:"Unknown CSP directive.",unknownKeyword:"{keyword} seems to be an invalid keyword.",deprecatedReflectedXSS:"reflected-xss is deprecated since CSP2. Please, use the X-XSS-Protection header instead.",deprecatedReferrer:"referrer is deprecated since CSP2. Please, use the Referrer-Policy header instead.",deprecatedDisownOpener:"disown-opener is deprecated since CSP3. Please, use the Cross-Origin-Opener-Policy header instead.",plainWildcards:"Avoid using plain wildcards ({keyword}) in this directive. Plain wildcards allow scripts to be sourced from an unsafe domain.",plainUrlScheme:"Avoid using plain URL schemes ({keyword}) in this directive. Plain URL schemes allow scripts to be sourced from an unsafe domain."}),uM={[iM.Type.MISSING_SEMICOLON]:lM.missingSemicolon,[iM.Type.UNKNOWN_DIRECTIVE]:cM(lM.unknownDirective),[iM.Type.INVALID_KEYWORD]:lM.unknownKeyword,[iM.Type.MISSING_DIRECTIVES]:{[sM.Directive.BASE_URI]:cM(lM.missingBaseUri),[sM.Directive.SCRIPT_SRC]:cM(lM.missingScriptSrc),[sM.Directive.OBJECT_SRC]:cM(lM.missingObjectSrc)},[iM.Type.SCRIPT_UNSAFE_INLINE]:cM(lM.unsafeInline),[iM.Type.PLAIN_WILDCARD]:lM.plainWildcards,[iM.Type.PLAIN_URL_SCHEMES]:lM.plainUrlScheme,[iM.Type.NONCE_LENGTH]:cM(lM.nonceLength),[iM.Type.NONCE_CHARSET]:cM(lM.nonceCharset),[iM.Type.DEPRECATED_DIRECTIVE]:{[sM.Directive.REFLECTED_XSS]:cM(lM.deprecatedReflectedXSS),[sM.Directive.REFERRER]:cM(lM.deprecatedReferrer),[sM.Directive.DISOWN_OPENER]:cM(lM.deprecatedDisownOpener)},[iM.Type.STRICT_DYNAMIC]:cM(lM.strictDynamic),[iM.Type.UNSAFE_INLINE_FALLBACK]:cM(lM.unsafeInlineFallback),[iM.Type.ALLOWLIST_FALLBACK]:cM(lM.allowlistFallback),[iM.Type.REPORTING_DESTINATION_MISSING]:cM(lM.reportingDestinationMissing),[iM.Type.REPORT_TO_ONLY]:cM(lM.reportToOnly)},o(tM,"getTranslatedDescription"),o(aM,"parseCsp"),o(nM,"evaluateRawCspsForXss")})),mM={};c(mM,{UIStrings:()=>pM,default:()=>fM});var pM,hM,gM,fM,yM,vM,bM=s((()=>{J(),xr(),fb(),ro(),dM(),hM=eo("core/audits/csp-xss.js",pM={title:"Ensure CSP is effective against XSS attacks",description:"A strong Content Security Policy (CSP) significantly reduces the risk of cross-site scripting (XSS) attacks. [Learn how to use a CSP to prevent XSS](https://developer.chrome.com/docs/lighthouse/best-practices/csp-xss/)",noCsp:"No CSP found in enforcement mode",metaTagMessage:"The page contains a CSP defined in a <meta> tag. Consider moving the CSP to an HTTP header or defining another strict CSP in an HTTP header.",columnDirective:"Directive",columnSeverity:"Severity",itemSeveritySyntax:"Syntax"}),gM=class extends Dr{static{o(this,"CspXss")}static get meta(){return{id:"csp-xss",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:hM(pM.title),description:hM(pM.description),requiredArtifacts:["devtoolsLogs","MetaElements","URL"]}}static async getRawCsps(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=await pb.request({devtoolsLog:a,URL:e.URL},t),r=e.MetaElements.filter((e=>e.httpEquiv&&"content-security-policy"===e.httpEquiv.toLowerCase())).flatMap((e=>(e.content||"").split(","))).filter((e=>e.replace(/\s/g,"")));return{cspHeaders:n.responseHeaders.filter((e=>"content-security-policy"===e.name.toLowerCase())).flatMap((e=>e.value.split(","))).filter((e=>e.replace(/\s/g,""))),cspMetaTags:r}}static findingToTableItem(e,t){return{directive:e.directive,description:tM(e),severity:t}}static constructSyntaxResults(e,t){let a=[];for(let n=0;n<e.length;++n){let r=e[n].map((e=>this.findingToTableItem(e)));r.length&&a.push({severity:hM(pM.itemSeveritySyntax),description:{type:"code",value:t[n]},subItems:{type:"subitems",items:r}})}return a}static constructResults(e,t){let a=[...e,...t];if(!a.length)return{score:0,results:[{severity:hM(no.itemSeverityHigh),description:hM(pM.noCsp),directive:void 0}]};let{bypasses:n,warnings:r,syntax:i}=nM(a),o=[...this.constructSyntaxResults(i,a),...n.map((e=>this.findingToTableItem(e,hM(no.itemSeverityHigh)))),...r.map((e=>this.findingToTableItem(e,hM(no.itemSeverityMedium))))],s=nM(e).bypasses.length>0||0===e.length;return t.length>0&&s&&o.push({severity:hM(no.itemSeverityMedium),description:hM(pM.metaTagMessage),directive:void 0}),{score:n.length?0:1,results:o}}static async audit(e,t){let{cspHeaders:a,cspMetaTags:n}=await this.getRawCsps(e,t),{score:r,results:i}=this.constructResults(a,n),o=[{key:"description",valueType:"text",subItemsHeading:{key:"description"},label:hM(no.columnDescription)},{key:"directive",valueType:"code",subItemsHeading:{key:"directive"},label:hM(pM.columnDirective)},{key:"severity",valueType:"text",subItemsHeading:{key:"severity"},label:hM(pM.columnSeverity)}],s=Dr.makeTableDetails(o,i);return{score:r,notApplicable:!i.length,details:s}}},fM=gM})),wM=s((()=>{J(),yM={AuthorizationCoveredByWildcard:"Authorization will not be covered by the wildcard symbol (*) in CORS `Access-Control-Allow-Headers` handling.",CanRequestURLHTTPContainingNewline:"Resource requests whose URLs contained both removed whitespace `(n|r|t)` characters and less-than characters (`<`) are blocked. Please remove newlines and encode less-than characters from places like element attribute values in order to load these resources.",ChromeLoadTimesConnectionInfo:"`chrome.loadTimes()` is deprecated, instead use standardized API: Navigation Timing 2.",ChromeLoadTimesFirstPaintAfterLoadTime:"`chrome.loadTimes()` is deprecated, instead use standardized API: Paint Timing.",ChromeLoadTimesWasAlternateProtocolAvailable:"`chrome.loadTimes()` is deprecated, instead use standardized API: `nextHopProtocol` in Navigation Timing 2.",CookieWithTruncatingChar:"Cookies containing a `(0|r|n)` character will be rejected instead of truncated.",CrossOriginAccessBasedOnDocumentDomain:"Relaxing the same-origin policy by setting `document.domain` is deprecated, and will be disabled by default. This deprecation warning is for a cross-origin access that was enabled by setting `document.domain`.",CrossOriginWindowAlert:"Triggering window.alert from cross origin iframes has been deprecated and will be removed in the future.",CrossOriginWindowConfirm:"Triggering window.confirm from cross origin iframes has been deprecated and will be removed in the future.",CSSSelectorInternalMediaControlsOverlayCastButton:"The `disableRemotePlayback` attribute should be used in order to disable the default Cast integration instead of using `-internal-media-controls-overlay-cast-button` selector.",DataUrlInSvgUse:"Support for data: URLs in SVG <use> element is deprecated and it will be removed in the future.",DocumentDomainSettingWithoutOriginAgentClusterHeader:"Relaxing the same-origin policy by setting `document.domain` is deprecated, and will be disabled by default. To continue using this feature, please opt-out of origin-keyed agent clusters by sending an `Origin-Agent-Cluster: ?0` header along with the HTTP response for the document and frames. See https://developer.chrome.com/blog/immutable-document-domain/ for more details.",DOMMutationEvents:"DOM Mutation Events, including `DOMSubtreeModified`, `DOMNodeInserted`, `DOMNodeRemoved`, `DOMNodeRemovedFromDocument`, `DOMNodeInsertedIntoDocument`, and `DOMCharacterDataModified` are deprecated (https://w3c.github.io/uievents/#legacy-event-types) and will be removed. Please use `MutationObserver` instead.",ExpectCTHeader:"The `Expect-CT` header is deprecated and will be removed. Chrome requires Certificate Transparency for all publicly trusted certificates issued after April 30, 2018.",GeolocationInsecureOrigin:"`getCurrentPosition()` and `watchPosition()` no longer work on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",GeolocationInsecureOriginDeprecatedNotRemoved:"`getCurrentPosition()` and `watchPosition()` are deprecated on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",GetUserMediaInsecureOrigin:"`getUserMedia()` no longer works on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",HostCandidateAttributeGetter:"`RTCPeerConnectionIceErrorEvent.hostCandidate` is deprecated. Please use `RTCPeerConnectionIceErrorEvent.address` or `RTCPeerConnectionIceErrorEvent.port` instead.",IdentityInCanMakePaymentEvent:"The merchant origin and arbitrary data from the `canmakepayment` service worker event are deprecated and will be removed: `topOrigin`, `paymentRequestOrigin`, `methodData`, `modifiers`.",InsecurePrivateNetworkSubresourceRequest:"The website requested a subresource from a network that it could only access because of its users' privileged network position. These requests expose non-public devices and servers to the internet, increasing the risk of a cross-site request forgery (CSRF) attack, and/or information leakage. To mitigate these risks, Chrome deprecates requests to non-public subresources when initiated from non-secure contexts, and will start blocking them.",InterestGroupDailyUpdateUrl:"The `dailyUpdateUrl` field of `InterestGroups` passed to `joinAdInterestGroup()` has been renamed to `updateUrl`, to more accurately reflect its behavior.",LocalCSSFileExtensionRejected:"CSS cannot be loaded from `file:` URLs unless they end in a `.css` file extension.",MediaSourceAbortRemove:"Using `SourceBuffer.abort()` to abort `remove()`'s asynchronous range removal is deprecated due to specification change. Support will be removed in the future. You should listen to the `updateend` event instead. `abort()` is intended to only abort an asynchronous media append or reset parser state.",MediaSourceDurationTruncatingBuffered:"Setting `MediaSource.duration` below the highest presentation timestamp of any buffered coded frames is deprecated due to specification change. Support for implicit removal of truncated buffered media will be removed in the future. You should instead perform explicit `remove(newDuration, oldDuration)` on all `sourceBuffers`, where `newDuration < oldDuration`.",NonStandardDeclarativeShadowDOM:"The older, non-standardized `shadowroot` attribute is deprecated, and will *no longer function* in M119. Please use the new, standardized `shadowrootmode` attribute instead.",NoSysexWebMIDIWithoutPermission:"Web MIDI will ask a permission to use even if the sysex is not specified in the `MIDIOptions`.",NotificationInsecureOrigin:"The Notification API may no longer be used from insecure origins. You should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",NotificationPermissionRequestedIframe:"Permission for the Notification API may no longer be requested from a cross-origin iframe. You should consider requesting permission from a top-level frame or opening a new window instead.",ObsoleteCreateImageBitmapImageOrientationNone:"Option `imageOrientation: 'none'` in createImageBitmap is deprecated. Please use createImageBitmap with option \\{imageOrientation: 'from-image'\\} instead.",ObsoleteWebRtcCipherSuite:"Your partner is negotiating an obsolete (D)TLS version. Please check with your partner to have this fixed.",OverflowVisibleOnReplacedElement:"Specifying `overflow: visible` on img, video and canvas tags may cause them to produce visual content outside of the element bounds. See https://github.com/WICG/shared-element-transitions/blob/main/debugging_overflow_on_images.md.",PaymentInstruments:"`paymentManager.instruments` is deprecated. Please use just-in-time install for payment handlers instead.",PaymentRequestCSPViolation:"Your `PaymentRequest` call bypassed Content-Security-Policy (CSP) `connect-src` directive. This bypass is deprecated. Please add the payment method identifier from the `PaymentRequest` API (in `supportedMethods` field) to your CSP `connect-src` directive.",PersistentQuotaType:"`StorageType.persistent` is deprecated. Please use standardized `navigator.storage` instead.",PictureSourceSrc:"`<source src>` with a `<picture>` parent is invalid and therefore ignored. Please use `<source srcset>` instead.",PrefixedCancelAnimationFrame:"webkitCancelAnimationFrame is vendor-specific. Please use the standard cancelAnimationFrame instead.",PrefixedRequestAnimationFrame:"webkitRequestAnimationFrame is vendor-specific. Please use the standard requestAnimationFrame instead.",PrefixedVideoDisplayingFullscreen:"HTMLVideoElement.webkitDisplayingFullscreen is deprecated. Please use Document.fullscreenElement instead.",PrefixedVideoEnterFullScreen:"HTMLVideoElement.webkitEnterFullScreen() is deprecated. Please use Element.requestFullscreen() instead.",PrefixedVideoEnterFullscreen:"HTMLVideoElement.webkitEnterFullscreen() is deprecated. Please use Element.requestFullscreen() instead.",PrefixedVideoExitFullScreen:"HTMLVideoElement.webkitExitFullScreen() is deprecated. Please use Document.exitFullscreen() instead.",PrefixedVideoExitFullscreen:"HTMLVideoElement.webkitExitFullscreen() is deprecated. Please use Document.exitFullscreen() instead.",PrefixedVideoSupportsFullscreen:"HTMLVideoElement.webkitSupportsFullscreen is deprecated. Please use Document.fullscreenEnabled instead.",PrivacySandboxExtensionsAPI:"We're deprecating the API `chrome.privacy.websites.privacySandboxEnabled`, though it will remain active for backward compatibility until release M113. Instead, please use `chrome.privacy.websites.topicsEnabled`, `chrome.privacy.websites.fledgeEnabled` and `chrome.privacy.websites.adMeasurementEnabled`. See https://developer.chrome.com/docs/extensions/reference/privacy/#property-websites-privacySandboxEnabled.",RangeExpand:"Range.expand() is deprecated. Please use Selection.modify() instead.",RequestedSubresourceWithEmbeddedCredentials:"Subresource requests whose URLs contain embedded credentials (e.g. `https://user:pass@host/`) are blocked.",RTCConstraintEnableDtlsSrtpFalse:"The constraint `DtlsSrtpKeyAgreement` is removed. You have specified a `false` value for this constraint, which is interpreted as an attempt to use the removed `SDES key negotiation` method. This functionality is removed; use a service that supports `DTLS key negotiation` instead.",RTCConstraintEnableDtlsSrtpTrue:"The constraint `DtlsSrtpKeyAgreement` is removed. You have specified a `true` value for this constraint, which had no effect, but you can remove this constraint for tidiness.",RTCPeerConnectionGetStatsLegacyNonCompliant:"The callback-based getStats() is deprecated and will be removed. Use the spec-compliant getStats() instead.",RtcpMuxPolicyNegotiate:"The `rtcpMuxPolicy` option is deprecated and will be removed.",SharedArrayBufferConstructedWithoutIsolation:"`SharedArrayBuffer` will require cross-origin isolation. See https://developer.chrome.com/blog/enabling-shared-array-buffer/ for more details.",TextToSpeech_DisallowedByAutoplay:"`speechSynthesis.speak()` without user activation is deprecated and will be removed.",V8SharedArrayBufferConstructedInExtensionWithoutIsolation:"Extensions should opt into cross-origin isolation to continue using `SharedArrayBuffer`. See https://developer.chrome.com/docs/extensions/mv3/cross-origin-isolation/.",WebSQL:"Web SQL is deprecated. Please use SQLite WebAssembly or Indexed Database",WindowPlacementPermissionDescriptorUsed:"The permission descriptor `window-placement` is deprecated. Use `window-management` instead. For more help, check https://bit.ly/window-placement-rename.",WindowPlacementPermissionPolicyParsed:"The permission policy `window-placement` is deprecated. Use `window-management` instead. For more help, check https://bit.ly/window-placement-rename.",XHRJSONEncodingDetection:"UTF-16 is not supported by response json in `XMLHttpRequest`",XMLHttpRequestSynchronousInNonWorkerOutsideBeforeUnload:"Synchronous `XMLHttpRequest` on the main thread is deprecated because of its detrimental effects to the end user's experience. For more help, check https://xhr.spec.whatwg.org/.",XRSupportsSession:"`supportsSession()` is deprecated. Please use `isSessionSupported()` and check the resolved boolean value instead."},vM={AuthorizationCoveredByWildcard:{milestone:97},CSSSelectorInternalMediaControlsOverlayCastButton:{chromeStatusFeature:5714245488476160},CanRequestURLHTTPContainingNewline:{chromeStatusFeature:5735596811091968},ChromeLoadTimesConnectionInfo:{chromeStatusFeature:5637885046816768},ChromeLoadTimesFirstPaintAfterLoadTime:{chromeStatusFeature:5637885046816768},ChromeLoadTimesWasAlternateProtocolAvailable:{chromeStatusFeature:5637885046816768},CookieWithTruncatingChar:{milestone:103},CrossOriginAccessBasedOnDocumentDomain:{milestone:115},DOMMutationEvents:{chromeStatusFeature:5083947249172480,milestone:127},DataUrlInSvgUse:{chromeStatusFeature:5128825141198848,milestone:119},DocumentDomainSettingWithoutOriginAgentClusterHeader:{milestone:115},ExpectCTHeader:{chromeStatusFeature:6244547273687040,milestone:107},IdentityInCanMakePaymentEvent:{chromeStatusFeature:5190978431352832},InsecurePrivateNetworkSubresourceRequest:{chromeStatusFeature:5436853517811712,milestone:92},LocalCSSFileExtensionRejected:{milestone:64},MediaSourceAbortRemove:{chromeStatusFeature:6107495151960064},MediaSourceDurationTruncatingBuffered:{chromeStatusFeature:6107495151960064},NoSysexWebMIDIWithoutPermission:{chromeStatusFeature:5138066234671104,milestone:82},NonStandardDeclarativeShadowDOM:{chromeStatusFeature:6239658726391808,milestone:119},NotificationPermissionRequestedIframe:{chromeStatusFeature:6451284559265792},ObsoleteCreateImageBitmapImageOrientationNone:{milestone:111},ObsoleteWebRtcCipherSuite:{milestone:81},OverflowVisibleOnReplacedElement:{chromeStatusFeature:5137515594383360,milestone:108},PaymentInstruments:{chromeStatusFeature:5099285054488576},PaymentRequestCSPViolation:{chromeStatusFeature:6286595631087616},PersistentQuotaType:{chromeStatusFeature:5176235376246784,milestone:106},RTCConstraintEnableDtlsSrtpFalse:{milestone:97},RTCConstraintEnableDtlsSrtpTrue:{milestone:97},RTCPeerConnectionGetStatsLegacyNonCompliant:{chromeStatusFeature:4631626228695040,milestone:117},RequestedSubresourceWithEmbeddedCredentials:{chromeStatusFeature:5669008342777856},RtcpMuxPolicyNegotiate:{chromeStatusFeature:5654810086866944,milestone:62},SharedArrayBufferConstructedWithoutIsolation:{milestone:106},TextToSpeech_DisallowedByAutoplay:{chromeStatusFeature:5687444770914304,milestone:71},V8SharedArrayBufferConstructedInExtensionWithoutIsolation:{milestone:96},WebSQL:{chromeStatusFeature:5134293578285056,milestone:115},WindowPlacementPermissionDescriptorUsed:{chromeStatusFeature:5137018030391296,milestone:112},WindowPlacementPermissionPolicyParsed:{chromeStatusFeature:5137018030391296,milestone:112},XHRJSONEncodingDetection:{milestone:93},XRSupportsSession:{milestone:80}}}));function DM(e){let t,a=e.type,n=yM[a];n&&(t=SM(n));let r=[],i=vM[a],o=i?.chromeStatusFeature??0;0!==o&&r.push({link:`https://chromestatus.com/feature/${o}`,linkTitle:TM(EM.feature)});let s=i?.milestone??0;return 0!==s&&r.push({link:"https://chromiumdash.appspot.com/schedule",linkTitle:TM(EM.milestone,{milestone:s})}),{substitutions:new Map([["PLACEHOLDER_title",TM(EM.title)],["PLACEHOLDER_message",t]]),links:r,message:t}}var EM,TM,SM,CM=s((()=>{J(),ro(),wM(),TM=eo("core/lib/deprecation-description.js",EM={feature:"Check the feature status page for more details.",milestone:"This change will go into effect with milestone {milestone}.",title:"Deprecated Feature Used"}),SM=eo("core/lib/deprecation-description.js",yM),o(DM,"getIssueDetailDescription")})),kM={};c(kM,{UIStrings:()=>xM,default:()=>RM});var xM,AM,_M,RM,FM=s((()=>{J(),xr(),YR(),ro(),CM(),AM=eo("core/audits/deprecations.js",xM={title:"Avoids deprecated APIs",failureTitle:"Uses deprecated APIs",description:"Deprecated APIs will eventually be removed from the browser. [Learn more about deprecated APIs](https://developer.chrome.com/docs/lighthouse/best-practices/deprecations/).",displayValue:"{itemCount, plural,\n    =1 {1 warning found}\n    other {# warnings found}\n    }",columnDeprecate:"Deprecation / Warning",columnLine:"Line"}),_M=class extends Dr{static{o(this,"Deprecations")}static get meta(){return{id:"deprecations",title:AM(xM.title),failureTitle:AM(xM.failureTitle),description:AM(xM.description),requiredArtifacts:["InspectorIssues","SourceMaps","Scripts"]}}static async audit(e,t){let a,n=await GR.request(e,t),r=e.InspectorIssues.deprecationIssue.map((e=>{let t,{scriptId:a,url:r,lineNumber:i,columnNumber:o}=e.sourceCodeLocation,s=n.find((e=>e.script.scriptId===a)),l=DM(e);l.links.length&&(t={type:"subitems",items:l.links.map((e=>({type:"link",url:e.link,text:e.linkTitle})))});let c=e.message;return{value:l.message||c||e.type,source:Dr.makeSourceLocation(r,i,o-1,s),subItems:t}})),i=[{key:"value",valueType:"text",label:AM(xM.columnDeprecate)},{key:"source",valueType:"source-location",label:AM(no.columnSource)}],o=Dr.makeTableDetails(i,r);return r.length>0&&(a=AM(xM.displayValue,{itemCount:r.length})),{score:+(0===r.length),displayValue:a,details:o}}},RM=_M})),NM={};c(NM,{default:()=>MM});var IM,MM,PM=s((()=>{J(),xr(),uR(),Yc(),Jc(),fb(),IM=class extends Dr{static{o(this,"Diagnostics")}static get meta(){return{id:"diagnostics",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:"Diagnostics",description:"Collection of useful page vitals.",supportedModes:["navigation"],requiredArtifacts:["URL","traces","devtoolsLogs"]}}static async audit(e,t){let a=e.traces[Dr.DEFAULT_PASS],n=e.devtoolsLogs[Dr.DEFAULT_PASS],r=await oR.request(a,t),i=await Pc.request(n,t),o=await Oc.request(n,t),s=await pb.request({devtoolsLog:n,URL:e.URL},t),l=r.filter((e=>!e.parent)),c=s.transferSize,u=i.reduce(((e,t)=>e+(t.transferSize||0)),0),d=l.reduce(((e,t)=>e+(t.duration||0)),0),m=Math.max(...o.additionalRttByOrigin.values())+o.rtt,p=Math.max(...o.serverResponseTimeByOrigin.values());return{score:1,details:{type:"debugdata",items:[{numRequests:i.length,numScripts:i.filter((e=>"Script"===e.resourceType)).length,numStylesheets:i.filter((e=>"Stylesheet"===e.resourceType)).length,numFonts:i.filter((e=>"Font"===e.resourceType)).length,numTasks:l.length,numTasksOver10ms:l.filter((e=>e.duration>10)).length,numTasksOver25ms:l.filter((e=>e.duration>25)).length,numTasksOver50ms:l.filter((e=>e.duration>50)).length,numTasksOver100ms:l.filter((e=>e.duration>100)).length,numTasksOver500ms:l.filter((e=>e.duration>500)).length,rtt:o.rtt,throughput:o.throughput,maxRtt:m,maxServerLatency:p,totalByteWeight:u,totalTaskTime:d,mainDocumentTransferSize:c}]}}}},MM=IM})),LM={};c(LM,{CHARSET_HTML_REGEX:()=>BM,CHARSET_HTTP_REGEX:()=>qM,IANA_REGEX:()=>UM,UIStrings:()=>OM,default:()=>VM});var OM,jM,UM,BM,qM,zM,VM,WM=s((()=>{J(),xr(),ro(),fb(),jM=eo("core/audits/dobetterweb/charset.js",OM={title:"Properly defines charset",failureTitle:"Charset declaration is missing or occurs too late in the HTML",description:"A character encoding declaration is required. It can be done with a `<meta>` tag in the first 1024 bytes of the HTML or in the Content-Type HTTP response header. [Learn more about declaring the character encoding](https://developer.chrome.com/docs/lighthouse/best-practices/charset/)."}),"content-type",UM=/^[a-zA-Z0-9-_:.()]{2,}$/,BM=/<meta[^>]+charset[^<]+>/i,qM=/charset\s*=\s*[a-zA-Z0-9-_:.()]{2,}/i,zM=class extends Dr{static{o(this,"CharsetDefined")}static get meta(){return{id:"charset",title:jM(OM.title),failureTitle:jM(OM.failureTitle),description:jM(OM.description),requiredArtifacts:["MainDocumentContent","URL","devtoolsLogs","MetaElements"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=await pb.request({devtoolsLog:a,URL:e.URL},t),r=!1;if(n.responseHeaders){let e=n.responseHeaders.find((e=>"content-type"===e.name.toLowerCase()));e&&(r=qM.test(e.value))}return r=r||65279===e.MainDocumentContent.charCodeAt(0),BM.test(e.MainDocumentContent.slice(0,1024))&&(r=r||e.MetaElements.some((e=>e.charset&&UM.test(e.charset)||"content-type"===e.httpEquiv&&e.content&&qM.test(e.content)))),{score:Number(r)}}},VM=zM})),HM={};c(HM,{UIStrings:()=>GM,default:()=>YM});var GM,$M,KM,YM,JM=s((()=>{J(),xr(),ro(),Hc(),$M=eo("core/audits/dobetterweb/doctype.js",GM={title:"Page has the HTML doctype",failureTitle:"Page lacks the HTML doctype, thus triggering quirks-mode",description:"Specifying a doctype prevents the browser from switching to quirks-mode. [Learn more about the doctype declaration](https://developer.chrome.com/docs/lighthouse/best-practices/doctype/).",explanationNoDoctype:"Document must contain a doctype",explanationWrongDoctype:"Document contains a `doctype` that triggers `quirks-mode`",explanationLimitedQuirks:"Document contains a `doctype` that triggers `limited-quirks-mode`",explanationPublicId:"Expected publicId to be an empty string",explanationSystemId:"Expected systemId to be an empty string",explanationBadDoctype:"Doctype name must be the string `html`"}),KM=class extends Dr{static{o(this,"Doctype")}static get meta(){return{id:"doctype",title:$M(GM.title),failureTitle:$M(GM.failureTitle),description:$M(GM.description),requiredArtifacts:["Doctype"],__internalOptionalArtifacts:["InspectorIssues","traces"]}}static async audit(e,t){if(!e.Doctype)return{score:0,explanation:$M(GM.explanationNoDoctype)};let a=e.Doctype.name,n=e.Doctype.publicId,r=e.Doctype.systemId,i=e.Doctype.documentCompatMode,o=e.traces?.[Dr.DEFAULT_PASS],s=[];if(o&&e.InspectorIssues){let a=(await kc.request(o,t)).mainFrameInfo.frameId;s=e.InspectorIssues.quirksModeIssue.filter((e=>e.frameId===a))}let l=s.some((e=>e.isLimitedQuirksMode));return"CSS1Compat"!==i||l?l?{score:0,explanation:$M(GM.explanationLimitedQuirks)}:""!==n?{score:0,explanation:$M(GM.explanationPublicId)}:""!==r?{score:0,explanation:$M(GM.explanationSystemId)}:"html"!==a?{score:0,explanation:$M(GM.explanationBadDoctype)}:{score:0,explanation:$M(GM.explanationWrongDoctype)}:{score:1}}},YM=KM})),ZM={};c(ZM,{UIStrings:()=>XM,default:()=>tP});var XM,QM,eP,tP,aP,nP,rP=s((()=>{J(),xr(),ro(),QM=eo("core/audits/dobetterweb/dom-size.js",XM={title:"Avoids an excessive DOM size",failureTitle:"Avoid an excessive DOM size",description:"A large DOM will increase memory usage, cause longer [style calculations](https://developers.google.com/web/fundamentals/performance/rendering/reduce-the-scope-and-complexity-of-style-calculations), and produce costly [layout reflows](https://developers.google.com/speed/articles/reflow). [Learn how to avoid an excessive DOM size](https://developer.chrome.com/docs/lighthouse/performance/dom-size/).",columnStatistic:"Statistic",columnValue:"Value",displayValue:"{itemCount, plural,\n    =1 {1 element}\n    other {# elements}\n    }",statisticDOMElements:"Total DOM Elements",statisticDOMDepth:"Maximum DOM Depth",statisticDOMWidth:"Maximum Child Elements"}),eP=class extends Dr{static{o(this,"DOMSize")}static get meta(){return{id:"dom-size",title:QM(XM.title),failureTitle:QM(XM.failureTitle),description:QM(XM.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["DOMStats"]}}static get defaultOptions(){return{p10:818,median:1400}}static audit(e,t){let a=e.DOMStats,n=Dr.computeLogNormalScore({p10:t.options.p10,median:t.options.median},a.totalBodyElements),r=[{key:"statistic",valueType:"text",label:QM(XM.columnStatistic)},{key:"node",valueType:"node",label:QM(no.columnElement)},{key:"value",valueType:"numeric",label:QM(XM.columnValue)}],i=[{statistic:QM(XM.statisticDOMElements),value:{type:"numeric",granularity:1,value:a.totalBodyElements}},{node:Dr.makeNodeItem(a.depth),statistic:QM(XM.statisticDOMDepth),value:{type:"numeric",granularity:1,value:a.depth.max}},{node:Dr.makeNodeItem(a.width),statistic:QM(XM.statisticDOMWidth),value:{type:"numeric",granularity:1,value:a.width.max}}];return{score:n,numericValue:a.totalBodyElements,numericUnit:"element",displayValue:QM(XM.displayValue,{itemCount:a.totalBodyElements}),details:Dr.makeTableDetails(r,i)}}},tP=eP})),iP=s((()=>{J(),xr(),YR(),aP=class extends Dr{static{o(this,"ViolationAudit")}static async getViolationResults(e,t,a){let n=await GR.request(e,t);function r(e){return void 0!==e}o(r,"filterUndefined");let i=new Set;return e.ConsoleMessages.filter((e=>e.url&&"violation"===e.source&&a.test(e.text))).map((e=>{let t=n.find((t=>t.script.scriptId===e.scriptId));return Dr.makeSourceLocationFromConsoleMessage(e,t)})).filter(r).filter((e=>{let t=`${e.url}!${e.line}!${e.column}`;return!i.has(t)&&(i.add(t),!0)})).map((e=>({source:e})))}},nP=aP})),oP={};c(oP,{UIStrings:()=>sP,default:()=>uP});var sP,lP,cP,uP,dP=s((()=>{J(),iP(),ro(),lP=eo("core/audits/dobetterweb/geolocation-on-start.js",sP={title:"Avoids requesting the geolocation permission on page load",failureTitle:"Requests the geolocation permission on page load",description:"Users are mistrustful of or confused by sites that request their location without context. Consider tying the request to a user action instead. [Learn more about the geolocation permission](https://developer.chrome.com/docs/lighthouse/best-practices/geolocation-on-start/)."}),cP=class extends nP{static{o(this,"GeolocationOnStart")}static get meta(){return{id:"geolocation-on-start",title:lP(sP.title),failureTitle:lP(sP.failureTitle),description:lP(sP.description),supportedModes:["navigation"],requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static async audit(e,t){let a=await nP.getViolationResults(e,t,/geolocation/),n=[{key:"source",valueType:"source-location",label:lP(no.columnSource)}],r=nP.makeTableDetails(n,a);return{score:+(0===a.length),details:r}}},uP=cP})),mP={};c(mP,{UIStrings:()=>pP,default:()=>fP});var pP,hP,gP,fP,yP=s((()=>{J(),xr(),ro(),hP=eo("core/audits/dobetterweb/inspector-issues.js",pP={title:"No issues in the `Issues` panel in Chrome Devtools",failureTitle:"Issues were logged in the `Issues` panel in Chrome Devtools",description:"Issues logged to the `Issues` panel in Chrome Devtools indicate unresolved problems. They can come from network request failures, insufficient security controls, and other browser concerns. Open up the Issues panel in Chrome DevTools for more details on each issue.",columnIssueType:"Issue type",issueTypeBlockedByResponse:"Blocked by cross-origin policy",issueTypeHeavyAds:"Heavy resource usage by ads"}),gP=class extends Dr{static{o(this,"IssuesPanelEntries")}static get meta(){return{id:"inspector-issues",title:hP(pP.title),failureTitle:hP(pP.failureTitle),description:hP(pP.description),requiredArtifacts:["InspectorIssues"]}}static getMixedContentRow(e){let t=new Set;for(let a of e){let e=a.request?.url||a.mainResourceURL;t.add(e)}return{issueType:"Mixed content",subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static getCookieRow(e){let t=new Set;for(let a of e){let e=a.request?.url||a.cookieUrl;e&&t.add(e)}return{issueType:"Cookie",subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static getBlockedByResponseRow(e){let t=new Set;for(let a of e){let e=a.request?.url;e&&t.add(e)}return{issueType:hP(pP.issueTypeBlockedByResponse),subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static getContentSecurityPolicyRow(e){let t=new Set;for(let a of e){let e=a.blockedURL;e&&t.add(e)}return{issueType:"Content security policy",subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static audit(e){let t=[{key:"issueType",valueType:"text",subItemsHeading:{key:"url",valueType:"url"},label:hP(pP.columnIssueType)}],a=e.InspectorIssues,n=[];a.mixedContentIssue.length&&n.push(this.getMixedContentRow(a.mixedContentIssue)),a.cookieIssue.length&&n.push(this.getCookieRow(a.cookieIssue)),a.blockedByResponseIssue.length&&n.push(this.getBlockedByResponseRow(a.blockedByResponseIssue)),a.heavyAdIssue.length&&n.push({issueType:hP(pP.issueTypeHeavyAds)});let r=a.contentSecurityPolicyIssue.filter((e=>"kTrustedTypesSinkViolation"!==e.contentSecurityPolicyViolationType&&"kTrustedTypesPolicyViolation"!==e.contentSecurityPolicyViolationType));return r.length&&n.push(this.getContentSecurityPolicyRow(r)),{score:n.length>0?0:1,details:Dr.makeTableDetails(t,n)}}},fP=gP})),vP={};c(vP,{UIStrings:()=>bP,default:()=>EP});var bP,wP,DP,EP,TP=s((()=>{J(),xr(),ro(),wP=eo("core/audits/dobetterweb/js-libraries.js",bP={title:"Detected JavaScript libraries",description:"All front-end JavaScript libraries detected on the page. [Learn more about this JavaScript library detection diagnostic audit](https://developer.chrome.com/docs/lighthouse/best-practices/js-libraries/).",columnVersion:"Version"}),DP=class extends Dr{static{o(this,"JsLibrariesAudit")}static get meta(){return{id:"js-libraries",title:wP(bP.title),scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,description:wP(bP.description),requiredArtifacts:["Stacks"]}}static audit(e){let t=e.Stacks.filter((e=>"js"===e.detector)).filter((e=>!e.id.endsWith("-fast"))).map((e=>({name:e.name,version:e.version,npm:e.npm}))),a=[{key:"name",valueType:"text",label:wP(no.columnName)},{key:"version",valueType:"text",label:wP(bP.columnVersion)}],n=Dr.makeTableDetails(a,t),r={type:"debugdata",stacks:e.Stacks.map((e=>({id:e.id,version:e.version})))};return t.length?{score:1,details:{...n,debugData:r}}:{score:null,notApplicable:!0}}},EP=DP})),SP={};c(SP,{UIStrings:()=>CP,default:()=>AP});var CP,kP,xP,AP,_P=s((()=>{J(),iP(),ro(),kP=eo("core/audits/dobetterweb/no-document-write.js",CP={title:"Avoids `document.write()`",failureTitle:"Avoid `document.write()`",description:"For users on slow connections, external scripts dynamically injected via `document.write()` can delay page load by tens of seconds. [Learn how to avoid document.write()](https://developer.chrome.com/docs/lighthouse/best-practices/no-document-write/)."}),xP=class extends nP{static{o(this,"NoDocWriteAudit")}static get meta(){return{id:"no-document-write",title:kP(CP.title),failureTitle:kP(CP.failureTitle),description:kP(CP.description),requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static async audit(e,t){let a=await nP.getViolationResults(e,t,/document\.write/),n=[{key:"source",valueType:"source-location",label:kP(no.columnSource)}],r=nP.makeTableDetails(n,a);return{score:+(0===a.length),details:r}}},AP=xP})),RP={};c(RP,{UIStrings:()=>FP,default:()=>MP});var FP,NP,IP,MP,PP=s((()=>{J(),iP(),ro(),NP=eo("core/audits/dobetterweb/notification-on-start.js",FP={title:"Avoids requesting the notification permission on page load",failureTitle:"Requests the notification permission on page load",description:"Users are mistrustful of or confused by sites that request to send notifications without context. Consider tying the request to user gestures instead. [Learn more about responsibly getting permission for notifications](https://developer.chrome.com/docs/lighthouse/best-practices/notification-on-start/)."}),IP=class extends nP{static{o(this,"NotificationOnStart")}static get meta(){return{id:"notification-on-start",title:NP(FP.title),failureTitle:NP(FP.failureTitle),description:NP(FP.description),supportedModes:["navigation"],requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static async audit(e,t){let a=await nP.getViolationResults(e,t,/notification permission/),n=[{key:"source",valueType:"source-location",label:NP(no.columnSource)}],r=nP.makeTableDetails(n,a);return{score:+(0===a.length),details:r}}},MP=IP})),LP={};c(LP,{UIStrings:()=>OP,default:()=>BP});var OP,jP,UP,BP,qP=s((()=>{J(),xr(),ro(),jP=eo("core/audits/dobetterweb/paste-preventing-inputs.js",OP={title:"Allows users to paste into input fields",failureTitle:"Prevents users from pasting into input fields",description:"Preventing input pasting is a bad practice for the UX, and weakens security by blocking password managers.[Learn more about user-friendly input fields](https://developer.chrome.com/docs/lighthouse/best-practices/paste-preventing-inputs/)."}),UP=class extends Dr{static{o(this,"PastePreventingInputsAudit")}static get meta(){return{id:"paste-preventing-inputs",title:jP(OP.title),failureTitle:jP(OP.failureTitle),description:jP(OP.description),requiredArtifacts:["Inputs"]}}static audit(e){let t=e.Inputs.inputs.filter((e=>e.preventsPaste)),a=[];t.forEach((e=>{a.push({node:Dr.makeNodeItem(e.node),type:e.type})}));let n=[{key:"node",valueType:"node",label:jP(no.columnFailingElem)}];return{score:+(0===t.length),details:Dr.makeTableDetails(n,a)}}},BP=UP})),zP={};c(zP,{UIStrings:()=>VP,default:()=>$P});var VP,WP,HP,GP,$P,KP=s((()=>{J(),xr(),Uu(),ql(),zR(),UR(),qc(),Yc(),Zc(),$c(),BR(),OR(),ro(),WP=eo("core/audits/dobetterweb/uses-http2.js",VP={title:"Use HTTP/2",description:"HTTP/2 offers many benefits over HTTP/1.1, including binary headers and multiplexing. [Learn more about HTTP/2](https://developer.chrome.com/docs/lighthouse/best-practices/uses-http2/).",displayValue:"{itemCount, plural,\n    =1 {1 request not served via HTTP/2}\n    other {# requests not served via HTTP/2}\n    }",columnProtocol:"Protocol"}),HP=new Set([wc.TYPES.Document,wc.TYPES.Font,wc.TYPES.Image,wc.TYPES.Stylesheet,wc.TYPES.Script,wc.TYPES.Media]),GP=class e extends Dr{static{o(this,"UsesHTTP2Audit")}static get meta(){return{id:"uses-http2",title:WP(VP.title),description:WP(VP.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["timespan","navigation"],requiredArtifacts:["URL","devtoolsLogs","traces","GatherContext"]}}static computeWasteWithGraph(e,t,a,n){n=Object.assign({label:""},n);let r=`${this.meta.id}-${n.label}-before`,i=`${this.meta.id}-${n.label}-after`,o=new Set(e.map((e=>e.url))),s=a.simulate(t,{label:r,flexibleOrdering:true}),l=new Map;t.traverse((e=>{"network"===e.type&&o.has(e.record.url)&&(l.set(e.record.requestId,e.record.protocol),e.record.protocol="h2")}));let c=a.simulate(t,{label:i,flexibleOrdering:true});t.traverse((e=>{if("network"!==e.type)return;let t=l.get(e.record.requestId);void 0!==t&&(e.record.protocol=t)}));let u=s.timeInMs-c.timeInMs;return{savings:10*Math.round(Math.max(u,0)/10),simulationBefore:s,simulationAfter:c}}static computeWasteWithTTIGraph(e,t,a){let{savings:n,simulationBefore:r,simulationAfter:i}=this.computeWasteWithGraph(e,t,a,{label:"tti"}),o=AR.getLastLongTaskEndTime(r.nodeTimings)-AR.getLastLongTaskEndTime(i.nodeTimings),s=Math.max(o,n);return 10*Math.round(Math.max(s,0)/10)}static isStaticAsset(e,t){if(!HP.has(e.resourceType))return!1;if(e.resourceSize<100){let a=t.entityByUrl.get(e.url);if(a&&!a.isUnrecognized)return!1}return!0}static determineNonHttp2Resources(t,a){let n=[],r=new Set,i=new Map;for(let n of t){if(!e.isStaticAsset(n,a)||Ml.isLikeLocalhost(n.parsedURL.host))continue;let t=i.get(n.parsedURL.securityOrigin)||[];t.push(n),i.set(n.parsedURL.securityOrigin,t)}for(let e of t)r.has(e.url)||e.fetchedViaServiceWorker||!/HTTP\/[01][.\d]?/i.test(e.protocol)||(i.get(e.parsedURL.securityOrigin)||[]).length<6||(r.add(e.url),n.push({protocol:e.protocol,url:e.url}));return n}static async audit(t,a){let n,r=t.traces[Dr.DEFAULT_PASS],i=t.devtoolsLogs[Dr.DEFAULT_PASS],o=t.URL,s=await Pc.request(i,a),l=await Pu.request({URL:o,devtoolsLog:i},a),c=e.determineNonHttp2Resources(s,l);if(c.length>0&&(n=WP(VP.displayValue,{itemCount:c.length})),"timespan"===t.GatherContext.gatherMode){let e=[{key:"url",valueType:"url",label:WP(no.columnURL)},{key:"protocol",valueType:"text",label:WP(VP.columnProtocol)}],t=Dr.makeTableDetails(e,c);return{displayValue:n,score:c.length?0:1,details:t}}let u={devtoolsLog:i,settings:a?.settings||{}},d=await Fc.request({trace:r,devtoolsLog:i,URL:o},a),m=await Uc.request(u,a),p=Dr.makeMetricComputationDataInput(t,a),{pessimisticGraph:h}=await SR.request(p,a),{pessimisticGraph:g}=await RR.request(p,a),f=e.computeWasteWithTTIGraph(c,d,m),y=e.computeWasteWithGraph(c,h,m,{label:"fcp"}),v=e.computeWasteWithGraph(c,g,m,{label:"lcp"}),b=[{key:"url",valueType:"url",label:WP(no.columnURL)},{key:"protocol",valueType:"text",label:WP(VP.columnProtocol)}],w=Dr.makeOpportunityDetails(b,c,{overallSavingsMs:f});return{displayValue:n,numericValue:f,numericUnit:"millisecond",score:MR.scoreForWastedMs(f),details:w,metricSavings:{LCP:v.savings,FCP:y.savings}}}},$P=GP})),YP={};c(YP,{UIStrings:()=>JP,default:()=>QP});var JP,ZP,XP,QP,eL=s((()=>{J(),iP(),ro(),ZP=eo("core/audits/dobetterweb/uses-passive-event-listeners.js",JP={title:"Uses passive listeners to improve scrolling performance",failureTitle:"Does not use passive listeners to improve scrolling performance",description:"Consider marking your touch and wheel event listeners as `passive` to improve your page's scroll performance. [Learn more about adopting passive event listeners](https://developer.chrome.com/docs/lighthouse/best-practices/uses-passive-event-listeners/)."}),XP=class extends nP{static{o(this,"PassiveEventsAudit")}static get meta(){return{id:"uses-passive-event-listeners",title:ZP(JP.title),failureTitle:ZP(JP.failureTitle),description:ZP(JP.description),requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static async audit(e,t){let a=await nP.getViolationResults(e,t,/passive event listener/),n=[{key:"source",valueType:"source-location",label:ZP(no.columnSource)}],r=nP.makeTableDetails(n,a);return{score:+(0===a.length),details:r}}},QP=XP})),tL={};c(tL,{UIStrings:()=>aL,default:()=>iL});var aL,nL,rL,iL,oL,sL,lL=s((()=>{J(),ea(),xr(),YR(),ro(),nL=eo("core/audits/errors-in-console.js",aL={title:"No browser errors logged to the console",failureTitle:"Browser errors were logged to the console",description:"Errors logged to the console indicate unresolved problems. They can come from network request failures and other browser concerns. [Learn more about this errors in console diagnostic audit](https://developer.chrome.com/docs/lighthouse/best-practices/errors-in-console/)"}),rL=class e extends Dr{static{o(this,"ErrorLogs")}static get meta(){return{id:"errors-in-console",title:nL(aL.title),failureTitle:nL(aL.failureTitle),description:nL(aL.description),requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static get defaultOptions(){return{ignoredPatterns:["ERR_BLOCKED_BY_CLIENT.Inspector"]}}static filterAccordingToOptions(e,t){let{ignoredPatterns:a,...n}=t,r=Object.keys(n);return r.length&&Kt.warn(this.meta.id,"Unrecognized options",r),a?e.filter((({description:e})=>{if(!e)return!0;for(let t of a)if(t instanceof RegExp&&t.test(e)||"string"==typeof t&&e.includes(t))return!1;return!0})):e}static async audit(t,a){let n=a.options,r=await GR.request(t,a),i=t.ConsoleMessages.filter((e=>"error"===e.level)).map((e=>{let t=r.find((t=>t.script.scriptId===e.scriptId));return{source:e.source,description:e.text,sourceLocation:Dr.makeSourceLocationFromConsoleMessage(e,t)}})),o=e.filterAccordingToOptions(i,n).sort(((e,t)=>(e.description||"").localeCompare(t.description||""))),s=[{key:"sourceLocation",valueType:"source-location",label:nL(no.columnSource)},{key:"description",valueType:"code",label:nL(no.columnDescription)}],l=Dr.makeTableDetails(s,o);return{score:+(0===o.length),details:l}}},iL=rL})),cL=s((()=>{J(),Bc(),"Screenshot",oL=class{static{o(this,"Screenshots")}static async compute_(e){return e.traceEvents.filter((e=>"Screenshot"===e.name)).map((e=>({timestamp:e.ts,datauri:`data:image/jpeg;base64,${e.args.snapshot}`})))}},sL=dc(oL,null)})),uL={};c(uL,{default:()=>mL});var dL,mL,pL=s((()=>{J(),xr(),xl(),Hc(),cL(),dL=class extends Dr{static{o(this,"FinalScreenshot")}static get meta(){return{id:"final-screenshot",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:"Final Screenshot",description:"The last screenshot captured of the pageload.",requiredArtifacts:["traces","GatherContext"]}}static async audit(e,t){let a=e.traces[Dr.DEFAULT_PASS],n=await kc.request(a,t),r=await sL.request(a,t),{timeOrigin:i}=n.timestamps,o=r[r.length-1];if(!o){if("timespan"===e.GatherContext.gatherMode)return{notApplicable:!0,score:1};throw new El(El.errors.NO_SCREENSHOTS)}return{score:1,details:{type:"screenshot",timing:Math.round((o.timestamp-i)/1e3),timestamp:o.timestamp,data:o.datauri}}}},mL=dL})),hL={};c(hL,{UIStrings:()=>vL,default:()=>DL});var gL,fL,yL,vL,bL,wL,DL,EL=s((()=>{J(),xr(),ql(),ro(),Du(),Yc(),gL=/^(block|fallback|optional|swap)$/,fL=/url\((.*?)\)/,yL=new RegExp(fL,"g"),bL=eo("core/audits/font-display.js",vL={title:"All text remains visible during webfont loads",failureTitle:"Ensure text remains visible during webfont load",description:"Leverage the `font-display` CSS feature to ensure text is user-visible while webfonts are loading. [Learn more about `font-display`](https://developer.chrome.com/docs/lighthouse/performance/font-display/).",undeclaredFontOriginWarning:"{fontCountForOrigin, plural, =1 {Lighthouse was unable to automatically check the `font-display` value for the origin {fontOrigin}.} other {Lighthouse was unable to automatically check the `font-display` values for the origin {fontOrigin}.}}"}),wL=class e extends Dr{static{o(this,"FontDisplay")}static get meta(){return{id:"font-display",title:bL(vL.title),failureTitle:bL(vL.failureTitle),description:bL(vL.description),supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","CSSUsage","URL"]}}static findFontDisplayDeclarations(e,t){let a=new Set,n=new Set;for(let r of e.CSSUsage.stylesheets){let i=r.content.replace(/(\r|\n)+/g," ").match(/@font-face\s*{(.*?)}/g)||[];for(let o of i){let i=o.match(yL);if(!i)continue;let s=o.match(/font-display\s*:\s*(\w+)\s*(;|\})/)?.[1]||"",l=t.test(s)?a:n,c=i.map((e=>e.match(fL)[1].trim())).map((e=>/^('|").*\1$/.test(e)?e.substr(1,e.length-2):e));for(let t of c)try{let a=Ml.isValid(r.header.sourceURL)?r.header.sourceURL:e.URL.finalDisplayedUrl,n=new URL(t,a);l.add(n.href)}catch(e){vu.captureException(e,{tags:{audit:this.meta.id}})}}}return{passingURLs:a,failingURLs:n}}static getWarningsForFontUrls(e){let t=new Map;for(let a of e){let e=Ml.getOrigin(a);if(!e)continue;let n=t.get(e)||0;t.set(e,n+1)}return[...t].map((([e,t])=>bL(vL.undeclaredFontOriginWarning,{fontCountForOrigin:t,fontOrigin:e})))}static async audit(t,a){let n=t.devtoolsLogs[this.DEFAULT_PASS],r=await Pc.request(n,a),{passingURLs:i,failingURLs:o}=e.findFontDisplayDeclarations(t,gL),s=[],l=r.filter((e=>"Font"===e.resourceType)).filter((e=>!/^data:/.test(e.url))).filter((e=>!/^blob:/.test(e.url))).filter((e=>!!o.has(e.url)||(i.has(e.url)||s.push(e.url),!1))).map((e=>{let t=Math.min(e.networkEndTime-e.networkRequestTime,3e3);return{url:e.url,wastedMs:t}})),c=[{key:"url",valueType:"url",label:bL(no.columnURL)},{key:"wastedMs",valueType:"ms",label:bL(no.columnWastedMs)}],u=Dr.makeTableDetails(c,l);return{score:+(0===l.length),details:u,warnings:e.getWarningsForFontUrls(s)}}},DL=wL})),TL={};c(TL,{UIStrings:()=>SL,default:()=>xL});var SL,CL,kL,xL,AL=s((()=>{J(),xr(),ql(),ro(),CL=eo("core/audits/image-aspect-ratio.js",SL={title:"Displays images with correct aspect ratio",failureTitle:"Displays images with incorrect aspect ratio",description:"Image display dimensions should match natural aspect ratio. [Learn more about image aspect ratio](https://developer.chrome.com/docs/lighthouse/best-practices/image-aspect-ratio/).",columnDisplayed:"Aspect Ratio (Displayed)",columnActual:"Aspect Ratio (Actual)"}),2,kL=class e extends Dr{static{o(this,"ImageAspectRatio")}static get meta(){return{id:"image-aspect-ratio",title:CL(SL.title),failureTitle:CL(SL.failureTitle),description:CL(SL.description),requiredArtifacts:["ImageElements"]}}static computeAspectRatios(e){let t=Ml.elideDataURI(e.src),a=e.naturalDimensions.width/e.naturalDimensions.height,n=e.displayedWidth/e.displayedHeight,r=e.displayedWidth/a,i=Math.abs(r-e.displayedHeight)<2;return{url:t,node:Dr.makeNodeItem(e.node),displayedAspectRatio:`${e.displayedWidth} x ${e.displayedHeight}\n        (${n.toFixed(2)})`,actualAspectRatio:`${e.naturalDimensions.width} x ${e.naturalDimensions.height}\n        (${a.toFixed(2)})`,doRatiosMatch:i}}static audit(t){let a=t.ImageElements,n=[];a.filter((e=>!e.isCss&&"image/svg+xml"!==Ml.guessMimeType(e.src)&&e.naturalDimensions&&e.naturalDimensions.height>5&&e.naturalDimensions.width>5&&e.displayedWidth&&e.displayedHeight&&"fill"===e.computedStyles.objectFit)).forEach((t=>{let a=t,r=e.computeAspectRatios(a);r.doRatiosMatch||n.push(r)}));let r=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:CL(no.columnURL)},{key:"displayedAspectRatio",valueType:"text",label:CL(SL.columnDisplayed)},{key:"actualAspectRatio",valueType:"text",label:CL(SL.columnActual)}];return{score:+(0===n.length),details:Dr.makeTableDetails(r,n)}}},xL=kL})),_L={};function RL(e,t){return(e.bottom-e.top)*(e.right-e.left)>0&&e.top<=t.innerHeight&&e.bottom>=0&&e.left<=t.innerWidth&&e.right>=0}function FL(e,t){return e.bottom-e.top<=t.innerHeight&&e.right-e.left<=t.innerWidth}function NL(e){return!(e.displayedWidth<=1||e.displayedHeight<=1||!e.naturalDimensions||!e.naturalDimensions.width||!e.naturalDimensions.height||"image/svg+xml"===Ml.guessMimeType(e.src)||e.isCss||"fill"!==e.computedStyles.objectFit||["pixelated","crisp-edges"].includes(e.computedStyles.imageRendering)||/ \d+(\.\d+)?x/.test(e.srcset))}function IL(e){return!!e.naturalDimensions}function ML(e,t){let[a,n]=LL(e.displayedWidth,e.displayedHeight,t);return e.naturalDimensions.width>=a&&e.naturalDimensions.height>=n}function PL(e,t){let[a,n]=OL(e.displayedWidth,e.displayedHeight,t);return{url:Ml.elideDataURI(e.src),node:Dr.makeNodeItem(e.node),displayedSize:`${e.displayedWidth} x ${e.displayedHeight}`,actualSize:`${e.naturalDimensions.width} x ${e.naturalDimensions.height}`,actualPixels:e.naturalDimensions.width*e.naturalDimensions.height,expectedSize:`${a} x ${n}`,expectedPixels:a*n}}function LL(e,t,a){let n=VL;(e>HL||t>HL)&&(n=WL);let r=BL(a);return[Math.ceil(n*r*e),Math.ceil(n*r*t)]}function OL(e,t,a){return[Math.ceil(BL(a)*e),Math.ceil(BL(a)*t)]}function jL(e){e.sort(((e,t)=>e.url===t.url?0:e.url<t.url?-1:1));let t=[];for(let a of e){let e=t[t.length-1];e&&e.url===a.url?e.expectedPixels<a.expectedPixels&&(t[t.length-1]=a):t.push(a)}return t}function UL(e){return e.sort(((e,t)=>t.expectedPixels-t.actualPixels-(e.expectedPixels-e.actualPixels)))}function BL(e){return e>=2?2:e>=1.5?1.5:1}c(_L,{UIStrings:()=>qL,default:()=>$L});var qL,zL,VL,WL,HL,GL,$L,KL=s((()=>{J(),xr(),ql(),ro(),zL=eo("core/audits/image-size-responsive.js",qL={title:"Serves images with appropriate resolution",failureTitle:"Serves images with low resolution",description:"Image natural dimensions should be proportional to the display size and the pixel ratio to maximize image clarity. [Learn how to provide responsive images](https://web.dev/serve-responsive-images/).",columnDisplayed:"Displayed size",columnActual:"Actual size",columnExpected:"Expected size"}),VL=1,WL=.75,HL=64,o(RL,"isVisible"),o(FL,"isSmallerThanViewport"),o(NL,"isCandidate"),o(IL,"imageHasNaturalDimensions"),o(ML,"imageHasRightSize"),o(PL,"getResult"),o(LL,"allowedImageSize"),o(OL,"expectedImageSize"),o(jL,"deduplicateResultsByUrl"),o(UL,"sortResultsBySizeDelta"),GL=class extends Dr{static{o(this,"ImageSizeResponsive")}static get meta(){return{id:"image-size-responsive",title:zL(qL.title),failureTitle:zL(qL.failureTitle),description:zL(qL.description),requiredArtifacts:["ImageElements","ViewportDimensions"]}}static audit(e){let t=e.ViewportDimensions.devicePixelRatio,a=Array.from(e.ImageElements).filter(NL).filter(IL).filter((e=>!ML(e,t))).filter((t=>RL(t.clientRect,e.ViewportDimensions))).filter((t=>FL(t.clientRect,e.ViewportDimensions))).map((e=>PL(e,t))),n=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:zL(no.columnURL)},{key:"displayedSize",valueType:"text",label:zL(qL.columnDisplayed)},{key:"actualSize",valueType:"text",label:zL(qL.columnActual)},{key:"expectedSize",valueType:"text",label:zL(qL.columnExpected)}],r=UL(jL(a));return{score:+(0===a.length),details:Dr.makeTableDetails(n,r)}}},o(BL,"quantizeDpr"),$L=GL}));function YL(e){return!(!e||!e.icons||0===e.icons.value.length)}function JL(e,t){let a=t.icons.value,n=[];return a.filter((e=>{let t=e.value.type.value;if(t)return"image/png"===t;let a=e.value.src.value;return a&&new URL(a).pathname.endsWith(".png")})).forEach((e=>{e.value.sizes.value&&n.push(...e.value.sizes.value)})),n.filter((e=>/\d+x\d+/.test(e))).filter((t=>{let a=t.split(/x/i),n=[parseFloat(a[0]),parseFloat(a[1])];return n[0]>=e&&n[1]>=e&&n[0]===n[1]}))}function ZL(e){return e.icons.value.some((e=>e.value.purpose?.value&&e.value.purpose.value.includes("maskable")))}var XL,QL,eO,tO=s((()=>{J(),o(YL,"doExist"),o(JL,"pngSizedAtLeast"),o(ZL,"containsMaskableIcon")})),aO=s((()=>{J(),Bc(),tO(),XL=["minimal-ui","fullscreen","standalone"],12,QL=class e{static{o(this,"ManifestValues")}static get manifestChecks(){return[{id:"hasStartUrl",failureText:"Manifest does not contain a `start_url`",validate:e=>!!e.start_url.value},{id:"hasIconsAtLeast144px",failureText:"Manifest does not have a PNG icon of at least 144px",validate:e=>YL(e)&&JL(144,e).length>0},{id:"hasIconsAtLeast512px",failureText:"Manifest does not have a PNG icon of at least 512px",validate:e=>YL(e)&&JL(512,e).length>0},{id:"fetchesIcon",failureText:"Manifest icon failed to be fetched",validate:(e,t)=>{let a=["cannot-download-icon","no-icon-available"];return YL(e)&&!t.some((e=>a.includes(e.errorId)))}},{id:"hasPWADisplayValue",failureText:"Manifest's `display` value is not one of: "+XL.join(" | "),validate:e=>XL.includes(e.display.value)},{id:"hasBackgroundColor",failureText:"Manifest does not have `background_color`",validate:e=>!!e.background_color.value},{id:"hasThemeColor",failureText:"Manifest does not have `theme_color`",validate:e=>!!e.theme_color.value},{id:"hasShortName",failureText:"Manifest does not have `short_name`",validate:e=>!!e.short_name.value},{id:"shortNameLength",failureText:"Manifest's `short_name` is too long (>12 characters) to be displayed on a homescreen without truncation",validate:e=>!!e.short_name.value&&e.short_name.value.length<=12},{id:"hasName",failureText:"Manifest does not have `name`",validate:e=>!!e.name.value},{id:"hasMaskableIcon",failureText:"Manifest does not have at least one icon that is maskable",validate:e=>YL(e)&&ZL(e)}]}static async compute_({WebAppManifest:t,InstallabilityErrors:a}){if(null===t)return{isParseFailure:!0,parseFailureReason:"No manifest was fetched",allChecks:[]};let n=t.value;return void 0===n?{isParseFailure:!0,parseFailureReason:"Manifest failed to parse as valid JSON",allChecks:[]}:{isParseFailure:!1,allChecks:e.manifestChecks.map((e=>({id:e.id,failureText:e.failureText,passing:e.validate(n,a.errors)})))}}},eO=dc(QL,["InstallabilityErrors","WebAppManifest"])})),nO={};c(nO,{UIStrings:()=>rO,default:()=>sO});var rO,iO,oO,sO,lO=s((()=>{J(),xr(),ro(),aO(),iO=eo("core/audits/installable-manifest.js",rO={title:"Web app manifest and service worker meet the installability requirements",failureTitle:"Web app manifest or service worker do not meet the installability requirements",description:"Service worker is the technology that enables your app to use many Progressive Web App features, such as offline, add to homescreen, and push notifications. With proper service worker and manifest implementations, browsers can proactively prompt users to add your app to their homescreen, which can lead to higher engagement. [Learn more about manifest installability requirements](https://developer.chrome.com/docs/lighthouse/pwa/installable-manifest/).",columnValue:"Failure reason",displayValue:"{itemCount, plural,\n    =1 {1 reason}\n    other {# reasons}\n    }",noErrorId:"Installability error id '{errorId}' is not recognized","not-in-main-frame":"Page is not loaded in the main frame","not-from-secure-origin":"Page is not served from a secure origin","no-manifest":"Page has no manifest <link> URL","start-url-not-valid":"Manifest start URL is not valid","manifest-missing-name-or-short-name":"Manifest does not contain a 'name' or 'short_name' field","manifest-display-not-supported":"Manifest 'display' property must be one of 'standalone', 'fullscreen', or 'minimal-ui'","manifest-empty":"Manifest could not be fetched, is empty, or could not be parsed","manifest-missing-suitable-icon":'Manifest does not contain a suitable icon - PNG, SVG or WebP format of at least {value0} px is required, the sizes attribute must be set, and the purpose attribute, if set, must include "any".',"no-acceptable-icon":'No supplied icon is at least {value0} px square in PNG, SVG or WebP format, with the purpose attribute unset or set to "any"',"cannot-download-icon":"Could not download a required icon from the manifest","no-icon-available":"Downloaded icon was empty or corrupted","platform-not-supported-on-android":"The specified application platform is not supported on Android","no-id-specified":"No Play store ID provided","ids-do-not-match":"The Play Store app URL and Play Store ID do not match","already-installed":"The app is already installed","url-not-supported-for-webapk":"A URL in the manifest contains a username, password, or port","in-incognito":"Page is loaded in an incognito window","not-offline-capable":"Page does not work offline","no-url-for-service-worker":"Could not check service worker without a 'start_url' field in the manifest","prefer-related-applications":"Manifest specifies prefer_related_applications: true","prefer-related-applications-only-beta-stable":"prefer_related_applications is only supported on Chrome Beta and Stable channels on Android.","manifest-display-override-not-supported":"Manifest contains 'display_override' field, and the first supported display mode must be one of 'standalone', 'fullscreen', or 'minimal-ui'","manifest-location-changed":"Manifest URL changed while the manifest was being fetched.","warn-not-offline-capable":"Page does not work offline. The page will not be regarded as installable after Chrome 93, stable release August 2021.","protocol-timeout":"Lighthouse could not determine if the page is installable. Please try with a newer version of Chrome.","pipeline-restarted":"PWA has been uninstalled and installability checks resetting.","scheme-not-supported-for-webapk":"The manifest URL scheme ({scheme}) is not supported on Android."}),oO=class e extends Dr{static{o(this,"InstallableManifest")}static get meta(){return{id:"installable-manifest",title:iO(rO.title),failureTitle:iO(rO.failureTitle),description:iO(rO.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static getInstallabilityErrors(e){let t=e.InstallabilityErrors.errors,a=[],n=[],r=/{([^}]+)}/g;for(let i of t){if("in-incognito"===i.errorId)continue;if("warn-not-offline-capable"===i.errorId){n.push(iO(rO[i.errorId]));continue}if("pipeline-restarted"===i.errorId)continue;let t=rO[i.errorId];if("scheme-not-supported-for-webapk"===i.errorId){let n=e.WebAppManifest?.url;if(!n)continue;let r=new URL(n).protocol;a.push(iO(t,{scheme:r}));continue}if(void 0===t){a.push(iO(rO.noErrorId,{errorId:i.errorId}));continue}let o=t.match(r)||[],s=i.errorArguments?.length&&i.errorArguments[0].value;if(t&&i.errorArguments.length!==o.length){let e=JSON.stringify(i.errorArguments),t=i.errorArguments.length>o.length?`${i.errorId} has unexpected arguments ${e}`:`${i.errorId} does not have the expected number of arguments.`;a.push(t)}else t&&s?a.push(iO(t,{value0:s})):t&&a.push(iO(t))}return{i18nErrors:a,warnings:n}}static async audit(t,a){let{i18nErrors:n,warnings:r}=e.getInstallabilityErrors(t),i=t.WebAppManifest?t.WebAppManifest.url:null,o=[{key:"reason",valueType:"text",label:iO(rO.columnValue)}],s=n.map((e=>({reason:e})));if(!s.length){let e=await eO.request(t,a);e.isParseFailure&&s.push({reason:e.parseFailureReason})}let l={type:"debugdata",manifestUrl:i};return s.length>0?{score:0,warnings:r,numericValue:s.length,numericUnit:"element",displayValue:iO(rO.displayValue,{itemCount:s.length}),details:{...Dr.makeTableDetails(o,s),debugData:l}}:{score:1,warnings:r,details:{...Dr.makeTableDetails(o,s),debugData:l}}}},sO=oO})),cO={};c(cO,{UIStrings:()=>uO,default:()=>hO});var uO,dO,mO,pO,hO,gO,fO,yO,vO,bO,wO,DO=s((()=>{J(),xr(),ql(),qc(),Yc(),ro(),dO={MixedContentAutomaticallyUpgraded:(uO={title:"Uses HTTPS",failureTitle:"Does not use HTTPS",description:"All sites should be protected with HTTPS, even ones that don't handle sensitive data. This includes avoiding [mixed content](https://developers.google.com/web/fundamentals/security/prevent-mixed-content/what-is-mixed-content), where some resources are loaded over HTTP despite the initial request being served over HTTPS. HTTPS prevents intruders from tampering with or passively listening in on the communications between your app and your users, and is a prerequisite for HTTP/2 and many new web platform APIs. [Learn more about HTTPS](https://developer.chrome.com/docs/lighthouse/pwa/is-on-https/).",displayValue:"{itemCount, plural,\n    =1 {1 insecure request found}\n    other {# insecure requests found}\n    }",columnInsecureURL:"Insecure URL",columnResolution:"Request Resolution",allowed:"Allowed",blocked:"Blocked",warning:"Allowed with warning",upgraded:"Automatically upgraded to HTTPS"}).upgraded,MixedContentBlocked:uO.blocked,MixedContentWarning:uO.warning},mO=eo("core/audits/is-on-https.js",uO),pO=class extends Dr{static{o(this,"HTTPS")}static get meta(){return{id:"is-on-https",title:mO(uO.title),failureTitle:mO(uO.failureTitle),description:mO(uO.description),requiredArtifacts:["devtoolsLogs","InspectorIssues"]}}static async audit(e,t){let a,n=e.devtoolsLogs[Dr.DEFAULT_PASS],r=(await Pc.request(n,t)).filter((e=>!wc.isSecureRequest(e))).map((e=>Ml.elideDataURI(e.url))),i=Array.from(new Set(r)).map((e=>({url:e,resolution:void 0}))),o=[{key:"url",valueType:"url",label:mO(uO.columnInsecureURL)},{key:"resolution",valueType:"text",label:mO(uO.columnResolution)}];for(let t of e.InspectorIssues.mixedContentIssue){let e=i.find((e=>e.url===t.insecureURL));e||(e={url:t.insecureURL},i.push(e)),e.resolution=dO[t.resolutionStatus]?mO(dO[t.resolutionStatus]):t.resolutionStatus}for(let e of i)e.resolution||(e.resolution=mO(uO.allowed));return i.length>0&&(a=mO(uO.displayValue,{itemCount:i.length})),{score:+(0===i.length),displayValue:a,details:Dr.makeTableDetails(o,i)}}},hO=pO})),EO=s((()=>{J(),Bc(),MF(),xl(),BR(),gO=class extends AF{static{o(this,"LargestContentfulPaint")}static computeSimulatedMetric(e,t){let a=AF.getMetricComputationInput(e);return RR.request(a,t)}static async computeObservedMetric(e){let{processedNavigation:t}=e;if(void 0===t.timings.largestContentfulPaint)throw new El(El.errors.NO_LCP);return{timing:t.timings.largestContentfulPaint,timestamp:t.timestamps.largestContentfulPaint}}},fO=dc(gO,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),TO=s((()=>{J(),Bc(),MF(),fb(),Jc(),yO=class extends AF{static{o(this,"TimeToFirstByte")}static async computeSimulatedMetric(e,t){let a=await pb.request(e,t),n=await Oc.request(e.devtoolsLog,t),r=(await this.computeObservedMetric(e,t)).timing,i=n.serverResponseTimeByOrigin.get(a.parsedURL.securityOrigin);if(void 0===i)throw new Error("No response time for origin");let o=2;a.protocol.startsWith("h3")||(o+=1),"https"===a.parsedURL.scheme&&(o+=1);let s=e.settings.throttling.rttMs*o+i;return{timing:Math.max(r,s)}}static async computeObservedMetric(e,t){let a=await pb.request(e,t);if(!a.timing)throw new Error("missing timing for main resource");let{processedNavigation:n}=e,r=n.timestamps.timeOrigin,i=1e3*(1e3*a.timing.requestTime+a.timing.receiveHeadersStart);return{timing:(i-r)/1e3,timestamp:i}}},vO=dc(yO,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),SO=s((()=>{J(),Bc(),xl(),EO(),yD(),TO(),qR(),bO=class{static{o(this,"LCPBreakdown")}static async compute_(e,t){let a=await lD.request(e.trace,t),n=a.timings.largestContentfulPaint;if(void 0===n)throw new El(El.errors.NO_LCP);let r=a.timestamps.timeOrigin/1e3,{timing:i}=await vO.request(e,t),o=await NR.request(e,t);if(!o)return{ttfb:i};let{timing:s}=await fO.request(e,t),l=s/n,c=(o.networkRequestTime-r)*l,u=Math.max(i,Math.min(c,s)),d=(o.networkEndTime-r)*l;return{ttfb:i,loadStart:u,loadEnd:Math.max(u,Math.min(d,s))}}},wO=dc(bO,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),CO={};c(CO,{UIStrings:()=>kO,default:()=>_O});var kO,xO,AO,_O,RO=s((()=>{J(),ea(),xr(),ro(),EO(),SO(),Du(),xO=eo("core/audits/largest-contentful-paint-element.js",kO={title:"Largest Contentful Paint element",description:"This is the largest contentful element painted within the viewport. [Learn more about the Largest Contentful Paint element](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-largest-contentful-paint/)",columnPhase:"Phase",columnPercentOfLCP:"% of LCP",columnTiming:"Timing",itemTTFB:"TTFB",itemLoadDelay:"Load Delay",itemLoadTime:"Load Time",itemRenderDelay:"Render Delay"}),AO=class extends Dr{static{o(this,"LargestContentfulPaintElement")}static get meta(){return{id:"largest-contentful-paint-element",title:xO(kO.title),description:xO(kO.description),scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["traces","TraceElements","devtoolsLogs","GatherContext","settings","URL"]}}static makeElementTable(e){let t=e.TraceElements.find((e=>"largest-contentful-paint"===e.traceEventType));if(!t)return;let a=[{key:"node",valueType:"node",label:xO(no.columnElement)}],n=[{node:Dr.makeNodeItem(t.node)}];return Dr.makeTableDetails(a,n)}static async makePhaseTable(e,t,a){let{ttfb:n,loadStart:r,loadEnd:i}=await wO.request(t,a),o=0,s=0,l=e-n;r&&i&&(o=r-n,s=i-r,l=e-i);let c=[{phase:xO(kO.itemTTFB),timing:n},{phase:xO(kO.itemLoadDelay),timing:o},{phase:xO(kO.itemLoadTime),timing:s},{phase:xO(kO.itemRenderDelay),timing:l}].map((t=>{let a=`${(100*t.timing/e).toFixed(0)}%`;return{...t,percent:a}})),u=[{key:"phase",valueType:"text",label:xO(kO.columnPhase)},{key:"percent",valueType:"text",label:xO(kO.columnPercentOfLCP)},{key:"timing",valueType:"ms",label:xO(kO.columnTiming)}];return Dr.makeTableDetails(u,c)}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings,URL:e.URL},n=this.makeElementTable(e);if(!n)return{score:null,notApplicable:!0};let r,i=[n];try{let{timing:e}=await fO.request(a,t);r=xO(no.ms,{timeInMs:e});let n=await this.makePhaseTable(e,a,t);i.push(n)}catch(e){vu.captureException(e,{tags:{audit:this.meta.id},level:"error"}),Kt.error(this.meta.id,e.message)}return{score:1,displayValue:r,details:Dr.makeListDetails(i)}}},_O=AO})),FO={};c(FO,{UIStrings:()=>NO,default:()=>PO});var NO,IO,MO,PO,LO=s((()=>{J(),xr(),ro(),bD(),IO=eo("core/audits/layout-shift-elements.js",NO={title:"Avoid large layout shifts",description:"These DOM elements contribute most to the CLS of the page. [Learn how to improve CLS](https://web.dev/optimize-cls/)",columnContribution:"CLS Contribution"}),MO=class extends Dr{static{o(this,"LayoutShiftElements")}static get meta(){return{id:"layout-shift-elements",title:IO(NO.title),description:IO(NO.description),scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,requiredArtifacts:["traces","TraceElements"]}}static async audit(e,t){let a,n=e.TraceElements.filter((e=>"layout-shift"===e.traceEventType)).map((e=>({node:Dr.makeNodeItem(e.node),score:e.score}))),r=[{key:"node",valueType:"node",label:IO(no.columnElement)},{key:"score",valueType:"numeric",granularity:.001,label:IO(NO.columnContribution)}],i=Dr.makeTableDetails(r,n);n.length>0&&(a=IO(no.displayValueElementsFound,{nodeCount:n.length}));let{cumulativeLayoutShift:o}=await gD.request(e.traces[Dr.DEFAULT_PASS],t);return{score:1,metricSavings:{CLS:o},notApplicable:0===i.items.length,displayValue:a,details:i}}},PO=MO})),OO={};c(OO,{UIStrings:()=>jO,default:()=>qO});var jO,UO,BO,qO,zO=s((()=>{J(),xr(),ro(),UO=eo("core/audits/lcp-lazy-loaded.js",jO={title:"Largest Contentful Paint image was not lazily loaded",failureTitle:"Largest Contentful Paint image was lazily loaded",description:"Above-the-fold images that are lazily loaded render later in the page lifecycle, which can delay the largest contentful paint. [Learn more about optimal lazy loading](https://web.dev/lcp-lazy-loading/)."}),BO=class extends Dr{static{o(this,"LargestContentfulPaintLazyLoaded")}static get meta(){return{id:"lcp-lazy-loaded",title:UO(jO.title),failureTitle:UO(jO.failureTitle),description:UO(jO.description),supportedModes:["navigation"],requiredArtifacts:["TraceElements","ViewportDimensions","ImageElements"]}}static isImageInViewport(e,t){return e.clientRect.top<t.innerHeight}static audit(e){let t=e.TraceElements.find((e=>"largest-contentful-paint"===e.traceEventType&&"image"===e.type)),a=t?e.ImageElements.find((e=>e.node.devtoolsNodePath===t.node.devtoolsNodePath)):void 0;if(!a||!this.isImageInViewport(a,e.ViewportDimensions))return{score:null,notApplicable:!0};let n=[{key:"node",valueType:"node",label:UO(no.columnElement)}],r=Dr.makeTableDetails(n,[{node:Dr.makeNodeItem(a.node)}]);return{score:"lazy"===a.loading?0:1,details:r}}},qO=BO})),VO={};function WO(e,t){let a=e.indexOf(t);return a>-1?a:e.push(t)-1}function HO(e){return Math.round(10*e)/10}c(VO,{UIStrings:()=>$O,default:()=>JO});var GO,$O,KO,YO,JO,ZO=s((()=>{J(),xr(),Yc(),ro(),uR(),$c(),Zc(),fR(),GO={startTime:0,endTime:0,duration:0},20,KO=eo("core/audits/long-tasks.js",$O={title:"Avoid long main-thread tasks",description:"Lists the longest tasks on the main thread, useful for identifying worst contributors to input delay. [Learn how to avoid long main-thread tasks](https://web.dev/long-tasks-devtools/)",displayValue:"{itemCount, plural,\n  =1 {# long task found}\n  other {# long tasks found}\n  }"}),o(WO,"insertUrl"),o(HO,"roundTenths"),YO=class e extends Dr{static{o(this,"LongTasks")}static get meta(){return{id:"long-tasks",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:KO($O.title),description:KO($O.description),requiredArtifacts:["traces","devtoolsLogs","URL"]}}static getTimingBreakdown(t,a,n=new Map){let r=e.getTiming(t,a),i=0;if(r.duration>0)for(let r of t.children){let{duration:t}=e.getTimingBreakdown(r,a,n);i+=t}let o=r.duration-i,s=n.get(t.group.id)||0;return n.set(t.group.id,s+o),{startTime:r.startTime,duration:r.duration,timeByTaskGroup:n}}static makeDebugData(t,a,n){let r=[],i=[];for(let o of t){let t=mR(o,a),{startTime:s,duration:l,timeByTaskGroup:c}=e.getTimingBreakdown(o,n),u=[...c].map((([e,t])=>[e,HO(t)])).sort(((e,t)=>e[0].localeCompare(t[0])));i.push({urlIndex:WO(r,t),startTime:HO(s),duration:HO(l),...Object.fromEntries(u)})}return{type:"debugdata",urls:r,tasks:i}}static getTiming(e,t){let a=e;t&&(a=t.get(e.event)||GO);let{duration:n,startTime:r}=a;return{duration:n,startTime:r}}static async audit(t,a){let n,r=a.settings||{},i=t.URL,o=t.traces[Dr.DEFAULT_PASS],s=await oR.request(o,a),l=t.devtoolsLogs[e.DEFAULT_PASS],c=await Pc.request(l,a);if("simulate"===r.throttlingMethod){n=new Map;let e={devtoolsLog:l,settings:a.settings},t=await Fc.request({trace:o,devtoolsLog:l,URL:i},a),r=await(await Uc.request(e,a)).simulate(t,{label:"long-tasks-diagnostic"});for(let[e,t]of r.nodeTimings.entries())"cpu"===e.type&&n.set(e.event,t)}let u,d=dR(c),m=s.map((t=>{let{duration:a}=e.getTiming(t,n);return{task:t,duration:a}})).filter((({task:e,duration:t})=>t>=50&&!e.unbounded&&!e.parent)).sort(((e,t)=>t.duration-e.duration)).map((({task:e})=>e)),p=m.map((t=>{let a=e.getTiming(t,n);return{url:mR(t,d),duration:a.duration,startTime:a.startTime}})).slice(0,20),h=[{key:"url",valueType:"url",label:KO(no.columnURL)},{key:"startTime",valueType:"ms",granularity:1,label:KO(no.columnStartTime)},{key:"duration",valueType:"ms",granularity:1,label:KO(no.columnDuration)}],g=Dr.makeTableDetails(h,p,{sortedBy:["duration"],skipSumming:["startTime"]});return g.debugData=e.makeDebugData(m,d,n),p.length>0&&(u=KO($O.displayValue,{itemCount:p.length})),{score:0===p.length?1:0,notApplicable:0===p.length,details:g,displayValue:u}}},JO=YO})),XO={};c(XO,{default:()=>ej});var QO,ej,tj=s((()=>{J(),xr(),uR(),QO=class extends Dr{static{o(this,"MainThreadTasks")}static get meta(){return{id:"main-thread-tasks",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:"Tasks",description:"Lists the toplevel main thread tasks that executed during page load.",requiredArtifacts:["traces"]}}static async audit(e,t){let a=e.traces[Dr.DEFAULT_PASS],n=(await oR.request(a,t)).filter((e=>e.duration>5&&!e.parent)).map((e=>({duration:e.duration,startTime:e.startTime})));return{score:1,details:Dr.makeTableDetails([{key:"startTime",valueType:"ms",granularity:1,label:"Start Time"},{key:"duration",valueType:"ms",granularity:1,label:"End Time"}],n)}}},ej=QO})),aj={};c(aj,{UIStrings:()=>nj,default:()=>oj});var nj,rj,ij,oj,sj=s((()=>{J(),xr(),lR(),ro(),uR(),rj=eo("core/audits/mainthread-work-breakdown.js",nj={title:"Minimizes main-thread work",failureTitle:"Minimize main-thread work",description:"Consider reducing the time spent parsing, compiling and executing JS. You may find delivering smaller JS payloads helps with this. [Learn how to minimize main-thread work](https://developer.chrome.com/docs/lighthouse/performance/mainthread-work-breakdown/)",columnCategory:"Category"}),ij=class e extends Dr{static{o(this,"MainThreadWorkBreakdown")}static get meta(){return{id:"mainthread-work-breakdown",title:rj(nj.title),failureTitle:rj(nj.failureTitle),description:rj(nj.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["traces"]}}static get defaultOptions(){return{p10:2017,median:4e3}}static getExecutionTimingsByGroup(e){let t=new Map;for(let a of e){let e=t.get(a.group.id)||0;t.set(a.group.id,e+a.selfTime)}return t}static async audit(t,a){let n=a.settings||{},r=t.traces[e.DEFAULT_PASS],i=await oR.request(r,a),o="simulate"===n.throttlingMethod?n.throttling.cpuSlowdownMultiplier:1,s=e.getExecutionTimingsByGroup(i),l=0,c={},u=Array.from(s).map((([e,t])=>{let a=t*o;l+=a;let n=c[e]||0;return c[e]=n+a,{group:e,groupLabel:aR[e].label,duration:a}})),d=[{key:"groupLabel",valueType:"text",label:rj(nj.columnCategory)},{key:"duration",valueType:"ms",granularity:1,label:rj(no.columnTimeSpent)}];u.sort(((e,t)=>c[t.group]-c[e.group]));let m=e.makeTableDetails(d,u,{sortedBy:["duration"]});return{score:Dr.computeLogNormalScore({p10:a.options.p10,median:a.options.median},l),numericValue:l,numericUnit:"millisecond",displayValue:rj(no.seconds,{timeInMs:l}),details:m}}},oj=ij})),lj={};c(lj,{UIStrings:()=>cj,default:()=>mj});var cj,uj,dj,mj,pj=s((()=>{J(),bx(),ro(),uj=eo("core/audits/manual/pwa-cross-browser.js",cj={title:"Site works cross-browser",description:"To reach the most number of users, sites should work across every major browser. [Learn about cross-browser compatibility](https://developer.chrome.com/docs/lighthouse/pwa/pwa-cross-browser/)."}),dj=class extends yx{static{o(this,"PWACrossBrowser")}static get meta(){return Object.assign({id:"pwa-cross-browser",title:uj(cj.title),description:uj(cj.description)},super.partialMeta)}},mj=dj})),hj={};c(hj,{UIStrings:()=>gj,default:()=>vj});var gj,fj,yj,vj,bj=s((()=>{J(),bx(),ro(),fj=eo("core/audits/manual/pwa-each-page-has-url.js",gj={title:"Each page has a URL",description:"Ensure individual pages are deep linkable via URL and that URLs are unique for the purpose of shareability on social media. [Learn more about providing deep links](https://developer.chrome.com/docs/lighthouse/pwa/pwa-each-page-has-url/)."}),yj=class extends yx{static{o(this,"PWAEachPageHasURL")}static get meta(){return Object.assign({id:"pwa-each-page-has-url",title:fj(gj.title),description:fj(gj.description)},super.partialMeta)}},vj=yj})),wj={};c(wj,{UIStrings:()=>Dj,default:()=>Sj});var Dj,Ej,Tj,Sj,Cj=s((()=>{J(),bx(),ro(),Ej=eo("core/audits/manual/pwa-page-transitions.js",Dj={title:"Page transitions don't feel like they block on the network",description:"Transitions should feel snappy as you tap around, even on a slow network. This experience is key to a user's perception of performance. [Learn more about page transitions](https://developer.chrome.com/docs/lighthouse/pwa/pwa-page-transitions/)."}),Tj=class extends yx{static{o(this,"PWAPageTransitions")}static get meta(){return Object.assign({id:"pwa-page-transitions",title:Ej(Dj.title),description:Ej(Dj.description)},super.partialMeta)}},Sj=Tj})),kj={};c(kj,{UIStrings:()=>xj,default:()=>Rj});var xj,Aj,_j,Rj,Fj,Nj,Ij,Mj,Pj,Lj,Oj,jj,Uj,Bj,qj,zj,Vj,Wj,Hj,Gj,$j,Kj=s((()=>{J(),xr(),aO(),ro(),Aj=eo("core/audits/maskable-icon.js",xj={title:"Manifest has a maskable icon",failureTitle:"Manifest doesn't have a maskable icon",description:"A maskable icon ensures that the image fills the entire shape without being letterboxed when installing the app on a device. [Learn about maskable manifest icons](https://developer.chrome.com/docs/lighthouse/pwa/maskable-icon-audit/)."}),_j=class extends Dr{static{o(this,"MaskableIcon")}static get meta(){return{id:"maskable-icon",title:Aj(xj.title),failureTitle:Aj(xj.failureTitle),description:Aj(xj.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static async audit(e,t){let a=await eO.request(e,t);return a.isParseFailure?{score:0,explanation:a.parseFailureReason}:{score:a.allChecks.find((e=>"hasMaskableIcon"===e.id))?.passing?1:0}}},Rj=_j})),Yj=l(((e,a)=>{J();var n,r=(ua(),n=la,u(t({},"__esModule",{value:!0}),n));if(r&&r.default){a.exports=r.default;for(let e in r)a.exports[e]=r[e]}else r&&(a.exports=r)})),Jj=l(((e,t)=>{J();function a(e){Math.round;var a,n,r,i,s,l=Math.floor,c=new Array(64),u=new Array(64),d=new Array(64),m=new Array(64),p=new Array(65535),h=new Array(65535),g=new Array(64),f=new Array(64),y=[],v=0,b=7,w=new Array(64),D=new Array(64),E=new Array(64),T=new Array(256),S=new Array(2048),C=[0,1,5,6,14,15,27,28,2,4,7,13,16,26,29,42,3,8,12,17,25,30,41,43,9,11,18,24,31,40,44,53,10,19,23,32,39,45,52,54,20,22,33,38,46,51,55,60,21,34,37,47,50,56,59,61,35,36,48,49,57,58,62,63],k=[0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0],x=[0,1,2,3,4,5,6,7,8,9,10,11],A=[0,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125],_=[1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250],R=[0,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0],F=[0,1,2,3,4,5,6,7,8,9,10,11],N=[0,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119],I=[0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250];function M(e){for(var t=[16,11,10,16,24,40,51,61,12,12,14,19,26,58,60,55,14,13,16,24,40,57,69,56,14,17,22,29,51,87,80,62,18,22,37,56,68,109,103,77,24,35,55,64,81,104,113,92,49,64,78,87,103,121,120,101,72,92,95,98,112,100,103,99],a=0;a<64;a++){var n=l((t[a]*e+50)/100);n<1?n=1:n>255&&(n=255),c[C[a]]=n}for(var r=[17,18,24,47,99,99,99,99,18,21,26,66,99,99,99,99,24,26,56,99,99,99,99,99,47,66,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99],i=0;i<64;i++){var o=l((r[i]*e+50)/100);o<1?o=1:o>255&&(o=255),u[C[i]]=o}for(var s=[1,1.387039845,1.306562965,1.175875602,1,.785694958,.5411961,.275899379],p=0,h=0;h<8;h++)for(var g=0;g<8;g++)d[p]=1/(c[C[p]]*s[h]*s[g]*8),m[p]=1/(u[C[p]]*s[h]*s[g]*8),p++}function P(e,t){for(var a=0,n=0,r=new Array,i=1;i<=16;i++){for(var o=1;o<=e[i];o++)r[t[n]]=[],r[t[n]][0]=a,r[t[n]][1]=i,n++,a++;a*=2}return r}function L(){a=P(k,x),n=P(R,F),r=P(A,_),i=P(N,I)}function O(){for(var e=1,t=2,a=1;a<=15;a++){for(var n=e;n<t;n++)h[32767+n]=a,p[32767+n]=[],p[32767+n][1]=a,p[32767+n][0]=n;for(var r=-(t-1);r<=-e;r++)h[32767+r]=a,p[32767+r]=[],p[32767+r][1]=a,p[32767+r][0]=t-1+r;e<<=1,t<<=1}}function j(){for(var e=0;e<256;e++)S[e]=19595*e,S[e+256>>0]=38470*e,S[e+512>>0]=7471*e+32768,S[e+768>>0]=-11059*e,S[e+1024>>0]=-21709*e,S[e+1280>>0]=32768*e+8421375,S[e+1536>>0]=-27439*e,S[e+1792>>0]=-5329*e}function U(e){for(var t=e[0],a=e[1]-1;a>=0;)t&1<<a&&(v|=1<<b),a--,--b<0&&(255==v?(B(255),B(0)):B(v),b=7,v=0)}function B(e){y.push(e)}function q(e){B(e>>8&255),B(255&e)}function z(e,t){var a,n,r,i,o,s,l,c,u,d,m=0;for(u=0;u<8;++u){a=e[m],n=e[m+1],r=e[m+2],i=e[m+3],o=e[m+4],s=e[m+5],l=e[m+6];var p=a+(c=e[m+7]),h=a-c,f=n+l,y=n-l,v=r+s,b=r-s,w=i+o,D=i-o,E=p+w,T=p-w,S=f+v,C=f-v;e[m]=E+S,e[m+4]=E-S;var k=.707106781*(C+T);e[m+2]=T+k,e[m+6]=T-k;var x=.382683433*((E=D+b)-(C=y+h)),A=.5411961*E+x,_=1.306562965*C+x,R=.707106781*(S=b+y),F=h+R,N=h-R;e[m+5]=N+A,e[m+3]=N-A,e[m+1]=F+_,e[m+7]=F-_,m+=8}for(m=0,u=0;u<8;++u){a=e[m],n=e[m+8],r=e[m+16],i=e[m+24],o=e[m+32],s=e[m+40],l=e[m+48];var I=a+(c=e[m+56]),M=a-c,P=n+l,L=n-l,O=r+s,j=r-s,U=i+o,B=i-o,q=I+U,z=I-U,V=P+O,W=P-O;e[m]=q+V,e[m+32]=q-V;var H=.707106781*(W+z);e[m+16]=z+H,e[m+48]=z-H;var G=.382683433*((q=B+j)-(W=L+M)),$=.5411961*q+G,K=1.306562965*W+G,Y=.707106781*(V=j+L),J=M+Y,Z=M-Y;e[m+40]=Z+$,e[m+24]=Z-$,e[m+8]=J+K,e[m+56]=J-K,m++}for(u=0;u<64;++u)d=e[u]*t[u],g[u]=d>0?d+.5|0:d-.5|0;return g}function V(){q(65504),q(16),B(74),B(70),B(73),B(70),B(0),B(1),B(1),B(0),q(1),q(1),B(0),B(0)}function W(e){if(e){q(65505),69===e[0]&&120===e[1]&&105===e[2]&&102===e[3]?q(e.length+2):(q(e.length+5+2),B(69),B(120),B(105),B(102),B(0));for(var t=0;t<e.length;t++)B(e[t])}}function H(e,t){q(65472),q(17),B(8),q(t),q(e),B(3),B(1),B(17),B(0),B(2),B(17),B(1),B(3),B(17),B(1)}function G(){q(65499),q(132),B(0);for(var e=0;e<64;e++)B(c[e]);B(1);for(var t=0;t<64;t++)B(u[t])}function $(){q(65476),q(418),B(0);for(var e=0;e<16;e++)B(k[e+1]);for(var t=0;t<=11;t++)B(x[t]);B(16);for(var a=0;a<16;a++)B(A[a+1]);for(var n=0;n<=161;n++)B(_[n]);B(1);for(var r=0;r<16;r++)B(R[r+1]);for(var i=0;i<=11;i++)B(F[i]);B(17);for(var o=0;o<16;o++)B(N[o+1]);for(var s=0;s<=161;s++)B(I[s])}function K(e){typeof e>"u"||e.constructor!==Array||e.forEach((e=>{if("string"==typeof e){q(65534);var t,a=e.length;for(q(a+2),t=0;t<a;t++)B(e.charCodeAt(t))}}))}function Y(){q(65498),q(12),B(3),B(1),B(0),B(2),B(17),B(3),B(17),B(0),B(63),B(0)}function J(e,t,a,n,r){for(var i,o=r[0],s=r[240],l=z(e,t),c=0;c<64;++c)f[C[c]]=l[c];var u=f[0]-a;a=f[0],0==u?U(n[0]):(U(n[h[i=32767+u]]),U(p[i]));for(var d=63;d>0&&0==f[d];d--);if(0==d)return U(o),a;for(var m,g=1;g<=d;){for(var y=g;0==f[g]&&g<=d;++g);var v=g-y;if(v>=16){m=v>>4;for(var b=1;b<=m;++b)U(s);v&=15}i=32767+f[g],U(r[(v<<4)+h[i]]),U(p[i]),g++}return 63!=d&&U(o),a}function Z(){for(var e=String.fromCharCode,t=0;t<256;t++)T[t]=e(t)}function X(e){if(e<=0&&(e=1),e>100&&(e=100),s!=e){M(e<50?Math.floor(5e3/e):Math.floor(200-2*e)),s=e}}function Q(){var t=(new Date).getTime();e||(e=50),Z(),L(),O(),j(),X(e);(new Date).getTime()}o(M,"initQuantTables"),o(P,"computeHuffmanTbl"),o(L,"initHuffmanTbl"),o(O,"initCategoryNumber"),o(j,"initRGBYUVTable"),o(U,"writeBits"),o(B,"writeByte"),o(q,"writeWord"),o(z,"fDCTQuant"),o(V,"writeAPP0"),o(W,"writeAPP1"),o(H,"writeSOF0"),o(G,"writeDQT"),o($,"writeDHT"),o(K,"writeCOM"),o(Y,"writeSOS"),o(J,"processDU"),o(Z,"initCharLookupTable"),this.encode=function(e,o){(new Date).getTime();o&&X(o),y=new Array,v=0,b=7,q(65496),V(),K(e.comments),W(e.exifBuffer),G(),H(e.width,e.height),$(),Y();var s=0,l=0,c=0;v=0,b=7,this.encode.displayName="_encode_";for(var u,p,h,g,f,T,C,k,x,A=e.data,_=e.width,R=e.height,F=4*_,N=0;N<R;){for(u=0;u<F;){for(T=f=F*N+u,C=-1,k=0,x=0;x<64;x++)T=f+(k=x>>3)*F+(C=4*(7&x)),N+k>=R&&(T-=F*(N+1+k-R)),u+C>=F&&(T-=u+C-F+4),p=A[T++],h=A[T++],g=A[T++],w[x]=(S[p]+S[h+256>>0]+S[g+512>>0]>>16)-128,D[x]=(S[p+768>>0]+S[h+1024>>0]+S[g+1280>>0]>>16)-128,E[x]=(S[p+1280>>0]+S[h+1536>>0]+S[g+1792>>0]>>16)-128;s=J(w,d,s,a,r),l=J(D,m,l,n,i),c=J(E,m,c,n,i),u+=32}N+=8}if(b>=0){var I=[];I[1]=b+1,I[0]=(1<<b+1)-1,U(I)}return q(65497),typeof t>"u"?new Uint8Array(y):Buffer.from(y)},o(X,"setQuality"),o(Q,"init"),Q()}function n(e,t){return typeof t>"u"&&(t=50),{data:new a(t).encode(e,t),width:e.width,height:e.height}}o(a,"JPEGEncoder"),typeof t<"u"?t.exports=n:typeof window<"u"&&(window["jpeg-js"]=window["jpeg-js"]||{},window["jpeg-js"].encode=n),o(n,"encode")})),Zj=l(((e,t)=>{J();var a=o((function(){var e=new Int32Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),t=4017,a=799,n=3406,r=2276,i=1567,s=3784,l=5793,c=2896;function u(){}function d(e,t){for(var a,n,r=0,i=[],o=16;o>0&&!e[o-1];)o--;i.push({children:[],index:0});var s,l=i[0];for(a=0;a<o;a++){for(n=0;n<e[a];n++){for((l=i.pop()).children[l.index]=t[r];l.index>0;){if(0===i.length)throw new Error("Could not recreate Huffman Table");l=i.pop()}for(l.index++,i.push(l);i.length<=a;)i.push(s={children:[],index:0}),l.children[l.index]=s.children,l=s;r++}a+1<o&&(i.push(s={children:[],index:0}),l.children[l.index]=s.children,l=s)}return i[0].children}function m(t,a,n,r,i,s,l,c,u,d){n.precision,n.samplesPerLine,n.scanLines;var m=n.mcusPerLine,p=n.progressive,h=(n.maxH,n.maxV,a),g=0,f=0;function y(){if(f>0)return f--,g>>f&1;if(255==(g=t[a++])){var e=t[a++];if(e)throw new Error("unexpected marker: "+(g<<8|e).toString(16))}return f=7,g>>>7}function v(e){for(var t,a=e;null!==(t=y());){if("number"==typeof(a=a[t]))return a;if("object"!=typeof a)throw new Error("invalid huffman sequence")}return null}function b(e){for(var t=0;e>0;){var a=y();if(null===a)return;t=t<<1|a,e--}return t}function w(e){var t=b(e);return t>=1<<e-1?t:t+(-1<<e)+1}function D(t,a){var n=v(t.huffmanTableDC),r=0===n?0:w(n);a[0]=t.pred+=r;for(var i=1;i<64;){var o=v(t.huffmanTableAC),s=15&o,l=o>>4;if(0!==s){a[e[i+=l]]=w(s),i++}else{if(l<15)break;i+=16}}}function E(e,t){var a=v(e.huffmanTableDC),n=0===a?0:w(a)<<u;t[0]=e.pred+=n}function T(e,t){t[0]|=y()<<u}o(y,"readBit"),o(v,"decodeHuffman"),o(b,"receive"),o(w,"receiveAndExtend"),o(D,"decodeBaseline"),o(E,"decodeDCFirst"),o(T,"decodeDCSuccessive");var S=0;function C(t,a){if(S>0)S--;else for(var n=s,r=l;n<=r;){var i=v(t.huffmanTableAC),o=15&i,c=i>>4;if(0!==o){a[e[n+=c]]=w(o)*(1<<u),n++}else{if(c<15){S=b(c)+(1<<c)-1;break}n+=16}}}o(C,"decodeACFirst");var k,x=0;function A(t,a){for(var n=s,r=l,i=0;n<=r;){var o=e[n],c=a[o]<0?-1:1;switch(x){case 0:var d=v(t.huffmanTableAC),m=15&d;i=d>>4;if(0===m)i<15?(S=b(i)+(1<<i),x=4):(i=16,x=1);else{if(1!==m)throw new Error("invalid ACn encoding");k=w(m),x=i?2:3}continue;case 1:case 2:a[o]?a[o]+=(y()<<u)*c:0===--i&&(x=2==x?3:0);break;case 3:a[o]?a[o]+=(y()<<u)*c:(a[o]=k<<u,x=0);break;case 4:a[o]&&(a[o]+=(y()<<u)*c)}n++}4===x&&(0===--S&&(x=0))}function _(e,t,a,n,r){var i=a%m,o=(a/m|0)*e.v+n,s=i*e.h+r;void 0===e.blocks[o]&&d.tolerantDecoding||t(e,e.blocks[o][s])}function R(e,t,a){var n=a/e.blocksPerLine|0,r=a%e.blocksPerLine;void 0===e.blocks[n]&&d.tolerantDecoding||t(e,e.blocks[n][r])}o(A,"decodeACSuccessive"),o(_,"decodeMcu"),o(R,"decodeBlock");var F,N,I,M,P,L,O=r.length;L=p?0===s?0===c?E:T:0===c?C:A:D;var j,U,B,q,z=0;for(U=1==O?r[0].blocksPerLine*r[0].blocksPerColumn:m*n.mcusPerColumn,i||(i=U);z<U;){for(N=0;N<O;N++)r[N].pred=0;if(S=0,1==O)for(F=r[0],P=0;P<i;P++)R(F,L,z),z++;else for(P=0;P<i;P++){for(N=0;N<O;N++)for(B=(F=r[N]).h,q=F.v,I=0;I<q;I++)for(M=0;M<B;M++)_(F,L,z,I,M);if(++z===U)break}if(z===U)do{if(255===t[a]&&0!==t[a+1])break;a+=1}while(a<t.length-2);if(f=0,(j=t[a]<<8|t[a+1])<65280)throw new Error("marker was not found");if(!(j>=65488&&j<=65495))break;a+=2}return a-h}function p(e,u){var d=[],m=u.blocksPerLine,p=u.blocksPerColumn,h=m<<3,g=new Int32Array(64),f=new Uint8Array(64);function v(e,o,d){var m,p,h,g,f,y,v,b,w,D,E=u.quantizationTable,T=d;for(D=0;D<64;D++)T[D]=e[D]*E[D];for(D=0;D<8;++D){var S=8*D;0!=T[1+S]||0!=T[2+S]||0!=T[3+S]||0!=T[4+S]||0!=T[5+S]||0!=T[6+S]||0!=T[7+S]?(m=l*T[0+S]+128>>8,p=l*T[4+S]+128>>8,h=T[2+S],g=T[6+S],f=c*(T[1+S]-T[7+S])+128>>8,b=c*(T[1+S]+T[7+S])+128>>8,y=T[3+S]<<4,v=T[5+S]<<4,w=m-p+1>>1,m=m+p+1>>1,p=w,w=h*s+g*i+128>>8,h=h*i-g*s+128>>8,g=w,w=f-v+1>>1,f=f+v+1>>1,v=w,w=b+y+1>>1,y=b-y+1>>1,b=w,w=m-g+1>>1,m=m+g+1>>1,g=w,w=p-h+1>>1,p=p+h+1>>1,h=w,w=f*r+b*n+2048>>12,f=f*n-b*r+2048>>12,b=w,w=y*a+v*t+2048>>12,y=y*t-v*a+2048>>12,v=w,T[0+S]=m+b,T[7+S]=m-b,T[1+S]=p+v,T[6+S]=p-v,T[2+S]=h+y,T[5+S]=h-y,T[3+S]=g+f,T[4+S]=g-f):(w=l*T[0+S]+512>>10,T[0+S]=w,T[1+S]=w,T[2+S]=w,T[3+S]=w,T[4+S]=w,T[5+S]=w,T[6+S]=w,T[7+S]=w)}for(D=0;D<8;++D){var C=D;0!=T[8+C]||0!=T[16+C]||0!=T[24+C]||0!=T[32+C]||0!=T[40+C]||0!=T[48+C]||0!=T[56+C]?(m=l*T[0+C]+2048>>12,p=l*T[32+C]+2048>>12,h=T[16+C],g=T[48+C],f=c*(T[8+C]-T[56+C])+2048>>12,b=c*(T[8+C]+T[56+C])+2048>>12,y=T[24+C],v=T[40+C],w=m-p+1>>1,m=m+p+1>>1,p=w,w=h*s+g*i+2048>>12,h=h*i-g*s+2048>>12,g=w,w=f-v+1>>1,f=f+v+1>>1,v=w,w=b+y+1>>1,y=b-y+1>>1,b=w,w=m-g+1>>1,m=m+g+1>>1,g=w,w=p-h+1>>1,p=p+h+1>>1,h=w,w=f*r+b*n+2048>>12,f=f*n-b*r+2048>>12,b=w,w=y*a+v*t+2048>>12,y=y*t-v*a+2048>>12,v=w,T[0+C]=m+b,T[56+C]=m-b,T[8+C]=p+v,T[48+C]=p-v,T[16+C]=h+y,T[40+C]=h-y,T[24+C]=g+f,T[32+C]=g-f):(w=l*d[D+0]+8192>>14,T[0+C]=w,T[8+C]=w,T[16+C]=w,T[24+C]=w,T[32+C]=w,T[40+C]=w,T[48+C]=w,T[56+C]=w)}for(D=0;D<64;++D){var k=128+(T[D]+8>>4);o[D]=k<0?0:k>255?255:k}}o(v,"quantizeAndInverse"),y(h*p*8);for(var b,w,D=0;D<p;D++){var E=D<<3;for(b=0;b<8;b++)d.push(new Uint8Array(h));for(var T=0;T<m;T++){v(u.blocks[D][T],f,g);var S=0,C=T<<3;for(w=0;w<8;w++){var k=d[E+w];for(b=0;b<8;b++)k[C+b]=f[S++]}}}return d}function h(e){return e<0?0:e>255?255:e}o(u,"constructor"),o(d,"buildHuffmanTable"),o(m,"decodeScan"),o(p,"buildComponentData"),o(h,"clampTo8bit"),u.prototype={load:o((function(e){var t=new XMLHttpRequest;t.open("GET",e,!0),t.responseType="arraybuffer",t.onload=function(){var e=new Uint8Array(t.response||t.mozResponseArrayBuffer);this.parse(e),this.onload&&this.onload()}.bind(this),t.send(null)}),"load"),parse:o((function(t){var a=1e3*this.opts.maxResolutionInMP*1e3,n=0;t.length;function r(){var e=t[n]<<8|t[n+1];return n+=2,e}function i(){var e=r(),a=t.subarray(n,n+e-2);return n+=a.length,a}function s(e){var t,a,n=1,r=1;for(a in e.components)e.components.hasOwnProperty(a)&&(n<(t=e.components[a]).h&&(n=t.h),r<t.v&&(r=t.v));var i=Math.ceil(e.samplesPerLine/8/n),o=Math.ceil(e.scanLines/8/r);for(a in e.components)if(e.components.hasOwnProperty(a)){t=e.components[a];var s=Math.ceil(Math.ceil(e.samplesPerLine/8)*t.h/n),l=Math.ceil(Math.ceil(e.scanLines/8)*t.v/r),c=i*t.h,u=o*t.v,d=[];y(256*(u*c));for(var m=0;m<u;m++){for(var p=[],h=0;h<c;h++)p.push(new Int32Array(64));d.push(p)}t.blocksPerLine=s,t.blocksPerColumn=l,t.blocks=d}e.maxH=n,e.maxV=r,e.mcusPerLine=i,e.mcusPerColumn=o}o(r,"readUint16"),o(i,"readDataBlock"),o(s,"prepareComponents");var l,c,u=null,h=null,g=[],f=[],v=[],b=[],w=r(),D=-1;if(this.comments=[],65496!=w)throw new Error("SOI not found");for(w=r();65497!=w;){switch(w){case 65280:break;case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:var E=i();if(65534===w){var T=String.fromCharCode.apply(null,E);this.comments.push(T)}65504===w&&74===E[0]&&70===E[1]&&73===E[2]&&70===E[3]&&0===E[4]&&(u={version:{major:E[5],minor:E[6]},densityUnits:E[7],xDensity:E[8]<<8|E[9],yDensity:E[10]<<8|E[11],thumbWidth:E[12],thumbHeight:E[13],thumbData:E.subarray(14,14+3*E[12]*E[13])}),65505===w&&69===E[0]&&120===E[1]&&105===E[2]&&102===E[3]&&0===E[4]&&(this.exifBuffer=E.subarray(5,E.length)),65518===w&&65===E[0]&&100===E[1]&&111===E[2]&&98===E[3]&&101===E[4]&&0===E[5]&&(h={version:E[6],flags0:E[7]<<8|E[8],flags1:E[9]<<8|E[10],transformCode:E[11]});break;case 65499:for(var S=r()+n-2;n<S;){var C=t[n++];y(256);var k=new Int32Array(64);if(C>>4){if(C>>4!=1)throw new Error("DQT: invalid table spec");for(K=0;K<64;K++){k[e[K]]=r()}}else for(K=0;K<64;K++){k[e[K]]=t[n++]}g[15&C]=k}break;case 65472:case 65473:case 65474:r(),(l={}).extended=65473===w,l.progressive=65474===w,l.precision=t[n++],l.scanLines=r(),l.samplesPerLine=r(),l.components={},l.componentsOrder=[];var x=l.scanLines*l.samplesPerLine;if(x>a){var A=Math.ceil((x-a)/1e6);throw new Error(`maxResolutionInMP limit exceeded by ${A}MP`)}var _,R=t[n++];for(G=0;G<R;G++){_=t[n];var F=t[n+1]>>4,N=15&t[n+1],I=t[n+2];if(F<=0||N<=0)throw new Error("Invalid sampling factor, expected values above 0");l.componentsOrder.push(_),l.components[_]={h:F,v:N,quantizationIdx:I},n+=3}s(l),f.push(l);break;case 65476:var M=r();for(G=2;G<M;){var P=t[n++],L=new Uint8Array(16),O=0;for(K=0;K<16;K++,n++)O+=L[K]=t[n];y(16+O);var j=new Uint8Array(O);for(K=0;K<O;K++,n++)j[K]=t[n];G+=17+O,(P>>4?v:b)[15&P]=d(L,j)}break;case 65501:r(),c=r();break;case 65500:r(),r();break;case 65498:r();var U=t[n++],B=[];for(G=0;G<U;G++){Y=l.components[t[n++]];var q=t[n++];Y.huffmanTableDC=b[q>>4],Y.huffmanTableAC=v[15&q],B.push(Y)}var z=t[n++],V=t[n++],W=t[n++],H=m(t,n,l,B,c,z,V,W>>4,15&W,this.opts);n+=H;break;case 65535:255!==t[n]&&n--;break;default:if(255==t[n-3]&&t[n-2]>=192&&t[n-2]<=254){n-=3;break}if(224===w||225==w){if(-1!==D)throw new Error(`first unknown JPEG marker at offset ${D.toString(16)}, second unknown JPEG marker ${w.toString(16)} at offset ${(n-1).toString(16)}`);D=n-1;let e=r();if(255===t[n+e-2]){n+=e-2;break}}throw new Error("unknown JPEG marker "+w.toString(16))}w=r()}if(1!=f.length)throw new Error("only single frame JPEGs supported");for(var G=0;G<f.length;G++){var $=f[G].components;for(var K in $)$[K].quantizationTable=g[$[K].quantizationIdx],delete $[K].quantizationIdx}this.width=l.samplesPerLine,this.height=l.scanLines,this.jfif=u,this.adobe=h,this.components=[];for(G=0;G<l.componentsOrder.length;G++){var Y=l.components[l.componentsOrder[G]];this.components.push({lines:p(0,Y),scaleX:Y.h/l.maxH,scaleY:Y.v/l.maxV})}}),"parse"),getData:o((function(e,t){var a,n,r,i,o,s,l,c,u,d,m,p,g,f,v,b,w,D,E,T,S,C=this.width/e,k=this.height/t,x=0,A=e*t*this.components.length;y(A);var _=new Uint8Array(A);switch(this.components.length){case 1:for(a=this.components[0],d=0;d<t;d++)for(o=a.lines[0|d*a.scaleY*k],u=0;u<e;u++)m=o[0|u*a.scaleX*C],_[x++]=m;break;case 2:for(a=this.components[0],n=this.components[1],d=0;d<t;d++)for(o=a.lines[0|d*a.scaleY*k],s=n.lines[0|d*n.scaleY*k],u=0;u<e;u++)m=o[0|u*a.scaleX*C],_[x++]=m,m=s[0|u*n.scaleX*C],_[x++]=m;break;case 3:for(S=!0,this.adobe&&this.adobe.transformCode?S=!0:typeof this.opts.colorTransform<"u"&&(S=!!this.opts.colorTransform),a=this.components[0],n=this.components[1],r=this.components[2],d=0;d<t;d++)for(o=a.lines[0|d*a.scaleY*k],s=n.lines[0|d*n.scaleY*k],l=r.lines[0|d*r.scaleY*k],u=0;u<e;u++)S?(m=o[0|u*a.scaleX*C],p=s[0|u*n.scaleX*C],D=h(m+1.402*((g=l[0|u*r.scaleX*C])-128)),E=h(m-.3441363*(p-128)-.71413636*(g-128)),T=h(m+1.772*(p-128))):(D=o[0|u*a.scaleX*C],E=s[0|u*n.scaleX*C],T=l[0|u*r.scaleX*C]),_[x++]=D,_[x++]=E,_[x++]=T;break;case 4:if(!this.adobe)throw new Error("Unsupported color mode (4 components)");for(S=!1,this.adobe&&this.adobe.transformCode?S=!0:typeof this.opts.colorTransform<"u"&&(S=!!this.opts.colorTransform),a=this.components[0],n=this.components[1],r=this.components[2],i=this.components[3],d=0;d<t;d++)for(o=a.lines[0|d*a.scaleY*k],s=n.lines[0|d*n.scaleY*k],l=r.lines[0|d*r.scaleY*k],c=i.lines[0|d*i.scaleY*k],u=0;u<e;u++)S?(m=o[0|u*a.scaleX*C],p=s[0|u*n.scaleX*C],g=l[0|u*r.scaleX*C],f=c[0|u*i.scaleX*C],v=255-h(m+1.402*(g-128)),b=255-h(m-.3441363*(p-128)-.71413636*(g-128)),w=255-h(m+1.772*(p-128))):(v=o[0|u*a.scaleX*C],b=s[0|u*n.scaleX*C],w=l[0|u*r.scaleX*C],f=c[0|u*i.scaleX*C]),_[x++]=255-v,_[x++]=255-b,_[x++]=255-w,_[x++]=255-f;break;default:throw new Error("Unsupported color mode")}return _}),"getData"),copyToImageData:o((function(e,t){var a,n,r,i,o,s,l,c,u,d=e.width,m=e.height,p=e.data,g=this.getData(d,m),f=0,y=0;switch(this.components.length){case 1:for(n=0;n<m;n++)for(a=0;a<d;a++)r=g[f++],p[y++]=r,p[y++]=r,p[y++]=r,t&&(p[y++]=255);break;case 3:for(n=0;n<m;n++)for(a=0;a<d;a++)l=g[f++],c=g[f++],u=g[f++],p[y++]=l,p[y++]=c,p[y++]=u,t&&(p[y++]=255);break;case 4:for(n=0;n<m;n++)for(a=0;a<d;a++)o=g[f++],s=g[f++],r=g[f++],l=255-h(o*(1-(i=g[f++])/255)+i),c=255-h(s*(1-i/255)+i),u=255-h(r*(1-i/255)+i),p[y++]=l,p[y++]=c,p[y++]=u,t&&(p[y++]=255);break;default:throw new Error("Unsupported color mode")}}),"copyToImageData")};var g=0,f=0;function y(e=0){var t=g+e;if(t>f){var a=Math.ceil((t-f)/1024/1024);throw new Error(`maxMemoryUsageInMB limit exceeded by at least ${a}MB`)}g=t}return o(y,"requestMemoryAllocation"),u.resetMaxMemoryUsage=function(e){g=0,f=e},u.getBytesAllocated=function(){return g},u.requestMemoryAllocation=y,u}),"jpegImage")();function n(e,t={}){var n={colorTransform:void 0,useTArray:!1,formatAsRGBA:!0,tolerantDecoding:!0,maxResolutionInMP:100,maxMemoryUsageInMB:512,...t},r=new Uint8Array(e),i=new a;i.opts=n,a.resetMaxMemoryUsage(1024*n.maxMemoryUsageInMB*1024),i.parse(r);var o=n.formatAsRGBA?4:3,s=i.width*i.height*o;try{a.requestMemoryAllocation(s);var l={width:i.width,height:i.height,exifBuffer:i.exifBuffer,data:n.useTArray?new Uint8Array(s):Buffer.alloc(s)};i.comments.length>0&&(l.comments=i.comments)}catch(e){throw e instanceof RangeError?new Error("Could not allocate enough memory for the image. Required: "+s):e instanceof ReferenceError&&"Buffer is not defined"===e.message?new Error("Buffer is not globally defined in this environment. Consider setting useTArray to true"):e}return i.copyToImageData(l,n.formatAsRGBA),l}typeof t<"u"?t.exports=n:typeof window<"u"&&(window["jpeg-js"]=window["jpeg-js"]||{},window["jpeg-js"].decode=n),o(n,"decode")})),Xj=l(((e,t)=>{J();var a=Jj(),n=Zj();t.exports={encode:a,decode:n}})),Qj=l(((e,t)=>{J();var a=Yj(),n=Xj();function r(e,t,a,n,r){return r[4*(e+t*n)+a]}function i(e,t,a){return r(e,t,0,a.width,a.data)>=249&&r(e,t,1,a.width,a.data)>=249&&r(e,t,2,a.width,a.data)>=249}function s(e){let t=o((function(){let e=[];for(let t=0;t<256;t++)e[t]=0;return e}),"createHistogramArray"),a=e.width,n=e.height,s=[t(),t(),t()];for(let t=0;t<n;t++)for(let n=0;n<a;n++)if(!i(n,t,e))for(let i=0;i<s.length;i++){let o=r(n,t,i,a,e.data);s[i][o]++}return s}function l(e){let t=n.decode(e[0].getImage()),a=t.width,r=t.height,i=Buffer.alloc(a*r*4),o=0;for(;o<i.length;)i[o++]=255,i[o++]=255,i[o++]=255,i[o++]=255;return n.encode({data:i,width:a,height:r}).data}o(r,"getPixel"),o(i,"isWhitePixel"),o(s,"convertPixelsToHistogram"),o(l,"synthesizeWhiteFrame");function c(e,t){let n;t=t||{},e="string"==typeof e?a.readFileSync(e,"utf-8"):e;try{n="string"==typeof e?JSON.parse(e):e}catch(e){throw new Error("Speedline: Invalid JSON"+e.message)}let r=n.traceEvents||n,i=Number.MAX_VALUE,o=-Number.MAX_VALUE;r.forEach((e=>{0!==e.ts&&(i=Math.min(i,e.ts),o=Math.max(o,e.ts))})),i=(t.timeOrigin||i)/1e3,o/=1e3;let s=null,c=r.filter((e=>e.cat.includes("disabled-by-default-devtools.screenshot")&&e.ts>=1e3*i));c.sort(((e,t)=>e.ts-t.ts));let d=c.map((function(e){let t=e.args&&e.args.snapshot,a=e.ts/1e3;return t===s?null:(s=t,u(Buffer.from(t,"base64"),a))})).filter(Boolean);if(0===d.length)return Promise.reject(new Error("No screenshots found in trace"));let m=u(l(d),i);d.unshift(m);let p={startTs:i,endTs:o,frames:d};return Promise.resolve(p)}function u(e,t){let a=null,r=null,i=null,o=null,l=null,c=null;return{getHistogram:function(){if(a)return a;let e=this.getParsedImage();return a=s(e),a},getTimeStamp:function(){return t},setProgress:function(e,t){r=e,i=!!t},setPerceptualProgress:function(e,t){o=e,l=!!t},getImage:function(){return e},getParsedImage:function(){return c||(c=n.decode(e)),c},getProgress:function(){return r},isProgressInterpolated:function(){return i},getPerceptualProgress:function(){return o},isPerceptualProgressInterpolated:function(){return l}}}o(c,"extractFramesFromTimeline"),o(u,"frame"),t.exports={extractFramesFromTimeline:c,create:u}})),eU=l(((e,t)=>{var a;J(),function(e){var t;(t=e.Channels||(e.Channels={}))[t.Grey=1]="Grey",t[t.GreyAlpha=2]="GreyAlpha",t[t.RGB=3]="RGB",t[t.RGBAlpha=4]="RGBAlpha";var a;e.Channels;function n(e,t,n,r,i,s,l){if(void 0===n&&(n=8),void 0===r&&(r=.01),void 0===i&&(i=.03),void 0===s&&(s=!0),void 0===l&&(l=8),e.width!==t.width||e.height!==t.height)throw new Error("Images have different sizes!");var c=(1<<l)-1,u=Math.pow(r*c,2),d=Math.pow(i*c,2),m=0,p=0,h=0;function g(e,t,a,n){var r,i,o;r=i=o=0;for(var s=0;s<e.length;s++)i+=Math.pow(e[s]-a,2),o+=Math.pow(t[s]-n,2),r+=(e[s]-a)*(t[s]-n);var l=e.length-1;i/=l,o/=l;var c=(2*a*n+u)*(2*(r/=l)+d),g=(Math.pow(a,2)+Math.pow(n,2)+u)*(i+o+d);p+=c/g,h+=(2*r+d)/(i+o+d),m++}return o(g,"iteration"),a._iterate(e,t,n,s,g),{ssim:p/m,mcs:h/m}}o(n,"compare"),e.compare=n,function(e){function t(e,t,r,i,o){for(var s=e.width,l=e.height,c=0;c<l;c+=r)for(var u=0;u<s;u+=r){var d=Math.min(r,s-u),m=Math.min(r,l-c),p=a(e,u,c,d,m,i),h=a(t,u,c,d,m,i);o(p,h,n(p),n(h))}}function a(e,t,a,n,r,i){for(var o=e.data,s=new Float32Array(new ArrayBuffer(n*r*4)),l=0,c=a+r,u=a;u<c;u++){var d=u*e.width,m=(d+t)*e.channels,p=(d+t+n)*e.channels;switch(e.channels){case 1:for(;m<p;)s[l++]=o[m++];break;case 2:for(;m<p;)s[l++]=o[m++]*(o[m++]/255);break;case 3:if(i)for(;m<p;)s[l++]=.212655*o[m++]+.715158*o[m++]+.072187*o[m++];else for(;m<p;)s[l++]=o[m++]+o[m++]+o[m++];break;case 4:if(i)for(;m<p;)s[l++]=(.212655*o[m++]+.715158*o[m++]+.072187*o[m++])*(o[m++]/255);else for(;m<p;)s[l++]=(o[m++]+o[m++]+o[m++])*(o[m++]/255)}}return s}function n(e){for(var t=0,a=0;a<e.length;a++)t+=e[a];return t/e.length}o(t,"_iterate"),e._iterate=t,o(a,"_lumaValuesForWindow"),o(n,"_averageLuma")}(a||(a={}))}(a||(a={})),t.exports=a})),tU=l(((e,t)=>{J();var a=eU(),n=-1,r=5-n,i=Math.log((3-n)/r);function s(e){let t=e/1e3;return r*Math.exp(i*t)+n}function l(e,t,a){let n,r=0,i=0,o=e.getHistogram(),s=t.getHistogram(),l=a.getHistogram();for(let e=0;e<3;e++)for(let t=0;t<256;t++){let a=o[e][t],n=s[e][t],c=l[e][t],u=Math.abs(a-n),d=Math.abs(c-n);i+=Math.min(u,d),r+=d}return n=0===i&&0===r?100:Math.floor(i/r*100),n}function c(e,t,a,n,r,i){if(!n)return void e.forEach((e=>i(e,r(e),!1)));let o=e[t],l=e[a],u=l.getTimeStamp()-o.getTimeStamp(),d=r(o),m=r(l);if(i(o,d,!1),i(l,m,!1),Math.abs(d-m)<s(u))for(let n=t+1;n<a;n++)i(e[n],d,!0);else if(a-t>1){let o=Math.floor((t+a)/2);c(e,t,o,n,r,i),c(e,o,a,n,r,i)}}function u(e,t){let a=e[0],n=e[e.length-1];function r(e){return"number"==typeof e.getProgress()?e.getProgress():l(e,a,n)}function i(e,t,a){return e.setProgress(t,a)}return o(r,"getProgress"),o(i,"setProgress"),c(e,0,e.length-1,t&&t.fastMode,r,i),e}function d(e,t){let n={channels:4},r=Object.assign(e.getParsedImage(),n),i=Object.assign(t.getParsedImage(),n);return a.compare(r,i).ssim}function m(e,t){let a=e[0],n=e[e.length-1],r=d(a,n);function i(e){if("number"==typeof e.getPerceptualProgress())return e.getPerceptualProgress();let t=d(e,n);return Math.max(100*(t-r)/(1-r),0)}function s(e,t,a){return e.setPerceptualProgress(t,a)}return o(i,"getProgress"),o(s,"setProgress"),c(e,0,e.length-1,t&&t.fastMode,i,s),e}function p(e,t){let a,n,r="number"==typeof e[0].getProgress(),i="number"==typeof e[0].getPerceptualProgress(),o=r?"getProgress":"getPerceptualProgress",s=t.startTs;for(let t=0;t<e.length&&!n;t++)e[t][o]()>0&&(n=e[t].getTimeStamp());for(let t=0;t<e.length&&!a;t++)e[t][o]()>=100&&(a=e[t].getTimeStamp());let l=e[0].getTimeStamp(),c=e[0].getProgress(),u=e[0].getPerceptualProgress(),d=n-s,m=n-s;return e.forEach((function(e){if(e.getTimeStamp()>n){let t=e.getTimeStamp()-l;d+=t*(1-c),m+=t*(1-u)}l=e.getTimeStamp(),c=e.getProgress()/100,u=e.getPerceptualProgress()/100})),d=r?d:void 0,m=i?m:void 0,{firstPaintTs:n,visuallyCompleteTs:a,speedIndex:d,perceptualSpeedIndex:m}}o(s,"calculateFastModeAllowableChange"),o(l,"calculateFrameProgress"),o(c,"calculateProgressBetweenFrames"),o(u,"calculateVisualProgress"),o(d,"calculateFrameSimilarity"),o(m,"calculatePerceptualProgress"),o(p,"calculateSpeedIndexes"),t.exports={calculateFastModeAllowableChange:s,calculateFrameSimilarity:d,calculateVisualProgress:u,calculatePerceptualProgress:m,calculateSpeedIndexes:p}})),aU=l(((e,t)=>{J();var a=Qj(),n=tU();function r(e,t){let a=n.calculateSpeedIndexes(e,t),r=Math.floor(t.endTs-t.startTs),i=Math.floor(a.firstPaintTs-t.startTs),o=Math.floor(a.visuallyCompleteTs-t.startTs);return{beginning:t.startTs,end:t.endTs,frames:e,first:i,complete:o,duration:r,speedIndex:a.speedIndex,perceptualSpeedIndex:a.perceptualSpeedIndex}}o(r,"calculateValues");var i={All:"all",pSI:"perceptualSpeedIndex",SI:"speedIndex"};t.exports=function(e,t){let o=t&&t.include||i.All;if(!Object.keys(i).some((e=>i[e]===o)))throw new Error(`Unrecognized include option: ${o}`);return a.extractFramesFromTimeline(e,t).then((function(e){let a=e.frames;return(o===i.All||o===i.SI)&&n.calculateVisualProgress(a,t),(o===i.All||o===i.pSI)&&n.calculatePerceptualProgress(a,t),r(a,e)}))}})),nU=s((()=>{J(),Fj=d(aU(),1),Bc(),xl(),Hc(),Nj=class{static{o(this,"Speedline")}static async compute_(e,t){return kc.request(e,t).then((t=>{let a=e.traceEvents.slice(),n=t.timestamps.timeOrigin;return(0,Fj.default)(a,{timeOrigin:n,fastMode:!0,include:"speedIndex"})})).catch((e=>{throw/No screenshots found in trace/.test(e.message)?new El(El.errors.NO_SCREENSHOTS):e})).then((e=>{if(0===e.frames.length)throw new El(El.errors.NO_SPEEDLINE_FRAMES);if(0===e.speedIndex)throw new El(El.errors.SPEEDINDEX_OF_ZERO);return e}))}},Ij=dc(Nj,null)})),rU=s((()=>{J(),Bc(),MF(),Mj=class extends AF{static{o(this,"FirstContentfulPaintAllFrames")}static computeSimulatedMetric(){throw new Error("FCP All Frames not implemented in lantern")}static async computeObservedMetric(e){let{processedNavigation:t}=e;return{timing:t.timings.firstContentfulPaintAllFrames,timestamp:t.timestamps.firstContentfulPaintAllFrames}}},Pj=dc(Mj,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),iU=s((()=>{J(),Bc(),MF(),xl(),jR(),Lj=class extends AF{static{o(this,"FirstMeaningfulPaint")}static computeSimulatedMetric(e,t){let a=AF.getMetricComputationInput(e);return kR.request(a,t)}static async computeObservedMetric(e){let{processedNavigation:t}=e;if(void 0===t.timings.firstMeaningfulPaint)throw new El(El.errors.NO_FMP);return{timing:t.timings.firstMeaningfulPaint,timestamp:t.timestamps.firstMeaningfulPaint}}},Oj=dc(Lj,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),oU=s((()=>{J(),Bc(),MF(),xl(),jj=class extends AF{static{o(this,"LargestContentfulPaintAllFrames")}static async computeSimulatedMetric(){throw new Error("LCP All Frames not implemented in lantern")}static async computeObservedMetric(e){let{processedNavigation:t}=e;if(void 0===t.timings.largestContentfulPaintAllFrames)throw new El(El.errors.NO_LCP_ALL_FRAMES);return{timing:t.timings.largestContentfulPaintAllFrames,timestamp:t.timestamps.largestContentfulPaintAllFrames}}},Uj=dc(jj,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),sU=s((()=>{J(),Bc(),LR(),Cl(),nU(),OR(),oc(),Bj=class e extends ER{static{o(this,"LanternSpeedIndex")}static get COEFFICIENTS(){return{intercept:-250,optimistic:1.4,pessimistic:.65}}static getScaledCoefficients(e){let t=this.COEFFICIENTS,a=$l.mobileSlow4G.rttMs-30,n=Math.max((e-30)/a,0);return{intercept:t.intercept*n,optimistic:.5+(t.optimistic-.5)*n,pessimistic:.5+(t.pessimistic-.5)*n}}static getOptimisticGraph(e){return e}static getPessimisticGraph(e){return e}static getEstimateFromSimulation(t,a){if(!a.fcpResult)throw new Error("missing fcpResult");if(!a.speedline)throw new Error("missing speedline");let n=a.fcpResult.pessimisticEstimate.timeInMs;return{timeInMs:a.optimistic?a.speedline.speedIndex:e.computeLayoutBasedSpeedIndex(t.nodeTimings,n),nodeTimings:t.nodeTimings}}static async compute_(e,t){let a=await Ij.request(e.trace,t),n=await SR.request(e,t),r=await this.computeMetricWithGraphs(e,t,{speedline:a,fcpResult:n});return r.timing=Math.max(r.timing,n.timing),r}static computeLayoutBasedSpeedIndex(e,t){let a=[];for(let[t,n]of e.entries())if(t.type===fl.TYPES.CPU&&t.childEvents.some((e=>"Layout"===e.name))){let e=Math.max(Math.log2(n.endTime-n.startTime),0);a.push({time:n.endTime,weight:e})}let n=a.map((e=>e.weight*Math.max(e.time,t))).reduce(((e,t)=>e+t),0),r=a.map((e=>e.weight)).reduce(((e,t)=>e+t),0);return r?n/r:t}},qj=dc(Bj,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),lU=s((()=>{J(),Bc(),MF(),sU(),nU(),zj=class extends AF{static{o(this,"SpeedIndex")}static computeSimulatedMetric(e,t){let a=AF.getMetricComputationInput(e);return qj.request(a,t)}static async computeObservedMetric(e,t){let a=await Ij.request(e.trace,t),n=Math.round(a.speedIndex),r=1e3*(n+a.beginning);return Promise.resolve({timing:n,timestamp:r})}},Vj=dc(zj,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),cU=s((()=>{J(),Bc(),LR(),Cl(),OR(),Wj=class e extends ER{static{o(this,"LanternMaxPotentialFID")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e){return e}static getPessimisticGraph(e){return e}static getEstimateFromSimulation(t,a){if(!a.fcpResult)throw new Error("missing fcpResult");let n=a.optimistic?a.fcpResult.pessimisticEstimate.timeInMs:a.fcpResult.optimisticEstimate.timeInMs,r=e.getTimingsAfterFCP(t.nodeTimings,n);return{timeInMs:Math.max(...r.map((e=>e.duration)),16),nodeTimings:t.nodeTimings}}static async compute_(e,t){let a=await SR.request(e,t);return super.computeMetricWithGraphs(e,t,{fcpResult:a})}static getTimingsAfterFCP(e,t){return Array.from(e.entries()).filter((([e,a])=>e.type===fl.TYPES.CPU&&a.endTime>t)).map((([e,t])=>t))}},Hj=dc(Wj,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),uU=s((()=>{J(),Bc(),MF(),cU(),na(),Gj=class extends AF{static{o(this,"MaxPotentialFID")}static computeSimulatedMetric(e,t){let a=AF.getMetricComputationInput(e);return Hj.request(a,t)}static computeObservedMetric(e){let{firstContentfulPaint:t}=e.processedNavigation.timings,a=Xt.getMainThreadTopLevelEvents(e.processedTrace,t).filter((e=>e.duration>=1));return Promise.resolve({timing:Math.max(...a.map((e=>e.duration)),16)})}},$j=dc(Gj,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])}));function dU(e,t,a,n){let r=50;if(n&&(r*=e.duration/n.duration),e.duration<r||e.end<t||e.start>a)return 0;let i=Math.max(e.start,t),o=Math.min(e.end,a)-i;return o<r?0:o-r}function mU(e,t,a){if(a<=t)return 0;let n=0;for(let r of e)n+=dU(r,t,a);return n}var pU,hU,gU,fU,yU,vU,bU=s((()=>{J(),o(dU,"calculateTbtImpactForEvent"),o(mU,"calculateSumOfBlockingTime")})),wU=s((()=>{J(),Bc(),LR(),Cl(),OR(),UR(),bU(),pU=class e extends ER{static{o(this,"LanternTotalBlockingTime")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e){return e}static getPessimisticGraph(e){return e}static getEstimateFromSimulation(t,a){if(!a.fcpResult)throw new Error("missing fcpResult");if(!a.interactiveResult)throw new Error("missing interactiveResult");let n=a.optimistic?a.fcpResult.pessimisticEstimate.timeInMs:a.fcpResult.optimisticEstimate.timeInMs,r=a.optimistic?a.interactiveResult.optimisticEstimate.timeInMs:a.interactiveResult.pessimisticEstimate.timeInMs;return{timeInMs:mU(e.getTopLevelEvents(t.nodeTimings,50),n,r),nodeTimings:t.nodeTimings}}static async compute_(e,t){let a=await SR.request(e,t),n=await AR.request(e,t);return this.computeMetricWithGraphs(e,t,{fcpResult:a,interactiveResult:n})}static getTopLevelEvents(e,t){let a=[];for(let[n,r]of e.entries())n.type===fl.TYPES.CPU&&(r.duration<t||a.push({start:r.startTime,end:r.endTime,duration:r.duration}));return a}},hU=dc(pU,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),DU=s((()=>{J(),Bc(),IF(),na(),wU(),PF(),bU(),gU=class extends xF{static{o(this,"TotalBlockingTime")}static computeSimulatedMetric(e,t){let a=xF.getMetricComputationInput(e);return hU.request(a,t)}static async computeObservedMetric(e,t){let a=Xt.getMainThreadTopLevelEvents(e.processedTrace);if(e.processedNavigation){let{firstContentfulPaint:n}=e.processedNavigation.timings,r=xF.getMetricComputationInput(e);return{timing:mU(a,n,(await FF.request(r,t)).timing)}}return{timing:mU(a,0,e.processedTrace.timings.traceEnd)}}},fU=dc(gU,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])})),EU=s((()=>{J(),Hc(),yD(),nU(),KF(),rU(),iU(),EO(),oU(),PF(),bD(),lU(),uU(),DU(),Bc(),TO(),SO(),yU=class e{static{o(this,"TimingSummary")}static async summarize(e,t,a,n,r,i){let s={trace:e,devtoolsLog:t,gatherContext:a,settings:n,URL:r},l=o(((e,t)=>e.request(t,i).catch((e=>{}))),"requestOrUndefined"),c=await kc.request(e,i),u=await l(lD,e),d=await Ij.request(e,i),m=await l(HF,s),p=await l(Pj,s),h=await l(Oj,s),g=await l(fO,s),f=await l(Uj,s),y=await l(FF,s),v=await l(gD,e),b=await l($j,s),w=await l(Vj,s),D=await l(fU,s),E=await l(wO,s),T=await l(vO,s),{cumulativeLayoutShift:S,cumulativeLayoutShiftMainFrame:C}=v||{};return{metrics:{firstContentfulPaint:m?.timing,firstContentfulPaintTs:m?.timestamp,firstContentfulPaintAllFrames:p?.timing,firstContentfulPaintAllFramesTs:p?.timestamp,firstMeaningfulPaint:h?.timing,firstMeaningfulPaintTs:h?.timestamp,largestContentfulPaint:g?.timing,largestContentfulPaintTs:g?.timestamp,largestContentfulPaintAllFrames:f?.timing,largestContentfulPaintAllFramesTs:f?.timestamp,interactive:y?.timing,interactiveTs:y?.timestamp,speedIndex:w?.timing,speedIndexTs:w?.timestamp,totalBlockingTime:D?.timing,maxPotentialFID:b?.timing,cumulativeLayoutShift:S,cumulativeLayoutShiftMainFrame:C,lcpLoadStart:E?.loadStart,lcpLoadEnd:E?.loadEnd,timeToFirstByte:T?.timing,timeToFirstByteTs:T?.timestamp,observedTimeOrigin:c.timings.timeOrigin,observedTimeOriginTs:c.timestamps.timeOrigin,observedNavigationStart:u?.timings.timeOrigin,observedNavigationStartTs:u?.timestamps.timeOrigin,observedFirstPaint:u?.timings.firstPaint,observedFirstPaintTs:u?.timestamps.firstPaint,observedFirstContentfulPaint:u?.timings.firstContentfulPaint,observedFirstContentfulPaintTs:u?.timestamps.firstContentfulPaint,observedFirstContentfulPaintAllFrames:u?.timings.firstContentfulPaintAllFrames,observedFirstContentfulPaintAllFramesTs:u?.timestamps.firstContentfulPaintAllFrames,observedFirstMeaningfulPaint:u?.timings.firstMeaningfulPaint,observedFirstMeaningfulPaintTs:u?.timestamps.firstMeaningfulPaint,observedLargestContentfulPaint:u?.timings.largestContentfulPaint,observedLargestContentfulPaintTs:u?.timestamps.largestContentfulPaint,observedLargestContentfulPaintAllFrames:u?.timings.largestContentfulPaintAllFrames,observedLargestContentfulPaintAllFramesTs:u?.timestamps.largestContentfulPaintAllFrames,observedTraceEnd:c.timings.traceEnd,observedTraceEndTs:c.timestamps.traceEnd,observedLoad:u?.timings.load,observedLoadTs:u?.timestamps.load,observedDomContentLoaded:u?.timings.domContentLoaded,observedDomContentLoadedTs:u?.timestamps.domContentLoaded,observedCumulativeLayoutShift:S,observedCumulativeLayoutShiftMainFrame:C,observedFirstVisualChange:d.first,observedFirstVisualChangeTs:1e3*(d.first+d.beginning),observedLastVisualChange:d.complete,observedLastVisualChangeTs:1e3*(d.complete+d.beginning),observedSpeedIndex:d.speedIndex,observedSpeedIndexTs:1e3*(d.speedIndex+d.beginning)},debugInfo:{lcpInvalidated:!!u?.lcpInvalidated}}}static async compute_(t,a){return e.summarize(t.trace,t.devtoolsLog,t.gatherContext,t.settings,t.URL,a)}},vU=dc(yU,["devtoolsLog","gatherContext","settings","trace","URL"])})),TU={};c(TU,{default:()=>kU});var SU,CU,kU,xU=s((()=>{J(),xr(),EU(),SU=new Set(["cumulativeLayoutShift","cumulativeLayoutShiftMainFrame","observedCumulativeLayoutShift","observedCumulativeLayoutShiftMainFrame"]),CU=class extends Dr{static{o(this,"Metrics")}static get meta(){return{id:"metrics",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:"Metrics",description:"Collects all available metrics.",supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static async audit(e,t){let a=e.GatherContext,n=e.traces[Dr.DEFAULT_PASS],r=e.devtoolsLogs[Dr.DEFAULT_PASS],i=e.URL,o=await vU.request({trace:n,devtoolsLog:r,gatherContext:a,settings:t.settings,URL:i},t),s=o.metrics,l=o.debugInfo;for(let[e,t]of Object.entries(s)){let a=e;"number"==typeof t&&!SU.has(a)&&(s[a]=Math.round(t))}let c={type:"debugdata",items:[s,l]};return{score:1,numericValue:s.interactive||0,numericUnit:"millisecond",details:c}}},kU=CU})),AU={};c(AU,{UIStrings:()=>_U,default:()=>NU});var _U,RU,FU,NU,IU=s((()=>{J(),xr(),bD(),ro(),RU=eo("core/audits/metrics/cumulative-layout-shift.js",_U={description:"Cumulative Layout Shift measures the movement of visible elements within the viewport. [Learn more about the Cumulative Layout Shift metric](https://web.dev/cls/)."}),FU=class extends Dr{static{o(this,"CumulativeLayoutShift")}static get meta(){return{id:"cumulative-layout-shift",title:RU(no.cumulativeLayoutShiftMetric),description:RU(_U.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["traces"]}}static get defaultOptions(){return{p10:.1,median:.25}}static async audit(e,t){let a=e.traces[Dr.DEFAULT_PASS],{cumulativeLayoutShift:n,...r}=await gD.request(a,t),i={type:"debugdata",items:[r]};return{score:Dr.computeLogNormalScore({p10:t.options.p10,median:t.options.median},n),numericValue:n,numericUnit:"unitless",displayValue:n.toLocaleString(t.settings.locale),details:i}}},NU=FU})),MU={};c(MU,{UIStrings:()=>PU,default:()=>jU});var PU,LU,OU,jU,UU=s((()=>{J(),xr(),ro(),KF(),LU=eo("core/audits/metrics/first-contentful-paint.js",PU={description:"First Contentful Paint marks the time at which the first text or image is painted. [Learn more about the First Contentful Paint metric](https://developer.chrome.com/docs/lighthouse/performance/first-contentful-paint/)."}),OU=class extends Dr{static{o(this,"FirstContentfulPaint")}static get meta(){return{id:"first-contentful-paint",title:LU(no.firstContentfulPaintMetric),description:LU(PU.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:1800,median:3e3}},desktop:{scoring:{p10:934,median:1600}}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings,URL:e.URL},n=await HF.request(a,t),r=t.options[t.settings.formFactor];return{score:Dr.computeLogNormalScore(r.scoring,n.timing),numericValue:n.timing,numericUnit:"millisecond",displayValue:LU(no.seconds,{timeInMs:n.timing})}}},jU=OU})),BU={};c(BU,{UIStrings:()=>qU,default:()=>WU});var qU,zU,VU,WU,HU=s((()=>{J(),xr(),ro(),iU(),zU=eo("core/audits/metrics/first-meaningful-paint.js",qU={description:"First Meaningful Paint measures when the primary content of a page is visible. [Learn more about the First Meaningful Paint metric](https://developer.chrome.com/docs/lighthouse/performance/first-meaningful-paint/)."}),VU=class extends Dr{static{o(this,"FirstMeaningfulPaint")}static get meta(){return{id:"first-meaningful-paint",title:zU(no.firstMeaningfulPaintMetric),description:zU(qU.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:2336,median:4e3}},desktop:{scoring:{p10:934,median:1600}}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings,URL:e.URL},n=await Oj.request(a,t),r=t.options[t.settings.formFactor];return{score:Dr.computeLogNormalScore(r.scoring,n.timing),numericValue:n.timing,numericUnit:"millisecond",displayValue:zU(no.seconds,{timeInMs:n.timing})}}},WU=VU})),GU={};c(GU,{UIStrings:()=>$U,default:()=>JU});var $U,KU,YU,JU,ZU=s((()=>{J(),xr(),vD(),ro(),KU=eo("core/audits/metrics/interaction-to-next-paint.js",$U={description:"Interaction to Next Paint measures page responsiveness, how long it takes the page to visibly respond to user input. [Learn more about the Interaction to Next Paint metric](https://web.dev/inp/)."}),YU=class extends Dr{static{o(this,"InteractionToNextPaint")}static get meta(){return{id:"interaction-to-next-paint",title:KU(no.interactionToNextPaint),description:KU($U.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["timespan"],requiredArtifacts:["traces"]}}static get defaultOptions(){return{p10:200,median:500}}static async audit(e,t){let{settings:a}=t;if("simulate"===a.throttlingMethod)return{score:null,notApplicable:!0};let n={trace:e.traces[Dr.DEFAULT_PASS],settings:a},r=await pD.request(n,t);if(null===r)return{score:null,notApplicable:!0};let i="FallbackTiming"===r.name?r.duration:r.args.data.duration;return{score:Dr.computeLogNormalScore({p10:t.options.p10,median:t.options.median},i),numericValue:i,numericUnit:"millisecond",displayValue:KU(no.ms,{timeInMs:i})}}},JU=YU})),XU={};c(XU,{UIStrings:()=>QU,default:()=>aB});var QU,eB,tB,aB,nB=s((()=>{J(),xr(),ro(),PF(),eB=eo("core/audits/metrics/interactive.js",QU={description:"Time to Interactive is the amount of time it takes for the page to become fully interactive. [Learn more about the Time to Interactive metric](https://developer.chrome.com/docs/lighthouse/performance/interactive/)."}),tB=class extends Dr{static{o(this,"InteractiveMetric")}static get meta(){return{id:"interactive",title:eB(no.interactiveMetric),description:eB(QU.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:3785,median:7300}},desktop:{scoring:{p10:2468,median:4500}}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings,URL:e.URL},n=(await FF.request(a,t)).timing,r=t.options[t.settings.formFactor];return{score:Dr.computeLogNormalScore(r.scoring,n),numericValue:n,numericUnit:"millisecond",displayValue:eB(no.seconds,{timeInMs:n})}}},aB=tB})),rB={};c(rB,{UIStrings:()=>iB,default:()=>lB});var iB,oB,sB,lB,cB=s((()=>{J(),xr(),ro(),EO(),oB=eo("core/audits/metrics/largest-contentful-paint.js",iB={description:"Largest Contentful Paint marks the time at which the largest text or image is painted. [Learn more about the Largest Contentful Paint metric](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-largest-contentful-paint/)"}),sB=class extends Dr{static{o(this,"LargestContentfulPaint")}static get meta(){return{id:"largest-contentful-paint",title:oB(no.largestContentfulPaintMetric),description:oB(iB.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["HostUserAgent","traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:2500,median:4e3}},desktop:{scoring:{p10:1200,median:2400}}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings,URL:e.URL},n=await fO.request(a,t),r=t.options[t.settings.formFactor];return{score:Dr.computeLogNormalScore(r.scoring,n.timing),numericValue:n.timing,numericUnit:"millisecond",displayValue:oB(no.seconds,{timeInMs:n.timing})}}},lB=sB})),uB={};c(uB,{UIStrings:()=>dB,default:()=>hB});var dB,mB,pB,hB,gB=s((()=>{J(),xr(),uU(),ro(),mB=eo("core/audits/metrics/max-potential-fid.js",dB={description:"The maximum potential First Input Delay that your users could experience is the duration of the longest task. [Learn more about the Maximum Potential First Input Delay metric](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-max-potential-fid/)."}),pB=class extends Dr{static{o(this,"MaxPotentialFID")}static get meta(){return{id:"max-potential-fid",title:mB(no.maxPotentialFIDMetric),description:mB(dB.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{p10:130,median:250}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings,URL:e.URL},n=await $j.request(a,t);return{score:Dr.computeLogNormalScore({p10:t.options.p10,median:t.options.median},n.timing),numericValue:n.timing,numericUnit:"millisecond",displayValue:mB(no.ms,{timeInMs:n.timing})}}},hB=pB})),fB={};c(fB,{UIStrings:()=>yB,default:()=>wB});var yB,vB,bB,wB,DB=s((()=>{J(),xr(),ro(),lU(),vB=eo("core/audits/metrics/speed-index.js",yB={description:"Speed Index shows how quickly the contents of a page are visibly populated. [Learn more about the Speed Index metric](https://developer.chrome.com/docs/lighthouse/performance/speed-index/)."}),bB=class extends Dr{static{o(this,"SpeedIndex")}static get meta(){return{id:"speed-index",title:vB(no.speedIndexMetric),description:vB(yB.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:3387,median:5800}},desktop:{scoring:{p10:1311,median:2300}}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings,URL:e.URL},n=await Vj.request(a,t),r=t.options[t.settings.formFactor];return{score:Dr.computeLogNormalScore(r.scoring,n.timing),numericValue:n.timing,numericUnit:"millisecond",displayValue:vB(no.seconds,{timeInMs:n.timing})}}},wB=bB})),EB={};c(EB,{UIStrings:()=>TB,default:()=>kB});var TB,SB,CB,kB,xB=s((()=>{J(),xr(),DU(),ro(),SB=eo("core/audits/metrics/total-blocking-time.js",TB={description:"Sum of all time periods between FCP and Time to Interactive, when task length exceeded 50ms, expressed in milliseconds. [Learn more about the Total Blocking Time metric](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-total-blocking-time/)."}),CB=class extends Dr{static{o(this,"TotalBlockingTime")}static get meta(){return{id:"total-blocking-time",title:SB(no.totalBlockingTimeMetric),description:SB(TB.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:200,median:600}},desktop:{scoring:{p10:150,median:350}}}}static async audit(e,t){let a=e.traces[Dr.DEFAULT_PASS],n=e.devtoolsLogs[Dr.DEFAULT_PASS],r=e.GatherContext,i={trace:a,devtoolsLog:n,gatherContext:r,settings:t.settings,URL:e.URL};if("timespan"===r.gatherMode&&"simulate"===t.settings.throttlingMethod)return{score:1,notApplicable:!0};let o=await fU.request(i,t),s=t.options[t.settings.formFactor];return{score:Dr.computeLogNormalScore(s.scoring,o.timing),numericValue:o.timing,numericUnit:"millisecond",displayValue:SB(no.ms,{timeInMs:o.timing})}}},kB=CB})),AB={};c(AB,{default:()=>RB});var _B,RB,FB=s((()=>{J(),xr(),ql(),Yc(),fb(),Uu(),_B=class extends Dr{static{o(this,"NetworkRequests")}static get meta(){return{id:"network-requests",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:"Network Requests",description:"Lists the network requests that were made during page load.",requiredArtifacts:["devtoolsLogs","URL","GatherContext"]}}static async audit(e,t){let a,n=e.devtoolsLogs[Dr.DEFAULT_PASS],r=await Pc.request(n,t),i=await Pu.request({URL:e.URL,devtoolsLog:n},t),s=r.reduce(((e,t)=>Math.min(e,t.rendererStartTime)),1/0);"navigation"===e.GatherContext.gatherMode&&(a=(await pb.request({devtoolsLog:n,URL:e.URL},t)).frameId);let l=o((e=>e<s||!Number.isFinite(e)?void 0:e-s),"normalizeTime"),c=r.map((e=>{let t=e.lrStatistics?.endTimeDeltaMs,n=e.lrStatistics?.TCPMs,r=e.lrStatistics?.requestMs,o=e.lrStatistics?.responseMs,s=e.isLinkPreload||void 0,c=a&&e.frameId===a||void 0,u=i.entityByUrl.get(e.url);return{url:Ml.elideDataURI(e.url),sessionTargetType:e.sessionTargetType,protocol:e.protocol,rendererStartTime:l(e.rendererStartTime),networkRequestTime:l(e.networkRequestTime),networkEndTime:l(e.networkEndTime),finished:e.finished,transferSize:e.transferSize,resourceSize:e.resourceSize,statusCode:e.statusCode,mimeType:e.mimeType,resourceType:e.resourceType,priority:e.priority,isLinkPreload:s,experimentalFromMainFrame:c,entity:u?.name,lrEndTimeDeltaMs:t,lrTCPMs:n,lrRequestMs:r,lrResponseMs:o}})),u=Dr.makeTableDetails([{key:"url",valueType:"url",label:"URL"},{key:"protocol",valueType:"text",label:"Protocol"},{key:"networkRequestTime",valueType:"ms",granularity:1,label:"Network Request Time"},{key:"networkEndTime",valueType:"ms",granularity:1,label:"Network End Time"},{key:"transferSize",valueType:"bytes",displayUnit:"kb",granularity:1,label:"Transfer Size"},{key:"resourceSize",valueType:"bytes",displayUnit:"kb",granularity:1,label:"Resource Size"},{key:"statusCode",valueType:"text",label:"Status Code"},{key:"mimeType",valueType:"text",label:"MIME Type"},{key:"resourceType",valueType:"text",label:"Resource Type"}],c),d=Number.isFinite(s)?1e3*s:void 0;return u.debugData={type:"debugdata",networkStartTimeTs:d},{score:1,details:u}}},RB=_B})),NB={};c(NB,{UIStrings:()=>IB,default:()=>LB});var IB,MB,PB,LB,OB=s((()=>{J(),xr(),ro(),Yc(),Jc(),MB=eo("core/audits/network-rtt.js",IB={title:"Network Round Trip Times",description:"Network round trip times (RTT) have a large impact on performance. If the RTT to an origin is high, it's an indication that servers closer to the user could improve performance. [Learn more about the Round Trip Time](https://hpbn.co/primer-on-latency-and-bandwidth/)."}),PB=class extends Dr{static{o(this,"NetworkRTT")}static get meta(){return{id:"network-rtt",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:MB(IB.title),description:MB(IB.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS];if(!(await Pc.request(a,t)).length)return{score:1,notApplicable:!0};let n=await Oc.request(a,t),r=0,i=n.rtt,o=[];for(let[e,t]of n.additionalRttByOrigin.entries()){if(!e.startsWith("http"))continue;let a=t+i;o.push({origin:e,rtt:a}),r=Number.isFinite(a)?Math.max(a,r):r}o.sort(((e,t)=>t.rtt-e.rtt));let s=[{key:"origin",valueType:"text",label:MB(no.columnURL)},{key:"rtt",valueType:"ms",granularity:1,label:MB(no.columnTimeSpent)}],l=Dr.makeTableDetails(s,o,{sortedBy:["rtt"]});return{score:1,numericValue:r,numericUnit:"millisecond",displayValue:MB(no.ms,{timeInMs:r}),details:l}}},LB=PB})),jB={};c(jB,{UIStrings:()=>UB,default:()=>zB});var UB,BB,qB,zB,VB=s((()=>{J(),xr(),ro(),Yc(),Jc(),BB=eo("core/audits/network-server-latency.js",UB={title:"Server Backend Latencies",description:"Server latencies can impact web performance. If the server latency of an origin is high, it's an indication the server is overloaded or has poor backend performance. [Learn more about server response time](https://hpbn.co/primer-on-web-performance/#analyzing-the-resource-waterfall)."}),qB=class extends Dr{static{o(this,"NetworkServerLatency")}static get meta(){return{id:"network-server-latency",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:BB(UB.title),description:BB(UB.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS];if(!(await Pc.request(a,t)).length)return{score:1,notApplicable:!0};let n=await Oc.request(a,t),r=0,i=[];for(let[e,t]of n.serverResponseTimeByOrigin.entries())e.startsWith("http")&&(r=Math.max(t,r),i.push({origin:e,serverResponseTime:t}));i.sort(((e,t)=>t.serverResponseTime-e.serverResponseTime));let o=[{key:"origin",valueType:"text",label:BB(no.columnURL)},{key:"serverResponseTime",valueType:"ms",granularity:1,label:BB(no.columnTimeSpent)}],s=Dr.makeTableDetails(o,i,{sortedBy:["serverResponseTime"]});return{score:Math.max(1-r/500,0),numericValue:r,numericUnit:"millisecond",displayValue:BB(no.ms,{timeInMs:r}),details:s}}},zB=qB})),WB={};c(WB,{UIStrings:()=>HB,default:()=>KB});var HB,GB,$B,KB,YB=s((()=>{J(),xr(),YR(),ro(),GB=eo("core/audits/no-unload-listeners.js",HB={title:"Avoids `unload` event listeners",failureTitle:"Registers an `unload` listener",description:"The `unload` event does not fire reliably and listening for it can prevent browser optimizations like the Back-Forward Cache. Use `pagehide` or `visibilitychange` events instead. [Learn more about unload event listeners](https://web.dev/bfcache/#never-use-the-unload-event)"}),$B=class extends Dr{static{o(this,"NoUnloadListeners")}static get meta(){return{id:"no-unload-listeners",title:GB(HB.title),failureTitle:GB(HB.failureTitle),description:GB(HB.description),requiredArtifacts:["GlobalListeners","SourceMaps","Scripts"]}}static async audit(e,t){let a=e.GlobalListeners.filter((e=>"unload"===e.type));if(!a.length)return{score:1};let n=await GR.request(e,t),r=[{key:"source",valueType:"source-location",label:GB(no.columnSource)}],i=a.map((t=>{let{lineNumber:a,columnNumber:r}=t,i=e.Scripts.find((e=>e.scriptId===t.scriptId));if(!i)return{source:{type:"url",value:`(unknown):${a}:${r}`}};let o=n.find((e=>e.script.scriptId===i.scriptId));return{source:Dr.makeSourceLocation(i.url,a,r,o)}}));return{score:0,details:Dr.makeTableDetails(r,i)}}},KB=$B})),JB={};function ZB(e,t){return eq.filter((t=>e&t.flag)).map((e=>e.text===XB.unsupportedCSSProperty?QB(e.text,{propertyCount:t.length,properties:t.join(", ")}):QB(e.text)))}c(JB,{UIStrings:()=>XB,default:()=>aq});var XB,QB,eq,tq,aq,nq=s((()=>{J(),xr(),ro(),QB=eo("core/audits/non-composited-animations.js",XB={title:"Avoid non-composited animations",description:"Animations which are not composited can be janky and increase CLS. [Learn how to avoid non-composited animations](https://developer.chrome.com/docs/lighthouse/performance/non-composited-animations/)",displayValue:"{itemCount, plural,\n  =1 {# animated element found}\n  other {# animated elements found}\n  }",unsupportedCSSProperty:"{propertyCount, plural,\n    =1 {Unsupported CSS Property: {properties}}\n    other {Unsupported CSS Properties: {properties}}\n  }",transformDependsBoxSize:"Transform-related property depends on box size",filterMayMovePixels:"Filter-related property may move pixels",nonReplaceCompositeMode:'Effect has composite mode other than "replace"',incompatibleAnimations:"Target has another animation which is incompatible",unsupportedTimingParameters:"Effect has unsupported timing parameters"}),eq=[{flag:8192,text:XB.unsupportedCSSProperty},{flag:2048,text:XB.transformDependsBoxSize},{flag:4096,text:XB.filterMayMovePixels},{flag:16,text:XB.nonReplaceCompositeMode},{flag:64,text:XB.incompatibleAnimations},{flag:8,text:XB.unsupportedTimingParameters}],o(ZB,"getActionableFailureReasons"),tq=class extends Dr{static{o(this,"NonCompositedAnimations")}static get meta(){return{id:"non-composited-animations",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:QB(XB.title),description:QB(XB.description),requiredArtifacts:["TraceElements","HostUserAgent"]}}static async audit(e){let t=e.HostUserAgent.match(/Chrome\/(\d+)/);if(!t||Number(t[1])<86)return{score:1,notApplicable:!0,metricSavings:{CLS:0}};let a=[],n=!1;e.TraceElements.forEach((e=>{if("animation"!==e.traceEventType)return;let t=e.animations||[],r=new Map;for(let{name:e,failureReasonsMask:a,unsupportedProperties:i}of t){if(!a)continue;let t=ZB(a,i||[]);for(let a of t){e&&(n=!0);let t=r.get(e)||new Set;t.add(a),r.set(e,t)}}if(!r.size)return;let i=[];for(let[e,t]of r)for(let a of t)i.push({failureReason:a,animation:e});a.push({node:Dr.makeNodeItem(e.node),subItems:{type:"subitems",items:i}})}));let r=[{key:"node",valueType:"node",subItemsHeading:{key:"failureReason",valueType:"text"},label:QB(no.columnElement)}];n&&r.push({key:null,valueType:"text",subItemsHeading:{key:"animation",valueType:"text"},label:QB(no.columnName)});let i,o=Dr.makeTableDetails(r,a);return a.length>0&&(i=QB(XB.displayValue,{itemCount:a.length})),{score:0===a.length?1:0,notApplicable:0===a.length,metricSavings:{CLS:0},details:o,displayValue:i}}},aq=tq})),rq={};c(rq,{default:()=>iq});var iq,oq,sq,lq=s((()=>{J(),iq={meta:{id:"oopif-iframe-test-audit",title:"IFrame Elements",failureTitle:"IFrame Elements",description:"Audit to force the inclusion of IFrameElements artifact",requiredArtifacts:["IFrameElements"]},audit:()=>({score:1})}})),cq=s((()=>{J(),Uu(),Bc(),Yc(),qc(),Dm(),kr(),oq=class e{static{o(this,"ResourceSummary")}static determineResourceType(e){return e.resourceType&&{Stylesheet:"stylesheet",Image:"image",Media:"media",Font:"font",Script:"script",Document:"document"}[e.resourceType]||"other"}static summarize(e,t,a,n){let r={stylesheet:{count:0,resourceSize:0,transferSize:0},image:{count:0,resourceSize:0,transferSize:0},media:{count:0,resourceSize:0,transferSize:0},font:{count:0,resourceSize:0,transferSize:0},script:{count:0,resourceSize:0,transferSize:0},document:{count:0,resourceSize:0,transferSize:0},other:{count:0,resourceSize:0,transferSize:0},total:{count:0,resourceSize:0,transferSize:0},"third-party":{count:0,resourceSize:0,transferSize:0}},i=wm.getMatchingBudget(a,t.mainDocumentUrl),o=[];return o=i?.options?.firstPartyHostnames?i.options.firstPartyHostnames:n.firstParty?.domains.map((e=>`*.${e}`))||[`*.${br.getRootDomain(t.finalDisplayedUrl)}`],e.filter((e=>!("other"===this.determineResourceType(e)&&e.url.endsWith("/favicon.ico")||wc.isNonNetworkRequest(e)))).forEach((e=>{let t=this.determineResourceType(e);r[t].count++,r[t].resourceSize+=e.resourceSize,r[t].transferSize+=e.transferSize,r.total.count++,r.total.resourceSize+=e.resourceSize,r.total.transferSize+=e.transferSize,o.some((t=>{let a=new URL(e.url);return t.startsWith("*.")?a.hostname.endsWith(t.slice(2)):a.hostname===t}))||(r["third-party"].count++,r["third-party"].resourceSize+=e.resourceSize,r["third-party"].transferSize+=e.transferSize)})),r}static async compute_(t,a){let n=await Pc.request(t.devtoolsLog,a),r=await Pu.request({URL:t.URL,devtoolsLog:t.devtoolsLog},a);return e.summarize(n,t.URL,t.budgets,r)}},sq=dc(oq,["URL","devtoolsLog","budgets"])})),uq={};c(uq,{UIStrings:()=>dq,default:()=>hq});var dq,mq,pq,hq,gq=s((()=>{J(),xr(),cq(),fb(),Dm(),ro(),mq=eo("core/audits/performance-budget.js",dq={title:"Performance budget",description:"Keep the quantity and size of network requests under the targets set by the provided performance budget. [Learn more about performance budgets](https://developers.google.com/web/tools/lighthouse/audits/budgets).",requestCountOverBudget:"{count, plural,\n    =1 {1 request}\n    other {# requests}\n   }"}),pq=class extends Dr{static{o(this,"ResourceBudget")}static get meta(){return{id:"performance-budget",title:mq(dq.title),description:mq(dq.description),scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","URL"]}}static getRowLabel(e){return{total:no.totalResourceType,document:no.documentResourceType,script:no.scriptResourceType,stylesheet:no.stylesheetResourceType,image:no.imageResourceType,media:no.mediaResourceType,font:no.fontResourceType,other:no.otherResourceType,"third-party":no.thirdPartyResourceType}[e]}static tableItems(e,t){return Object.keys(t).map((a=>{let n,r,i=mq(this.getRowLabel(a)),o=t[a].count,s=t[a].transferSize;if(e.resourceSizes){let t=e.resourceSizes.find((e=>e.resourceType===a));t&&s>1024*t.budget&&(n=s-1024*t.budget)}if(e.resourceCounts){let t=e.resourceCounts.find((e=>e.resourceType===a));if(t&&o>t.budget){let e=o-t.budget;r=mq(dq.requestCountOverBudget,{count:e})}}return{resourceType:a,label:i,requestCount:o,transferSize:s,countOverBudget:r,sizeOverBudget:n}})).filter((t=>!!(e.resourceSizes&&e.resourceSizes.some((e=>e.resourceType===t.resourceType))||e.resourceCounts&&e.resourceCounts.some((e=>e.resourceType===t.resourceType))))).sort(((e,t)=>(t.sizeOverBudget||0)-(e.sizeOverBudget||0)))}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n={devtoolsLog:a,URL:e.URL,budgets:t.settings.budgets},r=await sq.request(n,t),i=await pb.request({URL:e.URL,devtoolsLog:a},t),o=wm.getMatchingBudget(t.settings.budgets,i.url);if(!o)return{score:0,notApplicable:!0};let s=[{key:"label",valueType:"text",label:mq(no.columnResourceType)},{key:"requestCount",valueType:"numeric",label:mq(no.columnRequests)},{key:"transferSize",valueType:"bytes",label:mq(no.columnTransferSize)},{key:"countOverBudget",valueType:"text",label:""},{key:"sizeOverBudget",valueType:"bytes",label:mq(no.columnOverBudget)}];return{details:Dr.makeTableDetails(s,this.tableItems(o,r),{sortedBy:["sizeOverBudget"]}),score:1}}},hq=pq})),fq={};c(fq,{default:()=>bq});var yq,vq,bq,wq=s((()=>{J(),xr(),ro(),OR(),jR(),UR(),sU(),BR(),EU(),oc(),3651,1e4,yq=eo("core/audits/predictive-perf.js",{}),vq=class extends Dr{static{o(this,"PredictivePerf")}static get meta(){return{id:"predictive-perf",title:"Predicted Performance (beta)",description:"Predicted performance evaluates how your site will perform under a cellular connection on a mobile device.",scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static async audit(e,t){let a=e.GatherContext,n=e.traces[Dr.DEFAULT_PASS],r=e.devtoolsLogs[Dr.DEFAULT_PASS],i=e.URL,o={trace:n,devtoolsLog:r,gatherContext:a,settings:JSON.parse(JSON.stringify(Jl)),URL:i},s=await SR.request(o,t),l=await kR.request(o,t),c=await AR.request(o,t),u=await qj.request(o,t),d=await RR.request(o,t),m=await vU.request(o,t),p={roughEstimateOfFCP:s.timing,optimisticFCP:s.optimisticEstimate.timeInMs,pessimisticFCP:s.pessimisticEstimate.timeInMs,roughEstimateOfFMP:l.timing,optimisticFMP:l.optimisticEstimate.timeInMs,pessimisticFMP:l.pessimisticEstimate.timeInMs,roughEstimateOfTTI:c.timing,optimisticTTI:c.optimisticEstimate.timeInMs,pessimisticTTI:c.pessimisticEstimate.timeInMs,roughEstimateOfSI:u.timing,optimisticSI:u.optimisticEstimate.timeInMs,pessimisticSI:u.pessimisticEstimate.timeInMs,roughEstimateOfLCP:d.timing,optimisticLCP:d.optimisticEstimate.timeInMs,pessimisticLCP:d.pessimisticEstimate.timeInMs,roughEstimateOfTTFB:m.metrics.timeToFirstByte,roughEstimateOfLCPLoadStart:m.metrics.lcpLoadStart,roughEstimateOfLCPLoadEnd:m.metrics.lcpLoadEnd};return{score:Dr.computeLogNormalScore({p10:3651,median:1e4},p.roughEstimateOfTTI),numericValue:p.roughEstimateOfTTI,numericUnit:"millisecond",displayValue:yq(no.ms,{timeInMs:p.roughEstimateOfTTI}),details:{type:"debugdata",items:[p]}}}},bq=vq})),Dq={};c(Dq,{UIStrings:()=>Tq,default:()=>kq});var Eq,Tq,Sq,Cq,kq,xq=s((()=>{J(),xr(),ro(),EL(),Yc(),Eq=/^(optional)$/,Sq=eo("core/audits/preload-fonts.js",Tq={title:"Fonts with `font-display: optional` are preloaded",failureTitle:"Fonts with `font-display: optional` are not preloaded",description:"Preload `optional` fonts so first-time visitors may use them. [Learn more about preloading fonts](https://web.dev/preload-optional-fonts/)"}),Cq=class e extends Dr{static{o(this,"PreloadFontsAudit")}static get meta(){return{id:"preload-fonts",title:Sq(Tq.title),failureTitle:Sq(Tq.failureTitle),description:Sq(Tq.description),requiredArtifacts:["devtoolsLogs","URL","CSSUsage"]}}static getURLsAttemptedToPreload(e){let t=e.filter((e=>"Font"===e.resourceType)).filter((e=>e.isLinkPreload)).map((e=>e.url));return new Set(t)}static async audit_(t,a){let n=t.devtoolsLogs[this.DEFAULT_PASS],r=await Pc.request(n,a),i=DL.findFontDisplayDeclarations(t,Eq).passingURLs,o=e.getURLsAttemptedToPreload(r),s=Array.from(i).filter((e=>!o.has(e))).map((e=>({url:e}))),l=[{key:"url",valueType:"url",label:Sq(no.columnURL)}];return{score:s.length>0?0:1,details:Dr.makeTableDetails(l,s),notApplicable:0===i.size}}static async audit(){return{score:1,notApplicable:!0}}},kq=Cq})),Aq={};c(Aq,{UIStrings:()=>_q,default:()=>Nq});var _q,Rq,Fq,Nq,Iq=s((()=>{J(),xr(),ro(),qc(),fb(),BR(),Zc(),zR(),qR(),Rq=eo("core/audits/prioritize-lcp-image.js",_q={title:"Preload Largest Contentful Paint image",description:"If the LCP element is dynamically added to the page, you should preload the image in order to improve LCP. [Learn more about preloading LCP elements](https://web.dev/optimize-lcp/#optimize-when-the-resource-is-discovered)."}),Fq=class e extends Dr{static{o(this,"PrioritizeLcpImage")}static get meta(){return{id:"prioritize-lcp-image",title:Rq(_q.title),description:Rq(_q.description),supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL","TraceElements"],scoreDisplayMode:Dr.SCORING_MODES.NUMERIC}}static shouldPreloadRequest(e,t,a){return!(e.isLinkPreload||wc.isNonNetworkRequest(e)||a.length<=2)&&e.frameId===t.frameId}static findLCPNode(e,t){for(let{node:a}of e.traverseGenerator())if("network"===a.type&&a.record.requestId===t.requestId)return a}static getLcpInitiatorPath(e,t){let a=[],n=!1,r=e;for(;r;){n||=r.requestId===t.requestId;let e=r.initiator?.type??"other";if(r.initiatorRequest&&r.initiatorRequest===r.redirectSource&&(e="redirect"),!r.initiatorRequest&&!n&&(e="fallbackToMain"),a.push({url:r.url,initiatorType:e}),n)break;r=r.initiatorRequest||t}return a}static getLCPNodeToPreload(t,a,n){if(!n)return{};let r=e.findLCPNode(a,n),i=e.getLcpInitiatorPath(n,t);return r?{lcpNodeToPreload:e.shouldPreloadRequest(n,t,i)?r:void 0,initiatorPath:i}:{initiatorPath:i}}static computeWasteWithGraph(e,t,a,n){if(!t)return{wastedMs:0,results:[]};let r=a.cloneWithRelationships(),i=new Set;for(let e of t.getDependencies())i.add(e.id);let o=null,s=null;for(let{node:e}of r.traverseGenerator())"network"===e.type&&(e.isMainDocument()?s=e:e.id===t.id&&(o=e));if(!s)throw new Error("Could not find main document node");if(!o)throw new Error("Could not find the LCP node");o.removeAllDependencies(),o.addDependency(s);let l=n.simulate(a,{flexibleOrdering:!0}),c=n.simulate(r,{flexibleOrdering:!0}),u=l.nodeTimings.get(t);if(!u)throw new Error("Impossible - node timings should never be undefined");let d=c.nodeTimings.get(o);if(!d)throw new Error("Impossible - node timings should never be undefined");let m=Array.from(c.nodeTimings.keys()).reduce(((e,t)=>e.set(t.id,t)),new Map),p=0;for(let e of Array.from(i)){let t=m.get(e);if(!t)throw new Error("Impossible - node should never be undefined");let a=c.nodeTimings.get(t)?.endTime||0;p=Math.max(p,a)}let h=u.endTime-Math.max(d.endTime,p);return{wastedMs:h,results:[{node:Dr.makeNodeItem(e.node),url:t.record.url,wastedMs:h}]}}static async audit(t,a){let n=t.GatherContext,r=t.traces[e.DEFAULT_PASS],i=t.devtoolsLogs[e.DEFAULT_PASS],o=t.URL,s=a.settings,l={trace:r,devtoolsLog:i,gatherContext:n,settings:s,URL:o},c=t.TraceElements.find((e=>"largest-contentful-paint"===e.traceEventType));if(!c||"image"!==c.type)return{score:null,notApplicable:!0,metricSavings:{LCP:0}};let u=await pb.request({devtoolsLog:i,URL:o},a),d=await RR.request(l,a),m=await Uc.request({devtoolsLog:i,settings:s},a),p=await NR.request({trace:r,devtoolsLog:i},a),h=d.pessimisticGraph,{lcpNodeToPreload:g,initiatorPath:f}=e.getLCPNodeToPreload(u,h,p),{results:y,wastedMs:v}=e.computeWasteWithGraph(c,g,h,m),b=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:Rq(no.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:Rq(no.columnWastedMs)}],w=Dr.makeOpportunityDetails(b,y,{overallSavingsMs:v,sortedBy:["wastedMs"]});return f&&(w.debugData={type:"debugdata",initiatorPath:f,pathLength:f.length}),{score:MR.scoreForWastedMs(v),numericValue:v,numericUnit:"millisecond",displayValue:v?Rq(no.displayValueMsSavings,{wastedMs:v}):"",details:w,metricSavings:{LCP:v}}}},Nq=Fq})),Mq={};c(Mq,{UIStrings:()=>Pq,default:()=>jq});var Pq,Lq,Oq,jq,Uq=s((()=>{J(),xr(),zR(),ro(),Hc(),Yc(),UR(),Lq=eo("core/audits/redirects.js",Pq={title:"Avoid multiple page redirects",description:"Redirects introduce additional delays before the page can be loaded. [Learn how to avoid page redirects](https://developer.chrome.com/docs/lighthouse/performance/redirects/)."}),Oq=class e extends Dr{static{o(this,"Redirects")}static get meta(){return{id:"redirects",title:Lq(Pq.title),description:Lq(Pq.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["URL","GatherContext","devtoolsLogs","traces"]}}static getDocumentRequestChain(e,t){let a=[];for(let n of t.processEvents){if("navigationStart"!==n.name)continue;let t=n.args.data||{};if(!t.documentLoaderURL||!t.isLoadingMainFrame)continue;let r=e.find((e=>e.requestId===t.navigationId));for(;r;)a.push(r),r=r.redirectDestination}if(!a.length)throw new Error("No navigation requests found");return a}static async audit(t,a){let n=a.settings,r=t.traces[Dr.DEFAULT_PASS],i=t.devtoolsLogs[Dr.DEFAULT_PASS],o=t.GatherContext,s=await kc.request(r,a),l=await Pc.request(i,a),c={trace:r,devtoolsLog:i,gatherContext:o,settings:n,URL:t.URL},u=await AR.request(c,a),d=new Map;for(let[e,t]of u.pessimisticEstimate.nodeTimings.entries())"network"===e.type&&d.set(e.record.requestId,t);let m=e.getDocumentRequestChain(l,s),p=0,h=[];for(let e=0;e<m.length&&!(m.length<2);e++){let t=m[e],a=m[e+1]||t,r=d.get(t.requestId),i=d.get(a.requestId);if(!r||!i)throw new Error("Could not find redirects in graph");let o=i.startTime-r.startTime,s=a.networkRequestTime-t.networkRequestTime,l="simulate"===n.throttlingMethod?o:s;p+=l,h.push({url:t.url,wastedMs:l})}let g=[{key:"url",valueType:"url",label:Lq(no.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:Lq(no.columnTimeSpent)}],f=Dr.makeOpportunityDetails(g,h,{overallSavingsMs:p});return{score:m.length<=2?1:MR.scoreForWastedMs(p),numericValue:p,numericUnit:"millisecond",displayValue:p?Lq(no.displayValueMsSavings,{wastedMs:p}):"",details:f,metricSavings:{LCP:p,FCP:p}}}},jq=Oq})),Bq={};c(Bq,{default:()=>Vq});var qq,zq,Vq,Wq=s((()=>{J(),qq=d(Xj(),1),xr(),xl(),nU(),8,zq=class e extends Dr{static{o(this,"ScreenshotThumbnails")}static get meta(){return{id:"screenshot-thumbnails",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:"Screenshot Thumbnails",description:"This is what the load of your site looked like.",requiredArtifacts:["traces","GatherContext"]}}static scaleImageToThumbnail(e,t){let a=e.width/t,n=Math.floor(e.height/a),r=new Uint8Array(t*n*4);for(let i=0;i<t;i++)for(let o=0;o<n;o++){let n=Math.floor(i*a),s=4*(Math.floor(o*a)*e.width+n),l=4*(o*t+i);r[l]=e.data[s],r[l+1]=e.data[s+1],r[l+2]=e.data[s+2],r[l+3]=e.data[s+3]}return{width:t,height:n,data:r}}static async _audit(t,a){let n=t.traces[Dr.DEFAULT_PASS],r=new Map,i=await Ij.request(n,a),o=a.options.minimumTimelineDuration||3e3,s=a.options.numberOfThumbnails||8,l=a.options.thumbnailWidth||null,c=[],u=i.frames.filter((e=>!e.isProgressInterpolated())),d=i.complete||Math.max(...i.frames.map((e=>e.getTimeStamp()-i.beginning))),m=Math.max(d,o);if(!u.length||!Number.isFinite(m))throw new El(El.errors.INVALID_SPEEDLINE);for(let t=1;t<=s;t++){let a=i.beginning+m*t/s,n=null;t===s?n=u[u.length-1]:u.forEach((e=>{e.getTimeStamp()<=a&&(n=e)}));let o,d=r.get(n);if(d)o=d;else if(null!==l){let t=n.getParsedImage(),a=e.scaleImageToThumbnail(t,l);o=qq.default.encode(a,90).data.toString("base64"),r.set(n,o)}else o=n.getImage().toString("base64"),r.set(n,o);c.push({timing:Math.round(a-i.beginning),timestamp:1e3*a,data:`data:image/jpeg;base64,${o}`})}return{score:1,details:{type:"filmstrip",scale:m,items:c}}}static async audit(e,t){try{return await this._audit(e,t)}catch(t){if(new Set([El.errors.NO_SCREENSHOTS.code,El.errors.SPEEDINDEX_OF_ZERO.code,El.errors.NO_SPEEDLINE_FRAMES.code,El.errors.INVALID_SPEEDLINE.code]).has(t.code)&&"timespan"===e.GatherContext.gatherMode)return{notApplicable:!0,score:1};throw t}}},Vq=zq})),Hq={};c(Hq,{default:()=>Gq});var Gq,$q=s((()=>{J(),Gq={meta:{id:"script-elements-test-audit",title:"ScriptElements",failureTitle:"ScriptElements",description:"Audit to force the inclusion of ScriptElements artifact",requiredArtifacts:["ScriptElements"]},audit:()=>({score:1})}})),Kq={};c(Kq,{default:()=>Jq});var Yq,Jq,Zq=s((()=>{J(),xr(),YR(),ON(),JR(),QR(),Yq=class e extends Dr{static{o(this,"ScriptTreemapDataAudit")}static get meta(){return{id:"script-treemap-data",scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,title:"Script Treemap Data",description:"Used for treemap app",requiredArtifacts:["traces","devtoolsLogs","SourceMaps","Scripts","JsUsage","URL"]}}static makeScriptNode(e,t,a){function n(e){return{name:e,resourceBytes:0}}o(n,"newNode");let r=n(t);function i(e,a){let i=r;r.resourceBytes+=a.resourceBytes,a.unusedBytes&&(r.unusedBytes=(r.unusedBytes||0)+a.unusedBytes);let o=e.replace(t,"").split(/\/+/);o.forEach(((e,t)=>{if(0===e.length)return;let r=t===o.length-1,s=i.children&&i.children.find((t=>t.name===e));s||(s=n(e),i.children=i.children||[],i.children.push(s)),i=s,i.resourceBytes+=a.resourceBytes,a.unusedBytes&&(i.unusedBytes=(i.unusedBytes||0)+a.unusedBytes),r&&void 0!==a.duplicatedNormalizedModuleName&&(i.duplicatedNormalizedModuleName=a.duplicatedNormalizedModuleName)}))}o(i,"addAllNodesInSourcePath");for(let[e,t]of Object.entries(a))i(e,t);function s(e){for(;e.children&&1===e.children.length;)e.name+="/"+e.children[0].name,e.children=e.children[0].children;if(e.children)for(let t of e.children)s(t)}if(o(s,"collapseAll"),s(r),!r.name)return{...r,name:e,children:r.children};let l={...r};return l.name=e,l.children=[r],l}static async makeNodes(e,t){let a=[],n=new Map,r=await GR.request(e,t),i=await KR.request(e,t);for(let o of e.Scripts){if("JavaScript"!==o.scriptLanguage)continue;let s,l=o.url,c=r.find((e=>o.scriptId===e.script.scriptId)),u=e.JsUsage[o.scriptId],d=u?await PN.request({scriptId:o.scriptId,scriptCoverage:u,bundle:c},t):void 0;if(c&&!("errorMessage"in c.sizes)){let e={};for(let t of Object.keys(c.sizes.files)){let a={resourceBytes:c.sizes.files[t]};d?.sourcesWastedBytes&&(a.unusedBytes=d.sourcesWastedBytes[t]);let n=t;c.rawMap.sourceRoot&&t.startsWith(c.rawMap.sourceRoot)&&(n=t.replace(c.rawMap.sourceRoot,""));let r=KR.normalizeSource(n);i.has(r)&&(a.duplicatedNormalizedModuleName=r),e[t]=a}if(c.sizes.unmappedBytes){let t={resourceBytes:c.sizes.unmappedBytes};d?.sourcesWastedBytes&&(t.unusedBytes=d.sourcesWastedBytes["(unmapped)"]),e["(unmapped)"]=t}s=this.makeScriptNode(o.url,c.rawMap.sourceRoot||"",e)}else s={name:l,resourceBytes:d?.totalBytes??o.length??0,unusedBytes:d?.wastedBytes};if(ZR(o)){let e=n.get(o.executionContextAuxData.frameId);e||(e={name:l,resourceBytes:0,unusedBytes:void 0,children:[]},n.set(o.executionContextAuxData.frameId,e),a.push(e)),e.resourceBytes+=s.resourceBytes,s.unusedBytes&&(e.unusedBytes=(e.unusedBytes||0)+s.unusedBytes),s.name=o.content?"(inline) "+o.content.trimStart().substring(0,15)+"…":"(inline)",e.children?.push(s)}else a.push(s)}return a}static async audit(t,a){return{score:1,details:{type:"treemap-data",nodes:await e.makeNodes(t,a)}}}},Jq=Yq})),Xq={};c(Xq,{UIStrings:()=>Qq,default:()=>az});var Qq,ez,tz,az,nz=s((()=>{J(),xr(),ql(),fb(),ro(),ez=eo("core/audits/seo/canonical.js",Qq={title:"Document has a valid `rel=canonical`",failureTitle:"Document does not have a valid `rel=canonical`",description:"Canonical links suggest which URL to show in search results. [Learn more about canonical links](https://developer.chrome.com/docs/lighthouse/seo/canonical/).",explanationConflict:"Multiple conflicting URLs ({urlList})",explanationInvalid:"Invalid URL ({url})",explanationRelative:"Is not an absolute URL ({url})",explanationPointsElsewhere:"Points to another `hreflang` location ({url})",explanationRoot:"Points to the domain's root URL (the homepage), instead of an equivalent page of content"}),tz=class e extends Dr{static{o(this,"Canonical")}static get meta(){return{id:"canonical",title:ez(Qq.title),failureTitle:ez(Qq.failureTitle),description:ez(Qq.description),supportedModes:["navigation"],requiredArtifacts:["LinkElements","URL","devtoolsLogs"]}}static collectCanonicalURLs(e){let t,a,n=new Set,r=new Set;for(let i of e)if("body"!==i.source)if("canonical"===i.rel){if(!i.hrefRaw)continue;i.href?Ml.isValid(i.hrefRaw)?n.add(i.href):a=i:t=i}else"alternate"===i.rel&&i.href&&i.hreflang&&r.add(i.href);return{uniqueCanonicalURLs:n,hreflangURLs:r,invalidCanonicalLink:t,relativeCanonicallink:a}}static findInvalidCanonicalURLReason(e){let{uniqueCanonicalURLs:t,invalidCanonicalLink:a,relativeCanonicallink:n}=e;if(a)return{score:0,explanation:ez(Qq.explanationInvalid,{url:a.hrefRaw})};if(n)return{score:0,explanation:ez(Qq.explanationRelative,{url:n.hrefRaw})};let r=Array.from(t);return 0===r.length?{score:1,notApplicable:!0}:r.length>1?{score:0,explanation:ez(Qq.explanationConflict,{urlList:r.join(", ")})}:void 0}static findCommonCanonicalURLMistakes(e,t,a){let{hreflangURLs:n}=e;return n.has(a.href)&&n.has(t.href)&&a.href!==t.href?{score:0,explanation:ez(Qq.explanationPointsElsewhere,{url:a.href})}:t.origin===a.origin&&"/"===t.pathname&&"/"!==a.pathname?{score:0,explanation:ez(Qq.explanationRoot)}:void 0}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=await pb.request({devtoolsLog:n,URL:t.URL},a),i=new URL(r.url),o=e.collectCanonicalURLs(t.LinkElements),s=e.findInvalidCanonicalURLReason(o);if(s)return s;let l=new URL([...o.uniqueCanonicalURLs][0]);return e.findCommonCanonicalURLMistakes(o,l,i)||{score:1}}},az=tz})),rz={};c(rz,{UIStrings:()=>iz,default:()=>lz});var iz,oz,sz,lz,cz,uz,dz,mz=s((()=>{J(),xr(),ro(),oz=eo("core/audits/seo/crawlable-anchors.js",iz={title:"Links are crawlable",failureTitle:"Links are not crawlable",description:"Search engines may use `href` attributes on links to crawl websites. Ensure that the `href` attribute of anchor elements links to an appropriate destination, so more pages of the site can be discovered. [Learn how to make links crawlable](https://support.google.com/webmasters/answer/9112205)",columnFailingLink:"Uncrawlable Link"}),sz=class extends Dr{static{o(this,"CrawlableAnchors")}static get meta(){return{id:"crawlable-anchors",title:oz(iz.title),failureTitle:oz(iz.failureTitle),description:oz(iz.description),requiredArtifacts:["AnchorElements","URL"]}}static audit({AnchorElements:e,URL:t}){let a=e.filter((({rawHref:e,name:a="",role:n="",id:r})=>{if(e=e.replace(/\s/g,""),a=a.trim(),(n=n.trim()).length>0||e.startsWith("mailto:")||""===e&&r)return;let i=/javascript:void(\(|)0(\)|)/;if(e.startsWith("file:"))return!0;if(!(a.length>0)){if(""===e||i.test(e))return!0;try{new URL(e,t.finalDisplayedUrl)}catch{return!0}}})),n=[{key:"node",valueType:"node",label:oz(iz.columnFailingLink)}],r=a.map((e=>({node:Dr.makeNodeItem(e.node)})));return{score:+(0===a.length),details:Dr.makeTableDetails(n,r)}}},lz=sz})),pz=l((e=>{function t(e,t){return null===e?t:null===t?e:Math.min(e,t)}function a(e,t){return null===e?t:null===t?e:Math.max(e,t)}function n(e,t,a){return"number"==typeof e?e>=0?i(e,1,1e4):void 0:"device-width"===e?100*t:"device-height"===e?100*a:1}function r(e){return"number"==typeof e?e>=0?i(e,.1,10):void 0:"yes"===e?1:"device-width"===e||"device-height"===e?10:"no"===e||null===e?.1:void 0}function i(e,n,r){return a(t(e,r),n)}J(),e.getRenderingDataFromViewport=function(e,o,s,l,c){var u=o/100,d=s/100,m=null,p=null,h=null,g=null,f=null,y=null,v=null,b=null,w=null,D=o,E=s,T="zoom",S="resizes-visual";if(void 0!==e["maximum-scale"]&&(m=r(e["maximum-scale"])),void 0!==e["minimum-scale"]&&(p=r(e["minimum-scale"])),void 0!==e["initial-scale"]&&(h=r(e["initial-scale"])),null!==p&&null===m&&(p=t(l,r(e["minimum-scale"]))),void 0!==e.width&&(g="extend-to-zoom",y=n(e.width,u,d)),void 0!==e.height&&(f="extend-to-zoom",v=n(e.height,u,d)),void 0!==e["user-scalable"])if("number"==typeof(T=e["user-scalable"]))T=T>=1||T<=-1?"zoom":"fixed";else switch(T){case"yes":case"device-width":case"device-height":T="zoom";break;default:T="fixed"}if(void 0!==e["interactive-widget"])switch(e["interactive-widget"]){case"overlays-content":case"resizes-content":case"resizes-visual":S=e["interactive-widget"];break;default:S="resizes-visual"}null!==h&&(void 0===e.width||void 0===b)&&(void 0!==e.height?(g=null,y=null):(g="extend-to-zoom",y="extend-to-zoom")),null!==p&&null!==m&&(m=a(p,m)),null!==h&&(h=i(h,p,m));var C,k,x=null===h&&null===m?null:t(h,m);return null===x?("extend-to-zoom"===y&&(y=null),"extend-to-zoom"===v&&(v=null),"extend-to-zoom"===g&&(g=y),"extend-to-zoom"===f&&(f=v)):(C=D/x,k=E/x,"extend-to-zoom"===y&&(y=C),"extend-to-zoom"===v&&(v=k),"extend-to-zoom"===g&&(g=a(C,y)),"extend-to-zoom"===f&&(f=a(k,v))),(null!==g||null!==y)&&(b=a(g,t(y,D))),(null!==f||null!==v)&&(w=a(f,t(v,E))),null===b&&(b=null===w?D:0!==E?Math.round(w*(D/E)):D),null===w&&(w=0!==D?Math.round(b*(E/D)):E),{zoom:h,width:b,height:w,userZoom:T,interactiveWidget:S}},o(t,"min"),o(a,"max"),o(n,"translateLengthProperty"),o(r,"translateZoomProperty"),o(i,"clamp"),e.parseMetaViewPortContent=function(e){for(var t={validProperties:{},unknownProperties:{},invalidValues:{}},a=1;a<=e.length;){for(;a<=e.length&&RegExp(" |\n|\t|\0d|,|;|=").test(e[a-1]);)a++;a<=e.length&&(a=l(t,e,a))}return t};var s=["width","height","initial-scale","minimum-scale","maximum-scale","user-scalable","shrink-to-fit","viewport-fit","interactive-widget"];function l(e,t,a){for(var n=a;a<=t.length&&!RegExp(" |\n|\t|\0d|,|;|=").test(t[a-1]);)a++;if(a>t.length||RegExp(",|;").test(t[a-1]))return a;for(var r=t.slice(n-1,a-1);a<=t.length&&!RegExp(",|;|=").test(t[a-1]);)a++;if(a>t.length||RegExp(",|;").test(t[a-1]))return a;for(;a<=t.length&&RegExp(" |\n|\t|\0d|=").test(t[a-1]);)a++;if(a>t.length||RegExp(",|;").test(t[a-1]))return a;for(n=a;a<=t.length&&!RegExp(" |\n|\t|\0d|,|;|=").test(t[a-1]);)a++;return c(e,r,t.slice(n-1,a-1)),a}function c(t,a,n){if(s.indexOf(a)>=0){var r=parseFloat(n);if(!isNaN(r))return void(t.validProperties[a]=r);var i=n.toLowerCase();if("yes"===i||"no"===i||"device-width"===i||"device-height"===i||"viewport-fit"===a.toLowerCase()&&("auto"===i||"cover"===i)||"interactive-widget"===a.toLowerCase()&&e.expectedValues["interactive-widget"].includes(i))return void(t.validProperties[a]=i);t.validProperties[a]=null,t.invalidValues[a]=n}else t.unknownProperties[a]=n}o(l,"parseProperty"),o(c,"setProperty"),e.expectedValues={width:["device-width","device-height","a positive number"],height:["device-width","device-height","a positive number"],"initial-scale":["a positive number"],"minimum-scale":["a positive number"],"maximum-scale":["a positive number"],"user-scalable":["yes","no","0","1"],"shrink-to-fit":["yes","no"],"viewport-fit":["auto","cover"],"interactive-widget":["overlays-content","resizes-content","resizes-visual"]}})),hz=s((()=>{J(),cz=d(pz(),1),Bc(),uz=class{static{o(this,"ViewportMeta")}static async compute_(e){let t=e.find((e=>"viewport"===e.name));if(!t)return{hasViewportTag:!1,isMobileOptimized:!1,parserWarnings:[]};let a=[],n=cz.default.parseMetaViewPortContent(t.content||"");Object.keys(n.unknownProperties).length&&a.push(`Invalid properties found: ${JSON.stringify(n.unknownProperties)}`),Object.keys(n.invalidValues).length&&a.push(`Invalid values found: ${JSON.stringify(n.invalidValues)}`);let r=n.validProperties;return{hasViewportTag:!0,isMobileOptimized:!(!r.width&&!r["initial-scale"]),parserWarnings:a}}},dz=dc(uz,null)})),gz={};function fz(e){let t=new Map;return e.forEach((e=>{let{nodeId:a,cssRule:n,fontSize:r,textLength:i,parentNode:o}=e,s=Dz(n,a),l=t.get(s);l?l.textLength+=i:t.set(s,{nodeId:a,parentNode:o,cssRule:n,fontSize:r,textLength:i})})),[...t.values()]}function yz(e=[]){let t=new Map;for(let a=0;a<e.length;a+=2){let n=e[a],r=e[a+1];if(!n||!r)continue;let i=r.trim();i&&t.set(n.toLowerCase(),i)}return t}function vz(e){let t=yz(e.attributes);if(t.has("id"))return"#"+t.get("id");{let e=t.get("class");if(e)return"."+e.split(/\s+/).join(".")}return e.nodeName.toLowerCase()}function bz(e){let t=(e.attributes||[]).map(((e,t)=>t%2==0?` ${e}`:`="${e}"`)).join("");return{type:"node",selector:e.parentNode?vz(e.parentNode):"",snippet:`<${e.nodeName.toLowerCase()}${t}>`}}function wz(e,t,a){if(!t||"Attributes"===t.type||"Inline"===t.type)return{source:{type:"url",value:e},selector:bz(a)};if(t.parentRule&&"user-agent"===t.parentRule.origin)return{source:{type:"code",value:"User Agent Stylesheet"},selector:t.parentRule.selectors.map((e=>e.text)).join(", ")};let n="";if(t.parentRule&&(n=t.parentRule.selectors.map((e=>e.text)).join(", ")),t.stylesheet&&!t.stylesheet.sourceURL)return{source:{type:"code",value:"dynamic"},selector:n};if(t.stylesheet&&t.range){let{range:e,stylesheet:a}=t,r=a.hasSourceURL?"comment":"network",i=e.startLine,o=e.startColumn;a.isInline&&"comment"!==r&&(i+=a.startLine,0===e.startLine&&(o+=a.startColumn));let s=Dr.makeSourceLocation(a.sourceURL,i,o);return s.urlProvider=r,{source:s,selector:n}}return{selector:n,source:{type:"code",value:"Unknown"}}}function Dz(e,t){if(e&&"Regular"===e.type){let t=e.range?e.range.startLine:0,a=e.range?e.range.startColumn:0;return`${e.styleSheetId}@${t}:${a}`}return`node_${t}`}c(gz,{UIStrings:()=>Ez,default:()=>Cz});var Ez,Tz,Sz,Cz,kz=s((()=>{J(),ro(),xr(),hz(),60,Tz=eo("core/audits/seo/font-size.js",Ez={title:"Document uses legible font sizes",failureTitle:"Document doesn't use legible font sizes",description:"Font sizes less than 12px are too small to be legible and require mobile visitors to “pinch to zoom” in order to read. Strive to have >60% of page text ≥12px. [Learn more about legible font sizes](https://developer.chrome.com/docs/lighthouse/seo/font-size/).",displayValue:"{decimalProportion, number, extendedPercent} legible text",explanationViewport:"Text is illegible because there's no viewport meta tag optimized for mobile screens.",additionalIllegibleText:"Add'l illegible text",legibleText:"Legible text",columnSelector:"Selector",columnPercentPageText:"% of Page Text",columnFontSize:"Font Size"}),o(fz,"getUniqueFailingRules"),o(yz,"getAttributeMap"),o(vz,"getSelector"),o(bz,"nodeToTableNode"),o(wz,"findStyleRuleSource"),o(Dz,"getFontArtifactId"),Sz=class extends Dr{static{o(this,"FontSize")}static get meta(){return{id:"font-size",title:Tz(Ez.title),failureTitle:Tz(Ez.failureTitle),description:Tz(Ez.description),requiredArtifacts:["FontSize","URL","MetaElements"]}}static async audit(e,t){if("desktop"===t.settings.formFactor)return{score:1,notApplicable:!0};if(!(await dz.request(e.MetaElements,t)).isMobileOptimized)return{score:0,explanation:Tz(Ez.explanationViewport)};let{analyzedFailingNodesData:a,analyzedFailingTextLength:n,failingTextLength:r,totalTextLength:i}=e.FontSize;if(0===i)return{score:1};let o=fz(a),s=(i-r)/i*100,l=e.URL.finalDisplayedUrl,c=[{key:"source",valueType:"source-location",label:Tz(no.columnSource)},{key:"selector",valueType:"code",label:Tz(Ez.columnSelector)},{key:"coverage",valueType:"text",label:Tz(Ez.columnPercentPageText)},{key:"fontSize",valueType:"text",label:Tz(Ez.columnFontSize)}],u=o.sort(((e,t)=>t.textLength-e.textLength)).map((({cssRule:e,textLength:t,fontSize:a,parentNode:n})=>{let r=t/i*100,o=wz(l,e,n);return{source:o.source,selector:o.selector,coverage:`${r.toFixed(2)}%`,fontSize:`${a}px`}}));if(n<r){let e=(r-n)/i*100;u.push({source:{type:"code",value:Tz(Ez.additionalIllegibleText)},selector:"",coverage:`${e.toFixed(2)}%`,fontSize:"< 12px"})}s>0&&u.push({source:{type:"code",value:Tz(Ez.legibleText)},selector:"",coverage:`${s.toFixed(2)}%`,fontSize:"≥ 12px"});let d=s/100,m=Tz(Ez.displayValue,{decimalProportion:d}),p=Dr.makeTableDetails(c,u);return{score:Number(s>=60),details:p,displayValue:m}}},Cz=Sz}));function xz(e){let t=Az;for(;e.length<3;)e+="`";for(let a=0;a<=e.length-1;a++){if(t=t[e.charCodeAt(a)-96],!t)return!1}return!0}var Az,_z=s((()=>{J(),Az=[,[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,,,,,1,1,1,1,,,1,1,1,,1,,1,,1,1],[1,1,1,,1,1,,1,1,1,,1,,,1,1,1,,,1,1,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,,,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1],[,1,,,,,,1,,1,,,,,1,,1,,,,1,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,,,1,,,,,1,1,1,,1,,1,,1,,,,,,1],[1,,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,,1,,1,,,,,1,,1,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,,1,1,1,,1,,1,1,1,,,1,1,1,1,1,1,1,1],[,,1,,,1,,1,,,,1,1,1,,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1,1,1,1,1,,,1,1,1],[1,1,1,1,1,,,1,,,1,,,1,1,1,,,,,1,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1],[,1,,1,1,1,,1,1,,1,,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,,,1,1,1,,,1,1,,,,,,1,1],[1,1,1,,,,,1,,,,1,1,,1,,,,,,1,,,,,1],[,1,,,1,,,1,,,,,,1],[,1,,1,,,,1,,,,1],[1,,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,,1,,,1,1,1,1],[,1,1,1,1,1,,,1,,,1,,1,1,,1,,1,,,,,1,,1],[,1,,,,1,,,1,1,,1,,1,1,1,1,,1,1,,,1,,,1],[,1,1,,,,,,1,,,,1,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,,1,1,1,,,1,1,1,1,1,1,,1,,,,,1,1,,1,,1],[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,1,1],[,1,1,1,,,,1,1,1,,1,1,,,1,1,,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,,1,,,,,1,1,1,,,1,,1,,,1,1],[,,,,1,,,,,,,,,,,,,,,,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,,1,1,1,,1,1,,,,1,1,1,1,1,,,1,1,1,,,,,1],[1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,1,,,,,,,1],[,1,1,,1,1,,1,,,,,,,,,,,,,1],,[1,1,1,,,,,,,,,,,,,1],[,,,,,,,,1,,,1,,,1,1,,,,,1]],[,[1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,,1],[,,,1,,,,,,,,,,,,,,,1],[,1,,,1,1,,1,,1,1,,,,1,1,,,1,1,,,,1],[1,,,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,,,,1],,[,1,1,1,1,1,,1,1,1,,1,1,,1,1,,,1,1,1,1,,1,1,,1],[,1,,,1,,,1,,1,,,1,1,1,1,,,1,1,,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,,,1,1,1,1,1,1,1,,,1,,,1,,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,,,,1],[,,,,,,,1,,,,1,,1,1],[,1,1,1,1,1,1,1,,,,1,1,1,1,1,,,1,1,,1,1,1,1,1],[,1,,,1,1,,1,,1,1,1,,,1,1,,,1,,1,1,1,1,,1],[,1,1,1,,1,1,,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1],[,,,,,,,,,,,,,,,,1],,[,1,1,1,1,1,,1,1,1,,,1,,1,1,,1,1,1,1,1,,1,,1],[,,1,,,1,,,1,1,,,1,,1,1,,1],[,1,1,,1,,,,1,1,,1,,1,1,1,1,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,1,,1,,1,1],,[,1,1,,1,,,1,,1,,,,1,1,1,,,,,,1,,,,1],[1,1,,,1,1,,1,,,,,1,,1]],[,[,1],[,,,1,,,,1,,,,1,,,,1,,,1,,,1],[,,,,,,,,,,,,,,,,,,1,1,,,,,,1],,[1,,,,,1],[,1,,,,1,,,,1],[,1,,,,,,,,,,,1,,,1,,,,,,,,,1,1],[,,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,1,,1],[,1],[,1,,1,,1,,1,,1,,1,1,1,,1,1,,1,,,,,,,1],[1,,,,,1,,,1,1,,1,,1,,1,1,,,,,1,,,1],[,1,1,,,1,,1,,1,,1,,1,1,1,1,,,1,,1,,1,1,1],[1,1,1,1,1,,1,,1,,,,1,1,1,1,,1,1,,,1,1,1,1],[1,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],,[,1,,,,,,1,1,1,,1,,,,1,,,1,1,1,,,1],[1,,,,,1,,1,1,1,,1,1,1,1,1,,1,,1,,1,,,1,1],[1,,1,1,,,,,1,,,,,,1,1,,,1,1,1,1,,,1,,1],[1,,,,,,,,,,,,,,,,,1],[,,,,,1,,,1,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,,,1],[,1,,,,1]],[,[1,1,1,,1,,1,1,1,1,1,1,1,1,1,,1,,1,,1,1,,,1,1,1],[,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],,[,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1],,[1,1,,,,1,1,,,,,,1,,,,1,,1,,1,1,,1],[1],[,,,,,,,,,,,1,,,,,,,,,,,1],[,1,,,,,,,1,1,,,1,,1,,,,1,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,,1],[,,1,,,,,1,,1],[1,,,,1,,,,,1,,,,1,1,,,,1,1,,,,,1],[,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[1,,,1,1,,,,,,,1,,1,,1,1,1,1,1,1],[,,,,,1,,,,,,,1,,,,,,,1],,[,,1,1,1,1,1,,1,1,1,,,1,1,,,1,1,,1,1,1,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,,,,1],,[1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,,,1,1,1,1,,,,,,1,,1,,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,,,,1,,1,,,1,1,1,1,1],[,,,,,,,,,,,1,,,,,,,,,1,,,,1],[,1,1,,1,1,,1,,,,1,1,,1,1,,,1,,1,1,,1],[,1,,1,,1,,,1,,,1,1,,1,1,,,1,1,1],[,1,1,1,1,1,,1,1,,,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,,,,,,,,,1,,1,,1,1,,,,1,,,1],[,1,,,1,1,,,,,,,,,1,1,1,,,,,1],[1,,,1,1,,,,1,1,1,1,1,,,1,,,1,,,1,,1,,1],[,1,1,,1,1,,1,1,,,,1,1,1,,,1,1,,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,,,,1,,,,,,,,,1],[,1,,,,,,,,1,,,,,1,,,,1,,,1],[,1,1,1,1,,,1,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1],[,,,,,1,,1,,,,,1,1,1,1,1,,,1,,,,1],[,1,,,,,,,,1,,,,,,,,,,,,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,1,,,,1,,1,1,1,1,1,,1,1,,,,,,1],[,1,1,1,1,1,1,1,,1,1,,,1,1,,,,1,,1,1,,1,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,1,1,,1,,,1,1,1,1,,,1,,,,,,,1],[,1,,,,,,,,1,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1],[,1,1,,,,,,,,,,,,1,1,,,,,,1],[,1,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,,,,,1],[1,1,,,1,,,1,1,1,,,,1],,[,,,,,,,,,,,,,1,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,1,,,,,,,1],[1,1,1,,1,,1,1,1,1,1,1,1,1,,1,,,1,,1,,,1,1],[,,,,,,,,,1],[,1,,,,1,,,,,,1,,,1,,,,,1],[,1,1,,1,1,,,,,,,,,,,,,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,1,1,1,,,,1,1,,,,1,,1],[1,1,1,1,1,1,,,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,,1,1],[,,,,,,,,,,,,,,,1,,,,1],,[1,1,,1,,1,,,,,,1,,1,,1,1,,1,,1,1,,1,1,,1],[,,1,,,,,,1,,,,1,,1,,,,,1],[1,,,,,,,,,1,,,,,,1,,,,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,,1,,,,,,1,,,1,,,,,,,,1],[,1,,1,,,,,,,,,,,,1],,[1,1,,,,,,,,,,,,,,,,,,,,,,1,1],[1]],[,[1,,,,,,,,,1,,,,,1,,1,,1],[,1,1,,1,1,,1,1,1,,,1,1,1,,,,1,,,1,,,,1],[,1,,,,,,,1,,,,1,,,,,,1],[1,1,1,1,1,1,,,,1,,,,,,,,,1,1,1,1],[1],[,1,1,,,1,1,,,,,1,,1,,,,,,,,1,,,,1],[1,,1,,,1,,1,,,,,1,1,1,1,,,,1,,,,1],[,,1,,,,,,,1,,,,,,,1,,,,,,,1],[1,,,,,,,,,,,,,,1,,,,1],[,,,1,,1,,,,,1,,,,1,1,,,,1],[1,,,,,1,,,,1,,1,1,,,1,1,,1,1,1,,1,1,1,,1],[,1,1,,,,,1,,1,,1,1,1,,1,1,,,1,,1,1,1],[,1,,,,1,,,,1,,,1,,1,1,,,1,1,,,,,,1],[1,,1,1,,1,,1,1,,1,,1,1,1,1,1,,,1,1,,,,,,1],[1,,,,,,,,,,,,,,,,,,1,,,1,,1],[,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,,1,,1],[,1,,,,1,,,1,1,,1,,,1,1,,,1,,,1,,,1,1],[1,1,,1,1,1,,1,1,1,,1,,1,1,1,,,1,,1,1],[1,,1,1,1,1,,,,1,,1,1,1,,1,,,1,1,1,,1,1,1,1,1],[1,,,,,,,,,,,,,1],[,,1,,,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,,,1,,1,,1,,,,1],[,,,1,,,,,,,,,1],[,1,,,,,,,,,,,,,,1,,,,,,,,,1],[,,,,,,,,1,1,,,,,,,,,1,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,,,1,1,1],[,,,,,1,,,,1,1,1,,,1,1,,,1,,1,1,,1],[,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,1,,,,,,,,,,,,,1],[,,1,,,1,,1,1,1,,1,1,,1,,,,1,,1,1],,[,,1,,,1,,,,,,1,,,,1],[,,,,,,,,,1,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,,1,1,,1,,1,,,1,1,1,,,1],[,,,,,1,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,1,,1,1,,1,,,1],[,,,,,1,,,,,,,,,,,,,,1],[,1,1,1,1,,,,,1,,,1,,1,,,,1,1,,,,1,1],[,1,,,1,,,1,,1,1,,1,,,,,,,1],[,,1,,1,,,1,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,,,,,,,,,,1,,1,1],[,,,,,,,,,,,,1],,[,1,1,1,1,,,,1,1,,1,1,1,1,1,1,,1,1,1,1,,1,,1],[1,,,,1,,,,,,,,,,1],[1,,,,,,,,,1],,[,1,,,,1,,,,,,,,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,,1,,,,1,1,,,1,1,,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,1],[1,1,1,,,,,1,1,1,,1,1,1,1,,,1,1,,1,1,,,,,1],[,1,,,,,,,1,1,,,1,1,1,,1,,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,,,1,,,,1,,,1,,,,1,,,,,,,1,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1],[1,1,1,,1,,,1,1,1,1,,1,1,1,1,,,,1,,1,,1,,,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,,1,1,,,,,,,,,1],,[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,,1,,1,,,,1],[,1,,,1,1,,1,1,1,,,1,1,1,1,1,,1,1,1,,1,,,1],[1,,,1,,,,1,1,1,,,,,1,1,,,,1,,1],[1,1,,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,,1,,1,,,,,,,,1,,1],[,1,,,,1,,1,1,,,,1,1,,1,,,,1,1,1,,1],,[,1,,,,,,1,,,,,,,1],[,,,,,,,,1,,,,1,,1,,,,,,,,,,,,1]],[,[,1,1,,1,1,1,1,,1,1,1,,1,1,,1,1,,1,1,1,1,1,1,,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,,,1,,,,,,,,1,,,,,,1,,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,,1,,1,1,1,1,1,1,1,,1,1,,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1],[,1,1,,,,,1,1,1,,,1,,1,1,,,,1,,1,,,1,1],[,,,,,,,1,,,,1,1,1,1,1,,1,,,,,,,,1],[1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,,1,,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,1,1,,1,,1,1,1,,1,,1,1,,1,1,,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,,1,,,,,1,,1],[,1,1,1,,1,,1,,1,,,,1,,1,,,1,,,,,,1,1],[,1,,,1,1,,1,,1,,1,1,1,1,1,,1,1,,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,,1,,1,,1,,,,,,1,,1,,,,1,1]],[,[,1,,1,,,,,,,,,,,,,,,1,,,,1],[,,,,,,,,,1,,1,1,1,,1,,,1,,1,1],[1,1,,,,,,,1,,,,,,,1,,,,,,1],[,1,,,,,,,,,,1,,,,,,,,,1,1],,[,,,,,,,,,,,,,,,1,,,,1,,1],[,,1,1,,1,,1,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,,,,,,,,1],[1,,1,1,,,,1,,,,,,,,,1,,,1,,,1,1],[,1,1,,1,1,,1,1,1,1,1,1,1,1,1,,,1,1,,1,1,,1],[,1,,,1,1,,,,,,1,,1,,1,,,1,,1,1],[1,1,1,1,,1,,1,,1,,1,1,,1,1,1,1,1,,1,1,1,1,1],[,1,1,,,1,,1,,1,1,1,,,1,1,1,,1,1,1,1,,1,1],[,,,,1,,,1,,,,,,,1,,,,1,1],[,1,,,,,,,,,,1,,1,,1,,,,,1,,,,,1],,[1,1,,1,,1,,1,1,,,,,,1,1,,,1,1,1,1,1,1,1,1,1],[1,1,,1,,,,,,1,,,,,,1,1,,,,1,1,,,1],[,1,1,,1,1,,,,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,,,1,,,,1,,,,1,1],[,,,,1],[,,,,,,,,,1,,,1],,[,,1,,1,,,,,,,,,1,,,,,,,,,,,,1],[,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,,,1],[,1,,1,,,,,,1,,,,,1,1,,,,,1,1],[,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,,,1,,1,1,1],[,1,,,,1,,,,,,,1],[,1,,,1,,,1,,1,,1,1,,1,,,,,1,,1,,,,1,1],[,1,,,1,,,1,1,1,,1,1,1,1,1,,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,1,1,,,,1,1,,,,,,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,,1,1,,1,1,1,1,1],[,1,,,,1,,,,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,1,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,,1,1,1,,1,1,1,,,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,,,,,,,1,1,,,,,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,1,,1,1,1,1],,[,1,1,,,,,1,,1,,,,1,1,1,,,1,,,,,1],[,,,,,,,,,,,,,1],[,,,,,1,,,,,,,,1,1,,,,,1,,1,,,1,1],[,,,,,,,,,,,,,,1]],[,[,1],,,,,,,,,,,,,,,,,,,,[1,1,1,1,1,,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,1,1,1,1],[,1,,1,,1,,,1,1,1,,1,1,1,1,1,,,1,,,,1,,1,1],[,1,,1,,1,,,1,,,,,1,,,,,,1,1],[,1,,1,,,,,1,,,,1,,1,1,1,1,1,1,1,1,,1],[,1,,,,,,,,,,,,,,,1]],[,[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,,,,,,,,,1,1,,,,1],[,,,,,,1],[,,1],[,1,1,,,1,,1,,1,1,,1,1,1,,,,1,1,1,,,,,1],,[,1,,,,1,,,,,,1,,,1,,,,1,1,,1],[,,,,,,,1,,,,,,,,,1],[,1,,,,1,1,,,,,,1,1,1,,,,1,,1,1],[,,,,,,,1,,1,,,,,,,,,,1],[,1,1,,,,,,1,1,,,,1,,,,,,,1,,,1],,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,,1,,,1,,,,,1,,1,,1,,1,,,,,1],[1,1,1,1,1,1,1,1,,,,,1,1,,1,1,,1,,,1,,1],[,,,,,,,,,,,,,,1,,,,,,1],,[,,,,,,,,,1,,,,,,1,,,,,1],[,,1,,,,,,,1,,,1,1],[,,,1,,,,,1,,,,,1,,,,,,1,,,,1],[1,,1,1,,1,1,1,1,1,,1,,,,1,1,1,,,1,1,,,,1,1],,[1,1,,,,,,,,,,1,,1,,1,,,1],[,,,,1,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,1],[,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,,1,,,1,,,,,,,,1,,,,,,1,,,,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,1,,,,1,1,1,1,1,1,,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,1,,1,1,,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,,1,,1,,1,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,,,,,,1,,1,,,,,1,1,,,,,1],[1,,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,,1,,,,1,1,1,1,1,,,1,1,,1,,1],[,1,1,1,1,,,,,1,,1,1,1,1,1,,,1,1,,,,1,1,1],[,1,1,1,1,1,,1,,,,,1,,1,,1,,,1,,,1,1,,1]],[,[1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,,,,,1,,,,,1,1,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,,,,1,,1,1,,1,1,1,1,1,,,1,,1,,1],[1,1,1,,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,,1,,,,,,,,,,1,1,1,1,1,1,1,,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,1,1,,,,,,1,1,1,1,1,,,,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,,1,1,1],[,1,1,1,,1,,1,1,1,1,,,1,1,1,,1,1,1,1,1,,,1,1],[1,1,,,,1,,,1,1,1,,1,,1,,1,,1,1,1,1,1,,1,,1],[,1,,,,,,,1,,1,,1,1,1,1,,,,,,,,,1]],[,[,,,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,1,,,1,,,,,,1,,,1,,,,1],,[,1,,,,1,,1,,1,1,,1,1,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],[1,1,1,,,1,,,,,,,,,1,1,,,,,,,,,,1],[,1,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1,,,1],[,,,,,,,,,1],[1,1,,,,,,1,1,1,,1,1,,,,1,1,,1,,1,1,1,,1],[,1,1,1,,1,1,,,1,,1,1,1,1,,,,,,,1,,1],[,1,1,1,1,,,1,,1,,,,1,1,1,1,,1,1,,1],[,1,,,1,1,,1,,,,1,,1,1,,1,,1,,,1,,,1,,1],[,,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,,,,,1],,[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1],[,1,,,,,,,1,1,,1,,,,,1,,,1,,1],[,1,,,,1,,,1,,,,,,,,1,,1,,,1],[,,,,,,,,,,,,,1,1,,,,1,,,1],[,,,,,1,,,1,,,,1],[,1],,[,1],[1,,,,,,,,,,,,,,1,,,,,1]],[,[,1,,,,1,1,1,1,1,1,,1,1,1,1,1,,1,1,,1,1,,,1],[,,1,,,,,,,,,1],,,[1,,,1,1,,,,,,,,1,1,,1,1,,1],,[,,,,,,,,,,,,,,,,,,1,,1],,[1,,,1,1,,1,1,,,,,1,,1,,,,,1,1,,1],,[,1,,,,,,,,1,1,1,1,1,,1,1,,,,1,1],[,,,,,,,,,,,,,,,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,,1,1,1,1,1,1],[,,,,,,,,,,,1,,1,,,1],[1,,,,,,,,,,,,,,,,,,1,,1],,,[,1,,,,,,,,,,,,,,1,,,,1,1],[,,,,,,,,,1,,,1,,,,,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,1,1,,,,,,1],,[,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,1,1,,1,1,1,1,1,1,,,1,1,1,1,1,,1,1],[,1,,,,,,,,1],[,,,,1,,,1,,,1,1,,,,,,,,,,1,,,,1],[,1,,1,1,,,1,1,1,,,,1,1,1,1,,1,1,1,1,,1],[,,,,,,,1],[,1,1,,,,,1,,1,,,,,,1,,,,,,1,,1,,1],[,1,,,,,,1,,,,1,,,,,,,,,,1],[,,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1,1,1,1,,1],[,1,,,,,,,,1],[,1,1,,1,,,,,,,,1,,,,,,1,,,1,,1,,1],[,1,,1,,1,,1,1,1,,1,1,1,,1,,,1,1,,1,1,1,1,1],[,1,1,1,1,1,,,1,1,,,,1,1,1,,,,1,1,,,1,1],[,,1,1,1,1,,1,,1,,1,,1,1,1,1,,,,,1,,1,,1],[1,1,1,1,1,1,1,1,,1,,1,,1,1,1,,,1,1,,,,1,,1],[,,,1],,[,1,1,,1,,,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1],[,1,,,,,,1,,1,,1,,,,,,,1,1,,1,1],[,,,,,,1,,1,1,,1,,1,,,,,,,,,,1],[,1,1,,1,,,,1,,,,1,1,1,,,,1,,1,1,1,,1,1],,[,1,1,,,,,,,,,,,,,1,,,1,,,,,1],[,1,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,1,,,,1,,,,,1,,,,,,,1]],[,[,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[,1,1,1,1,1,,1,,1,1,,,1,1,1,1,,1,,,,,1,1,1],[,,1,1,,1,,1,1,,,,1,1,1,1,,,1,,1,1,1,1,,1],[,1,,1,,,,,,,,1,,1,,1,,,,,,,,,,1],[,,1,,1,,,1,,,,,1,1,,,1,,1,1,1,1],[,1],[,1,1,,1,,1,1,,1,,,1,1,1,,,,1,,,1,,1],[1,1,,1,1,1,,,,,,,,,,,,,1,,1,1,1],[,1,1,,,,,,,1,,,1,,1,,1,,1,1,,,1,,,1],[,,1,,,,,,,,,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,,1,,,,,1,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,,1,,1,1,1,,,1,1,1,1,,,,1,1],[,,,1,1,,,1,,1,,1,,1,1,1,1,,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,,1,,1,,,,1,1,,,1,1,,1,1,,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1,,1,1,,,1],[,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,,1,,,1,,,1,,1,1,1,1,1,,1,,1,1],[,,,,,1,,,,1,,,,,1,1,,,,1],[,1,,1,1,1,,1,,,1,1,1,,,1,,,1,,1,,,1],[,,1,,,,,,,,,1,,1,,,,,1,,1],[,1,1,,,,,,,,1,1,1,,,,,,,,1,,,,,1],[,,,,,,,,1,,,,,1,,,1]],[,[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,,1,1,1,1,1,1,1,1,,,,,,,,,1,1],[,,,,,,,,1,,,,1,,1,,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,1,,1,,1,,,,1,1,,1,,1,,,,1,1,1,1,1,,,1],,[,1,,,,,,,,1,,,1,1,,,1,,1,1,,1,,1],[,1,,,1,,,,,,,,1,,,,,,,1],[1,1,,,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1],,[,1,,,,,,1,,1,,1,1,1,1,1,,,1,,1,1,,,,1],[,1,1,,,1,,1,,1,,,1,1,1,1,,,1,,,1,,,,1],[,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1],[,1,,,1,1,,1,1,,,1,1,,1,1,,1,,1,,1],[1,,1,,,,,1,,1,,1,1,1,1,,,,,1,1,,,,1,1],[,1,1,,,,,1,1,,,1,,1,1,1,1,,,,,,,,,,1],,[,1,1,,,1,,,,1,,1,1,1,1,1,,,,1,,,,1,,1],[,,,1,1,,,1,,,,,1,,1,1,1,,1,1,,,,,,1],[,1,,,,,,,,,,,1,,,,1,,,,,,,1,,1],[,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,1,,,,,1,,1,,,1,1,,1,1,,1],[,1,,,,,,1,,,,,1,1,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1,,,1,,,,,1],[,,,,,,,1,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,,1,,,,,,,1,,,,,,,,1,,,1],[,1,,,,,,,1],[,,,,,,,,,,1],[,1,,,,,,1,1,,,,,,1],,[,1,1,,,,,,1,,,,,1,1,,,,1],[1,,1,,1,,,,,1,,,,,1,,,,,,,,,1,1],[,1,1,,,,,,,,,1,1,1,1,,,,1,,,,,1,,,1],,[,1,1,,1,,,1,1,,,1,,,1,1,1,,1,,1,1,1,,,,1],[,,,,,1,,,,,1,,,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,,,1,,,,,1,,,,,1,,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,1],[,1,,,,,,1,,,,,,,1,1,1,,,1],[,1,,,,,,,,,,1,1,1,,,,,1,,,1],[,,,,,1,,1,,,,,1,1,1,,1,1,,1,1,1,,,1,1],[1,1,,,,,,,1,,,,,1,1,,,,,,,,,,,1],,[,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,,1,,,,,1,,,1,,,,1,,1],[,1,,,,,,,,,1]]],o(xz,"isValidLang")})),Rz={};function Fz(e){return e.startsWith("http:")||e.startsWith("https:")}function Nz(e){if(e.toLowerCase()===Iz)return!0;let[t]=e.split("-");return xz(t.toLowerCase())}c(Rz,{UIStrings:()=>Mz,default:()=>Oz});var Iz,Mz,Pz,Lz,Oz,jz=s((()=>{J(),xr(),ro(),_z(),Iz="x-default",Pz=eo("core/audits/seo/hreflang.js",Mz={title:"Document has a valid `hreflang`",failureTitle:"Document doesn't have a valid `hreflang`",description:"hreflang links tell search engines what version of a page they should list in search results for a given language or region. [Learn more about `hreflang`](https://developer.chrome.com/docs/lighthouse/seo/hreflang/).",unexpectedLanguage:"Unexpected language code",notFullyQualified:"Relative href value"}),o(Fz,"isFullyQualified"),o(Nz,"isExpectedLanguageCode"),Lz=class extends Dr{static{o(this,"Hreflang")}static get meta(){return{id:"hreflang",title:Pz(Mz.title),failureTitle:Pz(Mz.failureTitle),description:Pz(Mz.description),supportedModes:["navigation"],requiredArtifacts:["LinkElements","URL"]}}static audit({LinkElements:e}){let t=[],a=e.filter((e=>{let t="alternate"===e.rel,a=e.hreflang,n="body"===e.source;return t&&a&&!n}));for(let e of a){let a,n=[];Nz(e.hreflang)||n.push(Pz(Mz.unexpectedLanguage)),Fz(e.hrefRaw.toLowerCase())||n.push(Pz(Mz.notFullyQualified)),"head"===e.source?a=e.node?{...Dr.makeNodeItem(e.node),snippet:`<link rel="alternate" hreflang="${e.hreflang}" href="${e.hrefRaw}" />`}:{type:"node",snippet:`<link rel="alternate" hreflang="${e.hreflang}" href="${e.hrefRaw}" />`}:"headers"===e.source&&(a=`Link: <${e.hrefRaw}>; rel="alternate"; hreflang="${e.hreflang}"`),a&&n.length&&t.push({source:a,subItems:{type:"subitems",items:n.map((e=>({reason:e})))}})}let n=Dr.makeTableDetails([{key:"source",valueType:"code",subItemsHeading:{key:"reason",valueType:"text"},label:""}],t);return{score:+(0===t.length),details:n}}},Oz=Lz})),Uz={};c(Uz,{UIStrings:()=>Bz,default:()=>Vz});var Bz,qz,zz,Vz,Wz=s((()=>{J(),xr(),ro(),fb(),400,599,qz=eo("core/audits/seo/http-status-code.js",Bz={title:"Page has successful HTTP status code",failureTitle:"Page has unsuccessful HTTP status code",description:"Pages with unsuccessful HTTP status codes may not be indexed properly. [Learn more about HTTP status codes](https://developer.chrome.com/docs/lighthouse/seo/http-status-code/)."}),zz=class extends Dr{static{o(this,"HTTPStatusCode")}static get meta(){return{id:"http-status-code",title:qz(Bz.title),failureTitle:qz(Bz.failureTitle),description:qz(Bz.description),requiredArtifacts:["devtoolsLogs","URL","GatherContext"],supportedModes:["navigation"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=e.URL,r=(await pb.request({devtoolsLog:a,URL:n},t)).statusCode;return r>=400&&r<=599?{score:0,displayValue:`${r}`}:{score:1}}},Vz=zz})),Hz=l(((e,t)=>{function a(e){return e?Array.isArray(e)?e.map(a):String(e).trim():null}function n(e){var t=e.indexOf("#");return t>-1?e.substr(0,t):e}function r(e){var t=String(e).indexOf(":");return!e||t<0?null:[e.slice(0,t),e.slice(t+1)]}function i(e){var t=e.toLowerCase(),a=t.indexOf("/");return a>-1&&(t=t.substr(0,a)),t.trim()}function s(e){try{return l(encodeURI(e).replace(/%25/g,"%"))}catch{return e}}function l(e){return e.replace(/%[0-9a-fA-F]{2}/g,(function(e){return e.toUpperCase()}))}function c(e,t){var a=new Array(t.length+1),n=1;a[0]=0;for(var r=0;r<e.length;r++){if("$"===e[r]&&r+1===e.length)return a[n-1]===t.length;if("*"==e[r]){n=t.length-a[0]+1;for(var i=1;i<n;i++)a[i]=a[i-1]+1}else{var o=0;for(i=0;i<n;i++)a[i]<t.length&&t[a[i]]===e[r]&&(a[o++]=a[i]+1);if(0==o)return!1;n=o}}return!0}function u(e,t){for(var o=e.split(/\r\n|\r|\n/).map(n).map(r).map(a),s=[],l=!0,c=0;c<o.length;c++){var u=o[c];if(u&&u[0]){switch(u[0].toLowerCase()){case"user-agent":l&&(s.length=0),u[1]&&s.push(i(u[1]));break;case"disallow":t.addRule(s,u[1],!1,c+1);break;case"allow":t.addRule(s,u[1],!0,c+1);break;case"crawl-delay":t.setCrawlDelay(s,u[1]);break;case"sitemap":u[1]&&t.addSitemap(u[1]);break;case"host":u[1]&&t.setPreferredHost(u[1].toLowerCase())}l="user-agent"!==u[0].toLowerCase()}}}function d(e,t){for(var a=null,n=0;n<t.length;n++){var r=t[n];c(r.pattern,e)&&(!a||r.pattern.length>a.pattern.length||r.pattern.length==a.pattern.length&&r.allow&&!a.allow)&&(a=r)}return a}function m(e){try{return(e=new URL(e,"http://robots-relative.samclarke.com/")).port||(e.port="https:"===e.protocol?443:80),e}catch{return null}}function p(e,t){this._url=m(e)||{},this._rules=Object.create(null),this._sitemaps=[],this._preferredHost=null,u(t||"",this)}J(),o(a,"trimLine"),o(n,"removeComments"),o(r,"splitLine"),o(i,"formatUserAgent"),o(s,"normaliseEncoding"),o(l,"urlEncodeToUpper"),o(c,"matches"),o(u,"parseRobots"),o(d,"findRule"),o(m,"parseUrl"),o(p,"Robots"),p.prototype.addRule=function(e,t,a,n){var r=this._rules;e.forEach((function(e){r[e]=r[e]||[],t&&r[e].push({pattern:s(t),allow:a,lineNumber:n})}))},p.prototype.setCrawlDelay=function(e,t){var a=this._rules,n=Number(t);e.forEach((function(e){a[e]=a[e]||[],!isNaN(n)&&(a[e].crawlDelay=n)}))},p.prototype.addSitemap=function(e){this._sitemaps.push(e)},p.prototype.setPreferredHost=function(e){this._preferredHost=e},p.prototype._getRule=function(e,t){var a=m(e)||{},n=i(t||"*");if(a.protocol===this._url.protocol&&a.hostname===this._url.hostname&&a.port===this._url.port){var r=this._rules[n]||this._rules["*"]||[];return d(l(a.pathname+a.search),r)}},p.prototype.isAllowed=function(e,t){var a=this._getRule(e,t);if(!(typeof a>"u"))return!a||a.allow},p.prototype.getMatchingLineNumber=function(e,t){var a=this._getRule(e,t);return a?a.lineNumber:-1},p.prototype.isDisallowed=function(e,t){return!this.isAllowed(e,t)},p.prototype.getCrawlDelay=function(e){var t=i(e||"*");return(this._rules[t]||this._rules["*"]||{}).crawlDelay},p.prototype.getPreferredHost=function(){return this._preferredHost},p.prototype.getSitemaps=function(){return this._sitemaps.slice(0)},t.exports=p})),Gz=l(((e,t)=>{J();var a=Hz();t.exports=function(e,t){return new a(e,t)}})),$z={};function Kz(e){let t=e.split(":");if(t.length<=1||t[0]!==eV)return!1;let a=Date.parse(t.slice(1).join(":"));return!isNaN(a)&&a<Date.now()}function Yz(e){return e.split(",").map((e=>e.toLowerCase().trim())).some((e=>Qz.has(e)||Kz(e)))}function Jz(e){let t=e.match(/^([^,:]+):/);if(t&&t[1].toLowerCase()!==eV)return t[1]}c($z,{UIStrings:()=>tV,default:()=>rV});var Zz,Xz,Qz,eV,tV,aV,nV,rV,iV=s((()=>{J(),Zz=d(Gz(),1),xr(),fb(),ro(),Xz=new Set([void 0,"Googlebot","bingbot","DuckDuckBot","archive.org_bot"]),Qz=new Set(["noindex","none"]),"x-robots-tag",eV="unavailable_after",aV=eo("core/audits/seo/is-crawlable.js",tV={title:"Page isn’t blocked from indexing",failureTitle:"Page is blocked from indexing",description:"Search engines are unable to include your pages in search results if they don't have permission to crawl them. [Learn more about crawler directives](https://developer.chrome.com/docs/lighthouse/seo/is-crawlable/)."}),o(Kz,"isUnavailable"),o(Yz,"hasBlockingDirective"),o(Jz,"getUserAgentFromHeaderDirectives"),nV=class e extends Dr{static{o(this,"IsCrawlable")}static get meta(){return{id:"is-crawlable",title:aV(tV.title),failureTitle:aV(tV.failureTitle),description:aV(tV.description),supportedModes:["navigation"],requiredArtifacts:["MetaElements","RobotsTxt","URL","devtoolsLogs"]}}static handleMetaElement(e){let t=e.content||"";if(Yz(t))return{source:{...Dr.makeNodeItem(e.node),snippet:`<meta name="${e.name}" content="${t}" />`}}}static determineIfCrawlableForUserAgent(t,a,n,r,i){let o,s=[];if(t&&(o=n.find((e=>e.name===t.toLowerCase()))),o||(o=n.find((e=>"robots"===e.name))),o){let t=e.handleMetaElement(o);t&&s.push(t)}for(let e of a.responseHeaders||[]){if("x-robots-tag"!==e.name.toLowerCase())continue;let a=Jz(e.value);if(a!==t&&void 0!==a)continue;let n=e.value.trim();t&&e.value.startsWith(`${t}:`)&&(n=e.value.replace(`${t}:`,"")),Yz(n)&&s.push({source:`${e.name}: ${e.value}`})}if(r&&!r.isAllowed(a.url,t)){let e=r.getMatchingLineNumber(a.url)||1;s.push({source:{type:"source-location",url:i.href,urlProvider:"network",line:e-1,column:0}})}return s}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=await pb.request({devtoolsLog:n,URL:t.URL},a),i=new URL("/robots.txt",r.url),o=t.RobotsTxt.content?(0,Zz.default)(i.href,t.RobotsTxt.content):void 0,s=[],l=[];for(let a of Xz){let n=e.determineIfCrawlableForUserAgent(a,r,t.MetaElements,o,i);n.length>0&&s.push(a),void 0===a&&l.push(...n)}let c=s.length===Xz.size?0:1,u=[];if(c&&s.length>0){let e=s.filter(Boolean).join(", ");u.push(`The following bot user agents are blocked from crawling: ${e}. The audit is otherwise passing, because at least one bot was explicitly allowed.`)}return{score:c,details:Dr.makeTableDetails([{key:"source",valueType:"code",label:"Blocking Directive Source"}],0===c?l:[]),warnings:u}}},rV=nV})),oV={};c(oV,{UIStrings:()=>lV,default:()=>dV});var sV,lV,cV,uV,dV,mV=s((()=>{J(),xr(),ql(),ro(),sV=new Set(["click here","click this","go","here","information","learn more","more","more info","more information","right here","read more","see more","start","this","ここをクリック","こちらをクリック","リンク","続きを読む","続く","全文表示","click aquí","click aqui","clicka aquí","clicka aqui","pincha aquí","pincha aqui","aquí","aqui","más","mas","más información","más informacion","mas información","mas informacion","este","enlace","este enlace","empezar","clique aqui","ir","mais informação","mais informações","mais","veja mais","여기","여기를 클릭","클릭","링크","자세히","자세히 보기","계속","이동","전체 보기","här","klicka här","läs mer","mer","mer info","mer information","அடுத்த பக்கம்","மறுபக்கம்","முந்தைய பக்கம்","முன்பக்கம்","மேலும் அறிக","மேலும் தகவலுக்கு","மேலும் தரவுகளுக்கு","தயவுசெய்து இங்கே அழுத்தவும்","இங்கே கிளிக் செய்யவும்"]),cV=eo("core/audits/seo/link-text.js",lV={title:"Links have descriptive text",failureTitle:"Links do not have descriptive text",description:"Descriptive link text helps search engines understand your content. [Learn how to make links more accessible](https://developer.chrome.com/docs/lighthouse/seo/link-text/).",displayValue:"{itemCount, plural,\n    =1 {1 link found}\n    other {# links found}\n    }"}),uV=class extends Dr{static{o(this,"LinkText")}static get meta(){return{id:"link-text",title:cV(lV.title),failureTitle:cV(lV.failureTitle),description:cV(lV.description),requiredArtifacts:["URL","AnchorElements"]}}static audit(e){let t,a=e.AnchorElements.filter((e=>e.href&&!e.rel.includes("nofollow"))).filter((t=>{let a=t.href.toLowerCase();return!(a.startsWith("javascript:")||a.startsWith("mailto:")||Ml.equalWithExcludedFragments(t.href,e.URL.finalDisplayedUrl))&&sV.has(t.text.trim().toLowerCase())})).map((e=>({href:e.href,text:e.text.trim()}))),n=Dr.makeTableDetails([{key:"href",valueType:"url",label:"Link destination"},{key:"text",valueType:"text",label:"Link Text"}],a);return a.length&&(t=cV(lV.displayValue,{itemCount:a.length})),{score:+(0===a.length),details:n,displayValue:t}}},dV=uV})),pV={};c(pV,{UIStrings:()=>hV,default:()=>yV});var hV,gV,fV,yV,vV=s((()=>{J(),bx(),ro(),gV=eo("core/audits/seo/manual/structured-data.js",hV={description:"Run the [Structured Data Testing Tool](https://search.google.com/structured-data/testing-tool/) and the [Structured Data Linter](http://linter.structured-data.org/) to validate structured data. [Learn more about Structured Data](https://developer.chrome.com/docs/lighthouse/seo/structured-data/).",title:"Structured data is valid"}),fV=class extends yx{static{o(this,"StructuredData")}static get meta(){return Object.assign({id:"structured-data",description:gV(hV.description),title:gV(hV.title)},super.partialMeta)}},yV=fV})),bV={};c(bV,{UIStrings:()=>wV,default:()=>TV});var wV,DV,EV,TV,SV=s((()=>{J(),xr(),ro(),DV=eo("core/audits/seo/meta-description.js",wV={title:"Document has a meta description",failureTitle:"Document does not have a meta description",description:"Meta descriptions may be included in search results to concisely summarize page content. [Learn more about the meta description](https://developer.chrome.com/docs/lighthouse/seo/meta-description/).",explanation:"Description text is empty."}),EV=class extends Dr{static{o(this,"Description")}static get meta(){return{id:"meta-description",title:DV(wV.title),failureTitle:DV(wV.failureTitle),description:DV(wV.description),requiredArtifacts:["MetaElements"]}}static audit(e){let t=e.MetaElements.find((e=>"description"===e.name));return t?0===(t.content||"").trim().length?{score:0,explanation:DV(wV.explanation)}:{score:1}:{score:0}}},TV=EV})),CV={};function kV(e){return e=e.trim().toLowerCase(),RV.has(e)||e.startsWith(AV)||e.startsWith(_V)}function xV(e){try{let t=new URL(e,"http://example.com").pathname.split(".");if(t.length<2)return!1;let a=t[t.length-1];return FV.has(a.trim().toLowerCase())}catch{return!1}}c(CV,{UIStrings:()=>IV,default:()=>LV});var AV,_V,RV,FV,NV,IV,MV,PV,LV,OV=s((()=>{J(),xr(),ro(),AV="application/x-java-applet",_V="application/x-java-bean",RV=new Set(["application/x-shockwave-flash",AV,_V,"application/x-silverlight","application/x-silverlight-2"]),FV=new Set(["swf","flv","class","xap"]),NV=new Set(["code","movie","source","src"]),MV=eo("core/audits/seo/plugins.js",IV={title:"Document avoids plugins",failureTitle:"Document uses plugins",description:"Search engines can't index plugin content, and many devices restrict plugins or don't support them. [Learn more about avoiding plugins](https://developer.chrome.com/docs/lighthouse/seo/plugins/)."}),o(kV,"isPluginType"),o(xV,"isPluginURL"),PV=class extends Dr{static{o(this,"Plugins")}static get meta(){return{id:"plugins",title:MV(IV.title),failureTitle:MV(IV.failureTitle),description:MV(IV.description),requiredArtifacts:["EmbeddedContent"]}}static audit(e){let t=e.EmbeddedContent.filter((e=>{if("APPLET"===e.tagName||("EMBED"===e.tagName||"OBJECT"===e.tagName)&&e.type&&kV(e.type))return!0;let t=e.src||e.code;return!!("EMBED"===e.tagName&&t&&xV(t)||"OBJECT"===e.tagName&&e.data&&xV(e.data))||e.params.filter((e=>NV.has(e.name.trim().toLowerCase())&&xV(e.value))).length>0})).map((e=>({source:Dr.makeNodeItem(e.node)}))),a=Dr.makeTableDetails([{key:"source",valueType:"code",label:"Element source"}],t);return{score:+(0===t.length),details:a}}},LV=PV})),jV={};function UV(e,t){if(!$V.has(e))throw new Error("Unknown directive");if(e===zV){let e;try{e=new URL(t)}catch{throw new Error("Invalid sitemap URL")}if(!KV.has(e.protocol))throw new Error("Invalid sitemap URL protocol")}if(e===VV&&!t)throw new Error("No user-agent specified");if(e===WV||e===HV){if(""!==t&&"/"!==t[0]&&"*"!==t[0])throw new Error('Pattern should either be empty, start with "/" or "*"');let e=t.indexOf("$");if(-1!==e&&e!==t.length-1)throw new Error('"$" should only be used at the end of the pattern')}}function BV(e){let t=e.indexOf("#");if(-1!==t&&(e=e.substr(0,t)),0===(e=e.trim()).length)return null;let a=e.indexOf(":");if(-1===a)throw new Error("Syntax not understood");let n=e.slice(0,a).trim().toLowerCase(),r=e.slice(a+1).trim();return UV(n,r),{directive:n,value:r}}function qV(e){let t=[],a=!1;return e.split(/\r\n|\r|\n/).forEach(((e,n)=>{let r;try{r=BV(e)}catch(a){t.push({index:(n+1).toString(),line:e,message:a.message.toString()})}r&&(r.directive===VV?a=!0:!a&&GV.has(r.directive)&&t.push({index:(n+1).toString(),line:e,message:"No user-agent specified"}))})),t}c(jV,{UIStrings:()=>YV,default:()=>XV});var zV,VV,WV,HV,GV,$V,KV,YV,JV,ZV,XV,QV=s((()=>{J(),xr(),ro(),400,500,zV="sitemap",VV="user-agent",WV="allow",HV="disallow",GV=new Set([WV,HV]),$V=new Set([VV,HV,WV,zV,"crawl-delay","clean-param","host","request-rate","visit-time","noindex"]),KV=new Set(["https:","http:","ftp:"]),JV=eo("core/audits/seo/robots-txt.js",YV={title:"robots.txt is valid",failureTitle:"robots.txt is not valid",description:"If your robots.txt file is malformed, crawlers may not be able to understand how you want your website to be crawled or indexed. [Learn more about robots.txt](https://developer.chrome.com/docs/lighthouse/seo/invalid-robots-txt/).",displayValueHttpBadCode:"Request for robots.txt returned HTTP status: {statusCode}",displayValueValidationError:"{itemCount, plural,\n    =1 {1 error found}\n    other {# errors found}\n    }",explanation:"Lighthouse was unable to download a robots.txt file"}),o(UV,"verifyDirective"),o(BV,"parseLine"),o(qV,"validateRobots"),ZV=class extends Dr{static{o(this,"RobotsTxt")}static get meta(){return{id:"robots-txt",title:JV(YV.title),failureTitle:JV(YV.failureTitle),description:JV(YV.description),requiredArtifacts:["RobotsTxt"]}}static audit(e){let{status:t,content:a}=e.RobotsTxt;if(!t)return{score:0,explanation:JV(YV.explanation)};if(t>=500)return{score:0,displayValue:JV(YV.displayValueHttpBadCode,{statusCode:t})};if(t>=400||""===a)return{score:1,notApplicable:!0};if(null===a)throw new Error(`Status ${t} was valid, but content was null`);let n,r=qV(a),i=Dr.makeTableDetails([{key:"index",valueType:"text",label:"Line #"},{key:"line",valueType:"code",label:"Content"},{key:"message",valueType:"code",label:"Error"}],r);return r.length&&(n=JV(YV.displayValueValidationError,{itemCount:r.length})),{score:+(0===r.length),details:i,displayValue:n}}},XV=ZV}));function eW(e){return e=aW(e=cw(e=lw(e)))}function tW(e,t){return Math.abs(e-t)<=10}function aW(e){for(let t=0;t<e.length;t++)for(let a=t+1;a<e.length;a++){let n=e[t],r=e[a],i=tW(n.top,r.top)||tW(n.bottom,r.bottom),o=tW(n.left,r.left)||tW(n.right,r.right);if(dw(n,r)&&(i||o)){let t=pw([n,r]),a=uw(t);if(!ow(n,a)&&!ow(r,a))continue;return(e=e.filter((e=>e!==n&&e!==r))).push(t),aW(e)}}return e}var nW=s((()=>{J(),Dw(),o(eW,"getTappableRectsFromClientRects"),o(tW,"almostEqual"),o(aW,"mergeTouchingClientRects")})),rW={};function iW(e){return e.map((e=>({tapTarget:e,paddedBoundsRect:mw(e.clientRects,hW)})))}function oW(e){return e.width<hW||e.height<hW}function sW(e){return e.filter((e=>e.tapTarget.clientRects.every(oW)))}function lW(e,t){let a=[];return e.forEach((e=>{let n=eW(e.tapTarget.clientRects);for(let r of t){if(r===e||!dw(e.paddedBoundsRect,r.paddedBoundsRect)||e.tapTarget.href===r.tapTarget.href&&/https?:\/\//.test(e.tapTarget.href))continue;let t=r.tapTarget.clientRects;if(ww(n,t))continue;let i=cW(n,t);i&&a.push({...i,tapTarget:e.tapTarget,overlappingTarget:r.tapTarget})}})),a}function cW(e,t){let a=null;for(let n of e){let e=yw(n,hW),r=fw(e,n);for(let n of t){let t=fw(e,n),i=t/r;i<gW||(!a||i>a.overlapScoreRatio)&&(a={overlapScoreRatio:i,tapTargetScore:r,overlappingTargetScore:t})}}return a}function uW(e){let t=[];return e.forEach(((a,n)=>{let r=e.find((e=>e.tapTarget===a.overlappingTarget&&e.overlappingTarget===a.tapTarget));if(!r)return void t.push(a);let{overlapScoreRatio:i}=a,{overlapScoreRatio:o}=r;(i>o||i===o&&n<e.indexOf(r))&&t.push(a)})),t}function dW(e){let t=e.map((e=>{let t=bw(e.tapTarget.clientRects),a=Math.floor(t.width),n=Math.floor(t.height),r=a+"x"+n;return{tapTarget:Dr.makeNodeItem(e.tapTarget.node),overlappingTarget:Dr.makeNodeItem(e.overlappingTarget.node),tapTargetScore:e.tapTargetScore,overlappingTargetScore:e.overlappingTargetScore,overlapScoreRatio:e.overlapScoreRatio,size:r,width:a,height:n}}));return t.sort(((e,t)=>t.overlapScoreRatio-e.overlapScoreRatio)),t}c(rW,{UIStrings:()=>mW,default:()=>yW});var mW,pW,hW,gW,fW,yW,vW=s((()=>{J(),xr(),hz(),Dw(),nW(),ro(),pW=eo("core/audits/seo/tap-targets.js",mW={title:"Tap targets are sized appropriately",failureTitle:"Tap targets are not sized appropriately",description:"Interactive elements like buttons and links should be large enough (48x48px), or have enough space around them, to be easy enough to tap without overlapping onto other elements. [Learn more about tap targets](https://developer.chrome.com/docs/lighthouse/seo/tap-targets/).",tapTargetHeader:"Tap Target",overlappingTargetHeader:"Overlapping Target",explanationViewportMetaNotOptimized:"Tap targets are too small because there's no viewport meta tag optimized for mobile screens",displayValue:"{decimalProportion, number, percent} appropriately sized tap targets"}),hW=48,gW=.25,o(iW,"getBoundedTapTargets"),o(oW,"clientRectBelowMinimumSize"),o(sW,"getTooSmallTargets"),o(lW,"getAllOverlapFailures"),o(cW,"getOverlapFailureForTargetPair"),o(uW,"mergeSymmetricFailures"),o(dW,"getTableItems"),(fW=class extends Dr{static{o(this,"TapTargets")}static get meta(){return{id:"tap-targets",title:pW(mW.title),failureTitle:pW(mW.failureTitle),description:pW(mW.description),requiredArtifacts:["MetaElements","TapTargets"]}}static async audit(e,t){if("desktop"===t.settings.formFactor)return{score:1,notApplicable:!0};if(!(await dz.request(e.MetaElements,t)).isMobileOptimized)return{score:0,explanation:pW(mW.explanationViewportMetaNotOptimized)};let a=iW(e.TapTargets),n=lW(sW(a),a),r=dW(uW(n)),i=[{key:"tapTarget",valueType:"node",label:pW(mW.tapTargetHeader)},{key:"size",valueType:"text",label:pW(no.columnSize)},{key:"overlappingTarget",valueType:"node",label:pW(mW.overlappingTargetHeader)}],o=Dr.makeTableDetails(i,r),s=e.TapTargets.length,l=new Set(n.map((e=>e.tapTarget))).size,c=1,u=1;return l>0&&(u=(s-l)/s,c=.89*u),{score:c,details:o,displayValue:pW(mW.displayValue,{decimalProportion:u})}}}).FINGER_SIZE_PX=hW,yW=fW})),bW={};c(bW,{UIStrings:()=>wW,default:()=>TW});var wW,DW,EW,TW,SW,CW,kW=s((()=>{J(),xr(),ro(),fb(),DW=eo("core/audits/server-response-time.js",wW={title:"Initial server response time was short",failureTitle:"Reduce initial server response time",description:"Keep the server response time for the main document short because all other requests depend on it. [Learn more about the Time to First Byte metric](https://developer.chrome.com/docs/lighthouse/performance/time-to-first-byte/).",displayValue:"Root document took {timeInMs, number, milliseconds} ms"}),600,100,EW=class e extends Dr{static{o(this,"ServerResponseTime")}static get meta(){return{id:"server-response-time",title:DW(wW.title),failureTitle:DW(wW.failureTitle),description:DW(wW.description),supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","URL","GatherContext"]}}static calculateResponseTime(e){return globalThis.isLightrider&&e.lrStatistics?e.lrStatistics.requestMs:e.timing?e.timing.receiveHeadersStart-e.timing.sendEnd:null}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=await pb.request({devtoolsLog:n,URL:t.URL},a),i=e.calculateResponseTime(r);if(null===i)throw new Error("no timing found for main resource");let o=i<600,s=DW(wW.displayValue,{timeInMs:i}),l=[{key:"url",valueType:"url",label:DW(no.columnURL)},{key:"responseTime",valueType:"timespanMs",label:DW(no.columnTimeSpent)}],c=Math.max(i-100,0),u=Dr.makeOpportunityDetails(l,[{url:r.url,responseTime:i}],{overallSavingsMs:c});return{numericValue:i,numericUnit:"millisecond",score:Number(o),displayValue:s,details:u,metricSavings:{FCP:c,LCP:c}}}},TW=EW})),xW=s((()=>{J(),xr(),SW=class extends Dr{static{o(this,"MultiCheckAudit")}static async audit(e,t){let a=await this.audit_(e,t);return this.createAuditProduct(a)}static createAuditProduct(e){let t={...e,...e.manifestValues,manifestValues:void 0,allChecks:void 0};e.manifestValues?.allChecks&&e.manifestValues.allChecks.forEach((e=>{t[e.id]=e.passing}));let a={type:"debugdata",items:[t]};return e.failures.length>0?{score:0,explanation:`Failures: ${e.failures.join(",\n")}.`,details:a}:{score:1,details:a}}static audit_(e,t){throw new Error("audit_ unimplemented")}},CW=SW})),AW={};c(AW,{UIStrings:()=>_W,default:()=>NW});var _W,RW,FW,NW,IW=s((()=>{J(),xW(),aO(),ro(),RW=eo("core/audits/splash-screen.js",_W={title:"Configured for a custom splash screen",failureTitle:"Is not configured for a custom splash screen",description:"A themed splash screen ensures a high-quality experience when users launch your app from their homescreens. [Learn more about splash screens](https://developer.chrome.com/docs/lighthouse/pwa/splash-screen/)."}),FW=class e extends CW{static{o(this,"SplashScreen")}static get meta(){return{id:"splash-screen",title:RW(_W.title),failureTitle:RW(_W.failureTitle),description:RW(_W.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static assessManifest(e,t){if(e.isParseFailure&&e.parseFailureReason)return void t.push(e.parseFailureReason);let a=["hasName","hasBackgroundColor","hasThemeColor","hasIconsAtLeast512px"];e.allChecks.filter((e=>a.includes(e.id))).forEach((e=>{e.passing||t.push(e.failureText)}))}static async audit_(t,a){let n=[],r=await eO.request(t,a);return e.assessManifest(r,n),{failures:n,manifestValues:r}}},NW=FW})),MW={};c(MW,{UIStrings:()=>PW,default:()=>jW});var PW,LW,OW,jW,UW=s((()=>{J(),xW(),aO(),ro(),LW=eo("core/audits/themed-omnibox.js",PW={title:"Sets a theme color for the address bar.",failureTitle:"Does not set a theme color for the address bar.",description:"The browser address bar can be themed to match your site. [Learn more about theming the address bar](https://developer.chrome.com/docs/lighthouse/pwa/themed-omnibox/)."}),OW=class e extends CW{static{o(this,"ThemedOmnibox")}static get meta(){return{id:"themed-omnibox",title:LW(PW.title),failureTitle:LW(PW.failureTitle),description:LW(PW.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors","MetaElements"]}}static assessMetaThemecolor(e,t){e?e.content||t.push("The theme-color meta tag did not contain a content value"):t.push('No `<meta name="theme-color">` tag found')}static assessManifest(e,t){if(e.isParseFailure&&e.parseFailureReason)return void t.push(e.parseFailureReason);let a=e.allChecks.find((e=>"hasThemeColor"===e.id));a&&!a.passing&&t.push(a.failureText)}static async audit_(t,a){let n=[],r=t.MetaElements.find((e=>"theme-color"===e.name)),i=await eO.request(t,a);return e.assessManifest(i,n),e.assessMetaThemecolor(r,n),{failures:n,manifestValues:i,themeColor:r?.content||null}}},jW=OW})),BW={};c(BW,{UIStrings:()=>qW,default:()=>WW});var qW,zW,VW,WW,HW=s((()=>{J(),xr(),Uu(),ro(),Yc(),uR(),fR(),zW=eo("core/audits/third-party-summary.js",qW={title:"Minimize third-party usage",failureTitle:"Reduce the impact of third-party code",description:"Third-party code can significantly impact load performance. Limit the number of redundant third-party providers and try to load third-party code after your page has primarily finished loading. [Learn how to minimize third-party impact](https://developers.google.com/web/fundamentals/performance/optimizing-content-efficiency/loading-third-party-javascript/).",columnThirdParty:"Third-Party",displayValue:"Third-party code blocked the main thread for {timeInMs, number, milliseconds} ms"}),250,4096,5,VW=class e extends Dr{static{o(this,"ThirdPartySummary")}static get meta(){return{id:"third-party-summary",title:zW(qW.title),failureTitle:zW(qW.failureTitle),description:zW(qW.description),requiredArtifacts:["traces","devtoolsLogs","URL"]}}static getSummaries(e,t,a,n){let r=new Map,i=new Map,o={mainThreadTime:0,blockingTime:0,transferSize:0};for(let t of e){let e=r.get(t.url)||{...o};e.transferSize+=t.transferSize,r.set(t.url,e)}let s=dR(e);for(let e of t){let t=mR(e,s),n=r.get(t)||{...o},i=e.selfTime*a;n.mainThreadTime+=i,n.blockingTime+=Math.max(i-50,0),r.set(t,n)}let l=new Map;for(let[e,t]of r.entries()){let a=n.entityByUrl.get(e);if(!a){r.delete(e);continue}let s=i.get(a)||{...o};s.transferSize+=t.transferSize,s.mainThreadTime+=t.mainThreadTime,s.blockingTime+=t.blockingTime,i.set(a,s);let c=l.get(a)||[];c.push(e),l.set(a,c)}return{byURL:r,byEntity:i,urls:l}}static makeSubItems(e,t,a){let n=(t.urls.get(e)||[]).map((e=>({url:e,...t.byURL.get(e)}))).filter((e=>e.transferSize>0)).sort(((e,t)=>t.blockingTime-e.blockingTime||t.transferSize-e.transferSize)),r={transferSize:0,blockingTime:0},i=Math.max(4096,a.transferSize/20),o=Math.min(5,n.length),s=0;for(;s<o;){let e=n[s];if(0===e.blockingTime&&e.transferSize<i)break;s++,r.transferSize+=e.transferSize,r.blockingTime+=e.blockingTime}if(!r.blockingTime&&!r.transferSize)return[];n=n.slice(0,s);let l={url:zW(no.otherResourcesLabel),transferSize:a.transferSize-r.transferSize,blockingTime:a.blockingTime-r.blockingTime};return l.transferSize>i&&n.push(l),n}static async audit(t,a){let n=a.settings||{},r=t.traces[Dr.DEFAULT_PASS],i=t.devtoolsLogs[Dr.DEFAULT_PASS],o=await Pc.request(i,a),s=await Pu.request({URL:t.URL,devtoolsLog:i},a),l=s.firstParty,c=await oR.request(r,a),u="simulate"===n.throttlingMethod?n.throttling.cpuSlowdownMultiplier:1,d=e.getSummaries(o,c,u,s),m={wastedBytes:0,wastedMs:0},p=Array.from(d.byEntity.entries()).filter((([e])=>!(l&&l===e))).map((([t,a])=>(m.wastedBytes+=a.transferSize,m.wastedMs+=a.blockingTime,{...a,entity:t.name,subItems:{type:"subitems",items:e.makeSubItems(t,d,a)}}))).sort(((e,t)=>t.blockingTime-e.blockingTime||t.transferSize-e.transferSize)),h=[{key:"entity",valueType:"text",label:zW(qW.columnThirdParty),subItemsHeading:{key:"url",valueType:"url"}},{key:"transferSize",granularity:1,valueType:"bytes",label:zW(no.columnTransferSize),subItemsHeading:{key:"transferSize"}},{key:"blockingTime",granularity:1,valueType:"ms",label:zW(no.columnBlockingTime),subItemsHeading:{key:"blockingTime"}}];if(!p.length)return{score:1,notApplicable:!0};let g=Dr.makeTableDetails(h,p,{...m,isEntityGrouped:!0});return{score:+(m.wastedMs<=250),displayValue:zW(qW.displayValue,{timeInMs:m.wastedMs}),details:g}}},WW=VW})),GW={};c(GW,{UIStrings:()=>$W,default:()=>ZW});var $W,KW,YW,JW,ZW,XW=s((()=>{J(),xr(),ro(),Uu(),ju(),Yc(),uR(),HW(),KW=eo("core/audits/third-party-facades.js",$W={title:"Lazy load third-party resources with facades",failureTitle:"Some third-party resources can be lazy loaded with a facade",description:"Some third-party embeds can be lazy loaded. Consider replacing them with a facade until they are required. [Learn how to defer third-parties with a facade](https://developer.chrome.com/docs/lighthouse/performance/third-party-facades/).",displayValue:"{itemCount, plural,\n  =1 {# facade alternative available}\n  other {# facade alternatives available}\n  }",columnProduct:"Product",categoryVideo:"{productName} (Video)",categoryCustomerSuccess:"{productName} (Customer Success)",categoryMarketing:"{productName} (Marketing)",categorySocial:"{productName} (Social)"}),YW={video:$W.categoryVideo,"customer-success":$W.categoryCustomerSuccess,marketing:$W.categoryMarketing,social:$W.categorySocial},JW=class e extends Dr{static{o(this,"ThirdPartyFacades")}static get meta(){return{id:"third-party-facades",title:KW($W.title),failureTitle:KW($W.failureTitle),description:KW($W.description),supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","URL"]}}static condenseItems(e){e.sort(((e,t)=>t.transferSize-e.transferSize));let t=e.findIndex((e=>e.transferSize<1e3))||1;if((-1===t||t>5)&&(t=5),t>=e.length-1)return;let a=e.splice(t).reduce(((e,t)=>(e.transferSize+=t.transferSize,e.blockingTime+=t.blockingTime,e)));a.transferSize<1e3||(a.url=KW(no.otherResourcesLabel),e.push(a))}static getProductsWithFacade(e,t){let a=new Map;for(let n of e.keys()){let e=t.entityByUrl.get(n);if(!e||t.isFirstParty(n))continue;let r=Iu.getProduct(n);!r||!r.facades||!r.facades.length||a.has(r.name)||a.set(r.name,{product:r,entity:e})}return Array.from(a.values())}static async audit(t,a){let n=a.settings,r=t.traces[Dr.DEFAULT_PASS],i=t.devtoolsLogs[Dr.DEFAULT_PASS],o=await Pc.request(i,a),s=await Pu.request({URL:t.URL,devtoolsLog:i},a),l=await oR.request(r,a),c="simulate"===n.throttlingMethod?n.throttling.cpuSlowdownMultiplier:1,u=WW.getSummaries(o,l,c,s),d=e.getProductsWithFacade(u.byURL,s),m=[];for(let{product:e,entity:t}of d){let a,n=YW[e.categories[0]];a=n?KW(n,{productName:e.name}):e.name;let r=u.urls.get(t),i=u.byEntity.get(t);if(!r||!i)continue;let o=Array.from(r).map((e=>({url:e,...u.byURL.get(e)})));this.condenseItems(o),m.push({product:a,transferSize:i.transferSize,blockingTime:i.blockingTime,subItems:{type:"subitems",items:o},entity:t.name})}if(!m.length)return{score:1,notApplicable:!0};let p=[{key:"product",valueType:"text",subItemsHeading:{key:"url",valueType:"url"},label:KW($W.columnProduct)},{key:"transferSize",valueType:"bytes",subItemsHeading:{key:"transferSize"},granularity:1,label:KW(no.columnTransferSize)},{key:"blockingTime",valueType:"ms",subItemsHeading:{key:"blockingTime"},granularity:1,label:KW(no.columnBlockingTime)}];return{score:0,displayValue:KW($W.displayValue,{itemCount:m.length}),details:Dr.makeTableDetails(p,m)}}},ZW=JW})),QW={};c(QW,{UIStrings:()=>eH,default:()=>nH});var eH,tH,aH,nH,rH=s((()=>{J(),xr(),EU(),fb(),Dm(),ro(),tH=eo("core/audits/timing-budget.js",eH={title:"Timing budget",description:"Set a timing budget to help you keep an eye on the performance of your site. Performant sites load fast and respond to user input events quickly. [Learn more about performance budgets](https://developers.google.com/web/tools/lighthouse/audits/budgets).",columnTimingMetric:"Metric",columnMeasurement:"Measurement"}),aH=class extends Dr{static{o(this,"TimingBudget")}static get meta(){return{id:"timing-budget",title:tH(eH.title),description:tH(eH.description),scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","traces","URL","GatherContext"]}}static getRowLabel(e){let t={"first-contentful-paint":no.firstContentfulPaintMetric,interactive:no.interactiveMetric,"first-meaningful-paint":no.firstMeaningfulPaintMetric,"max-potential-fid":no.maxPotentialFIDMetric,"total-blocking-time":no.totalBlockingTimeMetric,"speed-index":no.speedIndexMetric,"largest-contentful-paint":no.largestContentfulPaintMetric,"cumulative-layout-shift":no.cumulativeLayoutShiftMetric};return tH(t[e])}static getMeasurement(e,t){return{"first-contentful-paint":t.firstContentfulPaint,interactive:t.interactive,"first-meaningful-paint":t.firstMeaningfulPaint,"max-potential-fid":t.maxPotentialFID,"total-blocking-time":t.totalBlockingTime,"speed-index":t.speedIndex,"largest-contentful-paint":t.largestContentfulPaint,"cumulative-layout-shift":t.cumulativeLayoutShift}[e]}static tableItems(e,t){let a=[];if(!e.timings)return a;a=e.timings.map((e=>{let a=e.metric,n=this.getRowLabel(a),r=this.getMeasurement(a,t);return{metric:a,label:n,measurement:r,overBudget:r&&r>e.budget?r-e.budget:void 0}})).sort(((e,t)=>(t.overBudget||0)-(e.overBudget||0)));let n=a.find((e=>"cumulative-layout-shift"===e.metric));return n&&("number"==typeof n.measurement&&(n.measurement={type:"numeric",value:Number(n.measurement),granularity:.01}),"number"==typeof n.overBudget&&(n.overBudget={type:"numeric",value:Number(n.overBudget),granularity:.01})),a}static async audit(e,t){let a=e.GatherContext,n=e.devtoolsLogs[Dr.DEFAULT_PASS],r=e.traces[Dr.DEFAULT_PASS],i=e.URL,o=await pb.request({URL:i,devtoolsLog:n},t),s={trace:r,devtoolsLog:n,gatherContext:a,settings:t.settings,URL:i},l=(await vU.request(s,t)).metrics,c=wm.getMatchingBudget(t.settings.budgets,o.url);if(!c)return{score:0,notApplicable:!0};let u=[{key:"label",valueType:"text",label:tH(eH.columnTimingMetric)},{key:"measurement",valueType:"ms",label:tH(eH.columnMeasurement)},{key:"overBudget",valueType:"ms",label:tH(no.columnOverBudget)}];return{details:Dr.makeTableDetails(u,this.tableItems(c,l),{sortedBy:["overBudget"]}),score:1}}},nH=aH})),iH={};c(iH,{UIStrings:()=>oH,default:()=>cH});var oH,sH,lH,cH,uH,dH,mH=s((()=>{J(),xr(),ro(),ql(),sH=eo("core/audits/unsized-images.js",oH={title:"Image elements have explicit `width` and `height`",failureTitle:"Image elements do not have explicit `width` and `height`",description:"Set an explicit width and height on image elements to reduce layout shifts and improve CLS. [Learn how to set image dimensions](https://web.dev/optimize-cls/#images-without-dimensions)"}),lH=class e extends Dr{static{o(this,"UnsizedImages")}static get meta(){return{id:"unsized-images",title:sH(oH.title),failureTitle:sH(oH.failureTitle),description:sH(oH.description),requiredArtifacts:["ImageElements"]}}static doesHtmlAttrProvideExplicitSize(e){return!(!e||e.startsWith("+"))&&parseInt(e,10)>=0}static isCssPropExplicitlySet(e){return!!e&&!["auto","initial","unset","inherit"].includes(e)}static isSizedImage(t){if(void 0===t.cssEffectiveRules)return!0;let a=t.attributeWidth,n=t.attributeHeight,r=t.cssEffectiveRules.width,i=t.cssEffectiveRules.height,o=t.cssEffectiveRules.aspectRatio,s=e.doesHtmlAttrProvideExplicitSize(a),l=e.isCssPropExplicitlySet(r),c=e.doesHtmlAttrProvideExplicitSize(n),u=e.isCssPropExplicitlySet(i),d=e.isCssPropExplicitlySet(o),m=s||l,p=c||u;return m&&p||m&&d||p&&d}static isNonNetworkSvg(e){let t="image/svg+xml"===Ml.guessMimeType(e.src),a=e.src.slice(0,e.src.indexOf(":")),n=Ml.isNonNetworkProtocol(a);return t&&n}static async audit(t){let a=t.ImageElements.filter((e=>!e.isCss&&!e.isInShadowDOM)),n=[];for(let t of a){if("fixed"===t.computedStyles.position||"absolute"===t.computedStyles.position||e.isNonNetworkSvg(t)||e.isSizedImage(t))continue;let a=t.node.boundingRect;0===a.width&&0===a.height||n.push({url:Ml.elideDataURI(t.src),node:Dr.makeNodeItem(t.node)})}let r=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:sH(no.columnURL)}];return{score:n.length>0?0:1,notApplicable:0===a.length,details:Dr.makeTableDetails(r,n),metricSavings:{CLS:0}}}},cH=lH})),pH=s((()=>{J(),Bc(),Hc(),uH=class{static{o(this,"UserTimings")}static async compute_(e,t){let a=await kc.request(e,t),n=[],r={};return a.processEvents.filter((e=>!!e.cat.includes("blink.user_timing")&&("requestStart"!==e.name&&"navigationStart"!==e.name&&"paintNonDefaultBackgroundColor"!==e.name&&void 0===e.args.frame))).forEach((e=>{"R"===e.ph||"I"===e.ph.toUpperCase()?n.push({name:e.name,isMark:!0,args:e.args,startTime:e.ts}):"b"===e.ph.toLowerCase()?r[e.name]=e.ts:"e"===e.ph.toLowerCase()&&n.push({name:e.name,isMark:!1,args:e.args,startTime:r[e.name],endTime:e.ts,duration:e.ts-r[e.name]})})),n.forEach((e=>{e.startTime=(e.startTime-a.timeOriginEvt.ts)/1e3,e.isMark||(e.endTime=(e.endTime-a.timeOriginEvt.ts)/1e3,e.duration=e.duration/1e3)})),n}},dH=dc(uH,null)})),hH={};c(hH,{UIStrings:()=>gH,default:()=>vH});var gH,fH,yH,vH,bH=s((()=>{J(),xr(),ro(),pH(),fH=eo("core/audits/user-timings.js",gH={title:"User Timing marks and measures",description:"Consider instrumenting your app with the User Timing API to measure your app's real-world performance during key user experiences. [Learn more about User Timing marks](https://developer.chrome.com/docs/lighthouse/performance/user-timings/).",displayValue:"{itemCount, plural,\n    =1 {1 user timing}\n    other {# user timings}\n    }",columnType:"Type"}),yH=class e extends Dr{static{o(this,"UserTimings")}static get meta(){return{id:"user-timings",title:fH(gH.title),description:fH(gH.description),scoreDisplayMode:Dr.SCORING_MODES.INFORMATIVE,requiredArtifacts:["traces"]}}static get excludedPrefixes(){return["goog_"]}static excludeEvent(t){return e.excludedPrefixes.every((e=>!t.name.startsWith(e)))}static async audit(t,a){let n,r=t.traces[Dr.DEFAULT_PASS],i=(await dH.request(r,a)).filter(e.excludeEvent),o=i.map((e=>({name:e.name,startTime:e.startTime,duration:e.isMark?void 0:e.duration,timingType:e.isMark?"Mark":"Measure"}))).sort(((e,t)=>e.timingType===t.timingType?e.startTime-t.startTime:"Measure"===e.timingType?-1:1)),s=[{key:"name",valueType:"text",label:fH(no.columnName)},{key:"timingType",valueType:"text",label:fH(gH.columnType)},{key:"startTime",valueType:"ms",granularity:.01,label:fH(no.columnStartTime)},{key:"duration",valueType:"ms",granularity:.01,label:fH(no.columnDuration)}],l=Dr.makeTableDetails(s,o);return i.length&&(n=fH(gH.displayValue,{itemCount:i.length})),{score:+(0===i.length),notApplicable:0===i.length,displayValue:n,details:l}}},vH=yH})),wH={};c(wH,{UIStrings:()=>DH,default:()=>SH});var DH,EH,TH,SH,CH=s((()=>{J(),xr(),zR(),ql(),ro(),Yc(),fb(),Zc(),yD(),$c(),BR(),OR(),15e3,50,EH=eo("core/audits/uses-rel-preconnect.js",DH={title:"Preconnect to required origins",description:"Consider adding `preconnect` or `dns-prefetch` resource hints to establish early connections to important third-party origins. [Learn how to preconnect to required origins](https://developer.chrome.com/docs/lighthouse/performance/uses-rel-preconnect/).",unusedWarning:'A `<link rel=preconnect>` was found for "{securityOrigin}" but was not used by the browser. Only use `preconnect` for important origins that the page will certainly request.',crossoriginWarning:'A `<link rel=preconnect>` was found for "{securityOrigin}" but was not used by the browser. Check that you are using the `crossorigin` attribute properly.',tooManyPreconnectLinksWarning:"More than 2 `<link rel=preconnect>` connections were found. These should be used sparingly and only to the most important origins."}),TH=class e extends Dr{static{o(this,"UsesRelPreconnectAudit")}static get meta(){return{id:"uses-rel-preconnect",title:EH(DH.title),description:EH(DH.description),supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","URL","LinkElements"],scoreDisplayMode:Dr.SCORING_MODES.NUMERIC}}static hasValidTiming(e){return!!e.timing&&e.timing.connectEnd>=0&&e.timing.connectStart>=0}static hasAlreadyConnectedToOrigin(e){return!!e.timing&&(-1===e.timing.dnsStart&&-1===e.timing.dnsEnd&&-1===e.timing.connectStart&&-1===e.timing.connectEnd||e.timing.dnsEnd-e.timing.dnsStart==0&&e.timing.connectEnd-e.timing.connectStart==0)}static socketStartTimeIsBelowThreshold(e,t){return Math.max(0,e.networkRequestTime-t.networkEndTime)<15e3}static async audit(t,a){let n=t.traces[e.DEFAULT_PASS],r=t.devtoolsLogs[e.DEFAULT_PASS],i=a.settings,o=0,s=0,l=[],[c,u,d,m,p]=await Promise.all([Pc.request(r,a),pb.request({devtoolsLog:r,URL:t.URL},a),Uc.request({devtoolsLog:r,settings:i},a),lD.request(n,a),Fc.request({trace:n,devtoolsLog:r,URL:t.URL},a)]),{rtt:h,additionalRttByOrigin:g}=d.getOptions(),f=await RR.getPessimisticGraph(p,m),y=new Set;f.traverse((e=>{"network"===e.type&&y.add(e.record.url)}));let v=await SR.getPessimisticGraph(p,m),b=new Set;v.traverse((e=>{"network"===e.type&&b.add(e.record.url)}));let w=new Map;c.forEach((t=>{if(!e.hasValidTiming(t)||t.initiator.url===u.url||!t.parsedURL||!t.parsedURL.securityOrigin||u.parsedURL.securityOrigin===t.parsedURL.securityOrigin||!y.has(t.url)||e.hasAlreadyConnectedToOrigin(t)||!e.socketStartTimeIsBelowThreshold(t,u))return;let a=t.parsedURL.securityOrigin,n=w.get(a)||[];n.push(t),w.set(a,n)}));let D=t.LinkElements.filter((e=>"preconnect"===e.rel)),E=new Set(D.map((e=>Ml.getOrigin(e.href||"")))),T=[];w.forEach((e=>{let t=e.reduce(((e,t)=>t.networkRequestTime<e.networkRequestTime?t:e));if(!t.timing)return;let a=t.parsedURL.securityOrigin,n=g.get(a)||0,r=h+n;"https"===t.parsedURL.scheme&&(r*=2);let i=t.networkRequestTime-u.networkEndTime+t.timing.dnsStart,c=Math.min(r,i);if(!(c<50)){if(E.has(a))return void l.push(EH(DH.crossoriginWarning,{securityOrigin:a}));o=Math.max(c,o),b.has(t.url)&&(s=Math.max(c,o)),T.push({url:a,wastedMs:c})}})),T=T.sort(((e,t)=>t.wastedMs-e.wastedMs));for(let e of E)e&&(c.some((t=>e===t.parsedURL.securityOrigin))||l.push(EH(DH.unusedWarning,{securityOrigin:e})));if(D.length>=2)return{score:1,warnings:D.length>=3?[...l,EH(DH.tooManyPreconnectLinksWarning)]:l,metricSavings:{LCP:o,FCP:s}};let S=[{key:"url",valueType:"url",label:EH(no.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:EH(no.columnWastedMs)}],C=Dr.makeOpportunityDetails(S,T,{overallSavingsMs:o,sortedBy:["wastedMs"]});return{score:MR.scoreForWastedMs(o),numericValue:o,numericUnit:"millisecond",displayValue:o?EH(no.displayValueMsSavings,{wastedMs:o}):"",warnings:l,details:C,metricSavings:{LCP:o,FCP:s}}}},SH=TH})),kH={};c(kH,{UIStrings:()=>xH,default:()=>RH});var xH,AH,_H,RH,FH=s((()=>{J(),ql(),qc(),xr(),zR(),OI(),ro(),fb(),$c(),Zc(),AH=eo("core/audits/uses-rel-preload.js",xH={title:"Preload key requests",description:"Consider using `<link rel=preload>` to prioritize fetching resources that are currently requested later in page load. [Learn how to preload key requests](https://developer.chrome.com/docs/lighthouse/performance/uses-rel-preload/).",crossoriginWarning:'A preload `<link>` was found for "{preloadURL}" but was not used by the browser. Check that you are using the `crossorigin` attribute properly.'}),100,_H=class e extends Dr{static{o(this,"UsesRelPreloadAudit")}static get meta(){return{id:"uses-rel-preload",title:AH(xH.title),description:AH(xH.description),supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","traces","URL"],scoreDisplayMode:Dr.SCORING_MODES.NUMERIC}}static getURLsToPreload(t,a){let n=new Set;return a.traverse(((a,r)=>{if("network"!==a.type)return;let i=r.slice(1).filter((e=>"network"===e.type));e.shouldPreloadRequest(a.record,t,i)&&n.add(a.record.url)})),n}static getURLsFailedToPreload(e){let t=[];e.traverse((e=>"network"===e.type&&t.push(e.record)));let a=t.filter((e=>e.isLinkPreload)),n=new Map;for(let e of a){let t=n.get(e.frameId)||new Set;t.add(e.url),n.set(e.frameId,t)}let r=t.filter((e=>{let t=n.get(e.frameId);return!(!t||!t.has(e.url))&&!(e.fromDiskCache||e.fromMemoryCache||e.fromPrefetchCache||e.isLinkPreload)}));return new Set(r.map((e=>e.url)))}static shouldPreloadRequest(e,t,a){let n=t.redirects?t.redirects.length:0;return!(e.isLinkPreload||!PI.isCritical(e,t)||wc.isNonNetworkRequest(e)||a.length!==n+2||e.frameId!==t.frameId)&&Ml.rootDomainsMatch(e.url,t.url)}static computeWasteWithGraph(e,t,a){if(!e.size)return{wastedMs:0,results:[]};let n=a.simulate(t,{flexibleOrdering:!0}),r=t.cloneWithRelationships(),i=[],o=null;if(r.traverse((t=>{"network"===t.type&&(t.isMainDocument()?o=t:t.record&&e.has(t.record.url)&&i.push(t))})),!o)throw new Error("Could not find main document node");for(let e of i)e.removeAllDependencies(),e.addDependency(o);let s=a.simulate(r,{flexibleOrdering:!0}),l=Array.from(n.nodeTimings.keys()).reduce(((e,t)=>e.set(t.record,t)),new Map),c=[];for(let e of i){let t=l.get(e.record),a=s.nodeTimings.get(e),r=n.nodeTimings.get(t);if(!r||!a)throw new Error("Missing preload node");let i=Math.round(r.endTime-a.endTime);i<100||c.push({url:e.record.url,wastedMs:i})}return c.length?{wastedMs:Math.max(...c.map((e=>e.wastedMs))),results:c}:{wastedMs:0,results:c}}static async audit_(t,a){let n=t.traces[e.DEFAULT_PASS],r=t.devtoolsLogs[e.DEFAULT_PASS],i=t.URL,o={devtoolsLog:r,settings:a.settings},[s,l,c]=await Promise.all([pb.request({devtoolsLog:r,URL:i},a),Fc.request({trace:n,devtoolsLog:r,URL:i},a),Uc.request(o,a)]),u=e.getURLsToPreload(s,l),{results:d,wastedMs:m}=e.computeWasteWithGraph(u,l,c);d.sort(((e,t)=>t.wastedMs-e.wastedMs));let p,h=e.getURLsFailedToPreload(l);h.size&&(p=Array.from(h).map((e=>AH(xH.crossoriginWarning,{preloadURL:e}))));let g=[{key:"url",valueType:"url",label:AH(no.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:AH(no.columnWastedMs)}],f=Dr.makeOpportunityDetails(g,d,{overallSavingsMs:m,sortedBy:["wastedMs"]});return{score:MR.scoreForWastedMs(m),numericValue:m,numericUnit:"millisecond",displayValue:m?AH(no.displayValueMsSavings,{wastedMs:m}):"",details:f,warnings:p}}static async audit(){return{score:1,notApplicable:!0,details:Dr.makeOpportunityDetails([],[],{overallSavingsMs:0})}}},RH=_H})),NH={};c(NH,{UIStrings:()=>IH,default:()=>LH});var IH,MH,PH,LH,OH=s((()=>{J(),xr(),Uu(),ro(),kr(),ql(),MH=eo("core/audits/valid-source-maps.js",IH={title:"Page has valid source maps",failureTitle:"Missing source maps for large first-party JavaScript",description:"Source maps translate minified code to the original source code. This helps developers debug in production. In addition, Lighthouse is able to provide further insights. Consider deploying source maps to take advantage of these benefits. [Learn more about source maps](https://developer.chrome.com/docs/devtools/javascript/source-maps/).",columnMapURL:"Map URL",missingSourceMapErrorMessage:"Large JavaScript file is missing a source map",missingSourceMapItemsWarningMesssage:"{missingItems, plural,\n    =1 {Warning: missing 1 item in `.sourcesContent`}\n    other {Warning: missing # items in `.sourcesContent`}\n    }"}),512e3,PH=class extends Dr{static{o(this,"ValidSourceMaps")}static get meta(){return{id:"valid-source-maps",title:MH(IH.title),failureTitle:MH(IH.failureTitle),description:MH(IH.description),requiredArtifacts:["Scripts","SourceMaps","URL","devtoolsLogs"]}}static isLargeFirstPartyJS(e,t){let a=e.url;if(!(e.length&&a&&Ml.isValid(a)&&br.createOrReturnURL(a).protocol.startsWith("http")))return!1;let n=e.length>=512e3;return t.isFirstParty(a)&&n}static async audit(e,t){let{SourceMaps:a}=e,n=e.devtoolsLogs[Dr.DEFAULT_PASS],r=await Pu.request({URL:e.URL,devtoolsLog:n},t),i=new Set,o=!1,s=[];for(let t of e.Scripts){let e=a.find((e=>e.scriptId===t.scriptId)),n=[];if(this.isLargeFirstPartyJS(t,r)&&(!e||!e.map)&&(o=!0,i.add(t.url),n.push({error:MH(IH.missingSourceMapErrorMessage)})),e&&!e.map&&n.push({error:e.errorMessage}),e?.map){let t=e.map.sourcesContent||[],a=0;for(let n=0;n<e.map.sources.length;n++)(t.length<n||!t[n])&&(a+=1);a>0&&n.push({error:MH(IH.missingSourceMapItemsWarningMesssage,{missingItems:a})})}(e||n.length)&&s.push({scriptUrl:t.url,sourceMapUrl:e?.sourceMapUrl,subItems:{type:"subitems",items:n}})}let l=[{key:"scriptUrl",valueType:"url",subItemsHeading:{key:"error"},label:MH(no.columnURL)},{key:"sourceMapUrl",valueType:"url",label:MH(IH.columnMapURL)}];return s.sort(((e,t)=>{let a=i.has(e.scriptUrl),n=i.has(t.scriptUrl);return a&&!n?-1:!a&&n?1:e.subItems.items.length&&!t.subItems.items.length?-1:!e.subItems.items.length&&t.subItems.items.length?1:t.scriptUrl.localeCompare(e.scriptUrl)})),{score:o?0:1,details:Dr.makeTableDetails(l,s)}}},LH=PH})),jH={};c(jH,{UIStrings:()=>UH,default:()=>zH});var UH,BH,qH,zH,VH=s((()=>{J(),xr(),hz(),ro(),BH=eo("core/audits/viewport.js",UH={title:'Has a `<meta name="viewport">` tag with `width` or `initial-scale`',failureTitle:'Does not have a `<meta name="viewport">` tag with `width` or `initial-scale`',description:'A `<meta name="viewport">` not only optimizes your app for mobile screen sizes, but also prevents [a 300 millisecond delay to user input](https://developer.chrome.com/blog/300ms-tap-delay-gone-away/). [Learn more about using the viewport meta tag](https://developer.chrome.com/docs/lighthouse/pwa/viewport/).',explanationNoTag:'No `<meta name="viewport">` tag found'}),qH=class extends Dr{static{o(this,"Viewport")}static get meta(){return{id:"viewport",title:BH(UH.title),failureTitle:BH(UH.failureTitle),description:BH(UH.description),requiredArtifacts:["MetaElements"]}}static async audit(e,t){let a=await dz.request(e.MetaElements,t),n=300;return a.hasViewportTag?(a.isMobileOptimized&&(n=0),{score:Number(a.isMobileOptimized),metricSavings:{INP:n},warnings:a.parserWarnings}):{score:0,explanation:BH(UH.explanationNoTag),metricSavings:{INP:n}}}},zH=qH})),WH={};c(WH,{UIStrings:()=>HH,default:()=>KH});var HH,GH,$H,KH,YH,JH,ZH,XH,QH,eG,tG,aG=s((()=>{J(),xr(),vD(),Hc(),ro(),Yc(),cR(),lR(),na(),fR(),ZU(),xl(),1,GH=eo("core/audits/work-during-interaction.js",HH={title:"Minimizes work during key interaction",failureTitle:"Minimize work during key interaction",description:"This is the thread-blocking work occurring during the Interaction to Next Paint measurement. [Learn more about the Interaction to Next Paint metric](https://web.dev/inp/).",inputDelay:"Input delay",processingTime:"Processing time",presentationDelay:"Presentation delay",displayValue:"{timeInMs, number, milliseconds} ms spent on event '{interactionType}'",eventTarget:"Event target"}),$H=class e extends Dr{static{o(this,"WorkDuringInteraction")}static get meta(){return{id:"work-during-interaction",title:GH(HH.title),failureTitle:GH(HH.failureTitle),description:GH(HH.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["timespan"],requiredArtifacts:["traces","devtoolsLogs","TraceElements"]}}static recursivelyClipTasks(t,a,n,r){let i=t.event.ts,o=t.endEvent?.ts??t.event.ts+Number(t.event.dur||0);t.startTime=Math.max(n,Math.min(r,i))/1e3,t.endTime=Math.max(n,Math.min(r,o))/1e3,t.duration=t.endTime-t.startTime;let s=t.children.map((a=>e.recursivelyClipTasks(a,t,n,r))).reduce(((e,t)=>e+t),0);return t.selfTime=t.duration-s,t.duration}static clipTasksByTs(t,a,n){for(let r of t)r.parent||e.recursivelyClipTasks(r,void 0,a,n)}static getPhaseTimes(e){let t=e.args.data,a=e.ts,n=a-1e3*t.timeStamp,r=n+1e3*t.processingStart,i=n+1e3*t.processingEnd;return{inputDelay:{startTs:a,endTs:r},processingTime:{startTs:r,endTs:i},presentationDelay:{startTs:i,endTs:a+1e3*t.duration}}}static getThreadBreakdownTable(t,a,n,r){let i=Xt.filteredTraceSort(a.traceEvents,(e=>e.pid===t.pid&&e.tid===t.tid)),o=i.reduce(((e,t)=>Math.max(t.ts+(t.dur||0),e)),0),{frames:s}=n,l=rR.getMainThreadTasks(i,s,o),c=e.getPhaseTimes(t),u=[];for(let[t,a]of Object.entries(c)){e.clipTasksByTs(l,a.startTs,a.endTs);let n=pR(l,r),i=[];for(let[e,t]of n){let a=Object.values(t).reduce(((e,t)=>e+t)),n=t[aR.scriptEvaluation.id]||0,r=t[aR.styleLayout.id]||0,o=t[aR.paintCompositeRender.id]||0;i.push({url:e,total:a,scripting:n,layout:r,render:o})}let o=i.filter((e=>e.total>1)).sort(((e,t)=>t.total-e.total));u.push({phase:GH(HH[t]),total:(a.endTs-a.startTs)/1e3,subItems:{type:"subitems",items:o}})}let d=[{key:"phase",valueType:"text",subItemsHeading:{key:"url",valueType:"url"},label:"Phase"},{key:"total",valueType:"ms",subItemsHeading:{key:"total",granularity:1,valueType:"ms"},granularity:1,label:"Total time"},{key:null,valueType:"ms",subItemsHeading:{key:"scripting",granularity:1,valueType:"ms"},label:"Script evaluation"},{key:null,valueType:"ms",subItemsHeading:{key:"layout",granularity:1,valueType:"ms"},label:aR.styleLayout.label},{key:null,valueType:"ms",subItemsHeading:{key:"render",granularity:1,valueType:"ms"},label:aR.paintCompositeRender.label}];return{table:Dr.makeTableDetails(d,u,{sortedBy:["total"]}),phases:c}}static getTraceElementTable(e){let t=e.find((e=>"responsiveness"===e.traceEventType));if(!t)return;let a=[{key:"node",valueType:"node",label:GH(HH.eventTarget)}],n=[{node:Dr.makeNodeItem(t.node)}];return Dr.makeTableDetails(a,n)}static async audit(t,a){let{settings:n}=a;if("simulate"===n.throttlingMethod)return{score:null,notApplicable:!0,metricSavings:{INP:0}};let r=t.traces[e.DEFAULT_PASS],i={trace:r,settings:n},o=await pD.request(i,a);if(null===o)return{score:null,notApplicable:!0,metricSavings:{INP:0}};if("FallbackTiming"===o.name)throw new El(El.errors.UNSUPPORTED_OLD_CHROME,{featureName:"detailed EventTiming trace events"});let s=[],l=e.getTraceElementTable(t.TraceElements);l&&s.push(l);let c=t.devtoolsLogs[e.DEFAULT_PASS],u=await Pc.request(c,a),d=await kc.request(r,a),{table:m,phases:p}=e.getThreadBreakdownTable(o,r,d,u);s.push(m);let h=o.args.data.type;s.push({type:"debugdata",interactionType:h,phases:p});let g=o.args.data.duration,f=GH(HH.displayValue,{timeInMs:g,interactionType:h});return{score:g<JU.defaultOptions.p10?1:0,displayValue:f,details:{type:"list",items:s},metricSavings:{INP:g}}}},KH=$H})),nG=s((()=>{J(),ro(),JH=eo("node_modules/lighthouse-plugin-publisher-ads/messages/common-strings.js",YH={GROUPS__METRICS:"Metrics",GROUPS__ADS_PERFORMANCE:"Ad Speed",GROUPS__ADS_BEST_PRACTICES:"Tag Best Practices",NOT_APPLICABLE__DEFAULT:"Audit not applicable",NOT_APPLICABLE__INVALID_TIMING:"Invalid timing task data",NOT_APPLICABLE__NO_AD_RELATED_REQ:"No ad-related requests",NOT_APPLICABLE__NO_AD_RENDERED:"No ads rendered",NOT_APPLICABLE__NO_ADS_VIEWPORT:"No ads in viewport",NOT_APPLICABLE__NO_ADS:"No ads requested",NOT_APPLICABLE__NO_BIDS:"No bids detected",NOT_APPLICABLE__NO_EVENT_MATCHING_REQ:"No event matches network records",NOT_APPLICABLE__NO_GPT:"GPT not requested",NOT_APPLICABLE__NO_RECORDS:"No successful network records",NOT_APPLICABLE__NO_VISIBLE_SLOTS:"No visible slots",NOT_APPLICABLE__NO_TAG:"No tag requested",NOT_APPLICABLE__NO_TAGS:"No tags requested",NOT_APPLICABLE__NO_TASKS:"No tasks to compare",NOT_APPLICABLE__NO_VALID_AD_WIDTHS:"No requested ads contain ads of valid width",NOT_APPLICABLE__NO_LAYOUT_SHIFTS:"No layout shift events found",ERRORS__AREA_LARGER_THAN_VIEWPORT:"Calculated ad area is larger than viewport",ERRORS__VIEWPORT_AREA_ZERO:"Viewport area is zero",WARNINGS__NO_ADS:"No ads were requested when fetching this page.",WARNINGS__NO_AD_RENDERED:"No ads were rendered when rendering this page.",WARNINGS__NO_TAG:"The GPT tag was not requested."}),ZH=o((e=>({notApplicable:!0,score:1,displayValue:JH(e)})),"notApplicableObj"),XH={Default:ZH(YH.NOT_APPLICABLE__DEFAULT),InvalidTiming:ZH(YH.NOT_APPLICABLE__INVALID_TIMING),NoAdRelatedReq:ZH(YH.NOT_APPLICABLE__NO_AD_RELATED_REQ),NoAdRendered:ZH(YH.NOT_APPLICABLE__NO_AD_RENDERED),NoAdsViewport:ZH(YH.NOT_APPLICABLE__NO_ADS_VIEWPORT),NoAds:ZH(YH.NOT_APPLICABLE__NO_ADS),NoBids:ZH(YH.NOT_APPLICABLE__NO_BIDS),NoEventMatchingReq:ZH(YH.NOT_APPLICABLE__NO_EVENT_MATCHING_REQ),NoGpt:ZH(YH.NOT_APPLICABLE__NO_GPT),NoLayoutShifts:ZH(YH.NOT_APPLICABLE__NO_LAYOUT_SHIFTS),NoRecords:ZH(YH.NOT_APPLICABLE__NO_RECORDS),NoVisibleSlots:ZH(YH.NOT_APPLICABLE__NO_VISIBLE_SLOTS),NoTag:ZH(YH.NOT_APPLICABLE__NO_TAG),NoTags:ZH(YH.NOT_APPLICABLE__NO_TAGS),NoTasks:ZH(YH.NOT_APPLICABLE__NO_TASKS),NoValidAdWidths:ZH(YH.NOT_APPLICABLE__NO_VALID_AD_WIDTHS)},QH={NoAds:JH(YH.WARNINGS__NO_ADS),NoAdRendered:JH(YH.WARNINGS__NO_AD_RENDERED),NoTag:JH(YH.WARNINGS__NO_TAG)},eG={ViewportAreaZero:JH(YH.ERRORS__VIEWPORT_AREA_ZERO)},tG={Metrics:JH(YH.GROUPS__METRICS),AdsPerformance:JH(YH.GROUPS__ADS_PERFORMANCE),AdsBestPractices:JH(YH.GROUPS__ADS_BEST_PRACTICES)}})),rG={};c(rG,{UIStrings:()=>oG,default:()=>lG});var iG,oG,sG,lG,cG,uG=s((()=>{J(),ro(),nG(),iG="lighthouse-plugin-publisher-ads",sG=eo("node_modules/lighthouse-plugin-publisher-ads/plugin.js",oG={categoryDescription:"A Lighthouse plugin to improve ad speed and overall quality that is targeted at sites using GPT or AdSense tag. [Learn more](https://developers.google.com/publisher-ads-audits/reference)"}),lG={audits:[{path:`${iG}/audits/ad-blocking-tasks`},{path:`${iG}/audits/ad-render-blocking-resources`},{path:`${iG}/audits/ad-request-critical-path`},{path:`${iG}/audits/bid-request-from-page-start`},{path:`${iG}/audits/ad-request-from-page-start`},{path:`${iG}/audits/ad-top-of-viewport`},{path:`${iG}/audits/ads-in-viewport`},{path:`${iG}/audits/async-ad-tags`},{path:`${iG}/audits/blocking-load-events`},{path:`${iG}/audits/bottleneck-requests`},{path:`${iG}/audits/duplicate-tags`},{path:`${iG}/audits/first-ad-render`},{path:`${iG}/audits/full-width-slots`},{path:`${iG}/audits/gpt-bids-parallel`},{path:`${iG}/audits/loads-gpt-from-official-source`},{path:`${iG}/audits/loads-ad-tag-over-https`},{path:`${iG}/audits/script-injected-tags`},{path:`${iG}/audits/serial-header-bidding`},{path:`${iG}/audits/tag-load-time`},{path:`${iG}/audits/viewport-ad-density`},{path:`${iG}/audits/cumulative-ad-shift`},{path:`${iG}/audits/deprecated-api-usage`},{path:`${iG}/audits/gpt-errors-overall`},{path:`${iG}/audits/total-ad-blocking-time`}],groups:{metrics:{title:tG.Metrics},"ads-performance":{title:tG.AdsPerformance},"ads-best-practices":{title:tG.AdsBestPractices}},category:{title:"Publisher Ads",description:sG(oG.categoryDescription),auditRefs:[{id:"tag-load-time",weight:5,group:"metrics"},{id:"bid-request-from-page-start",weight:5,group:"metrics"},{id:"ad-request-from-page-start",weight:25,group:"metrics"},{id:"first-ad-render",weight:10,group:"metrics"},{id:"cumulative-ad-shift",weight:5,group:"metrics"},{id:"total-ad-blocking-time",weight:2,group:"metrics"},{id:"gpt-bids-parallel",weight:1,group:"ads-performance"},{id:"serial-header-bidding",weight:1,group:"ads-performance"},{id:"bottleneck-requests",weight:1,group:"ads-performance"},{id:"script-injected-tags",weight:1,group:"ads-performance"},{id:"blocking-load-events",weight:1,group:"ads-performance"},{id:"ad-render-blocking-resources",weight:1,group:"ads-performance"},{id:"ad-blocking-tasks",weight:1,group:"ads-performance"},{id:"ad-request-critical-path",weight:0,group:"ads-performance"},{id:"ads-in-viewport",weight:4,group:"ads-best-practices"},{id:"async-ad-tags",weight:2,group:"ads-best-practices"},{id:"loads-ad-tag-over-https",weight:1,group:"ads-best-practices"},{id:"loads-gpt-from-official-source",weight:4,group:"ads-best-practices"},{id:"viewport-ad-density",weight:2,group:"ads-best-practices"},{id:"ad-top-of-viewport",weight:2,group:"ads-best-practices"},{id:"duplicate-tags",weight:1,group:"ads-best-practices"},{id:"deprecated-gpt-api-usage",weight:0,group:"ads-best-practices"},{id:"gpt-errors-overall",weight:0,group:"ads-best-practices"}]}}})),dG=s((()=>{J(),cG=[{label:"Prebid JS",patterns:["^https?://([^.]*.)?prebid[.]org/.*","^https?://acdn[.]adnxs[.]com/prebid/.*"]},{label:"33Across",patterns:["^https?://ssc[.]33across.com/api/.*"]},{label:"AppNexus",patterns:["^https?://ib[.]adnxs[.]com/.*"]},{label:"Amazon Ads",patterns:["^https?://[a-z-_.]*[.]amazon-adsystem[.]com/.*bid.*"]},{label:"AdTechus (AOL)",patterns:["^https?://([^.]*.)?adserver[.]adtechus[.]com/.*"]},{label:"Aardvark",patterns:["^https?://thor[.]rtk[.]io/.*"]},{label:"AdBlade",patterns:["^https?://rtb[.]adblade[.]com/prebidjs/bid.*"]},{label:"AdBund",patterns:["^https?://us-east-engine[.]adbund[.]xyz/prebid/ad/get.*","^https?://us-west-engine[.]adbund[.]xyz/prebid/ad/get.*"]},{label:"AdButler",patterns:["^https?://servedbyadbutler[.]com/adserve.*"]},{label:"Adequant",patterns:["^https?://rex[.]adequant[.]com/rex/c2s_prebid.*"]},{label:"AdForm",patterns:["^https?://adx[.]adform[.]net/adx.*"]},{label:"AdMedia",patterns:["^https?://b[.]admedia[.]com/banner/prebid/bidder.*"]},{label:"AdMixer",patterns:["^https?://inv-nets[.]admixer[.]net/prebid[.]aspx.*","^https?://inv-nets[.]admixer[.]net/videoprebid[.]aspx.*"]},{label:"AOL",patterns:["^https?://adserver-us[.]adtech[.]advertising[.]com.*","^https?://adserver-eu[.]adtech[.]advertising[.]com.*","^https?://adserver-as[.]adtech[.]advertising[.]com.*","^https?://adserver[.]adtech[.]de/pubapi/.*"]},{label:"Beachfront",patterns:["^https?://reachms[.]bfmio[.]com/bid[.]json?exchange_id=.*"]},{label:"Bidfluence",patterns:["^https?://cdn[.]bidfluence[.]com/forge[.]js.*"]},{label:"Brightcom",patterns:["^https?://hb[.]iselephant[.]com/auc/ortb.*"]},{label:"C1x",patterns:["^https?://ht-integration[.]c1exchange[.]com:9000/ht.*"]},{label:"CentroBid",patterns:["^https?://t[.]brand-server[.]com/hb.*"]},{label:"Conversant",patterns:["^https?://media[.]msg[.]dotomi[.]com/s2s/.*"]},{label:"Criteo",patterns:["^https?://static[.]criteo[.]net/js/ld/publishertag[.]js.*","^https?://([^.]*.)?bidder[.]criteo[.]com/cdb.*","^https?://([^.]*.)?rtax[.]criteo[.]com/delivery/rta.*","^https?://([^.]*.)?rtax[.]eu[.]criteo[.]com/delivery/rta.*"]},{label:"Datablocks",patterns:["^https?://[a-z0-9_.-]*[.]dblks[.]net/.*"]},{label:"Districtm",patterns:["^https?://prebid[.]districtm[.]ca/lib[.]js.*"]},{label:"E-Planning",patterns:["^https?://ads[.]us[.]e-planning[.]net.*"]},{label:"Essens",patterns:["^https?://bid[.]essrtb[.]com/bid/prebid_call.*"]},{label:"Facebook",patterns:["^https?://an[.]facebook[.]com/v2/placementbid[.]json.*"]},{label:"FeatureForward",patterns:["^https?://prmbdr[.]featureforward[.]com/newbidder/.*"]},{label:"Fidelity",patterns:["^https?://x[.]fidelity-media[.]com.*"]},{label:"GetIntent",patterns:["^https?://px[.]adhigh[.]net/rtb/direct_banner.*","^https?://px[.]adhigh[.]net/rtb/direct_vast.*"]},{label:"GumGum",patterns:["^https?://g2[.]gumgum[.]com/hbid/imp.*"]},{label:"Hiromedia",patterns:["^https?://hb-rtb[.]ktdpublishers[.]com/bid/get.*"]},{label:"Imonomy",patterns:["^https?://b[.]imonomy[.]com/openrtb/hb/.*"]},{label:"ImproveDigital",patterns:["^https?://ad[.]360yield[.]com/hb.*"]},{label:"IndexExchange",patterns:["^https?://as(-sec)?[.]casalemedia[.]com/(cygnus|headertag).*","^https?://js(-sec)?[.]indexww[.]com/ht/.*"]},{label:"InnerActive",patterns:["^https?://ad-tag[.]inner-active[.]mobi/simpleM2M/requestJsonAd.*"]},{label:"Innity",patterns:["^https?://as[.]innity[.]com/synd/.*"]},{label:"JCM",patterns:["^https?://media[.]adfrontiers[.]com/pq.*"]},{label:"JustPremium",patterns:["^https?://pre[.]ads[.]justpremium[.]com/v/.*"]},{label:"Kargo",patterns:["^https?://krk[.]kargo[.]com/api/v1/bid.*"]},{label:"Komoona",patterns:["^https?://bidder[.]komoona[.]com/v1/GetSBids.*"]},{label:"KruxLink",patterns:["^https?://link[.]krxd[.]net/hb.*"]},{label:"Kumma",patterns:["^https?://cdn[.]kumma[.]com/pb_ortb[.]js.*"]},{label:"Mantis",patterns:["^https?://mantodea[.]mantisadnetwork[.]com/website/prebid.*"]},{label:"MarsMedia",patterns:["^https?://bid306[.]rtbsrv[.]com:9306/bidder.*"]},{label:"Media.net",patterns:["^https?://contextual[.]media[.]net/bidexchange.*"]},{label:"MemeGlobal",patterns:["^https?://stinger[.]memeglobal[.]com/api/v1/services/prebid.*"]},{label:"MobFox",patterns:["^https?://my[.]mobfox[.]com/request[.]php.*"]},{label:"NanoInteractive",patterns:["^https?://tmp[.]audiencemanager[.]de/hb.*"]},{label:"OpenX",patterns:["^https?://([^.]*.)?d[.]openx[.]net/w/1[.]0/arj.*","^https?://([^.]*.)?servedbyopenx[.]com/.*"]},{label:"Piximedia",patterns:["^https?://static[.]adserver[.]pm/prebid.*"]},{label:"Platformio",patterns:["^https?://piohbdisp[.]hb[.]adx1[.]com.*"]},{label:"Pollux",patterns:["^https?://adn[.]plxnt[.]com/prebid.*"]},{label:"PubGears",patterns:["^https?://c[.]pubgears[.]com/tags.*"]},{label:"Pubmatic",patterns:["^https?://ads[.]pubmatic[.]com/AdServer/js/gshowad[.]js.*","^https?://([^.]*.)?gads.pubmatic[.]com/.*","^https?://hbopenbid.pubmatic[.]com/.*"]},{label:"Pulsepoint",patterns:["^https?://bid[.]contextweb[.]com/header/tag.*"]},{label:"Quantcast",patterns:["^https?://global[.]qc[.]rtb[.]quantserve[.]com:8080/qchb.*"]},{label:"Rhythmone",patterns:["^https?://tag[.]1rx[.]io/rmp/.*"]},{label:"Roxot",patterns:["^https?://r[.]rxthdr[.]com.*"]},{label:"Rubicon",patterns:["^https?://([^.]*.)?(fastlane|optimized-by|anvil)[.]rubiconproject[.]com/a/api.*","^https?://fastlane-adv[.]rubiconproject[.]com/v1/auction/video.*"]},{label:"Sekindo",patterns:["^https?://hb[.]sekindo[.]com/live/liveView[.]php.*"]},{label:"ShareThrough",patterns:["^https?://btlr[.]sharethrough[.]com/header-bid/.*"]},{label:"Smart AdServer",patterns:["^https?://prg[.]smartadserver[.]com/prebid.*"]},{label:"Sonobi",patterns:["^https?://apex[.]go[.]sonobi[.]com/trinity[.]js.*"]},{label:"Sovrn",patterns:["^https?://ap[.]lijit[.]com/rtb/bid.*"]},{label:"SpringServe",patterns:["^https?://bidder[.]springserve[.]com/display/hbid.*"]},{label:"StickyAds",patterns:["^https?://cdn[.]stickyadstv[.]com/mustang/mustang[.]min[.]js.*","^https?://cdn[.]stickyadstv[.]com/prime-time/.*"]},{label:"TapSense3",patterns:["^https?://ads04[.]tapsense[.]com/ads/headerad.*"]},{label:"ThoughtLeadr",patterns:["^https?://a[.]thoughtleadr[.]com/v4/.*"]},{label:"TremorBid",patterns:["^https?://([^.]*.)?ads[.]tremorhub[.]com/ad/tag.*"]},{label:"Trion",patterns:["^https?://in-appadvertising[.]com/api/bidRequest.*"]},{label:"TripleLift",patterns:["^https?://tlx[.]3lift[.]com/header/auction.*"]},{label:"TrustX",patterns:["^https?://sofia[.]trustx[.]org/hb.*"]},{label:"UCFunnel",patterns:["^https?://agent[.]aralego[.]com/header.*"]},{label:"Underdog Media",patterns:["^https?://udmserve[.]net/udm/img[.]fetch.*"]},{label:"UnRuly",patterns:["^https?://targeting[.]unrulymedia[.]com/prebid.*"]},{label:"VertaMedia",patterns:["^https?://rtb[.]vertamedia[.]com/hb/.*"]},{label:"Vertoz",patterns:["^https?://hb[.]vrtzads[.]com/vzhbidder/bid.*"]},{label:"WideOrbig",patterns:["^https?://([^.]*.)?atemda[.]com/JSAdservingMP[.]ashx.*"]},{label:"WideSpace",patterns:["^https?://engine[.]widespace[.]com/map/engine/hb/.*"]},{label:"YieldBot",patterns:["^https?://cdn[.]yldbt[.]com/js/yieldbot[.]intent[.]js.*"]},{label:"YieldMo",patterns:["^https?://ads[.]yieldmo[.]com/exchange/prebid.*"]}]})),mG=l(((e,t)=>{J();var a=/([a-zA-Z][a-zA-Z_-]*)\s*(?:=(?:"([^"]*)"|([^ \t",;]*)))?/g,n="max-age",r="s-maxage",i="max-stale",s="min-fresh",l="immutable",c="must-revalidate",u="no-cache",d="no-store",m="no-transform",p="only-if-cached",h="private",g="proxy-revalidate",f="public";function y(e){return null===e}function v(e){if(!e)return null;let t=parseInt(e,10);return!Number.isFinite(t)||t<0?null:t}o(y,"parseBooleanOnly"),o(v,"parseDuration");var b=class{static{o(this,"CacheControl")}constructor(){this.maxAge=null,this.sharedMaxAge=null,this.maxStale=null,this.maxStaleDuration=null,this.minFresh=null,this.immutable=null,this.mustRevalidate=null,this.noCache=null,this.noStore=null,this.noTransform=null,this.onlyIfCached=null,this.private=null,this.proxyRevalidate=null,this.public=null}parse(e){if(!e||0===e.length)return this;let t={},o=e.match(a)||[];return Array.prototype.forEach.call(o,(e=>{let a=e.split("=",2),[n]=a,r=null;a.length>1&&(r=a[1].trim()),t[n.toLowerCase()]=r})),this.maxAge=v(t[n]),this.sharedMaxAge=v(t[r]),this.maxStale=y(t[i]),this.maxStaleDuration=v(t[i]),this.maxStaleDuration&&(this.maxStale=!0),this.minFresh=v(t[s]),this.immutable=y(t[l]),this.mustRevalidate=y(t[c]),this.noCache=y(t[u]),this.noStore=y(t[d]),this.noTransform=y(t[m]),this.onlyIfCached=y(t[p]),this.private=y(t[h]),this.proxyRevalidate=y(t[g]),this.public=y(t[f]),this}format(){let e=[];return"number"==typeof this.maxAge&&e.push(`${n}=${this.maxAge}`),"number"==typeof this.sharedMaxAge&&e.push(`${r}=${this.sharedMaxAge}`),this.maxStale&&("number"==typeof this.maxStaleDuration?e.push(`${i}=${this.maxStaleDuration}`):e.push(i)),"number"==typeof this.minFresh&&e.push(`${s}=${this.minFresh}`),this.immutable&&e.push(l),this.mustRevalidate&&e.push(c),this.noCache&&e.push(u),this.noStore&&e.push(d),this.noTransform&&e.push(m),this.onlyIfCached&&e.push(p),this.private&&e.push(h),this.proxyRevalidate&&e.push(g),this.public&&e.push(f),e.join(", ")}};function w(e){return(new b).parse(e)}function D(e){return e instanceof b?e.format():b.prototype.format.call(e)}o(w,"parse"),o(D,"format"),t.exports={CacheControl:b,parse:w,format:D}}));function pG(e,t){let a=t.toLowerCase();return(e.responseHeaders||[]).find((e=>e.name.toLowerCase()===a))}function hG(e){if(!eI.isCacheableAsset(e))return!1;let t=pG(e,"cache-control");if(t){try{let e=(0,gG.parse)(t.value);if(e.noStore||e.noCache||0===e.maxAge)return!1}catch{}return!0}return!!pG(e,"expires")||!!pG(e,"last-modified")}var gG,fG=s((()=>{J(),tI(),gG=d(mG(),1),o(pG,"getHeader"),o(hG,"isCacheable")}));function yG(e){let t;try{t="string"==typeof e?new URL(e):e}catch{t=new URL("http://_")}return t}function vG(e){return e=yG(e),/(^|\.)(doubleclick.net|google(syndication|tagservices).com)$/.test(e.hostname)}function bG(e){let t="pagead2.googlesyndication.com"===(e=yG(e)).host,a=["/pagead/js/adsbygoogle.js","/pagead/show_ads.js"].includes(e.pathname);return t&&a}function wG(e){let t="pagead2.googlesyndication.com"===(e=yG(e)).host,a=/(^\/pagead\/js\/.*\/show_ads_impl.*?\.js)/.test(e.pathname);return t&&a}function DG(e){return bG(e=yG(e))||wG(e)}function EG(e){if(!e)return!1;let t=new URL(e.url);return"/pagead/ads"===t.pathname&&"googleads.g.doubleclick.net"===t.host}function TG(e){return/(^aswift_\d+)/.test(e.id)}function SG(e){let{host:t,pathname:a}=yG(e);return["securepubads.g.doubleclick.net","googleads4.g.doubleclick.net"].includes(t)&&["/pcs/view","/pagead/adview"].includes(a)}function CG(e){let{host:t,pathname:a}=yG(e),n=["www.googletagservices.com","pagead2.googlesyndication.com","securepubads.g.doubleclick.net"].includes(t),r=["/tag/js/gpt.js","/tag/js/gpt_mobile.js"].includes(a);return n&&r}function kG(e){let{host:t,pathname:a}=yG(e),n=["cdn.ampproject.org"].includes(t),r=["/v0/amp-ad-0.1.js"].includes(a);return n&&r}function xG(e){return vG(e)&&/(^\/gpt\/pubads_impl([a-z_]*)((?<!rendering)_)\d+\.js)/.test(yG(e).pathname)}function AG(e){return/^\/[a-z_]*\/\d+\/v0\/amp-ad-network-doubleclick-impl-0.1.js/.test(yG(e).pathname)}function _G(e){return CG(e=yG(e))||xG(e)}function RG(e){return kG(e)||AG(e)}function FG(e){return!!e&&("/gampad/ads"===new URL(e.url).pathname&&"XHR"===e.resourceType&&vG(e.url))}function NG(e){if(!e)return!1;let t=new URL(e.url);return"/gampad/ads"===t.pathname&&"securepubads.g.doubleclick.net"===t.host&&"Fetch"===e.resourceType}function IG(e){return/(^google_ads_iframe_)/.test(e.id)}function MG(e){return bG(e)||CG(e)||kG(e)}function PG(e){return DG(e)||_G(e)||RG(e)}function LG(e){return EG(e)||FG(e)||NG(e)}function OG(e){return TG(e)||IG(e)}function jG(e){return bG(e)||xG(e)||AG(e)}function UG(e,t){return t.some((t=>e.includes(t)))}function BG(e){for(let t of cG)for(let a of t.patterns)if(new RegExp(a).test(e))return t.label}function qG(e){return!!BG("string"==typeof e?e:e.url)}function zG(e){return(null==e.resourceSize||e.resourceSize>0)&&"Image"!=e.resourceType&&!hG(e)}function VG(e){return qG(e)&&zG(e)}function WG(e){return["parser","preload","other"].includes(e.initiator.type)}function HG(e){let t=new URL(e),a=t.pathname.length>60?t.pathname.substr(0,60)+"...":t.pathname;return t.origin+a}function GG(e){let t=BG(e);if(t)return t;if(_G(e))return"GPT";if(DG(e))return"AdSense";if(kG(e))return"AMP tag";let a=Iu.getEntity(e);if(a)return a.name;let{host:n}=new URL(e),[r=""]=n.match(/([^.]*(\.[a-z]{2,3}){1,2})$/)||[];return r||n}function $G(e){let t="string"==typeof e?e:e.url;if(!t)return!1;if(PG(t)||BG(t))return!0;let a=Iu.getEntity(t);return!!a&&a.categories.includes("ad")}var KG=s((()=>{J(),dG(),ju(),fG(),o(yG,"toURL"),o(vG,"isGoogleAds"),o(bG,"isAdSenseTag"),o(wG,"isAdSenseImplTag"),o(DG,"isAdSense"),o(EG,"isAdSenseAdRequest"),o(TG,"isAdSenseIframe"),o(SG,"isImpressionPing"),o(CG,"isGptTag"),o(kG,"isAMPTag"),o(xG,"isGptImplTag"),o(AG,"isAMPImplTag"),o(_G,"isGpt"),o(RG,"isAMP"),o(FG,"isGptAdRequest"),o(NG,"isAMPAdRequest"),o(IG,"isGptIframe"),o(MG,"isAdTag"),o(PG,"isAdScript"),o(LG,"isAdRequest"),o(OG,"isAdIframe"),o(jG,"isImplTag"),o(UG,"containsAnySubstring"),o(BG,"getHeaderBidder"),o(qG,"isBidRelatedRequest"),o(zG,"isPossibleBidRequest"),o(VG,"isBidRequest"),o(WG,"isStaticRequest"),o(HG,"trimUrl"),o(GG,"getNameOrTld"),o($G,"isAdRelated")}));function YG(e){return e.args.frame||e.args.data&&e.args.data.frame||null}function JG(e){let t=new Set;for(let{args:a}of e.childEvents)a.data&&a.data.url&&t.add(a.data.url);return Array.from(t)}function ZG(e){return!!JG(e).find((e=>qG(e)||vG(yG(e))))}function XG(e){return e.event.dur>5e4}function QG(e,t){e===t||e.endTime>t.startTime||e.addDependent(t)}function e$(e){let t=[],a=[];e.traverse((e=>{e.type===fl.TYPES.NETWORK&&(CG(e.record.url)&&"Script"===e.record.resourceType?a.push(e):FG(e.record)&&t.push(e))})),e.traverse((e=>{if(e.type===fl.TYPES.NETWORK){if(xG(e.record.url)){let t=e;for(let e of a)QG(e,t)}if(qG(e.record)){let a=e;for(let e of t)QG(a,e)}if(SG(e.record.url)){let a=e;for(let e of t){QG(e,a);for(let t of e.getDependents())QG(t,a)}}}}))}var t$,a$,n$=s((()=>{J(),Cl(),Vc(),LR(),zc(),KG(),o(YG,"getFrame"),o(JG,"getCpuNodeUrls"),o(ZG,"isAdTask"),o(XG,"isLongTask"),o(QG,"addEdge"),o(e$,"addEdges"),t$=class e extends ER{static{o(this,"AdLanternMetric")}static get COEFFICIENTS(){return{intercept:0,optimistic:1,pessimistic:0}}static getPessimisticGraph(e){let t=e.cloneWithRelationships((e=>!0));return e$(t),t}static getOptimisticGraph(t){let a=t.record.frameId,n=e.getPessimisticGraph(t),r=n.cloneWithRelationships((e=>{if(e.type===fl.TYPES.CPU)return XG(e)||ZG(e)||!!YG(e.event)&&YG(e.event)!==a;if(e.hasRenderBlockingPriority())return!0;let t=e.record.url;return qG(t)||vG(yG(t))}));return e$(n),r}static getEstimateFromSimulation(e,t){throw new Error("getEstimateFromSimulation not implemented by "+this.name)}static findTiming(e,t){let a={startTime:1/0,endTime:-1/0,duration:0};for(let[n,r]of e.entries())t(n,r)&&a.startTime>r.startTime&&(a=r);return a}static findNetworkTiming(e,t){return this.findTiming(e,(e=>e.type===fl.TYPES.NETWORK&&t(e.record)))}},a$=t$}));function r$(e){let t=e.find((e=>jG(new URL(e.url))));return t?t.endTime:-1}function i$(e){let t=e.find(LG);return t?t.startTime:-1}function o$(e){let t=e.find(VG);return t?t.startTime:-1}function s$(e){let t=e.find((e=>SG(e.url)));return t?t.startTime:-1}function l$(e,t=-1){let a=e.find((e=>200==e.statusCode));return a?a.startTime:t}async function c$(e,t,a){let n=new Map,r=await Pc.request(t,a);if("simulate"==a.settings.throttlingMethod){let r=await Fc.request({trace:e,devtoolsLog:t},a),i=a$.getOptimisticGraph(r),o=await Uc.request({devtoolsLog:t,settings:a.settings},a),{nodeTimings:s}=o.simulate(i,{});for(let[{record:e},t]of s.entries())e&&n.set(e,t)}else{let e=l$(r);for(let t of r)n.set(t,{startTime:1e3*(t.startTime-e),endTime:1e3*(t.endTime-e),duration:1e3*(t.endTime-t.startTime)})}return n}function u$(e){if(e.args.data&&["EvaluateScript","FunctionCall"].includes(e.name)){if(e.args.data.url)return e.args.data.url;if(e.args.data.stackTrace)return e.args.data.stackTrace[0].url}}async function d$(e,t,a){let n=1e3*l$(await Pc.request(t,a)),r=new Map;for(let t of e.traceEvents){let e=u$(t);if(!e)continue;let a=t.ts/1e3-n;(!r.has(e)||r.get(e)>a)&&r.set(e,a)}if("simulate"!==a.settings.throttlingMethod)return r;let i=await c$(e,t,a),o=new Map;for(let[e,t]of i.entries()){let i=r.get(e.url);if(!i||o.has(e.url))continue;let s=1e3*e.startTime-n,l=t.endTime,c=a.settings.throttling.cpuSlowdownMultiplier*(i-s);o.set(e.url,l+c)}return o}var m$,p$,h$,g$=s((()=>{J(),n$(),Zc(),Yc(),$c(),KG(),o(r$,"getTagEndTime"),o(i$,"getAdStartTime"),o(o$,"getBidStartTime"),o(s$,"getImpressionStartTime"),o(l$,"getPageStartTime"),o(c$,"getTimingsByRecord"),o(u$,"getScriptUrl"),o(d$,"getScriptEvaluationTimes")})),f$=s((()=>{J(),n$(),IF(),Bc(),g$(),KG(),m$=dc(m$=class extends a${static{o(this,"LanternAdRequestTime")}static getEstimateFromSimulation(e,t){let{nodeTimings:a}=e;return{timeInMs:a$.findNetworkTiming(a,LG).startTime,nodeTimings:a}}}),p$=dc(p$=class extends xF{static{o(this,"AdRequestTime")}static async computeSimulatedMetric(e,t){return m$.request(e,t)}static async computeObservedMetric(e){let{networkRecords:t}=e,a=l$(t),n=1e3*(i$(t)-a);return Promise.resolve({timing:n})}static async request(e,t){throw Error("Not implemented -- class not decorated")}}),h$=p$}));function y$(e,t=new Set){let a=e.attributableURLs.find((e=>t.has(e))),n=e.attributableURLs[0],r=a||n;if(r)return r;let i=50,o="";for(let a of e.children){let e=y$(a,t);e&&a.duration>i&&(o=e,i=a.duration)}return o}var v$=s((()=>{J(),o(y$,"getAttributableUrl")}));function b$(e,t){if(e.duration<w$)return!1;let a=y$(e,t);if(!a)return!1;if(e.parent){return a!=y$(e.parent,t)}return!0}var w$,D$,E$,T$=s((()=>{J(),n$(),Cl(),IF(),Vc(),v$(),Zc(),uR(),Bc(),zc(),Yc(),$c(),w$=50,100,o(b$,"isLong"),D$=dc(D$=class extends xF{static{o(this,"LongTasks")}static async getSimulationGraph(e,t,a){let n=await Fc.request({trace:e,devtoolsLog:t},a);return a$.getOptimisticGraph(n)}static async computeSimulatedResult(e,t,a){let n=await this.getSimulationGraph(e,t,a),r=await Uc.request({devtoolsLog:t,settings:a.settings},a),{nodeTimings:i}=r.simulate(n,{}),o=[];for(let[e,t]of i.entries())e.type!==fl.TYPES.CPU||t.duration<100||o.push({event:e.event,startTime:t.startTime,endTime:t.endTime,duration:t.duration,selfTime:t.duration,attributableURLs:Array.from(e.getEvaluateScriptURLs()),children:[],parent:e.parent,unbounded:e.unbounded,group:e.group});return o}static async computeObservedResult(e,t,a){let n=await oR.request(e,a),r=await Pc.request(t,a),i=new Set(r.filter((e=>"Script"===e.resourceType)).map((e=>e.url)));return n.filter((e=>b$(e,i)))}static async compute_({trace:e,devtoolsLog:t},a){return"simulate"==a.settings.throttlingMethod?this.computeSimulatedResult(e,t,a):this.computeObservedResult(e,t,a)}static async request(e,t){throw Error("Not implemented -- class not decorated")}}),E$=D$})),S$={};c(S$,{UIStrings:()=>C$,default:()=>_$});var C$,k$,x$,A$,_$,R$=s((()=>{J(),f$(),ro(),T$(),nG(),xQ(),v$(),KG(),k$=eo("node_modules/lighthouse-plugin-publisher-ads/audits/ad-blocking-tasks.js",C$={title:"No long tasks blocking ad-related network requests",failureTitle:"Avoid long tasks that block ad-related network requests",description:"Tasks blocking the main thread can delay ad requests and cause a poor user experience. Consider removing long blocking tasks or moving them off of the main thread. These tasks can be especially detrimental to performance on less powerful devices. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-blocking-tasks).",failureDisplayValue:"{timeInMs, number, seconds} s blocked",columnScript:"Attributable URL",columnStartTime:"Start",columnDuration:"Duration"}),x$=[{key:"script",itemType:"url",text:k$(C$.columnScript)},{key:"startTime",itemType:"ms",text:k$(C$.columnStartTime),granularity:1},{key:"duration",itemType:"ms",text:k$(C$.columnDuration),granularity:1}],A$=class e extends Dr{static{o(this,"AdBlockingTasks")}static get meta(){return{id:"ad-blocking-tasks",title:k$(C$.title),failureTitle:k$(C$.failureTitle),description:k$(C$.description),requiredArtifacts:["traces","devtoolsLogs"]}}static async audit(t,a){let n="simulate"==a.settings.throttlingMethod?200:100,r={trace:t.traces[Dr.DEFAULT_PASS],devtoolsLog:t.devtoolsLogs[Dr.DEFAULT_PASS],settings:a.settings},i=[];try{i=await E$.request(r,a)}catch{return XH.InvalidTiming}if(!i.length)return XH.NoTasks;let{timing:o}=await h$.request(r,a);if(!(o>0))return XH.NoAdRelatedReq;let s=[];for(let e of i){if(e.startTime>o||e.duration<n)continue;let t=y$(e);if(t&&PG(new URL(t)))continue;let a=t&&new URL(t),r=a&&a.origin+a.pathname||"Other";s.push({script:r,rawUrl:t,startTime:e.startTime,endTime:e.endTime,duration:e.duration,isTopLevel:!e.parent})}let l=Array.from(s);l.length>10&&(l=s.filter((e=>"Other"!==e.script&&e.isTopLevel)).sort(((e,t)=>t.duration-e.duration)).splice(0,10).sort(((e,t)=>e.startTime-t.startTime)));let c=l.reduce(((e,t)=>t.isTopLevel?e+t.duration:e),0),u=l.length>0;return{score:u?0:1,numericValue:c,numericUnit:"millisecond",displayValue:u?k$(C$.failureDisplayValue,{timeInMs:c}):"",details:e.makeTableDetails(x$,l)}}},_$=A$})),F$={};c(F$,{UIStrings:()=>N$,default:()=>L$});var N$,I$,M$,P$,L$,O$=s((()=>{J(),ro(),Yc(),nG(),xQ(),g$(),KG(),I$=eo("node_modules/lighthouse-plugin-publisher-ads/audits/ad-render-blocking-resources.js",N$={title:"Minimal render-blocking resources found",failureTitle:"Avoid render-blocking resources",description:"Render-blocking resources slow down tag load times. Consider loading critical JS/CSS inline or loading scripts asynchronously or loading the tag earlier in the head. [Learn more](https://developers.google.com/web/tools/lighthouse/audits/blocking-resources).",failureDisplayValue:"Up to {timeInMs, number, seconds} s tag load time improvement",columnUrl:"Resource",columnStartTime:"Start",columnDuration:"Duration"}),100,M$=[{key:"url",itemType:"url",text:I$(N$.columnUrl)},{key:"startTime",itemType:"ms",text:I$(N$.columnStartTime),granularity:1},{key:"duration",itemType:"ms",text:I$(N$.columnDuration),granularity:1}],P$=class e extends Dr{static{o(this,"AdRenderBlockingResources")}static get meta(){return{id:"ad-render-blocking-resources",title:I$(N$.title),failureTitle:I$(N$.failureTitle),scoreDisplayMode:"binary",description:I$(N$.description),requiredArtifacts:["LinkElements","ScriptElements","devtoolsLogs","traces"]}}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=t.traces[Dr.DEFAULT_PASS],i=await Pc.request(n,a),o=i.find((e=>MG(new URL(e.url))));if(!o)return XH.NoTag;let s=await c$(r,n,a),l=new Set;for(let e of t.LinkElements)e.href&&"stylesheet"==e.rel&&l.add(e.href);for(let e of t.ScriptElements)e.src&&!e.defer&&!e.async&&l.add(e.src);let c=i.filter((e=>e.endTime<o.startTime)).filter((e=>e!=o.initiatorRequest)).filter((e=>e.initiator.type="parser")).filter((e=>l.has(e.url))).map((e=>Object.assign({url:e.url},s.get(e))));c.sort(((e,t)=>e.endTime-t.endTime));let u=s.get(o)||{startTime:1/0},d=c.map((e=>e.startTime)),m=c.map((e=>e.endTime)),p=Math.min(...d),h=Math.min(Math.max(...m),u.startTime)-p,g="";return c.length>0&&h>0&&(g=I$(N$.failureDisplayValue,{timeInMs:h})),{score:c.length>0&&h>100?0:1,numericValue:c.length,numericUnit:"unitless",displayValue:g,details:{opportunity:h,...e.makeTableDetails(M$,c)}}}},L$=P$}));function j$(e){if(null==e)throw new Error("Expected not to be null");return e}var U$=s((()=>{J(),o(j$,"assert")}));function B$(e,t,a){let n=t.xhrEdges.get(e.url);if(!n)return!1;for(let{url:e}of a)if(n.has(e))return!0;return!1}function q$(e,t,a,n){let r=a.allRecords.filter((e=>null!=e.resourceType)).filter((e=>["Script","XHR"].includes(e.resourceType||"")&&e.endTime<t.startTime)).filter((t=>t.initiatorRequest==e||Fc.getNetworkInitiators(t).includes(e.url)));for(let e of r)"XHR"==e.resourceType&&B$(e,a,n)&&V$(a,e,n)}function z$(e,t,a){let n=W$(e,t),r=new Set;return V$(n,a,r),r}function V$(e,t,a=new Set){if(!t||a.has(t))return a;a.add(t);let n=new Set;for(let r=t.initiator.stack;r;r=r.parent)for(let{url:i}of r.callFrames){if(n.has(i))continue;n.add(i);let o=e.requestsByUrl.get(i);if(o&&(V$(e,o,a),"Script"==o.resourceType)){let n=r.callFrames[0].url,i=e.requestsByUrl.get(n);i&&q$(i,t,e,a)}}return V$(e,t.initiatorRequest||null,a),a}function W$(e,t){let a=new Map;for(let t of e)a.set(t.url,t);let n=t.filter((e=>e.name.startsWith("XHR"))).filter((e=>!!(e.args.data||{}).url)),r=new Map;for(let e of n){let t=e.args.data||{},a=r.get(t.url)||new Set;for(let{url:e}of t.stackTrace||[])a.add(e);r.set(t.url,a)}return{requestsByUrl:a,xhrEdges:r,allRecords:e}}function H$(e,t){return!(Math.max(e.startTime,t.startTime)>Math.min(e.endTime,t.endTime)||e.type&&t.type&&e.type!=t.type||"Script"==e.type)&&e.nameOrTld==t.nameOrTld}function G$(e){e.sort(((e,t)=>e.nameOrTld!=t.nameOrTld?e.nameOrTld<t.nameOrTld?-1:1:e.type!=t.type?e.type<t.type?-1:1:e.startTime!=t.startTime?e.startTime<t.startTime?-1:1:e.endTime-t.endTime));let t=[];for(let a=0;a<e.length;a++){let n,r=e[a];for(;a<e.length&&(n=e[a+1],n&&H$(n,r));)r.endTime=Math.max(r.endTime,n.endTime),r.duration=r.endTime-r.startTime,a++;t.push(r)}return t.sort(((e,t)=>e.startTime-t.startTime)),t}function $$(e){if(!e.length)return[];let t=j$(e[0]);t.selfTime=t.duration;let a=t.startTime;for(let n of e){if(n.endTime<a||n==t)continue;let e=Math.max(a,n.startTime),r=Math.min(t.endTime,n.endTime);e<r&&(t.selfTime-=r-e),a=Math.max(a,r),n.endTime>t.endTime&&(n.selfTime=n.endTime-e,t=n)}}async function K$(e,t,a){let n=await Pc.request(t,a),r=n.find(LG)||n.find(VG)||n.find($G);if(null==r)return Promise.resolve([]);let i=new Set,o=j$(r),s=n.filter((e=>_G(e.url)||DG(e.url))),l=n.filter((e=>VG(e)&&e.endTime<=o.startTime)),c=W$(n,e.traceEvents);for(let e of[o,...l,...s])V$(c,e,i);let u=new Set(["Script","XHR","Fetch","EventStream","Document",void 0]),d=Array.from(i).filter((e=>e.endTime<o.startTime)).filter((e=>u.has(e.resourceType))).filter((e=>"text/css"!=e.mimeType)),m=await c$(e,t,a),p=G$(d.map((e=>{let{startTime:t,endTime:a}=m.get(e)||e;return{startTime:t,endTime:a,duration:a-t,selfTime:0,url:HG(e.url),nameOrTld:GG(e.url),type:e.resourceType,record:e}})));return $$(p),p}var Y$=s((()=>{J(),Cl(),Vc(),zc(),Yc(),U$(),KG(),$c(),g$(),KG(),o(B$,"isXhrCritical"),o(q$,"addInitiatedRequests"),o(z$,"getCriticalGraph"),o(V$,"linkGraph"),o(W$,"buildNetworkSummary"),o(H$,"areSimilarRequests"),o(G$,"computeSummaries"),o($$,"computeSelfTimes"),o(K$,"computeAdRequestWaterfall")})),J$={};function Z$(e){let t=0,a=0;for(let{startTime:n,endTime:r}of e)n>=t?(++a,t=r):t=Math.min(t,r);return a}function X$(e){let t=1/0,a=[];for(let n=0;n<e.length;){let{startTime:r,endTime:i}=e[n];for(r-t>aK&&a.push(r-t),t=i;++n<e.length&&e[n].startTime<t;)t=Math.max(t,e[n].endTime)}return a}c(J$,{UIStrings:()=>Q$,default:()=>rK});var Q$,eK,tK,aK,nK,rK,iK,oK,sK,lK=s((()=>{J(),ro(),nG(),xQ(),Y$(),eK=eo("node_modules/lighthouse-plugin-publisher-ads/audits/ad-request-critical-path.js",Q$={title:"Ad request waterfall",failureTitle:"Reduce critical path for ad loading",description:"Consider reducing the number of resources, loading multiple resources simultaneously, or loading resources earlier to improve ad speed. Requests that block ad loading can be found below. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-request-critical-path).",displayValue:"{serialResources, plural, =1 {1 serial resource} other {# serial resources}}",columnUrl:"Request",columnType:"Type",columnStartTime:"Start",columnEndTime:"End"}),tK=[{key:"nameOrTld",itemType:"text",text:eK(Q$.columnType)},{key:"url",itemType:"url",text:eK(Q$.columnUrl)},{key:"startTime",itemType:"ms",text:eK(Q$.columnStartTime),granularity:1},{key:"endTime",itemType:"ms",text:eK(Q$.columnEndTime),granularity:1}],o(Z$,"computeDepth"),aK=150,o(X$,"computeIdleTimes"),nK=class e extends Dr{static{o(this,"AdRequestCriticalPath")}static get meta(){return{id:"ad-request-critical-path",title:eK(Q$.title),failureTitle:eK(Q$.failureTitle),description:eK(Q$.description),scoreDisplayMode:"informative",requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,a){let n=t.traces[Dr.DEFAULT_PASS],r=t.devtoolsLogs[Dr.DEFAULT_PASS],i=(await K$(n,r,a)).filter((e=>e.startTime>0&&e.startTime<e.endTime));if(!i.length)return XH.NoAds;let o=Z$(i),s=o>3;for(let e of i)delete e.record;let l=X$(i),c=Math.max(...l),u=l.reduce(((e,t)=>e+t),0);return{numericValue:o,numericUnit:"unitless",score:s?0:1,displayValue:eK(Q$.displayValue,{serialResources:o}),details:{size:i.length,depth:o,maxIdleTime:c,totalIdleTime:u,...e.makeTableDetails(tK,i)}}}},rK=nK})),cK=s((()=>{J(),n$(),IF(),Bc(),g$(),KG(),iK=dc(iK=class extends a${static{o(this,"LanternBidRequestTime")}static getEstimateFromSimulation(e,t){let{nodeTimings:a}=e,n=a$.findNetworkTiming(a,VG).startTime;return n>a$.findNetworkTiming(a,LG).startTime?{timeInMs:-1,nodeTimings:a}:{timeInMs:n,nodeTimings:a}}}),oK=dc(oK=class extends xF{static{o(this,"BidRequestTime")}static async computeSimulatedMetric(e,t){return iK.request(e,t)}static async computeObservedMetric(e){let{networkRecords:t}=e,a=l$(t),n=o$(t);return i$(t)<n?{timing:-1}:{timing:1e3*(n-a)}}static async request(e,t){throw Error("Not implemented -- class not decorated")}}),sK=oK})),uK={};c(uK,{UIStrings:()=>dK,default:()=>hK});var dK,mK,pK,hK,gK=s((()=>{J(),cK(),ro(),nG(),xQ(),mK=eo("node_modules/lighthouse-plugin-publisher-ads/audits/bid-request-from-page-start.js",dK={title:"First bid request time",failureTitle:"Reduce time to send the first bid request",description:"This metric measures the elapsed time from the start of page load until the first bid request is made. Delayed bid requests will decrease impressions and viewability, and have a negative impact on ad revenue. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/bid-request-from-page-start).",displayValue:"{timeInMs, number, seconds} s"}),pK=class extends Dr{static{o(this,"BidRequestFromPageStart")}static get meta(){return{id:"bid-request-from-page-start",title:mK(dK.title),failureTitle:mK(dK.failureTitle),description:mK(dK.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:4350,median:8e3},provided:{p10:1200,median:2e3}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],settings:t.settings},n=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"],{timing:r}=await sK.request(a,t);return r>0?{numericValue:r,numericUnit:"millisecond",score:Dr.computeLogNormalScore(n,r),displayValue:mK(dK.displayValue,{timeInMs:r})}:XH.NoBids}},hK=pK})),fK={};c(fK,{UIStrings:()=>yK,default:()=>wK});var yK,vK,bK,wK,DK=s((()=>{J(),f$(),ro(),nG(),xQ(),vK=eo("node_modules/lighthouse-plugin-publisher-ads/audits/ad-request-from-page-start.js",yK={title:"First ad request time",failureTitle:"Reduce time to send the first ad request",description:"This metric measures the elapsed time from the start of page load until the first ad request is made. Delayed ad requests will decrease impressions and viewability, and have a negative impact on ad revenue. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-request-from-page-start).",displayValue:"{timeInMs, number, seconds} s"}),bK=class extends Dr{static{o(this,"AdRequestFromPageStart")}static get meta(){return{id:"ad-request-from-page-start",title:vK(yK.title),failureTitle:vK(yK.failureTitle),description:vK(yK.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:6500,median:1e4},provided:{p10:1900,median:3500}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],settings:t.settings},n=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"],{timing:r}=await h$.request(a,t);if(!(r>0)){let e=XH.NoAds;return e.runWarnings=[QH.NoAds],e}return{numericValue:r,numericUnit:"millisecond",score:Dr.computeLogNormalScore(n,r),displayValue:vK(yK.displayValue,{timeInMs:r})}}},wK=bK})),EK={};c(EK,{UIStrings:()=>TK,default:()=>xK});var TK,SK,CK,kK,xK,AK=s((()=>{J(),ro(),nG(),xQ(),KG(),SK=eo("node_modules/lighthouse-plugin-publisher-ads/audits/ad-top-of-viewport.js",TK={title:"No ad found at the very top of the viewport",failureTitle:"Move the top ad further down the page",description:"Over 10% of ads are never viewed because users scroll past them before they become viewable. By moving ad slots away from the very top of the viewport, users are more likely to see ads before scrolling away. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-top-of-viewport).",failureDisplayValue:"A scroll of {valueInPx, number} px would hide half of your topmost ad",columnSlot:"Top Slot ID"}),100,CK=[{key:"slot",itemType:"text",text:SK(TK.columnSlot)}],kK=class e extends Dr{static{o(this,"AdTopOfViewport")}static get meta(){return{id:"ad-top-of-viewport",title:SK(TK.title),failureTitle:SK(TK.failureTitle),description:SK(TK.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(t){let a=t.ViewportDimensions,n=t.IFrameElements.filter(OG).filter((e=>e.clientRect.width*e.clientRect.height>1&&!e.isPositionFixed)).map((e=>({midpoint:e.clientRect.top+e.clientRect.height/2,id:e.id})));if(!n.length)return XH.NoVisibleSlots;let r=n.reduce(((e,t)=>e.midpoint<t.midpoint?e:t)),i=r.midpoint<a.innerHeight;if(!i)return XH.NoAdsViewport;let o=i&&r.midpoint<100?0:1;return{score:o,numericValue:r.midpoint,numericUnit:"unitless",displayValue:o?"":SK(TK.failureDisplayValue,{valueInPx:r.midpoint}),details:e.makeTableDetails(CK,o?[]:[{slot:r.id}])}}},xK=kK}));function _K(e,t){let{innerWidth:a,innerHeight:n}=t,{left:r,top:i,right:o,bottom:s}=e;return r<o&&i<s&&r<a&&i<n&&0<o&&0<s}function RK([e,t,a,n]){return{left:e,top:t,width:a,height:n,right:e+a,bottom:t+n}}function FK(e,t){let a=!(e.right<t.left||t.right<e.left),n=!(e.bottom<t.top||t.bottom<e.top);return a&&n}var NK=s((()=>{J(),o(_K,"isBoxInViewport"),o(RK,"toClientRect"),o(FK,"overlaps")})),IK={};c(IK,{UIStrings:()=>MK,default:()=>jK});var MK,PK,LK,OK,jK,UK=s((()=>{J(),nG(),xQ(),ro(),NK(),KG(),PK=eo("node_modules/lighthouse-plugin-publisher-ads/audits/ads-in-viewport.js",MK={title:"Few or no ads loaded outside viewport",failureTitle:"Avoid loading ads until they are nearly on-screen",description:"Too many ads loaded outside the viewport lowers viewability rates and impacts user experience. Consider loading ads below the fold lazily as the user scrolls down. Consider using GPT's [Lazy Loading API](https://developers.google.com/doubleclick-gpt/reference#googletag.PubAdsService_enableLazyLoad). [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ads-in-viewport).",failureDisplayValue:"{hiddenAds, plural, =1 {1 ad} other {# ads}} out of view",columnSlot:"Slots Outside Viewport"}),LK=[{key:"slot",itemType:"text",text:PK(MK.columnSlot)}],OK=class e extends Dr{static{o(this,"AdsInViewport")}static get meta(){return{id:"ads-in-viewport",title:PK(MK.title),failureTitle:PK(MK.failureTitle),description:PK(MK.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(t){let a=t.ViewportDimensions,n=t.IFrameElements.filter((e=>IG(e)&&e.clientRect.height*e.clientRect.width>1));if(!n.length)return XH.NoVisibleSlots;let r=n.filter((e=>!_K(e.clientRect,a))).map((e=>({slot:e.id}))).sort(((e,t)=>e.slot.localeCompare(t.slot)));return{numericValue:(n.length-r.length)/n.length,numericUnit:"unitless",score:r.length>3?0:1,displayValue:r.length?PK(MK.failureDisplayValue,{hiddenAds:r.length}):"",details:e.makeTableDetails(LK,r)}}},jK=OK}));function BK(e,t){let a=0;for(let n of e)t(n)&&a++;return a}function qK(e,t){let a=new Map;for(let n of e){let e=t(n);if(null!=e){let t=a.get(e)||[];t.push(n),a.set(e,t)}}return a}var zK=s((()=>{J(),o(BK,"count"),o(qK,"bucket")})),VK={};function WK(e){return"Low"==e.priority||WG(e)}c(VK,{UIStrings:()=>HK,default:()=>KK});var HK,GK,$K,KK,YK=s((()=>{J(),zK(),ro(),fb(),Yc(),nG(),xQ(),KG(),GK=eo("node_modules/lighthouse-plugin-publisher-ads/audits/async-ad-tags.js",HK={title:"Ad tag is loaded asynchronously",failureTitle:"Load ad tag asynchronously",description:"Loading the ad tag synchronously blocks content rendering until the tag is fetched and loaded. Consider using the `async` attribute to load gpt.js and/or adsbygoogle.js asynchronously. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/async-ad-tags)."}),o(WK,"isAsync"),$K=class extends Dr{static{o(this,"AsyncAdTags")}static get meta(){return{id:"async-ad-tags",title:GK(HK.title),failureTitle:GK(HK.failureTitle),description:GK(HK.description),requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=await Pc.request(a,t),r=await pb.request({URL:e.URL,devtoolsLog:a},t),i=n.filter((e=>MG(new URL(e.url)))).filter((e=>e.frameId===r.frameId));if(!i.length)return XH.NoTag;let o=BK(i,WK)-i.length;return{score:Number(0===o),numericValue:o,numericUnit:"unitless"}}},KK=$K})),JK={};function ZK(e){let{record:t}=e,a=t&&t.initiator&&t.initiator.stack;if(a){for(;a.parent;)a=a.parent;return a.callFrames[a.callFrames.length-1]}}function XK(e,t){return t.find((t=>"FunctionCall"==t.name&&t.args.data&&t.args.data.functionName==e.functionName&&t.args.data.scriptId==e.scriptId&&t.args.data.url==e.url&&Math.abs(t.args.data.lineNumber==e.lineNumber)<2&&Math.abs(t.args.data.columnNumber==e.columnNumber)<2))}function QK(e,t){let a={},n=[];for(let r of t)r.name==`${e}EventStart`?a={start:r.ts,end:1/0,eventName:e}:r.name==`${e}EventEnd`&&(a.end=r.ts,n.push(a));return n}function eY(e,t,a){let n=t.find((t=>t.url==e.url)),r=t.find((t=>t.url==e.blockedUrl));if(!n||!r)return 0;let i=a.get(n),o=a.get(r);return i&&o?o.startTime-i.endTime:0}c(JK,{UIStrings:()=>tY,default:()=>iY});var tY,aY,nY,rY,iY,oY=s((()=>{J(),ro(),Yc(),Hc(),yD(),nG(),xQ(),Y$(),g$(),aY=eo("node_modules/lighthouse-plugin-publisher-ads/audits/blocking-load-events.js",tY={title:"Ads not blocked by load events",failureTitle:"Avoid waiting on load events",description:"Waiting on load events increases ad latency. To speed up ads, eliminate the following load event handlers. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/blocking-load-events).",displayValue:"{timeInMs, number, seconds} s blocked",columnEvent:"Event Name",columnTime:"Event Time",columnScript:"Script",columnBlockedUrl:"Blocked URL",columnFunctionName:"Function"}),nY=[{key:"eventName",itemType:"text",text:aY(tY.columnEvent)},{key:"time",itemType:"ms",text:aY(tY.columnTime),granularity:1},{key:"url",itemType:"url",text:aY(tY.columnScript)},{key:"functionName",itemType:"text",text:aY(tY.columnFunctionName)}],o(ZK,"findOriginalCallFrame"),o(XK,"findTraceEventOfCallFrame"),o(QK,"findEventIntervals"),o(eY,"quantifyBlockedTime"),rY=class e extends Dr{static{o(this,"BlockingLoadEvents")}static get meta(){return{id:"blocking-load-events",title:aY(tY.title),failureTitle:aY(tY.failureTitle),description:aY(tY.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,a){let n=t.traces[Dr.DEFAULT_PASS],r=t.devtoolsLogs[Dr.DEFAULT_PASS],i=await Pc.request(r,a),o=await kc.request(n,a),{timings:s}=await lD.request(o,a),{processEvents:l}=o,c=await c$(n,r,a),u=(await K$(n,r,a)).sort(((e,t)=>e.startTime-t.startTime));if(!u.length)return XH.NoAdRelatedReq;let d=[...QK("domContentLoaded",l),...QK("load",l)],m=[],p=new Set;for(let e of u){let t=ZK(e);if(!t)continue;let a=JSON.stringify(t);if(p.has(a))continue;p.add(a);let n=XK(t,l);if(!n)continue;let r=d.find((e=>e.start<=n.ts&&n.ts<=e.end));if(r){let a=Object.assign({eventName:r.eventName,blockedUrl:e.url,time:s[r.eventName],blockedTime:1/0},t);a.blockedTime=eY(a,i,c),m.push(a)}}let h=m.length>0,g=0;return h&&(g=Math.min(...m.map((e=>e.blockedTime)))),{numericValue:m.length,numericUnit:"unitless",score:h?0:1,displayValue:h&&g?aY(tY.displayValue,{timeInMs:g}):"",details:e.makeTableDetails(nY,m)}}},iY=rY})),sY={};c(sY,{UIStrings:()=>lY,default:()=>mY});var lY,cY,uY,dY,mY,pY=s((()=>{J(),ro(),nG(),xQ(),Y$(),KG(),cY=eo("node_modules/lighthouse-plugin-publisher-ads/audits/bottleneck-requests.js",lY={title:"No bottleneck requests found",failureTitle:"Avoid bottleneck requests",description:"Speed up, load earlier, parallelize, or eliminate the following requests and their dependencies in order to speed up ad loading. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/bottleneck-requests).",displayValue:"{blockedTime, number, seconds} s spent blocked on requests",columnUrl:"Blocking Request",columnInitiatorUrl:"Initiator Request",columnStartTime:"Start",columnSelfTime:"Exclusive Time",columnDuration:"Total Time"}),uY=[{key:"url",itemType:"url",text:cY(lY.columnUrl)},{key:"selfTime",itemType:"ms",text:cY(lY.columnSelfTime),granularity:1},{key:"duration",itemType:"ms",text:cY(lY.columnDuration),granularity:1}],dY=class e extends Dr{static{o(this,"BottleneckRequests")}static get meta(){return{id:"bottleneck-requests",title:cY(lY.title),failureTitle:cY(lY.failureTitle),description:cY(lY.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,a){let n=t.traces[Dr.DEFAULT_PASS],r=t.devtoolsLogs[Dr.DEFAULT_PASS],i=(await K$(n,r,a)).filter((e=>e.startTime>0));if(!i.length)return XH.NoAdRelatedReq;let s=o((e=>!PG(yG(e.url))&&(e.selfTime>250||e.duration>1e3)),"isBottleneck"),l=o((e=>3*e.selfTime+e.duration),"cost"),c=i.filter(s).sort(((e,t)=>l(t)-l(e))).slice(0,5),u=c.reduce(((e,t)=>e+t.selfTime),0)/1e3,d=1e3*u>1e3;for(let e of c)delete e.record;return{numericValue:c.length,numericUnit:"unitless",score:d?0:1,displayValue:d?cY(lY.displayValue,{blockedTime:u}):"",details:e.makeTableDetails(uY,c)}}},mY=dY})),hY={};c(hY,{UIStrings:()=>gY,default:()=>wY});var gY,fY,yY,vY,bY,wY,DY,EY,TY,SY=s((()=>{J(),ro(),fb(),Yc(),qc(),nG(),xQ(),KG(),fY=eo("node_modules/lighthouse-plugin-publisher-ads/audits/duplicate-tags.js",gY={title:"No duplicate tags found",failureTitle:"Load tags only once",description:"Loading a tag more than once in the same page is redundant and adds overhead without benefit. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/duplicate-tags).",failureDisplayValue:"{duplicateTags, plural, =1 {1 duplicate tag} other {# duplicate tags}}",columnScript:"Script",columnNumReqs:"Duplicate Requests",columnFrameId:"Frame ID"}),yY=["googletagservices.com/tag/js/gpt.js","securepubads.g.doubleclick.net/tag/js/gpt.js","pagead2.googlesyndication.com/pagead/js/adsbygoogle.js","pagead2.googlesyndication.com/pagead/js/show_ads.js","cdn.ampproject.org/v0/amp-ad-0.1.js"],vY=[{key:"script",itemType:"url",text:fY(gY.columnScript)},{key:"numReqs",itemType:"text",text:fY(gY.columnNumReqs)}],bY=class e extends Dr{static{o(this,"DuplicateTags")}static get meta(){return{id:"duplicate-tags",title:fY(gY.title),failureTitle:fY(gY.failureTitle),description:fY(gY.description),requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=await Pc.request(n,a),i=await pb.request({URL:t.URL,devtoolsLog:n},a),o=r.filter((e=>e.frameId===i.frameId)).filter((e=>UG(e.url,yY))).filter((e=>e.resourceType===wc.TYPES.Script));if(!o.length)return XH.NoTags;let s=new Map;for(let e of o){let t=new URL(e.url).pathname,a=s.get(t)||0;s.set(t,a+1)}let l=[];for(let[e,t]of s)t>1&&l.push({script:e,numReqs:t});return{numericValue:l.length,numericUnit:"unitless",score:l.length?0:1,details:e.makeTableDetails(vY,l),displayValue:l.length?fY(gY.failureDisplayValue,{duplicateTags:l.length}):""}}},wY=bY})),CY=s((()=>{J(),n$(),IF(),Bc(),g$(),KG(),DY=dc(DY=class extends a${static{o(this,"LanternAdRenderTime")}static getEstimateFromSimulation(e,t){let{nodeTimings:a}=e;return{timeInMs:a$.findNetworkTiming(a,(e=>!!e.url&&SG(new URL(e.url)))).startTime,nodeTimings:a}}}),EY=dc(EY=class extends xF{static{o(this,"AdRenderTime")}static async computeSimulatedMetric(e,t){return DY.request(e,t)}static async computeObservedMetric(e,t){let{networkRecords:a}=e,n=l$(a),r=1e3*(s$(a)-n);return Promise.resolve({timing:r})}static async request(e,t){throw Error("Not implemented -- class not decorated")}}),TY=EY})),kY={};c(kY,{UIStrings:()=>xY,default:()=>RY});var xY,AY,_Y,RY,FY=s((()=>{J(),CY(),ro(),nG(),xQ(),AY=eo("node_modules/lighthouse-plugin-publisher-ads/audits/first-ad-render.js",xY={title:"Latency of first ad render",failureTitle:"Reduce time to render first ad",description:"This metric measures the time for the first ad iframe to render from page navigation. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/first-ad-render).",displayValue:"{timeInMs, number, seconds} s"}),_Y=class extends Dr{static{o(this,"FirstAdRender")}static get meta(){return{id:"first-ad-render",title:AY(xY.title),failureTitle:AY(xY.failureTitle),description:AY(xY.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:12900,median:22e3},provided:{p10:2750,median:3700}}}static async audit(e,t){let a=e.traces[Dr.DEFAULT_PASS],n={devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],trace:a,settings:t.settings},{timing:r}=await TY.request(n,t);if(!(r>0)){let e=XH.NoAdRendered;return e.runWarnings=[QH.NoAdRendered],e}let i=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"];return{numericValue:r,numericUnit:"millisecond",score:Dr.computeLogNormalScore(i,r),displayValue:AY(xY.displayValue,{timeInMs:r})}}},RY=_Y})),NY={};c(NY,{UIStrings:()=>IY,default:()=>LY});var IY,MY,PY,LY,OY=s((()=>{J(),ro(),Yc(),nG(),xQ(),KG(),MY=eo("node_modules/lighthouse-plugin-publisher-ads/audits/full-width-slots.js",IY={title:"Ad slots effectively use horizontal space",failureTitle:"Increase the width of ad slots",description:"Ad slots that utilize most of the page width generally experience increased click-through rate over smaller ad sizes. We recommend leaving no more than 25% of the viewport width unutilized on mobile devices.",failureDisplayValue:"{percentUnused, number, percent} of viewport width is underutilized"}),PY=class extends Dr{static{o(this,"FullWidthSlots")}static get meta(){return{id:"full-width-slots",title:MY(IY.title),failureTitle:MY(IY.failureTitle),description:MY(IY.description),requiredArtifacts:["ViewportDimensions","devtoolsLogs"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=await Pc.request(a,t),r=e.ViewportDimensions.innerWidth,i=n.filter(LG).map((e=>new URL(e.url)));if(!i.length)return XH.NoAds;let o=i.map((e=>e.searchParams.get("prev_iu_szs")||e.searchParams.get("sz"))).join("|").split(/[|,]/).map((e=>parseInt(e.split("x")[0]))).filter((e=>e<=r&&e>1));if(!o.length)return XH.NoValidAdWidths;let s=1-Math.max(...o)/r,l=s>.25?0:1;return{score:l,numericValue:s,numericUnit:"unitless",displayValue:l?"":MY(IY.failureDisplayValue,{percentUnused:s})}}},LY=PY})),jY={};c(jY,{UIStrings:()=>UY,default:()=>zY});var UY,BY,qY,zY,VY=s((()=>{J(),Yc(),U$(),nG(),xQ(),Y$(),g$(),KG(),"gpt-bids-parallel",BY=[{key:"bidder",itemType:"text",text:(UY={title:"GPT and bids loaded in parallel",failureTitle:"Load GPT and bids in parallel",description:"To optimize ad loading, bid requests should not wait on GPT to load. This issue can often be fixed by making sure that bid requests do not wait on `googletag.pubadsReady` or `googletag.cmd.push`. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/gpt-bids-parallel).",columnBidder:"Bidder",columnUrl:"URL",columnStartTime:"Start",columnDuration:"Duration"}).columnBidder},{key:"url",itemType:"url",text:UY.columnUrl},{key:"startTime",itemType:"ms",text:UY.columnStartTime},{key:"duration",itemType:"ms",text:UY.columnDuration}],qY=class e extends Dr{static{o(this,"GptBidsInParallel")}static get meta(){return{id:"gpt-bids-parallel",title:UY.title,failureTitle:UY.failureTitle,description:UY.description,requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=t.traces[Dr.DEFAULT_PASS],i=await Pc.request(n,a),o=i.find((e=>xG(e.url)));if(!o)return XH.NoGpt;let s=i.filter(VG).filter((e=>e.frameId==o.frameId));if(!s.length)return XH.NoBids;let l=await c$(r,n,a),c=[],u=new Set;for(let e of s)if(z$(i,r.traceEvents,e).has(o)){let{startTime:t,endTime:a}=l.get(e)||e,n=j$(BG(e.url));if(u.has(n))continue;u.add(n),c.push({bidder:n,url:e.url,startTime:t,duration:a-t})}let d=c.length>0;return{numericValue:c.length,numericUnit:"unitless",score:d?0:1,details:d?e.makeTableDetails(BY,c):void 0}}},zY=qY})),WY={};c(WY,{UIStrings:()=>HY,default:()=>KY});var HY,GY,$Y,KY,YY=s((()=>{J(),ro(),Yc(),nG(),xQ(),KG(),GY=eo("node_modules/lighthouse-plugin-publisher-ads/audits/loads-gpt-from-official-source.js",HY={title:"GPT tag is loaded from an official source",failureTitle:"Load GPT from an official source",description:"Load GPT from 'securepubads.g.doubleclick.net' for standard integrations or from 'pagead2.googlesyndication.com' for limited ads. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/loads-gpt-from-official-source)."}),$Y=class extends Dr{static{o(this,"LoadsGptFromOfficalSource")}static get meta(){return{id:"loads-gpt-from-official-source",title:GY(HY.title),failureTitle:GY(HY.failureTitle),description:GY(HY.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=(await Pc.request(a,t)).map((e=>new URL(e.url))).find(CG);if(!n)return XH.NoGpt;let r=["securepubads.g.doubleclick.net","pagead2.googlesyndication.com"].includes(n.host);return{score:Number(r),numericValue:+!r,numericUnit:"unitless"}}},KY=$Y})),JY={};c(JY,{UIStrings:()=>ZY,default:()=>eJ});var ZY,XY,QY,eJ,tJ=s((()=>{J(),ro(),Yc(),nG(),xQ(),KG(),XY=eo("node_modules/lighthouse-plugin-publisher-ads/audits/loads-ad-tag-over-https.js",ZY={title:"Ad tag is loaded over HTTPS",failureTitle:"Load ad tag over HTTPS",description:'For privacy and security, always load GPT/AdSense over HTTPS. Insecure pages should explicitly request the ad script securely. GPT Example: `<script async src="https://securepubads.g.doubleclick.net/tag/js/gpt.js">` AdSense Example: `<script async src="https://pagead2.googlesyndication.com/pagead/js/adsbygoogle.js">`. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/loads-ad-tag-over-https).'}),QY=class extends Dr{static{o(this,"LoadsAdTagOverHttps")}static get meta(){return{id:"loads-ad-tag-over-https",title:XY(ZY.title),failureTitle:XY(ZY.failureTitle),description:XY(ZY.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=await Pc.request(a,t);if(!n.find((e=>200==e.statusCode)))return XH.NoRecords;let r=n.filter((e=>MG(new URL(e.url)))),i=r.filter((e=>e.isSecure)),o={type:"debugdata",numAdTagHttpReqs:r.length-i.length,numAdTagHttpsReqs:i.length};if(!r.length){let e=XH.NoTag;return e.details=o,e}return{numericValue:o.numAdTagHttpReqs,score:o.numAdTagHttpReqs?0:1,details:o}}},eJ=QY})),aJ={};function nJ(e){if("script"!==e.initiator.type)return!1;let t=Fc.getNetworkInitiators(e);return!(1!==t.length||t[0]!==e.documentURL)}async function rJ(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS],n=e.traces[Dr.DEFAULT_PASS],r=[],i=await K$(n,a,t);for(let{record:e}of i)!e||"Script"!==e.resourceType||(nJ(e)||lJ.find((t=>e.url.match(t))))&&r.push(e);return r}c(aJ,{UIStrings:()=>iJ,default:()=>uJ});var iJ,oJ,sJ,lJ,cJ,uJ,dJ=s((()=>{J(),zK(),ro(),$c(),nG(),xQ(),Y$(),g$(),400,oJ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/script-injected-tags.js",iJ={title:"Ad scripts are loaded statically",failureTitle:"Load ad scripts statically",description:"Load the following scripts directly with `<script async src=...>` instead of injecting scripts with JavaScript. Doing so allows the browser to preload scripts sooner. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/script-injected-tags).",failureDisplayValue:"Load {tags, plural, =1 {1 script} other {# scripts}} statically",columnUrl:"Script",columnLoadTime:"Load Time"}),sJ=[{key:"url",itemType:"url",text:oJ(iJ.columnUrl)},{key:"loadTime",itemType:"ms",granularity:1,text:oJ(iJ.columnLoadTime)}],lJ=[/amazon-adsystem\.com\/aax2\/apstag.js/,/js-sec\.indexww\.com\/ht\/p\/.*\.js/,/pubads\.g\.doubleclick\.net\/tag\/js\/gpt\.js/,/static\.criteo\.net\/js\/.*\/publishertag\.js/,/www\.googletagservices\.com\/tag\/js\/gpt\.js/,/pagead2\.googlesyndication\.com\/pagead\/js\/adsbygoogle\.js/,/cdn\.ampproject\.org\/v0\/amp-ad-\d+\.\d+\.js/],o(nJ,"initiatedByInlineScript"),o(rJ,"findStaticallyLoadableTags"),cJ=class e extends Dr{static{o(this,"StaticAdTags")}static get meta(){return{id:"script-injected-tags",title:oJ(iJ.title),failureTitle:oJ(iJ.failureTitle),description:oJ(iJ.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,a){let n=await rJ(t,a);if(!n.length)return XH.NoTag;let r=new Set,i=[],o=t.devtoolsLogs[Dr.DEFAULT_PASS],s=t.traces[Dr.DEFAULT_PASS],l=await d$(s,o,a);for(let e of n){if(r.has(e.url))continue;if(r.add(e.url),0===BK(n.filter((t=>t.url===e.url)),(e=>"parser"===e.initiator.type&&!e.isLinkPreload))){let t=l.get(e.url)||0;if(t<400)continue;i.push({url:e.url,loadTime:t})}}i.sort(((e,t)=>e.loadTime-t.loadTime));let c=i.length>0;return{displayValue:c?oJ(iJ.failureDisplayValue,{tags:i.length}):"",score:+!c,numericValue:i.length,numericUnit:"unitless",details:e.makeTableDetails(sJ,i)}}},uJ=cJ})),mJ={};function pJ(e,t,a){let n=[];for(let r of e){let e=a.get(r);e&&n.push(Object.assign({},e,{url:r.url,type:t}))}return n}function hJ(e){return vG(new URL(e.url))?DJ.AD:BG(e.url)?DJ.BID:DJ.UNKNOWN}function gJ(e){return(null==e.resourceSize||e.resourceSize>0)&&"Image"!=e.resourceType&&e.endTime-e.startTime>=bJ&&!hG(e)}function fJ(e){let t=new URL(e);return t.search="",t.toString()}c(mJ,{UIStrings:()=>yJ,default:()=>TJ});var yJ,vJ,bJ,wJ,DJ,EJ,TJ,SJ,CJ,kJ,xJ=s((()=>{J(),f$(),ro(),fb(),Yc(),nG(),xQ(),zK(),g$(),fG(),KG(),vJ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/serial-header-bidding.js",yJ={title:"Header bidding is parallelized",failureTitle:"Parallelize bid requests",description:"Send header bidding requests simultaneously, rather than serially, to retrieve bids more quickly. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/serial-header-bidding).",columnBidder:"Bidder",columnUrl:"URL",columnStartTime:"Start",columnDuration:"Duration"}),bJ=.05,wJ=[{key:"bidder",itemType:"text",text:vJ(yJ.columnBidder)},{key:"url",itemType:"url",text:vJ(yJ.columnUrl)},{key:"startTime",itemType:"ms",text:vJ(yJ.columnStartTime)},{key:"duration",itemType:"ms",text:vJ(yJ.columnDuration)}],DJ={AD:"ad",BID:"bid",UNKNOWN:"unknown"},o(pJ,"constructRecords"),o(hJ,"checkRecordType"),o(gJ,"isPossibleBid"),o(fJ,"clearQueryString"),EJ=class e extends Dr{static{o(this,"SerialHeaderBidding")}static get meta(){return{id:"serial-header-bidding",title:vJ(yJ.title),failureTitle:vJ(yJ.failureTitle),description:vJ(yJ.description),requiredArtifacts:["devtoolsLogs","traces","URL"]}}static async audit(t,a){let n=t.devtoolsLogs[Dr.DEFAULT_PASS],r=t.traces[Dr.DEFAULT_PASS],i=await Pc.request(n,a);if(!i.length)return XH.NoRecords;let o=await pb.request({URL:t.URL,devtoolsLog:n},a),s=qK(i.filter(gJ).filter((e=>e.frameId==o.frameId)),hJ);if(!s.has(DJ.BID))return XH.NoBids;let l,c={trace:r,devtoolsLog:n,settings:a.settings},{timing:u}=await h$.request(c,a),d=await c$(r,n,a),m=pJ(s.get(DJ.BID)||[],DJ.BID,d),p=[];for(let e of m)u>0&&e.endTime>u||(e.bidder=BG(e.url),e.url=fJ(e.url),l&&e.startTime>=l.endTime&&(p.push(l),p.push(e)),(!l||e.endTime<l.endTime||e.startTime>=l.endTime)&&(l=e));p=Array.from(new Set(p));let h=p.length>1;return{numericValue:Number(h),numericUnit:"unitless",score:h?0:1,details:h?e.makeTableDetails(wJ,p):void 0}}},TJ=EJ})),AJ=s((()=>{J(),n$(),IF(),Bc(),g$(),KG(),SJ=dc(SJ=class extends a${static{o(this,"LanternTagLoadTime")}static getEstimateFromSimulation(e,t){let{nodeTimings:a}=e;return{timeInMs:a$.findNetworkTiming(a,(e=>!!e.url&&jG(new URL(e.url)))).endTime,nodeTimings:a}}}),CJ=dc(CJ=class extends xF{static{o(this,"TagLoadTime")}static async computeSimulatedMetric(e,t){return SJ.request(e,t)}static async computeObservedMetric(e,t){let{networkRecords:a}=e,n=l$(a),r=1e3*(r$(a)-n);return Promise.resolve({timing:r})}static async request(e,t){throw Error("Not implemented -- class not decorated")}}),kJ=CJ})),_J={};c(_J,{UIStrings:()=>RJ,default:()=>IJ});var RJ,FJ,NJ,IJ,MJ=s((()=>{J(),AJ(),ro(),nG(),xQ(),FJ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/tag-load-time.js",RJ={title:"Tag load time",failureTitle:"Reduce tag load time",description:"This metric measures the time for the ad tag's implementation script (pubads_impl.js for GPT; adsbygoogle.js for AdSense) to load after the page loads. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/tag-load-time).",displayValue:"{timeInMs, number, seconds} s"}),NJ=class extends Dr{static{o(this,"TagLoadTime")}static get meta(){return{id:"tag-load-time",title:FJ(RJ.title),failureTitle:FJ(RJ.failureTitle),description:FJ(RJ.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:4350,median:8e3},provided:{p10:1200,median:2e3}}}static async audit(e,t){let a={trace:e.traces[Dr.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[Dr.DEFAULT_PASS],settings:t.settings},n=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"],{timing:r}=await kJ.request(a,t);if(!(r>0)){let e=XH.NoTag;return e.runWarnings=[QH.NoTag],e}return{numericValue:r,numericUnit:"millisecond",score:Dr.computeLogNormalScore(n,r),displayValue:FJ(RJ.displayValue,{timeInMs:r})}}},IJ=NJ})),PJ={};function LJ(e,t){let a=new Set([...e.map((e=>e.clientRect.left)),...e.map((e=>e.clientRect.right))].map((e=>Math.min(Math.max(1,e),t.innerWidth-1))));e=e.sort(((e,t)=>e.clientRect.top!==t.clientRect.top?e.clientRect.top-t.clientRect.top:e.clientRect.bottom-t.clientRect.bottom));let n=0;for(let t of a){let a=0,r=0;for(let n of e){if(t<n.clientRect.left||t>n.clientRect.right)continue;if(n.isPositionFixed){a+=n.clientRect.height;continue}let e=n.clientRect.bottom-Math.max(r,n.clientRect.top);e>0&&(a+=e),r=Math.max(r,n.clientRect.bottom)}n=Math.max(n,a)}return n}c(PJ,{UIStrings:()=>OJ,default:()=>BJ});var OJ,jJ,UJ,BJ,qJ=s((()=>{J(),ro(),nG(),xQ(),KG(),jJ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/viewport-ad-density.js",OJ={title:"Ads to page-height ratio is within recommended range",failureTitle:"Reduce ads to page-height ratio",description:"The ads to page-height ratio can impact user experience and ultimately user retention. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/viewport-ad-density).",displayValue:"{adDensity, number, percent} ads to page-height ratio"}),o(LJ,"computeAdLength"),UJ=class extends Dr{static{o(this,"ViewportAdDensity")}static get meta(){return{id:"viewport-ad-density",title:jJ(OJ.title),failureTitle:jJ(OJ.failureTitle),description:jJ(OJ.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(e){let t=e.ViewportDimensions,a=e.IFrameElements.filter((e=>OG(e)&&e.clientRect.width*e.clientRect.height>1));if(!a.length)return XH.NoVisibleSlots;if(t.innerHeight<=0)throw new Error(eG.ViewportAreaZero);let n=LJ(a,t),r=Math.max(...a.map((e=>e.clientRect.top+e.clientRect.height/2)))+t.innerHeight,i=Math.min(1,n/r);return{score:i>.3?0:1,numericValue:i,numericUnit:"unitless",displayValue:jJ(OJ.displayValue,{adDensity:i})}}},BJ=UJ})),zJ={};c(zJ,{UIStrings:()=>VJ,default:()=>GJ});var VJ,WJ,HJ,GJ,$J=s((()=>{J(),ro(),nG(),xQ(),g$(),KG(),NK(),WJ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/cumulative-ad-shift.js",VJ={title:"Cumulative ad shift",failureTitle:"Reduce ad-related layout shift",description:"Measures layout shifts that were caused by ads or happened near ads. Reducing cumulative ad-related layout shift will improve user experience. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/cumulative-ad-shift)."}),HJ=class extends Dr{static{o(this,"CumulativeAdShift")}static get meta(){return{id:"cumulative-ad-shift",title:WJ(VJ.title),failureTitle:WJ(VJ.failureTitle),description:WJ(VJ.description),scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","IFrameElements"]}}static get defaultOptions(){return{p10:.05,median:.25}}static isAdExpansion(e,t){if(!e.args||!e.args.data)return!1;for(let a of e.args.data.impacted_nodes||[]){let e=RK(a.old_rect||[]),n=RK(a.new_rect||[]);if(!(e.top>n.top||e.height!==n.height))for(let a of t){let t=a.clientRect;if((e.top>=t.top||n.top>=t.bottom)&&FK(e,t))return!0}}return!1}static isAttributableToTask(e,t){if(!e.args||!e.args.data)return!1;return!!t.find((t=>t.ts<e.ts&&e.ts-t.ts<5e4))}static compute(e,t,a,n){let r=0,i=0,o=0,s=0,l=0,c=0;for(let u of e)!u.args||!u.args.data||!u.args.data.is_main_frame||(r+=u.args.data.score,i++,(this.isAdExpansion(u,a)||this.isAttributableToTask(u,t))&&(o+=u.args.data.score,s++,u.ts<n&&(l+=u.args.data.score,c++)));return{cumulativeShift:r,numShifts:i,cumulativeAdShift:o,numAdShifts:s,cumulativePreImplTagAdShift:l,numPreImplTagAdShifts:c}}static getLayoutShiftEventsByWindow(e){let t=0,a=[],n=0,r=[];for(let i of e){if("LayoutShift"!==i.name||!i.args||!i.args.data)continue;if(r.length){let e=r[0],o=r[r.length-1];(o.ts-e.ts>5e6||i.ts-o.ts>1e6)&&(n>t&&(a=r,t=n),r=[],n=0)}r.push(i);let e=i.args.data;n+=e.weighted_score_delta||e.score||0}return a.length||(a=r),a}static async audit(e,t){let a=e.traces[Dr.DEFAULT_PASS],n=this.getLayoutShiftEventsByWindow(a.traceEvents);if(!n.length)return XH.NoLayoutShifts;let r=a.traceEvents.filter((e=>$G(u$(e)||""))),i=r.find((e=>jG(u$(e)||"")))||{ts:1/0},o=e.IFrameElements.filter(OG),s=this.compute(n,r,o,i.ts),l=s.cumulativeAdShift;return o.length||l?{numericValue:l,numericUnit:"unitless",score:Dr.computeLogNormalScore({p10:t.options.p10,median:t.options.median},l),displayValue:l.toLocaleString(t.settings.locale),details:s}:XH.NoAdRendered}},GJ=HJ})),KJ={};c(KJ,{UIStrings:()=>YJ,default:()=>XJ});var YJ,JJ,ZJ,XJ,QJ=s((()=>{J(),ro(),Yc(),nG(),xQ(),KG(),JJ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/deprecated-api-usage.js",YJ={title:"Deprecated GPT API Usage",failureTitle:"Avoid deprecated GPT APIs",description:"Deprecated GPT API methods should be avoided to ensure your page is tagged correctly. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/deprecated-gpt-api-usage).",displayValue:"{numErrors, plural, =1 {1 error} other {# errors}} found"}),ZJ=class extends Dr{static{o(this,"DeprecatedApiUsage")}static get meta(){return{id:"deprecated-gpt-api-usage",title:JJ(YJ.title),failureTitle:JJ(YJ.failureTitle),description:JJ(YJ.description),scoreDisplayMode:"informative",requiredArtifacts:["ConsoleMessages","devtoolsLogs"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS];if(!(await Pc.request(a,t)).find((e=>xG(e.url))))return XH.NoGpt;let n=e.ConsoleMessages.filter((e=>"warning"===e.level||"error"===e.level)).filter((e=>e.url&&_G(e.url))).filter((e=>e.text.toLowerCase().includes("deprecated")||e.text.toLowerCase().includes("discouraged"))).map((e=>({source:e.source,description:e.text,url:e.url,timestamp:e.timestamp}))).sort(((e,t)=>(e.timestamp||0)-(t.timestamp||0))),r=[{key:"url",itemType:"url",text:JJ(no.columnURL)},{key:"description",itemType:"code",text:JJ(no.columnDescription)}],i=Dr.makeTableDetails(r,n),o=n.length;return{score:+(0===o),details:i,displayValue:JJ(YJ.displayValue,{numErrors:o})}}},XJ=ZJ})),eZ={};c(eZ,{UIStrings:()=>tZ,default:()=>rZ});var tZ,aZ,nZ,rZ,iZ=s((()=>{J(),ro(),Yc(),nG(),xQ(),KG(),aZ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/gpt-errors-overall.js",tZ={title:"GPT Errors",failureTitle:"Fix GPT errors",description:"Fix GPT errors to ensure your page is tagged as intended. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/gpt-errors-overall).",displayValue:"{numErrors, plural, =1 {1 error} other {# errors}} found"}),nZ=class extends Dr{static{o(this,"GptErrorsOverall")}static get meta(){return{id:"gpt-errors-overall",title:aZ(tZ.title),failureTitle:aZ(tZ.failureTitle),description:aZ(tZ.description),scoreDisplayMode:"informative",requiredArtifacts:["ConsoleMessages","devtoolsLogs"]}}static async audit(e,t){let a=e.devtoolsLogs[Dr.DEFAULT_PASS];if(!(await Pc.request(a,t)).find((e=>xG(e.url))))return XH.NoGpt;let n=e.ConsoleMessages.filter((e=>"error"===e.level||"warning"===e.level)).filter((e=>e.url&&_G(e.url))).filter((e=>!e.text.toLowerCase().includes("deprecated")&&!e.text.toLowerCase().includes("discouraged"))).map((e=>({source:e.source,description:e.text,url:e.url,timestamp:e.timestamp}))).sort(((e,t)=>(e.timestamp||0)-(t.timestamp||0))),r=[{key:"url",itemType:"url",text:aZ(no.columnURL)},{key:"description",itemType:"code",text:aZ(no.columnDescription)}],i=Dr.makeTableDetails(r,n),o=n.length;return{score:+(0===o),details:i,displayValue:aZ(tZ.displayValue,{numErrors:o})}}},rZ=nZ})),oZ={};c(oZ,{UIStrings:()=>sZ,default:()=>dZ});var sZ,lZ,cZ,uZ,dZ,mZ=s((()=>{J(),ro(),T$(),Yc(),nG(),xQ(),v$(),KG(),lZ=eo("node_modules/lighthouse-plugin-publisher-ads/audits/total-ad-blocking-time.js",sZ={title:"Total ad JS blocking time",failureTitle:"Reduce ad JS blocking time",description:"Ad-related scripts are blocking the main thread. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/total-ad-blocking-time).",failureDisplayValue:"{timeInMs, number, seconds} s blocked",columnName:"Name",columnBlockingTime:"Blocking Time"}),cZ=[{key:"name",itemType:"text",text:lZ(sZ.columnName)},{key:"blockingTime",itemType:"ms",text:lZ(sZ.columnBlockingTime),granularity:1}],uZ=class e extends Dr{static{o(this,"TotalAdBlockingTime")}static get meta(){return{id:"total-ad-blocking-time",title:lZ(sZ.title),failureTitle:lZ(sZ.failureTitle),description:lZ(sZ.description),requiredArtifacts:["traces","devtoolsLogs"]}}static get defaultOptions(){return{simulate:{p10:290,median:600},provided:{p10:150,median:350}}}static async audit(t,a){let n=t.traces[Dr.DEFAULT_PASS],r=t.devtoolsLogs[Dr.DEFAULT_PASS];if(!(await Pc.request(r,a)).find((e=>$G(e.url))))return XH.NoAdRelatedReq;let i={trace:n,devtoolsLog:r,settings:a.settings},o=[];try{o=await E$.request(i,a)}catch{return XH.InvalidTiming}let s=0,l=new Map;for(let e of o){let t=y$(e);if(!t||!$G(t)||e.parent)continue;let a=e.duration-50;s+=a;let n=GG(t),r=l.get(n)||0;l.set(n,r+a)}let c=[];for(let[e,t]of l.entries())c.push({name:e,blockingTime:t});c.sort(((e,t)=>t.blockingTime-e.blockingTime));let u=a.options[a.settings.throttlingMethod]||a.options.provided;return{score:Dr.computeLogNormalScore(u,s),numericValue:s,numericUnit:"millisecond",displayValue:lZ(sZ.failureDisplayValue,{timeInMs:s}),details:e.makeTableDetails(cZ,c)}}},dZ=uZ})),pZ={};c(pZ,{default:()=>hZ});var hZ,gZ=s((()=>{J(),hZ={audits:[{path:"lighthouse-plugin-soft-navigation/audits/soft-nav-fcp"},{path:"lighthouse-plugin-soft-navigation/audits/soft-nav-lcp"}],groups:{metrics:{title:"Metrics associated with a soft navigation"}},category:{title:"Soft Navigation",supportedModes:["timespan"],auditRefs:[{id:"soft-nav-fcp",weight:1,group:"metrics"},{id:"soft-nav-lcp",weight:1,group:"metrics"}]}}}));function fZ(e){let t,a,n,r;for(let i of e)switch(i.name){case"SoftNavigationHeuristics::UserInitiatedClick":a||(t=i);break;case"SoftNavigationHeuristics_SoftNavigationDetected":if(a)throw new Error("Multiple soft navigations detected");a=i;break;case"largestContentfulPaint::Candidate":t&&(n=i);break;case"firstContentfulPaint":t&&(r=i)}if(!t)return{};let i=t.ts,s=o((e=>{if(e)return(e.ts-i)/1e3}),"getTiming");return{lcpTiming:s(n),fcpTiming:s(r)}}var yZ=s((()=>{J(),o(fZ,"computeMetricTimings")})),vZ={};c(vZ,{default:()=>wZ});var bZ,wZ,DZ=s((()=>{J(),xQ(),Hc(),yZ(),bZ=class extends Dr{static{o(this,"SoftNavFCP")}static get meta(){return{id:"soft-nav-fcp",title:"Soft Navigation First Contentful Paint",description:"First Contentful Paint of a soft navigation.",scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["timespan"],requiredArtifacts:["Trace"]}}static async audit(e,t){let a=e.Trace,n=await kc.request(a,t),{fcpTiming:r}=fZ(n.mainThreadEvents);return r?{numericValue:r,numericUnit:"millisecond",displayValue:`${r} ms`,score:Dr.computeLogNormalScore({p10:1800,median:3e3},r)}:{notApplicable:!0,score:1}}},wZ=bZ})),EZ={};c(EZ,{default:()=>SZ});var TZ,SZ,CZ=s((()=>{J(),xQ(),Hc(),yZ(),TZ=class extends Dr{static{o(this,"SoftNavLCP")}static get meta(){return{id:"soft-nav-lcp",title:"Soft Navigation Largest Contentful Paint",description:"Largest Contentful Paint of a soft navigation.",scoreDisplayMode:Dr.SCORING_MODES.NUMERIC,supportedModes:["timespan"],requiredArtifacts:["Trace"]}}static async audit(e,t){let a=e.Trace,n=await kc.request(a,t),{lcpTiming:r}=fZ(n.mainThreadEvents);return r?{numericValue:r,numericUnit:"millisecond",displayValue:`${r} ms`,score:Dr.computeLogNormalScore({p10:2500,median:4e3},r)}:{notApplicable:!0,score:1}}},SZ=TZ}));function kZ(){if(globalThis.isDevtools||globalThis.isLightrider)return!0;try{return WZ.resolve("lighthouse-logger"),!1}catch{return!0}}function xZ(e,t,a=!1){if(typeof e>"u"||null===e)return t;if(typeof t>"u")return e;if(Array.isArray(t)){if(a)return t;if(!Array.isArray(e))throw new TypeError("Expected array but got "+typeof e);let n=e.slice();return t.forEach((e=>{n.some((t=>(0,VZ.default)(t,e)))||n.push(e)})),n}if("object"==typeof t){if("object"!=typeof e)throw new TypeError("Expected object but got "+typeof e);if(Array.isArray(e))throw new TypeError("Expected object but got Array");return Object.keys(t).forEach((n=>{let r=a||"settings"===n&&"object"==typeof e[n];e[n]=xZ(e[n],t[n],r)})),e}return t}function AZ(e,t,a){let n=new Map,r=e||[];for(let e=0;e<r.length;e++){let t=r[e];n.set(a(t),{index:e,item:t})}for(let e of t||[]){let t=n.get(a(e));if(t){let a=t.item,n="object"==typeof e&&"object"==typeof a?GZ(a,e,!0):e;r[t.index]=n}else r.push(e)}return r}function _Z(e){if("string"==typeof e)return{path:e};if("implementation"in e||"instance"in e)return e;if("path"in e){if("string"!=typeof e.path)throw new Error("Invalid Gatherer type "+JSON.stringify(e));return e}if("function"==typeof e)return{implementation:e};if(e&&"function"==typeof e.getArtifact)return{instance:e};throw new Error("Invalid Gatherer type "+JSON.stringify(e))}function RZ(e){if("string"==typeof e)return{path:e,options:{}};if("implementation"in e&&"function"==typeof e.implementation.audit)return e;if("path"in e&&"string"==typeof e.path)return e;if("audit"in e&&"function"==typeof e.audit)return{implementation:e,options:{}};throw new Error("Invalid Audit type "+JSON.stringify(e))}async function FZ(e){let t;if(Ta.isAbsolute(e)&&(e=ei.pathToFileURL(e).href),$Z.has(e)?t=await $Z.get(e):(e.match(/\.(js|mjs|cjs)$/)||(e+=".js"),t=await import(e)),t.default)return t.default;let a=new Set(["meta"]),n=Object.keys(t).filter((e=>!!(t[e]&&t[e]instanceof Object)&&Object.getOwnPropertyNames(t[e]).some((e=>a.has(e)))));if(1===n.length)return n[0];throw n.length>1?new Error(`module '${e}' has too many possible exports`):new Error(`module '${e}' missing default export`)}async function NZ(e,t,a){let n=t.find((t=>t===`${e}.js`)),r=`../gather/gatherers/${e}`;n||(r=UZ(e,a,"gatherer"));let i=await FZ(r);return{instance:new i,implementation:i,path:e}}function IZ(e,t,a){let n=`${e}.js`,r=`../audits/${e}`;if(!t.find((e=>e===n)))if(kZ())r=e;else{let t=UZ(e,a,"audit");r=kZ()?Ta.relative("",t):t}return FZ(r)}function MZ(e={}){let t={};for(let a of Object.keys(e))a in Jl&&(t[a]=e[a]);return t}function PZ(e={},t=void 0){let a=Qi(t?.locale||e.locale),{defaultSettings:n}=Gl,r=GZ(qZ(n),e,!0),i=GZ(r,MZ(t),!0);return i.budgets&&(i.budgets=wm.initializeBudget(i.budgets)),i.locale=a,!0===i.emulatedUserAgent&&(i.emulatedUserAgent=Yl[i.formFactor]),Kd(i),i}async function LZ(e,t,a){let n=e.plugins||[],r=new Set([...n,...a?.plugins||[]]);for(let a of r){Vd(e,a);let n=kZ()?a:UZ(a,t,"plugin"),r=await FZ(n),i=Am.parsePlugin(r,a);e=GZ(e,i)}return e}async function OZ(e,t,a){let n=_Z(e);if(n.instance)return{instance:n.instance,implementation:n.implementation,path:n.path};if(n.implementation){return{instance:new(0,n.implementation),implementation:n.implementation,path:n.path}}if(n.path){return NZ(n.path,t,a)}throw new Error("Invalid expanded Gatherer: "+JSON.stringify(n))}async function jZ(e,t){if(!e)return null;let a=Ou.getAuditList(),n=e.map((async e=>{let n,r=RZ(e);return n="implementation"in r?r.implementation:await IZ(r.path,a,t),{implementation:n,path:r.path,options:r.options||{}}})),r=await Promise.all(n),i=HZ(r);return i.forEach((e=>Gd(e))),i}function UZ(e,t,a){try{return WZ.resolve(e)}catch{}try{return WZ.resolve(e,{paths:[process.cwd()]})}catch{}let n=Ta.resolve(process.cwd(),e);try{return WZ.resolve(n)}catch{}let r="Unable to locate "+(a?`${a}: `:"")+`\`${e}\`.\n     Tried to resolve the module from these locations:\n       \n       ${n}`;if(!t)throw new Error(r);let i=Ta.resolve(t,e);try{return WZ.resolve(i)}catch{}try{return WZ.resolve(e,{paths:[t]})}catch{}throw new Error(r+`\n       ${i}`)}function BZ(e){return"object"==typeof e?Object.assign(Object.create(Object.getPrototypeOf(e)),e):e}function qZ(e){return JSON.parse(JSON.stringify(e))}function zZ(e){let t=qZ(e);return Array.isArray(e.audits)&&(t.audits=e.audits.map((e=>BZ(e)))),Array.isArray(e.artifacts)&&(t.artifacts=e.artifacts.map((e=>({...e,gatherer:BZ(e.gatherer)})))),t}var VZ,WZ,HZ,GZ,$Z,KZ=s((()=>{J(),ka(),ni(),ri(),VZ=d(lr(),1),oc(),Dm(),Rm(),Bu(),ro(),Qd(),oi(),WZ=Zr("core/config/config-helpers.js"),o(kZ,"isBundledEnvironment"),HZ=o((function(e){let t=[];for(let a of e){let e=a.path&&t.find((e=>e.path===a.path));e?e.options=Object.assign({},e.options,a.options):t.push(a)}return t}),"mergeOptionsOfItems"),o(xZ,"_mergeConfigFragment"),GZ=xZ,o(AZ,"mergeConfigFragmentArrayByKey"),o(_Z,"expandGathererShorthand"),o(RZ,"expandAuditShorthand"),$Z=new Map([["../gather/gatherers/accessibility",Promise.resolve().then((()=>(jm(),Nm)))],["../gather/gatherers/anchor-elements",Promise.resolve().then((()=>(Km(),Vm)))],["../gather/gatherers/bf-cache-failures",Promise.resolve().then((()=>(fp(),pp)))],["../gather/gatherers/cache-contents",Promise.resolve().then((()=>(Dp(),yp)))],["../gather/gatherers/console-messages",Promise.resolve().then((()=>(kp(),Ep)))],["../gather/gatherers/css-usage",Promise.resolve().then((()=>(Rp(),xp)))],["../gather/gatherers/devtools-log-compat",Promise.resolve().then((()=>(Mp(),Fp)))],["../gather/gatherers/devtools-log",Promise.resolve().then((()=>(mp(),lp)))],["../gather/gatherers/dobetterweb/doctype",Promise.resolve().then((()=>(Up(),Pp)))],["../gather/gatherers/dobetterweb/domstats",Promise.resolve().then((()=>(Wp(),Bp)))],["../gather/gatherers/dobetterweb/optimized-images",Promise.resolve().then((()=>(Jp(),Hp)))],["../gather/gatherers/dobetterweb/response-compression",Promise.resolve().then((()=>(Wy(),Oy)))],["../gather/gatherers/dobetterweb/tags-blocking-first-paint",Promise.resolve().then((()=>(Jy(),Hy)))],["../gather/gatherers/full-page-screenshot",Promise.resolve().then((()=>(gv(),lv)))],["../gather/gatherers/global-listeners",Promise.resolve().then((()=>(bv(),fv)))],["../gather/gatherers/iframe-elements",Promise.resolve().then((()=>(Sv(),wv)))],["../gather/gatherers/image-elements",Promise.resolve().then((()=>(Yv(),Lv)))],["../gather/gatherers/inputs",Promise.resolve().then((()=>(eb(),Jv)))],["../gather/gatherers/inspector-issues",Promise.resolve().then((()=>(rb(),tb)))],["../gather/gatherers/installability-errors",Promise.resolve().then((()=>(lb(),ib)))],["../gather/gatherers/js-usage",Promise.resolve().then((()=>(hb(),cb)))],["../gather/gatherers/link-elements",Promise.resolve().then((()=>(kb(),yb)))],["../gather/gatherers/main-document-content",Promise.resolve().then((()=>(Rb(),xb)))],["../gather/gatherers/meta-elements",Promise.resolve().then((()=>(Pb(),Fb)))],["../gather/gatherers/network-user-agent",Promise.resolve().then((()=>(Ub(),Lb)))],["../gather/gatherers/script-elements",Promise.resolve().then((()=>(Wb(),Bb)))],["../gather/gatherers/scripts",Promise.resolve().then((()=>(Jb(),Hb)))],["../gather/gatherers/seo/embedded-content",Promise.resolve().then((()=>(tw(),Zb)))],["../gather/gatherers/seo/font-size",Promise.resolve().then((()=>(Pv(),Cv)))],["../gather/gatherers/seo/robots-txt",Promise.resolve().then((()=>(iw(),aw)))],["../gather/gatherers/seo/tap-targets",Promise.resolve().then((()=>(Pw(),Ew)))],["../gather/gatherers/service-worker",Promise.resolve().then((()=>(zw(),Uw)))],["../gather/gatherers/source-maps",Promise.resolve().then((()=>(Xw(),Kw)))],["../gather/gatherers/stacks",Promise.resolve().then((()=>(nD(),Qw)))],["../gather/gatherers/trace-compat",Promise.resolve().then((()=>(fD(),rD)))],["../gather/gatherers/trace-elements",Promise.resolve().then((()=>(SD(),wD)))],["../gather/gatherers/trace",Promise.resolve().then((()=>(sa(),ra)))],["../gather/gatherers/viewport-dimensions",Promise.resolve().then((()=>(_D(),CD)))],["../gather/gatherers/web-app-manifest",Promise.resolve().then((()=>(nE(),JD)))],["../audits/accessibility/accesskeys",Promise.resolve().then((()=>(uE(),iE)))],["../audits/accessibility/aria-allowed-attr",Promise.resolve().then((()=>(fE(),dE)))],["../audits/accessibility/aria-allowed-role",Promise.resolve().then((()=>(EE(),yE)))],["../audits/accessibility/aria-command-name",Promise.resolve().then((()=>(AE(),TE)))],["../audits/accessibility/aria-dialog-name",Promise.resolve().then((()=>(ME(),_E)))],["../audits/accessibility/aria-hidden-body",Promise.resolve().then((()=>(BE(),PE)))],["../audits/accessibility/aria-hidden-focus",Promise.resolve().then((()=>(GE(),qE)))],["../audits/accessibility/aria-input-field-name",Promise.resolve().then((()=>(XE(),$E)))],["../audits/accessibility/aria-meter-name",Promise.resolve().then((()=>(rT(),QE)))],["../audits/accessibility/aria-progressbar-name",Promise.resolve().then((()=>(uT(),iT)))],["../audits/accessibility/aria-required-attr",Promise.resolve().then((()=>(fT(),dT)))],["../audits/accessibility/aria-required-children",Promise.resolve().then((()=>(ET(),yT)))],["../audits/accessibility/aria-required-parent",Promise.resolve().then((()=>(AT(),TT)))],["../audits/accessibility/aria-roles",Promise.resolve().then((()=>(MT(),_T)))],["../audits/accessibility/aria-text",Promise.resolve().then((()=>(BT(),PT)))],["../audits/accessibility/aria-toggle-field-name",Promise.resolve().then((()=>(GT(),qT)))],["../audits/accessibility/aria-tooltip-name",Promise.resolve().then((()=>(XT(),$T)))],["../audits/accessibility/aria-treeitem-name",Promise.resolve().then((()=>(rS(),QT)))],["../audits/accessibility/aria-valid-attr-value",Promise.resolve().then((()=>(uS(),iS)))],["../audits/accessibility/aria-valid-attr",Promise.resolve().then((()=>(fS(),dS)))],["../audits/accessibility/button-name",Promise.resolve().then((()=>(ES(),yS)))],["../audits/accessibility/bypass",Promise.resolve().then((()=>(AS(),TS)))],["../audits/accessibility/color-contrast",Promise.resolve().then((()=>(MS(),_S)))],["../audits/accessibility/definition-list",Promise.resolve().then((()=>(BS(),PS)))],["../audits/accessibility/dlitem",Promise.resolve().then((()=>(GS(),qS)))],["../audits/accessibility/document-title",Promise.resolve().then((()=>(XS(),$S)))],["../audits/accessibility/duplicate-id-active",Promise.resolve().then((()=>(rC(),QS)))],["../audits/accessibility/duplicate-id-aria",Promise.resolve().then((()=>(uC(),iC)))],["../audits/accessibility/empty-heading",Promise.resolve().then((()=>(fC(),dC)))],["../audits/accessibility/form-field-multiple-labels",Promise.resolve().then((()=>(EC(),yC)))],["../audits/accessibility/frame-title",Promise.resolve().then((()=>(AC(),TC)))],["../audits/accessibility/heading-order",Promise.resolve().then((()=>(MC(),_C)))],["../audits/accessibility/html-has-lang",Promise.resolve().then((()=>(BC(),PC)))],["../audits/accessibility/html-lang-valid",Promise.resolve().then((()=>(GC(),qC)))],["../audits/accessibility/html-xml-lang-mismatch",Promise.resolve().then((()=>(XC(),$C)))],["../audits/accessibility/identical-links-same-purpose",Promise.resolve().then((()=>(rk(),QC)))],["../audits/accessibility/image-alt",Promise.resolve().then((()=>(uk(),ik)))],["../audits/accessibility/image-redundant-alt",Promise.resolve().then((()=>(fk(),dk)))],["../audits/accessibility/input-button-name",Promise.resolve().then((()=>(Ek(),yk)))],["../audits/accessibility/input-image-alt",Promise.resolve().then((()=>(Ak(),Tk)))],["../audits/accessibility/label-content-name-mismatch",Promise.resolve().then((()=>(Mk(),_k)))],["../audits/accessibility/label",Promise.resolve().then((()=>(Bk(),Pk)))],["../audits/accessibility/landmark-one-main",Promise.resolve().then((()=>(Gk(),qk)))],["../audits/accessibility/link-in-text-block",Promise.resolve().then((()=>(Xk(),$k)))],["../audits/accessibility/link-name",Promise.resolve().then((()=>(rx(),Qk)))],["../audits/accessibility/list",Promise.resolve().then((()=>(ux(),ix)))],["../audits/accessibility/listitem",Promise.resolve().then((()=>(vx(),dx)))],["../audits/accessibility/manual/custom-controls-labels",Promise.resolve().then((()=>(Tx(),wx)))],["../audits/accessibility/manual/custom-controls-roles",Promise.resolve().then((()=>(xx(),Sx)))],["../audits/accessibility/manual/focus-traps",Promise.resolve().then((()=>(Fx(),Ax)))],["../audits/accessibility/manual/focusable-controls",Promise.resolve().then((()=>(Px(),Nx)))],["../audits/accessibility/manual/interactive-element-affordance",Promise.resolve().then((()=>(Ux(),Lx)))],["../audits/accessibility/manual/logical-tab-order",Promise.resolve().then((()=>(Vx(),Bx)))],["../audits/accessibility/manual/managed-focus",Promise.resolve().then((()=>($x(),Wx)))],["../audits/accessibility/manual/offscreen-content-hidden",Promise.resolve().then((()=>(Zx(),Kx)))],["../audits/accessibility/manual/use-landmarks",Promise.resolve().then((()=>(tA(),Xx)))],["../audits/accessibility/manual/visual-order-follows-dom",Promise.resolve().then((()=>(iA(),aA)))],["../audits/accessibility/meta-refresh",Promise.resolve().then((()=>(dA(),oA)))],["../audits/accessibility/meta-viewport",Promise.resolve().then((()=>(yA(),mA)))],["../audits/accessibility/object-alt",Promise.resolve().then((()=>(TA(),vA)))],["../audits/accessibility/select-name",Promise.resolve().then((()=>(_A(),SA)))],["../audits/accessibility/skip-link",Promise.resolve().then((()=>(PA(),RA)))],["../audits/accessibility/tabindex",Promise.resolve().then((()=>(qA(),LA)))],["../audits/accessibility/table-duplicate-name",Promise.resolve().then((()=>($A(),zA)))],["../audits/accessibility/table-fake-caption",Promise.resolve().then((()=>(QA(),KA)))],["../audits/accessibility/target-size",Promise.resolve().then((()=>(i_(),e_)))],["../audits/accessibility/td-has-header",Promise.resolve().then((()=>(d_(),o_)))],["../audits/accessibility/td-headers-attr",Promise.resolve().then((()=>(y_(),m_)))],["../audits/accessibility/th-has-data-cells",Promise.resolve().then((()=>(T_(),v_)))],["../audits/accessibility/valid-lang",Promise.resolve().then((()=>(__(),S_)))],["../audits/accessibility/video-caption",Promise.resolve().then((()=>(P_(),R_)))],["../audits/autocomplete",Promise.resolve().then((()=>($_(),L_)))],["../audits/bf-cache",Promise.resolve().then((()=>(sR(),Y_)))],["../audits/bootup-time",Promise.resolve().then((()=>(PR(),yR)))],["../audits/byte-efficiency/duplicated-javascript",Promise.resolve().then((()=>(oF(),eF)))],["../audits/byte-efficiency/efficient-animated-content",Promise.resolve().then((()=>(mF(),sF)))],["../audits/byte-efficiency/legacy-javascript",Promise.resolve().then((()=>(wF(),pF)))],["../audits/byte-efficiency/modern-image-formats",Promise.resolve().then((()=>(NF(),DF)))],["../audits/byte-efficiency/offscreen-images",Promise.resolve().then((()=>(GF(),LF)))],["../audits/byte-efficiency/render-blocking-resources",Promise.resolve().then((()=>(nN(),YF)))],["../audits/byte-efficiency/total-byte-weight",Promise.resolve().then((()=>(cN(),rN)))],["../audits/byte-efficiency/unminified-css",Promise.resolve().then((()=>(EN(),yN)))],["../audits/byte-efficiency/unminified-javascript",Promise.resolve().then((()=>(AN(),TN)))],["../audits/byte-efficiency/unused-css-rules",Promise.resolve().then((()=>(LN(),_N)))],["../audits/byte-efficiency/unused-javascript",Promise.resolve().then((()=>($N(),jN)))],["../audits/byte-efficiency/uses-long-cache-ttl",Promise.resolve().then((()=>(tI(),YN)))],["../audits/byte-efficiency/uses-optimized-images",Promise.resolve().then((()=>(cI(),aI)))],["../audits/byte-efficiency/uses-responsive-images-snapshot",Promise.resolve().then((()=>(EI(),yI)))],["../audits/byte-efficiency/uses-responsive-images",Promise.resolve().then((()=>(fI(),dI)))],["../audits/byte-efficiency/uses-text-compression",Promise.resolve().then((()=>(AI(),TI)))],["../audits/content-width",Promise.resolve().then((()=>(LI(),_I)))],["../audits/critical-request-chains",Promise.resolve().then((()=>(VI(),jI)))],["../audits/csp-xss",Promise.resolve().then((()=>(bM(),mM)))],["../audits/deprecations",Promise.resolve().then((()=>(FM(),kM)))],["../audits/diagnostics",Promise.resolve().then((()=>(PM(),NM)))],["../audits/dobetterweb/charset",Promise.resolve().then((()=>(WM(),LM)))],["../audits/dobetterweb/doctype",Promise.resolve().then((()=>(JM(),HM)))],["../audits/dobetterweb/dom-size",Promise.resolve().then((()=>(rP(),ZM)))],["../audits/dobetterweb/geolocation-on-start",Promise.resolve().then((()=>(dP(),oP)))],["../audits/dobetterweb/inspector-issues",Promise.resolve().then((()=>(yP(),mP)))],["../audits/dobetterweb/js-libraries",Promise.resolve().then((()=>(TP(),vP)))],["../audits/dobetterweb/no-document-write",Promise.resolve().then((()=>(_P(),SP)))],["../audits/dobetterweb/notification-on-start",Promise.resolve().then((()=>(PP(),RP)))],["../audits/dobetterweb/paste-preventing-inputs",Promise.resolve().then((()=>(qP(),LP)))],["../audits/dobetterweb/uses-http2",Promise.resolve().then((()=>(KP(),zP)))],["../audits/dobetterweb/uses-passive-event-listeners",Promise.resolve().then((()=>(eL(),YP)))],["../audits/errors-in-console",Promise.resolve().then((()=>(lL(),tL)))],["../audits/final-screenshot",Promise.resolve().then((()=>(pL(),uL)))],["../audits/font-display",Promise.resolve().then((()=>(EL(),hL)))],["../audits/image-aspect-ratio",Promise.resolve().then((()=>(AL(),TL)))],["../audits/image-size-responsive",Promise.resolve().then((()=>(KL(),_L)))],["../audits/installable-manifest",Promise.resolve().then((()=>(lO(),nO)))],["../audits/is-on-https",Promise.resolve().then((()=>(DO(),cO)))],["../audits/largest-contentful-paint-element",Promise.resolve().then((()=>(RO(),CO)))],["../audits/layout-shift-elements",Promise.resolve().then((()=>(LO(),FO)))],["../audits/lcp-lazy-loaded",Promise.resolve().then((()=>(zO(),OO)))],["../audits/long-tasks",Promise.resolve().then((()=>(ZO(),VO)))],["../audits/main-thread-tasks",Promise.resolve().then((()=>(tj(),XO)))],["../audits/mainthread-work-breakdown",Promise.resolve().then((()=>(sj(),aj)))],["../audits/manual/pwa-cross-browser",Promise.resolve().then((()=>(pj(),lj)))],["../audits/manual/pwa-each-page-has-url",Promise.resolve().then((()=>(bj(),hj)))],["../audits/manual/pwa-page-transitions",Promise.resolve().then((()=>(Cj(),wj)))],["../audits/maskable-icon",Promise.resolve().then((()=>(Kj(),kj)))],["../audits/metrics",Promise.resolve().then((()=>(xU(),TU)))],["../audits/metrics/cumulative-layout-shift",Promise.resolve().then((()=>(IU(),AU)))],["../audits/metrics/first-contentful-paint",Promise.resolve().then((()=>(UU(),MU)))],["../audits/metrics/first-meaningful-paint",Promise.resolve().then((()=>(HU(),BU)))],["../audits/metrics/interaction-to-next-paint",Promise.resolve().then((()=>(ZU(),GU)))],["../audits/metrics/interactive",Promise.resolve().then((()=>(nB(),XU)))],["../audits/metrics/largest-contentful-paint",Promise.resolve().then((()=>(cB(),rB)))],["../audits/metrics/max-potential-fid",Promise.resolve().then((()=>(gB(),uB)))],["../audits/metrics/speed-index",Promise.resolve().then((()=>(DB(),fB)))],["../audits/metrics/total-blocking-time",Promise.resolve().then((()=>(xB(),EB)))],["../audits/network-requests",Promise.resolve().then((()=>(FB(),AB)))],["../audits/network-rtt",Promise.resolve().then((()=>(OB(),NB)))],["../audits/network-server-latency",Promise.resolve().then((()=>(VB(),jB)))],["../audits/no-unload-listeners",Promise.resolve().then((()=>(YB(),WB)))],["../audits/non-composited-animations",Promise.resolve().then((()=>(nq(),JB)))],["../audits/oopif-iframe-test-audit",Promise.resolve().then((()=>(lq(),rq)))],["../audits/performance-budget",Promise.resolve().then((()=>(gq(),uq)))],["../audits/predictive-perf",Promise.resolve().then((()=>(wq(),fq)))],["../audits/preload-fonts",Promise.resolve().then((()=>(xq(),Dq)))],["../audits/prioritize-lcp-image",Promise.resolve().then((()=>(Iq(),Aq)))],["../audits/redirects",Promise.resolve().then((()=>(Uq(),Mq)))],["../audits/screenshot-thumbnails",Promise.resolve().then((()=>(Wq(),Bq)))],["../audits/script-elements-test-audit",Promise.resolve().then((()=>($q(),Hq)))],["../audits/script-treemap-data",Promise.resolve().then((()=>(Zq(),Kq)))],["../audits/seo/canonical",Promise.resolve().then((()=>(nz(),Xq)))],["../audits/seo/crawlable-anchors",Promise.resolve().then((()=>(mz(),rz)))],["../audits/seo/font-size",Promise.resolve().then((()=>(kz(),gz)))],["../audits/seo/hreflang",Promise.resolve().then((()=>(jz(),Rz)))],["../audits/seo/http-status-code",Promise.resolve().then((()=>(Wz(),Uz)))],["../audits/seo/is-crawlable",Promise.resolve().then((()=>(iV(),$z)))],["../audits/seo/link-text",Promise.resolve().then((()=>(mV(),oV)))],["../audits/seo/manual/structured-data",Promise.resolve().then((()=>(vV(),pV)))],["../audits/seo/meta-description",Promise.resolve().then((()=>(SV(),bV)))],["../audits/seo/plugins",Promise.resolve().then((()=>(OV(),CV)))],["../audits/seo/robots-txt",Promise.resolve().then((()=>(QV(),jV)))],["../audits/seo/tap-targets",Promise.resolve().then((()=>(vW(),rW)))],["../audits/server-response-time",Promise.resolve().then((()=>(kW(),bW)))],["../audits/splash-screen",Promise.resolve().then((()=>(IW(),AW)))],["../audits/themed-omnibox",Promise.resolve().then((()=>(UW(),MW)))],["../audits/third-party-facades",Promise.resolve().then((()=>(XW(),GW)))],["../audits/third-party-summary",Promise.resolve().then((()=>(HW(),BW)))],["../audits/timing-budget",Promise.resolve().then((()=>(rH(),QW)))],["../audits/unsized-images",Promise.resolve().then((()=>(mH(),iH)))],["../audits/user-timings",Promise.resolve().then((()=>(bH(),hH)))],["../audits/uses-rel-preconnect",Promise.resolve().then((()=>(CH(),wH)))],["../audits/uses-rel-preload",Promise.resolve().then((()=>(FH(),kH)))],["../audits/valid-source-maps",Promise.resolve().then((()=>(OH(),NH)))],["../audits/viewport",Promise.resolve().then((()=>(VH(),jH)))],["../audits/work-during-interaction",Promise.resolve().then((()=>(aG(),WH)))],["lighthouse-plugin-publisher-ads",Promise.resolve().then((()=>(uG(),rG)))],["lighthouse-plugin-publisher-ads/audits/ad-blocking-tasks",Promise.resolve().then((()=>(R$(),S$)))],["lighthouse-plugin-publisher-ads/audits/ad-render-blocking-resources",Promise.resolve().then((()=>(O$(),F$)))],["lighthouse-plugin-publisher-ads/audits/ad-request-critical-path",Promise.resolve().then((()=>(lK(),J$)))],["lighthouse-plugin-publisher-ads/audits/bid-request-from-page-start",Promise.resolve().then((()=>(gK(),uK)))],["lighthouse-plugin-publisher-ads/audits/ad-request-from-page-start",Promise.resolve().then((()=>(DK(),fK)))],["lighthouse-plugin-publisher-ads/audits/ad-top-of-viewport",Promise.resolve().then((()=>(AK(),EK)))],["lighthouse-plugin-publisher-ads/audits/ads-in-viewport",Promise.resolve().then((()=>(UK(),IK)))],["lighthouse-plugin-publisher-ads/audits/async-ad-tags",Promise.resolve().then((()=>(YK(),VK)))],["lighthouse-plugin-publisher-ads/audits/blocking-load-events",Promise.resolve().then((()=>(oY(),JK)))],["lighthouse-plugin-publisher-ads/audits/bottleneck-requests",Promise.resolve().then((()=>(pY(),sY)))],["lighthouse-plugin-publisher-ads/audits/duplicate-tags",Promise.resolve().then((()=>(SY(),hY)))],["lighthouse-plugin-publisher-ads/audits/first-ad-render",Promise.resolve().then((()=>(FY(),kY)))],["lighthouse-plugin-publisher-ads/audits/full-width-slots",Promise.resolve().then((()=>(OY(),NY)))],["lighthouse-plugin-publisher-ads/audits/gpt-bids-parallel",Promise.resolve().then((()=>(VY(),jY)))],["lighthouse-plugin-publisher-ads/audits/loads-gpt-from-official-source",Promise.resolve().then((()=>(YY(),WY)))],["lighthouse-plugin-publisher-ads/audits/loads-ad-tag-over-https",Promise.resolve().then((()=>(tJ(),JY)))],["lighthouse-plugin-publisher-ads/audits/script-injected-tags",Promise.resolve().then((()=>(dJ(),aJ)))],["lighthouse-plugin-publisher-ads/audits/serial-header-bidding",Promise.resolve().then((()=>(xJ(),mJ)))],["lighthouse-plugin-publisher-ads/audits/tag-load-time",Promise.resolve().then((()=>(MJ(),_J)))],["lighthouse-plugin-publisher-ads/audits/viewport-ad-density",Promise.resolve().then((()=>(qJ(),PJ)))],["lighthouse-plugin-publisher-ads/audits/cumulative-ad-shift",Promise.resolve().then((()=>($J(),zJ)))],["lighthouse-plugin-publisher-ads/audits/deprecated-api-usage",Promise.resolve().then((()=>(QJ(),KJ)))],["lighthouse-plugin-publisher-ads/audits/gpt-errors-overall",Promise.resolve().then((()=>(iZ(),eZ)))],["lighthouse-plugin-publisher-ads/audits/total-ad-blocking-time",Promise.resolve().then((()=>(mZ(),oZ)))],["lighthouse-plugin-soft-navigation",Promise.resolve().then((()=>(gZ(),pZ)))],["lighthouse-plugin-soft-navigation/audits/soft-nav-fcp",Promise.resolve().then((()=>(DZ(),vZ)))],["lighthouse-plugin-soft-navigation/audits/soft-nav-lcp",Promise.resolve().then((()=>(CZ(),EZ)))]]),o(FZ,"requireWrapper"),o(NZ,"requireGatherer"),o(IZ,"requireAudit"),o(MZ,"cleanFlagsForSettings"),o(PZ,"resolveSettings"),o(LZ,"mergePlugins"),o(OZ,"resolveGathererToDefn"),o(jZ,"resolveAuditsToDefns"),o(UZ,"resolveModulePath"),o(BZ,"shallowClone"),o(qZ,"deepClone"),o(zZ,"deepCloneConfigJson")}));function YZ(e,t){let{configPath:a}=t;if(a&&!Ta.isAbsolute(a))throw new Error("configPath must be an absolute path");e||(e=jd,a=nX);let n=a?Ta.dirname(a):void 0;return{configWorkingCopy:zZ(e),configPath:a,configDir:n}}function JZ(e){if(!e.extends)return e;if("lighthouse:default"!==e.extends)throw new Error("`lighthouse:default` is the only valid extension method.");let{artifacts:t,...a}=e,n=zZ(jd),r=GZ(n,a);return r.artifacts=AZ(n.artifacts,t,(e=>e.id)),r}function ZZ(e,t,a){if(!("dependencies"in t.instance.meta))return;let n=Object.entries(t.instance.meta.dependencies).map((([n,r])=>{let i=a.get(r);return i||Zd(e.id,n),zd(t,i.gatherer)||Xd(e.id,n),[n,{id:i.id}]}));return Object.fromEntries(n)}async function XZ(e,t){if(!e)return null;let a={msg:"Resolve artifact definitions",id:"lh:config:resolveArtifactsToDefns"};Kt.time(a,"verbose");let n=[...e];n.sort(((e,t)=>(rX[e.id]||0)-(rX[t.id]||0)));let r=new Map,i=Ou.getGathererList(),o=[];for(let e of n){let a=e.gatherer,n=await OZ(a,i,t),s={id:e.id,gatherer:n,dependencies:ZZ(e,n,r)},l=s.gatherer.instance.meta.symbol;l&&r.set(l,s),o.push(s)}return Kt.timeEnd(a),o}function QZ(e,t){"timespan"===t&&"simulate"===e.throttlingMethod&&(e.throttlingMethod="devtools")}function eX(e,t){e.disableThrottling||"simulate"!==t.throttlingMethod&&(e.cpuQuietThresholdMs=Math.max(e.cpuQuietThresholdMs||0,Xl.cpuQuietThresholdMs),e.networkQuietThresholdMs=Math.max(e.networkQuietThresholdMs||0,Xl.networkQuietThresholdMs),e.pauseAfterFcpMs=Math.max(e.pauseAfterFcpMs||0,Xl.pauseAfterFcpMs),e.pauseAfterLoadMs=Math.max(e.pauseAfterLoadMs||0,Xl.pauseAfterLoadMs))}function tX(e,t){if(!e)return null;let a={msg:"Resolve navigation definitions",id:"lh:config:resolveNavigationsToDefns"};Kt.time(a,"verbose");let n={...Zl,artifacts:e,pauseAfterFcpMs:t.pauseAfterFcpMs,pauseAfterLoadMs:t.pauseAfterLoadMs,networkQuietThresholdMs:t.networkQuietThresholdMs,cpuQuietThresholdMs:t.cpuQuietThresholdMs,blankPage:t.blankPage};eX(n,t);let r=[n];return Yd(r),Kt.timeEnd(a),r}async function aX(e,t,a={}){let n={msg:"Initialize config",id:"lh:config"};Kt.time(n,"verbose");let{configWorkingCopy:r,configDir:i}=YZ(t,a);r=JZ(r),r=await LZ(r,i,a);let o=PZ(r.settings||{},a);QZ(o,e);let s=await XZ(r.artifacts,i),l={artifacts:s,navigations:tX(s,o),audits:await jZ(r.audits,i),categories:r.categories||null,groups:r.groups||null,settings:o},{warnings:c}=Jd(l);return l=um(l,e),l=dm(l,o),Kt.timeEnd(n),{resolvedConfig:l,warnings:c}}var nX,rX,iX=s((()=>{J(),ka(),ea(),Bu(),qd(),oc(),Qd(),fm(),KZ(),oi(),Mi(),nX=Ta.join("","../../config/default-config.js"),rX={FullPageScreenshot:1,BFCacheFailures:1},o(YZ,"resolveWorkingCopy"),o(JZ,"resolveExtensions"),o(ZZ,"resolveArtifactDependencies"),o(XZ,"resolveArtifactsToDefns"),o(QZ,"overrideSettingsForGatherMode"),o(eX,"overrideNavigationThrottlingWindows"),o(tX,"resolveFakeNavigations"),o(aX,"initializeConfig")}));async function oX(e){let t={msg:"Getting browser version",id:"lh:gather:getVersion"};Kt.time(t,"verbose");let a=await e.sendCommand("Browser.getVersion"),n=a.product.match(/\/(\d+)/),r=n?parseInt(n[1]):0;return Kt.timeEnd(t),Object.assign(a,{milestone:r})}async function sX(e){let t={msg:"Benchmarking machine",id:"lh:gather:getBenchmarkIndex"};Kt.time(t);let a=await e.evaluate(sd.computeBenchmarkIndex,{args:[]});return Kt.timeEnd(t),a}function lX(e){let{settings:t,baseArtifacts:a}=e,{throttling:n,throttlingMethod:r}=t,i=Jl.throttling;if("cli"!==t.channel)return;let o="simulate"===r||"devtools"===r,s=n.cpuSlowdownMultiplier===i.cpuSlowdownMultiplier;return!o||!s||a.BenchmarkIndex>dX?void 0:mX(uX.warningSlowHostCpu)}function cX(e){return[lX(e)].filter((e=>!!e))}var uX,dX,mX,pX=s((()=>{J(),ea(),oc(),bd(),ro(),dX=1e3,mX=eo("core/gather/driver/environment.js",uX={warningSlowHostCpu:"The tested device appears to have a slower CPU than  Lighthouse expects. This can negatively affect your performance score. Learn more about [calibrating an appropriate CPU slowdown multiplier](https://github.com/GoogleChrome/lighthouse/blob/main/docs/throttling.md#cpu-throttling)."}),o(oX,"getBrowserVersion"),o(sX,"getBenchmarkIndex"),o(lX,"getSlowHostCpuWarning"),o(cX,"getEnvironmentWarnings")}));async function hX(e,t,a){let n=await sX(t.executionContext),{userAgent:r}=await oX(t.defaultSession);return{fetchTime:(new Date).toJSON(),Timing:[],LighthouseRunWarnings:[],settings:e.settings,BenchmarkIndex:n,HostUserAgent:r,HostFormFactor:r.includes("Android")||r.includes("Mobile")?"mobile":"desktop",URL:{finalDisplayedUrl:""},PageLoadError:null,GatherContext:a}}function gX(e){let t=[];for(let a of e)t.some((e=>(0,yX.default)(a,e)))||t.push(a);return t}function fX(e,t){let a=e.LighthouseRunWarnings.concat(t.LighthouseRunWarnings||[]).concat(cX({settings:e.settings,baseArtifacts:e})),n={...e,...t};if(n.Timing=Kt.getTimeEntries(),n.LighthouseRunWarnings=gX(a),n.PageLoadError&&!n.URL.finalDisplayedUrl&&(n.URL.finalDisplayedUrl=n.URL.requestedUrl||""),!n.URL.finalDisplayedUrl)throw new Error("Runner did not set finalDisplayedUrl");return n}var yX,vX=s((()=>{J(),ea(),yX=d(lr(),1),pX(),o(hX,"getBaseArtifacts"),o(gX,"deduplicateWarnings"),o(fX,"finalizeArtifacts")}));async function bX(e,t={}){let{flags:a={},config:n}=t;Kt.setLevel(a.logLevel||"error");let{resolvedConfig:r}=await aX("snapshot",n,a),i=new vd(e);await i.connect();let o=new Map,s=await i.url(),l={resolvedConfig:r,computedCache:o};return{artifacts:await Ou.gather((async()=>{let t=await hX(r,i,{gatherMode:"snapshot"});t.URL={finalDisplayedUrl:s};let a=r.artifacts||[],n={startInstrumentation:{},startSensitiveInstrumentation:{},stopSensitiveInstrumentation:{},stopInstrumentation:{},getArtifact:{}};return await Ad({phase:"getArtifact",gatherMode:"snapshot",driver:i,page:e,baseArtifacts:t,artifactDefinitions:a,artifactState:n,computedCache:o,settings:r.settings}),await i.disconnect(),fX(t,await Rd(n))}),l),runnerOptions:l}}var wX=s((()=>{J(),ea(),Cd(),Bu(),Ud(),iX(),vX(),o(bX,"snapshotGather")}));async function DX(e,t){let a={msg:"Cleaning origin data",id:"lh:storage:clearDataForOrigin"};Kt.time(a);let n=[],r=new URL(t).origin,i=["file_systems","shader_cache","service_workers","cache_storage"].join(",");e.setNextProtocolTimeout(5e3);try{await e.sendCommand("Storage.clearDataForOrigin",{origin:r,storageTypes:i})}catch(e){if("PROTOCOL_TIMEOUT"!==e.code)throw e;Kt.warn("Driver","clearDataForOrigin timed out"),n.push(CX(SX.warningOriginDataTimeout))}finally{Kt.timeEnd(a)}return n}async function EX(e,t){let a=await e.sendCommand("Storage.getUsageAndQuota",{origin:t}),n={local_storage:"Local Storage",indexeddb:"IndexedDB",websql:"Web SQL"},r=a.usageBreakdown.filter((e=>e.usage)).map((e=>n[e.storageType]||"")).filter(Boolean);if(r.length)return CX(SX.warningData,{locations:r.join(", "),locationCount:r.length})}async function TX(e){let t={msg:"Cleaning browser cache",id:"lh:storage:clearBrowserCaches"};Kt.time(t);let a=[];try{await e.sendCommand("Network.clearBrowserCache"),await e.sendCommand("Network.setCacheDisabled",{cacheDisabled:!0}),await e.sendCommand("Network.setCacheDisabled",{cacheDisabled:!1})}catch(e){if("PROTOCOL_TIMEOUT"!==e.code)throw e;Kt.warn("Driver","clearBrowserCaches timed out"),a.push(CX(SX.warningCacheTimeout))}finally{Kt.timeEnd(t)}return a}var SX,CX,kX=s((()=>{J(),ea(),ro(),CX=eo("core/gather/driver/storage.js",SX={warningData:"{locationCount, plural,\n    =1 {There may be stored data affecting loading performance in this location: {locations}. Audit this page in an incognito window to prevent those resources from affecting your scores.}\n    other {There may be stored data affecting loading performance in these locations: {locations}. Audit this page in an incognito window to prevent those resources from affecting your scores.}\n  }",warningCacheTimeout:"Clearing the browser cache timed out. Try auditing this page again and file a bug if the issue persists.",warningOriginDataTimeout:"Clearing the origin data timed out. Try auditing this page again and file a bug if the issue persists."}),o(DX,"clearDataForOrigin"),o(EX,"getImportantStorageWarning"),o(TX,"clearBrowserCaches")}));async function xX(e){let t=o((async()=>{await e.sendCommand("Debugger.enable"),await e.sendCommand("Debugger.setSkipAllPauses",{skip:!0}),await e.sendCommand("Debugger.setAsyncCallStackDepth",{maxDepth:8})}),"enable");function a(){e.sendCommand("Debugger.resume")}function n(e){e.frame.parentId||t().catch((e=>Kt.error("Driver",e)))}return o(a,"onDebuggerPaused"),o(n,"onFrameNavigated"),e.on("Debugger.paused",a),e.on("Page.frameNavigated",n),await t(),async()=>{await e.sendCommand("Debugger.disable"),e.off("Debugger.paused",a),e.off("Page.frameNavigated",n)}}async function AX(e,t){await e.executionContext.evaluateOnNewDocument(sd.wrapRequestIdleCallback,{args:[t.throttling.cpuSlowdownMultiplier]})}async function _X(e){e.on("Page.javascriptDialogOpening",(t=>{Kt.warn("Driver",`${t.type} dialog opened by the page automatically suppressed.`),e.sendCommand("Page.handleJavaScriptDialog",{accept:!0,promptText:"Lighthouse prompt response"}).catch((e=>Kt.warn("Driver",e)))})),await e.sendCommand("Page.enable")}async function RX(e,t){let a=[],n=await EX(e,t);n&&a.push(n);let r=await DX(e,t);a.push(...r);let i=await TX(e);return a.push(...i),{warnings:a}}async function FX(e,t,a){let n={msg:"Preparing network conditions",id:"lh:gather:prepareThrottlingAndNetwork"};Kt.time(n),a.disableThrottling?await ev(e):await Qy(e,t);let r=(a.blockedUrlPatterns||[]).concat(t.blockedUrlPatterns||[]);await e.sendCommand("Network.setBlockedURLs",{urls:r});let i=t.extraHeaders;i&&await e.sendCommand("Network.setExtraHTTPHeaders",{headers:i}),Kt.timeEnd(n)}async function NX(e,t){await e.defaultSession.sendCommand("Network.enable"),await Xy(e.defaultSession,t)}async function IX(e,t){let a={msg:"Preparing target for timespan mode",id:"lh:prepare:timespanMode"};Kt.time(a),await NX(e,t),await FX(e.defaultSession,t,{disableThrottling:!1,blockedUrlPatterns:void 0}),await MX(e),Kt.timeEnd(a)}async function MX(e){await e.executionContext.evaluate(sd.truncate,{args:["aaa",2]})}async function PX(e,t){let a={msg:"Preparing target for navigation mode",id:"lh:prepare:navigationMode"};Kt.time(a),await NX(e,t),await _X(e.defaultSession),await e.executionContext.cacheNativesOnNewDocument(),"simulate"===t.throttlingMethod&&await AX(e,t),await MX(e),Kt.timeEnd(a)}async function LX(e,t,a){let n={msg:"Preparing target for navigation",id:"lh:prepare:navigation"};Kt.time(n);let r=[],{requestor:i}=a;if(!t.disableStorageReset&&!a.disableStorageReset&&"string"==typeof i){let t=i,{warnings:a}=await RX(e,t);r.push(...a)}return await FX(e,t,a),Kt.timeEnd(n),{warnings:r}}var OX=s((()=>{J(),ea(),kX(),sv(),bd(),o(xX,"enableAsyncStacks"),o(AX,"shimRequestIdleCallbackOnNewDocument"),o(_X,"dismissJavaScriptDialogs"),o(RX,"resetStorageForUrl"),o(FX,"prepareThrottlingAndNetwork"),o(NX,"prepareDeviceEmulation"),o(IX,"prepareTargetForTimespanMode"),o(MX,"warmUpIntlSegmenter"),o(PX,"prepareTargetForNavigationMode"),o(LX,"prepareTargetForIndividualNavigation")}));async function jX(e,t={}){let{flags:a={},config:n}=t;Kt.setLevel(a.logLevel||"error");let{resolvedConfig:r}=await aX("timespan",n,a),i=new vd(e);await i.connect();let o=new Map,s=r.artifacts||[],l=await hX(r,i,{gatherMode:"timespan"}),c={startInstrumentation:{},startSensitiveInstrumentation:{},stopSensitiveInstrumentation:{},stopInstrumentation:{},getArtifact:{}},u={driver:i,page:e,artifactDefinitions:s,artifactState:c,baseArtifacts:l,computedCache:o,gatherMode:"timespan",settings:r.settings};await IX(i,r.settings);let d=await xX(i.defaultSession);return await Ad({phase:"startInstrumentation",...u}),await Ad({phase:"startSensitiveInstrumentation",...u}),{async endTimespanGather(){let e=await i.url(),t={resolvedConfig:r,computedCache:o};return{artifacts:await Ou.gather((async()=>{l.URL={finalDisplayedUrl:e},await Ad({phase:"stopSensitiveInstrumentation",...u}),await Ad({phase:"stopInstrumentation",...u}),await d(),await Ad({phase:"getArtifact",...u}),await i.disconnect();let t=await Rd(c);return fX(l,t)}),t),runnerOptions:t}}}}var UX,BX=s((()=>{J(),ea(),Cd(),Bu(),Ud(),OX(),iX(),vX(),o(jX,"startTimespanGather")})),qX=s((()=>{J(),UX={}}));function zX(e){let{pauseAfterFcpMs:t,pauseAfterLoadMs:a,networkQuietThresholdMs:n,cpuQuietThresholdMs:r}=e,i=e.maxWaitForLoad,o=e.maxWaitForFcp;return"number"!=typeof t&&(t=$X),"number"!=typeof a&&(a=KX),"number"!=typeof n&&(n=YX),"number"!=typeof r&&(r=JX),"number"!=typeof i&&(i=Jl.maxWaitForLoad),"number"!=typeof o&&(o=Jl.maxWaitForFcp),e.waitUntil.includes("fcp")||(o=void 0),{pauseAfterFcpMs:t,pauseAfterLoadMs:a,networkQuietThresholdMs:n,cpuQuietThresholdMs:r,maxWaitForLoadedMs:i,maxWaitForFcpMs:o}}async function VX(e,t,a){let n="string"==typeof t?{msg:`Navigating to ${t}`,id:"lh:driver:navigate"}:{msg:"Navigating using a user defined function",id:"lh:driver:navigate"};Kt.time(n);let r,i=e.defaultSession,o=e.networkMonitor;await i.sendCommand("Page.enable"),await i.sendCommand("Page.setLifecycleEventsEnabled",{enabled:!0}),"string"==typeof t?(i.setNextProtocolTimeout(1/0),r=i.sendCommand("Page.navigate",{url:t})):r=t();let s=a.waitUntil.includes("navigated"),l=a.waitUntil.includes("load"),c=a.waitUntil.includes("fcp"),u=[];if(s){let e=Jm(i).promise;u.push(e.then((()=>({timedOut:!1}))))}if(l){let e=zX(a);u.push(rp(i,o,e))}else if(c)throw new Error("Cannot wait for FCP without waiting for page load");let d=(await Promise.all(u)).some((e=>e.timedOut)),m=await o.getNavigationUrls(),p=m.requestedUrl;if("string"==typeof t&&(p&&!Ml.equalWithExcludedFragments(t,p)&&Kt.error("Navigation",`Provided URL (${t}) did not match initial navigation URL (${p})`),p=t),!p)throw Error("No navigations detected when running user defined requestor.");let h=m.mainDocumentUrl||p;return await r,a.debugNavigation&&await ip(e),Kt.timeEnd(n),{requestedUrl:p,mainDocumentUrl:h,warnings:WX({timedOut:d,mainDocumentUrl:h,requestedUrl:p})}}function WX(e){let{requestedUrl:t,mainDocumentUrl:a}=e,n=[];return e.timedOut&&n.push(GX(HX.warningTimeout)),Ml.equalWithExcludedFragments(t,a)||n.push(GX(HX.warningRedirected,{requested:t,final:a})),n}var HX,GX,$X,KX,YX,JX,ZX=s((()=>{J(),ea(),sp(),oc(),ro(),ql(),GX=eo("core/gather/driver/navigation.js",HX={warningRedirected:"The page may not be loading as expected because your test URL ({requested}) was redirected to {final}. Try testing the second URL directly.",warningTimeout:"The page loaded too slowly to finish within the time limit. Results may be incomplete."}),$X=0,KX=0,YX=5e3,JX=0,o(zX,"resolveWaitForFullyLoadedOptions"),o(VX,"gotoURL"),o(WX,"getNavigationWarnings")}));function XX(e){if(!e)return new El(El.errors.NO_DOCUMENT_REQUEST);if(e.failed){let t=e.localizedFailDescription;return"net::ERR_NAME_NOT_RESOLVED"===t||"net::ERR_NAME_RESOLUTION_FAILED"===t||t.startsWith("net::ERR_DNS_")?new El(El.errors.DNS_FAILURE):new El(El.errors.FAILED_DOCUMENT_REQUEST,{errorDetails:t})}return e.hasErrorStatusCode()?new El(El.errors.ERRORED_DOCUMENT_REQUEST,{statusCode:`${e.statusCode}`}):void 0}function QX(e,t){if(e&&t.find((e=>e.documentURL.startsWith("chrome-error://")))&&e.failed)return e.localizedFailDescription.startsWith("net::ERR_CERT")?new El(El.errors.INSECURE_DOCUMENT_REQUEST,{securityMessages:e.localizedFailDescription}):new El(El.errors.CHROME_INTERSTITIAL_ERROR)}function eQ(e){if(e&&e.mimeType&&-1!==e.statusCode&&e.mimeType!==rQ&&e.mimeType!==iQ)return new El(El.errors.NOT_HTML,{mimeType:e.mimeType})}function tQ(e,t){let a,{url:n,loadFailureMode:r,networkRecords:i}=t,o=Ll.findResourceForUrl(i,n);if(!o){let e=i.filter((e=>e.resourceType===wc.TYPES.Document));e.length&&(o=e.reduce(((e,t)=>t.networkRequestTime<e.networkRequestTime?t:e)))}o&&(a=Ll.resolveRedirects(o)),a?.mimeType===iQ&&t.warnings.push(nQ(aQ.warningXhtml));let s=XX(o),l=QX(o,i),c=eQ(a);if("ignore"!==r)return l||s||c||e}var aQ,nQ,rQ,iQ,oQ=s((()=>{J(),xl(),zl(),qc(),ro(),nQ=eo("core/lib/navigation-error.js",aQ={warningXhtml:"The page MIME type is XHTML: Lighthouse does not explicitly support this document type"}),rQ="text/html",iQ="application/xhtml+xml",o(XX,"getNetworkError"),o(QX,"getInterstitialError"),o(eQ,"getNonHtmlError"),o(tQ,"getPageLoadError")}));async function sQ({driver:e,resolvedConfig:t,requestor:a}){await e.connect(),"string"==typeof a&&!t.settings.skipAboutBlank&&await VX(e,Zl.blankPage,{waitUntil:["navigated"]});let n=await hX(t,e,{gatherMode:"navigation"});return await PX(e,t.settings),{baseArtifacts:n}}async function lQ({requestor:e,driver:t,navigation:a,resolvedConfig:n}){"string"==typeof e&&!n.settings.skipAboutBlank&&await VX(t,a.blankPage,{...a,waitUntil:["navigated"]});let{warnings:r}=await LX(t.defaultSession,n.settings,{...a,requestor:e});return{warnings:r}}async function cQ({driver:e}){await ev(e.defaultSession)}async function uQ(e){let{driver:t,resolvedConfig:a,requestor:n}=e;try{let{requestedUrl:r,mainDocumentUrl:i,warnings:o}=await VX(t,n,{...e.navigation,debugNavigation:a.settings.debugNavigation,maxWaitForFcp:a.settings.maxWaitForFcp,maxWaitForLoad:a.settings.maxWaitForLoad,waitUntil:e.navigation.pauseAfterFcpMs?["fcp","load"]:["load"]});return{requestedUrl:r,mainDocumentUrl:i,navigationError:void 0,warnings:o}}catch(e){if(!(e instanceof El)||"NO_FCP"!==e.code&&"PAGE_HUNG"!==e.code||"string"!=typeof n)throw e;return{requestedUrl:n,mainDocumentUrl:n,navigationError:e,warnings:[]}}}async function dQ(e,t){let a=t.artifactDefinitions.find((e=>e.gatherer.instance.meta.symbol===dp.symbol)),n=t.artifactDefinitions.find((e=>e.gatherer.instance.meta.symbol===oa.symbol)),r=[a,n].filter((e=>!!e));if(!r.length)return{};await Ad({...t,phase:"getArtifact",artifactDefinitions:r});let i=t.artifactState.getArtifact,o=a?.id,s=o&&await i[o],l=s&&await Pc.request(s,e),c=n?.id;return{devtoolsLog:s,records:l,trace:c&&await i[c]}}async function mQ(e,t,a,n){let{navigationError:r,mainDocumentUrl:i}=n,o=[...a.warnings,...n.warnings],s=await dQ(e,t),l=s.records?tQ(r,{url:i,loadFailureMode:e.navigation.loadFailureMode,networkRecords:s.records,warnings:o}):r;if(l){let t=e.resolvedConfig.settings.locale,a=vi(l.friendlyMessage,t);Kt.error("NavigationRunner",a,n.requestedUrl);let r={},i=`pageLoadError-${e.navigation.id}`;return s.devtoolsLog&&(r.DevtoolsLogError=s.devtoolsLog,r.devtoolsLogs={[i]:s.devtoolsLog}),s.trace&&(r.TraceError=s.trace,r.traces={[i]:s.trace}),{pageLoadError:l,artifacts:r,warnings:[...o,l.friendlyMessage]}}return await Ad({phase:"getArtifact",...t}),{artifacts:await Rd(t.artifactState),warnings:o,pageLoadError:void 0}}async function pQ(e){let t={startInstrumentation:{},startSensitiveInstrumentation:{},stopSensitiveInstrumentation:{},stopInstrumentation:{},getArtifact:{}},a={url:await e.driver.url(),gatherMode:"navigation",driver:e.driver,page:e.page,computedCache:e.computedCache,artifactDefinitions:e.navigation.artifacts,artifactState:t,baseArtifacts:e.baseArtifacts,settings:e.resolvedConfig.settings},n=await lQ(e),r=await xX(e.driver.defaultSession);await Ad({phase:"startInstrumentation",...a}),await Ad({phase:"startSensitiveInstrumentation",...a});let i=await uQ(e);return Object.values(a.baseArtifacts).every(Boolean)||(a.baseArtifacts.URL={requestedUrl:i.requestedUrl,mainDocumentUrl:i.mainDocumentUrl,finalDisplayedUrl:await e.driver.url()}),a.url=i.mainDocumentUrl,await Ad({phase:"stopSensitiveInstrumentation",...a}),await Ad({phase:"stopInstrumentation",...a}),await r(),await cQ(e),mQ(e,a,n,i)}async function hQ(e){let{driver:t,page:a,resolvedConfig:n,requestor:r,baseArtifacts:i,computedCache:o}=e;if(!n.artifacts||!n.navigations)throw new Error("No artifacts were defined on the config");let s={},l=[];for(let e of n.navigations){let c={driver:t,page:a,navigation:e,requestor:r,resolvedConfig:n,baseArtifacts:i,computedCache:o},u=!1,d=await pQ(c);if("fatal"===e.loadFailureMode&&d.pageLoadError&&(s.PageLoadError=d.pageLoadError,u=!0),l.push(...d.warnings),Object.assign(s,d.artifacts),u)break}return{artifacts:{...s,LighthouseRunWarnings:l}}}async function gQ({requestedUrl:e,driver:t,resolvedConfig:a,lhBrowser:n,lhPage:r}){!a.settings.disableStorageReset&&e&&await DX(t.defaultSession,e),await t.disconnect(),await(r?.close()),await(n?.disconnect())}async function fQ(e,t,a={}){let{flags:n={},config:r}=a;Kt.setLevel(n.logLevel||"error");let{resolvedConfig:i}=await aX("navigation",r,n),o=new Map,s="function"==typeof t,l={resolvedConfig:i,computedCache:o};return{artifacts:await Ou.gather((async()=>{let a,r,l=s?t:Ml.normalizeUrl(t);if(!e){let{hostname:t=yQ,port:i=vQ}=n;a=await UX.connect({browserURL:`http://${t}:${i}`,defaultViewport:null}),r=await a.newPage(),e=r}let c={driver:new vd(e),lhBrowser:a,lhPage:r,resolvedConfig:i,requestor:l},{baseArtifacts:u}=await sQ(c),{artifacts:d}=await hQ({...c,page:e,baseArtifacts:u,computedCache:o});return await gQ(c),fX(u,d)}),l),runnerOptions:l}}var yQ,vQ,bQ=s((()=>{J(),qX(),ea(),Cd(),Bu(),Ud(),OX(),ZX(),kX(),sv(),oc(),iX(),vX(),Mi(),xl(),ql(),oQ(),sa(),mp(),Yc(),yQ="127.0.0.1",vQ=9222,o(sQ,"_setup"),o(lQ,"_setupNavigation"),o(cQ,"_cleanupNavigation"),o(uQ,"_navigate"),o(dQ,"_collectDebugData"),o(mQ,"_computeNavigationResult"),o(pQ,"_navigation"),o(hQ,"_navigations"),o(gQ,"_cleanup"),o(fQ,"navigationGather")})),wQ=s((()=>{J(),Tu(),wX(),BX(),bQ(),Bu(),iX(),Mi(),KZ(),ro(),ta(),eo("core/user-flow.js",{defaultFlowName:"User flow ({url})",defaultNavigationName:"Navigation report ({url})",defaultTimespanName:"Timespan report ({url})",defaultSnapshotName:"Snapshot report ({url})"})})),DQ=s((()=>{J(),ta(),oc(),{extends:"lighthouse:default",settings:{formFactor:"desktop",throttling:$l.desktopDense4G,screenEmulation:Kl.desktop,emulatedUserAgent:Yl.desktop}}}));async function EQ(e,t={},a,n){return TQ(n,e,{config:a,flags:t})}async function TQ(e,t,a){let n=await fQ(e,t,a);return Ou.audit(n.artifacts,n.runnerOptions)}async function SQ(e,t){let a=await bX(e,t);return Ou.audit(a.artifacts,a.runnerOptions)}async function CQ(e,t){let{endTimespanGather:a}=await jX(e,t);return{endTimespan:o((async()=>{let e=await a();return Ou.audit(e.artifacts,e.runnerOptions)}),"endTimespan")}}var kQ,xQ=s((()=>{J(),sa(),Bu(),wQ(),Tu(),BX(),wX(),bQ(),ta(),xr(),aa(),Yc(),qd(),DQ(),ta(),o(EQ,"lighthouse"),o(TQ,"navigation"),o(SQ,"snapshot"),o(CQ,"startTimespan"),oa.getDefaultTraceCategories(),kQ=EQ}));function AQ(e,t){let a={onlyCategories:e,screenEmulation:{disabled:!0}};return"desktop"===t&&(a.throttling=$l.desktopDense4G,a.emulatedUserAgent=Yl.desktop,a.formFactor="desktop"),{extends:"lighthouse:default",plugins:["lighthouse-plugin-publisher-ads"],settings:a}}function _Q(e){Kt.events.addListener("status",e),Kt.events.addListener("warning",e)}function RQ(e){return Qi(e,Ei())}function FQ(e,{page:t,...a}){return TQ(t,e,a)}function NQ({page:e,...t}){return CQ(e,t)}function IQ({page:e,...t}){return SQ(e,t)}J(),lt(),ea(),xQ(),ro(),Mi(),oc(),globalThis.Buffer=oe,o(AQ,"createConfig"),o(_Q,"listenForStatus"),o(RQ,"lookupCanonicalLocale"),o(FQ,"runLighthouseNavigation"),o(NQ,"startLighthouseTimespan"),o(IQ,"runLighthouseSnapshot"),typeof self<"u"?(globalThis.isDevtools=!0,self.runLighthouseNavigation=FQ,self.navigation=TQ,self.startLighthouseTimespan=NQ,self.startTimespan=CQ,self.runLighthouseSnapshot=IQ,self.snapshot=SQ,self.createConfig=AQ,self.listenForStatus=_Q,self.registerLocaleData=Si,self.lookupLocale=RQ):globalThis.runBundledLighthouse=kQ})();
/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 * @license  MIT
 */
/*! Bundled license information:

lighthouse-stack-packs/packs/joomla.js:
  (**
   * @license Copyright 2020 The Lighthouse Authors. All Rights Reserved.
   * Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
   * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
   *)

image-ssim/index.js:
  (**
   * @preserve
   * Copyright 2015 Igor Bezkrovny
   * All rights reserved. (MIT Licensed)
   *
   * ssim.ts - part of Image Quantization Library
   *)
*/