import{assert}from"../util/assert.js";import{Deferred}from"../util/Deferred.js";import{Connection}from"./Connection.js";import{EventEmitter}from"./EventEmitter.js";import{InitializationStatus,CDPTarget}from"./Target.js";import{debugError}from"./util.js";export class ChromeTargetManager extends EventEmitter{#t;#e=new Map;#a=new Map;#r=new Map;#s=new Set;#i;#n;#o=new WeakMap;#g=new WeakMap;#d=new WeakMap;#h=Deferred.create();#c=new Set;#I=!0;constructor(t,e,a,r=!0){super(),this.#t=t,this.#i=a,this.#n=e,this.#I=r,this.#t.on("Target.targetCreated",this.#T),this.#t.on("Target.targetDestroyed",this.#f),this.#t.on("Target.targetInfoChanged",this.#l),this.#t.on("sessiondetached",this.#y),this.#m(this.#t),this.#t.send("Target.setDiscoverTargets",{discover:!0,filter:[{type:"tab",exclude:!0},{}]}).then(this.#u).catch(debugError)}#u=()=>{if(this.#I)for(const[t,e]of this.#e.entries()){const a=new CDPTarget(e,void 0,void 0,this,void 0);this.#i&&!this.#i(a)||"browser"===e.type||this.#c.add(t)}};async initialize(){await this.#t.send("Target.setAutoAttach",{waitForDebuggerOnStart:!0,flatten:!0,autoAttach:!0}),this.#B(),await this.#h.valueOrThrow()}dispose(){this.#t.off("Target.targetCreated",this.#T),this.#t.off("Target.targetDestroyed",this.#f),this.#t.off("Target.targetInfoChanged",this.#l),this.#t.off("sessiondetached",this.#y),this.#F(this.#t)}getAvailableTargets(){return this.#a}addTargetInterceptor(t,e){const a=this.#o.get(t)||[];a.push(e),this.#o.set(t,a)}removeTargetInterceptor(t,e){const a=this.#o.get(t)||[];this.#o.set(t,a.filter((t=>t!==e)))}#m(t){const e=e=>this.#v(t,e);assert(!this.#g.has(t)),this.#g.set(t,e),t.on("Target.attachedToTarget",e);const a=e=>this.#p(t,e);assert(!this.#d.has(t)),this.#d.set(t,a),t.on("Target.detachedFromTarget",a)}#F(t){this.#g.has(t)&&(t.off("Target.attachedToTarget",this.#g.get(t)),this.#g.delete(t)),this.#d.has(t)&&(t.off("Target.detachedFromTarget",this.#d.get(t)),this.#d.delete(t))}#y=t=>{this.#F(t),this.#o.delete(t)};#T=async t=>{if(this.#e.set(t.targetInfo.targetId,t.targetInfo),this.emit("targetDiscovered",t.targetInfo),"browser"===t.targetInfo.type&&t.targetInfo.attached){if(this.#a.has(t.targetInfo.targetId))return;const e=this.#n(t.targetInfo,void 0);e._initialize(),this.#a.set(t.targetInfo.targetId,e)}};#f=t=>{const e=this.#e.get(t.targetId);if(this.#e.delete(t.targetId),this.#B(t.targetId),"service_worker"===e?.type&&this.#a.has(t.targetId)){const e=this.#a.get(t.targetId);this.emit("targetGone",e),this.#a.delete(t.targetId)}};#l=t=>{if(this.#e.set(t.targetInfo.targetId,t.targetInfo),this.#s.has(t.targetInfo.targetId)||!this.#a.has(t.targetInfo.targetId)||!t.targetInfo.attached)return;const e=this.#a.get(t.targetInfo.targetId);if(!e)return;const a=e.url(),r=e._initializedDeferred.value()===InitializationStatus.SUCCESS;e._targetInfoChanged(t.targetInfo),r&&a!==e.url()&&this.emit("targetChanged",{target:e,wasInitialized:r,previousURL:a})};#v=async(t,e)=>{const a=e.targetInfo,r=this.#t.session(e.sessionId);if(!r)throw new Error(`Session ${e.sessionId} was not created.`);const s=async()=>{await r.send("Runtime.runIfWaitingForDebugger").catch(debugError),await t.send("Target.detachFromTarget",{sessionId:r.id()}).catch(debugError)};if(!this.#t.isAutoAttached(a.targetId))return;if("service_worker"===a.type&&this.#t.isAutoAttached(a.targetId)){if(this.#B(a.targetId),await s(),this.#a.has(a.targetId))return;const t=this.#n(a);return t._initialize(),this.#a.set(a.targetId,t),void this.emit("targetAvailable",t)}const i=this.#a.has(a.targetId),n=i?this.#a.get(a.targetId):this.#n(a,r);if(this.#i&&!this.#i(n))return this.#s.add(a.targetId),this.#B(a.targetId),void await s();i||n._initialize(),this.#m(r),i?this.#r.set(r.id(),this.#a.get(a.targetId)):(this.#a.set(a.targetId,n),this.#r.set(r.id(),n));for(const e of this.#o.get(t)||[])t instanceof Connection||assert(this.#r.has(t.id())),e(n,t instanceof Connection?null:this.#r.get(t.id()));this.#c.delete(n._targetId),i||this.emit("targetAvailable",n),this.#B(),await Promise.all([r.send("Target.setAutoAttach",{waitForDebuggerOnStart:!0,flatten:!0,autoAttach:!0}),r.send("Runtime.runIfWaitingForDebugger")]).catch(debugError)};#B(t){void 0!==t&&this.#c.delete(t),0===this.#c.size&&this.#h.resolve()}#p=(t,e)=>{const a=this.#r.get(e.sessionId);this.#r.delete(e.sessionId),a&&(this.#a.delete(a._targetId),this.emit("targetGone",a))}}