import{LazyArg}from"../LazyArg.js";import{debugError,isDate,isPlainObject,isRegExp}from"../util.js";import{ElementHandle}from"./ElementHandle.js";import{JSHandle}from"./JSHandle.js";class UnserializableError extends Error{}export class BidiSerializer{static serializeNumber(e){let r;return r=Object.is(e,-0)?"-0":Object.is(e,1/0)?"Infinity":Object.is(e,-1/0)?"-Infinity":Object.is(e,NaN)?"NaN":e,{type:"number",value:r}}static serializeObject(e){if(null===e)return{type:"null"};if(Array.isArray(e)){return{type:"array",value:e.map((e=>BidiSerializer.serializeRemoveValue(e)))}}if(isPlainObject(e)){try{JSON.stringify(e)}catch(e){throw e instanceof TypeError&&e.message.startsWith("Converting circular structure to JSON")&&(e.message+=" Recursive objects are not allowed."),e}const r=[];for(const i in e)r.push([BidiSerializer.serializeRemoveValue(i),BidiSerializer.serializeRemoveValue(e[i])]);return{type:"object",value:r}}if(isRegExp(e))return{type:"regexp",value:{pattern:e.source,flags:e.flags}};if(isDate(e))return{type:"date",value:e.toISOString()};throw new UnserializableError("Custom object sterilization not possible. Use plain objects instead.")}static serializeRemoveValue(e){switch(typeof e){case"symbol":case"function":throw new UnserializableError("Unable to serializable "+typeof e);case"object":return BidiSerializer.serializeObject(e);case"undefined":return{type:"undefined"};case"number":return BidiSerializer.serializeNumber(e);case"bigint":return{type:"bigint",value:e.toString()};case"string":return{type:"string",value:e};case"boolean":return{type:"boolean",value:e}}}static async serialize(e,r){e instanceof LazyArg&&(e=await e.get(r));const i=e&&(e instanceof JSHandle||e instanceof ElementHandle)?e:null;if(i){if(i.context()!==r&&!("sharedId"in i.remoteValue()))throw new Error("JSHandles can be evaluated only in the context they were created!");if(i.disposed)throw new Error("JSHandle is disposed!");return i.remoteValue()}return BidiSerializer.serializeRemoveValue(e)}static deserializeNumber(e){switch(e){case"-0":return-0;case"NaN":return NaN;case"Infinity":return 1/0;case"-Infinity":return-1/0;default:return e}}static deserializeLocalValue(e){switch(e.type){case"array":if(e.value)return e.value.map((e=>BidiSerializer.deserializeLocalValue(e)));break;case"set":if(e.value)return e.value.reduce(((e,r)=>e.add(BidiSerializer.deserializeLocalValue(r))),new Set);break;case"object":if(e.value)return e.value.reduce(((e,r)=>{const{key:i,value:a}=BidiSerializer.deserializeTuple(r);return e[i]=a,e}),{});break;case"map":if(e.value)return e.value?.reduce(((e,r)=>{const{key:i,value:a}=BidiSerializer.deserializeTuple(r);return e.set(i,a)}),new Map);break;case"promise":return{};case"regexp":return new RegExp(e.value.pattern,e.value.flags);case"date":return new Date(e.value);case"undefined":return;case"null":return null;case"number":return BidiSerializer.deserializeNumber(e.value);case"bigint":return BigInt(e.value);case"boolean":return Boolean(e.value);case"string":return e.value}throw new UnserializableError(`Deserialization of type ${e.type} not supported.`)}static deserializeTuple([e,r]){return{key:"string"==typeof e?e:BidiSerializer.deserializeLocalValue(e),value:BidiSerializer.deserializeLocalValue(r)}}static deserialize(e){if(e)try{return BidiSerializer.deserializeLocalValue(e)}catch(e){if(e instanceof UnserializableError)return void debugError(e.message);throw e}else debugError("Service did not produce a result.")}}