const styles=new CSSStyleSheet;styles.replaceSync("/*\n * Copyright (c) 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n:host {\n  width: 270px;\n  height: 350px;\n  user-select: none;\n  padding: 16px;\n  overflow: hidden;\n}\n\n.bezier-preset-selected > svg {\n  background-color: var(--legacy-selection-bg-color);\n}\n\n.bezier-container {\n  --override-bezier-control-color: #9c27b0;\n\n  display: flex;\n  margin-top: 38px;\n  flex-shrink: 0;\n  /* overflown bezier visualization must be on top of the source text */\n  z-index: 2;\n  background-image: radial-gradient(circle, var(--color-background-elevation-2) 1px, var(--color-background-inverted-opacity-0) 1px);\n  background-size: 17px 17px;\n  background-position: -5px -10px;\n}\n\n.-theme-with-dark-background .bezier-container,\n:host-context(.-theme-with-dark-background) .bezier-container {\n  --override-bezier-control-color: rgb(196 79 216);\n}\n\n.bezier-preset {\n  width: 50px;\n  height: 50px;\n  padding: 5px;\n  margin: auto;\n  background-color: var(--color-background-elevation-1);\n  border-radius: 3px;\n}\n\n.bezier-preset line.bezier-control-line {\n  stroke: var(--color-text-secondary);\n  stroke-width: 1;\n  stroke-linecap: round;\n  fill: none;\n}\n\n.bezier-preset circle.bezier-control-circle {\n  fill: var(--color-text-secondary);\n}\n\n.bezier-preset path.bezier-path {\n  stroke: var(--color-background-inverted);\n  stroke-width: 2;\n  stroke-linecap: round;\n  fill: none;\n}\n\n.bezier-preset-selected path.bezier-path,\n.bezier-preset-selected line.bezier-control-line {\n  stroke: var(--color-background);\n}\n\n.bezier-preset-selected circle.bezier-control-circle {\n  fill: var(--color-background);\n}\n\n.bezier-curve line.linear-line {\n  stroke: var(--color-background-elevation-2);\n  stroke-width: 2;\n  stroke-linecap: round;\n  fill: none;\n}\n\n.bezier-curve line.bezier-control-line {\n  stroke: var(--override-bezier-control-color);\n  stroke-width: 2;\n  stroke-linecap: round;\n  fill: none;\n  opacity: 60%;\n}\n\n.bezier-curve circle.bezier-control-circle {\n  fill: var(--override-bezier-control-color);\n  cursor: pointer;\n}\n\n.bezier-curve path.bezier-path {\n  stroke: var(--color-background-inverted);\n  stroke-width: 3;\n  stroke-linecap: round;\n  fill: none;\n}\n\n.bezier-curve path.bezier-path.linear-path {\n  cursor: pointer;\n}\n\n.bezier-preview-container {\n  position: relative;\n  background-color: var(--color-background);\n  overflow: hidden;\n  border-radius: 20px;\n  width: 200%;\n  height: 20px;\n  z-index: 2;\n  flex-shrink: 0;\n  opacity: 0%;\n}\n\n.bezier-preview-animation {\n  background-color: #9c27b0; /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n  width: 20px;\n  height: 20px;\n  border-radius: 20px;\n  position: absolute;\n}\n\n.bezier-preview-onion {\n  margin-top: -20px;\n  position: relative;\n  z-index: 1;\n}\n\n.bezier-preview-onion > .bezier-preview-animation {\n  opacity: 10%;\n}\n\nsvg.bezier-preset-modify {\n  background-color: var(--color-background-elevation-1);\n  border-radius: 35px;\n  display: inline-block;\n  visibility: hidden;\n  transition: transform 100ms cubic-bezier(0.4, 0, 0.2, 1);\n  cursor: pointer;\n  position: absolute;\n}\n\nsvg.bezier-preset-modify:hover,\n.bezier-preset:hover {\n  background-color: var(--color-background-elevation-2);\n}\n\n.bezier-preset-selected .bezier-preset:hover {\n  background-color: var(--legacy-selection-bg-color);\n}\n\n.bezier-preset-modify path {\n  stroke-width: 2;\n  stroke: var(--color-background-inverted);\n  fill: none;\n}\n\n.bezier-presets {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n\n.bezier-preset-selected .bezier-preset-modify {\n  opacity: 100%;\n}\n\n.bezier-preset-category {\n  width: 50px;\n  cursor: pointer;\n  transition: transform 100ms cubic-bezier(0.4, 0, 0.2, 1);\n}\n\nspan.bezier-display-value {\n  width: 100%;\n  user-select: text;\n  display: block;\n  text-align: center;\n  line-height: 20px;\n  min-height: 20px;\n  cursor: text;\n}\n\nsvg.bezier-curve {\n  margin-left: 32px;\n  margin-top: -8px;\n}\n\nsvg.bezier-curve.linear {\n  margin-top: 42px;\n  overflow: visible;\n}\n\nsvg.bezier-preset-modify.bezier-preset-plus {\n  right: 0;\n}\n\n.bezier-header {\n  margin-top: 16px;\n  z-index: 1;\n}\n\nsvg.bezier-preset-modify:active {\n  transform: scale(1.1);\n  background-color: var(--legacy-selection-bg-color);\n}\n\n.bezier-preset-category:active {\n  transform: scale(1.05);\n}\n\n.bezier-header-active > svg.bezier-preset-modify {\n  visibility: visible;\n}\n\n.bezier-preset-modify:active path {\n  stroke: var(--color-background);\n}\n\n/*# sourceURL=bezierEditor.css */\n");export default styles;